(*Title bisection*)

cutlst::usage = \
"cutlst[liste,n], Cette fonction est la pour transformer une liste simple en matrice en faisant un retour chariot tout les n elements.";\



BuildMat::usage = "BuildMat[liste de triangle] se charge de construire la matrice C, exprimant les relations de bases sur les triabgles,
les angles de chaque triangle somment a \[Pi], autour de chaque sommet cree, on somme aussi a \[Pi]";\


reduce::usage = \
"reduce[matrice], agit sur une matrice decrivant les relations de base (cf BuildMat) et donne une liste de deux elements contenant la matrice M et le vecteur PI necessaire pour exprimer les angles en fonctions des parametres libres: A=MP+PI. En fait M est juste le noyau de C.";\


MatE::usage = \
"MatE[liste de triangle], donne la matrice necessaire a l'expression des angles exterieurs en fonction des angles.";\


S::usage = "S[n] donne toutes les permutations d'un n-uple.";

MatPermut::usage = "MatPermut[permutation] donne la matrice correspondante a la permutation.";

ListPermutTri::usage = \
"ListPermutTri[nombre de triangle] donne la liste des permutations permises par la geometrie des sommets des triangles (on ne permute que les sommets d'un meme triangle entres-eux et les triangles eux-meme). ";\


ListMatPermutTri::usage = \
"ListMatPermutTri[Nombre de Triangle] donne les matrices de permutations associees aux permutations autorisees (cf. ListPermutTri).";\


ComputeTri::usage = "ComputeTri[liste de triangle 1, liste de triangle 2], donne les solutions (peut-etre pas toutes cependant) des equations exprimant les contraintes sur les angles pour avoir une similitude d'un type combinatoire (liste de triangle) sur l'autre. La sortie est une grosse liste qui contient comme 2 premiers elements les
listes de triangles. Puis, des listes contenant:{permutation, angles solutions} ou
{permutation, angles solutions, contraintes}, selon que la solution est unique ou non.";\


makepoly::usage = "makepoly[liste de triangles, liste d'angles] donne une liste de triplets de points
correspondant a des tirangles ayant les angles specifies par le vecteur d'angle. Pour que la fonction marche,
il faut toutefois veiller a ce que la liste de triangle soit ordonnee de maniere a ce que d'un 
triangle au suivant dans la liste, il y ai au plus un seul nouveau point.";

MakeNormalizedPolys::usage = \
"MakeNormalizedPolys[liste de triangle 1, liste de triangle 2, permutation, angles] Meme usage que makepoly mais ici, les triangles seront tels que les points 1,2 et 3 vont forcement coincider, ce qui n'etait pas assure par la methode de construction de makepoly.";\


PWA::usage = "PWA[liste de triangle 1, liste de triangle 2, permutation, angles] trouve les affinites qui tranforme
les triangles 1 en les triangles 2.";

IsIso::usage = \
"IsIso[PWA] Retourne True si une PWA n'est en fait composee que d'isometries.";\


AreIso::usage = \
"AreIso[Liste de Solutions] Retourne les solutions de la liste qui sont des isometries par morceaux.";\


DrawPart::usage = "DrawPart[liste de triangle 1, liste de triangle 2, permutation, angles] affiche les partitions
avant et apres l'affinite consideree. Les deux listes de triangles correspondent au deux type combinatoire
utilises dans ComputeTri, la permutation et le vecteur d'angle etant donnes dans la liste des solutions.";\


DrawNum::usage = "DrawNum[liste de solutions] va parcourir toute la liste de solution specifiee. Cette derniere
devra etre issue d'une sortie de ComputeTri. La fonction va alors appliquer DrawPart sur toute les solutions 
uniques de la liste.";




<< Algebra`InequalitySolve`

<< DiscreteMath`Combinatorica`


cutlst[lst_, n_] := 
    Table[Take[lst, {(i - 1)*n + 1, i*n}], {i, Length[lst]/n}];

reduce[A_] := 
    Block[{m = {}, e, vlist = {}, dim = Length[A[[1]]], idx = {}, p = {}, 
        ra = {}, ipi = {}},
      m = NullSpace[A];
      e[i_] := Table[If[i == j, 1, 0], {j, dim}];
      
      IsInvlist[v_] := Block[{st = False}, Do[
            If[v == vlist[[i]], st = True]
            , {i, Length[vlist]}];
          Return[st]];
      
      Isnul[v_] := If[Plus @@ Abs[v] == 0, True, False];
      
      LinIndep[v_, vlist_] := Block[{r, fl = True},
          r = RowReduce[Append[vlist, v]];
          If[Isnul[r[[Length[r]]]], fl = False];
          Return[fl];
          ];
      
      Do[
        If[(! Isnul[A.e[i]]) && (LinIndep[A.e[i], vlist]) && (Length[idx] < 
                  dim - Length[m]),
            AppendTo[vlist, A.e[i]]; AppendTo[idx, i]];
        , {i, dim}];
      p = Transpose[Join[
            Table[e[idx[[i]]], {i, Length[idx]}], m]];
      ra = 
        Take[Transpose[Take[Transpose[A.p], dim - Length[m]]], 
          dim - Length[m]];
      ipi = Inverse[ra].Table[Pi, {i, dim - Length[m]}];
      PI = Table[0, {i, dim}];
      Do[PI[[idx[[i]]]] = ipi[[i]], {i, Length[idx]}];
      Return[{Transpose[m], PI}];
      ];



BuildMat[trilist_] := Block[{t, a, n = Length[trilist]},
      a = Table[0, {i, 2*n-1}, {j, 3*n}];
      Do[
        Do[
            a[[j, (j - 1)*3 + i]] = 1;
            , {i, 3}];
        , {j, n}];
      
      Do[
        Do[t = trilist[[j]];
            Do[
              If[t[[2]] == s, a[[n + s - 3, (j - 1)*3 + k]] = 1];
              t = RotateRight[t]
              , {k, 3}];
            , {j, n}];
        , {s, 4, 3 + n - 1}];
      
      Return[a];
      ];

MatE[trilist_] := Block[{t, n = Length[trilist]},
      a = Table[0, {i, 2}, {j, 3*n}];
      Do[
        Do[t = trilist[[j]];
            Do[
              If[t[[2]] == s, a[[s, (j - 1)*3 + k]] = 1];
              t = RotateRight[t]
              , {k, 3}];
            , {j, n}];
        , {s, 2}];
      
      Return[a];
      ];

S[n_] := Permutations[Range[n]];

S3P = {{1, 2, 3}, {2, 3, 1}, {3, 1, 2}};
S3N = {{1, 3, 2}, {2, 1, 3}, {3, 2, 1}};

MatPermut[permut_] := Table[
      Table[
        If[permut[[i]] == j, 1, 0]
        , {j, Length[permut]}],
      {i, Length[permut]}];

ListMatPermut[n_] := Map[MatPermut, S[n]];


ListPermutTri[NbTri_] := 
    Block[{pertri, s3, lst = {}, idx, lstper = {}, perm},
      pertri = S[NbTri]; s3 = S[3];
      lst = Table[s3 + (j - 1)*3, {j, NbTri}];
      Do[
        Do[
            idx = IntegerDigits[j, 6] + 1;
            
            idx = Flatten[
                PrependTo[idx, Table[1, {q, NbTri - Length[idx]}]]];
            perm = {};
            Do[
              AppendTo[perm, lst[[pertri[[i, k]], idx[[1]]]]];
              idx = Drop[idx, 1];
              , {k, NbTri}];
            AppendTo[lstper, perm]
            , {j, 0, (3*NbTri)^NbTri - 1}];
        , {i, Length[pertri]}];
      Return[cutlst[Flatten[lstper], 3*NbTri]];
      ];

PermutTri[NbTri_, K_] := Block[{pertri, s3, lst = {}, idx, perm, i, j},
      pertri = S[NbTri]; s3 = S[3];
      lst = Table[s3 + (j - 1)*3, {j, NbTri}];
      j = Mod[K, 6^NbTri];
      i = Quotient[K - 1, 6^NbTri] + 1;
      idx = IntegerDigits[j, 6] + 1;
      idx = Flatten[PrependTo[idx, Table[1, {q, NbTri - Length[idx]}]]];
      perm = {};
      Do[
        AppendTo[perm, lst[[pertri[[i, k]], idx[[1]]]]]; idx = Drop[idx, 1];
        , {k, NbTri}];
      Return[Flatten[perm]];
      ];


PermutTriP[NbTri_, K_] := Block[{pertri, s3, lst = {}, idx, perm, i, j},
      pertri = S[NbTri]; s3 = S3P;
      lst = Table[s3 + (j - 1)*3, {j, NbTri}];
      j = Mod[K, 3^NbTri];
      i = Quotient[K - 1, 3^NbTri] + 1;
      idx = IntegerDigits[j, 3] + 1;
      idx = Flatten[PrependTo[idx, Table[1, {q, NbTri - Length[idx]}]]];
      perm = {};
      Do[
        AppendTo[perm, lst[[pertri[[i, k]], idx[[1]]]]]; idx = Drop[idx, 1];
        , {k, NbTri}];
      Return[Flatten[perm]];
      ];



ReducePermut[perm_] := Block[{size, carac},
      size = Length[perm]/3;
      carac[block_] := ((Plus @@ block) - 3)/3;
      Return[
        (Table[carac[Take[perm, {(i - 1)*3 + 1, i*3}]], {i, size}] - 1)/3 + 1
        ];
      ];

MatPermutTri[NbTri_, K_] := MatPermut[PermutTri[NbTri, K]];

MatPermutTriP[NbTri_, K_] := MatPermut[PermutTriP[NbTri, K]];

NbPermutTri[n_] := n!*6^n;

NbPermutTriP[n_] := n!*3^n;

ListMatPermutTri[NbTri_] := Map[MatPermut, ListPermutTri[NbTri]];

DoPermut[perm_, lst_] := Table[lst[[perm[[i]]]], {i, Length[lst]}];

Wrongangle[angle_] := 
    Times @@ Table[
        If[NumberQ[
              N[angle[[i]]]] && ((N[angle[[i]]] < 
                    0) || (Mod[N[angle[[i]]], \[Pi]] == 
                    0) || (N[angle[[i]]] == 0)),
          0, 1], {i, Length[angle]}];

NumVecQ[vec_] := And @@ Map[NumberQ[N[#]] &, vec];

BuildIneq[vec_] := Block[{},
      Return[
          And @@ Table[(vec[[i]] > 0) && (vec[[i]] < Pi), {i, Length[vec]}]];
      ];


InSollist[sols_, angles_] := Block[{i = 0, flag = False},
      While[(! flag) && (i < Length[sols]),
        i++; If[sols[[i, 2]] == angles, flag = True]];
      Return[flag];
      ];

ComputeTri[trilist1_, trilist2_] := 
    Block[{x, C1, C2, E1, E2, H, M1, M2, PI1, PI2, sol, angle, pars, varangle,
         nbpars, varpars, null, pi, nbeq, ineq, sollist = {}, big},
      C1 = BuildMat[trilist1];
      C2 = BuildMat[trilist2];
      E1 = MatE[trilist1];
      E2 = MatE[trilist2];
      M1 = reduce[C1][[1]];
      PI1 = reduce[C1][[2]];
      M2 = reduce[C2][[1]];
      PI2 = reduce[C2][[2]];
      nbpars = Length[M1[[1]]];
      varpars = Table[x[i], {i, nbpars}];
      nbeq = Length[C1];
      null = Table[0, {i, Length[C1] + Length[E1]}];
      pi = Table[Pi, {i, nbeq}];
      varangle = M1.varpars + PI1;
      Do[
        H = MatPermutTri[Length[trilist1], i];
        big = Join[C1 - C2.H, E1 - E2.H];
        sol = Flatten[Solve[big.varangle == null, varpars]];
        pars = varpars /. sol;
        angle = M1.pars + PI1;
        If[(sol != {}) && (Chop[big.angle] == null) ,
          If[(Wrongangle[angle] != 0) && (sol != {}) && (NumVecQ[angle]),
              AppendTo[sollist, {PermutTri[Length[trilist1], i], angle}],
              ineq = InequalitySolve[BuildIneq[angle], varpars];
              
              If[(! AtomQ[ineq]), 
                AppendTo[
                  sollist, {PermutTri[Length[trilist1], i], angle, ineq}]];];
          ];
        , {i, NbPermutTri[Length[trilist1]]}];
      Print[Length[sollist], " Solutions trouvees."];
      sollist = Sort[sollist];
      PrependTo[sollist, trilist2]; PrependTo[sollist, trilist1];
      Return[sollist];
      ];


ComputeTriP[trilist1_, trilist2_] := 
    Block[{x, C1, C2, E1, E2, H, M1, M2, PI1, PI2, sol, angle, pars, varangle,
         nbpars, varpars, null, pi, nbeq, ineq, sollist = {}, big},
      C1 = BuildMat[trilist1];
      C2 = BuildMat[trilist2];
      E1 = MatE[trilist1];
      E2 = MatE[trilist2];
      M1 = reduce[C1][[1]];
      PI1 = reduce[C1][[2]];
      M2 = reduce[C2][[1]];
      PI2 = reduce[C2][[2]];
      nbpars = Length[M1[[1]]];
      varpars = Table[x[i], {i, nbpars}];
      nbeq = Length[C1];
      null = Table[0, {i, Length[C1] + Length[E1]}];
      pi = Table[Pi, {i, nbeq}];
      varangle = M1.varpars + PI1;
      Do[
        H = MatPermutTriP[Length[trilist1], i];
        big = Join[C1 - C2.H, E1 - E2.H];
        sol = Flatten[Solve[big.varangle == null, varpars]];
        pars = varpars /. sol;
        angle = M1.pars + PI1;
        If[(sol != {}) && (big.angle == null),
          If[(Wrongangle[angle] != 0) && (sol != {}) && (NumVecQ[angle]),
              AppendTo[sollist, {PermutTriP[Length[trilist1], i], angle}],
              ineq = InequalitySolve[BuildIneq[angle], varpars];
              
              If[(! AtomQ[ineq]), 
                AppendTo[
                  sollist, {PermutTriP[Length[trilist1], i], angle, 
                    ineq}]];];
          ];
        , {i, NbPermutTriP[Length[trilist1]]}];
      Print[Length[sollist], " Solutions trouvees."];
      sollist = Sort[sollist];
      PrependTo[sollist, trilist2]; PrependTo[sollist, trilist1];
      Return[sollist];
      ];




GraphPoly[vlst_] := 
    Graphics[Table[{Thickness[0.0001], 
          Line[{vlst[[i]], vlst[[Mod[i, Length[vlst]] + 1]]}]}, {i, 
          Length[vlst]}]];
DrawPolys[polylist_, as_] := 
    Show[Map[GraphPoly, polylist], AspectRatio -> as];
DrawFilledPolys[polys_, as_] := 
    Show[Graphics[
        Table[{Hue[i/Length[polys]], Polygon[polys[[i]]]}, {i, 
            Length[polys]}]], AspectRatio -> as, Axes -> True];
GraphicsFilledPolys[polys_] := 
    Graphics[Table[{Hue[i/Length[polys]], Polygon[polys[[i]]]}, {i, 
          Length[polys]}], AspectRatio -> 1];


Complete[a_, b_, aa_, ab_] := 
    Block[{seg1, seg2, slope1, slope2, oo1, oo2, xsol, ysol, angleorig},
      If[a[[1]] != b[[1]], 
        angleorig = Chop[N[ArcTan[(b[[2]] - a[[2]])/(b[[1]] - a[[1]])]]], 
        angleorig = Pi/2];
      If[(aa + angleorig != Pi/2) && (ab - angleorig != Pi/2),
        If[angleorig >= 0,
            slope1 = Tan[aa + angleorig] // N;
            oo1 = a[[2]] - slope1*a[[1]];
            slope2 = -Tan[ab - angleorig] // N;
            oo2 = b[[2]] - slope2*b[[1]];
            xsol = (oo2 - oo1)/(slope1 - slope2);
            ysol = slope1*xsol + oo1;,
            slope1 = Tan[aa - Abs[angleorig]] // N;
            oo1 = a[[2]] - slope1*a[[1]];
            slope2 = -Tan[ab + Abs[angleorig]] // N;
            oo2 = b[[2]] - slope2*b[[1]];
            xsol = (oo2 - oo1)/(slope1 - slope2);
            ysol = slope1*xsol + oo1;
            ];
        ];
      If[aa + angleorig == Pi/2,
        slope2 = Tan[Pi + angleorig - ab] // N;
        oo2 = b[[2]] - slope2*b[[1]];
        xsol = a[[1]];
        ysol = slope2*xsol + oo2;
        ];
      If[Pi + angleorig - ab == Pi/2,
        slope1 = Tan[aa + angleorig] // N;
        oo1 = a[[2]] - slope1*a[[1]];
        xsol = b[[1]];
        ysol = slope1*xsol + oo1;
        ];
      Return[Chop[N[{xsol, ysol}]]];
      ];




makepoly[trilist_, angles_] := Block[{points, tri, a, b, graph = {}},
      points = Table[0, {i, Length[trilist] + 2}];
      points[[trilist[[1, 1]]]] = {0, 0}; points[[trilist[[1, 2]]]] = {1, 0};
      Do[tri = trilist[[i]];
        Do[tri = RotateRight[tri];
          If[points[[tri[[2]]]] == 0,
            a = points[[RotateRight[tri, 1][[2]]]];
            b = points[[RotateRight[tri, 2][[2]]]];
            
            points[[tri[[2]]]] = 
              Complete[b, a, angles[[(i - 1)*3 + Mod[j + 2, 3] + 1]], 
                angles[[(i - 1)*3 + Mod[j + 1, 3] + 1]]];
            
            PPrint[RotateRight[tri, 2], " ", RotateRight[tri, 1], " ", 
              angles[[(i - 1)*3 + Mod[j + 2, 3] + 1]], " ", 
              angles[[(i - 1)*3 + Mod[j + 1, 3] + 1]]];
            ];
          , {j, 3}];
        , {i, Length[trilist]}];
      graph = Table[
          Table[
            points[[trilist[[i, j]]]]
            , {j, 3}]
          , {i, Length[trilist]}];
      Return[graph];
      ];


makepolys[trilist1_, trilist2_, permuts_, 
      angles_] := {makepoly[trilist1, angles], 
      makepoly[trilist2, DoPermut[permuts, angles]]};

norm[vec_] := Sqrt[Sum[vec[[i]][[1]]^2 + vec[[i]][[2]]^2, {i, Length[vec]}]];

complex[pt_] := pt[[1]] + I pt[[2]];

couple[z_] := {Re[z], Im[z]};

simil[tri1_, tri2_] := Block[{th, t1, t2, A, t, sol = {}, rsol},
      A = \[Lambda]*{{Cos[th], -Sin[th]}, {Sin[th], Cos[th]}};
      t = {t1, t2};
      sol = 
        Solve[{A.tri1[[1]] + t == tri2[[1]], 
            A.tri1[[2]] + t == tri2[[2]]}, {\[Lambda], th, t1, t2}];
      Table[If[(th /. sol)[[i]] >= 0, rsol = sol[[i]]], {i, Length[sol]}];
      Return[{\[Lambda]*{{Cos[th], -Sin[th]}, {Sin[th], Cos[th]}}, t} /. 
          rsol];
      ];


affinity[tri1_, tri2_] := Block[{a1, a2, b1, b2, t1, t2, A, t, sol = {}},
      A = {{a1, a2}, {b1, b2}};
      t = {t1, t2};
      sol = 
        Solve[{A.tri1[[1]] + t == tri2[[1]], A.tri1[[2]] + t == tri2[[2]], 
            A.tri1[[3]] + t == tri2[[3]]}, {a1, a2, b1, b2, t1, t2}];
      Return[{{{a1, a2}, {b1, b2}}, {t1, t2}} /. sol[[1]]];
      ];


ApplyOnPoly[aff_, pol_] := Map[(aff[[1]].# + aff[[2]]) &, pol];

ApplyOnPolys[aff_, pollst_] := 
    Table[Map[(aff[[1]].# + aff[[2]]) &, pollst[[i]]], {i, Length[pollst]}];


PWA[trilist1_, trilist2_, permuts_, angles_] := 
    Block[{polys, aff = {}, pts1, pts2, tri1, tri2, angls1, angls2},
      polys = MakeNormalizedPolys[trilist1, trilist2, permuts, angles];
      angls1 = 
        Table[RotateRight[trilist1[[i]], j][[2]], {i, Length[trilist1]}, {j, 
              0, 2}] // Flatten;
      angls2 = 
        Table[RotateRight[trilist2[[i]], j][[2]], {i, Length[trilist2]}, {j, 
              0, 2}] // Flatten;
      pts1 = Range[Length[trilist1] + 2];
      pts2 = Range[Length[trilist2] + 2];
      Do[
        pts1[[trilist1[[i, j]]]] = polys[[1]][[i, j]];
        pts2[[trilist2[[i, j]]]] = polys[[2]][[i, j]];
        , {i, Length[trilist1]}, {j, 3}];
      angls2 = DoPermut[InversePermutation[permuts], angls2];
      Do[
        tri1 = Take[angls1, {3*(i - 1) + 1, 3*i}];
        tri2 = Take[angls2, {3*(i - 1) + 1, 3*i}];
        AppendTo[aff, 
          affinity[{pts1[[tri1[[1]]]], pts1[[tri1[[2]]]], 
              pts1[[tri1[[3]]]]}, {pts2[[tri2[[1]]]], pts2[[tri2[[2]]]], 
              pts2[[tri2[[3]]]]}]];
        , {i, Length[trilist1]}];
      Return[Chop[aff]];
      ];

IsIso[pwa_] := 
    And @@ Map[Chop[(Abs[Det[#]] - 1)] == 0 &, Transpose[pwa][[1]]];

MakeNormalizedPolys[trilist1_, trilist2_, permuts_, angles_] := 
    Block[{polys1, polys2, idx11 = {}, idx21 = {}, idx12 = {}, idx22 = {}, a, 
        b, ap, bp, aff, g1, g2, c, cp},
      polys1 = makepoly[trilist1, angles];
      polys2 = makepoly[trilist2, DoPermut[permuts, angles]];
      Do[
        Do[
            If[trilist1[[i, j]] == 1, idx11 = {i, j}];
            If[trilist1[[i, j]] == 2, idx12 = {i, j}];
            If[trilist2[[i, j]] == 1, idx21 = {i, j}];
            If[trilist2[[i, j]] == 2, idx22 = {i, j}];
            , {j, 3}];
        , {i, Length[trilist1]}];
      a = polys1[[idx11[[1]], idx11[[2]]]]; 
      b = polys1[[idx12[[1]], idx12[[2]]]];
      ap = polys2[[idx21[[1]], idx21[[2]]]]; 
      bp = polys2[[idx22[[1]], idx22[[2]]]];
      aff = simil[{a, b}, {ap, bp}];
      polys1 = ApplyOnPolys[aff, polys1];
      Return[{polys1, polys2}];
      ];

DrawPart[trilist1_, trilist2_, permuts_, angles_] := 
    Block[{polys, g1, g2, polys2},
      polys = MakeNormalizedPolys[trilist1, trilist2, permuts, angles];
      polys2 = 
        DoPermut[InversePermutation[ReducePermut[permuts]], polys[[2]]];
      g1 = DrawFilledPolysQuiet[polys[[1]]];
      g2 = DrawFilledPolysQuiet[polys2];
      Show[GraphicsArray[{g1, g2}], Axes -> True, 
        PlotLabel -> ToString[angles]];
      ];

DrawNum[sollist_] := Do[
      If[NumVecQ[sollist[[i, 2]]], 
          DrawPart[sollist[[1]], sollist[[2]], sollist[[i, 1]], 
            sollist[[i, 2]]]];
      , {i, 3, Length[sollist]}];

AreIsoNum[sollist_] := Block[{pwa, idnb = 0}, Do[idnb = 0;
          
          If[NumVecQ[sollist[[i, 2]]], 
            pwa = PWA[sollist[[1]], sollist[[2]], sollist[[i, 1]], 
                sollist[[i, 2]]];
            If[IsIso[pwa], Print["Solution Nb ", i - 2, " is a PWI."];
              
              Do[If[Chop[pwa[[j, 1]] - {{1, 0}, {0, 1}}] == {{0, 0}, {0, 0}}, 
                  idnb++], {j, Length[pwa]}];];
            If[idnb > 0, Print["Warning ! Identity on ", idnb, " atom(s)."]];
            ];
          , {i, 3, Length[sollist]}];
      ];

DrawIsoNum[sollist_] := Do[
      If[NumVecQ[sollist[[i, 2]]],
          
          If[IsIso[
                PWA[sollist[[1]], sollist[[2]], sollist[[i, 1]], 
                  sollist[[i, 2]]]], 
              DrawPart[sollist[[1]], sollist[[2]], sollist[[i, 1]], 
                sollist[[i, 2]]]];
          ];
      , {i, 3, Length[sollist]}];

convertsolNb[sollist_, i_] := Block[{at, mp, pwi},
      at = 
        Chop[MakeNormalizedPolys[sollist[[1]], sollist[[2]], sollist[[i, 1]], 
              sollist[[i, 2]]][[1]]];
      mp = PWA[sollist[[1]], sollist[[2]], sollist[[i, 1]], sollist[[i, 2]]];
      If[! IsIso[mp], Print["Warning: Not a PWI !"]];
      Do[If[Chop[mp[[j, 1]] - {{1, 0}, {0, 1}}] == 0, 
          Print["Warning ! Identity on an atom."]], {j, Length[mp]}];
      pwi = Transpose[{Map[SortVertices[#] &, at], mp}];
      Return[pwi];
      ];
      
      
convertsol[sollist_]:=Block[{at,mp,pwi},
      at=Chop[
          MakeNormalizedPolys[sollist[[1]],sollist[[2]],sollist[[3]],
              sollist[[4]]][[1]]];
      mp=PWA[sollist[[1]],sollist[[2]],sollist[[3]],sollist[[4]]];
      pwi=Transpose[{Map[SortVertices[#]&,at],mp}];
      Return[pwi];
      ];


NumInter[sollist_] := 
    Block[{soln, ineq, pos, var, solveout = {}, newlist = {}, found = False, 
        nb = ""},
      Do[
        If[NumberQ[Times @@ N[sollist[[i, 2]]]], soln = sollist[[i, 2]]; 
            nb = nb <> " Solution Numero:" <> ToString[i - 2] <> 
                " intersection de ";
            Do[
              If[! NumberQ[Times @@ N[sollist[[j, 2]]]], ineq = sollist[[j]];
                  solveout = Flatten[Solve[ineq[[2]] == soln], 1];
                  
                  If[(solveout != {}) && ((ineq[[3]] /. solveout) != False), 
                    found = True; nb = nb <> "," <> ToString[j - 2];];
                  ];
              , {j, 3, Length[sollist]}];
            If[found, AppendTo[newlist, nb]]];
        , {i, 3, Length[sollist]}];
      Print[nb];
      ];


IsAnyNum[sollist_] := 
    Block[{nb = 0}, 
      Do[If[NumberQ[Times @@ N[sollist[[i, 2]]]], nb++], {i, 3, 
          Length[sollist]}]; Print[nb, " numerical sols."]];



SubSpaceQ[base2_, base1_] :=
    If[MatrixRank[Join[base1, base2]] <= Length[base1], Return[True], 
      Return[False]];

SameSpaceQ[base2_, base1_] := 
    If[SubspaceQ[base1, base2] && SubSpaceQ[base2, base1], True, False];


sample[ineqss_, sampling_] := 
    Block[{rules = {}, i, ineq, lbs = "", ubs = "", pos = {}, smpl, ineqs, 
        dummy, var, pos1, pos2},
      If[StringPosition[ToString[ineqss], "||"] == {}, 
        ineqs = ineqss && dummy, ineqs = ineqss[[1]] && dummy];
      Do[
        ineq = StringReplace[ineqs[[i]] /. rules // ToString, "=" -> ""];
        pos = {StringPosition[ineq, "<"][[1, 1]], 
            StringPosition[ineq, "<"][[2, 1]]};
        var = StringTake[ineq, {pos[[1]] + 1, pos[[2]] - 1}];
        ineq = 
          StringReplace[N[(ineqs[[i]] /. rules)] // ToString, "=" -> ""];
        pos = {StringPosition[ineq, "<"][[1, 1]], 
            StringPosition[ineq, "<"][[2, 1]]};
        lbs = StringTake[ineq, pos[[1]] - 1];
        ubs = StringTake[ineq, {pos[[2]] + 1, StringLength[ineq]}];
        If[sampling == 0, smpl = Random[], smpl = sampling];
        AppendTo[rules, 
          ToExpression[var] -> 
            Expand[(smpl*ToExpression[lbs] + (1 - smpl)*ToExpression[ubs])]];
        , {i, Length[ineqs] - 1}];
      Return[rules];
      ];



DrawIneq[sollist_] := Do[
      If[! NumVecQ[sollist[[i, 2]]],
          
          DrawPart[sollist[[1]], sollist[[2]], sollist[[i, 1]], 
              sollist[[i, 2]] /. (sample[sollist[[i, 3]], 0.5])];
          ];
      , {i, 3, Length[sollist]}];

AnimeIneqNb[sollist_, i_] := Do[
      DrawPart[sollist[[1]], sollist[[2]], sollist[[i + 2, 1]], 
        sollist[[i + 2, 2]] /. (sample[sollist[[i + 2, 3]], j])];
      If[IsIso[
          PWA[sollist[[1]], sollist[[2]], sollist[[i + 2, 1]], 
            sollist[[i + 2, 2]] /. (sample[sollist[[i + 2, 3]], j])]],
        Print["C'est une PWI:", 
            PWA[sollist[[1]], sollist[[2]], sollist[[i + 2, 1]], 
              sollist[[i + 2, 2]] /. (sample[sollist[[i + 2, 3]], j])]];]
      , {j, 0.05, 0.95, 0.05}];


Orientation[sol_] := Block[{ans = " mixed"},
      If[And @@ Map[Det[#] > 0 &, Transpose[sol][[1]]], ans = " direct"];
      If[And @@ Map[Det[#] < 0 &, Transpose[sol][[1]]], ans = " reverse"];
      Return[ans];
      ];



centeriso[iso_] := Block[{m = {}, ret},
      m = iso[[1]]-IdentityMatrix[Length[iso[[1]]]];
      If[Chop[Det[m]] != 0,
        ret = Inverse[m].(-iso[[2]]),
        ret = "Reflection"];
      Return[ret];
      ];


Analyze[sh1_, sh2_, sol_] := 
    Block[{diag = "", sampling = {}, clsample, id, reflex, sym, invariant, 
        polys = {}, samepolyQ},
      
      samepolyQ[poly1_, poly2_] := 
        Block[{yes = False, perm = S[Length[poly1]]},
          
          Do[yes = 
              yes || Plus @@ 
                    Flatten[
                      Abs[Chop[N[poly1 - DoPermut[perm[[i]], poly2]]]]] == 
                  0, {i, Length[perm]}];
          Return[yes]];
      
      If[Length[sol] > 2,
        sampling = Chop[N[Table[
                
                convertsol[{sh1, sh2, sol[[1]], 
                    sol[[2]] /. sample[sol[[3]], s]}]
                , {s, 0.1, 0.9, 0.008}]]];
        clsample = 
          Table[Transpose[sampling[[i]]][[2]], {i, Length[sampling]}];
        polys = Table[Transpose[sampling[[i]]][[1]], {i, Length[sampling]}];
        , sampling = Chop[N[convertsol[{sh1, sh2, sol[[1]], sol[[2]]}]]];
        clsample = {Table[sampling[[i, 2]], {i, Length[sampling]}]};
        polys = {Table[sampling[[i, 1]], {i, Length[sampling]}]};
        ];
      If[Length[clsample] > 1, 
        diag = diag <> ToString[Length[clsample]] <> 
            " echantillons examines, a " <> ToString[Length[sh1]] <> 
            " atomes. "];
      If[(Plus @@ 
                Abs[Flatten[
                    Table[Chop[RotateLeft[clsample[[i]]] - clsample[[i]]], {i,
                         Length[clsample]}]]] == 0) && (Length[clsample] > 1),
         diag = diag <> "Toutes les applications sont les memes. "];
      If[(Plus @@ Abs[Flatten[Chop[RotateLeft[clsample] - clsample]]] == 
              0) && (Length[clsample] > 1), 
        diag = diag <> 
            "Toutes les applications sont independantes des angles. "];
      id = 0; reflex = 0; sym = 0; invariant = 0;
      Do[Do[
          If[clsample[[i, j, 1]] == {{0, 1}, {1, 0}}, sym++], {j, 
            Length[clsample[[i]]]}], {i, Length[clsample]}];
      Do[Do[
          If[samepolyQ[ApplyOnPoly[clsample[[i, j]], polys[[i, j]]], 
              polys[[i, j]]]
            , invariant++], {j, Length[clsample[[i]]]}], {i, 
          Length[clsample]}];
      Do[Do[
          If[Chop[clsample[[i, j, 1]]-{{1, 0}, {0, 1}}]=={{0,0},{0,0}}, id++], {j, 
            Length[clsample[[i]]]}], {i, Length[clsample]}];
      Do[Do[
          If[Length[centeriso[clsample[[i, j]]]] == 0, reflex++], {j, 
            Length[clsample[[i]]]}], {i, Length[clsample]}];
      If[invariant > 0, 
        diag = diag <> ToString[invariant/Length[clsample]] <> 
            " atomes invariants. "];
      If[id > 0, 
        diag = diag <> ToString[id/Length[clsample]] <> " identite(s). "];
      If[reflex > 0, 
        diag = diag <> ToString[reflex/Length[clsample]] <> 
            " reflection(s). "];
      If[sym > 0, 
        diag = diag <> ToString[sym/Length[clsample]] <> 
            " symetrie(s) centrale(s). "];
      If[(And @@ Map[IsIso, clsample]),
        If[Length[clsample] > 1, diag = diag <> " Tout les echantillons sont des PWI. ",
           diag = diag <> " C'est une PWI."]];
      Print[diag];
      ];



PrettyPrint[sollist_] := Block[{toshow, nbi = 0, nbn = 0},
      Do[
        toshow = {"Solution numero", i - 2, " Permutation:", 
            MatrixForm[sollist[[i, 1]]], " Angles:", 
            MatrixForm[sollist[[i, 2]]]};
        If[Length[sollist[[i]]] <= 2, nbn++; 
          Analyze[sollist[[1]], sollist[[2]], sollist[[i]]], nbi++; 
          AppendTo[toshow, sollist[[i, 3]]]; 
          Analyze[sollist[[1]], sollist[[2]], sollist[[i]]]];
        Print[toshow];
        Print["------------------------------------------------------"];
        , {i, 3, Length[sollist]}];
      Print[nbi + nbn, " Solutions au total, ", nbn, " Solutions Rigides et ",
         nbi, " simplexes de solutions."];
      ];


AnalyzeQuiet[sh1_, sh2_, sol_] := 
    Block[{diag = {}, sampling = {}, clsample, id, reflex, sym, invariant, 
        polys = {}, samepolyQ},
      
      samepolyQ[poly1_, poly2_] := 
        Block[{yes = False, perm = S[Length[poly1]]},
          
          Do[yes = 
              yes || Plus @@ 
                    Flatten[
                      Abs[Chop[N[poly1 - DoPermut[perm[[i]], poly2]]]]] == 
                  0, {i, Length[perm]}];
          Return[yes]];
      
      If[Length[sol] > 2,
        sampling = Chop[N[Table[
                
                convertsol[{sh1, sh2, sol[[1]], 
                    sol[[2]] /. sample[sol[[3]], s]}]
                , {s, 0.1, 0.9, 0.008}]]];
        clsample = 
          Table[Transpose[sampling[[i]]][[2]], {i, Length[sampling]}];
        polys = Table[Transpose[sampling[[i]]][[1]], {i, Length[sampling]}];
        , sampling = Chop[N[convertsol[{sh1, sh2, sol[[1]], sol[[2]]}]]];
        clsample = {Table[sampling[[i, 2]], {i, Length[sampling]}]};
        polys = {Table[sampling[[i, 1]], {i, Length[sampling]}]};
        ];
      If[Length[clsample] > 1, AppendTo[diag, "Simplex"]];
      If[(Plus @@ 
                Abs[Flatten[
                    Table[Chop[RotateLeft[clsample[[i]]] - clsample[[i]]], {i,
                         Length[clsample]}]]] == 0) && (Length[clsample] > 1),
         AppendTo[diag, "Inv. Globale"]];
      If[(Plus @@ Abs[Flatten[Chop[RotateLeft[clsample] - clsample]]] == 
              0) && (Length[clsample] > 1), AppendTo[diag, "App.Inv."]];
      id = 0; reflex = 0; sym = 0; invariant = 0;
      Do[Do[
          If[clsample[[i, j, 1]] == {{0, 1}, {1, 0}}, sym++], {j, 
            Length[clsample[[i]]]}], {i, Length[clsample]}];
      Do[Do[
          If[samepolyQ[ApplyOnPoly[clsample[[i, j]], polys[[i, j]]], 
              polys[[i, j]]]
            , invariant++], {j, Length[clsample[[i]]]}], {i, 
          Length[clsample]}];
      Do[Do[
          If[clsample[[i, j, 1]] == {{1, 0}, {0, 1}}, id++], {j, 
            Length[clsample[[i]]]}], {i, Length[clsample]}];
      Do[Do[
          If[Length[centeriso[clsample[[i, j]]]] == 0, reflex++], {j, 
            Length[clsample[[i]]]}], {i, Length[clsample]}];
      If[invariant > 0, 
        AppendTo[diag, 
          ToString[invariant/Length[clsample]] <> " at. inv. "]];
      If[id > 0, 
        AppendTo[diag, ToString[id/Length[clsample]] <> " identite(s). "]];
      If[reflex > 0, 
        AppendTo[diag, ToString[reflex/Length[clsample]] <> " refl. "]];
      If[sym > 0, 
        AppendTo[diag, ToString[sym/Length[clsample]] <> " sym.cent. "]];
      If[(And @@ Map[IsIso, clsample]),
        If[Length[clsample] > 1, AppendTo[diag, "PWI ?"];, 
          AppendTo[diag, "PWI."];]];
      If[Length[clsample] > 1,
        AppendTo[diag, Orientation[clsample[[50]]]];
        , AppendTo[diag, Orientation[clsample[[1]]]];];
      Return[diag];
      ];

PrettyPrintQuiet[sollist_] := Block[{toshow = {}, nbi = 0, nbn = 0},
      Do[
        AppendTo[toshow, 
            Flatten[{i - 2, 
                AnalyzeQuiet[sollist[[1]], sollist[[2]], sollist[[i]]]}]];
        , {i, 3, Length[sollist]}];
      Return[toshow];
      ];
      
      
      degrees[sollist_]:=Block[{deg=Table[0,{i,40}],nb=0},
      Do[
        If[And@@Map[NumberQ[N[#]]&,sollist[[i,2]]],nb++;
            deg[[EulerPhi[Max[Map[Denominator,sollist[[i,2]]]]]]]++;
            ];
        ,{i,3,Length[sollist]}];
      Return[deg];
      ];
      
      
      nbnum[sollist_]:=Block[{nb=0},
      Do[
        If[And@@Map[NumberQ[N[#]]&,sollist[[i,2]]],nb++],{i,3,
          Length[sollist]}];
      Return[nb];];

      
      Null
      