(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   1830253,      64208]*)
(*NotebookOutlinePosition[   1830897,      64230]*)
(*  CellTagsIndexPosition[   1830853,      64226]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["\<\

Computations of all the solutions with 3 triangles with the libraries \
\"PWS\".\
\>", "Subtitle"],

Cell[CellGroupData[{

Cell["Librairies loading:", "Subsection"],

Cell[BoxData[{
    \(<< "\<PWS`graphicx`\>"\), "\[IndentingNewLine]", 
    \(<< "\<PWS`bisection`\>"\)}], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Computation of all the pairs with 3 triangles:", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(\(req = {{1, 6, 11}, {2, 9, 12}, {3, 10, 
            13}, {4, 7, 15}, {5, 8, 
            14}};\)\[IndentingNewLine]\[IndentingNewLine]
    \(seq = {{1, 6}, {2, 8}, {4, 10}, {5, 9}, {7, 3}, {11, 11}, {12, 
            14}, {13, 
            15}};\)\[IndentingNewLine]\[IndentingNewLine]\[IndentingNewLine]
    \(find[k_, lst_] := 
        Block[{ans = {}}, \[IndentingNewLine]Do[\[IndentingNewLine]Do[\
\[IndentingNewLine]\(If[lst[\([i, j]\)] \[Equal] k, ans = {i, j}; 
                  Break[]];\)\[IndentingNewLine], {j, 
                Length[lst[\([i]\)]]}]\[IndentingNewLine], {i, 
              Length[lst]}]; \[IndentingNewLine]Return[
            ans];\[IndentingNewLine]];\)\[IndentingNewLine]\[IndentingNewLine]\

    \(biglist = {};\)\[IndentingNewLine]
    \(Do[\[IndentingNewLine]\(Do[
            lst = {}; \[IndentingNewLine]AppendTo[
              lst, {i, j}]; \[IndentingNewLine]posi = 
              find[i, req]; \[IndentingNewLine]newi = 
              req[\([posi[\([1]\)], 
                  Mod[posi[\([2]\)] + 1, 3] + 
                    1]\)]; \[IndentingNewLine]posj = 
              find[j, req]; \[IndentingNewLine]newj = 
              req[\([posj[\([1]\)], 
                  Mod[posj[\([2]\)] + 1, 3] + 
                    1]\)]; \[IndentingNewLine]AppendTo[
              lst, {newi, newj}]; \[IndentingNewLine]posi = find[newi, req]; 
            posj = find[newj, req]; \[IndentingNewLine]newi = 
              req[\([posi[\([1]\)], 
                  Mod[posi[\([2]\)] + 1, 3] + 
                    1]\)]; \[IndentingNewLine]newj = 
              req[\([posj[\([1]\)], 
                  Mod[posj[\([2]\)] + 1, 3] + 
                    1]\)]; \[IndentingNewLine]AppendTo[
              lst, {newi, newj}]; \[IndentingNewLine]posi = 
              find[i, seq]; \[IndentingNewLine]newi = 
              seq[\([posi[\([1]\)], 
                  Mod[posi[\([2]\)] + 2, 2] + 
                    1]\)]; \[IndentingNewLine]posj = 
              find[j, seq]; \[IndentingNewLine]newj = 
              seq[\([posj[\([1]\)], 
                  Mod[posj[\([2]\)] + 2, 2] + 
                    1]\)]; \[IndentingNewLine]AppendTo[lst, {newi, newj}]; 
            lst = Union[lst, 
                lst]; \[IndentingNewLine]\[IndentingNewLine]flag = 
              False; \[IndentingNewLine]Do[\[IndentingNewLine]\(If[
                  MemberQ[biglist, lst[\([l]\)]], flag = True; 
                  Break[]];\)\[IndentingNewLine], {l, 
                Length[lst]}]; \[IndentingNewLine]If[\(! flag\), 
              AppendTo[biglist, {i, j}]];\[IndentingNewLine], {j, 
              15}];\)\[IndentingNewLine], {i, 
          15}];\)\[IndentingNewLine]\[IndentingNewLine]
    biglist // Length\[IndentingNewLine]\[IndentingNewLine]
    \(rclst = Map[Reverse, biglist];\)\[IndentingNewLine]
    \(biglst = {};\)\[IndentingNewLine]
    \(Do[\[IndentingNewLine]\(If[
            biglist[\([i, 1]\)] != 
              biglist[\([i, 
                  2]\)], \[IndentingNewLine]\(If[\(! MemberQ[rclst, 
                    biglist[\([i]\)]]\), 
                AppendTo[biglst, biglist[\([i]\)]]];\)\[IndentingNewLine], 
            AppendTo[biglst, 
              biglist[\([i]\)]]\[IndentingNewLine]];\)\[IndentingNewLine], \
{i, Length[rclst]}];\)\[IndentingNewLine]\[IndentingNewLine]
    \(bigtrilist = {{{1, 2, 4}, {1, 4, 5}, {1, 5, 3}}, {{1, 2, 5}, {5, 2, 
              4}, {1, 4, 3}}, {{1, 5, 4}, {5, 2, 4}, {1, 4, 3}}, {{1, 2, 
              4}, {1, 4, 5}, {5, 4, 3}}, {{1, 5, 3}, {5, 4, 3}, {1, 2, 
              4}}, {{1, 2, 4}, {4, 2, 5}, {5, 2, 3}}, {{1, 5, 4}, {5, 2, 
              4}, {4, 2, 3}}, {{1, 2, 5}, {1, 5, 4}, {4, 2, 3}}, {{4, 5, 
              3}, {3, 5, 2}, {1, 2, 4}}, {{3, 4, 5}, {5, 4, 2}, {1, 2, 
              4}}, {{1, 4, 3}, {4, 5, 3}, {5, 2, 3}}, {{1, 5, 3}, {1, 4, 
              5}, {4, 2, 3}}, {{1, 4, 5}, {5, 4, 3}, {4, 2, 3}}, {{4, 2, 
              5}, {3, 5, 2}, {1, 4, 3}}, {{4, 2, 5}, {4, 5, 3}, {3, 1, 
              4}}};\)\[IndentingNewLine]\[IndentingNewLine]
    \(couplelist = 
        Table[{bigtrilist[\([biglst[\([i, 1]\)]]\)], 
            bigtrilist[\([biglst[\([i, 2]\)]]\)]}, {i, 
            Length[biglst]}];\)\)\)\)], "Input"],

Cell[BoxData[
    \(75\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Computations of all possible solutions (about 20min on a 3Ghz Desktop PC), \
the solutions are then stored into a filed called \"Sols3tri\" and \
\"Sols3triP\", the latter containing only the direct  solutions.
Execute once.\
\>", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(\(Solutions = 
        Table[ComputeTri[couplelist[\([i, 1]\)], couplelist[\([i, 2]\)]], {i, 
            Length[couplelist]}];\)\[IndentingNewLine]
    \(savefile = OpenWrite["\<Sols3tri\>"];\)\[IndentingNewLine]
    \(Write[savefile, Solutions];\)\[IndentingNewLine]
    \(Close[savefile];\)\[IndentingNewLine]\[IndentingNewLine]
    \(SolutionsP = 
        Table[ComputeTriP[couplelist[\([i, 1]\)], 
            couplelist[\([i, 2]\)]], {i, 
            Length[couplelist]}];\)\[IndentingNewLine]
    \(savefile = OpenWrite["\<Sols3triP\>"];\)\[IndentingNewLine]
    \(Write[savefile, SolutionsP];\)\[IndentingNewLine]
    \(Close[savefile];\)\)\)\)], "Input"],

Cell[BoxData[
    RowBox[{\(Solve::"svars"\), \(\(:\)\(\ \)\), "\<\"Equations may not give \
solutions for all \\\"solve\\\" variables. \\!\\(\\*ButtonBox[\\\"More\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Solve::svars\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Solve::"svars"\), \(\(:\)\(\ \)\), "\<\"Equations may not give \
solutions for all \\\"solve\\\" variables. \\!\\(\\*ButtonBox[\\\"More\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Solve::svars\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Solve::"svars"\), \(\(:\)\(\ \)\), "\<\"Equations may not give \
solutions for all \\\"solve\\\" variables. \\!\\(\\*ButtonBox[\\\"More\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Solve::svars\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(Solve :: \\\"svars\\\"\\) will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    InterpretationBox[\(123\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 123, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(20\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 20, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(12\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 12, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(48\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 48, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(9\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 9, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(26\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 26, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(20\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 20, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(48\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 48, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(12\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 12, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(9\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 9, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(26\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 26, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(123\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 123, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(48\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 48, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(51\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 51, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(96\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 96, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(23\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 23, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(85\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 85, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(9\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 9, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(23\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 23, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(18\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 18, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(35\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 35, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(19\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 19, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(297\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 297, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(12\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 12, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(63\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 63, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(51\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 51, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(18\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 18, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(69\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 69, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(26\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 26, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(85\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 85, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(69\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 69, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(19\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 19, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(129\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 129, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(297\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 297, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(26\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 26, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(69\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 69, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(85\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 85, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(19\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 19, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(129\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 129, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(12\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 12, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(51\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 51, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(63\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 63, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(18\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 18, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(69\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 69, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(123\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 123, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(9\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 9, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(18\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 18, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(23\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 23, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(35\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 35, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(19\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 19, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(48\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 48, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(96\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 96, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(51\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 51, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(23\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 23, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(85\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 85, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    RowBox[{\(Solve::"svars"\), \(\(:\)\(\ \)\), "\<\"Equations may not give \
solutions for all \\\"solve\\\" variables. \\!\\(\\*ButtonBox[\\\"More\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Solve::svars\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Solve::"svars"\), \(\(:\)\(\ \)\), "\<\"Equations may not give \
solutions for all \\\"solve\\\" variables. \\!\\(\\*ButtonBox[\\\"More\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Solve::svars\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Solve::"svars"\), \(\(:\)\(\ \)\), "\<\"Equations may not give \
solutions for all \\\"solve\\\" variables. \\!\\(\\*ButtonBox[\\\"More\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Solve::svars\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(Solve :: \\\"svars\\\"\\) will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    InterpretationBox[\(17\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 17, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(4\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 4, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(3\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 3, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(9\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 9, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(4\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 4, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(7\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 7, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(4\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 4, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(9\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 9, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(3\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 3, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(4\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 4, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(7\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 7, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(17\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 17, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(9\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 9, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(9\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 9, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(16\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 16, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(4\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 4, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(9\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 9, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(4\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 4, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(4\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 4, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(5\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 5, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(8\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 8, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(1\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 1, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(33\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 33, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(3\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 3, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(9\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 9, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(9\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 9, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(5\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 5, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(13\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 13, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(7\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 7, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(9\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 9, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(13\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 13, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(1\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 1, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(20\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 20, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(33\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 33, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(7\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 7, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(13\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 13, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(9\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 9, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(1\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 1, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(20\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 20, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(3\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 3, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(9\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 9, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(9\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 9, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(5\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 5, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(13\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 13, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(17\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 17, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(4\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 4, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(5\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 5, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(4\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 4, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(8\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 8, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(1\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 1, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(9\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 9, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(16\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 16, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(9\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 9, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(4\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 4, " Solutions trouvees."],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(9\[InvisibleSpace]" Solutions trouvees."\),
      SequenceForm[ 9, " Solutions trouvees."],
      Editable->False]], "Print"]
}, Open  ]],

Cell[BoxData[
    \(\[IndentingNewLine]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Solutions are loaded from the hard disk, provided the files have been created \
before (see above).\
\>", "Subsection"],

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(\(savefile = 
        OpenRead["\<Sols3tri\>"];\)\[IndentingNewLine]
    \(Solutions = Read[savefile, Expression];\)\[IndentingNewLine]
    \(Close[savefile];\)\[IndentingNewLine]\[IndentingNewLine]
    \(savefile = OpenRead["\<Sols3triP\>"];\)\[IndentingNewLine]
    \(SolutionsP = Read[savefile, Expression];\)\[IndentingNewLine]
    \(Close[savefile];\)\[IndentingNewLine]
    \)\)\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["We count them:", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(Plus @@ 
      Map[Length[#] - 2 &, Solutions]\[IndentingNewLine]
    Plus @@ 
      Map[Length[#] - 2 &, SolutionsP]\[IndentingNewLine]\[IndentingNewLine]
    \)\)\)], "Input"],

Cell[BoxData[
    \(3089\)], "Output"],

Cell[BoxData[
    \(487\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(PrettyPrint[
        Solutions[\([33]\)]];\)\)\)], "Input"],

Cell[BoxData[
    RowBox[{\(Solve::"ifun"\), \(\(:\)\(\ \)\), "\<\"Inverse functions are \
being used by \\!\\(Solve\\), so some solutions may not be found; use Reduce \
for complete solution information. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Solve::ifun\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    RowBox[{\(Solve::"ifun"\), \(\(:\)\(\ \)\), "\<\"Inverse functions are \
being used by \\!\\(Solve\\), so some solutions may not be found; use Reduce \
for complete solution information. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Solve::ifun\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    \("2 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "1", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"1"},
                {"3"},
                {"5"},
                {"4"},
                {"6"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 1, 3, 5, 4, 6, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    RowBox[{\(Solve::"ifun"\), \(\(:\)\(\ \)\), "\<\"Inverse functions are \
being used by \\!\\(Solve\\), so some solutions may not be found; use Reduce \
for complete solution information. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Solve::ifun\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(Solve :: \\\"ifun\\\"\\) will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    \("3 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "2", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"1"},
                {"3"},
                {"5"},
                {"4"},
                {"6"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 1, 3, 5, 4, 6, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("1 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "3", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"1"},
                {"3"},
                {"5"},
                {"6"},
                {"4"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 1, 3, 5, 6, 4, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("1 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "4", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"1"},
                {"3"},
                {"5"},
                {"6"},
                {"4"},
                {"9"},
                {"7"},
                {"8"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 1, 3, 5, 6, 4, 9, 7, 8}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(4\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(3\ \[Pi]\)\/7\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 4, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "5", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"1"},
                {"3"},
                {"8"},
                {"9"},
                {"7"},
                {"5"},
                {"4"},
                {"6"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 1, 3, 8, 9, 7, 5, 4, 6}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/10\)},
                {\(\[Pi]\/2\)},
                {\(\[Pi]\/10\)},
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\(3\ \[Pi]\)\/10\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi]\/2\)},
                {\(\(3\ \[Pi]\)\/10\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 10], Pi], 
            Times[ 
              Rational[ 1, 2], Pi], 
            Times[ 
              Rational[ 1, 10], Pi], 
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 3, 10], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 1, 2], Pi], 
            Times[ 
              Rational[ 3, 10], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "6", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"3"},
                {"1"},
                {"6"},
                {"4"},
                {"5"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 3, 1, 6, 4, 5, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(4\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(4\ \[Pi]\)\/7\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 4, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 4, 7], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("1 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "7", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"3"},
                {"1"},
                {"6"},
                {"5"},
                {"4"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 3, 1, 6, 5, 4, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("1 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "8", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"3"},
                {"1"},
                {"6"},
                {"5"},
                {"4"},
                {"9"},
                {"7"},
                {"8"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 3, 1, 6, 5, 4, 9, 7, 8}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(4\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(3\ \[Pi]\)\/7\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 4, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("2 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "9", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"3"},
                {"1"},
                {"7"},
                {"9"},
                {"8"},
                {"5"},
                {"4"},
                {"6"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 3, 1, 7, 9, 8, 5, 4, 6}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("1 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "10", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"3"},
                {"1"},
                {"7"},
                {"9"},
                {"8"},
                {"6"},
                {"4"},
                {"5"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 3, 1, 7, 9, 8, 6, 4, 5}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "11", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"3"},
                {"1"},
                {"8"},
                {"9"},
                {"7"},
                {"6"},
                {"4"},
                {"5"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 3, 1, 8, 9, 7, 6, 4, 5}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(5\ \[Pi]\)\/8\)},
                {\(\[Pi]\/8\)},
                {\(\[Pi]\/4\)},
                {\(\[Pi]\/8\)},
                {\(\(3\ \[Pi]\)\/8\)},
                {\(\[Pi]\/2\)},
                {\(\[Pi]\/4\)},
                {\(\(3\ \[Pi]\)\/8\)},
                {\(\(3\ \[Pi]\)\/8\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 5, 8], Pi], 
            Times[ 
              Rational[ 1, 8], Pi], 
            Times[ 
              Rational[ 1, 4], Pi], 
            Times[ 
              Rational[ 1, 8], Pi], 
            Times[ 
              Rational[ 3, 8], Pi], 
            Times[ 
              Rational[ 1, 2], Pi], 
            Times[ 
              Rational[ 1, 4], Pi], 
            Times[ 
              Rational[ 3, 8], Pi], 
            Times[ 
              Rational[ 3, 8], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "12", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"3"},
                {"1"},
                {"9"},
                {"8"},
                {"7"},
                {"5"},
                {"4"},
                {"6"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 3, 1, 9, 8, 7, 5, 4, 6}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(4\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(3\ \[Pi]\)\/7\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 4, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "13", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"3"},
                {"1"},
                {"2"},
                {"5"},
                {"6"},
                {"4"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {3, 1, 2, 5, 6, 4, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(4\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(4\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(2\ \[Pi]\)\/7\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 4, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 4, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "14", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"3"},
                {"1"},
                {"2"},
                {"7"},
                {"9"},
                {"8"},
                {"5"},
                {"4"},
                {"6"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {3, 1, 2, 7, 9, 8, 5, 4, 6}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(4\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(4\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(2\ \[Pi]\)\/7\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 4, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 4, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("2 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "15", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"3"},
                {"2"},
                {"1"},
                {"6"},
                {"5"},
                {"4"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {3, 2, 1, 6, 5, 4, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("3 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "16", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"3"},
                {"2"},
                {"1"},
                {"6"},
                {"5"},
                {"4"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {3, 2, 1, 6, 5, 4, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "17", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"3"},
                {"2"},
                {"1"},
                {"9"},
                {"7"},
                {"8"},
                {"4"},
                {"6"},
                {"5"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {3, 2, 1, 9, 7, 8, 4, 6, 5}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(4\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(3\ \[Pi]\)\/7\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 4, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("2 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "18", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"3"},
                {"2"},
                {"1"},
                {"9"},
                {"7"},
                {"8"},
                {"5"},
                {"4"},
                {"6"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {3, 2, 1, 9, 7, 8, 5, 4, 6}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("1 atomes invariants. 2 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "19", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"5"},
                {"4"},
                {"6"},
                {"1"},
                {"2"},
                {"3"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {5, 4, 6, 1, 2, 3, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/3\)},
                {\(\[Pi]\/6\)},
                {\(\[Pi]\/6\)},
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/2\)},
                {\(\[Pi]\/6\)},
                {\(\[Pi]\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 3], Pi], 
            Times[ 
              Rational[ 1, 6], Pi], 
            Times[ 
              Rational[ 1, 6], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 2], Pi], 
            Times[ 
              Rational[ 1, 6], Pi], 
            Times[ 
              Rational[ 1, 3], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "20", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"5"},
                {"6"},
                {"4"},
                {"7"},
                {"9"},
                {"8"},
                {"3"},
                {"2"},
                {"1"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {5, 6, 4, 7, 9, 8, 3, 2, 1}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(4\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(4\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(2\ \[Pi]\)\/7\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 4, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 4, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("2 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "21", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"4"},
                {"5"},
                {"2"},
                {"1"},
                {"3"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 4, 5, 2, 1, 3, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/6\)},
                {\(\(2\ \[Pi]\)\/3\)},
                {\(\[Pi]\/6\)},
                {\(\[Pi]\/2\)},
                {\(\[Pi]\/12\)},
                {\(\(5\ \[Pi]\)\/12\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 6], Pi], 
            Times[ 
              Rational[ 2, 3], Pi], 
            Times[ 
              Rational[ 1, 6], Pi], 
            Times[ 
              Rational[ 1, 2], Pi], 
            Times[ 
              Rational[ 1, 12], Pi], 
            Times[ 
              Rational[ 5, 12], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(" C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "22", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"4"},
                {"5"},
                {"2"},
                {"3"},
                {"1"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 4, 5, 2, 3, 1, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(5\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(3\ \[Pi]\)\/7\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 5, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(" C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "23", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"4"},
                {"5"},
                {"2"},
                {"3"},
                {"1"},
                {"9"},
                {"7"},
                {"8"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 4, 5, 2, 3, 1, 9, 7, 8}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/11\)},
                {\(\(2\ \[Pi]\)\/11\)},
                {\(\(7\ \[Pi]\)\/11\)},
                {\(\[Pi]\/11\)},
                {\(\(9\ \[Pi]\)\/11\)},
                {\(\[Pi]\/11\)},
                {\(\(3\ \[Pi]\)\/11\)},
                {\(\(3\ \[Pi]\)\/11\)},
                {\(\(5\ \[Pi]\)\/11\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 11], Pi], 
            Times[ 
              Rational[ 2, 11], Pi], 
            Times[ 
              Rational[ 7, 11], Pi], 
            Times[ 
              Rational[ 1, 11], Pi], 
            Times[ 
              Rational[ 9, 11], Pi], 
            Times[ 
              Rational[ 1, 11], Pi], 
            Times[ 
              Rational[ 3, 11], Pi], 
            Times[ 
              Rational[ 3, 11], Pi], 
            Times[ 
              Rational[ 5, 11], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(" C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "24", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"4"},
                {"5"},
                {"3"},
                {"1"},
                {"2"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 4, 5, 3, 1, 2, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(" C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "25", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"4"},
                {"5"},
                {"3"},
                {"1"},
                {"2"},
                {"9"},
                {"7"},
                {"8"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 4, 5, 3, 1, 2, 9, 7, 8}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(6\ \[Pi]\)\/13\)},
                {\(\[Pi]\/13\)},
                {\(\(6\ \[Pi]\)\/13\)},
                {\(\(3\ \[Pi]\)\/13\)},
                {\(\(7\ \[Pi]\)\/13\)},
                {\(\(3\ \[Pi]\)\/13\)},
                {\(\(4\ \[Pi]\)\/13\)},
                {\(\(4\ \[Pi]\)\/13\)},
                {\(\(5\ \[Pi]\)\/13\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 6, 13], Pi], 
            Times[ 
              Rational[ 1, 13], Pi], 
            Times[ 
              Rational[ 6, 13], Pi], 
            Times[ 
              Rational[ 3, 13], Pi], 
            Times[ 
              Rational[ 7, 13], Pi], 
            Times[ 
              Rational[ 3, 13], Pi], 
            Times[ 
              Rational[ 4, 13], Pi], 
            Times[ 
              Rational[ 4, 13], Pi], 
            Times[ 
              Rational[ 5, 13], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("2 reflection(s). 1 symetrie(s) centrale(s).  C'est une PWI."\)], \
"Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "26", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"4"},
                {"5"},
                {"3"},
                {"2"},
                {"1"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 4, 5, 3, 2, 1, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/6\)},
                {\(\(2\ \[Pi]\)\/3\)},
                {\(\[Pi]\/6\)},
                {\(\[Pi]\/2\)},
                {\(\[Pi]\/12\)},
                {\(\(5\ \[Pi]\)\/12\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 6], Pi], 
            Times[ 
              Rational[ 2, 3], Pi], 
            Times[ 
              Rational[ 1, 6], Pi], 
            Times[ 
              Rational[ 1, 2], Pi], 
            Times[ 
              Rational[ 1, 12], Pi], 
            Times[ 
              Rational[ 5, 12], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("1 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "27", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"4"},
                {"5"},
                {"7"},
                {"9"},
                {"8"},
                {"1"},
                {"2"},
                {"3"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 4, 5, 7, 9, 8, 1, 2, 3}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("2 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "28", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"4"},
                {"5"},
                {"7"},
                {"9"},
                {"8"},
                {"3"},
                {"2"},
                {"1"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 4, 5, 7, 9, 8, 3, 2, 1}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "29", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"4"},
                {"5"},
                {"9"},
                {"7"},
                {"8"},
                {"1"},
                {"3"},
                {"2"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 4, 5, 9, 7, 8, 1, 3, 2}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(3\ \[Pi]\)\/10\)},
                {\(\(3\ \[Pi]\)\/10\)},
                {\(\[Pi]\/5\)},
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi]\/2\)},
                {\(\[Pi]\/10\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 3, 10], Pi], 
            Times[ 
              Rational[ 3, 10], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 1, 2], Pi], 
            Times[ 
              Rational[ 1, 10], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("1 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "30", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"4"},
                {"5"},
                {"9"},
                {"7"},
                {"8"},
                {"3"},
                {"2"},
                {"1"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 4, 5, 9, 7, 8, 3, 2, 1}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "31", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"4"},
                {"5"},
                {"9"},
                {"8"},
                {"7"},
                {"1"},
                {"2"},
                {"3"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 4, 5, 9, 8, 7, 1, 2, 3}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/10\)},
                {\(\[Pi]\/2\)},
                {\(\[Pi]\/5\)},
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(3\ \[Pi]\)\/10\)},
                {\(\(3\ \[Pi]\)\/10\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 10], Pi], 
            Times[ 
              Rational[ 1, 2], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 3, 10], Pi], 
            Times[ 
              Rational[ 3, 10], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("1 atomes invariants. 2 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "32", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"5"},
                {"4"},
                {"1"},
                {"2"},
                {"3"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 5, 4, 1, 2, 3, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/3\)},
                {\(\[Pi]\/6\)},
                {\(\[Pi]\/6\)},
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/2\)},
                {\(\[Pi]\/6\)},
                {\(\[Pi]\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 3], Pi], 
            Times[ 
              Rational[ 1, 6], Pi], 
            Times[ 
              Rational[ 1, 6], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 2], Pi], 
            Times[ 
              Rational[ 1, 6], Pi], 
            Times[ 
              Rational[ 1, 3], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("2 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "33", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"7"},
                {"9"},
                {"1"},
                {"2"},
                {"3"},
                {"5"},
                {"4"},
                {"6"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 7, 9, 1, 2, 3, 5, 4, 6}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "34", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"7"},
                {"9"},
                {"3"},
                {"2"},
                {"1"},
                {"6"},
                {"4"},
                {"5"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 7, 9, 3, 2, 1, 6, 4, 5}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(4\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(4\ \[Pi]\)\/7\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 4, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 4, 7], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("2 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "35", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"7"},
                {"9"},
                {"5"},
                {"4"},
                {"6"},
                {"1"},
                {"2"},
                {"3"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 7, 9, 5, 4, 6, 1, 2, 3}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "36", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"7"},
                {"9"},
                {"5"},
                {"6"},
                {"4"},
                {"1"},
                {"3"},
                {"2"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 7, 9, 5, 6, 4, 1, 3, 2}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(4\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(3\ \[Pi]\)\/7\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 4, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("2 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "37", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"7"},
                {"9"},
                {"5"},
                {"6"},
                {"4"},
                {"3"},
                {"2"},
                {"1"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 7, 9, 5, 6, 4, 3, 2, 1}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "38", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"7"},
                {"9"},
                {"6"},
                {"4"},
                {"5"},
                {"3"},
                {"2"},
                {"1"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 7, 9, 6, 4, 5, 3, 2, 1}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(4\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(4\ \[Pi]\)\/7\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 4, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 4, 7], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "39", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"7"},
                {"9"},
                {"6"},
                {"5"},
                {"4"},
                {"3"},
                {"1"},
                {"2"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 7, 9, 6, 5, 4, 3, 1, 2}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi]\/2\)},
                {\(\[Pi]\/5\)},
                {\(\(3\ \[Pi]\)\/10\)},
                {\(\[Pi]\/10\)},
                {\(\[Pi]\/2\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(3\ \[Pi]\)\/10\)},
                {\(\[Pi]\/10\)},
                {\(\(3\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 1, 2], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 3, 10], Pi], 
            Times[ 
              Rational[ 1, 10], Pi], 
            Times[ 
              Rational[ 1, 2], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 3, 10], Pi], 
            Times[ 
              Rational[ 1, 10], Pi], 
            Times[ 
              Rational[ 3, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(" C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "40", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"9"},
                {"7"},
                {"1"},
                {"2"},
                {"3"},
                {"6"},
                {"4"},
                {"5"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 9, 7, 1, 2, 3, 6, 4, 5}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "41", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"9"},
                {"7"},
                {"2"},
                {"1"},
                {"3"},
                {"5"},
                {"4"},
                {"6"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 9, 7, 2, 1, 3, 5, 4, 6}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(4\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(4\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(2\ \[Pi]\)\/7\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 4, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 4, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "42", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"9"},
                {"7"},
                {"5"},
                {"6"},
                {"4"},
                {"3"},
                {"1"},
                {"2"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 9, 7, 5, 6, 4, 3, 1, 2}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(3\ \[Pi]\)\/8\)},
                {\(\[Pi]\/4\)},
                {\(\(3\ \[Pi]\)\/8\)},
                {\(\[Pi]\/8\)},
                {\(\(5\ \[Pi]\)\/8\)},
                {\(\[Pi]\/4\)},
                {\(\(3\ \[Pi]\)\/8\)},
                {\(\[Pi]\/8\)},
                {\(\[Pi]\/2\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 3, 8], Pi], 
            Times[ 
              Rational[ 1, 4], Pi], 
            Times[ 
              Rational[ 3, 8], Pi], 
            Times[ 
              Rational[ 1, 8], Pi], 
            Times[ 
              Rational[ 5, 8], Pi], 
            Times[ 
              Rational[ 1, 4], Pi], 
            Times[ 
              Rational[ 3, 8], Pi], 
            Times[ 
              Rational[ 1, 8], Pi], 
            Times[ 
              Rational[ 1, 2], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("1 reflection(s).  C'est une PWI."\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "43", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"9"},
                {"7"},
                {"5"},
                {"6"},
                {"4"},
                {"3"},
                {"2"},
                {"1"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 9, 7, 5, 6, 4, 3, 2, 1}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "44", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"9"},
                {"7"},
                {"8"},
                {"1"},
                {"2"},
                {"3"},
                {"4"},
                {"5"},
                {"6"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {9, 7, 8, 1, 2, 3, 4, 5, 6}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(7\ \[Pi]\)\/9\)},
                {\(\[Pi]\/9\)},
                {\(\[Pi]\/9\)},
                {\(\[Pi]\/3\)},
                {\(\(2\ \[Pi]\)\/9\)},
                {\(\(4\ \[Pi]\)\/9\)},
                {\(\(4\ \[Pi]\)\/9\)},
                {\(\(2\ \[Pi]\)\/9\)},
                {\(\[Pi]\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 7, 9], Pi], 
            Times[ 
              Rational[ 1, 9], Pi], 
            Times[ 
              Rational[ 1, 9], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 2, 9], Pi], 
            Times[ 
              Rational[ 4, 9], Pi], 
            Times[ 
              Rational[ 4, 9], Pi], 
            Times[ 
              Rational[ 2, 9], Pi], 
            Times[ 
              Rational[ 1, 3], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "45", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"9"},
                {"8"},
                {"7"},
                {"5"},
                {"4"},
                {"6"},
                {"1"},
                {"2"},
                {"3"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {9, 8, 7, 5, 4, 6, 1, 2, 3}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(4\ \[Pi]\)\/7\)},
                {\(\[Pi]\/7\)},
                {\(\(3\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 4, 7], Pi], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi]}]]}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 2 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "46", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"1"},
                {"3"},
                {"5"},
                {"6"},
                {"4"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 1, 3, 5, 6, 4, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(x[4]\)},
                {\(2\ \[Pi] - 3\ x[4]\)},
                {\(\(-2\)\ \[Pi] + 4\ x[4]\)},
                {\(2\ \[Pi] - 3\ x[4]\)},
                {\(\[Pi] - x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -3, 
                x[ 4]]], 
            Plus[ 
              Times[ -2, Pi], 
              Times[ 4, 
                x[ 4]]], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -3, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]]}]], ",", \(\[Pi]\/2 < x[4] < \(2\ \[Pi]\)\/3\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "47", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"3"},
                {"1"},
                {"5"},
                {"4"},
                {"6"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 3, 1, 5, 4, 6, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(x[4]\/3\)},
                {\(\(2\ x[4]\)\/3\)},
                {\(x[4]\/3\)},
                {\(x[4]\)},
                {\(\[Pi] - \(4\ x[4]\)\/3\)},
                {\(\(2\ x[4]\)\/3\)},
                {\(x[4]\/3\)},
                {\(\[Pi] - x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 3], 
              x[ 4]], 
            Times[ 
              Rational[ 2, 3], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 3], 
              x[ 4]], 
            x[ 4], 
            Plus[ Pi, 
              Times[ 
                Rational[ -4, 3], 
                x[ 4]]], 
            Times[ 
              Rational[ 2, 3], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 3], 
              x[ 4]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]]}]], ",", \(0 < x[4] < \(3\ \[Pi]\)\/4\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "48", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"3"},
                {"1"},
                {"5"},
                {"4"},
                {"6"},
                {"9"},
                {"7"},
                {"8"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 3, 1, 5, 4, 6, 9, 7, 8}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\(\[Pi]\/3\)\) + \(2\ x[4]\)\/3\)},
                {\(\[Pi]\/3 + x[4]\/3\)},
                {\(\(-\(\[Pi]\/3\)\) + \(2\ x[4]\)\/3\)},
                {\(x[4]\)},
                {\(\(4\ \[Pi]\)\/3 - \(5\ x[4]\)\/3\)},
                {\(\(-\(\(2\ \[Pi]\)\/3\)\) + \(4\ x[4]\)\/3\)},
                {\(\[Pi] - x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - x[4]\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 3], Pi], 
              Times[ 
                Rational[ 2, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ 1, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 3], Pi], 
              Times[ 
                Rational[ 2, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 4, 3], Pi], 
              Times[ 
                Rational[ -5, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -2, 3], Pi], 
              Times[ 
                Rational[ 4, 3], 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]]}]], ",", \(\[Pi]\/2 < x[4] < \(4\ \[Pi]\)\/5\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 2 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "49", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"3"},
                {"1"},
                {"5"},
                {"4"},
                {"6"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 3, 1, 5, 4, 6, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(\(-\(\[Pi]\/2\)\) + \(3\ x[4]\)\/2\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(x[4]\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(\[Pi] - x[4]\)},
                {\(\(-\(\[Pi]\/4\)\) + \(3\ x[4]\)\/4\)},
                {\(\[Pi]\/4 + x[4]\/4\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 2], Pi], 
              Times[ 
                Rational[ 3, 2], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 4], Pi], 
              Times[ 
                Rational[ 3, 4], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 4], Pi], 
              Times[ 
                Rational[ 1, 4], 
                x[ 4]]]}]], ",", \(\[Pi]\/3 < x[4] < \[Pi]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. Toutes les applications sont \
independantes des angles.  Tout les echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "50", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"3"},
                {"1"},
                {"5"},
                {"6"},
                {"4"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 3, 1, 5, 6, 4, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/5\)},
                {\(\(-\(\[Pi]\/5\)\) + x[4]\)},
                {\(\[Pi]\/5\)},
                {\(x[4]\)},
                {\(\(4\ \[Pi]\)\/5 - x[4]\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Plus[ 
              Times[ 
                Rational[ -1, 5], Pi], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 5], Pi], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 4, 5], Pi], 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi]}]], 
        ",", \(\[Pi]\/5 < x[4] < \(4\ \[Pi]\)\/5\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. Toutes les applications sont \
independantes des angles.  Tout les echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "51", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"3"},
                {"1"},
                {"5"},
                {"6"},
                {"4"},
                {"9"},
                {"7"},
                {"8"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 3, 1, 5, 6, 4, 9, 7, 8}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/7\)},
                {\(\(-\(\[Pi]\/7\)\) + x[4]\)},
                {\(\[Pi]\/7\)},
                {\(x[4]\)},
                {\(\(6\ \[Pi]\)\/7 - x[4]\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(2\ \[Pi]\)\/7\)},
                {\(\(3\ \[Pi]\)\/7\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 7], Pi], 
            Plus[ 
              Times[ 
                Rational[ -1, 7], Pi], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 7], Pi], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 6, 7], Pi], 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 2, 7], Pi], 
            Times[ 
              Rational[ 3, 7], Pi]}]], 
        ",", \(\[Pi]\/7 < x[4] < \(6\ \[Pi]\)\/7\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "52", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"3"},
                {"1"},
                {"5"},
                {"6"},
                {"4"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 3, 1, 5, 6, 4, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi] - x[3] - x[4]\)},
                {\(\(-\[Pi]\) + x[3] + 2\ x[4]\)},
                {\(\[Pi] - x[3] - x[4]\)},
                {\(x[4]\)},
                {\(x[3]\)},
                {\(2\ \[Pi] - 2\ x[3] - 2\ x[4]\)},
                {\(\(-\[Pi]\) + \(3\ x[3]\)\/2 + \(3\ x[4]\)\/2\)},
                {\(x[3]\/2 + x[4]\/2\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 3]], 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              x[ 3], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 3]], 
              Times[ -1, 
                x[ 4]]], 
            x[ 4], 
            x[ 3], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -2, 
                x[ 3]], 
              Times[ -2, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 
                Rational[ 3, 2], 
                x[ 3]], 
              Times[ 
                Rational[ 3, 2], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], 
                x[ 3]], 
              Times[ 
                Rational[ 1, 2], 
                x[ 4]]]}]], 
        ",", \(0 < x[3] \[LessEqual] \[Pi]\/3 && 
            1\/3\ \((2\ \[Pi] - 3\ x[3])\) < 
              x[4] < \[Pi] - x[3] || \[Pi]\/3 < x[3] < \[Pi] && 
            1\/2\ \((\[Pi] - x[3])\) < x[4] < \[Pi] - x[3]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 2 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "53", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"3"},
                {"1"},
                {"6"},
                {"5"},
                {"4"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 3, 1, 6, 5, 4, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(\(-\[Pi]\) + 3\ x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(2\ \[Pi] - 4\ x[4]\)},
                {\(\(-\[Pi]\) + 3\ x[4]\)},
                {\(x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 3, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            x[ 4], 
            x[ 4], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -4, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 3, 
                x[ 4]]], 
            x[ 4]}]], ",", \(\[Pi]\/3 < x[4] < \[Pi]\/2\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "54", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"3"},
                {"1"},
                {"9"},
                {"7"},
                {"8"},
                {"5"},
                {"4"},
                {"6"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 3, 1, 9, 7, 8, 5, 4, 6}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(\(-\[Pi]\) + 3\ x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(2\ \[Pi] - 4\ x[4]\)},
                {\(\(-\[Pi]\) + 3\ x[4]\)},
                {\(x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 3, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            x[ 4], 
            x[ 4], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -4, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 3, 
                x[ 4]]], 
            x[ 4]}]], ",", \(\[Pi]\/3 < x[4] < \[Pi]\/2\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "55", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"3"},
                {"1"},
                {"9"},
                {"7"},
                {"8"},
                {"6"},
                {"4"},
                {"5"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 3, 1, 9, 7, 8, 6, 4, 5}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(\(-\[Pi]\) + 3\ x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(2\ \[Pi] - 4\ x[4]\)},
                {\(\(-\[Pi]\) + 3\ x[4]\)},
                {\(x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 3, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            x[ 4], 
            x[ 4], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -4, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 3, 
                x[ 4]]], 
            x[ 4]}]], ",", \(\[Pi]\/3 < x[4] < \[Pi]\/2\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "56", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"2"},
                {"3"},
                {"1"},
                {"9"},
                {"8"},
                {"7"},
                {"6"},
                {"4"},
                {"5"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {2, 3, 1, 9, 8, 7, 6, 4, 5}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(x[4]\/3\)},
                {\(\(2\ x[4]\)\/3\)},
                {\(x[4]\/3\)},
                {\(x[4]\)},
                {\(\[Pi] - \(4\ x[4]\)\/3\)},
                {\(\(2\ x[4]\)\/3\)},
                {\(\[Pi] - \(5\ x[4]\)\/3\)},
                {\(x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 3], 
              x[ 4]], 
            Times[ 
              Rational[ 2, 3], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 3], 
              x[ 4]], 
            x[ 4], 
            Plus[ Pi, 
              Times[ 
                Rational[ -4, 3], 
                x[ 4]]], 
            Times[ 
              Rational[ 2, 3], 
              x[ 4]], 
            Plus[ Pi, 
              Times[ 
                Rational[ -5, 3], 
                x[ 4]]], 
            x[ 4]}]], ",", \(0 < x[4] < \(3\ \[Pi]\)\/5\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s). "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "57", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"3"},
                {"2"},
                {"1"},
                {"5"},
                {"4"},
                {"6"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {3, 2, 1, 5, 4, 6, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi]\/2\)},
                {\(x[3]\)},
                {\(\[Pi]\/2 - x[3]\)},
                {\(\[Pi]\/2 - x[3]\)},
                {\(\[Pi]\/2\)},
                {\(x[3]\)},
                {\(\[Pi]\/2\)},
                {\(\[Pi]\/4 - x[3]\/2\)},
                {\(\[Pi]\/4 + x[3]\/2\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 1, 2], Pi], 
            x[ 3], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ -1, 
                x[ 3]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ -1, 
                x[ 3]]], 
            Times[ 
              Rational[ 1, 2], Pi], 
            x[ 3], 
            Times[ 
              Rational[ 1, 2], Pi], 
            Plus[ 
              Times[ 
                Rational[ 1, 4], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 3]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 4], Pi], 
              Times[ 
                Rational[ 1, 2], 
                x[ 3]]]}]], ",", \(0 < x[3] < \[Pi]\/2\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "58", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"3"},
                {"2"},
                {"1"},
                {"5"},
                {"6"},
                {"4"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {3, 2, 1, 5, 6, 4, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\(\[Pi]\/3\)\) + \(4\ x[4]\)\/3\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)},
                {\(x[4]\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 3], Pi], 
              Times[ 
                Rational[ 4, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]]}]], ",", \(\[Pi]\/4 < x[4] < \[Pi]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "59", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"3"},
                {"2"},
                {"1"},
                {"5"},
                {"6"},
                {"4"},
                {"9"},
                {"7"},
                {"8"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {3, 2, 1, 5, 6, 4, 9, 7, 8}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\(\[Pi]\/3\)\) + \(5\ x[4]\)\/3\)},
                {\(\[Pi]\/3 - \(2\ x[4]\)\/3\)},
                {\(\[Pi]\/3 - \(2\ x[4]\)\/3\)},
                {\(x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - x[4]\/3\)},
                {\(x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - \(4\ x[4]\)\/3\)},
                {\(\[Pi]\/3 + x[4]\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 3], Pi], 
              Times[ 
                Rational[ 5, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -4, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ 1, 3], 
                x[ 4]]]}]], ",", \(\[Pi]\/5 < x[4] < \[Pi]\/2\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 2 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "60", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"3"},
                {"2"},
                {"1"},
                {"5"},
                {"6"},
                {"4"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {3, 2, 1, 5, 6, 4, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(x[4]\/2\)},
                {\(x[4]\/2\)},
                {\(x[4]\/2\)},
                {\(x[4]\)},
                {\(\[Pi] - \(3\ x[4]\)\/2\)},
                {\(x[4]\)},
                {\(\[Pi]\/2 - \(3\ x[4]\)\/4\)},
                {\(\[Pi]\/2 - x[4]\/4\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 2], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 2], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 2], 
              x[ 4]], 
            x[ 4], 
            Plus[ Pi, 
              Times[ 
                Rational[ -3, 2], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -3, 4], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 4], 
                x[ 4]]]}]], ",", \(0 < x[4] < \(2\ \[Pi]\)\/3\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "61", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"3"},
                {"2"},
                {"1"},
                {"7"},
                {"9"},
                {"8"},
                {"4"},
                {"5"},
                {"6"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {3, 2, 1, 7, 9, 8, 4, 5, 6}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\(\[Pi]\/4\)\) + x[4]\)},
                {\(\[Pi]\/4\)},
                {\(\[Pi]\/4\)},
                {\(x[4]\)},
                {\(\(3\ \[Pi]\)\/4 - x[4]\)},
                {\(x[4]\)},
                {\(\[Pi]\/2 - x[4]\)},
                {\(\[Pi]\/2\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 4], Pi], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 4], Pi], 
            Times[ 
              Rational[ 1, 4], Pi], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 3, 4], Pi], 
              Times[ -1, 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 2], Pi]}]], ",", \(\[Pi]\/4 < x[4] < \[Pi]\/2\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "62", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"3"},
                {"2"},
                {"1"},
                {"7"},
                {"9"},
                {"8"},
                {"4"},
                {"6"},
                {"5"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {3, 2, 1, 7, 9, 8, 4, 6, 5}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(x[4]\/3\)},
                {\(\(2\ x[4]\)\/3\)},
                {\(\(2\ x[4]\)\/3\)},
                {\(x[4]\)},
                {\(\[Pi] - \(5\ x[4]\)\/3\)},
                {\(x[4]\)},
                {\(x[4]\/3\)},
                {\(\[Pi] - \(4\ x[4]\)\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 3], 
              x[ 4]], 
            Times[ 
              Rational[ 2, 3], 
              x[ 4]], 
            Times[ 
              Rational[ 2, 3], 
              x[ 4]], 
            x[ 4], 
            Plus[ Pi, 
              Times[ 
                Rational[ -5, 3], 
                x[ 4]]], 
            x[ 4], 
            Times[ 
              Rational[ 1, 3], 
              x[ 4]], 
            Plus[ Pi, 
              Times[ 
                Rational[ -4, 3], 
                x[ 4]]]}]], ",", \(0 < x[4] < \(3\ \[Pi]\)\/5\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "63", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"3"},
                {"2"},
                {"1"},
                {"7"},
                {"9"},
                {"8"},
                {"5"},
                {"4"},
                {"6"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {3, 2, 1, 7, 9, 8, 5, 4, 6}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\(\[Pi]\/3\)\) + \(4\ x[4]\)\/3\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)},
                {\(x[4]\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 3], Pi], 
              Times[ 
                Rational[ 4, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]]}]], ",", \(\[Pi]\/4 < x[4] < \[Pi]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "64", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"3"},
                {"2"},
                {"1"},
                {"7"},
                {"9"},
                {"8"},
                {"6"},
                {"4"},
                {"5"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {3, 2, 1, 7, 9, 8, 6, 4, 5}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(\(-\[Pi]\) + 3\ x[4]\)},
                {\(\(-\[Pi]\) + 3\ x[4]\)},
                {\(x[4]\)},
                {\(2\ \[Pi] - 4\ x[4]\)},
                {\(x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 3, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 3, 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -4, 
                x[ 4]]], 
            x[ 4], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            x[ 4]}]], ",", \(\[Pi]\/3 < x[4] < \[Pi]\/2\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "65", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"3"},
                {"2"},
                {"1"},
                {"9"},
                {"7"},
                {"8"},
                {"6"},
                {"4"},
                {"5"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {3, 2, 1, 9, 7, 8, 6, 4, 5}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(\(-\[Pi]\) + 3\ x[4]\)},
                {\(\(-\[Pi]\) + 3\ x[4]\)},
                {\(x[4]\)},
                {\(2\ \[Pi] - 4\ x[4]\)},
                {\(x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 3, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 3, 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -4, 
                x[ 4]]], 
            x[ 4], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            x[ 4]}]], ",", \(\[Pi]\/3 < x[4] < \[Pi]\/2\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes.  1\n---\n101 reflection(s). \
"\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "66", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"5"},
                {"6"},
                {"1"},
                {"2"},
                {"3"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 5, 6, 1, 2, 3, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\(3\ \[Pi]\)\/5 - x[1]\)},
                {\(\(-\(\[Pi]\/5\)\) + x[1]\)},
                {\(\[Pi]\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(4\ \[Pi]\)\/5 - x[1]\)},
                {\(\[Pi]\/5\)},
                {\(x[1]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 3, 5], Pi], 
            Plus[ 
              Times[ 
                Rational[ 3, 5], Pi], 
              Times[ -1, 
                x[ 1]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 5], Pi], 
              x[ 1]], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Plus[ 
              Times[ 
                Rational[ 4, 5], Pi], 
              Times[ -1, 
                x[ 1]]], 
            Times[ 
              Rational[ 1, 5], Pi], 
            x[ 1]}]], ",", \(\[Pi]\/5 < x[1] < \(3\ \[Pi]\)\/5\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 atomes invariants. 1 \
identite(s). 2 reflection(s).  Tout les echantillons sont des PWI. "\)], \
"Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "67", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"5"},
                {"6"},
                {"1"},
                {"2"},
                {"3"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 5, 6, 1, 2, 3, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(x[4]\/2\)},
                {\(x[4]\/2\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(\[Pi] - \(3\ x[4]\)\/2\)},
                {\(x[4]\/2\)},
                {\(x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 2], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 2], 
              x[ 4]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            x[ 4], 
            x[ 4], 
            Plus[ Pi, 
              Times[ 
                Rational[ -3, 2], 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 2], 
              x[ 4]], 
            x[ 4]}]], ",", \(0 < x[4] < \[Pi]\/2\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 atomes invariants. 1 \
identite(s). 2 reflection(s).  Tout les echantillons sont des PWI. "\)], \
"Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "68", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"5"},
                {"6"},
                {"1"},
                {"3"},
                {"2"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 5, 6, 1, 3, 2, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 3\ x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 3, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            x[ 4], 
            x[ 4], 
            x[ 4], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            x[ 4]}]], ",", \(\[Pi]\/3 < x[4] < \[Pi]\/2\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 atomes invariants. 1 \
identite(s). 2 reflection(s).  Tout les echantillons sont des PWI. "\)], \
"Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "69", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"5"},
                {"6"},
                {"1"},
                {"3"},
                {"2"},
                {"9"},
                {"7"},
                {"8"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 5, 6, 1, 3, 2, 9, 7, 8}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\(\[Pi]\/2\)\) + \(3\ x[4]\)\/2\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 2], Pi], 
              Times[ 
                Rational[ 3, 2], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            x[ 4], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            x[ 4]}]], ",", \(\[Pi]\/3 < x[4] < \[Pi]\/2\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 atomes invariants. 1 \
identite(s). 3 reflection(s).  Tout les echantillons sont des PWI. "\)], \
"Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "70", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"5"},
                {"6"},
                {"1"},
                {"3"},
                {"2"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 5, 6, 1, 3, 2, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-x[2]\) + x[4]\)},
                {\(x[2]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(\[Pi] - x[2] - x[4]\)},
                {\(x[2]\)},
                {\(x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, 
                x[ 2]], 
              x[ 4]], 
            x[ 2], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            x[ 4], 
            x[ 4], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 2]], 
              Times[ -1, 
                x[ 4]]], 
            x[ 2], 
            x[ 4]}]], 
        ",", \(0 < x[2] < \[Pi]\/2 && x[2] < x[4] < \[Pi]\/2\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "71", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"5"},
                {"6"},
                {"8"},
                {"9"},
                {"7"},
                {"1"},
                {"2"},
                {"3"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 5, 6, 8, 9, 7, 1, 2, 3}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\(-\(\(2\ \[Pi]\)\/5\)\) + x[3]\)},
                {\(\(4\ \[Pi]\)\/5 - x[3]\)},
                {\(\(3\ \[Pi]\)\/5 - x[3]\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(x[3]\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi] - x[3]\)},
                {\(\(-\(\[Pi]\/5\)\) + x[3]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 3, 5], Pi], 
            Plus[ 
              Times[ 
                Rational[ -2, 5], Pi], 
              x[ 3]], 
            Plus[ 
              Times[ 
                Rational[ 4, 5], Pi], 
              Times[ -1, 
                x[ 3]]], 
            Plus[ 
              Times[ 
                Rational[ 3, 5], Pi], 
              Times[ -1, 
                x[ 3]]], 
            Times[ 
              Rational[ 2, 5], Pi], 
            x[ 3], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 3]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 5], Pi], 
              x[ 3]]}]], ",", \(\(2\ \[Pi]\)\/5 < x[3] < \(3\ \[Pi]\)\/5\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "72", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"5"},
                {"6"},
                {"9"},
                {"7"},
                {"8"},
                {"3"},
                {"1"},
                {"2"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 5, 6, 9, 7, 8, 3, 1, 2}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/5\)},
                {\(\(-\(\[Pi]\/5\)\) + x[4]\)},
                {\(\(3\ \[Pi]\)\/5 - x[4]\)},
                {\(x[4]\)},
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(4\ \[Pi]\)\/5 - x[4]\)},
                {\(\(-\(\(2\ \[Pi]\)\/5\)\) + x[4]\)},
                {\(\(3\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Plus[ 
              Times[ 
                Rational[ -1, 5], Pi], 
              x[ 4]], 
            Plus[ 
              Times[ 
                Rational[ 3, 5], Pi], 
              Times[ -1, 
                x[ 4]]], 
            x[ 4], 
            Times[ 
              Rational[ 2, 5], Pi], 
            Plus[ 
              Times[ 
                Rational[ 4, 5], Pi], 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -2, 5], Pi], 
              x[ 4]], 
            Times[ 
              Rational[ 3, 5], Pi]}]], 
        ",", \(\(2\ \[Pi]\)\/5 < x[4] < \(3\ \[Pi]\)\/5\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "73", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"1"},
                {"2"},
                {"3"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 1, 2, 3, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/3 - x[1] + \(2\ x[4]\)\/3\)},
                {\(\(-\(\[Pi]\/3\)\) + x[1] + x[4]\/3\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)},
                {\(\(2\ \[Pi]\)\/3 - x[1] + x[4]\/3\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(x[1]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ -1, 
                x[ 1]], 
              Times[ 
                Rational[ 2, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 3], Pi], 
              x[ 1], 
              Times[ 
                Rational[ 1, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ -1, 
                x[ 1]], 
              Times[ 
                Rational[ 1, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            x[ 1]}]], 
        ",", \(0 < x[1] \[LessEqual] \[Pi]\/3 && \[Pi] - 3\ x[1] < 
              x[4] < \[Pi] || \[Pi]\/3 < x[1] < \[Pi] && 
            1\/2\ \((\(-\[Pi]\) + 3\ x[1])\) < x[4] < \[Pi]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "74", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"1"},
                {"2"},
                {"3"},
                {"9"},
                {"7"},
                {"8"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 1, 2, 3, 9, 7, 8}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/3 - x[2] + x[4]\/3\)},
                {\(\(-\(\[Pi]\/3\)\) + x[2] + \(2\ x[4]\)\/3\)},
                {\(\[Pi]\/3 - \(2\ x[4]\)\/3\)},
                {\(x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - x[4]\/3\)},
                {\(\(2\ \[Pi]\)\/3 - x[2] - x[4]\/3\)},
                {\(x[2]\)},
                {\(\[Pi]\/3 + x[4]\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ -1, 
                x[ 2]], 
              Times[ 
                Rational[ 1, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 3], Pi], 
              x[ 2], 
              Times[ 
                Rational[ 2, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ -1, 
                x[ 2]], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            x[ 2], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ 1, 3], 
                x[ 4]]]}]], 
        ",", \(0 < x[2] \[LessEqual] \[Pi]\/3 && 
            1\/2\ \((\[Pi] - 3\ x[2])\) < x[4] < \[Pi]\/2 || \[Pi]\/3 < 
              x[2] < \[Pi]\/2 && \(-\[Pi]\) + 3\ x[2] < x[4] < \[Pi]\/2\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 2 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "75", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"1"},
                {"2"},
                {"3"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 1, 2, 3, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(x[4]\/2\)},
                {\(x[4]\/2\)},
                {\(\[Pi] - x[3] - x[4]\)},
                {\(x[4]\)},
                {\(x[3]\)},
                {\(\[Pi] - x[3] - x[4]\/2\)},
                {\(x[3]\/2\)},
                {\(x[3]\/2 + x[4]\/2\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 2], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 2], 
              x[ 4]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 3]], 
              Times[ -1, 
                x[ 4]]], 
            x[ 4], 
            x[ 3], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 3]], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 2], 
              x[ 3]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], 
                x[ 3]], 
              Times[ 
                Rational[ 1, 2], 
                x[ 4]]]}]], 
        ",", \(0 < x[3] < \[Pi] && 0 < x[4] < \[Pi] - x[3]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 2 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "76", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"1"},
                {"3"},
                {"2"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 1, 3, 2, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + \(3\ x[3]\)\/2 + \(3\ x[4]\)\/2\)},
                {\(\[Pi] - \(3\ x[3]\)\/2 - x[4]\/2\)},
                {\(\[Pi] - x[3] - x[4]\)},
                {\(x[4]\)},
                {\(x[3]\)},
                {\(x[3]\/2 + x[4]\/2\)},
                {\(\[Pi] - x[3] - x[4]\)},
                {\(x[3]\/2 + x[4]\/2\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 
                Rational[ 3, 2], 
                x[ 3]], 
              Times[ 
                Rational[ 3, 2], 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ 
                Rational[ -3, 2], 
                x[ 3]], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 3]], 
              Times[ -1, 
                x[ 4]]], 
            x[ 4], 
            x[ 3], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], 
                x[ 3]], 
              Times[ 
                Rational[ 1, 2], 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 3]], 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], 
                x[ 3]], 
              Times[ 
                Rational[ 1, 2], 
                x[ 4]]]}]], 
        ",", \(0 < x[3] \[LessEqual] \[Pi]\/2 && 
            1\/3\ \((2\ \[Pi] - 3\ x[3])\) < 
              x[4] < \[Pi] - x[3] || \[Pi]\/2 < x[3] < \(2\ \[Pi]\)\/3 && 
            1\/3\ \((2\ \[Pi] - 3\ x[3])\) < x[4] < 2\ \[Pi] - 3\ x[3]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 2 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "77", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"1"},
                {"3"},
                {"2"},
                {"9"},
                {"7"},
                {"8"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 1, 3, 2, 9, 7, 8}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\(\[Pi]\/2\)\) + \(3\ x[3]\)\/4 + \(3\ x[4]\)\/4\)},
                {\(\[Pi]\/2 - \(3\ x[3]\)\/4 + x[4]\/4\)},
                {\(\[Pi] - x[3] - x[4]\)},
                {\(x[4]\)},
                {\(x[3]\)},
                {\(\[Pi]\/2 - x[3]\/4 - x[4]\/4\)},
                {\(\[Pi]\/2 - x[3]\/4 - x[4]\/4\)},
                {\(x[3]\/2 + x[4]\/2\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 2], Pi], 
              Times[ 
                Rational[ 3, 4], 
                x[ 3]], 
              Times[ 
                Rational[ 3, 4], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -3, 4], 
                x[ 3]], 
              Times[ 
                Rational[ 1, 4], 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 3]], 
              Times[ -1, 
                x[ 4]]], 
            x[ 4], 
            x[ 3], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 4], 
                x[ 3]], 
              Times[ 
                Rational[ -1, 4], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 4], 
                x[ 3]], 
              Times[ 
                Rational[ -1, 4], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], 
                x[ 3]], 
              Times[ 
                Rational[ 1, 2], 
                x[ 4]]]}]], 
        ",", \(0 < x[3] \[LessEqual] \(2\ \[Pi]\)\/3 && 
            1\/3\ \((2\ \[Pi] - 3\ x[3])\) < 
              x[4] < \[Pi] - x[3] || \(2\ \[Pi]\)\/3 < 
              x[3] < \(3\ \[Pi]\)\/4 && \(-2\)\ \[Pi] + 3\ x[3] < 
              x[4] < \[Pi] - x[3]\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    RowBox[{\(ReplaceAll::"reps"\), \(\(:\)\(\ \)\), "\<\"\\!\\({rsol}\\) is \
neither a list of replacement rules nor a valid dispatch table, and so cannot \
be used for replacing. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"ReplaceAll::reps\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(ReplaceAll::"reps"\), \(\(:\)\(\ \)\), "\<\"\\!\\({rsol}\\) is \
neither a list of replacement rules nor a valid dispatch table, and so cannot \
be used for replacing. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"ReplaceAll::reps\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Dot::"rect"\), \(\(:\)\(\ \)\), "\<\"Non-rectangular tensor \
encountered. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Dot::rect\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Dot::"rect"\), \(\(:\)\(\ \)\), "\<\"Non-rectangular tensor \
encountered. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Dot::rect\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Dot::"rect"\), \(\(:\)\(\ \)\), "\<\"Non-rectangular tensor \
encountered. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Dot::rect\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(Dot :: \\\"rect\\\"\\) will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    RowBox[{\(ReplaceAll::"reps"\), \(\(:\)\(\ \)\), "\<\"\\!\\({rsol}\\) is \
neither a list of replacement rules nor a valid dispatch table, and so cannot \
be used for replacing. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"ReplaceAll::reps\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(ReplaceAll :: \\\"reps\\\"\\) will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Solve::"dinv"\), \(\(:\)\(\ \)\), "\<\"The expression \\!\\(\\(\
\\({\\(\\({a1, a2}\\)\\), \\(\\({b1, b2}\\)\\)}\\)\\) . \\(\\((rsol + \
\\(\\(\\(\\({\\(\\({\\(\\({\\(\\(\[Lambda]\\\\ \
\\(\\(Cos[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\
\\(\\(-\[Lambda]\\)\\)\\\\ \\(\\(Sin[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\
\\)\\)]\\)\\)\\)\\)}\\)\\), \\(\\({\\(\\(\[Lambda]\\\\ \\(\\(Sin[\\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\[Lambda]\\\\ \
\\(\\(Cos[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\)}\\)\\)}\
\\)\\), \\(\\({t1, t2}\\)\\)}\\)\\) . \\(\\({0, 0}\\)\\)\\)\\))\\)\\)\\) \
involves unknowns in more than one argument, so inverse functions cannot be \
used. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Solve::dinv\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Solve::"dinv"\), \(\(:\)\(\ \)\), "\<\"The expression \\!\\(\\(\
\\({\\(\\({a1, a2}\\)\\), \\(\\({b1, b2}\\)\\)}\\)\\) . \\(\\((rsol + \
\\(\\(\\(\\({\\(\\({\\(\\({\\(\\(\[Lambda]\\\\ \
\\(\\(Cos[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\
\\(\\(-\[Lambda]\\)\\)\\\\ \\(\\(Sin[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\
\\)\\)]\\)\\)\\)\\)}\\)\\), \\(\\({\\(\\(\[Lambda]\\\\ \\(\\(Sin[\\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\[Lambda]\\\\ \
\\(\\(Cos[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\)}\\)\\)}\
\\)\\), \\(\\({t1, t2}\\)\\)}\\)\\) . \\(\\({0, 0}\\)\\)\\)\\))\\)\\)\\) \
involves unknowns in more than one argument, so inverse functions cannot be \
used. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Solve::dinv\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Solve::"dinv"\), \(\(:\)\(\ \)\), "\<\"The expression \\!\\(\\(\
\\({\\(\\({a1, a2}\\)\\), \\(\\({b1, b2}\\)\\)}\\)\\) . \\(\\((rsol + \
\\(\\(\\(\\({\\(\\({\\(\\({\\(\\(\[Lambda]\\\\ \
\\(\\(Cos[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\
\\(\\(-\[Lambda]\\)\\)\\\\ \\(\\(Sin[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\
\\)\\)]\\)\\)\\)\\)}\\)\\), \\(\\({\\(\\(\[Lambda]\\\\ \\(\\(Sin[\\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\[Lambda]\\\\ \
\\(\\(Cos[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\)}\\)\\)}\
\\)\\), \\(\\({t1, t2}\\)\\)}\\)\\) . \\(\\({1, 0}\\)\\)\\)\\))\\)\\)\\) \
involves unknowns in more than one argument, so inverse functions cannot be \
used. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Solve::dinv\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(Solve :: \\\"dinv\\\"\\) will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    RowBox[{\(Transpose::"nmtx"\), \(\(:\)\(\ \)\), "\<\"The first two levels \
of the one-dimensional list \\!\\({\\(\\(rsol + \
\\(\\(\\(\\({\\(\\({\\(\\({\\(\\(\[Lambda]\\\\ \
\\(\\(Cos[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\
\\(\\(-\[Lambda]\\)\\)\\\\ \\(\\(Sin[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\
\\)\\)]\\)\\)\\)\\)}\\)\\), \\(\\({\\(\\(\[Lambda]\\\\ \\(\\(Sin[\\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\[Lambda]\\\\ \
\\(\\(Cos[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\)}\\)\\)}\
\\)\\), \\(\\({t1, t2}\\)\\)}\\)\\) . \\(\\({0, 0}\\)\\)\\)\\)\\)\\), \
\\(\\(rsol + \\(\\(\\(\\({\\(\\({\\(\\({\\(\\(\[Lambda]\\\\ \\(\\(Cos[\\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\\(\\(-\[Lambda]\
\\)\\)\\\\ \\(\\(Sin[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\
\\)}\\)\\), \\(\\({\\(\\(\[Lambda]\\\\ \\(\\(Sin[\\(\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\[Lambda]\\\\ \\(\\(Cos[\\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\)}\\)\\)}\\)\\), \
\\(\\({t1, t2}\\)\\)}\\)\\) . \\(\\({1, 0}\\)\\)\\)\\)\\)\\), \\(\\(rsol + \
\\(\\(\\(\\({\\(\\({\\(\\({\\(\\(\[Lambda]\\\\ \
\\(\\(Cos[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\
\\(\\(-\[Lambda]\\)\\)\\\\ \\(\\(Sin[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\
\\)\\)]\\)\\)\\)\\)}\\)\\), \\(\\({\\(\\(\[Lambda]\\\\ \\(\\(Sin[\\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\[Lambda]\\\\ \
\\(\\(Cos[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\)}\\)\\)}\
\\)\\), \\(\\({t1, t2}\\)\\)}\\)\\) . \\(\\({xsol, \
ysol}\\)\\)\\)\\)\\)\\)}\\) cannot be transposed. \\!\\(\\*ButtonBox[\\\"More\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Transpose::nmtx\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Transpose::"tperm"\), \(\(:\)\(\ \)\), "\<\"Permutation \\!\\({\
\\(\\(90\\\\ t$256356\\)\\), \\(\\(90\\\\ t$256357\\)\\), \\(\\(90\\\\ \
t$256358\\)\\)}\\) is longer than the dimensions \\!\\({3}\\) of the array. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Transpose::tperm\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    RowBox[{\(Take::"take"\), \(\(:\)\(\ \)\), "\<\"Cannot take positions \\!\
\\(1\\) through \\!\\(2\\) in \
\\!\\(Transpose[\\(\\(Transpose[\\(\\(Transpose[\\(\\(\\(\\({\\(\\(rsol + \\(\
\\(\\(\\({\\(\\({\\(\[LeftSkeleton] 2 \[RightSkeleton]\\)}\\)\\), \\(\\({\\(\
\[LeftSkeleton] 2 \[RightSkeleton]\\)}\\)\\)}\\)\\) . \\(\\({0, \
0}\\)\\)\\)\\)\\)\\), \\(\\(rsol + \\(\\(\\(\\({\\(\\({\\(\[LeftSkeleton] 2 \
\[RightSkeleton]\\)}\\)\\), \\(\\({\\(\[LeftSkeleton] 2 \
\[RightSkeleton]\\)}\\)\\)}\\)\\) . \\(\\({1, 0}\\)\\)\\)\\)\\)\\), \
\\(\\(rsol + \\(\\(\\(\\({\\(\\({\\(\[LeftSkeleton] 2 \[RightSkeleton]\\)}\\)\
\\), \\(\\({\\(\[LeftSkeleton] 2 \[RightSkeleton]\\)}\\)\\)}\\)\\) . \
\\(\\({xsol, ysol}\\)\\)\\)\\)\\)\\)}\\)\\), \\(\\({\\(\\(90\\\\ \
t$256356\\)\\), \\(\\(90\\\\ t$256357\\)\\), \\(\\(90\\\\ \
t$256358\\)\\)}\\)\\)\\)\\)]\\)\\)]\\)\\)]\\). \\!\\(\\*ButtonBox[\\\"More\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Take::take\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Transpose::"nmtx"\), \(\(:\)\(\ \)\), "\<\"The first two levels \
of the one-dimensional list \\!\\({\\(\\(rsol + \
\\(\\(\\(\\({\\(\\({\\(\\({\\(\\(\[Lambda]\\\\ \
\\(\\(Cos[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\
\\(\\(-\[Lambda]\\)\\)\\\\ \\(\\(Sin[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\
\\)\\)]\\)\\)\\)\\)}\\)\\), \\(\\({\\(\\(\[Lambda]\\\\ \\(\\(Sin[\\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\[Lambda]\\\\ \
\\(\\(Cos[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\)}\\)\\)}\
\\)\\), \\(\\({t1, t2}\\)\\)}\\)\\) . \\(\\({1, 0}\\)\\)\\)\\)\\)\\), \
\\(\\(rsol + \\(\\(\\(\\({\\(\\({\\(\\({\\(\\(\[Lambda]\\\\ \\(\\(Cos[\\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\\(\\(-\[Lambda]\
\\)\\)\\\\ \\(\\(Sin[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\
\\)}\\)\\), \\(\\({\\(\\(\[Lambda]\\\\ \\(\\(Sin[\\(\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\[Lambda]\\\\ \\(\\(Cos[\\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\)}\\)\\)}\\)\\), \
\\(\\({t1, t2}\\)\\)}\\)\\) . \\(\\({xsol, ysol}\\)\\)\\)\\)\\)\\), \
\\(\\(rsol + \\(\\(\\(\\({\\(\\({\\(\\({\\(\\(\[Lambda]\\\\ \\(\\(Cos[\\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\\(\\(-\[Lambda]\
\\)\\)\\\\ \\(\\(Sin[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\
\\)}\\)\\), \\(\\({\\(\\(\[Lambda]\\\\ \\(\\(Sin[\\(\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\[Lambda]\\\\ \\(\\(Cos[\\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\)}\\)\\)}\\)\\), \
\\(\\({t1, t2}\\)\\)}\\)\\) . \\(\\({xsol, ysol}\\)\\)\\)\\)\\)\\)}\\) cannot \
be transposed. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Transpose::nmtx\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Transpose::"tperm"\), \(\(:\)\(\ \)\), "\<\"Permutation \\!\\({\
\\(\\(90\\\\ t$256363\\)\\), \\(\\(90\\\\ t$256364\\)\\), \\(\\(90\\\\ \
t$256365\\)\\)}\\) is longer than the dimensions \\!\\({3}\\) of the array. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Transpose::tperm\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    RowBox[{\(Take::"take"\), \(\(:\)\(\ \)\), "\<\"Cannot take positions \\!\
\\(1\\) through \\!\\(2\\) in \
\\!\\(Transpose[\\(\\(Transpose[\\(\\(Transpose[\\(\\(\\(\\({\\(\\(rsol + \\(\
\\(\\(\\({\\(\\({\\(\[LeftSkeleton] 2 \[RightSkeleton]\\)}\\)\\), \\(\\({\\(\
\[LeftSkeleton] 2 \[RightSkeleton]\\)}\\)\\)}\\)\\) . \\(\\({1, \
0}\\)\\)\\)\\)\\)\\), \\(\\(rsol + \\(\\(\\(\\({\\(\\({\\(\[LeftSkeleton] 2 \
\[RightSkeleton]\\)}\\)\\), \\(\\({\\(\[LeftSkeleton] 2 \
\[RightSkeleton]\\)}\\)\\)}\\)\\) . \\(\\({xsol, ysol}\\)\\)\\)\\)\\)\\), \\(\
\\(rsol + \\(\\(\\(\\({\\(\\({\\(\[LeftSkeleton] 2 \
\[RightSkeleton]\\)}\\)\\), \\(\\({\\(\[LeftSkeleton] 2 \
\[RightSkeleton]\\)}\\)\\)}\\)\\) . \\(\\({xsol, \
ysol}\\)\\)\\)\\)\\)\\)}\\)\\), \\(\\({\\(\\(90\\\\ t$256363\\)\\), \
\\(\\(90\\\\ t$256364\\)\\), \\(\\(90\\\\ t$256365\\)\\)}\\)\\)\\)\\)]\\)\\)]\
\\)\\)]\\). \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Take::take\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Transpose::"nmtx"\), \(\(:\)\(\ \)\), "\<\"The first two levels \
of the one-dimensional list \\!\\({\\(\\(rsol + \
\\(\\(\\(\\({\\(\\({\\(\\({\\(\\(\[Lambda]\\\\ \
\\(\\(Cos[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\
\\(\\(-\[Lambda]\\)\\)\\\\ \\(\\(Sin[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\
\\)\\)]\\)\\)\\)\\)}\\)\\), \\(\\({\\(\\(\[Lambda]\\\\ \\(\\(Sin[\\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\[Lambda]\\\\ \
\\(\\(Cos[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\)}\\)\\)}\
\\)\\), \\(\\({t1, t2}\\)\\)}\\)\\) . \\(\\({0, 0}\\)\\)\\)\\)\\)\\), \
\\(\\(rsol + \\(\\(\\(\\({\\(\\({\\(\\({\\(\\(\[Lambda]\\\\ \\(\\(Cos[\\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\\(\\(-\[Lambda]\
\\)\\)\\\\ \\(\\(Sin[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\
\\)}\\)\\), \\(\\({\\(\\(\[Lambda]\\\\ \\(\\(Sin[\\(\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\[Lambda]\\\\ \\(\\(Cos[\\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\)}\\)\\)}\\)\\), \
\\(\\({t1, t2}\\)\\)}\\)\\) . \\(\\({xsol, ysol}\\)\\)\\)\\)\\)\\), \
\\(\\(rsol + \\(\\(\\(\\({\\(\\({\\(\\({\\(\\(\[Lambda]\\\\ \\(\\(Cos[\\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\\(\\(-\[Lambda]\
\\)\\)\\\\ \\(\\(Sin[\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\
\\)}\\)\\), \\(\\({\\(\\(\[Lambda]\\\\ \\(\\(Sin[\\(\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\)]\\)\\)\\)\\), \\(\\(\[Lambda]\\\\ \\(\\(Cos[\\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)]\\)\\)\\)\\)}\\)\\)}\\)\\), \
\\(\\({t1, t2}\\)\\)}\\)\\) . \\(\\({xsol, ysol}\\)\\)\\)\\)\\)\\)}\\) cannot \
be transposed. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Transpose::nmtx\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(Transpose :: \\\"nmtx\\\"\\) will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Transpose::"tperm"\), \(\(:\)\(\ \)\), "\<\"Permutation \\!\\({\
\\(\\(90\\\\ t$256371\\)\\), \\(\\(90\\\\ t$256372\\)\\), \\(\\(90\\\\ \
t$256373\\)\\)}\\) is longer than the dimensions \\!\\({3}\\) of the array. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Transpose::tperm\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(Transpose :: \\\"tperm\\\"\\) will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Take::"take"\), \(\(:\)\(\ \)\), "\<\"Cannot take positions \\!\
\\(1\\) through \\!\\(2\\) in \
\\!\\(Transpose[\\(\\(Transpose[\\(\\(Transpose[\\(\\(\\(\\({\\(\\(rsol + \\(\
\\(\\(\\({\\(\\({\\(\[LeftSkeleton] 2 \[RightSkeleton]\\)}\\)\\), \\(\\({\\(\
\[LeftSkeleton] 2 \[RightSkeleton]\\)}\\)\\)}\\)\\) . \\(\\({0, \
0}\\)\\)\\)\\)\\)\\), \\(\\(rsol + \\(\\(\\(\\({\\(\\({\\(\[LeftSkeleton] 2 \
\[RightSkeleton]\\)}\\)\\), \\(\\({\\(\[LeftSkeleton] 2 \
\[RightSkeleton]\\)}\\)\\)}\\)\\) . \\(\\({xsol, ysol}\\)\\)\\)\\)\\)\\), \\(\
\\(rsol + \\(\\(\\(\\({\\(\\({\\(\[LeftSkeleton] 2 \
\[RightSkeleton]\\)}\\)\\), \\(\\({\\(\[LeftSkeleton] 2 \
\[RightSkeleton]\\)}\\)\\)}\\)\\) . \\(\\({xsol, \
ysol}\\)\\)\\)\\)\\)\\)}\\)\\), \\(\\({\\(\\(90\\\\ t$256371\\)\\), \
\\(\\(90\\\\ t$256372\\)\\), \\(\\(90\\\\ t$256373\\)\\)}\\)\\)\\)\\)]\\)\\)]\
\\)\\)]\\). \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Take::take\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(Take :: \\\"take\\\"\\) will be suppressed during this calculation. \\!\
\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Det::"matsq"\), \(\(:\)\(\ \)\), "\<\"Argument \
\\!\\({\\(\\({\\(\\({\\(\\(\\(\\(-1\\)\\) + a1\\)\\), \\(\\(\\(\\(-1\\)\\) + \
a2\\)\\)}\\)\\), \\(\\({b1, b2}\\)\\)}\\)\\), \\(\\({t1, \\(\\(\\(\\(-1\\)\\) \
+ t2\\)\\)}\\)\\)}\\) at position \\!\\(1\\) is not a nonempty square matrix. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::matsq\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    RowBox[{\(Det::"matsq"\), \(\(:\)\(\ \)\), "\<\"Argument \
\\!\\({\\(\\({\\(\\({\\(\\(\\(\\(-1\\)\\) + a1\\)\\), \\(\\(\\(\\(-1\\)\\) + \
a2\\)\\)}\\)\\), \\(\\({b1, b2}\\)\\)}\\)\\), \\(\\({t1, \\(\\(\\(\\(-1\\)\\) \
+ t2\\)\\)}\\)\\)}\\) at position \\!\\(1\\) is not a nonempty square matrix. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::matsq\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    RowBox[{\(Det::"matsq"\), \(\(:\)\(\ \)\), "\<\"Argument \
\\!\\({\\(\\({\\(\\({\\(\\(\\(\\(-1\\)\\) + a1\\)\\), \\(\\(\\(\\(-1\\)\\) + \
a2\\)\\)}\\)\\), \\(\\({b1, b2}\\)\\)}\\)\\), \\(\\({t1, \\(\\(\\(\\(-1\\)\\) \
+ t2\\)\\)}\\)\\)}\\) at position \\!\\(1\\) is not a nonempty square matrix. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::matsq\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(Det :: \\\"matsq\\\"\\) will be suppressed during this calculation. \\!\
\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. Toutes les applications sont \
independantes des angles. 3 reflection(s). "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "78", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"1"},
                {"3"},
                {"2"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 1, 3, 2, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-x[2]\) + x[3]\/2 + x[4]\/2\)},
                {\(x[2] - x[3]\/2 + x[4]\/2\)},
                {\(\[Pi] - x[3] - x[4]\)},
                {\(x[4]\)},
                {\(x[3]\)},
                {\(\[Pi] - x[2] - x[3]\/2 - x[4]\/2\)},
                {\(x[2]\)},
                {\(x[3]\/2 + x[4]\/2\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, 
                x[ 2]], 
              Times[ 
                Rational[ 1, 2], 
                x[ 3]], 
              Times[ 
                Rational[ 1, 2], 
                x[ 4]]], 
            Plus[ 
              x[ 2], 
              Times[ 
                Rational[ -1, 2], 
                x[ 3]], 
              Times[ 
                Rational[ 1, 2], 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 3]], 
              Times[ -1, 
                x[ 4]]], 
            x[ 4], 
            x[ 3], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 2]], 
              Times[ 
                Rational[ -1, 2], 
                x[ 3]], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            x[ 2], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], 
                x[ 3]], 
              Times[ 
                Rational[ 1, 2], 
                x[ 4]]]}]], 
        ",", \(0 < 
              x[2] < \[Pi]\/6 && \((0 < x[3] \[LessEqual] 2\ x[2] && 
                  2\ x[2] - x[3] < x[4] < \[Pi] - x[3] || 
                2\ x[2] < x[3] < 
                    1\/2\ \((\[Pi] + 2\ x[2])\) && \(-2\)\ x[2] + x[3] < 
                    x[4] < \[Pi] - x[3])\) || \[Pi]\/6 \[LessEqual] 
              x[2] < \[Pi]\/2 && \((0 < x[3] < 2\ x[2] && 
                  2\ x[2] - x[3] < x[4] < \[Pi] - x[3] || 
                x[3] \[Equal] 2\ x[2] && 0 < x[4] < \[Pi] - x[3] || 
                2\ x[2] < x[3] < 
                    1\/2\ \((\[Pi] + 2\ x[2])\) && \(-2\)\ x[2] + x[3] < 
                    x[4] < \[Pi] - x[3])\)\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "79", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"2"},
                {"1"},
                {"3"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 2, 1, 3, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)},
                {\(\(4\ \[Pi]\)\/3 - \(4\ x[4]\)\/3\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(\(-\(\(2\ \[Pi]\)\/3\)\) + \(5\ x[4]\)\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 4, 3], Pi], 
              Times[ 
                Rational[ -4, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -2, 3], Pi], 
              Times[ 
                Rational[ 5, 3], 
                x[ 4]]]}]], ",", \(\[Pi]\/2 < x[4] < \[Pi]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 3 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "80", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"2"},
                {"1"},
                {"3"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 2, 1, 3, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/3 - x[3]\)},
                {\(\(2\ \[Pi]\)\/3\)},
                {\(x[3]\)},
                {\(\(2\ \[Pi]\)\/3 - x[3]\)},
                {\(x[3]\/2\)},
                {\(\[Pi]\/3 + x[3]\/2\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ -1, 
                x[ 3]]], 
            Times[ 
              Rational[ 2, 3], Pi], 
            x[ 3], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ -1, 
                x[ 3]]], 
            Times[ 
              Rational[ 1, 2], 
              x[ 3]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ 1, 2], 
                x[ 3]]]}]], ",", \(0 < x[3] < \[Pi]\/3\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "81", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"2"},
                {"3"},
                {"1"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 2, 3, 1, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(\(-\(\[Pi]\/3\)\) + \(2\ x[4]\)\/3\)},
                {\(x[4]\)},
                {\(\(4\ \[Pi]\)\/3 - \(5\ x[4]\)\/3\)},
                {\(\(2\ \[Pi]\)\/3 - x[4]\/3\)},
                {\(\(-\(\[Pi]\/3\)\) + \(2\ x[4]\)\/3\)},
                {\(\(2\ \[Pi]\)\/3 - x[4]\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 3], Pi], 
              Times[ 
                Rational[ 2, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 4, 3], Pi], 
              Times[ 
                Rational[ -5, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 3], Pi], 
              Times[ 
                Rational[ 2, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]]}]], ",", \(\[Pi]\/2 < x[4] < \(4\ \[Pi]\)\/5\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "82", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"2"},
                {"3"},
                {"1"},
                {"9"},
                {"7"},
                {"8"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 2, 3, 1, 9, 7, 8}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(\(-\[Pi]\) + \(4\ x[4]\)\/3\)},
                {\(x[4]\)},
                {\(2\ \[Pi] - \(7\ x[4]\)\/3\)},
                {\(x[4]\/3\)},
                {\(x[4]\/3\)},
                {\(\[Pi] - \(2\ x[4]\)\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 
                Rational[ 4, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ 
                Rational[ -7, 3], 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 3], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 3], 
              x[ 4]], 
            Plus[ Pi, 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]]}]], 
        ",", \(\(3\ \[Pi]\)\/4 < x[4] < \(6\ \[Pi]\)\/7\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 2 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "83", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"2"},
                {"3"},
                {"1"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 2, 3, 1, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(\[Pi] - x[3] - x[4]\)},
                {\(x[4]\)},
                {\(x[3]\)},
                {\(2\ \[Pi] - x[3] - 2\ x[4]\)},
                {\(\(-\[Pi]\) + x[3]\/2 + \(3\ x[4]\)\/2\)},
                {\(x[3]\/2 + x[4]\/2\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 3]], 
              Times[ -1, 
                x[ 4]]], 
            x[ 4], 
            x[ 3], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -1, 
                x[ 3]], 
              Times[ -2, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 
                Rational[ 1, 2], 
                x[ 3]], 
              Times[ 
                Rational[ 3, 2], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], 
                x[ 3]], 
              Times[ 
                Rational[ 1, 2], 
                x[ 4]]]}]], 
        ",", \(0 < x[3] < \[Pi]\/2 && 
          1\/3\ \((2\ \[Pi] - x[3])\) < x[4] < \[Pi] - x[3]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "84", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"3"},
                {"1"},
                {"2"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 3, 1, 2, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(\[Pi] - \(4\ x[4]\)\/3\)},
                {\(x[4]\)},
                {\(x[4]\/3\)},
                {\(\(2\ x[4]\)\/3\)},
                {\(\[Pi] - \(4\ x[4]\)\/3\)},
                {\(\(2\ x[4]\)\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ 
                Rational[ -4, 3], 
                x[ 4]]], 
            x[ 4], 
            Times[ 
              Rational[ 1, 3], 
              x[ 4]], 
            Times[ 
              Rational[ 2, 3], 
              x[ 4]], 
            Plus[ Pi, 
              Times[ 
                Rational[ -4, 3], 
                x[ 4]]], 
            Times[ 
              Rational[ 2, 3], 
              x[ 4]]}]], ",", \(\[Pi]\/2 < x[4] < \(3\ \[Pi]\)\/4\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "85", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"3"},
                {"1"},
                {"2"},
                {"9"},
                {"7"},
                {"8"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 3, 1, 2, 9, 7, 8}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(\(5\ \[Pi]\)\/3 - \(8\ x[4]\)\/3\)},
                {\(x[4]\)},
                {\(\(-\(\(2\ \[Pi]\)\/3\)\) + \(5\ x[4]\)\/3\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)},
                {\(\(-\(\[Pi]\/3\)\) + \(4\ x[4]\)\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 5, 3], Pi], 
              Times[ 
                Rational[ -8, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ -2, 3], Pi], 
              Times[ 
                Rational[ 5, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 3], Pi], 
              Times[ 
                Rational[ 4, 3], 
                x[ 4]]]}]], ",", \(\[Pi]\/2 < x[4] < \(5\ \[Pi]\)\/8\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 2 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "86", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"3"},
                {"1"},
                {"2"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 3, 1, 2, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(\[Pi] - x[3] - x[4]\)},
                {\(x[4]\)},
                {\(x[3]\)},
                {\(\(-x[3]\) + x[4]\)},
                {\(\[Pi] + x[3]\/2 - \(3\ x[4]\)\/2\)},
                {\(x[3]\/2 + x[4]\/2\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 3]], 
              Times[ -1, 
                x[ 4]]], 
            x[ 4], 
            x[ 3], 
            Plus[ 
              Times[ -1, 
                x[ 3]], 
              x[ 4]], 
            Plus[ Pi, 
              Times[ 
                Rational[ 1, 2], 
                x[ 3]], 
              Times[ 
                Rational[ -3, 2], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], 
                x[ 3]], 
              Times[ 
                Rational[ 1, 2], 
                x[ 4]]]}]], 
        ",", \(0 < x[3] \[LessEqual] \[Pi]\/4 && \[Pi]\/2 < x[4] < 
              1\/3\ \((2\ \[Pi] + x[3])\) || \[Pi]\/4 < 
              x[3] < \[Pi]\/2 && \[Pi]\/2 < x[4] < \[Pi] - x[3]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "87", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"3"},
                {"2"},
                {"1"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 3, 2, 1, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)},
                {\(\(-\(\(2\ \[Pi]\)\/3\)\) + \(5\ x[4]\)\/3\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(\(4\ \[Pi]\)\/3 - \(4\ x[4]\)\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -2, 3], Pi], 
              Times[ 
                Rational[ 5, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 4, 3], Pi], 
              Times[ 
                Rational[ -4, 3], 
                x[ 4]]]}]], ",", \(\[Pi]\/2 < x[4] < \[Pi]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 3 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "88", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"3"},
                {"2"},
                {"1"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 3, 2, 1, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/3 - x[3]\)},
                {\(\(2\ \[Pi]\)\/3\)},
                {\(x[3]\)},
                {\(\(2\ \[Pi]\)\/3 - x[3]\)},
                {\(x[3]\/2\)},
                {\(\[Pi]\/3 + x[3]\/2\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ -1, 
                x[ 3]]], 
            Times[ 
              Rational[ 2, 3], Pi], 
            x[ 3], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ -1, 
                x[ 3]]], 
            Times[ 
              Rational[ 1, 2], 
              x[ 3]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ 1, 2], 
                x[ 3]]]}]], ",", \(0 < x[3] < \[Pi]\/3\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "89", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"7"},
                {"9"},
                {"8"},
                {"1"},
                {"2"},
                {"3"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 7, 9, 8, 1, 2, 3}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(2\ \[Pi] - 3\ x[4]\)},
                {\(\(-2\)\ \[Pi] + 4\ x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(x[4]\)},
                {\(2\ \[Pi] - 3\ x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(\[Pi] - x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -3, 
                x[ 4]]], 
            Plus[ 
              Times[ -2, Pi], 
              Times[ 4, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -3, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]]}]], ",", \(\[Pi]\/2 < x[4] < \(2\ \[Pi]\)\/3\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "90", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"7"},
                {"9"},
                {"8"},
                {"1"},
                {"3"},
                {"2"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 7, 9, 8, 1, 3, 2}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)},
                {\(\(-\(\(2\ \[Pi]\)\/3\)\) + \(5\ x[4]\)\/3\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)},
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(\(-\(\[Pi]\/3\)\) + \(4\ x[4]\)\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -2, 3], Pi], 
              Times[ 
                Rational[ 5, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 3], Pi], 
              Times[ 
                Rational[ 4, 3], 
                x[ 4]]]}]], ",", \(\(2\ \[Pi]\)\/5 < x[4] < \[Pi]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "91", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"7"},
                {"9"},
                {"8"},
                {"3"},
                {"1"},
                {"2"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 7, 9, 8, 3, 1, 2}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/4\)},
                {\(\(-\(\[Pi]\/4\)\) + x[4]\)},
                {\(\(3\ \[Pi]\)\/4 - x[4]\)},
                {\(x[4]\)},
                {\(\[Pi]\/4\)},
                {\(\[Pi] - x[4]\)},
                {\(\(-\(\[Pi]\/2\)\) + x[4]\)},
                {\(\[Pi]\/2\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 4], Pi], 
            Plus[ 
              Times[ 
                Rational[ -1, 4], Pi], 
              x[ 4]], 
            Plus[ 
              Times[ 
                Rational[ 3, 4], Pi], 
              Times[ -1, 
                x[ 4]]], 
            x[ 4], 
            Times[ 
              Rational[ 1, 4], Pi], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 2], Pi], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 2], Pi]}]], 
        ",", \(\[Pi]\/2 < x[4] < \(3\ \[Pi]\)\/4\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s). "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "92", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"7"},
                {"9"},
                {"8"},
                {"3"},
                {"2"},
                {"1"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 7, 9, 8, 3, 2, 1}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(x[4]\/3\)},
                {\(\(2\ x[4]\)\/3\)},
                {\(\[Pi] - \(4\ x[4]\)\/3\)},
                {\(x[4]\)},
                {\(x[4]\/3\)},
                {\(\[Pi] - x[4]\)},
                {\(x[4]\/3\)},
                {\(\(2\ x[4]\)\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 3], 
              x[ 4]], 
            Times[ 
              Rational[ 2, 3], 
              x[ 4]], 
            Plus[ Pi, 
              Times[ 
                Rational[ -4, 3], 
                x[ 4]]], 
            x[ 4], 
            Times[ 
              Rational[ 1, 3], 
              x[ 4]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 3], 
              x[ 4]], 
            Times[ 
              Rational[ 2, 3], 
              x[ 4]]}]], ",", \(0 < x[4] < \(3\ \[Pi]\)\/4\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "93", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"8"},
                {"9"},
                {"7"},
                {"3"},
                {"2"},
                {"1"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 8, 9, 7, 3, 2, 1}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\(\[Pi]\/2\)\) + x[4]\)},
                {\(\[Pi]\/2\)},
                {\(\(3\ \[Pi]\)\/4 - x[4]\)},
                {\(x[4]\)},
                {\(\[Pi]\/4\)},
                {\(\[Pi]\/4\)},
                {\(\[Pi] - x[4]\)},
                {\(\(-\(\[Pi]\/4\)\) + x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 2], Pi], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 2], Pi], 
            Plus[ 
              Times[ 
                Rational[ 3, 4], Pi], 
              Times[ -1, 
                x[ 4]]], 
            x[ 4], 
            Times[ 
              Rational[ 1, 4], Pi], 
            Times[ 
              Rational[ 1, 4], Pi], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 4], Pi], 
              x[ 4]]}]], ",", \(\[Pi]\/2 < x[4] < \(3\ \[Pi]\)\/4\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "94", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"9"},
                {"7"},
                {"8"},
                {"1"},
                {"2"},
                {"3"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 9, 7, 8, 1, 2, 3}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi] - x[2] - x[4]\)},
                {\(\(-\[Pi]\) + x[2] + 2\ x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(x[4]\)},
                {\(2\ \[Pi] - 3\ x[4]\)},
                {\(\(-x[2]\) + x[4]\)},
                {\(x[2]\)},
                {\(\[Pi] - x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 2]], 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              x[ 2], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -3, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, 
                x[ 2]], 
              x[ 4]], 
            x[ 2], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]]}]], 
        ",", \(0 < x[2] \[LessEqual] \[Pi]\/3 && \[Pi]\/2 < 
              x[4] < \(2\ \[Pi]\)\/3 || \[Pi]\/3 < 
              x[2] < \[Pi]\/2 && \[Pi]\/2 < x[4] < \[Pi] - x[2]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "95", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"9"},
                {"7"},
                {"8"},
                {"1"},
                {"3"},
                {"2"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 9, 7, 8, 1, 3, 2}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(x[4]\/2\)},
                {\(x[4]\/2\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(x[4]\)},
                {\(2\ \[Pi] - 3\ x[4]\)},
                {\(\(-\[Pi]\) + \(5\ x[4]\)\/2\)},
                {\(\[Pi] - \(3\ x[4]\)\/2\)},
                {\(\[Pi] - x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 2], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 2], 
              x[ 4]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -3, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 
                Rational[ 5, 2], 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ 
                Rational[ -3, 2], 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]]}]], ",", \(\[Pi]\/2 < x[4] < \(2\ \[Pi]\)\/3\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "96", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"9"},
                {"7"},
                {"8"},
                {"3"},
                {"2"},
                {"1"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 9, 7, 8, 3, 2, 1}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(x[4]\)},
                {\(2\ \[Pi] - 3\ x[4]\)},
                {\(\(-2\)\ \[Pi] + 4\ x[4]\)},
                {\(2\ \[Pi] - 3\ x[4]\)},
                {\(\[Pi] - x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -3, 
                x[ 4]]], 
            Plus[ 
              Times[ -2, Pi], 
              Times[ 4, 
                x[ 4]]], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -3, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]]}]], ",", \(\[Pi]\/2 < x[4] < \(2\ \[Pi]\)\/3\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "97", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"9"},
                {"8"},
                {"7"},
                {"1"},
                {"2"},
                {"3"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 9, 8, 7, 1, 2, 3}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi] - \(3\ x[4]\)\/2\)},
                {\(\(-\[Pi]\) + \(5\ x[4]\)\/2\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(x[4]\)},
                {\(2\ \[Pi] - 3\ x[4]\)},
                {\(x[4]\/2\)},
                {\(x[4]\/2\)},
                {\(\[Pi] - x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ 
                Rational[ -3, 2], 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 
                Rational[ 5, 2], 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -3, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 2], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 2], 
              x[ 4]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]]}]], ",", \(\[Pi]\/2 < x[4] < \(2\ \[Pi]\)\/3\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "98", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"4"},
                {"6"},
                {"5"},
                {"9"},
                {"8"},
                {"7"},
                {"3"},
                {"2"},
                {"1"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {4, 6, 5, 9, 8, 7, 3, 2, 1}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(\(-\(\[Pi]\/3\)\) + \(4\ x[4]\)\/3\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)},
                {\(\(-\(\(2\ \[Pi]\)\/3\)\) + \(5\ x[4]\)\/3\)},
                {\(\[Pi] - x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 3], Pi], 
              Times[ 
                Rational[ 4, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -2, 3], Pi], 
              Times[ 
                Rational[ 5, 3], 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]]}]], ",", \(\(2\ \[Pi]\)\/5 < x[4] < \[Pi]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. Toutes les applications sont \
independantes des angles. 1 atomes invariants. 3 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "99", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"5"},
                {"4"},
                {"6"},
                {"1"},
                {"3"},
                {"2"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {5, 4, 6, 1, 3, 2, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/3\)},
                {\(\[Pi]\/3 - x[2]\)},
                {\(x[2]\)},
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/3\)},
                {\(\(2\ \[Pi]\)\/3 - x[2]\)},
                {\(x[2]\)},
                {\(\[Pi]\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 3], Pi], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ -1, 
                x[ 2]]], 
            x[ 2], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ -1, 
                x[ 2]]], 
            x[ 2], 
            Times[ 
              Rational[ 1, 3], Pi]}]], ",", \(0 < x[2] < \[Pi]\/3\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "100", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"5"},
                {"6"},
                {"4"},
                {"1"},
                {"2"},
                {"3"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {5, 6, 4, 1, 2, 3, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(3\ \[Pi]\)\/4\)},
                {\(\[Pi]\/2 - x[1]\)},
                {\(\(-\(\[Pi]\/4\)\) + x[1]\)},
                {\(\[Pi]\/4\)},
                {\(\[Pi]\/4\)},
                {\(\[Pi]\/2\)},
                {\(\(3\ \[Pi]\)\/4 - x[1]\)},
                {\(\[Pi]\/4\)},
                {\(x[1]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 3, 4], Pi], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ -1, 
                x[ 1]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 4], Pi], 
              x[ 1]], 
            Times[ 
              Rational[ 1, 4], Pi], 
            Times[ 
              Rational[ 1, 4], Pi], 
            Times[ 
              Rational[ 1, 2], Pi], 
            Plus[ 
              Times[ 
                Rational[ 3, 4], Pi], 
              Times[ -1, 
                x[ 1]]], 
            Times[ 
              Rational[ 1, 4], Pi], 
            x[ 1]}]], ",", \(\[Pi]\/4 < x[1] < \[Pi]\/2\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "101", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"5"},
                {"6"},
                {"4"},
                {"1"},
                {"2"},
                {"3"},
                {"9"},
                {"7"},
                {"8"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {5, 6, 4, 1, 2, 3, 9, 7, 8}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(4\ \[Pi]\)\/5\)},
                {\(\(2\ \[Pi]\)\/5 - x[2]\)},
                {\(\(-\(\[Pi]\/5\)\) + x[2]\)},
                {\(\[Pi]\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\(3\ \[Pi]\)\/5 - x[2]\)},
                {\(x[2]\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 4, 5], Pi], 
            Plus[ 
              Times[ 
                Rational[ 2, 5], Pi], 
              Times[ -1, 
                x[ 2]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 5], Pi], 
              x[ 2]], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 3, 5], Pi], 
            Plus[ 
              Times[ 
                Rational[ 3, 5], Pi], 
              Times[ -1, 
                x[ 2]]], 
            x[ 2], 
            Times[ 
              Rational[ 2, 5], Pi]}]], 
        ",", \(\[Pi]\/5 < x[2] < \(2\ \[Pi]\)\/5\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "102", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"5"},
                {"6"},
                {"4"},
                {"1"},
                {"2"},
                {"3"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {5, 6, 4, 1, 2, 3, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(x[4]\/2\)},
                {\(x[4]\/2\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(\(3\ x[4]\)\/2\)},
                {\(\[Pi]\/2 - x[4]\)},
                {\(\[Pi]\/2 - x[4]\/2\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 2], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 2], 
              x[ 4]], 
            x[ 4], 
            x[ 4], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            Times[ 
              Rational[ 3, 2], 
              x[ 4]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]]}]], ",", \(0 < x[4] < \[Pi]\/2\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "103", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"5"},
                {"6"},
                {"4"},
                {"1"},
                {"3"},
                {"2"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {5, 6, 4, 1, 3, 2, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/2 - \(3\ x[4]\)\/2\)},
                {\(\(-\(\[Pi]\/2\)\) + \(5\ x[4]\)\/2\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(x[4]\)},
                {\(\[Pi]\/2 - x[4]\/2\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -3, 2], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 2], Pi], 
              Times[ 
                Rational[ 5, 2], 
                x[ 4]]], 
            x[ 4], 
            x[ 4], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]]}]], ",", \(\[Pi]\/5 < x[4] < \[Pi]\/3\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "104", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"5"},
                {"6"},
                {"4"},
                {"1"},
                {"3"},
                {"2"},
                {"9"},
                {"7"},
                {"8"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {5, 6, 4, 1, 3, 2, 9, 7, 8}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/4 - \(3\ x[4]\)\/4\)},
                {\(\(-\(\[Pi]\/4\)\) + \(7\ x[4]\)\/4\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(\[Pi]\/4 + x[4]\/4\)},
                {\(\[Pi]\/4 + x[4]\/4\)},
                {\(\[Pi]\/2 - x[4]\/2\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 4], Pi], 
              Times[ 
                Rational[ -3, 4], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 4], Pi], 
              Times[ 
                Rational[ 7, 4], 
                x[ 4]]], 
            x[ 4], 
            x[ 4], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 4], Pi], 
              Times[ 
                Rational[ 1, 4], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 4], Pi], 
              Times[ 
                Rational[ 1, 4], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]]}]], ",", \(\[Pi]\/7 < x[4] < \[Pi]\/3\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 2 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "105", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"5"},
                {"6"},
                {"4"},
                {"1"},
                {"3"},
                {"2"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {5, 6, 4, 1, 3, 2, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/2 - x[2] - x[4]\/2\)},
                {\(\(-\(\[Pi]\/2\)\) + x[2] + \(3\ x[4]\)\/2\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(\[Pi]\/2 - x[2] + x[4]\/2\)},
                {\(x[2]\)},
                {\(\[Pi]\/2 - x[4]\/2\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ -1, 
                x[ 2]], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 2], Pi], 
              x[ 2], 
              Times[ 
                Rational[ 3, 2], 
                x[ 4]]], 
            x[ 4], 
            x[ 4], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ -1, 
                x[ 2]], 
              Times[ 
                Rational[ 1, 2], 
                x[ 4]]], 
            x[ 2], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]]}]], 
        ",", \(0 < x[2] \[LessEqual] \[Pi]\/4 && 
            1\/3\ \((\[Pi] - 2\ x[2])\) < x[4] < \[Pi]\/2 || \[Pi]\/4 < 
              x[2] < \[Pi]\/2 && 
            1\/3\ \((\[Pi] - 2\ x[2])\) < x[4] < \[Pi] - 2\ x[2]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "106", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"4"},
                {"5"},
                {"1"},
                {"2"},
                {"3"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 4, 5, 1, 2, 3, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(x[4]\/2\)},
                {\(x[4]\/2\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(x[4]\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(\[Pi]\/2\)},
                {\(\[Pi]\/4 - x[4]\/4\)},
                {\(\[Pi]\/4 + x[4]\/4\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 2], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 2], 
              x[ 4]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 2], Pi], 
            Plus[ 
              Times[ 
                Rational[ 1, 4], Pi], 
              Times[ 
                Rational[ -1, 4], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 4], Pi], 
              Times[ 
                Rational[ 1, 4], 
                x[ 4]]]}]], ",", \(0 < x[4] < \[Pi]\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "107", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"4"},
                {"5"},
                {"1"},
                {"3"},
                {"2"},
                {"7"},
                {"8"},
                {"9"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 4, 5, 1, 3, 2, 7, 8, 9}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\(\[Pi]\/4\)\) + \(3\ x[4]\)\/4\)},
                {\(\[Pi]\/4 + x[4]\/4\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(x[4]\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(\[Pi]\/4 + x[4]\/4\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(\[Pi]\/4 + x[4]\/4\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 4], Pi], 
              Times[ 
                Rational[ 3, 4], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 4], Pi], 
              Times[ 
                Rational[ 1, 4], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 4], Pi], 
              Times[ 
                Rational[ 1, 4], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 4], Pi], 
              Times[ 
                Rational[ 1, 4], 
                x[ 4]]]}]], ",", \(\[Pi]\/3 < x[4] < \[Pi]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "108", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"4"},
                {"5"},
                {"1"},
                {"3"},
                {"2"},
                {"9"},
                {"7"},
                {"8"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 4, 5, 1, 3, 2, 9, 7, 8}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\(\[Pi]\/8\)\) + \(3\ x[4]\)\/8\)},
                {\(\[Pi]\/8 + \(5\ x[4]\)\/8\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(x[4]\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(\(3\ \[Pi]\)\/8 - x[4]\/8\)},
                {\(\(3\ \[Pi]\)\/8 - x[4]\/8\)},
                {\(\[Pi]\/4 + x[4]\/4\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 8], Pi], 
              Times[ 
                Rational[ 3, 8], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 8], Pi], 
              Times[ 
                Rational[ 5, 8], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 3, 8], Pi], 
              Times[ 
                Rational[ -1, 8], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 3, 8], Pi], 
              Times[ 
                Rational[ -1, 8], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 4], Pi], 
              Times[ 
                Rational[ 1, 4], 
                x[ 4]]]}]], ",", \(\[Pi]\/3 < x[4] < \[Pi]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 2 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "109", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"4"},
                {"5"},
                {"1"},
                {"3"},
                {"2"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 4, 5, 1, 3, 2, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/4 - x[2] + x[4]\/4\)},
                {\(\(-\(\[Pi]\/4\)\) + x[2] + \(3\ x[4]\)\/4\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(x[4]\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(\(3\ \[Pi]\)\/4 - x[2] - x[4]\/4\)},
                {\(x[2]\)},
                {\(\[Pi]\/4 + x[4]\/4\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 4], Pi], 
              Times[ -1, 
                x[ 2]], 
              Times[ 
                Rational[ 1, 4], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 4], Pi], 
              x[ 2], 
              Times[ 
                Rational[ 3, 4], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 3, 4], Pi], 
              Times[ -1, 
                x[ 2]], 
              Times[ 
                Rational[ -1, 4], 
                x[ 4]]], 
            x[ 2], 
            Plus[ 
              Times[ 
                Rational[ 1, 4], Pi], 
              Times[ 
                Rational[ 1, 4], 
                x[ 4]]]}]], 
        ",", \(0 < x[2] \[LessEqual] \[Pi]\/4 && 
            1\/3\ \((\[Pi] - 4\ x[2])\) < x[4] < \[Pi] || \[Pi]\/4 < 
              x[2] < \[Pi]\/2 && \(-\[Pi]\) + 4\ x[2] < x[4] < \[Pi]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "110", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"4"},
                {"5"},
                {"2"},
                {"3"},
                {"1"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 4, 5, 2, 3, 1, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(x[4]\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(\(3\ \[Pi]\)\/2 - \(3\ x[4]\)\/2\)},
                {\(\(-\(\(3\ \[Pi]\)\/4\)\) + \(5\ x[4]\)\/4\)},
                {\(\[Pi]\/4 + x[4]\/4\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 3, 2], Pi], 
              Times[ 
                Rational[ -3, 2], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -3, 4], Pi], 
              Times[ 
                Rational[ 5, 4], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 4], Pi], 
              Times[ 
                Rational[ 1, 4], 
                x[ 4]]]}]], ",", \(\(3\ \[Pi]\)\/5 < x[4] < \[Pi]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "111", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"4"},
                {"5"},
                {"3"},
                {"1"},
                {"2"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 4, 5, 3, 1, 2, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(x[4]\)},
                {\(\[Pi]\/2 - x[4]\/2\)},
                {\(\(-\(\[Pi]\/2\)\) + \(3\ x[4]\)\/2\)},
                {\(\(5\ \[Pi]\)\/4 - \(7\ x[4]\)\/4\)},
                {\(\[Pi]\/4 + x[4]\/4\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 1, 2], Pi], 
              Times[ 
                Rational[ -1, 2], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 2], Pi], 
              Times[ 
                Rational[ 3, 2], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 5, 4], Pi], 
              Times[ 
                Rational[ -7, 4], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 4], Pi], 
              Times[ 
                Rational[ 1, 4], 
                x[ 4]]]}]], ",", \(\[Pi]\/2 < x[4] < \(5\ \[Pi]\)\/7\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "112", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"4"},
                {"5"},
                {"9"},
                {"7"},
                {"8"},
                {"1"},
                {"2"},
                {"3"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 4, 5, 9, 7, 8, 1, 2, 3}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/5\)},
                {\(\(2\ \[Pi]\)\/5 - x[2]\)},
                {\(\[Pi]\/5 + x[2]\)},
                {\(\[Pi]\/5\)},
                {\(\(3\ \[Pi]\)\/5\)},
                {\(\[Pi]\/5\)},
                {\(\(3\ \[Pi]\)\/5 - x[2]\)},
                {\(x[2]\)},
                {\(\(2\ \[Pi]\)\/5\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 5], Pi], 
            Plus[ 
              Times[ 
                Rational[ 2, 5], Pi], 
              Times[ -1, 
                x[ 2]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 5], Pi], 
              x[ 2]], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Times[ 
              Rational[ 3, 5], Pi], 
            Times[ 
              Rational[ 1, 5], Pi], 
            Plus[ 
              Times[ 
                Rational[ 3, 5], Pi], 
              Times[ -1, 
                x[ 2]]], 
            x[ 2], 
            Times[ 
              Rational[ 2, 5], Pi]}]], ",", \(0 < x[2] < \(2\ \[Pi]\)\/5\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. Toutes les applications sont \
independantes des angles. 1 atomes invariants. 3 reflection(s).  Tout les \
echantillons sont des PWI. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "113", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"6"},
                {"5"},
                {"4"},
                {"1"},
                {"3"},
                {"2"},
                {"9"},
                {"8"},
                {"7"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {6, 5, 4, 1, 3, 2, 9, 8, 7}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\(2\ \[Pi]\)\/3\)},
                {\(\[Pi]\/3 - x[2]\)},
                {\(x[2]\)},
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/3\)},
                {\(\(2\ \[Pi]\)\/3 - x[2]\)},
                {\(x[2]\)},
                {\(\[Pi]\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Times[ 
              Rational[ 2, 3], Pi], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ -1, 
                x[ 2]]], 
            x[ 2], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ -1, 
                x[ 2]]], 
            x[ 2], 
            Times[ 
              Rational[ 1, 3], Pi]}]], ",", \(0 < x[2] < \[Pi]\/3\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "114", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"7"},
                {"9"},
                {"1"},
                {"2"},
                {"3"},
                {"6"},
                {"4"},
                {"5"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 7, 9, 1, 2, 3, 6, 4, 5}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(\(-\(\[Pi]\/3\)\) + \(4\ x[4]\)\/3\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 3], Pi], 
              Times[ 
                Rational[ 4, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            x[ 4]}]], ",", \(\[Pi]\/4 < x[4] < \[Pi]\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s). "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "115", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"7"},
                {"9"},
                {"1"},
                {"3"},
                {"2"},
                {"5"},
                {"4"},
                {"6"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 7, 9, 1, 3, 2, 5, 4, 6}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 3\ x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 3, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            x[ 4], 
            x[ 4], 
            x[ 4], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            x[ 4]}]], ",", \(\[Pi]\/3 < x[4] < \[Pi]\/2\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s). "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "116", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"7"},
                {"9"},
                {"1"},
                {"3"},
                {"2"},
                {"6"},
                {"4"},
                {"5"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 7, 9, 1, 3, 2, 6, 4, 5}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 3\ x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 3, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            x[ 4], 
            x[ 4], 
            x[ 4], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            x[ 4]}]], ",", \(\[Pi]\/3 < x[4] < \[Pi]\/2\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "117", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"7"},
                {"9"},
                {"5"},
                {"4"},
                {"6"},
                {"3"},
                {"2"},
                {"1"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 7, 9, 5, 4, 6, 3, 2, 1}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(x[4]\/3\)},
                {\(\(2\ x[4]\)\/3\)},
                {\(x[4]\/3\)},
                {\(x[4]\)},
                {\(\[Pi] - \(4\ x[4]\)\/3\)},
                {\(\(2\ x[4]\)\/3\)},
                {\(x[4]\/3\)},
                {\(\[Pi] - x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 3], 
              x[ 4]], 
            Times[ 
              Rational[ 2, 3], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 3], 
              x[ 4]], 
            x[ 4], 
            Plus[ Pi, 
              Times[ 
                Rational[ -4, 3], 
                x[ 4]]], 
            Times[ 
              Rational[ 2, 3], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 3], 
              x[ 4]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]]}]], ",", \(0 < x[4] < \(3\ \[Pi]\)\/4\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "118", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"7"},
                {"9"},
                {"5"},
                {"6"},
                {"4"},
                {"1"},
                {"2"},
                {"3"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 7, 9, 5, 6, 4, 1, 2, 3}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(2\ \[Pi] - 3\ x[4]\)},
                {\(\(-2\)\ \[Pi] + 4\ x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(x[4]\)},
                {\(2\ \[Pi] - 3\ x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(\[Pi] - x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -3, 
                x[ 4]]], 
            Plus[ 
              Times[ -2, Pi], 
              Times[ 4, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -3, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]]}]], ",", \(\[Pi]\/2 < x[4] < \(2\ \[Pi]\)\/3\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "119", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"9"},
                {"7"},
                {"1"},
                {"2"},
                {"3"},
                {"5"},
                {"4"},
                {"6"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 9, 7, 1, 2, 3, 5, 4, 6}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\(\[Pi]\/3\)\) + \(4\ x[4]\)\/3\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)},
                {\(x[4]\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 3], Pi], 
              Times[ 
                Rational[ 4, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]]}]], ",", \(\[Pi]\/4 < x[4] < \[Pi]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s). "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "120", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"9"},
                {"7"},
                {"1"},
                {"3"},
                {"2"},
                {"5"},
                {"4"},
                {"6"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 9, 7, 1, 3, 2, 5, 4, 6}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 3\ x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 3, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            x[ 4], 
            x[ 4], 
            x[ 4], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            x[ 4]}]], ",", \(\[Pi]\/3 < x[4] < \[Pi]\/2\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s). "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "121", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"9"},
                {"7"},
                {"1"},
                {"3"},
                {"2"},
                {"6"},
                {"4"},
                {"5"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 9, 7, 1, 3, 2, 6, 4, 5}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 3\ x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(x[4]\)},
                {\(\[Pi] - 2\ x[4]\)},
                {\(x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 3, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            x[ 4], 
            x[ 4], 
            x[ 4], 
            Plus[ Pi, 
              Times[ -2, 
                x[ 4]]], 
            x[ 4]}]], ",", \(\[Pi]\/3 < x[4] < \[Pi]\/2\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "122", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"9"},
                {"7"},
                {"5"},
                {"4"},
                {"6"},
                {"1"},
                {"2"},
                {"3"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 9, 7, 5, 4, 6, 1, 2, 3}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(2\ \[Pi] - 3\ x[4]\)},
                {\(x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(2\ \[Pi] - 3\ x[4]\)},
                {\(\(-2\)\ \[Pi] + 4\ x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -3, 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -3, 
                x[ 4]]], 
            Plus[ 
              Times[ -2, Pi], 
              Times[ 4, 
                x[ 4]]]}]], ",", \(\[Pi]\/2 < x[4] < \(2\ \[Pi]\)\/3\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "123", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"9"},
                {"7"},
                {"5"},
                {"4"},
                {"6"},
                {"3"},
                {"2"},
                {"1"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 9, 7, 5, 4, 6, 3, 2, 1}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(2\ \[Pi] - 3\ x[4]\)},
                {\(x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(2\ \[Pi] - 3\ x[4]\)},
                {\(\(-2\)\ \[Pi] + 4\ x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -3, 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -3, 
                x[ 4]]], 
            Plus[ 
              Times[ -2, Pi], 
              Times[ 4, 
                x[ 4]]]}]], ",", \(\[Pi]\/2 < x[4] < \(2\ \[Pi]\)\/3\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "124", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"9"},
                {"7"},
                {"5"},
                {"6"},
                {"4"},
                {"1"},
                {"2"},
                {"3"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 9, 7, 5, 6, 4, 1, 2, 3}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(2\ \[Pi] - 3\ x[4]\)},
                {\(\(-2\)\ \[Pi] + 4\ x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(x[4]\)},
                {\(2\ \[Pi] - 3\ x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(\(-\[Pi]\) + 2\ x[4]\)},
                {\(\[Pi] - x[4]\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -3, 
                x[ 4]]], 
            Plus[ 
              Times[ -2, Pi], 
              Times[ 4, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 2, Pi], 
              Times[ -3, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ -1, Pi], 
              Times[ 2, 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]]}]], ",", \(\[Pi]\/2 < x[4] < \(2\ \[Pi]\)\/3\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "125", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"8"},
                {"9"},
                {"7"},
                {"5"},
                {"6"},
                {"4"},
                {"1"},
                {"3"},
                {"2"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {8, 9, 7, 5, 6, 4, 1, 3, 2}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)},
                {\(\(-\(\(2\ \[Pi]\)\/3\)\) + \(5\ x[4]\)\/3\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)},
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(\(-\(\[Pi]\/3\)\) + \(4\ x[4]\)\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -2, 3], Pi], 
              Times[ 
                Rational[ 5, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 3], Pi], 
              Times[ 
                Rational[ 4, 3], 
                x[ 4]]]}]], ",", \(\(2\ \[Pi]\)\/5 < x[4] < \[Pi]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s). "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "126", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"9"},
                {"7"},
                {"8"},
                {"1"},
                {"3"},
                {"2"},
                {"4"},
                {"5"},
                {"6"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {9, 7, 8, 1, 3, 2, 4, 5, 6}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/3 - x[4]\)},
                {\(\(-\(\[Pi]\/3\)\) + 2\ x[4]\)},
                {\(\[Pi]\/3\)},
                {\(x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - x[4]\)},
                {\(x[4]\)},
                {\(\[Pi]\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 3], Pi], 
              Times[ 2, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 3], Pi], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ -1, 
                x[ 4]]], 
            x[ 4], 
            Times[ 
              Rational[ 1, 3], Pi]}]], ",", \(\[Pi]\/6 < x[4] < \[Pi]\/3\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "127", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"9"},
                {"7"},
                {"8"},
                {"5"},
                {"4"},
                {"6"},
                {"3"},
                {"2"},
                {"1"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {9, 7, 8, 5, 4, 6, 3, 2, 1}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\(\[Pi]\/2\)\) + x[4]\)},
                {\(\[Pi]\/2\)},
                {\(\[Pi]\/4\)},
                {\(x[4]\)},
                {\(\(3\ \[Pi]\)\/4 - x[4]\)},
                {\(\(-\(\[Pi]\/4\)\) + x[4]\)},
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/4\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 2], Pi], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 2], Pi], 
            Times[ 
              Rational[ 1, 4], Pi], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 3, 4], Pi], 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 4], Pi], 
              x[ 4]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 4], Pi]}]], 
        ",", \(\[Pi]\/2 < x[4] < \(3\ \[Pi]\)\/4\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. 1 reflection(s). "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "128", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"9"},
                {"8"},
                {"7"},
                {"1"},
                {"3"},
                {"2"},
                {"4"},
                {"6"},
                {"5"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {9, 8, 7, 1, 3, 2, 4, 6, 5}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\(-\(\[Pi]\/3\)\) + x[4]\)},
                {\(\[Pi]\/3\)},
                {\(\[Pi]\/3\)},
                {\(x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - x[4]\)},
                {\(x[4]\)},
                {\(\(2\ \[Pi]\)\/3 - x[4]\)},
                {\(\[Pi]\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 3], Pi], 
              x[ 4]], 
            Times[ 
              Rational[ 1, 3], Pi], 
            Times[ 
              Rational[ 1, 3], Pi], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ -1, 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ -1, 
                x[ 4]]], 
            Times[ 
              Rational[ 1, 3], Pi]}]], 
        ",", \(\[Pi]\/3 < x[4] < \(2\ \[Pi]\)\/3\)}], "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("101 echantillons examines, a 3 atomes. "\)], "Print"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{"\<\"Solution numero\"\>", ",", "129", 
        ",", "\<\" Permutation:\"\>", ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"9"},
                {"8"},
                {"7"},
                {"5"},
                {"4"},
                {"6"},
                {"3"},
                {"2"},
                {"1"}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {9, 8, 7, 5, 4, 6, 3, 2, 1}]], ",", "\<\" Angles:\"\>", 
        ",", 
        InterpretationBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {\(\[Pi] - x[4]\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(\(-\(\[Pi]\/3\)\) + \(4\ x[4]\)\/3\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)},
                {\(x[4]\)},
                {\(\[Pi]\/3 - x[4]\/3\)},
                {\(\[Pi] - x[4]\)},
                {\(\(-\(\(2\ \[Pi]\)\/3\)\) + \(5\ x[4]\)\/3\)},
                {\(\(2\ \[Pi]\)\/3 - \(2\ x[4]\)\/3\)}
                }], "\[NoBreak]", ")"}],
          MatrixForm[ {
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -1, 3], Pi], 
              Times[ 
                Rational[ 4, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]], 
            x[ 4], 
            Plus[ 
              Times[ 
                Rational[ 1, 3], Pi], 
              Times[ 
                Rational[ -1, 3], 
                x[ 4]]], 
            Plus[ Pi, 
              Times[ -1, 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ -2, 3], Pi], 
              Times[ 
                Rational[ 5, 3], 
                x[ 4]]], 
            Plus[ 
              Times[ 
                Rational[ 2, 3], Pi], 
              Times[ 
                Rational[ -2, 3], 
                x[ 4]]]}]], ",", \(\(2\ \[Pi]\)\/5 < x[4] < \[Pi]\)}], 
      "}"}]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\(129\[InvisibleSpace]" Solutions au total, "\
\[InvisibleSpace]45\[InvisibleSpace]" Solutions Rigides et \
"\[InvisibleSpace]84\[InvisibleSpace]" simplexes de solutions."\),
      SequenceForm[ 
      129, " Solutions au total, ", 45, " Solutions Rigides et ", 84, 
        " simplexes de solutions."],
      Editable->False]], "Print"]
}, Open  ]],

Cell[BoxData[
    \(\t\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(DrawNum[Solutions[\([33]\)]]\)\)\)], "Input"],

Cell[BoxData[
    RowBox[{\(Solve::"ifun"\), \(\(:\)\(\ \)\), "\<\"Inverse functions are \
being used by \\!\\(Solve\\), so some solutions may not be found; use Reduce \
for complete solution information. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Solve::ifun\\\"]\\)\"\>"}]], \
"Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(2) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(3) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(2) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(5) show
135.000 39.000 moveto
(5) show
165.000 39.000 moveto
(5) show
195.000 39.000 moveto
(5) show
225.000 39.000 moveto
(5) show
255.000 39.000 moveto
(5) show
285.000 39.000 moveto
(5) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -9.21572e-018 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.61803 0 L
.5 .36327 L
F
0 0 1 r
.61803 0 m
1 0 L
.5 .36327 L
F
1 0 0 r
0 0 m
.5 .36327 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -1.19262e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.38197 0 m
1 0 L
.5 .36327 L
F
0 0 1 r
.38197 0 m
.5 .36327 L
.19098 .58779 L
F
1 0 0 r
.19098 .58779 m
0 0 L
.38197 0 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000Zb000`400?l00000o`00003oF`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?oo
o`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00D03ooooo00000<@00000
D03oool005/0oooo00<000000?l00000o`00N`00o`1=0000oaH0ooooC@3o00000`000?l00?l0003o
001j003o05d0oooo001K0?ooo`030000003o0000o`0007/00?l0C0000?lG0?ooodd0o`0000<0003o
003o0000o`00N@00o`1N0?ooo`00F`3oool00`000000o`000?l000020?l007T00?l0BP000?lI0?oo
odd0o`0000<0003o003o0000o`00M`00o`1P0?ooo`00F`3oool00`000000oooo0?l000030?l007L0
0?l0BP000?lK0?oood/0o`000`000?mg003o0640oooo001K0?ooo`030000003oool0o`0000@0o`00
MP00o`190000oa`0ooooB`3o00030000ogH00?l0HP3oool005/0oooo00<000000?ooo`3o00001P3o
001d003o04L0003o7P3ooom;0?l000<0003oM000o`1T0?ooo`00F`3oool00`000000oooo0?ooo`07
0?l007800?l0A`000?lP0?ooodT0o`001@000?mb003o06D0oooo001K0?ooo`030000003oool0oooo
00T0o`00L000o`150000ob80ooooB@3o00050000og000?l0I`3oool005/0oooo00<000000?ooo`3o
ool02P3o001_003o04@0003o8`3ooom90?l000D0003oK`00o`1X0?ooo`00F`3oool010000000oooo
0?ooo`3oool:0?l006d00?l0A0000?lU0?ooodL0o`001`000?m]003o06T0oooo001K0?ooo`040000
003oool0oooo0?ooo``0o`00J`00o`120000obL0ooooA`3o00070000of/00?l0J`3oool005/0oooo
00@000000?ooo`3oool0oooo3@3o001Z003o0440003o:03ooom70?l000L0003oJP00o`1/0?ooo`00
F`3oool00`000000oooo0?ooo`020?ooo`d0o`00J000o`110000obX0ooooA@3o00090000ofP00?l0
K@3oool005/0oooo00<000000?ooo`3oool00P3oool?0?l006H00?l0?`000?l/0?ooodD0o`002@00
0?mV003o06l0oooo001K0?ooo`030000003oool0oooo0080oooo403o001U003o03h0003o;@3ooom5
0?l000T0003oI@00o`1`0?ooo`00F`3oool00`000000oooo0?ooo`030?oooa40o`00HP00o`0m0000
oc00oooo@`3o000;0000of800?l0LP3oool005/0oooo00<000000?ooo`3oool00`3ooolB0?l00640
0?l0?0000?la0?oood<0o`002`000?mQ003o07<0oooo001K0?ooo`030000003oool0oooo00<0oooo
4`3o001P003o03/0003o<P3ooom30?l000/0003oH000o`1d0?ooo`00F`3oool00`000000oooo0?oo
o`040?oooa@0o`00G@00o`0j0000ocD0oooo@@3o000=0000oed00?l0MP3oool005/0oooo00<00000
0?ooo`3oool0103ooolE0?l005`00?l0>@000?lf0?oood40o`003@000?mL003o07L0oooo001K0?oo
o`030000003oool0oooo00@0oooo5P3o001K003o03P0003o=`3ooom10?l000d0003oF`00o`1h0?oo
o`00F`3oool00`000000oooo0?ooo`050?oooaL0o`00F000o`0g0000ocX0oooo?`3o000?0000oeP0
0?l0NP3oool005/0oooo00<000000?ooo`3oool01@3ooolH0?l005L00?l0=P000?lk0?ooocl0o`00
3`000?mG003o07/0oooo001K0?ooo`030000003oool0oooo00D0oooo6P3o001E003o03@0003o?@3o
oolo0?l000l0003oE@00o`1m0?ooo`00F`3oool00`000000oooo0?ooo`060?oooaX0o`00D`00o`0d
0000ocl0oooo?@3o000A0000oe<00?l0OP3oool005/0oooo00<000000?ooo`3oool01P3ooolK0?l0
05800?l0<`000?m00?ooocd0o`004@000?mB003o07l0oooo001K0?ooo`030000003oool0oooo00H0
oooo7@3o001@003o0340003o@P3ooolm0?l00140003oD000o`210?ooo`00F`3oool00`000000oooo
0?ooo`070?oooad0o`00CP00o`0a0000od@0oooo>`3o000C0000odh00?l0PP3oool005/0oooo00<0
00000?ooo`3oool01`3ooolN0?l004d00?l0<0000?m50?oooc/0o`004`000?m=003o08<0oooo001K
0?ooo`030000003oool0oooo00L0oooo803o001;003o02h0003oA`3ooolk0?l001<0003oB`00o`25
0?ooo`00F`3oool00`000000oooo0?ooo`080?ooob00o`00B@00o`0^0000odT0oooo>@3o000E0000
odT00?l0QP3oool005/0oooo00<000000?ooo`3oool0203ooolR0?l004L00?l0;0000?m;0?ooocT0
o`005@000?m7003o08P0oooo001K0?ooo`030000003oool0oooo00P0oooo8`3o0016003o02/0003o
C03oooli0?l001D0003oAP00o`290?ooo`00F`3oool00`000000oooo0?ooo`090?ooob<0o`00A000
o`0[0000odh0oooo=`3o000G0000od@00?l0RP3oool005/0oooo00<000000?ooo`3oool02@3ooolU
0?l004800?l0:@000?m@0?ooocL0o`005`000?m2003o08`0oooo001K0?ooo`030000003oool0oooo
00T0oooo9P3o0011003o02P0003oD@3ooolg0?l001L0003o@@00o`2=0?ooo`00F`3oool00`000000
oooo0?ooo`0:0?ooobH0o`00?`00o`0W0000oe@0oooo=@3o000H0000ocl00?l0S`3oool005/0oooo
00<000000?ooo`3oool02P3ooolX0?l003d00?l09P000?mE0?ooocD0o`006@000?lm003o0900oooo
001K0?ooo`030000003oool0oooo00X0oooo:@3o000l003o02D0003oEP3ooole0?l001T0003o?000
o`2A0?ooo`00F`3oool00`000000oooo0?ooo`0:0?ooob/0o`00>P00o`0S0000oeP0oooo=03o000J
0000ocX00?l0T`3oool005/0oooo00<000000?ooo`3oool02`3oool[0?l003P00?l08`000?mJ0?oo
oc<0o`006`000?lh003o09@0oooo001K0?ooo`030000003oool0oooo00/0oooo;03o000g003o0280
003oF`3ooolc0?l001/0003o=`00o`2E0?ooo`00F`3oool00`000000oooo0?ooo`0;0?ooobh0o`00
=@00o`0P0000oed0oooo<`3o000K0000ocD00?l0U`3oool005/0oooo00<000000?ooo`3oool0303o
ool^0?l003<00?l080000?mO0?oooc40o`007@000?lc003o09P0oooo001K0?ooo`030000003oool0
oooo00`0oooo<03o000a003o01h0003oH@3ooola0?l001d0003o<@00o`2J0?ooo`00F`3oool00`00
0000oooo0?ooo`0<0?oooc40o`00<000o`0M0000of80oooo<@3o000M0000oc000?l0V`3oool005/0
oooo00<000000?ooo`3oool03@3ooola0?l002h00?l07@000?mT0?ooobl0o`007`000?l^003o09`0
oooo001K0?ooo`030000003oool0oooo00d0oooo<`3o000/003o01/0003oIP3oool_0?l001l0003o
;000o`2N0?ooo`00F`3oool00`000000oooo0?ooo`0=0?oooc@0o`00:`00o`0J0000ofL0oooo;`3o
000O0000ob/00?l0W`3oool005/0oooo00<000000?ooo`3oool03P3ooold0?l002T00?l06P000?mY
0?ooobd0o`008@000?lY003o0:00oooo001K0?ooo`030000003oool0oooo00h0oooo=P3o000W003o
01P0003oJ`3oool]0?l00240003o9`00o`2R0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooocL0
o`009P00o`0G0000of`0oooo;@3o000Q0000obH00?l0X`3oool005/0oooo00<000000?ooo`3oool0
3`3ooolh0?l002<00?l05P000?m_0?ooob/0o`008`000?lS003o0:D0oooo001K0?ooo`030000003o
ool0oooo00l0oooo>@3o000R003o01D0003oL03oool[0?l002<0003o8P00o`2V0?ooo`00F`3oool0
0`000000oooo0?ooo`0?0?ooocX0o`008@00o`0D0000og40oooo:`3o000S0000ob400?l0Y`3oool0
05/0oooo00<000000?ooo`3oool0403ooolk0?l001h00?l04`000?md0?ooobT0o`009@000?lN003o
0:T0oooo001K0?ooo`030000003oool0oooo0100oooo?03o000M003o0180003oM@3ooolY0?l002D0
003o7@00o`2Z0?ooo`00F`3oool00`000000oooo0?ooo`0@0?ooocd0o`007000o`0A0000ogH0oooo
:@3o000U0000oa`00?l0Z`3oool005/0oooo00<000000?ooo`3oool04@3oooln0?l001T00?l04000
0?mi0?ooobL0o`009`000?lI003o0:d0oooo001K0?ooo`030000003oool0oooo0140oooo?`3o000H
003o00l0003oNP3ooolW0?l002L0003o6000o`2^0?ooo`00F`3oool00`000000oooo0?ooo`0A0?oo
od40o`005P00o`0=0000og`0oooo9`3o000W0000oaH00?l0/03oool005/0oooo00<000000?ooo`3o
ool04P3ooom10?l001@00?l03@000?mn0?ooobD0o`00:@000?lD003o0;40oooo001K0?ooo`030000
003oool0oooo0180oooo@P3o000C003o00`0003oO`3ooolU0?l002T0003o4`00o`2b0?ooo`00F`3o
ool00`000000oooo0?ooo`0B0?oood@0o`004@00o`0:0000oh40oooo9@3o000Y0000oa400?l0]03o
ool005/0oooo00<000000?ooo`3oool04`3ooom40?l000l00?l02P000?n30?ooob<0o`00:`000?l?
003o0;D0oooo001K0?ooo`030000003oool0oooo01<0ooooA@3o000>003o00T0003oQ03ooolS0?l0
02/0003o3P00o`2f0?ooo`00F`3oool00`000000oooo0?ooo`0C0?ooodL0o`003000o`070000ohH0
oooo8`3o000[0000o``00?l0^03oool005/0oooo00<000000?ooo`3oool0503ooom70?l000X00?l0
1`000?n80?ooob40o`00;@000?l:003o0;T0oooo001K0?ooo`030000003oool0oooo01@0ooooB@3o
0008003o00D0003oRP3ooolQ0?l002d0003o2000o`2k0?ooo`00F`3oool00`000000oooo0?ooo`0D
0?ooodX0o`001`00o`040000oh/0oooo8@3o000]0000o`L00?l0_03oool005/0oooo00<000000?oo
o`3oool05@3ooom:0?l000D00?l010000?n=0?oooal0o`00;`000?l5003o0;d0oooo001K0?ooo`03
0000003oool0oooo01D0ooooC03o0003003o0080003oS`3ooolO0?l002l0003o0`00o`2o0?ooo`00
F`3oool00`000000oooo0?ooo`0E0?ooodd0o`000P00o`000`000?l0oooo0?ooo`2>0?oooal0o`00
;`000?l2003o0<00oooo001K0?ooo`030000003oool0oooo01H0ooooC@3o002C0?oooad0o`00<000
0?o20?ooo`00F`3oool00`000000oooo0?ooo`0F0?oood`0o`00U03ooolM0?l002l0003o``3oool0
05/0oooo00<000000?ooo`3oool05P3ooom;0?l009D0oooo7@3o000^0000ol@0oooo001K0?ooo`03
0000003oool0oooo01L0ooooB03o002H0?oooa/0o`00;@000?o60?ooo`00F`3oool00`000000oooo
0?ooo`0G0?ooodL0o`00V@3ooolK0?l002`0003oa`3oool005/0oooo00<000000?ooo`3oool05`3o
oom60?l009X0oooo6`3o000[0000olP0oooo001K0?ooo`030000003oool0oooo01L0ooooA03o002L
0?oooaX0o`00:P000?o:0?ooo`00F`3oool00`000000oooo0?ooo`0H0?oood80o`00WP3ooolI0?l0
02T0003ob`3oool005/0oooo00<000000?ooo`3oool0603ooom10?l009l0oooo6@3o000X0000ol`0
oooo001K0?ooo`030000003oool0oooo01P0oooo?`3o002Q0?oooaT0o`009P000?o>0?ooo`00F`3o
ool00`000000oooo0?ooo`0I0?ooocd0o`00X`3ooolG0?l002H0003oc`3oool005/0oooo00<00000
0?ooo`3oool06@3ooolk0?l00:D0oooo5`3o000T0000om40oooo001K0?ooo`030000003oool0oooo
01T0oooo>P3o002V0?oooaL0o`008`000?oB0?ooo`00F`3oool00`000000oooo0?ooo`0J0?ooocP0
o`00Z03ooolE0?l002<0003od`3oool005/0oooo00<000000?ooo`3oool06P3ooolf0?l00:X0oooo
5@3o000Q0000omD0oooo001K0?ooo`030000003oool0oooo01X0oooo=@3o002[0?oooaD0o`008000
0?oF0?ooo`00F`3oool00`000000oooo0?ooo`0K0?oooc<0o`00[@3ooolC0?l00200003oe`3oool0
05/0oooo00<000000?ooo`3oool06`3ooola0?l00:l0oooo4`3o000N0000omT0oooo001K0?ooo`03
0000003oool0oooo01/0oooo<03o002`0?oooa<0o`007@000?oJ0?ooo`00F`3oool00`000000oooo
0?ooo`0L0?ooobd0o`00/`3ooolA0?l001`0003og03oool005/0oooo00<000000?ooo`3oool0703o
ool/0?l00;@0oooo4@3o000K0000omd0oooo001K0?ooo`030000003oool0oooo01`0oooo:`3o002e
0?oooa40o`006P000?oN0?ooo`00F`3oool00`000000oooo0?ooo`0M0?ooobP0o`00^03oool?0?l0
01T0003oh03oool005/0oooo00<000000?ooo`3oool07@3ooolW0?l00;T0oooo3`3o000H0000on40
oooo001K0?ooo`030000003oool0oooo01d0oooo9P3o002j0?ooo`l0o`005`000?oR0?ooo`00F`3o
ool00`000000oooo0?ooo`0N0?ooob<0o`00_@3oool=0?l001H0003oi03oool005/0oooo00<00000
0?ooo`3oool07P3ooolR0?l00;h0oooo3@3o000E0000onD0oooo001K0?ooo`030000003oool0oooo
01h0oooo8@3o002o0?ooo`d0o`0050000?oV0?ooo`00F`3oool00`000000oooo0?ooo`0O0?oooah0
o`00`P3oool;0?l001<0003oj03oool005/0oooo00<000000?ooo`3oool07`3ooolM0?l00<<0oooo
2`3o000B0000onT0oooo001K0?ooo`030000003oool0oooo01l0oooo6`3o00350?ooo`/0o`004000
0?o[0?ooo`00F`3oool00`000000oooo0?ooo`0P0?oooaT0o`00a`3oool90?l00100003ok03oool0
05/0oooo00<000000?ooo`3oool0803ooolH0?l00<P0oooo2@3o000?0000ond0oooo001K0?ooo`03
0000003oool0oooo0200oooo5P3o003:0?ooo`T0o`003@000?o_0?ooo`00F`3oool00`000000oooo
0?ooo`0Q0?oooa@0o`00c03oool70?l000d0003ol03oool005/0oooo00<000000?ooo`3oool08@3o
oolC0?l00<d0oooo1`3o000<0000oo40oooo001K0?ooo`030000003oool0oooo0240oooo4@3o003?
0?ooo`L0o`002P000?oc0?ooo`00F`3oool00`000000oooo0?ooo`0R0?ooo`l0o`00d@3oool50?l0
00X0003om03oool005/0oooo00<000000?ooo`3oool08P3oool=0?l00=<0oooo1@3o00080000ooH0
oooo001K0?ooo`030000003oool0oooo0280oooo303o003D0?ooo`D0o`001`000?og0?ooo`00F`3o
ool00`000000oooo0?ooo`0S0?ooo`X0o`00eP3oool30?l000L0003on03oool005/0oooo00<00000
0?ooo`3oool08`3oool80?l00=P0oooo0`3o00050000ooX0oooo001K0?ooo`030000003oool0oooo
02<0oooo1`3o003I0?ooo`<0o`0010000?ok0?ooo`00F`3oool00`000000oooo0?ooo`0T0?ooo`D0
o`00f`3oool00`3o0000003o0000o`020000oo`0oooo001K0?ooo`030000003oool0oooo02@0oooo
0`3o003M0?ooo`030?l000000?l0003o0?h0oooo001K0?ooo`030000003oool0oooo02@0oooo0P3o
003N0?ooo`030?l000000?l0oooo0?h0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool7
0?ooo`00F`3oool00`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3o
ool0o`3ooooo0?ooo`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00o`3o
oooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?oo
ool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00]@3oool2000001`0oooo0P00000L0?ooo`800000
703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000
_03oool00;@0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00000J0?ooo`04
0000003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00
000J0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3oool010000000
oooo0?ooo`00000J0?ooo`040000003oool0oooo00000;/0oooo002g0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`2i0?ooo`00]@3oool2000001`0
oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0
oooo0P00000L0?ooo`800000_03oool00;D0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo0;/0oooo002e0?ooo`<000006`3oool3000001/0oooo0`00
000K0?ooo`<000006`3oool3000001/0oooo0`00000K0?ooo`<000006`3oool3000001/0oooo0`00
002k0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00
o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00Z`3oool00`00
0000oooo0?ooo`3o0?ooo`T0oooo00<000000?ooo`3oool0ZP3oool00:X0oooo00<000000?ooo`3o
ool06P3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool0Z@3oool00:X0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool0Z@3oool00:X0oooo00@000000?ooo`3oool0oooo
100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo
100000020?ooo`@000000`3oool00`000000oooo0?ooo`2Y0?ooo`00Z@3oool00`000000oooo0?oo
o`3o0?ooo`d0oooo00<000000?ooo`3oool0Z03oool00:X0oooo00<000000?ooo`3oool0o`3oool;
0?ooo`030000003oool0oooo0:T0oooo002Z0?ooo`030000003oool0oooo0?l0oooo2`3oool00`00
0000oooo0?ooo`2Y0?ooo`00Z`3oool00`000000oooo0?ooo`3o0?ooo`T0oooo00<000000?ooo`3o
ool0ZP3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool0
0?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3o
oomU0?ooo`00[P3oool4000000L0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000>
0?ooo`@000001`3oool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000l0oooo0P000008
0?ooo`<000001@3oool3000000d0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`000005
0?ooo`<000003@3oool3000000D0oooo0`00000>0?ooo`@000001`3oool3000000D0oooo0`00002_
0?ooo`00[P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0:h0oooo002_0?oo
o`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?oo
o`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?oo
o`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`070?oo
o`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`000000oooo0?ooo`0>0?oo
o`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?oo
o`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?oo
o`3oool0[P3oool00;00oooo00<000000?ooo`3oool01`3oool010000000oooo0?ooo`0000030?oo
o`8000003`3oool010000000oooo0?ooo`0000030?ooo`8000004@3oool00`000000oooo0?ooo`07
0?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo
0P00000B0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool000000`3oool2000000l0
oooo00@000000?ooo`3oool000000`3oool200000140oooo00<000000?ooo`3oool01`3oool01000
0000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000030?ooo`8000004@3o
ool00`000000oooo0?ooo`070?ooo`040000003oool0oooo000000<0oooo0P00002`0?ooo`00[P3o
ool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@0
00000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo0000
01@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000003o
ool0oooo000001@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?oo
o`040000003oool0oooo00000;D0oooo002_0?ooo`800000203oool4000000D0oooo00<000000?oo
o`3oool0303oool4000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo100000050?oo
o`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?oo
o`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?oo
o`800000203oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<000000?oo
o`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo0:h0oooo003o0?ooool0
ooooI@3oool00?l0ooooo`3ooomU0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 610.563}, {170.188, 0}} -> {-0.426205, -0.013998, \
0.00467178, 0.00467178}, {{91.1875, 295.063}, {167.188, 47.3125}} -> \
{-1.34175, -0.0239702, 0.00793648, 0.00793648}, {{315.438, 519.313}, \
{167.188, 47.3125}} -> {-3.12151, -0.0239702, 0.00793648, 0.00793648}}],

Cell[BoxData[
    RowBox[{\(Solve::"ifun"\), \(\(:\)\(\ \)\), "\<\"Inverse functions are \
being used by \\!\\(Solve\\), so some solutions may not be found; use Reduce \
for complete solution information. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Solve::ifun\\\"]\\)\"\>"}]], \
"Message"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(2) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(3) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(2) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(5) show
135.000 39.000 moveto
(5) show
165.000 39.000 moveto
(5) show
195.000 39.000 moveto
(5) show
225.000 39.000 moveto
(5) show
255.000 39.000 moveto
(5) show
285.000 39.000 moveto
(5) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -9.21572e-018 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.61803 0 L
.5 .36327 L
F
0 0 1 r
.61803 0 m
1 0 L
.5 .36327 L
F
1 0 0 r
0 0 m
.5 .36327 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -1.19262e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.38197 0 m
1 0 L
.5 .36327 L
F
0 0 1 r
.38197 0 m
.5 .36327 L
.19098 .58779 L
F
1 0 0 r
.19098 .58779 m
0 0 L
.38197 0 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000Zb000`400?l00000o`00003oF`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?oo
o`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00D03ooooo00000<@00000
D03oool005/0oooo00<000000?l00000o`00N`00o`1=0000oaH0ooooC@3o00000`000?l00?l0003o
001j003o05d0oooo001K0?ooo`030000003o0000o`0007/00?l0C0000?lG0?ooodd0o`0000<0003o
003o0000o`00N@00o`1N0?ooo`00F`3oool00`000000o`000?l000020?l007T00?l0BP000?lI0?oo
odd0o`0000<0003o003o0000o`00M`00o`1P0?ooo`00F`3oool00`000000oooo0?l000030?l007L0
0?l0BP000?lK0?oood/0o`000`000?mg003o0640oooo001K0?ooo`030000003oool0o`0000@0o`00
MP00o`190000oa`0ooooB`3o00030000ogH00?l0HP3oool005/0oooo00<000000?ooo`3o00001P3o
001d003o04L0003o7P3ooom;0?l000<0003oM000o`1T0?ooo`00F`3oool00`000000oooo0?ooo`07
0?l007800?l0A`000?lP0?ooodT0o`001@000?mb003o06D0oooo001K0?ooo`030000003oool0oooo
00T0o`00L000o`150000ob80ooooB@3o00050000og000?l0I`3oool005/0oooo00<000000?ooo`3o
ool02P3o001_003o04@0003o8`3ooom90?l000D0003oK`00o`1X0?ooo`00F`3oool010000000oooo
0?ooo`3oool:0?l006d00?l0A0000?lU0?ooodL0o`001`000?m]003o06T0oooo001K0?ooo`040000
003oool0oooo0?ooo``0o`00J`00o`120000obL0ooooA`3o00070000of/00?l0J`3oool005/0oooo
00@000000?ooo`3oool0oooo3@3o001Z003o0440003o:03ooom70?l000L0003oJP00o`1/0?ooo`00
F`3oool00`000000oooo0?ooo`020?ooo`d0o`00J000o`110000obX0ooooA@3o00090000ofP00?l0
K@3oool005/0oooo00<000000?ooo`3oool00P3oool?0?l006H00?l0?`000?l/0?ooodD0o`002@00
0?mV003o06l0oooo001K0?ooo`030000003oool0oooo0080oooo403o001U003o03h0003o;@3ooom5
0?l000T0003oI@00o`1`0?ooo`00F`3oool00`000000oooo0?ooo`030?oooa40o`00HP00o`0m0000
oc00oooo@`3o000;0000of800?l0LP3oool005/0oooo00<000000?ooo`3oool00`3ooolB0?l00640
0?l0?0000?la0?oood<0o`002`000?mQ003o07<0oooo001K0?ooo`030000003oool0oooo00<0oooo
4`3o001P003o03/0003o<P3ooom30?l000/0003oH000o`1d0?ooo`00F`3oool00`000000oooo0?oo
o`040?oooa@0o`00G@00o`0j0000ocD0oooo@@3o000=0000oed00?l0MP3oool005/0oooo00<00000
0?ooo`3oool0103ooolE0?l005`00?l0>@000?lf0?oood40o`003@000?mL003o07L0oooo001K0?oo
o`030000003oool0oooo00@0oooo5P3o001K003o03P0003o=`3ooom10?l000d0003oF`00o`1h0?oo
o`00F`3oool00`000000oooo0?ooo`050?oooaL0o`00F000o`0g0000ocX0oooo?`3o000?0000oeP0
0?l0NP3oool005/0oooo00<000000?ooo`3oool01@3ooolH0?l005L00?l0=P000?lk0?ooocl0o`00
3`000?mG003o07/0oooo001K0?ooo`030000003oool0oooo00D0oooo6P3o001E003o03@0003o?@3o
oolo0?l000l0003oE@00o`1m0?ooo`00F`3oool00`000000oooo0?ooo`060?oooaX0o`00D`00o`0d
0000ocl0oooo?@3o000A0000oe<00?l0OP3oool005/0oooo00<000000?ooo`3oool01P3ooolK0?l0
05800?l0<`000?m00?ooocd0o`004@000?mB003o07l0oooo001K0?ooo`030000003oool0oooo00H0
oooo7@3o001@003o0340003o@P3ooolm0?l00140003oD000o`210?ooo`00F`3oool00`000000oooo
0?ooo`070?oooad0o`00CP00o`0a0000od@0oooo>`3o000C0000odh00?l0PP3oool005/0oooo00<0
00000?ooo`3oool01`3ooolN0?l004d00?l0<0000?m50?oooc/0o`004`000?m=003o08<0oooo001K
0?ooo`030000003oool0oooo00L0oooo803o001;003o02h0003oA`3ooolk0?l001<0003oB`00o`25
0?ooo`00F`3oool00`000000oooo0?ooo`080?ooob00o`00B@00o`0^0000odT0oooo>@3o000E0000
odT00?l0QP3oool005/0oooo00<000000?ooo`3oool0203ooolR0?l004L00?l0;0000?m;0?ooocT0
o`005@000?m7003o08P0oooo001K0?ooo`030000003oool0oooo00P0oooo8`3o0016003o02/0003o
C03oooli0?l001D0003oAP00o`290?ooo`00F`3oool00`000000oooo0?ooo`090?ooob<0o`00A000
o`0[0000odh0oooo=`3o000G0000od@00?l0RP3oool005/0oooo00<000000?ooo`3oool02@3ooolU
0?l004800?l0:@000?m@0?ooocL0o`005`000?m2003o08`0oooo001K0?ooo`030000003oool0oooo
00T0oooo9P3o0011003o02P0003oD@3ooolg0?l001L0003o@@00o`2=0?ooo`00F`3oool00`000000
oooo0?ooo`0:0?ooobH0o`00?`00o`0W0000oe@0oooo=@3o000H0000ocl00?l0S`3oool005/0oooo
00<000000?ooo`3oool02P3ooolX0?l003d00?l09P000?mE0?ooocD0o`006@000?lm003o0900oooo
001K0?ooo`030000003oool0oooo00X0oooo:@3o000l003o02D0003oEP3ooole0?l001T0003o?000
o`2A0?ooo`00F`3oool00`000000oooo0?ooo`0:0?ooob/0o`00>P00o`0S0000oeP0oooo=03o000J
0000ocX00?l0T`3oool005/0oooo00<000000?ooo`3oool02`3oool[0?l003P00?l08`000?mJ0?oo
oc<0o`006`000?lh003o09@0oooo001K0?ooo`030000003oool0oooo00/0oooo;03o000g003o0280
003oF`3ooolc0?l001/0003o=`00o`2E0?ooo`00F`3oool00`000000oooo0?ooo`0;0?ooobh0o`00
=@00o`0P0000oed0oooo<`3o000K0000ocD00?l0U`3oool005/0oooo00<000000?ooo`3oool0303o
ool^0?l003<00?l080000?mO0?oooc40o`007@000?lc003o09P0oooo001K0?ooo`030000003oool0
oooo00`0oooo<03o000a003o01h0003oH@3ooola0?l001d0003o<@00o`2J0?ooo`00F`3oool00`00
0000oooo0?ooo`0<0?oooc40o`00<000o`0M0000of80oooo<@3o000M0000oc000?l0V`3oool005/0
oooo00<000000?ooo`3oool03@3ooola0?l002h00?l07@000?mT0?ooobl0o`007`000?l^003o09`0
oooo001K0?ooo`030000003oool0oooo00d0oooo<`3o000/003o01/0003oIP3oool_0?l001l0003o
;000o`2N0?ooo`00F`3oool00`000000oooo0?ooo`0=0?oooc@0o`00:`00o`0J0000ofL0oooo;`3o
000O0000ob/00?l0W`3oool005/0oooo00<000000?ooo`3oool03P3ooold0?l002T00?l06P000?mY
0?ooobd0o`008@000?lY003o0:00oooo001K0?ooo`030000003oool0oooo00h0oooo=P3o000W003o
01P0003oJ`3oool]0?l00240003o9`00o`2R0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooocL0
o`009P00o`0G0000of`0oooo;@3o000Q0000obH00?l0X`3oool005/0oooo00<000000?ooo`3oool0
3`3ooolh0?l002<00?l05P000?m_0?ooob/0o`008`000?lS003o0:D0oooo001K0?ooo`030000003o
ool0oooo00l0oooo>@3o000R003o01D0003oL03oool[0?l002<0003o8P00o`2V0?ooo`00F`3oool0
0`000000oooo0?ooo`0?0?ooocX0o`008@00o`0D0000og40oooo:`3o000S0000ob400?l0Y`3oool0
05/0oooo00<000000?ooo`3oool0403ooolk0?l001h00?l04`000?md0?ooobT0o`009@000?lN003o
0:T0oooo001K0?ooo`030000003oool0oooo0100oooo?03o000M003o0180003oM@3ooolY0?l002D0
003o7@00o`2Z0?ooo`00F`3oool00`000000oooo0?ooo`0@0?ooocd0o`007000o`0A0000ogH0oooo
:@3o000U0000oa`00?l0Z`3oool005/0oooo00<000000?ooo`3oool04@3oooln0?l001T00?l04000
0?mi0?ooobL0o`009`000?lI003o0:d0oooo001K0?ooo`030000003oool0oooo0140oooo?`3o000H
003o00l0003oNP3ooolW0?l002L0003o6000o`2^0?ooo`00F`3oool00`000000oooo0?ooo`0A0?oo
od40o`005P00o`0=0000og`0oooo9`3o000W0000oaH00?l0/03oool005/0oooo00<000000?ooo`3o
ool04P3ooom10?l001@00?l03@000?mn0?ooobD0o`00:@000?lD003o0;40oooo001K0?ooo`030000
003oool0oooo0180oooo@P3o000C003o00`0003oO`3ooolU0?l002T0003o4`00o`2b0?ooo`00F`3o
ool00`000000oooo0?ooo`0B0?oood@0o`004@00o`0:0000oh40oooo9@3o000Y0000oa400?l0]03o
ool005/0oooo00<000000?ooo`3oool04`3ooom40?l000l00?l02P000?n30?ooob<0o`00:`000?l?
003o0;D0oooo001K0?ooo`030000003oool0oooo01<0ooooA@3o000>003o00T0003oQ03ooolS0?l0
02/0003o3P00o`2f0?ooo`00F`3oool00`000000oooo0?ooo`0C0?ooodL0o`003000o`070000ohH0
oooo8`3o000[0000o``00?l0^03oool005/0oooo00<000000?ooo`3oool0503ooom70?l000X00?l0
1`000?n80?ooob40o`00;@000?l:003o0;T0oooo001K0?ooo`030000003oool0oooo01@0ooooB@3o
0008003o00D0003oRP3ooolQ0?l002d0003o2000o`2k0?ooo`00F`3oool00`000000oooo0?ooo`0D
0?ooodX0o`001`00o`040000oh/0oooo8@3o000]0000o`L00?l0_03oool005/0oooo00<000000?oo
o`3oool05@3ooom:0?l000D00?l010000?n=0?oooal0o`00;`000?l5003o0;d0oooo001K0?ooo`03
0000003oool0oooo01D0ooooC03o0003003o0080003oS`3ooolO0?l002l0003o0`00o`2o0?ooo`00
F`3oool00`000000oooo0?ooo`0E0?ooodd0o`000P00o`000`000?l0oooo0?ooo`2>0?oooal0o`00
;`000?l2003o0<00oooo001K0?ooo`030000003oool0oooo01H0ooooC@3o002C0?oooad0o`00<000
0?o20?ooo`00F`3oool00`000000oooo0?ooo`0F0?oood`0o`00U03ooolM0?l002l0003o``3oool0
05/0oooo00<000000?ooo`3oool05P3ooom;0?l009D0oooo7@3o000^0000ol@0oooo001K0?ooo`03
0000003oool0oooo01L0ooooB03o002H0?oooa/0o`00;@000?o60?ooo`00F`3oool00`000000oooo
0?ooo`0G0?ooodL0o`00V@3ooolK0?l002`0003oa`3oool005/0oooo00<000000?ooo`3oool05`3o
oom60?l009X0oooo6`3o000[0000olP0oooo001K0?ooo`030000003oool0oooo01L0ooooA03o002L
0?oooaX0o`00:P000?o:0?ooo`00F`3oool00`000000oooo0?ooo`0H0?oood80o`00WP3ooolI0?l0
02T0003ob`3oool005/0oooo00<000000?ooo`3oool0603ooom10?l009l0oooo6@3o000X0000ol`0
oooo001K0?ooo`030000003oool0oooo01P0oooo?`3o002Q0?oooaT0o`009P000?o>0?ooo`00F`3o
ool00`000000oooo0?ooo`0I0?ooocd0o`00X`3ooolG0?l002H0003oc`3oool005/0oooo00<00000
0?ooo`3oool06@3ooolk0?l00:D0oooo5`3o000T0000om40oooo001K0?ooo`030000003oool0oooo
01T0oooo>P3o002V0?oooaL0o`008`000?oB0?ooo`00F`3oool00`000000oooo0?ooo`0J0?ooocP0
o`00Z03ooolE0?l002<0003od`3oool005/0oooo00<000000?ooo`3oool06P3ooolf0?l00:X0oooo
5@3o000Q0000omD0oooo001K0?ooo`030000003oool0oooo01X0oooo=@3o002[0?oooaD0o`008000
0?oF0?ooo`00F`3oool00`000000oooo0?ooo`0K0?oooc<0o`00[@3ooolC0?l00200003oe`3oool0
05/0oooo00<000000?ooo`3oool06`3ooola0?l00:l0oooo4`3o000N0000omT0oooo001K0?ooo`03
0000003oool0oooo01/0oooo<03o002`0?oooa<0o`007@000?oJ0?ooo`00F`3oool00`000000oooo
0?ooo`0L0?ooobd0o`00/`3ooolA0?l001`0003og03oool005/0oooo00<000000?ooo`3oool0703o
ool/0?l00;@0oooo4@3o000K0000omd0oooo001K0?ooo`030000003oool0oooo01`0oooo:`3o002e
0?oooa40o`006P000?oN0?ooo`00F`3oool00`000000oooo0?ooo`0M0?ooobP0o`00^03oool?0?l0
01T0003oh03oool005/0oooo00<000000?ooo`3oool07@3ooolW0?l00;T0oooo3`3o000H0000on40
oooo001K0?ooo`030000003oool0oooo01d0oooo9P3o002j0?ooo`l0o`005`000?oR0?ooo`00F`3o
ool00`000000oooo0?ooo`0N0?ooob<0o`00_@3oool=0?l001H0003oi03oool005/0oooo00<00000
0?ooo`3oool07P3ooolR0?l00;h0oooo3@3o000E0000onD0oooo001K0?ooo`030000003oool0oooo
01h0oooo8@3o002o0?ooo`d0o`0050000?oV0?ooo`00F`3oool00`000000oooo0?ooo`0O0?oooah0
o`00`P3oool;0?l001<0003oj03oool005/0oooo00<000000?ooo`3oool07`3ooolM0?l00<<0oooo
2`3o000B0000onT0oooo001K0?ooo`030000003oool0oooo01l0oooo6`3o00350?ooo`/0o`004000
0?o[0?ooo`00F`3oool00`000000oooo0?ooo`0P0?oooaT0o`00a`3oool90?l00100003ok03oool0
05/0oooo00<000000?ooo`3oool0803ooolH0?l00<P0oooo2@3o000?0000ond0oooo001K0?ooo`03
0000003oool0oooo0200oooo5P3o003:0?ooo`T0o`003@000?o_0?ooo`00F`3oool00`000000oooo
0?ooo`0Q0?oooa@0o`00c03oool70?l000d0003ol03oool005/0oooo00<000000?ooo`3oool08@3o
oolC0?l00<d0oooo1`3o000<0000oo40oooo001K0?ooo`030000003oool0oooo0240oooo4@3o003?
0?ooo`L0o`002P000?oc0?ooo`00F`3oool00`000000oooo0?ooo`0R0?ooo`l0o`00d@3oool50?l0
00X0003om03oool005/0oooo00<000000?ooo`3oool08P3oool=0?l00=<0oooo1@3o00080000ooH0
oooo001K0?ooo`030000003oool0oooo0280oooo303o003D0?ooo`D0o`001`000?og0?ooo`00F`3o
ool00`000000oooo0?ooo`0S0?ooo`X0o`00eP3oool30?l000L0003on03oool005/0oooo00<00000
0?ooo`3oool08`3oool80?l00=P0oooo0`3o00050000ooX0oooo001K0?ooo`030000003oool0oooo
02<0oooo1`3o003I0?ooo`<0o`0010000?ok0?ooo`00F`3oool00`000000oooo0?ooo`0T0?ooo`D0
o`00f`3oool00`3o0000003o0000o`020000oo`0oooo001K0?ooo`030000003oool0oooo02@0oooo
0`3o003M0?ooo`030?l000000?l0003o0?h0oooo001K0?ooo`030000003oool0oooo02@0oooo0P3o
003N0?ooo`030?l000000?l0oooo0?h0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool7
0?ooo`00F`3oool00`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3o
ool0o`3ooooo0?ooo`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00o`3o
oooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?oo
ool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00]@3oool2000001`0oooo0P00000L0?ooo`800000
703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000
_03oool00;@0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00000J0?ooo`04
0000003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00
000J0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3oool010000000
oooo0?ooo`00000J0?ooo`040000003oool0oooo00000;/0oooo002g0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`2i0?ooo`00]@3oool2000001`0
oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0
oooo0P00000L0?ooo`800000_03oool00;D0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo0;/0oooo002e0?ooo`<000006`3oool3000001/0oooo0`00
000K0?ooo`<000006`3oool3000001/0oooo0`00000K0?ooo`<000006`3oool3000001/0oooo0`00
002k0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00
o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00Z`3oool00`00
0000oooo0?ooo`3o0?ooo`T0oooo00<000000?ooo`3oool0ZP3oool00:X0oooo00<000000?ooo`3o
ool06P3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool0Z@3oool00:X0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool0Z@3oool00:X0oooo00@000000?ooo`3oool0oooo
100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo
100000020?ooo`@000000`3oool00`000000oooo0?ooo`2Y0?ooo`00Z@3oool00`000000oooo0?oo
o`3o0?ooo`d0oooo00<000000?ooo`3oool0Z03oool00:X0oooo00<000000?ooo`3oool0o`3oool;
0?ooo`030000003oool0oooo0:T0oooo002Z0?ooo`030000003oool0oooo0?l0oooo2`3oool00`00
0000oooo0?ooo`2Y0?ooo`00Z`3oool00`000000oooo0?ooo`3o0?ooo`T0oooo00<000000?ooo`3o
ool0ZP3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool0
0?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3o
oomU0?ooo`00[P3oool4000000L0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000>
0?ooo`@000001`3oool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000l0oooo0P000008
0?ooo`<000001@3oool3000000d0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`000005
0?ooo`<000003@3oool3000000D0oooo0`00000>0?ooo`@000001`3oool3000000D0oooo0`00002_
0?ooo`00[P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0:h0oooo002_0?oo
o`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?oo
o`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?oo
o`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`070?oo
o`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`000000oooo0?ooo`0>0?oo
o`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?oo
o`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?oo
o`3oool0[P3oool00;00oooo00<000000?ooo`3oool01`3oool010000000oooo0?ooo`0000030?oo
o`8000003`3oool010000000oooo0?ooo`0000030?ooo`8000004@3oool00`000000oooo0?ooo`07
0?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo
0P00000B0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool000000`3oool2000000l0
oooo00@000000?ooo`3oool000000`3oool200000140oooo00<000000?ooo`3oool01`3oool01000
0000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000030?ooo`8000004@3o
ool00`000000oooo0?ooo`070?ooo`040000003oool0oooo000000<0oooo0P00002`0?ooo`00[P3o
ool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@0
00000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo0000
01@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000003o
ool0oooo000001@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?oo
o`040000003oool0oooo00000;D0oooo002_0?ooo`800000203oool4000000D0oooo00<000000?oo
o`3oool0303oool4000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo100000050?oo
o`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?oo
o`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?oo
o`800000203oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<000000?oo
o`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo0:h0oooo003o0?ooool0
ooooI@3oool00?l0ooooo`3ooomU0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 610.563}, {170.188, 0}} -> {-0.426205, -0.013998, \
0.00467178, 0.00467178}, {{91.1875, 295.063}, {167.188, 47.3125}} -> \
{-1.34175, -0.0239702, 0.00793648, 0.00793648}, {{315.438, 519.313}, \
{167.188, 47.3125}} -> {-3.12151, -0.0239702, 0.00793648, 0.00793648}}],

Cell[BoxData[
    RowBox[{\(Solve::"ifun"\), \(\(:\)\(\ \)\), "\<\"Inverse functions are \
being used by \\!\\(Solve\\), so some solutions may not be found; use Reduce \
for complete solution information. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Solve::ifun\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(Solve :: \\\"ifun\\\"\\) will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], \
"Message"],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(2) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(3) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(2) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(5) show
135.000 39.000 moveto
(5) show
165.000 39.000 moveto
(5) show
195.000 39.000 moveto
(5) show
225.000 39.000 moveto
(5) show
255.000 39.000 moveto
(5) show
285.000 39.000 moveto
(5) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -9.21572e-018 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.61803 0 L
.5 .36327 L
F
0 0 1 r
.61803 0 m
1 0 L
.5 .36327 L
F
1 0 0 r
0 0 m
.5 .36327 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -1.19262e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.38197 0 m
1 0 L
.5 .36327 L
F
0 0 1 r
.38197 0 m
.5 .36327 L
.19098 .58779 L
F
1 0 0 r
.19098 .58779 m
0 0 L
.38197 0 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000Zb000`400?l00000o`00003oF`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?oo
o`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00D03ooooo00000<@00000
D03oool005/0oooo00<000000?l00000o`00N`00o`1=0000oaH0ooooC@3o00000`000?l00?l0003o
001j003o05d0oooo001K0?ooo`030000003o0000o`0007/00?l0C0000?lG0?ooodd0o`0000<0003o
003o0000o`00N@00o`1N0?ooo`00F`3oool00`000000o`000?l000020?l007T00?l0BP000?lI0?oo
odd0o`0000<0003o003o0000o`00M`00o`1P0?ooo`00F`3oool00`000000oooo0?l000030?l007L0
0?l0BP000?lK0?oood/0o`000`000?mg003o0640oooo001K0?ooo`030000003oool0o`0000@0o`00
MP00o`190000oa`0ooooB`3o00030000ogH00?l0HP3oool005/0oooo00<000000?ooo`3o00001P3o
001d003o04L0003o7P3ooom;0?l000<0003oM000o`1T0?ooo`00F`3oool00`000000oooo0?ooo`07
0?l007800?l0A`000?lP0?ooodT0o`001@000?mb003o06D0oooo001K0?ooo`030000003oool0oooo
00T0o`00L000o`150000ob80ooooB@3o00050000og000?l0I`3oool005/0oooo00<000000?ooo`3o
ool02P3o001_003o04@0003o8`3ooom90?l000D0003oK`00o`1X0?ooo`00F`3oool010000000oooo
0?ooo`3oool:0?l006d00?l0A0000?lU0?ooodL0o`001`000?m]003o06T0oooo001K0?ooo`040000
003oool0oooo0?ooo``0o`00J`00o`120000obL0ooooA`3o00070000of/00?l0J`3oool005/0oooo
00@000000?ooo`3oool0oooo3@3o001Z003o0440003o:03ooom70?l000L0003oJP00o`1/0?ooo`00
F`3oool00`000000oooo0?ooo`020?ooo`d0o`00J000o`110000obX0ooooA@3o00090000ofP00?l0
K@3oool005/0oooo00<000000?ooo`3oool00P3oool?0?l006H00?l0?`000?l/0?ooodD0o`002@00
0?mV003o06l0oooo001K0?ooo`030000003oool0oooo0080oooo403o001U003o03h0003o;@3ooom5
0?l000T0003oI@00o`1`0?ooo`00F`3oool00`000000oooo0?ooo`030?oooa40o`00HP00o`0m0000
oc00oooo@`3o000;0000of800?l0LP3oool005/0oooo00<000000?ooo`3oool00`3ooolB0?l00640
0?l0?0000?la0?oood<0o`002`000?mQ003o07<0oooo001K0?ooo`030000003oool0oooo00<0oooo
4`3o001P003o03/0003o<P3ooom30?l000/0003oH000o`1d0?ooo`00F`3oool00`000000oooo0?oo
o`040?oooa@0o`00G@00o`0j0000ocD0oooo@@3o000=0000oed00?l0MP3oool005/0oooo00<00000
0?ooo`3oool0103ooolE0?l005`00?l0>@000?lf0?oood40o`003@000?mL003o07L0oooo001K0?oo
o`030000003oool0oooo00@0oooo5P3o001K003o03P0003o=`3ooom10?l000d0003oF`00o`1h0?oo
o`00F`3oool00`000000oooo0?ooo`050?oooaL0o`00F000o`0g0000ocX0oooo?`3o000?0000oeP0
0?l0NP3oool005/0oooo00<000000?ooo`3oool01@3ooolH0?l005L00?l0=P000?lk0?ooocl0o`00
3`000?mG003o07/0oooo001K0?ooo`030000003oool0oooo00D0oooo6P3o001E003o03@0003o?@3o
oolo0?l000l0003oE@00o`1m0?ooo`00F`3oool00`000000oooo0?ooo`060?oooaX0o`00D`00o`0d
0000ocl0oooo?@3o000A0000oe<00?l0OP3oool005/0oooo00<000000?ooo`3oool01P3ooolK0?l0
05800?l0<`000?m00?ooocd0o`004@000?mB003o07l0oooo001K0?ooo`030000003oool0oooo00H0
oooo7@3o001@003o0340003o@P3ooolm0?l00140003oD000o`210?ooo`00F`3oool00`000000oooo
0?ooo`070?oooad0o`00CP00o`0a0000od@0oooo>`3o000C0000odh00?l0PP3oool005/0oooo00<0
00000?ooo`3oool01`3ooolN0?l004d00?l0<0000?m50?oooc/0o`004`000?m=003o08<0oooo001K
0?ooo`030000003oool0oooo00L0oooo803o001;003o02h0003oA`3ooolk0?l001<0003oB`00o`25
0?ooo`00F`3oool00`000000oooo0?ooo`080?ooob00o`00B@00o`0^0000odT0oooo>@3o000E0000
odT00?l0QP3oool005/0oooo00<000000?ooo`3oool0203ooolR0?l004L00?l0;0000?m;0?ooocT0
o`005@000?m7003o08P0oooo001K0?ooo`030000003oool0oooo00P0oooo8`3o0016003o02/0003o
C03oooli0?l001D0003oAP00o`290?ooo`00F`3oool00`000000oooo0?ooo`090?ooob<0o`00A000
o`0[0000odh0oooo=`3o000G0000od@00?l0RP3oool005/0oooo00<000000?ooo`3oool02@3ooolU
0?l004800?l0:@000?m@0?ooocL0o`005`000?m2003o08`0oooo001K0?ooo`030000003oool0oooo
00T0oooo9P3o0011003o02P0003oD@3ooolg0?l001L0003o@@00o`2=0?ooo`00F`3oool00`000000
oooo0?ooo`0:0?ooobH0o`00?`00o`0W0000oe@0oooo=@3o000H0000ocl00?l0S`3oool005/0oooo
00<000000?ooo`3oool02P3ooolX0?l003d00?l09P000?mE0?ooocD0o`006@000?lm003o0900oooo
001K0?ooo`030000003oool0oooo00X0oooo:@3o000l003o02D0003oEP3ooole0?l001T0003o?000
o`2A0?ooo`00F`3oool00`000000oooo0?ooo`0:0?ooob/0o`00>P00o`0S0000oeP0oooo=03o000J
0000ocX00?l0T`3oool005/0oooo00<000000?ooo`3oool02`3oool[0?l003P00?l08`000?mJ0?oo
oc<0o`006`000?lh003o09@0oooo001K0?ooo`030000003oool0oooo00/0oooo;03o000g003o0280
003oF`3ooolc0?l001/0003o=`00o`2E0?ooo`00F`3oool00`000000oooo0?ooo`0;0?ooobh0o`00
=@00o`0P0000oed0oooo<`3o000K0000ocD00?l0U`3oool005/0oooo00<000000?ooo`3oool0303o
ool^0?l003<00?l080000?mO0?oooc40o`007@000?lc003o09P0oooo001K0?ooo`030000003oool0
oooo00`0oooo<03o000a003o01h0003oH@3ooola0?l001d0003o<@00o`2J0?ooo`00F`3oool00`00
0000oooo0?ooo`0<0?oooc40o`00<000o`0M0000of80oooo<@3o000M0000oc000?l0V`3oool005/0
oooo00<000000?ooo`3oool03@3ooola0?l002h00?l07@000?mT0?ooobl0o`007`000?l^003o09`0
oooo001K0?ooo`030000003oool0oooo00d0oooo<`3o000/003o01/0003oIP3oool_0?l001l0003o
;000o`2N0?ooo`00F`3oool00`000000oooo0?ooo`0=0?oooc@0o`00:`00o`0J0000ofL0oooo;`3o
000O0000ob/00?l0W`3oool005/0oooo00<000000?ooo`3oool03P3ooold0?l002T00?l06P000?mY
0?ooobd0o`008@000?lY003o0:00oooo001K0?ooo`030000003oool0oooo00h0oooo=P3o000W003o
01P0003oJ`3oool]0?l00240003o9`00o`2R0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooocL0
o`009P00o`0G0000of`0oooo;@3o000Q0000obH00?l0X`3oool005/0oooo00<000000?ooo`3oool0
3`3ooolh0?l002<00?l05P000?m_0?ooob/0o`008`000?lS003o0:D0oooo001K0?ooo`030000003o
ool0oooo00l0oooo>@3o000R003o01D0003oL03oool[0?l002<0003o8P00o`2V0?ooo`00F`3oool0
0`000000oooo0?ooo`0?0?ooocX0o`008@00o`0D0000og40oooo:`3o000S0000ob400?l0Y`3oool0
05/0oooo00<000000?ooo`3oool0403ooolk0?l001h00?l04`000?md0?ooobT0o`009@000?lN003o
0:T0oooo001K0?ooo`030000003oool0oooo0100oooo?03o000M003o0180003oM@3ooolY0?l002D0
003o7@00o`2Z0?ooo`00F`3oool00`000000oooo0?ooo`0@0?ooocd0o`007000o`0A0000ogH0oooo
:@3o000U0000oa`00?l0Z`3oool005/0oooo00<000000?ooo`3oool04@3oooln0?l001T00?l04000
0?mi0?ooobL0o`009`000?lI003o0:d0oooo001K0?ooo`030000003oool0oooo0140oooo?`3o000H
003o00l0003oNP3ooolW0?l002L0003o6000o`2^0?ooo`00F`3oool00`000000oooo0?ooo`0A0?oo
od40o`005P00o`0=0000og`0oooo9`3o000W0000oaH00?l0/03oool005/0oooo00<000000?ooo`3o
ool04P3ooom10?l001@00?l03@000?mn0?ooobD0o`00:@000?lD003o0;40oooo001K0?ooo`030000
003oool0oooo0180oooo@P3o000C003o00`0003oO`3ooolU0?l002T0003o4`00o`2b0?ooo`00F`3o
ool00`000000oooo0?ooo`0B0?oood@0o`004@00o`0:0000oh40oooo9@3o000Y0000oa400?l0]03o
ool005/0oooo00<000000?ooo`3oool04`3ooom40?l000l00?l02P000?n30?ooob<0o`00:`000?l?
003o0;D0oooo001K0?ooo`030000003oool0oooo01<0ooooA@3o000>003o00T0003oQ03ooolS0?l0
02/0003o3P00o`2f0?ooo`00F`3oool00`000000oooo0?ooo`0C0?ooodL0o`003000o`070000ohH0
oooo8`3o000[0000o``00?l0^03oool005/0oooo00<000000?ooo`3oool0503ooom70?l000X00?l0
1`000?n80?ooob40o`00;@000?l:003o0;T0oooo001K0?ooo`030000003oool0oooo01@0ooooB@3o
0008003o00D0003oRP3ooolQ0?l002d0003o2000o`2k0?ooo`00F`3oool00`000000oooo0?ooo`0D
0?ooodX0o`001`00o`040000oh/0oooo8@3o000]0000o`L00?l0_03oool005/0oooo00<000000?oo
o`3oool05@3ooom:0?l000D00?l010000?n=0?oooal0o`00;`000?l5003o0;d0oooo001K0?ooo`03
0000003oool0oooo01D0ooooC03o0003003o0080003oS`3ooolO0?l002l0003o0`00o`2o0?ooo`00
F`3oool00`000000oooo0?ooo`0E0?ooodd0o`000P00o`000`000?l0oooo0?ooo`2>0?oooal0o`00
;`000?l2003o0<00oooo001K0?ooo`030000003oool0oooo01H0ooooC@3o002C0?oooad0o`00<000
0?o20?ooo`00F`3oool00`000000oooo0?ooo`0F0?oood`0o`00U03ooolM0?l002l0003o``3oool0
05/0oooo00<000000?ooo`3oool05P3ooom;0?l009D0oooo7@3o000^0000ol@0oooo001K0?ooo`03
0000003oool0oooo01L0ooooB03o002H0?oooa/0o`00;@000?o60?ooo`00F`3oool00`000000oooo
0?ooo`0G0?ooodL0o`00V@3ooolK0?l002`0003oa`3oool005/0oooo00<000000?ooo`3oool05`3o
oom60?l009X0oooo6`3o000[0000olP0oooo001K0?ooo`030000003oool0oooo01L0ooooA03o002L
0?oooaX0o`00:P000?o:0?ooo`00F`3oool00`000000oooo0?ooo`0H0?oood80o`00WP3ooolI0?l0
02T0003ob`3oool005/0oooo00<000000?ooo`3oool0603ooom10?l009l0oooo6@3o000X0000ol`0
oooo001K0?ooo`030000003oool0oooo01P0oooo?`3o002Q0?oooaT0o`009P000?o>0?ooo`00F`3o
ool00`000000oooo0?ooo`0I0?ooocd0o`00X`3ooolG0?l002H0003oc`3oool005/0oooo00<00000
0?ooo`3oool06@3ooolk0?l00:D0oooo5`3o000T0000om40oooo001K0?ooo`030000003oool0oooo
01T0oooo>P3o002V0?oooaL0o`008`000?oB0?ooo`00F`3oool00`000000oooo0?ooo`0J0?ooocP0
o`00Z03ooolE0?l002<0003od`3oool005/0oooo00<000000?ooo`3oool06P3ooolf0?l00:X0oooo
5@3o000Q0000omD0oooo001K0?ooo`030000003oool0oooo01X0oooo=@3o002[0?oooaD0o`008000
0?oF0?ooo`00F`3oool00`000000oooo0?ooo`0K0?oooc<0o`00[@3ooolC0?l00200003oe`3oool0
05/0oooo00<000000?ooo`3oool06`3ooola0?l00:l0oooo4`3o000N0000omT0oooo001K0?ooo`03
0000003oool0oooo01/0oooo<03o002`0?oooa<0o`007@000?oJ0?ooo`00F`3oool00`000000oooo
0?ooo`0L0?ooobd0o`00/`3ooolA0?l001`0003og03oool005/0oooo00<000000?ooo`3oool0703o
ool/0?l00;@0oooo4@3o000K0000omd0oooo001K0?ooo`030000003oool0oooo01`0oooo:`3o002e
0?oooa40o`006P000?oN0?ooo`00F`3oool00`000000oooo0?ooo`0M0?ooobP0o`00^03oool?0?l0
01T0003oh03oool005/0oooo00<000000?ooo`3oool07@3ooolW0?l00;T0oooo3`3o000H0000on40
oooo001K0?ooo`030000003oool0oooo01d0oooo9P3o002j0?ooo`l0o`005`000?oR0?ooo`00F`3o
ool00`000000oooo0?ooo`0N0?ooob<0o`00_@3oool=0?l001H0003oi03oool005/0oooo00<00000
0?ooo`3oool07P3ooolR0?l00;h0oooo3@3o000E0000onD0oooo001K0?ooo`030000003oool0oooo
01h0oooo8@3o002o0?ooo`d0o`0050000?oV0?ooo`00F`3oool00`000000oooo0?ooo`0O0?oooah0
o`00`P3oool;0?l001<0003oj03oool005/0oooo00<000000?ooo`3oool07`3ooolM0?l00<<0oooo
2`3o000B0000onT0oooo001K0?ooo`030000003oool0oooo01l0oooo6`3o00350?ooo`/0o`004000
0?o[0?ooo`00F`3oool00`000000oooo0?ooo`0P0?oooaT0o`00a`3oool90?l00100003ok03oool0
05/0oooo00<000000?ooo`3oool0803ooolH0?l00<P0oooo2@3o000?0000ond0oooo001K0?ooo`03
0000003oool0oooo0200oooo5P3o003:0?ooo`T0o`003@000?o_0?ooo`00F`3oool00`000000oooo
0?ooo`0Q0?oooa@0o`00c03oool70?l000d0003ol03oool005/0oooo00<000000?ooo`3oool08@3o
oolC0?l00<d0oooo1`3o000<0000oo40oooo001K0?ooo`030000003oool0oooo0240oooo4@3o003?
0?ooo`L0o`002P000?oc0?ooo`00F`3oool00`000000oooo0?ooo`0R0?ooo`l0o`00d@3oool50?l0
00X0003om03oool005/0oooo00<000000?ooo`3oool08P3oool=0?l00=<0oooo1@3o00080000ooH0
oooo001K0?ooo`030000003oool0oooo0280oooo303o003D0?ooo`D0o`001`000?og0?ooo`00F`3o
ool00`000000oooo0?ooo`0S0?ooo`X0o`00eP3oool30?l000L0003on03oool005/0oooo00<00000
0?ooo`3oool08`3oool80?l00=P0oooo0`3o00050000ooX0oooo001K0?ooo`030000003oool0oooo
02<0oooo1`3o003I0?ooo`<0o`0010000?ok0?ooo`00F`3oool00`000000oooo0?ooo`0T0?ooo`D0
o`00f`3oool00`3o0000003o0000o`020000oo`0oooo001K0?ooo`030000003oool0oooo02@0oooo
0`3o003M0?ooo`030?l000000?l0003o0?h0oooo001K0?ooo`030000003oool0oooo02@0oooo0P3o
003N0?ooo`030?l000000?l0oooo0?h0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool7
0?ooo`00F`3oool00`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3o
ool0o`3ooooo0?ooo`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00o`3o
oooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?oo
ool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00]@3oool2000001`0oooo0P00000L0?ooo`800000
703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000
_03oool00;@0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00000J0?ooo`04
0000003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00
000J0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3oool010000000
oooo0?ooo`00000J0?ooo`040000003oool0oooo00000;/0oooo002g0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`2i0?ooo`00]@3oool2000001`0
oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0
oooo0P00000L0?ooo`800000_03oool00;D0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo0;/0oooo002e0?ooo`<000006`3oool3000001/0oooo0`00
000K0?ooo`<000006`3oool3000001/0oooo0`00000K0?ooo`<000006`3oool3000001/0oooo0`00
002k0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00
o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00Z`3oool00`00
0000oooo0?ooo`3o0?ooo`T0oooo00<000000?ooo`3oool0ZP3oool00:X0oooo00<000000?ooo`3o
ool06P3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool0Z@3oool00:X0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool0Z@3oool00:X0oooo00@000000?ooo`3oool0oooo
100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo
100000020?ooo`@000000`3oool00`000000oooo0?ooo`2Y0?ooo`00Z@3oool00`000000oooo0?oo
o`3o0?ooo`d0oooo00<000000?ooo`3oool0Z03oool00:X0oooo00<000000?ooo`3oool0o`3oool;
0?ooo`030000003oool0oooo0:T0oooo002Z0?ooo`030000003oool0oooo0?l0oooo2`3oool00`00
0000oooo0?ooo`2Y0?ooo`00Z`3oool00`000000oooo0?ooo`3o0?ooo`T0oooo00<000000?ooo`3o
ool0ZP3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool0
0?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3o
oomU0?ooo`00[P3oool4000000L0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000>
0?ooo`@000001`3oool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000l0oooo0P000008
0?ooo`<000001@3oool3000000d0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`000005
0?ooo`<000003@3oool3000000D0oooo0`00000>0?ooo`@000001`3oool3000000D0oooo0`00002_
0?ooo`00[P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0:h0oooo002_0?oo
o`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?oo
o`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?oo
o`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`070?oo
o`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`000000oooo0?ooo`0>0?oo
o`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?oo
o`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?oo
o`3oool0[P3oool00;00oooo00<000000?ooo`3oool01`3oool010000000oooo0?ooo`0000030?oo
o`8000003`3oool010000000oooo0?ooo`0000030?ooo`8000004@3oool00`000000oooo0?ooo`07
0?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo
0P00000B0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool000000`3oool2000000l0
oooo00@000000?ooo`3oool000000`3oool200000140oooo00<000000?ooo`3oool01`3oool01000
0000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000030?ooo`8000004@3o
ool00`000000oooo0?ooo`070?ooo`040000003oool0oooo000000<0oooo0P00002`0?ooo`00[P3o
ool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@0
00000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo0000
01@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000003o
ool0oooo000001@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?oo
o`040000003oool0oooo00000;D0oooo002_0?ooo`800000203oool4000000D0oooo00<000000?oo
o`3oool0303oool4000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo100000050?oo
o`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?oo
o`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?oo
o`800000203oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<000000?oo
o`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo0:h0oooo003o0?ooool0
ooooI@3oool00?l0ooooo`3ooomU0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 610.563}, {170.188, 0}} -> {-0.426205, -0.013998, \
0.00467178, 0.00467178}, {{91.1875, 295.063}, {167.188, 47.3125}} -> \
{-1.34175, -0.0239702, 0.00793648, 0.00793648}, {{315.438, 519.313}, \
{167.188, 47.3125}} -> {-3.12151, -0.0239702, 0.00793648, 0.00793648}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .20661 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00491932 0.47619 [
[.5 .21911 -152 0 ]
[.5 .21911 152 38.75 ]
[ 0 0 0 0 ]
[ 1 .20661 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00492 m
1 .00492 L
s
.02381 0 m
.02381 .20661 L
s
gsave
.5 .21911 -213 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(3) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(4) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(2) show
237.000 12.750 moveto
(Pi) show
261.000 12.750 moveto
(2) show
273.000 12.750 moveto
(Pi) show
297.000 12.750 moveto
(2) show
309.000 12.750 moveto
(Pi) show
333.000 12.750 moveto
(3) show
345.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
(--) show
249.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
261.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
273.000 25.875 moveto
(--) show
285.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
297.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
309.000 25.875 moveto
(--) show
321.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
333.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
345.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
357.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
105.000 39.000 moveto
(7) show
135.000 39.000 moveto
(7) show
165.000 39.000 moveto
(7) show
195.000 39.000 moveto
(7) show
231.000 39.000 moveto
(7) show
267.000 39.000 moveto
(7) show
303.000 39.000 moveto
(7) show
339.000 39.000 moveto
(7) show
345.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .20661 L
0 .20661 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00491932 0.477324 0.201692 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.445042 0.554958 1.37152e-017 0.554958 [
[ 0 0 0 0 ]
[ 1 .43388 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .43388 L
0 .43388 L
closepath
clip
newpath
0 1 0 r
0 0 m
.55496 0 L
.5 .24079 L
F
0 0 1 r
.55496 0 m
1 0 L
.5 .24079 L
F
1 0 0 r
0 0 m
.5 .24079 L
.09903 .43388 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00491932 0.97619 0.201692 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.445042 0.554958 -4.49944e-018 0.554958 [
[ 0 0 0 0 ]
[ 1 .43388 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .43388 L
0 .43388 L
closepath
clip
newpath
0 1 0 r
.44504 0 m
1 0 L
.5 .24079 L
F
0 0 1 r
.44504 0 m
.5 .24079 L
.09903 .43388 L
F
1 0 0 r
.09903 .43388 m
0 0 L
.44504 0 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.625, 126.375},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000OR000`400?l00000o`00003oM@3oool0
0`000000oooo0?ooo`3o0?ooon`0oooo001e0?ooo`030000003oool0oooo0?l0ooook03oool006/0
ooooo`00002=000006`0oooo001e0?ooo`030000003o0000o`0006000?l0CP000?lE0?ooodl0o`00
00<0003o003o0000o`00GP00o`1h0?ooo`00M@3oool00`000000o`000?l000020?l005h00?l0C000
0?lG0?ooodh0o`000P000?mN003o07X0oooo001e0?ooo`030000003o0000o`0000@0o`00G000o`1:
0000oaT0ooooC@3o00030000oe`00?l0O03oool007D0oooo00<000000?l0003o00001P3o001J003o
04P0003o6`3ooom<0?l000@0003oFP00o`1n0?ooo`00M@3oool00`000000oooo0?l000080?l005L0
0?l0A`000?lN0?oood/0o`001@000?mG003o0800oooo001e0?ooo`030000003oool0o`0000X0o`00
E@00o`150000ob00ooooBP3o00060000oeD00?l0PP3oool007D0oooo00<000000?ooo`3o0000303o
001C003o04<0003o8P3ooom90?l000L0003oD`00o`240?ooo`00M@3oool00`000000oooo0?l0000>
0?l005400?l0@@000?lT0?ooodP0o`0020000?mA003o08H0oooo001e0?ooo`030000003oool0o`00
0100o`00CP00o`100000obL0ooooAP3o00090000odl00?l0R03oool007D0oooo00<000000?ooo`3o
ool04P3o001<003o03h0003o:@3ooom60?l000X0003oC000o`2:0?ooo`00M@3oool00`000000oooo
0?ooo`0D0?l004X00?l0>`000?l/0?ooodD0o`002`000?m9003o08d0oooo001e0?ooo`030000003o
ool0oooo01H0o`00B000o`0i0000obh0ooooA03o000<0000odL00?l0S`3oool007D0oooo00<00000
0?ooo`3oool0603o0015003o03P0003o<03ooom30?l000d0003oA@00o`2A0?ooo`00M@3oool01000
0000oooo0?ooo`3ooolI0?l004<00?l0=P000?lc0?oood40o`003P000?m3003o09<0oooo001e0?oo
o`040000003oool0oooo0?oooa`0o`00@000o`0d0000ocD0oooo@@3o000?0000od000?l0U@3oool0
07D0oooo00@000000?ooo`3oool0oooo7P3o000n003o0380003o=`3ooom00?l00100003o?P00o`2G
0?ooo`00M@3oool010000000oooo0?ooo`3ooolP0?l003`00?l0<0000?li0?ooocl0o`004@000?ll
003o09T0oooo001e0?ooo`040000003oool0oooo0?ooob80o`00>@00o`0_0000oc`0oooo?@3o000B
0000ocX00?l0V`3oool007D0oooo00<000000?ooo`3oool00P3ooolS0?l003L00?l0;@000?ln0?oo
oc`0o`004`000?lh003o09d0oooo001e0?ooo`030000003oool0oooo0080oooo9@3o000e003o02/0
003o@03oooll0?l001@0003o=@00o`2O0?ooo`00M@3oool00`000000oooo0?ooo`020?ooobL0o`00
<`00o`0Y0000od80oooo>`3o000E0000oc<00?l0X@3oool007D0oooo00<000000?ooo`3oool00P3o
oolY0?l003000?l09`000?m60?ooocT0o`005P000?l`003o0:@0oooo001e0?ooo`030000003oool0
oooo00<0oooo:P3o000^003o02D0003oB03ooolh0?l001L0003o;P00o`2V0?ooo`00M@3oool00`00
0000oooo0?ooo`030?ooob`0o`00;000o`0S0000odX0oooo=`3o000I0000ob/00?l0Z03oool007D0
oooo00<000000?ooo`3oool00`3oool^0?l002X00?l08@000?m<0?ooocL0o`006@000?lY003o0:X0
oooo001e0?ooo`030000003oool0oooo00<0oooo<03o000W003o0200003oCP3ooolf0?l001X0003o
9`00o`2/0?ooo`00M@3oool00`000000oooo0?ooo`030?oooc80o`009@00o`0N0000oe40oooo=03o
000K0000obD00?l0[P3oool007D0oooo00<000000?ooo`3oool0103ooolc0?l002<00?l070000?mC
0?oooc<0o`0070000?lS003o0;00oooo001e0?ooo`030000003oool0oooo00@0oooo=P3o000P003o
01X0003oE@3ooolb0?l001h0003o8000o`2b0?ooo`00M@3oool00`000000oooo0?ooo`040?ooocP0
o`007P00o`0H0000oeL0oooo<P3o000N0000oah00?l0]03oool007D0oooo00<000000?ooo`3oool0
103ooolj0?l001/00?l05`000?mJ0?oooc00o`007`000?lL003o0;H0oooo001e0?ooo`030000003o
ool0oooo00@0oooo?03o000I003o01D0003oG03oool_0?l00200003o6P00o`2h0?ooo`00M@3oool0
0`000000oooo0?ooo`050?ooocd0o`005`00o`0B0000oel0oooo;P3o000Q0000oaL00?l0^`3oool0
07D0oooo00<000000?ooo`3oool01@3ooolo0?l001D00?l040000?mQ0?ooobd0o`008`000?lD003o
0;d0oooo001e0?ooo`030000003oool0oooo00D0oooo@@3o000B003o00l0003oI03oool/0?l002<0
003o4P00o`2o0?ooo`00M@3oool00`000000oooo0?ooo`050?oood<0o`004000o`0=0000ofH0oooo
:`3o000T0000oa000?l0`@3oool007D0oooo00<000000?ooo`3oool01P3ooom40?l000h00?l02`00
0?mX0?ooobX0o`009@000?l>003o0<<0oooo001e0?ooo`030000003oool0oooo00H0ooooAP3o000<
003o00T0003oJP3ooolY0?l002H0003o3000o`350?ooo`00M@3oool00`000000oooo0?ooo`060?oo
odP0o`002@00o`080000of`0oooo:03o000X0000o`T00?l0a`3oool007D0oooo00<000000?ooo`3o
ool01P3ooom:0?l000L00?l01P000?m_0?ooobL0o`00:0000?l7003o0<T0oooo001e0?ooo`030000
003oool0oooo00H0ooooC03o0005003o00@0003oL@3ooolV0?l002T0003o1@00o`3;0?ooo`00M@3o
ool00`000000oooo0?ooo`070?ooodd0o`000`00o`020000og<0oooo9@3o000Z0000o`<00?l0c@3o
ool007D0oooo00<000000?ooo`3oool01`3ooom?0?l007H0oooo903o000[0000om00oooo001e0?oo
o`030000003oool0oooo00L0ooooC@3o001i0?ooob<0o`00:@000?oB0?ooo`00M@3oool00`000000
oooo0?ooo`070?oood/0o`00N`3ooolR0?l002P0003oe03oool007D0oooo00<000000?ooo`3oool0
203ooom80?l007d0oooo8@3o000W0000omH0oooo001e0?ooo`030000003oool0oooo00P0ooooAP3o
001o0?ooob00o`009P000?oH0?ooo`00M@3oool00`000000oooo0?ooo`080?oood@0o`00PP3ooolN
0?l002D0003ofP3oool007D0oooo00<000000?ooo`3oool0203ooom20?l008@0oooo7P3o000S0000
om`0oooo001e0?ooo`030000003oool0oooo00P0oooo@03o00260?oooad0o`008P000?oN0?ooo`00
M@3oool00`000000oooo0?ooo`090?ooocd0o`00R03ooolL0?l00240003oh03oool007D0oooo00<0
00000?ooo`3oool02@3ooolk0?l008X0oooo6`3o000P0000on80oooo001e0?ooo`030000003oool0
oooo00T0oooo>@3o002=0?oooaT0o`007`000?oT0?ooo`00M@3oool00`000000oooo0?ooo`090?oo
ocL0o`00S`3ooolI0?l001d0003oiP3oool007D0oooo00<000000?ooo`3oool02@3ooole0?l00940
oooo603o000L0000onP0oooo001e0?ooo`030000003oool0oooo00X0oooo<P3o002C0?oooaL0o`00
6`000?oZ0?ooo`00M@3oool00`000000oooo0?ooo`0:0?oooc00o`00UP3ooolE0?l001X0003ok03o
ool007D0oooo00<000000?ooo`3oool02P3oool^0?l009P0oooo503o000I0000onh0oooo001e0?oo
o`030000003oool0oooo00X0oooo;03o002J0?oooa@0o`005`000?o`0?ooo`00M@3oool00`000000
oooo0?ooo`0;0?ooobT0o`00W03ooolC0?l001H0003olP3oool007D0oooo00<000000?ooo`3oool0
2`3ooolV0?l00:00oooo4@3o000E0000oo@0oooo001e0?ooo`030000003oool0oooo00/0oooo903o
002R0?oooa00o`0050000?of0?ooo`00M@3oool00`000000oooo0?ooo`0;0?ooob80o`00Y03oool?
0?l001<0003on03oool007D0oooo00<000000?ooo`3oool02`3ooolP0?l00:H0oooo3`3o000A0000
ooX0oooo001e0?ooo`030000003oool0oooo00`0oooo7@3o002X0?ooo`h0o`0040000?ol0?ooo`00
M@3oool00`000000oooo0?ooo`0<0?oooa/0o`00Z`3oool<0?l000l0003ooP3oool007D0oooo00<0
00000?ooo`3oool0303ooolI0?l00:d0oooo2`3o000>0000ool0oooo0@3oool007D0oooo00<00000
0?ooo`3oool0303ooolG0?l00:l0oooo2P3o000=0000ool0oooo0`3oool007D0oooo00<000000?oo
o`3oool03@3ooolD0?l00;40oooo2P3o000;0000ool0oooo1@3oool007D0oooo00<000000?ooo`3o
ool03@3ooolB0?l00;@0oooo203o000:0000ool0oooo1`3oool007D0oooo00<000000?ooo`3oool0
3@3oool@0?l00;H0oooo1`3o00090000ool0oooo2@3oool007D0oooo00<000000?ooo`3oool03@3o
ool>0?l00;P0oooo1P3o00080000ool0oooo2`3oool007D0oooo00<000000?ooo`3oool03@3oool<
0?l00;X0oooo1@3o00070000ool0oooo3@3oool007D0oooo00<000000?ooo`3oool03P3oool90?l0
0;d0oooo103o00050000ool0oooo3`3oool007D0oooo00<000000?ooo`3oool03P3oool70?l00;l0
oooo0`3o00040000ool0oooo4@3oool007D0oooo00<000000?ooo`3oool03P3oool50?l00<40oooo
0P3o00030000ool0oooo4`3oool007D0oooo00<000000?ooo`3oool03P3oool30?l00<<0oooo00<0
o`000000o`000?l0o`3ooolE0?ooo`00M@3oool00`000000oooo0?ooo`3o0?ooon`0oooo001e0?oo
o`030000003oool0oooo0?l0ooook03oool007D0oooo00<000000?ooo`3oool0o`3oooo/0?ooo`00
o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?oo
ofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o
0?ooool0ooooI@3oool00:X0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?oo
o`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0Q0?oo
o`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?oo
o`030000003oool0oooo0:h0oooo002Z0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3o
ool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`2^0?ooo`00ZP3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool0[P3oool00:/0oooo00<000000?ooo`3oool06`3o
ool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3o
ool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3o
ool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0:d0oooo002X0?ooo`040000003oool0
oooo000001X0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00000J0?ooo`04
0000003oool0oooo000001X0oooo00@000000?ooo`3oool00000803oool010000000oooo0?ooo`00
000P0?ooo`040000003oool0oooo00000200oooo00@000000?ooo`3oool00000803oool010000000
oooo0?ooo`00002_0?ooo`00Z03oool4000001X0oooo1000000J0?ooo`@000006P3oool4000001X0
oooo1000000P0?ooo`@00000803oool400000200oooo1000000P0?ooo`@00000[`3oool00?l0oooo
o`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?oo
o`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool009l0oooo00<000000?ooo`3oool0o`3o
oolQ0?ooo`030000003oool0oooo09h0oooo002N0?ooo`030000003oool0oooo01X0oooo00<00000
0?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<00000
0?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<00000
0?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo09d0oooo002N0?oo
o`030000003oool0oooo01X0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?oo
o`030000003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?oo
o`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?oo
o`030000003oool0oooo09d0oooo002N0?ooo`040000003oool0oooo0?ooo`@000000P3oool40000
0080oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool40000
00@0oooo00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool40000
00@0oooo00<000000?ooo`3oool01`3oool400000080oooo100000040?ooo`030000003oool0oooo
00L0oooo100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo
00L0oooo100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo
00L0oooo100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo
00L0oooo100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo
00L0oooo100000020?ooo`@000000P3oool400000080oooo100000030?ooo`030000003oool0oooo
09d0oooo002M0?ooo`030000003oool0oooo0?l0oooo9@3oool00`000000oooo0?ooo`2L0?ooo`00
WP3oool00`000000oooo0?ooo`3o0?ooob<0oooo00<000000?ooo`3oool0W@3oool009h0oooo00<0
00000?ooo`3oool0o`3ooolS0?ooo`030000003oool0oooo09d0oooo002O0?ooo`030000003oool0
oooo0?l0oooo8@3oool00`000000oooo0?ooo`2N0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0
ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool0
0?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002S0?ooo`800000203oool3000000D0oooo
0`00000=0?ooo`<000001@3oool3000000l0oooo0P0000080?ooo`<000001@3oool3000000d0oooo
0`0000050?ooo`<00000403oool3000000H0oooo0`0000050?ooo`<000003P3oool4000000L0oooo
0`0000050?ooo`<000003P3oool4000000L0oooo0`0000050?ooo`<000003P3oool4000000L0oooo
0`0000050?ooo`<000003`3oool2000000P0oooo0`0000050?ooo`<00000X`3oool00:80oooo00@0
00000?ooo`3oool00000203oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool03@3oool010000000oooo0?ooo`0000080?ooo`030000003oool0oooo
00D0oooo00<000000?ooo`3oool0XP3oool00:@0oooo00<000000?ooo`3oool01`3oool3000000D0
oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03`3oool00`000000
oooo0?ooo`070?ooo`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`000000
oooo0?ooo`0=0?ooo`D000001`3oool3000000D0oooo00<000000?ooo`3oool03P3oool00`000000
oooo0?ooo`080?ooo`<000001@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0
oooo0`0000050?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool3000000D0
oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`070?ooo`<000001@3oool00`000000
oooo0?ooo`2R0?ooo`00Y@3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo000000<0
oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000B0?ooo`030000003oool0oooo
00H0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3o
ool2000000l0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`0000030?ooo`80
00004@3oool00`000000oooo0?ooo`070?ooo`040000003oool0oooo000000<0oooo0P00000A0?oo
o`030000003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool200000140oooo00<00000
0?ooo`3oool01`3oool010000000oooo0?ooo`0000030?ooo`8000004P3oool00`000000oooo0?oo
o`060?ooo`040000003oool0oooo000000<0oooo0P00002T0?ooo`00XP3oool010000000oooo0?oo
o`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000503oool01000
0000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000
5@3oool00`000000oooo000000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000000P0oooo00@0
00000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo0000
01@0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00002Y0?ooo`00X`3oool2
000000P0oooo100000050?ooo`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0
oooo00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool0
0`000000oooo0?ooo`0?0?ooo`8000001`3oool4000000D0oooo00<000000?ooo`3oool03P3oool2
000000P0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool0
0`000000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool03P3oool2
000000P0oooo100000050?ooo`030000003oool0oooo0:80oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 610.625}, {125.375, 0}} -> {-0.621763, -0.0103329, \
0.00531182, 0.00531182}, {{117, 296.313}, {123.375, 45.625}} -> {-1.97905, \
-0.0201154, 0.0100557, 0.0100557}, {{314.25, 493.563}, {123.375, 45.625}} -> \
{-3.96254, -0.0201154, 0.0100557, 0.0100557}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .15472 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0036839 0.47619 [
[.5 .16722 -134 0 ]
[.5 .16722 134 38.75 ]
[ 0 0 0 0 ]
[ 1 .15472 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00368 m
1 .00368 L
s
.02381 0 m
.02381 .15472 L
s
gsave
.5 .16722 -195 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(Pi) show
153.000 12.750 moveto
(Pi) show
177.000 12.750 moveto
(3) show
189.000 12.750 moveto
(Pi) show
213.000 12.750 moveto
(3) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(Pi) show
273.000 12.750 moveto
(Pi) show
297.000 12.750 moveto
(3) show
309.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
153.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
165.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
177.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
189.000 25.875 moveto
(--) show
201.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
213.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
225.000 25.875 moveto
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
273.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
285.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
297.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
309.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
321.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(10) show
129.000 39.000 moveto
(2) show
153.000 39.000 moveto
(10) show
183.000 39.000 moveto
(5) show
219.000 39.000 moveto
(10) show
249.000 39.000 moveto
(5) show
273.000 39.000 moveto
(2) show
303.000 39.000 moveto
(10) show
315.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .15472 L
0 .15472 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0036839 0.477324 0.15104 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.236068 0.763932 1.77538e-018 0.763932 [
[ 0 0 0 0 ]
[ 1 .32492 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .32492 L
0 .32492 L
closepath
clip
newpath
0 1 0 r
.10557 0 m
.6 0 L
.55279 .14531 L
F
0 0 1 r
.6 0 m
1 0 L
.55279 .14531 L
F
1 0 0 r
.10557 0 m
.55279 .14531 L
0 .32492 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.0036839 0.97619 0.15104 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.236068 0.763932 -1.04626e-017 0.763932 [
[ 0 0 0 0 ]
[ 1 .32492 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .32492 L
0 .32492 L
closepath
clip
newpath
0 1 0 r
.23607 0 m
1 0 L
.30902 .22451 L
F
0 0 1 r
0 .32492 m
.10557 0 L
.23607 0 L
F
1 0 0 r
.23607 0 m
.30902 .22451 L
0 .32492 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.125, 94.5625},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000GR000`400?l00000o`00003oU03oool0
0`000000oooo0?ooo`3o0?ooold0oooo002=0?ooool00000B@00002>0?ooo`00U03oool00`000000
oooo0?ooo`0=0?ooo`@0o`00AP00o`0h0000ob80oooo4`000?l00`3o00000?l0003o001/003o09T0
oooo002D0?ooo`030000003oool0oooo00d0oooo1`3o0013003o03D0003o9@3ooolB0000o`80o`00
J`00o`2L0?ooo`00U03oool00`000000oooo0?ooo`0<0?ooo`/0o`00@000o`0b0000obL0oooo4P00
0?l30?l006P00?l0W`3oool009@0oooo00<000000?ooo`3oool0303oool>0?l003`00?l0<0000?lZ
0?oooa80003o103o001T003o0:80oooo002D0?ooo`030000003oool0oooo00`0oooo4@3o000i003o
02d0003o;@3ooolA0000o`D0o`00H@00o`2U0?ooo`00U03oool00`000000oooo0?ooo`0;0?oooaD0
o`00=P00o`0Z0000obl0oooo4@000?l60?l005h00?l0Z03oool009@0oooo00<000000?ooo`3oool0
2`3ooolH0?l003800?l0:0000?lb0?oooa00003o203o001J003o0:/0oooo002D0?ooo`030000003o
ool0oooo00/0oooo6`3o000_003o02D0003o=@3oool@0000o`P0o`00E`00o`2^0?ooo`00U03oool0
0`000000oooo0?ooo`0:0?oooal0o`00;000o`0R0000ocL0oooo40000?l90?l005@00?l0/@3oool0
09@0oooo00<000000?ooo`3oool02P3ooolR0?l002P00?l080000?lj0?ooo`l0003o2`3o001@003o
0;@0oooo002D0?ooo`030000003oool0oooo00X0oooo9@3o000U003o01d0003o?@3oool>0000o``0
o`00C@00o`2g0?ooo`00U03oool00`000000oooo0?ooo`090?ooobT0o`008P00o`0J0000ocl0oooo
3`000?l<0?l004X00?l0^P3oool009@0oooo00<000000?ooo`3oool02@3oool/0?l001h00?l06000
0?m20?ooo`h0003o3P3o0016003o0;d0oooo002D0?ooo`030000003oool0oooo00T0oooo;`3o000K
003o01D0003oA@3oool=0000o`l0o`00@`00o`300?ooo`00U03oool00`000000oooo0?ooo`080?oo
oc<0o`006000o`0B0000odL0oooo3P000?l?0?l004000?l0``3oool009@0oooo00<000000?ooo`3o
ool0203ooolf0?l001@00?l040000?m:0?ooo`d0003o4@3o000l003o0<H0oooo002D0?ooo`030000
003oool0oooo00P0oooo>@3o000A003o00d0003oC@3oool<0000oa80o`00>@00o`390?ooo`00U03o
ool00`000000oooo0?ooo`070?ooocd0o`003P00o`0:0000odl0oooo30000?lC0?l003H00?l0c03o
ool009@0oooo00<000000?ooo`3oool01`3ooom00?l000X00?l020000?mB0?ooo``0003o503o000b
003o0<l0oooo002D0?ooo`030000003oool0oooo00L0oooo@`3o0007003o00D0003oE@3oool;0000
oaD0o`00;`00o`3B0?ooo`00U03oool00`000000oooo0?ooo`060?ooodL0o`001000o`020000oeL0
oooo2`000?lF0?l002`00?l0e@3oool009@0oooo00<000000?ooo`3oool01P3ooom:0?l005X0oooo
2P000?lH0?l002P00?l0f03oool009@0oooo00<000000?ooo`3oool01P3ooom70?l005d0oooo2P00
0?lH0?l002D00?l0f`3oool009@0oooo00<000000?ooo`3oool01@3ooom50?l005l0oooo2P000?lI
0?l002800?l0gP3oool009@0oooo00<000000?ooo`3oool01@3ooom20?l00680oooo2@000?lK0?l0
01h00?l0h@3oool009@0oooo00<000000?ooo`3oool01@3ooolo0?l006D0oooo2@000?lK0?l001/0
0?l0i03oool009@0oooo00<000000?ooo`3oool0103ooolm0?l006L0oooo2@000?lL0?l001P00?l0
i`3oool009@0oooo00<000000?ooo`3oool0103oooli0?l006/0oooo20000?lN0?l001@00?l0jP3o
ool009@0oooo00<000000?ooo`3oool0103ooolf0?l006h0oooo1`000?lO0?l001400?l0k@3oool0
09@0oooo00<000000?ooo`3oool00`3ooold0?l00700oooo20000?lO0?l000h00?l0l03oool009@0
oooo00<000000?ooo`3oool00`3ooola0?l007<0oooo1`000?lQ0?l000X00?l0l`3oool009@0oooo
00<000000?ooo`3oool00`3oool^0?l007H0oooo1P000?lR0?l000L00?l0mP3oool009@0oooo00<0
00000?ooo`3oool00P3oool[0?l007T0oooo1P000?lS0?l000@00?l0n@3oool009@0oooo00<00000
0?ooo`3oool00P3ooolX0?l007`0oooo1P000?lS0?l00?d0oooo002D0?ooo`030000003oool0oooo
0080oooo9@3o001o0?ooo`D0003o8@3o003o0?ooo`40oooo002D0?ooo`040000003oool0oooo0?oo
ob<0o`00P@3oool50000oal0o`00o`3oool40?ooo`00U03oool010000000oooo0?ooo`3ooolP0?l0
08@0oooo1@000?lL0?l00?l0oooo1`3oool009@0oooo00@000000?ooo`3oool0oooo703o00280?oo
o`@0003o6@3o003o0?ooo`/0oooo002D0?ooo`030000003oool0oooo01X0o`00RP3oool40000oaL0
o`00o`3oool>0?ooo`00U03oool00`000000oooo0?ooo`0G0?l008d0oooo0`000?lE0?l00?l0oooo
4@3oool009@0oooo00<000000?ooo`3oool0503o002@0?ooo`<0003o4@3o003o0?oooaD0oooo002D
0?ooo`030000003oool0o`000140o`00TP3oool30000o`l0o`00o`3ooolH0?ooo`00U03oool00`00
0000oooo0?l0000=0?l009H0oooo0P000?l=0?l00?l0oooo6`3oool009@0oooo00<000000?ooo`3o
00002P3o002I0?ooo`030000o`3o0000o`0000T0o`00o`3ooolN0?ooo`00U03oool00`000000o`00
0?l000070?l009/0oooo0P000?l70?l00?l0oooo8P3oool009@0oooo00<000000?l0003o0000103o
002N0?ooo`030000o`3o0000o`0000<0o`00o`3ooolU0?ooo`00U03oool010000000o`000?l0003o
002Q0?ooo`<0o`00o`3ooolX0?ooo`00U03oool00`000000oooo0?ooo`3o0?ooold0oooo002D0?oo
o`030000003oool0oooo0?l0ooooc@3oool009@0oooo00<000000?ooo`3oool0o`3oooo=0?ooo`00
o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?oo
ofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002k
0?ooo`8000006`3oool500000080oooo0P00000?0?ooo`@00000503oool500000080oooo0P00000F
0?ooo`8000008@3oool500000080oooo0P00000F0?ooo`8000005@3oool4000001X0oooo1@000002
0?ooo`800000_03oool00;X0oooo00@000000?ooo`3oool00000703oool01@000000oooo0?ooo`3o
ool000000080oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0G0?ooo`050000003o
ool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0B0?ooo`040000003oool0oooo00000280
oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo0180oooo00@000000?oo
o`3oool00000503oool00`000000oooo0?ooo`0M0?ooo`050000003oool0oooo0?ooo`0000000P3o
ool00`000000oooo0?ooo`2i0?ooo`00_@3oool00`000000oooo0?ooo`0J0?ooo`050000003oool0
oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo01H0oooo00D0
00000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
803oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool05@3oool00`000000
oooo0?ooo`0C0?ooo`030000003oool0oooo01`0oooo00D000000?ooo`3oool0oooo000000020?oo
o`030000003oool0oooo0;T0oooo002k0?ooo`8000007@3oool01@000000oooo0?ooo`3oool00000
0080oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0E0?ooo`050000003oool0oooo
0?ooo`0000000P3oool00`000000oooo0?ooo`0C0?ooo`8000008`3oool01@000000oooo0?ooo`3o
ool000000080oooo00<000000?ooo`3oool04`3oool2000001L0oooo00<000000?ooo`3oool06`3o
ool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool0^@3oool00;/0oooo00<0
00000?ooo`3oool0703oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool0
303oool010000000oooo0?ooo`00000F0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`00
0000oooo0?ooo`0C0?ooo`030000003oool0oooo0280oooo00D000000?ooo`3oool0oooo00000002
0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0503oool010000000oooo0?ooo`00
000L0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`2i0?ooo`00^`3o
ool3000001/0oooo0P0000040?ooo`800000403oool2000001H0oooo0P0000040?ooo`8000005P3o
ool300000240oooo0P0000040?ooo`8000005P3oool3000001D0oooo0P00000L0?ooo`800000103o
ool200000;`0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002a0?oo
o`030000003oool0oooo0?`0oooo00<000000?ooo`3oool0/03oool00;00oooo00<000000?ooo`3o
ool06P3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool0[`3oool00;00oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool0[`3oool00;00oooo00@000000?ooo`3oool0oooo
100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000<0oooo
00<000000?ooo`3oool0[`3oool00:l0oooo00<000000?ooo`3oool0o`3oool10?ooo`030000003o
ool0oooo0:h0oooo002`0?ooo`030000003oool0oooo0?h0oooo00<000000?ooo`3oool0[`3oool0
0;00oooo00<000000?ooo`3oool0oP3oool00`000000oooo0?ooo`2_0?ooo`00/@3oool00`000000
oooo0?ooo`3l0?ooo`030000003oool0oooo0;00oooo003o0?ooool0ooooI@3oool00?l0ooooo`3o
oomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00
o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00;@0oooo100000070?ooo`<000001@3oool3
000000d0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000=0?ooo`<000001@3oool3
000000l0oooo0P0000080?ooo`<000001@3oool3000000l0oooo0P0000080?ooo`<000001@3oool3
000000d0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000?0?ooo`800000203oool3
000000D0oooo0`00002e0?ooo`00]03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo
00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo
00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo
00D0oooo00<000000?ooo`3oool03@3oool010000000oooo0?ooo`0000080?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool03@3oool010000000oooo0?ooo`0000080?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003o
ool0oooo000000P0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`2d0?ooo`00]@3o
ool00`000000oooo0?ooo`080?ooo`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3o
ool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3o
ool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo00L0oooo0`0000050?ooo`030000003o
ool0oooo00l0oooo00<000000?ooo`3oool01`3oool3000000D0oooo00<000000?ooo`3oool03@3o
ool3000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03`3o
ool00`000000oooo0?ooo`070?ooo`<000001@3oool00`000000oooo0?ooo`2d0?ooo`00]P3oool0
0`000000oooo0?ooo`070?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003o
ool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`04
0000003oool0oooo000000<0oooo0P00000B0?ooo`030000003oool0oooo00H0oooo00@000000?oo
o`3oool000000`3oool200000180oooo00<000000?ooo`3oool01P3oool010000000oooo0?ooo`00
00030?ooo`8000003`3oool010000000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo
0?ooo`0000030?ooo`8000004P3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
00<0oooo0P00002f0?ooo`00]03oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo
000001@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00000D0?ooo`040000
003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00000D
0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000503oool010000000oooo
0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool0
10000000oooo0?ooo`00002k0?ooo`00]@3oool2000000P0oooo100000050?ooo`030000003oool0
oooo00`0oooo100000050?ooo`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0
oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool0
0`000000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool0303oool4
000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<000000?ooo`3oool03P3oool2
000000P0oooo100000050?ooo`030000003oool0oooo0;@0oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 610.125}, {93.5625, 0}} -> {-0.954435, -0.00773795, \
0.00640667, 0.00640667}, {{148.938, 297.625}, {92.3125, 44}} -> {-1.62025, \
-0.0110112, 0.0088039, 0.0088039}, {{312.438, 461.125}, {92.3125, 44}} -> \
{-3.05969, -0.0110112, 0.0088039, 0.0088039}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .16569 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00394499 0.47619 [
[.5 .17819 -146 0 ]
[.5 .17819 146 38.75 ]
[ 0 0 0 0 ]
[ 1 .16569 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00394 m
1 .00394 L
s
.02381 0 m
.02381 .16569 L
s
gsave
.5 .17819 -207 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(2) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(3) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(3) show
237.000 12.750 moveto
(Pi) show
261.000 12.750 moveto
(2) show
273.000 12.750 moveto
(Pi) show
297.000 12.750 moveto
(Pi) show
321.000 12.750 moveto
(4) show
333.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
(--) show
249.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
261.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
273.000 25.875 moveto
(--) show
285.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
297.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
309.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
321.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
333.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
345.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
105.000 39.000 moveto
(7) show
135.000 39.000 moveto
(7) show
165.000 39.000 moveto
(7) show
195.000 39.000 moveto
(7) show
231.000 39.000 moveto
(7) show
267.000 39.000 moveto
(7) show
297.000 39.000 moveto
(7) show
327.000 39.000 moveto
(7) show
333.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .16569 L
0 .16569 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00394499 0.477324 0.161744 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.198062 0.801938 1.12079e-017 0.801938 [
[ 0 0 0 0 ]
[ 1 .34795 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .34795 L
0 .34795 L
closepath
clip
newpath
0 1 0 r
0 0 m
.44504 0 L
.5 .24079 L
F
0 0 1 r
.44504 0 m
1 0 L
.5 .24079 L
F
1 0 0 r
0 0 m
.5 .24079 L
.27748 .34795 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00394499 0.97619 0.161744 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.198062 0.801938 1.12079e-017 0.801938 [
[ 0 0 0 0 ]
[ 1 .34795 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .34795 L
0 .34795 L
closepath
clip
newpath
0 1 0 r
.19806 0 m
1 0 L
.42058 .27903 L
F
0 0 1 r
.19806 0 m
.42058 .27903 L
.27748 .34795 L
F
1 0 0 r
.27748 .34795 m
0 0 L
.19806 0 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.438, 101.313},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000IB000`400?l00000o`00003oS03oool0
0`000000oooo0?ooo`3o0?ooomD0oooo002<0?ooo`030000003oool0oooo0?l0ooooe@3oool008@0
ooooo`00001K000008D0oooo002<0?ooo`030000003o0000o`0004@00?l0E0000?lC0?oooal0o`00
NP00o`2@0?ooo`00S03oool00`000000oooo0?l000020?l004800?l0DP000?lF0?oooah0o`0000<0
003o003o0000o`00M@00o`2B0?ooo`00S03oool00`000000oooo0?ooo`040?l004000?l0D0000?lI
0?oooad0o`000P000?md003o09@0oooo002<0?ooo`040000003oool0oooo0?ooo`D0o`00?P00o`1>
0000oa`0oooo703o00030000og400?l0UP3oool008`0oooo00<000000?ooo`3oool00P3oool60?l0
03d00?l0B`000?lN0?oooad0o`000P000?m_003o09P0oooo002<0?ooo`030000003oool0oooo0080
oooo203o000k003o04T0003o8@3ooolL0?l000<0003oK000o`2J0?ooo`00S03oool00`000000oooo
0?ooo`030?ooo`T0o`00>@00o`170000ob@0oooo6`3o00040000ofT00?l0W03oool008`0oooo00<0
00000?ooo`3oool0103oool;0?l003H00?l0A@000?lW0?oooaX0o`001@000?mV003o09h0oooo002<
0?ooo`030000003oool0oooo00D0oooo303o000e003o0480003o:P3ooolI0?l000H0003oHP00o`2Q
0?ooo`00S03oool00`000000oooo0?ooo`060?ooo`d0o`00<`00o`0o0000obd0oooo6P3o00050000
of000?l0X`3oool008`0oooo00<000000?ooo`3oool01P3oool?0?l003400?l0?@000?l`0?oooaT0
o`001P000?mM003o0:D0oooo002<0?ooo`030000003oool0oooo00L0oooo403o000_003o03/0003o
<`3ooolH0?l000L0003oFP00o`2W0?ooo`00S03oool00`000000oooo0?ooo`080?oooa40o`00;P00
o`0h0000ocH0oooo5`3o00080000oeL00?l0Z@3oool008`0oooo00<000000?ooo`3oool02@3ooolB
0?l002`00?l0=P000?li0?oooaL0o`0020000?mD003o0:/0oooo002<0?ooo`030000003oool0oooo
00X0oooo503o000Y003o03@0003o>`3ooolG0?l000P0003oDP00o`2]0?ooo`00S03oool00`000000
oooo0?ooo`0;0?oooaD0o`009`00o`0b0000och0oooo5P3o00090000odl00?l0[`3oool008`0oooo
00<000000?ooo`3oool02`3ooolG0?l002H00?l0;`000?m10?oooaD0o`002P000?m<003o0;40oooo
002<0?ooo`030000003oool0oooo00`0oooo603o000T003o02d0003oA03ooolD0?l000/0003oB000
o`2d0?ooo`00S03oool00`000000oooo0?ooo`0=0?oooaT0o`008P00o`0Z0000odP0oooo503o000;
0000odD00?l0]P3oool008`0oooo00<000000?ooo`3oool03P3ooolJ0?l002000?l0:0000?m:0?oo
oa@0o`002`000?m3003o0;P0oooo002<0?ooo`030000003oool0oooo00l0oooo6`3o000O003o02D0
003oC@3ooolC0?l000`0003o@000o`2j0?ooo`00S03oool00`000000oooo0?ooo`0?0?oooad0o`00
7@00o`0S0000oe00oooo4P3o000=0000ocd00?l0_03oool008`0oooo00<000000?ooo`3oool0403o
oolO0?l001X00?l08@000?mC0?oooa80o`003@000?lj003o0;h0oooo002<0?ooo`030000003oool0
oooo0140oooo803o000H003o01l0003oEP3ooolA0?l000d0003o>000o`300?ooo`00S03oool00`00
0000oooo0?ooo`0B0?ooob40o`005`00o`0L0000oeP0oooo4@3o000>0000ocD00?l0`P3oool008`0
oooo00<000000?ooo`3oool04`3ooolR0?l001D00?l06P000?mK0?oooa00o`003`000?la003o0<D0
oooo002<0?ooo`030000003oool0oooo01<0oooo903o000C003o01P0003oGP3oool?0?l00100003o
;P00o`370?ooo`00S03oool00`000000oooo0?ooo`0D0?ooobD0o`004@00o`0E0000of80oooo3`3o
000@0000ob/00?l0b@3oool008`0oooo00<000000?ooo`3oool05@3ooolV0?l001000?l04P000?mU
0?ooo`h0o`0040000?lY003o0</0oooo002<0?ooo`030000003oool0oooo01H0oooo:03o000=003o
0100003oI`3oool>0?l00140003o9P00o`3=0?ooo`00S03oool00`000000oooo0?ooo`0G0?ooobT0
o`002`00o`0>0000ofX0oooo3@3o000B0000ob<00?l0c`3oool008`0oooo00<000000?ooo`3oool0
603ooolZ0?l000T00?l030000?m]0?ooo`d0o`004P000?lP003o0=40oooo002<0?ooo`030000003o
ool0oooo01P0oooo;03o0008003o00T0003oL03oool<0?l001<0003o7@00o`3C0?ooo`00S03oool0
0`000000oooo0?ooo`0I0?ooobd0o`001P00o`070000og<0oooo2`3o000C0000oa/00?l0e@3oool0
08`0oooo00<000000?ooo`3oool06P3oool^0?l000@00?l01@000?me0?ooo`/0o`0050000?lG003o
0=P0oooo002<0?ooo`030000003oool0oooo01/0oooo;`3o0002003o00<0003oN03oool:0?l001D0
003o5000o`3J0?ooo`00S03oool00`000000oooo0?ooo`0L0?oooc00o`00O03oool:0?l001D0003o
4@00o`3L0?ooo`00S03oool00`000000oooo0?ooo`0L0?ooobh0o`00O`3oool90?l001H0003o3P00
o`3N0?ooo`00S03oool00`000000oooo0?ooo`0M0?ooob/0o`00PP3oool80?l001H0003o3000o`3P
0?ooo`00S03oool00`000000oooo0?ooo`0N0?ooobP0o`00Q03oool80?l001L0003o2@00o`3R0?oo
o`00S03oool00`000000oooo0?ooo`0O0?ooobD0o`00Q`3oool80?l001L0003o1P00o`3T0?ooo`00
S03oool00`000000oooo0?ooo`0P0?ooob80o`00RP3oool70?l001P0003o0`00o`3V0?ooo`00S03o
ool00`000000oooo0?ooo`0Q0?oooal0o`00S@3oool60?l001P0003oj@3oool008`0oooo00<00000
0?ooo`3oool08@3ooolM0?l00900oooo1@3o000F0000on/0oooo002<0?ooo`030000003oool0oooo
0280oooo6P3o002B0?ooo`D0o`0050000?o]0?ooo`00S03oool00`000000oooo0?ooo`0S0?oooaL0
o`00U@3oool50?l00140003ok`3oool008`0oooo00<000000?ooo`3oool0903ooolD0?l009P0oooo
103o000?0000oo40oooo002<0?ooo`030000003oool0oooo02D0oooo4@3o002K0?ooo`<0o`003@00
0?oc0?ooo`00S03oool00`000000oooo0?ooo`0U0?ooo`l0o`00WP3oool20?l000/0003om@3oool0
08`0oooo00<000000?ooo`3oool09P3oool<0?l00:00oooo0`3o00080000ooL0oooo002<0?ooo`03
0000003oool0oooo02L0oooo2@3o002S0?ooo`80o`001P000?oi0?ooo`00S03oool00`000000oooo
0?ooo`0X0?ooo`H0o`00YP3oool00`3o0000003o0000o`020000oo/0oooo002<0?ooo`030000003o
ool0oooo02T0oooo0`3o002Y0?ooo`80003oo@3oool008`0oooo00<000000?ooo`3oool0o`3ooooE
0?ooo`00S03oool00`000000oooo0?ooo`3o0?ooomD0oooo003o0?ooool0ooooI@3oool00?l0oooo
o`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?oo
o`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00/03oool0
0`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool0
0`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool0
0`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0]03oool0
0;00oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo
0240oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
0;@0oooo002`0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`0Q0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`2d0?ooo`00/@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0240oooo
00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool0/`3oool00:h0oooo00@000000?ooo`3oool000006P3oool010000000oooo
0?ooo`00000J0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3oool0
10000000oooo0?ooo`00000P0?ooo`040000003oool0oooo00000200oooo00@000000?ooo`3oool0
00006P3oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo00000;D0oooo002^0?oo
o`@000006P3oool4000001X0oooo1000000J0?ooo`@000006P3oool400000200oooo1000000P0?oo
o`@000006P3oool4000001X0oooo1000002e0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0oooo
I@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00Y@3oool00`000000oooo0?ooo`3o0?oooaD0oooo00<000000?ooo`3oool0
Y03oool00:@0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0E0?ooo`030000003o
ool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003o
ool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000003o
ool0oooo0240oooo00<000000?ooo`3oool0X`3oool00:@0oooo00<000000?ooo`3oool06P3oool0
0`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool05@3oool0
0`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool0
0`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0X`3oool0
0:@0oooo00@000000?ooo`3oool0oooo100000020?ooo`@000000P3oool400000080oooo10000004
0?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`07
0?ooo`@000000P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`07
0?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo10000002
0?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo10000002
0?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo10000002
0?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo10000004
0?ooo`030000003oool0oooo00L0oooo100000020?ooo`@000000P3oool400000080oooo10000003
0?ooo`030000003oool0oooo0:<0oooo002S0?ooo`030000003oool0oooo0?l0oooo6@3oool00`00
0000oooo0?ooo`2R0?ooo`00Y03oool00`000000oooo0?ooo`3o0?oooaL0oooo00<000000?ooo`3o
ool0X`3oool00:@0oooo00<000000?ooo`3oool0o`3ooolG0?ooo`030000003oool0oooo0:<0oooo
002U0?ooo`030000003oool0oooo0?l0oooo5@3oool00`000000oooo0?ooo`2T0?ooo`00o`3ooooo
0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo
003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002Z0?ooo`<0
00001P3oool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000h0oooo100000070?ooo`<0
00001@3oool3000000d0oooo0`0000050?ooo`<000003`3oool2000000P0oooo0`0000050?ooo`<0
00003`3oool2000000P0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`0000050?ooo`<0
00003@3oool3000000D0oooo0`00000@0?ooo`<000001P3oool3000000D0oooo0`00002Y0?ooo`00
Z`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0
3@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0
2@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3o
ool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool0403oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool0Z03oool00:P0oooo1@0000070?ooo`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<0
00001@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?ooo`03
0000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3o
ool01`3oool3000000D0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`070?ooo`<0
00001@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?ooo`03
0000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo00d0oooo1@0000070?ooo`<0
00001@3oool00`000000oooo0?ooo`2X0?ooo`00Z03oool010000000oooo0?ooo`0000080?ooo`04
0000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000A
0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@0
00000?ooo`3oool000000`3oool200000180oooo00<000000?ooo`3oool01P3oool010000000oooo
0?ooo`0000030?ooo`8000004P3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
00<0oooo0P00000A0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool2
000000l0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool00000
203oool010000000oooo0?ooo`0000030?ooo`800000ZP3oool00:T0oooo00<000000?ooo`000000
203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?oo
o`3oool00000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo
00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo
000000P0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000
003oool0oooo000001@0oooo00@000000?ooo`3oool000005@3oool00`000000oooo000000080?oo
o`040000003oool0oooo00000:l0oooo002Z0?ooo`8000001`3oool4000000D0oooo00<000000?oo
o`3oool0303oool4000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo100000050?oo
o`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?oo
o`@000001@3oool00`000000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?oo
o`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo00`0oooo100000050?oo
o`030000003oool0oooo00l0oooo0P0000070?ooo`@000001@3oool00`000000oooo0?ooo`2X0?oo
o`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00001\
\>"],
  ImageRangeCache->{{{0, 610.438}, {100.313, 0}} -> {-0.855249, -0.00828636, \
0.00607843, 0.00607843}, {{140.688, 297.375}, {98.9375, 44.375}} -> \
{-1.36664, -0.0111165, 0.00795846, 0.00795846}, {{313, 469.688}, {98.9375, \
44.375}} -> {-2.73798, -0.0111165, 0.00795846, 0.00795846}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(Pi) show
153.000 12.750 moveto
(Pi) show
177.000 12.750 moveto
(2) show
189.000 12.750 moveto
(Pi) show
213.000 12.750 moveto
(2) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(2) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
153.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
165.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
177.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
189.000 25.875 moveto
(--) show
201.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
213.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
225.000 25.875 moveto
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(5) show
129.000 39.000 moveto
(5) show
153.000 39.000 moveto
(5) show
183.000 39.000 moveto
(5) show
219.000 39.000 moveto
(5) show
255.000 39.000 moveto
(5) show
285.000 39.000 moveto
(5) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -2.23075e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.38197 0 L
.5 .36327 L
F
0 0 1 r
.38197 0 m
1 0 L
.5 .36327 L
F
1 0 0 r
0 0 m
.5 .36327 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -1.19262e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.38197 0 m
1 0 L
.69098 .22451 L
F
0 0 1 r
.38197 0 m
.69098 .22451 L
.19098 .58779 L
F
1 0 0 r
.19098 .58779 m
0 0 L
.38197 0 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000Zb000`400?l00000o`00003oF`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?oo
o`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00D03ooooo00000<@00000
D03oool005/0oooo00<000000?l00000o`00C000o`1l0000oaH0ooooC@3o00020000og/00?l0G@3o
ool005/0oooo00<000000?l0003o0000C000o`1k0000oaL0ooooC@3o00030000ogT00?l0GP3oool0
05/0oooo00<000000?l0003o00000P3o001:003o07T0003o6@3ooom=0?l000D0003oM@00o`1P0?oo
o`00F`3oool00`000000oooo0?l000030?l004X00?l0M`000?lK0?oood/0o`001`000?mc003o0640
oooo001K0?ooo`030000003oool0o`0000@0o`00B@00o`1f0000oa`0ooooB`3o00080000og400?l0
HP3oool005/0oooo00<000000?ooo`3o00001P3o0017003o07@0003o7P3ooom;0?l000X0003oK@00
o`1T0?ooo`00F`3oool00`000000oooo0?ooo`070?l004L00?l0LP000?lP0?ooodT0o`0030000?m[
003o06D0oooo001K0?ooo`030000003oool0oooo00T0o`00A@00o`1`0000ob80ooooB@3o000=0000
ofT00?l0IP3oool005/0oooo00<000000?ooo`3oool02P3o0014003o06l0003o8`3ooom90?l000l0
003oI@00o`1X0?ooo`00F`3oool010000000oooo0?ooo`3oool:0?l004@00?l0K@000?lU0?ooodL0
o`004@000?mS003o06T0oooo001K0?ooo`040000003oool0oooo0?ooo``0o`00@P00o`1[0000obL0
ooooA`3o000C0000oel00?l0J`3oool005/0oooo00@000000?ooo`3oool0oooo3@3o0011003o06X0
003o:03ooom70?l001@0003oG@00o`1/0?ooo`00F`3oool00`000000oooo0?ooo`020?ooo`d0o`00
@@00o`1X0000obX0ooooA@3o000F0000oe/00?l0K@3oool005/0oooo00<000000?ooo`3oool00P3o
ool?0?l003l00?l0IP000?l/0?ooodD0o`0060000?mG003o06l0oooo001K0?ooo`030000003oool0
oooo0080oooo403o000n003o06D0003o;@3ooom50?l001T0003oE@00o`1`0?ooo`00F`3oool00`00
0000oooo0?ooo`030?oooa40o`00?@00o`1R0000oc00oooo@`3o000K0000oe<00?l0L@3oool005/0
oooo00<000000?ooo`3oool00`3ooolB0?l003`00?l0H@000?la0?oood<0o`007@000?m?003o07<0
oooo001K0?ooo`030000003oool0oooo00<0oooo4`3o000k003o0600003o<P3ooom30?l001h0003o
C@00o`1d0?ooo`00F`3oool00`000000oooo0?ooo`040?oooa@0o`00>P00o`1M0000ocD0oooo@@3o
000Q0000odT00?l0MP3oool005/0oooo00<000000?ooo`3oool0103ooolE0?l003T00?l0G0000?lf
0?oood40o`008P000?m7003o07L0oooo001K0?ooo`030000003oool0oooo00@0oooo5P3o000h003o
05/0003o=`3ooom10?l002<0003oA@00o`1h0?ooo`00F`3oool00`000000oooo0?ooo`050?oooaL0
o`00=`00o`1H0000ocX0oooo?`3o000V0000od400?l0NP3oool005/0oooo00<000000?ooo`3oool0
1@3ooolH0?l003H00?l0E`000?lk0?ooocl0o`009`000?lo003o07/0oooo001K0?ooo`030000003o
ool0oooo00D0oooo6P3o000d003o05D0003o?@3ooolo0?l002P0003o?@00o`1l0?ooo`00F`3oool0
0`000000oooo0?ooo`060?oooaX0o`00=000o`1C0000ocl0oooo?@3o000[0000ocT00?l0OP3oool0
05/0oooo00<000000?ooo`3oool01P3ooolK0?l003<00?l0DP000?m00?ooocd0o`00;0000?lg003o
07l0oooo001K0?ooo`030000003oool0oooo00H0oooo7@3o000a003o0500003o@P3ooolm0?l002d0
003o=@00o`200?ooo`00F`3oool00`000000oooo0?ooo`070?oooad0o`00<@00o`1>0000od@0oooo
>`3o000`0000oc400?l0PP3oool005/0oooo00<000000?ooo`3oool01`3ooolN0?l003000?l0C@00
0?m50?oooc/0o`00<@000?l_003o08<0oooo001K0?ooo`030000003oool0oooo00L0oooo803o000^
003o04/0003oA`3ooolk0?l003<0003o:`00o`250?ooo`00F`3oool00`000000oooo0?ooo`080?oo
ob00o`00;P00o`190000odT0oooo>@3o000e0000obT00?l0QP3oool005/0oooo00<000000?ooo`3o
ool0203ooolR0?l002`00?l0A`000?m;0?ooocT0o`00=P000?lW003o08L0oooo001K0?ooo`030000
003oool0oooo00P0oooo8`3o000[003o04H0003oC03oooli0?l003P0003o8`00o`290?ooo`00F`3o
ool00`000000oooo0?ooo`090?ooob<0o`00:`00o`140000odh0oooo=`3o000j0000ob400?l0RP3o
ool005/0oooo00<000000?ooo`3oool02@3ooolU0?l002T00?l0@P000?m@0?ooocL0o`00>`000?lO
003o08/0oooo001K0?ooo`030000003oool0oooo00T0oooo9P3o000X003o0440003oD@3ooolg0?l0
03d0003o6`00o`2=0?ooo`00F`3oool00`000000oooo0?ooo`0:0?ooobH0o`009`00o`0o0000oe@0
oooo=@3o000o0000oaT00?l0SP3oool005/0oooo00<000000?ooo`3oool02P3ooolX0?l002H00?l0
?@000?mE0?ooocD0o`00@@000?lE003o0900oooo001K0?ooo`030000003oool0oooo00X0oooo:@3o
000U003o03`0003oEP3ooole0?l00480003o4`00o`2A0?ooo`00F`3oool00`000000oooo0?ooo`0:
0?ooob/0o`008`00o`0j0000oeP0oooo=03o00140000oa400?l0TP3oool005/0oooo00<000000?oo
o`3oool02`3oool[0?l002<00?l0>0000?mJ0?oooc<0o`00AP000?l=003o09@0oooo001K0?ooo`03
0000003oool0oooo00/0oooo;03o000R003o03L0003oF`3ooolc0?l004L0003o2`00o`2E0?ooo`00
F`3oool00`000000oooo0?ooo`0;0?ooobh0o`008000o`0e0000oed0oooo<`3o00180000o`T00?l0
UP3oool005/0oooo00<000000?ooo`3oool0303oool^0?l002000?l0<`000?mO0?oooc40o`00B`00
0?l5003o09P0oooo001K0?ooo`030000003oool0oooo00`0oooo<03o000N003o0340003oH@3ooola
0?l004`0003o0`00o`2I0?ooo`00F`3oool00`000000oooo0?ooo`0<0?oooc40o`007@00o`0`0000
of80oooo<@3o001=0000oi/0oooo001K0?ooo`030000003oool0oooo00d0oooo<@3o000M003o02h0
003oI03oool_0?l004d0003oW03oool005/0oooo00<000000?ooo`3oool03@3ooolc0?l001/00?l0
;0000?mV0?ooobl0o`00C0000?nM0?ooo`00F`3oool00`000000oooo0?ooo`0=0?oooc@0o`006P00
o`0[0000ofL0oooo;`3o001:0000oil0oooo001K0?ooo`030000003oool0oooo00h0oooo=03o000J
003o02T0003oJ@3oool]0?l004X0003oX03oool005/0oooo00<000000?ooo`3oool03P3ooolf0?l0
01P00?l09`000?m[0?ooobd0o`00B@000?nQ0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooocL0
o`005`00o`0V0000of`0oooo;@3o00170000oj<0oooo001K0?ooo`030000003oool0oooo00l0oooo
>03o000F003o02<0003oK`3oool[0?l004L0003oY03oool005/0oooo00<000000?ooo`3oool03`3o
ooli0?l001D00?l08P000?m`0?ooob/0o`00A@000?nV0?ooo`00F`3oool00`000000oooo0?ooo`0?
0?ooocX0o`005000o`0Q0000og40oooo:`3o00140000ojL0oooo001K0?ooo`030000003oool0oooo
0100oooo>`3o000C003o01h0003oM03ooolY0?l004@0003oZ03oool005/0oooo00<000000?ooo`3o
ool0403oooll0?l001800?l07@000?me0?ooobT0o`00@P000?nZ0?ooo`00F`3oool00`000000oooo
0?ooo`0@0?ooocd0o`004@00o`0L0000ogH0oooo:@3o00110000oj/0oooo001K0?ooo`030000003o
ool0oooo0140oooo?P3o000@003o01T0003oN@3ooolW0?l00440003o[03oool005/0oooo00<00000
0?ooo`3oool04@3ooolo0?l000l00?l060000?mj0?ooobL0o`00?`000?n^0?ooo`00F`3oool00`00
0000oooo0?ooo`0A0?oood40o`003@00o`0F0000og`0oooo9`3o000n0000ojl0oooo001K0?ooo`03
0000003oool0oooo0180oooo@@3o000=003o01@0003oOP3ooolU0?l003d0003o/@3oool005/0oooo
00<000000?ooo`3oool04P3ooom20?l000`00?l04`000?mo0?ooobD0o`00?0000?nb0?ooo`00F`3o
ool00`000000oooo0?ooo`0B0?oood@0o`002P00o`0A0000oh40oooo9@3o000k0000ok<0oooo001K
0?ooo`030000003oool0oooo01<0ooooA03o000:003o00l0003oP`3ooolS0?l003X0003o]@3oool0
05/0oooo00<000000?ooo`3oool04`3ooom50?l000T00?l03P000?n40?ooob<0o`00>@000?nf0?oo
o`00F`3oool00`000000oooo0?ooo`0C0?ooodL0o`001`00o`0<0000ohH0oooo8`3o000h0000okL0
oooo001K0?ooo`030000003oool0oooo01@0ooooA`3o0007003o00X0003oR03ooolQ0?l003L0003o
^@3oool005/0oooo00<000000?ooo`3oool0503ooom90?l000D00?l020000?n:0?ooob40o`00=P00
0?nj0?ooo`00F`3oool00`000000oooo0?ooo`0D0?ooodX0o`001000o`070000oh/0oooo8@3o000d
0000ok`0oooo001K0?ooo`030000003oool0oooo01D0ooooBP3o0004003o00D0003oS@3ooolO0?l0
03@0003o_@3oool005/0oooo00<000000?ooo`3oool05@3ooom<0?l000800?l00`000?n?0?oooal0
o`00<`000?nn0?ooo`00F`3oool00`000000oooo0?ooo`0E0?ooodd0o`0000<00?l00000o`000?l0
T03ooolO0?l00340003o`03oool005/0oooo00<000000?ooo`3oool05P3ooom=0?l009<0oooo7@3o
000a0000ol40oooo001K0?ooo`030000003oool0oooo01H0ooooC03o002D0?oooad0o`00<0000?o2
0?ooo`00F`3oool00`000000oooo0?ooo`0F0?oood/0o`00U@3ooolM0?l002h0003oa03oool005/0
oooo00<000000?ooo`3oool05`3ooom80?l009P0oooo6`3o000^0000olD0oooo001K0?ooo`030000
003oool0oooo01L0ooooA`3o002I0?oooa/0o`00;0000?o70?ooo`00F`3oool00`000000oooo0?oo
o`0G0?ooodH0o`00VP3ooolK0?l002/0003ob03oool005/0oooo00<000000?ooo`3oool05`3ooom4
0?l009`0oooo6P3o000[0000olT0oooo001K0?ooo`030000003oool0oooo01P0oooo@P3o002N0?oo
oaT0o`00:@000?o;0?ooo`00F`3oool00`000000oooo0?ooo`0H0?oood40o`00W`3ooolI0?l002P0
003oc03oool005/0oooo00<000000?ooo`3oool0603ooolo0?l00:40oooo6@3o000V0000olh0oooo
001K0?ooo`030000003oool0oooo01T0oooo?@3o002S0?oooaL0o`009P000?o?0?ooo`00F`3oool0
0`000000oooo0?ooo`0I0?oooc/0o`00Y@3ooolG0?l002D0003od03oool005/0oooo00<000000?oo
o`3oool06@3ooolj0?l00:H0oooo5`3o000S0000om80oooo001K0?ooo`030000003oool0oooo01X0
oooo>03o002X0?oooaD0o`008`000?oC0?ooo`00F`3oool00`000000oooo0?ooo`0J0?ooocH0o`00
ZP3ooolE0?l00280003oe03oool005/0oooo00<000000?ooo`3oool06P3ooole0?l00:/0oooo5@3o
000P0000omH0oooo001K0?ooo`030000003oool0oooo01/0oooo<`3o002]0?oooa<0o`0080000?oG
0?ooo`00F`3oool00`000000oooo0?ooo`0K0?oooc40o`00[`3ooolC0?l001h0003of@3oool005/0
oooo00<000000?ooo`3oool06`3oool`0?l00;00oooo4`3o000M0000omX0oooo001K0?ooo`030000
003oool0oooo01`0oooo;@3o002c0?oooa40o`007@000?oK0?ooo`00F`3oool00`000000oooo0?oo
o`0L0?ooob`0o`00]03ooolA0?l001/0003og@3oool005/0oooo00<000000?ooo`3oool0703oool[
0?l00;D0oooo4@3o000J0000omh0oooo001K0?ooo`030000003oool0oooo01d0oooo:03o002h0?oo
o`l0o`006P000?oO0?ooo`00F`3oool00`000000oooo0?ooo`0M0?ooobL0o`00^@3oool?0?l001P0
003oh@3oool005/0oooo00<000000?ooo`3oool07@3ooolV0?l00;X0oooo3`3o000G0000on80oooo
001K0?ooo`030000003oool0oooo01h0oooo8`3o002m0?ooo`d0o`005P000?oT0?ooo`00F`3oool0
0`000000oooo0?ooo`0N0?ooob80o`00_P3oool=0?l001D0003oi@3oool005/0oooo00<000000?oo
o`3oool07P3ooolQ0?l00;l0oooo3@3o000D0000onH0oooo001K0?ooo`030000003oool0oooo01l0
oooo7P3o00320?ooo`/0o`004`000?oX0?ooo`00F`3oool00`000000oooo0?ooo`0O0?oooad0o`00
``3oool;0?l00180003oj@3oool005/0oooo00<000000?ooo`3oool07`3ooolK0?l00<D0oooo2`3o
000A0000onX0oooo001K0?ooo`030000003oool0oooo0200oooo6@3o00370?ooo`T0o`0040000?o/
0?ooo`00F`3oool00`000000oooo0?ooo`0P0?oooaP0o`00b03oool90?l000l0003ok@3oool005/0
oooo00<000000?ooo`3oool0803ooolF0?l00<X0oooo2@3o000=0000onl0oooo001K0?ooo`030000
003oool0oooo0240oooo503o003<0?ooo`L0o`003@000?o`0?ooo`00F`3oool00`000000oooo0?oo
o`0Q0?oooa<0o`00c@3oool70?l000`0003ol@3oool005/0oooo00<000000?ooo`3oool08@3ooolA
0?l00<l0oooo1`3o000:0000oo<0oooo001K0?ooo`030000003oool0oooo0280oooo3`3o003A0?oo
o`D0o`002P000?od0?ooo`00F`3oool00`000000oooo0?ooo`0R0?ooo`d0o`00d`3oool50?l000T0
003om@3oool005/0oooo00<000000?ooo`3oool08P3oool<0?l00=@0oooo1@3o00070000ooL0oooo
001K0?ooo`030000003oool0oooo02<0oooo2P3o003F0?ooo`<0o`001`000?oh0?ooo`00F`3oool0
0`000000oooo0?ooo`0S0?ooo`P0o`00f03oool30?l000D0003onP3oool005/0oooo00<000000?oo
o`3oool08`3oool70?l00=T0oooo0`3o00040000oo/0oooo001K0?ooo`030000003oool0oooo02@0
oooo1@3o003K0?ooo`030?l000000?l0003o0080003oo03oool005/0oooo00<000000?ooo`3oool0
903oool30?l00=d0oooo00<0o`000000o`000?l0oP3oool005/0oooo00<000000?ooo`3oool0903o
ool20?l00=h0oooo00<0o`000000o`3oool0oP3oool005/0oooo00<000000?ooo`3oool0o`3ooooo
0?ooo`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00F`3oool00`000000
oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?ooo`L0oooo
003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0
ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool0
0?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002e0?ooo`800000703oool2000001H0oooo
0P00000F0?ooo`800000703oool200000280oooo0P00000R0?ooo`800000703oool2000001`0oooo
0P00002l0?ooo`00]03oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001@0
oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00000J0?ooo`040000003oool0
oooo00000200oooo00@000000?ooo`3oool00000803oool010000000oooo0?ooo`00000J0?ooo`04
0000003oool0oooo000001X0oooo00@000000?ooo`3oool00000^`3oool00;L0oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0;T0oooo002e0?ooo`80
0000703oool2000001H0oooo0P00000F0?ooo`800000703oool200000280oooo0P00000R0?ooo`80
0000703oool2000001`0oooo0P00002l0?ooo`00]@3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo01/0oooo00<000000?ooo`3oool0^`3oool00;D0oooo0`00000K0?ooo`<000005@3o
ool3000001D0oooo0`00000K0?ooo`<000008@3oool300000240oooo0`00000K0?ooo`<000006`3o
ool300000;/0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002[0?oo
o`030000003oool0oooo0?l0oooo2@3oool00`000000oooo0?ooo`2Z0?ooo`00ZP3oool00`000000
oooo0?ooo`0J0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`000000
oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`2Y0?ooo`00ZP3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo01D0oooo
00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo
00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo
00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`2Y0?ooo`00ZP3oool010000000oooo0?oo
o`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000
103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000
0P3oool400000080oooo100000030?ooo`030000003oool0oooo0:T0oooo002Y0?ooo`030000003o
ool0oooo0?l0oooo3@3oool00`000000oooo0?ooo`2X0?ooo`00ZP3oool00`000000oooo0?ooo`3o
0?ooo`/0oooo00<000000?ooo`3oool0Z@3oool00:X0oooo00<000000?ooo`3oool0o`3oool;0?oo
o`030000003oool0oooo0:T0oooo002[0?ooo`030000003oool0oooo0?l0oooo2@3oool00`000000
oooo0?ooo`2Z0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3o
oooo0?ooofD0oooo002_0?ooo`800000203oool3000000D0oooo0`00000=0?ooo`<000001@3oool3
000000d0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000>0?ooo`@000001`3oool3
000000D0oooo0`00000>0?ooo`@000001`3oool3000000D0oooo0`00000>0?ooo`@000001`3oool3
000000D0oooo0`00000=0?ooo`<000001@3oool3000000h0oooo100000070?ooo`<000001@3oool3
00000:l0oooo002^0?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0[P3oool0
0;00oooo00<000000?ooo`3oool01`3oool3000000D0oooo00<000000?ooo`3oool03@3oool30000
00D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03@3oool30000
00D0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`00
0000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo
00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?ooo`3oool03@3oool30000
00D0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`00
0000oooo0?ooo`2^0?ooo`00/@3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
00<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0
oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000A0?ooo`030000
003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool200000140oooo00<000000?ooo`3o
ool01`3oool010000000oooo0?ooo`0000030?ooo`8000004@3oool00`000000oooo0?ooo`070?oo
o`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00
000A0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool200000;00oooo
002^0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000503oool010000000
oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000503o
ool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000000P0oooo00@0
00000?ooo`3oool00000503oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo0000
00P0oooo00@000000?ooo`3oool00000]@3oool00:l0oooo0P0000080?ooo`@000001@3oool00`00
0000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`00
0000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?ooo`800000203oool40000
00D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo
00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`00
0000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool0[P3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo0000\
\>"],
  ImageRangeCache->{{{0, 610.563}, {170.188, 0}} -> {-0.426205, -0.013998, \
0.00467178, 0.00467178}, {{91.1875, 295.063}, {167.188, 47.3125}} -> \
{-1.34175, -0.0239702, 0.00793648, 0.00793648}, {{315.438, 519.313}, \
{167.188, 47.3125}} -> {-3.12151, -0.0239702, 0.00793648, 0.00793648}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .20661 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00491932 0.47619 [
[.5 .21911 -152 0 ]
[.5 .21911 152 38.75 ]
[ 0 0 0 0 ]
[ 1 .20661 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00492 m
1 .00492 L
s
.02381 0 m
.02381 .20661 L
s
gsave
.5 .21911 -213 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(2) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(3) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(3) show
237.000 12.750 moveto
(Pi) show
261.000 12.750 moveto
(2) show
273.000 12.750 moveto
(Pi) show
297.000 12.750 moveto
(2) show
309.000 12.750 moveto
(Pi) show
333.000 12.750 moveto
(3) show
345.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
(--) show
249.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
261.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
273.000 25.875 moveto
(--) show
285.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
297.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
309.000 25.875 moveto
(--) show
321.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
333.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
345.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
357.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
105.000 39.000 moveto
(7) show
135.000 39.000 moveto
(7) show
165.000 39.000 moveto
(7) show
195.000 39.000 moveto
(7) show
231.000 39.000 moveto
(7) show
267.000 39.000 moveto
(7) show
303.000 39.000 moveto
(7) show
339.000 39.000 moveto
(7) show
345.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .20661 L
0 .20661 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00491932 0.477324 0.201692 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.445042 0.554958 7.61652e-018 0.554958 [
[ 0 0 0 0 ]
[ 1 .43388 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .43388 L
0 .43388 L
closepath
clip
newpath
0 1 0 r
0 0 m
.44504 0 L
.5 .24079 L
F
0 0 1 r
.44504 0 m
1 0 L
.5 .24079 L
F
1 0 0 r
0 0 m
.5 .24079 L
.09903 .43388 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00491932 0.97619 0.201692 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.445042 0.554958 -4.49944e-018 0.554958 [
[ 0 0 0 0 ]
[ 1 .43388 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .43388 L
0 .43388 L
closepath
clip
newpath
0 1 0 r
.44504 0 m
1 0 L
.59903 .1931 L
F
0 0 1 r
.44504 0 m
.59903 .1931 L
.09903 .43388 L
F
1 0 0 r
.09903 .43388 m
0 0 L
.44504 0 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.625, 126.375},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000OR000`400?l00000o`00003oM@3oool0
0`000000oooo0?ooo`3o0?ooon`0oooo001e0?ooo`030000003oool0oooo0?l0ooook03oool006/0
ooooo`00002=000006`0oooo001e0?ooo`030000003o0000o`0004d00?l0H@000?lE0?ooodl0o`00
00<0003o003o0000o`00GP00o`1h0?ooo`00M@3oool00`000000o`000?l000020?l004/00?l0G`00
0?lG0?ooodh0o`000`000?mM003o07X0oooo001e0?ooo`030000003o0000o`0000@0o`00B@00o`1M
0000oaT0ooooC@3o00050000oeX00?l0O03oool007D0oooo00<000000?l0003o00001P3o0017003o
05/0003o6`3ooom<0?l000L0003oE`00o`1n0?ooo`00M@3oool00`000000oooo0?l000080?l004H0
0?l0F0000?lN0?oood/0o`001`000?mE003o0800oooo001e0?ooo`030000003oool0o`0000X0o`00
A000o`1F0000ob00ooooBP3o00090000oe800?l0PP3oool007D0oooo00<000000?ooo`3o0000303o
0012003o05@0003o8P3ooom90?l000/0003oC`00o`240?ooo`00M@3oool00`000000oooo0?l0000>
0?l004000?l0DP000?lT0?ooodP0o`003@000?m<003o08H0oooo001e0?ooo`030000003oool0o`00
0100o`00?`00o`1?0000obL0ooooAP3o000>0000odX00?l0R03oool007D0oooo00<000000?ooo`3o
ool04P3o000m003o04d0003o:@3ooom60?l000l0003oA`00o`2:0?ooo`00M@3oool00`000000oooo
0?ooo`0D0?l003/00?l0BP000?l/0?ooodD0o`004@000?m4003o08`0oooo001e0?ooo`030000003o
ool0oooo01H0o`00>@00o`180000obh0ooooA03o000C0000od400?l0SP3oool007D0oooo00<00000
0?ooo`3oool0603o000h003o04D0003o<03ooom30?l001D0003o?P00o`2@0?ooo`00M@3oool01000
0000oooo0?ooo`3ooolI0?l003H00?l0@`000?lc0?oood40o`005P000?ll003o0980oooo001e0?oo
o`040000003oool0oooo0?oooa`0o`00<`00o`110000ocD0oooo@@3o000G0000ocT00?l0U03oool0
07D0oooo00@000000?ooo`3oool0oooo7P3o000a003o03l0003o=`3ooom00?l001T0003o=P00o`2F
0?ooo`00M@3oool010000000oooo0?ooo`3ooolP0?l002l00?l0?@000?li0?ooocl0o`006`000?lc
003o09P0oooo001e0?ooo`040000003oool0oooo0?ooob80o`00;P00o`0j0000oc`0oooo?@3o000L
0000oc000?l0V`3oool007D0oooo00<000000?ooo`3oool00P3ooolS0?l002`00?l0>0000?ln0?oo
oc`0o`007P000?l]003o09d0oooo001e0?ooo`030000003oool0oooo0080oooo9@3o000Z003o03H0
003o@03oooll0?l001l0003o:P00o`2O0?ooo`00M@3oool00`000000oooo0?ooo`020?ooobL0o`00
:000o`0d0000od80oooo>`3o000Q0000obL00?l0X@3oool007D0oooo00<000000?ooo`3oool00P3o
oolY0?l002L00?l0<0000?m60?ooocT0o`008P000?lU003o0:<0oooo001e0?ooo`030000003oool0
oooo00<0oooo:P3o000U003o02h0003oB03ooolh0?l002@0003o8P00o`2U0?ooo`00M@3oool00`00
0000oooo0?ooo`030?ooob`0o`008`00o`0/0000odX0oooo=`3o000V0000oal00?l0Y`3oool007D0
oooo00<000000?ooo`3oool00`3oool^0?l002400?l0:P000?m<0?ooocL0o`009`000?lL003o0:T0
oooo001e0?ooo`030000003oool0oooo00<0oooo<03o000P003o02L0003oCP3ooolf0?l002T0003o
6@00o`2[0?ooo`00M@3oool00`000000oooo0?ooo`030?oooc80o`007P00o`0U0000oe40oooo=03o
000Z0000oaL00?l0[@3oool007D0oooo00<000000?ooo`3oool0103ooolc0?l001`00?l08`000?mC
0?oooc<0o`00;0000?lD003o0:l0oooo001e0?ooo`030000003oool0oooo00@0oooo=P3o000I003o
0240003oE@3ooolb0?l002h0003o4@00o`2a0?ooo`00M@3oool00`000000oooo0?ooo`040?ooocP0
o`005`00o`0O0000oeL0oooo<P3o000_0000o`h00?l0/`3oool007D0oooo00<000000?ooo`3oool0
103ooolj0?l001H00?l070000?mJ0?oooc00o`00<0000?l<003o0;D0oooo001e0?ooo`030000003o
ool0oooo00@0oooo?03o000D003o01X0003oG03oool_0?l00380003o2@00o`2g0?ooo`00M@3oool0
0`000000oooo0?ooo`050?ooocd0o`004P00o`0G0000oel0oooo;P3o000d0000o`H00?l0^@3oool0
07D0oooo00<000000?ooo`3oool01@3ooolo0?l001000?l05@000?mQ0?ooobd0o`00=P000?l3003o
0;/0oooo001e0?ooo`030000003oool0oooo00D0oooo@@3o000?003o0180003oI03oool/0?l003H0
003o_P3oool007D0oooo00<000000?ooo`3oool01@3ooom30?l000d00?l040000?mV0?ooob/0o`00
=@000?o00?ooo`00M@3oool00`000000oooo0?ooo`060?oood@0o`002`00o`0>0000ofP0oooo:P3o
000d0000ol80oooo001e0?ooo`030000003oool0oooo00H0ooooAP3o0009003o00`0003oJP3ooolY
0?l003<0003oa03oool007D0oooo00<000000?ooo`3oool01P3ooom80?l000P00?l02@000?m/0?oo
obP0o`00<P000?o60?ooo`00M@3oool00`000000oooo0?ooo`060?ooodX0o`001P00o`070000ofl0
oooo9`3o000`0000olP0oooo001e0?ooo`030000003oool0oooo00H0ooooC03o0004003o00D0003o
L@3ooolV0?l002l0003obP3oool007D0oooo00<000000?ooo`3oool01`3ooom=0?l000800?l00`00
0?mc0?ooobD0o`00;P000?o<0?ooo`00M@3oool00`000000oooo0?ooo`070?ooodl0o`00MP3ooolT
0?l002d0003ocP3oool007D0oooo00<000000?ooo`3oool01`3ooom=0?l007T0oooo8`3o000[0000
om00oooo001e0?ooo`030000003oool0oooo00L0ooooB`3o001k0?ooob80o`00:P000?oB0?ooo`00
M@3oool00`000000oooo0?ooo`080?ooodP0o`00O@3ooolQ0?l002T0003oe03oool007D0oooo00<0
00000?ooo`3oool0203ooom60?l007l0oooo803o000X0000omH0oooo001e0?ooo`030000003oool0
oooo00P0ooooA03o00220?oooah0o`009`000?oH0?ooo`00M@3oool00`000000oooo0?ooo`080?oo
od80o`00Q03ooolN0?l002D0003ofP3oool007D0oooo00<000000?ooo`3oool0203ooom00?l008H0
oooo7@3o000S0000omd0oooo001e0?ooo`030000003oool0oooo00T0oooo?@3o00280?oooa`0o`00
8P000?oO0?ooo`00M@3oool00`000000oooo0?ooo`090?oooc/0o`00RP3ooolK0?l00240003oh@3o
ool007D0oooo00<000000?ooo`3oool02@3oooli0?l008d0oooo6@3o000P0000on<0oooo001e0?oo
o`030000003oool0oooo00T0oooo=`3o002?0?oooaT0o`007P000?oU0?ooo`00M@3oool00`000000
oooo0?ooo`090?ooocD0o`00T@3ooolH0?l001d0003oi`3oool007D0oooo00<000000?ooo`3oool0
2P3ooolb0?l009<0oooo5`3o000L0000onT0oooo001e0?ooo`030000003oool0oooo00X0oooo<03o
002F0?oooaD0o`006`000?o[0?ooo`00M@3oool00`000000oooo0?ooo`0:0?ooobh0o`00V03ooolD
0?l001X0003ok@3oool007D0oooo00<000000?ooo`3oool02P3oool/0?l009X0oooo503o000H0000
onl0oooo001e0?ooo`030000003oool0oooo00/0oooo:@3o002L0?oooa<0o`005`000?oa0?ooo`00
M@3oool00`000000oooo0?ooo`0;0?ooobH0o`00X03ooolA0?l001H0003ol`3oool007D0oooo00<0
00000?ooo`3oool02`3ooolT0?l00:80oooo403o000E0000ooD0oooo001e0?ooo`030000003oool0
oooo00/0oooo8P3o002T0?ooo`l0o`0050000?og0?ooo`00M@3oool00`000000oooo0?ooo`0;0?oo
ob00o`00YP3oool?0?l00140003onP3oool007D0oooo00<000000?ooo`3oool0303ooolM0?l00:P0
oooo3P3o000@0000oo`0oooo001e0?ooo`030000003oool0oooo00`0oooo6`3o002[0?ooo``0o`00
3`000?on0?ooo`00M@3oool00`000000oooo0?ooo`0<0?oooaT0o`00[@3oool;0?l000h0003oo`3o
ool10?ooo`00M@3oool00`000000oooo0?ooo`0<0?oooaL0o`00[`3oool:0?l000d0003oo`3oool3
0?ooo`00M@3oool00`000000oooo0?ooo`0=0?oooa@0o`00/@3oool:0?l000/0003oo`3oool50?oo
o`00M@3oool00`000000oooo0?ooo`0=0?oooa80o`00]03oool80?l000X0003oo`3oool70?ooo`00
M@3oool00`000000oooo0?ooo`0=0?oooa00o`00]P3oool70?l000T0003oo`3oool90?ooo`00M@3o
ool00`000000oooo0?ooo`0=0?ooo`h0o`00^03oool60?l000P0003oo`3oool;0?ooo`00M@3oool0
0`000000oooo0?ooo`0=0?ooo``0o`00^P3oool50?l000L0003oo`3oool=0?ooo`00M@3oool00`00
0000oooo0?ooo`0>0?ooo`T0o`00_@3oool40?l000D0003oo`3oool?0?ooo`00M@3oool00`000000
oooo0?ooo`0>0?ooo`L0o`00_`3oool30?l000@0003oo`3ooolA0?ooo`00M@3oool00`000000oooo
0?ooo`0>0?ooo`D0o`00`@3oool20?l000<0003oo`3ooolC0?ooo`00M@3oool00`000000oooo0?oo
o`0>0?ooo`<0o`00``3oool00`3o0000003o0000o`3o0?oooaD0oooo001e0?ooo`030000003oool0
oooo0?l0ooook03oool007D0oooo00<000000?ooo`3oool0o`3oooo/0?ooo`00M@3oool00`000000
oooo0?ooo`3o0?ooon`0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo
0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo
003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00ZP3oool00`000000oooo0?ooo`0K0?oo
o`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?oo
o`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?oo
o`030000003oool0oooo0240oooo00<000000?ooo`3oool0[P3oool00:X0oooo00<000000?ooo`3o
ool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3o
ool06`3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0:h0oooo002Z0?ooo`030000
003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo01/0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`2^0?ooo`00Z`3o
ool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3o
ool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3o
ool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0[@3o
ool00:P0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00000J0?ooo`040000
003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00000P
0?ooo`040000003oool0oooo00000200oooo00@000000?ooo`3oool00000803oool010000000oooo
0?ooo`00000P0?ooo`040000003oool0oooo00000:l0oooo002X0?ooo`@000006P3oool4000001X0
oooo1000000J0?ooo`@000006P3oool400000200oooo1000000P0?ooo`@00000803oool400000200
oooo1000002_0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00W`3o
ool00`000000oooo0?ooo`3o0?ooob40oooo00<000000?ooo`3oool0WP3oool009h0oooo00<00000
0?ooo`3oool06P3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<00000
0?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<00000
0?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<00000
0?ooo`3oool0W@3oool009h0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0E0?oo
o`030000003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?oo
o`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?oo
o`030000003oool0oooo0240oooo00<000000?ooo`3oool0W@3oool009h0oooo00@000000?ooo`3o
ool0oooo100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo
00L0oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool40000
0080oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool40000
00@0oooo00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool40000
00@0oooo00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool40000
00@0oooo00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool40000
00@0oooo00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool40000
00@0oooo00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool40000
00<0oooo00<000000?ooo`3oool0W@3oool009d0oooo00<000000?ooo`3oool0o`3ooolU0?ooo`03
0000003oool0oooo09`0oooo002N0?ooo`030000003oool0oooo0?l0oooo8`3oool00`000000oooo
0?ooo`2M0?ooo`00WP3oool00`000000oooo0?ooo`3o0?ooob<0oooo00<000000?ooo`3oool0W@3o
ool009l0oooo00<000000?ooo`3oool0o`3ooolQ0?ooo`030000003oool0oooo09h0oooo003o0?oo
ool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3o
ool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00:@0oooo
0`0000060?ooo`<000001@3oool3000000d0oooo0`0000050?ooo`<000003P3oool4000000L0oooo
0`0000050?ooo`<000003@3oool3000000D0oooo0`00000?0?ooo`800000203oool3000000D0oooo
0`00000?0?ooo`800000203oool3000000D0oooo0`00000>0?ooo`@000001`3oool3000000D0oooo
0`00000>0?ooo`@000001`3oool3000000D0oooo0`00000?0?ooo`800000203oool3000000D0oooo
0`00002S0?ooo`00Y@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<0
00000?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<0
00000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo0000
00P0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`2R0?ooo`00XP3oool5000000L0
oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo00h0
oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?ooo`3oool03@3oool3000000D0
oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`070?ooo`<000001@3oool00`000000
oooo0?ooo`0?0?ooo`030000003oool0oooo00L0oooo0`0000050?ooo`030000003oool0oooo00h0
oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?ooo`3oool03P3oool00`000000
oooo0?ooo`080?ooo`<000001@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo00L0
oooo0`0000050?ooo`030000003oool0oooo0:80oooo002R0?ooo`040000003oool0oooo000000P0
oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool2
00000140oooo00<000000?ooo`3oool01`3oool010000000oooo0?ooo`0000030?ooo`8000003`3o
ool010000000oooo0?ooo`0000030?ooo`8000004P3oool00`000000oooo0?ooo`060?ooo`040000
003oool0oooo000000<0oooo0P00000B0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3o
ool000000`3oool200000140oooo00<000000?ooo`3oool01`3oool010000000oooo0?ooo`000003
0?ooo`8000004@3oool00`000000oooo0?ooo`070?ooo`040000003oool0oooo000000<0oooo0P00
000B0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool000000`3oool200000:@0oooo
002S0?ooo`030000003oool0000000P0oooo00@000000?ooo`3oool00000503oool010000000oooo
0?ooo`00000D0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000503oool0
10000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool0
0000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@00000
0?ooo`3oool00000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000000P0
oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0
oooo00000:T0oooo002T0?ooo`8000001`3oool4000000D0oooo00<000000?ooo`3oool0303oool4
000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0
oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool0
0`000000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool03P3oool2
000000P0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool0
0`000000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool0XP3oool0
0?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo0000\
\>"],
  ImageRangeCache->{{{0, 610.625}, {125.375, 0}} -> {-0.621763, -0.0103329, \
0.00531182, 0.00531182}, {{117, 296.313}, {123.375, 45.625}} -> {-1.97905, \
-0.0201154, 0.0100557, 0.0100557}, {{314.25, 493.563}, {123.375, 45.625}} -> \
{-3.96254, -0.0201154, 0.0100557, 0.0100557}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(Pi) show
153.000 12.750 moveto
(Pi) show
177.000 12.750 moveto
(2) show
189.000 12.750 moveto
(Pi) show
213.000 12.750 moveto
(2) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(2) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
153.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
165.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
177.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
189.000 25.875 moveto
(--) show
201.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
213.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
225.000 25.875 moveto
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(5) show
129.000 39.000 moveto
(5) show
153.000 39.000 moveto
(5) show
183.000 39.000 moveto
(5) show
219.000 39.000 moveto
(5) show
255.000 39.000 moveto
(5) show
285.000 39.000 moveto
(5) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -2.23075e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.38197 0 L
.5 .36327 L
F
0 0 1 r
.38197 0 m
1 0 L
.5 .36327 L
F
1 0 0 r
0 0 m
.5 .36327 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -1.19262e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.38197 0 m
1 0 L
.69098 .22451 L
F
0 0 1 r
.19098 .58779 m
0 0 L
.38197 0 L
F
1 0 0 r
.38197 0 m
.69098 .22451 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000Zb000`400?l00000o`00003oF`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?oo
o`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00D03ooooo00000<@00000
D03oool005/0oooo00<000000?l00000o`00C000o`1l0000oaH0ooooC@000?l20?l007/00?l0G@3o
ool005/0oooo00<000000?l0003o0000C000o`1k0000oaL0ooooC@000?l30?l007T00?l0GP3oool0
05/0oooo00<000000?l0003o00000P3o001:003o07T0003o6@3ooom=0000o`D0o`00M@00o`1P0?oo
o`00F`3oool00`000000oooo0?l000030?l004X00?l0M`000?lK0?oood/0003o1`3o001c003o0640
oooo001K0?ooo`030000003oool0o`0000@0o`00B@00o`1f0000oa`0ooooB`000?l80?l007400?l0
HP3oool005/0oooo00<000000?ooo`3o00001P3o0017003o07@0003o7P3ooom;0000o`X0o`00K@00
o`1T0?ooo`00F`3oool00`000000oooo0?ooo`070?l004L00?l0LP000?lP0?ooodT0003o303o001[
003o06D0oooo001K0?ooo`030000003oool0oooo00T0o`00A@00o`1`0000ob80ooooB@000?l=0?l0
06T00?l0IP3oool005/0oooo00<000000?ooo`3oool02P3o0014003o06l0003o8`3ooom90000o`l0
o`00I@00o`1X0?ooo`00F`3oool010000000oooo0?ooo`3oool:0?l004@00?l0K@000?lU0?ooodL0
003o4@3o001S003o06T0oooo001K0?ooo`040000003oool0oooo0?ooo``0o`00@P00o`1[0000obL0
ooooA`000?lC0?l005l00?l0J`3oool005/0oooo00@000000?ooo`3oool0oooo3@3o0011003o06X0
003o:03ooom70000oa@0o`00G@00o`1/0?ooo`00F`3oool00`000000oooo0?ooo`020?ooo`d0o`00
@@00o`1X0000obX0ooooA@000?lF0?l005/00?l0K@3oool005/0oooo00<000000?ooo`3oool00P3o
ool?0?l003l00?l0IP000?l/0?ooodD0003o603o001G003o06l0oooo001K0?ooo`030000003oool0
oooo0080oooo403o000n003o06D0003o;@3ooom50000oaT0o`00E@00o`1`0?ooo`00F`3oool00`00
0000oooo0?ooo`030?oooa40o`00?@00o`1R0000oc00oooo@`000?lK0?l005<00?l0L@3oool005/0
oooo00<000000?ooo`3oool00`3ooolB0?l003`00?l0H@000?la0?oood<0003o7@3o001?003o07<0
oooo001K0?ooo`030000003oool0oooo00<0oooo4`3o000k003o0600003o<P3ooom30000oah0o`00
C@00o`1d0?ooo`00F`3oool00`000000oooo0?ooo`040?oooa@0o`00>P00o`1M0000ocD0oooo@@00
0?lQ0?l004T00?l0MP3oool005/0oooo00<000000?ooo`3oool0103ooolE0?l003T00?l0G0000?lf
0?oood40003o8P3o0017003o07L0oooo001K0?ooo`030000003oool0oooo00@0oooo5P3o000h003o
05/0003o=`3ooom10000ob<0o`00A@00o`1h0?ooo`00F`3oool00`000000oooo0?ooo`050?oooaL0
o`00=`00o`1H0000ocX0oooo?`000?lV0?l004400?l0NP3oool005/0oooo00<000000?ooo`3oool0
1@3ooolH0?l003H00?l0E`000?lk0?ooocl0003o9`3o000o003o07/0oooo001K0?ooo`030000003o
ool0oooo00D0oooo6P3o000d003o05D0003o?@3ooolo0000obP0o`00?@00o`1l0?ooo`00F`3oool0
0`000000oooo0?ooo`060?oooaX0o`00=000o`1C0000ocl0oooo?@000?l[0?l003T00?l0OP3oool0
05/0oooo00<000000?ooo`3oool01P3ooolK0?l003<00?l0DP000?m00?ooocd0003o;03o000g003o
07l0oooo001K0?ooo`030000003oool0oooo00H0oooo7@3o000a003o0500003o@P3ooolm0000obd0
o`00=@00o`200?ooo`00F`3oool00`000000oooo0?ooo`070?oooad0o`00<@00o`1>0000od@0oooo
>`000?l`0?l003400?l0PP3oool005/0oooo00<000000?ooo`3oool01`3ooolN0?l003000?l0C@00
0?m50?oooc/0003o<@3o000_003o08<0oooo001K0?ooo`030000003oool0oooo00L0oooo803o000^
003o04/0003oA`3ooolk0000oc<0o`00:`00o`250?ooo`00F`3oool00`000000oooo0?ooo`080?oo
ob00o`00;P00o`190000odT0oooo>@000?le0?l002T00?l0QP3oool005/0oooo00<000000?ooo`3o
ool0203ooolR0?l002`00?l0A`000?m;0?ooocT0003o=P3o000W003o08L0oooo001K0?ooo`030000
003oool0oooo00P0oooo8`3o000[003o04H0003oC03oooli0000ocP0o`008`00o`290?ooo`00F`3o
ool00`000000oooo0?ooo`090?ooob<0o`00:`00o`140000odh0oooo=`000?lj0?l002400?l0RP3o
ool005/0oooo00<000000?ooo`3oool02@3ooolU0?l002T00?l0@P000?m@0?ooocL0003o>`3o000O
003o08/0oooo001K0?ooo`030000003oool0oooo00T0oooo9P3o000X003o0440003oD@3ooolg0000
ocd0o`006`00o`2=0?ooo`00F`3oool00`000000oooo0?ooo`0:0?ooobH0o`009`00o`0o0000oe@0
oooo=@000?lo0?l001T00?l0SP3oool005/0oooo00<000000?ooo`3oool02P3ooolX0?l002H00?l0
?@000?mE0?ooocD0003o@@3o000E003o0900oooo001K0?ooo`030000003oool0oooo00X0oooo:@3o
000U003o03`0003oEP3ooole0000od80o`004`00o`2A0?ooo`00F`3oool00`000000oooo0?ooo`0:
0?ooob/0o`008`00o`0j0000oeP0oooo=0000?m40?l001400?l0TP3oool005/0oooo00<000000?oo
o`3oool02`3oool[0?l002<00?l0>0000?mJ0?oooc<0003oAP3o000=003o09@0oooo001K0?ooo`03
0000003oool0oooo00/0oooo;03o000R003o03L0003oF`3ooolc0000odL0o`002`00o`2E0?ooo`00
F`3oool00`000000oooo0?ooo`0;0?ooobh0o`008000o`0e0000oed0oooo<`000?m80?l000T00?l0
UP3oool005/0oooo00<000000?ooo`3oool0303oool^0?l002000?l0<`000?mO0?oooc40003oB`3o
0005003o09P0oooo001K0?ooo`030000003oool0oooo00`0oooo<03o000N003o0340003oH@3ooola
0000od`0o`000`00o`2I0?ooo`00F`3oool00`000000oooo0?ooo`0<0?oooc40o`007@00o`0`0000
of80oooo<@000?m=0?l009/0oooo001K0?ooo`030000003oool0oooo00d0oooo<@3o000M003o02h0
003oI03oool_0000odd0o`00W03oool005/0oooo00<000000?ooo`3oool03@3ooolc0?l001/00?l0
;0000?mV0?ooobl0003oC03o002M0?ooo`00F`3oool00`000000oooo0?ooo`0=0?oooc@0o`006P00
o`0[0000ofL0oooo;`000?m:0?l009l0oooo001K0?ooo`030000003oool0oooo00h0oooo=03o000J
003o02T0003oJ@3oool]0000odX0o`00X03oool005/0oooo00<000000?ooo`3oool03P3ooolf0?l0
01P00?l09`000?m[0?ooobd0003oB@3o002Q0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooocL0
o`005`00o`0V0000of`0oooo;@000?m70?l00:<0oooo001K0?ooo`030000003oool0oooo00l0oooo
>03o000F003o02<0003oK`3oool[0000odL0o`00Y03oool005/0oooo00<000000?ooo`3oool03`3o
ooli0?l001D00?l08P000?m`0?ooob/0003oA@3o002V0?ooo`00F`3oool00`000000oooo0?ooo`0?
0?ooocX0o`005000o`0Q0000og40oooo:`000?m40?l00:L0oooo001K0?ooo`030000003oool0oooo
0100oooo>`3o000C003o01h0003oM03ooolY0000od@0o`00Z03oool005/0oooo00<000000?ooo`3o
ool0403oooll0?l001800?l07@000?me0?ooobT0003o@P3o002Z0?ooo`00F`3oool00`000000oooo
0?ooo`0@0?ooocd0o`004@00o`0L0000ogH0oooo:@000?m10?l00:/0oooo001K0?ooo`030000003o
ool0oooo0140oooo?P3o000@003o01T0003oN@3ooolW0000od40o`00[03oool005/0oooo00<00000
0?ooo`3oool04@3ooolo0?l000l00?l060000?mj0?ooobL0003o?`3o002^0?ooo`00F`3oool00`00
0000oooo0?ooo`0A0?oood40o`003@00o`0F0000og`0oooo9`000?ln0?l00:l0oooo001K0?ooo`03
0000003oool0oooo0180oooo@@3o000=003o01@0003oOP3ooolU0000ocd0o`00/@3oool005/0oooo
00<000000?ooo`3oool04P3ooom20?l000`00?l04`000?mo0?ooobD0003o?03o002b0?ooo`00F`3o
ool00`000000oooo0?ooo`0B0?oood@0o`002P00o`0A0000oh40oooo9@000?lk0?l00;<0oooo001K
0?ooo`030000003oool0oooo01<0ooooA03o000:003o00l0003oP`3ooolS0000ocX0o`00]@3oool0
05/0oooo00<000000?ooo`3oool04`3ooom50?l000T00?l03P000?n40?ooob<0003o>@3o002f0?oo
o`00F`3oool00`000000oooo0?ooo`0C0?ooodL0o`001`00o`0<0000ohH0oooo8`000?lh0?l00;L0
oooo001K0?ooo`030000003oool0oooo01@0ooooA`3o0007003o00X0003oR03ooolQ0000ocL0o`00
^@3oool005/0oooo00<000000?ooo`3oool0503ooom90?l000D00?l020000?n:0?ooob40003o=P3o
002j0?ooo`00F`3oool00`000000oooo0?ooo`0D0?ooodX0o`001000o`070000oh/0oooo8@000?ld
0?l00;`0oooo001K0?ooo`030000003oool0oooo01D0ooooBP3o0004003o00D0003oS@3ooolO0000
oc@0o`00_@3oool005/0oooo00<000000?ooo`3oool05@3ooom<0?l000800?l00`000?n?0?oooal0
003o<`3o002n0?ooo`00F`3oool00`000000oooo0?ooo`0E0?ooodd0o`0000<00?l00000o`000?l0
T03ooolO0000oc40o`00`03oool005/0oooo00<000000?ooo`3oool05P3ooom=0?l009<0oooo7@00
0?la0?l00<40oooo001K0?ooo`030000003oool0oooo01H0ooooC03o002D0?oooad0003o<03o0032
0?ooo`00F`3oool00`000000oooo0?ooo`0F0?oood/0o`00U@3ooolM0000obh0o`00a03oool005/0
oooo00<000000?ooo`3oool05`3ooom80?l009P0oooo6`000?l^0?l00<D0oooo001K0?ooo`030000
003oool0oooo01L0ooooA`3o002I0?oooa/0003o;03o00370?ooo`00F`3oool00`000000oooo0?oo
o`0G0?ooodH0o`00VP3ooolK0000ob/0o`00b03oool005/0oooo00<000000?ooo`3oool05`3ooom4
0?l009`0oooo6P000?l[0?l00<T0oooo001K0?ooo`030000003oool0oooo01P0oooo@P3o002N0?oo
oaT0003o:@3o003;0?ooo`00F`3oool00`000000oooo0?ooo`0H0?oood40o`00W`3ooolI0000obP0
o`00c03oool005/0oooo00<000000?ooo`3oool0603ooolo0?l00:40oooo6@000?lV0?l00<h0oooo
001K0?ooo`030000003oool0oooo01T0oooo?@3o002S0?oooaL0003o9P3o003?0?ooo`00F`3oool0
0`000000oooo0?ooo`0I0?oooc/0o`00Y@3ooolG0000obD0o`00d03oool005/0oooo00<000000?oo
o`3oool06@3ooolj0?l00:H0oooo5`000?lS0?l00=80oooo001K0?ooo`030000003oool0oooo01X0
oooo>03o002X0?oooaD0003o8`3o003C0?ooo`00F`3oool00`000000oooo0?ooo`0J0?ooocH0o`00
ZP3ooolE0000ob80o`00e03oool005/0oooo00<000000?ooo`3oool06P3ooole0?l00:/0oooo5@00
0?lP0?l00=H0oooo001K0?ooo`030000003oool0oooo01/0oooo<`3o002]0?oooa<0003o803o003G
0?ooo`00F`3oool00`000000oooo0?ooo`0K0?oooc40o`00[`3ooolC0000oah0o`00f@3oool005/0
oooo00<000000?ooo`3oool06`3oool`0?l00;00oooo4`000?lM0?l00=X0oooo001K0?ooo`030000
003oool0oooo01`0oooo;@3o002c0?oooa40003o7@3o003K0?ooo`00F`3oool00`000000oooo0?oo
o`0L0?ooob`0o`00]03ooolA0000oa/0o`00g@3oool005/0oooo00<000000?ooo`3oool0703oool[
0?l00;D0oooo4@000?lJ0?l00=h0oooo001K0?ooo`030000003oool0oooo01d0oooo:03o002h0?oo
o`l0003o6P3o003O0?ooo`00F`3oool00`000000oooo0?ooo`0M0?ooobL0o`00^@3oool?0000oaP0
o`00h@3oool005/0oooo00<000000?ooo`3oool07@3ooolV0?l00;X0oooo3`000?lG0?l00>80oooo
001K0?ooo`030000003oool0oooo01h0oooo8`3o002m0?ooo`d0003o5P3o003T0?ooo`00F`3oool0
0`000000oooo0?ooo`0N0?ooob80o`00_P3oool=0000oaD0o`00i@3oool005/0oooo00<000000?oo
o`3oool07P3ooolQ0?l00;l0oooo3@000?lD0?l00>H0oooo001K0?ooo`030000003oool0oooo01l0
oooo7P3o00320?ooo`/0003o4`3o003X0?ooo`00F`3oool00`000000oooo0?ooo`0O0?oooad0o`00
``3oool;0000oa80o`00j@3oool005/0oooo00<000000?ooo`3oool07`3ooolK0?l00<D0oooo2`00
0?lA0?l00>X0oooo001K0?ooo`030000003oool0oooo0200oooo6@3o00370?ooo`T0003o403o003/
0?ooo`00F`3oool00`000000oooo0?ooo`0P0?oooaP0o`00b03oool90000o`l0o`00k@3oool005/0
oooo00<000000?ooo`3oool0803ooolF0?l00<X0oooo2@000?l=0?l00>l0oooo001K0?ooo`030000
003oool0oooo0240oooo503o003<0?ooo`L0003o3@3o003`0?ooo`00F`3oool00`000000oooo0?oo
o`0Q0?oooa<0o`00c@3oool70000o``0o`00l@3oool005/0oooo00<000000?ooo`3oool08@3ooolA
0?l00<l0oooo1`000?l:0?l00?<0oooo001K0?ooo`030000003oool0oooo0280oooo3`3o003A0?oo
o`D0003o2P3o003d0?ooo`00F`3oool00`000000oooo0?ooo`0R0?ooo`d0o`00d`3oool50000o`T0
o`00m@3oool005/0oooo00<000000?ooo`3oool08P3oool<0?l00=@0oooo1@000?l70?l00?L0oooo
001K0?ooo`030000003oool0oooo02<0oooo2P3o003F0?ooo`<0003o1`3o003h0?ooo`00F`3oool0
0`000000oooo0?ooo`0S0?ooo`P0o`00f03oool30000o`D0o`00nP3oool005/0oooo00<000000?oo
o`3oool08`3oool70?l00=T0oooo0`000?l40?l00?/0oooo001K0?ooo`030000003oool0oooo02@0
oooo1@3o003K0?ooo`030000o`3o0000o`000080o`00o03oool005/0oooo00<000000?ooo`3oool0
903oool30?l00=d0oooo00<0003o0?l0003o0000oP3oool005/0oooo00<000000?ooo`3oool0903o
ool20?l00=h0oooo00<0003o0?l0003oool0oP3oool005/0oooo00<000000?ooo`3oool0o`3ooooo
0?ooo`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00F`3oool00`000000
oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?ooo`L0oooo
003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0
ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool0
0?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002e0?ooo`800000703oool2000001H0oooo
0P00000F0?ooo`800000703oool200000280oooo0P00000R0?ooo`800000703oool2000001`0oooo
0P00002l0?ooo`00]03oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001@0
oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00000J0?ooo`040000003oool0
oooo00000200oooo00@000000?ooo`3oool00000803oool010000000oooo0?ooo`00000J0?ooo`04
0000003oool0oooo000001X0oooo00@000000?ooo`3oool00000^`3oool00;L0oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0;T0oooo002e0?ooo`80
0000703oool2000001H0oooo0P00000F0?ooo`800000703oool200000280oooo0P00000R0?ooo`80
0000703oool2000001`0oooo0P00002l0?ooo`00]@3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo01/0oooo00<000000?ooo`3oool0^`3oool00;D0oooo0`00000K0?ooo`<000005@3o
ool3000001D0oooo0`00000K0?ooo`<000008@3oool300000240oooo0`00000K0?ooo`<000006`3o
ool300000;/0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002[0?oo
o`030000003oool0oooo0?l0oooo2@3oool00`000000oooo0?ooo`2Z0?ooo`00ZP3oool00`000000
oooo0?ooo`0J0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`000000
oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`2Y0?ooo`00ZP3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo01D0oooo
00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo
00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo
00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`2Y0?ooo`00ZP3oool010000000oooo0?oo
o`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000
103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000
0P3oool400000080oooo100000030?ooo`030000003oool0oooo0:T0oooo002Y0?ooo`030000003o
ool0oooo0?l0oooo3@3oool00`000000oooo0?ooo`2X0?ooo`00ZP3oool00`000000oooo0?ooo`3o
0?ooo`/0oooo00<000000?ooo`3oool0Z@3oool00:X0oooo00<000000?ooo`3oool0o`3oool;0?oo
o`030000003oool0oooo0:T0oooo002[0?ooo`030000003oool0oooo0?l0oooo2@3oool00`000000
oooo0?ooo`2Z0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3o
oooo0?ooofD0oooo002_0?ooo`800000203oool3000000D0oooo0`00000=0?ooo`<000001@3oool3
000000d0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000>0?ooo`@000001`3oool3
000000D0oooo0`00000>0?ooo`@000001`3oool3000000D0oooo0`00000>0?ooo`@000001`3oool3
000000D0oooo0`00000=0?ooo`<000001@3oool3000000h0oooo100000070?ooo`<000001@3oool3
00000:l0oooo002^0?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0[P3oool0
0;00oooo00<000000?ooo`3oool01`3oool3000000D0oooo00<000000?ooo`3oool03@3oool30000
00D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03@3oool30000
00D0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`00
0000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo
00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?ooo`3oool03@3oool30000
00D0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`00
0000oooo0?ooo`2^0?ooo`00/@3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
00<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0
oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000A0?ooo`030000
003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool200000140oooo00<000000?ooo`3o
ool01`3oool010000000oooo0?ooo`0000030?ooo`8000004@3oool00`000000oooo0?ooo`070?oo
o`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00
000A0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool200000;00oooo
002^0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000503oool010000000
oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000503o
ool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000000P0oooo00@0
00000?ooo`3oool00000503oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo0000
00P0oooo00@000000?ooo`3oool00000]@3oool00:l0oooo0P0000080?ooo`@000001@3oool00`00
0000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`00
0000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?ooo`800000203oool40000
00D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo
00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`00
0000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool0[P3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo0000\
\>"],
  ImageRangeCache->{{{0, 610.563}, {170.188, 0}} -> {-0.426205, -0.013998, \
0.00467178, 0.00467178}, {{91.1875, 295.063}, {167.188, 47.3125}} -> \
{-1.34175, -0.0239702, 0.00793648, 0.00793648}, {{315.438, 519.313}, \
{167.188, 47.3125}} -> {-3.12151, -0.0239702, 0.00793648, 0.00793648}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(Pi) show
153.000 12.750 moveto
(Pi) show
177.000 12.750 moveto
(2) show
189.000 12.750 moveto
(Pi) show
213.000 12.750 moveto
(2) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(2) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
153.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
165.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
177.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
189.000 25.875 moveto
(--) show
201.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
213.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
225.000 25.875 moveto
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(5) show
129.000 39.000 moveto
(5) show
153.000 39.000 moveto
(5) show
183.000 39.000 moveto
(5) show
219.000 39.000 moveto
(5) show
255.000 39.000 moveto
(5) show
285.000 39.000 moveto
(5) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -2.23075e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.38197 0 L
.5 .36327 L
F
0 0 1 r
.38197 0 m
1 0 L
.5 .36327 L
F
1 0 0 r
0 0 m
.5 .36327 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -1.19262e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.38197 0 m
1 0 L
.69098 .22451 L
F
0 0 1 r
.19098 .58779 m
0 0 L
.38197 0 L
F
1 0 0 r
.38197 0 m
.69098 .22451 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000Zb000`400?l00000o`00003oF`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?oo
o`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00D03ooooo00000<@00000
D03oool005/0oooo00<000000?l00000o`00C000o`1l0000oaH0ooooC@000?l20?l007/00?l0G@3o
ool005/0oooo00<000000?l0003o0000C000o`1k0000oaL0ooooC@000?l30?l007T00?l0GP3oool0
05/0oooo00<000000?l0003o00000P3o001:003o07T0003o6@3ooom=0000o`D0o`00M@00o`1P0?oo
o`00F`3oool00`000000oooo0?l000030?l004X00?l0M`000?lK0?oood/0003o1`3o001c003o0640
oooo001K0?ooo`030000003oool0o`0000@0o`00B@00o`1f0000oa`0ooooB`000?l80?l007400?l0
HP3oool005/0oooo00<000000?ooo`3o00001P3o0017003o07@0003o7P3ooom;0000o`X0o`00K@00
o`1T0?ooo`00F`3oool00`000000oooo0?ooo`070?l004L00?l0LP000?lP0?ooodT0003o303o001[
003o06D0oooo001K0?ooo`030000003oool0oooo00T0o`00A@00o`1`0000ob80ooooB@000?l=0?l0
06T00?l0IP3oool005/0oooo00<000000?ooo`3oool02P3o0014003o06l0003o8`3ooom90000o`l0
o`00I@00o`1X0?ooo`00F`3oool010000000oooo0?ooo`3oool:0?l004@00?l0K@000?lU0?ooodL0
003o4@3o001S003o06T0oooo001K0?ooo`040000003oool0oooo0?ooo``0o`00@P00o`1[0000obL0
ooooA`000?lC0?l005l00?l0J`3oool005/0oooo00@000000?ooo`3oool0oooo3@3o0011003o06X0
003o:03ooom70000oa@0o`00G@00o`1/0?ooo`00F`3oool00`000000oooo0?ooo`020?ooo`d0o`00
@@00o`1X0000obX0ooooA@000?lF0?l005/00?l0K@3oool005/0oooo00<000000?ooo`3oool00P3o
ool?0?l003l00?l0IP000?l/0?ooodD0003o603o001G003o06l0oooo001K0?ooo`030000003oool0
oooo0080oooo403o000n003o06D0003o;@3ooom50000oaT0o`00E@00o`1`0?ooo`00F`3oool00`00
0000oooo0?ooo`030?oooa40o`00?@00o`1R0000oc00oooo@`000?lK0?l005<00?l0L@3oool005/0
oooo00<000000?ooo`3oool00`3ooolB0?l003`00?l0H@000?la0?oood<0003o7@3o001?003o07<0
oooo001K0?ooo`030000003oool0oooo00<0oooo4`3o000k003o0600003o<P3ooom30000oah0o`00
C@00o`1d0?ooo`00F`3oool00`000000oooo0?ooo`040?oooa@0o`00>P00o`1M0000ocD0oooo@@00
0?lQ0?l004T00?l0MP3oool005/0oooo00<000000?ooo`3oool0103ooolE0?l003T00?l0G0000?lf
0?oood40003o8P3o0017003o07L0oooo001K0?ooo`030000003oool0oooo00@0oooo5P3o000h003o
05/0003o=`3ooom10000ob<0o`00A@00o`1h0?ooo`00F`3oool00`000000oooo0?ooo`050?oooaL0
o`00=`00o`1H0000ocX0oooo?`000?lV0?l004400?l0NP3oool005/0oooo00<000000?ooo`3oool0
1@3ooolH0?l003H00?l0E`000?lk0?ooocl0003o9`3o000o003o07/0oooo001K0?ooo`030000003o
ool0oooo00D0oooo6P3o000d003o05D0003o?@3ooolo0000obP0o`00?@00o`1l0?ooo`00F`3oool0
0`000000oooo0?ooo`060?oooaX0o`00=000o`1C0000ocl0oooo?@000?l[0?l003T00?l0OP3oool0
05/0oooo00<000000?ooo`3oool01P3ooolK0?l003<00?l0DP000?m00?ooocd0003o;03o000g003o
07l0oooo001K0?ooo`030000003oool0oooo00H0oooo7@3o000a003o0500003o@P3ooolm0000obd0
o`00=@00o`200?ooo`00F`3oool00`000000oooo0?ooo`070?oooad0o`00<@00o`1>0000od@0oooo
>`000?l`0?l003400?l0PP3oool005/0oooo00<000000?ooo`3oool01`3ooolN0?l003000?l0C@00
0?m50?oooc/0003o<@3o000_003o08<0oooo001K0?ooo`030000003oool0oooo00L0oooo803o000^
003o04/0003oA`3ooolk0000oc<0o`00:`00o`250?ooo`00F`3oool00`000000oooo0?ooo`080?oo
ob00o`00;P00o`190000odT0oooo>@000?le0?l002T00?l0QP3oool005/0oooo00<000000?ooo`3o
ool0203ooolR0?l002`00?l0A`000?m;0?ooocT0003o=P3o000W003o08L0oooo001K0?ooo`030000
003oool0oooo00P0oooo8`3o000[003o04H0003oC03oooli0000ocP0o`008`00o`290?ooo`00F`3o
ool00`000000oooo0?ooo`090?ooob<0o`00:`00o`140000odh0oooo=`000?lj0?l002400?l0RP3o
ool005/0oooo00<000000?ooo`3oool02@3ooolU0?l002T00?l0@P000?m@0?ooocL0003o>`3o000O
003o08/0oooo001K0?ooo`030000003oool0oooo00T0oooo9P3o000X003o0440003oD@3ooolg0000
ocd0o`006`00o`2=0?ooo`00F`3oool00`000000oooo0?ooo`0:0?ooobH0o`009`00o`0o0000oe@0
oooo=@000?lo0?l001T00?l0SP3oool005/0oooo00<000000?ooo`3oool02P3ooolX0?l002H00?l0
?@000?mE0?ooocD0003o@@3o000E003o0900oooo001K0?ooo`030000003oool0oooo00X0oooo:@3o
000U003o03`0003oEP3ooole0000od80o`004`00o`2A0?ooo`00F`3oool00`000000oooo0?ooo`0:
0?ooob/0o`008`00o`0j0000oeP0oooo=0000?m40?l001400?l0TP3oool005/0oooo00<000000?oo
o`3oool02`3oool[0?l002<00?l0>0000?mJ0?oooc<0003oAP3o000=003o09@0oooo001K0?ooo`03
0000003oool0oooo00/0oooo;03o000R003o03L0003oF`3ooolc0000odL0o`002`00o`2E0?ooo`00
F`3oool00`000000oooo0?ooo`0;0?ooobh0o`008000o`0e0000oed0oooo<`000?m80?l000T00?l0
UP3oool005/0oooo00<000000?ooo`3oool0303oool^0?l002000?l0<`000?mO0?oooc40003oB`3o
0005003o09P0oooo001K0?ooo`030000003oool0oooo00`0oooo<03o000N003o0340003oH@3ooola
0000od`0o`000`00o`2I0?ooo`00F`3oool00`000000oooo0?ooo`0<0?oooc40o`007@00o`0`0000
of80oooo<@000?m=0?l009/0oooo001K0?ooo`030000003oool0oooo00d0oooo<@3o000M003o02h0
003oI03oool_0000odd0o`00W03oool005/0oooo00<000000?ooo`3oool03@3ooolc0?l001/00?l0
;0000?mV0?ooobl0003oC03o002M0?ooo`00F`3oool00`000000oooo0?ooo`0=0?oooc@0o`006P00
o`0[0000ofL0oooo;`000?m:0?l009l0oooo001K0?ooo`030000003oool0oooo00h0oooo=03o000J
003o02T0003oJ@3oool]0000odX0o`00X03oool005/0oooo00<000000?ooo`3oool03P3ooolf0?l0
01P00?l09`000?m[0?ooobd0003oB@3o002Q0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooocL0
o`005`00o`0V0000of`0oooo;@000?m70?l00:<0oooo001K0?ooo`030000003oool0oooo00l0oooo
>03o000F003o02<0003oK`3oool[0000odL0o`00Y03oool005/0oooo00<000000?ooo`3oool03`3o
ooli0?l001D00?l08P000?m`0?ooob/0003oA@3o002V0?ooo`00F`3oool00`000000oooo0?ooo`0?
0?ooocX0o`005000o`0Q0000og40oooo:`000?m40?l00:L0oooo001K0?ooo`030000003oool0oooo
0100oooo>`3o000C003o01h0003oM03ooolY0000od@0o`00Z03oool005/0oooo00<000000?ooo`3o
ool0403oooll0?l001800?l07@000?me0?ooobT0003o@P3o002Z0?ooo`00F`3oool00`000000oooo
0?ooo`0@0?ooocd0o`004@00o`0L0000ogH0oooo:@000?m10?l00:/0oooo001K0?ooo`030000003o
ool0oooo0140oooo?P3o000@003o01T0003oN@3ooolW0000od40o`00[03oool005/0oooo00<00000
0?ooo`3oool04@3ooolo0?l000l00?l060000?mj0?ooobL0003o?`3o002^0?ooo`00F`3oool00`00
0000oooo0?ooo`0A0?oood40o`003@00o`0F0000og`0oooo9`000?ln0?l00:l0oooo001K0?ooo`03
0000003oool0oooo0180oooo@@3o000=003o01@0003oOP3ooolU0000ocd0o`00/@3oool005/0oooo
00<000000?ooo`3oool04P3ooom20?l000`00?l04`000?mo0?ooobD0003o?03o002b0?ooo`00F`3o
ool00`000000oooo0?ooo`0B0?oood@0o`002P00o`0A0000oh40oooo9@000?lk0?l00;<0oooo001K
0?ooo`030000003oool0oooo01<0ooooA03o000:003o00l0003oP`3ooolS0000ocX0o`00]@3oool0
05/0oooo00<000000?ooo`3oool04`3ooom50?l000T00?l03P000?n40?ooob<0003o>@3o002f0?oo
o`00F`3oool00`000000oooo0?ooo`0C0?ooodL0o`001`00o`0<0000ohH0oooo8`000?lh0?l00;L0
oooo001K0?ooo`030000003oool0oooo01@0ooooA`3o0007003o00X0003oR03ooolQ0000ocL0o`00
^@3oool005/0oooo00<000000?ooo`3oool0503ooom90?l000D00?l020000?n:0?ooob40003o=P3o
002j0?ooo`00F`3oool00`000000oooo0?ooo`0D0?ooodX0o`001000o`070000oh/0oooo8@000?ld
0?l00;`0oooo001K0?ooo`030000003oool0oooo01D0ooooBP3o0004003o00D0003oS@3ooolO0000
oc@0o`00_@3oool005/0oooo00<000000?ooo`3oool05@3ooom<0?l000800?l00`000?n?0?oooal0
003o<`3o002n0?ooo`00F`3oool00`000000oooo0?ooo`0E0?ooodd0o`0000<00?l00000o`000?l0
T03ooolO0000oc40o`00`03oool005/0oooo00<000000?ooo`3oool05P3ooom=0?l009<0oooo7@00
0?la0?l00<40oooo001K0?ooo`030000003oool0oooo01H0ooooC03o002D0?oooad0003o<03o0032
0?ooo`00F`3oool00`000000oooo0?ooo`0F0?oood/0o`00U@3ooolM0000obh0o`00a03oool005/0
oooo00<000000?ooo`3oool05`3ooom80?l009P0oooo6`000?l^0?l00<D0oooo001K0?ooo`030000
003oool0oooo01L0ooooA`3o002I0?oooa/0003o;03o00370?ooo`00F`3oool00`000000oooo0?oo
o`0G0?ooodH0o`00VP3ooolK0000ob/0o`00b03oool005/0oooo00<000000?ooo`3oool05`3ooom4
0?l009`0oooo6P000?l[0?l00<T0oooo001K0?ooo`030000003oool0oooo01P0oooo@P3o002N0?oo
oaT0003o:@3o003;0?ooo`00F`3oool00`000000oooo0?ooo`0H0?oood40o`00W`3ooolI0000obP0
o`00c03oool005/0oooo00<000000?ooo`3oool0603ooolo0?l00:40oooo6@000?lV0?l00<h0oooo
001K0?ooo`030000003oool0oooo01T0oooo?@3o002S0?oooaL0003o9P3o003?0?ooo`00F`3oool0
0`000000oooo0?ooo`0I0?oooc/0o`00Y@3ooolG0000obD0o`00d03oool005/0oooo00<000000?oo
o`3oool06@3ooolj0?l00:H0oooo5`000?lS0?l00=80oooo001K0?ooo`030000003oool0oooo01X0
oooo>03o002X0?oooaD0003o8`3o003C0?ooo`00F`3oool00`000000oooo0?ooo`0J0?ooocH0o`00
ZP3ooolE0000ob80o`00e03oool005/0oooo00<000000?ooo`3oool06P3ooole0?l00:/0oooo5@00
0?lP0?l00=H0oooo001K0?ooo`030000003oool0oooo01/0oooo<`3o002]0?oooa<0003o803o003G
0?ooo`00F`3oool00`000000oooo0?ooo`0K0?oooc40o`00[`3ooolC0000oah0o`00f@3oool005/0
oooo00<000000?ooo`3oool06`3oool`0?l00;00oooo4`000?lM0?l00=X0oooo001K0?ooo`030000
003oool0oooo01`0oooo;@3o002c0?oooa40003o7@3o003K0?ooo`00F`3oool00`000000oooo0?oo
o`0L0?ooob`0o`00]03ooolA0000oa/0o`00g@3oool005/0oooo00<000000?ooo`3oool0703oool[
0?l00;D0oooo4@000?lJ0?l00=h0oooo001K0?ooo`030000003oool0oooo01d0oooo:03o002h0?oo
o`l0003o6P3o003O0?ooo`00F`3oool00`000000oooo0?ooo`0M0?ooobL0o`00^@3oool?0000oaP0
o`00h@3oool005/0oooo00<000000?ooo`3oool07@3ooolV0?l00;X0oooo3`000?lG0?l00>80oooo
001K0?ooo`030000003oool0oooo01h0oooo8`3o002m0?ooo`d0003o5P3o003T0?ooo`00F`3oool0
0`000000oooo0?ooo`0N0?ooob80o`00_P3oool=0000oaD0o`00i@3oool005/0oooo00<000000?oo
o`3oool07P3ooolQ0?l00;l0oooo3@000?lD0?l00>H0oooo001K0?ooo`030000003oool0oooo01l0
oooo7P3o00320?ooo`/0003o4`3o003X0?ooo`00F`3oool00`000000oooo0?ooo`0O0?oooad0o`00
``3oool;0000oa80o`00j@3oool005/0oooo00<000000?ooo`3oool07`3ooolK0?l00<D0oooo2`00
0?lA0?l00>X0oooo001K0?ooo`030000003oool0oooo0200oooo6@3o00370?ooo`T0003o403o003/
0?ooo`00F`3oool00`000000oooo0?ooo`0P0?oooaP0o`00b03oool90000o`l0o`00k@3oool005/0
oooo00<000000?ooo`3oool0803ooolF0?l00<X0oooo2@000?l=0?l00>l0oooo001K0?ooo`030000
003oool0oooo0240oooo503o003<0?ooo`L0003o3@3o003`0?ooo`00F`3oool00`000000oooo0?oo
o`0Q0?oooa<0o`00c@3oool70000o``0o`00l@3oool005/0oooo00<000000?ooo`3oool08@3ooolA
0?l00<l0oooo1`000?l:0?l00?<0oooo001K0?ooo`030000003oool0oooo0280oooo3`3o003A0?oo
o`D0003o2P3o003d0?ooo`00F`3oool00`000000oooo0?ooo`0R0?ooo`d0o`00d`3oool50000o`T0
o`00m@3oool005/0oooo00<000000?ooo`3oool08P3oool<0?l00=@0oooo1@000?l70?l00?L0oooo
001K0?ooo`030000003oool0oooo02<0oooo2P3o003F0?ooo`<0003o1`3o003h0?ooo`00F`3oool0
0`000000oooo0?ooo`0S0?ooo`P0o`00f03oool30000o`D0o`00nP3oool005/0oooo00<000000?oo
o`3oool08`3oool70?l00=T0oooo0`000?l40?l00?/0oooo001K0?ooo`030000003oool0oooo02@0
oooo1@3o003K0?ooo`030000o`3o0000o`000080o`00o03oool005/0oooo00<000000?ooo`3oool0
903oool30?l00=d0oooo00<0003o0?l0003o0000oP3oool005/0oooo00<000000?ooo`3oool0903o
ool20?l00=h0oooo00<0003o0?l0003oool0oP3oool005/0oooo00<000000?ooo`3oool0o`3ooooo
0?ooo`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00F`3oool00`000000
oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?ooo`L0oooo
003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0
ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool0
0?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002e0?ooo`800000703oool2000001H0oooo
0P00000F0?ooo`800000703oool200000280oooo0P00000R0?ooo`800000703oool2000001`0oooo
0P00002l0?ooo`00]03oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001@0
oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00000J0?ooo`040000003oool0
oooo00000200oooo00@000000?ooo`3oool00000803oool010000000oooo0?ooo`00000J0?ooo`04
0000003oool0oooo000001X0oooo00@000000?ooo`3oool00000^`3oool00;L0oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0;T0oooo002e0?ooo`80
0000703oool2000001H0oooo0P00000F0?ooo`800000703oool200000280oooo0P00000R0?ooo`80
0000703oool2000001`0oooo0P00002l0?ooo`00]@3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo01/0oooo00<000000?ooo`3oool0^`3oool00;D0oooo0`00000K0?ooo`<000005@3o
ool3000001D0oooo0`00000K0?ooo`<000008@3oool300000240oooo0`00000K0?ooo`<000006`3o
ool300000;/0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002[0?oo
o`030000003oool0oooo0?l0oooo2@3oool00`000000oooo0?ooo`2Z0?ooo`00ZP3oool00`000000
oooo0?ooo`0J0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`000000
oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`2Y0?ooo`00ZP3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo01D0oooo
00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo
00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo
00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`2Y0?ooo`00ZP3oool010000000oooo0?oo
o`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000
103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000
0P3oool400000080oooo100000030?ooo`030000003oool0oooo0:T0oooo002Y0?ooo`030000003o
ool0oooo0?l0oooo3@3oool00`000000oooo0?ooo`2X0?ooo`00ZP3oool00`000000oooo0?ooo`3o
0?ooo`/0oooo00<000000?ooo`3oool0Z@3oool00:X0oooo00<000000?ooo`3oool0o`3oool;0?oo
o`030000003oool0oooo0:T0oooo002[0?ooo`030000003oool0oooo0?l0oooo2@3oool00`000000
oooo0?ooo`2Z0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3o
oooo0?ooofD0oooo002_0?ooo`800000203oool3000000D0oooo0`00000=0?ooo`<000001@3oool3
000000d0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000>0?ooo`@000001`3oool3
000000D0oooo0`00000>0?ooo`@000001`3oool3000000D0oooo0`00000>0?ooo`@000001`3oool3
000000D0oooo0`00000=0?ooo`<000001@3oool3000000h0oooo100000070?ooo`<000001@3oool3
00000:l0oooo002^0?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0[P3oool0
0;00oooo00<000000?ooo`3oool01`3oool3000000D0oooo00<000000?ooo`3oool03@3oool30000
00D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03@3oool30000
00D0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`00
0000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo
00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?ooo`3oool03@3oool30000
00D0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`00
0000oooo0?ooo`2^0?ooo`00/@3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
00<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0
oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000A0?ooo`030000
003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool200000140oooo00<000000?ooo`3o
ool01`3oool010000000oooo0?ooo`0000030?ooo`8000004@3oool00`000000oooo0?ooo`070?oo
o`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00
000A0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool200000;00oooo
002^0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000503oool010000000
oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000503o
ool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000000P0oooo00@0
00000?ooo`3oool00000503oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo0000
00P0oooo00@000000?ooo`3oool00000]@3oool00:l0oooo0P0000080?ooo`@000001@3oool00`00
0000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`00
0000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?ooo`800000203oool40000
00D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo
00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`00
0000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool0[P3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo0000\
\>"],
  ImageRangeCache->{{{0, 610.563}, {170.188, 0}} -> {-0.426205, -0.013998, \
0.00467178, 0.00467178}, {{91.1875, 295.063}, {167.188, 47.3125}} -> \
{-1.34175, -0.0239702, 0.00793648, 0.00793648}, {{315.438, 519.313}, \
{167.188, 47.3125}} -> {-3.12151, -0.0239702, 0.00793648, 0.00793648}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .19724 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0046963 0.47619 [
[.5 .20974 -134 0 ]
[.5 .20974 134 38.75 ]
[ 0 0 0 0 ]
[ 1 .19724 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .0047 m
1 .0047 L
s
.02381 0 m
.02381 .19724 L
s
gsave
.5 .20974 -195 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(Pi) show
153.000 12.750 moveto
(Pi) show
177.000 12.750 moveto
(3) show
189.000 12.750 moveto
(Pi) show
213.000 12.750 moveto
(Pi) show
237.000 12.750 moveto
(Pi) show
261.000 12.750 moveto
(3) show
273.000 12.750 moveto
(Pi) show
297.000 12.750 moveto
(3) show
309.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
153.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
165.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
177.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
189.000 25.875 moveto
(--) show
201.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
213.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
225.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
237.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
249.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
261.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
273.000 25.875 moveto
(--) show
285.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
297.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
309.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
321.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
105.000 39.000 moveto
(8) show
129.000 39.000 moveto
(4) show
153.000 39.000 moveto
(8) show
183.000 39.000 moveto
(8) show
213.000 39.000 moveto
(2) show
237.000 39.000 moveto
(4) show
267.000 39.000 moveto
(8) show
303.000 39.000 moveto
(8) show
309.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .19724 L
0 .19724 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0046963 0.477324 0.192548 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.171573 0.828427 -8.70072e-018 0.828427 [
[ 0 0 0 0 ]
[ 1 .41421 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .41421 L
0 .41421 L
closepath
clip
newpath
0 1 0 r
0 0 m
.41421 0 L
.5 .20711 L
F
0 0 1 r
.41421 0 m
1 0 L
.5 .20711 L
F
1 0 0 r
0 0 m
.5 .20711 L
0 .41421 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.0046963 0.97619 0.192548 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.171573 0.828427 -9.52743e-018 0.828427 [
[ 0 0 0 0 ]
[ 1 .41421 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .41421 L
0 .41421 L
closepath
clip
newpath
0 1 0 r
.17157 0 m
1 0 L
.41421 .24264 L
F
0 0 1 r
0 .41421 m
0 0 L
.17157 0 L
F
1 0 0 r
.17157 0 m
.41421 .24264 L
0 .41421 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.188, 120.563},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000N2000`400?l00000o`00003oN@3oool0
0`000000oooo0?ooo`3o0?ooonP0oooo001i0?ooo`030000003oool0oooo0?l0ooooj03oool00700
ooooo`00002300000740oooo001i0?ooo`<0o`00AP00o`1T0000oa<0oooo7P000?l20?l008d00?l0
O@3oool007T0oooo1@3o0014003o0680003o5@3ooolN0000o`<0o`00RP00o`1o0?ooo`00N@3oool8
0?l004800?l0GP000?lH0?oooad0003o1@3o0026003o0880oooo001i0?ooo`X0o`00@000o`1L0000
oaX0oooo7@000?l60?l008<00?l0Q03oool007T0oooo3@3o000n003o05P0003o7@3ooolL0000o`P0
o`00O`00o`270?ooo`00N@3oool?0?l003`00?l0EP000?lO0?oooa`0003o2@3o001l003o08T0oooo
001i0?oooa40o`00>P00o`1C0000ob80oooo70000?l:0?l007P00?l0S03oool007T0oooo503o000h
003o0500003o903ooolK0000o``0o`00M@00o`2>0?ooo`00N@3ooolF0?l003H00?l0C@000?lW0?oo
oa/0003o3@3o001b003o0900oooo001i0?oooaT0o`00=000o`1:0000obT0oooo6P000?l?0?l006h0
0?l0T`3oool007T0oooo6`3o000b003o04P0003o:`3ooolJ0000oa00o`00J`00o`2E0?ooo`00N@3o
oolM0?l003000?l0A@000?l^0?oooaT0003o4P3o001W003o09P0oooo001i0?ooob00o`00;P00o`12
0000oc00oooo6@000?lC0?l006@00?l0VP3oool007T0oooo8P3o000/003o03l0003o<`3ooolI0000
oa@0o`00H000o`2M0?ooo`00N@3ooolU0?l002X00?l0?0000?le0?oooaP0003o5P3o001M003o09l0
oooo001i0?ooobL0o`00:000o`0i0000ocP0oooo60000?lG0?l005X00?l0X@3oool007T0oooo:P3o
000V003o03H0003o>P3ooolG0000oaT0o`00EP00o`2T0?ooo`00N@3oool/0?l002@00?l0<`000?lm
0?oooaL0003o6P3o001C003o0:H0oooo001i0?ooobh0o`008P00o`0a0000ocl0oooo5`000?lK0?l0
04l00?l0Z@3oool007T0oooo<@3o000P003o02h0003o@@3ooolF0000oad0o`00C000o`2[0?ooo`00
N@3ooolc0?l001h00?l0:`000?m40?oooaH0003o7P3o0018003o0:h0oooo001i0?ooocH0o`007000
o`0X0000odH0oooo5@000?lP0?l004D00?l0/03oool007T0oooo>03o000J003o02D0003oB@3ooolE
0000ob40o`00@P00o`2b0?ooo`00N@3ooolj0?l001P00?l08`000?m;0?oooa@0003o8`3o000n003o
0;D0oooo001i0?ooocd0o`005P00o`0O0000odh0oooo50000?lT0?l003/00?l0]`3oool007T0oooo
?`3o000D003o01d0003oD03ooolD0000obD0o`00=`00o`2j0?ooo`00N@3ooom20?l001800?l06@00
0?mC0?oooa<0003o9`3o000d003o0;`0oooo001i0?oood@0o`004000o`0G0000oeD0oooo4`000?lX
0?l003000?l0_`3oool007T0ooooA`3o000>003o01@0003oE`3ooolB0000obX0o`00;@00o`310?oo
o`00N@3ooom90?l000`00?l04@000?mJ0?oooa80003o:`3o000Z003o0<<0oooo001i0?oood/0o`00
2P00o`0?0000oe`0oooo4P000?l/0?l002H00?l0aP3oool007T0ooooCP3o0008003o00/0003oG`3o
oolA0000obh0o`008`00o`380?ooo`00N@3ooom@0?l000H00?l02@000?mQ0?oooa40003o;`3o000O
003o0</0oooo001i0?oooe<0o`001000o`050000of@0oooo40000?la0?l001`00?l0c@3oool007T0
ooooE@3o0002003o00<0003oIP3oool@0000oc80o`006000o`3@0?ooo`00N@3ooomG0?l006T0oooo
3`000?ld0?l001D00?l0dP3oool007T0ooooE@3o001[0?ooo`l0003o=@3o000B003o0=@0oooo001i
0?oooe<0o`00K@3oool?0000ocH0o`003P00o`3G0?ooo`00N@3ooom@0?l00700oooo3P000?lh0?l0
00/00?l0f@3oool007T0ooooCP3o001b0?ooo`h0003o>@3o0007003o0=`0oooo001i0?oood/0o`00
M@3oool=0000oc/0o`001000o`3N0?ooo`00N@3ooom90?l007L0oooo3@000?ll0?l00>40oooo001i
0?ooodL0o`00N@3oool=0000ocX0o`00h`3oool007T0ooooA03o001l0?ooo``0003o>@3o003U0?oo
o`00N@3ooom20?l007h0oooo30000?lf0?l00>P0oooo001i0?ooocl0o`00P@3oool;0000ocD0o`00
jP3oool007T0oooo?@3o00230?ooo`/0003o<P3o003]0?ooo`00N@3ooolj0?l008H0oooo2P000?la
0?l00>l0oooo001i0?ooocP0o`00R03oool:0000obh0o`00lP3oool007T0oooo=P3o002:0?ooo`X0
003o;03o003d0?ooo`00N@3ooolc0?l008d0oooo2@000?l[0?l00?H0oooo001i0?oooc40o`00S`3o
ool90000obP0o`00n@3oool007T0oooo;P3o002B0?ooo`P0003o9`3o003k0?ooo`00N@3oool/0?l0
09@0oooo20000?lT0?l00?h0oooo001i0?ooobX0o`00UP3oool80000ob80o`00o`3oool10?ooo`00
N@3ooolW0?l009T0oooo1`000?lP0?l00?l0oooo103oool007T0oooo9@3o002K0?ooo`L0003o7P3o
003o0?ooo`H0oooo001i0?ooob80o`00WP3oool60000oad0o`00o`3oool80?ooo`00N@3ooolP0?l0
0:00oooo1P000?lJ0?l00?l0oooo2`3oool007T0oooo7@3o002S0?ooo`D0003o6@3o003o0?ooo`d0
oooo001i0?oooa/0o`00Y@3oool50000oaH0o`00o`3oool@0?ooo`00N@3ooolI0?l00:L0oooo1@00
0?lD0?l00?l0oooo4P3oool007T0oooo5P3o002Z0?ooo`@0003o4P3o003o0?oooaD0oooo001i0?oo
oa@0o`00[03oool40000oa00o`00o`3ooolG0?ooo`00N@3ooolA0?l00:l0oooo0`000?l?0?l00?l0
oooo6@3oool007T0oooo3`3o002a0?ooo`<0003o303o003o0?oooa`0oooo001i0?ooo`d0o`00/`3o
ool30000o`X0o`00o`3ooolN0?ooo`00N@3oool:0?l00;H0oooo0P000?l80?l00?l0oooo8@3oool0
07T0oooo203o002h0?ooo`80003o1P3o003o0?ooob<0oooo001i0?ooo`D0o`00^`3oool00`000?l0
o`000?l000020?l00?l0oooo9P3oool007T0oooo0`3o002m0?ooo`030000o`3o0000o`000?l0oooo
:03oool007T0oooo00<000000?ooo`3oool0o`3ooooX0?ooo`00N@3oool00`000000oooo0?ooo`3o
0?ooonP0oooo001i0?ooo`030000003oool0oooo0?l0ooooj03oool00?l0ooooo`3ooomU0?ooo`00
o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?oo
ofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002k
0?ooo`800000703oool2000001L0oooo0`00000D0?ooo`800000703oool2000001/0oooo1000000F
0?ooo`<000006P3oool200000280oooo0P0000320?ooo`00^P3oool010000000oooo0?ooo`00000J
0?ooo`040000003oool0oooo000001L0oooo00<000000?ooo`3oool04P3oool010000000oooo0?oo
o`00000J0?ooo`040000003oool0oooo000001X0oooo00<000000?ooo`3oool0603oool00`000000
oooo0?ooo`0H0?ooo`040000003oool0oooo00000200oooo00@000000?ooo`3oool00000`@3oool0
0;X0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00000D0?ooo`D000004`3o
ool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001/0oooo00<000000?ooo`3o
ool0503oool5000001T0oooo00@000000?ooo`3oool00000803oool010000000oooo0?ooo`000031
0?ooo`00^`3oool2000001`0oooo0P00000E0?ooo`040000003oool0oooo000001D0oooo0P00000L
0?ooo`8000007@3oool00`000000oooo0?ooo`0C0?ooo`040000003oool0oooo000001/0oooo0P00
000R0?ooo`800000`P3oool00;X0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?oo
o`00000E0?ooo`030000003oool0000001@0oooo00@000000?ooo`3oool000006P3oool010000000
oooo0?ooo`00000J0?ooo`040000003oool0oooo000001D0oooo00<000000?ooo`0000006P3oool0
10000000oooo0?ooo`00000P0?ooo`040000003oool0oooo00000<40oooo002k0?ooo`800000703o
ool2000001L0oooo0P00000E0?ooo`800000703oool2000001`0oooo0P00000G0?ooo`8000006`3o
ool200000280oooo0P0000320?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00/@3oool00`000000oooo0?ooo`3l0?ooo`030000003oool0oooo0;00oooo002`0?ooo`03
0000003oool0oooo01X0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`03
0000003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`03
0000003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`03
0000003oool0oooo0:l0oooo002`0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
8@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
8@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0:l0oooo002`0?ooo`040000003o
ool0oooo0?ooo`@000000P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo
0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo
100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000103oool00`000000oooo
0?ooo`070?ooo`@000000P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo
0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo
100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@000000P3oool400000080oooo
100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@000000P3oool400000080oooo
100000030?ooo`030000003oool0oooo0:l0oooo002_0?ooo`030000003oool0oooo0?l0oooo0@3o
ool00`000000oooo0?ooo`2^0?ooo`00/03oool00`000000oooo0?ooo`3n0?ooo`030000003oool0
oooo0:l0oooo002`0?ooo`030000003oool0oooo0?h0oooo00<000000?ooo`3oool0[`3oool00;40
oooo00<000000?ooo`3oool0o03oool00`000000oooo0?ooo`2`0?ooo`00o`3ooooo0?ooofD0oooo
003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0
ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002e0?ooo`800000203oool3
000000D0oooo0`00000=0?ooo`<000001@3oool3000000d0oooo0`0000050?ooo`<000003@3oool3
000000D0oooo0`00000?0?ooo`800000203oool3000000D0oooo0`00000=0?ooo`<000001@3oool3
000000d0oooo0`0000050?ooo`<000003`3oool2000000P0oooo0`0000050?ooo`<000003`3oool2
000000P0oooo0`0000050?ooo`<00000]@3oool00;@0oooo00@000000?ooo`3oool00000203oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00@000000?ooo`3oool00000203o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3o
ool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3o
ool010000000oooo0?ooo`0000080?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0
3@3oool010000000oooo0?ooo`0000080?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3o
ool0]03oool00;L0oooo00<000000?ooo`3oool01P3oool3000000D0oooo00<000000?ooo`3oool0
3@3oool3000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool0
3@3oool3000000D0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`070?ooo`<00000
1@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<00000
1@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo00L0oooo0`0000050?ooo`030000
003oool0oooo00l0oooo00<000000?ooo`3oool01`3oool3000000D0oooo00<000000?ooo`3oool0
]03oool00;D0oooo0P0000090?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000
003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000?0?oo
o`040000003oool0oooo000000<0oooo0P00000B0?ooo`030000003oool0oooo00H0oooo00@00000
0?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo
00@000000?ooo`3oool000000`3oool200000180oooo00<000000?ooo`3oool01P3oool010000000
oooo0?ooo`0000030?ooo`8000004P3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo
000000<0oooo0P00002f0?ooo`00]@3oool00`000000oooo0?ooo`080?ooo`040000003oool0oooo
000001@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00000D0?ooo`040000
003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00000D
0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000503oool010000000oooo
0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool0
10000000oooo0?ooo`00002k0?ooo`00]@3oool3000000L0oooo100000050?ooo`030000003oool0
oooo00`0oooo100000050?ooo`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0
oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool0
0`000000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool0
0`000000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool03P3oool2
000000P0oooo100000050?ooo`030000003oool0oooo0;@0oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 610.188}, {119.563, 0}} -> {-0.662876, -0.00986444, \
0.00545038, 0.00545038}, {{121.563, 296.313}, {117.75, 45.375}} -> {-1.04699, \
-0.0125241, 0.00690847, 0.00690847}, {{313.813, 488.563}, {117.75, 45.375}} -> \
{-2.37515, -0.0125241, 0.00690847, 0.00690847}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .20661 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00491932 0.47619 [
[.5 .21911 -152 0 ]
[.5 .21911 152 38.75 ]
[ 0 0 0 0 ]
[ 1 .20661 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00492 m
1 .00492 L
s
.02381 0 m
.02381 .20661 L
s
gsave
.5 .21911 -213 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(2) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(3) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(3) show
237.000 12.750 moveto
(Pi) show
261.000 12.750 moveto
(2) show
273.000 12.750 moveto
(Pi) show
297.000 12.750 moveto
(2) show
309.000 12.750 moveto
(Pi) show
333.000 12.750 moveto
(3) show
345.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
(--) show
249.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
261.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
273.000 25.875 moveto
(--) show
285.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
297.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
309.000 25.875 moveto
(--) show
321.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
333.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
345.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
357.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
105.000 39.000 moveto
(7) show
135.000 39.000 moveto
(7) show
165.000 39.000 moveto
(7) show
195.000 39.000 moveto
(7) show
231.000 39.000 moveto
(7) show
267.000 39.000 moveto
(7) show
303.000 39.000 moveto
(7) show
339.000 39.000 moveto
(7) show
345.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .20661 L
0 .20661 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00491932 0.477324 0.201692 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.198062 0.801938 6.55942e-018 0.801938 [
[ 0 0 0 0 ]
[ 1 .43388 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .43388 L
0 .43388 L
closepath
clip
newpath
0 1 0 r
0 0 m
.44504 0 L
.5 .24079 L
F
0 0 1 r
.44504 0 m
1 0 L
.5 .24079 L
F
1 0 0 r
0 0 m
.5 .24079 L
.09903 .43388 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00491932 0.97619 0.201692 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.198062 0.801938 8.83625e-018 0.801938 [
[ 0 0 0 0 ]
[ 1 .43388 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .43388 L
0 .43388 L
closepath
clip
newpath
0 1 0 r
.19806 0 m
1 0 L
.42058 .27903 L
F
0 0 1 r
.09903 .43388 m
0 0 L
.19806 0 L
F
1 0 0 r
.19806 0 m
.42058 .27903 L
.09903 .43388 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.625, 126.375},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000OR000`400?l00000o`00003oM@3oool0
0`000000oooo0?ooo`3o0?ooon`0oooo001e0?ooo`030000003oool0oooo0?l0ooook03oool006/0
ooooo`00002=000006`0oooo001e0?ooo`030000003o0000o`0004d00?l0H@000?lE0?ooob80003o
00<0o`00003o0000o`00R`00o`1h0?ooo`00M@3oool00`000000o`000?l000020?l004/00?l0G`00
0?lG0?ooob80003o0P3o002:003o07X0oooo001e0?ooo`030000003o0000o`0000@0o`00B@00o`1M
0000oaT0oooo8P000?l30?l008L00?l0O03oool007D0oooo00<000000?l0003o00001P3o0017003o
05/0003o6`3ooolR0000o`@0o`00Q000o`1n0?ooo`00M@3oool00`000000oooo0?l000080?l004H0
0?l0F0000?lN0?ooob00003o1@3o0022003o0800oooo001e0?ooo`030000003oool0o`0000X0o`00
A000o`1F0000ob00oooo80000?l60?l007l00?l0PP3oool007D0oooo00<000000?ooo`3o0000303o
0012003o05@0003o8P3ooolP0000o`L0o`00O000o`240?ooo`00M@3oool00`000000oooo0?l0000>
0?l004000?l0DP000?lT0?ooob00003o203o001i003o08H0oooo001e0?ooo`030000003oool0o`00
0100o`00?`00o`1?0000obL0oooo7`000?l90?l007H00?l0R03oool007D0oooo00<000000?ooo`3o
ool04P3o000m003o04d0003o:@3ooolN0000o`X0o`00M000o`2:0?ooo`00M@3oool00`000000oooo
0?ooo`0D0?l003/00?l0BP000?l/0?oooah0003o2`3o001a003o08`0oooo001e0?ooo`030000003o
ool0oooo01H0o`00>@00o`180000obh0oooo7P000?l<0?l006h00?l0SP3oool007D0oooo00<00000
0?ooo`3oool0603o000h003o04D0003o<03ooolN0000o`d0o`00JP00o`2A0?ooo`00M@3oool01000
0000oooo0?ooo`3ooolI0?l003H00?l0@`000?lc0?oooa`0003o3`3o001W003o09<0oooo001e0?oo
o`040000003oool0oooo0?oooa`0o`00<`00o`110000ocD0oooo70000?l?0?l006D00?l0U@3oool0
07D0oooo00@000000?ooo`3oool0oooo7P3o000a003o03l0003o=`3ooolL0000oa00o`00HP00o`2G
0?ooo`00M@3oool010000000oooo0?ooo`3ooolP0?l002l00?l0?@000?li0?oooa`0003o4@3o001O
003o09T0oooo001e0?ooo`040000003oool0oooo0?ooob80o`00;P00o`0j0000oc`0oooo6`000?lB
0?l005`00?l0V`3oool007D0oooo00<000000?ooo`3oool00P3ooolS0?l002`00?l0>0000?ln0?oo
oaX0003o503o001I003o09d0oooo001e0?ooo`030000003oool0oooo0080oooo9@3o000Z003o03H0
003o@03ooolJ0000oa@0o`00E`00o`2O0?ooo`00M@3oool00`000000oooo0?ooo`020?ooobL0o`00
:000o`0d0000od80oooo6P000?lE0?l005@00?l0X@3oool007D0oooo00<000000?ooo`3oool00P3o
oolY0?l002L00?l0<0000?m60?oooaT0003o5P3o001A003o0:<0oooo001e0?ooo`030000003oool0
oooo00<0oooo:P3o000U003o02h0003oB03ooolH0000oaP0o`00CP00o`2U0?ooo`00M@3oool00`00
0000oooo0?ooo`030?ooob`0o`008`00o`0/0000odX0oooo60000?lI0?l004/00?l0Y`3oool007D0
oooo00<000000?ooo`3oool00`3oool^0?l002400?l0:P000?m<0?oooaP0003o6@3o0018003o0:X0
oooo001e0?ooo`030000003oool0oooo00<0oooo<03o000P003o02L0003oCP3ooolH0000oaX0o`00
A@00o`2/0?ooo`00M@3oool00`000000oooo0?ooo`030?oooc80o`007P00o`0U0000oe40oooo5`00
0?lK0?l004800?l0[P3oool007D0oooo00<000000?ooo`3oool0103ooolc0?l001`00?l08`000?mC
0?oooaH0003o7@3o000o003o0;00oooo001e0?ooo`030000003oool0oooo00@0oooo=P3o000I003o
0240003oE@3ooolF0000oah0o`00?000o`2b0?ooo`00M@3oool00`000000oooo0?ooo`040?ooocP0
o`005`00o`0O0000oeL0oooo5P000?lN0?l003X00?l0]03oool007D0oooo00<000000?ooo`3oool0
103ooolj0?l001H00?l070000?mJ0?oooaD0003o7`3o000g003o0;H0oooo001e0?ooo`030000003o
ool0oooo00@0oooo?03o000D003o01X0003oG03ooolE0000ob00o`00=000o`2h0?ooo`00M@3oool0
0`000000oooo0?ooo`050?ooocd0o`004P00o`0G0000oel0oooo50000?lR0?l003400?l0^P3oool0
07D0oooo00<000000?ooo`3oool01@3ooolo0?l001000?l05@000?mQ0?oooa@0003o8`3o000^003o
0;`0oooo001e0?ooo`030000003oool0oooo00D0oooo@@3o000?003o0180003oI03ooolC0000ob<0
o`00;000o`2n0?ooo`00M@3oool00`000000oooo0?ooo`050?oood<0o`003@00o`0@0000ofH0oooo
4`000?lT0?l002T00?l0`03oool007D0oooo00<000000?ooo`3oool01P3ooom40?l000/00?l03P00
0?mX0?oooa80003o9P3o000V003o0<80oooo001e0?ooo`030000003oool0oooo00H0ooooAP3o0009
003o00`0003oJP3ooolB0000obL0o`008P00o`350?ooo`00M@3oool00`000000oooo0?ooo`060?oo
odP0o`002000o`090000of`0oooo4P000?lX0?l001l00?l0a`3oool007D0oooo00<000000?ooo`3o
ool01P3ooom:0?l000H00?l01`000?m_0?oooa40003o:03o000M003o0<T0oooo001e0?ooo`030000
003oool0oooo00H0ooooC03o0004003o00D0003oL@3ooolA0000obT0o`006P00o`3;0?ooo`00M@3o
ool00`000000oooo0?ooo`070?ooodd0o`000P00o`030000og<0oooo40000?l[0?l001L00?l0c@3o
ool007D0oooo00<000000?ooo`3oool01`3ooom?0?l007H0oooo40000?l/0?l001@00?l0c`3oool0
07D0oooo00<000000?ooo`3oool01`3ooom=0?l007T0oooo3`000?l]0?l001400?l0d@3oool007D0
oooo00<000000?ooo`3oool01`3ooom;0?l007/0oooo3`000?l]0?l000l00?l0d`3oool007D0oooo
00<000000?ooo`3oool0203ooom80?l007d0oooo3P000?l_0?l000`00?l0e@3oool007D0oooo00<0
00000?ooo`3oool0203ooom60?l007l0oooo3P000?l`0?l000T00?l0e`3oool007D0oooo00<00000
0?ooo`3oool0203ooom40?l00880oooo3@000?la0?l000H00?l0f@3oool007D0oooo00<000000?oo
o`3oool0203ooom20?l008@0oooo3@000?lb0?l000<00?l0f`3oool007D0oooo00<000000?ooo`3o
ool0203ooom00?l008H0oooo3@000?lb0?l00=h0oooo001e0?ooo`030000003oool0oooo00T0oooo
?@3o00280?ooo``0003o<@3o003P0?ooo`00M@3oool00`000000oooo0?ooo`090?oooc/0o`00RP3o
ool<0000obl0o`00hP3oool007D0oooo00<000000?ooo`3oool02@3oooli0?l008d0oooo2`000?l]
0?l00>@0oooo001e0?ooo`030000003oool0oooo00T0oooo=`3o002?0?ooo`/0003o:`3o003V0?oo
o`00M@3oool00`000000oooo0?ooo`090?ooocD0o`00T@3oool;0000obT0o`00j03oool007D0oooo
00<000000?ooo`3oool02P3ooolb0?l009<0oooo2P000?lX0?l00>X0oooo001e0?ooo`030000003o
ool0oooo00X0oooo<03o002F0?ooo`T0003o9P3o003/0?ooo`00M@3oool00`000000oooo0?ooo`0:
0?ooobh0o`00V03oool90000ob@0o`00kP3oool007D0oooo00<000000?ooo`3oool02P3oool/0?l0
09X0oooo2@000?lR0?l00?00oooo001e0?ooo`030000003oool0oooo00/0oooo:@3o002L0?ooo`P0
003o8@3o003b0?ooo`00M@3oool00`000000oooo0?ooo`0;0?ooobH0o`00X03oool70000oal0o`00
m03oool007D0oooo00<000000?ooo`3oool02`3ooolT0?l00:80oooo1`000?lM0?l00?H0oooo001e
0?ooo`030000003oool0oooo00/0oooo8P3o002T0?ooo`L0003o6`3o003h0?ooo`00M@3oool00`00
0000oooo0?ooo`0;0?ooob00o`00YP3oool70000oaT0o`00nP3oool007D0oooo00<000000?ooo`3o
ool0303ooolM0?l00:P0oooo1P000?lH0?l00?`0oooo001e0?ooo`030000003oool0oooo00`0oooo
6`3o002[0?ooo`D0003o5P3o003n0?ooo`00M@3oool00`000000oooo0?ooo`0<0?oooaT0o`00[@3o
ool50000oa@0o`00o`3oool10?ooo`00M@3oool00`000000oooo0?ooo`0<0?oooaL0o`00[`3oool5
0000oa80o`00o`3oool30?ooo`00M@3oool00`000000oooo0?ooo`0=0?oooa@0o`00/@3oool40000
oa40o`00o`3oool50?ooo`00M@3oool00`000000oooo0?ooo`0=0?oooa80o`00]03oool30000o`l0
o`00o`3oool70?ooo`00M@3oool00`000000oooo0?ooo`0=0?oooa00o`00]P3oool30000o`d0o`00
o`3oool90?ooo`00M@3oool00`000000oooo0?ooo`0=0?ooo`h0o`00^03oool30000o`/0o`00o`3o
ool;0?ooo`00M@3oool00`000000oooo0?ooo`0=0?ooo``0o`00^P3oool30000o`T0o`00o`3oool=
0?ooo`00M@3oool00`000000oooo0?ooo`0>0?ooo`T0o`00_@3oool00`000?l0o`000?l000060?l0
0?l0oooo3`3oool007D0oooo00<000000?ooo`3oool03P3oool70?l00;l0oooo00<0003o0?l0003o
0000103o003o0?oooa40oooo001e0?ooo`030000003oool0oooo00h0oooo1@3o00310?ooo`030000
o`3o0000o`000080o`00o`3ooolC0?ooo`00M@3oool00`000000oooo0?ooo`0>0?ooo`<0o`00``3o
ool00`000?l0o`000?l0003o0?oooaD0oooo001e0?ooo`030000003oool0oooo0?l0ooook03oool0
07D0oooo00<000000?ooo`3oool0o`3oooo/0?ooo`00M@3oool00`000000oooo0?ooo`3o0?ooon`0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?oo
ool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3o
ool00?l0ooooo`3ooomU0?ooo`00ZP3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo
0240oooo00<000000?ooo`3oool0[P3oool00:X0oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`0Q0?ooo`030000003oool0oooo0:h0oooo002Z0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo
00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`2^0?ooo`00Z`3oool00`000000oooo0?oo
o`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?oo
o`0K0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?oo
o`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0[@3oool00:P0oooo00@00000
0?ooo`3oool000006P3oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001X0
oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00000P0?ooo`040000003oool0
oooo00000200oooo00@000000?ooo`3oool00000803oool010000000oooo0?ooo`00000P0?ooo`04
0000003oool0oooo00000:l0oooo002X0?ooo`@000006P3oool4000001X0oooo1000000J0?ooo`@0
00006P3oool400000200oooo1000000P0?ooo`@00000803oool400000200oooo1000002_0?ooo`00
o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?oo
ofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00W`3oool00`000000oooo0?oo
o`3o0?ooob40oooo00<000000?ooo`3oool0WP3oool009h0oooo00<000000?ooo`3oool06P3oool0
0`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool05@3oool0
0`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool0
0`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0W@3oool0
09h0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo
0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo
0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo
0240oooo00<000000?ooo`3oool0W@3oool009h0oooo00@000000?ooo`3oool0oooo100000020?oo
o`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?oo
o`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo100000020?oo
o`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?oo
o`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?oo
o`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?oo
o`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?oo
o`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?oo
o`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000<0oooo00<000000?oo
o`3oool0W@3oool009d0oooo00<000000?ooo`3oool0o`3ooolU0?ooo`030000003oool0oooo09`0
oooo002N0?ooo`030000003oool0oooo0?l0oooo8`3oool00`000000oooo0?ooo`2M0?ooo`00WP3o
ool00`000000oooo0?ooo`3o0?ooob<0oooo00<000000?ooo`3oool0W@3oool009l0oooo00<00000
0?ooo`3oool0o`3ooolQ0?ooo`030000003oool0oooo09h0oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00:@0oooo0`0000060?ooo`<00000
1@3oool3000000d0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`0000050?ooo`<00000
3@3oool3000000D0oooo0`00000?0?ooo`800000203oool3000000D0oooo0`00000?0?ooo`800000
203oool3000000D0oooo0`00000>0?ooo`@000001`3oool3000000D0oooo0`00000>0?ooo`@00000
1`3oool3000000D0oooo0`00000?0?ooo`800000203oool3000000D0oooo0`00002S0?ooo`00Y@3o
ool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool02@3o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3o
ool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3o
ool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3o
ool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3o
ool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`2R0?ooo`00XP3oool5000000L0oooo0`0000050?ooo`03
0000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3o
ool0203oool3000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3o
ool03`3oool00`000000oooo0?ooo`070?ooo`<000001@3oool00`000000oooo0?ooo`0?0?ooo`03
0000003oool0oooo00L0oooo0`0000050?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3o
ool0203oool3000000D0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`080?ooo`<0
00001@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo00L0oooo0`0000050?ooo`03
0000003oool0oooo0:80oooo002R0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3o
ool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool200000140oooo00<00000
0?ooo`3oool01`3oool010000000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?oo
o`0000030?ooo`8000004P3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo000000<0
oooo0P00000B0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool000000`3oool20000
0140oooo00<000000?ooo`3oool01`3oool010000000oooo0?ooo`0000030?ooo`8000004@3oool0
0`000000oooo0?ooo`070?ooo`040000003oool0oooo000000<0oooo0P00000B0?ooo`030000003o
ool0oooo00H0oooo00@000000?ooo`3oool000000`3oool200000:@0oooo002S0?ooo`030000003o
ool0000000P0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00000D0?ooo`04
0000003oool0oooo000000P0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00
000D0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000503oool010000000
oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203o
ool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3o
ool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000:T0oooo002T
0?ooo`8000001`3oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<00000
0?ooo`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo00`0oooo10000005
0?ooo`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`0>
0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo10000005
0?ooo`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`0>
0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool0XP3oool00?l0ooooo`3ooomU0?oo
o`00o`3ooooo0?ooofD0oooo0000\
\>"],
  ImageRangeCache->{{{0, 610.625}, {125.375, 0}} -> {-0.621763, -0.0103329, \
0.00531182, 0.00531182}, {{117, 296.313}, {123.375, 45.625}} -> {-1.06156, \
-0.0139203, 0.00695877, 0.00695877}, {{314.25, 493.563}, {123.375, 45.625}} -> \
{-2.43418, -0.0139203, 0.00695877, 0.00695877}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .22932 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00546003 0.47619 [
[.5 .24182 -146 0 ]
[.5 .24182 146 38.75 ]
[ 0 0 0 0 ]
[ 1 .22932 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00546 m
1 .00546 L
s
.02381 0 m
.02381 .22932 L
s
gsave
.5 .24182 -207 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(3) show
117.000 12.750 moveto
(Pi) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(4) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(2) show
237.000 12.750 moveto
(Pi) show
261.000 12.750 moveto
(4) show
273.000 12.750 moveto
(Pi) show
297.000 12.750 moveto
(Pi) show
321.000 12.750 moveto
(2) show
333.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
(--) show
129.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
141.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
(--) show
249.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
261.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
273.000 25.875 moveto
(--) show
285.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
297.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
309.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
321.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
333.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
345.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
111.000 39.000 moveto
(7) show
141.000 39.000 moveto
(7) show
165.000 39.000 moveto
(7) show
195.000 39.000 moveto
(7) show
231.000 39.000 moveto
(7) show
267.000 39.000 moveto
(7) show
297.000 39.000 moveto
(7) show
327.000 39.000 moveto
(7) show
333.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .22932 L
0 .22932 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00546003 0.477324 0.223861 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.384043 0.615957 6.23416e-019 0.615957 [
[ 0 0 0 0 ]
[ 1 .48157 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .48157 L
0 .48157 L
closepath
clip
newpath
0 1 0 r
.10992 0 m
.28621 0 L
.19806 .38619 L
F
0 0 1 r
.28621 0 m
1 0 L
.19806 .38619 L
F
1 0 0 r
.10992 0 m
.19806 .38619 L
0 .48157 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00546003 0.97619 0.223861 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.384043 0.615957 1.34983e-017 0.615957 [
[ 0 0 0 0 ]
[ 1 .48157 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .48157 L
0 .48157 L
closepath
clip
newpath
0 1 0 r
.38404 0 m
1 0 L
.44504 .26725 L
F
0 0 1 r
.38404 0 m
.44504 .26725 L
0 .48157 L
F
1 0 0 r
0 .48157 m
.10992 0 L
.38404 0 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 140.25},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000S2000`400?l00000o`00003oJ`3oool0
0`000000oooo0?ooo`3o0?ooooH0oooo001[0?ooo`030000003oool0oooo0?l0oooomP3oool006/0
oooo00<000000?ooo`3oool0o`3oooof0?ooo`00H@3ooooo00000:800000H@3oool006/0oooo00<0
00000?ooo`3oool04P3oool00`3o00000?l0003o000N003o08@0003o:P3ooold0?l000030000o`00
o`000?l006l00?l0KP3oool006/0oooo00<000000?ooo`3oool04P3oool00`3o00000?l0003o000N
003o0880003o;03ooolc0?l00080003oK`00o`1`0?ooo`00J`3oool00`000000oooo0?ooo`0B0?oo
o`030?l00000o`000?l001h00?l0P0000?l^0?oooc80o`000`000?m]003o0780oooo001[0?ooo`03
0000003oool0oooo0180oooo00<0o`00003o0000o`007P00o`1n0000oc00oooo<@3o00040000of/0
0?l0M03oool006/0oooo00<000000?ooo`3oool04@3oool30?l001h00?l0O@000?la0?oooc40o`00
1P000?mX003o07H0oooo001[0?ooo`030000003oool0oooo0140oooo0`3o000N003o07/0003o<`3o
oola0?l000H0003oIP00o`1h0?ooo`00J`3oool00`000000oooo0?ooo`0A0?ooo`<0o`007P00o`1i
0000ocD0oooo<03o00070000of@00?l0NP3oool006/0oooo00<000000?ooo`3oool04@3oool30?l0
01h00?l0M`000?lg0?ooobl0o`0020000?mR003o07`0oooo001[0?ooo`030000003oool0oooo0100
oooo103o000M003o07H0003o>03oool_0?l000T0003oH000o`1n0?ooo`00J`3oool00`000000oooo
0?ooo`0@0?ooo`D0o`007000o`1d0000ocX0oooo;P3o000;0000oe`00?l0P@3oool006/0oooo00<0
00000?ooo`3oool0403oool50?l001`00?l0L@000?lm0?ooobh0o`002`000?mJ003o08<0oooo001[
0?ooo`030000003oool0oooo0100oooo1@3o000L003o06l0003o?`3oool]0?l000`0003oF000o`25
0?ooo`00J`3oool00`000000oooo0?ooo`0?0?ooo`H0o`006`00o`1^0000od00oooo;@3o000=0000
oeH00?l0Q`3oool006/0oooo00<000000?ooo`3oool03`3oool70?l001X00?l0K0000?m20?ooob`0
o`003`000?mC003o08T0oooo001[0?ooo`030000003oool0oooo00l0oooo1`3o000J003o06X0003o
A03oool[0?l00100003oD@00o`2;0?ooo`00J`3oool00`000000oooo0?ooo`0?0?ooo`L0o`006P00
o`1X0000odH0oooo:`3o000@0000odl00?l0S@3oool006/0oooo00<000000?ooo`3oool03`3oool7
0?l001T00?l0I`000?m80?ooobX0o`004@000?m=003o08l0oooo001[0?ooo`030000003oool0oooo
00h0oooo203o000I003o06D0003oB@3ooolZ0?l00180003oB`00o`2A0?ooo`00J`3oool00`000000
oooo0?ooo`0>0?ooo`T0o`006000o`1S0000od/0oooo:@3o000D0000odP00?l0T`3oool006/0oooo
00<000000?ooo`3oool03P3oool90?l001P00?l0H@000?m=0?ooobP0o`005@000?m5003o09H0oooo
001[0?ooo`030000003oool0oooo00h0oooo2@3o000H003o05h0003oD03ooolW0?l001H0003o@`00
o`2H0?ooo`00J`3oool00`000000oooo0?ooo`0=0?ooo`X0o`005`00o`1M0000oe40oooo:03o000F
0000od400?l0VP3oool006/0oooo00<000000?ooo`3oool03@3oool;0?l001H00?l0F`000?mC0?oo
obL0o`0060000?ln003o09`0oooo001[0?ooo`030000003oool0oooo00d0oooo2`3o000F003o05T0
003oE@3ooolV0?l001T0003o?000o`2N0?ooo`00J`3oool00`000000oooo0?ooo`0=0?ooo`/0o`00
5P00o`1G0000oeL0oooo9@3o000J0000ocX00?l0X03oool006/0oooo00<000000?ooo`3oool0303o
ool<0?l001D00?l0EP000?mH0?ooobD0o`006`000?lh003o0:80oooo001[0?ooo`030000003oool0
oooo00`0oooo303o000E003o05@0003oFP3ooolU0?l001/0003o=P00o`2T0?ooo`00J`3oool00`00
0000oooo0?ooo`0<0?ooo`d0o`005000o`1B0000oe`0oooo903o000M0000oc<00?l0YP3oool006/0
oooo00<000000?ooo`3oool0303oool=0?l001@00?l0D0000?mN0?ooob<0o`007P000?la003o0:P0
oooo001[0?ooo`030000003oool0oooo00/0oooo3P3o000C003o04l0003oG`3ooolS0?l001l0003o
;P00o`2[0?ooo`00J`3oool00`000000oooo0?ooo`0;0?ooo`h0o`004`00o`1<0000of80oooo8P3o
000P0000ob`00?l0[@3oool006/0oooo00<000000?ooo`3oool02`3oool?0?l001800?l0BP000?mT
0?ooob80o`008@000?lY003o0:l0oooo001[0?ooo`030000003oool0oooo00/0oooo3`3o000B003o
04P0003oIP3ooolQ0?l00280003o9`00o`2a0?ooo`00J`3oool00`000000oooo0?ooo`0;0?ooo`l0
o`004@00o`170000ofP0oooo803o000S0000obD00?l0/`3oool006/0oooo00<000000?ooo`3oool0
2P3oool@0?l001400?l0A@000?mY0?ooob00o`0090000?lS003o0;D0oooo001[0?ooo`030000003o
ool0oooo00X0oooo403o000A003o04<0003oJ`3ooolO0?l002D0003o8@00o`2g0?ooo`00J`3oool0
0`000000oooo0?ooo`0:0?oooa40o`004000o`110000ofd0oooo7P3o000W0000oah00?l0^@3oool0
06/0oooo00<000000?ooo`3oool02P3ooolA0?l001000?l0?`000?m_0?oooah0o`009`000?lL003o
0;/0oooo001[0?ooo`030000003oool0oooo00T0oooo4P3o000?003o03h0003oL03ooolN0?l002P0
003o6P00o`2m0?ooo`00J`3oool00`000000oooo0?ooo`090?oooa80o`003`00o`0l0000og80oooo
7@3o000Y0000oaL00?l0`03oool006/0oooo00<000000?ooo`3oool02@3ooolC0?l000h00?l0>P00
0?md0?oooa`0o`00:`000?lD003o0<80oooo001[0?ooo`030000003oool0oooo00T0oooo4`3o000>
003o03L0003oM`3ooolK0?l002`0003o4P00o`340?ooo`00J`3oool00`000000oooo0?ooo`080?oo
oa@0o`003@00o`0f0000ogP0oooo703o000/0000oa000?l0aP3oool006/0oooo00<000000?ooo`3o
ool0203ooolD0?l000d00?l0=0000?mj0?oooa/0o`00;@000?l>003o0<P0oooo001[0?ooo`030000
003oool0oooo00P0oooo503o000=003o0380003oO03ooolJ0?l002h0003o3000o`3:0?ooo`00J`3o
ool00`000000oooo0?ooo`080?oooaD0o`003000o`0`0000ogh0oooo6@3o000`0000o`T00?l0c03o
ool006/0oooo00<000000?ooo`3oool0203ooolE0?l000/00?l0;`000?n00?oooaP0o`00<@000?l7
003o0<h0oooo001[0?ooo`030000003oool0oooo00L0oooo5P3o000;003o02d0003oP@3ooolI0?l0
0340003o1@00o`3@0?ooo`00J`3oool00`000000oooo0?ooo`070?oooaH0o`002`00o`0[0000oh<0
oooo603o000b0000o`<00?l0dP3oool006/0oooo00<000000?ooo`3oool01`3ooolG0?l000X00?l0
:@000?n50?oooaL0o`00<`000?oE0?ooo`00J`3oool00`000000oooo0?ooo`070?oooaL0o`002@00
o`0X0000ohL0oooo5P3o000b0000omL0oooo001[0?ooo`030000003oool0oooo00H0oooo603o0009
003o02D0003oR@3ooolF0?l00340003of@3oool006/0oooo00<000000?ooo`3oool01P3ooolH0?l0
00T00?l08`000?n;0?oooaH0o`00;`000?oK0?ooo`00J`3oool00`000000oooo0?ooo`060?oooaP0
o`002@00o`0Q0000ohd0oooo5@3o000^0000omd0oooo001[0?ooo`030000003oool0oooo00H0oooo
6@3o0008003o01l0003oS`3ooolD0?l002d0003og`3oool006/0oooo00<000000?ooo`3oool01@3o
oolJ0?l000L00?l07P000?n@0?oooa@0o`00;0000?oQ0?ooo`00J`3oool00`000000oooo0?ooo`05
0?oooaX0o`001`00o`0L0000oi80oooo4`3o000[0000on<0oooo001[0?ooo`030000003oool0oooo
00D0oooo6P3o0007003o01X0003oU03ooolB0?l002X0003oi@3oool006/0oooo00<000000?ooo`3o
ool01@3ooolK0?l000H00?l060000?nF0?oooa80o`00:0000?oW0?ooo`00J`3oool00`000000oooo
0?ooo`040?oooa`0o`001@00o`0G0000oiL0oooo4P3o000V0000onX0oooo001[0?ooo`030000003o
ool0oooo00@0oooo703o0005003o01D0003oV@3ooolA0?l002D0003ok03oool006/0oooo00<00000
0?ooo`3oool0103ooolL0?l000D00?l04P000?nL0?oooa00o`0090000?o^0?ooo`00J`3oool00`00
0000oooo0?ooo`040?oooa`0o`001@00o`0@0000oih0oooo3`3o000S0000oo00oooo001[0?ooo`03
0000003oool0oooo00@0oooo7@3o0003003o00l0003oX03oool?0?l00240003olP3oool006/0oooo
00<000000?ooo`3oool00`3ooolN0?l000<00?l03@000?nQ0?ooo`l0o`0080000?od0?ooo`00J`3o
ool00`000000oooo0?ooo`030?oooah0o`000`00o`0;0000oj<0oooo3P3o000O0000ooH0oooo001[
0?ooo`030000003oool0oooo00<0oooo7P3o0003003o00T0003oY@3oool=0?l001h0003on03oool0
06/0oooo00<000000?ooo`3oool00`3ooolO0?l00003003o00000?l0003o00H0003oY`3oool<0?l0
01d0003onP3oool006/0oooo00<000000?ooo`3oool00P3ooolP0?l00003003o00000?l0003o00@0
003oZ03oool=0?l001/0003oo03oool006/0oooo00<000000?ooo`3oool00P3ooolP0?l00003003o
00000?l0003o0080003oZP3oool<0?l001T0003oo`3oool006/0oooo00<000000?ooo`3oool00P3o
oolP0?l00003003o00000?l0003o0:`0oooo2`3o000H0000ool0oooo0P3oool006/0oooo00<00000
0?ooo`3oool00P3ooolP0?l00:l0oooo2P3o000G0000ool0oooo103oool006/0oooo00@000000?oo
o`3oool0oooo7`3o002`0?ooo`X0o`005P000?oo0?ooo`H0oooo001[0?ooo`040000003oool0oooo
0?oooad0o`00/P3oool90?l001D0003oo`3oool80?ooo`00J`3oool010000000oooo0?ooo`3ooolK
0?l00;@0oooo2@3o000C0000ool0oooo2P3oool006/0oooo00@000000?ooo`3oool0oooo6@3o002f
0?ooo`P0o`004P000?oo0?ooo``0oooo001[0?ooo`040000003oool0oooo0?oooaL0o`00^03oool7
0?l00140003oo`3oool>0?ooo`00J`3oool00`000000oooo0?ooo`0F0?l00;T0oooo1`3o000@0000
ool0oooo403oool006/0oooo00<000000?ooo`3oool0503o002k0?ooo`H0o`003`000?oo0?oooa80
oooo001[0?ooo`030000003oool0oooo0180o`00_@3oool60?l000`0003oo`3ooolE0?ooo`00J`3o
ool00`000000oooo0?ooo`0@0?l00;l0oooo1@3o000;0000ool0oooo5`3oool006/0oooo00<00000
0?ooo`3o00003P3o00300?ooo`D0o`002P000?oo0?oooaT0oooo001[0?ooo`030000003oool0o`00
00`0o`00`P3oool40?l000T0003oo`3ooolK0?ooo`00J`3oool00`000000oooo0?l0000:0?l00<@0
oooo0`3o00080000ool0oooo7@3oool006/0oooo00<000000?ooo`3o0000203o00360?ooo`<0o`00
1P000?oo0?oooal0oooo001[0?ooo`030000003o0000o`0000H0o`00a`3oool30?l000D0003oo`3o
oolQ0?ooo`00J`3oool00`000000o`000?l000040?l00<T0oooo0P3o00040000ool0oooo8`3oool0
06/0oooo00<000000?l0003o00000P3o003;0?ooo`040?l000000?l0003o0000ool0oooo9@3oool0
06/0oooo00<000000?l0003o0000c@3oool20000ool0oooo9`3oool006/0oooo00<000000?ooo`3o
ool0o`3oooof0?ooo`00J`3oool00`000000oooo0?ooo`3o0?ooooH0oooo001[0?ooo`030000003o
ool0oooo0?l0oooomP3oool006/0oooo00<000000?ooo`3oool0o`3oooof0?ooo`00o`3ooooo0?oo
ofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o
0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0oooo
I@3oool00;00oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?ooo`030000003o
ool0oooo01D0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0Q0?ooo`030000003o
ool0oooo0240oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003o
ool0oooo0;@0oooo002`0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool06`3oool0
0`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool08@3oool0
0`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool0
0`000000oooo0?ooo`2d0?ooo`00/03oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool0]03oool00;40oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`0K0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`0K0?ooo`030000003oool0oooo0;<0oooo002^0?ooo`040000003oool0oooo00000200
oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00000D0?ooo`040000003oool0
oooo000001X0oooo00@000000?ooo`3oool00000803oool010000000oooo0?ooo`00000P0?ooo`04
0000003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00
002e0?ooo`00[P3oool400000200oooo1000000J0?ooo`@00000503oool4000001X0oooo1000000P
0?ooo`@00000803oool4000001X0oooo1000000J0?ooo`@00000]@3oool00?l0ooooo`3ooomU0?oo
o`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo
0?ooofD0oooo003o0?ooool0ooooI@3oool00:D0oooo00<000000?ooo`3oool0o`3ooolE0?ooo`03
0000003oool0oooo0:@0oooo002T0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0
8@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
8@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0:<0oooo002T0?ooo`030000003o
ool0oooo01X0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000003o
ool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003o
ool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003o
ool0oooo0:<0oooo002T0?ooo`040000003oool0oooo0?ooo`@000000P3oool400000080oooo1000
00020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo1000
00020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<0
00000?ooo`3oool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo1000
00020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo1000
00020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo1000
00020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo1000
00020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo1000
00020?ooo`@000000`3oool00`000000oooo0?ooo`2S0?ooo`00X`3oool00`000000oooo0?ooo`3o
0?oooaT0oooo00<000000?ooo`3oool0XP3oool00:@0oooo00<000000?ooo`3oool0o`3ooolG0?oo
o`030000003oool0oooo0:<0oooo002T0?ooo`030000003oool0oooo0?l0oooo5`3oool00`000000
oooo0?ooo`2S0?ooo`00Y@3oool00`000000oooo0?ooo`3o0?oooaD0oooo00<000000?ooo`3oool0
Y03oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00Z@3oool2000000P0oooo0`0000050?ooo`<000003`3oool2000000P0oooo0`0000050?oo
o`<000003@3oool3000000D0oooo0`00000=0?ooo`<000001@3oool300000100oooo0`0000060?oo
o`<000001@3oool3000000h0oooo100000070?ooo`<000001@3oool300000100oooo0`0000060?oo
o`<000001@3oool3000000d0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`0000050?oo
o`<00000Z@3oool00:P0oooo00@000000?ooo`3oool00000203oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo00d0oooo00@000000?ooo`3oool00000203oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo0:P0oooo002Z0?ooo`030000003oool0oooo00L0oooo0`0000050?oo
o`030000003oool0oooo00l0oooo00<000000?ooo`3oool01`3oool3000000D0oooo00<000000?oo
o`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?oo
o`3oool03@3oool5000000L0oooo0`0000050?ooo`030000003oool0oooo00h0oooo00<000000?oo
o`3oool0203oool3000000D0oooo00<000000?ooo`3oool03@3oool5000000L0oooo0`0000050?oo
o`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo00h0oooo00<000000?oo
o`3oool0203oool3000000D0oooo00<000000?ooo`3oool0Z03oool00:/0oooo00<000000?ooo`3o
ool01P3oool010000000oooo0?ooo`0000030?ooo`8000004P3oool00`000000oooo0?ooo`060?oo
o`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00
000?0?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000P0
oooo00@000000?ooo`3oool000000`3oool200000140oooo00<000000?ooo`3oool01`3oool01000
0000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000080?ooo`040000003o
ool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000A0?ooo`03
0000003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool200000:X0oooo002X0?ooo`04
0000003oool0oooo000000P0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00
00080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000503oool010000000
oooo0?ooo`00000E0?ooo`030000003oool0000000P0oooo00@000000?ooo`3oool00000503oool0
10000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001D0oooo00<000000?ooo`000000
203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?oo
o`3oool00000203oool010000000oooo0?ooo`00002_0?ooo`00Z@3oool2000000P0oooo10000005
0?ooo`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`0<
0?ooo`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0?
0?ooo`8000001`3oool4000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo10000005
0?ooo`030000003oool0oooo00l0oooo0P0000070?ooo`@000001@3oool00`000000oooo0?ooo`0<
0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<00000
0?ooo`3oool0Z03oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo0000\
\>"],
  ImageRangeCache->{{{0, 610.563}, {139.25, 0}} -> {-0.542588, -0.0114686, \
0.00505301, 0.00505301}, {{107.375, 295.813}, {136.938, 46.1875}} -> \
{-1.5486, -0.0199454, 0.00861562, 0.00861562}, {{314.688, 503.125}, {136.938, \
46.1875}} -> {-3.33473, -0.0199454, 0.00861562, 0.00861562}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .22932 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00546003 0.47619 [
[.5 .24182 -146 0 ]
[.5 .24182 146 38.75 ]
[ 0 0 0 0 ]
[ 1 .22932 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00546 m
1 .00546 L
s
.02381 0 m
.02381 .22932 L
s
gsave
.5 .24182 -207 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(3) show
117.000 12.750 moveto
(Pi) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(4) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(2) show
237.000 12.750 moveto
(Pi) show
261.000 12.750 moveto
(4) show
273.000 12.750 moveto
(Pi) show
297.000 12.750 moveto
(Pi) show
321.000 12.750 moveto
(2) show
333.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
(--) show
129.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
141.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
(--) show
249.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
261.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
273.000 25.875 moveto
(--) show
285.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
297.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
309.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
321.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
333.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
345.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
111.000 39.000 moveto
(7) show
141.000 39.000 moveto
(7) show
165.000 39.000 moveto
(7) show
195.000 39.000 moveto
(7) show
231.000 39.000 moveto
(7) show
267.000 39.000 moveto
(7) show
297.000 39.000 moveto
(7) show
327.000 39.000 moveto
(7) show
333.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .22932 L
0 .22932 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00546003 0.477324 0.223861 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.384043 0.615957 6.23416e-019 0.615957 [
[ 0 0 0 0 ]
[ 1 .48157 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .48157 L
0 .48157 L
closepath
clip
newpath
0 1 0 r
.10992 0 m
.28621 0 L
.19806 .38619 L
F
0 0 1 r
.28621 0 m
1 0 L
.19806 .38619 L
F
1 0 0 r
.10992 0 m
.19806 .38619 L
0 .48157 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00546003 0.97619 0.223861 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.384043 0.615957 1.34983e-017 0.615957 [
[ 0 0 0 0 ]
[ 1 .48157 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .48157 L
0 .48157 L
closepath
clip
newpath
0 1 0 r
.38404 0 m
1 0 L
.44504 .26725 L
F
0 0 1 r
0 .48157 m
.10992 0 L
.38404 0 L
F
1 0 0 r
.38404 0 m
.44504 .26725 L
0 .48157 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 140.25},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000S2000`400?l00000o`00003oJ`3oool0
0`000000oooo0?ooo`3o0?ooooH0oooo001[0?ooo`030000003oool0oooo0?l0oooomP3oool006/0
oooo00<000000?ooo`3oool0o`3oooof0?ooo`00H@3ooooo00000:800000H@3oool006/0oooo00<0
00000?ooo`3oool04P3oool00`3o00000?l0003o000N003o08@0003o:P3ooold0000o`030?l00000
o`000?l006l00?l0KP3oool006/0oooo00<000000?ooo`3oool04P3oool00`3o00000?l0003o000N
003o0880003o;03ooolc0000o`80o`00K`00o`1`0?ooo`00J`3oool00`000000oooo0?ooo`0B0?oo
o`030?l00000o`000?l001h00?l0P0000?l^0?oooc80003o0`3o001]003o0780oooo001[0?ooo`03
0000003oool0oooo0180oooo00<0o`00003o0000o`007P00o`1n0000oc00oooo<@000?l40?l006/0
0?l0M03oool006/0oooo00<000000?ooo`3oool04@3oool30?l001h00?l0O@000?la0?oooc40003o
1P3o001X003o07H0oooo001[0?ooo`030000003oool0oooo0140oooo0`3o000N003o07/0003o<`3o
oola0000o`H0o`00IP00o`1h0?ooo`00J`3oool00`000000oooo0?ooo`0A0?ooo`<0o`007P00o`1i
0000ocD0oooo<0000?l70?l006@00?l0NP3oool006/0oooo00<000000?ooo`3oool04@3oool30?l0
01h00?l0M`000?lg0?ooobl0003o203o001R003o07`0oooo001[0?ooo`030000003oool0oooo0100
oooo103o000M003o07H0003o>03oool_0000o`T0o`00H000o`1n0?ooo`00J`3oool00`000000oooo
0?ooo`0@0?ooo`D0o`007000o`1d0000ocX0oooo;P000?l;0?l005`00?l0P@3oool006/0oooo00<0
00000?ooo`3oool0403oool50?l001`00?l0L@000?lm0?ooobh0003o2`3o001J003o08<0oooo001[
0?ooo`030000003oool0oooo0100oooo1@3o000L003o06l0003o?`3oool]0000o``0o`00F000o`25
0?ooo`00J`3oool00`000000oooo0?ooo`0?0?ooo`H0o`006`00o`1^0000od00oooo;@000?l=0?l0
05H00?l0Q`3oool006/0oooo00<000000?ooo`3oool03`3oool70?l001X00?l0K0000?m20?ooob`0
003o3`3o001C003o08T0oooo001[0?ooo`030000003oool0oooo00l0oooo1`3o000J003o06X0003o
A03oool[0000oa00o`00D@00o`2;0?ooo`00J`3oool00`000000oooo0?ooo`0?0?ooo`L0o`006P00
o`1X0000odH0oooo:`000?l@0?l004l00?l0S@3oool006/0oooo00<000000?ooo`3oool03`3oool7
0?l001T00?l0I`000?m80?ooobX0003o4@3o001=003o08l0oooo001[0?ooo`030000003oool0oooo
00h0oooo203o000I003o06D0003oB@3ooolZ0000oa80o`00B`00o`2A0?ooo`00J`3oool00`000000
oooo0?ooo`0>0?ooo`T0o`006000o`1S0000od/0oooo:@000?lD0?l004P00?l0T`3oool006/0oooo
00<000000?ooo`3oool03P3oool90?l001P00?l0H@000?m=0?ooobP0003o5@3o0015003o09H0oooo
001[0?ooo`030000003oool0oooo00h0oooo2@3o000H003o05h0003oD03ooolW0000oaH0o`00@`00
o`2H0?ooo`00J`3oool00`000000oooo0?ooo`0=0?ooo`X0o`005`00o`1M0000oe40oooo:0000?lF
0?l004400?l0VP3oool006/0oooo00<000000?ooo`3oool03@3oool;0?l001H00?l0F`000?mC0?oo
obL0003o603o000n003o09`0oooo001[0?ooo`030000003oool0oooo00d0oooo2`3o000F003o05T0
003oE@3ooolV0000oaT0o`00?000o`2N0?ooo`00J`3oool00`000000oooo0?ooo`0=0?ooo`/0o`00
5P00o`1G0000oeL0oooo9@000?lJ0?l003X00?l0X03oool006/0oooo00<000000?ooo`3oool0303o
ool<0?l001D00?l0EP000?mH0?ooobD0003o6`3o000h003o0:80oooo001[0?ooo`030000003oool0
oooo00`0oooo303o000E003o05@0003oFP3ooolU0000oa/0o`00=P00o`2T0?ooo`00J`3oool00`00
0000oooo0?ooo`0<0?ooo`d0o`005000o`1B0000oe`0oooo90000?lM0?l003<00?l0YP3oool006/0
oooo00<000000?ooo`3oool0303oool=0?l001@00?l0D0000?mN0?ooob<0003o7P3o000a003o0:P0
oooo001[0?ooo`030000003oool0oooo00/0oooo3P3o000C003o04l0003oG`3ooolS0000oal0o`00
;P00o`2[0?ooo`00J`3oool00`000000oooo0?ooo`0;0?ooo`h0o`004`00o`1<0000of80oooo8P00
0?lP0?l002`00?l0[@3oool006/0oooo00<000000?ooo`3oool02`3oool?0?l001800?l0BP000?mT
0?ooob80003o8@3o000Y003o0:l0oooo001[0?ooo`030000003oool0oooo00/0oooo3`3o000B003o
04P0003oIP3ooolQ0000ob80o`009`00o`2a0?ooo`00J`3oool00`000000oooo0?ooo`0;0?ooo`l0
o`004@00o`170000ofP0oooo80000?lS0?l002D00?l0/`3oool006/0oooo00<000000?ooo`3oool0
2P3oool@0?l001400?l0A@000?mY0?ooob00003o903o000S003o0;D0oooo001[0?ooo`030000003o
ool0oooo00X0oooo403o000A003o04<0003oJ`3ooolO0000obD0o`008@00o`2g0?ooo`00J`3oool0
0`000000oooo0?ooo`0:0?oooa40o`004000o`110000ofd0oooo7P000?lW0?l001h00?l0^@3oool0
06/0oooo00<000000?ooo`3oool02P3ooolA0?l001000?l0?`000?m_0?oooah0003o9`3o000L003o
0;/0oooo001[0?ooo`030000003oool0oooo00T0oooo4P3o000?003o03h0003oL03ooolN0000obP0
o`006P00o`2m0?ooo`00J`3oool00`000000oooo0?ooo`090?oooa80o`003`00o`0l0000og80oooo
7@000?lY0?l001L00?l0`03oool006/0oooo00<000000?ooo`3oool02@3ooolC0?l000h00?l0>P00
0?md0?oooa`0003o:`3o000D003o0<80oooo001[0?ooo`030000003oool0oooo00T0oooo4`3o000>
003o03L0003oM`3ooolK0000ob`0o`004P00o`340?ooo`00J`3oool00`000000oooo0?ooo`080?oo
oa@0o`003@00o`0f0000ogP0oooo70000?l/0?l001000?l0aP3oool006/0oooo00<000000?ooo`3o
ool0203ooolD0?l000d00?l0=0000?mj0?oooa/0003o;@3o000>003o0<P0oooo001[0?ooo`030000
003oool0oooo00P0oooo503o000=003o0380003oO03ooolJ0000obh0o`003000o`3:0?ooo`00J`3o
ool00`000000oooo0?ooo`080?oooaD0o`003000o`0`0000ogh0oooo6@000?l`0?l000T00?l0c03o
ool006/0oooo00<000000?ooo`3oool0203ooolE0?l000/00?l0;`000?n00?oooaP0003o<@3o0007
003o0<h0oooo001[0?ooo`030000003oool0oooo00L0oooo5P3o000;003o02d0003oP@3ooolI0000
oc40o`001@00o`3@0?ooo`00J`3oool00`000000oooo0?ooo`070?oooaH0o`002`00o`0[0000oh<0
oooo60000?lb0?l000<00?l0dP3oool006/0oooo00<000000?ooo`3oool01`3ooolG0?l000X00?l0
:@000?n50?oooaL0003o<`3o003E0?ooo`00J`3oool00`000000oooo0?ooo`070?oooaL0o`002@00
o`0X0000ohL0oooo5P000?lb0?l00=L0oooo001[0?ooo`030000003oool0oooo00H0oooo603o0009
003o02D0003oR@3ooolF0000oc40o`00f@3oool006/0oooo00<000000?ooo`3oool01P3ooolH0?l0
00T00?l08`000?n;0?oooaH0003o;`3o003K0?ooo`00J`3oool00`000000oooo0?ooo`060?oooaP0
o`002@00o`0Q0000ohd0oooo5@000?l^0?l00=d0oooo001[0?ooo`030000003oool0oooo00H0oooo
6@3o0008003o01l0003oS`3ooolD0000obd0o`00g`3oool006/0oooo00<000000?ooo`3oool01@3o
oolJ0?l000L00?l07P000?n@0?oooa@0003o;03o003Q0?ooo`00J`3oool00`000000oooo0?ooo`05
0?oooaX0o`001`00o`0L0000oi80oooo4`000?l[0?l00><0oooo001[0?ooo`030000003oool0oooo
00D0oooo6P3o0007003o01X0003oU03ooolB0000obX0o`00i@3oool006/0oooo00<000000?ooo`3o
ool01@3ooolK0?l000H00?l060000?nF0?oooa80003o:03o003W0?ooo`00J`3oool00`000000oooo
0?ooo`040?oooa`0o`001@00o`0G0000oiL0oooo4P000?lV0?l00>X0oooo001[0?ooo`030000003o
ool0oooo00@0oooo703o0005003o01D0003oV@3ooolA0000obD0o`00k03oool006/0oooo00<00000
0?ooo`3oool0103ooolL0?l000D00?l04P000?nL0?oooa00003o903o003^0?ooo`00J`3oool00`00
0000oooo0?ooo`040?oooa`0o`001@00o`0@0000oih0oooo3`000?lS0?l00?00oooo001[0?ooo`03
0000003oool0oooo00@0oooo7@3o0003003o00l0003oX03oool?0000ob40o`00lP3oool006/0oooo
00<000000?ooo`3oool00`3ooolN0?l000<00?l03@000?nQ0?ooo`l0003o803o003d0?ooo`00J`3o
ool00`000000oooo0?ooo`030?oooah0o`000`00o`0;0000oj<0oooo3P000?lO0?l00?H0oooo001[
0?ooo`030000003oool0oooo00<0oooo7P3o0003003o00T0003oY@3oool=0000oah0o`00n03oool0
06/0oooo00<000000?ooo`3oool00`3ooolO0?l00003003o00000?l0003o00H0003oY`3oool<0000
oad0o`00nP3oool006/0oooo00<000000?ooo`3oool00P3ooolP0?l00003003o00000?l0003o00@0
003oZ03oool=0000oa/0o`00o03oool006/0oooo00<000000?ooo`3oool00P3ooolP0?l00003003o
00000?l0003o0080003oZP3oool<0000oaT0o`00o`3oool006/0oooo00<000000?ooo`3oool00P3o
oolP0?l00003003o00000?l0003o0:`0oooo2`000?lH0?l00?l0oooo0P3oool006/0oooo00<00000
0?ooo`3oool00P3ooolP0?l00:l0oooo2P000?lG0?l00?l0oooo103oool006/0oooo00@000000?oo
o`3oool0oooo7`3o002`0?ooo`X0003o5P3o003o0?ooo`H0oooo001[0?ooo`040000003oool0oooo
0?oooad0o`00/P3oool90000oaD0o`00o`3oool80?ooo`00J`3oool010000000oooo0?ooo`3ooolK
0?l00;@0oooo2@000?lC0?l00?l0oooo2P3oool006/0oooo00@000000?ooo`3oool0oooo6@3o002f
0?ooo`P0003o4P3o003o0?ooo``0oooo001[0?ooo`040000003oool0oooo0?oooaL0o`00^03oool7
0000oa40o`00o`3oool>0?ooo`00J`3oool00`000000oooo0?ooo`0F0?l00;T0oooo1`000?l@0?l0
0?l0oooo403oool006/0oooo00<000000?ooo`3oool0503o002k0?ooo`H0003o3`3o003o0?oooa80
oooo001[0?ooo`030000003oool0oooo0180o`00_@3oool60000o``0o`00o`3ooolE0?ooo`00J`3o
ool00`000000oooo0?ooo`0@0?l00;l0oooo1@000?l;0?l00?l0oooo5`3oool006/0oooo00<00000
0?ooo`3o00003P3o00300?ooo`D0003o2P3o003o0?oooaT0oooo001[0?ooo`030000003oool0o`00
00`0o`00`P3oool40000o`T0o`00o`3ooolK0?ooo`00J`3oool00`000000oooo0?l0000:0?l00<@0
oooo0`000?l80?l00?l0oooo7@3oool006/0oooo00<000000?ooo`3o0000203o00360?ooo`<0003o
1P3o003o0?oooal0oooo001[0?ooo`030000003o0000o`0000H0o`00a`3oool30000o`D0o`00o`3o
oolQ0?ooo`00J`3oool00`000000o`000?l000040?l00<T0oooo0P000?l40?l00?l0oooo8`3oool0
06/0oooo00<000000?l0003o00000P3o003;0?ooo`040000o`3o0000o`000?l00?l0oooo9@3oool0
06/0oooo00<000000?l0003o0000c@3oool20?l00?l0oooo9`3oool006/0oooo00<000000?ooo`3o
ool0o`3oooof0?ooo`00J`3oool00`000000oooo0?ooo`3o0?ooooH0oooo001[0?ooo`030000003o
ool0oooo0?l0oooomP3oool006/0oooo00<000000?ooo`3oool0o`3oooof0?ooo`00o`3ooooo0?oo
ofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o
0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0oooo
I@3oool00;00oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?ooo`030000003o
ool0oooo01D0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0Q0?ooo`030000003o
ool0oooo0240oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003o
ool0oooo0;@0oooo002`0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool06`3oool0
0`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool08@3oool0
0`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool0
0`000000oooo0?ooo`2d0?ooo`00/03oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool0]03oool00;40oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`0K0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`0K0?ooo`030000003oool0oooo0;<0oooo002^0?ooo`040000003oool0oooo00000200
oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00000D0?ooo`040000003oool0
oooo000001X0oooo00@000000?ooo`3oool00000803oool010000000oooo0?ooo`00000P0?ooo`04
0000003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00
002e0?ooo`00[P3oool400000200oooo1000000J0?ooo`@00000503oool4000001X0oooo1000000P
0?ooo`@00000803oool4000001X0oooo1000000J0?ooo`@00000]@3oool00?l0ooooo`3ooomU0?oo
o`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo
0?ooofD0oooo003o0?ooool0ooooI@3oool00:D0oooo00<000000?ooo`3oool0o`3ooolE0?ooo`03
0000003oool0oooo0:@0oooo002T0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0
8@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
8@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0:<0oooo002T0?ooo`030000003o
ool0oooo01X0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000003o
ool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003o
ool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003o
ool0oooo0:<0oooo002T0?ooo`040000003oool0oooo0?ooo`@000000P3oool400000080oooo1000
00020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo1000
00020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<0
00000?ooo`3oool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo1000
00020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo1000
00020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo1000
00020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo1000
00020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo1000
00020?ooo`@000000`3oool00`000000oooo0?ooo`2S0?ooo`00X`3oool00`000000oooo0?ooo`3o
0?oooaT0oooo00<000000?ooo`3oool0XP3oool00:@0oooo00<000000?ooo`3oool0o`3ooolG0?oo
o`030000003oool0oooo0:<0oooo002T0?ooo`030000003oool0oooo0?l0oooo5`3oool00`000000
oooo0?ooo`2S0?ooo`00Y@3oool00`000000oooo0?ooo`3o0?oooaD0oooo00<000000?ooo`3oool0
Y03oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00Z@3oool2000000P0oooo0`0000050?ooo`<000003`3oool2000000P0oooo0`0000050?oo
o`<000003@3oool3000000D0oooo0`00000=0?ooo`<000001@3oool300000100oooo0`0000060?oo
o`<000001@3oool3000000h0oooo100000070?ooo`<000001@3oool300000100oooo0`0000060?oo
o`<000001@3oool3000000d0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`0000050?oo
o`<00000Z@3oool00:P0oooo00@000000?ooo`3oool00000203oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo00d0oooo00@000000?ooo`3oool00000203oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo0:P0oooo002Z0?ooo`030000003oool0oooo00L0oooo0`0000050?oo
o`030000003oool0oooo00l0oooo00<000000?ooo`3oool01`3oool3000000D0oooo00<000000?oo
o`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?oo
o`3oool03@3oool5000000L0oooo0`0000050?ooo`030000003oool0oooo00h0oooo00<000000?oo
o`3oool0203oool3000000D0oooo00<000000?ooo`3oool03@3oool5000000L0oooo0`0000050?oo
o`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo00h0oooo00<000000?oo
o`3oool0203oool3000000D0oooo00<000000?ooo`3oool0Z03oool00:/0oooo00<000000?ooo`3o
ool01P3oool010000000oooo0?ooo`0000030?ooo`8000004P3oool00`000000oooo0?ooo`060?oo
o`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00
000?0?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000P0
oooo00@000000?ooo`3oool000000`3oool200000140oooo00<000000?ooo`3oool01`3oool01000
0000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000080?ooo`040000003o
ool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000A0?ooo`03
0000003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool200000:X0oooo002X0?ooo`04
0000003oool0oooo000000P0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00
00080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000503oool010000000
oooo0?ooo`00000E0?ooo`030000003oool0000000P0oooo00@000000?ooo`3oool00000503oool0
10000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001D0oooo00<000000?ooo`000000
203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?oo
o`3oool00000203oool010000000oooo0?ooo`00002_0?ooo`00Z@3oool2000000P0oooo10000005
0?ooo`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`0<
0?ooo`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0?
0?ooo`8000001`3oool4000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo10000005
0?ooo`030000003oool0oooo00l0oooo0P0000070?ooo`@000001@3oool00`000000oooo0?ooo`0<
0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<00000
0?ooo`3oool0Z03oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo0000\
\>"],
  ImageRangeCache->{{{0, 610.563}, {139.25, 0}} -> {-0.542588, -0.0114686, \
0.00505301, 0.00505301}, {{107.375, 295.813}, {136.938, 46.1875}} -> \
{-1.5486, -0.0199454, 0.00861562, 0.00861562}, {{314.688, 503.125}, {136.938, \
46.1875}} -> {-3.33473, -0.0199454, 0.00861562, 0.00861562}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(Pi) show
153.000 12.750 moveto
(Pi) show
177.000 12.750 moveto
(2) show
189.000 12.750 moveto
(Pi) show
213.000 12.750 moveto
(2) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(2) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
153.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
165.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
177.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
189.000 25.875 moveto
(--) show
201.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
213.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
225.000 25.875 moveto
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(5) show
129.000 39.000 moveto
(5) show
153.000 39.000 moveto
(5) show
183.000 39.000 moveto
(5) show
219.000 39.000 moveto
(5) show
255.000 39.000 moveto
(5) show
285.000 39.000 moveto
(5) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -2.23075e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.38197 0 L
.5 .36327 L
F
0 0 1 r
.38197 0 m
1 0 L
.5 .36327 L
F
1 0 0 r
0 0 m
.5 .36327 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -1.19262e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.38197 0 m
1 0 L
.69098 .22451 L
F
0 0 1 r
.38197 0 m
.69098 .22451 L
.19098 .58779 L
F
1 0 0 r
.19098 .58779 m
0 0 L
.38197 0 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000Zb000`400?l00000o`00003oF`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?oo
o`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00D03ooooo00000<@00000
D03oool005/0oooo00<000000?l00000o`00C000o`1l0000oaH0ooooC@3o00020000og/00?l0G@3o
ool005/0oooo00<000000?l0003o0000C000o`1k0000oaL0ooooC@3o00030000ogT00?l0GP3oool0
05/0oooo00<000000?l0003o00000P3o001:003o07T0003o6@3ooom=0?l000D0003oM@00o`1P0?oo
o`00F`3oool00`000000oooo0?l000030?l004X00?l0M`000?lK0?oood/0o`001`000?mc003o0640
oooo001K0?ooo`030000003oool0o`0000@0o`00B@00o`1f0000oa`0ooooB`3o00080000og400?l0
HP3oool005/0oooo00<000000?ooo`3o00001P3o0017003o07@0003o7P3ooom;0?l000X0003oK@00
o`1T0?ooo`00F`3oool00`000000oooo0?ooo`070?l004L00?l0LP000?lP0?ooodT0o`0030000?m[
003o06D0oooo001K0?ooo`030000003oool0oooo00T0o`00A@00o`1`0000ob80ooooB@3o000=0000
ofT00?l0IP3oool005/0oooo00<000000?ooo`3oool02P3o0014003o06l0003o8`3ooom90?l000l0
003oI@00o`1X0?ooo`00F`3oool010000000oooo0?ooo`3oool:0?l004@00?l0K@000?lU0?ooodL0
o`004@000?mS003o06T0oooo001K0?ooo`040000003oool0oooo0?ooo``0o`00@P00o`1[0000obL0
ooooA`3o000C0000oel00?l0J`3oool005/0oooo00@000000?ooo`3oool0oooo3@3o0011003o06X0
003o:03ooom70?l001@0003oG@00o`1/0?ooo`00F`3oool00`000000oooo0?ooo`020?ooo`d0o`00
@@00o`1X0000obX0ooooA@3o000F0000oe/00?l0K@3oool005/0oooo00<000000?ooo`3oool00P3o
ool?0?l003l00?l0IP000?l/0?ooodD0o`0060000?mG003o06l0oooo001K0?ooo`030000003oool0
oooo0080oooo403o000n003o06D0003o;@3ooom50?l001T0003oE@00o`1`0?ooo`00F`3oool00`00
0000oooo0?ooo`030?oooa40o`00?@00o`1R0000oc00oooo@`3o000K0000oe<00?l0L@3oool005/0
oooo00<000000?ooo`3oool00`3ooolB0?l003`00?l0H@000?la0?oood<0o`007@000?m?003o07<0
oooo001K0?ooo`030000003oool0oooo00<0oooo4`3o000k003o0600003o<P3ooom30?l001h0003o
C@00o`1d0?ooo`00F`3oool00`000000oooo0?ooo`040?oooa@0o`00>P00o`1M0000ocD0oooo@@3o
000Q0000odT00?l0MP3oool005/0oooo00<000000?ooo`3oool0103ooolE0?l003T00?l0G0000?lf
0?oood40o`008P000?m7003o07L0oooo001K0?ooo`030000003oool0oooo00@0oooo5P3o000h003o
05/0003o=`3ooom10?l002<0003oA@00o`1h0?ooo`00F`3oool00`000000oooo0?ooo`050?oooaL0
o`00=`00o`1H0000ocX0oooo?`3o000V0000od400?l0NP3oool005/0oooo00<000000?ooo`3oool0
1@3ooolH0?l003H00?l0E`000?lk0?ooocl0o`009`000?lo003o07/0oooo001K0?ooo`030000003o
ool0oooo00D0oooo6P3o000d003o05D0003o?@3ooolo0?l002P0003o?@00o`1l0?ooo`00F`3oool0
0`000000oooo0?ooo`060?oooaX0o`00=000o`1C0000ocl0oooo?@3o000[0000ocT00?l0OP3oool0
05/0oooo00<000000?ooo`3oool01P3ooolK0?l003<00?l0DP000?m00?ooocd0o`00;0000?lg003o
07l0oooo001K0?ooo`030000003oool0oooo00H0oooo7@3o000a003o0500003o@P3ooolm0?l002d0
003o=@00o`200?ooo`00F`3oool00`000000oooo0?ooo`070?oooad0o`00<@00o`1>0000od@0oooo
>`3o000`0000oc400?l0PP3oool005/0oooo00<000000?ooo`3oool01`3ooolN0?l003000?l0C@00
0?m50?oooc/0o`00<@000?l_003o08<0oooo001K0?ooo`030000003oool0oooo00L0oooo803o000^
003o04/0003oA`3ooolk0?l003<0003o:`00o`250?ooo`00F`3oool00`000000oooo0?ooo`080?oo
ob00o`00;P00o`190000odT0oooo>@3o000e0000obT00?l0QP3oool005/0oooo00<000000?ooo`3o
ool0203ooolR0?l002`00?l0A`000?m;0?ooocT0o`00=P000?lW003o08L0oooo001K0?ooo`030000
003oool0oooo00P0oooo8`3o000[003o04H0003oC03oooli0?l003P0003o8`00o`290?ooo`00F`3o
ool00`000000oooo0?ooo`090?ooob<0o`00:`00o`140000odh0oooo=`3o000j0000ob400?l0RP3o
ool005/0oooo00<000000?ooo`3oool02@3ooolU0?l002T00?l0@P000?m@0?ooocL0o`00>`000?lO
003o08/0oooo001K0?ooo`030000003oool0oooo00T0oooo9P3o000X003o0440003oD@3ooolg0?l0
03d0003o6`00o`2=0?ooo`00F`3oool00`000000oooo0?ooo`0:0?ooobH0o`009`00o`0o0000oe@0
oooo=@3o000o0000oaT00?l0SP3oool005/0oooo00<000000?ooo`3oool02P3ooolX0?l002H00?l0
?@000?mE0?ooocD0o`00@@000?lE003o0900oooo001K0?ooo`030000003oool0oooo00X0oooo:@3o
000U003o03`0003oEP3ooole0?l00480003o4`00o`2A0?ooo`00F`3oool00`000000oooo0?ooo`0:
0?ooob/0o`008`00o`0j0000oeP0oooo=03o00140000oa400?l0TP3oool005/0oooo00<000000?oo
o`3oool02`3oool[0?l002<00?l0>0000?mJ0?oooc<0o`00AP000?l=003o09@0oooo001K0?ooo`03
0000003oool0oooo00/0oooo;03o000R003o03L0003oF`3ooolc0?l004L0003o2`00o`2E0?ooo`00
F`3oool00`000000oooo0?ooo`0;0?ooobh0o`008000o`0e0000oed0oooo<`3o00180000o`T00?l0
UP3oool005/0oooo00<000000?ooo`3oool0303oool^0?l002000?l0<`000?mO0?oooc40o`00B`00
0?l5003o09P0oooo001K0?ooo`030000003oool0oooo00`0oooo<03o000N003o0340003oH@3ooola
0?l004`0003o0`00o`2I0?ooo`00F`3oool00`000000oooo0?ooo`0<0?oooc40o`007@00o`0`0000
of80oooo<@3o001=0000oi/0oooo001K0?ooo`030000003oool0oooo00d0oooo<@3o000M003o02h0
003oI03oool_0?l004d0003oW03oool005/0oooo00<000000?ooo`3oool03@3ooolc0?l001/00?l0
;0000?mV0?ooobl0o`00C0000?nM0?ooo`00F`3oool00`000000oooo0?ooo`0=0?oooc@0o`006P00
o`0[0000ofL0oooo;`3o001:0000oil0oooo001K0?ooo`030000003oool0oooo00h0oooo=03o000J
003o02T0003oJ@3oool]0?l004X0003oX03oool005/0oooo00<000000?ooo`3oool03P3ooolf0?l0
01P00?l09`000?m[0?ooobd0o`00B@000?nQ0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooocL0
o`005`00o`0V0000of`0oooo;@3o00170000oj<0oooo001K0?ooo`030000003oool0oooo00l0oooo
>03o000F003o02<0003oK`3oool[0?l004L0003oY03oool005/0oooo00<000000?ooo`3oool03`3o
ooli0?l001D00?l08P000?m`0?ooob/0o`00A@000?nV0?ooo`00F`3oool00`000000oooo0?ooo`0?
0?ooocX0o`005000o`0Q0000og40oooo:`3o00140000ojL0oooo001K0?ooo`030000003oool0oooo
0100oooo>`3o000C003o01h0003oM03ooolY0?l004@0003oZ03oool005/0oooo00<000000?ooo`3o
ool0403oooll0?l001800?l07@000?me0?ooobT0o`00@P000?nZ0?ooo`00F`3oool00`000000oooo
0?ooo`0@0?ooocd0o`004@00o`0L0000ogH0oooo:@3o00110000oj/0oooo001K0?ooo`030000003o
ool0oooo0140oooo?P3o000@003o01T0003oN@3ooolW0?l00440003o[03oool005/0oooo00<00000
0?ooo`3oool04@3ooolo0?l000l00?l060000?mj0?ooobL0o`00?`000?n^0?ooo`00F`3oool00`00
0000oooo0?ooo`0A0?oood40o`003@00o`0F0000og`0oooo9`3o000n0000ojl0oooo001K0?ooo`03
0000003oool0oooo0180oooo@@3o000=003o01@0003oOP3ooolU0?l003d0003o/@3oool005/0oooo
00<000000?ooo`3oool04P3ooom20?l000`00?l04`000?mo0?ooobD0o`00?0000?nb0?ooo`00F`3o
ool00`000000oooo0?ooo`0B0?oood@0o`002P00o`0A0000oh40oooo9@3o000k0000ok<0oooo001K
0?ooo`030000003oool0oooo01<0ooooA03o000:003o00l0003oP`3ooolS0?l003X0003o]@3oool0
05/0oooo00<000000?ooo`3oool04`3ooom50?l000T00?l03P000?n40?ooob<0o`00>@000?nf0?oo
o`00F`3oool00`000000oooo0?ooo`0C0?ooodL0o`001`00o`0<0000ohH0oooo8`3o000h0000okL0
oooo001K0?ooo`030000003oool0oooo01@0ooooA`3o0007003o00X0003oR03ooolQ0?l003L0003o
^@3oool005/0oooo00<000000?ooo`3oool0503ooom90?l000D00?l020000?n:0?ooob40o`00=P00
0?nj0?ooo`00F`3oool00`000000oooo0?ooo`0D0?ooodX0o`001000o`070000oh/0oooo8@3o000d
0000ok`0oooo001K0?ooo`030000003oool0oooo01D0ooooBP3o0004003o00D0003oS@3ooolO0?l0
03@0003o_@3oool005/0oooo00<000000?ooo`3oool05@3ooom<0?l000800?l00`000?n?0?oooal0
o`00<`000?nn0?ooo`00F`3oool00`000000oooo0?ooo`0E0?ooodd0o`0000<00?l00000o`000?l0
T03ooolO0?l00340003o`03oool005/0oooo00<000000?ooo`3oool05P3ooom=0?l009<0oooo7@3o
000a0000ol40oooo001K0?ooo`030000003oool0oooo01H0ooooC03o002D0?oooad0o`00<0000?o2
0?ooo`00F`3oool00`000000oooo0?ooo`0F0?oood/0o`00U@3ooolM0?l002h0003oa03oool005/0
oooo00<000000?ooo`3oool05`3ooom80?l009P0oooo6`3o000^0000olD0oooo001K0?ooo`030000
003oool0oooo01L0ooooA`3o002I0?oooa/0o`00;0000?o70?ooo`00F`3oool00`000000oooo0?oo
o`0G0?ooodH0o`00VP3ooolK0?l002/0003ob03oool005/0oooo00<000000?ooo`3oool05`3ooom4
0?l009`0oooo6P3o000[0000olT0oooo001K0?ooo`030000003oool0oooo01P0oooo@P3o002N0?oo
oaT0o`00:@000?o;0?ooo`00F`3oool00`000000oooo0?ooo`0H0?oood40o`00W`3ooolI0?l002P0
003oc03oool005/0oooo00<000000?ooo`3oool0603ooolo0?l00:40oooo6@3o000V0000olh0oooo
001K0?ooo`030000003oool0oooo01T0oooo?@3o002S0?oooaL0o`009P000?o?0?ooo`00F`3oool0
0`000000oooo0?ooo`0I0?oooc/0o`00Y@3ooolG0?l002D0003od03oool005/0oooo00<000000?oo
o`3oool06@3ooolj0?l00:H0oooo5`3o000S0000om80oooo001K0?ooo`030000003oool0oooo01X0
oooo>03o002X0?oooaD0o`008`000?oC0?ooo`00F`3oool00`000000oooo0?ooo`0J0?ooocH0o`00
ZP3ooolE0?l00280003oe03oool005/0oooo00<000000?ooo`3oool06P3ooole0?l00:/0oooo5@3o
000P0000omH0oooo001K0?ooo`030000003oool0oooo01/0oooo<`3o002]0?oooa<0o`0080000?oG
0?ooo`00F`3oool00`000000oooo0?ooo`0K0?oooc40o`00[`3ooolC0?l001h0003of@3oool005/0
oooo00<000000?ooo`3oool06`3oool`0?l00;00oooo4`3o000M0000omX0oooo001K0?ooo`030000
003oool0oooo01`0oooo;@3o002c0?oooa40o`007@000?oK0?ooo`00F`3oool00`000000oooo0?oo
o`0L0?ooob`0o`00]03ooolA0?l001/0003og@3oool005/0oooo00<000000?ooo`3oool0703oool[
0?l00;D0oooo4@3o000J0000omh0oooo001K0?ooo`030000003oool0oooo01d0oooo:03o002h0?oo
o`l0o`006P000?oO0?ooo`00F`3oool00`000000oooo0?ooo`0M0?ooobL0o`00^@3oool?0?l001P0
003oh@3oool005/0oooo00<000000?ooo`3oool07@3ooolV0?l00;X0oooo3`3o000G0000on80oooo
001K0?ooo`030000003oool0oooo01h0oooo8`3o002m0?ooo`d0o`005P000?oT0?ooo`00F`3oool0
0`000000oooo0?ooo`0N0?ooob80o`00_P3oool=0?l001D0003oi@3oool005/0oooo00<000000?oo
o`3oool07P3ooolQ0?l00;l0oooo3@3o000D0000onH0oooo001K0?ooo`030000003oool0oooo01l0
oooo7P3o00320?ooo`/0o`004`000?oX0?ooo`00F`3oool00`000000oooo0?ooo`0O0?oooad0o`00
``3oool;0?l00180003oj@3oool005/0oooo00<000000?ooo`3oool07`3ooolK0?l00<D0oooo2`3o
000A0000onX0oooo001K0?ooo`030000003oool0oooo0200oooo6@3o00370?ooo`T0o`0040000?o/
0?ooo`00F`3oool00`000000oooo0?ooo`0P0?oooaP0o`00b03oool90?l000l0003ok@3oool005/0
oooo00<000000?ooo`3oool0803ooolF0?l00<X0oooo2@3o000=0000onl0oooo001K0?ooo`030000
003oool0oooo0240oooo503o003<0?ooo`L0o`003@000?o`0?ooo`00F`3oool00`000000oooo0?oo
o`0Q0?oooa<0o`00c@3oool70?l000`0003ol@3oool005/0oooo00<000000?ooo`3oool08@3ooolA
0?l00<l0oooo1`3o000:0000oo<0oooo001K0?ooo`030000003oool0oooo0280oooo3`3o003A0?oo
o`D0o`002P000?od0?ooo`00F`3oool00`000000oooo0?ooo`0R0?ooo`d0o`00d`3oool50?l000T0
003om@3oool005/0oooo00<000000?ooo`3oool08P3oool<0?l00=@0oooo1@3o00070000ooL0oooo
001K0?ooo`030000003oool0oooo02<0oooo2P3o003F0?ooo`<0o`001`000?oh0?ooo`00F`3oool0
0`000000oooo0?ooo`0S0?ooo`P0o`00f03oool30?l000D0003onP3oool005/0oooo00<000000?oo
o`3oool08`3oool70?l00=T0oooo0`3o00040000oo/0oooo001K0?ooo`030000003oool0oooo02@0
oooo1@3o003K0?ooo`030?l000000?l0003o0080003oo03oool005/0oooo00<000000?ooo`3oool0
903oool30?l00=d0oooo00<0o`000000o`000?l0oP3oool005/0oooo00<000000?ooo`3oool0903o
ool20?l00=h0oooo00<0o`000000o`3oool0oP3oool005/0oooo00<000000?ooo`3oool0o`3ooooo
0?ooo`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00F`3oool00`000000
oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?ooo`L0oooo
003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0
ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool0
0?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002e0?ooo`800000703oool2000001H0oooo
0P00000F0?ooo`800000703oool200000280oooo0P00000R0?ooo`800000703oool2000001`0oooo
0P00002l0?ooo`00]03oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001@0
oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00000J0?ooo`040000003oool0
oooo00000200oooo00@000000?ooo`3oool00000803oool010000000oooo0?ooo`00000J0?ooo`04
0000003oool0oooo000001X0oooo00@000000?ooo`3oool00000^`3oool00;L0oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0;T0oooo002e0?ooo`80
0000703oool2000001H0oooo0P00000F0?ooo`800000703oool200000280oooo0P00000R0?ooo`80
0000703oool2000001`0oooo0P00002l0?ooo`00]@3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo01/0oooo00<000000?ooo`3oool0^`3oool00;D0oooo0`00000K0?ooo`<000005@3o
ool3000001D0oooo0`00000K0?ooo`<000008@3oool300000240oooo0`00000K0?ooo`<000006`3o
ool300000;/0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002[0?oo
o`030000003oool0oooo0?l0oooo2@3oool00`000000oooo0?ooo`2Z0?ooo`00ZP3oool00`000000
oooo0?ooo`0J0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`000000
oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`2Y0?ooo`00ZP3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo01D0oooo
00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo
00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo
00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`2Y0?ooo`00ZP3oool010000000oooo0?oo
o`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000
103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000
0P3oool400000080oooo100000030?ooo`030000003oool0oooo0:T0oooo002Y0?ooo`030000003o
ool0oooo0?l0oooo3@3oool00`000000oooo0?ooo`2X0?ooo`00ZP3oool00`000000oooo0?ooo`3o
0?ooo`/0oooo00<000000?ooo`3oool0Z@3oool00:X0oooo00<000000?ooo`3oool0o`3oool;0?oo
o`030000003oool0oooo0:T0oooo002[0?ooo`030000003oool0oooo0?l0oooo2@3oool00`000000
oooo0?ooo`2Z0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3o
oooo0?ooofD0oooo002_0?ooo`800000203oool3000000D0oooo0`00000=0?ooo`<000001@3oool3
000000d0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000>0?ooo`@000001`3oool3
000000D0oooo0`00000>0?ooo`@000001`3oool3000000D0oooo0`00000>0?ooo`@000001`3oool3
000000D0oooo0`00000=0?ooo`<000001@3oool3000000h0oooo100000070?ooo`<000001@3oool3
00000:l0oooo002^0?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0[P3oool0
0;00oooo00<000000?ooo`3oool01`3oool3000000D0oooo00<000000?ooo`3oool03@3oool30000
00D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03@3oool30000
00D0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`00
0000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo
00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?ooo`3oool03@3oool30000
00D0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`00
0000oooo0?ooo`2^0?ooo`00/@3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
00<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0
oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000A0?ooo`030000
003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool200000140oooo00<000000?ooo`3o
ool01`3oool010000000oooo0?ooo`0000030?ooo`8000004@3oool00`000000oooo0?ooo`070?oo
o`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00
000A0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool200000;00oooo
002^0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000503oool010000000
oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000503o
ool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000000P0oooo00@0
00000?ooo`3oool00000503oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo0000
00P0oooo00@000000?ooo`3oool00000]@3oool00:l0oooo0P0000080?ooo`@000001@3oool00`00
0000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`00
0000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?ooo`800000203oool40000
00D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo
00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`00
0000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool0[P3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo0000\
\>"],
  ImageRangeCache->{{{0, 610.563}, {170.188, 0}} -> {-0.426205, -0.013998, \
0.00467178, 0.00467178}, {{91.1875, 295.063}, {167.188, 47.3125}} -> \
{-1.34175, -0.0239702, 0.00793648, 0.00793648}, {{315.438, 519.313}, \
{167.188, 47.3125}} -> {-3.12151, -0.0239702, 0.00793648, 0.00793648}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(Pi) show
153.000 12.750 moveto
(Pi) show
177.000 12.750 moveto
(2) show
189.000 12.750 moveto
(Pi) show
213.000 12.750 moveto
(2) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(2) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
153.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
165.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
177.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
189.000 25.875 moveto
(--) show
201.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
213.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
225.000 25.875 moveto
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(5) show
129.000 39.000 moveto
(5) show
153.000 39.000 moveto
(5) show
183.000 39.000 moveto
(5) show
219.000 39.000 moveto
(5) show
255.000 39.000 moveto
(5) show
285.000 39.000 moveto
(5) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -2.23075e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.38197 0 L
.5 .36327 L
F
0 0 1 r
.38197 0 m
1 0 L
.5 .36327 L
F
1 0 0 r
0 0 m
.5 .36327 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -1.19262e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.38197 0 m
1 0 L
.69098 .22451 L
F
0 0 1 r
.38197 0 m
.69098 .22451 L
.19098 .58779 L
F
1 0 0 r
.19098 .58779 m
0 0 L
.38197 0 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000Zb000`400?l00000o`00003oF`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?oo
o`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00D03ooooo00000<@00000
D03oool005/0oooo00<000000?l00000o`00C000o`1l0000oaH0ooooC@3o00020000og/00?l0G@3o
ool005/0oooo00<000000?l0003o0000C000o`1k0000oaL0ooooC@3o00030000ogT00?l0GP3oool0
05/0oooo00<000000?l0003o00000P3o001:003o07T0003o6@3ooom=0?l000D0003oM@00o`1P0?oo
o`00F`3oool00`000000oooo0?l000030?l004X00?l0M`000?lK0?oood/0o`001`000?mc003o0640
oooo001K0?ooo`030000003oool0o`0000@0o`00B@00o`1f0000oa`0ooooB`3o00080000og400?l0
HP3oool005/0oooo00<000000?ooo`3o00001P3o0017003o07@0003o7P3ooom;0?l000X0003oK@00
o`1T0?ooo`00F`3oool00`000000oooo0?ooo`070?l004L00?l0LP000?lP0?ooodT0o`0030000?m[
003o06D0oooo001K0?ooo`030000003oool0oooo00T0o`00A@00o`1`0000ob80ooooB@3o000=0000
ofT00?l0IP3oool005/0oooo00<000000?ooo`3oool02P3o0014003o06l0003o8`3ooom90?l000l0
003oI@00o`1X0?ooo`00F`3oool010000000oooo0?ooo`3oool:0?l004@00?l0K@000?lU0?ooodL0
o`004@000?mS003o06T0oooo001K0?ooo`040000003oool0oooo0?ooo``0o`00@P00o`1[0000obL0
ooooA`3o000C0000oel00?l0J`3oool005/0oooo00@000000?ooo`3oool0oooo3@3o0011003o06X0
003o:03ooom70?l001@0003oG@00o`1/0?ooo`00F`3oool00`000000oooo0?ooo`020?ooo`d0o`00
@@00o`1X0000obX0ooooA@3o000F0000oe/00?l0K@3oool005/0oooo00<000000?ooo`3oool00P3o
ool?0?l003l00?l0IP000?l/0?ooodD0o`0060000?mG003o06l0oooo001K0?ooo`030000003oool0
oooo0080oooo403o000n003o06D0003o;@3ooom50?l001T0003oE@00o`1`0?ooo`00F`3oool00`00
0000oooo0?ooo`030?oooa40o`00?@00o`1R0000oc00oooo@`3o000K0000oe<00?l0L@3oool005/0
oooo00<000000?ooo`3oool00`3ooolB0?l003`00?l0H@000?la0?oood<0o`007@000?m?003o07<0
oooo001K0?ooo`030000003oool0oooo00<0oooo4`3o000k003o0600003o<P3ooom30?l001h0003o
C@00o`1d0?ooo`00F`3oool00`000000oooo0?ooo`040?oooa@0o`00>P00o`1M0000ocD0oooo@@3o
000Q0000odT00?l0MP3oool005/0oooo00<000000?ooo`3oool0103ooolE0?l003T00?l0G0000?lf
0?oood40o`008P000?m7003o07L0oooo001K0?ooo`030000003oool0oooo00@0oooo5P3o000h003o
05/0003o=`3ooom10?l002<0003oA@00o`1h0?ooo`00F`3oool00`000000oooo0?ooo`050?oooaL0
o`00=`00o`1H0000ocX0oooo?`3o000V0000od400?l0NP3oool005/0oooo00<000000?ooo`3oool0
1@3ooolH0?l003H00?l0E`000?lk0?ooocl0o`009`000?lo003o07/0oooo001K0?ooo`030000003o
ool0oooo00D0oooo6P3o000d003o05D0003o?@3ooolo0?l002P0003o?@00o`1l0?ooo`00F`3oool0
0`000000oooo0?ooo`060?oooaX0o`00=000o`1C0000ocl0oooo?@3o000[0000ocT00?l0OP3oool0
05/0oooo00<000000?ooo`3oool01P3ooolK0?l003<00?l0DP000?m00?ooocd0o`00;0000?lg003o
07l0oooo001K0?ooo`030000003oool0oooo00H0oooo7@3o000a003o0500003o@P3ooolm0?l002d0
003o=@00o`200?ooo`00F`3oool00`000000oooo0?ooo`070?oooad0o`00<@00o`1>0000od@0oooo
>`3o000`0000oc400?l0PP3oool005/0oooo00<000000?ooo`3oool01`3ooolN0?l003000?l0C@00
0?m50?oooc/0o`00<@000?l_003o08<0oooo001K0?ooo`030000003oool0oooo00L0oooo803o000^
003o04/0003oA`3ooolk0?l003<0003o:`00o`250?ooo`00F`3oool00`000000oooo0?ooo`080?oo
ob00o`00;P00o`190000odT0oooo>@3o000e0000obT00?l0QP3oool005/0oooo00<000000?ooo`3o
ool0203ooolR0?l002`00?l0A`000?m;0?ooocT0o`00=P000?lW003o08L0oooo001K0?ooo`030000
003oool0oooo00P0oooo8`3o000[003o04H0003oC03oooli0?l003P0003o8`00o`290?ooo`00F`3o
ool00`000000oooo0?ooo`090?ooob<0o`00:`00o`140000odh0oooo=`3o000j0000ob400?l0RP3o
ool005/0oooo00<000000?ooo`3oool02@3ooolU0?l002T00?l0@P000?m@0?ooocL0o`00>`000?lO
003o08/0oooo001K0?ooo`030000003oool0oooo00T0oooo9P3o000X003o0440003oD@3ooolg0?l0
03d0003o6`00o`2=0?ooo`00F`3oool00`000000oooo0?ooo`0:0?ooobH0o`009`00o`0o0000oe@0
oooo=@3o000o0000oaT00?l0SP3oool005/0oooo00<000000?ooo`3oool02P3ooolX0?l002H00?l0
?@000?mE0?ooocD0o`00@@000?lE003o0900oooo001K0?ooo`030000003oool0oooo00X0oooo:@3o
000U003o03`0003oEP3ooole0?l00480003o4`00o`2A0?ooo`00F`3oool00`000000oooo0?ooo`0:
0?ooob/0o`008`00o`0j0000oeP0oooo=03o00140000oa400?l0TP3oool005/0oooo00<000000?oo
o`3oool02`3oool[0?l002<00?l0>0000?mJ0?oooc<0o`00AP000?l=003o09@0oooo001K0?ooo`03
0000003oool0oooo00/0oooo;03o000R003o03L0003oF`3ooolc0?l004L0003o2`00o`2E0?ooo`00
F`3oool00`000000oooo0?ooo`0;0?ooobh0o`008000o`0e0000oed0oooo<`3o00180000o`T00?l0
UP3oool005/0oooo00<000000?ooo`3oool0303oool^0?l002000?l0<`000?mO0?oooc40o`00B`00
0?l5003o09P0oooo001K0?ooo`030000003oool0oooo00`0oooo<03o000N003o0340003oH@3ooola
0?l004`0003o0`00o`2I0?ooo`00F`3oool00`000000oooo0?ooo`0<0?oooc40o`007@00o`0`0000
of80oooo<@3o001=0000oi/0oooo001K0?ooo`030000003oool0oooo00d0oooo<@3o000M003o02h0
003oI03oool_0?l004d0003oW03oool005/0oooo00<000000?ooo`3oool03@3ooolc0?l001/00?l0
;0000?mV0?ooobl0o`00C0000?nM0?ooo`00F`3oool00`000000oooo0?ooo`0=0?oooc@0o`006P00
o`0[0000ofL0oooo;`3o001:0000oil0oooo001K0?ooo`030000003oool0oooo00h0oooo=03o000J
003o02T0003oJ@3oool]0?l004X0003oX03oool005/0oooo00<000000?ooo`3oool03P3ooolf0?l0
01P00?l09`000?m[0?ooobd0o`00B@000?nQ0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooocL0
o`005`00o`0V0000of`0oooo;@3o00170000oj<0oooo001K0?ooo`030000003oool0oooo00l0oooo
>03o000F003o02<0003oK`3oool[0?l004L0003oY03oool005/0oooo00<000000?ooo`3oool03`3o
ooli0?l001D00?l08P000?m`0?ooob/0o`00A@000?nV0?ooo`00F`3oool00`000000oooo0?ooo`0?
0?ooocX0o`005000o`0Q0000og40oooo:`3o00140000ojL0oooo001K0?ooo`030000003oool0oooo
0100oooo>`3o000C003o01h0003oM03ooolY0?l004@0003oZ03oool005/0oooo00<000000?ooo`3o
ool0403oooll0?l001800?l07@000?me0?ooobT0o`00@P000?nZ0?ooo`00F`3oool00`000000oooo
0?ooo`0@0?ooocd0o`004@00o`0L0000ogH0oooo:@3o00110000oj/0oooo001K0?ooo`030000003o
ool0oooo0140oooo?P3o000@003o01T0003oN@3ooolW0?l00440003o[03oool005/0oooo00<00000
0?ooo`3oool04@3ooolo0?l000l00?l060000?mj0?ooobL0o`00?`000?n^0?ooo`00F`3oool00`00
0000oooo0?ooo`0A0?oood40o`003@00o`0F0000og`0oooo9`3o000n0000ojl0oooo001K0?ooo`03
0000003oool0oooo0180oooo@@3o000=003o01@0003oOP3ooolU0?l003d0003o/@3oool005/0oooo
00<000000?ooo`3oool04P3ooom20?l000`00?l04`000?mo0?ooobD0o`00?0000?nb0?ooo`00F`3o
ool00`000000oooo0?ooo`0B0?oood@0o`002P00o`0A0000oh40oooo9@3o000k0000ok<0oooo001K
0?ooo`030000003oool0oooo01<0ooooA03o000:003o00l0003oP`3ooolS0?l003X0003o]@3oool0
05/0oooo00<000000?ooo`3oool04`3ooom50?l000T00?l03P000?n40?ooob<0o`00>@000?nf0?oo
o`00F`3oool00`000000oooo0?ooo`0C0?ooodL0o`001`00o`0<0000ohH0oooo8`3o000h0000okL0
oooo001K0?ooo`030000003oool0oooo01@0ooooA`3o0007003o00X0003oR03ooolQ0?l003L0003o
^@3oool005/0oooo00<000000?ooo`3oool0503ooom90?l000D00?l020000?n:0?ooob40o`00=P00
0?nj0?ooo`00F`3oool00`000000oooo0?ooo`0D0?ooodX0o`001000o`070000oh/0oooo8@3o000d
0000ok`0oooo001K0?ooo`030000003oool0oooo01D0ooooBP3o0004003o00D0003oS@3ooolO0?l0
03@0003o_@3oool005/0oooo00<000000?ooo`3oool05@3ooom<0?l000800?l00`000?n?0?oooal0
o`00<`000?nn0?ooo`00F`3oool00`000000oooo0?ooo`0E0?ooodd0o`0000<00?l00000o`000?l0
T03ooolO0?l00340003o`03oool005/0oooo00<000000?ooo`3oool05P3ooom=0?l009<0oooo7@3o
000a0000ol40oooo001K0?ooo`030000003oool0oooo01H0ooooC03o002D0?oooad0o`00<0000?o2
0?ooo`00F`3oool00`000000oooo0?ooo`0F0?oood/0o`00U@3ooolM0?l002h0003oa03oool005/0
oooo00<000000?ooo`3oool05`3ooom80?l009P0oooo6`3o000^0000olD0oooo001K0?ooo`030000
003oool0oooo01L0ooooA`3o002I0?oooa/0o`00;0000?o70?ooo`00F`3oool00`000000oooo0?oo
o`0G0?ooodH0o`00VP3ooolK0?l002/0003ob03oool005/0oooo00<000000?ooo`3oool05`3ooom4
0?l009`0oooo6P3o000[0000olT0oooo001K0?ooo`030000003oool0oooo01P0oooo@P3o002N0?oo
oaT0o`00:@000?o;0?ooo`00F`3oool00`000000oooo0?ooo`0H0?oood40o`00W`3ooolI0?l002P0
003oc03oool005/0oooo00<000000?ooo`3oool0603ooolo0?l00:40oooo6@3o000V0000olh0oooo
001K0?ooo`030000003oool0oooo01T0oooo?@3o002S0?oooaL0o`009P000?o?0?ooo`00F`3oool0
0`000000oooo0?ooo`0I0?oooc/0o`00Y@3ooolG0?l002D0003od03oool005/0oooo00<000000?oo
o`3oool06@3ooolj0?l00:H0oooo5`3o000S0000om80oooo001K0?ooo`030000003oool0oooo01X0
oooo>03o002X0?oooaD0o`008`000?oC0?ooo`00F`3oool00`000000oooo0?ooo`0J0?ooocH0o`00
ZP3ooolE0?l00280003oe03oool005/0oooo00<000000?ooo`3oool06P3ooole0?l00:/0oooo5@3o
000P0000omH0oooo001K0?ooo`030000003oool0oooo01/0oooo<`3o002]0?oooa<0o`0080000?oG
0?ooo`00F`3oool00`000000oooo0?ooo`0K0?oooc40o`00[`3ooolC0?l001h0003of@3oool005/0
oooo00<000000?ooo`3oool06`3oool`0?l00;00oooo4`3o000M0000omX0oooo001K0?ooo`030000
003oool0oooo01`0oooo;@3o002c0?oooa40o`007@000?oK0?ooo`00F`3oool00`000000oooo0?oo
o`0L0?ooob`0o`00]03ooolA0?l001/0003og@3oool005/0oooo00<000000?ooo`3oool0703oool[
0?l00;D0oooo4@3o000J0000omh0oooo001K0?ooo`030000003oool0oooo01d0oooo:03o002h0?oo
o`l0o`006P000?oO0?ooo`00F`3oool00`000000oooo0?ooo`0M0?ooobL0o`00^@3oool?0?l001P0
003oh@3oool005/0oooo00<000000?ooo`3oool07@3ooolV0?l00;X0oooo3`3o000G0000on80oooo
001K0?ooo`030000003oool0oooo01h0oooo8`3o002m0?ooo`d0o`005P000?oT0?ooo`00F`3oool0
0`000000oooo0?ooo`0N0?ooob80o`00_P3oool=0?l001D0003oi@3oool005/0oooo00<000000?oo
o`3oool07P3ooolQ0?l00;l0oooo3@3o000D0000onH0oooo001K0?ooo`030000003oool0oooo01l0
oooo7P3o00320?ooo`/0o`004`000?oX0?ooo`00F`3oool00`000000oooo0?ooo`0O0?oooad0o`00
``3oool;0?l00180003oj@3oool005/0oooo00<000000?ooo`3oool07`3ooolK0?l00<D0oooo2`3o
000A0000onX0oooo001K0?ooo`030000003oool0oooo0200oooo6@3o00370?ooo`T0o`0040000?o/
0?ooo`00F`3oool00`000000oooo0?ooo`0P0?oooaP0o`00b03oool90?l000l0003ok@3oool005/0
oooo00<000000?ooo`3oool0803ooolF0?l00<X0oooo2@3o000=0000onl0oooo001K0?ooo`030000
003oool0oooo0240oooo503o003<0?ooo`L0o`003@000?o`0?ooo`00F`3oool00`000000oooo0?oo
o`0Q0?oooa<0o`00c@3oool70?l000`0003ol@3oool005/0oooo00<000000?ooo`3oool08@3ooolA
0?l00<l0oooo1`3o000:0000oo<0oooo001K0?ooo`030000003oool0oooo0280oooo3`3o003A0?oo
o`D0o`002P000?od0?ooo`00F`3oool00`000000oooo0?ooo`0R0?ooo`d0o`00d`3oool50?l000T0
003om@3oool005/0oooo00<000000?ooo`3oool08P3oool<0?l00=@0oooo1@3o00070000ooL0oooo
001K0?ooo`030000003oool0oooo02<0oooo2P3o003F0?ooo`<0o`001`000?oh0?ooo`00F`3oool0
0`000000oooo0?ooo`0S0?ooo`P0o`00f03oool30?l000D0003onP3oool005/0oooo00<000000?oo
o`3oool08`3oool70?l00=T0oooo0`3o00040000oo/0oooo001K0?ooo`030000003oool0oooo02@0
oooo1@3o003K0?ooo`030?l000000?l0003o0080003oo03oool005/0oooo00<000000?ooo`3oool0
903oool30?l00=d0oooo00<0o`000000o`000?l0oP3oool005/0oooo00<000000?ooo`3oool0903o
ool20?l00=h0oooo00<0o`000000o`3oool0oP3oool005/0oooo00<000000?ooo`3oool0o`3ooooo
0?ooo`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00F`3oool00`000000
oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?ooo`L0oooo
003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0
ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool0
0?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002e0?ooo`800000703oool2000001H0oooo
0P00000F0?ooo`800000703oool200000280oooo0P00000R0?ooo`800000703oool2000001`0oooo
0P00002l0?ooo`00]03oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001@0
oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00000J0?ooo`040000003oool0
oooo00000200oooo00@000000?ooo`3oool00000803oool010000000oooo0?ooo`00000J0?ooo`04
0000003oool0oooo000001X0oooo00@000000?ooo`3oool00000^`3oool00;L0oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0;T0oooo002e0?ooo`80
0000703oool2000001H0oooo0P00000F0?ooo`800000703oool200000280oooo0P00000R0?ooo`80
0000703oool2000001`0oooo0P00002l0?ooo`00]@3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo01/0oooo00<000000?ooo`3oool0^`3oool00;D0oooo0`00000K0?ooo`<000005@3o
ool3000001D0oooo0`00000K0?ooo`<000008@3oool300000240oooo0`00000K0?ooo`<000006`3o
ool300000;/0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002[0?oo
o`030000003oool0oooo0?l0oooo2@3oool00`000000oooo0?ooo`2Z0?ooo`00ZP3oool00`000000
oooo0?ooo`0J0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`000000
oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`2Y0?ooo`00ZP3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo01D0oooo
00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo
00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo
00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`2Y0?ooo`00ZP3oool010000000oooo0?oo
o`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000
103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool0
1`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000
0P3oool400000080oooo100000030?ooo`030000003oool0oooo0:T0oooo002Y0?ooo`030000003o
ool0oooo0?l0oooo3@3oool00`000000oooo0?ooo`2X0?ooo`00ZP3oool00`000000oooo0?ooo`3o
0?ooo`/0oooo00<000000?ooo`3oool0Z@3oool00:X0oooo00<000000?ooo`3oool0o`3oool;0?oo
o`030000003oool0oooo0:T0oooo002[0?ooo`030000003oool0oooo0?l0oooo2@3oool00`000000
oooo0?ooo`2Z0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3o
oooo0?ooofD0oooo002_0?ooo`800000203oool3000000D0oooo0`00000=0?ooo`<000001@3oool3
000000d0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000>0?ooo`@000001`3oool3
000000D0oooo0`00000>0?ooo`@000001`3oool3000000D0oooo0`00000>0?ooo`@000001`3oool3
000000D0oooo0`00000=0?ooo`<000001@3oool3000000h0oooo100000070?ooo`<000001@3oool3
00000:l0oooo002^0?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0[P3oool0
0;00oooo00<000000?ooo`3oool01`3oool3000000D0oooo00<000000?ooo`3oool03@3oool30000
00D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03@3oool30000
00D0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`00
0000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo
00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?ooo`3oool03@3oool30000
00D0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`00
0000oooo0?ooo`2^0?ooo`00/@3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
00<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0
oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000A0?ooo`030000
003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool200000140oooo00<000000?ooo`3o
ool01`3oool010000000oooo0?ooo`0000030?ooo`8000004@3oool00`000000oooo0?ooo`070?oo
o`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00
000A0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool200000;00oooo
002^0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000503oool010000000
oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000503o
ool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000000P0oooo00@0
00000?ooo`3oool00000503oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo0000
00P0oooo00@000000?ooo`3oool00000]@3oool00:l0oooo0P0000080?ooo`@000001@3oool00`00
0000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`00
0000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?ooo`800000203oool40000
00D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo
00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`00
0000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool0[P3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo0000\
\>"],
  ImageRangeCache->{{{0, 610.563}, {170.188, 0}} -> {-0.426205, -0.013998, \
0.00467178, 0.00467178}, {{91.1875, 295.063}, {167.188, 47.3125}} -> \
{-1.34175, -0.0239702, 0.00793648, 0.00793648}, {{315.438, 519.313}, \
{167.188, 47.3125}} -> {-3.12151, -0.0239702, 0.00793648, 0.00793648}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .29856 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00710862 0.47619 [
[.5 .31106 -152 0 ]
[.5 .31106 152 38.75 ]
[ 0 0 0 0 ]
[ 1 .29856 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00711 m
1 .00711 L
s
.02381 0 m
.02381 .29856 L
s
gsave
.5 .31106 -213 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(2) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(2) show
177.000 12.750 moveto
(Pi) show
201.000 12.750 moveto
(3) show
213.000 12.750 moveto
(Pi) show
237.000 12.750 moveto
(2) show
249.000 12.750 moveto
(Pi) show
273.000 12.750 moveto
(3) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(Pi) show
333.000 12.750 moveto
(3) show
345.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
(--) show
189.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
201.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
213.000 25.875 moveto
(--) show
225.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
237.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
249.000 25.875 moveto
(--) show
261.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
273.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
285.000 25.875 moveto
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
333.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
345.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
357.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
105.000 39.000 moveto
(7) show
135.000 39.000 moveto
(7) show
171.000 39.000 moveto
(7) show
207.000 39.000 moveto
(7) show
243.000 39.000 moveto
(7) show
279.000 39.000 moveto
(7) show
309.000 39.000 moveto
(7) show
339.000 39.000 moveto
(7) show
345.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .29856 L
0 .29856 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00710862 0.477324 0.291453 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.643104 0.356896 -5.04154e-018 0.356896 [
[ 0 0 0 0 ]
[ 1 .62698 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .62698 L
0 .62698 L
closepath
clip
newpath
0 1 0 r
0 0 m
.6431 0 L
.72252 .34795 L
F
0 0 1 r
.6431 0 m
1 0 L
.72252 .34795 L
F
1 0 0 r
0 0 m
.72252 .34795 L
.5 .62698 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00710862 0.97619 0.291453 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.643104 0.356896 -2.20364e-017 0.356896 [
[ 0 0 0 0 ]
[ 1 .62698 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .62698 L
0 .62698 L
closepath
clip
newpath
0 1 0 r
.6431 0 m
1 0 L
.90097 .12418 L
F
0 0 1 r
.5 .62698 m
0 0 L
.6431 0 L
F
1 0 0 r
.6431 0 m
.90097 .12418 L
.5 .62698 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.438, 182.563},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(Pi) show
153.000 12.750 moveto
(Pi) show
177.000 12.750 moveto
(2) show
189.000 12.750 moveto
(Pi) show
213.000 12.750 moveto
(2) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(2) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
153.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
165.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
177.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
189.000 25.875 moveto
(--) show
201.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
213.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
225.000 25.875 moveto
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(5) show
129.000 39.000 moveto
(5) show
153.000 39.000 moveto
(5) show
183.000 39.000 moveto
(5) show
219.000 39.000 moveto
(5) show
255.000 39.000 moveto
(5) show
285.000 39.000 moveto
(5) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -2.23075e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.38197 0 L
.5 .36327 L
F
0 0 1 r
.38197 0 m
1 0 L
.5 .36327 L
F
1 0 0 r
0 0 m
.5 .36327 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -1.19262e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.38197 0 m
1 0 L
.69098 .22451 L
F
0 0 1 r
.19098 .58779 m
0 0 L
.38197 0 L
F
1 0 0 r
.38197 0 m
.69098 .22451 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCacheValid->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .41239 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00981888 0.47619 [
[.5 .42489 -116 0 ]
[.5 .42489 116 38.75 ]
[ 0 0 0 0 ]
[ 1 .41239 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00982 m
1 .00982 L
s
.02381 0 m
.02381 .41239 L
s
gsave
.5 .42489 -177 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(Pi) show
153.000 12.750 moveto
(Pi) show
177.000 12.750 moveto
(Pi) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(Pi) show
273.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
153.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
165.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
177.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
189.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
201.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
273.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
285.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
105.000 39.000 moveto
(6) show
129.000 39.000 moveto
(6) show
153.000 39.000 moveto
(3) show
177.000 39.000 moveto
(3) show
201.000 39.000 moveto
(3) show
225.000 39.000 moveto
(2) show
249.000 39.000 moveto
(6) show
273.000 39.000 moveto
(3) show
279.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .41239 L
0 .41239 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00981888 0.477324 0.402574 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.5 1.48807e-017 0.5 [
[ 0 0 0 0 ]
[ 1 .86603 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .86603 L
0 .86603 L
closepath
clip
newpath
0 1 0 r
0 0 m
.5 0 L
.75 .43301 L
F
0 0 1 r
.5 0 m
1 0 L
.75 .43301 L
F
1 0 0 r
0 0 m
.75 .43301 L
.5 .86603 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00981888 0.97619 0.402574 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.5 0 0.5 [
[ 0 0 0 0 ]
[ 1 .86603 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .86603 L
0 .86603 L
closepath
clip
newpath
0 1 0 r
.5 0 m
.75 .43301 L
.5 .86603 L
F
0 0 1 r
.5 0 m
1 0 L
.75 .43301 L
F
1 0 0 r
.5 .86603 m
0 0 L
.5 0 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.813, 252.313},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000o2000`400?l00000o`00003o@`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo7`3oool004<0oooo00<000000?ooo`3oool0o`3ooooo0?oo
oal0oooo00130?ooo`030000003oool0oooo0?l0ooooo`3ooolO0?ooo`00@`3oool00`000000oooo
0?ooo`3o0?ooool0oooo7`3oool004<0oooo00<000000?ooo`3oool0o`3ooooo0?oooal0oooo000g
0?ooool00000mP00000g0?ooo`00@`3oool00`000000o`00003o001_003o0740003o5`3oooma0?l0
0003003o00000?l0003o06h0003oA03oool004<0oooo00@000000?ooo`3o0000o`00K`00o`1_0000
oaT0ooooL03o0002003o06h0003oA@3oool004<0oooo00<000000?ooo`3o00000`3o001]003o06l0
003o6@3ooom`0?l000800?l0KP000?m50?ooo`00@`3oool00`000000oooo0?ooo`040?l006d00?l0
K@000?lK0?ooofl0o`000`00o`1/0000odH0oooo00130?ooo`030000003oool0oooo00H0o`00J`00
o`1]0000oa/0ooooK`3o0003003o06`0003oAP3oool004<0oooo00@000000?ooo`3oool0oooo1`3o
001Z003o06/0003o7@3ooom^0?l000@00?l0JP000?m70?ooo`00@`3oool00`000000oooo0?ooo`02
0?ooo`P0o`00J@00o`1Y0000oal0ooooK@3o0004003o06T0003oB03oool004<0oooo00<000000?oo
o`3oool00P3oool90?l006P00?l0J@000?lO0?ooofd0o`001@00o`1X0000odP0oooo00130?ooo`03
0000003oool0oooo00<0oooo2P3o001W003o06L0003o8@3ooom/0?l000H00?l0IP000?m90?ooo`00
@`3oool00`000000oooo0?ooo`030?ooo``0o`00I@00o`1W0000ob40ooooK03o0006003o06H0003o
B@3oool004<0oooo00<000000?ooo`3oool0103oool=0?l006@00?l0I@000?lS0?ooof/0o`001`00
o`1T0000odX0oooo00130?ooo`030000003oool0oooo00@0oooo3P3o001S003o06D0003o8`3ooom[
0?l000L00?l0I0000?m:0?ooo`00@`3oool00`000000oooo0?ooo`050?ooo`l0o`00HP00o`1S0000
obD0ooooJP3o0008003o0680003oB`3oool004<0oooo00<000000?ooo`3oool01P3oool@0?l00640
0?l0H@000?lW0?ooofT0o`002000o`1Q0000od`0oooo00130?ooo`030000003oool0oooo00H0oooo
4P3o001O003o0640003o9`3ooomY0?l000T00?l0H0000?m<0?ooo`00@`3oool00`000000oooo0?oo
o`070?oooa80o`00G`00o`1O0000obT0ooooJ03o000:003o05h0003oC@3oool004<0oooo00<00000
0?ooo`3oool01`3ooolD0?l005d00?l0G`000?lY0?ooofP0o`002P00o`1N0000odd0oooo00130?oo
o`030000003oool0oooo00P0oooo5@3o001L003o05d0003o:`3ooomW0?l000/00?l0G0000?m>0?oo
o`00@`3oool00`000000oooo0?ooo`080?oooaH0o`00G000o`1K0000ob`0ooooI`3o000;003o05/0
003oC`3oool004<0oooo00<000000?ooo`3oool02@3ooolG0?l005X00?l0F`000?l]0?ooofH0o`00
3000o`1J0000odl0oooo00130?ooo`030000003oool0oooo00X0oooo603o001I003o05T0003o;`3o
oomU0?l000`00?l0F@000?m@0?ooo`00@`3oool00`000000oooo0?ooo`0:0?oooaX0o`00E`00o`1I
0000obl0ooooI@3o000=003o05P0003oD03oool004<0oooo00<000000?ooo`3oool02`3ooolJ0?l0
05L00?l0E`000?la0?ooof@0o`003P00o`1F0000oe40oooo00130?ooo`030000003oool0oooo00/0
oooo703o001E003o05L0003o<@3ooomT0?l000h00?l0EP000?mA0?ooo`00@`3oool00`000000oooo
0?ooo`0<0?oooad0o`00E000o`1E0000oc<0ooooH`3o000?003o05@0003oDP3oool004<0oooo00<0
00000?ooo`3oool0303ooolO0?l005<00?l0D`000?le0?ooof80o`003`00o`1C0000oe<0oooo0013
0?ooo`030000003oool0oooo00d0oooo7`3o001B003o05<0003o=@3ooomR0?l001000?l0DP000?mC
0?ooo`00@`3oool00`000000oooo0?ooo`0>0?ooob00o`00D@00o`1A0000ocL0ooooH@3o000@003o
0540003oE03oool004<0oooo00<000000?ooo`3oool03P3ooolR0?l004l00?l0D@000?lg0?ooof40
o`004@00o`1@0000oe@0oooo00130?ooo`030000003oool0oooo00l0oooo8`3o001>003o04l0003o
>@3ooomP0?l001800?l0CP000?mE0?ooo`00@`3oool00`000000oooo0?ooo`0?0?ooob@0o`00CP00
o`1=0000ocX0ooooH03o000B003o04d0003oEP3oool004<0oooo00<000000?ooo`3oool0403ooolU
0?l004`00?l0C@000?lk0?oooel0o`004`00o`1<0000oeH0oooo00130?ooo`030000003oool0oooo
0100oooo9`3o001;003o04/0003o?@3ooomN0?l001<00?l0B`000?mG0?ooo`00@`3oool00`000000
oooo0?ooo`0A0?ooobL0o`00BP00o`1;0000ocd0ooooGP3o000D003o04X0003oE`3oool004<0oooo
00<000000?ooo`3oool04P3ooolX0?l004T00?l0B@000?lo0?oooed0o`005000o`190000oeP0oooo
00130?ooo`030000003oool0oooo0180oooo:P3o0017003o04T0003o?`3ooomM0?l001D00?l0B000
0?mH0?ooo`00@`3oool00`000000oooo0?ooo`0C0?ooob/0o`00AP00o`170000od40ooooG03o000F
003o04H0003oF@3oool004<0oooo00<000000?ooo`3oool04`3oool/0?l004H00?l0A@000?m20?oo
oe`0o`005P00o`150000oeX0oooo00130?ooo`030000003oool0oooo01@0oooo;@3o0014003o04D0
003o@`3ooomK0?l001L00?l0A0000?mJ0?ooo`00@`3oool00`000000oooo0?ooo`0D0?ooobl0o`00
@`00o`130000odD0ooooFP3o000G003o04<0003oF`3oool004<0oooo00<000000?ooo`3oool05@3o
ool`0?l004400?l0@`000?m50?oooeX0o`006000o`120000oe/0oooo00130?ooo`030000003oool0
oooo01H0oooo<03o0011003o0440003oA`3ooomI0?l001P00?l0@@000?mL0?ooo`00@`3oool00`00
0000oooo0?ooo`0F0?oooc80o`00@000o`0o0000odP0ooooF@3o000I003o03l0003oG@3oool004<0
oooo00<000000?ooo`3oool05`3ooolc0?l003h00?l0?`000?m90?oooeP0o`006P00o`0n0000oed0
oooo00130?ooo`030000003oool0oooo01L0oooo=@3o000m003o03d0003oB`3ooomG0?l001X00?l0
?@000?mN0?ooo`00@`3oool00`000000oooo0?ooo`0H0?ooocD0o`00?000o`0m0000od/0ooooE`3o
000K003o03`0003oGP3oool004<0oooo00<000000?ooo`3oool0603ooolg0?l003/00?l0>`000?m=
0?oooeH0o`006`00o`0k0000oel0oooo00130?ooo`030000003oool0oooo01T0oooo>03o000i003o
03/0003oC@3ooomF0?l001`00?l0>P000?mO0?ooo`00@`3oool00`000000oooo0?ooo`0J0?ooocP0
o`00>@00o`0i0000odl0ooooE@3o000L003o03T0003oH03oool004<0oooo00<000000?ooo`3oool0
6P3ooolj0?l003P00?l0=`000?m@0?oooeD0o`007@00o`0g0000of40oooo00130?ooo`030000003o
ool0oooo01/0oooo>`3o000f003o03L0003oD@3ooomD0?l001h00?l0=P000?mQ0?ooo`00@`3oool0
0`000000oooo0?ooo`0K0?ooocd0o`00=@00o`0e0000oe<0ooooD`3o000N003o03D0003oHP3oool0
04<0oooo00<000000?ooo`3oool0703ooolm0?l003@00?l0=@000?mC0?oooe<0o`007`00o`0d0000
of80oooo00130?ooo`030000003oool0oooo01`0oooo?`3o000c003o03<0003oE@3ooomB0?l001l0
0?l0<`000?mS0?ooo`00@`3oool00`000000oooo0?ooo`0M0?oood00o`00<@00o`0c0000oeD0oooo
DP3o000P003o0380003oH`3oool004<0oooo00<000000?ooo`3oool07P3ooom10?l003000?l0<@00
0?mG0?oooe40o`008000o`0a0000of@0oooo00130?ooo`030000003oool0oooo01h0oooo@P3o000`
003o02l0003oF03ooomA0?l002400?l0;`000?mU0?ooo`00@`3oool00`000000oooo0?ooo`0O0?oo
od<0o`00;P00o`0_0000oeT0ooooD03o000R003o02h0003oI@3oool004<0oooo00<000000?ooo`3o
ool07`3ooom50?l002d00?l0;@000?mK0?ooodl0o`008P00o`0]0000ofH0oooo00130?ooo`030000
003oool0oooo0200ooooAP3o000[003o02d0003oF`3ooom?0?l002<00?l0;0000?mV0?ooo`00@`3o
ool00`000000oooo0?ooo`0P0?ooodL0o`00:`00o`0[0000oed0ooooCP3o000S003o02/0003oI`3o
ool004<0oooo00<000000?ooo`3oool08@3ooom80?l002X00?l0:@000?mN0?ooodh0o`009000o`0Y
0000ofP0oooo00130?ooo`030000003oool0oooo0280ooooB@3o000X003o02T0003oG`3ooom=0?l0
02@00?l0:@000?mX0?ooo`00@`3oool00`000000oooo0?ooo`0R0?oood/0o`009`00o`0W0000of40
ooooC03o000U003o02L0003oJ@3oool004<0oooo00<000000?ooo`3oool08`3ooom;0?l002H00?l0
9`000?mQ0?oood`0o`009P00o`0V0000ofT0oooo00130?ooo`030000003oool0oooo02<0ooooC@3o
000U003o02D0003oH`3ooom;0?l002H00?l09@000?mZ0?ooo`00@`3oool00`000000oooo0?ooo`0T
0?ooodh0o`008`00o`0U0000of<0ooooB`3o000W003o02@0003oJP3oool004<0oooo00<000000?oo
o`3oool09@3ooom>0?l002<00?l08`000?mU0?ooodX0o`009`00o`0S0000of/0oooo00130?ooo`03
0000003oool0oooo02D0ooooD03o000R003o0240003oIP3ooom:0?l002P00?l08@000?m/0?ooo`00
@`3oool00`000000oooo0?ooo`0V0?oooe40o`008000o`0Q0000ofL0ooooB@3o000X003o0240003o
K03oool004<0oooo00<000000?ooo`3oool09P3ooomC0?l001l00?l07`000?mY0?ooodP0o`00:@00
o`0O0000ofd0oooo00130?ooo`030000003oool0oooo02L0ooooD`3o000N003o01l0003oJ@3ooom8
0?l002X00?l07P000?m]0?ooo`00@`3oool00`000000oooo0?ooo`0W0?oooeD0o`007@00o`0M0000
of/0ooooA`3o000Z003o01d0003oKP3oool004<0oooo00<000000?ooo`3oool0:03ooomF0?l001`0
0?l06`000?m/0?ooodL0o`00:`00o`0K0000ofl0oooo00130?ooo`030000003oool0oooo02T0oooo
E`3o000J003o01/0003oK@3ooom60?l002/00?l06`000?m_0?ooo`00@`3oool00`000000oooo0?oo
o`0Y0?oooeP0o`006P00o`0I0000ofh0ooooAP3o000/003o01T0003oL03oool004<0oooo00<00000
0?ooo`3oool0:P3ooomI0?l001P00?l06@000?m_0?ooodD0o`00;000o`0I0000og00oooo00130?oo
o`030000003oool0oooo02X0ooooF`3o000G003o01L0003oL@3ooom40?l002d00?l05`000?ma0?oo
o`00@`3oool00`000000oooo0?ooo`0[0?oooe`0o`005@00o`0G0000og40ooooA03o000^003o01H0
003oL@3oool004<0oooo00<000000?ooo`3oool0:`3ooomM0?l001D00?l05@000?mc0?oood<0o`00
;P00o`0E0000og80oooo00130?ooo`030000003oool0oooo02`0ooooGP3o000D003o01<0003oM03o
oom30?l002l00?l04`000?mc0?ooo`00@`3oool00`000000oooo0?ooo`0]0?oooel0o`004P00o`0C
0000ogD0oooo@P3o000_003o01<0003oL`3oool004<0oooo00<000000?ooo`3oool0;@3ooomP0?l0
01800?l04@000?mg0?oood40o`00<000o`0A0000og@0oooo00130?ooo`030000003oool0oooo02h0
ooooH@3o000@003o0140003oM`3ooom10?l003000?l04@000?md0?ooo`00@`3oool00`000000oooo
0?ooo`0^0?ooof<0o`003`00o`0?0000ogT0oooo@03o000a003o00l0003oM@3oool004<0oooo00<0
00000?ooo`3oool0;`3ooomT0?l000h00?l03@000?mj0?oood00o`00<P00o`0=0000ogH0oooo0013
0?ooo`030000003oool0oooo02l0ooooI@3o000=003o00d0003oN`3ooolo0?l003800?l03@000?mf
0?ooo`00@`3oool00`000000oooo0?ooo`0`0?ooofH0o`003000o`0;0000og`0oooo?`3o000c003o
00/0003oM`3oool004<0oooo00<000000?ooo`3oool0<@3ooomW0?l000X00?l02`000?mm0?oooch0
o`00<`00o`0;0000ogL0oooo00130?ooo`030000003oool0oooo0340ooooJ@3o0009003o00T0003o
O`3ooolm0?l003@00?l02@000?mh0?ooo`00@`3oool00`000000oooo0?ooo`0b0?ooofT0o`002000
o`090000ogl0oooo?@3o000d003o00T0003oN03oool004<0oooo00<000000?ooo`3oool0<P3ooom[
0?l000L00?l01`000?n10?oooc`0o`00=@00o`070000ogT0oooo00130?ooo`030000003oool0oooo
03<0ooooK03o0006003o00D0003oPP3oooll0?l003H00?l01@000?mj0?ooo`00@`3oool00`000000
oooo0?ooo`0c0?ooofh0o`001000o`050000oh<0oooo>`3o000f003o00D0003oNP3oool004<0oooo
00<000000?ooo`3oool0=03ooom^0?l000@00?l00`000?n40?oooc/0o`00=`00o`030000og/0oooo
00130?ooo`030000003oool0oooo03D0ooooK`3o0002003o00<0003oQ@3ooolj0?l003L00?l00`00
0?mk0?ooo`00@`3oool00`000000oooo0?ooo`0e0?ooog40o`0000<00?l00000o`3oool0QP3oooli
0?l003P00?l000<0003o0?ooo`3oool0NP3oool004<0oooo00<000000?ooo`3oool0=P3oooma0?l0
08P0oooo>@3o000h003o07d0oooo00130?ooo`030000003oool0oooo03H0ooooL@3o00290?ooocP0
o`00>000o`1m0?ooo`00@`3oool00`000000oooo0?ooo`0g0?ooofl0o`00RP3ooolh0?l003L00?l0
OP3oool004<0oooo00<000000?ooo`3oool0=`3ooom_0?l008/0oooo=`3o000g003o07h0oooo0013
0?ooo`030000003oool0oooo03P0ooooK@3o002=0?ooocH0o`00=P00o`1o0?ooo`00@`3oool00`00
0000oooo0?ooo`0i0?ooof`0o`00S@3ooolf0?l003H00?l0O`3oool004<0oooo00<000000?ooo`3o
ool0>@3ooom[0?l008l0oooo=@3o000e003o0800oooo00130?ooo`030000003oool0oooo03X0oooo
J@3o002@0?ooocD0o`00=@00o`200?ooo`00@`3oool00`000000oooo0?ooo`0j0?ooofT0o`00T@3o
oold0?l003@00?l0P@3oool004<0oooo00<000000?ooo`3oool0>`3ooomW0?l00980oooo=03o000c
003o0880oooo00130?ooo`030000003oool0oooo03/0ooooI`3o002C0?oooc<0o`00<`00o`220?oo
o`00@`3oool00`000000oooo0?ooo`0l0?ooofD0o`00U@3ooolb0?l003800?l0P`3oool004<0oooo
00<000000?ooo`3oool0?@3ooomT0?l009D0oooo<P3o000b003o08<0oooo00130?ooo`030000003o
ool0oooo03d0ooooH`3o002G0?oooc40o`00<@00o`240?ooo`00@`3oool00`000000oooo0?ooo`0n
0?ooof40o`00V03ooola0?l003400?l0Q03oool004<0oooo00<000000?ooo`3oool0?P3ooomQ0?l0
09T0oooo<03o000`003o08D0oooo00130?ooo`030000003oool0oooo03l0ooooG`3o002J0?oooc00
o`00;`00o`260?ooo`00@`3oool00`000000oooo0?ooo`0o0?oooel0o`00V`3oool_0?l002l00?l0
QP3oool004<0oooo00<000000?ooo`3oool0@03ooomM0?l009d0oooo;P3o000^003o08L0oooo0013
0?ooo`030000003oool0oooo0440ooooG03o002M0?ooobh0o`00;P00o`270?ooo`00@`3oool00`00
0000oooo0?ooo`110?oooe/0o`00W`3oool]0?l002d00?l0R03oool004<0oooo00<000000?ooo`3o
ool0@P3ooomI0?l00:00oooo;@3o000]003o08P0oooo00130?ooo`030000003oool0oooo0480oooo
F@3o002Q0?ooob`0o`00;000o`290?ooo`00@`3oool00`000000oooo0?ooo`130?oooeL0o`00X`3o
ool[0?l002/00?l0RP3oool004<0oooo00<000000?ooo`3oool0@`3ooomG0?l00:<0oooo:`3o000[
003o08X0oooo00130?ooo`030000003oool0oooo04@0ooooE@3o002U0?ooobX0o`00:P00o`2;0?oo
o`00@`3oool00`000000oooo0?ooo`150?oooe@0o`00Y@3ooolZ0?l002X00?l0R`3oool004<0oooo
00<000000?ooo`3oool0A@3ooomC0?l00:L0oooo:@3o000Y003o08`0oooo00130?ooo`030000003o
ool0oooo04H0ooooD@3o002X0?ooobT0o`00:@00o`2<0?ooo`00@`3oool00`000000oooo0?ooo`16
0?oooe40o`00Z@3ooolX0?l002P00?l0S@3oool004<0oooo00<000000?ooo`3oool0A`3ooom?0?l0
0:/0oooo9`3o000X003o08d0oooo00130?ooo`030000003oool0oooo04L0ooooC`3o002[0?ooobL0
o`009`00o`2>0?ooo`00@`3oool00`000000oooo0?ooo`180?ooodd0o`00[@3ooolV0?l002H00?l0
S`3oool004<0oooo00<000000?ooo`3oool0B@3ooom;0?l00:h0oooo9P3o000V003o08l0oooo0013
0?ooo`030000003oool0oooo04T0ooooB`3o002_0?ooobD0o`009@00o`2@0?ooo`00@`3oool00`00
0000oooo0?ooo`1:0?ooodT0o`00/03ooolU0?l002D00?l0T03oool004<0oooo00<000000?ooo`3o
ool0BP3ooom90?l00;40oooo903o000T003o0940oooo00130?ooo`030000003oool0oooo04/0oooo
A`3o002c0?ooob<0o`009000o`2A0?ooo`00@`3oool00`000000oooo0?ooo`1<0?ooodH0o`00/`3o
oolS0?l002<00?l0TP3oool004<0oooo00<000000?ooo`3oool0C03ooom50?l00;D0oooo8P3o000R
003o09<0oooo00130?ooo`030000003oool0oooo04d0oooo@`3o002f0?ooob80o`008P00o`2C0?oo
o`00@`3oool00`000000oooo0?ooo`1=0?oood<0o`00]`3ooolQ0?l002400?l0U03oool004<0oooo
00<000000?ooo`3oool0CP3ooom10?l00;T0oooo803o000Q003o09@0oooo00130?ooo`030000003o
ool0oooo04h0oooo@@3o002i0?ooob00o`008000o`2E0?ooo`00@`3oool00`000000oooo0?ooo`1?
0?ooocl0o`00^`3ooolO0?l002000?l0U@3oool004<0oooo00<000000?ooo`3oool0D03oooln0?l0
0;/0oooo7`3o000O003o09H0oooo00130?ooo`030000003oool0oooo0500oooo?@3o002m0?oooah0
o`007P00o`2G0?ooo`00@`3oool00`000000oooo0?ooo`1A0?oooc/0o`00_P3ooolN0?l001h00?l0
U`3oool004<0oooo00<000000?ooo`3oool0D@3ooolk0?l00;l0oooo7@3o000M003o09P0oooo0013
0?ooo`030000003oool0oooo0580oooo>@3o00310?oooa`0o`007@00o`2H0?ooo`00@`3oool00`00
0000oooo0?ooo`1B0?ooocT0o`00`@3ooolL0?l001`00?l0V@3oool004<0oooo00<000000?ooo`3o
ool0D`3ooolg0?l00<<0oooo6`3o000L003o09T0oooo00130?ooo`030000003oool0oooo05@0oooo
=P3o00330?oooa/0o`006`00o`2J0?ooo`00@`3oool00`000000oooo0?ooo`1D0?ooocD0o`00a@3o
oolJ0?l001/00?l0VP3oool004<0oooo00<000000?ooo`3oool0E@3ooolc0?l00<H0oooo6P3o000J
003o09/0oooo00130?ooo`030000003oool0oooo05D0oooo<`3o00370?oooaT0o`006@00o`2L0?oo
o`00@`3oool00`000000oooo0?ooo`1F0?oooc40o`00b@3ooolH0?l001T00?l0W03oool004<0oooo
00<000000?ooo`3oool0EP3ooola0?l00<T0oooo603o000H003o09d0oooo00130?ooo`030000003o
ool0oooo05L0oooo;`3o003;0?oooaL0o`006000o`2M0?ooo`00@`3oool00`000000oooo0?ooo`1H
0?ooobh0o`00b`3ooolG0?l001L00?l0WP3oool004<0oooo00<000000?ooo`3oool0F03oool]0?l0
0<d0oooo5P3o000G003o09h0oooo00130?ooo`030000003oool0oooo05T0oooo:`3o003?0?oooaD0
o`005P00o`2O0?ooo`00@`3oool00`000000oooo0?ooo`1I0?ooob/0o`00c`3ooolE0?l001D00?l0
X03oool004<0oooo00<000000?ooo`3oool0FP3ooolY0?l00=40oooo503o000E003o0:00oooo0013
0?ooo`030000003oool0oooo05X0oooo:@3o003A0?oooa@0o`005000o`2Q0?ooo`00@`3oool00`00
0000oooo0?ooo`1K0?ooobL0o`00d`3ooolC0?l001@00?l0X@3oool004<0oooo00<000000?ooo`3o
ool0G03ooolU0?l00=@0oooo4`3o000C003o0:80oooo00130?ooo`030000003oool0oooo05`0oooo
9@3o003E0?oooa80o`004`00o`2R0?ooo`00@`3oool00`000000oooo0?ooo`1M0?ooob<0o`00e`3o
oolA0?l001800?l0X`3oool004<0oooo00<000000?ooo`3oool0G@3ooolS0?l00=L0oooo4@3o000A
003o0:@0oooo00130?ooo`030000003oool0oooo05h0oooo8@3o003I0?oooa00o`004@00o`2T0?oo
o`00@`3oool00`000000oooo0?ooo`1N0?ooob40o`00f@3oool@0?l001000?l0Y@3oool004<0oooo
00<000000?ooo`3oool0G`3ooolO0?l00=/0oooo3`3o000@003o0:D0oooo00130?ooo`030000003o
ool0oooo0600oooo7@3o003L0?ooo`l0o`003`00o`2V0?ooo`00@`3oool00`000000oooo0?ooo`1P
0?oooad0o`00g@3oool>0?l000l00?l0YP3oool004<0oooo00<000000?ooo`3oool0H@3ooolK0?l0
0=l0oooo3@3o000>003o0:L0oooo00130?ooo`030000003oool0oooo0640oooo6`3o003O0?ooo`d0
o`003P00o`2W0?ooo`00@`3oool00`000000oooo0?ooo`1R0?oooaT0o`00h@3oool<0?l000d00?l0
Z03oool004<0oooo00<000000?ooo`3oool0HP3ooolI0?l00>40oooo303o000<003o0:T0oooo0013
0?ooo`030000003oool0oooo06<0oooo5`3o003S0?ooo`/0o`003000o`2Y0?ooo`00@`3oool00`00
0000oooo0?ooo`1T0?oooaD0o`00i@3oool:0?l000/00?l0ZP3oool004<0oooo00<000000?ooo`3o
ool0I03ooolE0?l00>D0oooo2P3o000;003o0:X0oooo00130?ooo`030000003oool0oooo06D0oooo
4`3o003W0?ooo`T0o`002P00o`2[0?ooo`00@`3oool00`000000oooo0?ooo`1U0?oooa<0o`00i`3o
ool90?l000X00?l0Z`3oool004<0oooo00<000000?ooo`3oool0IP3ooolA0?l00>T0oooo203o0009
003o0:`0oooo00130?ooo`030000003oool0oooo06H0oooo4@3o003Y0?ooo`P0o`002000o`2]0?oo
o`00@`3oool00`000000oooo0?ooo`1W0?ooo`l0o`00j`3oool70?l000P00?l0[@3oool004<0oooo
00<000000?ooo`3oool0J03oool=0?l00>d0oooo1P3o0007003o0:h0oooo00130?ooo`030000003o
ool0oooo06P0oooo3@3o003]0?ooo`H0o`001`00o`2^0?ooo`00@`3oool00`000000oooo0?ooo`1Y
0?ooo`/0o`00k`3oool50?l000H00?l0[`3oool004<0oooo00<000000?ooo`3oool0J@3oool;0?l0
0>l0oooo1@3o0006003o0:l0oooo00130?ooo`030000003oool0oooo06X0oooo2@3o003a0?ooo`@0
o`001@00o`2`0?ooo`00@`3oool00`000000oooo0?ooo`1Z0?ooo`T0o`00l@3oool40?l000@00?l0
/@3oool004<0oooo00<000000?ooo`3oool0J`3oool70?l00?<0oooo0`3o0004003o0;40oooo0013
0?ooo`030000003oool0oooo06`0oooo1@3o003e0?ooo`80o`000`00o`2b0?ooo`00@`3oool00`00
0000oooo0?ooo`1/0?ooo`D0o`00m@3oool20?l000<00?l0/P3oool004<0oooo00<000000?ooo`3o
ool0K@3oool30?l00?L0oooo00<0o`00003o0000o`00/`3oool004<0oooo00<000000?ooo`3oool0
K@3oool30?l00?L0oooo00<0o`00003o0000o`00/`3oool004<0oooo00<000000?ooo`3oool0KP3o
ool00`3o0000oooo0?ooo`3g0?ooo`03003o003oool0oooo0;80oooo00130?ooo`030000003oool0
oooo0?l0ooooo`3ooolO0?ooo`00@`3oool00`000000oooo0?ooo`3o0?ooool0oooo7`3oool004<0
oooo00<000000?ooo`3oool0o`3ooooo0?oooal0oooo00130?ooo`030000003oool0oooo0?l0oooo
o`3ooolO0?ooo`00@`3oool00`000000oooo0?ooo`3o0?ooool0oooo7`3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3o
oooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00c@3oool2000001/0oooo0`00000E
0?ooo`<000005P3oool2000001H0oooo0P00000F0?ooo`8000005@3oool4000001@0oooo0`00000F
0?ooo`800000cP3oool00<`0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00
000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000503oool010000000
oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00<000000?ooo`3oool05@3oool0
10000000oooo0?ooo`00000D0?ooo`040000003oool0oooo00000<d0oooo003>0?ooo`030000003o
ool0oooo01T0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00000F0?ooo`03
0000003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0D0?ooo`03
0000003oool0oooo01@0oooo00@000000?ooo`3oool000005P3oool00`000000oooo0?ooo`3<0?oo
o`00c`3oool00`000000oooo0?ooo`0H0?ooo`<000005@3oool3000001P0oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3o
ool04`3oool3000001P0oooo00<000000?ooo`3oool0b`3oool00<`0oooo00@000000?ooo`3oool0
00006`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01@0oooo00@000000?ooo`3o
ool00000503oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@0
00000?ooo`3oool000005@3oool00`000000oooo0?ooo`0D0?ooo`040000003oool0oooo00000<d0
oooo003=0?ooo`800000703oool3000001D0oooo0`00000E0?ooo`8000005P3oool2000001H0oooo
0P00000F0?ooo`8000005P3oool3000001D0oooo0P00003>0?ooo`00o`3ooooo0?ooofD0oooo003o
0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0oooo
I@3oool00?l0ooooo`3ooomU0?ooo`00``3oool00`000000oooo0?ooo`3H0?ooo`030000003oool0
oooo0<80oooo00320?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool05@3oool00`00
0000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`00
0000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`00
0000oooo0?ooo`0E0?ooo`030000003oool0oooo0<40oooo00320?ooo`030000003oool0oooo01X0
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0<40
oooo00320?ooo`040000003oool0oooo0?ooo`@000000P3oool400000080oooo100000020?ooo`@0
0000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3o
ool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@0
0000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3o
ool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@0
0000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3o
ool01`3oool400000080oooo100000030?ooo`030000003oool0oooo0<40oooo00310?ooo`030000
003oool0oooo0=`0oooo00<000000?ooo`3oool0`03oool00<80oooo00<000000?ooo`3oool0fP3o
ool00`000000oooo0?ooo`310?ooo`00`P3oool00`000000oooo0?ooo`3J0?ooo`030000003oool0
oooo0<40oooo00330?ooo`030000003oool0oooo0=P0oooo00<000000?ooo`3oool0`P3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00aP3o
ool4000000L0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000=0?ooo`<000001@3o
ool3000000d0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000=0?ooo`<000001@3o
ool3000000d0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000=0?ooo`<000001@3o
ool300000<L0oooo00360?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo0<H0oooo00370?ooo`030000003oool0oooo
00P0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo
00d0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo
00d0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo
00d0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo
00d0oooo0`0000050?ooo`030000003oool0oooo0<H0oooo00380?ooo`030000003oool0oooo00L0
oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool2
000000l0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool00000
0`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3o
ool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@00000
0?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool200000<P0oooo
00360?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000503oool010000000
oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000503o
ool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000503oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo00000<d0oooo0037
0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<00000
0?ooo`3oool0303oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<00000
0?ooo`3oool0303oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<00000
0?ooo`3oool0303oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<00000
0?ooo`3oool0303oool4000000D0oooo00<000000?ooo`3oool0aP3oool00?l0ooooo`3ooomU0?oo
o`00o`3ooooo0?ooofD0oooo0000\
\>"],
  ImageRangeCache->{{{0, 610.813}, {251.313, 0}} -> {-0.28201, -0.0206241, \
0.00419772, 0.00419772}, {{67.125, 294.063}, {246.375, 49.875}} -> {-1.59187, \
-0.043531, 0.00881464, 0.00881464}, {{316.75, 543.625}, {246.375, 49.875}} -> \
{-3.79232, -0.043621, 0.00881551, 0.00881551}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .46425 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0110536 0.47619 [
[.5 .47675 -146 0 ]
[.5 .47675 146 38.75 ]
[ 0 0 0 0 ]
[ 1 .46425 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .01105 m
1 .01105 L
s
.02381 0 m
.02381 .46425 L
s
gsave
.5 .47675 -207 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(2) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(3) show
177.000 12.750 moveto
(Pi) show
201.000 12.750 moveto
(3) show
213.000 12.750 moveto
(Pi) show
237.000 12.750 moveto
(Pi) show
261.000 12.750 moveto
(4) show
273.000 12.750 moveto
(Pi) show
297.000 12.750 moveto
(Pi) show
321.000 12.750 moveto
(2) show
333.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
(--) show
189.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
201.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
213.000 25.875 moveto
(--) show
225.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
237.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
249.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
261.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
273.000 25.875 moveto
(--) show
285.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
297.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
309.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
321.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
333.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
345.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
105.000 39.000 moveto
(7) show
135.000 39.000 moveto
(7) show
171.000 39.000 moveto
(7) show
207.000 39.000 moveto
(7) show
237.000 39.000 moveto
(7) show
267.000 39.000 moveto
(7) show
297.000 39.000 moveto
(7) show
327.000 39.000 moveto
(7) show
333.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .46425 L
0 .46425 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0110536 0.477324 0.453198 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.554958 0.445042 1.6263e-018 0.445042 [
[ 0 0 0 0 ]
[ 1 .97493 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .97493 L
0 .97493 L
closepath
clip
newpath
0 1 0 r
0 0 m
.80194 0 L
.90097 .43388 L
F
0 0 1 r
.80194 0 m
1 0 L
.90097 .43388 L
F
1 0 0 r
0 0 m
.90097 .43388 L
.77748 .97493 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.0110536 0.97619 0.453198 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.554958 0.445042 1.91362e-017 0.445042 [
[ 0 0 0 0 ]
[ 1 .97493 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .97493 L
0 .97493 L
closepath
clip
newpath
0 1 0 r
.77748 .97493 m
0 0 L
.55496 0 L
F
0 0 1 r
.55496 0 m
1 0 L
.95593 .1931 L
F
1 0 0 r
.55496 0 m
.95593 .1931 L
.77748 .97493 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{612, 284.063},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009T000172000`400?l00000o`00003o?@3oool0
0`000000oooo0?ooo`3o0?ooool0oooo9P3oool003d0oooo00<000000?ooo`3oool0o`3ooooo0?oo
obH0oooo000m0?ooo`030000003oool0oooo0?l0ooooo`3ooolV0?ooo`00?@3oool00`000000oooo
0?ooo`3o0?ooool0oooo9P3oool003d0oooo00<000000?ooo`3oool0o`3ooooo0?ooobH0oooo000m
0?ooo`030000003oool0oooo0?l0ooooo`3ooolV0?ooo`00<@3ooooo00000?l000000`00000b0?oo
o`00?@3oool00`000000o`000?l0002h003o02d0003o6@3ooon1003o0080o`00I0000?lo0?ooo`00
?@3oool00`000000oooo0?l000020?l00;H00?l0;@000?lJ0?oooh000?l0103o001R0000ocl0oooo
000m0?ooo`030000003oool0oooo00@0o`00]000o`0]0000oa/0ooooO`00o`060?l00600003o?`3o
ool003d0oooo00@000000?ooo`3oool0oooo1@3o002b003o02d0003o703ooomn003o00P0o`00GP00
0?lo0?ooo`00?@3oool010000000oooo0?ooo`3oool70?l00;400?l0:`000?lM0?ooogl00?l02@3o
001K0000od00oooo000m0?ooo`030000003oool0oooo0080oooo203o002_003o02/0003o7P3ooomn
003o00/0o`00F@000?m00?ooo`00?@3oool00`000000oooo0?ooo`030?ooo`T0o`00[@00o`0[0000
oal0ooooO@00o`0=0?l005L0003o@03oool003d0oooo00<000000?ooo`3oool0103oool:0?l00:/0
0?l0:`000?lP0?ooog`00?l03`3o001E0000od00oooo000m0?ooo`030000003oool0oooo00D0oooo
2`3o002Z003o02T0003o8P3oooml003o0100o`00DP000?m10?ooo`00?@3oool00`000000oooo0?oo
o`050?ooo`d0o`00Z000o`0Y0000ob80ooooO000o`0B0?l00500003o@@3oool003d0oooo00<00000
0?ooo`3oool01P3oool>0?l00:H00?l0:@000?lS0?ooog/00?l0503o001>0000od40oooo000m0?oo
o`030000003oool0oooo00L0oooo3`3o002T003o02T0003o903ooomj003o01H0o`00C0000?m10?oo
o`00?@3oool00`000000oooo0?ooo`080?oooa00o`00XP00o`0Y0000obD0ooooN@00o`0H0?l004X0
003o@@3oool003d0oooo00<000000?ooo`3oool02@3ooolA0?l00:400?l09`000?lW0?ooogT00?l0
6@3o00170000od80oooo000m0?ooo`030000003oool0oooo00T0oooo503o002N003o02L0003o9`3o
oomi003o01/0o`00A@000?m20?ooo`00?@3oool00`000000oooo0?ooo`0:0?oooaD0o`00W000o`0W
0000obP0ooooN000o`0N0?l00480003o@P3oool003d0oooo00<000000?ooo`3oool02`3ooolF0?l0
09X00?l09`000?lY0?ooogL00?l0803o00100000od80oooo000m0?ooo`030000003oool0oooo00`0
oooo5`3o002I003o02D0003o:`3ooomg003o0240o`00?@000?m30?ooo`00?@3oool00`000000oooo
0?ooo`0=0?oooaP0o`00U`00o`0U0000ob`0ooooMP00o`0S0?l003/0003o@`3oool003d0oooo00<0
00000?ooo`3oool03@3ooolJ0?l009D00?l09@000?l/0?ooogH00?l09@3o000i0000od<0oooo000m
0?ooo`030000003oool0oooo00h0oooo6`3o002C003o02D0003o;@3ooome003o02L0o`00=`000?m3
0?ooo`00?@3oool00`000000oooo0?ooo`0?0?oooa`0o`00TP00o`0S0000obl0ooooM000o`0Y0?l0
03D0003o@`3oool003d0oooo00<000000?ooo`3oool0403ooolM0?l009000?l08`000?l`0?ooog@0
0?l0:P3o000b0000od@0oooo000m0?ooo`030000003oool0oooo0140oooo7P3o002>003o02<0003o
<@3ooomc003o02`0o`00<0000?m40?ooo`00?@3oool00`000000oooo0?ooo`0A0?ooob00o`00S000
o`0S0000oc40ooooL`00o`0^0?l002h0003oA03oool003d0oooo00<000000?ooo`3oool04P3ooolQ
0?l008X00?l08`000?lb0?ooog800?l0<03o000/0000od@0oooo000m0?ooo`030000003oool0oooo
01<0oooo8P3o0029003o0240003o=03ooomb003o0340o`00:@000?m50?ooo`00?@3oool00`000000
oooo0?ooo`0D0?ooob<0o`00Q`00o`0Q0000ocD0ooooL@00o`0c0?l002L0003oA@3oool003d0oooo
00<000000?ooo`3oool05@3ooolU0?l008@00?l08@000?le0?ooog400?l0=@3o000U0000odD0oooo
000m0?ooo`030000003oool0oooo01D0oooo9`3o0022003o0240003o=P3ooom`003o03L0o`008`00
0?m50?ooo`00?@3oool00`000000oooo0?ooo`0F0?ooobP0o`00P@00o`0O0000ocP0ooooK`00o`0j
0?l00200003oA@3oool003d0oooo00<000000?ooo`3oool05`3ooolY0?l007l00?l07`000?li0?oo
ofl00?l0>`3o000M0000odH0oooo000m0?ooo`030000003oool0oooo01P0oooo:P3o001m003o01l0
003o>P3ooom^003o03d0o`006`000?m60?ooo`00?@3oool00`000000oooo0?ooo`0I0?ooob/0o`00
N`00o`0O0000ocX0ooooKP00o`0o0?l001T0003oAP3oool003d0oooo00<000000?ooo`3oool06@3o
ool]0?l007T00?l07`000?lk0?ooofd00?l0@@3o000G0000odH0oooo000m0?ooo`030000003oool0
oooo01X0oooo;P3o001h003o01d0003o?@3ooom]003o0480o`0050000?m70?ooo`00?@3oool00`00
0000oooo0?ooo`0K0?ooobl0o`00MP00o`0M0000och0ooooK000o`140?l00180003oA`3oool003d0
oooo00<000000?ooo`3oool0703oool`0?l007@00?l07@000?lo0?ooof/00?l0AP3o000@0000odL0
oooo000m0?ooo`030000003oool0oooo01d0oooo<@3o001b003o01d0003o?`3ooom[003o04P0o`00
3P000?m70?ooo`00?@3oool00`000000oooo0?ooo`0M0?oooc<0o`00L@00o`0K0000od40ooooJP00
o`1:0?l000`0003oA`3oool003d0oooo00<000000?ooo`3oool07P3ooold0?l006l00?l06`000?m2
0?ooofX00?l0B`3o00090000odP0oooo000m0?ooo`030000003oool0oooo01l0oooo=@3o001]003o
01/0003o@`3ooomY003o04d0o`001`000?m80?ooo`00?@3oool00`000000oooo0?ooo`0P0?ooocH0
o`00J`00o`0K0000od@0ooooJ000o`1?0?l000D0003oB03oool003d0oooo00<000000?ooo`3oool0
8@3ooolh0?l006T00?l06@000?m50?ooofP00?l0D@3o00030000odP0oooo000m0?ooo`030000003o
ool0oooo0240oooo>P3o001W003o01T0003oAP3ooomX003o0580o`00B@3oool003d0oooo00<00000
0?ooo`3oool08P3ooolk0?l006D00?l06@000?m70?ooofL00?l0DP3o00190?ooo`00?@3oool00`00
0000oooo0?ooo`0S0?oooc`0o`00H`00o`0I0000odP0ooooIP00o`1B0?l004T0oooo000m0?ooo`03
0000003oool0oooo02@0oooo?@3o001Q003o01T0003oB@3ooomU003o0580o`00B@3oool003d0oooo
00<000000?ooo`3oool09@3oooln0?l006000?l05`000?m:0?ooofH00?l0D@3o00190?ooo`00?@3o
ool00`000000oooo0?ooo`0U0?oood00o`00GP00o`0G0000od/0ooooI@00o`1@0?l004X0oooo000m
0?ooo`030000003oool0oooo02H0oooo@@3o001L003o01L0003oC03ooomT003o0500o`00BP3oool0
03d0oooo00<000000?ooo`3oool09`3ooom20?l005X00?l05`000?m=0?ooof<00?l0D03o001:0?oo
o`00?@3oool00`000000oooo0?ooo`0X0?oood<0o`00F@00o`0E0000odl0ooooHP00o`1@0?l004X0
oooo000m0?ooo`030000003oool0oooo02T0ooooA03o001G003o01D0003oC`3ooomS003o04h0o`00
B`3oool003d0oooo00<000000?ooo`3oool0:@3ooom60?l005D00?l05@000?m@0?ooof800?l0CP3o
001;0?ooo`00?@3oool00`000000oooo0?ooo`0Z0?ooodL0o`00D`00o`0E0000oe40ooooH@00o`1>
0?l004/0oooo000m0?ooo`030000003oool0oooo02/0ooooB03o001A003o01D0003oDP3ooomP003o
04h0o`00B`3oool003d0oooo00<000000?ooo`3oool0;03ooom:0?l004l00?l04`000?mC0?ooof40
0?l0C03o001<0?ooo`00?@3oool00`000000oooo0?ooo`0]0?oood/0o`00C@00o`0C0000oe@0oooo
H000o`1<0?l004`0oooo000m0?ooo`030000003oool0oooo02d0ooooC@3o001;003o01<0003oE@3o
oomO003o04`0o`00C03oool003d0oooo00<000000?ooo`3oool0;P3ooom>0?l004T00?l04`000?mF
0?oooeh00?l0C03o001<0?ooo`00?@3oool00`000000oooo0?ooo`0_0?ooodl0o`00B000o`0A0000
oeP0ooooG@00o`1<0?l004`0oooo000m0?ooo`030000003oool0oooo0300ooooD03o0016003o0140
003oF03ooomN003o04X0o`00C@3oool003d0oooo00<000000?ooo`3oool0<@3ooomA0?l004@00?l0
4@000?mI0?oooed00?l0BP3o001=0?ooo`00?@3oool00`000000oooo0?ooo`0a0?oooe<0o`00@P00
o`0A0000oeX0ooooG000o`1:0?l004d0oooo000m0?ooo`030000003oool0oooo0380ooooE03o0011
003o00l0003oG03ooomK003o04X0o`00C@3oool003d0oooo00<000000?ooo`3oool0<`3ooomE0?l0
03l00?l03`000?mM0?oooe/00?l0B03o001>0?ooo`00?@3oool00`000000oooo0?ooo`0d0?oooeH0
o`00?@00o`0?0000oed0ooooF`00o`180?l004h0oooo000m0?ooo`030000003oool0oooo03D0oooo
E`3o000k003o00l0003oGP3ooomJ003o04P0o`00CP3oool003d0oooo00<000000?ooo`3oool0=@3o
oomI0?l003T00?l03`000?mO0?oooeT00?l0B03o001>0?ooo`00?@3oool00`000000oooo0?ooo`0f
0?oooeX0o`00>000o`0=0000of40ooooF000o`170?l004l0oooo000m0?ooo`030000003oool0oooo
03L0ooooF`3o000f003o00d0003oHP3ooomH003o04H0o`00C`3oool003d0oooo00<000000?ooo`3o
ool0>03ooomM0?l003<00?l03@000?mR0?oooeP00?l0AP3o001?0?ooo`00?@3oool00`000000oooo
0?ooo`0i0?oooeh0o`00<@00o`0=0000of<0ooooE`00o`160?l004l0oooo000m0?ooo`030000003o
ool0oooo03T0ooooH03o000`003o00/0003oI@3ooomF003o04H0o`00C`3oool003d0oooo00<00000
0?ooo`3oool0>P3ooomQ0?l002h00?l02`000?mV0?oooeH00?l0A03o001@0?ooo`00?@3oool00`00
0000oooo0?ooo`0k0?ooof80o`00;000o`0;0000ofL0ooooE@00o`140?l00500oooo000m0?ooo`03
0000003oool0oooo03`0ooooH`3o000Z003o00/0003oI`3ooomE003o04@0o`00D03oool003d0oooo
00<000000?ooo`3oool0?03ooomU0?l002P00?l02`000?mX0?oooe@00?l0A03o001@0?ooo`00?@3o
ool00`000000oooo0?ooo`0m0?ooofH0o`009`00o`090000ofX0ooooD`00o`130?l00540oooo000m
0?ooo`030000003oool0oooo03h0ooooI`3o000U003o00T0003oJ`3ooomC003o0480o`00D@3oool0
03d0oooo00<000000?ooo`3oool0?`3ooomX0?l002<00?l02@000?m/0?oooe800?l0@P3o001A0?oo
o`00?@3oool00`000000oooo0?ooo`100?ooofT0o`008@00o`090000of`0ooooDP00o`120?l00540
oooo000m0?ooo`030000003oool0oooo0400ooooJ`3o000P003o00L0003oKP3ooomA003o0440o`00
DP3oool003d0oooo00<000000?ooo`3oool0@@3ooom/0?l001h00?l01`000?m_0?oooe400?l0@03o
001B0?ooo`00?@3oool00`000000oooo0?ooo`120?ooofd0o`007000o`070000og00ooooD000o`10
0?l00580oooo000m0?ooo`030000003oool0oooo04<0ooooK`3o000I003o00L0003oL03ooom@003o
0400o`00DP3oool003d0oooo00<000000?ooo`3oool0A03ooom`0?l001P00?l01@000?mb0?ooodl0
0?l0@03o001B0?ooo`00?@3oool00`000000oooo0?ooo`140?ooog80o`005P00o`050000og<0oooo
CP00o`0o0?l005<0oooo000m0?ooo`030000003oool0oooo04D0ooooL`3o000D003o00D0003oM03o
oom>003o03h0o`00D`3oool003d0oooo00<000000?ooo`3oool0AP3ooomd0?l001800?l01@000?me
0?ooodd00?l0?P3o001C0?ooo`00?@3oool00`000000oooo0?ooo`170?ooogD0o`004000o`050000
ogD0ooooC@00o`0n0?l005<0oooo000m0?ooo`030000003oool0oooo04P0ooooMP3o000?003o00<0
003oM`3ooom<003o03d0o`00E03oool003d0oooo00<000000?ooo`3oool0B03ooomh0?l000d00?l0
0`000?mh0?oood`00?l0?03o001D0?ooo`00?@3oool00`000000oooo0?ooo`190?ooogT0o`002`00
o`030000ogT0ooooB`00o`0l0?l005@0oooo000m0?ooo`030000003oool0oooo04X0ooooNP3o0009
003o00<0003oNP3ooom:003o03`0o`00E03oool003d0oooo00<000000?ooo`3oool0B`3ooomk0?l0
00P00?l000<0003o0?ooo`3oool0N@3ooom:003o03/0o`00E@3oool003d0oooo00<000000?ooo`3o
ool0C03oooml0?l000H00?l000<0003o0?ooo`3oool0NP3ooom:003o03X0o`00E@3oool003d0oooo
00<000000?ooo`3oool0C03ooomn0?l000@00?l000<0003o0?ooo`3oool0N`3ooom9003o03X0o`00
E@3oool003d0oooo00<000000?ooo`3oool0C@3ooomo0?l000800?l000<0003o0?ooo`3oool0O03o
oom8003o03X0o`00E@3oool003d0oooo00<000000?ooo`3oool0CP3ooon00?l00800ooooA`00o`0j
0?l005D0oooo000m0?ooo`030000003oool0oooo04l0ooooO`3o00200?ooodL00?l0>@3o001F0?oo
o`00?@3oool00`000000oooo0?ooo`1@0?ooogh0o`00P@3ooom7003o03P0o`00EP3oool003d0oooo
00<000000?ooo`3oool0D03ooomn0?l00880ooooAP00o`0h0?l005H0oooo000m0?ooo`030000003o
ool0oooo0540ooooO@3o00230?ooodD00?l0>03o001F0?ooo`00?@3oool00`000000oooo0?ooo`1B
0?ooog/0o`00Q@3ooom4003o03L0o`00E`3oool003d0oooo00<000000?ooo`3oool0D`3ooomj0?l0
08D0ooooA@00o`0f0?l005L0oooo000m0?ooo`030000003oool0oooo05@0ooooN@3o00260?oood@0
0?l0=P3o001G0?ooo`00?@3oool00`000000oooo0?ooo`1D0?ooogT0o`00Q`3ooom3003o03H0o`00
E`3oool003d0oooo00<000000?ooo`3oool0E@3ooomg0?l008T0oooo@P00o`0e0?l005P0oooo000m
0?ooo`030000003oool0oooo05H0ooooMP3o002:0?oood400?l0=@3o001H0?ooo`00?@3oool00`00
0000oooo0?ooo`1G0?ooogD0o`00RP3ooom2003o03@0o`00F03oool003d0oooo00<000000?ooo`3o
ool0F03ooomd0?l008/0oooo@@00o`0d0?l005P0oooo000m0?ooo`030000003oool0oooo05P0oooo
M03o002<0?oood000?l0=03o001H0?ooo`00?@3oool00`000000oooo0?ooo`1I0?ooog80o`00SP3o
oolo003o03<0o`00F@3oool003d0oooo00<000000?ooo`3oool0FP3oooma0?l008h0oooo@000o`0b
0?l005T0oooo000m0?ooo`030000003oool0oooo05/0ooooL03o002?0?ooocl00?l0<P3o001I0?oo
o`00?@3oool00`000000oooo0?ooo`1L0?ooofl0o`00T03oooln003o0380o`00F@3oool003d0oooo
00<000000?ooo`3oool0G03ooom^0?l00980oooo?@00o`0a0?l005X0oooo000m0?ooo`030000003o
ool0oooo05d0ooooK@3o002C0?oooc`00?l0<@3o001J0?ooo`00?@3oool00`000000oooo0?ooo`1N
0?ooof`0o`00T`3ooolm003o0300o`00FP3oool003d0oooo00<000000?ooo`3oool0G`3ooom[0?l0
09@0oooo?000o`0`0?l005X0oooo000m0?ooo`030000003oool0oooo0600ooooJP3o002E0?oooc/0
0?l0;`3o001K0?ooo`00?@3oool00`000000oooo0?ooo`1P0?ooofT0o`00U`3ooolj003o02l0o`00
F`3oool003d0oooo00<000000?ooo`3oool0H@3ooomX0?l009P0oooo>P00o`0^0?l005/0oooo000m
0?ooo`030000003oool0oooo0680ooooI`3o002H0?ooocX00?l0;P3o001K0?ooo`00?@3oool00`00
0000oooo0?ooo`1S0?ooofH0o`00V@3oooli003o02h0o`00F`3oool003d0oooo00<000000?ooo`3o
ool0I03ooomT0?l009/0oooo>000o`0]0?l005`0oooo000m0?ooo`030000003oool0oooo06@0oooo
I03o002L0?ooocL00?l0;@3o001L0?ooo`00?@3oool00`000000oooo0?ooo`1U0?ooof<0o`00W@3o
oolg003o02`0o`00G03oool003d0oooo00<000000?ooo`3oool0IP3ooomR0?l009d0oooo=`00o`0/
0?l005`0oooo000m0?ooo`030000003oool0oooo06L0ooooH@3o002N0?ooocH00?l0:`3o001M0?oo
o`00?@3oool00`000000oooo0?ooo`1X0?oooel0o`00X03ooole003o02/0o`00G@3oool003d0oooo
00<000000?ooo`3oool0J03ooomO0?l00:40oooo=@00o`0Z0?l005d0oooo000m0?ooo`030000003o
ool0oooo06T0ooooGP3o002R0?oooc@00?l0:P3o001M0?ooo`00?@3oool00`000000oooo0?ooo`1Z
0?oooed0o`00XP3ooold003o02T0o`00GP3oool003d0oooo00<000000?ooo`3oool0J`3ooomK0?l0
0:@0oooo<`00o`0Y0?l005h0oooo000m0?ooo`030000003oool0oooo06`0ooooFP3o002U0?oooc<0
0?l0:03o001N0?ooo`00?@3oool00`000000oooo0?ooo`1/0?oooeX0o`00YP3ooolb003o02P0o`00
GP3oool003d0oooo00<000000?ooo`3oool0K@3ooomI0?l00:L0oooo<@00o`0X0?l005h0oooo000m
0?ooo`030000003oool0oooo06h0ooooF03o002W0?oooc400?l09`3o001O0?ooo`00?@3oool00`00
0000oooo0?ooo`1_0?oooeH0o`00Z@3oool`003o02L0o`00G`3oool003d0oooo00<000000?ooo`3o
ool0L03ooomE0?l00:X0oooo<000o`0V0?l005l0oooo000m0?ooo`030000003oool0oooo0700oooo
E@3o002[0?ooobl00?l09P3o001O0?ooo`00?@3oool00`000000oooo0?ooo`1a0?oooe@0o`00Z`3o
ool_003o02D0o`00H03oool003d0oooo00<000000?ooo`3oool0LP3ooomB0?l00:d0oooo;P00o`0U
0?l00600oooo000m0?ooo`030000003oool0oooo07<0ooooD@3o002^0?ooobh00?l0903o001P0?oo
o`00?@3oool00`000000oooo0?ooo`1d0?oooe00o`00[`3oool]003o02@0o`00H03oool003d0oooo
00<000000?ooo`3oool0M03ooom@0?l00;00oooo;000o`0S0?l00640oooo000m0?ooo`030000003o
ool0oooo07D0ooooC`3o002`0?ooob`00?l08`3o001Q0?ooo`00?@3oool00`000000oooo0?ooo`1f
0?ooodd0o`00/P3oool[003o02<0o`00H@3oool003d0oooo00<000000?ooo`3oool0M`3ooom<0?l0
0;<0oooo:`00o`0R0?l00640oooo000m0?ooo`030000003oool0oooo07L0ooooC03o002d0?ooobX0
0?l08P3o001Q0?ooo`00?@3oool00`000000oooo0?ooo`1h0?oood/0o`00]@3ooolY003o0240o`00
HP3oool003d0oooo00<000000?ooo`3oool0N@3ooom90?l00;H0oooo:@00o`0Q0?l00680oooo000m
0?ooo`030000003oool0oooo07X0ooooB03o002g0?ooobT00?l0803o001R0?ooo`00?@3oool00`00
0000oooo0?ooo`1k0?ooodL0o`00^03ooolX003o0200o`00HP3oool003d0oooo00<000000?ooo`3o
ool0N`3ooom70?l00;T0oooo9`00o`0O0?l006<0oooo000m0?ooo`030000003oool0oooo07`0oooo
AP3o002j0?ooobH00?l07`3o001S0?ooo`00?@3oool00`000000oooo0?ooo`1m0?oood@0o`00^`3o
oolV003o01l0o`00H`3oool003d0oooo00<000000?ooo`3oool0OP3ooom30?l00;`0oooo9P00o`0N
0?l006<0oooo000m0?ooo`030000003oool0oooo07l0oooo@P3o002m0?ooobD00?l07@3o001T0?oo
o`00?@3oool00`000000oooo0?ooo`1o0?oood80o`00_P3ooolT003o01d0o`00I03oool003d0oooo
00<000000?ooo`3oool0P03ooom00?l00<00oooo8`00o`0M0?l006@0oooo000m0?ooo`030000003o
ool0oooo0840oooo?`3o00300?ooob@00?l0703o001T0?ooo`00?@3oool00`000000oooo0?ooo`22
0?oooch0o`00`@3ooolS003o01`0o`00I03oool003d0oooo00<000000?ooo`3oool0P`3ooolm0?l0
0<80oooo8P00o`0K0?l006D0oooo000m0?ooo`030000003oool0oooo08<0oooo?@3o00330?ooob40
0?l06`3o001U0?ooo`00?@3oool00`000000oooo0?ooo`240?oooc/0o`00a@3ooolP003o01/0o`00
I@3oool003d0oooo00<000000?ooo`3oool0Q@3ooolj0?l00<D0oooo8@00o`0J0?l006D0oooo000m
0?ooo`030000003oool0oooo08H0oooo>@3o00360?ooob000?l06@3o001V0?ooo`00?@3oool00`00
0000oooo0?ooo`270?ooocP0o`00a`3ooolO003o01T0o`00IP3oool003d0oooo00<000000?ooo`3o
ool0Q`3ooolg0?l00<T0oooo7P00o`0I0?l006H0oooo000m0?ooo`030000003oool0oooo08P0oooo
=P3o00390?oooal00?l0603o001V0?ooo`00?@3oool00`000000oooo0?ooo`290?ooocD0o`00bP3o
oolN003o01L0o`00I`3oool003d0oooo00<000000?ooo`3oool0RP3ooold0?l00</0oooo7@00o`0G
0?l006L0oooo000m0?ooo`030000003oool0oooo08/0oooo<`3o003<0?oooa`00?l05`3o001W0?oo
o`00?@3oool00`000000oooo0?ooo`2;0?oooc80o`00cP3ooolK003o01L0o`00I`3oool003d0oooo
00<000000?ooo`3oool0S03ooola0?l00<h0oooo7000o`0F0?l006L0oooo000m0?ooo`030000003o
ool0oooo08d0oooo<03o003?0?oooa/00?l05@3o001X0?ooo`00?@3oool00`000000oooo0?ooo`2>
0?ooobl0o`00d03ooolJ003o01D0o`00J03oool003d0oooo00<000000?ooo`3oool0S`3oool]0?l0
0=80oooo6@00o`0E0?l006P0oooo000m0?ooo`030000003oool0oooo08l0oooo;@3o003C0?oooaT0
0?l0503o001X0?ooo`00?@3oool00`000000oooo0?ooo`2@0?ooob`0o`00d`3ooolI003o01<0o`00
J@3oool003d0oooo00<000000?ooo`3oool0T@3oool[0?l00=@0oooo6000o`0C0?l006T0oooo000m
0?ooo`030000003oool0oooo0980oooo:P3o003E0?oooaL00?l04`3o001Y0?ooo`00?@3oool00`00
0000oooo0?ooo`2C0?ooobP0o`00e`3ooolG003o0180o`00J@3oool003d0oooo00<000000?ooo`3o
ool0T`3ooolX0?l00=P0oooo5P00o`0A0?l006X0oooo000m0?ooo`030000003oool0oooo09@0oooo
9`3o003H0?oooaH00?l04@3o001Z0?ooo`00?@3oool00`000000oooo0?ooo`2E0?ooobH0o`00f@3o
oolE003o0140o`00JP3oool003d0oooo00<000000?ooo`3oool0UP3ooolT0?l00=/0oooo5000o`0A
0?l006X0oooo000m0?ooo`030000003oool0oooo09L0oooo8`3o003L0?oooa@00?l0403o001Z0?oo
o`00?@3oool00`000000oooo0?ooo`2G0?ooob<0o`00g@3ooolC003o00l0o`00J`3oool003d0oooo
00<000000?ooo`3oool0V03ooolR0?l00=d0oooo4`00o`0?0?l006/0oooo000m0?ooo`030000003o
ool0oooo09T0oooo8@3o003N0?oooa800?l03`3o001[0?ooo`00?@3oool00`000000oooo0?ooo`2J
0?oooal0o`00h03ooolB003o00h0o`00J`3oool003d0oooo00<000000?ooo`3oool0V`3ooolN0?l0
0>40oooo4@00o`0=0?l006`0oooo000m0?ooo`030000003oool0oooo09/0oooo7P3o003R0?oooa00
0?l03@3o001/0?ooo`00?@3oool00`000000oooo0?ooo`2L0?oooad0o`00hP3oool@003o00d0o`00
K03oool003d0oooo00<000000?ooo`3oool0W@3ooolK0?l00>@0oooo3`00o`0=0?l006`0oooo000m
0?ooo`030000003oool0oooo09h0oooo6P3o003U0?ooo`l00?l02`3o001]0?ooo`00?@3oool00`00
0000oooo0?ooo`2O0?oooaT0o`00iP3oool>003o00/0o`00K@3oool003d0oooo00<000000?ooo`3o
ool0W`3ooolI0?l00>H0oooo3P00o`0;0?l006d0oooo000m0?ooo`030000003oool0oooo0:00oooo
603o003W0?ooo`d00?l02`3o001]0?ooo`00?@3oool00`000000oooo0?ooo`2Q0?oooaH0o`00j@3o
ool=003o00X0o`00K@3oool003d0oooo00<000000?ooo`3oool0XP3ooolE0?l00>X0oooo3000o`09
0?l006h0oooo000m0?ooo`030000003oool0oooo0:<0oooo503o003[0?ooo`/00?l02@3o001^0?oo
o`00?@3oool00`000000oooo0?ooo`2S0?oooa@0o`00j`3oool;003o00T0o`00KP3oool003d0oooo
00<000000?ooo`3oool0Y03ooolB0?l00>d0oooo2P00o`090?l006h0oooo000m0?ooo`030000003o
ool0oooo0:D0oooo4@3o003^0?ooo`X00?l01`3o001_0?ooo`00?@3oool00`000000oooo0?ooo`2V
0?oooa00o`00k`3oool9003o00L0o`00K`3oool003d0oooo00<000000?ooo`3oool0Y`3oool?0?l0
0?00oooo2000o`070?l006l0oooo000m0?ooo`030000003oool0oooo0:L0oooo3`3o003`0?ooo`P0
0?l01`3o001_0?ooo`00?@3oool00`000000oooo0?ooo`2X0?ooo`d0o`00lP3oool8003o00D0o`00
L03oool003d0oooo00<000000?ooo`3oool0Z@3oool<0?l00?<0oooo1`00o`050?l00700oooo000m
0?ooo`030000003oool0oooo0:X0oooo2`3o003d0?ooo`H00?l01@3o001`0?ooo`00?@3oool00`00
0000oooo0?ooo`2[0?ooo`X0o`00m@3oool5003o00D0o`00L03oool003d0oooo00<000000?ooo`3o
ool0Z`3oool90?l00?H0oooo1@00o`050?l00700oooo000m0?ooo`030000003oool0oooo0:`0oooo
203o003g0?ooo`D00?l00`3o001a0?ooo`00?@3oool00`000000oooo0?ooo`2]0?ooo`L0o`00n03o
ool4003o00<0o`00L@3oool003d0oooo00<000000?ooo`3oool0[P3oool60?l00?T0oooo0`00o`03
0?l00740oooo000m0?ooo`030000003oool0oooo0:l0oooo1@3o003j0?ooo`800?l00`3o001a0?oo
o`00?@3oool00`000000oooo0?ooo`2_0?ooo`@0o`00n`3oool3003o00030?l0003oool0oooo0700
oooo000m0?ooo`030000003oool0oooo0;00oooo0`3o003l0?ooo`800?l000<0o`000?ooo`3oool0
L03oool003d0oooo00<000000?ooo`3oool0/@3oool20?l00?d0oooo00<00?l00?l0003oool0L@3o
ool003d0oooo00<000000?ooo`3oool0/P3oool00`3o0000oooo0?ooo`3l0?ooo`030?l0003oool0
oooo0700oooo000m0?ooo`030000003oool0oooo0?l0ooooo`3ooolV0?ooo`00?@3oool00`000000
oooo0?ooo`3o0?ooool0oooo9P3oool003d0oooo00<000000?ooo`3oool0o`3ooooo0?ooobH0oooo
000m0?ooo`030000003oool0oooo0?l0ooooo`3ooolV0?ooo`00?@3oool00`000000oooo0?ooo`3o
0?ooool0oooo9P3oool003d0oooo00<000000?ooo`3oool0o`3ooooo0?ooobH0oooo003o0?ooool0
ooooIP3oool00?l0ooooo`3ooomV0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool0
0?l0ooooo`3ooomV0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool00?l0ooooo`3o
oomV0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool00;00oooo00<000000?ooo`3o
ool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3o
ool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0;D0oooo002`0?ooo`030000
003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0Q0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`2e0?ooo`00/03o
ool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool08@3o
ool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3o
ool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0]@3o
ool00;40oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0
oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0
oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0
oooo0;@0oooo002^0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3o
ool010000000oooo0?ooo`00000P0?ooo`040000003oool0oooo00000200oooo00@000000?ooo`3o
ool000006P3oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001X0oooo00@0
00000?ooo`3oool000006P3oool010000000oooo0?ooo`00002f0?ooo`00[P3oool4000001X0oooo
1000000J0?ooo`@00000803oool400000200oooo1000000J0?ooo`@000006P3oool4000001X0oooo
1000000J0?ooo`@00000]P3oool00?l0ooooo`3ooomV0?ooo`00o`3ooooo0?ooofH0oooo003o0?oo
ool0ooooIP3oool00?l0ooooo`3ooomV0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3o
ool00:D0oooo00<000000?ooo`3oool0o`3ooolE0?ooo`030000003oool0oooo0:D0oooo002T0?oo
o`030000003oool0oooo01X0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?oo
o`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?oo
o`030000003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?oo
o`030000003oool0oooo0:@0oooo002T0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0:@0oooo002T0?ooo`040000
003oool0oooo0?ooo`@000000P3oool400000080oooo100000020?ooo`@00000103oool00`000000
oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080
oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080
oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080
oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080
oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@000000P3oool400000080
oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000103oool00`000000
oooo0?ooo`070?ooo`@000000P3oool400000080oooo100000020?ooo`@000000`3oool00`000000
oooo0?ooo`2T0?ooo`00X`3oool00`000000oooo0?ooo`3o0?oooaT0oooo00<000000?ooo`3oool0
X`3oool00:@0oooo00<000000?ooo`3oool0o`3ooolG0?ooo`030000003oool0oooo0:@0oooo002T
0?ooo`030000003oool0oooo0?l0oooo5`3oool00`000000oooo0?ooo`2T0?ooo`00Y@3oool00`00
0000oooo0?ooo`3o0?oooaD0oooo00<000000?ooo`3oool0Y@3oool00?l0ooooo`3ooomV0?ooo`00
o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool00?l0ooooo`3ooomV0?ooo`00o`3ooooo0?oo
ofH0oooo003o0?ooool0ooooIP3oool00?l0ooooo`3ooomV0?ooo`00ZP3oool3000000H0oooo0`00
00050?ooo`<000003@3oool3000000D0oooo0`00000>0?ooo`@000001`3oool3000000D0oooo0`00
000?0?ooo`800000203oool3000000D0oooo0`00000?0?ooo`800000203oool3000000D0oooo0`00
000=0?ooo`<000001@3oool300000100oooo0`0000060?ooo`<000001@3oool3000000d0oooo0`00
00050?ooo`<000003P3oool4000000L0oooo0`0000050?ooo`<00000ZP3oool00:/0oooo00<00000
0?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<0
00000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool0403oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0:T0oooo
002X0?ooo`D000001`3oool3000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<0
00000?ooo`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`000000oooo0?oo
o`0?0?ooo`030000003oool0oooo00L0oooo0`0000050?ooo`030000003oool0oooo00l0oooo00<0
00000?ooo`3oool01`3oool3000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<0
00000?ooo`3oool03@3oool5000000L0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`00
00050?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<0
00000?ooo`3oool0Z@3oool00:P0oooo00@000000?ooo`3oool00000203oool010000000oooo0?oo
o`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000030?ooo`8000004@3oool00`000000
oooo0?ooo`070?ooo`040000003oool0oooo000000<0oooo0P00000B0?ooo`030000003oool0oooo
00H0oooo00@000000?ooo`3oool000000`3oool200000180oooo00<000000?ooo`3oool01P3oool0
10000000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000030?ooo`800000
3`3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000000<0oooo0P00000?0?oo
o`040000003oool0oooo000000<0oooo0P00000A0?ooo`030000003oool0oooo00L0oooo00@00000
0?ooo`3oool000000`3oool200000:/0oooo002Y0?ooo`030000003oool0000000P0oooo00@00000
0?ooo`3oool00000503oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000000P0
oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0
oooo000001@0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00000D0?ooo`04
0000003oool0oooo000001D0oooo00<000000?ooo`000000203oool010000000oooo0?ooo`00000D
0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool010000000oooo
0?ooo`00002`0?ooo`00ZP3oool2000000L0oooo100000050?ooo`030000003oool0oooo00`0oooo
100000050?ooo`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo
0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo
100000050?ooo`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00l0oooo
0P0000070?ooo`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo
0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool0Z@3oool00?l0ooooo`3o
oomV0?ooo`00o`3ooooo0?ooofH0oooo0000\
\>"],
  ImageRangeCache->{{{0, 611}, {283.063, 0}} -> {-0.25193, -0.0232176, \
0.00409797, 0.00409797}, {{61.4375, 293.875}, {277.375, 50.8125}} -> \
{-1.84128, -0.0550043, 0.00966916, 0.00966916}, {{317.063, 549.5}, {277.375, \
50.8125}} -> {-4.31296, -0.0550043, 0.00966916, 0.00966916}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2381 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00566893 0.47619 [
[.5 .2506 -122 0 ]
[.5 .2506 122 38.75 ]
[ 0 0 0 0 ]
[ 1 .2381 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00567 m
1 .00567 L
s
.02381 0 m
.02381 .2381 L
s
gsave
.5 .2506 -183 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Pi) show
93.000 12.750 moveto
(Pi) show
117.000 12.750 moveto
(Pi) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(2) show
177.000 12.750 moveto
(Pi) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(Pi) show
273.000 12.750 moveto
(5) show
285.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
105.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
117.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
129.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
141.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
(--) show
189.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
201.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
273.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
285.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
297.000 25.875 moveto
(<) show
69.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
93.000 39.000 moveto
(3) show
117.000 39.000 moveto
(3) show
141.000 39.000 moveto
(6) show
171.000 39.000 moveto
(3) show
201.000 39.000 moveto
(6) show
225.000 39.000 moveto
(2) show
249.000 39.000 moveto
(12) show
279.000 39.000 moveto
(12) show
291.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2381 L
0 .2381 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00566893 0.477324 0.232426 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.133975 0.866025 -1.05168e-017 0.866025 [
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
0 1 0 r
0 0 m
.5 0 L
.25 .43301 L
F
0 0 1 r
.5 0 m
1 0 L
.25 .43301 L
F
1 0 0 r
0 0 m
.25 .43301 L
.13397 .5 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00566893 0.97619 0.232426 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.133975 0.866025 -3.08998e-018 0.866025 [
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
0 1 0 r
.13397 0 m
.56699 .25 L
.13397 .5 L
F
0 0 1 r
.13397 0 m
1 0 L
.56699 .25 L
F
1 0 0 r
.13397 .5 m
0 0 L
.13397 0 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{612, 145.688},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009T0000TB000`400?l00000o`00003oJ03oool0
0`000000oooo0?ooo`3o0?ooooX0oooo001X0?ooo`030000003oool0oooo0?l0oooonP3oool005h0
ooooo`00002X000005l0oooo001X0?ooo`0300000000o`000?l005d00?l0GP000?lF0?oooaP0o`00
0P00o`2S0000of/0oooo001X0?ooo`030000003o00000?l005`00?l0G@000?lH0?oooaP0o`001000
o`2O0000ofd0oooo001X0?ooo`030000003o00000?l005`00?l0F`000?lJ0?oooaP0o`001P00o`2K
0000ofl0oooo001X0?ooo`030000003oool0o`0005/00?l0F`000?lL0?oooaL0o`001`00o`2I0000
og00oooo001X0?ooo`030000003oool0o`0005/00?l0F@000?lN0?oooaL0o`002@00o`2E0000og80
oooo001X0?ooo`040000003oool0o`000?l005T00?l0F0000?lP0?oooaL0o`002`00o`2A0000og@0
oooo001X0?ooo`030000003oool0o`000080o`00E`00o`1G0000ob80oooo5`3o000=003o08d0003o
MP3oool006P0oooo00<000000?ooo`3oool00P3o001G003o05H0003o903ooolF0?l000h00?l0R`00
0?mg0?ooo`00J03oool00`000000oooo0?ooo`030?l005D00?l0E@000?lV0?oooaH0o`004000o`27
0000ogT0oooo001X0?ooo`030000003oool0oooo00<0o`00E@00o`1C0000obP0oooo5P3o000B003o
08<0003oN`3oool006P0oooo00<000000?ooo`3oool0103o001C003o05<0003o:@3ooolF0?l001@0
0?l0O`000?mm0?ooo`00J03oool010000000oooo0?ooo`3oool30?l005<00?l0D@000?l/0?oooaD0
o`005@00o`1m0000ogh0oooo001X0?ooo`040000003oool0oooo0?ooo`@0o`00D@00o`1@0000obh0
oooo5@3o000G003o07T0003oP03oool006P0oooo00@000000?ooo`3oool0oooo1@3o001?003o04l0
003o<03ooolE0?l001T00?l0M@000?n20?ooo`00J03oool010000000oooo0?ooo`3oool50?l004l0
0?l0CP000?la0?oooaD0o`006P00o`1c0000oh<0oooo001X0?ooo`030000003oool0oooo0080oooo
1@3o001=003o04d0003o=03ooolD0?l001`00?l0K`000?n50?ooo`00J03oool00`000000oooo0?oo
o`020?ooo`D0o`00C@00o`1;0000ocH0oooo503o000N003o06/0003oQ`3oool006P0oooo00<00000
0?ooo`3oool00P3oool60?l004/00?l0BP000?lh0?oooa@0o`008000o`1W0000ohT0oooo001X0?oo
o`030000003oool0oooo0080oooo1P3o001;003o04T0003o>@3ooolD0?l002400?l0I@000?n:0?oo
o`00J03oool00`000000oooo0?ooo`030?ooo`H0o`00B@00o`180000oc`0oooo4`3o000S003o0640
003oS03oool006P0oooo00<000000?ooo`3oool00`3oool70?l004L00?l0A`000?ln0?oooa<0o`00
9@00o`1M0000ohh0oooo001X0?ooo`030000003oool0oooo00<0oooo1`3o0017003o04H0003o?`3o
oolC0?l002L00?l0F@000?n@0?ooo`00J03oool00`000000oooo0?ooo`030?ooo`P0o`00A@00o`15
0000od40oooo4`3o000X003o05L0003oT@3oool006P0oooo00<000000?ooo`3oool0103oool70?l0
04D00?l0@`000?m40?oooa80o`00:P00o`1C0000oi<0oooo001X0?ooo`030000003oool0oooo00@0
oooo203o0013003o0480003oAP3ooolB0?l002`00?l0C`000?nE0?ooo`00J03oool00`000000oooo
0?ooo`040?ooo`T0o`00@@00o`120000odL0oooo4P3o000]003o04d0003oUP3oool006P0oooo00<0
00000?ooo`3oool01@3oool80?l004400?l0@0000?m:0?oooa40o`00;`00o`190000oiP0oooo001X
0?ooo`030000003oool0oooo00D0oooo2@3o000o003o03l0003oC03ooolA0?l003400?l0A@000?nJ
0?ooo`00J03oool00`000000oooo0?ooo`050?ooo`T0o`00?`00o`0n0000odd0oooo4@3o000c003o
0440003oW03oool006P0oooo00<000000?ooo`3oool01@3oool:0?l003d00?l0?@000?m?0?oooa40
o`00=000o`0o0000oid0oooo001X0?ooo`030000003oool0oooo00H0oooo2@3o000m003o03/0003o
DP3oool@0?l003H00?l0>`000?nO0?ooo`00J03oool00`000000oooo0?ooo`060?ooo`X0o`00>`00
o`0j0000oe@0oooo403o000h003o03L0003oX@3oool006P0oooo00<000000?ooo`3oool01P3oool;
0?l003T00?l0>P000?mE0?oooa00o`00>P00o`0c0000oj<0oooo001X0?ooo`030000003oool0oooo
00H0oooo2`3o000i003o03P0003oE`3oool@0?l003/00?l0<@000?nT0?ooo`00J03oool00`000000
oooo0?ooo`070?ooo`/0o`00=`00o`0g0000oeX0oooo3`3o000m003o02d0003oYP3oool006P0oooo
00<000000?ooo`3oool01`3oool;0?l003L00?l0=@000?mL0?ooo`l0o`00?`00o`0Y0000ojP0oooo
001X0?ooo`030000003oool0oooo00L0oooo303o000e003o03D0003oG@3oool?0?l004000?l09`00
0?nY0?ooo`00J03oool00`000000oooo0?ooo`070?ooo``0o`00=@00o`0c0000oel0oooo3`3o0012
003o02<0003oZ`3oool006P0oooo00<000000?ooo`3oool0203oool<0?l003<00?l0<P000?mR0?oo
o`h0o`00A000o`0O0000ojd0oooo001X0?ooo`030000003oool0oooo00P0oooo3@3o000a003o0380
003oH`3oool>0?l004H00?l06`000?n_0?ooo`00J03oool00`000000oooo0?ooo`080?ooo`d0o`00
<@00o`0`0000ofD0oooo3P3o0017003o01T0003o/03oool006P0oooo00<000000?ooo`3oool0203o
ool>0?l002l00?l0;`000?mW0?ooo`h0o`00B@00o`0E0000ok80oooo001X0?ooo`030000003oool0
oooo00T0oooo3@3o000_003o02d0003oJP3oool=0?l004/00?l04@000?nd0?ooo`00J03oool00`00
0000oooo0?ooo`090?ooo`h0o`00;@00o`0]0000of/0oooo3@3o001=003o00d0003o]P3oool006P0
oooo00<000000?ooo`3oool02@3oool?0?l002/00?l0;0000?m]0?ooo`d0o`00CP00o`0;0000okL0
oooo001X0?ooo`030000003oool0oooo00T0oooo3`3o000[003o02X0003oK`3oool=0?l005000?l0
1`000?ni0?ooo`00J03oool00`000000oooo0?ooo`0:0?ooo`l0o`00:@00o`0Z0000og40oooo303o
001B003o00<0003o^`3oool006P0oooo00<000000?ooo`3oool02P3oool?0?l002T00?l0:0000?mc
0?ooo``0o`00D`00o`2m0?ooo`00J03oool00`000000oooo0?ooo`0:0?oooa00o`009`00o`0W0000
ogD0oooo303o001B003o0;h0oooo001X0?ooo`030000003oool0oooo00/0oooo3`3o000W003o02D0
003oN03oool;0?l005000?l0`03oool006P0oooo00<000000?ooo`3oool02`3oool@0?l002D00?l0
9@000?mi0?ooo`/0o`00CP00o`320?ooo`00J03oool00`000000oooo0?ooo`0;0?oooa40o`008`00
o`0T0000og/0oooo2`3o001=003o0<<0oooo001X0?ooo`030000003oool0oooo00/0oooo4@3o000S
003o0280003oO@3oool;0?l004/00?l0a@3oool006P0oooo00<000000?ooo`3oool0303ooolA0?l0
02400?l08@000?n00?ooo`X0o`00B@00o`370?ooo`00J03oool00`000000oooo0?ooo`0<0?oooa40
o`008@00o`0P0000oh40oooo2P3o0017003o0<T0oooo001X0?ooo`030000003oool0oooo00`0oooo
4P3o000O003o01l0003oP`3oool:0?l004H00?l0bP3oool006P0oooo00<000000?ooo`3oool0303o
oolB0?l001l00?l07@000?n50?ooo`X0o`00A000o`3<0?ooo`00J03oool00`000000oooo0?ooo`0=
0?oooa80o`007@00o`0M0000ohL0oooo2@3o0012003o0<h0oooo001X0?ooo`030000003oool0oooo
00d0oooo4`3o000K003o01`0003oR@3oool90?l004000?l0d03oool006P0oooo00<000000?ooo`3o
ool03@3ooolC0?l001/00?l06P000?n;0?ooo`T0o`00?`00o`3A0?ooo`00J03oool00`000000oooo
0?ooo`0=0?oooa@0o`006@00o`0I0000ohd0oooo2@3o000m003o0=<0oooo001X0?ooo`030000003o
ool0oooo00h0oooo4`3o000I003o01P0003oS`3oool80?l003/00?l0e@3oool006P0oooo00<00000
0?ooo`3oool03P3ooolD0?l001L00?l05`000?nA0?ooo`P0o`00>P00o`3F0?ooo`00J03oool00`00
0000oooo0?ooo`0>0?oooaD0o`005@00o`0F0000oi<0oooo203o000h003o0=P0oooo001X0?ooo`03
0000003oool0oooo00h0oooo5@3o000E003o01D0003oU03oool80?l003H00?l0fP3oool006P0oooo
00<000000?ooo`3oool03`3ooolE0?l001<00?l050000?nG0?ooo`L0o`00=000o`3L0?ooo`00J03o
ool00`000000oooo0?ooo`0?0?oooaD0o`004`00o`0B0000oiT0oooo1`3o000c003o0=d0oooo001X
0?ooo`030000003oool0oooo00l0oooo5P3o000A003o0140003oV`3oool70?l003400?l0g`3oool0
06P0oooo00<000000?ooo`3oool03`3ooolF0?l001400?l040000?nL0?ooo`L0o`00;`00o`3Q0?oo
o`00J03oool00`000000oooo0?ooo`0@0?oooaH0o`003`00o`0?0000oil0oooo1P3o000]003o0><0
oooo001X0?ooo`030000003oool0oooo0100oooo5`3o000=003o00h0003oX@3oool60?l002`00?l0
i03oool006P0oooo00<000000?ooo`3oool0403ooolG0?l000d00?l030000?nS0?ooo`H0o`00:P00
o`3V0?ooo`00J03oool00`000000oooo0?ooo`0A0?oooaL0o`002`00o`0<0000ojD0oooo1@3o000X
003o0>P0oooo001X0?ooo`030000003oool0oooo0140oooo5`3o000;003o00X0003oY`3oool50?l0
02L00?l0j@3oool006P0oooo00<000000?ooo`3oool04@3ooolH0?l000T00?l02@000?nY0?ooo`D0
o`009@00o`3[0?ooo`00J03oool00`000000oooo0?ooo`0A0?oooaP0o`002@00o`080000ojX0oooo
1@3o000S003o0>d0oooo001X0?ooo`030000003oool0oooo0180oooo603o0007003o00L0003o[@3o
ool40?l002400?l0k`3oool006P0oooo00<000000?ooo`3oool04P3ooolI0?l000D00?l01P000?n_
0?ooo`@0o`008000o`3`0?ooo`00J03oool00`000000oooo0?ooo`0B0?oooaT0o`001@00o`040000
ok40oooo103o000N003o0?80oooo001X0?ooo`030000003oool0oooo0180oooo6P3o0003003o00@0
003o/P3oool40?l001`00?l0m03oool006P0oooo00<000000?ooo`3oool04`3ooolI0?l000<00?l0
0P000?ne0?ooo`<0o`006P00o`3f0?ooo`00J03oool00`000000oooo0?ooo`0C0?oooaX0o`0000<0
0?l00000o`3oool0]P3oool30?l001T00?l0m`3oool006P0oooo00<000000?ooo`3oool04`3ooolJ
0?l00;T0oooo0`3o000G003o0?T0oooo001X0?ooo`030000003oool0oooo01<0oooo6@3o002j0?oo
o`<0o`005@00o`3k0?ooo`00J03oool00`000000oooo0?ooo`0D0?oooaH0o`00_@3oool20?l001@0
0?l0o03oool006P0oooo00<000000?ooo`3oool0503ooolD0?l00;l0oooo0P3o000B003o0?h0oooo
001X0?ooo`030000003oool0oooo01@0oooo4P3o00310?ooo`80o`004000o`3o0?ooo`40oooo001X
0?ooo`030000003oool0oooo01@0oooo4@3o00320?ooo`80o`003P00o`3o0?ooo`<0oooo001X0?oo
o`030000003oool0oooo01D0oooo3P3o00350?ooo`030?l00000o`000?l000/00?l0o`3oool40?oo
o`00J03oool00`000000oooo0?ooo`0E0?ooo``0o`00a`3oool00`3o00000?l0003o0009003o0?l0
oooo1P3oool006P0oooo00<000000?ooo`3oool05@3oool:0?l00<T0oooo00<0o`00003o0000o`00
1`00o`3o0?ooo`P0oooo001X0?ooo`030000003oool0oooo01D0oooo2@3o003:0?ooo`030?l00000
o`000?l000D00?l0o`3oool:0?ooo`00J03oool00`000000oooo0?ooo`0F0?ooo`H0o`00c@3oool6
003o0?l0oooo2`3oool006P0oooo00<000000?ooo`3oool05P3oool40?l00<l0oooo1000o`3o0?oo
o`d0oooo001X0?ooo`030000003oool0oooo01H0oooo0P3o003A0?ooo`800?l0o`3oool?0?ooo`00
J03oool00`000000oooo0?ooo`3o0?ooooX0oooo001X0?ooo`030000003oool0oooo0?l0oooonP3o
ool006P0oooo00<000000?ooo`3oool0o`3ooooj0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0
ooooIP3oool00?l0ooooo`3ooomV0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool0
0?l0ooooo`3ooomV0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool00?l0ooooo`3o
oomV0?ooo`00`@3oool2000001H0oooo0P00000F0?ooo`8000005@3oool3000001`0oooo0P00000K
0?ooo`<000005@3oool4000001@0oooo1@0000000`3oool0000000000002000001@0oooo1@000000
0`3oool000000000000200000<P0oooo00300?ooo`040000003oool0oooo000001@0oooo00@00000
0?ooo`3oool00000503oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001X0
oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00000D0?ooo`030000003oool0
oooo01L0oooo00D000000?ooo`3oool0oooo0000000I0?ooo`050000003oool0oooo0?ooo`000000
b`3oool00<80oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003o
ool0oooo01<0oooo00@000000?ooo`3oool00000703oool00`000000oooo0?ooo`0I0?ooo`040000
003oool0oooo000001D0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo01H0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`380?ooo`00
``3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
4P3oool3000001h0oooo00<000000?ooo`3oool0603oool3000001L0oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`370?ooo`00`03oool010000000oooo0?ooo`00000D0?ooo`040000
003oool0oooo000001@0oooo00@000000?ooo`3oool000005@3oool00`000000oooo0?ooo`0J0?oo
o`040000003oool0oooo000001/0oooo00<000000?ooo`3oool0503oool010000000oooo0?ooo`00
000F0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0D0?ooo`050000
003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`360?ooo`00`@3oool2000001H0oooo
0P00000F0?ooo`8000005P3oool3000001/0oooo0P00000L0?ooo`<000005@3oool2000001H0oooo
0P0000040?ooo`8000005P3oool2000000@0oooo0P0000390?ooo`00o`3ooooo0?ooofH0oooo003o
0?ooool0ooooIP3oool00?l0ooooo`3ooomV0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0oooo
IP3oool00?l0ooooo`3ooomV0?ooo`00_@3oool00`000000oooo0?ooo`3T0?ooo`030000003oool0
oooo0;d0oooo002l0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool05@3oool00`00
0000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`00
0000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`00
0000oooo0?ooo`0Q0?ooo`030000003oool0oooo0;`0oooo002l0?ooo`030000003oool0oooo00h0
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0
oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0;`0
oooo002l0?ooo`040000003oool0oooo0?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3o
ool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@0
0000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3o
ool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3o
ool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@0
0000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3o
ool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000<0oooo00<000000?ooo`3o
ool0_03oool00;/0oooo00<000000?ooo`3oool0j03oool00`000000oooo0?ooo`2k0?ooo`00_03o
ool00`000000oooo0?ooo`3V0?ooo`030000003oool0oooo0;`0oooo002l0?ooo`030000003oool0
oooo0>H0oooo00<000000?ooo`3oool0_03oool00;d0oooo00<000000?ooo`3oool0i03oool00`00
0000oooo0?ooo`2m0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool00?l0ooooo`3o
oomV0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool00?l0ooooo`3ooomV0?ooo`00
o`3ooooo0?ooofH0oooo002o0?ooo`<000001@3oool3000000d0oooo0`0000050?ooo`<000003@3o
ool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000h0oooo100000070?ooo`<000001@3o
ool3000000d0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000=0?ooo`<000001@3o
ool3000000l0oooo0P0000080?ooo`<000001@3oool300000<80oooo00300?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`090?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool03@3oool010000000oooo0?ooo`0000080?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool0`@3oool00<00oooo0`0000050?ooo`030000003oool0
oooo00d0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0
oooo00d0oooo0`0000050?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool3
000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03@3oool3
000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool0403oool0
0`000000oooo0?ooo`060?ooo`<000001@3oool00`000000oooo0?ooo`310?ooo`00`03oool01000
0000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000030?ooo`8000003`3o
ool010000000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000030?ooo`80
00004@3oool00`000000oooo0?ooo`070?ooo`040000003oool0oooo000000<0oooo0P00000?0?oo
o`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00
000?0?ooo`040000003oool0oooo000000<0oooo0P00000@0?ooo`8000002@3oool010000000oooo
0?ooo`0000030?ooo`800000``3oool00<00oooo00@000000?ooo`3oool00000503oool010000000
oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000503o
ool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000503oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001D0oooo00<0
00000?ooo`3oool0203oool010000000oooo0?ooo`0000380?ooo`00_`3oool4000000D0oooo00<0
00000?ooo`3oool0303oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<0
00000?ooo`3oool0303oool4000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo1000
00050?ooo`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00`0oooo1000
00050?ooo`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0`00
00070?ooo`@000001@3oool00`000000oooo0?ooo`310?ooo`00o`3ooooo0?ooofH0oooo003o0?oo
ool0ooooIP3oool00001\
\>"],
  ImageRangeCache->{{{0, 611}, {144.688, 0}} -> {-0.517632, -0.0119074, \
0.0049677, 0.0049677}, {{104.188, 295.875}, {142.25, 46.375}} -> {-0.782325, \
-0.0147803, 0.00602393, 0.00602393}, {{315.063, 506.75}, {142.25, 46.375}} -> \
{-2.05262, -0.0147803, 0.00602393, 0.00602393}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .20661 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00491932 0.47619 [
[.5 .21911 -146 0 ]
[.5 .21911 146 38.75 ]
[ 0 0 0 0 ]
[ 1 .20661 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00492 m
1 .00492 L
s
.02381 0 m
.02381 .20661 L
s
gsave
.5 .21911 -207 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(2) show
117.000 12.750 moveto
(Pi) show
141.000 12.750 moveto
(3) show
153.000 12.750 moveto
(Pi) show
177.000 12.750 moveto
(Pi) show
201.000 12.750 moveto
(5) show
213.000 12.750 moveto
(Pi) show
237.000 12.750 moveto
(Pi) show
261.000 12.750 moveto
(3) show
273.000 12.750 moveto
(Pi) show
297.000 12.750 moveto
(Pi) show
321.000 12.750 moveto
(3) show
333.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
(--) show
129.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
141.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
153.000 25.875 moveto
(--) show
165.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
177.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
189.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
201.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
213.000 25.875 moveto
(--) show
225.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
237.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
249.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
261.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
273.000 25.875 moveto
(--) show
285.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
297.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
309.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
321.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
333.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
345.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
111.000 39.000 moveto
(7) show
147.000 39.000 moveto
(7) show
177.000 39.000 moveto
(7) show
207.000 39.000 moveto
(7) show
237.000 39.000 moveto
(7) show
267.000 39.000 moveto
(7) show
297.000 39.000 moveto
(7) show
327.000 39.000 moveto
(7) show
333.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .20661 L
0 .20661 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00491932 0.477324 0.201692 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.198062 0.801938 8.83625e-018 0.801938 [
[ 0 0 0 0 ]
[ 1 .43388 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .43388 L
0 .43388 L
closepath
clip
newpath
0 1 0 r
0 0 m
.55496 0 L
.27748 .34795 L
F
0 0 1 r
.55496 0 m
1 0 L
.27748 .34795 L
F
1 0 0 r
0 0 m
.27748 .34795 L
.09903 .43388 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00491932 0.97619 0.201692 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.198062 0.801938 8.83625e-018 0.801938 [
[ 0 0 0 0 ]
[ 1 .43388 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .43388 L
0 .43388 L
closepath
clip
newpath
0 1 0 r
.19806 0 m
.59903 .1931 L
.09903 .43388 L
F
0 0 1 r
.19806 0 m
1 0 L
.59903 .1931 L
F
1 0 0 r
.09903 .43388 m
0 0 L
.19806 0 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.625, 126.375},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000OR000`400?l00000o`00003oM@3oool0
0`000000oooo0?ooo`3o0?ooon`0oooo001e0?ooo`030000003oool0oooo0?l0ooook03oool006/0
ooooo`00002=000006`0oooo001e0?ooo`0300000000o`000?l006000?l0CP000?lE0?ooob80o`00
0`00o`2;0000ogP0oooo001e0?ooo`030000003o00000?l005l00?l0C@000?lG0?ooob80o`001@00
o`270000ogX0oooo001e0?ooo`030000003o0000o`0005h00?l0C0000?lI0?ooob80o`001`00o`23
0000og`0oooo001e0?ooo`040000003o0000o`000?l005`00?l0B`000?lK0?ooob80o`002@00o`1o
0000ogh0oooo001e0?ooo`040000003oool0o`000?l005/00?l0BP000?lN0?ooob00o`003000o`1k
0000oh00oooo001e0?ooo`030000003oool0o`000080o`00FP00o`180000ob00oooo803o000>003o
07L0003oPP3oool007D0oooo00<000000?ooo`3o00000`3o001H003o04L0003o8P3ooolP0?l00100
0?l0L`000?n40?ooo`00M@3oool00`000000oooo0?l000040?l005H00?l0AP000?lT0?ooob00o`00
4P00o`1_0000ohH0oooo001e0?ooo`030000003oool0o`0000D0o`00E000o`150000obL0oooo7`3o
000D003o06/0003oR03oool007D0oooo00<000000?ooo`3oool01@3o001C003o04@0003o:@3ooolN
0?l001L00?l0I`000?n:0?ooo`00M@3oool00`000000oooo0?ooo`060?l005800?l0@@000?l/0?oo
oah0o`006@00o`1S0000oh`0oooo001e0?ooo`030000003oool0oooo00L0o`00D000o`100000obh0
oooo7P3o000K003o05l0003oSP3oool007D0oooo00<000000?ooo`3oool0203o001>003o03l0003o
<03ooolN0?l001d00?l0F`000?n@0?ooo`00M@3oool010000000oooo0?ooo`3oool80?l004`00?l0
?P000?lc0?oooa`0o`008000o`1G0000oi80oooo001e0?ooo`040000003oool0oooo0?ooo`P0o`00
B`00o`0m0000ocD0oooo703o000R003o05<0003oU03oool007D0oooo00@000000?ooo`3oool0oooo
2@3o001:003o03/0003o=`3ooolL0?l002@00?l0C`000?nF0?ooo`00M@3oool010000000oooo0?oo
o`3oool:0?l004P00?l0>P000?li0?oooa`0o`009P00o`1;0000oiP0oooo001e0?ooo`040000003o
ool0oooo0?ooo`/0o`00AP00o`0i0000oc`0oooo6`3o000Y003o04D0003oV`3oool007D0oooo00<0
00000?ooo`3oool00P3oool;0?l004@00?l0>0000?ln0?oooaX0o`00;000o`110000oid0oooo001e
0?ooo`030000003oool0oooo0080oooo2`3o0013003o03L0003o@03ooolJ0?l002h00?l0?@000?nO
0?ooo`00M@3oool00`000000oooo0?ooo`020?ooo``0o`00@P00o`0d0000od<0oooo6P3o000`003o
03T0003oX@3oool007D0oooo00<000000?ooo`3oool00P3oool=0?l004000?l0<`000?m60?oooaT0
o`00<P00o`0e0000oj<0oooo001e0?ooo`030000003oool0oooo00<0oooo3@3o000n003o0380003o
B03ooolH0?l003D00?l0<@000?nU0?ooo`00M@3oool00`000000oooo0?ooo`030?ooo`d0o`00?@00
o`0a0000odX0oooo603o000g003o02d0003oY`3oool007D0oooo00<000000?ooo`3oool00`3oool>
0?l003/00?l0<0000?m<0?oooaP0o`00>@00o`0Y0000ojT0oooo001e0?ooo`030000003oool0oooo
00<0oooo3`3o000j003o02h0003oCP3ooolH0?l003/00?l09@000?n[0?ooo`00M@3oool00`000000
oooo0?ooo`030?oooa00o`00>000o`0]0000oe40oooo5`3o000m003o0240003o[@3oool007D0oooo
00<000000?ooo`3oool0103oool@0?l003H00?l0;0000?mC0?oooaH0o`00@000o`0M0000ojl0oooo
001e0?ooo`030000003oool0oooo00@0oooo403o000e003o02/0003oE@3ooolF0?l004800?l06@00
0?na0?ooo`00M@3oool00`000000oooo0?ooo`040?oooa40o`00<`00o`0Z0000oeL0oooo5P3o0014
003o01D0003o/`3oool007D0oooo00<000000?ooo`3oool0103ooolB0?l003400?l0:0000?mK0?oo
oaD0o`00AP00o`0A0000okD0oooo001e0?ooo`030000003oool0oooo00@0oooo4`3o000`003o02H0
003oG@3ooolE0?l004P00?l03@000?ng0?ooo`00M@3oool00`000000oooo0?ooo`050?oooa<0o`00
;P00o`0U0000oel0oooo503o001;003o00T0003o^@3oool007D0oooo00<000000?ooo`3oool01@3o
oolC0?l002d00?l090000?mQ0?oooa@0o`00C@00o`050000ok/0oooo001e0?ooo`030000003oool0
oooo00D0oooo503o000[003o02<0003oI03ooolC0?l004l00?l0_P3oool007D0oooo00<000000?oo
o`3oool01@3ooolE0?l002T00?l08P000?mV0?oooa<0o`00C@00o`300?ooo`00M@3oool00`000000
oooo0?ooo`060?oooaD0o`00:000o`0P0000ofP0oooo4P3o001<003o0<80oooo001e0?ooo`030000
003oool0oooo00H0oooo5P3o000V003o01l0003oJP3ooolB0?l004X00?l0a03oool007D0oooo00<0
00000?ooo`3oool01P3ooolF0?l002D00?l07P000?m/0?oooa80o`00B000o`360?ooo`00M@3oool0
0`000000oooo0?ooo`060?oooaL0o`008`00o`0M0000ofl0oooo4@3o0016003o0<P0oooo001e0?oo
o`030000003oool0oooo00H0oooo603o000Q003o01`0003oL@3ooolA0?l004@00?l0bP3oool007D0
oooo00<000000?ooo`3oool01`3ooolH0?l002000?l06@000?md0?oooa00o`00@`00o`3<0?ooo`00
M@3oool00`000000oooo0?ooo`070?oooaP0o`007`00o`0H0000ogH0oooo403o0011003o0<h0oooo
001e0?ooo`030000003oool0oooo00L0oooo6@3o000M003o01L0003oN@3oool?0?l003l00?l0d03o
ool007D0oooo00<000000?ooo`3oool01`3ooolJ0?l001/00?l05P000?mk0?ooo`l0o`00?@00o`3B
0?ooo`00M@3oool00`000000oooo0?ooo`080?oooaX0o`006@00o`0E0000ogd0oooo3P3o000l003o
0=@0oooo001e0?ooo`030000003oool0oooo00P0oooo6`3o000H003o01<0003oO`3oool>0?l003X0
0?l0eP3oool007D0oooo00<000000?ooo`3oool0203ooolK0?l001L00?l04P000?n20?ooo`d0o`00
>000o`3H0?ooo`00M@3oool00`000000oooo0?ooo`080?oooa`0o`005@00o`0A0000oh@0oooo3@3o
000f003o0=X0oooo001e0?ooo`030000003oool0oooo00P0oooo7@3o000C003o0100003oQP3oool=
0?l003<00?l0g@3oool007D0oooo00<000000?ooo`3oool02@3ooolM0?l001400?l03`000?n80?oo
o``0o`00<P00o`3O0?ooo`00M@3oool00`000000oooo0?ooo`090?oooah0o`004000o`0<0000oh/0
oooo303o000`003o0>40oooo001e0?ooo`030000003oool0oooo00T0oooo7P3o000?003o00/0003o
SP3oool;0?l002h00?l0h`3oool007D0oooo00<000000?ooo`3oool02@3ooolO0?l000d00?l02P00
0?n@0?ooo`/0o`00;000o`3U0?ooo`00M@3oool00`000000oooo0?ooo`090?ooob00o`002`00o`09
0000oi80oooo2`3o000Z003o0>L0oooo001e0?ooo`030000003oool0oooo00X0oooo803o0009003o
00P0003oU03oool:0?l002T00?l0j@3oool007D0oooo00<000000?ooo`3oool02P3ooolQ0?l000P0
0?l01P000?nG0?ooo`T0o`009`00o`3[0?ooo`00M@3oool00`000000oooo0?ooo`0:0?ooob40o`00
1`00o`050000oiT0oooo2@3o000U003o0>d0oooo001e0?ooo`030000003oool0oooo00X0oooo8P3o
0005003o00@0003oV`3oool90?l002<00?l0k`3oool007D0oooo00<000000?ooo`3oool02`3ooolR
0?l000<00?l00`000?nM0?ooo`P0o`008P00o`3a0?ooo`00M@3oool00`000000oooo0?ooo`0;0?oo
ob<0o`0000<00?l00000o`000?l0X03oool70?l002000?l0l`3oool007D0oooo00<000000?ooo`3o
ool02`3ooolS0?l00:<0oooo1`3o000N003o0?D0oooo001e0?ooo`030000003oool0oooo00/0oooo
8@3o002U0?ooo`L0o`007000o`3g0?ooo`00M@3oool00`000000oooo0?ooo`0;0?oooal0o`00Y`3o
ool70?l001T00?l0nP3oool007D0oooo00<000000?ooo`3oool0303ooolL0?l00:T0oooo1P3o000H
003o0?`0oooo001e0?ooo`030000003oool0oooo00`0oooo6P3o002/0?ooo`D0o`005P00o`3n0?oo
o`00M@3oool00`000000oooo0?ooo`0<0?oooaP0o`00[P3oool50?l001@00?l0o`3oool10?ooo`00
M@3oool00`000000oooo0?ooo`0<0?oooaH0o`00/03oool50?l001800?l0o`3oool30?ooo`00M@3o
ool00`000000oooo0?ooo`0=0?oooa<0o`00/P3oool40?l001400?l0o`3oool50?ooo`00M@3oool0
0`000000oooo0?ooo`0=0?oooa40o`00]@3oool30?l000l00?l0o`3oool70?ooo`00M@3oool00`00
0000oooo0?ooo`0=0?ooo`l0o`00]`3oool30?l000d00?l0o`3oool90?ooo`00M@3oool00`000000
oooo0?ooo`0=0?ooo`d0o`00^@3oool30?l000/00?l0o`3oool;0?ooo`00M@3oool00`000000oooo
0?ooo`0=0?ooo`/0o`00^`3oool30?l000T00?l0o`3oool=0?ooo`00M@3oool00`000000oooo0?oo
o`0>0?ooo`P0o`00_P3oool00`3o00000?l0003o0006003o0?l0oooo3`3oool007D0oooo00<00000
0?ooo`3oool03P3oool60?l00<00oooo00<0o`00003o0000o`001000o`3o0?oooa40oooo001e0?oo
o`030000003oool0oooo00h0oooo103o00320?ooo`030?l00000o`000?l000800?l0o`3ooolC0?oo
o`00M@3oool00`000000oooo0?ooo`0>0?ooo`80o`00a03oool00`3o00000?l0003o003o0?oooaD0
oooo001e0?ooo`030000003oool0oooo0?l0ooook03oool007D0oooo00<000000?ooo`3oool0o`3o
ooo/0?ooo`00M@3oool00`000000oooo0?ooo`3o0?ooon`0oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00/03o
ool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool06`3o
ool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3o
ool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0]03o
ool00;00oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0
oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0
oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0
oooo0;@0oooo002`0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`2d0?ooo`00/@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240
oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0
oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0
oooo00<000000?ooo`3oool0/`3oool00:h0oooo00@000000?ooo`3oool00000803oool010000000
oooo0?ooo`00000P0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3o
ool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3o
ool000006P3oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo00000;D0oooo002^
0?ooo`@00000803oool400000200oooo1000000J0?ooo`@000006P3oool4000001X0oooo1000000J
0?ooo`@000006P3oool4000001X0oooo1000002e0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0
ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool0
0?l0ooooo`3ooomU0?ooo`00Y@3oool00`000000oooo0?ooo`3o0?oooaD0oooo00<000000?ooo`3o
ool0Y03oool00:@0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0Q0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool0X`3oool00:@0oooo00<000000?ooo`3oool06P3o
ool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool05@3o
ool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool08@3o
ool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0X`3o
ool00:@0oooo00@000000?ooo`3oool0oooo100000020?ooo`@000000P3oool400000080oooo1000
00040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@000000P3oool400000080oooo1000
00040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@000000P3oool400000080oooo1000
00040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000103oool00`000000oooo0?oo
o`070?ooo`@000000P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo0?oo
o`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo1000
00020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo1000
00040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@000000P3oool400000080oooo1000
00030?ooo`030000003oool0oooo0:<0oooo002S0?ooo`030000003oool0oooo0?l0oooo6@3oool0
0`000000oooo0?ooo`2R0?ooo`00Y03oool00`000000oooo0?ooo`3o0?oooaL0oooo00<000000?oo
o`3oool0X`3oool00:@0oooo00<000000?ooo`3oool0o`3ooolG0?ooo`030000003oool0oooo0:<0
oooo002U0?ooo`030000003oool0oooo0?l0oooo5@3oool00`000000oooo0?ooo`2T0?ooo`00o`3o
oooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002X0?oo
o`@000001`3oool3000000D0oooo0`00000>0?ooo`@000001`3oool3000000D0oooo0`00000?0?oo
o`800000203oool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000l0oooo0P0000080?oo
o`<000001@3oool3000000d0oooo0`0000050?ooo`<000003`3oool2000000P0oooo0`0000050?oo
o`<000003@3oool3000000D0oooo0`00000?0?ooo`800000203oool3000000D0oooo0`00002Y0?oo
o`00Z03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3o
ool03@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3o
ool03@3oool010000000oooo0?ooo`0000080?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00@000000?oo
o`3oool00000203oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<0
00000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool03@3oool010000000oooo0?ooo`0000080?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool0Z03oool00:T0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<0
00000?ooo`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`000000oooo0?oo
o`0?0?ooo`030000003oool0oooo00L0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`00
00050?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool01P3oool3000000D0oooo00<0
00000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?oo
o`070?ooo`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`000000oooo0?oo
o`0?0?ooo`030000003oool0oooo00L0oooo0`0000050?ooo`030000003oool0oooo0:P0oooo002Z
0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool200000140oooo00<0
00000?ooo`3oool01`3oool010000000oooo0?ooo`0000030?ooo`8000004P3oool00`000000oooo
0?ooo`060?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo0000
00<0oooo0P00000@0?ooo`8000002@3oool010000000oooo0?ooo`0000030?ooo`8000003`3oool0
10000000oooo0?ooo`0000030?ooo`8000004P3oool00`000000oooo0?ooo`060?ooo`040000003o
ool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000B0?ooo`03
0000003oool0oooo00H0oooo00@000000?ooo`3oool000000`3oool200000:X0oooo002X0?ooo`04
0000003oool0oooo000000P0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00
00080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool010000000
oooo0?ooo`00000D0?ooo`040000003oool0oooo000001D0oooo00<000000?ooo`3oool0203oool0
10000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool0
0000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@00000
0?ooo`3oool00000203oool010000000oooo0?ooo`00002_0?ooo`00Z@3oool2000000P0oooo1000
00050?ooo`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?oo
o`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<0
00000?ooo`3oool03P3oool3000000L0oooo100000050?ooo`030000003oool0oooo00`0oooo1000
00050?ooo`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?oo
o`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<0
00000?ooo`3oool0Z03oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo0000\
\>"],
  ImageRangeCache->{{{0, 610.625}, {125.375, 0}} -> {-0.621763, -0.0103329, \
0.00531182, 0.00531182}, {{117, 296.313}, {123.375, 45.625}} -> {-1.06156, \
-0.0139203, 0.00695877, 0.00695877}, {{314.25, 493.563}, {123.375, 45.625}} -> \
{-2.43418, -0.0139203, 0.00695877, 0.00695877}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .13416 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00319425 0.47619 [
[.5 .14666 -152 0 ]
[.5 .14666 152 38.75 ]
[ 0 0 0 0 ]
[ 1 .13416 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00319 m
1 .00319 L
s
.02381 0 m
.02381 .13416 L
s
gsave
.5 .14666 -213 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(2) show
117.000 12.750 moveto
(Pi) show
141.000 12.750 moveto
(7) show
153.000 12.750 moveto
(Pi) show
177.000 12.750 moveto
(Pi) show
201.000 12.750 moveto
(9) show
213.000 12.750 moveto
(Pi) show
237.000 12.750 moveto
(Pi) show
261.000 12.750 moveto
(3) show
273.000 12.750 moveto
(Pi) show
297.000 12.750 moveto
(3) show
309.000 12.750 moveto
(Pi) show
333.000 12.750 moveto
(5) show
345.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
(--) show
129.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
141.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
153.000 25.875 moveto
(--) show
165.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
177.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
189.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
201.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
213.000 25.875 moveto
(--) show
225.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
237.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
249.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
261.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
273.000 25.875 moveto
(--) show
285.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
297.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
309.000 25.875 moveto
(--) show
321.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
333.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
345.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
357.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(11) show
111.000 39.000 moveto
(11) show
147.000 39.000 moveto
(11) show
177.000 39.000 moveto
(11) show
207.000 39.000 moveto
(11) show
237.000 39.000 moveto
(11) show
267.000 39.000 moveto
(11) show
303.000 39.000 moveto
(11) show
339.000 39.000 moveto
(11) show
351.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .13416 L
0 .13416 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00319425 0.477324 0.130964 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.28463 0.71537 7.99599e-018 0.71537 [
[ 0 0 0 0 ]
[ 1 .28173 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .28173 L
0 .28173 L
closepath
clip
newpath
0 1 0 r
0 0 m
.62721 0 L
.31361 .20154 L
F
0 0 1 r
.62721 0 m
1 0 L
.31361 .20154 L
F
1 0 0 r
0 0 m
.31361 .20154 L
.04051 .28173 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00319425 0.97619 0.130964 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.28463 0.71537 3.94379e-018 0.71537 [
[ 0 0 0 0 ]
[ 1 .28173 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .28173 L
0 .28173 L
closepath
clip
newpath
0 1 0 r
.28463 0 m
.64231 .10503 L
.04051 .28173 L
F
0 0 1 r
.28463 0 m
1 0 L
.64231 .10503 L
F
1 0 0 r
.04051 .28173 m
0 0 L
.28463 0 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{612, 82.0625},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009T0000DR000`400?l00000o`00003oZ03oool0
0`000000oooo0?ooo`3o0?oookX0oooo002Q0?ooool000008P00002R0?ooo`00Z03oool00`000000
o`00003o001>003o02h0003o4P3ooolT0?l000@00?l0EP000?n]0?ooo`00Z03oool010000000o`00
0?l0003o001;003o02d0003o5@3ooolS0?l000P00?l0D0000?n`0?ooo`00Z03oool00`000000o`00
0?l000020?l004T00?l0:`000?lH0?ooob80o`003@00o`190000ok<0oooo002X0?ooo`030000003o
0000o`0000@0o`00A@00o`0Y0000oa`0oooo8@3o000A003o0480003o]`3oool00:P0oooo00<00000
0?l0003o00001@3o0013003o02L0003o7`3ooolP0?l001D00?l0?0000?nj0?ooo`00Z03oool00`00
0000o`000?l000070?l003l00?l09P000?lR0?oooal0o`006P00o`0e0000okd0oooo002X0?ooo`03
0000003o0000o`0000P0o`00?@00o`0S0000obH0oooo7P3o000N003o02h0003o`@3oool00:P0oooo
00<000000?ooo`3o00002P3o000i003o0280003o:P3ooolM0?l002400?l0:0000?o40?ooo`00Z03o
ool00`000000oooo0?l0000;0?l003L00?l080000?l]0?oooa`0o`009P00o`0Q0000olL0oooo002X
0?ooo`030000003oool0o`0000d0o`00<`00o`0O0000oc00oooo6`3o000Z003o01/0003obP3oool0
0:P0oooo00<000000?ooo`3o00003P3o000a003o01`0003o=03ooolJ0?l002h00?l050000?o>0?oo
o`00Z03oool00`000000oooo0?l0000@0?l002d00?l06`000?lg0?oooaT0o`00<`00o`0=0000om40
oooo002X0?ooo`030000003oool0o`000140o`00:`00o`0I0000ocX0oooo603o000g003o00L0003o
e03oool00:P0oooo00<000000?ooo`3o00004`3o000W003o01L0003o?P3ooolG0?l003/00?l0f03o
ool00:P0oooo00<000000?ooo`3oool0503o000U003o01D0003o@P3ooolF0?l003P00?l0f`3oool0
0:P0oooo00<000000?ooo`3oool05P3o000Q003o01@0003oA@3ooolE0?l003H00?l0gP3oool00:P0
oooo00<000000?ooo`3oool05`3o000O003o0140003oB@3ooolD0?l003<00?l0hP3oool00:P0oooo
00<000000?ooo`3oool06@3o000K003o0100003oC03ooolC0?l003400?l0i@3oool00:P0oooo00<0
00000?ooo`3oool06P3o000I003o00h0003oC`3ooolB0?l002h00?l0j@3oool00:P0oooo00<00000
0?ooo`3oool0703o000E003o00d0003oDP3ooolA0?l002`00?l0k03oool00:P0oooo00<000000?oo
o`3oool07@3o000C003o00X0003oEP3oool@0?l002T00?l0l03oool00:P0oooo00<000000?ooo`3o
ool07`3o000?003o00T0003oF@3oool?0?l002L00?l0l`3oool00:P0oooo00@000000?ooo`3oool0
oooo7`3o000=003o00L0003oG@3oool>0?l002@00?l0mP3oool00:P0oooo00@000000?ooo`3oool0
oooo8@3o0009003o00D0003oH@3oool=0?l002400?l0nP3oool00:P0oooo00@000000?ooo`3oool0
oooo8P3o0007003o00<0003oI03oool<0?l001l00?l0o@3oool00:P0oooo00@000000?ooo`3oool0
oooo903o0003003o0080003oI`3oool;0?l001`00?l0o`3oool20?ooo`00Z03oool010000000oooo
0?ooo`3ooolU0?l006/0oooo2P3o000J003o0?l0oooo1@3oool00:P0oooo00@000000?ooo`3oool0
oooo8P3o001^0?ooo`T0o`005`00o`3o0?ooo`T0oooo002X0?ooo`040000003oool0oooo0?oooah0
o`00LP3oool80?l001D00?l0o`3oool<0?ooo`00Z03oool00`000000oooo0?ooo`020?oooaX0o`00
MP3oool70?l001800?l0o`3oool?0?ooo`00Z03oool00`000000oooo0?ooo`020?oooaH0o`00NP3o
ool60?l000l00?l0o`3ooolC0?ooo`00Z03oool00`000000oooo0?ooo`020?oooa80o`00OP3oool5
0?l000d00?l0o`3ooolF0?ooo`00Z03oool00`000000oooo0?ooo`020?ooo`l0o`00P@3oool40?l0
00X00?l0o`3ooolJ0?ooo`00Z03oool00`000000oooo0?ooo`020?ooo`/0o`00Q@3oool30?l000P0
0?l0o`3ooolM0?ooo`00Z03oool00`000000oooo0?ooo`020?ooo`P0o`00R03oool20?l000D00?l0
o`3ooolQ0?ooo`00Z03oool00`000000oooo0?ooo`020?ooo`@0o`00S03oool0103o00000?l0003o
0000o`3o0?ooob@0oooo002X0?ooo`030000003oool0oooo0?l0oooo^P3oool00:P0oooo00<00000
0?ooo`3oool0o`3ooonj0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool00?l0oooo
o`3ooomV0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool00?l0ooooo`3ooomV0?oo
o`00o`3ooooo0?ooofH0oooo002X0?ooo`D0000000<0oooo0000000000000`00000I0?ooo`D00000
00<0oooo0000000000000`00000I0?ooo`D0000000<0oooo0000000000000`00000C0?ooo`D00000
00<0oooo0000000000000`00000C0?ooo`D0000000<0oooo0000000000000`00000C0?ooo`D00000
00<0oooo0000000000000`00000C0?ooo`D0000000<0oooo0000000000000`00000I0?ooo`D00000
00<0oooo0000000000000`00000I0?ooo`D0000000<0oooo0000000000000`00002Y0?ooo`00ZP3o
ool00`000000oooo0?ooo`030?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool05@3o
ool00`000000oooo0?ooo`030?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool05@3o
ool00`000000oooo0?ooo`030?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0Z@3o
ool00:X0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0
oooo00<0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`030?ooo`030000003oool0
oooo01D0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0
oooo00<0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`030?ooo`030000003oool0
oooo01D0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0
oooo00<0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`030?ooo`030000003oool0
oooo0:T0oooo002Z0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`030?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`0E0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool05@3oool00`00
0000oooo0?ooo`030?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`0E0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`030?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`2Y0?ooo`00ZP3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo01/0
oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo00<0
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo01D0
oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo00<0
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo01/0
oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo00<0
oooo00<000000?ooo`3oool0Z@3oool00:T0oooo0P0000040?ooo`800000703oool2000000@0oooo
0P00000L0?ooo`800000103oool2000001H0oooo0P0000040?ooo`8000005P3oool2000000@0oooo
0P00000F0?ooo`800000103oool2000001H0oooo0P0000040?ooo`800000703oool2000000@0oooo
0P00000L0?ooo`800000103oool200000:/0oooo003o0?ooool0ooooIP3oool00?l0ooooo`3ooomV
0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool00?l0ooooo`3ooomV0?ooo`00o`3o
oooo0?ooofH0oooo002O0?ooo`030000003oool0oooo0?l0oooo8@3oool00`000000oooo0?ooo`2O
0?ooo`00WP3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo0240oooo00<000000?oo
o`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?oo
o`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?oo
o`3oool08@3oool00`000000oooo0?ooo`2N0?ooo`00WP3oool00`000000oooo0?ooo`0J0?ooo`03
0000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`03
0000003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`03
0000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`2N0?ooo`00
WP3oool010000000oooo0?ooo`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0
oooo00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0
oooo00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0
oooo00<000000?ooo`3oool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0
oooo100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0
oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080
oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080
oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080
oooo100000020?ooo`@000000`3oool00`000000oooo0?ooo`2N0?ooo`00W@3oool00`000000oooo
0?ooo`3o0?ooobD0oooo00<000000?ooo`3oool0W@3oool009h0oooo00<000000?ooo`3oool0o`3o
oolS0?ooo`030000003oool0oooo09h0oooo002N0?ooo`030000003oool0oooo0?l0oooo8`3oool0
0`000000oooo0?ooo`2N0?ooo`00W`3oool00`000000oooo0?ooo`3o0?ooob40oooo00<000000?oo
o`3oool0W`3oool00?l0ooooo`3ooomV0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3o
ool00?l0ooooo`3ooomV0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool00?l0oooo
o`3ooomV0?ooo`00XP3oool4000000L0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`00
00050?ooo`<00000403oool00`000000oooo0?ooo`060?ooo`<000001@3oool3000000d0oooo0`00
00050?ooo`<000003P3oool3000000P0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00
000?0?ooo`800000203oool3000000D0oooo0`00000?0?ooo`800000203oool3000000D0oooo0`00
000?0?ooo`800000203oool3000000D0oooo0`00002T0?ooo`00XP3oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`07
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=
0?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?oo
o`0=0?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3oool01@3oool00`000000oooo
0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3oool01@3oool00`000000
oooo0?ooo`2S0?ooo`00X`3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`000000oooo
0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo00l0oooo
00<000000?ooo`3oool01`3oool3000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo
00<000000?ooo`3oool03P3oool3000000P0oooo0`0000050?ooo`030000003oool0oooo00d0oooo
0`0000050?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool01`3oool3000000D0oooo
00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`070?ooo`<000001@3oool00`000000oooo
0?ooo`0@0?ooo`030000003oool0oooo00H0oooo0`0000050?ooo`030000003oool0oooo0:<0oooo
002T0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool200000140oooo
00<000000?ooo`3oool01`3oool010000000oooo0?ooo`0000030?ooo`8000004P3oool00`000000
oooo0?ooo`060?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo
000000<0oooo0P00000?0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000
0`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool200000180oooo00<000000?ooo`3o
ool01P3oool010000000oooo0?ooo`0000030?ooo`8000004P3oool00`000000oooo0?ooo`060?oo
o`040000003oool0oooo000000<0oooo0P00000@0?ooo`8000002@3oool010000000oooo0?ooo`00
00030?ooo`800000Y@3oool00:80oooo00@000000?ooo`3oool00000203oool010000000oooo0?oo
o`00000D0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000503oool01000
0000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000
503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?oo
o`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo
00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00000E0?ooo`030000003oool0oooo
00P0oooo00@000000?ooo`3oool00000ZP3oool00:<0oooo0P0000080?ooo`@000001@3oool00`00
0000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool03@3oool40000
00L0oooo100000050?ooo`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo
00h0oooo0`0000070?ooo`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`00
0000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool03P3oool20000
00P0oooo100000050?ooo`030000003oool0oooo00h0oooo0`0000070?ooo`@000001@3oool00`00
0000oooo0?ooo`2S0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool00001\
\>"],
  ImageRangeCache->{{{0, 611}, {81.0625, 0}} -> {-1.22371, -0.00670947, \
0.00727892, 0.00727892}, {{168.063, 298.938}, {80.125, 43.25}} -> {-2.19298, \
-0.0100347, 0.0106811, 0.0106811}, {{312, 442.875}, {80.125, 43.25}} -> \
{-3.7304, -0.0100347, 0.0106811, 0.0106811}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(2) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(3) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(2) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(5) show
135.000 39.000 moveto
(5) show
165.000 39.000 moveto
(5) show
195.000 39.000 moveto
(5) show
225.000 39.000 moveto
(5) show
255.000 39.000 moveto
(5) show
285.000 39.000 moveto
(5) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -9.21572e-018 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.61803 0 L
.5 .36327 L
F
0 0 1 r
.61803 0 m
1 0 L
.5 .36327 L
F
1 0 0 r
0 0 m
.5 .36327 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -1.19262e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.38197 0 m
.69098 .22451 L
.19098 .58779 L
F
0 0 1 r
.38197 0 m
1 0 L
.69098 .22451 L
F
1 0 0 r
.19098 .58779 m
0 0 L
.38197 0 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000Zb000`400?l00000o`00003oF`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?oo
o`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00D03ooooo00000<@00000
D03oool005/0oooo00<000000?l00000o`00N`00o`1=0000oaH0ooooC@3o0002003o07/0003oG@3o
ool005/0oooo00<000000?l0003o0000N`00o`1<0000oaL0ooooC@3o0003003o07T0003oGP3oool0
05/0oooo00<000000?l0003o00000P3o001i003o04X0003o6@3ooom=0?l000D00?l0M@000?mP0?oo
o`00F`3oool00`000000oooo0?l000030?l007L00?l0BP000?lK0?oood/0o`001`00o`1c0000of40
oooo001K0?ooo`030000003oool0o`0000@0o`00MP00o`190000oa`0ooooB`3o0008003o0740003o
HP3oool005/0oooo00<000000?ooo`3o00001P3o001d003o04L0003o7P3ooom;0?l000X00?l0K@00
0?mT0?ooo`00F`3oool00`000000oooo0?ooo`070?l007800?l0A`000?lP0?ooodT0o`003000o`1[
0000ofD0oooo001K0?ooo`030000003oool0oooo00T0o`00L000o`150000ob80ooooB@3o000=003o
06T0003oIP3oool005/0oooo00<000000?ooo`3oool02P3o001_003o04@0003o8`3ooom90?l000l0
0?l0I@000?mX0?ooo`00F`3oool010000000oooo0?ooo`3oool:0?l006d00?l0A0000?lU0?ooodL0
o`004@00o`1S0000ofT0oooo001K0?ooo`040000003oool0oooo0?ooo``0o`00J`00o`120000obL0
ooooA`3o000C003o05l0003oJ`3oool005/0oooo00@000000?ooo`3oool0oooo3@3o001Z003o0440
003o:03ooom70?l001@00?l0G@000?m/0?ooo`00F`3oool00`000000oooo0?ooo`020?ooo`d0o`00
J000o`110000obX0ooooA@3o000F003o05/0003oK@3oool005/0oooo00<000000?ooo`3oool00P3o
ool?0?l006H00?l0?`000?l/0?ooodD0o`006000o`1G0000ofl0oooo001K0?ooo`030000003oool0
oooo0080oooo403o001U003o03h0003o;@3ooom50?l001T00?l0E@000?m`0?ooo`00F`3oool00`00
0000oooo0?ooo`030?oooa40o`00HP00o`0m0000oc00oooo@`3o000K003o05<0003oL@3oool005/0
oooo00<000000?ooo`3oool00`3ooolB0?l006400?l0?0000?la0?oood<0o`007@00o`1?0000og<0
oooo001K0?ooo`030000003oool0oooo00<0oooo4`3o001P003o03/0003o<P3ooom30?l001h00?l0
C@000?md0?ooo`00F`3oool00`000000oooo0?ooo`040?oooa@0o`00G@00o`0j0000ocD0oooo@@3o
000Q003o04T0003oMP3oool005/0oooo00<000000?ooo`3oool0103ooolE0?l005`00?l0>@000?lf
0?oood40o`008P00o`170000ogL0oooo001K0?ooo`030000003oool0oooo00@0oooo5P3o001K003o
03P0003o=`3ooom10?l002<00?l0A@000?mh0?ooo`00F`3oool00`000000oooo0?ooo`050?oooaL0
o`00F000o`0g0000ocX0oooo?`3o000V003o0440003oNP3oool005/0oooo00<000000?ooo`3oool0
1@3ooolH0?l005L00?l0=P000?lk0?ooocl0o`009`00o`0o0000og/0oooo001K0?ooo`030000003o
ool0oooo00D0oooo6P3o001E003o03@0003o?@3ooolo0?l002P00?l0?@000?ml0?ooo`00F`3oool0
0`000000oooo0?ooo`060?oooaX0o`00D`00o`0d0000ocl0oooo?@3o000[003o03T0003oOP3oool0
05/0oooo00<000000?ooo`3oool01P3ooolK0?l005800?l0<`000?m00?ooocd0o`00;000o`0g0000
ogl0oooo001K0?ooo`030000003oool0oooo00H0oooo7@3o001@003o0340003o@P3ooolm0?l002d0
0?l0=@000?n00?ooo`00F`3oool00`000000oooo0?ooo`070?oooad0o`00CP00o`0a0000od@0oooo
>`3o000`003o0340003oPP3oool005/0oooo00<000000?ooo`3oool01`3ooolN0?l004d00?l0<000
0?m50?oooc/0o`00<@00o`0_0000oh<0oooo001K0?ooo`030000003oool0oooo00L0oooo803o001;
003o02h0003oA`3ooolk0?l003<00?l0:`000?n50?ooo`00F`3oool00`000000oooo0?ooo`080?oo
ob00o`00B@00o`0^0000odT0oooo>@3o000e003o02T0003oQP3oool005/0oooo00<000000?ooo`3o
ool0203ooolR0?l004L00?l0;0000?m;0?ooocT0o`00=P00o`0W0000ohL0oooo001K0?ooo`030000
003oool0oooo00P0oooo8`3o0016003o02/0003oC03oooli0?l003P00?l08`000?n90?ooo`00F`3o
ool00`000000oooo0?ooo`090?ooob<0o`00A000o`0[0000odh0oooo=`3o000j003o0240003oRP3o
ool005/0oooo00<000000?ooo`3oool02@3ooolU0?l004800?l0:@000?m@0?ooocL0o`00>`00o`0O
0000oh/0oooo001K0?ooo`030000003oool0oooo00T0oooo9P3o0011003o02P0003oD@3ooolg0?l0
03d00?l06`000?n=0?ooo`00F`3oool00`000000oooo0?ooo`0:0?ooobH0o`00?`00o`0W0000oe@0
oooo=@3o000o003o01T0003oSP3oool005/0oooo00<000000?ooo`3oool02P3ooolX0?l003d00?l0
9P000?mE0?ooocD0o`00@@00o`0E0000oi00oooo001K0?ooo`030000003oool0oooo00X0oooo:@3o
000l003o02D0003oEP3ooole0?l004800?l04`000?nA0?ooo`00F`3oool00`000000oooo0?ooo`0:
0?ooob/0o`00>P00o`0S0000oeP0oooo=03o0014003o0140003oTP3oool005/0oooo00<000000?oo
o`3oool02`3oool[0?l003P00?l08`000?mJ0?oooc<0o`00AP00o`0=0000oi@0oooo001K0?ooo`03
0000003oool0oooo00/0oooo;03o000g003o0280003oF`3ooolc0?l004L00?l02`000?nE0?ooo`00
F`3oool00`000000oooo0?ooo`0;0?ooobh0o`00=@00o`0P0000oed0oooo<`3o0018003o00T0003o
UP3oool005/0oooo00<000000?ooo`3oool0303oool^0?l003<00?l080000?mO0?oooc40o`00B`00
o`050000oiP0oooo001K0?ooo`030000003oool0oooo00`0oooo<03o000a003o01h0003oH@3ooola
0?l004`00?l00`000?nI0?ooo`00F`3oool00`000000oooo0?ooo`0<0?oooc40o`00<000o`0M0000
of80oooo<@3o001=003o09/0oooo001K0?ooo`030000003oool0oooo00d0oooo<@3o000^003o01d0
003oI03oool_0?l004d00?l0W03oool005/0oooo00<000000?ooo`3oool03@3ooolc0?l002`00?l0
6`000?mV0?ooobl0o`00C000o`2M0?ooo`00F`3oool00`000000oooo0?ooo`0=0?oooc@0o`00:`00
o`0J0000ofL0oooo;`3o001:003o09l0oooo001K0?ooo`030000003oool0oooo00h0oooo=03o000Y
003o01X0003oJ@3oool]0?l004X00?l0X03oool005/0oooo00<000000?ooo`3oool03P3ooolf0?l0
02L00?l060000?m[0?ooobd0o`00B@00o`2Q0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooocL0
o`009P00o`0G0000of`0oooo;@3o0017003o0:<0oooo001K0?ooo`030000003oool0oooo00l0oooo
>03o000S003o01H0003oK`3oool[0?l004L00?l0Y03oool005/0oooo00<000000?ooo`3oool03`3o
ooli0?l002800?l05@000?m`0?ooob/0o`00A@00o`2V0?ooo`00F`3oool00`000000oooo0?ooo`0?
0?ooocX0o`008@00o`0D0000og40oooo:`3o0014003o0:L0oooo001K0?ooo`030000003oool0oooo
0100oooo>`3o000N003o01<0003oM03ooolY0?l004@00?l0Z03oool005/0oooo00<000000?ooo`3o
ool0403oooll0?l001d00?l04P000?me0?ooobT0o`00@P00o`2Z0?ooo`00F`3oool00`000000oooo
0?ooo`0@0?ooocd0o`007000o`0A0000ogH0oooo:@3o0011003o0:/0oooo001K0?ooo`030000003o
ool0oooo0140oooo?P3o000I003o0100003oN@3ooolW0?l004400?l0[03oool005/0oooo00<00000
0?ooo`3oool04@3ooolo0?l001P00?l03`000?mj0?ooobL0o`00?`00o`2^0?ooo`00F`3oool00`00
0000oooo0?ooo`0A0?oood40o`005P00o`0=0000og`0oooo9`3o000n003o0:l0oooo001K0?ooo`03
0000003oool0oooo0180oooo@@3o000D003o00d0003oOP3ooolU0?l003d00?l0/@3oool005/0oooo
00<000000?ooo`3oool04P3ooom20?l001<00?l030000?mo0?ooobD0o`00?000o`2b0?ooo`00F`3o
ool00`000000oooo0?ooo`0B0?oood@0o`004@00o`0:0000oh40oooo9@3o000k003o0;<0oooo001K
0?ooo`030000003oool0oooo01<0ooooA03o000?003o00X0003oP`3ooolS0?l003X00?l0]@3oool0
05/0oooo00<000000?ooo`3oool04`3ooom50?l000h00?l02@000?n40?ooob<0o`00>@00o`2f0?oo
o`00F`3oool00`000000oooo0?ooo`0C0?ooodL0o`003000o`070000ohH0oooo8`3o000h003o0;L0
oooo001K0?ooo`030000003oool0oooo01@0ooooA`3o000:003o00L0003oR03ooolQ0?l003L00?l0
^@3oool005/0oooo00<000000?ooo`3oool0503ooom90?l000P00?l01@000?n:0?ooob40o`00=P00
o`2j0?ooo`00F`3oool00`000000oooo0?ooo`0D0?ooodX0o`001`00o`040000oh/0oooo8@3o000d
003o0;`0oooo001K0?ooo`030000003oool0oooo01D0ooooBP3o0005003o00@0003oS@3ooolO0?l0
03@00?l0_@3oool005/0oooo00<000000?ooo`3oool05@3ooom<0?l000<00?l00P000?n?0?oooal0
o`00<`00o`2n0?ooo`00F`3oool00`000000oooo0?ooo`0E0?ooodd0o`000P00o`000`000?l0oooo
0?ooo`2>0?oooal0o`00<@00o`300?ooo`00F`3oool00`000000oooo0?ooo`0F0?ooodd0o`00T`3o
oolM0?l003400?l0`@3oool005/0oooo00<000000?ooo`3oool05P3ooom<0?l009@0oooo7@3o000`
003o0<80oooo001K0?ooo`030000003oool0oooo01H0ooooB`3o002E0?oooad0o`00;P00o`340?oo
o`00F`3oool00`000000oooo0?ooo`0G0?ooodP0o`00V03ooolK0?l002h00?l0a@3oool005/0oooo
00<000000?ooo`3oool05`3ooom70?l009T0oooo6`3o000/003o0<L0oooo001K0?ooo`030000003o
ool0oooo01L0ooooAP3o002J0?oooa/0o`00:`00o`380?ooo`00F`3oool00`000000oooo0?ooo`0G
0?oood@0o`00W03ooolJ0?l002/00?l0b@3oool005/0oooo00<000000?ooo`3oool0603ooom20?l0
09h0oooo6@3o000Y003o0</0oooo001K0?ooo`030000003oool0oooo01P0oooo@@3o002O0?oooaT0
o`00:000o`3<0?ooo`00F`3oool00`000000oooo0?ooo`0H0?ooocl0o`00X@3ooolI0?l002H00?l0
cP3oool005/0oooo00<000000?ooo`3oool06@3ooolm0?l00:<0oooo5`3o000V003o0<l0oooo001K
0?ooo`030000003oool0oooo01T0oooo>`3o002U0?oooaL0o`009@00o`3@0?ooo`00F`3oool00`00
0000oooo0?ooo`0I0?ooocX0o`00YP3ooolG0?l002<00?l0dP3oool005/0oooo00<000000?ooo`3o
ool06P3ooolh0?l00:P0oooo5@3o000S003o0=<0oooo001K0?ooo`030000003oool0oooo01X0oooo
=P3o002Z0?oooaD0o`008P00o`3D0?ooo`00F`3oool00`000000oooo0?ooo`0J0?ooocD0o`00Z`3o
oolE0?l002000?l0eP3oool005/0oooo00<000000?ooo`3oool06`3ooolc0?l00:d0oooo4`3o000P
003o0=L0oooo001K0?ooo`030000003oool0oooo01/0oooo<@3o002_0?oooa<0o`007P00o`3I0?oo
o`00F`3oool00`000000oooo0?ooo`0K0?oooc00o`00/03ooolC0?l001d00?l0fP3oool005/0oooo
00<000000?ooo`3oool0703oool]0?l00;<0oooo4@3o000M003o0=/0oooo001K0?ooo`030000003o
ool0oooo01`0oooo;03o002d0?oooa40o`006`00o`3M0?ooo`00F`3oool00`000000oooo0?ooo`0L
0?ooob/0o`00]@3ooolA0?l001X00?l0gP3oool005/0oooo00<000000?ooo`3oool07@3ooolX0?l0
0;P0oooo3`3o000J003o0=l0oooo001K0?ooo`030000003oool0oooo01d0oooo9`3o002i0?ooo`l0
o`006000o`3Q0?ooo`00F`3oool00`000000oooo0?ooo`0M0?ooobH0o`00^P3oool?0?l001L00?l0
hP3oool005/0oooo00<000000?ooo`3oool07P3ooolS0?l00;d0oooo3@3o000F003o0>@0oooo001K
0?ooo`030000003oool0oooo01h0oooo8P3o002n0?ooo`d0o`005@00o`3U0?ooo`00F`3oool00`00
0000oooo0?ooo`0N0?ooob40o`00_`3oool=0?l001@00?l0iP3oool005/0oooo00<000000?ooo`3o
ool07`3ooolN0?l00<80oooo2`3o000C003o0>P0oooo001K0?ooo`030000003oool0oooo01l0oooo
7@3o00330?ooo`/0o`004P00o`3Y0?ooo`00F`3oool00`000000oooo0?ooo`0O0?oooa/0o`00a@3o
ool;0?l001400?l0jP3oool005/0oooo00<000000?ooo`3oool0803ooolI0?l00<L0oooo2@3o000@
003o0>`0oooo001K0?ooo`030000003oool0oooo0200oooo603o00380?ooo`T0o`003`00o`3]0?oo
o`00F`3oool00`000000oooo0?ooo`0P0?oooaH0o`00bP3oool90?l000d00?l0k`3oool005/0oooo
00<000000?ooo`3oool08@3ooolD0?l00<`0oooo1`3o000=003o0?00oooo001K0?ooo`030000003o
ool0oooo0240oooo4`3o003=0?ooo`L0o`003000o`3a0?ooo`00F`3oool00`000000oooo0?ooo`0Q
0?oooa40o`00c`3oool70?l000X00?l0l`3oool005/0oooo00<000000?ooo`3oool08P3oool?0?l0
0=40oooo1@3o000:003o0?@0oooo001K0?ooo`030000003oool0oooo0280oooo3@3o003C0?ooo`D0
o`002@00o`3e0?ooo`00F`3oool00`000000oooo0?ooo`0R0?ooo``0o`00e03oool50?l000L00?l0
m`3oool005/0oooo00<000000?ooo`3oool08`3oool:0?l00=H0oooo0`3o0007003o0?P0oooo001K
0?ooo`030000003oool0oooo02<0oooo203o003H0?ooo`<0o`001@00o`3j0?ooo`00F`3oool00`00
0000oooo0?ooo`0S0?ooo`L0o`00f@3oool30?l000@00?l0n`3oool005/0oooo00<000000?ooo`3o
ool0903oool50?l00=/0oooo00<0o`00003o0000o`000P00o`3l0?ooo`00F`3oool00`000000oooo
0?ooo`0T0?ooo`<0o`00g@3oool00`3o00000?l0003o003n0?ooo`00F`3oool00`000000oooo0?oo
o`0T0?ooo`80o`00gP3oool00`3o00000?l00?ooo`3n0?ooo`00F`3oool00`000000oooo0?ooo`3o
0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?ooo`L0oooo001K0?ooo`03
0000003oool0oooo0?l0ooooo`3oool70?ooo`00F`3oool00`000000oooo0?ooo`3o0?ooool0oooo
1`3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00;D0oooo0P00000L0?ooo`800000
703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000
703oool200000;`0oooo002d0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool0
00006P3oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001X0oooo00@00000
0?ooo`3oool000006P3oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001X0
oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00002k0?ooo`00]`3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0^@3oool00;D0
oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0
oooo0P00000L0?ooo`800000703oool200000;`0oooo002e0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`2k0?ooo`00]@3oool3000001/0oooo0`00
000K0?ooo`<000006`3oool3000001/0oooo0`00000K0?ooo`<000006`3oool3000001/0oooo0`00
000K0?ooo`<00000^`3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0
ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool0
0:/0oooo00<000000?ooo`3oool0o`3oool90?ooo`030000003oool0oooo0:X0oooo002Z0?ooo`03
0000003oool0oooo01X0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`03
0000003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`03
0000003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`03
0000003oool0oooo0:T0oooo002Z0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
8@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0:T0oooo002Z0?ooo`040000003o
ool0oooo0?ooo`@000000P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo
0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo
100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo
100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@000000P3oool400000080oooo
100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000103oool00`000000oooo
0?ooo`070?ooo`@000000P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo
0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo
100000020?ooo`@000000P3oool4000000<0oooo00<000000?ooo`3oool0Z@3oool00:T0oooo00<0
00000?ooo`3oool0o`3oool=0?ooo`030000003oool0oooo0:P0oooo002Z0?ooo`030000003oool0
oooo0?l0oooo2`3oool00`000000oooo0?ooo`2Y0?ooo`00ZP3oool00`000000oooo0?ooo`3o0?oo
o`/0oooo00<000000?ooo`3oool0Z@3oool00:/0oooo00<000000?ooo`3oool0o`3oool90?ooo`03
0000003oool0oooo0:X0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo
0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo
003o0?ooool0ooooI@3oool00:h0oooo100000070?ooo`<000001@3oool3000000d0oooo0`000005
0?ooo`<000003P3oool4000000L0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000?
0?ooo`800000203oool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000h0oooo10000007
0?ooo`<000001@3oool3000000d0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`000005
0?ooo`<00000[`3oool00:h0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool010000000oooo0?ooo`000008
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`2^
0?ooo`00[`3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`000000oooo0?ooo`0=0?oo
o`<000001@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?oo
o`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo00l0oooo00<000000?oo
o`3oool01`3oool3000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?oo
o`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`000000oooo0?ooo`0=0?oo
o`<000001@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?oo
o`030000003oool0oooo0:h0oooo002`0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3o
ool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool200000140oooo00<00000
0?ooo`3oool01`3oool010000000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?oo
o`0000030?ooo`8000004P3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo000000<0
oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000A0?ooo`030000003oool0oooo
00L0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3o
ool200000140oooo00<000000?ooo`3oool01`3oool010000000oooo0?ooo`0000030?ooo`800000
/03oool00:h0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00000D0?ooo`04
0000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00
000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool010000000
oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203o
ool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000203oool010000000oooo0?ooo`00002e0?ooo`00[`3oool2000000P0oooo100000050?oo
o`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?oo
o`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?oo
o`800000203oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<000000?oo
o`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo00`0oooo100000050?oo
o`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`2^0?oo
o`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00001\
\>"],
  ImageRangeCache->{{{0, 610.563}, {170.188, 0}} -> {-0.426205, -0.013998, \
0.00467178, 0.00467178}, {{91.1875, 295.063}, {167.188, 47.3125}} -> \
{-1.34175, -0.0239702, 0.00793648, 0.00793648}, {{315.438, 519.313}, \
{167.188, 47.3125}} -> {-3.12151, -0.0239702, 0.00793648, 0.00793648}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .31577 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0075184 0.47619 [
[.5 .32827 -158 0 ]
[.5 .32827 158 38.75 ]
[ 0 0 0 0 ]
[ 1 .31577 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00752 m
1 .00752 L
s
.02381 0 m
.02381 .31577 L
s
gsave
.5 .32827 -219 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(6) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(3) show
177.000 12.750 moveto
(Pi) show
201.000 12.750 moveto
(7) show
213.000 12.750 moveto
(Pi) show
237.000 12.750 moveto
(3) show
249.000 12.750 moveto
(Pi) show
273.000 12.750 moveto
(4) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(4) show
321.000 12.750 moveto
(Pi) show
345.000 12.750 moveto
(5) show
357.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
(--) show
189.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
201.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
213.000 25.875 moveto
(--) show
225.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
237.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
249.000 25.875 moveto
(--) show
261.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
273.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
285.000 25.875 moveto
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
333.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
345.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
357.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
369.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(13) show
105.000 39.000 moveto
(13) show
135.000 39.000 moveto
(13) show
171.000 39.000 moveto
(13) show
207.000 39.000 moveto
(13) show
243.000 39.000 moveto
(13) show
279.000 39.000 moveto
(13) show
315.000 39.000 moveto
(13) show
351.000 39.000 moveto
(13) show
363.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .31577 L
0 .31577 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0075184 0.477324 0.308254 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.70921 0.29079 1.30104e-018 0.29079 [
[ 0 0 0 0 ]
[ 1 .66312 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .66312 L
0 .66312 L
closepath
clip
newpath
0 1 0 r
0 0 m
.80575 0 L
.78234 .19283 L
F
0 0 1 r
.80575 0 m
1 0 L
.78234 .19283 L
F
1 0 0 r
0 0 m
.78234 .19283 L
.25149 .66312 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.0075184 0.97619 0.308254 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.70921 0.29079 2.57498e-018 0.29079 [
[ 0 0 0 0 ]
[ 1 .66312 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .66312 L
0 .66312 L
closepath
clip
newpath
0 1 0 r
.70921 0 m
.8546 .12881 L
.25149 .66312 L
F
0 0 1 r
.70921 0 m
1 0 L
.8546 .12881 L
F
1 0 0 r
.25149 .66312 m
0 0 L
.70921 0 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.75, 193.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000`B000`400?l00000o`00003oDP3oool0
0`000000oooo0?ooo`3o0?ooool0oooo403oool00580oooo00<000000?ooo`3oool0o`3ooooo0?oo
oa00oooo001B0?ooo`030000003oool0oooo0?l0ooooo`3oool@0?ooo`00DP3oool00`000000oooo
0?ooo`3o0?ooool0oooo403oool004L0ooooo`00003F000004L0oooo001B0?ooo`030000003o0000
o`000080o`00YP00o`0X0000oaL0ooooUP3o0002003o03X0003oE@3oool00580oooo00<000000?l0
003o00001P3o002R003o02L0003o603ooonE0?l000@00?l0>0000?mF0?ooo`00DP3oool00`000000
oooo0?l0000:0?l009h00?l09P000?lJ0?oooi<0o`001P00o`0f0000oeL0oooo001B0?ooo`030000
003oool0o`0000h0o`00VP00o`0U0000oa/0ooooT`3o0007003o03@0003oF03oool00580oooo00<0
00000?ooo`3o00004P3o002F003o02@0003o703ooonB0?l000T00?l0<P000?mI0?ooo`00DP3oool0
0`000000oooo0?ooo`0F0?l009800?l08`000?lN0?oooi00o`002`00o`0`0000oeX0oooo001B0?oo
o`030000003oool0oooo01X0o`00SP00o`0R0000oal0ooooT03o000=003o02d0003oF`3oool00580
oooo00@000000?ooo`3oool0oooo7@3o002:003o0240003o8@3ooon>0?l000l00?l0:`000?mL0?oo
o`00DP3oool010000000oooo0?ooo`3ooolQ0?l008D00?l080000?lS0?ooohd0o`004@00o`0X0000
oeh0oooo001B0?ooo`040000003oool0oooo0?ooobD0o`00P@00o`0O0000ob@0ooooS@3o000B003o
02H0003oG`3oool00580oooo00<000000?ooo`3oool00P3ooolX0?l007d00?l07P000?lV0?oooh/0
o`005000o`0T0000of00oooo001B0?ooo`030000003oool0oooo0080oooo;03o001i003o01d0003o
9`3ooon:0?l001H00?l08P000?mQ0?ooo`00DP3oool00`000000oooo0?ooo`030?ooobl0o`00M@00
o`0L0000obT0ooooR03o000H003o0200003oHP3oool00580oooo00<000000?ooo`3oool00`3ooolc
0?l007400?l06`000?lZ0?ooohP0o`006P00o`0M0000of<0oooo001B0?ooo`030000003oool0oooo
00<0oooo=`3o001]003o01X0003o:`3ooon70?l001`00?l06`000?mT0?ooo`00DP3oool00`000000
oooo0?ooo`040?ooocX0o`00J@00o`0I0000obd0ooooQ@3o000N003o01T0003oI@3oool00580oooo
00<000000?ooo`3oool0103oooln0?l006@00?l060000?l_0?ooohD0o`007`00o`0G0000ofH0oooo
001B0?ooo`030000003oool0oooo00@0oooo@P3o001P003o01L0003o<03ooon40?l002400?l05000
0?mX0?ooo`00DP3oool00`000000oooo0?ooo`050?ooodD0o`00G000o`0F0000oc80ooooPP3o000S
003o0180003oJ@3oool00580oooo00<000000?ooo`3oool01@3ooom90?l005P00?l05@000?lc0?oo
oh80o`009000o`0@0000ofX0oooo001B0?ooo`030000003oool0oooo00H0ooooC@3o001C003o01@0
003o=@3ooon00?l002L00?l03@000?m[0?ooo`00DP3oool00`000000oooo0?ooo`060?oooe40o`00
C`00o`0C0000ocH0ooooO`3o000Y003o00/0003oK03oool00580oooo00<000000?ooo`3oool01P3o
oomE0?l004/00?l04P000?lg0?ooogl0o`00:P00o`090000ofd0oooo001B0?ooo`030000003oool0
oooo00L0ooooF03o0017003o0140003o>@3ooomm0?l002`00?l01`000?m^0?ooo`00DP3oool00`00
0000oooo0?ooo`070?oooe`0o`00@P00o`0@0000oc/0ooooO03o000^003o00D0003oK`3oool00580
oooo00<000000?ooo`3oool0203ooomO0?l003h00?l03`000?lm0?ooogX0o`00<000o`030000og00
oooo001B0?ooo`030000003oool0oooo00P0ooooH`3o000j003o00h0003o?P3ooomj0?l003400?l0
LP3oool00580oooo00<000000?ooo`3oool0203ooomW0?l003H00?l03@000?lo0?ooogT0o`00<@00
o`1c0?ooo`00DP3oool00`000000oooo0?ooo`090?ooofX0o`00<P00o`0<0000od40ooooM`3o000a
003o07@0oooo001B0?ooo`030000003oool0oooo00T0ooooKP3o000^003o00/0003o@P3ooomg0?l0
03000?l0M@3oool00580oooo00<000000?ooo`3oool02@3ooomb0?l002X00?l02P000?m30?ooogH0
o`00<000o`1f0?ooo`00DP3oool00`000000oooo0?ooo`0:0?ooogD0o`009P00o`090000odD0oooo
M03o000`003o07L0oooo001B0?ooo`030000003oool0oooo00X0ooooN@3o000Q003o00P0003oA`3o
oomd0?l002l00?l0N03oool00580oooo00<000000?ooo`3oool02`3oooml0?l001d00?l01`000?m9
0?ooog80o`00;`00o`1i0?ooo`00DP3oool00`000000oooo0?ooo`0;0?oooh00o`006@00o`060000
odX0ooooL@3o000^003o07/0oooo001B0?ooo`030000003oool0oooo00/0ooooQ03o000E003o00D0
003oB`3oooma0?l002d00?l0O03oool00580oooo00<000000?ooo`3oool0303ooon70?l001400?l0
10000?m=0?ooofl0o`00;@00o`1m0?ooo`00DP3oool00`000000oooo0?ooo`0<0?oooh/0o`003@00
o`030000odh0ooooKP3o000]003o07h0oooo001B0?ooo`030000003oool0oooo00d0ooooSP3o0009
003o0080003oD03ooom/0?l002d00?l0O`3oool00580oooo00<000000?ooo`3oool03@3ooonB0?l0
00D00?l000<0003o0?ooo`3oool0C`3ooom/0?l002`00?l0P03oool00580oooo00<000000?ooo`3o
ool03@3ooonF0?l005<0ooooJ`3o000/003o0840oooo001B0?ooo`030000003oool0oooo00h0oooo
U03o001E0?ooofT0o`00;000o`220?ooo`00DP3oool00`000000oooo0?ooo`0>0?oooi<0o`00EP3o
oomY0?l002X00?l0Q03oool00580oooo00<000000?ooo`3oool03P3ooonB0?l005L0ooooJ03o000Z
003o08D0oooo001B0?ooo`030000003oool0oooo00l0ooooT03o001I0?ooofH0o`00:P00o`260?oo
o`00DP3oool00`000000oooo0?ooo`0?0?ooohl0o`00FP3ooomV0?l002T00?l0Q`3oool00580oooo
00<000000?ooo`3oool0403ooon=0?l005`0ooooI03o000Y003o08P0oooo001B0?ooo`030000003o
ool0oooo0100ooooS03o001M0?ooof<0o`00:@00o`290?ooo`00DP3oool00`000000oooo0?ooo`0@
0?ooohX0o`00G`3ooomS0?l002P00?l0RP3oool00580oooo00<000000?ooo`3oool04@3ooon80?l0
0640ooooH@3o000W003o08`0oooo001B0?ooo`030000003oool0oooo0140ooooQ`3o001R0?ooof00
o`009`00o`2=0?ooo`00DP3oool00`000000oooo0?ooo`0B0?ooohD0o`00I03ooomN0?l002L00?l0
SP3oool00580oooo00<000000?ooo`3oool04P3ooon40?l006D0ooooGP3o000V003o08l0oooo001B
0?ooo`030000003oool0oooo0180ooooP`3o001V0?oooed0o`009P00o`2@0?ooo`00DP3oool00`00
0000oooo0?ooo`0C0?oooh40o`00J03ooomK0?l002H00?l0T@3oool00580oooo00<000000?ooo`3o
ool04`3ooon00?l006T0ooooF`3o000U003o0980oooo001B0?ooo`030000003oool0oooo01<0oooo
OP3o001[0?oooeX0o`009@00o`2C0?ooo`00DP3oool00`000000oooo0?ooo`0D0?ooog`0o`00K@3o
oomH0?l002@00?l0U@3oool00580oooo00<000000?ooo`3oool0503ooomk0?l006h0ooooF03o000S
003o09H0oooo001B0?ooo`030000003oool0oooo01D0ooooN@3o001`0?oooeH0o`008`00o`2G0?oo
o`00DP3oool00`000000oooo0?ooo`0E0?ooogP0o`00L@3ooomE0?l002<00?l0V03oool00580oooo
00<000000?ooo`3oool05@3ooomg0?l00780ooooE@3o000R003o09T0oooo001B0?ooo`030000003o
ool0oooo01H0ooooM@3o001d0?oooe<0o`008P00o`2J0?ooo`00DP3oool00`000000oooo0?ooo`0F
0?ooog<0o`00MP3ooomB0?l002800?l0V`3oool00580oooo00<000000?ooo`3oool05`3oooma0?l0
07P0ooooD03o000Q003o09d0oooo001B0?ooo`030000003oool0oooo01L0ooooL03o001i0?oooe00
o`008000o`2N0?ooo`00DP3oool00`000000oooo0?ooo`0G0?ooofl0o`00NP3ooom?0?l002000?l0
W`3oool00580oooo00<000000?ooo`3oool0603ooom]0?l007`0ooooC@3o000P003o0:00oooo001B
0?ooo`030000003oool0oooo01P0ooooK03o001m0?ooodd0o`007`00o`2Q0?ooo`00DP3oool00`00
0000oooo0?ooo`0H0?ooof/0o`00OP3ooom<0?l001l00?l0XP3oool00580oooo00<000000?ooo`3o
ool06@3ooomY0?l00800ooooBP3o000O003o0:<0oooo001B0?ooo`030000003oool0oooo01T0oooo
I`3o00220?ooodX0o`007P00o`2T0?ooo`00DP3oool00`000000oooo0?ooo`0J0?ooofD0o`00Q03o
oom80?l001d00?l0YP3oool00580oooo00<000000?ooo`3oool06P3ooomT0?l008D0ooooA`3o000M
003o0:L0oooo001B0?ooo`030000003oool0oooo01X0ooooH`3o00260?ooodL0o`007000o`2X0?oo
o`00DP3oool00`000000oooo0?ooo`0K0?ooof40o`00R03ooom50?l001`00?l0Z@3oool00580oooo
00<000000?ooo`3oool06`3ooomP0?l008T0ooooA03o000L003o0:X0oooo001B0?ooo`030000003o
ool0oooo01`0ooooGP3o002;0?oood80o`007000o`2[0?ooo`00DP3oool00`000000oooo0?ooo`0L
0?oooed0o`00S03ooom20?l001/00?l0[03oool00580oooo00<000000?ooo`3oool0703ooomK0?l0
08h0oooo@@3o000J003o0:h0oooo001B0?ooo`030000003oool0oooo01d0ooooF@3o002@0?ooocl0
o`006P00o`2_0?ooo`00DP3oool00`000000oooo0?ooo`0M0?oooeP0o`00T@3ooolo0?l001T00?l0
/03oool00580oooo00<000000?ooo`3oool07P3ooomF0?l009<0oooo?@3o000I003o0;40oooo001B
0?ooo`030000003oool0oooo01h0ooooE@3o002D0?oooc`0o`006@00o`2b0?ooo`00DP3oool00`00
0000oooo0?ooo`0N0?oooe@0o`00U@3oooll0?l001P00?l0/`3oool00580oooo00<000000?ooo`3o
ool07`3ooomB0?l009L0oooo>P3o000H003o0;@0oooo001B0?ooo`030000003oool0oooo01l0oooo
D03o002I0?ooocT0o`006000o`2e0?ooo`00DP3oool00`000000oooo0?ooo`0O0?ooodl0o`00VP3o
ooli0?l001H00?l0]`3oool00580oooo00<000000?ooo`3oool0803ooom=0?l009`0oooo=`3o000F
003o0;P0oooo001B0?ooo`030000003oool0oooo0200ooooC03o002M0?ooocH0o`005P00o`2i0?oo
o`00DP3oool00`000000oooo0?ooo`0Q0?ooodX0o`00W`3ooold0?l001H00?l0^P3oool00580oooo
00<000000?ooo`3oool08@3ooom90?l00:00oooo=03o000E003o0;/0oooo001B0?ooo`030000003o
ool0oooo0240ooooB03o002Q0?oooc<0o`005@00o`2l0?ooo`00DP3oool00`000000oooo0?ooo`0R
0?ooodH0o`00X`3ooola0?l001D00?l0_@3oool00580oooo00<000000?ooo`3oool08P3ooom40?l0
0:D0oooo<@3o000C003o0;l0oooo001B0?ooo`030000003oool0oooo02<0oooo@P3o002W0?ooobl0
o`004`00o`300?ooo`00DP3oool00`000000oooo0?ooo`0S0?oood40o`00Z03oool^0?l001<00?l0
`@3oool00580oooo00<000000?ooo`3oool08`3ooom00?l00:T0oooo;P3o000B003o0<80oooo001B
0?ooo`030000003oool0oooo02@0oooo?P3o002[0?ooob`0o`004P00o`330?ooo`00DP3oool00`00
0000oooo0?ooo`0T0?ooocd0o`00[03oool[0?l001800?l0a03oool00580oooo00<000000?ooo`3o
ool0903oooll0?l00:d0oooo:`3o000A003o0<D0oooo001B0?ooo`030000003oool0oooo02D0oooo
>@3o002`0?ooobT0o`004@00o`360?ooo`00DP3oool00`000000oooo0?ooo`0U0?ooocP0o`00/@3o
oolX0?l001000?l0b03oool00580oooo00<000000?ooo`3oool09P3ooolf0?l00;<0oooo9P3o000@
003o0<T0oooo001B0?ooo`030000003oool0oooo02H0oooo=@3o002d0?ooobH0o`003`00o`3:0?oo
o`00DP3oool00`000000oooo0?ooo`0V0?oooc@0o`00]@3ooolU0?l000l00?l0b`3oool00580oooo
00<000000?ooo`3oool09`3ooolb0?l00;L0oooo8`3o000?003o0<`0oooo001B0?ooo`030000003o
ool0oooo02L0oooo<@3o002h0?ooob<0o`003P00o`3=0?ooo`00DP3oool00`000000oooo0?ooo`0X
0?ooobl0o`00^P3ooolQ0?l000h00?l0cP3oool00580oooo00<000000?ooo`3oool0:03oool]0?l0
0;`0oooo803o000=003o0=00oooo001B0?ooo`030000003oool0oooo02P0oooo;03o002m0?ooob00
o`003000o`3A0?ooo`00DP3oool00`000000oooo0?ooo`0Y0?ooobX0o`00_`3ooolN0?l000`00?l0
dP3oool00580oooo00<000000?ooo`3oool0:@3ooolY0?l00<00oooo7@3o000<003o0=<0oooo001B
0?ooo`030000003oool0oooo02T0oooo:03o00310?oooad0o`002`00o`3D0?ooo`00DP3oool00`00
0000oooo0?ooo`0Z0?ooobH0o`00``3ooolK0?l000/00?l0e@3oool00580oooo00<000000?ooo`3o
ool0:P3ooolU0?l00<@0oooo6P3o000;003o0=H0oooo001B0?ooo`030000003oool0oooo02/0oooo
8`3o00360?oooaP0o`002`00o`3G0?ooo`00DP3oool00`000000oooo0?ooo`0[0?ooob40o`00b03o
oolH0?l000T00?l0f@3oool00580oooo00<000000?ooo`3oool0:`3ooolP0?l00<T0oooo5`3o0009
003o0=X0oooo001B0?ooo`030000003oool0oooo02`0oooo7P3o003;0?oooaD0o`002@00o`3K0?oo
o`00DP3oool00`000000oooo0?ooo`0/0?oooad0o`00c03ooolE0?l000P00?l0g03oool00580oooo
00<000000?ooo`3oool0;@3ooolK0?l00<h0oooo4`3o0008003o0=d0oooo001B0?ooo`030000003o
ool0oooo02d0oooo6P3o003?0?oooa80o`002000o`3N0?ooo`00DP3oool00`000000oooo0?ooo`0]
0?oooaT0o`00d03ooolB0?l000L00?l0g`3oool00580oooo00<000000?ooo`3oool0;P3ooolF0?l0
0=<0oooo403o0006003o0>40oooo001B0?ooo`030000003oool0oooo02h0oooo5@3o003D0?ooo`l0
o`001P00o`3R0?ooo`00DP3oool00`000000oooo0?ooo`0^0?oooa@0o`00e@3oool?0?l000D00?l0
h`3oool00580oooo00<000000?ooo`3oool0;`3ooolB0?l00=L0oooo3@3o0005003o0>@0oooo001B
0?ooo`030000003oool0oooo02l0oooo4@3o003H0?ooo``0o`001@00o`3U0?ooo`00DP3oool00`00
0000oooo0?ooo`0`0?ooo`l0o`00fP3oool:0?l000D00?l0iP3oool00580oooo00<000000?ooo`3o
ool0<03oool>0?l00=/0oooo2P3o0004003o0>L0oooo001B0?ooo`030000003oool0oooo0300oooo
3@3o003L0?ooo`T0o`001000o`3X0?ooo`00DP3oool00`000000oooo0?ooo`0a0?ooo`X0o`00g`3o
ool70?l000<00?l0jP3oool00580oooo00<000000?ooo`3oool0<@3oool90?l00>00oooo1`3o0002
003o0>/0oooo001B0?ooo`030000003oool0oooo0380oooo1`3o003R0?ooo`D0o`000P00o`3/0?oo
o`00DP3oool00`000000oooo0?ooo`0b0?ooo`H0o`00h`3oool40?l000800?l0k@3oool00580oooo
00<000000?ooo`3oool0<P3oool50?l00>@0oooo103o00000`00o`00oooo0?ooo`3/0?ooo`00DP3o
ool00`000000oooo0?ooo`0c0?ooo`<0o`00iP3oool20?l00003003o003oool0oooo0>d0oooo001B
0?ooo`030000003oool0oooo03<0oooo0P3o003W0?ooo`030?l00000o`00oooo0>l0oooo001B0?oo
o`030000003oool0oooo0?l0ooooo`3oool@0?ooo`00DP3oool00`000000oooo0?ooo`3o0?ooool0
oooo403oool00580oooo00<000000?ooo`3oool0o`3ooooo0?oooa00oooo001B0?ooo`030000003o
ool0oooo0?l0ooooo`3oool@0?ooo`00DP3oool00`000000oooo0?ooo`3o0?ooool0oooo403oool0
0?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3o
oomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00
o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00:80oooo1@0000020?ooo`8000005@3oool5
00000080oooo0P00000E0?ooo`D000000P3oool2000001/0oooo1@0000020?ooo`8000006`3oool5
00000080oooo0P00000K0?ooo`D000000P3oool2000001/0oooo1@0000020?ooo`8000006`3oool5
00000080oooo0P00000K0?ooo`D000000P3oool200000:@0oooo002T0?ooo`050000003oool0oooo
0?ooo`0000000P3oool00`000000oooo0?ooo`0D0?ooo`050000003oool0oooo0?ooo`0000000P3o
ool00`000000oooo0?ooo`0D0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo
0?ooo`0J0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0J0?ooo`05
0000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0J0?ooo`050000003oool0oooo
0?ooo`0000000P3oool00`000000oooo0?ooo`0J0?ooo`050000003oool0oooo0?ooo`0000000P3o
ool00`000000oooo0?ooo`0J0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo
0?ooo`0J0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`2Q0?ooo`00
Y03oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
6`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
6`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
XP3oool00:@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0D0?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo01X0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0J0?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo01X0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0J0?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo0:40oooo002T0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?oo
o`0D0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0D0?ooo`050000
003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0J0?ooo`050000003oool0oooo0?oo
o`0000000P3oool00`000000oooo0?ooo`0J0?ooo`050000003oool0oooo0?ooo`0000000P3oool0
0`000000oooo0?ooo`0J0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?oo
o`0J0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0J0?ooo`050000
003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0J0?ooo`050000003oool0oooo0?oo
o`0000000P3oool00`000000oooo0?ooo`2Q0?ooo`00X`3oool2000000@0oooo0P00000F0?ooo`80
0000103oool2000001H0oooo0P0000040?ooo`800000703oool2000000@0oooo0P00000L0?ooo`80
0000103oool2000001`0oooo0P0000040?ooo`800000703oool2000000@0oooo0P00000L0?ooo`80
0000103oool2000001`0oooo0P0000040?ooo`800000Y03oool00?l0ooooo`3ooomU0?ooo`00o`3o
oooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool009T0oooo00<000000?ooo`3oool0o`3oool]0?ooo`030000003o
ool0oooo09P0oooo002H0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool05@3oool0
0`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool0
0`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool0
0`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo09L0oooo002H0?ooo`030000003oool0oooo
01X0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo
0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo
0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo
09L0oooo002H0?ooo`040000003oool0oooo0?ooo`@000000P3oool400000080oooo100000020?oo
o`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?oo
o`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?oo
o`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?oo
o`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?oo
o`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?oo
o`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?oo
o`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?oo
o`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000<0oooo00<000000?oo
o`3oool0U`3oool009L0oooo00<000000?ooo`3oool0o`3ooola0?ooo`030000003oool0oooo09H0
oooo002H0?ooo`030000003oool0oooo0?l0oooo;`3oool00`000000oooo0?ooo`2G0?ooo`00V03o
ool00`000000oooo0?ooo`3o0?ooobl0oooo00<000000?ooo`3oool0U`3oool009T0oooo00<00000
0?ooo`3oool0o`3oool]0?ooo`030000003oool0oooo09P0oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool009`0oooo0`0000080?ooo`<00000
1@3oool3000000d0oooo0`0000050?ooo`<000003P3oool3000000P0oooo0`0000050?ooo`<00000
3`3oool2000000P0oooo0`0000050?ooo`<00000403oool00`000000oooo0?ooo`060?ooo`<00000
1@3oool3000000l0oooo0P0000080?ooo`<000001@3oool300000100oooo0`0000060?ooo`<00000
1@3oool300000100oooo0`0000060?ooo`<000001@3oool3000000l0oooo0P0000080?ooo`<00000
1@3oool3000009d0oooo002L0?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0
3@3oool010000000oooo0?ooo`0000080?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3o
ool03@3oool010000000oooo0?ooo`0000080?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool03`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool03@3oool010000000oooo0?ooo`0000080?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool0403oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool0403oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool03@3oool010000000oooo0?ooo`0000080?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool0W03oool009`0oooo00@000000?ooo`3oool00000203oool3000000D0oooo00<0
00000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03@3oool010000000oooo0?oo
o`0000080?ooo`<000001@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo00L0oooo
0`0000050?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool01`3oool3000000D0oooo
00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`070?ooo`<000001@3oool00`000000oooo
0?ooo`0=0?ooo`D000001`3oool3000000D0oooo00<000000?ooo`3oool03@3oool5000000L0oooo
0`0000050?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool01P3oool3000000D0oooo
00<000000?ooo`3oool0W03oool009`0oooo0`0000090?ooo`040000003oool0oooo000000<0oooo
0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`<000002@3oool010000000
oooo0?ooo`0000030?ooo`8000004P3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo
000000<0oooo0P00000B0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool000000`3o
ool200000180oooo00<000000?ooo`3oool01P3oool010000000oooo0?ooo`0000030?ooo`800000
3`3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000000<0oooo0P00000?0?oo
o`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000000`3oool200000100oooo0P00
00090?ooo`040000003oool0oooo000000<0oooo0P00002N0?ooo`00W@3oool00`000000oooo0?oo
o`080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool000005@3oool00`000000
oooo0?ooo`080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool0
10000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool0
0000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001D0oooo00<00000
0?ooo`000000203oool010000000oooo0?ooo`00000E0?ooo`030000003oool0000000P0oooo00@0
00000?ooo`3oool000005@3oool00`000000oooo0?ooo`080?ooo`040000003oool0oooo00000:<0
oooo002M0?ooo`<000001`3oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo
00<000000?ooo`3oool03P3oool3000000L0oooo100000050?ooo`030000003oool0oooo00h0oooo
0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`0=0?ooo`@000001`3oool4000000D0oooo
00<000000?ooo`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo00l0oooo
0P0000070?ooo`@000001@3oool00`000000oooo0?ooo`0?0?ooo`8000001`3oool4000000D0oooo
00<000000?ooo`3oool03P3oool3000000L0oooo100000050?ooo`030000003oool0oooo09`0oooo
003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 610.75}, {192.188, 0}} -> {-0.372009, -0.0157921, \
0.00449287, 0.00449287}, {{82.75, 294.75}, {188.625, 48.0625}} -> {-3.78166, \
-0.057808, 0.0162236, 0.0162236}, {{315.938, 527.938}, {188.625, 48.0625}} -> \
{-7.5648, -0.057808, 0.0162236, 0.0162236}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2381 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00566893 0.47619 [
[.5 .2506 -122 0 ]
[.5 .2506 122 38.75 ]
[ 0 0 0 0 ]
[ 1 .2381 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00567 m
1 .00567 L
s
.02381 0 m
.02381 .2381 L
s
gsave
.5 .2506 -183 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Pi) show
93.000 12.750 moveto
(Pi) show
117.000 12.750 moveto
(Pi) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(2) show
177.000 12.750 moveto
(Pi) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(Pi) show
273.000 12.750 moveto
(5) show
285.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
105.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
117.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
129.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
141.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
(--) show
189.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
201.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
273.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
285.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
297.000 25.875 moveto
(<) show
69.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
93.000 39.000 moveto
(3) show
117.000 39.000 moveto
(3) show
141.000 39.000 moveto
(6) show
171.000 39.000 moveto
(3) show
201.000 39.000 moveto
(6) show
225.000 39.000 moveto
(2) show
249.000 39.000 moveto
(12) show
279.000 39.000 moveto
(12) show
291.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2381 L
0 .2381 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00566893 0.477324 0.232426 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.133975 0.866025 -1.05168e-017 0.866025 [
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
0 1 0 r
0 0 m
.5 0 L
.25 .43301 L
F
0 0 1 r
.5 0 m
1 0 L
.25 .43301 L
F
1 0 0 r
0 0 m
.25 .43301 L
.13397 .5 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00566893 0.97619 0.232426 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.133975 0.866025 -3.08998e-018 0.866025 [
[ 0 0 0 0 ]
[ 1 .5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .5 L
0 .5 L
closepath
clip
newpath
0 1 0 r
.13397 0 m
.56699 .25 L
.13397 .5 L
F
0 0 1 r
.13397 0 m
1 0 L
.56699 .25 L
F
1 0 0 r
.13397 .5 m
0 0 L
.13397 0 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{612, 145.688},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009T0000TB000`400?l00000o`00003oJ03oool0
0`000000oooo0?ooo`3o0?ooooX0oooo001X0?ooo`030000003oool0oooo0?l0oooonP3oool005h0
ooooo`00002X000005l0oooo001X0?ooo`0300000000o`000?l005d00?l0GP000?lF0?oooaP0o`00
0P00o`2S0000of/0oooo001X0?ooo`030000003o00000?l005`00?l0G@000?lH0?oooaP0o`001000
o`2O0000ofd0oooo001X0?ooo`030000003o00000?l005`00?l0F`000?lJ0?oooaP0o`001P00o`2K
0000ofl0oooo001X0?ooo`030000003oool0o`0005/00?l0F`000?lL0?oooaL0o`001`00o`2I0000
og00oooo001X0?ooo`030000003oool0o`0005/00?l0F@000?lN0?oooaL0o`002@00o`2E0000og80
oooo001X0?ooo`040000003oool0o`000?l005T00?l0F0000?lP0?oooaL0o`002`00o`2A0000og@0
oooo001X0?ooo`030000003oool0o`000080o`00E`00o`1G0000ob80oooo5`3o000=003o08d0003o
MP3oool006P0oooo00<000000?ooo`3oool00P3o001G003o05H0003o903ooolF0?l000h00?l0R`00
0?mg0?ooo`00J03oool00`000000oooo0?ooo`030?l005D00?l0E@000?lV0?oooaH0o`004000o`27
0000ogT0oooo001X0?ooo`030000003oool0oooo00<0o`00E@00o`1C0000obP0oooo5P3o000B003o
08<0003oN`3oool006P0oooo00<000000?ooo`3oool0103o001C003o05<0003o:@3ooolF0?l001@0
0?l0O`000?mm0?ooo`00J03oool010000000oooo0?ooo`3oool30?l005<00?l0D@000?l/0?oooaD0
o`005@00o`1m0000ogh0oooo001X0?ooo`040000003oool0oooo0?ooo`@0o`00D@00o`1@0000obh0
oooo5@3o000G003o07T0003oP03oool006P0oooo00@000000?ooo`3oool0oooo1@3o001?003o04l0
003o<03ooolE0?l001T00?l0M@000?n20?ooo`00J03oool010000000oooo0?ooo`3oool50?l004l0
0?l0CP000?la0?oooaD0o`006P00o`1c0000oh<0oooo001X0?ooo`030000003oool0oooo0080oooo
1@3o001=003o04d0003o=03ooolD0?l001`00?l0K`000?n50?ooo`00J03oool00`000000oooo0?oo
o`020?ooo`D0o`00C@00o`1;0000ocH0oooo503o000N003o06/0003oQ`3oool006P0oooo00<00000
0?ooo`3oool00P3oool60?l004/00?l0BP000?lh0?oooa@0o`008000o`1W0000ohT0oooo001X0?oo
o`030000003oool0oooo0080oooo1P3o001;003o04T0003o>@3ooolD0?l002400?l0I@000?n:0?oo
o`00J03oool00`000000oooo0?ooo`030?ooo`H0o`00B@00o`180000oc`0oooo4`3o000S003o0640
003oS03oool006P0oooo00<000000?ooo`3oool00`3oool70?l004L00?l0A`000?ln0?oooa<0o`00
9@00o`1M0000ohh0oooo001X0?ooo`030000003oool0oooo00<0oooo1`3o0017003o04H0003o?`3o
oolC0?l002L00?l0F@000?n@0?ooo`00J03oool00`000000oooo0?ooo`030?ooo`P0o`00A@00o`15
0000od40oooo4`3o000X003o05L0003oT@3oool006P0oooo00<000000?ooo`3oool0103oool70?l0
04D00?l0@`000?m40?oooa80o`00:P00o`1C0000oi<0oooo001X0?ooo`030000003oool0oooo00@0
oooo203o0013003o0480003oAP3ooolB0?l002`00?l0C`000?nE0?ooo`00J03oool00`000000oooo
0?ooo`040?ooo`T0o`00@@00o`120000odL0oooo4P3o000]003o04d0003oUP3oool006P0oooo00<0
00000?ooo`3oool01@3oool80?l004400?l0@0000?m:0?oooa40o`00;`00o`190000oiP0oooo001X
0?ooo`030000003oool0oooo00D0oooo2@3o000o003o03l0003oC03ooolA0?l003400?l0A@000?nJ
0?ooo`00J03oool00`000000oooo0?ooo`050?ooo`T0o`00?`00o`0n0000odd0oooo4@3o000c003o
0440003oW03oool006P0oooo00<000000?ooo`3oool01@3oool:0?l003d00?l0?@000?m?0?oooa40
o`00=000o`0o0000oid0oooo001X0?ooo`030000003oool0oooo00H0oooo2@3o000m003o03/0003o
DP3oool@0?l003H00?l0>`000?nO0?ooo`00J03oool00`000000oooo0?ooo`060?ooo`X0o`00>`00
o`0j0000oe@0oooo403o000h003o03L0003oX@3oool006P0oooo00<000000?ooo`3oool01P3oool;
0?l003T00?l0>P000?mE0?oooa00o`00>P00o`0c0000oj<0oooo001X0?ooo`030000003oool0oooo
00H0oooo2`3o000i003o03P0003oE`3oool@0?l003/00?l0<@000?nT0?ooo`00J03oool00`000000
oooo0?ooo`070?ooo`/0o`00=`00o`0g0000oeX0oooo3`3o000m003o02d0003oYP3oool006P0oooo
00<000000?ooo`3oool01`3oool;0?l003L00?l0=@000?mL0?ooo`l0o`00?`00o`0Y0000ojP0oooo
001X0?ooo`030000003oool0oooo00L0oooo303o000e003o03D0003oG@3oool?0?l004000?l09`00
0?nY0?ooo`00J03oool00`000000oooo0?ooo`070?ooo``0o`00=@00o`0c0000oel0oooo3`3o0012
003o02<0003oZ`3oool006P0oooo00<000000?ooo`3oool0203oool<0?l003<00?l0<P000?mR0?oo
o`h0o`00A000o`0O0000ojd0oooo001X0?ooo`030000003oool0oooo00P0oooo3@3o000a003o0380
003oH`3oool>0?l004H00?l06`000?n_0?ooo`00J03oool00`000000oooo0?ooo`080?ooo`d0o`00
<@00o`0`0000ofD0oooo3P3o0017003o01T0003o/03oool006P0oooo00<000000?ooo`3oool0203o
ool>0?l002l00?l0;`000?mW0?ooo`h0o`00B@00o`0E0000ok80oooo001X0?ooo`030000003oool0
oooo00T0oooo3@3o000_003o02d0003oJP3oool=0?l004/00?l04@000?nd0?ooo`00J03oool00`00
0000oooo0?ooo`090?ooo`h0o`00;@00o`0]0000of/0oooo3@3o001=003o00d0003o]P3oool006P0
oooo00<000000?ooo`3oool02@3oool?0?l002/00?l0;0000?m]0?ooo`d0o`00CP00o`0;0000okL0
oooo001X0?ooo`030000003oool0oooo00T0oooo3`3o000[003o02X0003oK`3oool=0?l005000?l0
1`000?ni0?ooo`00J03oool00`000000oooo0?ooo`0:0?ooo`l0o`00:@00o`0Z0000og40oooo303o
001B003o00<0003o^`3oool006P0oooo00<000000?ooo`3oool02P3oool?0?l002T00?l0:0000?mc
0?ooo``0o`00D`00o`2m0?ooo`00J03oool00`000000oooo0?ooo`0:0?oooa00o`009`00o`0W0000
ogD0oooo303o001B003o0;h0oooo001X0?ooo`030000003oool0oooo00/0oooo3`3o000W003o02D0
003oN03oool;0?l005000?l0`03oool006P0oooo00<000000?ooo`3oool02`3oool@0?l002D00?l0
9@000?mi0?ooo`/0o`00CP00o`320?ooo`00J03oool00`000000oooo0?ooo`0;0?oooa40o`008`00
o`0T0000og/0oooo2`3o001=003o0<<0oooo001X0?ooo`030000003oool0oooo00/0oooo4@3o000S
003o0280003oO@3oool;0?l004/00?l0a@3oool006P0oooo00<000000?ooo`3oool0303ooolA0?l0
02400?l08@000?n00?ooo`X0o`00B@00o`370?ooo`00J03oool00`000000oooo0?ooo`0<0?oooa40
o`008@00o`0P0000oh40oooo2P3o0017003o0<T0oooo001X0?ooo`030000003oool0oooo00`0oooo
4P3o000O003o01l0003oP`3oool:0?l004H00?l0bP3oool006P0oooo00<000000?ooo`3oool0303o
oolB0?l001l00?l07@000?n50?ooo`X0o`00A000o`3<0?ooo`00J03oool00`000000oooo0?ooo`0=
0?oooa80o`007@00o`0M0000ohL0oooo2@3o0012003o0<h0oooo001X0?ooo`030000003oool0oooo
00d0oooo4`3o000K003o01`0003oR@3oool90?l004000?l0d03oool006P0oooo00<000000?ooo`3o
ool03@3ooolC0?l001/00?l06P000?n;0?ooo`T0o`00?`00o`3A0?ooo`00J03oool00`000000oooo
0?ooo`0=0?oooa@0o`006@00o`0I0000ohd0oooo2@3o000m003o0=<0oooo001X0?ooo`030000003o
ool0oooo00h0oooo4`3o000I003o01P0003oS`3oool80?l003/00?l0e@3oool006P0oooo00<00000
0?ooo`3oool03P3ooolD0?l001L00?l05`000?nA0?ooo`P0o`00>P00o`3F0?ooo`00J03oool00`00
0000oooo0?ooo`0>0?oooaD0o`005@00o`0F0000oi<0oooo203o000h003o0=P0oooo001X0?ooo`03
0000003oool0oooo00h0oooo5@3o000E003o01D0003oU03oool80?l003H00?l0fP3oool006P0oooo
00<000000?ooo`3oool03`3ooolE0?l001<00?l050000?nG0?ooo`L0o`00=000o`3L0?ooo`00J03o
ool00`000000oooo0?ooo`0?0?oooaD0o`004`00o`0B0000oiT0oooo1`3o000c003o0=d0oooo001X
0?ooo`030000003oool0oooo00l0oooo5P3o000A003o0140003oV`3oool70?l003400?l0g`3oool0
06P0oooo00<000000?ooo`3oool03`3ooolF0?l001400?l040000?nL0?ooo`L0o`00;`00o`3Q0?oo
o`00J03oool00`000000oooo0?ooo`0@0?oooaH0o`003`00o`0?0000oil0oooo1P3o000]003o0><0
oooo001X0?ooo`030000003oool0oooo0100oooo5`3o000=003o00h0003oX@3oool60?l002`00?l0
i03oool006P0oooo00<000000?ooo`3oool0403ooolG0?l000d00?l030000?nS0?ooo`H0o`00:P00
o`3V0?ooo`00J03oool00`000000oooo0?ooo`0A0?oooaL0o`002`00o`0<0000ojD0oooo1@3o000X
003o0>P0oooo001X0?ooo`030000003oool0oooo0140oooo5`3o000;003o00X0003oY`3oool50?l0
02L00?l0j@3oool006P0oooo00<000000?ooo`3oool04@3ooolH0?l000T00?l02@000?nY0?ooo`D0
o`009@00o`3[0?ooo`00J03oool00`000000oooo0?ooo`0A0?oooaP0o`002@00o`080000ojX0oooo
1@3o000S003o0>d0oooo001X0?ooo`030000003oool0oooo0180oooo603o0007003o00L0003o[@3o
ool40?l002400?l0k`3oool006P0oooo00<000000?ooo`3oool04P3ooolI0?l000D00?l01P000?n_
0?ooo`@0o`008000o`3`0?ooo`00J03oool00`000000oooo0?ooo`0B0?oooaT0o`001@00o`040000
ok40oooo103o000N003o0?80oooo001X0?ooo`030000003oool0oooo0180oooo6P3o0003003o00@0
003o/P3oool40?l001`00?l0m03oool006P0oooo00<000000?ooo`3oool04`3ooolI0?l000<00?l0
0P000?ne0?ooo`<0o`006P00o`3f0?ooo`00J03oool00`000000oooo0?ooo`0C0?oooaX0o`0000<0
0?l00000o`3oool0]P3oool30?l001T00?l0m`3oool006P0oooo00<000000?ooo`3oool04`3ooolJ
0?l00;T0oooo0`3o000G003o0?T0oooo001X0?ooo`030000003oool0oooo01<0oooo6@3o002j0?oo
o`<0o`005@00o`3k0?ooo`00J03oool00`000000oooo0?ooo`0D0?oooaH0o`00_@3oool20?l001@0
0?l0o03oool006P0oooo00<000000?ooo`3oool0503ooolD0?l00;l0oooo0P3o000B003o0?h0oooo
001X0?ooo`030000003oool0oooo01@0oooo4P3o00310?ooo`80o`004000o`3o0?ooo`40oooo001X
0?ooo`030000003oool0oooo01@0oooo4@3o00320?ooo`80o`003P00o`3o0?ooo`<0oooo001X0?oo
o`030000003oool0oooo01D0oooo3P3o00350?ooo`030?l00000o`000?l000/00?l0o`3oool40?oo
o`00J03oool00`000000oooo0?ooo`0E0?ooo``0o`00a`3oool00`3o00000?l0003o0009003o0?l0
oooo1P3oool006P0oooo00<000000?ooo`3oool05@3oool:0?l00<T0oooo00<0o`00003o0000o`00
1`00o`3o0?ooo`P0oooo001X0?ooo`030000003oool0oooo01D0oooo2@3o003:0?ooo`030?l00000
o`000?l000D00?l0o`3oool:0?ooo`00J03oool00`000000oooo0?ooo`0F0?ooo`H0o`00c@3oool6
003o0?l0oooo2`3oool006P0oooo00<000000?ooo`3oool05P3oool40?l00<l0oooo1000o`3o0?oo
o`d0oooo001X0?ooo`030000003oool0oooo01H0oooo0P3o003A0?ooo`800?l0o`3oool?0?ooo`00
J03oool00`000000oooo0?ooo`3o0?ooooX0oooo001X0?ooo`030000003oool0oooo0?l0oooonP3o
ool006P0oooo00<000000?ooo`3oool0o`3ooooj0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0
ooooIP3oool00?l0ooooo`3ooomV0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool0
0?l0ooooo`3ooomV0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool00?l0ooooo`3o
oomV0?ooo`00`@3oool2000001H0oooo0P00000F0?ooo`8000005@3oool3000001`0oooo0P00000K
0?ooo`<000005@3oool4000001@0oooo1@0000000`3oool0000000000002000001@0oooo1@000000
0`3oool000000000000200000<P0oooo00300?ooo`040000003oool0oooo000001@0oooo00@00000
0?ooo`3oool00000503oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001X0
oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00000D0?ooo`030000003oool0
oooo01L0oooo00D000000?ooo`3oool0oooo0000000I0?ooo`050000003oool0oooo0?ooo`000000
b`3oool00<80oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003o
ool0oooo01<0oooo00@000000?ooo`3oool00000703oool00`000000oooo0?ooo`0I0?ooo`040000
003oool0oooo000001D0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo01H0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`380?ooo`00
``3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
4P3oool3000001h0oooo00<000000?ooo`3oool0603oool3000001L0oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`370?ooo`00`03oool010000000oooo0?ooo`00000D0?ooo`040000
003oool0oooo000001@0oooo00@000000?ooo`3oool000005@3oool00`000000oooo0?ooo`0J0?oo
o`040000003oool0oooo000001/0oooo00<000000?ooo`3oool0503oool010000000oooo0?ooo`00
000F0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0D0?ooo`050000
003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`360?ooo`00`@3oool2000001H0oooo
0P00000F0?ooo`8000005P3oool3000001/0oooo0P00000L0?ooo`<000005@3oool2000001H0oooo
0P0000040?ooo`8000005P3oool2000000@0oooo0P0000390?ooo`00o`3ooooo0?ooofH0oooo003o
0?ooool0ooooIP3oool00?l0ooooo`3ooomV0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0oooo
IP3oool00?l0ooooo`3ooomV0?ooo`00_@3oool00`000000oooo0?ooo`3T0?ooo`030000003oool0
oooo0;d0oooo002l0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool05@3oool00`00
0000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`00
0000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`00
0000oooo0?ooo`0Q0?ooo`030000003oool0oooo0;`0oooo002l0?ooo`030000003oool0oooo00h0
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0
oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0;`0
oooo002l0?ooo`040000003oool0oooo0?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3o
ool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@0
0000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3o
ool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3o
ool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@0
0000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3o
ool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000<0oooo00<000000?ooo`3o
ool0_03oool00;/0oooo00<000000?ooo`3oool0j03oool00`000000oooo0?ooo`2k0?ooo`00_03o
ool00`000000oooo0?ooo`3V0?ooo`030000003oool0oooo0;`0oooo002l0?ooo`030000003oool0
oooo0>H0oooo00<000000?ooo`3oool0_03oool00;d0oooo00<000000?ooo`3oool0i03oool00`00
0000oooo0?ooo`2m0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool00?l0ooooo`3o
oomV0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool00?l0ooooo`3ooomV0?ooo`00
o`3ooooo0?ooofH0oooo002o0?ooo`<000001@3oool3000000d0oooo0`0000050?ooo`<000003@3o
ool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000h0oooo100000070?ooo`<000001@3o
ool3000000d0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000=0?ooo`<000001@3o
ool3000000l0oooo0P0000080?ooo`<000001@3oool300000<80oooo00300?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`090?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool03@3oool010000000oooo0?ooo`0000080?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool0`@3oool00<00oooo0`0000050?ooo`030000003oool0
oooo00d0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0
oooo00d0oooo0`0000050?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool3
000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03@3oool3
000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool0403oool0
0`000000oooo0?ooo`060?ooo`<000001@3oool00`000000oooo0?ooo`310?ooo`00`03oool01000
0000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000030?ooo`8000003`3o
ool010000000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000030?ooo`80
00004@3oool00`000000oooo0?ooo`070?ooo`040000003oool0oooo000000<0oooo0P00000?0?oo
o`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00
000?0?ooo`040000003oool0oooo000000<0oooo0P00000@0?ooo`8000002@3oool010000000oooo
0?ooo`0000030?ooo`800000``3oool00<00oooo00@000000?ooo`3oool00000503oool010000000
oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000503o
ool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000503oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001D0oooo00<0
00000?ooo`3oool0203oool010000000oooo0?ooo`0000380?ooo`00_`3oool4000000D0oooo00<0
00000?ooo`3oool0303oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<0
00000?ooo`3oool0303oool4000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo1000
00050?ooo`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00`0oooo1000
00050?ooo`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0`00
00070?ooo`@000001@3oool00`000000oooo0?ooo`310?ooo`00o`3ooooo0?ooofH0oooo003o0?oo
ool0ooooIP3oool00001\
\>"],
  ImageRangeCache->{{{0, 611}, {144.688, 0}} -> {-0.517632, -0.0119074, \
0.0049677, 0.0049677}, {{104.188, 295.875}, {142.25, 46.375}} -> {-0.782325, \
-0.0147803, 0.00602393, 0.00602393}, {{315.063, 506.75}, {142.25, 46.375}} -> \
{-2.05262, -0.0147803, 0.00602393, 0.00602393}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(2) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(3) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(2) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(5) show
135.000 39.000 moveto
(5) show
165.000 39.000 moveto
(5) show
195.000 39.000 moveto
(5) show
225.000 39.000 moveto
(5) show
255.000 39.000 moveto
(5) show
285.000 39.000 moveto
(5) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -9.21572e-018 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.61803 0 L
.5 .36327 L
F
0 0 1 r
.61803 0 m
1 0 L
.5 .36327 L
F
1 0 0 r
0 0 m
.5 .36327 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -1.19262e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.19098 .58779 m
0 0 L
.38197 0 L
F
0 0 1 r
.38197 0 m
1 0 L
.69098 .22451 L
F
1 0 0 r
.38197 0 m
.69098 .22451 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000Zb000`400?l00000o`00003oF`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?oo
o`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00D03ooooo00000<@00000
D03oool005/0oooo00<000000?l00000o`00N`00o`1=0000oaH0ooooC@00o`020?l007/0003oG@3o
ool005/0oooo00<000000?l0003o0000N`00o`1<0000oaL0ooooC@00o`030?l007T0003oGP3oool0
05/0oooo00<000000?l0003o00000P3o001i003o04X0003o6@3ooom=003o00D0o`00M@000?mP0?oo
o`00F`3oool00`000000oooo0?l000030?l007L00?l0BP000?lK0?oood/00?l01`3o001c0000of40
oooo001K0?ooo`030000003oool0o`0000@0o`00MP00o`190000oa`0ooooB`00o`080?l00740003o
HP3oool005/0oooo00<000000?ooo`3o00001P3o001d003o04L0003o7P3ooom;003o00X0o`00K@00
0?mT0?ooo`00F`3oool00`000000oooo0?ooo`070?l007800?l0A`000?lP0?ooodT00?l0303o001[
0000ofD0oooo001K0?ooo`030000003oool0oooo00T0o`00L000o`150000ob80ooooB@00o`0=0?l0
06T0003oIP3oool005/0oooo00<000000?ooo`3oool02P3o001_003o04@0003o8`3ooom9003o00l0
o`00I@000?mX0?ooo`00F`3oool010000000oooo0?ooo`3oool:0?l006d00?l0A0000?lU0?ooodL0
0?l04@3o001S0000ofT0oooo001K0?ooo`040000003oool0oooo0?ooo``0o`00J`00o`120000obL0
ooooA`00o`0C0?l005l0003oJ`3oool005/0oooo00@000000?ooo`3oool0oooo3@3o001Z003o0440
003o:03ooom7003o01@0o`00G@000?m/0?ooo`00F`3oool00`000000oooo0?ooo`020?ooo`d0o`00
J000o`110000obX0ooooA@00o`0F0?l005/0003oK@3oool005/0oooo00<000000?ooo`3oool00P3o
ool?0?l006H00?l0?`000?l/0?ooodD00?l0603o001G0000ofl0oooo001K0?ooo`030000003oool0
oooo0080oooo403o001U003o03h0003o;@3ooom5003o01T0o`00E@000?m`0?ooo`00F`3oool00`00
0000oooo0?ooo`030?oooa40o`00HP00o`0m0000oc00oooo@`00o`0K0?l005<0003oL@3oool005/0
oooo00<000000?ooo`3oool00`3ooolB0?l006400?l0?0000?la0?oood<00?l07@3o001?0000og<0
oooo001K0?ooo`030000003oool0oooo00<0oooo4`3o001P003o03/0003o<P3ooom3003o01h0o`00
C@000?md0?ooo`00F`3oool00`000000oooo0?ooo`040?oooa@0o`00G@00o`0j0000ocD0oooo@@00
o`0Q0?l004T0003oMP3oool005/0oooo00<000000?ooo`3oool0103ooolE0?l005`00?l0>@000?lf
0?oood400?l08P3o00170000ogL0oooo001K0?ooo`030000003oool0oooo00@0oooo5P3o001K003o
03P0003o=`3ooom1003o02<0o`00A@000?mh0?ooo`00F`3oool00`000000oooo0?ooo`050?oooaL0
o`00F000o`0g0000ocX0oooo?`00o`0V0?l00440003oNP3oool005/0oooo00<000000?ooo`3oool0
1@3ooolH0?l005L00?l0=P000?lk0?ooocl00?l09`3o000o0000og/0oooo001K0?ooo`030000003o
ool0oooo00D0oooo6P3o001E003o03@0003o?@3ooolo003o02P0o`00?@000?ml0?ooo`00F`3oool0
0`000000oooo0?ooo`060?oooaX0o`00D`00o`0d0000ocl0oooo?@00o`0[0?l003T0003oOP3oool0
05/0oooo00<000000?ooo`3oool01P3ooolK0?l005800?l0<`000?m00?ooocd00?l0;03o000g0000
ogl0oooo001K0?ooo`030000003oool0oooo00H0oooo7@3o001@003o0340003o@P3ooolm003o02d0
o`00=@000?n00?ooo`00F`3oool00`000000oooo0?ooo`070?oooad0o`00CP00o`0a0000od@0oooo
>`00o`0`0?l00340003oPP3oool005/0oooo00<000000?ooo`3oool01`3ooolN0?l004d00?l0<000
0?m50?oooc/00?l0<@3o000_0000oh<0oooo001K0?ooo`030000003oool0oooo00L0oooo803o001;
003o02h0003oA`3ooolk003o03<0o`00:`000?n50?ooo`00F`3oool00`000000oooo0?ooo`080?oo
ob00o`00B@00o`0^0000odT0oooo>@00o`0e0?l002T0003oQP3oool005/0oooo00<000000?ooo`3o
ool0203ooolR0?l004L00?l0;0000?m;0?ooocT00?l0=P3o000W0000ohL0oooo001K0?ooo`030000
003oool0oooo00P0oooo8`3o0016003o02/0003oC03oooli003o03P0o`008`000?n90?ooo`00F`3o
ool00`000000oooo0?ooo`090?ooob<0o`00A000o`0[0000odh0oooo=`00o`0j0?l00240003oRP3o
ool005/0oooo00<000000?ooo`3oool02@3ooolU0?l004800?l0:@000?m@0?ooocL00?l0>`3o000O
0000oh/0oooo001K0?ooo`030000003oool0oooo00T0oooo9P3o0011003o02P0003oD@3ooolg003o
03d0o`006`000?n=0?ooo`00F`3oool00`000000oooo0?ooo`0:0?ooobH0o`00?`00o`0W0000oe@0
oooo=@00o`0o0?l001T0003oSP3oool005/0oooo00<000000?ooo`3oool02P3ooolX0?l003d00?l0
9P000?mE0?ooocD00?l0@@3o000E0000oi00oooo001K0?ooo`030000003oool0oooo00X0oooo:@3o
000l003o02D0003oEP3ooole003o0480o`004`000?nA0?ooo`00F`3oool00`000000oooo0?ooo`0:
0?ooob/0o`00>P00o`0S0000oeP0oooo=000o`140?l00140003oTP3oool005/0oooo00<000000?oo
o`3oool02`3oool[0?l003P00?l08`000?mJ0?oooc<00?l0AP3o000=0000oi@0oooo001K0?ooo`03
0000003oool0oooo00/0oooo;03o000g003o0280003oF`3ooolc003o04L0o`002`000?nE0?ooo`00
F`3oool00`000000oooo0?ooo`0;0?ooobh0o`00=@00o`0P0000oed0oooo<`00o`180?l000T0003o
UP3oool005/0oooo00<000000?ooo`3oool0303oool^0?l003<00?l080000?mO0?oooc400?l0B`3o
00050000oiP0oooo001K0?ooo`030000003oool0oooo00`0oooo<03o000a003o01h0003oH@3ooola
003o04`0o`000`000?nI0?ooo`00F`3oool00`000000oooo0?ooo`0<0?oooc40o`00<000o`0M0000
of80oooo<@00o`1=0?l009/0oooo001K0?ooo`030000003oool0oooo00d0oooo<@3o000^003o01d0
003oI03oool_003o04d0o`00W03oool005/0oooo00<000000?ooo`3oool03@3ooolc0?l002`00?l0
6`000?mV0?ooobl00?l0C03o002M0?ooo`00F`3oool00`000000oooo0?ooo`0=0?oooc@0o`00:`00
o`0J0000ofL0oooo;`00o`1:0?l009l0oooo001K0?ooo`030000003oool0oooo00h0oooo=03o000Y
003o01X0003oJ@3oool]003o04X0o`00X03oool005/0oooo00<000000?ooo`3oool03P3ooolf0?l0
02L00?l060000?m[0?ooobd00?l0B@3o002Q0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooocL0
o`009P00o`0G0000of`0oooo;@00o`170?l00:<0oooo001K0?ooo`030000003oool0oooo00l0oooo
>03o000S003o01H0003oK`3oool[003o04L0o`00Y03oool005/0oooo00<000000?ooo`3oool03`3o
ooli0?l002800?l05@000?m`0?ooob/00?l0A@3o002V0?ooo`00F`3oool00`000000oooo0?ooo`0?
0?ooocX0o`008@00o`0D0000og40oooo:`00o`140?l00:L0oooo001K0?ooo`030000003oool0oooo
0100oooo>`3o000N003o01<0003oM03ooolY003o04@0o`00Z03oool005/0oooo00<000000?ooo`3o
ool0403oooll0?l001d00?l04P000?me0?ooobT00?l0@P3o002Z0?ooo`00F`3oool00`000000oooo
0?ooo`0@0?ooocd0o`007000o`0A0000ogH0oooo:@00o`110?l00:/0oooo001K0?ooo`030000003o
ool0oooo0140oooo?P3o000I003o0100003oN@3ooolW003o0440o`00[03oool005/0oooo00<00000
0?ooo`3oool04@3ooolo0?l001P00?l03`000?mj0?ooobL00?l0?`3o002^0?ooo`00F`3oool00`00
0000oooo0?ooo`0A0?oood40o`005P00o`0=0000og`0oooo9`00o`0n0?l00:l0oooo001K0?ooo`03
0000003oool0oooo0180oooo@@3o000D003o00d0003oOP3ooolU003o03d0o`00/@3oool005/0oooo
00<000000?ooo`3oool04P3ooom20?l001<00?l030000?mo0?ooobD00?l0?03o002b0?ooo`00F`3o
ool00`000000oooo0?ooo`0B0?oood@0o`004@00o`0:0000oh40oooo9@00o`0k0?l00;<0oooo001K
0?ooo`030000003oool0oooo01<0ooooA03o000?003o00X0003oP`3ooolS003o03X0o`00]@3oool0
05/0oooo00<000000?ooo`3oool04`3ooom50?l000h00?l02@000?n40?ooob<00?l0>@3o002f0?oo
o`00F`3oool00`000000oooo0?ooo`0C0?ooodL0o`003000o`070000ohH0oooo8`00o`0h0?l00;L0
oooo001K0?ooo`030000003oool0oooo01@0ooooA`3o000:003o00L0003oR03ooolQ003o03L0o`00
^@3oool005/0oooo00<000000?ooo`3oool0503ooom90?l000P00?l01@000?n:0?ooob400?l0=P3o
002j0?ooo`00F`3oool00`000000oooo0?ooo`0D0?ooodX0o`001`00o`040000oh/0oooo8@00o`0d
0?l00;`0oooo001K0?ooo`030000003oool0oooo01D0ooooBP3o0005003o00@0003oS@3ooolO003o
03@0o`00_@3oool005/0oooo00<000000?ooo`3oool05@3ooom<0?l000<00?l00P000?n?0?oooal0
0?l0<`3o002n0?ooo`00F`3oool00`000000oooo0?ooo`0E0?ooodd0o`000P00o`000`000?l0oooo
0?ooo`2>0?oooal00?l0<@3o00300?ooo`00F`3oool00`000000oooo0?ooo`0F0?ooodd0o`00T`3o
oolM003o0340o`00`@3oool005/0oooo00<000000?ooo`3oool05P3ooom<0?l009@0oooo7@00o`0`
0?l00<80oooo001K0?ooo`030000003oool0oooo01H0ooooB`3o002E0?oooad00?l0;P3o00340?oo
o`00F`3oool00`000000oooo0?ooo`0G0?ooodP0o`00V03ooolK003o02h0o`00a@3oool005/0oooo
00<000000?ooo`3oool05`3ooom70?l009T0oooo6`00o`0/0?l00<L0oooo001K0?ooo`030000003o
ool0oooo01L0ooooAP3o002J0?oooa/00?l0:`3o00380?ooo`00F`3oool00`000000oooo0?ooo`0G
0?oood@0o`00W03ooolJ003o02/0o`00b@3oool005/0oooo00<000000?ooo`3oool0603ooom20?l0
09h0oooo6@00o`0Y0?l00</0oooo001K0?ooo`030000003oool0oooo01P0oooo@@3o002O0?oooaT0
0?l0:03o003<0?ooo`00F`3oool00`000000oooo0?ooo`0H0?ooocl0o`00X@3ooolI003o02H0o`00
cP3oool005/0oooo00<000000?ooo`3oool06@3ooolm0?l00:<0oooo5`00o`0V0?l00<l0oooo001K
0?ooo`030000003oool0oooo01T0oooo>`3o002U0?oooaL00?l09@3o003@0?ooo`00F`3oool00`00
0000oooo0?ooo`0I0?ooocX0o`00YP3ooolG003o02<0o`00dP3oool005/0oooo00<000000?ooo`3o
ool06P3ooolh0?l00:P0oooo5@00o`0S0?l00=<0oooo001K0?ooo`030000003oool0oooo01X0oooo
=P3o002Z0?oooaD00?l08P3o003D0?ooo`00F`3oool00`000000oooo0?ooo`0J0?ooocD0o`00Z`3o
oolE003o0200o`00eP3oool005/0oooo00<000000?ooo`3oool06`3ooolc0?l00:d0oooo4`00o`0P
0?l00=L0oooo001K0?ooo`030000003oool0oooo01/0oooo<@3o002_0?oooa<00?l07P3o003I0?oo
o`00F`3oool00`000000oooo0?ooo`0K0?oooc00o`00/03ooolC003o01d0o`00fP3oool005/0oooo
00<000000?ooo`3oool0703oool]0?l00;<0oooo4@00o`0M0?l00=/0oooo001K0?ooo`030000003o
ool0oooo01`0oooo;03o002d0?oooa400?l06`3o003M0?ooo`00F`3oool00`000000oooo0?ooo`0L
0?ooob/0o`00]@3ooolA003o01X0o`00gP3oool005/0oooo00<000000?ooo`3oool07@3ooolX0?l0
0;P0oooo3`00o`0J0?l00=l0oooo001K0?ooo`030000003oool0oooo01d0oooo9`3o002i0?ooo`l0
0?l0603o003Q0?ooo`00F`3oool00`000000oooo0?ooo`0M0?ooobH0o`00^P3oool?003o01L0o`00
hP3oool005/0oooo00<000000?ooo`3oool07P3ooolS0?l00;d0oooo3@00o`0F0?l00>@0oooo001K
0?ooo`030000003oool0oooo01h0oooo8P3o002n0?ooo`d00?l05@3o003U0?ooo`00F`3oool00`00
0000oooo0?ooo`0N0?ooob40o`00_`3oool=003o01@0o`00iP3oool005/0oooo00<000000?ooo`3o
ool07`3ooolN0?l00<80oooo2`00o`0C0?l00>P0oooo001K0?ooo`030000003oool0oooo01l0oooo
7@3o00330?ooo`/00?l04P3o003Y0?ooo`00F`3oool00`000000oooo0?ooo`0O0?oooa/0o`00a@3o
ool;003o0140o`00jP3oool005/0oooo00<000000?ooo`3oool0803ooolI0?l00<L0oooo2@00o`0@
0?l00>`0oooo001K0?ooo`030000003oool0oooo0200oooo603o00380?ooo`T00?l03`3o003]0?oo
o`00F`3oool00`000000oooo0?ooo`0P0?oooaH0o`00bP3oool9003o00d0o`00k`3oool005/0oooo
00<000000?ooo`3oool08@3ooolD0?l00<`0oooo1`00o`0=0?l00?00oooo001K0?ooo`030000003o
ool0oooo0240oooo4`3o003=0?ooo`L00?l0303o003a0?ooo`00F`3oool00`000000oooo0?ooo`0Q
0?oooa40o`00c`3oool7003o00X0o`00l`3oool005/0oooo00<000000?ooo`3oool08P3oool?0?l0
0=40oooo1@00o`0:0?l00?@0oooo001K0?ooo`030000003oool0oooo0280oooo3@3o003C0?ooo`D0
0?l02@3o003e0?ooo`00F`3oool00`000000oooo0?ooo`0R0?ooo``0o`00e03oool5003o00L0o`00
m`3oool005/0oooo00<000000?ooo`3oool08`3oool:0?l00=H0oooo0`00o`070?l00?P0oooo001K
0?ooo`030000003oool0oooo02<0oooo203o003H0?ooo`<00?l01@3o003j0?ooo`00F`3oool00`00
0000oooo0?ooo`0S0?ooo`L0o`00f@3oool3003o00@0o`00n`3oool005/0oooo00<000000?ooo`3o
ool0903oool50?l00=/0oooo00<00?l00?l0003o00000P3o003l0?ooo`00F`3oool00`000000oooo
0?ooo`0T0?ooo`<0o`00g@3oool00`00o`00o`000?l0003n0?ooo`00F`3oool00`000000oooo0?oo
o`0T0?ooo`80o`00gP3oool00`00o`00o`000?ooo`3n0?ooo`00F`3oool00`000000oooo0?ooo`3o
0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?ooo`L0oooo001K0?ooo`03
0000003oool0oooo0?l0ooooo`3oool70?ooo`00F`3oool00`000000oooo0?ooo`3o0?ooool0oooo
1`3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00;D0oooo0P00000L0?ooo`800000
703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000
703oool200000;`0oooo002d0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool0
00006P3oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001X0oooo00@00000
0?ooo`3oool000006P3oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001X0
oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00002k0?ooo`00]`3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0^@3oool00;D0
oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0
oooo0P00000L0?ooo`800000703oool200000;`0oooo002e0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`2k0?ooo`00]@3oool3000001/0oooo0`00
000K0?ooo`<000006`3oool3000001/0oooo0`00000K0?ooo`<000006`3oool3000001/0oooo0`00
000K0?ooo`<00000^`3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0
ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool0
0:/0oooo00<000000?ooo`3oool0o`3oool90?ooo`030000003oool0oooo0:X0oooo002Z0?ooo`03
0000003oool0oooo01X0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`03
0000003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`03
0000003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`03
0000003oool0oooo0:T0oooo002Z0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
8@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0:T0oooo002Z0?ooo`040000003o
ool0oooo0?ooo`@000000P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo
0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo
100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo
100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@000000P3oool400000080oooo
100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000103oool00`000000oooo
0?ooo`070?ooo`@000000P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo
0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo
100000020?ooo`@000000P3oool4000000<0oooo00<000000?ooo`3oool0Z@3oool00:T0oooo00<0
00000?ooo`3oool0o`3oool=0?ooo`030000003oool0oooo0:P0oooo002Z0?ooo`030000003oool0
oooo0?l0oooo2`3oool00`000000oooo0?ooo`2Y0?ooo`00ZP3oool00`000000oooo0?ooo`3o0?oo
o`/0oooo00<000000?ooo`3oool0Z@3oool00:/0oooo00<000000?ooo`3oool0o`3oool90?ooo`03
0000003oool0oooo0:X0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo
0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo
003o0?ooool0ooooI@3oool00:h0oooo100000070?ooo`<000001@3oool3000000d0oooo0`000005
0?ooo`<000003P3oool4000000L0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000?
0?ooo`800000203oool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000h0oooo10000007
0?ooo`<000001@3oool3000000d0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`000005
0?ooo`<00000[`3oool00:h0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool010000000oooo0?ooo`000008
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`2^
0?ooo`00[`3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`000000oooo0?ooo`0=0?oo
o`<000001@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?oo
o`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo00l0oooo00<000000?oo
o`3oool01`3oool3000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?oo
o`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`000000oooo0?ooo`0=0?oo
o`<000001@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?oo
o`030000003oool0oooo0:h0oooo002`0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3o
ool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool200000140oooo00<00000
0?ooo`3oool01`3oool010000000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?oo
o`0000030?ooo`8000004P3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo000000<0
oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000A0?ooo`030000003oool0oooo
00L0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3o
ool200000140oooo00<000000?ooo`3oool01`3oool010000000oooo0?ooo`0000030?ooo`800000
/03oool00:h0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00000D0?ooo`04
0000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00
000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool010000000
oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203o
ool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000203oool010000000oooo0?ooo`00002e0?ooo`00[`3oool2000000P0oooo100000050?oo
o`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?oo
o`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?oo
o`800000203oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<000000?oo
o`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo00`0oooo100000050?oo
o`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`2^0?oo
o`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00001\
\>"],
  ImageRangeCache->{{{0, 610.563}, {170.188, 0}} -> {-0.426205, -0.013998, \
0.00467178, 0.00467178}, {{91.1875, 295.063}, {167.188, 47.3125}} -> \
{-1.34175, -0.0239702, 0.00793648, 0.00793648}, {{315.438, 519.313}, \
{167.188, 47.3125}} -> {-3.12151, -0.0239702, 0.00793648, 0.00793648}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(2) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(3) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(2) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(5) show
135.000 39.000 moveto
(5) show
165.000 39.000 moveto
(5) show
195.000 39.000 moveto
(5) show
225.000 39.000 moveto
(5) show
255.000 39.000 moveto
(5) show
285.000 39.000 moveto
(5) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -9.21572e-018 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.61803 0 L
.5 .36327 L
F
0 0 1 r
.61803 0 m
1 0 L
.5 .36327 L
F
1 0 0 r
0 0 m
.5 .36327 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -1.19262e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.19098 .58779 m
0 0 L
.38197 0 L
F
0 0 1 r
.38197 0 m
1 0 L
.69098 .22451 L
F
1 0 0 r
.38197 0 m
.69098 .22451 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000Zb000`400?l00000o`00003oF`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?oo
o`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00D03ooooo00000<@00000
D03oool005/0oooo00<000000?l00000o`00N`00o`1=0000oaH0ooooC@00o`020?l007/0003oG@3o
ool005/0oooo00<000000?l0003o0000N`00o`1<0000oaL0ooooC@00o`030?l007T0003oGP3oool0
05/0oooo00<000000?l0003o00000P3o001i003o04X0003o6@3ooom=003o00D0o`00M@000?mP0?oo
o`00F`3oool00`000000oooo0?l000030?l007L00?l0BP000?lK0?oood/00?l01`3o001c0000of40
oooo001K0?ooo`030000003oool0o`0000@0o`00MP00o`190000oa`0ooooB`00o`080?l00740003o
HP3oool005/0oooo00<000000?ooo`3o00001P3o001d003o04L0003o7P3ooom;003o00X0o`00K@00
0?mT0?ooo`00F`3oool00`000000oooo0?ooo`070?l007800?l0A`000?lP0?ooodT00?l0303o001[
0000ofD0oooo001K0?ooo`030000003oool0oooo00T0o`00L000o`150000ob80ooooB@00o`0=0?l0
06T0003oIP3oool005/0oooo00<000000?ooo`3oool02P3o001_003o04@0003o8`3ooom9003o00l0
o`00I@000?mX0?ooo`00F`3oool010000000oooo0?ooo`3oool:0?l006d00?l0A0000?lU0?ooodL0
0?l04@3o001S0000ofT0oooo001K0?ooo`040000003oool0oooo0?ooo``0o`00J`00o`120000obL0
ooooA`00o`0C0?l005l0003oJ`3oool005/0oooo00@000000?ooo`3oool0oooo3@3o001Z003o0440
003o:03ooom7003o01@0o`00G@000?m/0?ooo`00F`3oool00`000000oooo0?ooo`020?ooo`d0o`00
J000o`110000obX0ooooA@00o`0F0?l005/0003oK@3oool005/0oooo00<000000?ooo`3oool00P3o
ool?0?l006H00?l0?`000?l/0?ooodD00?l0603o001G0000ofl0oooo001K0?ooo`030000003oool0
oooo0080oooo403o001U003o03h0003o;@3ooom5003o01T0o`00E@000?m`0?ooo`00F`3oool00`00
0000oooo0?ooo`030?oooa40o`00HP00o`0m0000oc00oooo@`00o`0K0?l005<0003oL@3oool005/0
oooo00<000000?ooo`3oool00`3ooolB0?l006400?l0?0000?la0?oood<00?l07@3o001?0000og<0
oooo001K0?ooo`030000003oool0oooo00<0oooo4`3o001P003o03/0003o<P3ooom3003o01h0o`00
C@000?md0?ooo`00F`3oool00`000000oooo0?ooo`040?oooa@0o`00G@00o`0j0000ocD0oooo@@00
o`0Q0?l004T0003oMP3oool005/0oooo00<000000?ooo`3oool0103ooolE0?l005`00?l0>@000?lf
0?oood400?l08P3o00170000ogL0oooo001K0?ooo`030000003oool0oooo00@0oooo5P3o001K003o
03P0003o=`3ooom1003o02<0o`00A@000?mh0?ooo`00F`3oool00`000000oooo0?ooo`050?oooaL0
o`00F000o`0g0000ocX0oooo?`00o`0V0?l00440003oNP3oool005/0oooo00<000000?ooo`3oool0
1@3ooolH0?l005L00?l0=P000?lk0?ooocl00?l09`3o000o0000og/0oooo001K0?ooo`030000003o
ool0oooo00D0oooo6P3o001E003o03@0003o?@3ooolo003o02P0o`00?@000?ml0?ooo`00F`3oool0
0`000000oooo0?ooo`060?oooaX0o`00D`00o`0d0000ocl0oooo?@00o`0[0?l003T0003oOP3oool0
05/0oooo00<000000?ooo`3oool01P3ooolK0?l005800?l0<`000?m00?ooocd00?l0;03o000g0000
ogl0oooo001K0?ooo`030000003oool0oooo00H0oooo7@3o001@003o0340003o@P3ooolm003o02d0
o`00=@000?n00?ooo`00F`3oool00`000000oooo0?ooo`070?oooad0o`00CP00o`0a0000od@0oooo
>`00o`0`0?l00340003oPP3oool005/0oooo00<000000?ooo`3oool01`3ooolN0?l004d00?l0<000
0?m50?oooc/00?l0<@3o000_0000oh<0oooo001K0?ooo`030000003oool0oooo00L0oooo803o001;
003o02h0003oA`3ooolk003o03<0o`00:`000?n50?ooo`00F`3oool00`000000oooo0?ooo`080?oo
ob00o`00B@00o`0^0000odT0oooo>@00o`0e0?l002T0003oQP3oool005/0oooo00<000000?ooo`3o
ool0203ooolR0?l004L00?l0;0000?m;0?ooocT00?l0=P3o000W0000ohL0oooo001K0?ooo`030000
003oool0oooo00P0oooo8`3o0016003o02/0003oC03oooli003o03P0o`008`000?n90?ooo`00F`3o
ool00`000000oooo0?ooo`090?ooob<0o`00A000o`0[0000odh0oooo=`00o`0j0?l00240003oRP3o
ool005/0oooo00<000000?ooo`3oool02@3ooolU0?l004800?l0:@000?m@0?ooocL00?l0>`3o000O
0000oh/0oooo001K0?ooo`030000003oool0oooo00T0oooo9P3o0011003o02P0003oD@3ooolg003o
03d0o`006`000?n=0?ooo`00F`3oool00`000000oooo0?ooo`0:0?ooobH0o`00?`00o`0W0000oe@0
oooo=@00o`0o0?l001T0003oSP3oool005/0oooo00<000000?ooo`3oool02P3ooolX0?l003d00?l0
9P000?mE0?ooocD00?l0@@3o000E0000oi00oooo001K0?ooo`030000003oool0oooo00X0oooo:@3o
000l003o02D0003oEP3ooole003o0480o`004`000?nA0?ooo`00F`3oool00`000000oooo0?ooo`0:
0?ooob/0o`00>P00o`0S0000oeP0oooo=000o`140?l00140003oTP3oool005/0oooo00<000000?oo
o`3oool02`3oool[0?l003P00?l08`000?mJ0?oooc<00?l0AP3o000=0000oi@0oooo001K0?ooo`03
0000003oool0oooo00/0oooo;03o000g003o0280003oF`3ooolc003o04L0o`002`000?nE0?ooo`00
F`3oool00`000000oooo0?ooo`0;0?ooobh0o`00=@00o`0P0000oed0oooo<`00o`180?l000T0003o
UP3oool005/0oooo00<000000?ooo`3oool0303oool^0?l003<00?l080000?mO0?oooc400?l0B`3o
00050000oiP0oooo001K0?ooo`030000003oool0oooo00`0oooo<03o000a003o01h0003oH@3ooola
003o04`0o`000`000?nI0?ooo`00F`3oool00`000000oooo0?ooo`0<0?oooc40o`00<000o`0M0000
of80oooo<@00o`1=0?l009/0oooo001K0?ooo`030000003oool0oooo00d0oooo<@3o000^003o01d0
003oI03oool_003o04d0o`00W03oool005/0oooo00<000000?ooo`3oool03@3ooolc0?l002`00?l0
6`000?mV0?ooobl00?l0C03o002M0?ooo`00F`3oool00`000000oooo0?ooo`0=0?oooc@0o`00:`00
o`0J0000ofL0oooo;`00o`1:0?l009l0oooo001K0?ooo`030000003oool0oooo00h0oooo=03o000Y
003o01X0003oJ@3oool]003o04X0o`00X03oool005/0oooo00<000000?ooo`3oool03P3ooolf0?l0
02L00?l060000?m[0?ooobd00?l0B@3o002Q0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooocL0
o`009P00o`0G0000of`0oooo;@00o`170?l00:<0oooo001K0?ooo`030000003oool0oooo00l0oooo
>03o000S003o01H0003oK`3oool[003o04L0o`00Y03oool005/0oooo00<000000?ooo`3oool03`3o
ooli0?l002800?l05@000?m`0?ooob/00?l0A@3o002V0?ooo`00F`3oool00`000000oooo0?ooo`0?
0?ooocX0o`008@00o`0D0000og40oooo:`00o`140?l00:L0oooo001K0?ooo`030000003oool0oooo
0100oooo>`3o000N003o01<0003oM03ooolY003o04@0o`00Z03oool005/0oooo00<000000?ooo`3o
ool0403oooll0?l001d00?l04P000?me0?ooobT00?l0@P3o002Z0?ooo`00F`3oool00`000000oooo
0?ooo`0@0?ooocd0o`007000o`0A0000ogH0oooo:@00o`110?l00:/0oooo001K0?ooo`030000003o
ool0oooo0140oooo?P3o000I003o0100003oN@3ooolW003o0440o`00[03oool005/0oooo00<00000
0?ooo`3oool04@3ooolo0?l001P00?l03`000?mj0?ooobL00?l0?`3o002^0?ooo`00F`3oool00`00
0000oooo0?ooo`0A0?oood40o`005P00o`0=0000og`0oooo9`00o`0n0?l00:l0oooo001K0?ooo`03
0000003oool0oooo0180oooo@@3o000D003o00d0003oOP3ooolU003o03d0o`00/@3oool005/0oooo
00<000000?ooo`3oool04P3ooom20?l001<00?l030000?mo0?ooobD00?l0?03o002b0?ooo`00F`3o
ool00`000000oooo0?ooo`0B0?oood@0o`004@00o`0:0000oh40oooo9@00o`0k0?l00;<0oooo001K
0?ooo`030000003oool0oooo01<0ooooA03o000?003o00X0003oP`3ooolS003o03X0o`00]@3oool0
05/0oooo00<000000?ooo`3oool04`3ooom50?l000h00?l02@000?n40?ooob<00?l0>@3o002f0?oo
o`00F`3oool00`000000oooo0?ooo`0C0?ooodL0o`003000o`070000ohH0oooo8`00o`0h0?l00;L0
oooo001K0?ooo`030000003oool0oooo01@0ooooA`3o000:003o00L0003oR03ooolQ003o03L0o`00
^@3oool005/0oooo00<000000?ooo`3oool0503ooom90?l000P00?l01@000?n:0?ooob400?l0=P3o
002j0?ooo`00F`3oool00`000000oooo0?ooo`0D0?ooodX0o`001`00o`040000oh/0oooo8@00o`0d
0?l00;`0oooo001K0?ooo`030000003oool0oooo01D0ooooBP3o0005003o00@0003oS@3ooolO003o
03@0o`00_@3oool005/0oooo00<000000?ooo`3oool05@3ooom<0?l000<00?l00P000?n?0?oooal0
0?l0<`3o002n0?ooo`00F`3oool00`000000oooo0?ooo`0E0?ooodd0o`000P00o`000`000?l0oooo
0?ooo`2>0?oooal00?l0<@3o00300?ooo`00F`3oool00`000000oooo0?ooo`0F0?ooodd0o`00T`3o
oolM003o0340o`00`@3oool005/0oooo00<000000?ooo`3oool05P3ooom<0?l009@0oooo7@00o`0`
0?l00<80oooo001K0?ooo`030000003oool0oooo01H0ooooB`3o002E0?oooad00?l0;P3o00340?oo
o`00F`3oool00`000000oooo0?ooo`0G0?ooodP0o`00V03ooolK003o02h0o`00a@3oool005/0oooo
00<000000?ooo`3oool05`3ooom70?l009T0oooo6`00o`0/0?l00<L0oooo001K0?ooo`030000003o
ool0oooo01L0ooooAP3o002J0?oooa/00?l0:`3o00380?ooo`00F`3oool00`000000oooo0?ooo`0G
0?oood@0o`00W03ooolJ003o02/0o`00b@3oool005/0oooo00<000000?ooo`3oool0603ooom20?l0
09h0oooo6@00o`0Y0?l00</0oooo001K0?ooo`030000003oool0oooo01P0oooo@@3o002O0?oooaT0
0?l0:03o003<0?ooo`00F`3oool00`000000oooo0?ooo`0H0?ooocl0o`00X@3ooolI003o02H0o`00
cP3oool005/0oooo00<000000?ooo`3oool06@3ooolm0?l00:<0oooo5`00o`0V0?l00<l0oooo001K
0?ooo`030000003oool0oooo01T0oooo>`3o002U0?oooaL00?l09@3o003@0?ooo`00F`3oool00`00
0000oooo0?ooo`0I0?ooocX0o`00YP3ooolG003o02<0o`00dP3oool005/0oooo00<000000?ooo`3o
ool06P3ooolh0?l00:P0oooo5@00o`0S0?l00=<0oooo001K0?ooo`030000003oool0oooo01X0oooo
=P3o002Z0?oooaD00?l08P3o003D0?ooo`00F`3oool00`000000oooo0?ooo`0J0?ooocD0o`00Z`3o
oolE003o0200o`00eP3oool005/0oooo00<000000?ooo`3oool06`3ooolc0?l00:d0oooo4`00o`0P
0?l00=L0oooo001K0?ooo`030000003oool0oooo01/0oooo<@3o002_0?oooa<00?l07P3o003I0?oo
o`00F`3oool00`000000oooo0?ooo`0K0?oooc00o`00/03ooolC003o01d0o`00fP3oool005/0oooo
00<000000?ooo`3oool0703oool]0?l00;<0oooo4@00o`0M0?l00=/0oooo001K0?ooo`030000003o
ool0oooo01`0oooo;03o002d0?oooa400?l06`3o003M0?ooo`00F`3oool00`000000oooo0?ooo`0L
0?ooob/0o`00]@3ooolA003o01X0o`00gP3oool005/0oooo00<000000?ooo`3oool07@3ooolX0?l0
0;P0oooo3`00o`0J0?l00=l0oooo001K0?ooo`030000003oool0oooo01d0oooo9`3o002i0?ooo`l0
0?l0603o003Q0?ooo`00F`3oool00`000000oooo0?ooo`0M0?ooobH0o`00^P3oool?003o01L0o`00
hP3oool005/0oooo00<000000?ooo`3oool07P3ooolS0?l00;d0oooo3@00o`0F0?l00>@0oooo001K
0?ooo`030000003oool0oooo01h0oooo8P3o002n0?ooo`d00?l05@3o003U0?ooo`00F`3oool00`00
0000oooo0?ooo`0N0?ooob40o`00_`3oool=003o01@0o`00iP3oool005/0oooo00<000000?ooo`3o
ool07`3ooolN0?l00<80oooo2`00o`0C0?l00>P0oooo001K0?ooo`030000003oool0oooo01l0oooo
7@3o00330?ooo`/00?l04P3o003Y0?ooo`00F`3oool00`000000oooo0?ooo`0O0?oooa/0o`00a@3o
ool;003o0140o`00jP3oool005/0oooo00<000000?ooo`3oool0803ooolI0?l00<L0oooo2@00o`0@
0?l00>`0oooo001K0?ooo`030000003oool0oooo0200oooo603o00380?ooo`T00?l03`3o003]0?oo
o`00F`3oool00`000000oooo0?ooo`0P0?oooaH0o`00bP3oool9003o00d0o`00k`3oool005/0oooo
00<000000?ooo`3oool08@3ooolD0?l00<`0oooo1`00o`0=0?l00?00oooo001K0?ooo`030000003o
ool0oooo0240oooo4`3o003=0?ooo`L00?l0303o003a0?ooo`00F`3oool00`000000oooo0?ooo`0Q
0?oooa40o`00c`3oool7003o00X0o`00l`3oool005/0oooo00<000000?ooo`3oool08P3oool?0?l0
0=40oooo1@00o`0:0?l00?@0oooo001K0?ooo`030000003oool0oooo0280oooo3@3o003C0?ooo`D0
0?l02@3o003e0?ooo`00F`3oool00`000000oooo0?ooo`0R0?ooo``0o`00e03oool5003o00L0o`00
m`3oool005/0oooo00<000000?ooo`3oool08`3oool:0?l00=H0oooo0`00o`070?l00?P0oooo001K
0?ooo`030000003oool0oooo02<0oooo203o003H0?ooo`<00?l01@3o003j0?ooo`00F`3oool00`00
0000oooo0?ooo`0S0?ooo`L0o`00f@3oool3003o00@0o`00n`3oool005/0oooo00<000000?ooo`3o
ool0903oool50?l00=/0oooo00<00?l00?l0003o00000P3o003l0?ooo`00F`3oool00`000000oooo
0?ooo`0T0?ooo`<0o`00g@3oool00`00o`00o`000?l0003n0?ooo`00F`3oool00`000000oooo0?oo
o`0T0?ooo`80o`00gP3oool00`00o`00o`000?ooo`3n0?ooo`00F`3oool00`000000oooo0?ooo`3o
0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?ooo`L0oooo001K0?ooo`03
0000003oool0oooo0?l0ooooo`3oool70?ooo`00F`3oool00`000000oooo0?ooo`3o0?ooool0oooo
1`3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00;D0oooo0P00000L0?ooo`800000
703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000
703oool200000;`0oooo002d0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool0
00006P3oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001X0oooo00@00000
0?ooo`3oool000006P3oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001X0
oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00002k0?ooo`00]`3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0^@3oool00;D0
oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0
oooo0P00000L0?ooo`800000703oool200000;`0oooo002e0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`2k0?ooo`00]@3oool3000001/0oooo0`00
000K0?ooo`<000006`3oool3000001/0oooo0`00000K0?ooo`<000006`3oool3000001/0oooo0`00
000K0?ooo`<00000^`3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0
ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool0
0:/0oooo00<000000?ooo`3oool0o`3oool90?ooo`030000003oool0oooo0:X0oooo002Z0?ooo`03
0000003oool0oooo01X0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`03
0000003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`03
0000003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`03
0000003oool0oooo0:T0oooo002Z0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
8@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0:T0oooo002Z0?ooo`040000003o
ool0oooo0?ooo`@000000P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo
0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo
100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo
100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@000000P3oool400000080oooo
100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000103oool00`000000oooo
0?ooo`070?ooo`@000000P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo
0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo
100000020?ooo`@000000P3oool4000000<0oooo00<000000?ooo`3oool0Z@3oool00:T0oooo00<0
00000?ooo`3oool0o`3oool=0?ooo`030000003oool0oooo0:P0oooo002Z0?ooo`030000003oool0
oooo0?l0oooo2`3oool00`000000oooo0?ooo`2Y0?ooo`00ZP3oool00`000000oooo0?ooo`3o0?oo
o`/0oooo00<000000?ooo`3oool0Z@3oool00:/0oooo00<000000?ooo`3oool0o`3oool90?ooo`03
0000003oool0oooo0:X0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo
0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo
003o0?ooool0ooooI@3oool00:h0oooo100000070?ooo`<000001@3oool3000000d0oooo0`000005
0?ooo`<000003P3oool4000000L0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000?
0?ooo`800000203oool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000h0oooo10000007
0?ooo`<000001@3oool3000000d0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`000005
0?ooo`<00000[`3oool00:h0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool010000000oooo0?ooo`000008
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`2^
0?ooo`00[`3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`000000oooo0?ooo`0=0?oo
o`<000001@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?oo
o`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo00l0oooo00<000000?oo
o`3oool01`3oool3000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?oo
o`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`000000oooo0?ooo`0=0?oo
o`<000001@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?oo
o`030000003oool0oooo0:h0oooo002`0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3o
ool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool200000140oooo00<00000
0?ooo`3oool01`3oool010000000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?oo
o`0000030?ooo`8000004P3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo000000<0
oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000A0?ooo`030000003oool0oooo
00L0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3o
ool200000140oooo00<000000?ooo`3oool01`3oool010000000oooo0?ooo`0000030?ooo`800000
/03oool00:h0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00000D0?ooo`04
0000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00
000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool010000000
oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203o
ool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000203oool010000000oooo0?ooo`00002e0?ooo`00[`3oool2000000P0oooo100000050?oo
o`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?oo
o`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?oo
o`800000203oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<000000?oo
o`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo00`0oooo100000050?oo
o`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`2^0?oo
o`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00001\
\>"],
  ImageRangeCache->{{{0, 610.563}, {170.188, 0}} -> {-0.426205, -0.013998, \
0.00467178, 0.00467178}, {{91.1875, 295.063}, {167.188, 47.3125}} -> \
{-1.34175, -0.0239702, 0.00793648, 0.00793648}, {{315.438, 519.313}, \
{167.188, 47.3125}} -> {-3.12151, -0.0239702, 0.00793648, 0.00793648}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(3) show
117.000 12.750 moveto
(Pi) show
141.000 12.750 moveto
(3) show
153.000 12.750 moveto
(Pi) show
177.000 12.750 moveto
(Pi) show
201.000 12.750 moveto
(3) show
213.000 12.750 moveto
(Pi) show
237.000 12.750 moveto
(Pi) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
(--) show
129.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
141.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
153.000 25.875 moveto
(--) show
165.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
177.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
189.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
201.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
213.000 25.875 moveto
(--) show
225.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
237.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
249.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
261.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
111.000 39.000 moveto
(10) show
147.000 39.000 moveto
(10) show
177.000 39.000 moveto
(5) show
207.000 39.000 moveto
(5) show
237.000 39.000 moveto
(5) show
261.000 39.000 moveto
(2) show
285.000 39.000 moveto
(10) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.618034 0.381966 1.68322e-017 0.381966 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.5 0 L
.34549 .47553 L
F
0 0 1 r
.5 0 m
1 0 L
.34549 .47553 L
F
1 0 0 r
0 0 m
.34549 .47553 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.618034 0.381966 1.71575e-017 0.381966 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.19098 .58779 m
0 0 L
.61803 0 L
F
0 0 1 r
.61803 0 m
1 0 L
.80902 .13876 L
F
1 0 0 r
.61803 0 m
.80902 .13876 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000Zb000`400?l00000o`00003oF`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?oo
o`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00D03ooooo00000<@00000
D03oool005/0oooo00<00000003o0000o`00H`00o`1U0000oaH0ooooO@00o`020?l004/0003oG@3o
ool005/0oooo00<000000?l00000o`00H`00o`1T0000oaL0ooooO000o`040?l004T0003oGP3oool0
05/0oooo00<000000?l0003o0000H`00o`1R0000oaT0ooooN`00o`070?l004D0003oH03oool005/0
oooo00<000000?ooo`3o0000HP00o`1R0000oa/0ooooNP00o`080?l004<0003oH@3oool005/0oooo
00@000000?ooo`3o0000o`00H@00o`1Q0000oa`0ooooN@00o`0:0?l00440003oHP3oool005/0oooo
00<000000?ooo`3o00000P3o001P003o05l0003o7P3ooomh003o00d0o`00?@000?mT0?ooo`00F`3o
ool00`000000oooo0?ooo`030?l005h00?l0G`000?lP0?ooogH00?l03`3o000k0000ofD0oooo001K
0?ooo`030000003oool0oooo00<0o`00GP00o`1M0000ob80ooooMP00o`0@0?l003T0003oIP3oool0
05/0oooo00<000000?ooo`3oool0103o001M003o05`0003o8`3ooome003o01<0o`00=@000?mX0?oo
o`00F`3oool010000000oooo0?ooo`3oool40?l005/00?l0G0000?lU0?ooog<00?l05@3o000c0000
ofT0oooo001K0?ooo`040000003oool0oooo0?ooo`@0o`00F`00o`1J0000obL0ooooL`00o`0F0?l0
0340003oJP3oool005/0oooo00@000000?ooo`3oool0oooo1@3o001J003o05T0003o:03ooomb003o
01T0o`00;@000?m/0?ooo`00F`3oool00`000000oooo0?ooo`020?ooo`D0o`00F000o`1I0000obX0
ooooL000o`0K0?l002/0003oK@3oool005/0oooo00<000000?ooo`3oool00P3oool60?l005L00?l0
E`000?l/0?ooofl00?l07@3o000Y0000ofh0oooo001K0?ooo`030000003oool0oooo0080oooo1P3o
001G003o05H0003o;@3ooom_003o01l0o`009@000?m`0?ooo`00F`3oool00`000000oooo0?ooo`03
0?ooo`H0o`00E@00o`1E0000oc00ooooK@00o`0Q0?l002<0003oL@3oool005/0oooo00<000000?oo
o`3oool00`3oool70?l005@00?l0E0000?la0?ooof`00?l08`3o000Q0000og80oooo001K0?ooo`03
0000003oool0oooo00<0oooo1`3o001D003o05<0003o<P3ooom[003o02H0o`007@000?md0?ooo`00
F`3oool00`000000oooo0?ooo`040?ooo`L0o`00DP00o`1B0000ocD0ooooJP00o`0W0?l001/0003o
M@3oool005/0oooo00<000000?ooo`3oool0103oool80?l005400?l0D@000?lf0?ooofT00?l0:@3o
000I0000ogH0oooo001K0?ooo`030000003oool0oooo00@0oooo2@3o001@003o04l0003o>03ooomX
003o02`0o`005@000?mh0?ooo`00F`3oool00`000000oooo0?ooo`050?ooo`P0o`00C`00o`1?0000
ocX0ooooI`00o`0]0?l001<0003oN@3oool005/0oooo00<000000?ooo`3oool01@3oool90?l004h0
0?l0CP000?lk0?ooofH00?l0;`3o000A0000ogX0oooo001K0?ooo`030000003oool0oooo00D0oooo
2P3o001=003o04`0003o?@3ooomU003o0380o`003@000?ml0?ooo`00F`3oool00`000000oooo0?oo
o`060?ooo`X0o`00B`00o`1<0000ocl0ooooH`00o`0d0?l000/0003oO@3oool005/0oooo00<00000
0?ooo`3oool01P3oool:0?l004/00?l0B`000?m00?ooof<00?l0=@3o00090000ogh0oooo001K0?oo
o`030000003oool0oooo00H0oooo2`3o001:003o04T0003o@P3ooomR003o03P0o`001@000?n00?oo
o`00F`3oool00`000000oooo0?ooo`070?ooo`/0o`00B000o`190000od@0ooooH000o`0j0?l000<0
003oP@3oool005/0oooo00<000000?ooo`3oool01`3oool;0?l004P00?l0A`000?m60?oooel00?l0
?03o00230?ooo`00F`3oool00`000000oooo0?ooo`070?ooo``0o`00A`00o`160000odL0ooooG`00
o`0k0?l008@0oooo001K0?ooo`030000003oool0oooo00P0oooo303o0015003o04H0003oB@3ooomM
003o03/0o`00Q@3oool005/0oooo00<000000?ooo`3oool0203oool=0?l004@00?l0A0000?m;0?oo
oe`00?l0>P3o00270?ooo`00F`3oool00`000000oooo0?ooo`080?ooo`d0o`00A000o`130000od`0
ooooG000o`0i0?l008P0oooo001K0?ooo`030000003oool0oooo00T0oooo3@3o0012003o04<0003o
CP3ooomJ003o03T0o`00R@3oool005/0oooo00<000000?ooo`3oool02@3oool>0?l004400?l0@@00
0?m@0?oooeT00?l0>03o002;0?ooo`00F`3oool00`000000oooo0?ooo`090?ooo`h0o`00@@00o`10
0000oe40ooooF000o`0h0?l008`0oooo001K0?ooo`030000003oool0oooo00X0oooo3P3o000o003o
03l0003oE03ooomG003o03H0o`00SP3oool005/0oooo00<000000?ooo`3oool02P3oool?0?l003h0
0?l0?P000?mE0?oooeH00?l0=P3o002?0?ooo`00F`3oool00`000000oooo0?ooo`0:0?oooa00o`00
?@00o`0m0000oeH0ooooE@00o`0f0?l00900oooo001K0?ooo`030000003oool0oooo00X0oooo403o
000l003o03`0003oF03ooomD003o03D0o`00TP3oool005/0oooo00<000000?ooo`3oool02`3oool@
0?l003/00?l0>`000?mJ0?oooe<00?l0=03o002C0?ooo`00F`3oool00`000000oooo0?ooo`0;0?oo
oa40o`00>P00o`0i0000oe`0ooooDP00o`0c0?l009D0oooo001K0?ooo`030000003oool0oooo00/0
oooo4P3o000h003o03T0003oG@3ooomA003o03<0o`00UP3oool005/0oooo00<000000?ooo`3oool0
303ooolA0?l003P00?l0>0000?mO0?oooe000?l0<P3o002G0?ooo`00F`3oool00`000000oooo0?oo
o`0<0?oooa80o`00=`00o`0f0000of40ooooC`00o`0a0?l009T0oooo001K0?ooo`030000003oool0
oooo00`0oooo4`3o000e003o03H0003oHP3ooom>003o0340o`00VP3oool005/0oooo00<000000?oo
o`3oool03@3ooolB0?l003D00?l0=@000?mT0?oood`00?l0<@3o002K0?ooo`00F`3oool00`000000
oooo0?ooo`0=0?oooa<0o`00=000o`0c0000ofH0ooooC000o`0_0?l009d0oooo001K0?ooo`030000
003oool0oooo00d0oooo503o000b003o03<0003oI`3ooom;003o02l0o`00WP3oool005/0oooo00<0
00000?ooo`3oool03P3ooolD0?l003400?l0<@000?mZ0?ooodT00?l0;P3o002P0?ooo`00F`3oool0
0`000000oooo0?ooo`0>0?oooa@0o`00<@00o`0`0000of/0ooooB@00o`0]0?l00:40oooo001K0?oo
o`030000003oool0oooo00h0oooo5@3o000_003o0300003oK03ooom8003o02d0o`00XP3oool005/0
oooo00<000000?ooo`3oool03`3ooolE0?l002h00?l0;P000?m_0?ooodH00?l0;03o002T0?ooo`00
F`3oool00`000000oooo0?ooo`0?0?oooaD0o`00;P00o`0]0000og00ooooA@00o`0/0?l00:D0oooo
001K0?ooo`030000003oool0oooo00l0oooo5P3o000/003o02d0003oL@3ooom5003o02X0o`00Y`3o
ool005/0oooo00<000000?ooo`3oool0403ooolF0?l002/00?l0:`000?md0?oood<00?l0:P3o002X
0?ooo`00F`3oool00`000000oooo0?ooo`0@0?oooaL0o`00:P00o`0Z0000ogD0oooo@P00o`0Z0?l0
0:T0oooo001K0?ooo`030000003oool0oooo0100oooo5`3o000Y003o02T0003oM`3ooom1003o02T0
o`00Z`3oool005/0oooo00<000000?ooo`3oool04@3ooolG0?l002P00?l0:0000?mi0?oood000?l0
:03o002/0?ooo`00F`3oool00`000000oooo0?ooo`0A0?oooaP0o`009`00o`0W0000ogX0oooo?`00
o`0X0?l00:d0oooo001K0?ooo`030000003oool0oooo0140oooo6@3o000U003o02H0003oO03oooln
003o02L0o`00[`3oool005/0oooo00<000000?ooo`3oool04P3ooolH0?l002D00?l09@000?mn0?oo
ocd00?l09P3o002`0?ooo`00F`3oool00`000000oooo0?ooo`0B0?oooaT0o`009000o`0S0000oh00
oooo?000o`0U0?l00;80oooo001K0?ooo`030000003oool0oooo0180oooo6P3o000R003o02<0003o
P@3ooolk003o02D0o`00/`3oool005/0oooo00<000000?ooo`3oool04`3ooolI0?l002800?l08P00
0?n30?ooocT00?l09@3o002d0?ooo`00F`3oool00`000000oooo0?ooo`0C0?oooaX0o`008@00o`0P
0000ohD0oooo>@00o`0S0?l00;H0oooo001K0?ooo`030000003oool0oooo01<0oooo6`3o000O003o
0200003oQP3ooolh003o02<0o`00]`3oool005/0oooo00<000000?ooo`3oool0503ooolK0?l001h0
0?l07`000?n80?ooocH00?l08P3o002i0?ooo`00F`3oool00`000000oooo0?ooo`0D0?oooa/0o`00
7P00o`0M0000ohX0oooo=@00o`0R0?l00;X0oooo001K0?ooo`030000003oool0oooo01@0oooo703o
000L003o01d0003oR`3ooole003o0240o`00^`3oool005/0oooo00<000000?ooo`3oool05@3ooolL
0?l001/00?l06`000?n>0?oooc<00?l0803o002m0?ooo`00F`3oool00`000000oooo0?ooo`0E0?oo
oa`0o`006`00o`0J0000ohl0oooo<P00o`0P0?l00;h0oooo001K0?ooo`030000003oool0oooo01D0
oooo7@3o000I003o01X0003oT03ooolb003o01l0o`00_`3oool005/0oooo00<000000?ooo`3oool0
5P3ooolM0?l001P00?l060000?nC0?oooc000?l07P3o00310?ooo`00F`3oool00`000000oooo0?oo
o`0F0?oooah0o`005`00o`0G0000oi@0oooo;`00o`0N0?l00<80oooo001K0?ooo`030000003oool0
oooo01H0oooo7P3o000F003o01L0003oU@3oool^003o01d0o`00a03oool005/0oooo00<000000?oo
o`3oool05`3ooolN0?l001D00?l05@000?nH0?ooobd00?l0703o00350?ooo`00F`3oool00`000000
oooo0?ooo`0G0?oooal0o`005000o`0D0000oiT0oooo;000o`0L0?l00<H0oooo001K0?ooo`030000
003oool0oooo01L0oooo803o000B003o01<0003oV`3oool[003o01/0o`00b03oool005/0oooo00<0
00000?ooo`3oool05`3ooolP0?l001800?l04P000?nL0?ooobX00?l06`3o00390?ooo`00F`3oool0
0`000000oooo0?ooo`0H0?ooob00o`004@00o`0A0000oih0oooo:@00o`0I0?l00</0oooo001K0?oo
o`030000003oool0oooo01P0oooo8@3o000?003o0100003oX03ooolX003o01T0o`00c03oool005/0
oooo00<000000?ooo`3oool0603ooolQ0?l000l00?l03`000?nQ0?ooobL00?l06@3o003=0?ooo`00
F`3oool00`000000oooo0?ooo`0I0?ooob40o`003P00o`0=0000oj@0oooo9P00o`0G0?l00<l0oooo
001K0?ooo`030000003oool0oooo01T0oooo8P3o000<003o00d0003oY@3ooolU003o01L0o`00d03o
ool005/0oooo00<000000?ooo`3oool06@3ooolS0?l000/00?l030000?nV0?ooob@00?l05`3o003A
0?ooo`00F`3oool00`000000oooo0?ooo`0J0?ooob80o`002`00o`0:0000ojT0oooo8P00o`0F0?l0
0=<0oooo001K0?ooo`030000003oool0oooo01X0oooo8`3o0009003o00X0003oZP3ooolR003o01D0
o`00e03oool005/0oooo00<000000?ooo`3oool06P3ooolT0?l000P00?l02@000?n[0?ooob400?l0
503o003F0?ooo`00F`3oool00`000000oooo0?ooo`0K0?ooob<0o`002000o`070000ojh0oooo7`00
o`0D0?l00=L0oooo001K0?ooo`030000003oool0oooo01/0oooo903o0006003o00L0003o[`3ooolO
003o01<0o`00f03oool005/0oooo00<000000?ooo`3oool06`3ooolU0?l000D00?l01@000?na0?oo
oah00?l04P3o003J0?ooo`00F`3oool00`000000oooo0?ooo`0L0?ooobD0o`001000o`040000ok<0
oooo7000o`0B0?l00=/0oooo001K0?ooo`030000003oool0oooo01`0oooo9@3o0003003o00@0003o
]03ooolK003o0140o`00g@3oool005/0oooo00<000000?ooo`3oool0703ooolV0?l000800?l00P00
0?nf0?oooa/00?l0403o003N0?ooo`00F`3oool00`000000oooo0?ooo`0M0?ooobH0o`0000<00?l0
0000o`3oool0]`3ooolI003o0100o`00g`3oool005/0oooo00<000000?ooo`3oool07@3ooolV0?l0
0;X0oooo6000o`0?0?l00>40oooo001K0?ooo`030000003oool0oooo01d0oooo9@3o002k0?oooaL0
0?l03`3o003R0?ooo`00F`3oool00`000000oooo0?ooo`0N0?ooob<0o`00_@3ooolF003o00h0o`00
h`3oool005/0oooo00<000000?ooo`3oool07P3ooolQ0?l00;l0oooo5@00o`0=0?l00>D0oooo001K
0?ooo`030000003oool0oooo01h0oooo803o00300?oooa@00?l03@3o003V0?ooo`00F`3oool00`00
0000oooo0?ooo`0O0?oooah0o`00`P3ooolC003o00/0o`00j03oool005/0oooo00<000000?ooo`3o
ool07`3ooolL0?l00<@0oooo4P00o`0;0?l00>T0oooo001K0?ooo`030000003oool0oooo01l0oooo
6`3o00350?oooa400?l02`3o003Z0?ooo`00F`3oool00`000000oooo0?ooo`0P0?oooaT0o`00a`3o
ool?003o00X0o`00k03oool005/0oooo00<000000?ooo`3oool0803ooolG0?l00<T0oooo3`00o`09
0?l00>d0oooo001K0?ooo`030000003oool0oooo0200oooo5P3o003:0?ooo`h00?l0203o003_0?oo
o`00F`3oool00`000000oooo0?ooo`0Q0?oooa@0o`00c03oool<003o00P0o`00l03oool005/0oooo
00<000000?ooo`3oool08@3ooolB0?l00<h0oooo2`00o`080?l00?40oooo001K0?ooo`030000003o
ool0oooo0240oooo4@3o003?0?ooo`/00?l01P3o003c0?ooo`00F`3oool00`000000oooo0?ooo`0R
0?ooo`l0o`00d@3oool9003o00H0o`00m03oool005/0oooo00<000000?ooo`3oool08P3oool=0?l0
0=<0oooo2000o`060?l00?D0oooo001K0?ooo`030000003oool0oooo0280oooo303o003D0?ooo`P0
0?l0103o003g0?ooo`00F`3oool00`000000oooo0?ooo`0S0?ooo`X0o`00eP3oool6003o00@0o`00
n03oool005/0oooo00<000000?ooo`3oool08`3oool80?l00=P0oooo1@00o`030?l00?X0oooo001K
0?ooo`030000003oool0oooo02<0oooo1`3o003I0?ooo`@00?l00`3o003k0?ooo`00F`3oool00`00
0000oooo0?ooo`0T0?ooo`D0o`00f`3oool3003o0080o`00o03oool005/0oooo00<000000?ooo`3o
ool0903oool30?l00=d0oooo0P00o`000`3o0000oooo0?ooo`3l0?ooo`00F`3oool00`000000oooo
0?ooo`0T0?ooo`80o`00gP3oool00`00o`00o`000?ooo`3n0?ooo`00F`3oool00`000000oooo0?oo
o`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?ooo`L0oooo001K0?oo
o`030000003oool0oooo0?l0ooooo`3oool70?ooo`00F`3oool00`000000oooo0?ooo`3o0?ooool0
oooo1`3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool0
0?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3o
oomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00;D0oooo0P00000Q0?ooo`D0
00000P3oool2000001/0oooo1@0000020?ooo`8000005P3oool2000001`0oooo0P00000L0?ooo`80
00005@3oool4000001@0oooo1@0000020?ooo`8000005P3oool200000;`0oooo002d0?ooo`040000
003oool0oooo00000280oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo
01X0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo0180oooo00@00000
0?ooo`3oool000006P3oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001@0
oooo00<000000?ooo`3oool05`3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?oo
o`3oool04P3oool010000000oooo0?ooo`00002k0?ooo`00]`3oool00`000000oooo0?ooo`0P0?oo
o`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0J0?ooo`050000003oool0
oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01/0oooo00<0
00000?ooo`3oool06`3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo01H0oooo00D0
00000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
^@3oool00;D0oooo0P00000S0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo
0?ooo`0J0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0C0?ooo`80
0000703oool2000001`0oooo0P00000G0?ooo`030000003oool0oooo01D0oooo00D000000?ooo`3o
ool0oooo000000020?ooo`030000003oool0oooo01<0oooo0P00002l0?ooo`00]@3oool00`000000
oooo0?ooo`0R0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0J0?oo
o`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0
oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0D0?ooo`040000003oool0
oooo000001H0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo01<0oooo
00<000000?ooo`3oool0^`3oool00;D0oooo0`00000Q0?ooo`800000103oool2000001`0oooo0P00
00040?ooo`8000005P3oool3000001/0oooo0`00000K0?ooo`<000005@3oool2000001H0oooo0P00
00040?ooo`8000005P3oool300000;/0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?oo
o`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo
0?ooofD0oooo002[0?ooo`030000003oool0oooo0?l0oooo2@3oool00`000000oooo0?ooo`2Z0?oo
o`00ZP3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`2Y0?ooo`00ZP3oool00`000000oooo0?ooo`0J0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`2Y0?ooo`00ZP3o
ool010000000oooo0?ooo`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@000000P3oool400000080oooo100000030?ooo`030000003oool0oooo0:T0oooo
002Y0?ooo`030000003oool0oooo0?l0oooo3@3oool00`000000oooo0?ooo`2X0?ooo`00ZP3oool0
0`000000oooo0?ooo`3o0?ooo`/0oooo00<000000?ooo`3oool0Z@3oool00:X0oooo00<000000?oo
o`3oool0o`3oool;0?ooo`030000003oool0oooo0:T0oooo002[0?ooo`030000003oool0oooo0?l0
oooo2@3oool00`000000oooo0?ooo`2Z0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3o
ool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0oooo
o`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002^0?ooo`@000001`3oool3000000D0oooo0`00000?
0?ooo`800000203oool3000000D0oooo0`00000?0?ooo`800000203oool3000000D0oooo0`00000=
0?ooo`<000001@3oool3000000l0oooo0P0000080?ooo`<000001@3oool3000000d0oooo0`000005
0?ooo`<000003@3oool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000h0oooo10000007
0?ooo`<000001@3oool300000:l0oooo002^0?ooo`030000003oool0oooo00T0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<0
00000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool03@3oool010000000oooo0?ooo`0000080?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool0[P3oool00:l0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<0
00000?ooo`3oool03`3oool00`000000oooo0?ooo`070?ooo`<000001@3oool00`000000oooo0?oo
o`0?0?ooo`030000003oool0oooo00L0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`00
00050?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool01`3oool3000000D0oooo00<0
00000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<0
00000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?oo
o`080?ooo`<000001@3oool00`000000oooo0?ooo`2^0?ooo`00/03oool00`000000oooo0?ooo`07
0?ooo`040000003oool0oooo000000<0oooo0P00000B0?ooo`030000003oool0oooo00H0oooo00@0
00000?ooo`3oool000000`3oool200000180oooo00<000000?ooo`3oool01P3oool010000000oooo
0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000030?ooo`8000004P3oool00`00
0000oooo0?ooo`060?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0
oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000
003oool0oooo000000<0oooo0P00000A0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3o
ool000000`3oool200000;00oooo002^0?ooo`040000003oool0oooo000000P0oooo00@000000?oo
o`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo
00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo
000001@0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00000D0?ooo`040000
003oool0oooo000001@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00000D
0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000]@3oool00:l0oooo0P00
00080?ooo`@000001@3oool00`000000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<0
00000?ooo`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo00`0oooo1000
00050?ooo`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?oo
o`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?oo
o`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<0
00000?ooo`3oool0[P3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo0000\
\>"],
  ImageRangeCache->{{{0, 610.563}, {170.188, 0}} -> {-0.426205, -0.013998, \
0.00467178, 0.00467178}, {{91.1875, 295.063}, {167.188, 47.3125}} -> \
{-2.78903, -0.0387846, 0.0128415, 0.0128415}, {{315.438, 519.313}, {167.188, \
47.3125}} -> {-5.66874, -0.0387846, 0.0128415, 0.0128415}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(2) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(3) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(2) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(5) show
135.000 39.000 moveto
(5) show
165.000 39.000 moveto
(5) show
195.000 39.000 moveto
(5) show
225.000 39.000 moveto
(5) show
255.000 39.000 moveto
(5) show
285.000 39.000 moveto
(5) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -9.21572e-018 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.61803 0 L
.5 .36327 L
F
0 0 1 r
.61803 0 m
1 0 L
.5 .36327 L
F
1 0 0 r
0 0 m
.5 .36327 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -1.19262e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.19098 .58779 m
0 0 L
.38197 0 L
F
0 0 1 r
.38197 0 m
1 0 L
.69098 .22451 L
F
1 0 0 r
.38197 0 m
.69098 .22451 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000Zb000`400?l00000o`00003oF`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?oo
o`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00D03ooooo00000<@00000
D03oool005/0oooo00<000000?l00000o`00N`00o`1=0000oaH0ooooC@00o`020?l007/0003oG@3o
ool005/0oooo00<000000?l0003o0000N`00o`1<0000oaL0ooooC@00o`030?l007T0003oGP3oool0
05/0oooo00<000000?l0003o00000P3o001i003o04X0003o6@3ooom=003o00D0o`00M@000?mP0?oo
o`00F`3oool00`000000oooo0?l000030?l007L00?l0BP000?lK0?oood/00?l01`3o001c0000of40
oooo001K0?ooo`030000003oool0o`0000@0o`00MP00o`190000oa`0ooooB`00o`080?l00740003o
HP3oool005/0oooo00<000000?ooo`3o00001P3o001d003o04L0003o7P3ooom;003o00X0o`00K@00
0?mT0?ooo`00F`3oool00`000000oooo0?ooo`070?l007800?l0A`000?lP0?ooodT00?l0303o001[
0000ofD0oooo001K0?ooo`030000003oool0oooo00T0o`00L000o`150000ob80ooooB@00o`0=0?l0
06T0003oIP3oool005/0oooo00<000000?ooo`3oool02P3o001_003o04@0003o8`3ooom9003o00l0
o`00I@000?mX0?ooo`00F`3oool010000000oooo0?ooo`3oool:0?l006d00?l0A0000?lU0?ooodL0
0?l04@3o001S0000ofT0oooo001K0?ooo`040000003oool0oooo0?ooo``0o`00J`00o`120000obL0
ooooA`00o`0C0?l005l0003oJ`3oool005/0oooo00@000000?ooo`3oool0oooo3@3o001Z003o0440
003o:03ooom7003o01@0o`00G@000?m/0?ooo`00F`3oool00`000000oooo0?ooo`020?ooo`d0o`00
J000o`110000obX0ooooA@00o`0F0?l005/0003oK@3oool005/0oooo00<000000?ooo`3oool00P3o
ool?0?l006H00?l0?`000?l/0?ooodD00?l0603o001G0000ofl0oooo001K0?ooo`030000003oool0
oooo0080oooo403o001U003o03h0003o;@3ooom5003o01T0o`00E@000?m`0?ooo`00F`3oool00`00
0000oooo0?ooo`030?oooa40o`00HP00o`0m0000oc00oooo@`00o`0K0?l005<0003oL@3oool005/0
oooo00<000000?ooo`3oool00`3ooolB0?l006400?l0?0000?la0?oood<00?l07@3o001?0000og<0
oooo001K0?ooo`030000003oool0oooo00<0oooo4`3o001P003o03/0003o<P3ooom3003o01h0o`00
C@000?md0?ooo`00F`3oool00`000000oooo0?ooo`040?oooa@0o`00G@00o`0j0000ocD0oooo@@00
o`0Q0?l004T0003oMP3oool005/0oooo00<000000?ooo`3oool0103ooolE0?l005`00?l0>@000?lf
0?oood400?l08P3o00170000ogL0oooo001K0?ooo`030000003oool0oooo00@0oooo5P3o001K003o
03P0003o=`3ooom1003o02<0o`00A@000?mh0?ooo`00F`3oool00`000000oooo0?ooo`050?oooaL0
o`00F000o`0g0000ocX0oooo?`00o`0V0?l00440003oNP3oool005/0oooo00<000000?ooo`3oool0
1@3ooolH0?l005L00?l0=P000?lk0?ooocl00?l09`3o000o0000og/0oooo001K0?ooo`030000003o
ool0oooo00D0oooo6P3o001E003o03@0003o?@3ooolo003o02P0o`00?@000?ml0?ooo`00F`3oool0
0`000000oooo0?ooo`060?oooaX0o`00D`00o`0d0000ocl0oooo?@00o`0[0?l003T0003oOP3oool0
05/0oooo00<000000?ooo`3oool01P3ooolK0?l005800?l0<`000?m00?ooocd00?l0;03o000g0000
ogl0oooo001K0?ooo`030000003oool0oooo00H0oooo7@3o001@003o0340003o@P3ooolm003o02d0
o`00=@000?n00?ooo`00F`3oool00`000000oooo0?ooo`070?oooad0o`00CP00o`0a0000od@0oooo
>`00o`0`0?l00340003oPP3oool005/0oooo00<000000?ooo`3oool01`3ooolN0?l004d00?l0<000
0?m50?oooc/00?l0<@3o000_0000oh<0oooo001K0?ooo`030000003oool0oooo00L0oooo803o001;
003o02h0003oA`3ooolk003o03<0o`00:`000?n50?ooo`00F`3oool00`000000oooo0?ooo`080?oo
ob00o`00B@00o`0^0000odT0oooo>@00o`0e0?l002T0003oQP3oool005/0oooo00<000000?ooo`3o
ool0203ooolR0?l004L00?l0;0000?m;0?ooocT00?l0=P3o000W0000ohL0oooo001K0?ooo`030000
003oool0oooo00P0oooo8`3o0016003o02/0003oC03oooli003o03P0o`008`000?n90?ooo`00F`3o
ool00`000000oooo0?ooo`090?ooob<0o`00A000o`0[0000odh0oooo=`00o`0j0?l00240003oRP3o
ool005/0oooo00<000000?ooo`3oool02@3ooolU0?l004800?l0:@000?m@0?ooocL00?l0>`3o000O
0000oh/0oooo001K0?ooo`030000003oool0oooo00T0oooo9P3o0011003o02P0003oD@3ooolg003o
03d0o`006`000?n=0?ooo`00F`3oool00`000000oooo0?ooo`0:0?ooobH0o`00?`00o`0W0000oe@0
oooo=@00o`0o0?l001T0003oSP3oool005/0oooo00<000000?ooo`3oool02P3ooolX0?l003d00?l0
9P000?mE0?ooocD00?l0@@3o000E0000oi00oooo001K0?ooo`030000003oool0oooo00X0oooo:@3o
000l003o02D0003oEP3ooole003o0480o`004`000?nA0?ooo`00F`3oool00`000000oooo0?ooo`0:
0?ooob/0o`00>P00o`0S0000oeP0oooo=000o`140?l00140003oTP3oool005/0oooo00<000000?oo
o`3oool02`3oool[0?l003P00?l08`000?mJ0?oooc<00?l0AP3o000=0000oi@0oooo001K0?ooo`03
0000003oool0oooo00/0oooo;03o000g003o0280003oF`3ooolc003o04L0o`002`000?nE0?ooo`00
F`3oool00`000000oooo0?ooo`0;0?ooobh0o`00=@00o`0P0000oed0oooo<`00o`180?l000T0003o
UP3oool005/0oooo00<000000?ooo`3oool0303oool^0?l003<00?l080000?mO0?oooc400?l0B`3o
00050000oiP0oooo001K0?ooo`030000003oool0oooo00`0oooo<03o000a003o01h0003oH@3ooola
003o04`0o`000`000?nI0?ooo`00F`3oool00`000000oooo0?ooo`0<0?oooc40o`00<000o`0M0000
of80oooo<@00o`1=0?l009/0oooo001K0?ooo`030000003oool0oooo00d0oooo<@3o000^003o01d0
003oI03oool_003o04d0o`00W03oool005/0oooo00<000000?ooo`3oool03@3ooolc0?l002`00?l0
6`000?mV0?ooobl00?l0C03o002M0?ooo`00F`3oool00`000000oooo0?ooo`0=0?oooc@0o`00:`00
o`0J0000ofL0oooo;`00o`1:0?l009l0oooo001K0?ooo`030000003oool0oooo00h0oooo=03o000Y
003o01X0003oJ@3oool]003o04X0o`00X03oool005/0oooo00<000000?ooo`3oool03P3ooolf0?l0
02L00?l060000?m[0?ooobd00?l0B@3o002Q0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooocL0
o`009P00o`0G0000of`0oooo;@00o`170?l00:<0oooo001K0?ooo`030000003oool0oooo00l0oooo
>03o000S003o01H0003oK`3oool[003o04L0o`00Y03oool005/0oooo00<000000?ooo`3oool03`3o
ooli0?l002800?l05@000?m`0?ooob/00?l0A@3o002V0?ooo`00F`3oool00`000000oooo0?ooo`0?
0?ooocX0o`008@00o`0D0000og40oooo:`00o`140?l00:L0oooo001K0?ooo`030000003oool0oooo
0100oooo>`3o000N003o01<0003oM03ooolY003o04@0o`00Z03oool005/0oooo00<000000?ooo`3o
ool0403oooll0?l001d00?l04P000?me0?ooobT00?l0@P3o002Z0?ooo`00F`3oool00`000000oooo
0?ooo`0@0?ooocd0o`007000o`0A0000ogH0oooo:@00o`110?l00:/0oooo001K0?ooo`030000003o
ool0oooo0140oooo?P3o000I003o0100003oN@3ooolW003o0440o`00[03oool005/0oooo00<00000
0?ooo`3oool04@3ooolo0?l001P00?l03`000?mj0?ooobL00?l0?`3o002^0?ooo`00F`3oool00`00
0000oooo0?ooo`0A0?oood40o`005P00o`0=0000og`0oooo9`00o`0n0?l00:l0oooo001K0?ooo`03
0000003oool0oooo0180oooo@@3o000D003o00d0003oOP3ooolU003o03d0o`00/@3oool005/0oooo
00<000000?ooo`3oool04P3ooom20?l001<00?l030000?mo0?ooobD00?l0?03o002b0?ooo`00F`3o
ool00`000000oooo0?ooo`0B0?oood@0o`004@00o`0:0000oh40oooo9@00o`0k0?l00;<0oooo001K
0?ooo`030000003oool0oooo01<0ooooA03o000?003o00X0003oP`3ooolS003o03X0o`00]@3oool0
05/0oooo00<000000?ooo`3oool04`3ooom50?l000h00?l02@000?n40?ooob<00?l0>@3o002f0?oo
o`00F`3oool00`000000oooo0?ooo`0C0?ooodL0o`003000o`070000ohH0oooo8`00o`0h0?l00;L0
oooo001K0?ooo`030000003oool0oooo01@0ooooA`3o000:003o00L0003oR03ooolQ003o03L0o`00
^@3oool005/0oooo00<000000?ooo`3oool0503ooom90?l000P00?l01@000?n:0?ooob400?l0=P3o
002j0?ooo`00F`3oool00`000000oooo0?ooo`0D0?ooodX0o`001`00o`040000oh/0oooo8@00o`0d
0?l00;`0oooo001K0?ooo`030000003oool0oooo01D0ooooBP3o0005003o00@0003oS@3ooolO003o
03@0o`00_@3oool005/0oooo00<000000?ooo`3oool05@3ooom<0?l000<00?l00P000?n?0?oooal0
0?l0<`3o002n0?ooo`00F`3oool00`000000oooo0?ooo`0E0?ooodd0o`000P00o`000`000?l0oooo
0?ooo`2>0?oooal00?l0<@3o00300?ooo`00F`3oool00`000000oooo0?ooo`0F0?ooodd0o`00T`3o
oolM003o0340o`00`@3oool005/0oooo00<000000?ooo`3oool05P3ooom<0?l009@0oooo7@00o`0`
0?l00<80oooo001K0?ooo`030000003oool0oooo01H0ooooB`3o002E0?oooad00?l0;P3o00340?oo
o`00F`3oool00`000000oooo0?ooo`0G0?ooodP0o`00V03ooolK003o02h0o`00a@3oool005/0oooo
00<000000?ooo`3oool05`3ooom70?l009T0oooo6`00o`0/0?l00<L0oooo001K0?ooo`030000003o
ool0oooo01L0ooooAP3o002J0?oooa/00?l0:`3o00380?ooo`00F`3oool00`000000oooo0?ooo`0G
0?oood@0o`00W03ooolJ003o02/0o`00b@3oool005/0oooo00<000000?ooo`3oool0603ooom20?l0
09h0oooo6@00o`0Y0?l00</0oooo001K0?ooo`030000003oool0oooo01P0oooo@@3o002O0?oooaT0
0?l0:03o003<0?ooo`00F`3oool00`000000oooo0?ooo`0H0?ooocl0o`00X@3ooolI003o02H0o`00
cP3oool005/0oooo00<000000?ooo`3oool06@3ooolm0?l00:<0oooo5`00o`0V0?l00<l0oooo001K
0?ooo`030000003oool0oooo01T0oooo>`3o002U0?oooaL00?l09@3o003@0?ooo`00F`3oool00`00
0000oooo0?ooo`0I0?ooocX0o`00YP3ooolG003o02<0o`00dP3oool005/0oooo00<000000?ooo`3o
ool06P3ooolh0?l00:P0oooo5@00o`0S0?l00=<0oooo001K0?ooo`030000003oool0oooo01X0oooo
=P3o002Z0?oooaD00?l08P3o003D0?ooo`00F`3oool00`000000oooo0?ooo`0J0?ooocD0o`00Z`3o
oolE003o0200o`00eP3oool005/0oooo00<000000?ooo`3oool06`3ooolc0?l00:d0oooo4`00o`0P
0?l00=L0oooo001K0?ooo`030000003oool0oooo01/0oooo<@3o002_0?oooa<00?l07P3o003I0?oo
o`00F`3oool00`000000oooo0?ooo`0K0?oooc00o`00/03ooolC003o01d0o`00fP3oool005/0oooo
00<000000?ooo`3oool0703oool]0?l00;<0oooo4@00o`0M0?l00=/0oooo001K0?ooo`030000003o
ool0oooo01`0oooo;03o002d0?oooa400?l06`3o003M0?ooo`00F`3oool00`000000oooo0?ooo`0L
0?ooob/0o`00]@3ooolA003o01X0o`00gP3oool005/0oooo00<000000?ooo`3oool07@3ooolX0?l0
0;P0oooo3`00o`0J0?l00=l0oooo001K0?ooo`030000003oool0oooo01d0oooo9`3o002i0?ooo`l0
0?l0603o003Q0?ooo`00F`3oool00`000000oooo0?ooo`0M0?ooobH0o`00^P3oool?003o01L0o`00
hP3oool005/0oooo00<000000?ooo`3oool07P3ooolS0?l00;d0oooo3@00o`0F0?l00>@0oooo001K
0?ooo`030000003oool0oooo01h0oooo8P3o002n0?ooo`d00?l05@3o003U0?ooo`00F`3oool00`00
0000oooo0?ooo`0N0?ooob40o`00_`3oool=003o01@0o`00iP3oool005/0oooo00<000000?ooo`3o
ool07`3ooolN0?l00<80oooo2`00o`0C0?l00>P0oooo001K0?ooo`030000003oool0oooo01l0oooo
7@3o00330?ooo`/00?l04P3o003Y0?ooo`00F`3oool00`000000oooo0?ooo`0O0?oooa/0o`00a@3o
ool;003o0140o`00jP3oool005/0oooo00<000000?ooo`3oool0803ooolI0?l00<L0oooo2@00o`0@
0?l00>`0oooo001K0?ooo`030000003oool0oooo0200oooo603o00380?ooo`T00?l03`3o003]0?oo
o`00F`3oool00`000000oooo0?ooo`0P0?oooaH0o`00bP3oool9003o00d0o`00k`3oool005/0oooo
00<000000?ooo`3oool08@3ooolD0?l00<`0oooo1`00o`0=0?l00?00oooo001K0?ooo`030000003o
ool0oooo0240oooo4`3o003=0?ooo`L00?l0303o003a0?ooo`00F`3oool00`000000oooo0?ooo`0Q
0?oooa40o`00c`3oool7003o00X0o`00l`3oool005/0oooo00<000000?ooo`3oool08P3oool?0?l0
0=40oooo1@00o`0:0?l00?@0oooo001K0?ooo`030000003oool0oooo0280oooo3@3o003C0?ooo`D0
0?l02@3o003e0?ooo`00F`3oool00`000000oooo0?ooo`0R0?ooo``0o`00e03oool5003o00L0o`00
m`3oool005/0oooo00<000000?ooo`3oool08`3oool:0?l00=H0oooo0`00o`070?l00?P0oooo001K
0?ooo`030000003oool0oooo02<0oooo203o003H0?ooo`<00?l01@3o003j0?ooo`00F`3oool00`00
0000oooo0?ooo`0S0?ooo`L0o`00f@3oool3003o00@0o`00n`3oool005/0oooo00<000000?ooo`3o
ool0903oool50?l00=/0oooo00<00?l00?l0003o00000P3o003l0?ooo`00F`3oool00`000000oooo
0?ooo`0T0?ooo`<0o`00g@3oool00`00o`00o`000?l0003n0?ooo`00F`3oool00`000000oooo0?oo
o`0T0?ooo`80o`00gP3oool00`00o`00o`000?ooo`3n0?ooo`00F`3oool00`000000oooo0?ooo`3o
0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?ooo`L0oooo001K0?ooo`03
0000003oool0oooo0?l0ooooo`3oool70?ooo`00F`3oool00`000000oooo0?ooo`3o0?ooool0oooo
1`3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00;D0oooo0P00000L0?ooo`800000
703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000
703oool200000;`0oooo002d0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool0
00006P3oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001X0oooo00@00000
0?ooo`3oool000006P3oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001X0
oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00002k0?ooo`00]`3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0^@3oool00;D0
oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0
oooo0P00000L0?ooo`800000703oool200000;`0oooo002e0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`2k0?ooo`00]@3oool3000001/0oooo0`00
000K0?ooo`<000006`3oool3000001/0oooo0`00000K0?ooo`<000006`3oool3000001/0oooo0`00
000K0?ooo`<00000^`3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0
ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool0
0:/0oooo00<000000?ooo`3oool0o`3oool90?ooo`030000003oool0oooo0:X0oooo002Z0?ooo`03
0000003oool0oooo01X0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`03
0000003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`03
0000003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`03
0000003oool0oooo0:T0oooo002Z0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
8@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0:T0oooo002Z0?ooo`040000003o
ool0oooo0?ooo`@000000P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo
0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo
100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo
100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@000000P3oool400000080oooo
100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000103oool00`000000oooo
0?ooo`070?ooo`@000000P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo
0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo
100000020?ooo`@000000P3oool4000000<0oooo00<000000?ooo`3oool0Z@3oool00:T0oooo00<0
00000?ooo`3oool0o`3oool=0?ooo`030000003oool0oooo0:P0oooo002Z0?ooo`030000003oool0
oooo0?l0oooo2`3oool00`000000oooo0?ooo`2Y0?ooo`00ZP3oool00`000000oooo0?ooo`3o0?oo
o`/0oooo00<000000?ooo`3oool0Z@3oool00:/0oooo00<000000?ooo`3oool0o`3oool90?ooo`03
0000003oool0oooo0:X0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo
0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo
003o0?ooool0ooooI@3oool00:h0oooo100000070?ooo`<000001@3oool3000000d0oooo0`000005
0?ooo`<000003P3oool4000000L0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000?
0?ooo`800000203oool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000h0oooo10000007
0?ooo`<000001@3oool3000000d0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`000005
0?ooo`<00000[`3oool00:h0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool010000000oooo0?ooo`000008
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`2^
0?ooo`00[`3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`000000oooo0?ooo`0=0?oo
o`<000001@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?oo
o`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo00l0oooo00<000000?oo
o`3oool01`3oool3000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?oo
o`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`000000oooo0?ooo`0=0?oo
o`<000001@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?oo
o`030000003oool0oooo0:h0oooo002`0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3o
ool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool200000140oooo00<00000
0?ooo`3oool01`3oool010000000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?oo
o`0000030?ooo`8000004P3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo000000<0
oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000A0?ooo`030000003oool0oooo
00L0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3o
ool200000140oooo00<000000?ooo`3oool01`3oool010000000oooo0?ooo`0000030?ooo`800000
/03oool00:h0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00000D0?ooo`04
0000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00
000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool010000000
oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203o
ool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000203oool010000000oooo0?ooo`00002e0?ooo`00[`3oool2000000P0oooo100000050?oo
o`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?oo
o`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?oo
o`800000203oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<000000?oo
o`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo00`0oooo100000050?oo
o`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`2^0?oo
o`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00001\
\>"],
  ImageRangeCache->{{{0, 610.563}, {170.188, 0}} -> {-0.426205, -0.013998, \
0.00467178, 0.00467178}, {{91.1875, 295.063}, {167.188, 47.3125}} -> \
{-1.34175, -0.0239702, 0.00793648, 0.00793648}, {{315.438, 519.313}, \
{167.188, 47.3125}} -> {-3.12151, -0.0239702, 0.00793648, 0.00793648}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(Pi) show
153.000 12.750 moveto
(Pi) show
177.000 12.750 moveto
(3) show
189.000 12.750 moveto
(Pi) show
213.000 12.750 moveto
(Pi) show
237.000 12.750 moveto
(3) show
249.000 12.750 moveto
(Pi) show
273.000 12.750 moveto
(3) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
153.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
165.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
177.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
189.000 25.875 moveto
(--) show
201.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
213.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
225.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
237.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
249.000 25.875 moveto
(--) show
261.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
273.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
285.000 25.875 moveto
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(10) show
129.000 39.000 moveto
(2) show
153.000 39.000 moveto
(5) show
183.000 39.000 moveto
(5) show
213.000 39.000 moveto
(5) show
243.000 39.000 moveto
(10) show
279.000 39.000 moveto
(10) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.190983 0.809017 1.84585e-017 0.809017 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.76393 0 L
.69098 .22451 L
F
0 0 1 r
.76393 0 m
1 0 L
.69098 .22451 L
F
1 0 0 r
0 0 m
.69098 .22451 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.190983 0.809017 1.38778e-017 0.809017 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.19098 .58779 m
0 0 L
.19098 0 L
F
0 0 1 r
.19098 0 m
1 0 L
.59549 .29389 L
F
1 0 0 r
.19098 0 m
.59549 .29389 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000Zb000`400?l00000o`00003oF`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?oo
o`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00D03ooooo00000<@00000
D03oool005/0oooo00@000000?l0003o0000o`00U`00o`0`0000oaH0oooo9P00o`020?l00:80003o
G@3oool005/0oooo00<000000?l0003o0000103o002D003o02l0003o5`3ooolV003o00<0o`00X000
0?mN0?ooo`00F`3oool00`000000o`000?l000070?l009400?l0;@000?lI0?ooobH00?l01@3o002L
0000of00oooo001K0?ooo`030000003oool0o`0000X0o`00S@00o`0]0000oa/0oooo9@00o`060?l0
09X0003oH@3oool005/0oooo00<000000?ooo`3o00003@3o002:003o02`0003o703ooolU003o00L0
o`00V0000?mR0?ooo`00F`3oool00`000000oooo0?l0000@0?l008L00?l0:P000?lN0?ooobD00?l0
2@3o002D0000of@0oooo001K0?ooo`030000003oool0oooo01<0o`00P`00o`0Z0000ob00oooo9000
o`0:0?l00980003oI@3oool005/0oooo00<000000?ooo`3oool05P3o0020003o02T0003o8@3ooolT
003o00/0o`00S`000?mW0?ooo`00F`3oool00`000000oooo0?ooo`0I0?l007d00?l09`000?lS0?oo
ob@00?l03@3o002<0000ofP0oooo001K0?ooo`040000003oool0oooo0?oooa/0o`00N@00o`0W0000
obD0oooo8`00o`0>0?l008X0003oJ@3oool005/0oooo00@000000?ooo`3oool0oooo7P3o001f003o
02D0003o9`3ooolS003o0100o`00QP000?m[0?ooo`00F`3oool010000000oooo0?ooo`3ooolQ0?l0
07<00?l090000?lX0?ooob<00?l04@3o00240000of`0oooo001K0?ooo`030000003oool0oooo0080
oooo8`3o001`003o02<0003o:P3ooolR003o0180o`00PP000?m]0?ooo`00F`3oool00`000000oooo
0?ooo`020?ooobH0o`00K000o`0R0000ob`0oooo8P00o`0D0?l007h0003oK`3oool005/0oooo00<0
00000?ooo`3oool00P3ooolY0?l006T00?l08@000?l]0?ooob800?l05@3o001l0000og00oooo001K
0?ooo`030000003oool0oooo00<0oooo;03o001U003o0200003o;`3ooolQ003o01H0o`00N@000?mb
0?ooo`00F`3oool00`000000oooo0?ooo`030?ooobl0o`00H@00o`0O0000oc40oooo8@00o`0H0?l0
07H0003oL`3oool005/0oooo00<000000?ooo`3oool00`3ooolb0?l005h00?l07P000?lb0?ooob40
0?l06@3o001d0000og@0oooo001K0?ooo`030000003oool0oooo00@0oooo=03o001K003o01`0003o
=@3ooolP003o01X0o`00L@000?mf0?ooo`00F`3oool00`000000oooo0?ooo`040?ooocL0o`00E`00
o`0L0000ocH0oooo8000o`0L0?l006h0003oM`3oool005/0oooo00<000000?ooo`3oool0103ooolj
0?l005@00?l06`000?lg0?ooob000?l07@3o001[0000ogT0oooo001K0?ooo`030000003oool0oooo
00D0oooo?03o001A003o01T0003o>P3ooolO003o01l0o`00J0000?mj0?ooo`00F`3oool00`000000
oooo0?ooo`050?ooocl0o`00C@00o`0I0000oc/0oooo7`00o`0P0?l006H0003oN`3oool005/0oooo
00<000000?ooo`3oool01@3ooom20?l004X00?l060000?ll0?oooal00?l08@3o001S0000ogd0oooo
001K0?ooo`030000003oool0oooo00H0ooooA03o0017003o01H0003o?`3ooolN003o02<0o`00H000
0?mn0?ooo`00F`3oool00`000000oooo0?ooo`060?ooodL0o`00A000o`0E0000od00oooo7P00o`0T
0?l005h0003oO`3oool005/0oooo00<000000?ooo`3oool01P3ooom:0?l004000?l05@000?m10?oo
oah00?l09@3o001K0000oh40oooo001K0?ooo`030000003oool0oooo00L0ooooC03o000m003o01<0
003oA03ooolM003o02L0o`00F0000?n20?ooo`00F`3oool00`000000oooo0?ooo`070?ooodl0o`00
>P00o`0B0000odD0oooo7@00o`0X0?l005D0003oQ03oool005/0oooo00<000000?ooo`3oool01`3o
oomB0?l003H00?l04@000?m70?oooad00?l0:@3o001C0000ohD0oooo001K0?ooo`030000003oool0
oooo00P0ooooE@3o000b003o0100003oB@3ooolL003o02/0o`00D0000?n60?ooo`00F`3oool00`00
0000oooo0?ooo`080?oooeP0o`00;`00o`0?0000odX0oooo7000o`0/0?l004d0003oR03oool005/0
oooo00<000000?ooo`3oool0203ooomK0?l002/00?l03P000?m<0?oooa`00?l0;P3o001:0000ohT0
oooo001K0?ooo`030000003oool0oooo00T0ooooG@3o000X003o00d0003oCP3ooolK003o02l0o`00
A`000?n;0?ooo`00F`3oool00`000000oooo0?ooo`090?ooof00o`009@00o`0<0000odl0oooo6`00
o`0`0?l004D0003oS03oool005/0oooo00<000000?ooo`3oool02@3ooomS0?l002800?l02P000?mA
0?oooa/00?l0<P3o00120000ohd0oooo001K0?ooo`030000003oool0oooo00X0ooooI@3o000N003o
00X0003oD`3ooolJ003o03<0o`00?`000?n?0?ooo`00F`3oool00`000000oooo0?ooo`0:0?ooofP0
o`006`00o`080000oeD0oooo6P00o`0d0?l003d0003oT03oool005/0oooo00<000000?ooo`3oool0
2P3ooom[0?l001P00?l01`000?mF0?oooaX00?l0=P3o000j0000oi40oooo001K0?ooo`030000003o
ool0oooo00X0ooooKP3o000D003o00L0003oE`3ooolJ003o03L0o`00=`000?nC0?ooo`00F`3oool0
0`000000oooo0?ooo`0;0?ooog00o`004@00o`050000oeX0oooo6@00o`0i0?l003@0003oU03oool0
05/0oooo00<000000?ooo`3oool02`3ooomc0?l000h00?l010000?mK0?oooaT00?l0>P3o000a0000
oiH0oooo001K0?ooo`030000003oool0oooo00/0ooooMP3o000:003o00@0003oG03ooolI003o03/0
o`00;`000?nG0?ooo`00F`3oool00`000000oooo0?ooo`0<0?ooogP0o`001`00o`020000oel0oooo
6000o`0m0?l002`0003oV03oool005/0oooo00<000000?ooo`3oool0303ooomk0?l000@00?l000<0
003o0?ooo`3oool0GP3ooolH003o03h0o`00:@000?nJ0?ooo`00F`3oool00`000000oooo0?ooo`0<
0?ooogh0o`00HP3ooolH003o03l0o`009`000?nK0?ooo`00F`3oool00`000000oooo0?ooo`0=0?oo
og`0o`00I03ooolG003o0440o`008`000?nM0?ooo`00F`3oool00`000000oooo0?ooo`0=0?ooog/0
o`00I@3ooolG003o0480o`008@000?nN0?ooo`00F`3oool00`000000oooo0?ooo`0=0?ooogT0o`00
I`3ooolG003o04<0o`007`000?nO0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooogL0o`00J@3o
oolF003o04D0o`006`000?nQ0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooogH0o`00JP3ooolF
003o04H0o`006@000?nR0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooog@0o`00K03ooolF003o
04P0o`005P000?nS0?ooo`00F`3oool00`000000oooo0?ooo`0?0?ooog80o`00KP3ooolE003o04T0
o`004`000?nU0?ooo`00F`3oool00`000000oooo0?ooo`0?0?ooog00o`00L03ooolE003o04X0o`00
4@000?nV0?ooo`00F`3oool00`000000oooo0?ooo`0?0?ooofl0o`00L@3ooolE003o04`0o`003@00
0?nX0?ooo`00F`3oool00`000000oooo0?ooo`0@0?ooofd0o`00L`3ooolD003o04d0o`002`000?nY
0?ooo`00F`3oool00`000000oooo0?ooo`0@0?ooof/0o`00M@3ooolD003o04h0o`002@000?nZ0?oo
o`00F`3oool00`000000oooo0?ooo`0@0?ooofX0o`00MP3ooolD003o0500o`001@000?n/0?ooo`00
F`3oool00`000000oooo0?ooo`0A0?ooofP0o`00N03ooolC003o0540o`000`000?n]0?ooo`00F`3o
ool00`000000oooo0?ooo`0A0?ooofH0o`00NP3ooolC003o0580o`00[`3oool005/0oooo00<00000
0?ooo`3oool04@3ooomU0?l007/0oooo4`00o`1A0?l00;00oooo001K0?ooo`030000003oool0oooo
0180ooooHP3o001n0?oooa800?l0D03o002a0?ooo`00F`3oool00`000000oooo0?ooo`0B0?ooof40
o`00O`3ooolB003o04h0o`00/`3oool005/0oooo00<000000?ooo`3oool04P3ooomP0?l00800oooo
4P00o`1=0?l00;@0oooo001K0?ooo`030000003oool0oooo01<0ooooG@3o00230?oooa400?l0C03o
002e0?ooo`00F`3oool00`000000oooo0?ooo`0C0?oooe`0o`00Q03ooolA003o04X0o`00]`3oool0
05/0oooo00<000000?ooo`3oool04`3ooomK0?l008D0oooo4@00o`190?l00;P0oooo001K0?ooo`03
0000003oool0oooo01@0ooooF03o00280?oooa000?l0B03o002i0?ooo`00F`3oool00`000000oooo
0?ooo`0D0?oooeL0o`00R@3oool@003o04H0o`00^`3oool005/0oooo00<000000?ooo`3oool0503o
oomE0?l008/0oooo4000o`150?l00;`0oooo001K0?ooo`030000003oool0oooo01D0ooooD`3o002=
0?ooo`l00?l0@`3o002n0?ooo`00F`3oool00`000000oooo0?ooo`0E0?oooe80o`00SP3oool?003o
0480o`00_`3oool005/0oooo00<000000?ooo`3oool05@3ooom@0?l00900oooo3`00o`110?l00<00
oooo001K0?ooo`030000003oool0oooo01H0ooooCP3o002B0?ooo`h00?l0?`3o00320?ooo`00F`3o
ool00`000000oooo0?ooo`0F0?ooodd0o`00T`3oool>003o03h0o`00``3oool005/0oooo00<00000
0?ooo`3oool05P3ooom;0?l009D0oooo3P00o`0m0?l00<@0oooo001K0?ooo`030000003oool0oooo
01L0ooooB@3o002G0?ooo`d00?l0>`3o00360?ooo`00F`3oool00`000000oooo0?ooo`0G0?ooodL0
o`00V@3oool=003o03X0o`00a`3oool005/0oooo00<000000?ooo`3oool05`3ooom60?l009X0oooo
3@00o`0i0?l00<P0oooo001K0?ooo`030000003oool0oooo01L0ooooA@3o002K0?ooo`d00?l0=`3o
003:0?ooo`00F`3oool00`000000oooo0?ooo`0H0?oood80o`00WP3oool<003o03H0o`00b`3oool0
05/0oooo00<000000?ooo`3oool0603ooom10?l009l0oooo3000o`0d0?l00<d0oooo001K0?ooo`03
0000003oool0oooo01P0oooo?`3o002Q0?ooo``00?l0<`3o003>0?ooo`00F`3oool00`000000oooo
0?ooo`0I0?ooocd0o`00X`3oool;003o0380o`00c`3oool005/0oooo00<000000?ooo`3oool06@3o
ooll0?l00:@0oooo2`00o`0`0?l00=40oooo001K0?ooo`030000003oool0oooo01T0oooo>P3o002V
0?ooo`/00?l0;`3o003B0?ooo`00F`3oool00`000000oooo0?ooo`0J0?ooocP0o`00Z03oool:003o
02h0o`00d`3oool005/0oooo00<000000?ooo`3oool06P3ooolg0?l00:T0oooo2P00o`0/0?l00=D0
oooo001K0?ooo`030000003oool0oooo01X0oooo=@3o002[0?ooo`X00?l0:`3o003F0?ooo`00F`3o
ool00`000000oooo0?ooo`0K0?oooc<0o`00[@3oool9003o02T0o`00f03oool005/0oooo00<00000
0?ooo`3oool06`3ooola0?l00:l0oooo2@00o`0X0?l00=T0oooo001K0?ooo`030000003oool0oooo
01/0oooo<03o002`0?ooo`T00?l09`3o003J0?ooo`00F`3oool00`000000oooo0?ooo`0L0?ooobh0
o`00/P3oool8003o02D0o`00g03oool005/0oooo00<000000?ooo`3oool0703oool/0?l00;@0oooo
2000o`0T0?l00=d0oooo001K0?ooo`030000003oool0oooo01`0oooo:`3o002e0?ooo`P00?l08`3o
003N0?ooo`00F`3oool00`000000oooo0?ooo`0M0?ooobT0o`00]`3oool7003o0240o`00h03oool0
05/0oooo00<000000?ooo`3oool07@3ooolW0?l00;T0oooo1`00o`0P0?l00>40oooo001K0?ooo`03
0000003oool0oooo01d0oooo9P3o002j0?ooo`L00?l07`3o003R0?ooo`00F`3oool00`000000oooo
0?ooo`0N0?ooob<0o`00_@3oool6003o01d0o`00i03oool005/0oooo00<000000?ooo`3oool07P3o
oolR0?l00;h0oooo1P00o`0L0?l00>D0oooo001K0?ooo`030000003oool0oooo01h0oooo8@3o002o
0?ooo`H00?l06P3o003W0?ooo`00F`3oool00`000000oooo0?ooo`0O0?oooah0o`00`P3oool5003o
01T0o`00j03oool005/0oooo00<000000?ooo`3oool07`3ooolM0?l00<<0oooo1@00o`0H0?l00>T0
oooo001K0?ooo`030000003oool0oooo01l0oooo703o00340?ooo`D00?l05P3o003[0?ooo`00F`3o
ool00`000000oooo0?ooo`0P0?oooaT0o`00a`3oool4003o01D0o`00k03oool005/0oooo00<00000
0?ooo`3oool0803ooolH0?l00<P0oooo1000o`0D0?l00>d0oooo001K0?ooo`030000003oool0oooo
0200oooo5P3o003:0?ooo`@00?l04P3o003_0?ooo`00F`3oool00`000000oooo0?ooo`0Q0?oooa@0
o`00c03oool3003o0140o`00l03oool005/0oooo00<000000?ooo`3oool08@3ooolC0?l00<d0oooo
0`00o`0@0?l00?40oooo001K0?ooo`030000003oool0oooo0240oooo4@3o003?0?ooo`<00?l03P3o
003c0?ooo`00F`3oool00`000000oooo0?ooo`0R0?ooo`l0o`00d@3oool2003o00d0o`00m03oool0
05/0oooo00<000000?ooo`3oool08P3oool>0?l00=80oooo0P00o`0;0?l00?H0oooo001K0?ooo`03
0000003oool0oooo0280oooo303o003D0?ooo`800?l02P3o003g0?ooo`00F`3oool00`000000oooo
0?ooo`0S0?ooo`X0o`00eP3oool00`00o`00o`000?l000070?l00?P0oooo001K0?ooo`030000003o
ool0oooo02<0oooo203o003H0?ooo`03003o003o0000o`0000D0o`00nP3oool005/0oooo00<00000
0?ooo`3oool08`3oool70?l00=T0oooo00<00?l00?l0003o0000103o003k0?ooo`00F`3oool00`00
0000oooo0?ooo`0T0?ooo`D0o`00f`3oool50?l00?`0oooo001K0?ooo`030000003oool0oooo02@0
oooo0`3o003M0?ooo`<0o`00oP3oool005/0oooo00<000000?ooo`3oool0903oool20?l00=h0oooo
0P3o003o0?ooo`00F`3oool00`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<00000
0?ooo`3oool0o`3ooooo0?ooo`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?oo
o`00F`3oool00`000000oooo0?ooo`3o0?ooool0oooo1`3oool00?l0ooooo`3ooomU0?ooo`00o`3o
oooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?oo
ool0ooooI@3oool00;D0oooo0P00000K0?ooo`D000000P3oool2000000l0oooo1000000E0?ooo`80
0000703oool2000001`0oooo0P00000K0?ooo`D000000P3oool2000001/0oooo1@0000020?ooo`80
0000703oool200000;`0oooo002d0?ooo`040000003oool0oooo000001`0oooo00D000000?ooo`3o
ool0oooo000000020?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool05@3oool01000
0000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool00000
703oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool06P3oool01@000000
oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool0603oool010000000oooo0?ooo`00002k
0?ooo`00]`3oool00`000000oooo0?ooo`0J0?ooo`050000003oool0oooo0?ooo`0000000P3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool06`3oool0
0`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01X0oooo00D000000?ooo`3oool0oooo0000
00020?ooo`030000003oool0oooo01X0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000
003oool0oooo01/0oooo00<000000?ooo`3oool0^@3oool00;D0oooo0P00000M0?ooo`050000003o
ool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo01@0oooo
0P00000L0?ooo`800000703oool2000001d0oooo00D000000?ooo`3oool0oooo000000020?ooo`03
0000003oool0oooo01X0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo
01T0oooo0P00002l0?ooo`00]@3oool00`000000oooo0?ooo`0L0?ooo`050000003oool0oooo0?oo
o`0000000P3oool00`000000oooo0?ooo`0<0?ooo`040000003oool0oooo000001D0oooo00<00000
0?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01`0oooo00D00000
0?ooo`3oool0oooo000000020?ooo`030000003oool0oooo01X0oooo00D000000?ooo`3oool0oooo
000000020?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0^`3oool00;D0oooo0`00
000K0?ooo`800000103oool200000100oooo0P00000F0?ooo`<000006`3oool3000001/0oooo0`00
000K0?ooo`800000103oool2000001`0oooo0P0000040?ooo`800000703oool300000;/0oooo003o
0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0oooo
I@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002[0?ooo`030000003oool0oooo
0?l0oooo2@3oool00`000000oooo0?ooo`2Z0?ooo`00ZP3oool00`000000oooo0?ooo`0J0?ooo`03
0000003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`03
0000003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`03
0000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`2Y0?ooo`00
ZP3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0
8@3oool00`000000oooo0?ooo`2Y0?ooo`00ZP3oool010000000oooo0?ooo`3oool400000080oooo
100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo
100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000103oool00`000000oooo
0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo
100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo
100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@000000P3oool400000080oooo
100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@000000P3oool400000080oooo
100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@000000P3oool400000080oooo
100000030?ooo`030000003oool0oooo0:T0oooo002Y0?ooo`030000003oool0oooo0?l0oooo3@3o
ool00`000000oooo0?ooo`2X0?ooo`00ZP3oool00`000000oooo0?ooo`3o0?ooo`/0oooo00<00000
0?ooo`3oool0Z@3oool00:X0oooo00<000000?ooo`3oool0o`3oool;0?ooo`030000003oool0oooo
0:T0oooo002[0?ooo`030000003oool0oooo0?l0oooo2@3oool00`000000oooo0?ooo`2Z0?ooo`00
o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?oo
ofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002^
0?ooo`@000001`3oool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000d0oooo0`000005
0?ooo`<000003@3oool3000000D0oooo0`00000?0?ooo`800000203oool3000000D0oooo0`00000=
0?ooo`<000001@3oool3000000l0oooo0P0000080?ooo`<000001@3oool3000000l0oooo0P000008
0?ooo`<000001@3oool3000000h0oooo100000070?ooo`<000001@3oool300000:l0oooo002^0?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?oo
o`040000003oool0oooo000000P0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool010000000oooo0?ooo`00
00080?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool010000000oooo0?oo
o`0000080?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0[P3oool00:l0oooo00<0
00000?ooo`3oool0203oool3000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<0
00000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<0
00000?ooo`3oool03`3oool00`000000oooo0?ooo`070?ooo`<000001@3oool00`000000oooo0?oo
o`0=0?ooo`<000001@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo00L0oooo0`00
00050?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool01`3oool3000000D0oooo00<0
00000?ooo`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`000000oooo0?oo
o`2^0?ooo`00/03oool00`000000oooo0?ooo`070?ooo`040000003oool0oooo000000<0oooo0P00
000?0?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0
oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000B0?ooo`030000003oool0oooo
00H0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3o
ool200000180oooo00<000000?ooo`3oool01P3oool010000000oooo0?ooo`0000030?ooo`800000
4P3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo000000<0oooo0P00000A0?ooo`03
0000003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool200000;00oooo002^0?ooo`04
0000003oool0oooo000000P0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00
000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000503oool010000000
oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000503o
ool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000000P0oooo00@0
00000?ooo`3oool00000]@3oool00:l0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?oo
o`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?oo
o`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<0
00000?ooo`3oool0303oool4000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo1000
00050?ooo`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?oo
o`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool0[P3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo0000\
\>"],
  ImageRangeCache->{{{0, 610.563}, {170.188, 0}} -> {-0.426205, -0.013998, \
0.00467178, 0.00467178}, {{91.1875, 295.063}, {167.188, 47.3125}} -> \
{-0.788938, -0.0183116, 0.00606293, 0.00606293}, {{315.438, 519.313}, \
{167.188, 47.3125}} -> {-2.14855, -0.0183116, 0.00606293, 0.00606293}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .41239 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00981888 0.47619 [
[.5 .42489 -116 0 ]
[.5 .42489 116 38.75 ]
[ 0 0 0 0 ]
[ 1 .41239 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00982 m
1 .00982 L
s
.02381 0 m
.02381 .41239 L
s
gsave
.5 .42489 -177 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(Pi) show
153.000 12.750 moveto
(Pi) show
177.000 12.750 moveto
(Pi) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(Pi) show
273.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
153.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
165.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
177.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
189.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
201.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
273.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
285.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
105.000 39.000 moveto
(6) show
129.000 39.000 moveto
(6) show
153.000 39.000 moveto
(3) show
177.000 39.000 moveto
(3) show
201.000 39.000 moveto
(3) show
225.000 39.000 moveto
(2) show
249.000 39.000 moveto
(6) show
273.000 39.000 moveto
(3) show
279.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .41239 L
0 .41239 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00981888 0.477324 0.402574 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.5 1.48807e-017 0.5 [
[ 0 0 0 0 ]
[ 1 .86603 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .86603 L
0 .86603 L
closepath
clip
newpath
0 1 0 r
0 0 m
.5 0 L
.75 .43301 L
F
0 0 1 r
.5 0 m
1 0 L
.75 .43301 L
F
1 0 0 r
0 0 m
.75 .43301 L
.5 .86603 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00981888 0.97619 0.402574 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.5 0 0.5 [
[ 0 0 0 0 ]
[ 1 .86603 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .86603 L
0 .86603 L
closepath
clip
newpath
0 1 0 r
.5 0 m
.75 .43301 L
.5 .86603 L
F
0 0 1 r
.5 0 m
1 0 L
.75 .43301 L
F
1 0 0 r
.5 .86603 m
0 0 L
.5 0 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.813, 252.313},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000o2000`400?l00000o`00003o@`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo7`3oool004<0oooo00<000000?ooo`3oool0o`3ooooo0?oo
oal0oooo00130?ooo`030000003oool0oooo0?l0ooooo`3ooolO0?ooo`00@`3oool00`000000oooo
0?ooo`3o0?ooool0oooo7`3oool004<0oooo00<000000?ooo`3oool0o`3ooooo0?oooal0oooo000g
0?ooool00000mP00000g0?ooo`00@`3oool00`000000o`00003o001_003o0740003o5`3oooma0?l0
0003003o00000?l0003o06h0003oA03oool004<0oooo00@000000?ooo`3o0000o`00K`00o`1_0000
oaT0ooooL03o0002003o06h0003oA@3oool004<0oooo00<000000?ooo`3o00000`3o001]003o06l0
003o6@3ooom`0?l000800?l0KP000?m50?ooo`00@`3oool00`000000oooo0?ooo`040?l006d00?l0
K@000?lK0?ooofl0o`000`00o`1/0000odH0oooo00130?ooo`030000003oool0oooo00H0o`00J`00
o`1]0000oa/0ooooK`3o0003003o06`0003oAP3oool004<0oooo00@000000?ooo`3oool0oooo1`3o
001Z003o06/0003o7@3ooom^0?l000@00?l0JP000?m70?ooo`00@`3oool00`000000oooo0?ooo`02
0?ooo`P0o`00J@00o`1Y0000oal0ooooK@3o0004003o06T0003oB03oool004<0oooo00<000000?oo
o`3oool00P3oool90?l006P00?l0J@000?lO0?ooofd0o`001@00o`1X0000odP0oooo00130?ooo`03
0000003oool0oooo00<0oooo2P3o001W003o06L0003o8@3ooom/0?l000H00?l0IP000?m90?ooo`00
@`3oool00`000000oooo0?ooo`030?ooo``0o`00I@00o`1W0000ob40ooooK03o0006003o06H0003o
B@3oool004<0oooo00<000000?ooo`3oool0103oool=0?l006@00?l0I@000?lS0?ooof/0o`001`00
o`1T0000odX0oooo00130?ooo`030000003oool0oooo00@0oooo3P3o001S003o06D0003o8`3ooom[
0?l000L00?l0I0000?m:0?ooo`00@`3oool00`000000oooo0?ooo`050?ooo`l0o`00HP00o`1S0000
obD0ooooJP3o0008003o0680003oB`3oool004<0oooo00<000000?ooo`3oool01P3oool@0?l00640
0?l0H@000?lW0?ooofT0o`002000o`1Q0000od`0oooo00130?ooo`030000003oool0oooo00H0oooo
4P3o001O003o0640003o9`3ooomY0?l000T00?l0H0000?m<0?ooo`00@`3oool00`000000oooo0?oo
o`070?oooa80o`00G`00o`1O0000obT0ooooJ03o000:003o05h0003oC@3oool004<0oooo00<00000
0?ooo`3oool01`3ooolD0?l005d00?l0G`000?lY0?ooofP0o`002P00o`1N0000odd0oooo00130?oo
o`030000003oool0oooo00P0oooo5@3o001L003o05d0003o:`3ooomW0?l000/00?l0G0000?m>0?oo
o`00@`3oool00`000000oooo0?ooo`080?oooaH0o`00G000o`1K0000ob`0ooooI`3o000;003o05/0
003oC`3oool004<0oooo00<000000?ooo`3oool02@3ooolG0?l005X00?l0F`000?l]0?ooofH0o`00
3000o`1J0000odl0oooo00130?ooo`030000003oool0oooo00X0oooo603o001I003o05T0003o;`3o
oomU0?l000`00?l0F@000?m@0?ooo`00@`3oool00`000000oooo0?ooo`0:0?oooaX0o`00E`00o`1I
0000obl0ooooI@3o000=003o05P0003oD03oool004<0oooo00<000000?ooo`3oool02`3ooolJ0?l0
05L00?l0E`000?la0?ooof@0o`003P00o`1F0000oe40oooo00130?ooo`030000003oool0oooo00/0
oooo703o001E003o05L0003o<@3ooomT0?l000h00?l0EP000?mA0?ooo`00@`3oool00`000000oooo
0?ooo`0<0?oooad0o`00E000o`1E0000oc<0ooooH`3o000?003o05@0003oDP3oool004<0oooo00<0
00000?ooo`3oool0303ooolO0?l005<00?l0D`000?le0?ooof80o`003`00o`1C0000oe<0oooo0013
0?ooo`030000003oool0oooo00d0oooo7`3o001B003o05<0003o=@3ooomR0?l001000?l0DP000?mC
0?ooo`00@`3oool00`000000oooo0?ooo`0>0?ooob00o`00D@00o`1A0000ocL0ooooH@3o000@003o
0540003oE03oool004<0oooo00<000000?ooo`3oool03P3ooolR0?l004l00?l0D@000?lg0?ooof40
o`004@00o`1@0000oe@0oooo00130?ooo`030000003oool0oooo00l0oooo8`3o001>003o04l0003o
>@3ooomP0?l001800?l0CP000?mE0?ooo`00@`3oool00`000000oooo0?ooo`0?0?ooob@0o`00CP00
o`1=0000ocX0ooooH03o000B003o04d0003oEP3oool004<0oooo00<000000?ooo`3oool0403ooolU
0?l004`00?l0C@000?lk0?oooel0o`004`00o`1<0000oeH0oooo00130?ooo`030000003oool0oooo
0100oooo9`3o001;003o04/0003o?@3ooomN0?l001<00?l0B`000?mG0?ooo`00@`3oool00`000000
oooo0?ooo`0A0?ooobL0o`00BP00o`1;0000ocd0ooooGP3o000D003o04X0003oE`3oool004<0oooo
00<000000?ooo`3oool04P3ooolX0?l004T00?l0B@000?lo0?oooed0o`005000o`190000oeP0oooo
00130?ooo`030000003oool0oooo0180oooo:P3o0017003o04T0003o?`3ooomM0?l001D00?l0B000
0?mH0?ooo`00@`3oool00`000000oooo0?ooo`0C0?ooob/0o`00AP00o`170000od40ooooG03o000F
003o04H0003oF@3oool004<0oooo00<000000?ooo`3oool04`3oool/0?l004H00?l0A@000?m20?oo
oe`0o`005P00o`150000oeX0oooo00130?ooo`030000003oool0oooo01@0oooo;@3o0014003o04D0
003o@`3ooomK0?l001L00?l0A0000?mJ0?ooo`00@`3oool00`000000oooo0?ooo`0D0?ooobl0o`00
@`00o`130000odD0ooooFP3o000G003o04<0003oF`3oool004<0oooo00<000000?ooo`3oool05@3o
ool`0?l004400?l0@`000?m50?oooeX0o`006000o`120000oe/0oooo00130?ooo`030000003oool0
oooo01H0oooo<03o0011003o0440003oA`3ooomI0?l001P00?l0@@000?mL0?ooo`00@`3oool00`00
0000oooo0?ooo`0F0?oooc80o`00@000o`0o0000odP0ooooF@3o000I003o03l0003oG@3oool004<0
oooo00<000000?ooo`3oool05`3ooolc0?l003h00?l0?`000?m90?oooeP0o`006P00o`0n0000oed0
oooo00130?ooo`030000003oool0oooo01L0oooo=@3o000m003o03d0003oB`3ooomG0?l001X00?l0
?@000?mN0?ooo`00@`3oool00`000000oooo0?ooo`0H0?ooocD0o`00?000o`0m0000od/0ooooE`3o
000K003o03`0003oGP3oool004<0oooo00<000000?ooo`3oool0603ooolg0?l003/00?l0>`000?m=
0?oooeH0o`006`00o`0k0000oel0oooo00130?ooo`030000003oool0oooo01T0oooo>03o000i003o
03/0003oC@3ooomF0?l001`00?l0>P000?mO0?ooo`00@`3oool00`000000oooo0?ooo`0J0?ooocP0
o`00>@00o`0i0000odl0ooooE@3o000L003o03T0003oH03oool004<0oooo00<000000?ooo`3oool0
6P3ooolj0?l003P00?l0=`000?m@0?oooeD0o`007@00o`0g0000of40oooo00130?ooo`030000003o
ool0oooo01/0oooo>`3o000f003o03L0003oD@3ooomD0?l001h00?l0=P000?mQ0?ooo`00@`3oool0
0`000000oooo0?ooo`0K0?ooocd0o`00=@00o`0e0000oe<0ooooD`3o000N003o03D0003oHP3oool0
04<0oooo00<000000?ooo`3oool0703ooolm0?l003@00?l0=@000?mC0?oooe<0o`007`00o`0d0000
of80oooo00130?ooo`030000003oool0oooo01`0oooo?`3o000c003o03<0003oE@3ooomB0?l001l0
0?l0<`000?mS0?ooo`00@`3oool00`000000oooo0?ooo`0M0?oood00o`00<@00o`0c0000oeD0oooo
DP3o000P003o0380003oH`3oool004<0oooo00<000000?ooo`3oool07P3ooom10?l003000?l0<@00
0?mG0?oooe40o`008000o`0a0000of@0oooo00130?ooo`030000003oool0oooo01h0oooo@P3o000`
003o02l0003oF03ooomA0?l002400?l0;`000?mU0?ooo`00@`3oool00`000000oooo0?ooo`0O0?oo
od<0o`00;P00o`0_0000oeT0ooooD03o000R003o02h0003oI@3oool004<0oooo00<000000?ooo`3o
ool07`3ooom50?l002d00?l0;@000?mK0?ooodl0o`008P00o`0]0000ofH0oooo00130?ooo`030000
003oool0oooo0200ooooAP3o000[003o02d0003oF`3ooom?0?l002<00?l0;0000?mV0?ooo`00@`3o
ool00`000000oooo0?ooo`0P0?ooodL0o`00:`00o`0[0000oed0ooooCP3o000S003o02/0003oI`3o
ool004<0oooo00<000000?ooo`3oool08@3ooom80?l002X00?l0:@000?mN0?ooodh0o`009000o`0Y
0000ofP0oooo00130?ooo`030000003oool0oooo0280ooooB@3o000X003o02T0003oG`3ooom=0?l0
02@00?l0:@000?mX0?ooo`00@`3oool00`000000oooo0?ooo`0R0?oood/0o`009`00o`0W0000of40
ooooC03o000U003o02L0003oJ@3oool004<0oooo00<000000?ooo`3oool08`3ooom;0?l002H00?l0
9`000?mQ0?oood`0o`009P00o`0V0000ofT0oooo00130?ooo`030000003oool0oooo02<0ooooC@3o
000U003o02D0003oH`3ooom;0?l002H00?l09@000?mZ0?ooo`00@`3oool00`000000oooo0?ooo`0T
0?ooodh0o`008`00o`0U0000of<0ooooB`3o000W003o02@0003oJP3oool004<0oooo00<000000?oo
o`3oool09@3ooom>0?l002<00?l08`000?mU0?ooodX0o`009`00o`0S0000of/0oooo00130?ooo`03
0000003oool0oooo02D0ooooD03o000R003o0240003oIP3ooom:0?l002P00?l08@000?m/0?ooo`00
@`3oool00`000000oooo0?ooo`0V0?oooe40o`008000o`0Q0000ofL0ooooB@3o000X003o0240003o
K03oool004<0oooo00<000000?ooo`3oool09P3ooomC0?l001l00?l07`000?mY0?ooodP0o`00:@00
o`0O0000ofd0oooo00130?ooo`030000003oool0oooo02L0ooooD`3o000N003o01l0003oJ@3ooom8
0?l002X00?l07P000?m]0?ooo`00@`3oool00`000000oooo0?ooo`0W0?oooeD0o`007@00o`0M0000
of/0ooooA`3o000Z003o01d0003oKP3oool004<0oooo00<000000?ooo`3oool0:03ooomF0?l001`0
0?l06`000?m/0?ooodL0o`00:`00o`0K0000ofl0oooo00130?ooo`030000003oool0oooo02T0oooo
E`3o000J003o01/0003oK@3ooom60?l002/00?l06`000?m_0?ooo`00@`3oool00`000000oooo0?oo
o`0Y0?oooeP0o`006P00o`0I0000ofh0ooooAP3o000/003o01T0003oL03oool004<0oooo00<00000
0?ooo`3oool0:P3ooomI0?l001P00?l06@000?m_0?ooodD0o`00;000o`0I0000og00oooo00130?oo
o`030000003oool0oooo02X0ooooF`3o000G003o01L0003oL@3ooom40?l002d00?l05`000?ma0?oo
o`00@`3oool00`000000oooo0?ooo`0[0?oooe`0o`005@00o`0G0000og40ooooA03o000^003o01H0
003oL@3oool004<0oooo00<000000?ooo`3oool0:`3ooomM0?l001D00?l05@000?mc0?oood<0o`00
;P00o`0E0000og80oooo00130?ooo`030000003oool0oooo02`0ooooGP3o000D003o01<0003oM03o
oom30?l002l00?l04`000?mc0?ooo`00@`3oool00`000000oooo0?ooo`0]0?oooel0o`004P00o`0C
0000ogD0oooo@P3o000_003o01<0003oL`3oool004<0oooo00<000000?ooo`3oool0;@3ooomP0?l0
01800?l04@000?mg0?oood40o`00<000o`0A0000og@0oooo00130?ooo`030000003oool0oooo02h0
ooooH@3o000@003o0140003oM`3ooom10?l003000?l04@000?md0?ooo`00@`3oool00`000000oooo
0?ooo`0^0?ooof<0o`003`00o`0?0000ogT0oooo@03o000a003o00l0003oM@3oool004<0oooo00<0
00000?ooo`3oool0;`3ooomT0?l000h00?l03@000?mj0?oood00o`00<P00o`0=0000ogH0oooo0013
0?ooo`030000003oool0oooo02l0ooooI@3o000=003o00d0003oN`3ooolo0?l003800?l03@000?mf
0?ooo`00@`3oool00`000000oooo0?ooo`0`0?ooofH0o`003000o`0;0000og`0oooo?`3o000c003o
00/0003oM`3oool004<0oooo00<000000?ooo`3oool0<@3ooomW0?l000X00?l02`000?mm0?oooch0
o`00<`00o`0;0000ogL0oooo00130?ooo`030000003oool0oooo0340ooooJ@3o0009003o00T0003o
O`3ooolm0?l003@00?l02@000?mh0?ooo`00@`3oool00`000000oooo0?ooo`0b0?ooofT0o`002000
o`090000ogl0oooo?@3o000d003o00T0003oN03oool004<0oooo00<000000?ooo`3oool0<P3ooom[
0?l000L00?l01`000?n10?oooc`0o`00=@00o`070000ogT0oooo00130?ooo`030000003oool0oooo
03<0ooooK03o0006003o00D0003oPP3oooll0?l003H00?l01@000?mj0?ooo`00@`3oool00`000000
oooo0?ooo`0c0?ooofh0o`001000o`050000oh<0oooo>`3o000f003o00D0003oNP3oool004<0oooo
00<000000?ooo`3oool0=03ooom^0?l000@00?l00`000?n40?oooc/0o`00=`00o`030000og/0oooo
00130?ooo`030000003oool0oooo03D0ooooK`3o0002003o00<0003oQ@3ooolj0?l003L00?l00`00
0?mk0?ooo`00@`3oool00`000000oooo0?ooo`0e0?ooog40o`0000<00?l00000o`3oool0QP3oooli
0?l003P00?l000<0003o0?ooo`3oool0NP3oool004<0oooo00<000000?ooo`3oool0=P3oooma0?l0
08P0oooo>@3o000h003o07d0oooo00130?ooo`030000003oool0oooo03H0ooooL@3o00290?ooocP0
o`00>000o`1m0?ooo`00@`3oool00`000000oooo0?ooo`0g0?ooofl0o`00RP3ooolh0?l003L00?l0
OP3oool004<0oooo00<000000?ooo`3oool0=`3ooom_0?l008/0oooo=`3o000g003o07h0oooo0013
0?ooo`030000003oool0oooo03P0ooooK@3o002=0?ooocH0o`00=P00o`1o0?ooo`00@`3oool00`00
0000oooo0?ooo`0i0?ooof`0o`00S@3ooolf0?l003H00?l0O`3oool004<0oooo00<000000?ooo`3o
ool0>@3ooom[0?l008l0oooo=@3o000e003o0800oooo00130?ooo`030000003oool0oooo03X0oooo
J@3o002@0?ooocD0o`00=@00o`200?ooo`00@`3oool00`000000oooo0?ooo`0j0?ooofT0o`00T@3o
oold0?l003@00?l0P@3oool004<0oooo00<000000?ooo`3oool0>`3ooomW0?l00980oooo=03o000c
003o0880oooo00130?ooo`030000003oool0oooo03/0ooooI`3o002C0?oooc<0o`00<`00o`220?oo
o`00@`3oool00`000000oooo0?ooo`0l0?ooofD0o`00U@3ooolb0?l003800?l0P`3oool004<0oooo
00<000000?ooo`3oool0?@3ooomT0?l009D0oooo<P3o000b003o08<0oooo00130?ooo`030000003o
ool0oooo03d0ooooH`3o002G0?oooc40o`00<@00o`240?ooo`00@`3oool00`000000oooo0?ooo`0n
0?ooof40o`00V03ooola0?l003400?l0Q03oool004<0oooo00<000000?ooo`3oool0?P3ooomQ0?l0
09T0oooo<03o000`003o08D0oooo00130?ooo`030000003oool0oooo03l0ooooG`3o002J0?oooc00
o`00;`00o`260?ooo`00@`3oool00`000000oooo0?ooo`0o0?oooel0o`00V`3oool_0?l002l00?l0
QP3oool004<0oooo00<000000?ooo`3oool0@03ooomM0?l009d0oooo;P3o000^003o08L0oooo0013
0?ooo`030000003oool0oooo0440ooooG03o002M0?ooobh0o`00;P00o`270?ooo`00@`3oool00`00
0000oooo0?ooo`110?oooe/0o`00W`3oool]0?l002d00?l0R03oool004<0oooo00<000000?ooo`3o
ool0@P3ooomI0?l00:00oooo;@3o000]003o08P0oooo00130?ooo`030000003oool0oooo0480oooo
F@3o002Q0?ooob`0o`00;000o`290?ooo`00@`3oool00`000000oooo0?ooo`130?oooeL0o`00X`3o
ool[0?l002/00?l0RP3oool004<0oooo00<000000?ooo`3oool0@`3ooomG0?l00:<0oooo:`3o000[
003o08X0oooo00130?ooo`030000003oool0oooo04@0ooooE@3o002U0?ooobX0o`00:P00o`2;0?oo
o`00@`3oool00`000000oooo0?ooo`150?oooe@0o`00Y@3ooolZ0?l002X00?l0R`3oool004<0oooo
00<000000?ooo`3oool0A@3ooomC0?l00:L0oooo:@3o000Y003o08`0oooo00130?ooo`030000003o
ool0oooo04H0ooooD@3o002X0?ooobT0o`00:@00o`2<0?ooo`00@`3oool00`000000oooo0?ooo`16
0?oooe40o`00Z@3ooolX0?l002P00?l0S@3oool004<0oooo00<000000?ooo`3oool0A`3ooom?0?l0
0:/0oooo9`3o000X003o08d0oooo00130?ooo`030000003oool0oooo04L0ooooC`3o002[0?ooobL0
o`009`00o`2>0?ooo`00@`3oool00`000000oooo0?ooo`180?ooodd0o`00[@3ooolV0?l002H00?l0
S`3oool004<0oooo00<000000?ooo`3oool0B@3ooom;0?l00:h0oooo9P3o000V003o08l0oooo0013
0?ooo`030000003oool0oooo04T0ooooB`3o002_0?ooobD0o`009@00o`2@0?ooo`00@`3oool00`00
0000oooo0?ooo`1:0?ooodT0o`00/03ooolU0?l002D00?l0T03oool004<0oooo00<000000?ooo`3o
ool0BP3ooom90?l00;40oooo903o000T003o0940oooo00130?ooo`030000003oool0oooo04/0oooo
A`3o002c0?ooob<0o`009000o`2A0?ooo`00@`3oool00`000000oooo0?ooo`1<0?ooodH0o`00/`3o
oolS0?l002<00?l0TP3oool004<0oooo00<000000?ooo`3oool0C03ooom50?l00;D0oooo8P3o000R
003o09<0oooo00130?ooo`030000003oool0oooo04d0oooo@`3o002f0?ooob80o`008P00o`2C0?oo
o`00@`3oool00`000000oooo0?ooo`1=0?oood<0o`00]`3ooolQ0?l002400?l0U03oool004<0oooo
00<000000?ooo`3oool0CP3ooom10?l00;T0oooo803o000Q003o09@0oooo00130?ooo`030000003o
ool0oooo04h0oooo@@3o002i0?ooob00o`008000o`2E0?ooo`00@`3oool00`000000oooo0?ooo`1?
0?ooocl0o`00^`3ooolO0?l002000?l0U@3oool004<0oooo00<000000?ooo`3oool0D03oooln0?l0
0;/0oooo7`3o000O003o09H0oooo00130?ooo`030000003oool0oooo0500oooo?@3o002m0?oooah0
o`007P00o`2G0?ooo`00@`3oool00`000000oooo0?ooo`1A0?oooc/0o`00_P3ooolN0?l001h00?l0
U`3oool004<0oooo00<000000?ooo`3oool0D@3ooolk0?l00;l0oooo7@3o000M003o09P0oooo0013
0?ooo`030000003oool0oooo0580oooo>@3o00310?oooa`0o`007@00o`2H0?ooo`00@`3oool00`00
0000oooo0?ooo`1B0?ooocT0o`00`@3ooolL0?l001`00?l0V@3oool004<0oooo00<000000?ooo`3o
ool0D`3ooolg0?l00<<0oooo6`3o000L003o09T0oooo00130?ooo`030000003oool0oooo05@0oooo
=P3o00330?oooa/0o`006`00o`2J0?ooo`00@`3oool00`000000oooo0?ooo`1D0?ooocD0o`00a@3o
oolJ0?l001/00?l0VP3oool004<0oooo00<000000?ooo`3oool0E@3ooolc0?l00<H0oooo6P3o000J
003o09/0oooo00130?ooo`030000003oool0oooo05D0oooo<`3o00370?oooaT0o`006@00o`2L0?oo
o`00@`3oool00`000000oooo0?ooo`1F0?oooc40o`00b@3ooolH0?l001T00?l0W03oool004<0oooo
00<000000?ooo`3oool0EP3ooola0?l00<T0oooo603o000H003o09d0oooo00130?ooo`030000003o
ool0oooo05L0oooo;`3o003;0?oooaL0o`006000o`2M0?ooo`00@`3oool00`000000oooo0?ooo`1H
0?ooobh0o`00b`3ooolG0?l001L00?l0WP3oool004<0oooo00<000000?ooo`3oool0F03oool]0?l0
0<d0oooo5P3o000G003o09h0oooo00130?ooo`030000003oool0oooo05T0oooo:`3o003?0?oooaD0
o`005P00o`2O0?ooo`00@`3oool00`000000oooo0?ooo`1I0?ooob/0o`00c`3ooolE0?l001D00?l0
X03oool004<0oooo00<000000?ooo`3oool0FP3ooolY0?l00=40oooo503o000E003o0:00oooo0013
0?ooo`030000003oool0oooo05X0oooo:@3o003A0?oooa@0o`005000o`2Q0?ooo`00@`3oool00`00
0000oooo0?ooo`1K0?ooobL0o`00d`3ooolC0?l001@00?l0X@3oool004<0oooo00<000000?ooo`3o
ool0G03ooolU0?l00=@0oooo4`3o000C003o0:80oooo00130?ooo`030000003oool0oooo05`0oooo
9@3o003E0?oooa80o`004`00o`2R0?ooo`00@`3oool00`000000oooo0?ooo`1M0?ooob<0o`00e`3o
oolA0?l001800?l0X`3oool004<0oooo00<000000?ooo`3oool0G@3ooolS0?l00=L0oooo4@3o000A
003o0:@0oooo00130?ooo`030000003oool0oooo05h0oooo8@3o003I0?oooa00o`004@00o`2T0?oo
o`00@`3oool00`000000oooo0?ooo`1N0?ooob40o`00f@3oool@0?l001000?l0Y@3oool004<0oooo
00<000000?ooo`3oool0G`3ooolO0?l00=/0oooo3`3o000@003o0:D0oooo00130?ooo`030000003o
ool0oooo0600oooo7@3o003L0?ooo`l0o`003`00o`2V0?ooo`00@`3oool00`000000oooo0?ooo`1P
0?oooad0o`00g@3oool>0?l000l00?l0YP3oool004<0oooo00<000000?ooo`3oool0H@3ooolK0?l0
0=l0oooo3@3o000>003o0:L0oooo00130?ooo`030000003oool0oooo0640oooo6`3o003O0?ooo`d0
o`003P00o`2W0?ooo`00@`3oool00`000000oooo0?ooo`1R0?oooaT0o`00h@3oool<0?l000d00?l0
Z03oool004<0oooo00<000000?ooo`3oool0HP3ooolI0?l00>40oooo303o000<003o0:T0oooo0013
0?ooo`030000003oool0oooo06<0oooo5`3o003S0?ooo`/0o`003000o`2Y0?ooo`00@`3oool00`00
0000oooo0?ooo`1T0?oooaD0o`00i@3oool:0?l000/00?l0ZP3oool004<0oooo00<000000?ooo`3o
ool0I03ooolE0?l00>D0oooo2P3o000;003o0:X0oooo00130?ooo`030000003oool0oooo06D0oooo
4`3o003W0?ooo`T0o`002P00o`2[0?ooo`00@`3oool00`000000oooo0?ooo`1U0?oooa<0o`00i`3o
ool90?l000X00?l0Z`3oool004<0oooo00<000000?ooo`3oool0IP3ooolA0?l00>T0oooo203o0009
003o0:`0oooo00130?ooo`030000003oool0oooo06H0oooo4@3o003Y0?ooo`P0o`002000o`2]0?oo
o`00@`3oool00`000000oooo0?ooo`1W0?ooo`l0o`00j`3oool70?l000P00?l0[@3oool004<0oooo
00<000000?ooo`3oool0J03oool=0?l00>d0oooo1P3o0007003o0:h0oooo00130?ooo`030000003o
ool0oooo06P0oooo3@3o003]0?ooo`H0o`001`00o`2^0?ooo`00@`3oool00`000000oooo0?ooo`1Y
0?ooo`/0o`00k`3oool50?l000H00?l0[`3oool004<0oooo00<000000?ooo`3oool0J@3oool;0?l0
0>l0oooo1@3o0006003o0:l0oooo00130?ooo`030000003oool0oooo06X0oooo2@3o003a0?ooo`@0
o`001@00o`2`0?ooo`00@`3oool00`000000oooo0?ooo`1Z0?ooo`T0o`00l@3oool40?l000@00?l0
/@3oool004<0oooo00<000000?ooo`3oool0J`3oool70?l00?<0oooo0`3o0004003o0;40oooo0013
0?ooo`030000003oool0oooo06`0oooo1@3o003e0?ooo`80o`000`00o`2b0?ooo`00@`3oool00`00
0000oooo0?ooo`1/0?ooo`D0o`00m@3oool20?l000<00?l0/P3oool004<0oooo00<000000?ooo`3o
ool0K@3oool30?l00?L0oooo00<0o`00003o0000o`00/`3oool004<0oooo00<000000?ooo`3oool0
K@3oool30?l00?L0oooo00<0o`00003o0000o`00/`3oool004<0oooo00<000000?ooo`3oool0KP3o
ool00`3o0000oooo0?ooo`3g0?ooo`03003o003oool0oooo0;80oooo00130?ooo`030000003oool0
oooo0?l0ooooo`3ooolO0?ooo`00@`3oool00`000000oooo0?ooo`3o0?ooool0oooo7`3oool004<0
oooo00<000000?ooo`3oool0o`3ooooo0?oooal0oooo00130?ooo`030000003oool0oooo0?l0oooo
o`3ooolO0?ooo`00@`3oool00`000000oooo0?ooo`3o0?ooool0oooo7`3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3o
oooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00c@3oool2000001/0oooo0`00000E
0?ooo`<000005P3oool2000001H0oooo0P00000F0?ooo`8000005@3oool4000001@0oooo0`00000F
0?ooo`800000cP3oool00<`0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00
000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000503oool010000000
oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00<000000?ooo`3oool05@3oool0
10000000oooo0?ooo`00000D0?ooo`040000003oool0oooo00000<d0oooo003>0?ooo`030000003o
ool0oooo01T0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00000F0?ooo`03
0000003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0D0?ooo`03
0000003oool0oooo01@0oooo00@000000?ooo`3oool000005P3oool00`000000oooo0?ooo`3<0?oo
o`00c`3oool00`000000oooo0?ooo`0H0?ooo`<000005@3oool3000001P0oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3o
ool04`3oool3000001P0oooo00<000000?ooo`3oool0b`3oool00<`0oooo00@000000?ooo`3oool0
00006`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01@0oooo00@000000?ooo`3o
ool00000503oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@0
00000?ooo`3oool000005@3oool00`000000oooo0?ooo`0D0?ooo`040000003oool0oooo00000<d0
oooo003=0?ooo`800000703oool3000001D0oooo0`00000E0?ooo`8000005P3oool2000001H0oooo
0P00000F0?ooo`8000005P3oool3000001D0oooo0P00003>0?ooo`00o`3ooooo0?ooofD0oooo003o
0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0oooo
I@3oool00?l0ooooo`3ooomU0?ooo`00``3oool00`000000oooo0?ooo`3H0?ooo`030000003oool0
oooo0<80oooo00320?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool05@3oool00`00
0000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`00
0000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`00
0000oooo0?ooo`0E0?ooo`030000003oool0oooo0<40oooo00320?ooo`030000003oool0oooo01X0
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0<40
oooo00320?ooo`040000003oool0oooo0?ooo`@000000P3oool400000080oooo100000020?ooo`@0
0000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3o
ool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@0
0000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3o
ool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@0
0000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3o
ool01`3oool400000080oooo100000030?ooo`030000003oool0oooo0<40oooo00310?ooo`030000
003oool0oooo0=`0oooo00<000000?ooo`3oool0`03oool00<80oooo00<000000?ooo`3oool0fP3o
ool00`000000oooo0?ooo`310?ooo`00`P3oool00`000000oooo0?ooo`3J0?ooo`030000003oool0
oooo0<40oooo00330?ooo`030000003oool0oooo0=P0oooo00<000000?ooo`3oool0`P3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00aP3o
ool4000000L0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000=0?ooo`<000001@3o
ool3000000d0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000=0?ooo`<000001@3o
ool3000000d0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000=0?ooo`<000001@3o
ool300000<L0oooo00360?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo0<H0oooo00370?ooo`030000003oool0oooo
00P0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo
00d0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo
00d0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo
00d0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo
00d0oooo0`0000050?ooo`030000003oool0oooo0<H0oooo00380?ooo`030000003oool0oooo00L0
oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool2
000000l0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool00000
0`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3o
ool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@00000
0?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool200000<P0oooo
00360?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000503oool010000000
oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000503o
ool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000503oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo00000<d0oooo0037
0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<00000
0?ooo`3oool0303oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<00000
0?ooo`3oool0303oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<00000
0?ooo`3oool0303oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<00000
0?ooo`3oool0303oool4000000D0oooo00<000000?ooo`3oool0aP3oool00?l0ooooo`3ooomU0?oo
o`00o`3ooooo0?ooofD0oooo0000\
\>"],
  ImageRangeCache->{{{0, 610.813}, {251.313, 0}} -> {-0.28201, -0.0206241, \
0.00419772, 0.00419772}, {{67.125, 294.063}, {246.375, 49.875}} -> {-1.59187, \
-0.043531, 0.00881464, 0.00881464}, {{316.75, 543.625}, {246.375, 49.875}} -> \
{-3.79232, -0.043621, 0.00881551, 0.00881551}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(Pi) show
153.000 12.750 moveto
(Pi) show
177.000 12.750 moveto
(2) show
189.000 12.750 moveto
(Pi) show
213.000 12.750 moveto
(2) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(2) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
153.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
165.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
177.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
189.000 25.875 moveto
(--) show
201.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
213.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
225.000 25.875 moveto
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(5) show
129.000 39.000 moveto
(5) show
153.000 39.000 moveto
(5) show
183.000 39.000 moveto
(5) show
219.000 39.000 moveto
(5) show
255.000 39.000 moveto
(5) show
285.000 39.000 moveto
(5) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -2.23075e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.38197 0 L
.5 .36327 L
F
0 0 1 r
.38197 0 m
1 0 L
.5 .36327 L
F
1 0 0 r
0 0 m
.5 .36327 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -1.19262e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.38197 0 m
.5 .36327 L
.19098 .58779 L
F
0 0 1 r
.19098 .58779 m
0 0 L
.38197 0 L
F
1 0 0 r
.38197 0 m
1 0 L
.5 .36327 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000Zb000`400?l00000o`00003oF`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?oo
o`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00D03ooooo00000<@00000
D03oool005/0oooo00<000000?l00000o`00C000o`1l0000oaH0ooooC@000?l00`00o`00o`000?l0
001j0?l005d0oooo001K0?ooo`030000003o0000o`0004`00?l0N`000?lG0?ooodd0003o00<00?l0
0?l0003o0000N@3o001N0?ooo`00F`3oool00`000000o`000?l000020?l004X00?l0N@000?lI0?oo
odd0003o00<00?l00?l0003o0000M`3o001P0?ooo`00F`3oool00`000000oooo0?l000030?l004X0
0?l0M`000?lK0?oood/0003o0`00o`1g0?l00640oooo001K0?ooo`030000003oool0o`0000@0o`00
B@00o`1f0000oa`0ooooB`000?l3003o07H0o`00HP3oool005/0oooo00<000000?ooo`3o00001P3o
0017003o07@0003o7P3ooom;0000o`<00?l0M03o001T0?ooo`00F`3oool00`000000oooo0?ooo`07
0?l004L00?l0LP000?lP0?ooodT0003o1@00o`1b0?l006D0oooo001K0?ooo`030000003oool0oooo
00T0o`00A@00o`1`0000ob80ooooB@000?l5003o0700o`00I`3oool005/0oooo00<000000?ooo`3o
ool02P3o0014003o06l0003o8`3ooom90000o`D00?l0K`3o001X0?ooo`00F`3oool010000000oooo
0?ooo`3oool:0?l004@00?l0K@000?lU0?ooodL0003o1`00o`1]0?l006T0oooo001K0?ooo`040000
003oool0oooo0?ooo``0o`00@P00o`1[0000obL0ooooA`000?l7003o06/0o`00J`3oool005/0oooo
00@000000?ooo`3oool0oooo3@3o0011003o06X0003o:03ooom70000o`L00?l0JP3o001/0?ooo`00
F`3oool00`000000oooo0?ooo`020?ooo`d0o`00@@00o`1X0000obX0ooooA@000?l9003o06P0o`00
K@3oool005/0oooo00<000000?ooo`3oool00P3oool?0?l003l00?l0IP000?l/0?ooodD0003o2@00
o`1V0?l006l0oooo001K0?ooo`030000003oool0oooo0080oooo403o000n003o06D0003o;@3ooom5
0000o`T00?l0I@3o001`0?ooo`00F`3oool00`000000oooo0?ooo`030?oooa40o`00?@00o`1R0000
oc00oooo@`000?l;003o0680o`00LP3oool005/0oooo00<000000?ooo`3oool00`3ooolB0?l003`0
0?l0H@000?la0?oood<0003o2`00o`1Q0?l007<0oooo001K0?ooo`030000003oool0oooo00<0oooo
4`3o000k003o0600003o<P3ooom30000o`/00?l0H03o001d0?ooo`00F`3oool00`000000oooo0?oo
o`040?oooa@0o`00>P00o`1M0000ocD0oooo@@000?l=003o05d0o`00MP3oool005/0oooo00<00000
0?ooo`3oool0103ooolE0?l003T00?l0G0000?lf0?oood40003o3@00o`1L0?l007L0oooo001K0?oo
o`030000003oool0oooo00@0oooo5P3o000h003o05/0003o=`3ooom10000o`d00?l0F`3o001h0?oo
o`00F`3oool00`000000oooo0?ooo`050?oooaL0o`00=`00o`1H0000ocX0oooo?`000?l?003o05P0
o`00NP3oool005/0oooo00<000000?ooo`3oool01@3ooolH0?l003H00?l0E`000?lk0?ooocl0003o
3`00o`1G0?l007/0oooo001K0?ooo`030000003oool0oooo00D0oooo6P3o000d003o05D0003o?@3o
oolo0000o`l00?l0E@3o001m0?ooo`00F`3oool00`000000oooo0?ooo`060?oooaX0o`00=000o`1C
0000ocl0oooo?@000?lA003o05<0o`00OP3oool005/0oooo00<000000?ooo`3oool01P3ooolK0?l0
03<00?l0DP000?m00?ooocd0003o4@00o`1B0?l007l0oooo001K0?ooo`030000003oool0oooo00H0
oooo7@3o000a003o0500003o@P3ooolm0000oa400?l0D03o00210?ooo`00F`3oool00`000000oooo
0?ooo`070?oooad0o`00<@00o`1>0000od@0oooo>`000?lC003o04h0o`00PP3oool005/0oooo00<0
00000?ooo`3oool01`3ooolN0?l003000?l0C@000?m50?oooc/0003o4`00o`1=0?l008<0oooo001K
0?ooo`030000003oool0oooo00L0oooo803o000^003o04/0003oA`3ooolk0000oa<00?l0B`3o0025
0?ooo`00F`3oool00`000000oooo0?ooo`080?ooob00o`00;P00o`190000odT0oooo>@000?lE003o
04T0o`00QP3oool005/0oooo00<000000?ooo`3oool0203ooolR0?l002`00?l0A`000?m;0?ooocT0
003o5@00o`170?l008P0oooo001K0?ooo`030000003oool0oooo00P0oooo8`3o000[003o04H0003o
C03oooli0000oaD00?l0AP3o00290?ooo`00F`3oool00`000000oooo0?ooo`090?ooob<0o`00:`00
o`140000odh0oooo=`000?lG003o04@0o`00RP3oool005/0oooo00<000000?ooo`3oool02@3ooolU
0?l002T00?l0@P000?m@0?ooocL0003o5`00o`120?l008`0oooo001K0?ooo`030000003oool0oooo
00T0oooo9P3o000X003o0440003oD@3ooolg0000oaL00?l0@@3o002=0?ooo`00F`3oool00`000000
oooo0?ooo`0:0?ooobH0o`009`00o`0o0000oe@0oooo=@000?lH003o03l0o`00S`3oool005/0oooo
00<000000?ooo`3oool02P3ooolX0?l002H00?l0?@000?mE0?ooocD0003o6@00o`0m0?l00900oooo
001K0?ooo`030000003oool0oooo00X0oooo:@3o000U003o03`0003oEP3ooole0000oaT00?l0?03o
002A0?ooo`00F`3oool00`000000oooo0?ooo`0:0?ooob/0o`008`00o`0j0000oeP0oooo=0000?lJ
003o03X0o`00T`3oool005/0oooo00<000000?ooo`3oool02`3oool[0?l002<00?l0>0000?mJ0?oo
oc<0003o6`00o`0h0?l009@0oooo001K0?ooo`030000003oool0oooo00/0oooo;03o000R003o03L0
003oF`3ooolc0000oa/00?l0=`3o002E0?ooo`00F`3oool00`000000oooo0?ooo`0;0?ooobh0o`00
8000o`0e0000oed0oooo<`000?lK003o03D0o`00U`3oool005/0oooo00<000000?ooo`3oool0303o
ool^0?l002000?l0<`000?mO0?oooc40003o7@00o`0c0?l009P0oooo001K0?ooo`030000003oool0
oooo00`0oooo<03o000N003o0340003oH@3ooola0000oad00?l0<@3o002J0?ooo`00F`3oool00`00
0000oooo0?ooo`0<0?oooc40o`007@00o`0`0000of80oooo<@000?lM003o0300o`00V`3oool005/0
oooo00<000000?ooo`3oool03@3ooola0?l001d00?l0;P000?mT0?ooobl0003o7`00o`0^0?l009`0
oooo001K0?ooo`030000003oool0oooo00d0oooo<`3o000K003o02`0003oIP3oool_0000oal00?l0
;03o002N0?ooo`00F`3oool00`000000oooo0?ooo`0=0?oooc@0o`006P00o`0[0000ofL0oooo;`00
0?lO003o02/0o`00W`3oool005/0oooo00<000000?ooo`3oool03P3ooold0?l001X00?l0:@000?mY
0?ooobd0003o8@00o`0Y0?l00:00oooo001K0?ooo`030000003oool0oooo00h0oooo=P3o000H003o
02L0003oJ`3oool]0000ob400?l09`3o002R0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooocL0
o`005`00o`0V0000of`0oooo;@000?lQ003o02H0o`00X`3oool005/0oooo00<000000?ooo`3oool0
3`3ooolh0?l001H00?l08`000?m_0?ooob/0003o8`00o`0S0?l00:D0oooo001K0?ooo`030000003o
ool0oooo00l0oooo>@3o000E003o0280003oL03oool[0000ob<00?l08P3o002V0?ooo`00F`3oool0
0`000000oooo0?ooo`0?0?ooocX0o`005000o`0Q0000og40oooo:`000?lS003o0240o`00Y`3oool0
05/0oooo00<000000?ooo`3oool0403ooolk0?l001<00?l07P000?md0?ooobT0003o9@00o`0N0?l0
0:T0oooo001K0?ooo`030000003oool0oooo0100oooo?03o000B003o01d0003oM@3ooolY0000obD0
0?l07@3o002Z0?ooo`00F`3oool00`000000oooo0?ooo`0@0?ooocd0o`004@00o`0L0000ogH0oooo
:@000?lU003o01`0o`00Z`3oool005/0oooo00<000000?ooo`3oool04@3oooln0?l001000?l06@00
0?mi0?ooobL0003o9`00o`0I0?l00:d0oooo001K0?ooo`030000003oool0oooo0140oooo?`3o000?
003o01P0003oNP3ooolW0000obL00?l0603o002^0?ooo`00F`3oool00`000000oooo0?ooo`0A0?oo
od40o`003@00o`0F0000og`0oooo9`000?lW003o01H0o`00/03oool005/0oooo00<000000?ooo`3o
ool04P3ooom10?l000d00?l050000?mn0?ooobD0003o:@00o`0D0?l00;40oooo001K0?ooo`030000
003oool0oooo0180oooo@P3o000<003o01<0003oO`3ooolU0000obT00?l04`3o002b0?ooo`00F`3o
ool00`000000oooo0?ooo`0B0?oood@0o`002P00o`0A0000oh40oooo9@000?lY003o0140o`00]03o
ool005/0oooo00<000000?ooo`3oool04`3ooom40?l000X00?l03`000?n30?ooob<0003o:`00o`0?
0?l00;D0oooo001K0?ooo`030000003oool0oooo01<0ooooA@3o0009003o00h0003oQ03ooolS0000
ob/00?l03P3o002f0?ooo`00F`3oool00`000000oooo0?ooo`0C0?ooodL0o`001`00o`0<0000ohH0
oooo8`000?l[003o00`0o`00^03oool005/0oooo00<000000?ooo`3oool0503ooom70?l000L00?l0
2P000?n80?ooob40003o;@00o`0:0?l00;T0oooo001K0?ooo`030000003oool0oooo01@0ooooB@3o
0005003o00P0003oRP3ooolQ0000obd00?l0203o002k0?ooo`00F`3oool00`000000oooo0?ooo`0D
0?ooodX0o`001000o`070000oh/0oooo8@000?l]003o00L0o`00_03oool005/0oooo00<000000?oo
o`3oool05@3ooom:0?l000@00?l01@000?n=0?oooal0003o;`00o`050?l00;d0oooo001K0?ooo`03
0000003oool0oooo01D0ooooC03o0002003o00<0003oS`3ooolO0000obl00?l00`3o002o0?ooo`00
F`3oool00`000000oooo0?ooo`0E0?ooodd0o`0000<00?l00000o`000?l0T03ooolO0000obl00?l0
0P3o00300?ooo`00F`3oool00`000000oooo0?ooo`0F0?ooodd0o`00T`3ooolM0000oc000?l0`P3o
ool005/0oooo00<000000?ooo`3oool05P3ooom<0?l009@0oooo7@000?l_003o0<<0oooo001K0?oo
o`030000003oool0oooo01H0ooooB`3o002E0?oooad0003o;P00o`340?ooo`00F`3oool00`000000
oooo0?ooo`0G0?ooodP0o`00V03ooolK0000obd00?l0aP3oool005/0oooo00<000000?ooo`3oool0
5`3ooom70?l009T0oooo6`000?l/003o0<L0oooo001K0?ooo`030000003oool0oooo01L0ooooAP3o
002J0?oooa/0003o:`00o`380?ooo`00F`3oool00`000000oooo0?ooo`0G0?oood@0o`00W03ooolJ
0000obX00?l0bP3oool005/0oooo00<000000?ooo`3oool0603ooom20?l009h0oooo6@000?lY003o
0</0oooo001K0?ooo`030000003oool0oooo01P0oooo@@3o002O0?oooaT0003o:000o`3<0?ooo`00
F`3oool00`000000oooo0?ooo`0H0?ooocl0o`00X@3ooolI0000obH00?l0cP3oool005/0oooo00<0
00000?ooo`3oool06@3ooolm0?l00:<0oooo5`000?lV003o0<l0oooo001K0?ooo`030000003oool0
oooo01T0oooo>`3o002U0?oooaL0003o9000o`3A0?ooo`00F`3oool00`000000oooo0?ooo`0I0?oo
ocX0o`00YP3ooolG0000ob<00?l0dP3oool005/0oooo00<000000?ooo`3oool06P3ooolh0?l00:P0
oooo5@000?lS003o0=<0oooo001K0?ooo`030000003oool0oooo01X0oooo=P3o002Z0?oooaD0003o
8@00o`3E0?ooo`00F`3oool00`000000oooo0?ooo`0J0?ooocD0o`00Z`3ooolE0000ob000?l0eP3o
ool005/0oooo00<000000?ooo`3oool06`3ooolc0?l00:d0oooo4`000?lP003o0=L0oooo001K0?oo
o`030000003oool0oooo01/0oooo<@3o002_0?oooa<0003o7P00o`3I0?ooo`00F`3oool00`000000
oooo0?ooo`0K0?oooc00o`00/03ooolC0000oad00?l0fP3oool005/0oooo00<000000?ooo`3oool0
703oool]0?l00;<0oooo4@000?lL003o0=`0oooo001K0?ooo`030000003oool0oooo01`0oooo;03o
002d0?oooa40003o6`00o`3M0?ooo`00F`3oool00`000000oooo0?ooo`0L0?ooob/0o`00]@3ooolA
0000oaX00?l0gP3oool005/0oooo00<000000?ooo`3oool07@3ooolX0?l00;P0oooo3`000?lI003o
0>00oooo001K0?ooo`030000003oool0oooo01d0oooo9`3o002i0?ooo`l0003o6000o`3Q0?ooo`00
F`3oool00`000000oooo0?ooo`0M0?ooobH0o`00^P3oool?0000oaL00?l0hP3oool005/0oooo00<0
00000?ooo`3oool07P3ooolS0?l00;d0oooo3@000?lF003o0>@0oooo001K0?ooo`030000003oool0
oooo01h0oooo8P3o002n0?ooo`d0003o5@00o`3U0?ooo`00F`3oool00`000000oooo0?ooo`0N0?oo
ob40o`00_`3oool=0000oa@00?l0iP3oool005/0oooo00<000000?ooo`3oool07`3ooolN0?l00<80
oooo2`000?lC003o0>P0oooo001K0?ooo`030000003oool0oooo01l0oooo7@3o00330?ooo`/0003o
4P00o`3Y0?ooo`00F`3oool00`000000oooo0?ooo`0O0?oooa/0o`00a@3oool;0000oa000?l0j`3o
ool005/0oooo00<000000?ooo`3oool0803ooolI0?l00<L0oooo2@000?l@003o0>`0oooo001K0?oo
o`030000003oool0oooo0200oooo603o00380?ooo`T0003o3`00o`3]0?ooo`00F`3oool00`000000
oooo0?ooo`0P0?oooaH0o`00bP3oool90000o`d00?l0k`3oool005/0oooo00<000000?ooo`3oool0
8@3ooolD0?l00<`0oooo1`000?l=003o0?00oooo001K0?ooo`030000003oool0oooo0240oooo4`3o
003=0?ooo`L0003o3000o`3a0?ooo`00F`3oool00`000000oooo0?ooo`0Q0?oooa40o`00c`3oool7
0000o`X00?l0l`3oool005/0oooo00<000000?ooo`3oool08P3oool?0?l00=40oooo1@000?l:003o
0?@0oooo001K0?ooo`030000003oool0oooo0280oooo3@3o003C0?ooo`D0003o2000o`3f0?ooo`00
F`3oool00`000000oooo0?ooo`0R0?ooo``0o`00e03oool50000o`L00?l0m`3oool005/0oooo00<0
00000?ooo`3oool08`3oool:0?l00=H0oooo0`000?l7003o0?P0oooo001K0?ooo`030000003oool0
oooo02<0oooo203o003H0?ooo`<0003o1@00o`3j0?ooo`00F`3oool00`000000oooo0?ooo`0S0?oo
o`L0o`00f@3oool30000o`@00?l0n`3oool005/0oooo00<000000?ooo`3oool0903oool50?l00=/0
oooo00<0003o003o0000o`000P00o`3l0?ooo`00F`3oool00`000000oooo0?ooo`0T0?ooo`<0o`00
g@3oool00`000?l00?l0003o003n0?ooo`00F`3oool00`000000oooo0?ooo`0T0?ooo`80o`00gP3o
ool00`000?l00?l00?ooo`3n0?ooo`00F`3oool00`000000oooo0?ooo`3o0?ooool0oooo1`3oool0
05/0oooo00<000000?ooo`3oool0o`3ooooo0?ooo`L0oooo001K0?ooo`030000003oool0oooo0?l0
ooooo`3oool70?ooo`00F`3oool00`000000oooo0?ooo`3o0?ooool0oooo1`3oool00?l0ooooo`3o
oomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00
o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?oo
ofD0oooo003o0?ooool0ooooI@3oool00;D0oooo0P00000L0?ooo`8000005P3oool2000001H0oooo
0P00000L0?ooo`8000008P3oool200000280oooo0P00000L0?ooo`800000703oool200000;`0oooo
002d0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool00000503oool010000000
oooo0?ooo`00000D0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool00000803o
ool010000000oooo0?ooo`00000P0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3o
ool000006P3oool010000000oooo0?ooo`00002k0?ooo`00]`3oool00`000000oooo0?ooo`0K0?oo
o`030000003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0K0?oo
o`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?oo
o`030000003oool0oooo01/0oooo00<000000?ooo`3oool0^@3oool00;D0oooo0P00000L0?ooo`80
00005P3oool2000001H0oooo0P00000L0?ooo`8000008P3oool200000280oooo0P00000L0?ooo`80
0000703oool200000;`0oooo002e0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0
8@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0
6`3oool00`000000oooo0?ooo`2k0?ooo`00]@3oool3000001/0oooo0`00000E0?ooo`<000005@3o
ool3000001/0oooo0`00000Q0?ooo`<000008@3oool3000001/0oooo0`00000K0?ooo`<00000^`3o
ool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0oooo
o`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00:/0oooo00<000000?oo
o`3oool0o`3oool90?ooo`030000003oool0oooo0:X0oooo002Z0?ooo`030000003oool0oooo01X0
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0
oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0:T0
oooo002Z0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool05@3oool00`000000oooo
0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo
0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo
0?ooo`0Q0?ooo`030000003oool0oooo0:T0oooo002Z0?ooo`040000003oool0oooo0?ooo`@00000
0P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@00000
0P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo100000040?ooo`030000
003oool0oooo00L0oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@00000
0P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@00000
0P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@00000
0P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@00000
0P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@00000
0P3oool4000000<0oooo00<000000?ooo`3oool0Z@3oool00:T0oooo00<000000?ooo`3oool0o`3o
ool=0?ooo`030000003oool0oooo0:P0oooo002Z0?ooo`030000003oool0oooo0?l0oooo2`3oool0
0`000000oooo0?ooo`2Y0?ooo`00ZP3oool00`000000oooo0?ooo`3o0?ooo`/0oooo00<000000?oo
o`3oool0Z@3oool00:/0oooo00<000000?ooo`3oool0o`3oool90?ooo`030000003oool0oooo0:X0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?oo
ool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3o
ool00:l0oooo0P0000080?ooo`<000001@3oool3000000d0oooo0`0000050?ooo`<000003@3oool3
000000D0oooo0`00000=0?ooo`<000001@3oool3000000h0oooo100000070?ooo`<000001@3oool3
000000h0oooo100000070?ooo`<000001@3oool3000000h0oooo100000070?ooo`<000001@3oool3
000000d0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`0000050?ooo`<00000[`3oool0
0:h0oooo00@000000?ooo`3oool00000203oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00d0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00d0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00d0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0
oooo00T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`2^0?ooo`00/03oool00`00
0000oooo0?ooo`070?ooo`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`00
0000oooo0?ooo`0=0?ooo`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`00
0000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo
00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?ooo`3oool03P3oool00`00
0000oooo0?ooo`080?ooo`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`00
0000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo
0:h0oooo002a0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool000000`3oool20000
00l0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3o
ool2000000l0oooo00@000000?ooo`3oool000000`3oool200000140oooo00<000000?ooo`3oool0
1`3oool010000000oooo0?ooo`0000030?ooo`8000004@3oool00`000000oooo0?ooo`070?ooo`04
0000003oool0oooo000000<0oooo0P00000A0?ooo`030000003oool0oooo00L0oooo00@000000?oo
o`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool200000140oooo00<0
00000?ooo`3oool01`3oool010000000oooo0?ooo`0000030?ooo`800000/03oool00:h0oooo00@0
00000?ooo`3oool00000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo0000
01@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00000D0?ooo`040000003o
ool0oooo000000P0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?oo
o`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool010000000oooo0?oo
o`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool01000
0000oooo0?ooo`00002e0?ooo`00[`3oool2000000P0oooo100000050?ooo`030000003oool0oooo
00`0oooo100000050?ooo`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo
00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool00`00
0000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool03P3oool20000
00P0oooo100000050?ooo`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo
00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`2^0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool00001\
\>"],
  ImageRangeCache->{{{0, 610.563}, {170.188, 0}} -> {-0.426205, -0.013998, \
0.00467178, 0.00467178}, {{91.1875, 295.063}, {167.188, 47.3125}} -> \
{-1.34175, -0.0239702, 0.00793648, 0.00793648}, {{315.438, 519.313}, \
{167.188, 47.3125}} -> {-3.12151, -0.0239702, 0.00793648, 0.00793648}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .16569 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00394499 0.47619 [
[.5 .17819 -146 0 ]
[.5 .17819 146 38.75 ]
[ 0 0 0 0 ]
[ 1 .16569 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00394 m
1 .00394 L
s
.02381 0 m
.02381 .16569 L
s
gsave
.5 .17819 -207 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(3) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(4) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(2) show
237.000 12.750 moveto
(Pi) show
261.000 12.750 moveto
(2) show
273.000 12.750 moveto
(Pi) show
297.000 12.750 moveto
(Pi) show
321.000 12.750 moveto
(4) show
333.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
(--) show
249.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
261.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
273.000 25.875 moveto
(--) show
285.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
297.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
309.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
321.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
333.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
345.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
105.000 39.000 moveto
(7) show
135.000 39.000 moveto
(7) show
165.000 39.000 moveto
(7) show
195.000 39.000 moveto
(7) show
231.000 39.000 moveto
(7) show
267.000 39.000 moveto
(7) show
297.000 39.000 moveto
(7) show
327.000 39.000 moveto
(7) show
333.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .16569 L
0 .16569 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00394499 0.477324 0.161744 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.198062 0.801938 2.1684e-019 0.801938 [
[ 0 0 0 0 ]
[ 1 .34795 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .34795 L
0 .34795 L
closepath
clip
newpath
0 1 0 r
0 0 m
.55496 0 L
.5 .24079 L
F
0 0 1 r
.55496 0 m
1 0 L
.5 .24079 L
F
1 0 0 r
0 0 m
.5 .24079 L
.27748 .34795 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00394499 0.97619 0.161744 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.198062 0.801938 1.12079e-017 0.801938 [
[ 0 0 0 0 ]
[ 1 .34795 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .34795 L
0 .34795 L
closepath
clip
newpath
0 1 0 r
.19806 0 m
.42058 .27903 L
.27748 .34795 L
F
0 0 1 r
.27748 .34795 m
0 0 L
.19806 0 L
F
1 0 0 r
.19806 0 m
1 0 L
.42058 .27903 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.438, 101.313},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000IB000`400?l00000o`00003oS03oool0
0`000000oooo0?ooo`3o0?ooomD0oooo002<0?ooo`030000003oool0oooo0?l0ooooe@3oool008@0
ooooo`00001K000008D0oooo002<0?ooo`030000003o0000o`0005@00?l0A0000?lC0?oooal0003o
NP3o002@0?ooo`00S03oool00`000000oooo0?l000020?l005800?l0@P000?lF0?oooah0003o00<0
0?l00?l0003o0000M@3o002B0?ooo`00S03oool00`000000oooo0?ooo`040?l005000?l0@0000?lI
0?oooad0003o0P00o`1d0?l009@0oooo002<0?ooo`040000003oool0oooo0?ooo`D0o`00CP00o`0n
0000oa`0oooo70000?l3003o0740o`00UP3oool008`0oooo00<000000?ooo`3oool00P3oool60?l0
04/00?l0?@000?lN0?oooad0003o0P00o`1_0?l009P0oooo002<0?ooo`030000003oool0oooo0080
oooo203o0019003o03/0003o8@3ooolL0000o`<00?l0K03o002J0?ooo`00S03oool00`000000oooo
0?ooo`030?ooo`T0o`00A`00o`0i0000ob@0oooo6`000?l4003o06T0o`00W03oool008`0oooo00<0
00000?ooo`3oool0103oool;0?l004@00?l0=`000?lW0?oooaX0003o1@00o`1V0?l009h0oooo002<
0?ooo`030000003oool0oooo00D0oooo303o0012003o03D0003o:P3ooolI0000o`H00?l0HP3o002Q
0?ooo`00S03oool00`000000oooo0?ooo`060?ooo`d0o`00?`00o`0c0000obd0oooo6P000?l5003o
0600o`00X`3oool008`0oooo00<000000?ooo`3oool01P3oool?0?l003d00?l0<@000?l`0?oooaT0
003o1P00o`1M0?l00:D0oooo002<0?ooo`030000003oool0oooo00L0oooo403o000k003o02l0003o
<`3ooolH0000o`L00?l0FP3o002W0?ooo`00S03oool00`000000oooo0?ooo`080?oooa40o`00>@00
o`0]0000ocH0oooo5`000?l8003o05L0o`00Z@3oool008`0oooo00<000000?ooo`3oool02@3ooolB
0?l003H00?l0;0000?li0?oooaL0003o2000o`1D0?l00:/0oooo002<0?ooo`030000003oool0oooo
00X0oooo503o000c003o02X0003o>`3ooolG0000o`P00?l0DP3o002]0?ooo`00S03oool00`000000
oooo0?ooo`0;0?oooaD0o`00<@00o`0X0000och0oooo5P000?l9003o04l0o`00[`3oool008`0oooo
00<000000?ooo`3oool02`3ooolG0?l002l00?l09P000?m10?oooaD0003o2P00o`1<0?l00;40oooo
002<0?ooo`030000003oool0oooo00`0oooo603o000]003o02@0003oA03ooolD0000o`/00?l0B03o
002d0?ooo`00S03oool00`000000oooo0?ooo`0=0?oooaT0o`00:P00o`0R0000odP0oooo50000?l;
003o04D0o`00]P3oool008`0oooo00<000000?ooo`3oool03P3ooolJ0?l002P00?l080000?m:0?oo
oa@0003o2`00o`130?l00;P0oooo002<0?ooo`030000003oool0oooo00l0oooo6`3o000V003o01h0
003oC@3ooolC0000o``00?l0@03o002j0?ooo`00S03oool00`000000oooo0?ooo`0?0?oooad0o`00
9000o`0L0000oe00oooo4P000?l=003o03d0o`00_03oool008`0oooo00<000000?ooo`3oool0403o
oolO0?l002400?l06P000?mC0?oooa80003o3@00o`0j0?l00;h0oooo002<0?ooo`030000003oool0
oooo0140oooo803o000N003o01T0003oEP3ooolA0000o`d00?l0>03o00300?ooo`00S03oool00`00
0000oooo0?ooo`0B0?ooob40o`007000o`0G0000oeP0oooo4@000?l>003o03D0o`00`P3oool008`0
oooo00<000000?ooo`3oool04`3ooolR0?l001X00?l05@000?mK0?oooa00003o3`00o`0a0?l00<D0
oooo002<0?ooo`030000003oool0oooo01<0oooo903o000H003o01<0003oGP3oool?0000oa000?l0
;P3o00370?ooo`00S03oool00`000000oooo0?ooo`0D0?ooobD0o`005@00o`0A0000of80oooo3`00
0?l@003o02/0o`00b@3oool008`0oooo00<000000?ooo`3oool05@3ooolV0?l001<00?l03`000?mU
0?ooo`h0003o4000o`0Y0?l00</0oooo002<0?ooo`030000003oool0oooo01H0oooo:03o000@003o
00d0003oI`3oool>0000oa400?l09P3o003=0?ooo`00S03oool00`000000oooo0?ooo`0G0?ooobT0
o`003P00o`0;0000ofX0oooo3@000?lB003o02<0o`00c`3oool008`0oooo00<000000?ooo`3oool0
603ooolZ0?l000`00?l02@000?m]0?ooo`d0003o4P00o`0P0?l00=40oooo002<0?ooo`030000003o
ool0oooo01P0oooo;03o0009003o00P0003oL03oool<0000oa<00?l07@3o003C0?ooo`00S03oool0
0`000000oooo0?ooo`0I0?ooobd0o`001`00o`060000og<0oooo2`000?lC003o01/0o`00e@3oool0
08`0oooo00<000000?ooo`3oool06P3oool^0?l000D00?l010000?me0?ooo`/0003o5000o`0G0?l0
0=P0oooo002<0?ooo`030000003oool0oooo01/0oooo;`3o0003003o0080003oN03oool:0000oaD0
0?l0503o003J0?ooo`00S03oool00`000000oooo0?ooo`0L0?oooc00o`00O03oool:0000oaD00?l0
4@3o003L0?ooo`00S03oool00`000000oooo0?ooo`0L0?ooobh0o`00O`3oool90000oaH00?l03P3o
003N0?ooo`00S03oool00`000000oooo0?ooo`0M0?ooob/0o`00PP3oool80000oaH00?l0303o003P
0?ooo`00S03oool00`000000oooo0?ooo`0N0?ooobP0o`00Q03oool80000oaL00?l02@3o003R0?oo
o`00S03oool00`000000oooo0?ooo`0O0?ooobD0o`00Q`3oool80000oaL00?l01P3o003T0?ooo`00
S03oool00`000000oooo0?ooo`0P0?ooob80o`00RP3oool70000oaP00?l00`3o003V0?ooo`00S03o
ool00`000000oooo0?ooo`0Q0?oooal0o`00S@3oool60000oaP00?l0j@3oool008`0oooo00<00000
0?ooo`3oool08@3ooolM0?l00900oooo1@000?lF003o0>/0oooo002<0?ooo`030000003oool0oooo
0280oooo6P3o002B0?ooo`D0003o5000o`3]0?ooo`00S03oool00`000000oooo0?ooo`0S0?oooaL0
o`00U@3oool50000oa400?l0k`3oool008`0oooo00<000000?ooo`3oool0903ooolD0?l009P0oooo
10000?l?003o0?40oooo002<0?ooo`030000003oool0oooo02D0oooo4@3o002K0?ooo`<0003o3@00
o`3c0?ooo`00S03oool00`000000oooo0?ooo`0U0?ooo`l0o`00WP3oool20000o`/00?l0m@3oool0
08`0oooo00<000000?ooo`3oool09P3oool<0?l00:00oooo0`000?l8003o0?L0oooo002<0?ooo`03
0000003oool0oooo02L0oooo2@3o002S0?ooo`80003o1P00o`3i0?ooo`00S03oool00`000000oooo
0?ooo`0X0?ooo`H0o`00YP3oool00`000?l00?l0003o0002003o0?/0oooo002<0?ooo`030000003o
ool0oooo02T0oooo0`3o002Y0?ooo`800?l0o@3oool008`0oooo00<000000?ooo`3oool0o`3ooooE
0?ooo`00S03oool00`000000oooo0?ooo`3o0?ooomD0oooo003o0?ooool0ooooI@3oool00?l0oooo
o`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?oo
o`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00/03oool0
0`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool0
0`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool0
0`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0]03oool0
0;00oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo
0240oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
0;@0oooo002`0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`0Q0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`2d0?ooo`00/@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0240oooo
00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool0/`3oool00:h0oooo00@000000?ooo`3oool000006P3oool010000000oooo
0?ooo`00000J0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3oool0
10000000oooo0?ooo`00000P0?ooo`040000003oool0oooo00000200oooo00@000000?ooo`3oool0
00006P3oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo00000;D0oooo002^0?oo
o`@000006P3oool4000001X0oooo1000000J0?ooo`@000006P3oool400000200oooo1000000P0?oo
o`@000006P3oool4000001X0oooo1000002e0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0oooo
I@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00Y@3oool00`000000oooo0?ooo`3o0?oooaD0oooo00<000000?ooo`3oool0
Y03oool00:@0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0E0?ooo`030000003o
ool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003o
ool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000003o
ool0oooo0240oooo00<000000?ooo`3oool0X`3oool00:@0oooo00<000000?ooo`3oool06P3oool0
0`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool05@3oool0
0`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool0
0`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0X`3oool0
0:@0oooo00@000000?ooo`3oool0oooo100000020?ooo`@000000P3oool400000080oooo10000004
0?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`07
0?ooo`@000000P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`07
0?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo10000002
0?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo10000002
0?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo10000002
0?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo10000004
0?ooo`030000003oool0oooo00L0oooo100000020?ooo`@000000P3oool400000080oooo10000003
0?ooo`030000003oool0oooo0:<0oooo002S0?ooo`030000003oool0oooo0?l0oooo6@3oool00`00
0000oooo0?ooo`2R0?ooo`00Y03oool00`000000oooo0?ooo`3o0?oooaL0oooo00<000000?ooo`3o
ool0X`3oool00:@0oooo00<000000?ooo`3oool0o`3ooolG0?ooo`030000003oool0oooo0:<0oooo
002U0?ooo`030000003oool0oooo0?l0oooo5@3oool00`000000oooo0?ooo`2T0?ooo`00o`3ooooo
0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo
003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002Y0?ooo`80
0000203oool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000l0oooo0P0000080?ooo`<0
00001@3oool3000000d0oooo0`0000050?ooo`<00000403oool3000000H0oooo0`0000050?ooo`<0
00003P3oool4000000L0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`0000050?ooo`<0
00003@3oool3000000D0oooo0`00000@0?ooo`<000001P3oool3000000D0oooo0`00002Y0?ooo`00
Z03oool010000000oooo0?ooo`0000080?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3o
ool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00@000000?ooo`3o
ool00000203oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool0403oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool0Z03oool00:X0oooo00<000000?ooo`3oool01`3oool3000000D0oooo00<000000?ooo`3o
ool03@3oool3000000D0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`070?ooo`<0
00001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`000000oooo0?ooo`0=0?ooo`D0
00001`3oool3000000D0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`080?ooo`<0
00001@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?ooo`03
0000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo00d0oooo1@0000070?ooo`<0
00001@3oool00`000000oooo0?ooo`2X0?ooo`00Z`3oool00`000000oooo0?ooo`060?ooo`040000
003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000B0?oo
o`030000003oool0oooo00H0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@00000
0?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool00000203oool010000000oooo
0?ooo`0000030?ooo`8000004@3oool00`000000oooo0?ooo`070?ooo`040000003oool0oooo0000
00<0oooo0P00000A0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool2
000000l0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool00000
203oool010000000oooo0?ooo`0000030?ooo`800000ZP3oool00:P0oooo00@000000?ooo`3oool0
0000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@00000
0?ooo`3oool00000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001D0
oooo00<000000?ooo`000000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo
000000P0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000
003oool0oooo000001@0oooo00@000000?ooo`3oool000005@3oool00`000000oooo000000080?oo
o`040000003oool0oooo00000:l0oooo002Y0?ooo`800000203oool4000000D0oooo00<000000?oo
o`3oool0303oool4000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo100000050?oo
o`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00l0oooo0P0000070?oo
o`@000001@3oool00`000000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?oo
o`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo00`0oooo100000050?oo
o`030000003oool0oooo00l0oooo0P0000070?ooo`@000001@3oool00`000000oooo0?ooo`2X0?oo
o`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00001\
\>"],
  ImageRangeCache->{{{0, 610.438}, {100.313, 0}} -> {-0.855249, -0.00828636, \
0.00607843, 0.00607843}, {{140.688, 297.375}, {98.9375, 44.375}} -> \
{-1.36664, -0.0111165, 0.00795846, 0.00795846}, {{313, 469.688}, {98.9375, \
44.375}} -> {-2.73798, -0.0111165, 0.00795846, 0.00795846}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(2) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(3) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(2) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(5) show
135.000 39.000 moveto
(5) show
165.000 39.000 moveto
(5) show
195.000 39.000 moveto
(5) show
225.000 39.000 moveto
(5) show
255.000 39.000 moveto
(5) show
285.000 39.000 moveto
(5) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -9.21572e-018 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.61803 0 L
.5 .36327 L
F
0 0 1 r
.61803 0 m
1 0 L
.5 .36327 L
F
1 0 0 r
0 0 m
.5 .36327 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -1.19262e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.19098 .58779 m
0 0 L
.38197 0 L
F
0 0 1 r
.38197 0 m
.5 .36327 L
.19098 .58779 L
F
1 0 0 r
.38197 0 m
1 0 L
.5 .36327 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000Zb000`400?l00000o`00003oF`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?oo
o`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00D03ooooo00000<@00000
D03oool005/0oooo00<000000?l00000o`00N`00o`1=0000oaH0ooooC@00o`000`000?l0o`000?l0
001j0?l005d0oooo001K0?ooo`030000003o0000o`0007/00?l0C0000?lG0?ooodd00?l000<0003o
0?l0003o0000N@3o001N0?ooo`00F`3oool00`000000o`000?l000020?l007T00?l0BP000?lI0?oo
odd00?l000<0003o0?l0003o0000M`3o001P0?ooo`00F`3oool00`000000oooo0?l000030?l007L0
0?l0BP000?lK0?oood/00?l00`000?mg0?l00640oooo001K0?ooo`030000003oool0o`0000@0o`00
MP00o`190000oa`0ooooB`00o`030000ogH0o`00HP3oool005/0oooo00<000000?ooo`3o00001P3o
001d003o04L0003o7P3ooom;003o00<0003oM03o001T0?ooo`00F`3oool00`000000oooo0?ooo`07
0?l007800?l0A`000?lP0?ooodT00?l01@000?mb0?l006D0oooo001K0?ooo`030000003oool0oooo
00T0o`00L000o`150000ob80ooooB@00o`050000og00o`00I`3oool005/0oooo00<000000?ooo`3o
ool02P3o001_003o04@0003o8`3ooom9003o00D0003oK`3o001X0?ooo`00F`3oool010000000oooo
0?ooo`3oool:0?l006d00?l0A0000?lU0?ooodL00?l01`000?m]0?l006T0oooo001K0?ooo`040000
003oool0oooo0?ooo``0o`00J`00o`120000obL0ooooA`00o`070000of/0o`00J`3oool005/0oooo
00@000000?ooo`3oool0oooo3@3o001Z003o0440003o:03ooom7003o00L0003oJP3o001/0?ooo`00
F`3oool00`000000oooo0?ooo`020?ooo`d0o`00J000o`110000obX0ooooA@00o`090000ofP0o`00
K@3oool005/0oooo00<000000?ooo`3oool00P3oool?0?l006H00?l0?`000?l/0?ooodD00?l02@00
0?mV0?l006l0oooo001K0?ooo`030000003oool0oooo0080oooo403o001U003o03h0003o;@3ooom5
003o00T0003oI@3o001`0?ooo`00F`3oool00`000000oooo0?ooo`030?oooa40o`00HP00o`0m0000
oc00oooo@`00o`0;0000of80o`00LP3oool005/0oooo00<000000?ooo`3oool00`3ooolB0?l00640
0?l0?0000?la0?oood<00?l02`000?mQ0?l007<0oooo001K0?ooo`030000003oool0oooo00<0oooo
4`3o001P003o03/0003o<P3ooom3003o00/0003oH03o001d0?ooo`00F`3oool00`000000oooo0?oo
o`040?oooa@0o`00G@00o`0j0000ocD0oooo@@00o`0=0000oed0o`00MP3oool005/0oooo00<00000
0?ooo`3oool0103ooolE0?l005`00?l0>@000?lf0?oood400?l03@000?mL0?l007L0oooo001K0?oo
o`030000003oool0oooo00@0oooo5P3o001K003o03P0003o=`3ooom1003o00d0003oF`3o001h0?oo
o`00F`3oool00`000000oooo0?ooo`050?oooaL0o`00F000o`0g0000ocX0oooo?`00o`0?0000oeP0
o`00NP3oool005/0oooo00<000000?ooo`3oool01@3ooolH0?l005L00?l0=P000?lk0?ooocl00?l0
3`000?mG0?l007/0oooo001K0?ooo`030000003oool0oooo00D0oooo6P3o001E003o03@0003o?@3o
oolo003o00l0003oE@3o001m0?ooo`00F`3oool00`000000oooo0?ooo`060?oooaX0o`00D`00o`0d
0000ocl0oooo?@00o`0A0000oe<0o`00OP3oool005/0oooo00<000000?ooo`3oool01P3ooolK0?l0
05800?l0<`000?m00?ooocd00?l04@000?mB0?l007l0oooo001K0?ooo`030000003oool0oooo00H0
oooo7@3o001@003o0340003o@P3ooolm003o0140003oD03o00210?ooo`00F`3oool00`000000oooo
0?ooo`070?oooad0o`00CP00o`0a0000od@0oooo>`00o`0C0000odh0o`00PP3oool005/0oooo00<0
00000?ooo`3oool01`3ooolN0?l004d00?l0<0000?m50?oooc/00?l04`000?m=0?l008<0oooo001K
0?ooo`030000003oool0oooo00L0oooo803o001;003o02h0003oA`3ooolk003o01<0003oB`3o0025
0?ooo`00F`3oool00`000000oooo0?ooo`080?ooob00o`00B@00o`0^0000odT0oooo>@00o`0E0000
odT0o`00QP3oool005/0oooo00<000000?ooo`3oool0203ooolR0?l004L00?l0;0000?m;0?ooocT0
0?l05@000?m70?l008P0oooo001K0?ooo`030000003oool0oooo00P0oooo8`3o0016003o02/0003o
C03oooli003o01D0003oAP3o00290?ooo`00F`3oool00`000000oooo0?ooo`090?ooob<0o`00A000
o`0[0000odh0oooo=`00o`0G0000od@0o`00RP3oool005/0oooo00<000000?ooo`3oool02@3ooolU
0?l004800?l0:@000?m@0?ooocL00?l05`000?m20?l008`0oooo001K0?ooo`030000003oool0oooo
00T0oooo9P3o0011003o02P0003oD@3ooolg003o01L0003o@@3o002=0?ooo`00F`3oool00`000000
oooo0?ooo`0:0?ooobH0o`00?`00o`0W0000oe@0oooo=@00o`0H0000ocl0o`00S`3oool005/0oooo
00<000000?ooo`3oool02P3ooolX0?l003d00?l09P000?mE0?ooocD00?l06@000?lm0?l00900oooo
001K0?ooo`030000003oool0oooo00X0oooo:@3o000l003o02D0003oEP3ooole003o01T0003o?03o
002A0?ooo`00F`3oool00`000000oooo0?ooo`0:0?ooob/0o`00>P00o`0S0000oeP0oooo=000o`0J
0000ocX0o`00T`3oool005/0oooo00<000000?ooo`3oool02`3oool[0?l003P00?l08`000?mJ0?oo
oc<00?l06`000?lh0?l009@0oooo001K0?ooo`030000003oool0oooo00/0oooo;03o000g003o0280
003oF`3ooolc003o01/0003o=`3o002E0?ooo`00F`3oool00`000000oooo0?ooo`0;0?ooobh0o`00
=@00o`0P0000oed0oooo<`00o`0K0000ocD0o`00U`3oool005/0oooo00<000000?ooo`3oool0303o
ool^0?l003<00?l080000?mO0?oooc400?l07@000?lc0?l009P0oooo001K0?ooo`030000003oool0
oooo00`0oooo<03o000a003o01h0003oH@3ooola003o01d0003o<@3o002J0?ooo`00F`3oool00`00
0000oooo0?ooo`0<0?oooc40o`00<000o`0M0000of80oooo<@00o`0M0000oc00o`00V`3oool005/0
oooo00<000000?ooo`3oool03@3ooola0?l002h00?l07@000?mT0?ooobl00?l07`000?l^0?l009`0
oooo001K0?ooo`030000003oool0oooo00d0oooo<`3o000/003o01/0003oIP3oool_003o01l0003o
;03o002N0?ooo`00F`3oool00`000000oooo0?ooo`0=0?oooc@0o`00:`00o`0J0000ofL0oooo;`00
o`0O0000ob/0o`00W`3oool005/0oooo00<000000?ooo`3oool03P3ooold0?l002T00?l06P000?mY
0?ooobd00?l08@000?lY0?l00:00oooo001K0?ooo`030000003oool0oooo00h0oooo=P3o000W003o
01P0003oJ`3oool]003o0240003o9`3o002R0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooocL0
o`009P00o`0G0000of`0oooo;@00o`0Q0000obH0o`00X`3oool005/0oooo00<000000?ooo`3oool0
3`3ooolh0?l002<00?l05P000?m_0?ooob/00?l08`000?lS0?l00:D0oooo001K0?ooo`030000003o
ool0oooo00l0oooo>@3o000R003o01D0003oL03oool[003o02<0003o8P3o002V0?ooo`00F`3oool0
0`000000oooo0?ooo`0?0?ooocX0o`008@00o`0D0000og40oooo:`00o`0S0000ob40o`00Y`3oool0
05/0oooo00<000000?ooo`3oool0403ooolk0?l001h00?l04`000?md0?ooobT00?l09@000?lN0?l0
0:T0oooo001K0?ooo`030000003oool0oooo0100oooo?03o000M003o0180003oM@3ooolY003o02D0
003o7@3o002Z0?ooo`00F`3oool00`000000oooo0?ooo`0@0?ooocd0o`007000o`0A0000ogH0oooo
:@00o`0U0000oa`0o`00Z`3oool005/0oooo00<000000?ooo`3oool04@3oooln0?l001T00?l04000
0?mi0?ooobL00?l09`000?lI0?l00:d0oooo001K0?ooo`030000003oool0oooo0140oooo?`3o000H
003o00l0003oNP3ooolW003o02L0003o603o002^0?ooo`00F`3oool00`000000oooo0?ooo`0A0?oo
od40o`005P00o`0=0000og`0oooo9`00o`0W0000oaH0o`00/03oool005/0oooo00<000000?ooo`3o
ool04P3ooom10?l001@00?l03@000?mn0?ooobD00?l0:@000?lD0?l00;40oooo001K0?ooo`030000
003oool0oooo0180oooo@P3o000C003o00`0003oO`3ooolU003o02T0003o4`3o002b0?ooo`00F`3o
ool00`000000oooo0?ooo`0B0?oood@0o`004@00o`0:0000oh40oooo9@00o`0Y0000oa40o`00]03o
ool005/0oooo00<000000?ooo`3oool04`3ooom40?l000l00?l02P000?n30?ooob<00?l0:`000?l?
0?l00;D0oooo001K0?ooo`030000003oool0oooo01<0ooooA@3o000>003o00T0003oQ03ooolS003o
02/0003o3P3o002f0?ooo`00F`3oool00`000000oooo0?ooo`0C0?ooodL0o`003000o`070000ohH0
oooo8`00o`0[0000o``0o`00^03oool005/0oooo00<000000?ooo`3oool0503ooom70?l000X00?l0
1`000?n80?ooob400?l0;@000?l:0?l00;T0oooo001K0?ooo`030000003oool0oooo01@0ooooB@3o
0008003o00D0003oRP3ooolQ003o02d0003o203o002k0?ooo`00F`3oool00`000000oooo0?ooo`0D
0?ooodX0o`001`00o`040000oh/0oooo8@00o`0]0000o`L0o`00_03oool005/0oooo00<000000?oo
o`3oool05@3ooom:0?l000D00?l010000?n=0?oooal00?l0;`000?l50?l00;d0oooo001K0?ooo`03
0000003oool0oooo01D0ooooC03o0003003o0080003oS`3ooolO003o02l0003o0`3o002o0?ooo`00
F`3oool00`000000oooo0?ooo`0E0?ooodd0o`000P00o`000`000?l0oooo0?ooo`2>0?oooal00?l0
;`000?l20?l00<00oooo001K0?ooo`030000003oool0oooo01H0ooooC@3o002C0?oooad00?l0<000
0?o20?ooo`00F`3oool00`000000oooo0?ooo`0F0?oood`0o`00U03ooolM003o02l0003o``3oool0
05/0oooo00<000000?ooo`3oool05P3ooom;0?l009D0oooo7@00o`0^0000ol@0oooo001K0?ooo`03
0000003oool0oooo01L0ooooB03o002H0?oooa/00?l0;@000?o60?ooo`00F`3oool00`000000oooo
0?ooo`0G0?ooodL0o`00V@3ooolK003o02`0003oa`3oool005/0oooo00<000000?ooo`3oool05`3o
oom60?l009X0oooo6`00o`0[0000olP0oooo001K0?ooo`030000003oool0oooo01L0ooooA03o002L
0?oooaX00?l0:P000?o:0?ooo`00F`3oool00`000000oooo0?ooo`0H0?oood80o`00WP3ooolI003o
02T0003ob`3oool005/0oooo00<000000?ooo`3oool0603ooom10?l009l0oooo6@00o`0X0000ol`0
oooo001K0?ooo`030000003oool0oooo01P0oooo?`3o002Q0?oooaT00?l09P000?o>0?ooo`00F`3o
ool00`000000oooo0?ooo`0I0?ooocd0o`00X`3ooolG003o02H0003oc`3oool005/0oooo00<00000
0?ooo`3oool06@3ooolk0?l00:D0oooo5`00o`0T0000om40oooo001K0?ooo`030000003oool0oooo
01T0oooo>P3o002V0?oooaL00?l08`000?oB0?ooo`00F`3oool00`000000oooo0?ooo`0J0?ooocP0
o`00Z03ooolE003o02<0003od`3oool005/0oooo00<000000?ooo`3oool06P3ooolf0?l00:X0oooo
5@00o`0Q0000omD0oooo001K0?ooo`030000003oool0oooo01X0oooo=@3o002[0?oooaD00?l08000
0?oF0?ooo`00F`3oool00`000000oooo0?ooo`0K0?oooc<0o`00[@3ooolC003o0200003oe`3oool0
05/0oooo00<000000?ooo`3oool06`3ooola0?l00:l0oooo4`00o`0N0000omT0oooo001K0?ooo`03
0000003oool0oooo01/0oooo<03o002`0?oooa<00?l07@000?oJ0?ooo`00F`3oool00`000000oooo
0?ooo`0L0?ooobd0o`00/`3ooolA003o01`0003og03oool005/0oooo00<000000?ooo`3oool0703o
ool/0?l00;@0oooo4@00o`0K0000omd0oooo001K0?ooo`030000003oool0oooo01`0oooo:`3o002e
0?oooa400?l06P000?oN0?ooo`00F`3oool00`000000oooo0?ooo`0M0?ooobP0o`00^03oool?003o
01T0003oh03oool005/0oooo00<000000?ooo`3oool07@3ooolW0?l00;T0oooo3`00o`0H0000on40
oooo001K0?ooo`030000003oool0oooo01d0oooo9P3o002j0?ooo`l00?l05`000?oR0?ooo`00F`3o
ool00`000000oooo0?ooo`0N0?ooob<0o`00_@3oool=003o01H0003oi03oool005/0oooo00<00000
0?ooo`3oool07P3ooolR0?l00;h0oooo3@00o`0E0000onD0oooo001K0?ooo`030000003oool0oooo
01h0oooo8@3o002o0?ooo`d00?l050000?oV0?ooo`00F`3oool00`000000oooo0?ooo`0O0?oooah0
o`00`P3oool;003o01<0003oj03oool005/0oooo00<000000?ooo`3oool07`3ooolM0?l00<<0oooo
2`00o`0B0000onT0oooo001K0?ooo`030000003oool0oooo01l0oooo6`3o00350?ooo`/00?l04000
0?o[0?ooo`00F`3oool00`000000oooo0?ooo`0P0?oooaT0o`00a`3oool9003o0100003ok03oool0
05/0oooo00<000000?ooo`3oool0803ooolH0?l00<P0oooo2@00o`0?0000ond0oooo001K0?ooo`03
0000003oool0oooo0200oooo5P3o003:0?ooo`T00?l03@000?o_0?ooo`00F`3oool00`000000oooo
0?ooo`0Q0?oooa@0o`00c03oool7003o00d0003ol03oool005/0oooo00<000000?ooo`3oool08@3o
oolC0?l00<d0oooo1`00o`0<0000oo40oooo001K0?ooo`030000003oool0oooo0240oooo4@3o003?
0?ooo`L00?l02P000?oc0?ooo`00F`3oool00`000000oooo0?ooo`0R0?ooo`l0o`00d@3oool5003o
00X0003om03oool005/0oooo00<000000?ooo`3oool08P3oool=0?l00=<0oooo1@00o`080000ooH0
oooo001K0?ooo`030000003oool0oooo0280oooo303o003D0?ooo`D00?l01`000?og0?ooo`00F`3o
ool00`000000oooo0?ooo`0S0?ooo`X0o`00eP3oool3003o00L0003on03oool005/0oooo00<00000
0?ooo`3oool08`3oool80?l00=P0oooo0`00o`050000ooX0oooo001K0?ooo`030000003oool0oooo
02<0oooo1`3o003I0?ooo`<00?l010000?ok0?ooo`00F`3oool00`000000oooo0?ooo`0T0?ooo`D0
o`00f`3oool00`00o`00003o0000o`020000oo`0oooo001K0?ooo`030000003oool0oooo02@0oooo
0`3o003M0?ooo`03003o00000?l0003o0?h0oooo001K0?ooo`030000003oool0oooo02@0oooo0P3o
003N0?ooo`03003o00000?l0oooo0?h0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool7
0?ooo`00F`3oool00`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3o
ool0o`3ooooo0?ooo`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00o`3o
oooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?oo
ool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00]@3oool2000001`0oooo0P00000L0?ooo`800000
703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000
_03oool00;@0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00000J0?ooo`04
0000003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00
000J0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3oool010000000
oooo0?ooo`00000J0?ooo`040000003oool0oooo00000;/0oooo002g0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`2i0?ooo`00]@3oool2000001`0
oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0
oooo0P00000L0?ooo`800000_03oool00;D0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo0;/0oooo002e0?ooo`<000006`3oool3000001/0oooo0`00
000K0?ooo`<000006`3oool3000001/0oooo0`00000K0?ooo`<000006`3oool3000001/0oooo0`00
002k0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00
o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00Z`3oool00`00
0000oooo0?ooo`3o0?ooo`T0oooo00<000000?ooo`3oool0ZP3oool00:X0oooo00<000000?ooo`3o
ool06P3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool0Z@3oool00:X0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool0Z@3oool00:X0oooo00@000000?ooo`3oool0oooo
100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo
100000020?ooo`@000000`3oool00`000000oooo0?ooo`2Y0?ooo`00Z@3oool00`000000oooo0?oo
o`3o0?ooo`d0oooo00<000000?ooo`3oool0Z03oool00:X0oooo00<000000?ooo`3oool0o`3oool;
0?ooo`030000003oool0oooo0:T0oooo002Z0?ooo`030000003oool0oooo0?l0oooo2`3oool00`00
0000oooo0?ooo`2Y0?ooo`00Z`3oool00`000000oooo0?ooo`3o0?ooo`T0oooo00<000000?ooo`3o
ool0ZP3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool0
0?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3o
oomU0?ooo`00[P3oool4000000L0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000>
0?ooo`@000001`3oool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000l0oooo0P000008
0?ooo`<000001@3oool3000000d0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`000005
0?ooo`<000003@3oool3000000D0oooo0`00000>0?ooo`@000001`3oool3000000D0oooo0`00002_
0?ooo`00[P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0:h0oooo002_0?oo
o`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?oo
o`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?oo
o`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`070?oo
o`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`000000oooo0?ooo`0>0?oo
o`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?oo
o`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?oo
o`3oool0[P3oool00;00oooo00<000000?ooo`3oool01`3oool010000000oooo0?ooo`0000030?oo
o`8000003`3oool010000000oooo0?ooo`0000030?ooo`8000004@3oool00`000000oooo0?ooo`07
0?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo
0P00000B0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool000000`3oool2000000l0
oooo00@000000?ooo`3oool000000`3oool200000140oooo00<000000?ooo`3oool01`3oool01000
0000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000030?ooo`8000004@3o
ool00`000000oooo0?ooo`070?ooo`040000003oool0oooo000000<0oooo0P00002`0?ooo`00[P3o
ool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@0
00000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo0000
01@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000003o
ool0oooo000001@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?oo
o`040000003oool0oooo00000;D0oooo002_0?ooo`800000203oool4000000D0oooo00<000000?oo
o`3oool0303oool4000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo100000050?oo
o`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?oo
o`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?oo
o`800000203oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<000000?oo
o`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo0:h0oooo003o0?ooool0
ooooI@3oool00?l0ooooo`3ooomU0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 610.563}, {170.188, 0}} -> {-0.426205, -0.013998, \
0.00467178, 0.00467178}, {{91.1875, 295.063}, {167.188, 47.3125}} -> \
{-1.34175, -0.0239702, 0.00793648, 0.00793648}, {{315.438, 519.313}, \
{167.188, 47.3125}} -> {-3.12151, -0.0239702, 0.00793648, 0.00793648}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .20661 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00491932 0.47619 [
[.5 .21911 -152 0 ]
[.5 .21911 152 38.75 ]
[ 0 0 0 0 ]
[ 1 .20661 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00492 m
1 .00492 L
s
.02381 0 m
.02381 .20661 L
s
gsave
.5 .21911 -213 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(2) show
117.000 12.750 moveto
(Pi) show
141.000 12.750 moveto
(2) show
153.000 12.750 moveto
(Pi) show
177.000 12.750 moveto
(Pi) show
201.000 12.750 moveto
(4) show
213.000 12.750 moveto
(Pi) show
237.000 12.750 moveto
(2) show
249.000 12.750 moveto
(Pi) show
273.000 12.750 moveto
(3) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(Pi) show
333.000 12.750 moveto
(3) show
345.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
(--) show
129.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
141.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
153.000 25.875 moveto
(--) show
165.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
177.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
189.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
201.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
213.000 25.875 moveto
(--) show
225.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
237.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
249.000 25.875 moveto
(--) show
261.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
273.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
285.000 25.875 moveto
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
333.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
345.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
357.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
111.000 39.000 moveto
(7) show
147.000 39.000 moveto
(7) show
177.000 39.000 moveto
(7) show
207.000 39.000 moveto
(7) show
243.000 39.000 moveto
(7) show
279.000 39.000 moveto
(7) show
309.000 39.000 moveto
(7) show
339.000 39.000 moveto
(7) show
345.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .20661 L
0 .20661 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00491932 0.477324 0.201692 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.445042 0.554958 1.37152e-017 0.554958 [
[ 0 0 0 0 ]
[ 1 .43388 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .43388 L
0 .43388 L
closepath
clip
newpath
0 1 0 r
0 0 m
.3569 0 L
.27748 .34795 L
F
0 0 1 r
.3569 0 m
1 0 L
.27748 .34795 L
F
1 0 0 r
0 0 m
.27748 .34795 L
.09903 .43388 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00491932 0.97619 0.201692 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.445042 0.554958 -4.49944e-018 0.554958 [
[ 0 0 0 0 ]
[ 1 .43388 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .43388 L
0 .43388 L
closepath
clip
newpath
0 1 0 r
.09903 .43388 m
0 0 L
.44504 0 L
F
0 0 1 r
.44504 0 m
.5 .24079 L
.09903 .43388 L
F
1 0 0 r
.44504 0 m
1 0 L
.5 .24079 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.625, 126.375},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000OR000`400?l00000o`00003oM@3oool0
0`000000oooo0?ooo`3o0?ooon`0oooo001e0?ooo`030000003oool0oooo0?l0ooook03oool006/0
ooooo`00002=000006`0oooo001e0?ooo`0300000000o`000?l003d00?l0L@000?lE0?ooodl00?l0
00<0003o0?l0003o0000GP3o001h0?ooo`00M@3oool00`000000o`00003o000m003o06l0003o5`3o
oom>003o0080003oGP3o001j0?ooo`00M@3oool00`000000o`000?l0000m003o06d0003o6@3ooom=
003o00<0003oG03o001l0?ooo`00M@3oool010000000o`000?l0003o000l003o06/0003o6`3ooom<
003o00@0003oFP3o001n0?ooo`00M@3oool010000000oooo0?l0003o000k003o06X0003o7P3ooom;
003o00D0003oE`3o00200?ooo`00M@3oool00`000000oooo0?l000020?l003X00?l0J0000?lP0?oo
odX00?l01P000?mE0?l00880oooo001e0?ooo`030000003oool0o`0000<0o`00>@00o`1V0000ob80
ooooB@00o`070000oe<0o`00Q03oool007D0oooo00<000000?ooo`3o0000103o000h003o06@0003o
903ooom8003o00P0003oD@3o00260?ooo`00M@3oool00`000000oooo0?l000050?l003H00?l0H`00
0?lW0?ooodH00?l02@000?m?0?l008P0oooo001e0?ooo`030000003oool0oooo00D0o`00=P00o`1Q
0000obT0ooooAP00o`0:0000od`0o`00RP3oool007D0oooo00<000000?ooo`3oool01P3o000e003o
05h0003o;03ooom5003o00/0003oB@3o002=0?ooo`00M@3oool00`000000oooo0?ooo`070?l003@0
0?l0G0000?l^0?oood@00?l030000?m70?l008l0oooo001e0?ooo`030000003oool0oooo00P0o`00
<P00o`1K0000oc00oooo@`00o`0=0000odD0o`00T@3oool007D0oooo00@000000?ooo`3oool0oooo
203o000a003o05T0003o<`3ooom1003o00h0003o@`3o002C0?ooo`00M@3oool010000000oooo0?oo
o`3oool80?l003400?l0E`000?le0?oood400?l03`000?m00?l009D0oooo001e0?ooo`040000003o
ool0oooo0?ooo`T0o`00<000o`1E0000ocL0oooo@000o`0@0000och0o`00U`3oool007D0oooo00@0
00000?ooo`3oool0oooo2P3o000^003o05@0003o>@3ooolo003o0140003o?03o002I0?ooo`00M@3o
ool010000000oooo0?ooo`3oool;0?l002d00?l0DP000?ll0?ooocd00?l04P000?lj0?l009/0oooo
001e0?ooo`030000003oool0oooo0080oooo2`3o000/003o0500003o?P3oooll003o01<0003o>03o
002M0?ooo`00M@3oool00`000000oooo0?ooo`020?ooo`/0o`00;000o`1>0000od00oooo?000o`0D
0000ocD0o`00W`3oool007D0oooo00<000000?ooo`3oool00P3oool<0?l002X00?l0C0000?m30?oo
oc/00?l05@000?lc0?l00:40oooo001e0?ooo`030000003oool0oooo0080oooo3@3o000Y003o04X0
003oAP3oooli003o01H0003o<03o002T0?ooo`00M@3oool00`000000oooo0?ooo`030?ooo`d0o`00
:000o`180000odP0oooo>000o`0G0000obh0o`00YP3oool007D0oooo00<000000?ooo`3oool00`3o
ool=0?l002P00?l0AP000?m:0?ooocL00?l06@000?l[0?l00:P0oooo001e0?ooo`030000003oool0
oooo00<0oooo3P3o000V003o04D0003oC03ooolg003o01T0003o:@3o002Z0?ooo`00M@3oool00`00
0000oooo0?ooo`030?ooo`l0o`009@00o`130000odh0oooo=P00o`0J0000obL0o`00[03oool007D0
oooo00<000000?ooo`3oool00`3oool@0?l002@00?l0@@000?mA0?oooc@00?l06`000?lU0?l00:h0
oooo001e0?ooo`030000003oool0oooo00@0oooo403o000S003o03l0003oD`3ooolc003o01`0003o
8`3o002`0?ooo`00M@3oool00`000000oooo0?ooo`040?oooa00o`008P00o`0n0000oeD0oooo<P00
o`0N0000ob00o`00/P3oool007D0oooo00<000000?ooo`3oool0103ooolA0?l002400?l0?0000?mG
0?oooc800?l07P000?lN0?l00;@0oooo001e0?ooo`030000003oool0oooo00@0oooo4P3o000P003o
03T0003oF`3oool`003o01l0003o703o002f0?ooo`00M@3oool00`000000oooo0?ooo`040?oooa<0
o`007`00o`0g0000oed0oooo;`00o`0P0000oaX0o`00^03oool007D0oooo00<000000?ooo`3oool0
1@3ooolC0?l001h00?l0=@000?mO0?ooobh00?l08@000?lG0?l00;/0oooo001e0?ooo`030000003o
ool0oooo00D0oooo4`3o000M003o03@0003oH@3oool]003o02<0003o503o002m0?ooo`00M@3oool0
0`000000oooo0?ooo`050?oooa@0o`007000o`0b0000of@0oooo;000o`0S0000oa80o`00_`3oool0
07D0oooo00<000000?ooo`3oool01@3ooolE0?l001/00?l0<0000?mV0?ooob/00?l090000?l@0?l0
0<40oooo001e0?ooo`030000003oool0oooo00H0oooo5@3o000J003o02h0003oJ03ooolZ003o02D0
003o3P3o00330?ooo`00M@3oool00`000000oooo0?ooo`060?oooaH0o`006000o`0]0000ofX0oooo
:@00o`0V0000o``0o`00a@3oool007D0oooo00<000000?ooo`3oool01P3ooolF0?l001P00?l0:`00
0?m/0?ooobP00?l0:0000?l90?l00<L0oooo001e0?ooo`030000003oool0oooo00H0oooo5`3o000G
003o02T0003oK`3ooolW003o02P0003o1`3o00390?ooo`00M@3oool00`000000oooo0?ooo`060?oo
oaP0o`005P00o`0W0000og40oooo9P00o`0Y0000o`D0o`00b`3oool007D0oooo00<000000?ooo`3o
ool01`3ooolH0?l001@00?l09@000?md0?ooobD00?l0:P000?l30?l00<d0oooo001e0?ooo`030000
003oool0oooo00L0oooo603o000D003o02<0003oMP3ooolT003o02/0003od03oool007D0oooo00<0
00000?ooo`3oool01`3ooolI0?l001<00?l08@000?mi0?ooob<00?l0:@000?oB0?ooo`00M@3oool0
0`000000oooo0?ooo`070?oooaX0o`004P00o`0O0000og/0oooo8P00o`0X0000om@0oooo001e0?oo
o`030000003oool0oooo00P0oooo6P3o000@003o01h0003oO@3ooolQ003o02L0003oeP3oool007D0
oooo00<000000?ooo`3oool0203ooolK0?l000l00?l070000?mo0?ooob000?l09P000?oH0?ooo`00
M@3oool00`000000oooo0?ooo`080?oooa/0o`003`00o`0J0000oh80oooo7P00o`0U0000omX0oooo
001e0?ooo`030000003oool0oooo00P0oooo703o000>003o01P0003oQ03ooolN003o02<0003og03o
ool007D0oooo00<000000?ooo`3oool0203ooolM0?l000`00?l05`000?n60?oooad00?l08P000?oN
0?ooo`00M@3oool00`000000oooo0?ooo`090?oooad0o`002`00o`0E0000ohP0oooo7000o`0Q0000
on00oooo001e0?ooo`030000003oool0oooo00T0oooo7P3o000:003o0180003oR`3ooolK003o0200
003ohP3oool007D0oooo00<000000?ooo`3oool02@3ooolN0?l000X00?l040000?n>0?oooaT00?l0
7`000?oT0?ooo`00M@3oool00`000000oooo0?ooo`090?oooal0o`002000o`0?0000oi00oooo6@00
o`0M0000onH0oooo001e0?ooo`030000003oool0oooo00T0oooo803o0007003o00d0003oTP3ooolH
003o01`0003oj03oool007D0oooo00<000000?ooo`3oool02P3ooolP0?l000H00?l02`000?nD0?oo
oaL00?l06`000?oZ0?ooo`00M@3oool00`000000oooo0?ooo`0:0?ooob40o`001@00o`090000oiL0
oooo5@00o`0J0000on`0oooo001e0?ooo`030000003oool0oooo00X0oooo8@3o0004003o00P0003o
V@3ooolD003o01T0003okP3oool007D0oooo00<000000?ooo`3oool02P3ooolR0?l000<00?l01P00
0?nK0?oooa@00?l05`000?o`0?ooo`00M@3oool00`000000oooo0?ooo`0;0?ooob80o`000P00o`04
0000oid0oooo4`00o`0F0000oo80oooo001e0?ooo`030000003oool0oooo00/0oooo8`3o00000`00
o`00003o0000o`2P0?oooa400?l05@000?od0?ooo`00M@3oool00`000000oooo0?ooo`0;0?ooob<0
o`00X`3oool@003o01@0003omP3oool007D0oooo00<000000?ooo`3oool02`3ooolQ0?l00:D0oooo
3`00o`0C0000ooP0oooo001e0?ooo`030000003oool0oooo00/0oooo7`3o002W0?ooo`l00?l04@00
0?oj0?ooo`00M@3oool00`000000oooo0?ooo`0<0?oooa`0o`00Z@3oool>003o0100003oo03oool0
07D0oooo00<000000?ooo`3oool0303ooolJ0?l00:`0oooo3000o`0?0000ooh0oooo001e0?ooo`03
0000003oool0oooo00`0oooo603o002^0?ooo`/00?l03P000?oo0?ooo`40oooo001e0?ooo`030000
003oool0oooo00`0oooo5P3o002`0?ooo`X00?l03@000?oo0?ooo`<0oooo001e0?ooo`030000003o
ool0oooo00d0oooo4`3o002b0?ooo`X00?l02`000?oo0?ooo`D0oooo001e0?ooo`030000003oool0
oooo00d0oooo4@3o002e0?ooo`P00?l02P000?oo0?ooo`L0oooo001e0?ooo`030000003oool0oooo
00d0oooo3`3o002g0?ooo`L00?l02@000?oo0?ooo`T0oooo001e0?ooo`030000003oool0oooo00d0
oooo3@3o002i0?ooo`H00?l020000?oo0?ooo`/0oooo001e0?ooo`030000003oool0oooo00d0oooo
2`3o002k0?ooo`D00?l01`000?oo0?ooo`d0oooo001e0?ooo`030000003oool0oooo00h0oooo203o
002n0?ooo`@00?l01@000?oo0?ooo`l0oooo001e0?ooo`030000003oool0oooo00h0oooo1P3o0030
0?ooo`<00?l010000?oo0?oooa40oooo001e0?ooo`030000003oool0oooo00h0oooo103o00320?oo
o`800?l00`000?oo0?oooa<0oooo001e0?ooo`030000003oool0oooo00h0oooo0P3o00340?ooo`03
003o00000?l0003o0?l0oooo5@3oool007D0oooo00<000000?ooo`3oool0o`3oooo/0?ooo`00M@3o
ool00`000000oooo0?ooo`3o0?ooon`0oooo001e0?ooo`030000003oool0oooo0?l0ooook03oool0
0?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3o
oomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00
o`3ooooo0?ooofD0oooo002Z0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3o
ool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool08@3o
ool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3o
ool00`000000oooo0?ooo`2^0?ooo`00ZP3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0
oooo0240oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0
oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0
oooo01/0oooo00<000000?ooo`3oool0[P3oool00:X0oooo00<000000?ooo`3oool08@3oool00`00
0000oooo0?ooo`0Q0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo0:h0oooo002[0?ooo`030000003oool0oooo0240
oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0
oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01/0
oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`2]0?ooo`00Z03oool010000000oooo
0?ooo`00000P0?ooo`040000003oool0oooo00000200oooo00@000000?ooo`3oool000006P3oool0
10000000oooo0?ooo`00000J0?ooo`040000003oool0oooo00000200oooo00@000000?ooo`3oool0
0000803oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001X0oooo00@00000
0?ooo`3oool00000[`3oool00:P0oooo1000000P0?ooo`@00000803oool4000001X0oooo1000000J
0?ooo`@00000803oool400000200oooo1000000J0?ooo`@000006P3oool400000:l0oooo003o0?oo
ool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3o
ool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002O0?ooo`030000003oool0oooo0?l0
oooo8@3oool00`000000oooo0?ooo`2N0?ooo`00WP3oool00`000000oooo0?ooo`0J0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`2M0?ooo`00WP3o
ool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3o
ool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3o
ool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool08@3o
ool00`000000oooo0?ooo`2M0?ooo`00WP3oool010000000oooo0?ooo`3oool400000080oooo1000
00020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo1000
00020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo1000
00020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo1000
00040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@000000P3oool400000080oooo1000
00040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@000000P3oool400000080oooo1000
00040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@000000P3oool400000080oooo1000
00040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000103oool00`000000oooo0?oo
o`070?ooo`@000000P3oool400000080oooo100000020?ooo`@000000`3oool00`000000oooo0?oo
o`2M0?ooo`00W@3oool00`000000oooo0?ooo`3o0?ooobD0oooo00<000000?ooo`3oool0W03oool0
09h0oooo00<000000?ooo`3oool0o`3ooolS0?ooo`030000003oool0oooo09d0oooo002N0?ooo`03
0000003oool0oooo0?l0oooo8`3oool00`000000oooo0?ooo`2M0?ooo`00W`3oool00`000000oooo
0?ooo`3o0?ooob40oooo00<000000?ooo`3oool0WP3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo
0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo
003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00X`3oool2000000P0oooo0`0000050?oo
o`<000003P3oool4000000L0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`0000050?oo
o`<000003@3oool3000000D0oooo0`00000@0?ooo`<000001P3oool3000000D0oooo0`00000>0?oo
o`@000001`3oool3000000D0oooo0`00000?0?ooo`800000203oool3000000D0oooo0`00000=0?oo
o`<000001@3oool3000000l0oooo0P0000080?ooo`<000001@3oool300000:<0oooo002R0?ooo`04
0000003oool0oooo000000P0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool010000000oooo0?ooo`000008
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00d0oooo00@000000?ooo`3oool00000203oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo0:80oooo002T0?ooo`030000003oool0oooo00L0oooo0`000005
0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<00000
0?ooo`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`000000oooo0?ooo`0=
0?ooo`<000001@3oool00`000000oooo0?ooo`0=0?ooo`D000001`3oool3000000D0oooo00<00000
0?ooo`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`000000oooo0?ooo`0?
0?ooo`030000003oool0oooo00L0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`000005
0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool01`3oool3000000D0oooo00<00000
0?ooo`3oool0XP3oool00:D0oooo00<000000?ooo`3oool01P3oool010000000oooo0?ooo`000003
0?ooo`8000004@3oool00`000000oooo0?ooo`070?ooo`040000003oool0oooo000000<0oooo0P00
000A0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo
00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool00000203oool01000
0000oooo0?ooo`0000030?ooo`8000004@3oool00`000000oooo0?ooo`070?ooo`040000003oool0
oooo000000<0oooo0P00000B0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool00000
0`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool200000180oooo00<000000?ooo`3o
ool01P3oool010000000oooo0?ooo`0000030?ooo`800000Y03oool00:80oooo00@000000?ooo`3o
ool00000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000000P0oooo00@0
00000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo0000
01@0oooo00@000000?ooo`3oool000005@3oool00`000000oooo000000080?ooo`040000003oool0
oooo000001@0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00000D0?ooo`04
0000003oool0oooo000000P0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00
000D0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000Z@3oool00:<0oooo
0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo
00<000000?ooo`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo00`0oooo
100000050?ooo`030000003oool0oooo00l0oooo0P0000070?ooo`@000001@3oool00`000000oooo
0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo
100000050?ooo`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo
0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`2R0?ooo`00o`3ooooo0?ooofD0oooo003o
0?ooool0ooooI@3oool00001\
\>"],
  ImageRangeCache->{{{0, 610.625}, {125.375, 0}} -> {-0.621763, -0.0103329, \
0.00531182, 0.00531182}, {{117, 296.313}, {123.375, 45.625}} -> {-1.97905, \
-0.0201154, 0.0100557, 0.0100557}, {{314.25, 493.563}, {123.375, 45.625}} -> \
{-3.96254, -0.0201154, 0.0100557, 0.0100557}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(2) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(3) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(2) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(5) show
135.000 39.000 moveto
(5) show
165.000 39.000 moveto
(5) show
195.000 39.000 moveto
(5) show
225.000 39.000 moveto
(5) show
255.000 39.000 moveto
(5) show
285.000 39.000 moveto
(5) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -9.21572e-018 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.61803 0 L
.5 .36327 L
F
0 0 1 r
.61803 0 m
1 0 L
.5 .36327 L
F
1 0 0 r
0 0 m
.5 .36327 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -1.19262e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.19098 .58779 m
0 0 L
.38197 0 L
F
0 0 1 r
.38197 0 m
.5 .36327 L
.19098 .58779 L
F
1 0 0 r
.38197 0 m
1 0 L
.5 .36327 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000Zb000`400?l00000o`00003oF`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?oo
o`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00D03ooooo00000<@00000
D03oool005/0oooo00<000000?l00000o`00N`00o`1=0000oaH0ooooC@00o`000`000?l0o`000?l0
001j0?l005d0oooo001K0?ooo`030000003o0000o`0007/00?l0C0000?lG0?ooodd00?l000<0003o
0?l0003o0000N@3o001N0?ooo`00F`3oool00`000000o`000?l000020?l007T00?l0BP000?lI0?oo
odd00?l000<0003o0?l0003o0000M`3o001P0?ooo`00F`3oool00`000000oooo0?l000030?l007L0
0?l0BP000?lK0?oood/00?l00`000?mg0?l00640oooo001K0?ooo`030000003oool0o`0000@0o`00
MP00o`190000oa`0ooooB`00o`030000ogH0o`00HP3oool005/0oooo00<000000?ooo`3o00001P3o
001d003o04L0003o7P3ooom;003o00<0003oM03o001T0?ooo`00F`3oool00`000000oooo0?ooo`07
0?l007800?l0A`000?lP0?ooodT00?l01@000?mb0?l006D0oooo001K0?ooo`030000003oool0oooo
00T0o`00L000o`150000ob80ooooB@00o`050000og00o`00I`3oool005/0oooo00<000000?ooo`3o
ool02P3o001_003o04@0003o8`3ooom9003o00D0003oK`3o001X0?ooo`00F`3oool010000000oooo
0?ooo`3oool:0?l006d00?l0A0000?lU0?ooodL00?l01`000?m]0?l006T0oooo001K0?ooo`040000
003oool0oooo0?ooo``0o`00J`00o`120000obL0ooooA`00o`070000of/0o`00J`3oool005/0oooo
00@000000?ooo`3oool0oooo3@3o001Z003o0440003o:03ooom7003o00L0003oJP3o001/0?ooo`00
F`3oool00`000000oooo0?ooo`020?ooo`d0o`00J000o`110000obX0ooooA@00o`090000ofP0o`00
K@3oool005/0oooo00<000000?ooo`3oool00P3oool?0?l006H00?l0?`000?l/0?ooodD00?l02@00
0?mV0?l006l0oooo001K0?ooo`030000003oool0oooo0080oooo403o001U003o03h0003o;@3ooom5
003o00T0003oI@3o001`0?ooo`00F`3oool00`000000oooo0?ooo`030?oooa40o`00HP00o`0m0000
oc00oooo@`00o`0;0000of80o`00LP3oool005/0oooo00<000000?ooo`3oool00`3ooolB0?l00640
0?l0?0000?la0?oood<00?l02`000?mQ0?l007<0oooo001K0?ooo`030000003oool0oooo00<0oooo
4`3o001P003o03/0003o<P3ooom3003o00/0003oH03o001d0?ooo`00F`3oool00`000000oooo0?oo
o`040?oooa@0o`00G@00o`0j0000ocD0oooo@@00o`0=0000oed0o`00MP3oool005/0oooo00<00000
0?ooo`3oool0103ooolE0?l005`00?l0>@000?lf0?oood400?l03@000?mL0?l007L0oooo001K0?oo
o`030000003oool0oooo00@0oooo5P3o001K003o03P0003o=`3ooom1003o00d0003oF`3o001h0?oo
o`00F`3oool00`000000oooo0?ooo`050?oooaL0o`00F000o`0g0000ocX0oooo?`00o`0?0000oeP0
o`00NP3oool005/0oooo00<000000?ooo`3oool01@3ooolH0?l005L00?l0=P000?lk0?ooocl00?l0
3`000?mG0?l007/0oooo001K0?ooo`030000003oool0oooo00D0oooo6P3o001E003o03@0003o?@3o
oolo003o00l0003oE@3o001m0?ooo`00F`3oool00`000000oooo0?ooo`060?oooaX0o`00D`00o`0d
0000ocl0oooo?@00o`0A0000oe<0o`00OP3oool005/0oooo00<000000?ooo`3oool01P3ooolK0?l0
05800?l0<`000?m00?ooocd00?l04@000?mB0?l007l0oooo001K0?ooo`030000003oool0oooo00H0
oooo7@3o001@003o0340003o@P3ooolm003o0140003oD03o00210?ooo`00F`3oool00`000000oooo
0?ooo`070?oooad0o`00CP00o`0a0000od@0oooo>`00o`0C0000odh0o`00PP3oool005/0oooo00<0
00000?ooo`3oool01`3ooolN0?l004d00?l0<0000?m50?oooc/00?l04`000?m=0?l008<0oooo001K
0?ooo`030000003oool0oooo00L0oooo803o001;003o02h0003oA`3ooolk003o01<0003oB`3o0025
0?ooo`00F`3oool00`000000oooo0?ooo`080?ooob00o`00B@00o`0^0000odT0oooo>@00o`0E0000
odT0o`00QP3oool005/0oooo00<000000?ooo`3oool0203ooolR0?l004L00?l0;0000?m;0?ooocT0
0?l05@000?m70?l008P0oooo001K0?ooo`030000003oool0oooo00P0oooo8`3o0016003o02/0003o
C03oooli003o01D0003oAP3o00290?ooo`00F`3oool00`000000oooo0?ooo`090?ooob<0o`00A000
o`0[0000odh0oooo=`00o`0G0000od@0o`00RP3oool005/0oooo00<000000?ooo`3oool02@3ooolU
0?l004800?l0:@000?m@0?ooocL00?l05`000?m20?l008`0oooo001K0?ooo`030000003oool0oooo
00T0oooo9P3o0011003o02P0003oD@3ooolg003o01L0003o@@3o002=0?ooo`00F`3oool00`000000
oooo0?ooo`0:0?ooobH0o`00?`00o`0W0000oe@0oooo=@00o`0H0000ocl0o`00S`3oool005/0oooo
00<000000?ooo`3oool02P3ooolX0?l003d00?l09P000?mE0?ooocD00?l06@000?lm0?l00900oooo
001K0?ooo`030000003oool0oooo00X0oooo:@3o000l003o02D0003oEP3ooole003o01T0003o?03o
002A0?ooo`00F`3oool00`000000oooo0?ooo`0:0?ooob/0o`00>P00o`0S0000oeP0oooo=000o`0J
0000ocX0o`00T`3oool005/0oooo00<000000?ooo`3oool02`3oool[0?l003P00?l08`000?mJ0?oo
oc<00?l06`000?lh0?l009@0oooo001K0?ooo`030000003oool0oooo00/0oooo;03o000g003o0280
003oF`3ooolc003o01/0003o=`3o002E0?ooo`00F`3oool00`000000oooo0?ooo`0;0?ooobh0o`00
=@00o`0P0000oed0oooo<`00o`0K0000ocD0o`00U`3oool005/0oooo00<000000?ooo`3oool0303o
ool^0?l003<00?l080000?mO0?oooc400?l07@000?lc0?l009P0oooo001K0?ooo`030000003oool0
oooo00`0oooo<03o000a003o01h0003oH@3ooola003o01d0003o<@3o002J0?ooo`00F`3oool00`00
0000oooo0?ooo`0<0?oooc40o`00<000o`0M0000of80oooo<@00o`0M0000oc00o`00V`3oool005/0
oooo00<000000?ooo`3oool03@3ooola0?l002h00?l07@000?mT0?ooobl00?l07`000?l^0?l009`0
oooo001K0?ooo`030000003oool0oooo00d0oooo<`3o000/003o01/0003oIP3oool_003o01l0003o
;03o002N0?ooo`00F`3oool00`000000oooo0?ooo`0=0?oooc@0o`00:`00o`0J0000ofL0oooo;`00
o`0O0000ob/0o`00W`3oool005/0oooo00<000000?ooo`3oool03P3ooold0?l002T00?l06P000?mY
0?ooobd00?l08@000?lY0?l00:00oooo001K0?ooo`030000003oool0oooo00h0oooo=P3o000W003o
01P0003oJ`3oool]003o0240003o9`3o002R0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooocL0
o`009P00o`0G0000of`0oooo;@00o`0Q0000obH0o`00X`3oool005/0oooo00<000000?ooo`3oool0
3`3ooolh0?l002<00?l05P000?m_0?ooob/00?l08`000?lS0?l00:D0oooo001K0?ooo`030000003o
ool0oooo00l0oooo>@3o000R003o01D0003oL03oool[003o02<0003o8P3o002V0?ooo`00F`3oool0
0`000000oooo0?ooo`0?0?ooocX0o`008@00o`0D0000og40oooo:`00o`0S0000ob40o`00Y`3oool0
05/0oooo00<000000?ooo`3oool0403ooolk0?l001h00?l04`000?md0?ooobT00?l09@000?lN0?l0
0:T0oooo001K0?ooo`030000003oool0oooo0100oooo?03o000M003o0180003oM@3ooolY003o02D0
003o7@3o002Z0?ooo`00F`3oool00`000000oooo0?ooo`0@0?ooocd0o`007000o`0A0000ogH0oooo
:@00o`0U0000oa`0o`00Z`3oool005/0oooo00<000000?ooo`3oool04@3oooln0?l001T00?l04000
0?mi0?ooobL00?l09`000?lI0?l00:d0oooo001K0?ooo`030000003oool0oooo0140oooo?`3o000H
003o00l0003oNP3ooolW003o02L0003o603o002^0?ooo`00F`3oool00`000000oooo0?ooo`0A0?oo
od40o`005P00o`0=0000og`0oooo9`00o`0W0000oaH0o`00/03oool005/0oooo00<000000?ooo`3o
ool04P3ooom10?l001@00?l03@000?mn0?ooobD00?l0:@000?lD0?l00;40oooo001K0?ooo`030000
003oool0oooo0180oooo@P3o000C003o00`0003oO`3ooolU003o02T0003o4`3o002b0?ooo`00F`3o
ool00`000000oooo0?ooo`0B0?oood@0o`004@00o`0:0000oh40oooo9@00o`0Y0000oa40o`00]03o
ool005/0oooo00<000000?ooo`3oool04`3ooom40?l000l00?l02P000?n30?ooob<00?l0:`000?l?
0?l00;D0oooo001K0?ooo`030000003oool0oooo01<0ooooA@3o000>003o00T0003oQ03ooolS003o
02/0003o3P3o002f0?ooo`00F`3oool00`000000oooo0?ooo`0C0?ooodL0o`003000o`070000ohH0
oooo8`00o`0[0000o``0o`00^03oool005/0oooo00<000000?ooo`3oool0503ooom70?l000X00?l0
1`000?n80?ooob400?l0;@000?l:0?l00;T0oooo001K0?ooo`030000003oool0oooo01@0ooooB@3o
0008003o00D0003oRP3ooolQ003o02d0003o203o002k0?ooo`00F`3oool00`000000oooo0?ooo`0D
0?ooodX0o`001`00o`040000oh/0oooo8@00o`0]0000o`L0o`00_03oool005/0oooo00<000000?oo
o`3oool05@3ooom:0?l000D00?l010000?n=0?oooal00?l0;`000?l50?l00;d0oooo001K0?ooo`03
0000003oool0oooo01D0ooooC03o0003003o0080003oS`3ooolO003o02l0003o0`3o002o0?ooo`00
F`3oool00`000000oooo0?ooo`0E0?ooodd0o`000P00o`000`000?l0oooo0?ooo`2>0?oooal00?l0
;`000?l20?l00<00oooo001K0?ooo`030000003oool0oooo01H0ooooC@3o002C0?oooad00?l0<000
0?o20?ooo`00F`3oool00`000000oooo0?ooo`0F0?oood`0o`00U03ooolM003o02l0003o``3oool0
05/0oooo00<000000?ooo`3oool05P3ooom;0?l009D0oooo7@00o`0^0000ol@0oooo001K0?ooo`03
0000003oool0oooo01L0ooooB03o002H0?oooa/00?l0;@000?o60?ooo`00F`3oool00`000000oooo
0?ooo`0G0?ooodL0o`00V@3ooolK003o02`0003oa`3oool005/0oooo00<000000?ooo`3oool05`3o
oom60?l009X0oooo6`00o`0[0000olP0oooo001K0?ooo`030000003oool0oooo01L0ooooA03o002L
0?oooaX00?l0:P000?o:0?ooo`00F`3oool00`000000oooo0?ooo`0H0?oood80o`00WP3ooolI003o
02T0003ob`3oool005/0oooo00<000000?ooo`3oool0603ooom10?l009l0oooo6@00o`0X0000ol`0
oooo001K0?ooo`030000003oool0oooo01P0oooo?`3o002Q0?oooaT00?l09P000?o>0?ooo`00F`3o
ool00`000000oooo0?ooo`0I0?ooocd0o`00X`3ooolG003o02H0003oc`3oool005/0oooo00<00000
0?ooo`3oool06@3ooolk0?l00:D0oooo5`00o`0T0000om40oooo001K0?ooo`030000003oool0oooo
01T0oooo>P3o002V0?oooaL00?l08`000?oB0?ooo`00F`3oool00`000000oooo0?ooo`0J0?ooocP0
o`00Z03ooolE003o02<0003od`3oool005/0oooo00<000000?ooo`3oool06P3ooolf0?l00:X0oooo
5@00o`0Q0000omD0oooo001K0?ooo`030000003oool0oooo01X0oooo=@3o002[0?oooaD00?l08000
0?oF0?ooo`00F`3oool00`000000oooo0?ooo`0K0?oooc<0o`00[@3ooolC003o0200003oe`3oool0
05/0oooo00<000000?ooo`3oool06`3ooola0?l00:l0oooo4`00o`0N0000omT0oooo001K0?ooo`03
0000003oool0oooo01/0oooo<03o002`0?oooa<00?l07@000?oJ0?ooo`00F`3oool00`000000oooo
0?ooo`0L0?ooobd0o`00/`3ooolA003o01`0003og03oool005/0oooo00<000000?ooo`3oool0703o
ool/0?l00;@0oooo4@00o`0K0000omd0oooo001K0?ooo`030000003oool0oooo01`0oooo:`3o002e
0?oooa400?l06P000?oN0?ooo`00F`3oool00`000000oooo0?ooo`0M0?ooobP0o`00^03oool?003o
01T0003oh03oool005/0oooo00<000000?ooo`3oool07@3ooolW0?l00;T0oooo3`00o`0H0000on40
oooo001K0?ooo`030000003oool0oooo01d0oooo9P3o002j0?ooo`l00?l05`000?oR0?ooo`00F`3o
ool00`000000oooo0?ooo`0N0?ooob<0o`00_@3oool=003o01H0003oi03oool005/0oooo00<00000
0?ooo`3oool07P3ooolR0?l00;h0oooo3@00o`0E0000onD0oooo001K0?ooo`030000003oool0oooo
01h0oooo8@3o002o0?ooo`d00?l050000?oV0?ooo`00F`3oool00`000000oooo0?ooo`0O0?oooah0
o`00`P3oool;003o01<0003oj03oool005/0oooo00<000000?ooo`3oool07`3ooolM0?l00<<0oooo
2`00o`0B0000onT0oooo001K0?ooo`030000003oool0oooo01l0oooo6`3o00350?ooo`/00?l04000
0?o[0?ooo`00F`3oool00`000000oooo0?ooo`0P0?oooaT0o`00a`3oool9003o0100003ok03oool0
05/0oooo00<000000?ooo`3oool0803ooolH0?l00<P0oooo2@00o`0?0000ond0oooo001K0?ooo`03
0000003oool0oooo0200oooo5P3o003:0?ooo`T00?l03@000?o_0?ooo`00F`3oool00`000000oooo
0?ooo`0Q0?oooa@0o`00c03oool7003o00d0003ol03oool005/0oooo00<000000?ooo`3oool08@3o
oolC0?l00<d0oooo1`00o`0<0000oo40oooo001K0?ooo`030000003oool0oooo0240oooo4@3o003?
0?ooo`L00?l02P000?oc0?ooo`00F`3oool00`000000oooo0?ooo`0R0?ooo`l0o`00d@3oool5003o
00X0003om03oool005/0oooo00<000000?ooo`3oool08P3oool=0?l00=<0oooo1@00o`080000ooH0
oooo001K0?ooo`030000003oool0oooo0280oooo303o003D0?ooo`D00?l01`000?og0?ooo`00F`3o
ool00`000000oooo0?ooo`0S0?ooo`X0o`00eP3oool3003o00L0003on03oool005/0oooo00<00000
0?ooo`3oool08`3oool80?l00=P0oooo0`00o`050000ooX0oooo001K0?ooo`030000003oool0oooo
02<0oooo1`3o003I0?ooo`<00?l010000?ok0?ooo`00F`3oool00`000000oooo0?ooo`0T0?ooo`D0
o`00f`3oool00`00o`00003o0000o`020000oo`0oooo001K0?ooo`030000003oool0oooo02@0oooo
0`3o003M0?ooo`03003o00000?l0003o0?h0oooo001K0?ooo`030000003oool0oooo02@0oooo0P3o
003N0?ooo`03003o00000?l0oooo0?h0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool7
0?ooo`00F`3oool00`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3o
ool0o`3ooooo0?ooo`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00o`3o
oooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?oo
ool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00]@3oool2000001`0oooo0P00000L0?ooo`800000
703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000
_03oool00;@0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00000J0?ooo`04
0000003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00
000J0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3oool010000000
oooo0?ooo`00000J0?ooo`040000003oool0oooo00000;/0oooo002g0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`2i0?ooo`00]@3oool2000001`0
oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0
oooo0P00000L0?ooo`800000_03oool00;D0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo0;/0oooo002e0?ooo`<000006`3oool3000001/0oooo0`00
000K0?ooo`<000006`3oool3000001/0oooo0`00000K0?ooo`<000006`3oool3000001/0oooo0`00
002k0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00
o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00Z`3oool00`00
0000oooo0?ooo`3o0?ooo`T0oooo00<000000?ooo`3oool0ZP3oool00:X0oooo00<000000?ooo`3o
ool06P3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool0Z@3oool00:X0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool0Z@3oool00:X0oooo00@000000?ooo`3oool0oooo
100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo
100000020?ooo`@000000`3oool00`000000oooo0?ooo`2Y0?ooo`00Z@3oool00`000000oooo0?oo
o`3o0?ooo`d0oooo00<000000?ooo`3oool0Z03oool00:X0oooo00<000000?ooo`3oool0o`3oool;
0?ooo`030000003oool0oooo0:T0oooo002Z0?ooo`030000003oool0oooo0?l0oooo2`3oool00`00
0000oooo0?ooo`2Y0?ooo`00Z`3oool00`000000oooo0?ooo`3o0?ooo`T0oooo00<000000?ooo`3o
ool0ZP3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool0
0?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3o
oomU0?ooo`00[P3oool4000000L0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000>
0?ooo`@000001`3oool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000l0oooo0P000008
0?ooo`<000001@3oool3000000d0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`000005
0?ooo`<000003@3oool3000000D0oooo0`00000>0?ooo`@000001`3oool3000000D0oooo0`00002_
0?ooo`00[P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0:h0oooo002_0?oo
o`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?oo
o`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?oo
o`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`070?oo
o`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`000000oooo0?ooo`0>0?oo
o`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?oo
o`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?oo
o`3oool0[P3oool00;00oooo00<000000?ooo`3oool01`3oool010000000oooo0?ooo`0000030?oo
o`8000003`3oool010000000oooo0?ooo`0000030?ooo`8000004@3oool00`000000oooo0?ooo`07
0?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo
0P00000B0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool000000`3oool2000000l0
oooo00@000000?ooo`3oool000000`3oool200000140oooo00<000000?ooo`3oool01`3oool01000
0000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000030?ooo`8000004@3o
ool00`000000oooo0?ooo`070?ooo`040000003oool0oooo000000<0oooo0P00002`0?ooo`00[P3o
ool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@0
00000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo0000
01@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000003o
ool0oooo000001@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?oo
o`040000003oool0oooo00000;D0oooo002_0?ooo`800000203oool4000000D0oooo00<000000?oo
o`3oool0303oool4000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo100000050?oo
o`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?oo
o`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?oo
o`800000203oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<000000?oo
o`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo0:h0oooo003o0?ooool0
ooooI@3oool00?l0ooooo`3ooomU0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 610.563}, {170.188, 0}} -> {-0.426205, -0.013998, \
0.00467178, 0.00467178}, {{91.1875, 295.063}, {167.188, 47.3125}} -> \
{-1.34175, -0.0239702, 0.00793648, 0.00793648}, {{315.438, 519.313}, \
{167.188, 47.3125}} -> {-3.12151, -0.0239702, 0.00793648, 0.00793648}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .16569 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00394499 0.47619 [
[.5 .17819 -146 0 ]
[.5 .17819 146 38.75 ]
[ 0 0 0 0 ]
[ 1 .16569 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00394 m
1 .00394 L
s
.02381 0 m
.02381 .16569 L
s
gsave
.5 .17819 -207 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(2) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(3) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(3) show
237.000 12.750 moveto
(Pi) show
261.000 12.750 moveto
(2) show
273.000 12.750 moveto
(Pi) show
297.000 12.750 moveto
(Pi) show
321.000 12.750 moveto
(4) show
333.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
(--) show
249.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
261.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
273.000 25.875 moveto
(--) show
285.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
297.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
309.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
321.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
333.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
345.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
105.000 39.000 moveto
(7) show
135.000 39.000 moveto
(7) show
165.000 39.000 moveto
(7) show
195.000 39.000 moveto
(7) show
231.000 39.000 moveto
(7) show
267.000 39.000 moveto
(7) show
297.000 39.000 moveto
(7) show
327.000 39.000 moveto
(7) show
333.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .16569 L
0 .16569 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00394499 0.477324 0.161744 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.198062 0.801938 1.12079e-017 0.801938 [
[ 0 0 0 0 ]
[ 1 .34795 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .34795 L
0 .34795 L
closepath
clip
newpath
0 1 0 r
0 0 m
.44504 0 L
.5 .24079 L
F
0 0 1 r
.44504 0 m
1 0 L
.5 .24079 L
F
1 0 0 r
0 0 m
.5 .24079 L
.27748 .34795 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00394499 0.97619 0.161744 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.198062 0.801938 1.12079e-017 0.801938 [
[ 0 0 0 0 ]
[ 1 .34795 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .34795 L
0 .34795 L
closepath
clip
newpath
0 1 0 r
.27748 .34795 m
0 0 L
.19806 0 L
F
0 0 1 r
.19806 0 m
.42058 .27903 L
.27748 .34795 L
F
1 0 0 r
.19806 0 m
1 0 L
.42058 .27903 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.438, 101.313},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000IB000`400?l00000o`00003oS03oool0
0`000000oooo0?ooo`3o0?ooomD0oooo002<0?ooo`030000003oool0oooo0?l0ooooe@3oool008@0
ooooo`00001K000008D0oooo002<0?ooo`030000003o0000o`0004@00?l0E0000?lC0?oooal00?l0
NP3o002@0?ooo`00S03oool00`000000oooo0?l000020?l004800?l0DP000?lF0?oooah00?l000<0
003o0?l0003o0000M@3o002B0?ooo`00S03oool00`000000oooo0?ooo`040?l004000?l0D0000?lI
0?oooad00?l00P000?md0?l009@0oooo002<0?ooo`040000003oool0oooo0?ooo`D0o`00?P00o`1>
0000oa`0oooo7000o`030000og40o`00UP3oool008`0oooo00<000000?ooo`3oool00P3oool60?l0
03d00?l0B`000?lN0?oooad00?l00P000?m_0?l009P0oooo002<0?ooo`030000003oool0oooo0080
oooo203o000k003o04T0003o8@3ooolL003o00<0003oK03o002J0?ooo`00S03oool00`000000oooo
0?ooo`030?ooo`T0o`00>@00o`170000ob@0oooo6`00o`040000ofT0o`00W03oool008`0oooo00<0
00000?ooo`3oool0103oool;0?l003H00?l0A@000?lW0?oooaX00?l01@000?mV0?l009h0oooo002<
0?ooo`030000003oool0oooo00D0oooo303o000e003o0480003o:P3ooolI003o00H0003oHP3o002Q
0?ooo`00S03oool00`000000oooo0?ooo`060?ooo`d0o`00<`00o`0o0000obd0oooo6P00o`050000
of00o`00X`3oool008`0oooo00<000000?ooo`3oool01P3oool?0?l003400?l0?@000?l`0?oooaT0
0?l01P000?mM0?l00:D0oooo002<0?ooo`030000003oool0oooo00L0oooo403o000_003o03/0003o
<`3ooolH003o00L0003oFP3o002W0?ooo`00S03oool00`000000oooo0?ooo`080?oooa40o`00;P00
o`0h0000ocH0oooo5`00o`080000oeL0o`00Z@3oool008`0oooo00<000000?ooo`3oool02@3ooolB
0?l002`00?l0=P000?li0?oooaL00?l020000?mD0?l00:/0oooo002<0?ooo`030000003oool0oooo
00X0oooo503o000Y003o03@0003o>`3ooolG003o00P0003oDP3o002]0?ooo`00S03oool00`000000
oooo0?ooo`0;0?oooaD0o`009`00o`0b0000och0oooo5P00o`090000odl0o`00[`3oool008`0oooo
00<000000?ooo`3oool02`3ooolG0?l002H00?l0;`000?m10?oooaD00?l02P000?m<0?l00;40oooo
002<0?ooo`030000003oool0oooo00`0oooo603o000T003o02d0003oA03ooolD003o00/0003oB03o
002d0?ooo`00S03oool00`000000oooo0?ooo`0=0?oooaT0o`008P00o`0Z0000odP0oooo5000o`0;
0000odD0o`00]P3oool008`0oooo00<000000?ooo`3oool03P3ooolJ0?l002000?l0:0000?m:0?oo
oa@00?l02`000?m30?l00;P0oooo002<0?ooo`030000003oool0oooo00l0oooo6`3o000O003o02D0
003oC@3ooolC003o00`0003o@03o002j0?ooo`00S03oool00`000000oooo0?ooo`0?0?oooad0o`00
7@00o`0S0000oe00oooo4P00o`0=0000ocd0o`00_03oool008`0oooo00<000000?ooo`3oool0403o
oolO0?l001X00?l08@000?mC0?oooa800?l03@000?lj0?l00;h0oooo002<0?ooo`030000003oool0
oooo0140oooo803o000H003o01l0003oEP3ooolA003o00d0003o>03o00300?ooo`00S03oool00`00
0000oooo0?ooo`0B0?ooob40o`005`00o`0L0000oeP0oooo4@00o`0>0000ocD0o`00`P3oool008`0
oooo00<000000?ooo`3oool04`3ooolR0?l001D00?l06P000?mK0?oooa000?l03`000?la0?l00<D0
oooo002<0?ooo`030000003oool0oooo01<0oooo903o000C003o01P0003oGP3oool?003o0100003o
;P3o00370?ooo`00S03oool00`000000oooo0?ooo`0D0?ooobD0o`004@00o`0E0000of80oooo3`00
o`0@0000ob/0o`00b@3oool008`0oooo00<000000?ooo`3oool05@3ooolV0?l001000?l04P000?mU
0?ooo`h00?l040000?lY0?l00</0oooo002<0?ooo`030000003oool0oooo01H0oooo:03o000=003o
0100003oI`3oool>003o0140003o9P3o003=0?ooo`00S03oool00`000000oooo0?ooo`0G0?ooobT0
o`002`00o`0>0000ofX0oooo3@00o`0B0000ob<0o`00c`3oool008`0oooo00<000000?ooo`3oool0
603ooolZ0?l000T00?l030000?m]0?ooo`d00?l04P000?lP0?l00=40oooo002<0?ooo`030000003o
ool0oooo01P0oooo;03o0008003o00T0003oL03oool<003o01<0003o7@3o003C0?ooo`00S03oool0
0`000000oooo0?ooo`0I0?ooobd0o`001P00o`070000og<0oooo2`00o`0C0000oa/0o`00e@3oool0
08`0oooo00<000000?ooo`3oool06P3oool^0?l000@00?l01@000?me0?ooo`/00?l050000?lG0?l0
0=P0oooo002<0?ooo`030000003oool0oooo01/0oooo;`3o0002003o00<0003oN03oool:003o01D0
003o503o003J0?ooo`00S03oool00`000000oooo0?ooo`0L0?oooc00o`00O03oool:003o01D0003o
4@3o003L0?ooo`00S03oool00`000000oooo0?ooo`0L0?ooobh0o`00O`3oool9003o01H0003o3P3o
003N0?ooo`00S03oool00`000000oooo0?ooo`0M0?ooob/0o`00PP3oool8003o01H0003o303o003P
0?ooo`00S03oool00`000000oooo0?ooo`0N0?ooobP0o`00Q03oool8003o01L0003o2@3o003R0?oo
o`00S03oool00`000000oooo0?ooo`0O0?ooobD0o`00Q`3oool8003o01L0003o1P3o003T0?ooo`00
S03oool00`000000oooo0?ooo`0P0?ooob80o`00RP3oool7003o01P0003o0`3o003V0?ooo`00S03o
ool00`000000oooo0?ooo`0Q0?oooal0o`00S@3oool6003o01P0003oj@3oool008`0oooo00<00000
0?ooo`3oool08@3ooolM0?l00900oooo1@00o`0F0000on/0oooo002<0?ooo`030000003oool0oooo
0280oooo6P3o002B0?ooo`D00?l050000?o]0?ooo`00S03oool00`000000oooo0?ooo`0S0?oooaL0
o`00U@3oool5003o0140003ok`3oool008`0oooo00<000000?ooo`3oool0903ooolD0?l009P0oooo
1000o`0?0000oo40oooo002<0?ooo`030000003oool0oooo02D0oooo4@3o002K0?ooo`<00?l03@00
0?oc0?ooo`00S03oool00`000000oooo0?ooo`0U0?ooo`l0o`00WP3oool2003o00/0003om@3oool0
08`0oooo00<000000?ooo`3oool09P3oool<0?l00:00oooo0`00o`080000ooL0oooo002<0?ooo`03
0000003oool0oooo02L0oooo2@3o002S0?ooo`800?l01P000?oi0?ooo`00S03oool00`000000oooo
0?ooo`0X0?ooo`H0o`00YP3oool00`00o`00003o0000o`020000oo/0oooo002<0?ooo`030000003o
ool0oooo02T0oooo0`3o002Y0?ooo`80003oo@3oool008`0oooo00<000000?ooo`3oool0o`3ooooE
0?ooo`00S03oool00`000000oooo0?ooo`3o0?ooomD0oooo003o0?ooool0ooooI@3oool00?l0oooo
o`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?oo
o`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00/03oool0
0`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool0
0`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool0
0`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0]03oool0
0;00oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo
0240oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
0;@0oooo002`0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`0Q0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`2d0?ooo`00/@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0240oooo
00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool0/`3oool00:h0oooo00@000000?ooo`3oool000006P3oool010000000oooo
0?ooo`00000J0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3oool0
10000000oooo0?ooo`00000P0?ooo`040000003oool0oooo00000200oooo00@000000?ooo`3oool0
00006P3oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo00000;D0oooo002^0?oo
o`@000006P3oool4000001X0oooo1000000J0?ooo`@000006P3oool400000200oooo1000000P0?oo
o`@000006P3oool4000001X0oooo1000002e0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0oooo
I@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00Y@3oool00`000000oooo0?ooo`3o0?oooaD0oooo00<000000?ooo`3oool0
Y03oool00:@0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0E0?ooo`030000003o
ool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003o
ool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000003o
ool0oooo0240oooo00<000000?ooo`3oool0X`3oool00:@0oooo00<000000?ooo`3oool06P3oool0
0`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool05@3oool0
0`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool0
0`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0X`3oool0
0:@0oooo00@000000?ooo`3oool0oooo100000020?ooo`@000000P3oool400000080oooo10000004
0?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`07
0?ooo`@000000P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`07
0?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo10000002
0?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo10000002
0?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo10000002
0?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo10000004
0?ooo`030000003oool0oooo00L0oooo100000020?ooo`@000000P3oool400000080oooo10000003
0?ooo`030000003oool0oooo0:<0oooo002S0?ooo`030000003oool0oooo0?l0oooo6@3oool00`00
0000oooo0?ooo`2R0?ooo`00Y03oool00`000000oooo0?ooo`3o0?oooaL0oooo00<000000?ooo`3o
ool0X`3oool00:@0oooo00<000000?ooo`3oool0o`3ooolG0?ooo`030000003oool0oooo0:<0oooo
002U0?ooo`030000003oool0oooo0?l0oooo5@3oool00`000000oooo0?ooo`2T0?ooo`00o`3ooooo
0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo
003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002Z0?ooo`<0
00001P3oool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000h0oooo100000070?ooo`<0
00001@3oool3000000d0oooo0`0000050?ooo`<000003`3oool2000000P0oooo0`0000050?ooo`<0
00003`3oool2000000P0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`0000050?ooo`<0
00003@3oool3000000D0oooo0`00000@0?ooo`<000001P3oool3000000D0oooo0`00002Y0?ooo`00
Z`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0
3@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0
2@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3o
ool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool0403oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool0Z03oool00:P0oooo1@0000070?ooo`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<0
00001@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?ooo`03
0000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3o
ool01`3oool3000000D0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`070?ooo`<0
00001@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?ooo`03
0000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo00d0oooo1@0000070?ooo`<0
00001@3oool00`000000oooo0?ooo`2X0?ooo`00Z03oool010000000oooo0?ooo`0000080?ooo`04
0000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000A
0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@0
00000?ooo`3oool000000`3oool200000180oooo00<000000?ooo`3oool01P3oool010000000oooo
0?ooo`0000030?ooo`8000004P3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
00<0oooo0P00000A0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool2
000000l0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool00000
203oool010000000oooo0?ooo`0000030?ooo`800000ZP3oool00:T0oooo00<000000?ooo`000000
203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?oo
o`3oool00000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo
00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo
000000P0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000
003oool0oooo000001@0oooo00@000000?ooo`3oool000005@3oool00`000000oooo000000080?oo
o`040000003oool0oooo00000:l0oooo002Z0?ooo`8000001`3oool4000000D0oooo00<000000?oo
o`3oool0303oool4000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo100000050?oo
o`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?oo
o`@000001@3oool00`000000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?oo
o`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo00`0oooo100000050?oo
o`030000003oool0oooo00l0oooo0P0000070?ooo`@000001@3oool00`000000oooo0?ooo`2X0?oo
o`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00001\
\>"],
  ImageRangeCache->{{{0, 610.438}, {100.313, 0}} -> {-0.855249, -0.00828636, \
0.00607843, 0.00607843}, {{140.688, 297.375}, {98.9375, 44.375}} -> \
{-1.36664, -0.0111165, 0.00795846, 0.00795846}, {{313, 469.688}, {98.9375, \
44.375}} -> {-2.73798, -0.0111165, 0.00795846, 0.00795846}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .12517 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00298034 0.47619 [
[.5 .13767 -134 0 ]
[.5 .13767 134 38.75 ]
[ 0 0 0 0 ]
[ 1 .12517 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00298 m
1 .00298 L
s
.02381 0 m
.02381 .12517 L
s
gsave
.5 .13767 -195 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Pi) show
93.000 12.750 moveto
(Pi) show
117.000 12.750 moveto
(3) show
129.000 12.750 moveto
(Pi) show
153.000 12.750 moveto
(Pi) show
177.000 12.750 moveto
(Pi) show
201.000 12.750 moveto
(2) show
213.000 12.750 moveto
(Pi) show
237.000 12.750 moveto
(3) show
249.000 12.750 moveto
(Pi) show
273.000 12.750 moveto
(Pi) show
297.000 12.750 moveto
(3) show
309.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
105.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
117.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
129.000 25.875 moveto
(--) show
141.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
153.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
165.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
177.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
189.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
201.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
213.000 25.875 moveto
(--) show
225.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
237.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
249.000 25.875 moveto
(--) show
261.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
273.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
285.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
297.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
309.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
321.000 25.875 moveto
(<) show
69.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
93.000 39.000 moveto
(5) show
123.000 39.000 moveto
(10) show
153.000 39.000 moveto
(10) show
177.000 39.000 moveto
(2) show
207.000 39.000 moveto
(5) show
243.000 39.000 moveto
(10) show
273.000 39.000 moveto
(10) show
303.000 39.000 moveto
(5) show
309.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .12517 L
0 .12517 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00298034 0.477324 0.122194 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.552786 0.447214 -6.95245e-018 0.447214 [
[ 0 0 0 0 ]
[ 1 .26287 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .26287 L
0 .26287 L
closepath
clip
newpath
0 1 0 r
0 0 m
.30902 0 L
.30902 .22451 L
F
0 0 1 r
.30902 0 m
1 0 L
.30902 .22451 L
F
1 0 0 r
0 0 m
.30902 .22451 L
.19098 .26287 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00298034 0.97619 0.122194 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.552786 0.447214 -1.09775e-018 0.447214 [
[ 0 0 0 0 ]
[ 1 .26287 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .26287 L
0 .26287 L
closepath
clip
newpath
0 1 0 r
.19098 .26287 m
0 0 L
.55279 0 L
F
0 0 1 r
.55279 0 m
.6382 .11756 L
.19098 .26287 L
F
1 0 0 r
.55279 0 m
1 0 L
.6382 .11756 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.125, 76.5},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000C2000`400?l00000o`00003o/@3oool0
0`000000oooo0?ooo`3o0?oook00oooo002[0?ooool000003@00002/0?ooo`00/@3oool00`000000
o`00003o000S003o0500003o4@3ooom0003o0080003o<`3o002f0?ooo`00/@3oool00`000000oooo
0?l0000S003o04d0003o5@3oooln003o00@0003o;`3o002i0?ooo`00/@3oool00`000000oooo0?oo
o`020?l002400?l0BP000?lI0?oooc/00?l01`000?l[0?l00;`0oooo002a0?ooo`030000003oool0
oooo00<0o`008000o`170000oa`0oooo>P00o`090000obL0o`00_`3oool00;40oooo00@000000?oo
o`3oool0oooo103o000N003o04@0003o803ooolh003o00X0003o903o00320?ooo`00/@3oool00`00
0000oooo0?ooo`020?ooo`@0o`007@00o`110000ob@0oooo=@00o`0=0000ob00o`00a@3oool00;40
oooo00<000000?ooo`3oool00`3oool40?l001`00?l0?P000?lX0?oooc<00?l03`000?lK0?l00<T0
oooo002a0?ooo`030000003oool0oooo00<0oooo1P3o000J003o03/0003o:`3ooolb003o0140003o
5`3o003<0?ooo`00/@3oool00`000000oooo0?ooo`040?ooo`H0o`006@00o`0h0000obl0oooo;`00
o`0D0000oa<0o`00c`3oool00;40oooo00<000000?ooo`3oool01@3oool70?l001L00?l0=@000?lc
0?ooobd00?l05@000?l@0?l00=80oooo002a0?ooo`030000003oool0oooo00H0oooo1`3o000F003o
0380003o=P3oool/003o01L0003o303o003E0?ooo`00/@3oool00`000000oooo0?ooo`060?ooo`P0
o`005@00o`0_0000ocX0oooo:@00o`0J0000o`P0o`00f03oool00;40oooo00<000000?ooo`3oool0
1`3oool90?l001<00?l0;0000?ln0?ooobL00?l070000?l40?l00=/0oooo002a0?ooo`030000003o
ool0oooo00P0oooo2@3o000B003o02P0003o@`3ooolU003o01d0003og`3oool00;40oooo00<00000
0?ooo`3oool02@3oool:0?l001000?l09@000?m60?ooob<00?l070000?oR0?ooo`00/@3oool00`00
0000oooo0?ooo`090?ooo`/0o`003`00o`0R0000odX0oooo8@00o`0J0000onD0oooo002a0?ooo`03
0000003oool0oooo00X0oooo2`3o000>003o01l0003oCP3ooolO003o01P0003oj03oool00;40oooo
00<000000?ooo`3oool02`3oool<0?l000`00?l070000?mA0?oooad00?l05`000?o[0?ooo`00/@3o
ool00`000000oooo0?ooo`0<0?ooo``0o`002`00o`0I0000oeD0oooo6`00o`0E0000onh0oooo002a
0?ooo`030000003oool0oooo00`0oooo3P3o0009003o01H0003oF@3ooolI003o01<0003ol@3oool0
0;40oooo00<000000?ooo`3oool03@3oool>0?l000P00?l04`000?mM0?oooaH00?l04P000?od0?oo
o`00/@3oool00`000000oooo0?ooo`0>0?ooo`h0o`001`00o`0@0000of00oooo5@00o`0@0000ooL0
oooo002a0?ooo`030000003oool0oooo00l0oooo3`3o0005003o00d0003oI03ooolC003o00h0003o
nP3oool00;40oooo00<000000?ooo`3oool03`3oool@0?l000@00?l02P000?mX0?oooa000?l03@00
0?om0?ooo`00/@3oool00`000000oooo0?ooo`0@0?oooa40o`000P00o`070000of/0oooo3`00o`0;
0000ool0oooo0@3oool00;40oooo00<000000?ooo`3oool04@3ooolA0?l00003003o00000?l0003o
0080003oK`3oool=003o00T0003oo`3oool40?ooo`00/@3oool00`000000oooo0?ooo`0B0?oooa40
o`00M03oool:003o00P0003oo`3oool70?ooo`00/@3oool00`000000oooo0?ooo`0B0?ooo`l0o`00
M`3oool8003o00H0003oo`3oool:0?ooo`00/@3oool00`000000oooo0?ooo`0C0?ooo`/0o`00NP3o
ool7003o00@0003oo`3oool=0?ooo`00/@3oool00`000000oooo0?ooo`0D0?ooo`L0o`00OP3oool4
003o00<0003oo`3oool@0?ooo`00/@3oool00`000000oooo0?ooo`0E0?ooo`<0o`00PP3oool2003o
00030000o`3oool0oooo0?l0oooo4@3oool00;40oooo00<000000?ooo`3oool0o`3ooon`0?ooo`00
o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?oo
ofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002d
0?ooo`@000005@3oool2000001/0oooo1@0000020?ooo`8000005@3oool500000080oooo0P00000?
0?ooo`@000006`3oool200000240oooo1@0000020?ooo`8000005@3oool500000080oooo0P00000F
0?ooo`800000`P3oool00;@0oooo00<000000?ooo`3oool05@3oool010000000oooo0?ooo`00000L
0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0D0?ooo`050000003o
ool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo01/0oooo
00@000000?ooo`3oool000008P3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?oo
o`3oool0503oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool04P3oool0
10000000oooo0?ooo`0000310?ooo`00]@3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0
oooo01X0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo01@0oooo00D0
00000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0
7@3oool00`000000oooo0?ooo`0P0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000
oooo0?ooo`0D0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0E0?oo
o`030000003oool0oooo0;l0oooo002f0?ooo`030000003oool0oooo01@0oooo0P00000M0?ooo`05
0000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0D0?ooo`050000003oool0oooo
0?ooo`0000000P3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo01X0oooo0P00000S
0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0D0?ooo`050000003o
ool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0C0?ooo`800000`P3oool00;@0oooo00@0
00000?ooo`3oool000005@3oool00`000000oooo0?ooo`0L0?ooo`050000003oool0oooo0?ooo`00
00000P3oool00`000000oooo0?ooo`0D0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`00
0000oooo0?ooo`0<0?ooo`040000003oool0oooo000001/0oooo00<000000?ooo`3oool08P3oool0
1@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool0503oool01@000000oooo0?oo
o`3oool000000080oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`310?ooo`00]@3o
ool2000001H0oooo0`00000K0?ooo`800000103oool2000001H0oooo0P0000040?ooo`800000403o
ool2000001`0oooo0`00000Q0?ooo`800000103oool2000001H0oooo0P0000040?ooo`8000005P3o
ool300000<40oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002a0?oo
o`030000003oool0oooo0?`0oooo00<000000?ooo`3oool0/03oool00;00oooo00<000000?ooo`3o
ool03P3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool0[`3oool00;00oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool0[`3oool00;00oooo00@000000?ooo`3oool0oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000<0oooo
00<000000?ooo`3oool0[`3oool00:l0oooo00<000000?ooo`3oool0o`3oool10?ooo`030000003o
ool0oooo0:h0oooo002`0?ooo`030000003oool0oooo0?h0oooo00<000000?ooo`3oool0[`3oool0
0;00oooo00<000000?ooo`3oool0oP3oool00`000000oooo0?ooo`2_0?ooo`00/@3oool00`000000
oooo0?ooo`3l0?ooo`030000003oool0oooo0;00oooo003o0?ooool0ooooI@3oool00?l0ooooo`3o
oomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00
o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00;<0oooo0`0000050?ooo`<000003@3oool3
000000D0oooo0`00000?0?ooo`800000203oool3000000D0oooo0`00000=0?ooo`<000001@3oool3
000000d0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`0000050?ooo`<000003`3oool2
000000P0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000?0?ooo`800000203oool3
000000D0oooo0`00002e0?ooo`00]03oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo
00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo
000000P0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00d0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00d0oooo00@000000?ooo`3oool00000203oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003o
ool0oooo000000P0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`2d0?ooo`00]03o
ool3000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03`3o
ool00`000000oooo0?ooo`070?ooo`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3o
ool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`000000oooo0?ooo`0>0?ooo`030000003o
ool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool01`3o
ool3000000D0oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03`3o
ool00`000000oooo0?ooo`070?ooo`<000001@3oool00`000000oooo0?ooo`2d0?ooo`00]03oool0
10000000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000030?ooo`800000
4P3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`04
0000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000A
0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3oool000000`3oool200000180oooo00<0
00000?ooo`3oool01P3oool010000000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo
0?ooo`0000030?ooo`8000004P3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
00<0oooo0P00002f0?ooo`00]03oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo
000001@0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00000D0?ooo`040000
003oool0oooo000001@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`000008
0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool010000000oooo
0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool0
10000000oooo0?ooo`00002k0?ooo`00/`3oool4000000D0oooo00<000000?ooo`3oool0303oool4
000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0
oooo00`0oooo100000050?ooo`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0
oooo00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`0>0?ooo`800000203oool4
000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<000000?ooo`3oool03P3oool2
000000P0oooo100000050?ooo`030000003oool0oooo0;@0oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 610.125}, {75.5, 0}} -> {-1.39991, -0.00626017, \
0.00786694, 0.00786694}, {{177.938, 299}, {74.6875, 42.875}} -> {-4.52423, \
-0.0150155, 0.018477, 0.018477}, {{311.063, 432.125}, {74.6875, 42.875}} -> \
{-6.98398, -0.0150155, 0.018477, 0.018477}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(Pi) show
153.000 12.750 moveto
(Pi) show
177.000 12.750 moveto
(2) show
189.000 12.750 moveto
(Pi) show
213.000 12.750 moveto
(2) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(2) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
153.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
165.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
177.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
189.000 25.875 moveto
(--) show
201.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
213.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
225.000 25.875 moveto
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(5) show
129.000 39.000 moveto
(5) show
153.000 39.000 moveto
(5) show
183.000 39.000 moveto
(5) show
219.000 39.000 moveto
(5) show
255.000 39.000 moveto
(5) show
285.000 39.000 moveto
(5) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -2.23075e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.38197 0 L
.5 .36327 L
F
0 0 1 r
.38197 0 m
1 0 L
.5 .36327 L
F
1 0 0 r
0 0 m
.5 .36327 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -1.19262e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.38197 0 m
.5 .36327 L
.19098 .58779 L
F
0 0 1 r
.19098 .58779 m
0 0 L
.38197 0 L
F
1 0 0 r
.38197 0 m
1 0 L
.5 .36327 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000Zb000`400?l00000o`00003oF`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?oo
o`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00D03ooooo00000<@00000
D03oool005/0oooo00<000000?l00000o`00C000o`1l0000oaH0ooooC@000?l00`00o`00o`000?l0
001j0?l005d0oooo001K0?ooo`030000003o0000o`0004`00?l0N`000?lG0?ooodd0003o00<00?l0
0?l0003o0000N@3o001N0?ooo`00F`3oool00`000000o`000?l000020?l004X00?l0N@000?lI0?oo
odd0003o00<00?l00?l0003o0000M`3o001P0?ooo`00F`3oool00`000000oooo0?l000030?l004X0
0?l0M`000?lK0?oood/0003o0`00o`1g0?l00640oooo001K0?ooo`030000003oool0o`0000@0o`00
B@00o`1f0000oa`0ooooB`000?l3003o07H0o`00HP3oool005/0oooo00<000000?ooo`3o00001P3o
0017003o07@0003o7P3ooom;0000o`<00?l0M03o001T0?ooo`00F`3oool00`000000oooo0?ooo`07
0?l004L00?l0LP000?lP0?ooodT0003o1@00o`1b0?l006D0oooo001K0?ooo`030000003oool0oooo
00T0o`00A@00o`1`0000ob80ooooB@000?l5003o0700o`00I`3oool005/0oooo00<000000?ooo`3o
ool02P3o0014003o06l0003o8`3ooom90000o`D00?l0K`3o001X0?ooo`00F`3oool010000000oooo
0?ooo`3oool:0?l004@00?l0K@000?lU0?ooodL0003o1`00o`1]0?l006T0oooo001K0?ooo`040000
003oool0oooo0?ooo``0o`00@P00o`1[0000obL0ooooA`000?l7003o06/0o`00J`3oool005/0oooo
00@000000?ooo`3oool0oooo3@3o0011003o06X0003o:03ooom70000o`L00?l0JP3o001/0?ooo`00
F`3oool00`000000oooo0?ooo`020?ooo`d0o`00@@00o`1X0000obX0ooooA@000?l9003o06P0o`00
K@3oool005/0oooo00<000000?ooo`3oool00P3oool?0?l003l00?l0IP000?l/0?ooodD0003o2@00
o`1V0?l006l0oooo001K0?ooo`030000003oool0oooo0080oooo403o000n003o06D0003o;@3ooom5
0000o`T00?l0I@3o001`0?ooo`00F`3oool00`000000oooo0?ooo`030?oooa40o`00?@00o`1R0000
oc00oooo@`000?l;003o0680o`00LP3oool005/0oooo00<000000?ooo`3oool00`3ooolB0?l003`0
0?l0H@000?la0?oood<0003o2`00o`1Q0?l007<0oooo001K0?ooo`030000003oool0oooo00<0oooo
4`3o000k003o0600003o<P3ooom30000o`/00?l0H03o001d0?ooo`00F`3oool00`000000oooo0?oo
o`040?oooa@0o`00>P00o`1M0000ocD0oooo@@000?l=003o05d0o`00MP3oool005/0oooo00<00000
0?ooo`3oool0103ooolE0?l003T00?l0G0000?lf0?oood40003o3@00o`1L0?l007L0oooo001K0?oo
o`030000003oool0oooo00@0oooo5P3o000h003o05/0003o=`3ooom10000o`d00?l0F`3o001h0?oo
o`00F`3oool00`000000oooo0?ooo`050?oooaL0o`00=`00o`1H0000ocX0oooo?`000?l?003o05P0
o`00NP3oool005/0oooo00<000000?ooo`3oool01@3ooolH0?l003H00?l0E`000?lk0?ooocl0003o
3`00o`1G0?l007/0oooo001K0?ooo`030000003oool0oooo00D0oooo6P3o000d003o05D0003o?@3o
oolo0000o`l00?l0E@3o001m0?ooo`00F`3oool00`000000oooo0?ooo`060?oooaX0o`00=000o`1C
0000ocl0oooo?@000?lA003o05<0o`00OP3oool005/0oooo00<000000?ooo`3oool01P3ooolK0?l0
03<00?l0DP000?m00?ooocd0003o4@00o`1B0?l007l0oooo001K0?ooo`030000003oool0oooo00H0
oooo7@3o000a003o0500003o@P3ooolm0000oa400?l0D03o00210?ooo`00F`3oool00`000000oooo
0?ooo`070?oooad0o`00<@00o`1>0000od@0oooo>`000?lC003o04h0o`00PP3oool005/0oooo00<0
00000?ooo`3oool01`3ooolN0?l003000?l0C@000?m50?oooc/0003o4`00o`1=0?l008<0oooo001K
0?ooo`030000003oool0oooo00L0oooo803o000^003o04/0003oA`3ooolk0000oa<00?l0B`3o0025
0?ooo`00F`3oool00`000000oooo0?ooo`080?ooob00o`00;P00o`190000odT0oooo>@000?lE003o
04T0o`00QP3oool005/0oooo00<000000?ooo`3oool0203ooolR0?l002`00?l0A`000?m;0?ooocT0
003o5@00o`170?l008P0oooo001K0?ooo`030000003oool0oooo00P0oooo8`3o000[003o04H0003o
C03oooli0000oaD00?l0AP3o00290?ooo`00F`3oool00`000000oooo0?ooo`090?ooob<0o`00:`00
o`140000odh0oooo=`000?lG003o04@0o`00RP3oool005/0oooo00<000000?ooo`3oool02@3ooolU
0?l002T00?l0@P000?m@0?ooocL0003o5`00o`120?l008`0oooo001K0?ooo`030000003oool0oooo
00T0oooo9P3o000X003o0440003oD@3ooolg0000oaL00?l0@@3o002=0?ooo`00F`3oool00`000000
oooo0?ooo`0:0?ooobH0o`009`00o`0o0000oe@0oooo=@000?lH003o03l0o`00S`3oool005/0oooo
00<000000?ooo`3oool02P3ooolX0?l002H00?l0?@000?mE0?ooocD0003o6@00o`0m0?l00900oooo
001K0?ooo`030000003oool0oooo00X0oooo:@3o000U003o03`0003oEP3ooole0000oaT00?l0?03o
002A0?ooo`00F`3oool00`000000oooo0?ooo`0:0?ooob/0o`008`00o`0j0000oeP0oooo=0000?lJ
003o03X0o`00T`3oool005/0oooo00<000000?ooo`3oool02`3oool[0?l002<00?l0>0000?mJ0?oo
oc<0003o6`00o`0h0?l009@0oooo001K0?ooo`030000003oool0oooo00/0oooo;03o000R003o03L0
003oF`3ooolc0000oa/00?l0=`3o002E0?ooo`00F`3oool00`000000oooo0?ooo`0;0?ooobh0o`00
8000o`0e0000oed0oooo<`000?lK003o03D0o`00U`3oool005/0oooo00<000000?ooo`3oool0303o
ool^0?l002000?l0<`000?mO0?oooc40003o7@00o`0c0?l009P0oooo001K0?ooo`030000003oool0
oooo00`0oooo<03o000N003o0340003oH@3ooola0000oad00?l0<@3o002J0?ooo`00F`3oool00`00
0000oooo0?ooo`0<0?oooc40o`007@00o`0`0000of80oooo<@000?lM003o0300o`00V`3oool005/0
oooo00<000000?ooo`3oool03@3ooola0?l001d00?l0;P000?mT0?ooobl0003o7`00o`0^0?l009`0
oooo001K0?ooo`030000003oool0oooo00d0oooo<`3o000K003o02`0003oIP3oool_0000oal00?l0
;03o002N0?ooo`00F`3oool00`000000oooo0?ooo`0=0?oooc@0o`006P00o`0[0000ofL0oooo;`00
0?lO003o02/0o`00W`3oool005/0oooo00<000000?ooo`3oool03P3ooold0?l001X00?l0:@000?mY
0?ooobd0003o8@00o`0Y0?l00:00oooo001K0?ooo`030000003oool0oooo00h0oooo=P3o000H003o
02L0003oJ`3oool]0000ob400?l09`3o002R0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooocL0
o`005`00o`0V0000of`0oooo;@000?lQ003o02H0o`00X`3oool005/0oooo00<000000?ooo`3oool0
3`3ooolh0?l001H00?l08`000?m_0?ooob/0003o8`00o`0S0?l00:D0oooo001K0?ooo`030000003o
ool0oooo00l0oooo>@3o000E003o0280003oL03oool[0000ob<00?l08P3o002V0?ooo`00F`3oool0
0`000000oooo0?ooo`0?0?ooocX0o`005000o`0Q0000og40oooo:`000?lS003o0240o`00Y`3oool0
05/0oooo00<000000?ooo`3oool0403ooolk0?l001<00?l07P000?md0?ooobT0003o9@00o`0N0?l0
0:T0oooo001K0?ooo`030000003oool0oooo0100oooo?03o000B003o01d0003oM@3ooolY0000obD0
0?l07@3o002Z0?ooo`00F`3oool00`000000oooo0?ooo`0@0?ooocd0o`004@00o`0L0000ogH0oooo
:@000?lU003o01`0o`00Z`3oool005/0oooo00<000000?ooo`3oool04@3oooln0?l001000?l06@00
0?mi0?ooobL0003o9`00o`0I0?l00:d0oooo001K0?ooo`030000003oool0oooo0140oooo?`3o000?
003o01P0003oNP3ooolW0000obL00?l0603o002^0?ooo`00F`3oool00`000000oooo0?ooo`0A0?oo
od40o`003@00o`0F0000og`0oooo9`000?lW003o01H0o`00/03oool005/0oooo00<000000?ooo`3o
ool04P3ooom10?l000d00?l050000?mn0?ooobD0003o:@00o`0D0?l00;40oooo001K0?ooo`030000
003oool0oooo0180oooo@P3o000<003o01<0003oO`3ooolU0000obT00?l04`3o002b0?ooo`00F`3o
ool00`000000oooo0?ooo`0B0?oood@0o`002P00o`0A0000oh40oooo9@000?lY003o0140o`00]03o
ool005/0oooo00<000000?ooo`3oool04`3ooom40?l000X00?l03`000?n30?ooob<0003o:`00o`0?
0?l00;D0oooo001K0?ooo`030000003oool0oooo01<0ooooA@3o0009003o00h0003oQ03ooolS0000
ob/00?l03P3o002f0?ooo`00F`3oool00`000000oooo0?ooo`0C0?ooodL0o`001`00o`0<0000ohH0
oooo8`000?l[003o00`0o`00^03oool005/0oooo00<000000?ooo`3oool0503ooom70?l000L00?l0
2P000?n80?ooob40003o;@00o`0:0?l00;T0oooo001K0?ooo`030000003oool0oooo01@0ooooB@3o
0005003o00P0003oRP3ooolQ0000obd00?l0203o002k0?ooo`00F`3oool00`000000oooo0?ooo`0D
0?ooodX0o`001000o`070000oh/0oooo8@000?l]003o00L0o`00_03oool005/0oooo00<000000?oo
o`3oool05@3ooom:0?l000@00?l01@000?n=0?oooal0003o;`00o`050?l00;d0oooo001K0?ooo`03
0000003oool0oooo01D0ooooC03o0002003o00<0003oS`3ooolO0000obl00?l00`3o002o0?ooo`00
F`3oool00`000000oooo0?ooo`0E0?ooodd0o`0000<00?l00000o`000?l0T03ooolO0000obl00?l0
0P3o00300?ooo`00F`3oool00`000000oooo0?ooo`0F0?ooodd0o`00T`3ooolM0000oc000?l0`P3o
ool005/0oooo00<000000?ooo`3oool05P3ooom<0?l009@0oooo7@000?l_003o0<<0oooo001K0?oo
o`030000003oool0oooo01H0ooooB`3o002E0?oooad0003o;P00o`340?ooo`00F`3oool00`000000
oooo0?ooo`0G0?ooodP0o`00V03ooolK0000obd00?l0aP3oool005/0oooo00<000000?ooo`3oool0
5`3ooom70?l009T0oooo6`000?l/003o0<L0oooo001K0?ooo`030000003oool0oooo01L0ooooAP3o
002J0?oooa/0003o:`00o`380?ooo`00F`3oool00`000000oooo0?ooo`0G0?oood@0o`00W03ooolJ
0000obX00?l0bP3oool005/0oooo00<000000?ooo`3oool0603ooom20?l009h0oooo6@000?lY003o
0</0oooo001K0?ooo`030000003oool0oooo01P0oooo@@3o002O0?oooaT0003o:000o`3<0?ooo`00
F`3oool00`000000oooo0?ooo`0H0?ooocl0o`00X@3ooolI0000obH00?l0cP3oool005/0oooo00<0
00000?ooo`3oool06@3ooolm0?l00:<0oooo5`000?lV003o0<l0oooo001K0?ooo`030000003oool0
oooo01T0oooo>`3o002U0?oooaL0003o9000o`3A0?ooo`00F`3oool00`000000oooo0?ooo`0I0?oo
ocX0o`00YP3ooolG0000ob<00?l0dP3oool005/0oooo00<000000?ooo`3oool06P3ooolh0?l00:P0
oooo5@000?lS003o0=<0oooo001K0?ooo`030000003oool0oooo01X0oooo=P3o002Z0?oooaD0003o
8@00o`3E0?ooo`00F`3oool00`000000oooo0?ooo`0J0?ooocD0o`00Z`3ooolE0000ob000?l0eP3o
ool005/0oooo00<000000?ooo`3oool06`3ooolc0?l00:d0oooo4`000?lP003o0=L0oooo001K0?oo
o`030000003oool0oooo01/0oooo<@3o002_0?oooa<0003o7P00o`3I0?ooo`00F`3oool00`000000
oooo0?ooo`0K0?oooc00o`00/03ooolC0000oad00?l0fP3oool005/0oooo00<000000?ooo`3oool0
703oool]0?l00;<0oooo4@000?lL003o0=`0oooo001K0?ooo`030000003oool0oooo01`0oooo;03o
002d0?oooa40003o6`00o`3M0?ooo`00F`3oool00`000000oooo0?ooo`0L0?ooob/0o`00]@3ooolA
0000oaX00?l0gP3oool005/0oooo00<000000?ooo`3oool07@3ooolX0?l00;P0oooo3`000?lI003o
0>00oooo001K0?ooo`030000003oool0oooo01d0oooo9`3o002i0?ooo`l0003o6000o`3Q0?ooo`00
F`3oool00`000000oooo0?ooo`0M0?ooobH0o`00^P3oool?0000oaL00?l0hP3oool005/0oooo00<0
00000?ooo`3oool07P3ooolS0?l00;d0oooo3@000?lF003o0>@0oooo001K0?ooo`030000003oool0
oooo01h0oooo8P3o002n0?ooo`d0003o5@00o`3U0?ooo`00F`3oool00`000000oooo0?ooo`0N0?oo
ob40o`00_`3oool=0000oa@00?l0iP3oool005/0oooo00<000000?ooo`3oool07`3ooolN0?l00<80
oooo2`000?lC003o0>P0oooo001K0?ooo`030000003oool0oooo01l0oooo7@3o00330?ooo`/0003o
4P00o`3Y0?ooo`00F`3oool00`000000oooo0?ooo`0O0?oooa/0o`00a@3oool;0000oa000?l0j`3o
ool005/0oooo00<000000?ooo`3oool0803ooolI0?l00<L0oooo2@000?l@003o0>`0oooo001K0?oo
o`030000003oool0oooo0200oooo603o00380?ooo`T0003o3`00o`3]0?ooo`00F`3oool00`000000
oooo0?ooo`0P0?oooaH0o`00bP3oool90000o`d00?l0k`3oool005/0oooo00<000000?ooo`3oool0
8@3ooolD0?l00<`0oooo1`000?l=003o0?00oooo001K0?ooo`030000003oool0oooo0240oooo4`3o
003=0?ooo`L0003o3000o`3a0?ooo`00F`3oool00`000000oooo0?ooo`0Q0?oooa40o`00c`3oool7
0000o`X00?l0l`3oool005/0oooo00<000000?ooo`3oool08P3oool?0?l00=40oooo1@000?l:003o
0?@0oooo001K0?ooo`030000003oool0oooo0280oooo3@3o003C0?ooo`D0003o2000o`3f0?ooo`00
F`3oool00`000000oooo0?ooo`0R0?ooo``0o`00e03oool50000o`L00?l0m`3oool005/0oooo00<0
00000?ooo`3oool08`3oool:0?l00=H0oooo0`000?l7003o0?P0oooo001K0?ooo`030000003oool0
oooo02<0oooo203o003H0?ooo`<0003o1@00o`3j0?ooo`00F`3oool00`000000oooo0?ooo`0S0?oo
o`L0o`00f@3oool30000o`@00?l0n`3oool005/0oooo00<000000?ooo`3oool0903oool50?l00=/0
oooo00<0003o003o0000o`000P00o`3l0?ooo`00F`3oool00`000000oooo0?ooo`0T0?ooo`<0o`00
g@3oool00`000?l00?l0003o003n0?ooo`00F`3oool00`000000oooo0?ooo`0T0?ooo`80o`00gP3o
ool00`000?l00?l00?ooo`3n0?ooo`00F`3oool00`000000oooo0?ooo`3o0?ooool0oooo1`3oool0
05/0oooo00<000000?ooo`3oool0o`3ooooo0?ooo`L0oooo001K0?ooo`030000003oool0oooo0?l0
ooooo`3oool70?ooo`00F`3oool00`000000oooo0?ooo`3o0?ooool0oooo1`3oool00?l0ooooo`3o
oomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00
o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?oo
ofD0oooo003o0?ooool0ooooI@3oool00;D0oooo0P00000L0?ooo`8000005P3oool2000001H0oooo
0P00000L0?ooo`8000008P3oool200000280oooo0P00000L0?ooo`800000703oool200000;`0oooo
002d0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool00000503oool010000000
oooo0?ooo`00000D0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool00000803o
ool010000000oooo0?ooo`00000P0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3o
ool000006P3oool010000000oooo0?ooo`00002k0?ooo`00]`3oool00`000000oooo0?ooo`0K0?oo
o`030000003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0K0?oo
o`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?oo
o`030000003oool0oooo01/0oooo00<000000?ooo`3oool0^@3oool00;D0oooo0P00000L0?ooo`80
00005P3oool2000001H0oooo0P00000L0?ooo`8000008P3oool200000280oooo0P00000L0?ooo`80
0000703oool200000;`0oooo002e0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0
8@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0
6`3oool00`000000oooo0?ooo`2k0?ooo`00]@3oool3000001/0oooo0`00000E0?ooo`<000005@3o
ool3000001/0oooo0`00000Q0?ooo`<000008@3oool3000001/0oooo0`00000K0?ooo`<00000^`3o
ool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0oooo
o`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00:/0oooo00<000000?oo
o`3oool0o`3oool90?ooo`030000003oool0oooo0:X0oooo002Z0?ooo`030000003oool0oooo01X0
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0
oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0:T0
oooo002Z0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool05@3oool00`000000oooo
0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo
0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo
0?ooo`0Q0?ooo`030000003oool0oooo0:T0oooo002Z0?ooo`040000003oool0oooo0?ooo`@00000
0P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@00000
0P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo100000040?ooo`030000
003oool0oooo00L0oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@00000
0P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@00000
0P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@00000
0P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@00000
0P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@00000
0P3oool4000000<0oooo00<000000?ooo`3oool0Z@3oool00:T0oooo00<000000?ooo`3oool0o`3o
ool=0?ooo`030000003oool0oooo0:P0oooo002Z0?ooo`030000003oool0oooo0?l0oooo2`3oool0
0`000000oooo0?ooo`2Y0?ooo`00ZP3oool00`000000oooo0?ooo`3o0?ooo`/0oooo00<000000?oo
o`3oool0Z@3oool00:/0oooo00<000000?ooo`3oool0o`3oool90?ooo`030000003oool0oooo0:X0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?oo
ool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3o
ool00:l0oooo0P0000080?ooo`<000001@3oool3000000d0oooo0`0000050?ooo`<000003@3oool3
000000D0oooo0`00000=0?ooo`<000001@3oool3000000h0oooo100000070?ooo`<000001@3oool3
000000h0oooo100000070?ooo`<000001@3oool3000000h0oooo100000070?ooo`<000001@3oool3
000000d0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`0000050?ooo`<00000[`3oool0
0:h0oooo00@000000?ooo`3oool00000203oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00d0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00d0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00d0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0
oooo00T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`2^0?ooo`00/03oool00`00
0000oooo0?ooo`070?ooo`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`00
0000oooo0?ooo`0=0?ooo`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`00
0000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo
00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?ooo`3oool03P3oool00`00
0000oooo0?ooo`080?ooo`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`00
0000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo
0:h0oooo002a0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool000000`3oool20000
00l0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3o
ool2000000l0oooo00@000000?ooo`3oool000000`3oool200000140oooo00<000000?ooo`3oool0
1`3oool010000000oooo0?ooo`0000030?ooo`8000004@3oool00`000000oooo0?ooo`070?ooo`04
0000003oool0oooo000000<0oooo0P00000A0?ooo`030000003oool0oooo00L0oooo00@000000?oo
o`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool200000140oooo00<0
00000?ooo`3oool01`3oool010000000oooo0?ooo`0000030?ooo`800000/03oool00:h0oooo00@0
00000?ooo`3oool00000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo0000
01@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00000D0?ooo`040000003o
ool0oooo000000P0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?oo
o`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool010000000oooo0?oo
o`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool01000
0000oooo0?ooo`00002e0?ooo`00[`3oool2000000P0oooo100000050?ooo`030000003oool0oooo
00`0oooo100000050?ooo`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo
00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool00`00
0000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool03P3oool20000
00P0oooo100000050?ooo`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo
00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`2^0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool00001\
\>"],
  ImageRangeCache->{{{0, 610.563}, {170.188, 0}} -> {-0.426205, -0.013998, \
0.00467178, 0.00467178}, {{91.1875, 295.063}, {167.188, 47.3125}} -> \
{-1.34175, -0.0239702, 0.00793648, 0.00793648}, {{315.438, 519.313}, \
{167.188, 47.3125}} -> {-3.12151, -0.0239702, 0.00793648, 0.00793648}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .22932 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00546003 0.47619 [
[.5 .24182 -146 0 ]
[.5 .24182 146 38.75 ]
[ 0 0 0 0 ]
[ 1 .22932 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00546 m
1 .00546 L
s
.02381 0 m
.02381 .22932 L
s
gsave
.5 .24182 -207 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(3) show
117.000 12.750 moveto
(Pi) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(4) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(2) show
237.000 12.750 moveto
(Pi) show
261.000 12.750 moveto
(4) show
273.000 12.750 moveto
(Pi) show
297.000 12.750 moveto
(Pi) show
321.000 12.750 moveto
(2) show
333.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
(--) show
129.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
141.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
(--) show
249.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
261.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
273.000 25.875 moveto
(--) show
285.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
297.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
309.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
321.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
333.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
345.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
111.000 39.000 moveto
(7) show
141.000 39.000 moveto
(7) show
165.000 39.000 moveto
(7) show
195.000 39.000 moveto
(7) show
231.000 39.000 moveto
(7) show
267.000 39.000 moveto
(7) show
297.000 39.000 moveto
(7) show
327.000 39.000 moveto
(7) show
333.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .22932 L
0 .22932 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00546003 0.477324 0.223861 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.384043 0.615957 6.23416e-019 0.615957 [
[ 0 0 0 0 ]
[ 1 .48157 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .48157 L
0 .48157 L
closepath
clip
newpath
0 1 0 r
.10992 0 m
.28621 0 L
.19806 .38619 L
F
0 0 1 r
.28621 0 m
1 0 L
.19806 .38619 L
F
1 0 0 r
.10992 0 m
.19806 .38619 L
0 .48157 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00546003 0.97619 0.223861 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.384043 0.615957 1.34983e-017 0.615957 [
[ 0 0 0 0 ]
[ 1 .48157 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .48157 L
0 .48157 L
closepath
clip
newpath
0 1 0 r
.38404 0 m
.55496 .21432 L
0 .48157 L
F
0 0 1 r
0 .48157 m
.10992 0 L
.38404 0 L
F
1 0 0 r
.38404 0 m
1 0 L
.55496 .21432 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 140.25},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000S2000`400?l00000o`00003oJ`3oool0
0`000000oooo0?ooo`3o0?ooooH0oooo001[0?ooo`030000003oool0oooo0?l0oooomP3oool006/0
oooo00<000000?ooo`3oool0o`3oooof0?ooo`00H@3ooooo00000:800000H@3oool006/0oooo00<0
00000?ooo`3oool04P3oool00`3o00000?l0003o000N003o08@0003o:P3ooold0000o`03003o003o
0000o`0006l0o`00KP3oool006/0oooo00<000000?ooo`3oool04P3oool00`3o00000?l0003o000N
003o0880003o;03ooolc0000o`<00?l0KP3o001`0?ooo`00J`3oool00`000000oooo0?ooo`0B0?oo
o`030?l00000o`000?l001h00?l0P0000?l^0?oooc80003o1@00o`1[0?l00780oooo001[0?ooo`03
0000003oool0oooo0180oooo00<0o`00003o0000o`007P00o`1n0000oc00oooo<@000?l7003o06P0
o`00M03oool006/0oooo00<000000?ooo`3oool04@3oool30?l001h00?l0O@000?la0?oooc40003o
2000o`1V0?l007H0oooo001[0?ooo`030000003oool0oooo0140oooo0`3o000N003o07/0003o<`3o
oola0000o`T00?l0H`3o001h0?ooo`00J`3oool00`000000oooo0?ooo`0A0?ooo`<0o`007P00o`1i
0000ocD0oooo<0000?l;003o0600o`00NP3oool006/0oooo00<000000?ooo`3oool04@3oool30?l0
01h00?l0M`000?lg0?ooobl0003o3@00o`1M0?l007`0oooo001[0?ooo`030000003oool0oooo0100
oooo103o000M003o07H0003o>03oool_0000o`l00?l0FP3o001n0?ooo`00J`3oool00`000000oooo
0?ooo`0@0?ooo`D0o`007000o`1d0000ocX0oooo;P000?l@003o05L0o`00P@3oool006/0oooo00<0
00000?ooo`3oool0403oool50?l001`00?l0L@000?lm0?ooobh0003o4@00o`1D0?l008<0oooo001[
0?ooo`030000003oool0oooo0100oooo1@3o000L003o06l0003o?`3oool]0000oa<00?l0D@3o0025
0?ooo`00J`3oool00`000000oooo0?ooo`0?0?ooo`H0o`006`00o`1^0000od00oooo;@000?lE003o
04h0o`00Q`3oool006/0oooo00<000000?ooo`3oool03`3oool70?l001X00?l0K0000?m20?ooob`0
003o5`00o`1;0?l008T0oooo001[0?ooo`030000003oool0oooo00l0oooo1`3o000J003o06X0003o
A03oool[0000oaP00?l0B@3o002;0?ooo`00J`3oool00`000000oooo0?ooo`0?0?ooo`L0o`006P00
o`1X0000odH0oooo:`000?lI003o04H0o`00S@3oool006/0oooo00<000000?ooo`3oool03`3oool7
0?l001T00?l0I`000?m80?ooobX0003o6`00o`130?l008l0oooo001[0?ooo`030000003oool0oooo
00h0oooo203o000I003o06D0003oB@3ooolZ0000oad00?l0@03o002A0?ooo`00J`3oool00`000000
oooo0?ooo`0>0?ooo`T0o`006000o`1S0000od/0oooo:@000?lO003o03d0o`00T`3oool006/0oooo
00<000000?ooo`3oool03P3oool90?l001P00?l0H@000?m=0?ooobP0003o8000o`0j0?l009H0oooo
001[0?ooo`030000003oool0oooo00h0oooo2@3o000H003o05h0003oD03ooolW0000ob800?l0=`3o
002H0?ooo`00J`3oool00`000000oooo0?ooo`0=0?ooo`X0o`005`00o`1M0000oe40oooo:0000?lS
003o03@0o`00VP3oool006/0oooo00<000000?ooo`3oool03@3oool;0?l001H00?l0F`000?mC0?oo
obL0003o9@00o`0a0?l009`0oooo001[0?ooo`030000003oool0oooo00d0oooo2`3o000F003o05T0
003oE@3ooolV0000obL00?l0;P3o002N0?ooo`00J`3oool00`000000oooo0?ooo`0=0?ooo`/0o`00
5P00o`1G0000oeL0oooo9@000?lX003o02`0o`00X03oool006/0oooo00<000000?ooo`3oool0303o
ool<0?l001D00?l0EP000?mH0?ooobD0003o:P00o`0Y0?l00:80oooo001[0?ooo`030000003oool0
oooo00`0oooo303o000E003o05@0003oFP3ooolU0000ob/00?l09P3o002T0?ooo`00J`3oool00`00
0000oooo0?ooo`0<0?ooo`d0o`005000o`1B0000oe`0oooo90000?l]003o02<0o`00YP3oool006/0
oooo00<000000?ooo`3oool0303oool=0?l001@00?l0D0000?mN0?ooob<0003o;`00o`0P0?l00:P0
oooo001[0?ooo`030000003oool0oooo00/0oooo3P3o000C003o04l0003oG`3ooolS0000oc000?l0
7@3o002[0?ooo`00J`3oool00`000000oooo0?ooo`0;0?ooo`h0o`004`00o`1<0000of80oooo8P00
0?lb003o01X0o`00[@3oool006/0oooo00<000000?ooo`3oool02`3oool?0?l001800?l0BP000?mT
0?ooob80003o<`00o`0G0?l00:l0oooo001[0?ooo`030000003oool0oooo00/0oooo3`3o000B003o
04P0003oIP3ooolQ0000ocD00?l0503o002a0?ooo`00J`3oool00`000000oooo0?ooo`0;0?ooo`l0
o`004@00o`170000ofP0oooo80000?lg003o0140o`00/`3oool006/0oooo00<000000?ooo`3oool0
2P3oool@0?l001400?l0A@000?mY0?ooob00003o>000o`0?0?l00;D0oooo001[0?ooo`030000003o
ool0oooo00X0oooo403o000A003o04<0003oJ`3ooolO0000ocX00?l0303o002g0?ooo`00J`3oool0
0`000000oooo0?ooo`0:0?oooa40o`004000o`110000ofd0oooo7P000?ll003o00T0o`00^@3oool0
06/0oooo00<000000?ooo`3oool02P3ooolA0?l001000?l0?`000?m_0?oooah0003o?@00o`060?l0
0;/0oooo001[0?ooo`030000003oool0oooo00T0oooo4P3o000?003o03h0003oL03ooolN0000ocl0
0?l00`3o002m0?ooo`00J`3oool00`000000oooo0?ooo`090?oooa80o`003`00o`0l0000og80oooo
7@000?m0003o0<00oooo001[0?ooo`030000003oool0oooo00T0oooo4`3o000>003o03X0003oM03o
oolL0000ocl00?l0`P3oool006/0oooo00<000000?ooo`3oool02@3ooolC0?l000h00?l0=`000?mg
0?oooa/0003o?P00o`340?ooo`00J`3oool00`000000oooo0?ooo`080?oooa@0o`003@00o`0f0000
ogP0oooo70000?ll003o0<H0oooo001[0?ooo`030000003oool0oooo00P0oooo503o000=003o03@0
003oNP3ooolK0000oc/00?l0b03oool006/0oooo00<000000?ooo`3oool0203ooolD0?l000d00?l0
<P000?ml0?oooaX0003o>P00o`3:0?ooo`00J`3oool00`000000oooo0?ooo`080?oooaD0o`003000
o`0`0000ogh0oooo6@000?li003o0<`0oooo001[0?ooo`030000003oool0oooo00P0oooo5@3o000;
003o02l0003oP03ooolH0000ocP00?l0cP3oool006/0oooo00<000000?ooo`3oool01`3ooolF0?l0
00/00?l0;@000?n10?oooaT0003o=P00o`3@0?ooo`00J`3oool00`000000oooo0?ooo`070?oooaH0
o`002`00o`0[0000oh<0oooo60000?le003o0=80oooo001[0?ooo`030000003oool0oooo00L0oooo
5`3o000:003o02T0003oQ@3ooolG0000oc<00?l0e@3oool006/0oooo00<000000?ooo`3oool01`3o
oolG0?l000T00?l0:0000?n70?oooaH0003o<P00o`3G0?ooo`00J`3oool00`000000oooo0?ooo`06
0?oooaP0o`002@00o`0U0000ohT0oooo5P000?la003o0=T0oooo001[0?ooo`030000003oool0oooo
00H0oooo603o0009003o02<0003oR`3ooolF0000obl00?l0f`3oool006/0oooo00<000000?ooo`3o
ool01P3ooolH0?l000T00?l08@000?n=0?oooaD0003o;P00o`3M0?ooo`00J`3oool00`000000oooo
0?ooo`060?oooaT0o`002000o`0O0000ohl0oooo50000?l]003o0=l0oooo001[0?ooo`030000003o
ool0oooo00D0oooo6P3o0007003o01h0003oT03ooolD0000ob`00?l0h@3oool006/0oooo00<00000
0?ooo`3oool01@3ooolJ0?l000L00?l070000?nB0?oooa<0003o:`00o`3S0?ooo`00J`3oool00`00
0000oooo0?ooo`050?oooaX0o`001`00o`0J0000oi@0oooo4P000?lZ003o0>D0oooo001[0?ooo`03
0000003oool0oooo00D0oooo6`3o0006003o01P0003oUP3ooolB0000obP00?l0i`3oool006/0oooo
00<000000?ooo`3oool0103ooolL0?l000D00?l05`000?nG0?oooa80003o9P00o`3Z0?ooo`00J`3o
ool00`000000oooo0?ooo`040?oooa`0o`001@00o`0E0000oiT0oooo4@000?lU003o0>`0oooo001[
0?ooo`030000003oool0oooo00@0oooo703o0005003o0180003oW03oool@0000ob@00?l0kP3oool0
06/0oooo00<000000?ooo`3oool0103ooolL0?l000D00?l040000?nN0?ooo`l0003o8`00o`3`0?oo
o`00J`3oool00`000000oooo0?ooo`040?oooad0o`000`00o`0?0000oj00oooo3`000?lQ003o0?80
oooo001[0?ooo`030000003oool0oooo00<0oooo7P3o0003003o00d0003oX@3oool?0000ob000?l0
m03oool006/0oooo00<000000?ooo`3oool00`3ooolN0?l000<00?l02`000?nS0?ooo`h0003o7`00
o`3f0?ooo`00J`3oool00`000000oooo0?ooo`030?oooah0o`000`00o`090000ojD0oooo3@000?lN
003o0?P0oooo001[0?ooo`030000003oool0oooo00<0oooo7`3o00000`00o`00003o0000o`060000
ojL0oooo30000?lM003o0?X0oooo001[0?ooo`030000003oool0oooo0080oooo803o00000`00o`00
003o0000o`040000ojP0oooo3@000?lK003o0?`0oooo001[0?ooo`030000003oool0oooo0080oooo
803o00000`00o`00003o0000o`020000ojX0oooo30000?lI003o0?l0oooo001[0?ooo`030000003o
ool0oooo0080oooo803o00000`00o`00003o0000o`2/0?ooo`/0003o6000o`3o0?ooo`80oooo001[
0?ooo`030000003oool0oooo0080oooo803o002_0?ooo`X0003o5`00o`3o0?ooo`@0oooo001[0?oo
o`040000003oool0oooo0?oooal0o`00/03oool:0000oaH00?l0o`3oool60?ooo`00J`3oool01000
0000oooo0?ooo`3ooolM0?l00;80oooo2@000?lE003o0?l0oooo203oool006/0oooo00@000000?oo
o`3oool0oooo6`3o002d0?ooo`T0003o4`00o`3o0?ooo`X0oooo001[0?ooo`040000003oool0oooo
0?oooaT0o`00]P3oool80000oa800?l0o`3oool<0?ooo`00J`3oool010000000oooo0?ooo`3ooolG
0?l00;P0oooo1`000?lA003o0?l0oooo3P3oool006/0oooo00<000000?ooo`3oool05P3o002i0?oo
o`L0003o4000o`3o0?oooa00oooo001[0?ooo`030000003oool0oooo01@0o`00^`3oool60000o`l0
0?l0o`3ooolB0?ooo`00J`3oool00`000000oooo0?ooo`0B0?l00;d0oooo1P000?l<003o0?l0oooo
5@3oool006/0oooo00<000000?ooo`3oool0403o002o0?ooo`D0003o2`00o`3o0?oooaL0oooo001[
0?ooo`030000003oool0o`0000h0o`00`03oool50000o`X00?l0o`3ooolI0?ooo`00J`3oool00`00
0000oooo0?l0000<0?l00<80oooo10000?l9003o0?l0oooo6`3oool006/0oooo00<000000?ooo`3o
00002P3o00340?ooo`<0003o2000o`3o0?oooad0oooo001[0?ooo`030000003oool0o`0000P0o`00
aP3oool30000o`H00?l0o`3ooolO0?ooo`00J`3oool00`000000o`000?l000060?l00<L0oooo0`00
0?l5003o0?l0oooo8@3oool006/0oooo00<000000?l0003o0000103o00390?ooo`80003o1000o`3o
0?ooob<0oooo001[0?ooo`030000003o0000o`000080o`00b`3oool010000?l00?l0003o0000o`3o
0?ooobD0oooo001[0?ooo`030000003o0000o`000<d0oooo0P00o`3o0?ooobL0oooo001[0?ooo`03
0000003oool0oooo0?l0oooomP3oool006/0oooo00<000000?ooo`3oool0o`3oooof0?ooo`00J`3o
ool00`000000oooo0?ooo`3o0?ooooH0oooo001[0?ooo`030000003oool0oooo0?l0oooomP3oool0
0?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3o
oomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00
o`3ooooo0?ooofD0oooo002`0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool06`3o
ool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool08@3o
ool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3o
ool00`000000oooo0?ooo`2d0?ooo`00/03oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0
oooo01/0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0
oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0
oooo01/0oooo00<000000?ooo`3oool0]03oool00;00oooo00<000000?ooo`3oool08@3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo0;@0oooo002a0?ooo`030000003oool0oooo0240
oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01/0
oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01/0
oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`2c0?ooo`00[P3oool010000000oooo
0?ooo`00000P0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool00000503oool0
10000000oooo0?ooo`00000J0?ooo`040000003oool0oooo00000200oooo00@000000?ooo`3oool0
0000803oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001X0oooo00@00000
0?ooo`3oool00000]@3oool00:h0oooo1000000P0?ooo`@000006P3oool4000001@0oooo1000000J
0?ooo`@00000803oool400000200oooo1000000J0?ooo`@000006P3oool400000;D0oooo003o0?oo
ool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3o
ool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002U0?ooo`030000003oool0oooo0?l0
oooo5@3oool00`000000oooo0?ooo`2T0?ooo`00Y03oool00`000000oooo0?ooo`0J0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`2S0?ooo`00Y03o
ool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool05@3o
ool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3o
ool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool08@3o
ool00`000000oooo0?ooo`2S0?ooo`00Y03oool010000000oooo0?ooo`3oool400000080oooo1000
00020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo1000
00020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo1000
00040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@00000103oool00`000000oooo0?oo
o`070?ooo`@000000P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo0?oo
o`070?ooo`@000000P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo0?oo
o`070?ooo`@000000P3oool400000080oooo100000020?ooo`@00000103oool00`000000oooo0?oo
o`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3oool01`3oool400000080oooo1000
00020?ooo`@000000P3oool4000000<0oooo00<000000?ooo`3oool0X`3oool00:<0oooo00<00000
0?ooo`3oool0o`3ooolI0?ooo`030000003oool0oooo0:80oooo002T0?ooo`030000003oool0oooo
0?l0oooo5`3oool00`000000oooo0?ooo`2S0?ooo`00Y03oool00`000000oooo0?ooo`3o0?oooaL0
oooo00<000000?ooo`3oool0X`3oool00:D0oooo00<000000?ooo`3oool0o`3ooolE0?ooo`030000
003oool0oooo0:@0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?oo
ofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o
0?ooool0ooooI@3oool00:T0oooo0P0000080?ooo`<000001@3oool3000000l0oooo0P0000080?oo
o`<000001@3oool3000000d0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000@0?oo
o`<000001P3oool3000000D0oooo0`00000>0?ooo`@000001`3oool3000000D0oooo0`00000@0?oo
o`<000001P3oool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000h0oooo100000070?oo
o`<000001@3oool300000:T0oooo002X0?ooo`040000003oool0oooo000000P0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0100oooo00<00000
0?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0100oooo00<00000
0?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`2X0?ooo`00ZP3oool00`000000oooo0?ooo`070?oo
o`<000001@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo00L0oooo0`0000050?oo
o`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?oo
o`030000003oool0oooo00d0oooo1@0000070?ooo`<000001@3oool00`000000oooo0?ooo`0>0?oo
o`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo00d0oooo1@0000070?oo
o`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`000000oooo0?ooo`0>0?oo
o`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo0:P0oooo002[0?ooo`03
0000003oool0oooo00H0oooo00@000000?ooo`3oool000000`3oool200000180oooo00<000000?oo
o`3oool01P3oool010000000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`00
00030?ooo`8000003`3oool010000000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo
0?ooo`0000080?ooo`040000003oool0oooo000000<0oooo0P00000A0?ooo`030000003oool0oooo
00L0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool00000203o
ool010000000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000030?ooo`80
00004@3oool00`000000oooo0?ooo`070?ooo`040000003oool0oooo000000<0oooo0P00002Z0?oo
o`00Z03oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@00000
0?ooo`3oool00000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0
oooo00@000000?ooo`3oool000005@3oool00`000000oooo000000080?ooo`040000003oool0oooo
000001@0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00000E0?ooo`030000
003oool0000000P0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00000D0?oo
o`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000[`3oool00:T0oooo0P000008
0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<00000
0?ooo`3oool0303oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<00000
0?ooo`3oool03`3oool2000000L0oooo100000050?ooo`030000003oool0oooo00h0oooo0P000008
0?ooo`@000001@3oool00`000000oooo0?ooo`0?0?ooo`8000001`3oool4000000D0oooo00<00000
0?ooo`3oool0303oool4000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo10000005
0?ooo`030000003oool0oooo0:P0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00
\
\>"],
  ImageRangeCache->{{{0, 610.563}, {139.25, 0}} -> {-0.542588, -0.0114686, \
0.00505301, 0.00505301}, {{107.375, 295.813}, {136.938, 46.1875}} -> \
{-1.5486, -0.0199454, 0.00861562, 0.00861562}, {{314.688, 503.125}, {136.938, \
46.1875}} -> {-3.33473, -0.0199454, 0.00861562, 0.00861562}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .16836 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00400854 0.47619 [
[.5 .18086 -134 0 ]
[.5 .18086 134 38.75 ]
[ 0 0 0 0 ]
[ 1 .16836 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00401 m
1 .00401 L
s
.02381 0 m
.02381 .16836 L
s
gsave
.5 .18086 -195 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(3) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(5) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(3) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
321.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
105.000 39.000 moveto
(4) show
135.000 39.000 moveto
(8) show
165.000 39.000 moveto
(8) show
195.000 39.000 moveto
(8) show
225.000 39.000 moveto
(4) show
255.000 39.000 moveto
(8) show
285.000 39.000 moveto
(8) show
309.000 39.000 moveto
(2) show
315.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .16836 L
0 .16836 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00400854 0.477324 0.16435 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.5 0 0.5 [
[ 0 0 0 0 ]
[ 1 .35355 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .35355 L
0 .35355 L
closepath
clip
newpath
0 1 0 r
0 0 m
.41421 0 L
.29289 .29289 L
F
0 0 1 r
.41421 0 m
1 0 L
.29289 .29289 L
F
1 0 0 r
0 0 m
.29289 .29289 L
.14645 .35355 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00400854 0.97619 0.16435 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.5 0 0.5 [
[ 0 0 0 0 ]
[ 1 .35355 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .35355 L
0 .35355 L
closepath
clip
newpath
0 1 0 r
.14645 .35355 m
0 0 L
.5 0 L
F
0 0 1 r
.5 0 m
.5 .20711 L
.14645 .35355 L
F
1 0 0 r
.5 0 m
1 0 L
.5 .20711 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611, 102.875},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000IR000`400?l00000o`00003oRP3oool0
0`000000oooo0?ooo`3o0?ooomL0oooo00220?ooool00000G`0000230?ooo`00RP3oool00`000000
o`00003o000o003o05/0003o4P3ooom>003o00030000o`3o0000o`0004/0o`00SP3oool008X0oooo
00<000000?l0003o0000?`00o`1I0000oa@0ooooC@00o`020000od/0o`00T03oool008X0oooo00@0
00000?ooo`3o0000o`00?@00o`1G0000oaP0ooooB`00o`030000odP0o`00T`3oool008X0oooo00<0
00000?ooo`3o00000P3o000l003o05D0003o6P3ooom:003o00@0003oAP3o002E0?ooo`00RP3oool0
0`000000oooo0?ooo`030?l003X00?l0D`000?lN0?ooodP00?l01@000?m40?l009L0oooo002:0?oo
o`030000003oool0oooo00@0o`00>@00o`1A0000ob00ooooA`00o`060000od40o`00VP3oool008X0
oooo00<000000?ooo`3oool01@3o000h003o04h0003o8`3ooom6003o00L0003o?`3o002L0?ooo`00
RP3oool010000000oooo0?ooo`3oool50?l003H00?l0C@000?lV0?oood@00?l020000?ll0?l009l0
oooo002:0?ooo`040000003oool0oooo0?ooo`H0o`00=@00o`1;0000obP0oooo@`00o`090000ocX0
o`00X@3oool008X0oooo00<000000?ooo`3oool00P3oool60?l003<00?l0B@000?l/0?oood400?l0
2P000?lh0?l00:<0oooo002:0?ooo`030000003oool0oooo0080oooo1`3o000b003o04L0003o;P3o
oom0003o00/0003o=@3o002V0?ooo`00RP3oool00`000000oooo0?ooo`020?ooo`P0o`00<@00o`14
0000oc80oooo?P00o`0<0000oc<0o`00Z03oool008X0oooo00<000000?ooo`3oool00`3oool80?l0
02l00?l0@`000?ld0?ooocd00?l03@000?l`0?l00:/0oooo002:0?ooo`030000003oool0oooo00<0
oooo2@3o000^003o0400003o=`3oooll003o00h0003o;P3o002]0?ooo`00RP3oool00`000000oooo
0?ooo`040?ooo`T0o`00;000o`0o0000ocX0oooo>P00o`0?0000ob`0o`00[`3oool008X0oooo00<0
00000?ooo`3oool0103oool:0?l002/00?l0?@000?ll0?ooocT00?l040000?lY0?l00;80oooo002:
0?ooo`030000003oool0oooo00@0oooo2`3o000Y003o03/0003o@03ooolg003o0140003o9`3o002d
0?ooo`00RP3oool00`000000oooo0?ooo`050?ooo`/0o`00:000o`0i0000od80oooo=P00o`0B0000
ob@0o`00]`3oool008X0oooo00<000000?ooo`3oool01@3oool<0?l002L00?l0=P000?m60?oooc@0
0?l04`000?lR0?l00;T0oooo002:0?ooo`030000003oool0oooo00H0oooo303o000U003o03D0003o
B03ooolc003o01@0003o803o002k0?ooo`00RP3oool00`000000oooo0?ooo`060?ooo`d0o`009000
o`0b0000od/0oooo<P00o`0E0000oad0o`00_P3oool008X0oooo00<000000?ooo`3oool01`3oool=
0?l002800?l0<@000?m>0?oooc000?l05P000?lK0?l00<00oooo002:0?ooo`030000003oool0oooo
00L0oooo3P3o000Q003o02h0003oD@3oool_003o01L0003o603o00330?ooo`00RP3oool00`000000
oooo0?ooo`070?ooo`l0o`008000o`0/0000oe@0oooo;@00o`0H0000oaH0o`00a@3oool008X0oooo
00<000000?ooo`3oool0203oool?0?l001h00?l0:`000?mF0?ooob`00?l06@000?lD0?l00<L0oooo
002:0?ooo`030000003oool0oooo00P0oooo403o000M003o02P0003oFP3ooolZ003o01X0003o4@3o
003:0?ooo`00RP3oool00`000000oooo0?ooo`090?oooa00o`006`00o`0W0000oe`0oooo:@00o`0K
0000o`l0o`00c03oool008X0oooo00<000000?ooo`3oool02@3ooolA0?l001X00?l090000?mO0?oo
obP00?l070000?l<0?l00<l0oooo002:0?ooo`030000003oool0oooo00T0oooo4P3o000I003o0280
003oHP3ooolV003o01d0003o2P3o003A0?ooo`00RP3oool00`000000oooo0?ooo`0:0?oooa80o`00
5`00o`0P0000ofD0oooo9@00o`0N0000o`P0o`00d`3oool008X0oooo00<000000?ooo`3oool02P3o
oolC0?l001H00?l07P000?mX0?ooob<00?l07`000?l50?l00=H0oooo002:0?ooo`030000003oool0
oooo00/0oooo4`3o000D003o01d0003oJP3ooolR003o0200003o0`3o003H0?ooo`00RP3oool00`00
0000oooo0?ooo`0;0?oooa@0o`004`00o`0J0000ofh0oooo8000o`0Q0000om/0oooo002:0?ooo`03
0000003oool0oooo00/0oooo5@3o000A003o01T0003oL03ooolO003o0200003og@3oool008X0oooo
00<000000?ooo`3oool0303ooolE0?l001000?l05P000?mc0?oooah00?l07`000?oO0?ooo`00RP3o
ool00`000000oooo0?ooo`0<0?oooaH0o`003`00o`0D0000ogH0oooo7000o`0M0000on80oooo002:
0?ooo`030000003oool0oooo00d0oooo5P3o000=003o0180003oN@3ooolK003o01`0003oi03oool0
08X0oooo00<000000?ooo`3oool03@3ooolG0?l000`00?l040000?ml0?oooaT00?l06P000?oW0?oo
o`00RP3oool00`000000oooo0?ooo`0>0?oooaL0o`002P00o`0?0000ogh0oooo6000o`0I0000onT0
oooo002:0?ooo`030000003oool0oooo00h0oooo603o0009003o00`0003oPP3ooolF003o01L0003o
k03oool008X0oooo00<000000?ooo`3oool03P3ooolI0?l000P00?l02P000?n40?oooaD00?l05P00
0?o^0?ooo`00RP3oool00`000000oooo0?ooo`0?0?oooaT0o`001P00o`080000ohL0oooo5000o`0E
0000oo00oooo002:0?ooo`030000003oool0oooo00l0oooo6P3o0005003o00H0003oRP3ooolB003o
01<0003ol`3oool008X0oooo00<000000?ooo`3oool0403ooolJ0?l000<00?l010000?n=0?oooa40
0?l04P000?oe0?ooo`00RP3oool00`000000oooo0?ooo`0@0?oooa/0o`000P00o`020000oi00oooo
3`00o`0@0000ooP0oooo002:0?ooo`030000003oool0oooo0100oooo703o002C0?ooo`h00?l03`00
0?oj0?ooo`00RP3oool00`000000oooo0?ooo`0A0?oooaT0o`00UP3oool<003o00d0003oo@3oool0
08X0oooo00<000000?ooo`3oool04@3ooolG0?l009P0oooo2`00o`0<0000ool0oooo002:0?ooo`03
0000003oool0oooo0180oooo4`3o002K0?ooo`X00?l02`000?oo0?ooo`80oooo002:0?ooo`030000
003oool0oooo0180oooo4@3o002N0?ooo`P00?l02@000?oo0?ooo`D0oooo002:0?ooo`030000003o
ool0oooo0180oooo3P3o002Q0?ooo`L00?l020000?oo0?ooo`L0oooo002:0?ooo`030000003oool0
oooo01<0oooo2`3o002T0?ooo`D00?l01P000?oo0?ooo`X0oooo002:0?ooo`030000003oool0oooo
01<0oooo2@3o002V0?ooo`@00?l01@000?oo0?ooo``0oooo002:0?ooo`030000003oool0oooo01@0
oooo1@3o002Z0?ooo`800?l00`000?oo0?ooo`l0oooo002:0?ooo`030000003oool0oooo01@0oooo
0`3o002/0?ooo`03003o00000?l0003o0?l0oooo4@3oool008X0oooo00<000000?ooo`3oool0o`3o
oooG0?ooo`00RP3oool00`000000oooo0?ooo`3o0?ooomL0oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00^`3o
ool2000001d0oooo0`00000J0?ooo`800000703oool2000001`0oooo0P00000M0?ooo`<000006P3o
ool2000001`0oooo0P00000E0?ooo`@00000^`3oool00;X0oooo00@000000?ooo`3oool000007@3o
ool00`000000oooo0?ooo`0H0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool0
00006P3oool010000000oooo0?ooo`00000M0?ooo`030000003oool0oooo01P0oooo00@000000?oo
o`3oool000006P3oool010000000oooo0?ooo`00000D0?ooo`030000003oool0oooo0;`0oooo002j
0?ooo`040000003oool0oooo000001X0oooo1@00000I0?ooo`040000003oool0oooo000001X0oooo
00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00000J0?ooo`D000006@3oool01000
0000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001D0oooo00<000000?ooo`3oool0^`3o
ool00;/0oooo0P00000K0?ooo`040000003oool0oooo000001/0oooo0P00000L0?ooo`800000703o
ool2000001/0oooo00@000000?ooo`3oool000006`3oool2000001`0oooo0P00000G0?ooo`030000
003oool0oooo0;X0oooo002j0?ooo`040000003oool0oooo000001/0oooo00<000000?ooo`000000
6P3oool010000000oooo0?ooo`00000J0?ooo`040000003oool0oooo000001X0oooo00@000000?oo
o`3oool000006`3oool00`000000oooo0000000J0?ooo`040000003oool0oooo000001X0oooo00@0
00000?ooo`3oool00000503oool010000000oooo0?ooo`00002k0?ooo`00^`3oool2000001d0oooo
0P00000K0?ooo`800000703oool2000001`0oooo0P00000M0?ooo`8000006`3oool2000001`0oooo
0P00000F0?ooo`800000_03oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?oo
ool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3o
ool00;40oooo00<000000?ooo`3oool0o03oool00`000000oooo0?ooo`2`0?ooo`00/03oool00`00
0000oooo0?ooo`0J0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`00
0000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`00
0000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`00
0000oooo0?ooo`2_0?ooo`00/03oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo01D0
oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`2_0?ooo`00/03oool010000000oooo
0?ooo`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3o
ool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@0
00000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@0
0000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo100000020?ooo`@0
0000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3o
ool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<000000?ooo`3o
ool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo100000020?ooo`@0
00000`3oool00`000000oooo0?ooo`2_0?ooo`00[`3oool00`000000oooo0?ooo`3o0?ooo`40oooo
00<000000?ooo`3oool0[P3oool00;00oooo00<000000?ooo`3oool0oP3oool00`000000oooo0?oo
o`2_0?ooo`00/03oool00`000000oooo0?ooo`3n0?ooo`030000003oool0oooo0:l0oooo002a0?oo
o`030000003oool0oooo0?`0oooo00<000000?ooo`3oool0/03oool00?l0ooooo`3ooomU0?ooo`00
o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?oo
ofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00]@3oool2000000P0oooo0`00
00050?ooo`<000003@3oool3000000D0oooo0`00000?0?ooo`800000203oool3000000D0oooo0`00
000=0?ooo`<000001@3oool3000000l0oooo0P0000080?ooo`<000001@3oool3000000d0oooo0`00
00050?ooo`<000003`3oool2000000P0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00
000=0?ooo`<000001@3oool300000;D0oooo002d0?ooo`040000003oool0oooo000000P0oooo00<0
00000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool03@3oool010000000oooo0?ooo`0000080?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo
00@000000?ooo`3oool00000203oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo0000
00P0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo
00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo
0;@0oooo002f0?ooo`030000003oool0oooo00L0oooo0`0000050?ooo`030000003oool0oooo00d0
oooo0`0000050?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool01`3oool3000000D0
oooo00<000000?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool0403oool00`000000
oooo0?ooo`060?ooo`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`000000
oooo0?ooo`0?0?ooo`030000003oool0oooo00L0oooo0`0000050?ooo`030000003oool0oooo00d0
oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo0;@0
oooo002g0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool000000`3oool2000000l0
oooo00@000000?ooo`3oool000000`3oool200000180oooo00<000000?ooo`3oool01P3oool01000
0000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000030?ooo`800000403o
ool2000000T0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool0
00000`3oool200000180oooo00<000000?ooo`3oool01P3oool010000000oooo0?ooo`0000030?oo
o`8000003`3oool010000000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`00
00030?ooo`800000]P3oool00;@0oooo00@000000?ooo`3oool00000203oool010000000oooo0?oo
o`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool01000
0000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001D0oooo00<000000?ooo`3oool0203o
ool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000203oool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000001@0oooo00@0
00000?ooo`3oool00000^`3oool00;D0oooo0P0000080?ooo`@000001@3oool00`000000oooo0?oo
o`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo00<0
00000?ooo`3oool0303oool4000000D0oooo00<000000?ooo`3oool03P3oool3000000L0oooo1000
00050?ooo`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0P00
00080?ooo`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?oo
o`0<0?ooo`@000001@3oool00`000000oooo0?ooo`2d0?ooo`00o`3ooooo0?ooofD0oooo003o0?oo
ool0ooooI@3oool00001\
\>"],
  ImageRangeCache->{{{0, 610}, {101.875, 0}} -> {-0.835121, -0.00841984, \
0.0060168, 0.0060168}, {{138.75, 297.063}, {100.438, 44.5}} -> {-2.75456, \
-0.018175, 0.012641, 0.012641}, {{312.875, 471.188}, {100.438, 44.5}} -> \
{-4.95568, -0.018175, 0.012641, 0.012641}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .2799 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00666423 0.47619 [
[.5 .2924 -140 0 ]
[.5 .2924 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .2799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00666 m
1 .00666 L
s
.02381 0 m
.02381 .2799 L
s
gsave
.5 .2924 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(2) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(Pi) show
189.000 12.750 moveto
(3) show
201.000 12.750 moveto
(Pi) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(2) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(Pi) show
309.000 12.750 moveto
(2) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
189.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
201.000 25.875 moveto
(--) show
213.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
225.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
309.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
321.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
105.000 39.000 moveto
(5) show
135.000 39.000 moveto
(5) show
165.000 39.000 moveto
(5) show
195.000 39.000 moveto
(5) show
225.000 39.000 moveto
(5) show
255.000 39.000 moveto
(5) show
285.000 39.000 moveto
(5) show
315.000 39.000 moveto
(5) show
321.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .2799 L
0 .2799 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00666423 0.477324 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -9.21572e-018 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
0 0 m
.61803 0 L
.5 .36327 L
F
0 0 1 r
.61803 0 m
1 0 L
.5 .36327 L
F
1 0 0 r
0 0 m
.5 .36327 L
.19098 .58779 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00666423 0.97619 0.273234 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.381966 0.618034 -1.19262e-017 0.618034 [
[ 0 0 0 0 ]
[ 1 .58779 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .58779 L
0 .58779 L
closepath
clip
newpath
0 1 0 r
.19098 .58779 m
0 0 L
.38197 0 L
F
0 0 1 r
.38197 0 m
.5 .36327 L
.19098 .58779 L
F
1 0 0 r
.38197 0 m
1 0 L
.5 .36327 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.563, 171.188},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000Zb000`400?l00000o`00003oF`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3oool0o`3ooooo0?oo
o`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00D03ooooo00000<@00000
D03oool005/0oooo00<000000?l00000o`00N`00o`1=0000oaH0ooooC@00o`000`000?l0o`000?l0
001j0?l005d0oooo001K0?ooo`030000003o0000o`0007/00?l0C0000?lG0?ooodd00?l000<0003o
0?l0003o0000N@3o001N0?ooo`00F`3oool00`000000o`000?l000020?l007T00?l0BP000?lI0?oo
odd00?l000<0003o0?l0003o0000M`3o001P0?ooo`00F`3oool00`000000oooo0?l000030?l007L0
0?l0BP000?lK0?oood/00?l00`000?mg0?l00640oooo001K0?ooo`030000003oool0o`0000@0o`00
MP00o`190000oa`0ooooB`00o`030000ogH0o`00HP3oool005/0oooo00<000000?ooo`3o00001P3o
001d003o04L0003o7P3ooom;003o00<0003oM03o001T0?ooo`00F`3oool00`000000oooo0?ooo`07
0?l007800?l0A`000?lP0?ooodT00?l01@000?mb0?l006D0oooo001K0?ooo`030000003oool0oooo
00T0o`00L000o`150000ob80ooooB@00o`050000og00o`00I`3oool005/0oooo00<000000?ooo`3o
ool02P3o001_003o04@0003o8`3ooom9003o00D0003oK`3o001X0?ooo`00F`3oool010000000oooo
0?ooo`3oool:0?l006d00?l0A0000?lU0?ooodL00?l01`000?m]0?l006T0oooo001K0?ooo`040000
003oool0oooo0?ooo``0o`00J`00o`120000obL0ooooA`00o`070000of/0o`00J`3oool005/0oooo
00@000000?ooo`3oool0oooo3@3o001Z003o0440003o:03ooom7003o00L0003oJP3o001/0?ooo`00
F`3oool00`000000oooo0?ooo`020?ooo`d0o`00J000o`110000obX0ooooA@00o`090000ofP0o`00
K@3oool005/0oooo00<000000?ooo`3oool00P3oool?0?l006H00?l0?`000?l/0?ooodD00?l02@00
0?mV0?l006l0oooo001K0?ooo`030000003oool0oooo0080oooo403o001U003o03h0003o;@3ooom5
003o00T0003oI@3o001`0?ooo`00F`3oool00`000000oooo0?ooo`030?oooa40o`00HP00o`0m0000
oc00oooo@`00o`0;0000of80o`00LP3oool005/0oooo00<000000?ooo`3oool00`3ooolB0?l00640
0?l0?0000?la0?oood<00?l02`000?mQ0?l007<0oooo001K0?ooo`030000003oool0oooo00<0oooo
4`3o001P003o03/0003o<P3ooom3003o00/0003oH03o001d0?ooo`00F`3oool00`000000oooo0?oo
o`040?oooa@0o`00G@00o`0j0000ocD0oooo@@00o`0=0000oed0o`00MP3oool005/0oooo00<00000
0?ooo`3oool0103ooolE0?l005`00?l0>@000?lf0?oood400?l03@000?mL0?l007L0oooo001K0?oo
o`030000003oool0oooo00@0oooo5P3o001K003o03P0003o=`3ooom1003o00d0003oF`3o001h0?oo
o`00F`3oool00`000000oooo0?ooo`050?oooaL0o`00F000o`0g0000ocX0oooo?`00o`0?0000oeP0
o`00NP3oool005/0oooo00<000000?ooo`3oool01@3ooolH0?l005L00?l0=P000?lk0?ooocl00?l0
3`000?mG0?l007/0oooo001K0?ooo`030000003oool0oooo00D0oooo6P3o001E003o03@0003o?@3o
oolo003o00l0003oE@3o001m0?ooo`00F`3oool00`000000oooo0?ooo`060?oooaX0o`00D`00o`0d
0000ocl0oooo?@00o`0A0000oe<0o`00OP3oool005/0oooo00<000000?ooo`3oool01P3ooolK0?l0
05800?l0<`000?m00?ooocd00?l04@000?mB0?l007l0oooo001K0?ooo`030000003oool0oooo00H0
oooo7@3o001@003o0340003o@P3ooolm003o0140003oD03o00210?ooo`00F`3oool00`000000oooo
0?ooo`070?oooad0o`00CP00o`0a0000od@0oooo>`00o`0C0000odh0o`00PP3oool005/0oooo00<0
00000?ooo`3oool01`3ooolN0?l004d00?l0<0000?m50?oooc/00?l04`000?m=0?l008<0oooo001K
0?ooo`030000003oool0oooo00L0oooo803o001;003o02h0003oA`3ooolk003o01<0003oB`3o0025
0?ooo`00F`3oool00`000000oooo0?ooo`080?ooob00o`00B@00o`0^0000odT0oooo>@00o`0E0000
odT0o`00QP3oool005/0oooo00<000000?ooo`3oool0203ooolR0?l004L00?l0;0000?m;0?ooocT0
0?l05@000?m70?l008P0oooo001K0?ooo`030000003oool0oooo00P0oooo8`3o0016003o02/0003o
C03oooli003o01D0003oAP3o00290?ooo`00F`3oool00`000000oooo0?ooo`090?ooob<0o`00A000
o`0[0000odh0oooo=`00o`0G0000od@0o`00RP3oool005/0oooo00<000000?ooo`3oool02@3ooolU
0?l004800?l0:@000?m@0?ooocL00?l05`000?m20?l008`0oooo001K0?ooo`030000003oool0oooo
00T0oooo9P3o0011003o02P0003oD@3ooolg003o01L0003o@@3o002=0?ooo`00F`3oool00`000000
oooo0?ooo`0:0?ooobH0o`00?`00o`0W0000oe@0oooo=@00o`0H0000ocl0o`00S`3oool005/0oooo
00<000000?ooo`3oool02P3ooolX0?l003d00?l09P000?mE0?ooocD00?l06@000?lm0?l00900oooo
001K0?ooo`030000003oool0oooo00X0oooo:@3o000l003o02D0003oEP3ooole003o01T0003o?03o
002A0?ooo`00F`3oool00`000000oooo0?ooo`0:0?ooob/0o`00>P00o`0S0000oeP0oooo=000o`0J
0000ocX0o`00T`3oool005/0oooo00<000000?ooo`3oool02`3oool[0?l003P00?l08`000?mJ0?oo
oc<00?l06`000?lh0?l009@0oooo001K0?ooo`030000003oool0oooo00/0oooo;03o000g003o0280
003oF`3ooolc003o01/0003o=`3o002E0?ooo`00F`3oool00`000000oooo0?ooo`0;0?ooobh0o`00
=@00o`0P0000oed0oooo<`00o`0K0000ocD0o`00U`3oool005/0oooo00<000000?ooo`3oool0303o
ool^0?l003<00?l080000?mO0?oooc400?l07@000?lc0?l009P0oooo001K0?ooo`030000003oool0
oooo00`0oooo<03o000a003o01h0003oH@3ooola003o01d0003o<@3o002J0?ooo`00F`3oool00`00
0000oooo0?ooo`0<0?oooc40o`00<000o`0M0000of80oooo<@00o`0M0000oc00o`00V`3oool005/0
oooo00<000000?ooo`3oool03@3ooola0?l002h00?l07@000?mT0?ooobl00?l07`000?l^0?l009`0
oooo001K0?ooo`030000003oool0oooo00d0oooo<`3o000/003o01/0003oIP3oool_003o01l0003o
;03o002N0?ooo`00F`3oool00`000000oooo0?ooo`0=0?oooc@0o`00:`00o`0J0000ofL0oooo;`00
o`0O0000ob/0o`00W`3oool005/0oooo00<000000?ooo`3oool03P3ooold0?l002T00?l06P000?mY
0?ooobd00?l08@000?lY0?l00:00oooo001K0?ooo`030000003oool0oooo00h0oooo=P3o000W003o
01P0003oJ`3oool]003o0240003o9`3o002R0?ooo`00F`3oool00`000000oooo0?ooo`0>0?ooocL0
o`009P00o`0G0000of`0oooo;@00o`0Q0000obH0o`00X`3oool005/0oooo00<000000?ooo`3oool0
3`3ooolh0?l002<00?l05P000?m_0?ooob/00?l08`000?lS0?l00:D0oooo001K0?ooo`030000003o
ool0oooo00l0oooo>@3o000R003o01D0003oL03oool[003o02<0003o8P3o002V0?ooo`00F`3oool0
0`000000oooo0?ooo`0?0?ooocX0o`008@00o`0D0000og40oooo:`00o`0S0000ob40o`00Y`3oool0
05/0oooo00<000000?ooo`3oool0403ooolk0?l001h00?l04`000?md0?ooobT00?l09@000?lN0?l0
0:T0oooo001K0?ooo`030000003oool0oooo0100oooo?03o000M003o0180003oM@3ooolY003o02D0
003o7@3o002Z0?ooo`00F`3oool00`000000oooo0?ooo`0@0?ooocd0o`007000o`0A0000ogH0oooo
:@00o`0U0000oa`0o`00Z`3oool005/0oooo00<000000?ooo`3oool04@3oooln0?l001T00?l04000
0?mi0?ooobL00?l09`000?lI0?l00:d0oooo001K0?ooo`030000003oool0oooo0140oooo?`3o000H
003o00l0003oNP3ooolW003o02L0003o603o002^0?ooo`00F`3oool00`000000oooo0?ooo`0A0?oo
od40o`005P00o`0=0000og`0oooo9`00o`0W0000oaH0o`00/03oool005/0oooo00<000000?ooo`3o
ool04P3ooom10?l001@00?l03@000?mn0?ooobD00?l0:@000?lD0?l00;40oooo001K0?ooo`030000
003oool0oooo0180oooo@P3o000C003o00`0003oO`3ooolU003o02T0003o4`3o002b0?ooo`00F`3o
ool00`000000oooo0?ooo`0B0?oood@0o`004@00o`0:0000oh40oooo9@00o`0Y0000oa40o`00]03o
ool005/0oooo00<000000?ooo`3oool04`3ooom40?l000l00?l02P000?n30?ooob<00?l0:`000?l?
0?l00;D0oooo001K0?ooo`030000003oool0oooo01<0ooooA@3o000>003o00T0003oQ03ooolS003o
02/0003o3P3o002f0?ooo`00F`3oool00`000000oooo0?ooo`0C0?ooodL0o`003000o`070000ohH0
oooo8`00o`0[0000o``0o`00^03oool005/0oooo00<000000?ooo`3oool0503ooom70?l000X00?l0
1`000?n80?ooob400?l0;@000?l:0?l00;T0oooo001K0?ooo`030000003oool0oooo01@0ooooB@3o
0008003o00D0003oRP3ooolQ003o02d0003o203o002k0?ooo`00F`3oool00`000000oooo0?ooo`0D
0?ooodX0o`001`00o`040000oh/0oooo8@00o`0]0000o`L0o`00_03oool005/0oooo00<000000?oo
o`3oool05@3ooom:0?l000D00?l010000?n=0?oooal00?l0;`000?l50?l00;d0oooo001K0?ooo`03
0000003oool0oooo01D0ooooC03o0003003o0080003oS`3ooolO003o02l0003o0`3o002o0?ooo`00
F`3oool00`000000oooo0?ooo`0E0?ooodd0o`000P00o`000`000?l0oooo0?ooo`2>0?oooal00?l0
;`000?l20?l00<00oooo001K0?ooo`030000003oool0oooo01H0ooooC@3o002C0?oooad00?l0<000
0?o20?ooo`00F`3oool00`000000oooo0?ooo`0F0?oood`0o`00U03ooolM003o02l0003o``3oool0
05/0oooo00<000000?ooo`3oool05P3ooom;0?l009D0oooo7@00o`0^0000ol@0oooo001K0?ooo`03
0000003oool0oooo01L0ooooB03o002H0?oooa/00?l0;@000?o60?ooo`00F`3oool00`000000oooo
0?ooo`0G0?ooodL0o`00V@3ooolK003o02`0003oa`3oool005/0oooo00<000000?ooo`3oool05`3o
oom60?l009X0oooo6`00o`0[0000olP0oooo001K0?ooo`030000003oool0oooo01L0ooooA03o002L
0?oooaX00?l0:P000?o:0?ooo`00F`3oool00`000000oooo0?ooo`0H0?oood80o`00WP3ooolI003o
02T0003ob`3oool005/0oooo00<000000?ooo`3oool0603ooom10?l009l0oooo6@00o`0X0000ol`0
oooo001K0?ooo`030000003oool0oooo01P0oooo?`3o002Q0?oooaT00?l09P000?o>0?ooo`00F`3o
ool00`000000oooo0?ooo`0I0?ooocd0o`00X`3ooolG003o02H0003oc`3oool005/0oooo00<00000
0?ooo`3oool06@3ooolk0?l00:D0oooo5`00o`0T0000om40oooo001K0?ooo`030000003oool0oooo
01T0oooo>P3o002V0?oooaL00?l08`000?oB0?ooo`00F`3oool00`000000oooo0?ooo`0J0?ooocP0
o`00Z03ooolE003o02<0003od`3oool005/0oooo00<000000?ooo`3oool06P3ooolf0?l00:X0oooo
5@00o`0Q0000omD0oooo001K0?ooo`030000003oool0oooo01X0oooo=@3o002[0?oooaD00?l08000
0?oF0?ooo`00F`3oool00`000000oooo0?ooo`0K0?oooc<0o`00[@3ooolC003o0200003oe`3oool0
05/0oooo00<000000?ooo`3oool06`3ooola0?l00:l0oooo4`00o`0N0000omT0oooo001K0?ooo`03
0000003oool0oooo01/0oooo<03o002`0?oooa<00?l07@000?oJ0?ooo`00F`3oool00`000000oooo
0?ooo`0L0?ooobd0o`00/`3ooolA003o01`0003og03oool005/0oooo00<000000?ooo`3oool0703o
ool/0?l00;@0oooo4@00o`0K0000omd0oooo001K0?ooo`030000003oool0oooo01`0oooo:`3o002e
0?oooa400?l06P000?oN0?ooo`00F`3oool00`000000oooo0?ooo`0M0?ooobP0o`00^03oool?003o
01T0003oh03oool005/0oooo00<000000?ooo`3oool07@3ooolW0?l00;T0oooo3`00o`0H0000on40
oooo001K0?ooo`030000003oool0oooo01d0oooo9P3o002j0?ooo`l00?l05`000?oR0?ooo`00F`3o
ool00`000000oooo0?ooo`0N0?ooob<0o`00_@3oool=003o01H0003oi03oool005/0oooo00<00000
0?ooo`3oool07P3ooolR0?l00;h0oooo3@00o`0E0000onD0oooo001K0?ooo`030000003oool0oooo
01h0oooo8@3o002o0?ooo`d00?l050000?oV0?ooo`00F`3oool00`000000oooo0?ooo`0O0?oooah0
o`00`P3oool;003o01<0003oj03oool005/0oooo00<000000?ooo`3oool07`3ooolM0?l00<<0oooo
2`00o`0B0000onT0oooo001K0?ooo`030000003oool0oooo01l0oooo6`3o00350?ooo`/00?l04000
0?o[0?ooo`00F`3oool00`000000oooo0?ooo`0P0?oooaT0o`00a`3oool9003o0100003ok03oool0
05/0oooo00<000000?ooo`3oool0803ooolH0?l00<P0oooo2@00o`0?0000ond0oooo001K0?ooo`03
0000003oool0oooo0200oooo5P3o003:0?ooo`T00?l03@000?o_0?ooo`00F`3oool00`000000oooo
0?ooo`0Q0?oooa@0o`00c03oool7003o00d0003ol03oool005/0oooo00<000000?ooo`3oool08@3o
oolC0?l00<d0oooo1`00o`0<0000oo40oooo001K0?ooo`030000003oool0oooo0240oooo4@3o003?
0?ooo`L00?l02P000?oc0?ooo`00F`3oool00`000000oooo0?ooo`0R0?ooo`l0o`00d@3oool5003o
00X0003om03oool005/0oooo00<000000?ooo`3oool08P3oool=0?l00=<0oooo1@00o`080000ooH0
oooo001K0?ooo`030000003oool0oooo0280oooo303o003D0?ooo`D00?l01`000?og0?ooo`00F`3o
ool00`000000oooo0?ooo`0S0?ooo`X0o`00eP3oool3003o00L0003on03oool005/0oooo00<00000
0?ooo`3oool08`3oool80?l00=P0oooo0`00o`050000ooX0oooo001K0?ooo`030000003oool0oooo
02<0oooo1`3o003I0?ooo`<00?l010000?ok0?ooo`00F`3oool00`000000oooo0?ooo`0T0?ooo`D0
o`00f`3oool00`00o`00003o0000o`020000oo`0oooo001K0?ooo`030000003oool0oooo02@0oooo
0`3o003M0?ooo`03003o00000?l0003o0?h0oooo001K0?ooo`030000003oool0oooo02@0oooo0P3o
003N0?ooo`03003o00000?l0oooo0?h0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool7
0?ooo`00F`3oool00`000000oooo0?ooo`3o0?ooool0oooo1`3oool005/0oooo00<000000?ooo`3o
ool0o`3ooooo0?ooo`L0oooo001K0?ooo`030000003oool0oooo0?l0ooooo`3oool70?ooo`00o`3o
oooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0
oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?oo
ool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00]@3oool2000001`0oooo0P00000L0?ooo`800000
703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000
_03oool00;@0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00000J0?ooo`04
0000003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00
000J0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool000006P3oool010000000
oooo0?ooo`00000J0?ooo`040000003oool0oooo00000;/0oooo002g0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`2i0?ooo`00]@3oool2000001`0
oooo0P00000L0?ooo`800000703oool2000001`0oooo0P00000L0?ooo`800000703oool2000001`0
oooo0P00000L0?ooo`800000_03oool00;D0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo0;/0oooo002e0?ooo`<000006`3oool3000001/0oooo0`00
000K0?ooo`<000006`3oool3000001/0oooo0`00000K0?ooo`<000006`3oool3000001/0oooo0`00
002k0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00
o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00Z`3oool00`00
0000oooo0?ooo`3o0?ooo`T0oooo00<000000?ooo`3oool0ZP3oool00:X0oooo00<000000?ooo`3o
ool06P3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool0Z@3oool00:X0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool0Z@3oool00:X0oooo00@000000?ooo`3oool0oooo
100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo
00<000000?ooo`3oool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo
100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool400000080oooo
100000020?ooo`@000000`3oool00`000000oooo0?ooo`2Y0?ooo`00Z@3oool00`000000oooo0?oo
o`3o0?ooo`d0oooo00<000000?ooo`3oool0Z03oool00:X0oooo00<000000?ooo`3oool0o`3oool;
0?ooo`030000003oool0oooo0:T0oooo002Z0?ooo`030000003oool0oooo0?l0oooo2`3oool00`00
0000oooo0?ooo`2Y0?ooo`00Z`3oool00`000000oooo0?ooo`3o0?ooo`T0oooo00<000000?ooo`3o
ool0ZP3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool0
0?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3o
oomU0?ooo`00[P3oool4000000L0oooo0`0000050?ooo`<000003@3oool3000000D0oooo0`00000>
0?ooo`@000001`3oool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000l0oooo0P000008
0?ooo`<000001@3oool3000000d0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`000005
0?ooo`<000003@3oool3000000D0oooo0`00000>0?ooo`@000001`3oool3000000D0oooo0`00002_
0?ooo`00[P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0:h0oooo002_0?oo
o`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?oo
o`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?oo
o`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`070?oo
o`<000001@3oool00`000000oooo0?ooo`0=0?ooo`<000001@3oool00`000000oooo0?ooo`0>0?oo
o`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?oo
o`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?oo
o`3oool0[P3oool00;00oooo00<000000?ooo`3oool01`3oool010000000oooo0?ooo`0000030?oo
o`8000003`3oool010000000oooo0?ooo`0000030?ooo`8000004@3oool00`000000oooo0?ooo`07
0?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo
0P00000B0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool000000`3oool2000000l0
oooo00@000000?ooo`3oool000000`3oool200000140oooo00<000000?ooo`3oool01`3oool01000
0000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000030?ooo`8000004@3o
ool00`000000oooo0?ooo`070?ooo`040000003oool0oooo000000<0oooo0P00002`0?ooo`00[P3o
ool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3o
ool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@0
00000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo0000
01@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?ooo`040000003o
ool0oooo000001@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`0000080?oo
o`040000003oool0oooo00000;D0oooo002_0?ooo`800000203oool4000000D0oooo00<000000?oo
o`3oool0303oool4000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo100000050?oo
o`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?oo
o`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`0>0?oo
o`800000203oool4000000D0oooo00<000000?ooo`3oool0303oool4000000D0oooo00<000000?oo
o`3oool03P3oool2000000P0oooo100000050?ooo`030000003oool0oooo0:h0oooo003o0?ooool0
ooooI@3oool00?l0ooooo`3ooomU0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 610.563}, {170.188, 0}} -> {-0.426205, -0.013998, \
0.00467178, 0.00467178}, {{91.1875, 295.063}, {167.188, 47.3125}} -> \
{-1.34175, -0.0239702, 0.00793648, 0.00793648}, {{315.438, 519.313}, \
{167.188, 47.3125}} -> {-3.12151, -0.0239702, 0.00793648, 0.00793648}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .41239 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00981888 0.47619 [
[.5 .42489 -140 0 ]
[.5 .42489 140 38.75 ]
[ 0 0 0 0 ]
[ 1 .41239 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .00982 m
1 .00982 L
s
.02381 0 m
.02381 .41239 L
s
gsave
.5 .42489 -201 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(Pi) show
153.000 12.750 moveto
(Pi) show
177.000 12.750 moveto
(2) show
189.000 12.750 moveto
(Pi) show
213.000 12.750 moveto
(4) show
225.000 12.750 moveto
(Pi) show
249.000 12.750 moveto
(4) show
261.000 12.750 moveto
(Pi) show
285.000 12.750 moveto
(2) show
297.000 12.750 moveto
(Pi) show
321.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
153.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
165.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
177.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
189.000 25.875 moveto
(--) show
201.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
213.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
225.000 25.875 moveto
(--) show
237.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
249.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
261.000 25.875 moveto
(--) show
273.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
285.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
297.000 25.875 moveto
(--) show
309.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
321.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
333.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(9) show
105.000 39.000 moveto
(9) show
129.000 39.000 moveto
(9) show
153.000 39.000 moveto
(3) show
183.000 39.000 moveto
(9) show
219.000 39.000 moveto
(9) show
255.000 39.000 moveto
(9) show
291.000 39.000 moveto
(9) show
321.000 39.000 moveto
(3) show
327.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .41239 L
0 .41239 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00981888 0.477324 0.402574 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.652704 0.347296 -2.50451e-017 0.347296 [
[ 0 0 0 0 ]
[ 1 .86603 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .86603 L
0 .86603 L
closepath
clip
newpath
0 1 0 r
0 0 m
.46791 0 L
.82635 .30077 L
F
0 0 1 r
.46791 0 m
1 0 L
.82635 .30077 L
F
1 0 0 r
0 0 m
.82635 .30077 L
.5 .86603 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.00981888 0.97619 0.402574 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.652704 0.347296 -2.20635e-017 0.347296 [
[ 0 0 0 0 ]
[ 1 .86603 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .86603 L
0 .86603 L
closepath
clip
newpath
0 1 0 r
.6527 0 m
.73396 .4608 L
.5 .86603 L
F
0 0 1 r
.5 .86603 m
0 0 L
.6527 0 L
F
1 0 0 r
.6527 0 m
1 0 L
.73396 .4608 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{611.813, 252.313},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009S0000o2000`400?l00000o`00003o@`3oool0
0`000000oooo0?ooo`3o0?ooool0oooo7`3oool004<0oooo00<000000?ooo`3oool0o`3ooooo0?oo
oal0oooo00130?ooo`030000003oool0oooo0?l0ooooo`3ooolO0?ooo`00@`3oool00`000000oooo
0?ooo`3o0?ooool0oooo7`3oool004<0oooo00<000000?ooo`3oool0o`3ooooo0?oooal0oooo000g
0?ooool00000mP00000g0?ooo`00@`3oool00`000000o`000?l0001Y003o07L0003o5`3ooonC0000
o`03003o003o0000o`0004`0o`00A03oool004<0oooo00<000000?ooo`3o00000`3o001W003o07D0
003o6@3ooonB0000o`03003o003o0000o`0004/0o`00A@3oool004<0oooo00<000000?ooo`3o0000
1P3o001U003o07@0003o6@3ooonB0000o`03003o003o0000o`0004/0o`00A@3oool004<0oooo00<0
00000?ooo`3oool0203o001T003o0780003o6`3ooonA0000o`03003o003o0000o`0004X0o`00AP3o
ool004<0oooo00<000000?ooo`3oool02`3o001R003o0740003o6`3ooonA0000o`03003o003o0000
o`0004X0o`00AP3oool004<0oooo00@000000?ooo`3oool0oooo3@3o001Q003o06h0003o7@3ooon?
0000o`<00?l0BP3o00170?ooo`00@`3oool00`000000oooo0?ooo`020?ooo`l0o`00G`00o`1/0000
oal0ooooSP000?l3003o04T0o`00B03oool004<0oooo00<000000?ooo`3oool00P3ooolA0?l005h0
0?l0J`000?lO0?ooohh0003o0`00o`190?l004P0oooo00130?ooo`030000003oool0oooo00<0oooo
4`3o001L003o06T0003o8@3ooon=0000o`<00?l0B03o00190?ooo`00@`3oool00`000000oooo0?oo
o`030?oooaH0o`00FP00o`1X0000ob40ooooS@000?l3003o04P0o`00B@3oool004<0oooo00<00000
0?ooo`3oool0103ooolH0?l005T00?l0I@000?lS0?oooh`0003o0`00o`170?l004X0oooo00130?oo
o`030000003oool0oooo00@0oooo6P3o001H003o06<0003o903ooon;0000o`D00?l0AP3o001:0?oo
o`00@`3oool00`000000oooo0?ooo`050?oooa`0o`00EP00o`1R0000obD0ooooRP000?l5003o04D0
o`00B`3oool004<0oooo00<000000?ooo`3oool01P3ooolN0?l005@00?l0H0000?lW0?ooohT0003o
1@00o`140?l004`0oooo00130?ooo`030000003oool0oooo00H0oooo8@3o001B003o05l0003o9`3o
oon90000o`D00?l0A03o001<0?ooo`00@`3oool00`000000oooo0?ooo`070?ooob80o`00DP00o`1L
0000obT0ooooR0000?l5003o04<0o`00C@3oool004<0oooo00<000000?ooo`3oool01`3ooolU0?l0
05000?l0FP000?lZ0?ooohP0003o1P00o`120?l004d0oooo00130?ooo`030000003oool0oooo00P0
oooo9`3o001>003o05T0003o:`3ooon60000o`L00?l0@@3o001>0?ooo`00@`3oool00`000000oooo
0?ooo`080?ooobX0o`00C000o`1G0000ob`0ooooQP000?l7003o0440o`00CP3oool004<0oooo00<0
00000?ooo`3oool02@3oool[0?l004/00?l0EP000?l]0?ooohD0003o1`00o`100?l004l0oooo0013
0?ooo`030000003oool0oooo00X0oooo;@3o001:003o05<0003o;`3ooon40000o`L00?l0?`3o001@
0?ooo`00@`3oool00`000000oooo0?ooo`0:0?oooc00o`00B000o`1B0000obl0ooooQ0000?l7003o
03l0o`00D03oool004<0oooo00<000000?ooo`3oool02`3ooolb0?l004H00?l0D0000?la0?oooh<0
003o2000o`0m0?l00540oooo00130?ooo`030000003oool0oooo00/0oooo=03o0015003o04h0003o
<P3ooon20000o`T00?l0?@3o001A0?ooo`00@`3oool00`000000oooo0?ooo`0<0?ooocH0o`00@`00
o`1=0000oc<0ooooP@000?l9003o03`0o`00DP3oool004<0oooo00<000000?ooo`3oool0303oooli
0?l004400?l0B`000?le0?oooh00003o2@00o`0l0?l00580oooo00130?ooo`030000003oool0oooo
00d0oooo>`3o0010003o04T0003o=@3ooon00000o`T00?l0>`3o001C0?ooo`00@`3oool00`000000
oooo0?ooo`0>0?oooc`0o`00?`00o`170000ocL0ooooO`000?l:003o03T0o`00E03oool004<0oooo
00<000000?ooo`3oool03P3ooolo0?l003d00?l0A@000?lh0?ooogh0003o2`00o`0i0?l005@0oooo
00130?ooo`030000003oool0oooo00l0oooo@@3o000k003o04@0003o>@3ooomm0000o`/00?l0>03o
001E0?ooo`00@`3oool00`000000oooo0?ooo`0?0?oood@0o`00>@00o`120000ocX0ooooO@000?l;
003o03P0o`00E@3oool004<0oooo00<000000?ooo`3oool0403ooom50?l003T00?l0@0000?lk0?oo
og`0003o2`00o`0g0?l005H0oooo00130?ooo`030000003oool0oooo0100ooooB03o000g003o03h0
003o?@3ooomk0000o`/00?l0=`3o001F0?ooo`00@`3oool00`000000oooo0?ooo`0A0?ooodX0o`00
=@00o`0l0000och0ooooN`000?l<003o03D0o`00E`3oool004<0oooo00<000000?ooo`3oool04P3o
oom<0?l003<00?l0>`000?lo0?ooogT0003o3@00o`0d0?l005P0oooo00130?ooo`030000003oool0
oooo0180ooooCP3o000b003o03T0003o@03ooomi0000o`d00?l0=03o001H0?ooo`00@`3oool00`00
0000oooo0?ooo`0C0?oooe00o`00<@00o`0g0000od40ooooN0000?l=003o03<0o`00F@3oool004<0
oooo00<000000?ooo`3oool04`3ooomC0?l002l00?l0=@000?m20?ooogP0003o3@00o`0c0?l005T0
oooo00130?ooo`030000003oool0oooo01@0ooooE@3o000]003o03@0003o@`3ooomg0000o`h00?l0
<@3o001J0?ooo`00@`3oool00`000000oooo0?ooo`0D0?oooeL0o`00;000o`0b0000odD0ooooMP00
0?l>003o0340o`00FP3oool004<0oooo00<000000?ooo`3oool05@3ooomI0?l002X00?l0<0000?m6
0?ooogD0003o3`00o`0`0?l005/0oooo00130?ooo`030000003oool0oooo01H0ooooF`3o000Y003o
02h0003oA`3ooomd0000o`l00?l0;`3o001L0?ooo`00@`3oool00`000000oooo0?ooo`0F0?oooeh0
o`009`00o`0/0000odP0ooooM0000?l?003o02l0o`00G03oool004<0oooo00<000000?ooo`3oool0
5`3ooomO0?l002H00?l0:`000?m90?ooog<0003o3`00o`0^0?l005d0oooo00130?ooo`030000003o
ool0oooo01L0ooooHP3o000T003o02T0003oB`3ooomb0000oa000?l0;@3o001M0?ooo`00@`3oool0
0`000000oooo0?ooo`0H0?ooof@0o`008P00o`0W0000od`0ooooLP000?l@003o02`0o`00GP3oool0
04<0oooo00<000000?ooo`3oool0603ooomW0?l002000?l09P000?m=0?ooog00003o4@00o`0/0?l0
05h0oooo00130?ooo`030000003oool0oooo01T0ooooJ03o000P003o02<0003oCP3ooom`0000oa40
0?l0:`3o001O0?ooo`00@`3oool00`000000oooo0?ooo`0J0?ooofX0o`007P00o`0R0000odl0oooo
K`000?lA003o02X0o`00H03oool004<0oooo00<000000?ooo`3oool06P3ooom]0?l001`00?l08000
0?m@0?ooofl0003o4P00o`0Y0?l00600oooo00130?ooo`030000003oool0oooo01/0ooooK`3o000J
003o01h0003oDP3ooom^0000oa800?l0:03o001Q0?ooo`00@`3oool00`000000oooo0?ooo`0K0?oo
og40o`006@00o`0M0000oe<0ooooK@000?lB003o02P0o`00H@3oool004<0oooo00<000000?ooo`3o
ool0703ooomc0?l001P00?l06P000?mD0?ooof`0003o4`00o`0W0?l00680oooo00130?ooo`030000
003oool0oooo01`0ooooMP3o000F003o01T0003oE@3ooom[0000oa<00?l09`3o001R0?ooo`00@`3o
ool00`000000oooo0?ooo`0M0?ooogP0o`005000o`0G0000oeH0ooooJ`000?lC003o02H0o`00H`3o
ool004<0oooo00<000000?ooo`3oool07P3ooomi0?l001<00?l05P000?mG0?ooofX0003o5000o`0T
0?l006@0oooo00130?ooo`030000003oool0oooo01h0ooooO03o000A003o01@0003oF03ooomZ0000
oa@00?l0903o001T0?ooo`00@`3oool00`000000oooo0?ooo`0O0?ooogh0o`004000o`0A0000oeX0
ooooJ0000?lE003o02<0o`00I@3oool004<0oooo00<000000?ooo`3oool07`3ooon10?l000h00?l0
40000?mK0?ooofL0003o5@00o`0S0?l006D0oooo00130?ooo`030000003oool0oooo0200ooooPP3o
000=003o00h0003oG03ooomW0000oaD00?l08P3o001V0?ooo`00@`3oool00`000000oooo0?ooo`0P
0?ooohD0o`002`00o`0=0000oed0ooooIP000?lF003o0240o`00IP3oool004<0oooo00<000000?oo
o`3oool08@3ooon70?l000T00?l02`000?mN0?ooofH0003o5P00o`0P0?l006L0oooo00130?ooo`03
0000003oool0oooo0280ooooR@3o0008003o00P0003oH03ooomU0000oaH00?l07`3o001X0?ooo`00
@`3oool00`000000oooo0?ooo`0R0?oooh/0o`001`00o`070000of40ooooH`000?lG003o01l0o`00
J03oool004<0oooo00<000000?ooo`3oool08`3ooon=0?l000D00?l01@000?mR0?ooof<0003o5`00
o`0N0?l006T0oooo00130?ooo`030000003oool0oooo02<0ooooT03o0003003o00@0003oH`3ooomR
0000oaL00?l07P3o001Y0?ooo`00@`3oool00`000000oooo0?ooo`0T0?oooi80o`0000<00?l00000
o`000?l0I03ooomR0000oaP00?l0703o001Z0?ooo`00@`3oool00`000000oooo0?ooo`0U0?oooi<0
o`00IP3ooomQ0000oaP00?l0703o001Z0?ooo`00@`3oool00`000000oooo0?ooo`0U0?oooi<0o`00
IP3ooomQ0000oaP00?l06`3o001[0?ooo`00@`3oool00`000000oooo0?ooo`0V0?oooi40o`00J03o
oomO0000oaT00?l06P3o001/0?ooo`00@`3oool00`000000oooo0?ooo`0V0?oooi40o`00J@3ooomN
0000oaT00?l06P3o001/0?ooo`00@`3oool00`000000oooo0?ooo`0W0?ooohl0o`00JP3ooomN0000
oaX00?l0603o001]0?ooo`00@`3oool00`000000oooo0?ooo`0W0?ooohl0o`00J`3ooomM0000oaX0
0?l0603o001]0?ooo`00@`3oool00`000000oooo0?ooo`0X0?ooohd0o`00K03ooomM0000oaX00?l0
5`3o001^0?ooo`00@`3oool00`000000oooo0?ooo`0Y0?oooh/0o`00KP3ooomL0000oaX00?l05`3o
001^0?ooo`00@`3oool00`000000oooo0?ooo`0Y0?oooh/0o`00KP3ooomK0000oa/00?l05P3o001_
0?ooo`00@`3oool00`000000oooo0?ooo`0Z0?ooohT0o`00L03ooomJ0000oa/00?l05@3o001`0?oo
o`00@`3oool00`000000oooo0?ooo`0Z0?ooohT0o`00L@3ooomI0000oa`00?l0503o001`0?ooo`00
@`3oool00`000000oooo0?ooo`0[0?ooohL0o`00LP3ooomI0000oa`00?l04`3o001a0?ooo`00@`3o
ool00`000000oooo0?ooo`0[0?ooohL0o`00L`3ooomH0000oa`00?l04`3o001a0?ooo`00@`3oool0
0`000000oooo0?ooo`0/0?ooohD0o`00M03ooomH0000oa`00?l04P3o001b0?ooo`00@`3oool00`00
0000oooo0?ooo`0]0?oooh<0o`00MP3ooomF0000oad00?l04P3o001b0?ooo`00@`3oool00`000000
oooo0?ooo`0]0?oooh<0o`00M`3ooomE0000oah00?l0403o001c0?ooo`00@`3oool00`000000oooo
0?ooo`0^0?oooh40o`00N03ooomE0000oah00?l03`3o001d0?ooo`00@`3oool00`000000oooo0?oo
o`0^0?oooh40o`00N@3ooomD0000oah00?l03`3o001d0?ooo`00@`3oool00`000000oooo0?ooo`0_
0?ooogl0o`00NP3ooomD0000oah00?l03P3o001e0?ooo`00@`3oool00`000000oooo0?ooo`0_0?oo
ogl0o`00N`3ooomB0000oal00?l03P3o001e0?ooo`00@`3oool00`000000oooo0?ooo`0`0?ooogd0
o`00O03ooomB0000oal00?l03@3o001f0?ooo`00@`3oool00`000000oooo0?ooo`0a0?ooog/0o`00
OP3ooomA0000ob000?l0303o001f0?ooo`00@`3oool00`000000oooo0?ooo`0a0?ooog/0o`00O`3o
oom@0000ob000?l02`3o001g0?ooo`00@`3oool00`000000oooo0?ooo`0b0?ooogT0o`00P03ooom@
0000ob000?l02P3o001h0?ooo`00@`3oool00`000000oooo0?ooo`0b0?ooogT0o`00P@3ooom?0000
ob000?l02P3o001h0?ooo`00@`3oool00`000000oooo0?ooo`0c0?ooogL0o`00PP3ooom>0000ob40
0?l02@3o001i0?ooo`00@`3oool00`000000oooo0?ooo`0c0?ooogL0o`00P`3ooom=0000ob800?l0
203o001i0?ooo`00@`3oool00`000000oooo0?ooo`0d0?ooogD0o`00Q03ooom=0000ob800?l01`3o
001j0?ooo`00@`3oool00`000000oooo0?ooo`0e0?ooog<0o`00QP3ooom<0000ob800?l01`3o001j
0?ooo`00@`3oool00`000000oooo0?ooo`0e0?ooog<0o`00Q`3ooom;0000ob800?l01P3o001k0?oo
o`00@`3oool00`000000oooo0?ooo`0f0?ooog40o`00R03ooom;0000ob800?l01@3o001l0?ooo`00
@`3oool00`000000oooo0?ooo`0f0?ooog40o`00R@3ooom90000ob<00?l01@3o001l0?ooo`00@`3o
ool00`000000oooo0?ooo`0g0?ooofl0o`00RP3ooom90000ob@00?l00`3o001m0?ooo`00@`3oool0
0`000000oooo0?ooo`0g0?ooofl0o`00R`3ooom80000ob@00?l00`3o001m0?ooo`00@`3oool00`00
0000oooo0?ooo`0h0?ooofd0o`00S@3ooom70000ob@00?l00P3o001n0?ooo`00@`3oool00`000000
oooo0?ooo`0i0?ooof/0o`00SP3ooom70000ob@00?l00P3o001n0?ooo`00@`3oool00`000000oooo
0?ooo`0i0?ooof/0o`00S`3ooom60000ob@00?l000<0o`000?ooo`3oool0O@3oool004<0oooo00<0
00000?ooo`3oool0>P3ooomY0?l00900ooooA@000?lU003o0800oooo00130?ooo`030000003oool0
oooo03X0ooooJ@3o002A0?oood@0003o9@00o`200?ooo`00@`3oool00`000000oooo0?ooo`0k0?oo
ofL0o`00TP3ooom40000ob@00?l0P@3oool004<0oooo00<000000?ooo`3oool0>`3ooomW0?l009<0
oooo@`000?lT003o0840oooo00130?ooo`030000003oool0oooo03`0ooooI@3o002E0?oood80003o
8`00o`220?ooo`00@`3oool00`000000oooo0?ooo`0m0?ooof<0o`00UP3ooom20000ob<00?l0PP3o
ool004<0oooo00<000000?ooo`3oool0?@3ooomS0?l009L0oooo@0000?lS003o08<0oooo00130?oo
o`030000003oool0oooo03h0ooooH@3o002H0?oood00003o8P00o`240?ooo`00@`3oool00`000000
oooo0?ooo`0n0?ooof40o`00V@3ooolo0000ob800?l0Q03oool004<0oooo00<000000?ooo`3oool0
?`3ooomO0?l009X0oooo?`000?lQ003o08D0oooo00130?ooo`030000003oool0oooo03l0ooooG`3o
002K0?oooch0003o8@00o`250?ooo`00@`3oool00`000000oooo0?ooo`100?oooed0o`00W@3oooll
0000ob400?l0QP3oool004<0oooo00<000000?ooo`3oool0@@3ooomK0?l009h0oooo?0000?lQ003o
08H0oooo00130?ooo`030000003oool0oooo0440ooooF`3o002O0?oooc/0003o8000o`270?ooo`00
@`3oool00`000000oooo0?ooo`120?oooeT0o`00X03ooolk0000oal00?l0R03oool004<0oooo00<0
00000?ooo`3oool0@P3ooomI0?l00:40oooo>P000?lO003o08P0oooo00130?ooo`030000003oool0
oooo04<0ooooE`3o002S0?ooocT0003o7P00o`290?ooo`00@`3oool00`000000oooo0?ooo`130?oo
oeL0o`00X`3ooolh0000oal00?l0R@3oool004<0oooo00<000000?ooo`3oool0A03ooomE0?l00:D0
oooo=`000?lN003o08X0oooo00130?ooo`030000003oool0oooo04D0ooooD`3o002V0?ooocL0003o
7P00o`2:0?ooo`00@`3oool00`000000oooo0?ooo`150?oooe<0o`00Y`3ooolf0000oad00?l0R`3o
ool004<0oooo00<000000?ooo`3oool0AP3ooomA0?l00:P0oooo=P000?lL003o08`0oooo00130?oo
o`030000003oool0oooo04H0ooooD@3o002Y0?ooocD0003o7000o`2<0?ooo`00@`3oool00`000000
oooo0?ooo`170?ooodl0o`00Z`3ooolc0000oa`00?l0S@3oool004<0oooo00<000000?ooo`3oool0
A`3ooom?0?l00:/0oooo<`000?lL003o08d0oooo00130?ooo`030000003oool0oooo04P0ooooC@3o
002]0?oooc80003o6`00o`2>0?ooo`00@`3oool00`000000oooo0?ooo`190?oood/0o`00[P3ooolb
0000oa/00?l0SP3oool004<0oooo00<000000?ooo`3oool0B@3ooom;0?l00:l0oooo<@000?lJ003o
08l0oooo00130?ooo`030000003oool0oooo04X0ooooB@3o002`0?oooc40003o6@00o`2@0?ooo`00
@`3oool00`000000oooo0?ooo`1:0?ooodT0o`00/@3oool_0000oaX00?l0T03oool004<0oooo00<0
00000?ooo`3oool0B`3ooom70?l00;<0oooo;P000?lI003o0940oooo00130?ooo`030000003oool0
oooo04`0ooooA@3o002d0?ooobh0003o6@00o`2A0?ooo`00@`3oool00`000000oooo0?ooo`1<0?oo
odD0o`00]@3oool]0000oaP00?l0TP3oool004<0oooo00<000000?ooo`3oool0C@3ooom30?l00;H0
oooo;@000?lG003o09<0oooo00130?ooo`030000003oool0oooo04d0oooo@`3o002g0?ooob`0003o
5`00o`2C0?ooo`00@`3oool00`000000oooo0?ooo`1>0?oood40o`00^@3ooolZ0000oaL00?l0U03o
ool004<0oooo00<000000?ooo`3oool0CP3ooom10?l00;T0oooo:P000?lG003o09@0oooo00130?oo
o`030000003oool0oooo04l0oooo?`3o002k0?ooobT0003o5P00o`2E0?ooo`00@`3oool00`000000
oooo0?ooo`1@0?ooocd0o`00_03ooolY0000oaH00?l0U@3oool004<0oooo00<000000?ooo`3oool0
D03ooolm0?l00;d0oooo:0000?lE003o09H0oooo00130?ooo`030000003oool0oooo0540oooo>`3o
002n0?ooobL0003o5@00o`2G0?ooo`00@`3oool00`000000oooo0?ooo`1A0?oooc/0o`00_`3ooolV
0000oaD00?l0U`3oool004<0oooo00<000000?ooo`3oool0DP3oooli0?l00<40oooo9@000?lD003o
09P0oooo00130?ooo`030000003oool0oooo0580oooo>@3o00310?ooobD0003o5000o`2H0?ooo`00
@`3oool00`000000oooo0?ooo`1C0?ooocL0o`00``3ooolT0000oa<00?l0V@3oool004<0oooo00<0
00000?ooo`3oool0E03ooole0?l00<@0oooo90000?lC003o09T0oooo00130?ooo`030000003oool0
oooo05@0oooo=@3o00350?ooob80003o4`00o`2J0?ooo`00@`3oool00`000000oooo0?ooo`1E0?oo
oc<0o`00aP3ooolR0000oa800?l0V`3oool004<0oooo00<000000?ooo`3oool0E@3ooolc0?l00<L0
oooo8@000?lB003o09/0oooo00130?ooo`030000003oool0oooo05H0oooo<@3o00390?ooob00003o
4@00o`2L0?ooo`00@`3oool00`000000oooo0?ooo`1F0?oooc40o`00b@3ooolP0000oa400?l0W03o
ool004<0oooo00<000000?ooo`3oool0E`3oool_0?l00</0oooo7`000?l@003o09d0oooo00130?oo
o`030000003oool0oooo05P0oooo;@3o003<0?oooah0003o4@00o`2M0?ooo`00@`3oool00`000000
oooo0?ooo`1H0?ooobd0o`00c@3ooolM0000oa000?l0WP3oool004<0oooo00<000000?ooo`3oool0
F@3oool[0?l00<l0oooo70000?l?003o09l0oooo00130?ooo`030000003oool0oooo05T0oooo:`3o
003?0?oooa`0003o3`00o`2O0?ooo`00@`3oool00`000000oooo0?ooo`1J0?ooobT0o`00d@3ooolK
0000o`h00?l0X03oool004<0oooo00<000000?ooo`3oool0FP3ooolY0?l00=40oooo6`000?l>003o
0:00oooo00130?ooo`030000003oool0oooo05/0oooo9`3o003C0?oooaT0003o3P00o`2Q0?ooo`00
@`3oool00`000000oooo0?ooo`1L0?ooobD0o`00e03ooolI0000o`h00?l0X@3oool004<0oooo00<0
00000?ooo`3oool0G03ooolU0?l00=D0oooo60000?l=003o0:80oooo00130?ooo`030000003oool0
oooo05d0oooo8`3o003G0?oooaL0003o3000o`2S0?ooo`00@`3oool00`000000oooo0?ooo`1M0?oo
ob<0o`00e`3ooolG0000o``00?l0X`3oool004<0oooo00<000000?ooo`3oool0GP3ooolQ0?l00=T0
oooo5P000?l;003o0:@0oooo00130?ooo`030000003oool0oooo05h0oooo8@3o003I0?oooaD0003o
3000o`2T0?ooo`00@`3oool00`000000oooo0?ooo`1O0?oooal0o`00f`3ooolD0000o`/00?l0Y@3o
ool004<0oooo00<000000?ooo`3oool0H03ooolM0?l00=`0oooo50000?l:003o0:H0oooo00130?oo
o`030000003oool0oooo0600oooo7@3o003M0?oooa<0003o2P00o`2V0?ooo`00@`3oool00`000000
oooo0?ooo`1Q0?oooa/0o`00g`3ooolB0000o`T00?l0Y`3oool004<0oooo00<000000?ooo`3oool0
H@3ooolK0?l00=l0oooo4@000?l:003o0:L0oooo00130?ooo`030000003oool0oooo0680oooo6@3o
003Q0?oooa00003o2@00o`2X0?ooo`00@`3oool00`000000oooo0?ooo`1R0?oooaT0o`00h@3oool@
0000o`T00?l0Z03oool004<0oooo00<000000?ooo`3oool0H`3ooolG0?l00><0oooo3`000?l8003o
0:T0oooo00130?ooo`030000003oool0oooo06@0oooo5@3o003U0?ooo`h0003o1`00o`2Z0?ooo`00
@`3oool00`000000oooo0?ooo`1T0?oooaD0o`00i@3oool>0000o`L00?l0ZP3oool004<0oooo00<0
00000?ooo`3oool0I@3ooolC0?l00>L0oooo30000?l7003o0:/0oooo00130?ooo`030000003oool0
oooo06D0oooo4`3o003W0?ooo``0003o1`00o`2[0?ooo`00@`3oool00`000000oooo0?ooo`1V0?oo
oa40o`00j@3oool;0000o`H00?l0[03oool004<0oooo00<000000?ooo`3oool0IP3ooolA0?l00>T0
oooo2`000?l6003o0:`0oooo00130?ooo`030000003oool0oooo06L0oooo3`3o003[0?ooo`X0003o
1@00o`2]0?ooo`00@`3oool00`000000oooo0?ooo`1X0?ooo`d0o`00k@3oool90000o`@00?l0[P3o
ool004<0oooo00<000000?ooo`3oool0J03oool=0?l00>d0oooo20000?l5003o0:h0oooo00130?oo
o`030000003oool0oooo06T0oooo2`3o003_0?ooo`L0003o1000o`2_0?ooo`00@`3oool00`000000
oooo0?ooo`1Y0?ooo`/0o`00k`3oool70000o`@00?l0[`3oool004<0oooo00<000000?ooo`3oool0
JP3oool90?l00?40oooo1P000?l3003o0;00oooo00130?ooo`030000003oool0oooo06X0oooo2@3o
003a0?ooo`H0003o0`00o`2`0?ooo`00@`3oool00`000000oooo0?ooo`1[0?ooo`L0o`00l`3oool5
0000o`800?l0/@3oool004<0oooo00<000000?ooo`3oool0K03oool50?l00?D0oooo0`000?l2003o
0;80oooo00130?ooo`030000003oool0oooo06`0oooo1@3o003e0?ooo`<0003o0P00o`2b0?ooo`00
@`3oool00`000000oooo0?ooo`1]0?ooo`<0o`00m`3oool20000o`03003o003oool0oooo0;40oooo
00130?ooo`030000003oool0oooo06d0oooo0`3o003g0?ooo`80003o00<00?l00?ooo`3oool0/@3o
ool004<0oooo00<000000?ooo`3oool0KP3oool00`3o0000oooo0?ooo`3g0?ooo`030000o`3oool0
oooo0;80oooo00130?ooo`030000003oool0oooo0?l0ooooo`3ooolO0?ooo`00@`3oool00`000000
oooo0?ooo`3o0?ooool0oooo7`3oool004<0oooo00<000000?ooo`3oool0o`3ooooo0?oooal0oooo
00130?ooo`030000003oool0oooo0?l0ooooo`3ooolO0?ooo`00@`3oool00`000000oooo0?ooo`3o
0?ooool0oooo7`3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0oooo
I@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00]03oool3000001/0oooo0`00000E0?ooo`<000005P3oool2000001/0oooo0`00000Q0?oo
o`<000008@3oool300000240oooo0`00000L0?ooo`800000]P3oool00;H0oooo00<000000?ooo`3o
ool06`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01<0oooo00@000000?ooo`3o
ool00000703oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?oo
o`3oool08@3oool00`000000oooo0?ooo`0I0?ooo`040000003oool0oooo00000;D0oooo002e0?oo
o`<000006`3oool3000001D0oooo0`00000F0?ooo`030000003oool0oooo01X0oooo0`00000Q0?oo
o`<000008@3oool300000240oooo0`00000L0?ooo`030000003oool0oooo0;@0oooo002d0?ooo`04
0000003oool0oooo000001X0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00
000G0?ooo`030000003oool0oooo01P0oooo00@000000?ooo`3oool00000803oool010000000oooo
0?ooo`00000P0?ooo`040000003oool0oooo00000200oooo00@000000?ooo`3oool000007@3oool0
0`000000oooo0?ooo`2c0?ooo`00]03oool010000000oooo0?ooo`00000J0?ooo`040000003oool0
oooo000001@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?ooo`00000J0?ooo`04
0000003oool0oooo00000200oooo00@000000?ooo`3oool00000803oool010000000oooo0?ooo`00
000P0?ooo`040000003oool0oooo000001X0oooo00@000000?ooo`3oool00000]@3oool00;D0oooo
0`00000K0?ooo`<000005@3oool3000001D0oooo0P00000L0?ooo`<000008@3oool300000240oooo
0`00000Q0?ooo`<000006`3oool200000;H0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU
0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0ooooo`3ooomU0?ooo`00o`3o
oooo0?ooofD0oooo002[0?ooo`030000003oool0oooo0?l0oooo2@3oool00`000000oooo0?ooo`2Z
0?ooo`00ZP3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo01D0oooo00<000000?oo
o`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?oo
o`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?oo
o`3oool05@3oool00`000000oooo0?ooo`2Y0?ooo`00ZP3oool00`000000oooo0?ooo`0J0?ooo`03
0000003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`03
0000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`03
0000003oool0oooo0240oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`2Y0?ooo`00
ZP3oool010000000oooo0?ooo`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0
oooo00<000000?ooo`3oool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0
oooo100000020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0
oooo00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0
oooo00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0
oooo00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0
oooo00<000000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0
oooo00<000000?ooo`3oool01`3oool400000080oooo100000030?ooo`030000003oool0oooo0:T0
oooo002Y0?ooo`030000003oool0oooo0?l0oooo3@3oool00`000000oooo0?ooo`2X0?ooo`00ZP3o
ool00`000000oooo0?ooo`3o0?ooo`/0oooo00<000000?ooo`3oool0Z@3oool00:X0oooo00<00000
0?ooo`3oool0o`3oool;0?ooo`030000003oool0oooo0:T0oooo002[0?ooo`030000003oool0oooo
0?l0oooo2@3oool00`000000oooo0?ooo`2Z0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0oooo
I@3oool00?l0ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00?l0
ooooo`3ooomU0?ooo`00o`3ooooo0?ooofD0oooo002`0?ooo`030000003oool0oooo00H0oooo0`00
00050?ooo`<000003@3oool3000000D0oooo0`00000=0?ooo`<000001@3oool3000000d0oooo0`00
00050?ooo`<000003P3oool4000000L0oooo0`0000050?ooo`<00000403oool3000000H0oooo0`00
00050?ooo`<00000403oool3000000H0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`00
00050?ooo`<000003@3oool3000000D0oooo0`00002_0?ooo`00/03oool00`000000oooo0?ooo`07
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo0:h0oooo002`0?ooo`030000003oool0oooo00L0oooo0`0000050?oo
o`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?oo
o`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo00h0oooo00<000000?oo
o`3oool0203oool3000000D0oooo00<000000?ooo`3oool03@3oool5000000L0oooo0`0000050?oo
o`030000003oool0oooo00d0oooo1@0000070?ooo`<000001@3oool00`000000oooo0?ooo`0>0?oo
o`030000003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo00d0oooo0`0000050?oo
o`030000003oool0oooo0:h0oooo002a0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3o
ool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool2000000l0oooo00@00000
0?ooo`3oool000000`3oool2000000l0oooo00@000000?ooo`3oool000000`3oool200000140oooo
00<000000?ooo`3oool01`3oool010000000oooo0?ooo`0000030?ooo`8000003`3oool010000000
oooo0?ooo`0000080?ooo`040000003oool0oooo000000<0oooo0P00000?0?ooo`040000003oool0
oooo000000P0oooo00@000000?ooo`3oool000000`3oool200000140oooo00<000000?ooo`3oool0
1`3oool010000000oooo0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000030?oo
o`800000/03oool00:h0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00000D
0?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000503oool010000000oooo
0?ooo`00000D0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000005@3oool0
0`000000oooo000000080?ooo`040000003oool0oooo000001D0oooo00<000000?ooo`000000203o
ool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3o
ool00000503oool010000000oooo0?ooo`00002e0?ooo`00[P3oool4000000L0oooo100000050?oo
o`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00`0oooo100000050?oo
o`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?oo
o`@000001@3oool00`000000oooo0?ooo`0?0?ooo`8000001`3oool4000000D0oooo00<000000?oo
o`3oool03`3oool2000000L0oooo100000050?ooo`030000003oool0oooo00h0oooo0P0000080?oo
o`@000001@3oool00`000000oooo0?ooo`0<0?ooo`@000001@3oool00`000000oooo0?ooo`2^0?oo
o`00o`3ooooo0?ooofD0oooo003o0?ooool0ooooI@3oool00001\
\>"],
  ImageRangeCache->{{{0, 610.813}, {251.313, 0}} -> {-0.28201, -0.0206241, \
0.00419772, 0.00419772}, {{67.125, 294.063}, {246.375, 49.875}} -> {-2.7315, \
-0.0626713, 0.0126904, 0.0126904}, {{316.75, 543.625}, {246.375, 49.875}} -> \
{-5.89948, -0.0628009, 0.0126916, 0.0126916}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .46425 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0110536 0.47619 [
[.5 .47675 -152 0 ]
[.5 .47675 152 38.75 ]
[ 0 0 0 0 ]
[ 1 .46425 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
0 .01105 m
1 .01105 L
s
.02381 0 m
.02381 .46425 L
s
gsave
.5 .47675 -213 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 46.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 12.750 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
81.000 12.750 moveto
(Pi) show
105.000 12.750 moveto
(Pi) show
129.000 12.750 moveto
(3) show
141.000 12.750 moveto
(Pi) show
165.000 12.750 moveto
(2) show
177.000 12.750 moveto
(Pi) show
201.000 12.750 moveto
(4) show
213.000 12.750 moveto
(Pi) show
237.000 12.750 moveto
(Pi) show
261.000 12.750 moveto
(3) show
273.000 12.750 moveto
(Pi) show
297.000 12.750 moveto
(2) show
309.000 12.750 moveto
(Pi) show
333.000 12.750 moveto
(2) show
345.000 12.750 moveto
(Pi) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
63.000 25.875 moveto
(8) show
69.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
81.000 25.875 moveto
(--) show
93.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
105.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
117.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
129.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
141.000 25.875 moveto
(--) show
153.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
165.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
177.000 25.875 moveto
(--) show
189.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
201.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
213.000 25.875 moveto
(--) show
225.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
237.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
249.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
261.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
273.000 25.875 moveto
(--) show
285.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
297.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
309.000 25.875 moveto
(--) show
321.000 25.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
333.000 25.875 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(--) show
345.000 25.875 moveto
(--) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
357.000 25.875 moveto
(<) show
75.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
105.000 39.000 moveto
(7) show
135.000 39.000 moveto
(7) show
171.000 39.000 moveto
(7) show
207.000 39.000 moveto
(7) show
237.000 39.000 moveto
(7) show
267.000 39.000 moveto
(7) show
303.000 39.000 moveto
(7) show
339.000 39.000 moveto
(7) show
345.000 39.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .46425 L
0 .46425 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0110536 0.477324 0.453198 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.445042 0.554958 -2.33103e-017 0.554958 [
[ 0 0 0 0 ]
[ 1 .97493 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .97493 L
0 .97493 L
closepath
clip
newpath
0 1 0 r
0 0 m
.80194 0 L
.72252 .34795 L
F
0 0 1 r
.80194 0 m
1 0 L
.72252 .34795 L
F
1 0 0 r
0 0 m
.72252 .34795 L
.22252 .97493 L
F
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.522676 0.0110536 0.97619 0.453198 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.445042 0.554958 -9.78492e-018 0.554958 [
[ 0 0 0 0 ]
[ 1 .97493 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .97493 L
0 .97493 L
closepath
clip
newpath
0 1 0 r
.22252 .97493 m
0 0 L
.44504 0 L
F
0 0 1 r
.44504 0 m
.72252 .34795 L
.22252 .97493 L
F
1 0 0 r
.44504 0 m
1 0 L
.72252 .34795 L
F
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{612, 284.063},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009T000172000`400?l00000o`00003o?@3oool0
0`000000oooo0?ooo`3o0?ooool0oooo9P3oool003d0oooo00<000000?ooo`3oool0o`3ooooo0?oo
obH0oooo000m0?ooo`030000003oool0oooo0?l0ooooo`3ooolV0?ooo`00?@3oool00`000000oooo
0?ooo`3o0?ooool0oooo9P3oool003d0oooo00<000000?ooo`3oool0o`3ooooo0?ooobH0oooo000m
0?ooo`030000003oool0oooo0?l0ooooo`3ooolV0?ooo`00<@3ooooo00000?l000000`00000b0?oo
o`00?@3oool00`000000o`000?l0002g003o02h0003o6@3ooomV003o00030000o`3o0000o`0007h0
o`00?`3oool003d0oooo00<000000?l0003o00000P3o002e003o02d0003o6P3ooomV003o0080003o
OP3o00100?ooo`00?@3oool00`000000o`000?l000040?l00;<00?l0;0000?lK0?ooofH00?l00`00
0?ml0?l00440oooo000m0?ooo`030000003o0000o`0000H0o`00/@00o`0[0000oa`0ooooIP00o`04
0000ogX0o`00@P3oool003d0oooo00<000000?ooo`3o0000203o002^003o02`0003o7@3ooomT003o
00D0003oN@3o00130?ooo`00?@3oool00`000000oooo0?l0000:0?l00:`00?l0:`000?lN0?ooof@0
0?l01P000?mh0?l004<0oooo000m0?ooo`030000003oool0o`0000`0o`00ZP00o`0Z0000oal0oooo
I000o`070000ogH0o`00A03oool003d0oooo00<000000?ooo`3o00003P3o002X003o02T0003o803o
oomT003o00P0003oM03o00150?ooo`00?@3oool00`000000oooo0?ooo`0@0?l00:D00?l0:@000?lR
0?ooof800?l02P000?mb0?l004H0oooo000m0?ooo`030000003oool0oooo0180o`00X`00o`0Y0000
ob80ooooHP00o`0:0000og40o`00A`3oool003d0oooo00<000000?ooo`3oool0503o002Q003o02P0
003o8`3ooomR003o00/0003oL03o00170?ooo`00?@3oool00`000000oooo0?ooo`0F0?l009l00?l0
9`000?lT0?ooof800?l030000?m^0?l004P0oooo000m0?ooo`030000003oool0oooo01P0o`00W@00
o`0V0000obD0ooooHP00o`0=0000of`0o`00B@3oool003d0oooo00@000000?ooo`3oool0oooo6P3o
002I003o02H0003o9`3ooomP003o00l0003oJP3o001:0?ooo`00?@3oool010000000oooo0?ooo`3o
oolL0?l009L00?l09P000?lW0?ooof000?l03`000?mY0?l004/0oooo000m0?ooo`040000003oool0
oooo0?oooah0o`00U@00o`0U0000obP0ooooH000o`0@0000ofP0o`00B`3oool003d0oooo00@00000
0?ooo`3oool0oooo803o002C003o02@0003o:@3ooomP003o0140003oIP3o001<0?ooo`00?@3oool0
0`000000oooo0?ooo`020?ooob40o`00T000o`0T0000ob/0ooooGP00o`0C0000of@0o`00C@3oool0
03d0oooo00<000000?ooo`3oool00P3ooolS0?l008h00?l08`000?l/0?oooeh00?l050000?mR0?l0
04h0oooo000m0?ooo`030000003oool0oooo0080oooo9@3o002<003o02<0003o;03ooomN003o01@0
003oH@3o001?0?ooo`00?@3oool00`000000oooo0?ooo`020?ooobL0o`00RP00o`0R0000obd0oooo
GP00o`0E0000of00o`00C`3oool003d0oooo00<000000?ooo`3oool00`3ooolX0?l008P00?l08@00
0?l^0?oooed00?l05`000?mN0?l00500oooo000m0?ooo`030000003oool0oooo00<0oooo:P3o0025
003o0240003o<03ooomL003o01P0003oG03o001A0?ooo`00?@3oool00`000000oooo0?ooo`030?oo
ob`0o`00P`00o`0Q0000oc00ooooG000o`0H0000oe/0o`00DP3oool003d0oooo00<000000?ooo`3o
ool00`3oool^0?l008400?l080000?la0?oooe`00?l06@000?mI0?l005<0oooo000m0?ooo`030000
003oool0oooo00<0oooo<03o001o003o01l0003o<P3ooomL003o01X0003oF03o001C0?ooo`00?@3o
ool00`000000oooo0?ooo`040?oooc40o`00O000o`0O0000oc@0ooooFP00o`0L0000oeH0o`00E03o
ool003d0oooo00<000000?ooo`3oool0103ooold0?l007T00?l07P000?le0?oooeX00?l07@000?mD
0?l005D0oooo000m0?ooo`030000003oool0oooo00@0oooo=P3o001g003o01h0003o=@3ooomJ003o
01d0003oD`3o001F0?ooo`00?@3oool00`000000oooo0?ooo`040?ooocP0o`00M@00o`0M0000ocH0
ooooFP00o`0N0000oe40o`00E`3oool003d0oooo00<000000?ooo`3oool01@3oooli0?l007<00?l0
70000?lg0?oooeT00?l080000?m@0?l005L0oooo000m0?ooo`030000003oool0oooo00D0oooo>`3o
001`003o01`0003o>@3ooomH003o0240003oCP3o001H0?ooo`00?@3oool00`000000oooo0?ooo`05
0?ooocd0o`00KP00o`0K0000ocX0ooooF000o`0R0000od`0o`00F@3oool003d0oooo00<000000?oo
o`3oool01@3ooolo0?l006`00?l06`000?lj0?oooeP00?l08P000?m;0?l005X0oooo000m0?ooo`03
0000003oool0oooo00H0oooo@03o001Z003o01X0003o>`3ooomG003o02@0003oB@3o001K0?ooo`00
?@3oool00`000000oooo0?ooo`060?oood80o`00I`00o`0J0000ocd0ooooEP00o`0U0000odP0o`00
F`3oool003d0oooo00<000000?ooo`3oool01P3ooom40?l006D00?l06@000?ln0?oooeH00?l09P00
0?m60?l005`0oooo000m0?ooo`030000003oool0oooo00H0ooooAP3o001S003o01P0003o?`3ooomF
003o02L0003oA03o001M0?ooo`00?@3oool00`000000oooo0?ooo`060?ooodP0o`00H@00o`0H0000
ocl0ooooEP00o`0W0000od<0o`00GP3oool003d0oooo00<000000?ooo`3oool01`3ooom90?l005l0
0?l05`000?m00?oooeD00?l0:@000?m10?l005l0oooo000m0?ooo`030000003oool0oooo00L0oooo
C03o001K003o01L0003o@P3ooomD003o02X0003o@03o001O0?ooo`00?@3oool00`000000oooo0?oo
o`070?ooodh0o`00F@00o`0F0000od<0ooooE000o`0[0000och0o`00H03oool003d0oooo00<00000
0?ooo`3oool01`3ooom@0?l005L00?l05P000?m30?oooe@00?l0:`000?lm0?l00640oooo000m0?oo
o`030000003oool0oooo00P0ooooD@3o001E003o01D0003oA03ooomC003o02d0003o>`3o001R0?oo
o`00?@3oool00`000000oooo0?ooo`080?oooe<0o`00DP00o`0E0000odH0ooooDP00o`0^0000ocT0
o`00H`3oool003d0oooo00<000000?ooo`3oool0203ooomE0?l005000?l050000?m70?oooe800?l0
;`000?lh0?l006<0oooo000m0?ooo`030000003oool0oooo00P0ooooE`3o001>003o01<0003oB03o
oomB003o0300003o=P3o001T0?ooo`00?@3oool00`000000oooo0?ooo`080?oooeT0o`00C000o`0C
0000odP0ooooDP00o`0`0000ocD0o`00I@3oool003d0oooo00<000000?ooo`3oool02@3ooomJ0?l0
04X00?l04P000?m:0?oooe000?l0<P000?lc0?l006H0oooo000m0?ooo`030000003oool0oooo00T0
ooooG03o0017003o0180003oB`3ooom@003o03<0003o<@3o001W0?ooo`00?@3oool00`000000oooo
0?ooo`090?oooeh0o`00A@00o`0A0000od`0ooooD000o`0d0000oc00o`00I`3oool003d0oooo00<0
00000?ooo`3oool02@3ooomP0?l004<00?l040000?m=0?oooe000?l0=@000?l^0?l006P0oooo000m
0?ooo`030000003oool0oooo00X0ooooH@3o0011003o0100003oC@3ooom?003o03H0003o;@3o001Y
0?ooo`00?@3oool00`000000oooo0?ooo`0:0?ooof<0o`00?P00o`0@0000odl0ooooCP00o`0g0000
ob/0o`00JP3oool003d0oooo00<000000?ooo`3oool02P3ooomV0?l003/00?l03`000?m@0?ooodh0
0?l0>0000?lY0?l006/0oooo000m0?ooo`030000003oool0oooo00X0ooooJ03o000i003o00h0003o
D@3ooom>003o03T0003o:03o001[0?ooo`00?@3oool00`000000oooo0?ooo`0;0?ooofT0o`00=`00
o`0=0000oe80ooooC@00o`0k0000obH0o`00K03oool003d0oooo00<000000?ooo`3oool02`3ooom[
0?l003D00?l03@000?mC0?oood`00?l0>`000?lU0?l006d0oooo000m0?ooo`030000003oool0oooo
00/0ooooK@3o000b003o00d0003oE03ooom<003o03`0003o8`3o001^0?ooo`00?@3oool00`000000
oooo0?ooo`0;0?ooofl0o`00<000o`0<0000oeD0ooooC000o`0m0000ob40o`00K`3oool003d0oooo
00<000000?ooo`3oool02`3oooma0?l002h00?l02`000?mF0?oood`00?l0?P000?lP0?l006l0oooo
000m0?ooo`030000003oool0oooo00`0ooooLP3o000/003o00/0003oEP3ooom;003o03l0003o7`3o
001`0?ooo`00?@3oool00`000000oooo0?ooo`0<0?ooog@0o`00:@00o`0;0000oeP0ooooBP00o`10
0000oad0o`00L@3oool003d0oooo00<000000?ooo`3oool0303ooomf0?l002L00?l02P000?mI0?oo
odX00?l0@@000?lK0?l00780oooo000m0?ooo`030000003oool0oooo00`0ooooN03o000U003o00T0
003oFP3ooom:003o0480003o6@3o001c0?ooo`00?@3oool00`000000oooo0?ooo`0=0?ooogT0o`00
8`00o`080000oe/0ooooB@00o`140000oaP0o`00L`3oool003d0oooo00<000000?ooo`3oool03@3o
oomk0?l002400?l020000?mL0?ooodP00?l0A0000?lG0?l007@0oooo000m0?ooo`030000003oool0
oooo00d0ooooOP3o000M003o00P0003oG@3ooom8003o04D0003o5@3o001e0?ooo`00?@3oool00`00
0000oooo0?ooo`0=0?oooh00o`006`00o`070000oeh0ooooB000o`160000oa<0o`00MP3oool003d0
oooo00<000000?ooo`3oool03P3ooon10?l001T00?l01P000?mO0?ooodL00?l0B0000?lA0?l007L0
oooo000m0?ooo`030000003oool0oooo00h0ooooP`3o000G003o00D0003oH03ooom7003o04T0003o
403o001g0?ooo`00?@3oool00`000000oooo0?ooo`0>0?ooohD0o`005000o`060000of40ooooAP00
o`190000o`l0o`00N03oool003d0oooo00<000000?ooo`3oool03P3ooon70?l001800?l01@000?mR
0?ooodH00?l0BP000?l=0?l007T0oooo000m0?ooo`030000003oool0oooo00h0ooooR@3o000@003o
00@0003oH`3ooom6003o04/0003o2`3o001j0?ooo`00?@3oool00`000000oooo0?ooo`0?0?ooohX0
o`003P00o`030000of@0ooooA@00o`1=0000o`T0o`00N`3oool003d0oooo00<000000?ooo`3oool0
3`3ooon<0?l000`00?l00P000?mV0?oood@00?l0CP000?l80?l007/0oooo000m0?ooo`030000003o
ool0oooo00l0ooooSP3o0009003o00<0003oIP3ooom4003o04h0003o1`3o001l0?ooo`00?@3oool0
0`000000oooo0?ooo`0?0?oooi00o`001`00o`020000ofL0ooooA000o`1?0000o`D0o`00O@3oool0
03d0oooo00<000000?ooo`3oool0403ooonA0?l000D00?l000<0003o0?ooo`3oool0IP3ooom3003o
0540003o0`3o001n0?ooo`00?@3oool00`000000oooo0?ooo`0@0?oooi<0o`000`00o`1Y0?oood<0
0?l0DP000?l00`3o0000oooo0?ooo`1m0?ooo`00?@3oool00`000000oooo0?ooo`0@0?oooiD0o`00
J`3ooom2003o0580003oP03oool003d0oooo00<000000?ooo`3oool0403ooonE0?l006/0oooo@P00
o`1B0000oh00oooo000m0?ooo`030000003oool0oooo0140ooooT`3o001/0?oood400?l0DP000?n1
0?ooo`00?@3oool00`000000oooo0?ooo`0A0?oooi80o`00K@3ooom1003o0540003oPP3oool003d0
oooo00<000000?ooo`3oool04@3ooonA0?l006l0oooo@000o`1@0000oh<0oooo000m0?ooo`030000
003oool0oooo0140ooooT@3o001_0?oood000?l0D0000?n30?ooo`00?@3oool00`000000oooo0?oo
o`0A0?oooi00o`00L03ooom0003o04l0003oQ03oool003d0oooo00<000000?ooo`3oool04P3ooon>
0?l00740oooo?`00o`1?0000ohD0oooo000m0?ooo`030000003oool0oooo0180ooooS@3o001b0?oo
ocl00?l0CP000?n60?ooo`00?@3oool00`000000oooo0?ooo`0B0?oooh`0o`00M03oooln003o04d0
003oQ`3oool003d0oooo00<000000?ooo`3oool04P3ooon<0?l007@0oooo?P00o`1=0000ohL0oooo
000m0?ooo`030000003oool0oooo01<0ooooRP3o001e0?ooocd00?l0C@000?n80?ooo`00?@3oool0
0`000000oooo0?ooo`0C0?ooohT0o`00MP3ooolm003o04`0003oR@3oool003d0oooo00<000000?oo
o`3oool04`3ooon80?l007P0oooo?000o`1;0000ohX0oooo000m0?ooo`030000003oool0oooo01<0
ooooQ`3o001i0?oooc`00?l0BP000?n;0?ooo`00?@3oool00`000000oooo0?ooo`0C0?ooohL0o`00
N@3oooll003o04X0003oR`3oool003d0oooo00<000000?ooo`3oool0503ooon50?l007X0oooo>`00
o`1:0000oh`0oooo000m0?ooo`030000003oool0oooo01@0ooooQ03o001l0?ooocX00?l0B@000?n=
0?ooo`00?@3oool00`000000oooo0?ooo`0D0?oooh<0o`00O@3ooolj003o04P0003oSP3oool003d0
oooo00<000000?ooo`3oool0503ooon20?l007h0oooo>P00o`170000ohl0oooo000m0?ooo`030000
003oool0oooo01D0ooooP@3o001n0?ooocT00?l0B0000?n?0?ooo`00?@3oool00`000000oooo0?oo
o`0E0?oooh00o`00O`3oooli003o04L0003oT03oool003d0oooo00<000000?ooo`3oool05@3ooomo
0?l00840oooo>000o`160000oi40oooo000m0?ooo`030000003oool0oooo01D0ooooOP3o00220?oo
ocP00?l0A@000?nB0?ooo`00?@3oool00`000000oooo0?ooo`0F0?ooog`0o`00P`3ooolg003o04D0
003oT`3oool003d0oooo00<000000?ooo`3oool05P3oooml0?l008<0oooo=`00o`150000oi<0oooo
000m0?ooo`030000003oool0oooo01H0ooooN`3o00250?ooocH00?l0A0000?nD0?ooo`00?@3oool0
0`000000oooo0?ooo`0F0?ooogX0o`00QP3ooolf003o04<0003oU@3oool003d0oooo00<000000?oo
o`3oool05P3ooomi0?l008L0oooo=P00o`120000oiH0oooo000m0?ooo`030000003oool0oooo01L0
ooooM`3o00280?ooocD00?l0@P000?nG0?ooo`00?@3oool00`000000oooo0?ooo`0G0?ooogL0o`00
R03ooole003o0480003oU`3oool003d0oooo00<000000?ooo`3oool05`3ooomf0?l008X0oooo=000
o`110000oiP0oooo000m0?ooo`030000003oool0oooo01L0ooooM@3o002;0?oooc@00?l0@0000?nI
0?ooo`00?@3oool00`000000oooo0?ooo`0H0?ooog<0o`00S03ooolc003o0400003oVP3oool003d0
oooo00<000000?ooo`3oool0603ooomb0?l008d0oooo<`00o`0o0000oi/0oooo000m0?ooo`030000
003oool0oooo01P0ooooLP3o002>0?oooc800?l0?`000?nK0?ooo`00?@3oool00`000000oooo0?oo
o`0H0?ooog40o`00S`3ooolb003o03h0003oW03oool003d0oooo00<000000?ooo`3oool06@3ooom_
0?l00900oooo<@00o`0n0000oid0oooo000m0?ooo`030000003oool0oooo01T0ooooKP3o002A0?oo
oc400?l0?@000?nN0?ooo`00?@3oool00`000000oooo0?ooo`0I0?ooofh0o`00T@3ooola003o03d0
003oWP3oool003d0oooo00<000000?ooo`3oool06@3ooom]0?l009<0oooo<000o`0l0000oil0oooo
000m0?ooo`030000003oool0oooo01T0ooooK03o002D0?oooc000?l0>`000?nP0?ooo`00?@3oool0
0`000000oooo0?ooo`0J0?ooofX0o`00U@3oool_003o03/0003oX@3oool003d0oooo00<000000?oo
o`3oool06P3ooomY0?l009H0oooo;`00o`0j0000oj80oooo000m0?ooo`030000003oool0oooo01X0
ooooJ@3o002G0?ooobh00?l0>P000?nR0?ooo`00?@3oool00`000000oooo0?ooo`0J0?ooofP0o`00
V03oool^003o03T0003oX`3oool003d0oooo00<000000?ooo`3oool06`3ooomV0?l009T0oooo;@00
o`0i0000oj@0oooo000m0?ooo`030000003oool0oooo01/0ooooI@3o002J0?ooobd00?l0>0000?nU
0?ooo`00?@3oool00`000000oooo0?ooo`0K0?ooof@0o`00V`3oool]003o03L0003oYP3oool003d0
oooo00<000000?ooo`3oool06`3ooomT0?l009`0oooo;000o`0g0000ojH0oooo000m0?ooo`030000
003oool0oooo01`0ooooHP3o002M0?ooob/00?l0=`000?nW0?ooo`00?@3oool00`000000oooo0?oo
o`0L0?ooof40o`00WP3oool[003o03H0003oZ03oool003d0oooo00<000000?ooo`3oool0703ooomP
0?l009l0oooo:`00o`0e0000ojT0oooo000m0?ooo`030000003oool0oooo01`0ooooG`3o002Q0?oo
obX00?l0=0000?nZ0?ooo`00?@3oool00`000000oooo0?ooo`0L0?oooel0o`00X@3ooolZ003o03@0
003oZP3oool003d0oooo00<000000?ooo`3oool07@3ooomM0?l00:80oooo:@00o`0d0000oj/0oooo
000m0?ooo`030000003oool0oooo01d0ooooG03o002S0?ooobT00?l0<`000?n/0?ooo`00?@3oool0
0`000000oooo0?ooo`0M0?oooe/0o`00Y@3ooolX003o0380003o[@3oool003d0oooo00<000000?oo
o`3oool07@3ooomJ0?l00:H0oooo:000o`0a0000ojh0oooo000m0?ooo`030000003oool0oooo01h0
ooooF@3o002V0?ooobL00?l0<P000?n^0?ooo`00?@3oool00`000000oooo0?ooo`0N0?oooeP0o`00
Y`3ooolW003o0340003o[`3oool003d0oooo00<000000?ooo`3oool07P3ooomG0?l00:P0oooo9`00
o`0`0000ok00oooo000m0?ooo`030000003oool0oooo01h0ooooEP3o002Z0?ooobH00?l0;`000?na
0?ooo`00?@3oool00`000000oooo0?ooo`0N0?oooeD0o`00Z`3ooolV003o02h0003o/P3oool003d0
oooo00<000000?ooo`3oool07`3ooomD0?l00:/0oooo9@00o`0_0000ok80oooo000m0?ooo`030000
003oool0oooo01l0ooooD`3o002/0?ooobD00?l0;P000?nc0?ooo`00?@3oool00`000000oooo0?oo
o`0O0?oooe80o`00[P3ooolT003o02d0003o]03oool003d0oooo00<000000?ooo`3oool07`3ooomA
0?l00:l0oooo9000o`0/0000okD0oooo000m0?ooo`030000003oool0oooo0200ooooC`3o002`0?oo
ob<00?l0;0000?nf0?ooo`00?@3oool00`000000oooo0?ooo`0P0?ooodl0o`00/03ooolS003o02`0
003o]P3oool003d0oooo00<000000?ooo`3oool0803ooom>0?l00;40oooo8`00o`0[0000okL0oooo
000m0?ooo`030000003oool0oooo0200ooooC@3o002c0?ooob800?l0:P000?nh0?ooo`00?@3oool0
0`000000oooo0?ooo`0Q0?oood/0o`00]03ooolQ003o02X0003o^@3oool003d0oooo00<000000?oo
o`3oool08@3ooom:0?l00;D0oooo8@00o`0Y0000okX0oooo000m0?ooo`030000003oool0oooo0240
ooooBP3o002e0?ooob400?l0:@000?nj0?ooo`00?@3oool00`000000oooo0?ooo`0Q0?ooodT0o`00
]`3ooolP003o02P0003o^`3oool003d0oooo00<000000?ooo`3oool08@3ooom80?l00;P0oooo8000
o`0W0000ok`0oooo000m0?ooo`030000003oool0oooo0280ooooAP3o002i0?oooal00?l09`000?nm
0?ooo`00?@3oool00`000000oooo0?ooo`0R0?ooodH0o`00^@3ooolO003o02L0003o_@3oool003d0
oooo00<000000?ooo`3oool08P3ooom50?l00;X0oooo7`00o`0V0000okh0oooo000m0?ooo`030000
003oool0oooo0280ooooA03o002l0?oooah00?l09@000?no0?ooo`00?@3oool00`000000oooo0?oo
o`0S0?oood80o`00_@3ooolM003o02D0003o`03oool003d0oooo00<000000?ooo`3oool08`3ooom1
0?l00;h0oooo7@00o`0T0000ol40oooo000m0?ooo`030000003oool0oooo02<0oooo@@3o002n0?oo
oad00?l090000?o10?ooo`00?@3oool00`000000oooo0?ooo`0S0?oood00o`00`03ooolL003o02<0
003o`P3oool003d0oooo00<000000?ooo`3oool0903oooln0?l00<40oooo6`00o`0S0000ol<0oooo
000m0?ooo`030000003oool0oooo02@0oooo?@3o00320?oooa/00?l08P000?o40?ooo`00?@3oool0
0`000000oooo0?ooo`0T0?oooc`0o`00``3ooolK003o0240003oa@3oool003d0oooo00<000000?oo
o`3oool0903oooll0?l00<<0oooo6`00o`0Q0000olD0oooo000m0?ooo`030000003oool0oooo02@0
oooo>`3o00350?oooaX00?l080000?o60?ooo`00?@3oool00`000000oooo0?ooo`0U0?ooocT0o`00
aP3ooolI003o0200003oa`3oool003d0oooo00<000000?ooo`3oool09@3ooolh0?l00<L0oooo6@00
o`0O0000olP0oooo000m0?ooo`030000003oool0oooo02D0oooo=`3o00380?oooaT00?l07P000?o9
0?ooo`00?@3oool00`000000oooo0?ooo`0U0?ooocL0o`00b@3ooolH003o01h0003ob@3oool003d0
oooo00<000000?ooo`3oool09P3ooole0?l00<X0oooo5`00o`0N0000olX0oooo000m0?ooo`030000
003oool0oooo02H0oooo=03o003;0?oooaL00?l07@000?o;0?ooo`00?@3oool00`000000oooo0?oo
o`0V0?oooc<0o`00c03ooolG003o01`0003oc03oool003d0oooo00<000000?ooo`3oool09P3ooolb
0?l00<d0oooo5`00o`0K0000old0oooo000m0?ooo`030000003oool0oooo02L0oooo<@3o003>0?oo
oaD00?l070000?o=0?ooo`00?@3oool00`000000oooo0?ooo`0W0?oooc00o`00c`3ooolE003o01/0
003ocP3oool003d0oooo00<000000?ooo`3oool09`3oool_0?l00=00oooo5@00o`0J0000oll0oooo
000m0?ooo`030000003oool0oooo02L0oooo;P3o003A0?oooaD00?l06@000?o@0?ooo`00?@3oool0
0`000000oooo0?ooo`0W0?ooobd0o`00d`3ooolD003o01P0003od@3oool003d0oooo00<000000?oo
o`3oool0:03oool/0?l00=<0oooo4`00o`0I0000om40oooo000m0?ooo`030000003oool0oooo02P0
oooo:`3o003D0?oooa<00?l060000?oB0?ooo`00?@3oool00`000000oooo0?ooo`0X0?ooobX0o`00
e@3ooolC003o01L0003od`3oool003d0oooo00<000000?ooo`3oool0:03ooolY0?l00=L0oooo4P00
o`0F0000om@0oooo000m0?ooo`030000003oool0oooo02T0oooo9`3o003H0?oooa400?l05P000?oE
0?ooo`00?@3oool00`000000oooo0?ooo`0Y0?ooobL0o`00f03ooolA003o01H0003oe@3oool003d0
oooo00<000000?ooo`3oool0:@3ooolV0?l00=T0oooo4@00o`0E0000omH0oooo000m0?ooo`030000
003oool0oooo02T0oooo9@3o003J0?oooa400?l050000?oG0?ooo`00?@3oool00`000000oooo0?oo
o`0Y0?ooob@0o`00g03oool@003o01<0003of03oool003d0oooo00<000000?ooo`3oool0:P3ooolS
0?l00=`0oooo3`00o`0D0000omP0oooo000m0?ooo`030000003oool0oooo02X0oooo8P3o003M0?oo
o`l00?l04`000?oI0?ooo`00?@3oool00`000000oooo0?ooo`0Z0?ooob40o`00gP3oool?003o0180
003ofP3oool003d0oooo00<000000?ooo`3oool0:P3ooolP0?l00>00oooo3P00o`0A0000om/0oooo
000m0?ooo`030000003oool0oooo02/0oooo7P3o003Q0?ooo`d00?l04@000?oL0?ooo`00?@3oool0
0`000000oooo0?ooo`0[0?oooah0o`00h@3oool=003o0140003og03oool003d0oooo00<000000?oo
o`3oool0:`3ooolM0?l00>80oooo3@00o`0@0000omd0oooo000m0?ooo`030000003oool0oooo02/0
oooo703o003S0?ooo`d00?l03`000?oN0?ooo`00?@3oool00`000000oooo0?ooo`0/0?oooaX0o`00
i@3oool;003o00l0003og`3oool003d0oooo00<000000?ooo`3oool0;03ooolI0?l00>H0oooo2`00
o`0>0000on00oooo000m0?ooo`030000003oool0oooo02`0oooo6@3o003V0?ooo`/00?l03P000?oP
0?ooo`00?@3oool00`000000oooo0?ooo`0/0?oooaP0o`00i`3oool;003o00d0003oh@3oool003d0
oooo00<000000?ooo`3oool0;03ooolG0?l00>T0oooo2P00o`0<0000on80oooo000m0?ooo`030000
003oool0oooo02d0oooo5@3o003Z0?ooo`T00?l030000?oS0?ooo`00?@3oool00`000000oooo0?oo
o`0]0?oooa@0o`00j`3oool9003o00/0003oi03oool003d0oooo00<000000?ooo`3oool0;@3ooolD
0?l00>/0oooo2@00o`0;0000on@0oooo000m0?ooo`030000003oool0oooo02d0oooo4`3o003/0?oo
o`T00?l02P000?oU0?ooo`00?@3oool00`000000oooo0?ooo`0^0?oooa40o`00kP3oool7003o00X0
003oiP3oool003d0oooo00<000000?ooo`3oool0;P3oool@0?l00>l0oooo1`00o`090000onL0oooo
000m0?ooo`030000003oool0oooo02h0oooo3`3o003`0?ooo`L00?l020000?oX0?ooo`00?@3oool0
0`000000oooo0?ooo`0^0?ooo`l0o`00l03oool7003o00P0003oj03oool003d0oooo00<000000?oo
o`3oool0;`3oool=0?l00?80oooo1@00o`080000onT0oooo000m0?ooo`030000003oool0oooo02l0
oooo303o003c0?ooo`D00?l01`000?oZ0?ooo`00?@3oool00`000000oooo0?ooo`0_0?ooo`/0o`00
m03oool5003o00H0003oj`3oool003d0oooo00<000000?ooo`3oool0;`3oool:0?l00?D0oooo1@00
o`050000on`0oooo000m0?ooo`030000003oool0oooo02l0oooo2P3o003e0?ooo`D00?l01@000?o/
0?ooo`00?@3oool00`000000oooo0?ooo`0`0?ooo`P0o`00m`3oool3003o00D0003ok@3oool003d0
oooo00<000000?ooo`3oool0<03oool70?l00?P0oooo0`00o`040000onh0oooo000m0?ooo`030000
003oool0oooo0300oooo1P3o003i0?ooo`<00?l00`000?o_0?ooo`00?@3oool00`000000oooo0?oo
o`0`0?ooo`D0o`00nP3oool3003o0080003ol03oool003d0oooo00<000000?ooo`3oool0<@3oool4
0?l00?/0oooo00@00?l00000o`000?l0003ol03oool003d0oooo00<000000?ooo`3oool0<@3oool3
0?l00?`0oooo00<00?l00000o`000?l0l@3oool003d0oooo00<000000?ooo`3oool0<@3oool20?l0
0?d0oooo00<00?l00000o`3oool0l@3oool003d0oooo00<000000?ooo`3oool0<@3oool00`3o0000
oooo0?ooo`3l0?ooo`03003o003oool0oooo0?40oooo000m0?ooo`030000003oool0oooo0?l0oooo
o`3ooolV0?ooo`00?@3oool00`000000oooo0?ooo`3o0?ooool0oooo9P3oool003d0oooo00<00000
0?ooo`3oool0o`3ooooo0?ooobH0oooo000m0?ooo`030000003oool0oooo0?l0ooooo`3ooolV0?oo
o`00?@3oool00`000000oooo0?ooo`3o0?ooool0oooo9P3oool003d0oooo00<000000?ooo`3oool0
o`3ooooo0?ooobH0oooo003o0?ooool0ooooIP3oool00?l0ooooo`3ooomV0?ooo`00o`3ooooo0?oo
ofH0oooo003o0?ooool0ooooIP3oool00?l0ooooo`3ooomV0?ooo`00o`3ooooo0?ooofH0oooo003o
0?ooool0ooooIP3oool00?l0ooooo`3ooomV0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0oooo
IP3oool00:X0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?ooo`030000003o
ool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?ooo`030000003o
ool0oooo01/0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003o
ool0oooo0:l0oooo002Z0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool0
0`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool06`3oool0
0`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool0
0`000000oooo0?ooo`2_0?ooo`00ZP3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo
0240oooo00<000000?ooo`3oool0[`3oool00:/0oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`0K0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`0Q0?ooo`030000003oool0oooo0:h0oooo002X0?ooo`040000003oool0oooo000001X0
oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00000P0?ooo`040000003oool0
oooo00000200oooo00@000000?ooo`3oool000006P3oool010000000oooo0?ooo`00000J0?ooo`04
0000003oool0oooo00000200oooo00@000000?ooo`3oool00000803oool010000000oooo0?ooo`00
002`0?ooo`00Z03oool4000001X0oooo1000000J0?ooo`@00000803oool400000200oooo1000000J
0?ooo`@000006P3oool400000200oooo1000000P0?ooo`@00000/03oool00?l0ooooo`3ooomV0?oo
o`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool00?l0ooooo`3ooomV0?ooo`00o`3ooooo
0?ooofH0oooo003o0?ooool0ooooIP3oool009l0oooo00<000000?ooo`3oool0o`3ooolQ0?ooo`03
0000003oool0oooo09l0oooo002N0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0
8@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0
8@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo09h0oooo002N0?ooo`030000003o
ool0oooo01X0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0Q0?ooo`030000003o
ool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0E0?ooo`030000003o
ool0oooo0240oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003o
ool0oooo09h0oooo002N0?ooo`040000003oool0oooo0?ooo`@000000P3oool400000080oooo1000
00020?ooo`@00000103oool00`000000oooo0?ooo`070?ooo`@000000P3oool4000000@0oooo00<0
00000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<0
00000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<0
00000?ooo`3oool01`3oool400000080oooo100000020?ooo`@000000P3oool4000000@0oooo00<0
00000?ooo`3oool01`3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo1000
00020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo1000
00020?ooo`@000000P3oool400000080oooo100000040?ooo`030000003oool0oooo00L0oooo1000
00020?ooo`@000000P3oool400000080oooo100000030?ooo`030000003oool0oooo09h0oooo002M
0?ooo`030000003oool0oooo0?l0oooo9@3oool00`000000oooo0?ooo`2M0?ooo`00WP3oool00`00
0000oooo0?ooo`3o0?ooob<0oooo00<000000?ooo`3oool0WP3oool009h0oooo00<000000?ooo`3o
ool0o`3ooolS0?ooo`030000003oool0oooo09h0oooo002O0?ooo`030000003oool0oooo0?l0oooo
8@3oool00`000000oooo0?ooo`2O0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool0
0?l0ooooo`3ooomV0?ooo`00o`3ooooo0?ooofH0oooo003o0?ooool0ooooIP3oool00?l0ooooo`3o
oomV0?ooo`00o`3ooooo0?ooofH0oooo002S0?ooo`800000203oool3000000D0oooo0`00000=0?oo
o`<000001@3oool3000000l0oooo0P0000080?ooo`<000001@3oool3000000h0oooo100000070?oo
o`<000001@3oool300000100oooo0`0000060?ooo`<000001@3oool3000000d0oooo0`0000050?oo
o`<000003`3oool2000000P0oooo0`0000050?ooo`<000003P3oool4000000L0oooo0`0000050?oo
o`<000003P3oool4000000L0oooo0`0000050?ooo`<00000Y03oool00:80oooo00@000000?ooo`3o
ool00000203oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo000000P0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo00H0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool03@3oool010000000oooo0?ooo`0000080?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool03@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool03@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool0X`3oool00:@0oooo00<000000?ooo`3oool01`3oool3000000D0oooo00<00000
0?ooo`3oool03@3oool3000000D0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`07
0?ooo`<000001@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo0`000005
0?ooo`030000003oool0oooo00d0oooo1@0000070?ooo`<000001@3oool00`000000oooo0?ooo`0=
0?ooo`<000001@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo00L0oooo0`000005
0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool3000000D0oooo00<00000
0?ooo`3oool03P3oool00`000000oooo0?ooo`080?ooo`<000001@3oool00`000000oooo0?ooo`2S
0?ooo`00Y@3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo000000<0oooo0P00000?
0?ooo`040000003oool0oooo000000<0oooo0P00000B0?ooo`030000003oool0oooo00H0oooo00@0
00000?ooo`3oool000000`3oool200000140oooo00<000000?ooo`3oool01`3oool010000000oooo
0?ooo`0000030?ooo`8000003`3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo
000000<0oooo0P00000?0?ooo`040000003oool0oooo000000<0oooo0P00000B0?ooo`030000003o
ool0oooo00H0oooo00@000000?ooo`3oool000000`3oool200000140oooo00<000000?ooo`3oool0
1`3oool010000000oooo0?ooo`0000030?ooo`8000004@3oool00`000000oooo0?ooo`070?ooo`04
0000003oool0oooo000000<0oooo0P00002U0?ooo`00XP3oool010000000oooo0?ooo`0000080?oo
o`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000503oool010000000oooo0?oo
o`0000080?ooo`040000003oool0oooo000001@0oooo00@000000?ooo`3oool00000203oool01000
0000oooo0?ooo`00000E0?ooo`030000003oool0000000P0oooo00@000000?ooo`3oool00000503o
ool010000000oooo0?ooo`00000D0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3o
ool00000503oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000001@0oooo00@0
00000?ooo`3oool00000203oool010000000oooo0?ooo`00002Z0?ooo`00X`3oool2000000P0oooo
100000050?ooo`030000003oool0oooo00`0oooo100000050?ooo`030000003oool0oooo00h0oooo
0P0000080?ooo`@000001@3oool00`000000oooo0?ooo`0>0?ooo`800000203oool4000000D0oooo
00<000000?ooo`3oool03`3oool2000000L0oooo100000050?ooo`030000003oool0oooo00`0oooo
100000050?ooo`030000003oool0oooo00h0oooo0P0000080?ooo`@000001@3oool00`000000oooo
0?ooo`0>0?ooo`800000203oool4000000D0oooo00<000000?ooo`3oool03P3oool2000000P0oooo
100000050?ooo`030000003oool0oooo0:<0oooo003o0?ooool0ooooIP3oool00?l0ooooo`3ooomV
0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 611}, {283.063, 0}} -> {-0.25193, -0.0232176, \
0.00409797, 0.00409797}, {{61.4375, 293.875}, {277.375, 50.8125}} -> \
{-1.27853, -0.04411, 0.00775407, 0.00775407}, {{317.063, 549.5}, {277.375, \
50.8125}} -> {-3.26066, -0.04411, 0.00775407, 0.00775407}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(\(pwi20 = 
        convertsol[{Solutions[\([33, 1]\)], Solutions[\([33, 2]\)], 
            Solutions[\([33, 20 + 2, 1]\)], 
            Solutions[\([33, 20 + 2, 2]\)]}];\)\[IndentingNewLine]
    \(DrawPartition[pwi20, 150, 1];\)\)\)\)], "Input"],

Cell[BoxData[
    RowBox[{\(Solve::"ifun"\), \(\(:\)\(\ \)\), "\<\"Inverse functions are \
being used by \\!\\(Solve\\), so some solutions may not be found; use Reduce \
for complete solution information. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Solve::ifun\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    RowBox[{\(Solve::"ifun"\), \(\(:\)\(\ \)\), "\<\"Inverse functions are \
being used by \\!\\(Solve\\), so some solutions may not be found; use Reduce \
for complete solution information. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Solve::ifun\\\"]\\)\"\>"}]], \
"Message"]
}, Open  ]],

Cell[BoxData[Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.552341 0.423849 0.0238095 0.434749 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
.8 1 .8 r
.88188 .44766 m
.02381 .02381 L
.78756 .02381 L
F
.8 .8 1 r
.88188 .44766 m
.78756 .02381 L
.97619 .02381 L
F
1 .8 .8 r
.76427 .97619 m
.02381 .02381 L
.88188 .44766 L
F
0 g
.0001 w
[ ] 0 setdash
.82378 .18659 m
.80368 .21244 L
s
.80368 .21244 m
.77144 .21244 L
s
.77144 .21244 m
.75134 .18659 L
s
.75134 .18659 m
.75851 .15435 L
s
.75851 .15435 m
.78756 .14 L
s
.78756 .14 m
.81661 .15435 L
s
.81661 .15435 m
.82378 .18659 L
s
.37344 .45759 m
.36106 .45759 L
s
.36106 .45759 m
.35334 .44766 L
s
.35334 .44766 m
.36946 .4397 L
s
.36946 .4397 m
.37344 .45759 L
s
.73301 .53003 m
.73522 .5201 L
s
.73522 .5201 m
.75311 .5201 L
s
.75311 .5201 m
.73301 .53003 L
s
.47095 .12849 m
.45483 .13645 L
s
.45483 .13645 m
.4598 .11414 L
s
.4598 .11414 m
.47095 .12849 L
s
.46697 .0819 m
.43473 .0819 L
s
.43473 .0819 m
.45085 .07394 L
s
.45085 .07394 m
.46697 .0819 L
s
.44245 .54241 m
.43473 .55234 L
s
.43473 .55234 m
.42358 .53799 L
s
.42358 .53799 m
.4397 .53003 L
s
.4397 .53003 m
.44245 .54241 L
s
.80766 .25903 m
.79331 .25903 L
s
.79331 .25903 m
.79154 .25107 L
s
.79154 .25107 m
.80766 .25903 L
s
.58635 .45759 m
.57244 .4397 L
s
.57244 .4397 m
.59254 .42977 L
s
.59254 .42977 m
.58635 .45759 L
s
.59254 .51017 m
.57244 .5201 L
s
.57244 .5201 m
.59751 .48786 L
s
.59751 .48786 m
.59254 .51017 L
s
.50496 .46201 m
.49381 .44766 L
s
.49381 .44766 m
.50496 .44215 L
s
.50496 .44215 m
.51612 .44766 L
s
.51612 .44766 m
.50496 .46201 L
s
.3042 .0819 m
.28808 .07394 L
s
.28808 .07394 m
.31039 .07394 L
s
.31039 .07394 m
.3042 .0819 L
s
.76746 .37522 m
.75134 .36725 L
s
.75134 .36725 m
.77144 .35732 L
s
.77144 .35732 m
.76746 .37522 L
s
.59254 .61044 m
.55632 .59254 L
s
.55632 .59254 m
.57863 .59254 L
s
.57863 .59254 m
.59254 .61044 L
s
.70617 .12849 m
.68607 .15435 L
s
.68607 .15435 m
.65383 .15435 L
s
.65383 .15435 m
.63373 .12849 L
s
.63373 .12849 m
.6409 .09625 L
s
.6409 .09625 m
.66995 .0819 L
s
.66995 .0819 m
.699 .09625 L
s
.699 .09625 m
.70617 .12849 L
s
.33668 .31712 m
.3243 .31712 L
s
.3243 .31712 m
.32828 .29923 L
s
.32828 .29923 m
.3444 .30719 L
s
.3444 .30719 m
.33668 .31712 L
s
.81164 .68288 m
.79154 .67295 L
s
.79154 .67295 m
.80049 .66853 L
s
.80049 .66853 m
.81164 .68288 L
s
.46599 .36725 m
.4598 .33943 L
s
.4598 .33943 m
.4799 .34936 L
s
.4799 .34936 m
.46599 .36725 L
s
.45483 .41739 m
.43473 .40746 L
s
.43473 .40746 m
.47493 .40746 L
s
.47493 .40746 m
.45483 .41739 L
s
.45483 .31712 m
.43694 .31712 L
s
.43694 .31712 m
.44092 .29923 L
s
.44092 .29923 m
.45208 .30474 L
s
.45208 .30474 m
.45483 .31712 L
s
.73522 .16585 m
.72804 .16231 L
s
.72804 .16231 m
.74416 .15435 L
s
.74416 .15435 m
.73522 .16585 L
s
.75532 .49425 m
.7392 .50221 L
s
.7392 .50221 m
.74416 .4799 L
s
.74416 .4799 m
.75532 .49425 L
s
.37841 .4799 m
.36946 .4397 L
s
.36946 .4397 m
.38337 .45759 L
s
.38337 .45759 m
.37841 .4799 L
s
.78437 .10264 m
.78039 .10776 L
s
.78039 .10776 m
.76888 .10776 L
s
.76888 .10776 m
.77144 .09625 L
s
.77144 .09625 m
.77719 .09341 L
s
.77719 .09341 m
.78295 .09625 L
s
.78295 .09625 m
.78437 .10264 L
s
.52507 .61682 m
.5201 .61044 L
s
.5201 .61044 m
.53003 .61044 L
s
.53003 .61044 m
.52507 .61682 L
s
.5434 .65064 m
.54119 .64071 L
s
.54119 .64071 m
.54836 .64425 L
s
.54836 .64425 m
.5434 .65064 L
s
.80049 .0819 m
.79331 .09113 L
s
.79331 .09113 m
.78614 .0819 L
s
.78614 .0819 m
.78756 .07552 L
s
.78756 .07552 m
.79331 .07268 L
s
.79331 .07268 m
.79907 .07552 L
s
.79907 .07552 m
.80049 .0819 L
s
.52408 .62833 m
.51612 .62833 L
s
.51612 .62833 m
.52231 .62036 L
s
.52231 .62036 m
.52408 .62833 L
s
.52329 .66625 m
.5201 .66214 L
s
.5201 .66214 m
.52329 .66057 L
s
.52329 .66057 m
.52649 .66214 L
s
.52649 .66214 m
.52329 .66625 L
s
.54978 .60917 m
.5488 .61044 L
s
.5488 .61044 m
.53445 .61044 L
s
.53445 .61044 m
.5434 .60602 L
s
.5434 .60602 m
.54978 .60917 L
s
.68749 .62296 m
.68658 .6225 L
s
.68658 .6225 m
.68749 .6184 L
s
.68749 .6184 m
.69103 .6184 L
s
.69103 .6184 m
.68749 .62296 L
s
.08013 .04454 m
.06578 .04454 L
s
.06578 .04454 m
.06898 .0302 L
s
.06898 .0302 m
.08013 .04454 L
s
.88188 .44766 m
.87726 .44538 L
s
.87726 .44538 m
.87789 .44254 L
s
.87789 .44254 m
.88188 .44766 L
s
.77349 .12849 m
.76888 .13077 L
s
.76888 .13077 m
.76427 .12849 L
s
.76427 .12849 m
.77144 .11926 L
s
.77144 .11926 m
.77349 .12849 L
s
.70936 .63629 m
.69786 .63629 L
s
.69786 .63629 m
.70042 .62478 L
s
.70042 .62478 m
.70838 .62478 L
s
.70838 .62478 m
.71114 .62833 L
s
.71114 .62833 m
.70936 .63629 L
s
.69324 .59254 m
.69502 .58458 L
s
.69502 .58458 m
.69723 .58742 L
s
.69723 .58742 m
.69324 .59254 L
s
.50496 .64268 m
.5 .63629 L
s
.5 .63629 m
.50717 .63275 L
s
.50717 .63275 m
.50496 .64268 L
s
.69182 .59893 m
.69324 .59254 L
s
.69324 .59254 m
.69679 .59254 L
s
.69679 .59254 m
.69182 .59893 L
s
.81341 .14 m
.80624 .14923 L
s
.80624 .14923 m
.81085 .12849 L
s
.81085 .12849 m
.81341 .14 L
s
.75851 .74097 m
.74416 .74097 L
s
.74416 .74097 m
.75532 .72662 L
s
.75532 .72662 m
.75851 .74097 L
s
.76427 .71512 m
.73522 .70077 L
s
.73522 .70077 m
.75851 .68926 L
s
.75851 .68926 m
.76427 .71512 L
s
.46918 .31712 m
.46122 .31712 L
s
.46122 .31712 m
.46378 .30562 L
s
.46378 .30562 m
.47415 .31074 L
s
.47415 .31074 m
.46918 .31712 L
s
.8399 .42693 m
.83529 .42465 L
s
.83529 .42465 m
.83848 .4103 L
s
.83848 .4103 m
.84565 .41953 L
s
.84565 .41953 m
.8399 .42693 L
s
.81917 .41668 m
.80624 .4103 L
s
.80624 .4103 m
.8142 .4103 L
s
.8142 .4103 m
.81917 .41668 L
s
.13105 .07678 m
.12707 .07166 L
s
.12707 .07166 m
.12805 .0704 L
s
.12805 .0704 m
.12963 .0704 L
s
.12963 .0704 m
.13105 .07678 L
s
.5402 .31074 m
.53843 .31161 L
s
.53843 .31161 m
.53898 .30916 L
s
.53898 .30916 m
.5402 .31074 L
s
.7191 .70873 m
.73522 .688 L
s
.73522 .688 m
.74815 .69438 L
s
.74815 .69438 m
.7191 .70873 L
s
.04312 .0302 m
.03816 .02381 L
s
.03816 .02381 m
.04454 .02381 L
s
.04454 .02381 m
.04312 .0302 L
s
.57102 .03304 m
.56065 .02792 L
s
.56065 .02792 m
.56385 .02381 L
s
.56385 .02381 m
.56897 .02381 L
s
.56897 .02381 m
.57102 .03304 L
s
.76427 .71512 m
.75851 .68926 L
s
.75851 .68926 m
.77144 .68288 L
s
.77144 .68288 m
.76427 .71512 L
s
.76825 .66853 m
.75709 .68288 L
s
.75709 .68288 m
.72485 .68288 L
s
.72485 .68288 m
.73203 .65064 L
s
.73203 .65064 m
.74815 .64268 L
s
.74815 .64268 m
.76427 .65064 L
s
.76427 .65064 m
.76825 .66853 L
s
.77144 .68288 m
.74815 .69438 L
s
.74815 .69438 m
.76825 .66853 L
s
.76825 .66853 m
.77144 .68288 L
s
.79587 .10264 m
.78756 .09853 L
s
.78756 .09853 m
.80049 .0819 L
s
.80049 .0819 m
.79587 .10264 L
s
.75851 .27053 m
.75134 .27976 L
s
.75134 .27976 m
.74416 .27053 L
s
.74416 .27053 m
.74559 .26415 L
s
.74559 .26415 m
.75134 .26131 L
s
.75134 .26131 m
.75709 .26415 L
s
.75709 .26415 m
.75851 .27053 L
s
.66995 .34298 m
.6642 .34582 L
s
.6642 .34582 m
.66278 .33943 L
s
.66278 .33943 m
.66995 .34298 L
s
.68784 .87789 m
.68288 .87151 L
s
.68288 .87151 m
.68607 .86993 L
s
.68607 .86993 m
.68784 .87789 L
s
.63948 .36371 m
.6409 .35732 L
s
.6409 .35732 m
.64445 .35732 L
s
.64445 .35732 m
.63948 .36371 L
s
.7539 .2498 m
.74239 .2498 L
s
.74239 .2498 m
.73841 .24468 L
s
.73841 .24468 m
.73983 .23829 L
s
.73983 .23829 m
.74559 .23545 L
s
.74559 .23545 m
.75134 .23829 L
s
.75134 .23829 m
.7539 .2498 L
s
.46776 .04966 m
.46201 .04682 L
s
.46201 .04682 m
.46599 .0417 L
s
.46599 .0417 m
.46776 .04966 L
s
.49539 .05194 m
.48963 .05478 L
s
.48963 .05478 m
.48388 .05194 L
s
.48388 .05194 m
.48565 .04966 L
s
.48565 .04966 m
.49361 .04966 L
s
.49361 .04966 m
.49539 .05194 L
s
.68288 .34936 m
.67712 .3522 L
s
.67712 .3522 m
.6757 .34582 L
s
.6757 .34582 m
.68288 .34936 L
s
.52329 .27053 m
.51868 .26826 L
s
.51868 .26826 m
.52073 .25903 L
s
.52073 .25903 m
.52585 .25903 L
s
.52585 .25903 m
.52905 .26313 L
s
.52905 .26313 m
.52329 .27053 L
s
.86256 .50575 m
.85744 .50575 L
s
.85744 .50575 m
.85858 .50063 L
s
.85858 .50063 m
.86256 .50575 L
s
.45341 .07268 m
.44971 .0745 L
s
.44971 .0745 m
.4488 .0704 L
s
.4488 .0704 m
.45164 .0704 L
s
.45164 .0704 m
.45341 .07268 L
s
.65958 .33786 m
.64922 .33274 L
s
.64922 .33274 m
.64894 .33147 L
s
.64894 .33147 m
.65462 .33147 L
s
.65462 .33147 m
.65958 .33786 L
s
.87931 .45917 m
.87521 .45917 L
s
.87521 .45917 m
.87498 .45815 L
s
.87498 .45815 m
.87868 .45632 L
s
.87868 .45632 m
.87967 .45759 L
s
.87967 .45759 m
.87931 .45917 L
s
.70794 .2137 m
.70696 .21244 L
s
.70696 .21244 m
.70822 .21244 L
s
.70822 .21244 m
.70794 .2137 L
s
.08908 .10776 m
.0851 .08987 L
s
.0851 .08987 m
.1052 .0998 L
s
.1052 .0998 m
.08908 .10776 L
s
.50114 .0491 m
.5 .04966 L
s
.5 .04966 m
.48963 .04454 L
s
.48963 .04454 m
.4976 .04454 L
s
.4976 .04454 m
.50114 .0491 L
s
.50256 .26029 m
.5 .25903 L
s
.5 .25903 m
.50158 .25903 L
s
.50158 .25903 m
.50256 .26029 L
s
.83829 .50575 m
.83671 .50575 L
s
.83671 .50575 m
.83785 .50519 L
s
.83785 .50519 m
.83829 .50575 L
s
.85027 .49653 m
.84388 .49653 L
s
.84388 .49653 m
.84964 .49368 L
s
.84964 .49368 m
.85062 .49495 L
s
.85062 .49495 m
.85027 .49653 L
s
.63673 .38318 m
.63515 .38318 L
s
.63515 .38318 m
.6355 .3816 L
s
.6355 .3816 m
.63673 .38318 L
s
.63373 .38956 m
.63259 .38444 L
s
.63259 .38444 m
.63515 .38318 L
s
.63515 .38318 m
.63373 .38956 L
s
.76888 .29411 m
.76427 .29639 L
s
.76427 .29639 m
.76171 .28488 L
s
.76171 .28488 m
.77002 .28899 L
s
.77002 .28899 m
.76888 .29411 L
s
.8747 .4799 m
.87151 .47579 L
s
.87151 .47579 m
.87612 .47351 L
s
.87612 .47351 m
.8747 .4799 L
s
.72406 .22167 m
.72052 .22167 L
s
.72052 .22167 m
.71654 .21655 L
s
.71654 .21655 m
.71973 .21244 L
s
.71973 .21244 m
.72485 .21244 L
s
.72485 .21244 m
.72804 .21655 L
s
.72804 .21655 m
.72406 .22167 L
s
.66022 .38672 m
.65383 .38672 L
s
.65383 .38672 m
.661 .38318 L
s
.661 .38318 m
.66022 .38672 L
s
.47671 .06117 m
.47095 .06401 L
s
.47095 .06401 m
.47272 .05605 L
s
.47272 .05605 m
.47671 .06117 L
s
.65604 .38956 m
.64808 .38956 L
s
.64808 .38956 m
.65383 .38672 L
s
.65383 .38672 m
.65604 .38956 L
s
.78181 .25903 m
.75595 .25903 L
s
.75595 .25903 m
.77463 .2498 L
s
.77463 .2498 m
.78181 .25903 L
s
.80624 .27566 m
.78756 .28488 L
s
.78756 .28488 m
.79331 .25903 L
s
.79331 .25903 m
.80624 .27566 L
s
.66534 .36371 m
.65958 .36087 L
s
.65958 .36087 m
.66676 .35732 L
s
.66676 .35732 m
.66534 .36371 L
s
.74672 .25903 m
.73636 .25391 L
s
.73636 .25391 m
.73955 .2498 L
s
.73955 .2498 m
.74467 .2498 L
s
.74467 .2498 m
.74672 .25903 L
s
.84565 .61044 m
.8399 .58458 L
s
.8399 .58458 m
.85283 .5782 L
s
.85283 .5782 m
.84565 .61044 L
s
.81661 .27053 m
.80624 .27566 L
s
.80624 .27566 m
.79331 .25903 L
s
.79331 .25903 m
.81661 .27053 L
s
.84964 .56385 m
.82953 .5897 L
s
.82953 .5897 m
.80943 .56385 L
s
.80943 .56385 m
.81341 .54596 L
s
.81341 .54596 m
.82953 .53799 L
s
.82953 .53799 m
.84565 .54596 L
s
.84565 .54596 m
.84964 .56385 L
s
.85283 .5782 m
.84565 .54596 L
s
.84565 .54596 m
.85858 .55234 L
s
.85858 .55234 m
.85283 .5782 L
s
.785 .22167 m
.78295 .21244 L
s
.78295 .21244 m
.80368 .21244 L
s
.80368 .21244 m
.785 .22167 L
s
.79587 .06117 m
.78437 .06117 L
s
.78437 .06117 m
.78039 .05605 L
s
.78039 .05605 m
.78181 .04966 L
s
.78181 .04966 m
.78756 .04682 L
s
.78756 .04682 m
.79331 .04966 L
s
.79331 .04966 m
.79587 .06117 L
s
.49823 .59254 m
.49602 .58261 L
s
.49602 .58261 m
.50319 .58616 L
s
.50319 .58616 m
.49823 .59254 L
s
.47813 .60816 m
.47493 .60405 L
s
.47493 .60405 m
.47813 .60247 L
s
.47813 .60247 m
.48132 .60405 L
s
.48132 .60405 m
.47813 .60816 L
s
.61505 .31586 m
.61407 .31712 L
s
.61407 .31712 m
.6061 .31712 L
s
.6061 .31712 m
.60689 .31358 L
s
.60689 .31358 m
.60866 .3127 L
s
.60866 .3127 m
.61505 .31586 L
s
.70042 .68105 m
.6995 .6806 L
s
.6995 .6806 m
.70042 .67649 L
s
.70042 .67649 m
.70396 .67649 L
s
.70396 .67649 m
.70042 .68105 L
s
.1253 .06117 m
.11955 .06401 L
s
.11955 .06401 m
.12132 .05605 L
s
.12132 .05605 m
.1253 .06117 L
s
.73522 .63629 m
.73061 .63401 L
s
.73061 .63401 m
.73266 .62478 L
s
.73266 .62478 m
.73778 .62478 L
s
.73778 .62478 m
.74097 .62889 L
s
.74097 .62889 m
.73522 .63629 L
s
.71591 .69438 m
.71079 .69438 L
s
.71079 .69438 m
.71192 .68926 L
s
.71192 .68926 m
.71591 .69438 L
s
.53445 .61044 m
.52649 .61044 L
s
.52649 .61044 m
.52728 .60689 L
s
.52728 .60689 m
.53622 .60247 L
s
.53622 .60247 m
.53941 .60405 L
s
.53941 .60405 m
.53445 .61044 L
s
.69324 .61556 m
.68863 .61328 L
s
.68863 .61328 m
.69502 .61328 L
s
.69502 .61328 m
.69324 .61556 L
s
.87151 .44254 m
.85858 .43615 L
s
.85858 .43615 m
.86654 .43615 L
s
.86654 .43615 m
.87151 .44254 L
s
.73266 .6478 m
.72627 .6478 L
s
.72627 .6478 m
.73203 .64495 L
s
.73203 .64495 m
.73301 .64622 L
s
.73301 .64622 m
.73266 .6478 L
s
.59033 .06243 m
.58935 .06117 L
s
.58935 .06117 m
.59062 .06117 L
s
.59062 .06117 m
.59033 .06243 L
s
.09546 .05605 m
.08652 .04454 L
s
.08652 .04454 m
.09944 .03816 L
s
.09944 .03816 m
.09546 .05605 L
s
.59972 .31712 m
.59814 .31712 L
s
.59814 .31712 m
.59972 .31004 L
s
.59972 .31004 m
.60149 .30916 L
s
.60149 .30916 m
.60468 .31074 L
s
.60468 .31074 m
.59972 .31712 L
s
.70617 .67365 m
.70156 .67137 L
s
.70156 .67137 m
.70794 .67137 L
s
.70794 .67137 m
.70617 .67365 L
s
.71449 .62605 m
.71192 .62478 L
s
.71192 .62478 m
.7135 .62478 L
s
.7135 .62478 m
.71449 .62605 L
s
.03674 .0302 m
.03595 .02918 L
s
.03595 .02918 m
.03639 .02862 L
s
.03639 .02862 m
.03674 .0302 L
s
.70361 .68516 m
.6995 .68516 L
s
.6995 .68516 m
.69928 .68414 L
s
.69928 .68414 m
.70298 .68231 L
s
.70298 .68231 m
.70396 .68358 L
s
.70396 .68358 m
.70361 .68516 L
s
.02637 .02507 m
.02539 .02381 L
s
.02539 .02381 m
.02609 .02381 L
s
.02609 .02381 m
.02637 .02507 L
s
.55399 .02462 m
.55325 .02426 L
s
.55325 .02426 m
.55361 .02381 L
s
.55361 .02381 m
.55417 .02381 L
s
.55417 .02381 m
.55399 .02462 L
s
.68907 .6184 m
.68749 .6184 L
s
.68749 .6184 m
.68784 .61682 L
s
.68784 .61682 m
.68907 .6184 L
s
.68607 .62478 m
.68493 .61966 L
s
.68493 .61966 m
.68749 .6184 L
s
.68749 .6184 m
.68607 .62478 L
s
.55952 .64268 m
.55234 .64622 L
s
.55234 .64622 m
.54517 .64268 L
s
.54517 .64268 m
.55632 .62833 L
s
.55632 .62833 m
.55952 .64268 L
s
.72804 .66853 m
.72485 .66442 L
s
.72485 .66442 m
.72947 .66214 L
s
.72947 .66214 m
.72804 .66853 L
s
.60866 .06756 m
.60645 .0704 L
s
.60645 .0704 m
.60291 .0704 L
s
.60291 .0704 m
.59893 .06528 L
s
.59893 .06528 m
.60212 .06117 L
s
.60212 .06117 m
.60724 .06117 L
s
.60724 .06117 m
.60866 .06756 L
s
.7191 .62833 m
.71591 .6299 L
s
.71591 .6299 m
.71192 .62478 L
s
.71192 .62478 m
.7191 .62833 L
s
.71256 .62194 m
.70617 .62194 L
s
.70617 .62194 m
.71335 .6184 L
s
.71335 .6184 m
.71256 .62194 L
s
.69068 .62706 m
.68658 .62706 L
s
.68658 .62706 m
.68635 .62605 L
s
.68635 .62605 m
.69147 .62352 L
s
.69147 .62352 m
.69068 .62706 L
s
.73471 .63857 m
.73345 .63857 L
s
.73345 .63857 m
.73487 .63787 L
s
.73487 .63787 m
.73471 .63857 L
s
.58303 .06198 m
.5823 .06162 L
s
.5823 .06162 m
.58265 .06117 L
s
.58265 .06117 m
.58322 .06117 L
s
.58322 .06117 m
.58303 .06198 L
s
.59289 .07141 m
.59175 .07085 L
s
.59175 .07085 m
.59254 .06983 L
s
.59254 .06983 m
.59289 .07141 L
s
.47813 .3127 m
.47636 .31358 L
s
.47636 .31358 m
.47592 .31161 L
s
.47592 .31161 m
.47813 .3127 L
s
.67614 .5603 m
.67456 .5603 L
s
.67456 .5603 m
.67492 .55873 L
s
.67492 .55873 m
.67614 .5603 L
s
.78181 .07836 m
.78039 .07906 L
s
.78039 .07906 m
.77896 .07836 L
s
.77896 .07836 m
.77861 .07678 L
s
.77861 .07678 m
.7796 .07552 L
s
.7796 .07552 m
.78117 .07552 L
s
.78117 .07552 m
.78216 .07678 L
s
.78216 .07678 m
.78181 .07836 L
s
.50221 .61044 m
.49425 .61044 L
s
.49425 .61044 m
.49602 .60247 L
s
.49602 .60247 m
.50221 .61044 L
s
.70838 .62478 m
.70042 .62478 L
s
.70042 .62478 m
.70617 .62194 L
s
.70617 .62194 m
.70838 .62478 L
s
.61363 .312 m
.613 .31484 L
s
.613 .31484 m
.60724 .312 L
s
.60724 .312 m
.60582 .30562 L
s
.60582 .30562 m
.60866 .30562 L
s
.60866 .30562 m
.61363 .312 L
s
.13247 .1508 m
.13424 .14284 L
s
.13424 .14284 m
.14142 .14638 L
s
.14142 .14638 m
.13247 .1508 L
s
.63259 .34298 m
.62336 .34298 L
s
.62336 .34298 m
.62222 .33786 L
s
.62222 .33786 m
.63515 .33147 L
s
.63515 .33147 m
.63259 .34298 L
s
.61875 .31769 m
.61761 .31712 L
s
.61761 .31712 m
.61505 .30562 L
s
.61505 .30562 m
.62001 .312 L
s
.62001 .312 m
.61875 .31769 L
s
.61824 .31996 m
.61761 .31712 L
s
.61761 .31712 m
.61875 .31769 L
s
.61875 .31769 m
.61824 .31996 L
s
.04116 .03728 m
.03993 .03886 L
s
.03993 .03886 m
.03276 .03532 L
s
.03276 .03532 m
.04072 .03532 L
s
.04072 .03532 m
.04116 .03728 L
s
.55908 .28331 m
.55809 .28204 L
s
.55809 .28204 m
.55952 .28134 L
s
.55952 .28134 m
.55908 .28331 L
s
.85283 .5782 m
.82953 .5897 L
s
.82953 .5897 m
.84964 .56385 L
s
.84964 .56385 m
.85283 .5782 L
s
.85858 .55234 m
.82953 .53799 L
s
.82953 .53799 m
.85283 .52649 L
s
.85283 .52649 m
.85858 .55234 L
s
.12132 .13645 m
.11237 .13204 L
s
.11237 .13204 m
.11955 .12849 L
s
.11955 .12849 m
.12132 .13645 L
s
.73699 .9181 m
.72087 .91013 L
s
.72087 .91013 m
.72584 .90375 L
s
.72584 .90375 m
.7338 .90375 L
s
.7338 .90375 m
.73699 .9181 L
s
.78756 .23317 m
.785 .22167 L
s
.785 .22167 m
.80368 .21244 L
s
.80368 .21244 m
.78756 .23317 L
s
.86177 .53799 m
.85283 .52649 L
s
.85283 .52649 m
.86576 .5201 L
s
.86576 .5201 m
.86177 .53799 L
s
.77719 .23829 m
.76427 .24468 L
s
.76427 .24468 m
.75134 .23829 L
s
.75134 .23829 m
.74815 .22395 L
s
.74815 .22395 m
.75709 .21244 L
s
.75709 .21244 m
.77144 .21244 L
s
.77144 .21244 m
.78039 .22395 L
s
.78039 .22395 m
.77719 .23829 L
s
.78756 .23317 m
.77719 .23829 L
s
.77719 .23829 m
.78295 .21244 L
s
.78295 .21244 m
.78756 .23317 L
s
.76427 .25492 m
.75595 .25903 L
s
.75595 .25903 m
.75134 .23829 L
s
.75134 .23829 m
.76427 .25492 L
s
.83671 .24468 m
.82555 .25903 L
s
.82555 .25903 m
.80766 .25903 L
s
.80766 .25903 m
.79651 .24468 L
s
.79651 .24468 m
.80049 .22679 L
s
.80049 .22679 m
.81661 .21883 L
s
.81661 .21883 m
.83273 .22679 L
s
.83273 .22679 m
.83671 .24468 L
s
.47316 .15435 m
.45085 .15435 L
s
.45085 .15435 m
.46201 .14 L
s
.46201 .14 m
.47316 .15435 L
s
.4598 .11414 m
.43473 .0819 L
s
.43473 .0819 m
.45262 .0819 L
s
.45262 .0819 m
.4598 .11414 L
s
.44589 .09625 m
.40568 .09625 L
s
.40568 .09625 m
.41684 .0819 L
s
.41684 .0819 m
.44589 .09625 L
s
.77144 .21244 m
.75355 .21244 L
s
.75355 .21244 m
.75851 .20605 L
s
.75851 .20605 m
.77144 .21244 L
s
.39851 .12849 m
.40348 .10618 L
s
.40348 .10618 m
.42358 .09625 L
s
.42358 .09625 m
.39851 .12849 L
s
.82059 .5782 m
.80447 .57023 L
s
.80447 .57023 m
.80668 .5603 L
s
.80668 .5603 m
.82059 .5782 L
s
.41861 .15435 m
.4047 .13645 L
s
.4047 .13645 m
.40967 .11414 L
s
.40967 .11414 m
.41861 .15435 L
s
.79651 .53445 m
.79331 .5201 L
s
.79331 .5201 m
.82555 .5201 L
s
.82555 .5201 m
.79651 .53445 L
s
.45085 .15435 m
.41861 .15435 L
s
.41861 .15435 m
.41463 .13645 L
s
.41463 .13645 m
.45085 .15435 L
s
.699 .53799 m
.68288 .54596 L
s
.68288 .54596 m
.6789 .52806 L
s
.6789 .52806 m
.699 .53799 L
s
.42358 .53799 m
.43749 .5201 L
s
.43749 .5201 m
.4598 .5201 L
s
.4598 .5201 m
.42358 .53799 L
s
.87612 .4218 m
.86895 .43103 L
s
.86895 .43103 m
.86177 .4218 L
s
.86177 .4218 m
.86319 .41542 L
s
.86319 .41542 m
.86895 .41258 L
s
.86895 .41258 m
.8747 .41542 L
s
.8747 .41542 m
.87612 .4218 L
s
.87612 .4218 m
.8747 .41542 L
s
.8747 .41542 m
.87931 .4177 L
s
.87931 .4177 m
.87612 .4218 L
s
.7764 .92164 m
.77144 .91525 L
s
.77144 .91525 m
.77783 .91525 L
s
.77783 .91525 m
.7764 .92164 L
s
.87151 .40107 m
.86 .40107 L
s
.86 .40107 m
.85602 .39595 L
s
.85602 .39595 m
.85744 .38956 L
s
.85744 .38956 m
.86319 .38672 L
s
.86319 .38672 m
.86895 .38956 L
s
.86895 .38956 m
.87151 .40107 L
s
.88763 .4218 m
.88188 .41896 L
s
.88188 .41896 m
.88649 .41668 L
s
.88649 .41668 m
.88763 .4218 L
s
.75532 .92322 m
.75276 .92448 L
s
.75276 .92448 m
.75185 .92038 L
s
.75185 .92038 m
.75595 .92038 L
s
.75595 .92038 m
.75532 .92322 L
s
.24866 .13488 m
.23829 .12976 L
s
.23829 .12976 m
.23801 .12849 L
s
.23801 .12849 m
.2437 .12849 L
s
.2437 .12849 m
.24866 .13488 L
s
.60768 .39753 m
.60326 .39753 L
s
.60326 .39753 m
.60212 .39241 L
s
.60212 .39241 m
.60326 .39184 L
s
.60326 .39184 m
.60768 .39753 L
s
.27196 .34298 m
.26797 .32508 L
s
.26797 .32508 m
.28808 .33501 L
s
.28808 .33501 m
.27196 .34298 L
s
.59574 .15435 m
.58139 .15435 L
s
.58139 .15435 m
.58025 .14923 L
s
.58025 .14923 m
.58856 .14512 L
s
.58856 .14512 m
.59574 .15435 L
s
.63275 .38515 m
.62931 .38956 L
s
.62931 .38956 m
.61938 .38956 L
s
.61938 .38956 m
.61619 .37522 L
s
.61619 .37522 m
.63054 .37522 L
s
.63054 .37522 m
.63275 .38515 L
s
.6154 .43615 m
.61264 .4397 L
s
.61264 .4397 m
.61044 .42977 L
s
.61044 .42977 m
.6154 .43615 L
s
.76427 .94749 m
.75851 .95034 L
s
.75851 .95034 m
.75709 .94395 L
s
.75709 .94395 m
.76427 .94749 L
s
.61485 .42977 m
.61044 .42977 L
s
.61044 .42977 m
.60866 .4218 L
s
.60866 .4218 m
.61485 .42977 L
s
.4017 .20732 m
.40107 .21016 L
s
.40107 .21016 m
.39532 .20732 L
s
.39532 .20732 m
.3939 .20093 L
s
.3939 .20093 m
.39674 .20093 L
s
.39674 .20093 m
.4017 .20732 L
s
.57386 .10776 m
.57102 .10776 L
s
.57102 .10776 m
.56988 .10264 L
s
.56988 .10264 m
.57386 .10776 L
s
.5659 .08475 m
.56271 .0704 L
s
.56271 .0704 m
.56767 .07678 L
s
.56767 .07678 m
.5659 .08475 L
s
.22403 .2725 m
.22281 .27408 L
s
.22281 .27408 m
.21563 .27053 L
s
.21563 .27053 m
.2236 .27053 L
s
.2236 .27053 m
.22403 .2725 L
s
.34715 .17862 m
.34617 .17736 L
s
.34617 .17736 m
.34759 .17666 L
s
.34759 .17666 m
.34715 .17862 L
s
.31137 .37522 m
.29525 .36725 L
s
.29525 .36725 m
.31535 .35732 L
s
.31535 .35732 m
.31137 .37522 L
s
.84309 .38956 m
.83671 .38956 L
s
.83671 .38956 m
.83273 .38444 L
s
.83273 .38444 m
.83415 .37806 L
s
.83415 .37806 m
.8399 .37522 L
s
.8399 .37522 m
.85027 .38034 L
s
.85027 .38034 m
.84309 .38956 L
s
.2809 .13488 m
.27948 .12849 L
s
.27948 .12849 m
.28587 .12849 L
s
.28587 .12849 m
.2809 .13488 L
s
.29702 .15561 m
.29639 .15845 L
s
.29639 .15845 m
.29064 .15561 L
s
.29064 .15561 m
.28921 .14923 L
s
.28921 .14923 m
.29206 .14923 L
s
.29206 .14923 m
.29702 .15561 L
s
.23396 .28134 m
.23573 .27338 L
s
.23573 .27338 m
.24291 .27692 L
s
.24291 .27692 m
.23396 .28134 L
s
.3554 .15435 m
.34617 .15435 L
s
.34617 .15435 m
.34503 .14923 L
s
.34503 .14923 m
.35334 .14512 L
s
.35334 .14512 m
.35654 .14923 L
s
.35654 .14923 m
.3554 .15435 L
s
.3243 .3816 m
.32288 .37522 L
s
.32288 .37522 m
.32926 .37522 L
s
.32926 .37522 m
.3243 .3816 L
s
.25505 .13488 m
.25441 .13772 L
s
.25441 .13772 m
.24866 .13488 L
s
.24866 .13488 m
.24724 .12849 L
s
.24724 .12849 m
.25008 .12849 L
s
.25008 .12849 m
.25505 .13488 L
s
.61264 .40391 m
.60468 .40391 L
s
.60468 .40391 m
.61044 .40107 L
s
.61044 .40107 m
.61264 .40391 L
s
.57883 .14284 m
.57564 .12849 L
s
.57564 .12849 m
.5806 .13488 L
s
.5806 .13488 m
.57883 .14284 L
s
.35059 .43528 m
.34936 .43685 L
s
.34936 .43685 m
.34219 .43331 L
s
.34219 .43331 m
.35015 .43331 L
s
.35015 .43331 m
.35059 .43528 L
s
.88266 .20605 m
.88109 .20605 L
s
.88109 .20605 m
.88188 .20504 L
s
.88188 .20504 m
.88266 .20605 L
s
.2662 .31712 m
.25008 .30916 L
s
.25008 .30916 m
.27018 .29923 L
s
.27018 .29923 m
.2662 .31712 L
s
.30214 .16129 m
.301 .16073 L
s
.301 .16073 m
.29844 .14923 L
s
.29844 .14923 m
.30341 .15561 L
s
.30341 .15561 m
.30214 .16129 L
s
.34105 .13133 m
.34042 .12849 L
s
.34042 .12849 m
.3414 .12976 L
s
.3414 .12976 m
.34105 .13133 L
s
.29844 .37592 m
.29702 .37522 L
s
.29702 .37522 m
.29899 .37522 L
s
.29899 .37522 m
.29844 .37592 L
s
.31437 .38869 m
.31314 .39027 L
s
.31314 .39027 m
.30597 .38672 L
s
.30597 .38672 m
.31393 .38672 L
s
.31393 .38672 m
.31437 .38869 L
s
.6037 .39949 m
.60326 .39753 L
s
.60326 .39753 m
.60523 .39753 L
s
.60523 .39753 m
.6037 .39949 L
s
.60326 .39753 m
.60007 .39595 L
s
.60007 .39595 m
.60149 .38956 L
s
.60149 .38956 m
.60326 .39753 L
s
.89224 .40107 m
.88188 .39595 L
s
.88188 .39595 m
.89019 .39184 L
s
.89019 .39184 m
.89338 .39595 L
s
.89338 .39595 m
.89224 .40107 L
s
.34617 .41542 m
.34042 .41258 L
s
.34042 .41258 m
.3444 .40746 L
s
.3444 .40746 m
.34617 .41542 L
s
.89878 .19809 m
.89657 .20093 L
s
.89657 .20093 m
.89019 .20093 L
s
.89019 .20093 m
.88905 .19581 L
s
.88905 .19581 m
.89224 .19171 L
s
.89224 .19171 m
.898 .19455 L
s
.898 .19455 m
.89878 .19809 L
s
.34219 .13645 m
.339 .13488 L
s
.339 .13488 m
.34042 .12849 L
s
.34042 .12849 m
.34219 .13645 L
s
.6355 .39753 m
.62656 .39311 L
s
.62656 .39311 m
.63452 .39311 L
s
.63452 .39311 m
.6355 .39753 L
s
.60823 .39114 m
.60184 .38799 L
s
.60184 .38799 m
.60212 .38672 L
s
.60212 .38672 m
.60724 .38672 L
s
.60724 .38672 m
.60823 .39114 L
s
.35291 .44569 m
.35113 .44482 L
s
.35113 .44482 m
.35271 .44482 L
s
.35271 .44482 m
.35291 .44569 L
s
.87777 .21163 m
.87704 .21199 L
s
.87704 .21199 m
.87691 .21143 L
s
.87691 .21143 m
.87726 .21097 L
s
.87726 .21097 m
.87777 .21163 L
s
.8911 .2096 m
.88996 .21016 L
s
.88996 .21016 m
.88968 .2089 L
s
.88968 .2089 m
.8911 .2096 L
s
.39134 .2022 m
.39035 .20093 L
s
.39035 .20093 m
.39232 .20093 L
s
.39232 .20093 m
.39134 .2022 L
s
.58758 .47194 m
.58714 .46997 L
s
.58714 .46997 m
.58911 .46997 L
s
.58911 .46997 m
.58758 .47194 L
s
.85425 .40391 m
.85283 .40461 L
s
.85283 .40461 m
.85141 .40391 L
s
.85141 .40391 m
.85106 .40234 L
s
.85106 .40234 m
.85204 .40107 L
s
.85204 .40107 m
.85362 .40107 L
s
.85362 .40107 m
.8546 .40234 L
s
.8546 .40234 m
.85425 .40391 L
s
.27771 .14923 m
.27196 .14638 L
s
.27196 .14638 m
.27913 .14284 L
s
.27913 .14284 m
.27771 .14923 L
s
.62656 .39311 m
.61938 .38956 L
s
.61938 .38956 m
.62931 .38956 L
s
.62931 .38956 m
.62656 .39311 L
s
.86576 .37522 m
.85858 .38444 L
s
.85858 .38444 m
.86319 .36371 L
s
.86319 .36371 m
.86576 .37522 L
s
.86576 .37522 m
.86319 .36371 L
s
.86319 .36371 m
.8747 .36371 L
s
.8747 .36371 m
.86576 .37522 L
s
.898 .37522 m
.88188 .35448 L
s
.88188 .35448 m
.90261 .35448 L
s
.90261 .35448 m
.898 .37522 L
s
.22281 .26699 m
.21386 .26257 L
s
.21386 .26257 m
.22104 .25903 L
s
.22104 .25903 m
.22281 .26699 L
s
.84246 .39696 m
.84132 .39184 L
s
.84132 .39184 m
.84451 .38774 L
s
.84451 .38774 m
.85283 .39184 L
s
.85283 .39184 m
.84246 .39696 L
s
.78039 .90375 m
.77463 .87789 L
s
.77463 .87789 m
.78756 .87151 L
s
.78756 .87151 m
.78039 .90375 L
s
.90261 .35448 m
.88188 .35448 L
s
.88188 .35448 m
.90517 .34298 L
s
.90517 .34298 m
.90261 .35448 L
s
.78437 .85716 m
.76427 .88301 L
s
.76427 .88301 m
.74416 .85716 L
s
.74416 .85716 m
.74815 .83927 L
s
.74815 .83927 m
.76427 .83131 L
s
.76427 .83131 m
.78039 .83927 L
s
.78039 .83927 m
.78437 .85716 L
s
.78756 .87151 m
.78039 .83927 L
s
.78039 .83927 m
.79331 .84565 L
s
.79331 .84565 m
.78756 .87151 L
s
.84821 .33786 m
.8399 .33375 L
s
.8399 .33375 m
.85283 .31712 L
s
.85283 .31712 m
.84821 .33786 L
s
.7191 .77321 m
.68784 .81341 L
s
.68784 .81341 m
.63771 .81341 L
s
.63771 .81341 m
.60645 .77321 L
s
.60645 .77321 m
.61761 .72308 L
s
.61761 .72308 m
.66278 .70077 L
s
.66278 .70077 m
.70794 .72308 L
s
.70794 .72308 m
.7191 .77321 L
s
.1454 .16428 m
.13302 .16428 L
s
.13302 .16428 m
.1253 .15435 L
s
.1253 .15435 m
.14142 .14638 L
s
.14142 .14638 m
.1454 .16428 L
s
.90915 .32508 m
.898 .31074 L
s
.898 .31074 m
.91092 .31712 L
s
.91092 .31712 m
.90915 .32508 L
s
.73522 .25903 m
.7191 .26699 L
s
.7191 .26699 m
.72406 .24468 L
s
.72406 .24468 m
.73522 .25903 L
s
.58139 .33501 m
.5953 .31712 L
s
.5953 .31712 m
.61761 .31712 L
s
.61761 .31712 m
.58139 .33501 L
s
.21441 .2491 m
.20669 .25903 L
s
.20669 .25903 m
.19553 .24468 L
s
.19553 .24468 m
.21165 .23672 L
s
.21165 .23672 m
.21441 .2491 L
s
.661 .0704 m
.64666 .0704 L
s
.64666 .0704 m
.64488 .06243 L
s
.64488 .06243 m
.661 .0704 L
s
.85681 .4799 m
.85283 .46201 L
s
.85283 .46201 m
.87072 .46201 L
s
.87072 .46201 m
.85681 .4799 L
s
.3645 .21686 m
.3444 .22679 L
s
.3444 .22679 m
.36946 .19455 L
s
.36946 .19455 m
.3645 .21686 L
s
.27692 .16869 m
.26576 .15435 L
s
.26576 .15435 m
.27692 .14884 L
s
.27692 .14884 m
.28808 .15435 L
s
.28808 .15435 m
.27692 .16869 L
s
.56846 .21244 m
.55234 .20448 L
s
.55234 .20448 m
.57465 .20448 L
s
.57465 .20448 m
.56846 .21244 L
s
.83273 .66853 m
.81661 .66057 L
s
.81661 .66057 m
.83671 .65064 L
s
.83671 .65064 m
.83273 .66853 L
s
.3645 .31712 m
.32828 .29923 L
s
.32828 .29923 m
.35059 .29923 L
s
.35059 .29923 m
.3645 .31712 L
s
.61186 .0819 m
.60468 .09113 L
s
.60468 .09113 m
.59751 .0819 L
s
.59751 .0819 m
.59893 .07552 L
s
.59893 .07552 m
.60468 .07268 L
s
.60468 .07268 m
.61044 .07552 L
s
.61044 .07552 m
.61186 .0819 L
s
.73522 .63629 m
.72947 .63913 L
s
.72947 .63913 m
.72804 .63275 L
s
.72804 .63275 m
.73522 .63629 L
s
.4598 .58458 m
.45483 .5782 L
s
.45483 .5782 m
.45803 .57662 L
s
.45803 .57662 m
.4598 .58458 L
s
.70475 .65702 m
.70617 .65064 L
s
.70617 .65064 m
.70972 .65064 L
s
.70972 .65064 m
.70475 .65702 L
s
.60724 .06117 m
.59574 .06117 L
s
.59574 .06117 m
.59175 .05605 L
s
.59175 .05605 m
.59318 .04966 L
s
.59318 .04966 m
.59893 .04682 L
s
.59893 .04682 m
.60468 .04966 L
s
.60468 .04966 m
.60724 .06117 L
s
.56846 .29285 m
.5635 .29923 L
s
.5635 .29923 m
.56129 .2893 L
s
.56129 .2893 m
.56846 .29285 L
s
.54162 .31712 m
.53366 .31712 L
s
.53366 .31712 m
.53445 .31358 L
s
.53445 .31358 m
.5434 .30916 L
s
.5434 .30916 m
.54659 .31074 L
s
.54659 .31074 m
.54162 .31712 L
s
.74815 .64268 m
.74239 .64552 L
s
.74239 .64552 m
.74097 .63913 L
s
.74097 .63913 m
.74815 .64268 L
s
.78756 .40107 m
.78295 .39879 L
s
.78295 .39879 m
.785 .38956 L
s
.785 .38956 m
.79012 .38956 L
s
.79012 .38956 m
.79331 .39367 L
s
.79331 .39367 m
.78756 .40107 L
s
.08446 .03532 m
.07934 .03532 L
s
.07934 .03532 m
.08332 .0302 L
s
.08332 .0302 m
.08446 .03532 L
s
.59688 .31712 m
.59175 .31712 L
s
.59175 .31712 m
.59254 .31358 L
s
.59254 .31358 m
.59574 .312 L
s
.59574 .312 m
.59688 .31712 L
s
.72485 .63117 m
.71449 .62605 L
s
.71449 .62605 m
.7142 .62478 L
s
.7142 .62478 m
.71989 .62478 L
s
.71989 .62478 m
.72485 .63117 L
s
.03623 .02792 m
.03532 .02837 L
s
.03532 .02837 m
.03276 .02507 L
s
.03276 .02507 m
.03374 .02381 L
s
.03374 .02381 m
.03532 .02381 L
s
.03532 .02381 m
.03623 .02792 L
s
.56129 .02507 m
.5603 .02381 L
s
.5603 .02381 m
.56157 .02381 L
s
.56157 .02381 m
.56129 .02507 L
s
.78295 .09625 m
.77258 .09113 L
s
.77258 .09113 m
.77975 .0819 L
s
.77975 .0819 m
.78295 .09625 L
s
.52728 .31712 m
.5257 .31712 L
s
.5257 .31712 m
.52728 .31004 L
s
.52728 .31004 m
.53622 .30562 L
s
.53622 .30562 m
.52728 .31712 L
s
.76683 .39083 m
.76427 .38956 L
s
.76427 .38956 m
.76584 .38956 L
s
.76584 .38956 m
.76683 .39083 L
s
.08908 .05605 m
.08829 .05504 L
s
.08829 .05504 m
.08873 .05447 L
s
.08873 .05447 m
.08908 .05605 L
s
.07871 .05093 m
.07473 .04581 L
s
.07473 .04581 m
.07571 .04454 L
s
.07571 .04454 m
.07729 .04454 L
s
.07729 .04454 m
.07871 .05093 L
s
.702 .67649 m
.70042 .67649 L
s
.70042 .67649 m
.70077 .67492 L
s
.70077 .67492 m
.702 .67649 L
s
.699 .68288 m
.69786 .67776 L
s
.69786 .67776 m
.70042 .67649 L
s
.70042 .67649 m
.699 .68288 L
s
.62222 .10548 m
.61761 .10776 L
s
.61761 .10776 m
.61505 .09625 L
s
.61505 .09625 m
.62336 .10036 L
s
.62336 .10036 m
.62222 .10548 L
s
.05286 .02792 m
.04966 .02381 L
s
.04966 .02381 m
.05605 .02381 L
s
.05605 .02381 m
.05286 .02792 L
s
.58139 .02792 m
.57741 .03304 L
s
.57741 .03304 m
.57386 .03304 L
s
.57386 .03304 m
.56988 .02792 L
s
.56988 .02792 m
.57307 .02381 L
s
.57307 .02381 m
.5782 .02381 L
s
.5782 .02381 m
.58139 .02792 L
s
.72548 .68004 m
.7191 .68004 L
s
.7191 .68004 m
.72627 .67649 L
s
.72627 .67649 m
.72548 .68004 L
s
.56748 .31712 m
.55952 .31712 L
s
.55952 .31712 m
.56129 .30916 L
s
.56129 .30916 m
.56748 .31712 L
s
.72131 .68288 m
.71335 .68288 L
s
.71335 .68288 m
.7191 .68004 L
s
.7191 .68004 m
.72131 .68288 L
s
.63515 .0704 m
.6093 .0704 L
s
.6093 .0704 m
.62798 .06117 L
s
.62798 .06117 m
.63515 .0704 L
s
.65958 .08702 m
.6409 .09625 L
s
.6409 .09625 m
.64666 .0704 L
s
.64666 .0704 m
.65958 .08702 L
s
.73061 .65702 m
.72485 .65418 L
s
.72485 .65418 m
.73203 .65064 L
s
.73203 .65064 m
.73061 .65702 L
s
.60007 .0704 m
.5897 .06528 L
s
.5897 .06528 m
.59289 .06117 L
s
.59289 .06117 m
.59802 .06117 L
s
.59802 .06117 m
.60007 .0704 L
s
.16329 .03532 m
.15435 .02381 L
s
.15435 .02381 m
.18659 .02381 L
s
.18659 .02381 m
.16329 .03532 L
s
.66995 .0819 m
.65958 .08702 L
s
.65958 .08702 m
.64666 .0704 L
s
.64666 .0704 m
.66995 .0819 L
s
.15036 .0704 m
.13247 .0704 L
s
.13247 .0704 m
.12132 .05605 L
s
.12132 .05605 m
.1253 .03816 L
s
.1253 .03816 m
.14142 .0302 L
s
.14142 .0302 m
.17047 .04454 L
s
.17047 .04454 m
.15036 .0704 L
s
.1253 .03816 m
.12849 .02381 L
s
.12849 .02381 m
.15435 .02381 L
s
.15435 .02381 m
.1253 .03816 L
s
.63834 .03304 m
.63629 .02381 L
s
.63629 .02381 m
.65702 .02381 L
s
.65702 .02381 m
.63834 .03304 L
s
.87789 .44254 m
.87726 .44538 L
s
.87726 .44538 m
.87151 .44254 L
s
.87151 .44254 m
.87009 .43615 L
s
.87009 .43615 m
.87293 .43615 L
s
.87293 .43615 m
.87789 .44254 L
s
.77463 .13361 m
.76888 .13077 L
s
.76888 .13077 m
.77349 .12849 L
s
.77349 .12849 m
.77463 .13361 L
s
.69786 .63629 m
.68863 .63629 L
s
.68863 .63629 m
.68749 .63117 L
s
.68749 .63117 m
.70042 .62478 L
s
.70042 .62478 m
.69786 .63629 L
s
.68351 .61328 m
.68032 .59893 L
s
.68032 .59893 m
.68528 .60531 L
s
.68528 .60531 m
.68351 .61328 L
s
.7887 .03714 m
.78791 .03816 L
s
.78791 .03816 m
.78665 .03816 L
s
.78665 .03816 m
.78551 .03304 L
s
.78551 .03304 m
.7887 .03714 L
s
.82334 .41384 m
.82236 .41258 L
s
.82236 .41258 m
.82378 .41188 L
s
.82378 .41188 m
.82334 .41384 L
s
.17047 .04454 m
.14142 .0302 L
s
.14142 .0302 m
.15435 .02381 L
s
.15435 .02381 m
.17047 .04454 L
s
.12132 .05605 m
.1052 .03532 L
s
.1052 .03532 m
.12849 .02381 L
s
.12849 .02381 m
.12132 .05605 L
s
.77144 .11926 m
.77002 .11288 L
s
.77002 .11288 m
.77463 .11516 L
s
.77463 .11516 m
.77144 .11926 L
s
.50895 .62478 m
.49283 .61682 L
s
.49283 .61682 m
.49779 .61044 L
s
.49779 .61044 m
.50575 .61044 L
s
.50575 .61044 m
.50895 .62478 L
s
.6409 .04454 m
.63834 .03304 L
s
.63834 .03304 m
.65702 .02381 L
s
.65702 .02381 m
.6409 .04454 L
s
.1052 .03532 m
.09625 .02381 L
s
.09625 .02381 m
.11414 .02381 L
s
.11414 .02381 m
.1052 .03532 L
s
.63054 .04966 m
.61761 .05605 L
s
.61761 .05605 m
.60468 .04966 L
s
.60468 .04966 m
.60149 .03532 L
s
.60149 .03532 m
.61044 .02381 L
s
.61044 .02381 m
.62478 .02381 L
s
.62478 .02381 m
.63373 .03532 L
s
.63373 .03532 m
.63054 .04966 L
s
.6409 .04454 m
.63054 .04966 L
s
.63054 .04966 m
.63629 .02381 L
s
.63629 .02381 m
.6409 .04454 L
s
.61761 .06629 m
.6093 .0704 L
s
.6093 .0704 m
.60468 .04966 L
s
.60468 .04966 m
.61761 .06629 L
s
.69005 .05605 m
.6789 .0704 L
s
.6789 .0704 m
.661 .0704 L
s
.661 .0704 m
.64985 .05605 L
s
.64985 .05605 m
.65383 .03816 L
s
.65383 .03816 m
.66995 .0302 L
s
.66995 .0302 m
.68607 .03816 L
s
.68607 .03816 m
.69005 .05605 L
s
.73743 .28488 m
.71512 .28488 L
s
.71512 .28488 m
.72627 .27053 L
s
.72627 .27053 m
.73743 .28488 L
s
.60645 .36725 m
.59751 .32705 L
s
.59751 .32705 m
.61761 .31712 L
s
.61761 .31712 m
.60645 .36725 L
s
.71015 .22679 m
.66995 .22679 L
s
.66995 .22679 m
.68111 .21244 L
s
.68111 .21244 m
.71015 .22679 L
s
.60645 .77321 m
.58911 .7509 L
s
.58911 .7509 m
.60149 .7509 L
s
.60149 .7509 m
.60645 .77321 L
s
.66278 .25903 m
.66774 .23672 L
s
.66774 .23672 m
.68784 .22679 L
s
.68784 .22679 m
.66278 .25903 L
s
.15754 .07394 m
.14761 .07394 L
s
.14761 .07394 m
.16152 .05605 L
s
.16152 .05605 m
.15754 .07394 L
s
.68288 .28488 m
.66897 .26699 L
s
.66897 .26699 m
.67393 .24468 L
s
.67393 .24468 m
.68288 .28488 L
s
.86177 .29285 m
.8546 .29639 L
s
.8546 .29639 m
.84565 .28488 L
s
.84565 .28488 m
.86177 .29285 L
s
.71512 .28488 m
.69281 .28488 L
s
.69281 .28488 m
.6789 .26699 L
s
.6789 .26699 m
.71512 .28488 L
s
.72229 .2424 m
.71512 .23317 L
s
.71512 .23317 m
.71654 .22679 L
s
.71654 .22679 m
.72229 .22395 L
s
.72229 .22395 m
.73266 .22907 L
s
.73266 .22907 m
.72229 .2424 L
s
.49283 .0302 m
.49141 .02381 L
s
.49141 .02381 m
.49779 .02381 L
s
.49779 .02381 m
.49283 .0302 L
s
.72485 .21244 m
.71335 .21244 L
s
.71335 .21244 m
.70936 .20732 L
s
.70936 .20732 m
.71079 .20093 L
s
.71079 .20093 m
.71654 .19809 L
s
.71654 .19809 m
.72229 .20093 L
s
.72229 .20093 m
.72485 .21244 L
s
.74097 .23317 m
.73522 .23033 L
s
.73522 .23033 m
.73983 .22805 L
s
.73983 .22805 m
.74097 .23317 L
s
.50575 .04682 m
.50205 .04865 L
s
.50205 .04865 m
.50114 .04454 L
s
.50114 .04454 m
.50398 .04454 L
s
.50398 .04454 m
.50575 .04682 L
s
.51293 .26541 m
.50256 .26029 L
s
.50256 .26029 m
.50228 .25903 L
s
.50228 .25903 m
.50796 .25903 L
s
.50796 .25903 m
.51293 .26541 L
s
.84467 .50575 m
.83899 .50575 L
s
.83899 .50575 m
.83876 .50474 L
s
.83876 .50474 m
.84246 .50291 L
s
.84246 .50291 m
.84467 .50575 L
s
.06003 .0417 m
.04391 .04966 L
s
.04391 .04966 m
.03993 .03177 L
s
.03993 .03177 m
.06003 .0417 L
s
.661 .44766 m
.64666 .44766 L
s
.64666 .44766 m
.64552 .44254 L
s
.64552 .44254 m
.65383 .43843 L
s
.65383 .43843 m
.661 .44766 L
s
.84964 .52806 m
.84246 .53161 L
s
.84246 .53161 m
.83529 .52238 L
s
.83529 .52238 m
.84565 .51726 L
s
.84565 .51726 m
.85062 .52364 L
s
.85062 .52364 m
.84964 .52806 L
s
.87214 .49141 m
.86576 .49141 L
s
.86576 .49141 m
.87293 .48786 L
s
.87293 .48786 m
.87214 .49141 L
s
.52905 .03532 m
.52329 .03816 L
s
.52329 .03816 m
.52507 .0302 L
s
.52507 .0302 m
.52905 .03532 L
s
.86796 .49425 m
.86 .49425 L
s
.86 .49425 m
.86576 .49141 L
s
.86576 .49141 m
.86796 .49425 L
s
.66597 .33786 m
.66534 .3407 L
s
.66534 .3407 m
.65958 .33786 L
s
.65958 .33786 m
.65816 .33147 L
s
.65816 .33147 m
.661 .33147 L
s
.661 .33147 m
.66597 .33786 L
s
.63913 .40107 m
.63629 .40107 L
s
.63629 .40107 m
.63515 .39595 L
s
.63515 .39595 m
.63913 .40107 L
s
.63117 .37806 m
.62798 .36371 L
s
.62798 .36371 m
.63294 .3701 L
s
.63294 .3701 m
.63117 .37806 L
s
.74672 .22577 m
.74594 .22679 L
s
.74594 .22679 m
.74467 .22679 L
s
.74467 .22679 m
.74353 .22167 L
s
.74353 .22167 m
.74672 .22577 L
s
.61142 .30916 m
.61044 .3079 L
s
.61044 .3079 m
.61186 .30719 L
s
.61186 .30719 m
.61142 .30916 L
s
.08332 .0819 m
.0672 .07394 L
s
.0672 .07394 m
.08731 .06401 L
s
.08731 .06401 m
.08332 .0819 L
s
.69644 .20093 m
.69005 .20093 L
s
.69005 .20093 m
.68607 .19581 L
s
.68607 .19581 m
.68749 .18943 L
s
.68749 .18943 m
.69324 .18659 L
s
.69324 .18659 m
.70361 .19171 L
s
.70361 .19171 m
.69644 .20093 L
s
.54517 .26541 m
.54375 .25903 L
s
.54375 .25903 m
.55013 .25903 L
s
.55013 .25903 m
.54517 .26541 L
s
.56129 .28615 m
.56065 .28899 L
s
.56065 .28899 m
.5549 .28615 L
s
.5549 .28615 m
.55348 .27976 L
s
.55348 .27976 m
.55632 .27976 L
s
.55632 .27976 m
.56129 .28615 L
s
.75134 .23829 m
.74559 .23545 L
s
.74559 .23545 m
.7502 .23317 L
s
.7502 .23317 m
.75134 .23829 L
s
.61966 .28488 m
.61044 .28488 L
s
.61044 .28488 m
.6093 .27976 L
s
.6093 .27976 m
.61761 .27566 L
s
.61761 .27566 m
.6208 .27976 L
s
.6208 .27976 m
.61966 .28488 L
s
.09625 .08829 m
.09483 .0819 L
s
.09483 .0819 m
.10122 .0819 L
s
.10122 .0819 m
.09625 .08829 L
s
.51931 .26541 m
.51868 .26826 L
s
.51868 .26826 m
.51293 .26541 L
s
.51293 .26541 m
.51151 .25903 L
s
.51151 .25903 m
.51435 .25903 L
s
.51435 .25903 m
.51931 .26541 L
s
.85106 .50575 m
.84821 .50575 L
s
.84821 .50575 m
.84707 .50063 L
s
.84707 .50063 m
.85106 .50575 L
s
.6441 .43615 m
.6409 .4218 L
s
.6409 .4218 m
.64587 .42819 L
s
.64587 .42819 m
.6441 .43615 L
s
.12254 .14196 m
.12132 .14354 L
s
.12132 .14354 m
.11414 .14 L
s
.11414 .14 m
.12211 .14 L
s
.12211 .14 m
.12254 .14196 L
s
.72185 .90571 m
.72032 .90375 L
s
.72032 .90375 m
.72229 .90375 L
s
.72229 .90375 m
.72185 .90571 L
s
.75134 .26131 m
.74097 .26643 L
s
.74097 .26643 m
.73841 .25492 L
s
.73841 .25492 m
.75134 .26131 L
s
.56641 .29183 m
.56527 .29127 L
s
.56527 .29127 m
.56271 .27976 L
s
.56271 .27976 m
.56767 .28615 L
s
.56767 .28615 m
.56641 .29183 L
s
.60531 .26187 m
.60468 .25903 L
s
.60468 .25903 m
.60567 .26029 L
s
.60567 .26029 m
.60531 .26187 L
s
.0704 .08261 m
.06898 .0819 L
s
.06898 .0819 m
.07094 .0819 L
s
.07094 .0819 m
.0704 .08261 L
s
.08632 .09538 m
.0851 .09695 L
s
.0851 .09695 m
.07792 .09341 L
s
.07792 .09341 m
.08589 .09341 L
s
.08589 .09341 m
.08632 .09538 L
s
.84344 .50418 m
.84246 .50291 L
s
.84246 .50291 m
.84388 .50221 L
s
.84388 .50221 m
.84344 .50418 L
s
.83671 .50575 m
.8399 .50165 L
s
.8399 .50165 m
.84246 .50291 L
s
.84246 .50291 m
.83671 .50575 L
s
.74559 .21244 m
.73522 .20732 L
s
.73522 .20732 m
.74353 .20321 L
s
.74353 .20321 m
.74672 .20732 L
s
.74672 .20732 m
.74559 .21244 L
s
.11812 .12211 m
.11237 .11926 L
s
.11237 .11926 m
.11635 .11414 L
s
.11635 .11414 m
.11812 .12211 L
s
.75036 .91368 m
.74692 .9181 L
s
.74692 .9181 m
.74141 .9181 L
s
.74141 .9181 m
.73522 .91013 L
s
.73522 .91013 m
.74018 .90375 L
s
.74018 .90375 m
.74815 .90375 L
s
.74815 .90375 m
.75036 .91368 L
s
.60645 .26699 m
.60326 .26541 L
s
.60326 .26541 m
.60468 .25903 L
s
.60468 .25903 m
.60645 .26699 L
s
.85858 .52364 m
.85539 .52522 L
s
.85539 .52522 m
.85141 .5201 L
s
.85141 .5201 m
.85858 .52364 L
s
.84104 .5093 m
.83785 .51087 L
s
.83785 .51087 m
.83529 .50758 L
s
.83529 .50758 m
.83592 .50677 L
s
.83592 .50677 m
.84104 .5093 L
s
.12486 .15238 m
.12309 .1515 L
s
.12309 .1515 m
.12467 .1515 L
s
.12467 .1515 m
.12486 .15238 L
s
.7105 .90501 m
.70936 .90445 L
s
.70936 .90445 m
.70991 .90375 L
s
.70991 .90375 m
.71079 .90375 L
s
.71079 .90375 m
.7105 .90501 L
s
.72584 .91967 m
.72406 .9188 L
s
.72406 .9188 m
.72529 .91722 L
s
.72529 .91722 m
.72584 .91967 L
s
.6556 .33274 m
.65462 .33147 L
s
.65462 .33147 m
.65659 .33147 L
s
.65659 .33147 m
.6556 .33274 L
s
.87967 .45759 m
.87868 .45632 L
s
.87868 .45632 m
.8801 .45562 L
s
.8801 .45562 m
.87967 .45759 L
s
.70759 .21528 m
.70617 .21598 L
s
.70617 .21598 m
.70475 .21528 L
s
.70475 .21528 m
.7044 .2137 L
s
.7044 .2137 m
.70538 .21244 L
s
.70538 .21244 m
.70696 .21244 L
s
.70696 .21244 m
.70794 .2137 L
s
.70794 .2137 m
.70759 .21528 L
s
.54197 .27976 m
.53622 .27692 L
s
.53622 .27692 m
.5434 .27338 L
s
.5434 .27338 m
.54197 .27976 L
s
.85062 .52364 m
.84565 .51726 L
s
.84565 .51726 m
.85141 .5201 L
s
.85141 .5201 m
.85062 .52364 L
s
.71192 .19581 m
.71654 .17508 L
s
.71654 .17508 m
.72804 .17508 L
s
.72804 .17508 m
.71192 .19581 L
s
.75134 .18659 m
.73522 .16585 L
s
.73522 .16585 m
.75595 .16585 L
s
.75595 .16585 m
.75134 .18659 L
s
.74815 .22395 m
.74672 .21756 L
s
.74672 .21756 m
.75134 .21984 L
s
.75134 .21984 m
.74815 .22395 L
s
.6958 .20833 m
.69467 .20321 L
s
.69467 .20321 m
.69786 .19911 L
s
.69786 .19911 m
.70617 .20321 L
s
.70617 .20321 m
.6958 .20833 L
s
.4566 .03532 m
.44766 .02381 L
s
.44766 .02381 m
.4799 .02381 L
s
.4799 .02381 m
.4566 .03532 L
s
.75595 .16585 m
.73522 .16585 L
s
.73522 .16585 m
.75851 .15435 L
s
.75851 .15435 m
.75595 .16585 L
s
.44368 .0704 m
.42579 .0704 L
s
.42579 .0704 m
.41463 .05605 L
s
.41463 .05605 m
.41861 .03816 L
s
.41861 .03816 m
.43473 .0302 L
s
.43473 .0302 m
.46378 .04454 L
s
.46378 .04454 m
.44368 .0704 L
s
.41861 .03816 m
.4218 .02381 L
s
.4218 .02381 m
.44766 .02381 L
s
.44766 .02381 m
.41861 .03816 L
s
.70156 .14923 m
.69324 .14512 L
s
.69324 .14512 m
.70617 .12849 L
s
.70617 .12849 m
.70156 .14923 L
s
.57564 .05377 m
.56846 .04454 L
s
.56846 .04454 m
.56988 .03816 L
s
.56988 .03816 m
.57564 .03532 L
s
.57564 .03532 m
.586 .04044 L
s
.586 .04044 m
.57564 .05377 L
s
.52507 .29127 m
.51612 .28685 L
s
.51612 .28685 m
.52329 .28331 L
s
.52329 .28331 m
.52507 .29127 L
s
.52443 .31712 m
.51931 .31712 L
s
.51931 .31712 m
.5201 .31358 L
s
.5201 .31358 m
.52329 .312 L
s
.52329 .312 m
.52443 .31712 L
s
.77719 .39595 m
.76683 .39083 L
s
.76683 .39083 m
.76654 .38956 L
s
.76654 .38956 m
.77223 .38956 L
s
.77223 .38956 m
.77719 .39595 L
s
.08857 .05377 m
.08766 .05422 L
s
.08766 .05422 m
.0851 .05093 L
s
.0851 .05093 m
.08731 .04809 L
s
.08731 .04809 m
.08857 .05377 L
s
.79331 .04966 m
.78295 .04454 L
s
.78295 .04454 m
.79012 .03532 L
s
.79012 .03532 m
.79331 .04966 L
s
.72627 .74097 m
.71192 .74097 L
s
.71192 .74097 m
.71079 .73585 L
s
.71079 .73585 m
.7191 .73174 L
s
.7191 .73174 m
.72627 .74097 L
s
.11237 .04454 m
.1052 .05377 L
s
.1052 .05377 m
.09802 .04454 L
s
.09802 .04454 m
.10299 .03816 L
s
.10299 .03816 m
.10741 .03816 L
s
.10741 .03816 m
.11237 .04454 L
s
.06898 .0302 m
.06401 .02381 L
s
.06401 .02381 m
.06756 .02381 L
s
.06756 .02381 m
.06898 .0302 L
s
.49504 .31712 m
.48786 .31358 L
s
.48786 .31358 m
.48884 .30916 L
s
.48884 .30916 m
.49504 .31712 L
s
.73124 .63117 m
.73061 .63401 L
s
.73061 .63401 m
.72485 .63117 L
s
.72485 .63117 m
.72343 .62478 L
s
.72343 .62478 m
.72627 .62478 L
s
.72627 .62478 m
.73124 .63117 L
s
.7044 .69438 m
.70156 .69438 L
s
.70156 .69438 m
.70042 .68926 L
s
.70042 .68926 m
.7044 .69438 L
s
.69644 .67137 m
.69324 .65702 L
s
.69324 .65702 m
.69821 .66341 L
s
.69821 .66341 m
.69644 .67137 L
s
.60007 .03714 m
.59928 .03816 L
s
.59928 .03816 m
.59802 .03816 L
s
.59802 .03816 m
.59688 .03304 L
s
.59688 .03304 m
.60007 .03714 L
s
.53898 .6705 m
.53745 .66853 L
s
.53745 .66853 m
.53941 .66853 L
s
.53941 .66853 m
.53898 .6705 L
s
.79331 .07268 m
.78295 .0778 L
s
.78295 .0778 m
.78039 .06629 L
s
.78039 .06629 m
.79331 .07268 L
s
.77925 .39696 m
.77719 .39595 L
s
.77719 .39595 m
.77577 .38956 L
s
.77577 .38956 m
.77861 .38956 L
s
.77861 .38956 m
.78181 .39367 L
s
.78181 .39367 m
.77925 .39696 L
s
.08652 .04454 m
.0819 .04682 L
s
.0819 .04682 m
.08589 .0417 L
s
.08589 .0417 m
.08652 .04454 L
s
.70759 .71695 m
.7068 .71796 L
s
.7068 .71796 m
.70617 .71512 L
s
.70617 .71512 m
.70759 .71695 L
s
.76797 .11845 m
.76723 .11881 L
s
.76723 .11881 m
.76683 .11699 L
s
.76683 .11699 m
.76797 .11845 L
s
.09113 .05706 m
.09022 .05661 L
s
.09022 .05661 m
.09148 .05093 L
s
.09148 .05093 m
.09369 .05377 L
s
.09369 .05377 m
.09113 .05706 L
s
.76541 .12703 m
.76505 .12748 L
s
.76505 .12748 m
.76477 .12621 L
s
.76477 .12621 m
.76541 .12703 L
s
.48246 .6117 m
.48132 .61114 L
s
.48132 .61114 m
.48187 .61044 L
s
.48187 .61044 m
.48274 .61044 L
s
.48274 .61044 m
.48246 .6117 L
s
.49779 .62636 m
.49602 .62549 L
s
.49602 .62549 m
.49724 .62391 L
s
.49724 .62391 m
.49779 .62636 L
s
.72087 .62605 m
.71989 .62478 L
s
.71989 .62478 m
.72185 .62478 L
s
.72185 .62478 m
.72087 .62605 L
s
.03276 .02507 m
.03177 .02381 L
s
.03177 .02381 m
.03374 .02381 L
s
.03374 .02381 m
.03276 .02507 L
s
.56094 .02665 m
.55952 .02735 L
s
.55952 .02735 m
.55809 .02665 L
s
.55809 .02665 m
.55774 .02507 L
s
.55774 .02507 m
.55873 .02381 L
s
.55873 .02381 m
.5603 .02381 L
s
.5603 .02381 m
.56129 .02507 L
s
.56129 .02507 m
.56094 .02665 L
s
.51293 .31712 m
.50496 .31712 L
s
.50496 .31712 m
.51116 .30916 L
s
.51116 .30916 m
.51293 .31712 L
s
.03674 .0302 m
.03212 .02792 L
s
.03212 .02792 m
.03276 .02507 L
s
.03276 .02507 m
.03674 .0302 L
s
.46201 .57465 m
.45483 .5782 L
s
.45483 .5782 m
.45085 .5603 L
s
.45085 .5603 m
.46378 .56669 L
s
.46378 .56669 m
.46201 .57465 L
s
.60724 .02792 m
.60633 .02381 L
s
.60633 .02381 m
.61044 .02381 L
s
.61044 .02381 m
.60724 .02792 L
s
.56748 .67846 m
.56404 .68288 L
s
.56404 .68288 m
.55411 .68288 L
s
.55411 .68288 m
.55234 .67492 L
s
.55234 .67492 m
.55731 .66853 L
s
.55731 .66853 m
.56527 .66853 L
s
.56527 .66853 m
.56748 .67846 L
s
.58139 .03816 m
.57564 .03532 L
s
.57564 .03532 m
.58076 .03532 L
s
.58076 .03532 m
.58139 .03816 L
s
.71192 .71228 m
.70873 .71385 L
s
.70873 .71385 m
.70475 .70873 L
s
.70475 .70873 m
.71192 .71228 L
s
.03879 .03121 m
.03788 .03076 L
s
.03788 .03076 m
.03914 .02507 L
s
.03914 .02507 m
.04135 .02792 L
s
.04135 .02792 m
.03879 .03121 L
s
.59545 .04308 m
.5951 .04353 L
s
.5951 .04353 m
.59482 .04226 L
s
.59482 .04226 m
.59545 .04308 L
s
.52763 .66979 m
.52649 .66923 L
s
.52649 .66923 m
.52703 .66853 L
s
.52703 .66853 m
.52791 .66853 L
s
.52791 .66853 m
.52763 .66979 L
s
.54296 .68445 m
.54119 .68358 L
s
.54119 .68358 m
.54241 .682 L
s
.54241 .682 m
.54296 .68445 L
s
.86753 .43742 m
.86654 .43615 L
s
.86654 .43615 m
.86851 .43615 L
s
.86851 .43615 m
.86753 .43742 L
s
.73301 .64622 m
.73203 .64495 L
s
.73203 .64495 m
.73345 .64425 L
s
.73345 .64425 m
.73301 .64622 L
s
.58998 .06401 m
.58856 .06471 L
s
.58856 .06471 m
.58714 .06401 L
s
.58714 .06401 m
.58679 .06243 L
s
.58679 .06243 m
.58777 .06117 L
s
.58777 .06117 m
.58935 .06117 L
s
.58935 .06117 m
.59033 .06243 L
s
.59033 .06243 m
.58998 .06401 L
s
.70298 .70077 m
.70156 .69438 L
s
.70156 .69438 m
.70794 .69438 L
s
.70794 .69438 m
.70298 .70077 L
s
.8198 .40107 m
.81341 .40107 L
s
.81341 .40107 m
.81263 .39753 L
s
.81263 .39753 m
.8198 .40107 L
s
.59574 .06117 m
.59062 .06117 L
s
.59062 .06117 m
.59175 .05605 L
s
.59175 .05605 m
.59574 .06117 L
s
.07934 .03532 m
.07296 .03532 L
s
.07296 .03532 m
.07217 .03177 L
s
.07217 .03177 m
.07934 .03532 L
s
.53622 .30562 m
.53126 .29923 L
s
.53126 .29923 m
.54119 .29923 L
s
.54119 .29923 m
.53622 .30562 L
s
.57386 .03304 m
.57102 .03304 L
s
.57102 .03304 m
.56988 .02792 L
s
.56988 .02792 m
.57386 .03304 L
s
.54738 .63275 m
.53622 .63826 L
s
.53622 .63826 m
.52507 .63275 L
s
.52507 .63275 m
.52231 .62036 L
s
.52231 .62036 m
.53003 .61044 L
s
.53003 .61044 m
.54241 .61044 L
s
.54241 .61044 m
.55013 .62036 L
s
.55013 .62036 m
.54738 .63275 L
s
.82555 .70077 m
.81838 .66853 L
s
.81838 .66853 m
.83273 .66853 L
s
.83273 .66853 m
.82555 .70077 L
s
.4799 .34936 m
.43473 .32705 L
s
.43473 .32705 m
.45483 .31712 L
s
.45483 .31712 m
.4799 .34936 L
s
.63515 .38318 m
.63259 .38444 L
s
.63259 .38444 m
.63117 .37806 L
s
.63117 .37806 m
.63515 .37294 L
s
.63515 .37294 m
.63692 .37522 L
s
.63692 .37522 m
.63515 .38318 L
s
.76888 .29411 m
.77002 .28899 L
s
.77002 .28899 m
.77463 .29127 L
s
.77463 .29127 m
.76888 .29411 L
s
.87612 .47351 m
.87151 .47579 L
s
.87151 .47579 m
.86576 .46839 L
s
.86576 .46839 m
.86895 .46429 L
s
.86895 .46429 m
.87726 .46839 L
s
.87726 .46839 m
.87612 .47351 L
s
.71654 .21655 m
.71562 .21244 L
s
.71562 .21244 m
.71973 .21244 L
s
.71973 .21244 m
.71654 .21655 L
s
.63913 .3883 m
.63401 .39083 L
s
.63401 .39083 m
.63373 .38956 L
s
.63373 .38956 m
.6409 .38034 L
s
.6409 .38034 m
.63913 .3883 L
s
.88152 .44924 m
.8801 .44994 L
s
.8801 .44994 m
.88188 .44766 L
s
.88188 .44766 m
.88152 .44924 L
s
.69991 .21289 m
.699 .21244 L
s
.699 .21244 m
.70026 .21244 L
s
.70026 .21244 m
.69991 .21289 L
s
.71015 .2211 m
.70936 .22212 L
s
.70936 .22212 m
.70475 .21984 L
s
.70475 .21984 m
.70987 .21984 L
s
.70987 .21984 m
.71015 .2211 L
s
.62478 .32067 m
.62301 .32154 L
s
.62301 .32154 m
.62336 .31996 L
s
.62336 .31996 m
.62478 .32067 L
s
.46378 .04454 m
.43473 .0302 L
s
.43473 .0302 m
.44766 .02381 L
s
.44766 .02381 m
.46378 .04454 L
s
.41463 .05605 m
.39851 .03532 L
s
.39851 .03532 m
.4218 .02381 L
s
.4218 .02381 m
.41463 .05605 L
s
.76171 .28488 m
.75595 .28204 L
s
.75595 .28204 m
.76057 .27976 L
s
.76057 .27976 m
.76171 .28488 L
s
.48849 .04966 m
.47415 .04966 L
s
.47415 .04966 m
.48132 .04044 L
s
.48132 .04044 m
.48707 .04328 L
s
.48707 .04328 m
.48849 .04966 L
s
.71192 .15435 m
.70156 .14923 L
s
.70156 .14923 m
.70617 .12849 L
s
.70617 .12849 m
.71192 .15435 L
s
.39851 .03532 m
.38956 .02381 L
s
.38956 .02381 m
.40746 .02381 L
s
.40746 .02381 m
.39851 .03532 L
s
.70617 .1802 m
.69324 .18659 L
s
.69324 .18659 m
.68032 .1802 L
s
.68032 .1802 m
.67712 .16585 L
s
.67712 .16585 m
.68607 .15435 L
s
.68607 .15435 m
.70042 .15435 L
s
.70042 .15435 m
.70936 .16585 L
s
.70936 .16585 m
.70617 .1802 L
s
.70936 .16585 m
.69324 .14512 L
s
.69324 .14512 m
.71192 .15435 L
s
.71192 .15435 m
.70936 .16585 L
s
.71192 .19581 m
.69324 .18659 L
s
.69324 .18659 m
.71398 .18659 L
s
.71398 .18659 m
.71192 .19581 L
s
.75532 .14 m
.74416 .15435 L
s
.74416 .15435 m
.72627 .15435 L
s
.72627 .15435 m
.71512 .14 L
s
.71512 .14 m
.7191 .12211 L
s
.7191 .12211 m
.73522 .11414 L
s
.73522 .11414 m
.75134 .12211 L
s
.75134 .12211 m
.75532 .14 L
s
.43694 .31712 m
.41463 .31712 L
s
.41463 .31712 m
.43198 .29481 L
s
.43198 .29481 m
.43694 .31712 L
s
.46874 .33501 m
.45483 .31712 L
s
.45483 .31712 m
.50496 .31712 L
s
.50496 .31712 m
.46874 .33501 L
s
.45704 .40746 m
.43473 .40746 L
s
.43473 .40746 m
.46599 .36725 L
s
.46599 .36725 m
.45704 .40746 L
s
.49105 .25461 m
.47095 .24468 L
s
.47095 .24468 m
.48884 .24468 L
s
.48884 .24468 m
.49105 .25461 L
s
.42358 .40195 m
.39851 .38956 L
s
.39851 .38956 m
.44864 .38956 L
s
.44864 .38956 m
.42358 .40195 L
s
.67492 .16869 m
.67314 .16073 L
s
.67314 .16073 m
.68607 .15435 L
s
.68607 .15435 m
.67492 .16869 L
s
.42082 .38956 m
.39576 .37718 L
s
.39576 .37718 m
.38956 .34936 L
s
.38956 .34936 m
.42082 .38956 L
s
.80943 .77321 m
.80545 .75532 L
s
.80545 .75532 m
.8144 .7509 L
s
.8144 .7509 m
.80943 .77321 L
s
.40348 .36725 m
.39728 .33943 L
s
.39728 .33943 m
.41463 .31712 L
s
.41463 .31712 m
.40348 .36725 L
s
.51612 .0417 m
.51037 .04454 L
s
.51037 .04454 m
.50895 .03816 L
s
.50895 .03816 m
.51612 .0417 L
s
.87293 .45917 m
.87612 .45506 L
s
.87612 .45506 m
.87868 .45632 L
s
.87868 .45632 m
.87293 .45917 L
s
.69005 .86796 m
.68288 .87151 L
s
.68288 .87151 m
.6789 .85362 L
s
.6789 .85362 m
.69182 .86 L
s
.69182 .86 m
.69005 .86796 L
s
.7539 .21655 m
.75299 .21244 L
s
.75299 .21244 m
.75709 .21244 L
s
.75709 .21244 m
.7539 .21655 L
s
.71015 .19809 m
.70617 .20321 L
s
.70617 .20321 m
.70156 .20093 L
s
.70156 .20093 m
.70042 .19581 L
s
.70042 .19581 m
.70361 .19171 L
s
.70361 .19171 m
.70936 .19455 L
s
.70936 .19455 m
.71015 .19809 L
s
.72804 .22679 m
.72229 .22395 L
s
.72229 .22395 m
.72741 .22395 L
s
.72741 .22395 m
.72804 .22679 L
s
.64666 .41896 m
.64346 .42054 L
s
.64346 .42054 m
.63948 .41542 L
s
.63948 .41542 m
.64666 .41896 L
s
.87726 .46271 m
.87407 .46429 L
s
.87407 .46429 m
.87151 .46099 L
s
.87151 .46099 m
.87214 .46018 L
s
.87214 .46018 m
.87726 .46271 L
s
.74211 .23171 m
.74176 .23216 L
s
.74176 .23216 m
.74148 .23089 L
s
.74148 .23089 m
.74211 .23171 L
s
.75567 .96311 m
.75453 .96254 L
s
.75453 .96254 m
.75508 .96184 L
s
.75508 .96184 m
.75595 .96184 L
s
.75595 .96184 m
.75567 .96311 L
s
.70247 .2096 m
.70133 .21016 L
s
.70133 .21016 m
.70105 .2089 L
s
.70105 .2089 m
.70247 .2096 L
s
.60326 .30688 m
.60228 .30562 L
s
.60228 .30562 m
.60424 .30562 L
s
.60424 .30562 m
.60326 .30688 L
s
.66774 .35291 m
.66676 .35164 L
s
.66676 .35164 m
.66818 .35094 L
s
.66818 .35094 m
.66774 .35291 L
s
.73664 .25264 m
.73522 .25334 L
s
.73522 .25334 m
.7338 .25264 L
s
.7338 .25264 m
.73345 .25107 L
s
.73345 .25107 m
.73443 .2498 L
s
.73443 .2498 m
.73601 .2498 L
s
.73601 .2498 m
.73699 .25107 L
s
.73699 .25107 m
.73664 .25264 L
s
.63771 .40746 m
.63629 .40107 L
s
.63629 .40107 m
.64268 .40107 L
s
.64268 .40107 m
.63771 .40746 L
s
.55553 .27053 m
.54915 .27053 L
s
.54915 .27053 m
.54836 .26699 L
s
.54836 .26699 m
.55553 .27053 L
s
.74239 .2498 m
.73727 .2498 L
s
.73727 .2498 m
.73841 .24468 L
s
.73841 .24468 m
.74239 .2498 L
s
.85858 .50063 m
.86 .49425 L
s
.86 .49425 m
.86355 .49425 L
s
.86355 .49425 m
.85858 .50063 L
s
.48963 .04454 m
.48388 .0417 L
s
.48388 .0417 m
.49105 .03816 L
s
.49105 .03816 m
.48963 .04454 L
s
.72052 .22167 m
.71768 .22167 L
s
.71768 .22167 m
.71654 .21655 L
s
.71654 .21655 m
.72052 .22167 L
s
.60866 .27692 m
.60247 .28488 L
s
.60247 .28488 m
.59254 .28488 L
s
.59254 .28488 m
.58635 .27692 L
s
.58635 .27692 m
.58856 .26699 L
s
.58856 .26699 m
.59751 .26257 L
s
.59751 .26257 m
.60645 .26699 L
s
.60645 .26699 m
.60866 .27692 L
s
.84246 .27053 m
.83095 .27053 L
s
.83095 .27053 m
.83671 .24468 L
s
.83671 .24468 m
.84246 .27053 L
s
.50496 .49779 m
.49105 .4799 L
s
.49105 .4799 m
.51612 .44766 L
s
.51612 .44766 m
.50496 .49779 L
s
.65383 .4799 m
.64985 .46201 L
s
.64985 .46201 m
.66774 .46201 L
s
.66774 .46201 m
.65383 .4799 L
s
.50496 .46201 m
.48486 .45208 L
s
.48486 .45208 m
.4799 .42977 L
s
.4799 .42977 m
.50496 .46201 L
s
.90773 .30277 m
.88188 .30277 L
s
.88188 .30277 m
.90517 .29127 L
s
.90517 .29127 m
.90773 .30277 L
s
.71512 .28488 m
.699 .27692 L
s
.699 .27692 m
.73522 .25903 L
s
.73522 .25903 m
.71512 .28488 L
s
.19553 .24468 m
.18162 .22679 L
s
.18162 .22679 m
.20944 .22679 L
s
.20944 .22679 m
.19553 .24468 L
s
.75532 .28488 m
.73743 .28488 L
s
.73743 .28488 m
.72627 .27053 L
s
.72627 .27053 m
.75532 .28488 L
s
.92704 .24468 m
.91092 .22395 L
s
.91092 .22395 m
.92129 .21883 L
s
.92129 .21883 m
.92704 .24468 L
s
.40967 .33943 m
.41463 .31712 L
s
.41463 .31712 m
.45483 .31712 L
s
.45483 .31712 m
.40967 .33943 L
s
.76427 .65064 m
.74815 .64268 L
s
.74815 .64268 m
.7593 .62833 L
s
.7593 .62833 m
.76427 .65064 L
s
.43694 .31712 m
.43198 .29481 L
s
.43198 .29481 m
.44589 .27692 L
s
.44589 .27692 m
.43694 .31712 L
s
.77144 .09625 m
.73522 .11414 L
s
.73522 .11414 m
.699 .09625 L
s
.699 .09625 m
.69005 .05605 L
s
.69005 .05605 m
.71512 .02381 L
s
.71512 .02381 m
.75532 .02381 L
s
.75532 .02381 m
.78039 .05605 L
s
.78039 .05605 m
.77144 .09625 L
s
.40568 .09625 m
.36946 .11414 L
s
.36946 .11414 m
.33324 .09625 L
s
.33324 .09625 m
.3243 .05605 L
s
.3243 .05605 m
.34936 .02381 L
s
.34936 .02381 m
.38956 .02381 L
s
.38956 .02381 m
.41463 .05605 L
s
.41463 .05605 m
.40568 .09625 L
s
.68288 .54596 m
.66995 .55234 L
s
.66995 .55234 m
.66774 .54241 L
s
.66774 .54241 m
.67393 .53445 L
s
.67393 .53445 m
.68288 .54596 L
s
.81661 .27053 m
.80943 .26699 L
s
.80943 .26699 m
.82555 .25903 L
s
.82555 .25903 m
.81661 .27053 L
s
.51116 .46997 m
.51612 .44766 L
s
.51612 .44766 m
.53622 .45759 L
s
.53622 .45759 m
.51116 .46997 L
s
.58139 .4799 m
.57244 .4397 L
s
.57244 .4397 m
.58635 .45759 L
s
.58635 .45759 m
.58139 .4799 L
s
.66278 .45562 m
.64985 .46201 L
s
.64985 .46201 m
.64666 .44766 L
s
.64666 .44766 m
.65659 .44766 L
s
.65659 .44766 m
.66278 .45562 L
s
.28188 .0819 m
.27196 .0819 L
s
.27196 .0819 m
.26797 .06401 L
s
.26797 .06401 m
.28188 .0819 L
s
.80049 .40746 m
.78437 .41542 L
s
.78437 .41542 m
.78039 .39753 L
s
.78039 .39753 m
.80049 .40746 L
s
.76746 .37522 m
.73522 .37522 L
s
.73522 .37522 m
.75134 .36725 L
s
.75134 .36725 m
.76746 .37522 L
s
.74913 .45759 m
.74018 .46201 L
s
.74018 .46201 m
.73699 .44766 L
s
.73699 .44766 m
.75134 .44766 L
s
.75134 .44766 m
.74913 .45759 L
s
.63152 .66057 m
.61761 .64268 L
s
.61761 .64268 m
.62533 .63275 L
s
.62533 .63275 m
.63152 .66057 L
s
.15533 .16428 m
.14142 .14638 L
s
.14142 .14638 m
.16152 .13645 L
s
.16152 .13645 m
.15533 .16428 L
s
.68288 .34936 m
.69005 .31712 L
s
.69005 .31712 m
.69403 .33501 L
s
.69403 .33501 m
.68288 .34936 L
s
.50717 .22679 m
.47095 .24468 L
s
.47095 .24468 m
.43473 .22679 L
s
.43473 .22679 m
.42579 .18659 L
s
.42579 .18659 m
.45085 .15435 L
s
.45085 .15435 m
.49105 .15435 L
s
.49105 .15435 m
.51612 .18659 L
s
.51612 .18659 m
.50717 .22679 L
s
.74815 .64268 m
.73522 .63629 L
s
.73522 .63629 m
.74141 .62833 L
s
.74141 .62833 m
.75134 .62833 L
s
.75134 .62833 m
.74815 .64268 L
s
.75851 .15435 m
.75134 .15789 L
s
.75134 .15789 m
.75532 .14 L
s
.75532 .14 m
.75851 .15435 L
s
.78933 .53799 m
.77542 .5201 L
s
.77542 .5201 m
.79331 .5201 L
s
.79331 .5201 m
.78933 .53799 L
s
.73522 .5201 m
.7392 .50221 L
s
.7392 .50221 m
.75532 .49425 L
s
.75532 .49425 m
.73522 .5201 L
s
.80447 .57023 m
.79154 .56385 L
s
.79154 .56385 m
.80049 .55234 L
s
.80049 .55234 m
.80668 .5603 L
s
.80668 .5603 m
.80447 .57023 L
s
.4047 .13645 m
.39851 .12849 L
s
.39851 .12849 m
.40967 .11414 L
s
.40967 .11414 m
.4047 .13645 L
s
.84565 .28488 m
.82953 .27692 L
s
.82953 .27692 m
.84246 .27053 L
s
.84246 .27053 m
.84565 .28488 L
s
.68288 .54596 m
.66278 .5201 L
s
.66278 .5201 m
.6789 .52806 L
s
.6789 .52806 m
.68288 .54596 L
s
.47095 .06401 m
.45803 .0704 L
s
.45803 .0704 m
.45483 .05605 L
s
.45483 .05605 m
.4598 .04966 L
s
.4598 .04966 m
.46776 .04966 L
s
.46776 .04966 m
.47272 .05605 L
s
.47272 .05605 m
.47095 .06401 L
s
.65383 .36371 m
.65241 .35732 L
s
.65241 .35732 m
.6588 .35732 L
s
.6588 .35732 m
.65383 .36371 L
s
.64666 .33147 m
.6409 .32863 L
s
.6409 .32863 m
.64729 .32863 L
s
.64729 .32863 m
.64666 .33147 L
s
.64666 .33147 m
.64587 .33501 L
s
.64587 .33501 m
.6409 .32863 L
s
.6409 .32863 m
.64666 .33147 L
s
.49283 .0302 m
.49105 .03816 L
s
.49105 .03816 m
.48388 .0417 L
s
.48388 .0417 m
.47095 .03532 L
s
.47095 .03532 m
.4799 .02381 L
s
.4799 .02381 m
.48786 .02381 L
s
.48786 .02381 m
.49283 .0302 L
s
.64887 .35732 m
.6409 .35732 L
s
.6409 .35732 m
.64488 .3522 L
s
.64488 .3522 m
.64887 .35732 L
s
.62478 .33659 m
.62222 .33786 L
s
.62222 .33786 m
.62131 .33375 L
s
.62131 .33375 m
.62542 .33375 L
s
.62542 .33375 m
.62478 .33659 L
s
.66818 .35094 m
.661 .35448 L
s
.661 .35448 m
.66818 .34526 L
s
.66818 .34526 m
.66944 .34526 L
s
.66944 .34526 m
.66818 .35094 L
s
.73266 .25208 m
.72969 .25061 L
s
.72969 .25061 m
.72987 .2498 L
s
.72987 .2498 m
.73443 .2498 L
s
.73443 .2498 m
.73266 .25208 L
s
.72804 .9296 m
.72406 .91171 L
s
.72406 .91171 m
.74416 .92164 L
s
.74416 .92164 m
.72804 .9296 L
s
.03098 .02735 m
.02779 .02893 L
s
.02779 .02893 m
.02381 .02381 L
s
.02381 .02381 m
.03098 .02735 L
s
.43473 .0819 m
.43075 .07678 L
s
.43075 .07678 m
.43217 .0704 L
s
.43217 .0704 m
.44368 .0704 L
s
.44368 .0704 m
.43473 .0819 L
s
.7392 .23545 m
.73522 .24057 L
s
.73522 .24057 m
.72691 .23647 L
s
.72691 .23647 m
.73266 .22907 L
s
.73266 .22907 m
.73841 .23191 L
s
.73841 .23191 m
.7392 .23545 L
s
.75709 .26415 m
.75134 .26131 L
s
.75134 .26131 m
.75646 .26131 L
s
.75646 .26131 m
.75709 .26415 L
s
.63373 .36087 m
.62798 .36371 L
s
.62798 .36371 m
.62656 .35732 L
s
.62656 .35732 m
.63373 .36087 L
s
.75134 .26131 m
.74672 .25903 L
s
.74672 .25903 m
.75311 .25903 L
s
.75311 .25903 m
.75134 .26131 L
s
.39851 .03532 m
.40746 .02381 L
s
.40746 .02381 m
.4218 .02381 L
s
.4218 .02381 m
.39851 .03532 L
s
.70042 .15435 m
.68607 .15435 L
s
.68607 .15435 m
.69324 .14512 L
s
.69324 .14512 m
.70042 .15435 L
s
.72485 .17097 m
.70617 .1802 L
s
.70617 .1802 m
.71192 .15435 L
s
.71192 .15435 m
.72485 .17097 L
s
.81199 .55234 m
.80368 .54823 L
s
.80368 .54823 m
.80766 .54311 L
s
.80766 .54311 m
.81405 .54311 L
s
.81405 .54311 m
.81199 .55234 L
s
.06401 .07552 m
.06003 .0704 L
s
.06003 .0704 m
.0672 .06117 L
s
.0672 .06117 m
.08013 .06756 L
s
.08013 .06756 m
.06401 .07552 L
s
.08908 .10776 m
.07792 .09341 L
s
.07792 .09341 m
.08687 .09783 L
s
.08687 .09783 m
.08908 .10776 L
s
.68012 .85913 m
.6789 .8607 L
s
.6789 .8607 m
.67172 .85716 L
s
.67172 .85716 m
.67968 .85716 L
s
.67968 .85716 m
.68012 .85913 L
s
.84743 .50221 m
.84565 .50133 L
s
.84565 .50133 m
.84707 .50063 L
s
.84707 .50063 m
.84743 .50221 L
s
.71398 .18659 m
.69324 .18659 L
s
.69324 .18659 m
.71654 .17508 L
s
.71654 .17508 m
.71398 .18659 L
s
.76028 .9583 m
.75134 .95388 L
s
.75134 .95388 m
.75851 .95034 L
s
.75851 .95034 m
.76028 .9583 L
s
.61442 .30277 m
.61044 .3079 L
s
.61044 .3079 m
.60149 .29639 L
s
.60149 .29639 m
.613 .29639 L
s
.613 .29639 m
.61442 .30277 L
s
.73522 .16585 m
.72485 .17097 L
s
.72485 .17097 m
.71192 .15435 L
s
.71192 .15435 m
.73522 .16585 L
s
.74815 .20093 m
.73522 .20732 L
s
.73522 .20732 m
.71192 .19581 L
s
.71192 .19581 m
.72804 .17508 L
s
.72804 .17508 m
.74239 .17508 L
s
.74239 .17508 m
.75134 .18659 L
s
.75134 .18659 m
.74815 .20093 L
s
.74239 .17508 m
.71654 .17508 L
s
.71654 .17508 m
.73522 .16585 L
s
.73522 .16585 m
.74239 .17508 L
s
.46378 .04454 m
.4566 .03532 L
s
.4566 .03532 m
.4799 .02381 L
s
.4799 .02381 m
.46378 .04454 L
s
.27913 .14284 m
.27196 .14638 L
s
.27196 .14638 m
.25903 .14 L
s
.25903 .14 m
.26797 .12849 L
s
.26797 .12849 m
.27594 .12849 L
s
.27594 .12849 m
.2809 .13488 L
s
.2809 .13488 m
.27913 .14284 L
s
.89082 .40746 m
.88763 .40335 L
s
.88763 .40335 m
.89224 .40107 L
s
.89224 .40107 m
.89082 .40746 L
s
.5782 .12723 m
.57564 .12849 L
s
.57564 .12849 m
.57421 .12211 L
s
.57421 .12211 m
.5782 .12723 L
s
.86895 .41258 m
.86433 .4103 L
s
.86433 .4103 m
.87072 .4103 L
s
.87072 .4103 m
.86895 .41258 L
s
.31137 .14284 m
.3042 .14638 L
s
.3042 .14638 m
.29702 .14284 L
s
.29702 .14284 m
.29383 .12849 L
s
.29383 .12849 m
.30818 .12849 L
s
.30818 .12849 m
.31314 .13488 L
s
.31314 .13488 m
.31137 .14284 L
s
.6154 .43615 m
.61044 .42977 L
s
.61044 .42977 m
.62036 .42977 L
s
.62036 .42977 m
.6154 .43615 L
s
.60547 .40746 m
.60326 .4103 L
s
.60326 .4103 m
.5983 .40391 L
s
.5983 .40391 m
.60007 .39595 L
s
.60007 .39595 m
.60326 .39753 L
s
.60326 .39753 m
.60547 .40746 L
s
.89338 .39595 m
.89019 .39184 L
s
.89019 .39184 m
.8948 .38956 L
s
.8948 .38956 m
.89338 .39595 L
s
.34759 .4218 m
.33722 .42693 L
s
.33722 .42693 m
.33324 .4218 L
s
.33324 .4218 m
.34042 .41258 L
s
.34042 .41258 m
.34617 .41542 L
s
.34617 .41542 m
.34759 .4218 L
s
.89019 .20093 m
.88649 .19911 L
s
.88649 .19911 m
.88905 .19581 L
s
.88905 .19581 m
.89019 .20093 L
s
.59112 .45917 m
.586 .45917 L
s
.586 .45917 m
.58714 .45404 L
s
.58714 .45404 m
.59033 .45562 L
s
.59033 .45562 m
.59112 .45917 L
s
.22616 .28204 m
.22458 .28204 L
s
.22458 .28204 m
.21563 .27053 L
s
.21563 .27053 m
.22458 .27495 L
s
.22458 .27495 m
.22616 .28204 L
s
.92732 .21016 m
.92436 .21163 L
s
.92436 .21163 m
.92385 .21097 L
s
.92385 .21097 m
.9259 .20833 L
s
.9259 .20833 m
.92704 .2089 L
s
.92704 .2089 m
.92732 .21016 L
s
.35113 .17666 m
.34936 .17578 L
s
.34936 .17578 m
.35078 .17508 L
s
.35078 .17508 m
.35113 .17666 L
s
.75453 .90375 m
.74559 .89224 L
s
.74559 .89224 m
.75851 .88586 L
s
.75851 .88586 m
.75453 .90375 L
s
.61044 .40107 m
.60149 .38956 L
s
.60149 .38956 m
.60184 .38799 L
s
.60184 .38799 m
.60823 .39114 L
s
.60823 .39114 m
.61044 .40107 L
s
.35334 .44766 m
.35113 .44482 L
s
.35113 .44482 m
.35291 .44569 L
s
.35291 .44569 m
.35334 .44766 L
s
.87704 .21199 m
.87612 .21244 L
s
.87612 .21244 m
.87691 .21143 L
s
.87691 .21143 m
.87704 .21199 L
s
.88996 .21016 m
.88535 .21244 L
s
.88535 .21244 m
.88854 .20833 L
s
.88854 .20833 m
.88968 .2089 L
s
.88968 .2089 m
.88996 .21016 L
s
.85141 .40391 m
.85027 .40335 L
s
.85027 .40335 m
.85106 .40234 L
s
.85106 .40234 m
.85141 .40391 L
s
.85027 .40335 m
.84821 .40436 L
s
.84821 .40436 m
.84565 .40107 L
s
.84565 .40107 m
.85027 .40335 L
s
.25008 .12849 m
.23573 .12849 L
s
.23573 .12849 m
.23716 .12211 L
s
.23716 .12211 m
.24291 .11926 L
s
.24291 .11926 m
.25008 .12849 L
s
.91554 .20321 m
.91184 .20504 L
s
.91184 .20504 m
.91092 .20093 L
s
.91092 .20093 m
.91554 .20321 L
s
.34759 .16073 m
.34361 .16585 L
s
.34361 .16585 m
.33644 .16231 L
s
.33644 .16231 m
.33545 .15789 L
s
.33545 .15789 m
.34042 .1515 L
s
.34042 .1515 m
.34617 .15435 L
s
.34617 .15435 m
.34759 .16073 L
s
.85744 .38956 m
.86063 .38546 L
s
.86063 .38546 m
.86319 .38672 L
s
.86319 .38672 m
.85744 .38956 L
s
.59254 .42977 m
.59432 .4218 L
s
.59432 .4218 m
.60149 .42535 L
s
.60149 .42535 m
.59254 .42977 L
s
.85744 .38956 m
.85283 .39184 L
s
.85283 .39184 m
.85681 .38672 L
s
.85681 .38672 m
.85744 .38956 L
s
.28232 .12849 m
.27515 .09625 L
s
.27515 .09625 m
.28808 .10264 L
s
.28808 .10264 m
.28232 .12849 L
s
.24291 .09625 m
.24866 .0704 L
s
.24866 .0704 m
.27196 .0819 L
s
.27196 .0819 m
.24291 .09625 L
s
.87612 .39879 m
.87726 .39367 L
s
.87726 .39367 m
.88188 .39595 L
s
.88188 .39595 m
.87612 .39879 L
s
.29781 .14638 m
.29383 .1515 L
s
.29383 .1515 m
.28488 .14 L
s
.28488 .14 m
.29639 .14 L
s
.29639 .14 m
.29781 .14638 L
s
.8399 .16585 m
.82953 .17097 L
s
.82953 .17097 m
.81661 .15435 L
s
.81661 .15435 m
.8399 .16585 L
s
.27196 .0819 m
.24866 .0704 L
s
.24866 .0704 m
.25185 .05605 L
s
.25185 .05605 m
.27196 .0819 L
s
.85283 .20093 m
.8399 .20732 L
s
.8399 .20732 m
.82697 .20093 L
s
.82697 .20093 m
.82122 .17508 L
s
.82122 .17508 m
.84707 .17508 L
s
.84707 .17508 m
.85602 .18659 L
s
.85602 .18659 m
.85283 .20093 L
s
.85602 .18659 m
.8399 .16585 L
s
.8399 .16585 m
.85858 .17508 L
s
.85858 .17508 m
.85602 .18659 L
s
.33005 .0819 m
.31854 .0819 L
s
.31854 .0819 m
.3243 .05605 L
s
.3243 .05605 m
.33005 .0819 L
s
.52329 .03816 m
.51612 .0417 L
s
.51612 .0417 m
.50895 .03816 L
s
.50895 .03816 m
.50575 .02381 L
s
.50575 .02381 m
.5201 .02381 L
s
.5201 .02381 m
.52507 .0302 L
s
.52507 .0302 m
.52329 .03816 L
s
.6588 .39311 m
.65383 .38672 L
s
.65383 .38672 m
.66022 .38672 L
s
.66022 .38672 m
.6588 .39311 L
s
.63771 .39469 m
.63515 .39595 L
s
.63515 .39595 m
.63424 .39184 L
s
.63424 .39184 m
.63834 .39184 L
s
.63834 .39184 m
.63771 .39469 L
s
.8801 .45562 m
.87868 .45632 L
s
.87868 .45632 m
.87612 .45506 L
s
.87612 .45506 m
.8801 .44994 L
s
.8801 .44994 m
.88137 .44994 L
s
.88137 .44994 m
.8801 .45562 L
s
.70361 .21472 m
.70064 .21325 L
s
.70064 .21325 m
.70083 .21244 L
s
.70083 .21244 m
.70538 .21244 L
s
.70538 .21244 m
.70361 .21472 L
s
.69005 .86796 m
.69182 .86 L
s
.69182 .86 m
.699 .86355 L
s
.699 .86355 m
.69005 .86796 L
s
.7539 .21655 m
.75134 .21984 L
s
.75134 .21984 m
.74467 .21655 L
s
.74467 .21655 m
.74559 .21244 L
s
.74559 .21244 m
.75299 .21244 L
s
.75299 .21244 m
.7539 .21655 L
s
.70156 .20093 m
.69786 .19911 L
s
.69786 .19911 m
.70042 .19581 L
s
.70042 .19581 m
.70156 .20093 L
s
.65958 .36087 m
.65702 .3596 L
s
.65702 .3596 m
.661 .35448 L
s
.661 .35448 m
.66739 .35448 L
s
.66739 .35448 m
.66676 .35732 L
s
.66676 .35732 m
.65958 .36087 L
s
.73636 .25391 m
.73727 .2498 L
s
.73727 .2498 m
.73955 .2498 L
s
.73955 .2498 m
.73636 .25391 L
s
.04391 .04966 m
.03276 .03532 L
s
.03276 .03532 m
.0417 .03973 L
s
.0417 .03973 m
.04391 .04966 L
s
.73869 .21016 m
.73408 .21244 L
s
.73408 .21244 m
.73727 .20833 L
s
.73727 .20833 m
.73841 .2089 L
s
.73841 .2089 m
.73869 .21016 L
s
.56306 .28134 m
.56129 .28046 L
s
.56129 .28046 m
.56271 .27976 L
s
.56271 .27976 m
.56306 .28134 L
s
.72229 .90375 m
.70617 .89579 L
s
.70617 .89579 m
.72627 .88586 L
s
.72627 .88586 m
.72229 .90375 L
s
.87868 .46201 m
.87726 .46271 L
s
.87726 .46271 m
.87214 .46018 L
s
.87214 .46018 m
.87293 .45917 L
s
.87293 .45917 m
.87931 .45917 L
s
.87931 .45917 m
.87868 .46201 L
s
.70731 .21655 m
.70822 .21244 L
s
.70822 .21244 m
.7105 .21244 L
s
.7105 .21244 m
.70731 .21655 L
s
.74176 .23216 m
.74097 .23317 L
s
.74097 .23317 m
.74148 .23089 L
s
.74148 .23089 m
.74176 .23216 L
s
.75453 .96254 m
.75311 .96184 L
s
.75311 .96184 m
.75508 .96184 L
s
.75508 .96184 m
.75453 .96254 L
s
.70133 .21016 m
.69837 .21163 L
s
.69837 .21163 m
.69786 .21097 L
s
.69786 .21097 m
.69991 .20833 L
s
.69991 .20833 m
.70105 .2089 L
s
.70105 .2089 m
.70133 .21016 L
s
.76383 .97422 m
.76206 .97335 L
s
.76206 .97335 m
.76363 .97335 L
s
.76363 .97335 m
.76383 .97422 L
s
.61726 .31555 m
.61682 .31611 L
s
.61682 .31611 m
.61619 .31529 L
s
.61619 .31529 m
.6171 .31484 L
s
.6171 .31484 m
.61726 .31555 L
s
.7338 .25264 m
.73266 .25208 L
s
.73266 .25208 m
.73345 .25107 L
s
.73345 .25107 m
.7338 .25264 L
s
.73266 .25208 m
.73061 .25309 L
s
.73061 .25309 m
.72804 .2498 L
s
.72804 .2498 m
.73266 .25208 L
s
.661 .33147 m
.64666 .33147 L
s
.64666 .33147 m
.64808 .32508 L
s
.64808 .32508 m
.65383 .32224 L
s
.65383 .32224 m
.661 .33147 L
s
.72691 .20321 m
.72321 .20504 L
s
.72321 .20504 m
.72229 .20093 L
s
.72229 .20093 m
.72691 .20321 L
s
.55952 .26541 m
.55553 .27053 L
s
.55553 .27053 m
.54836 .26699 L
s
.54836 .26699 m
.54738 .26257 L
s
.54738 .26257 m
.55013 .25903 L
s
.55013 .25903 m
.55809 .25903 L
s
.55809 .25903 m
.55952 .26541 L
s
.74097 .23317 m
.73983 .22805 L
s
.73983 .22805 m
.74239 .22679 L
s
.74239 .22679 m
.74097 .23317 L
s
.73983 .23829 m
.74303 .23419 L
s
.74303 .23419 m
.74559 .23545 L
s
.74559 .23545 m
.73983 .23829 L
s
.72741 .24899 m
.72691 .24834 L
s
.72691 .24834 m
.72896 .24569 L
s
.72896 .24569 m
.73152 .24696 L
s
.73152 .24696 m
.72741 .24899 L
s
.74331 .21244 m
.74394 .21163 L
s
.74394 .21163 m
.74445 .21188 L
s
.74445 .21188 m
.74331 .21244 L
s
.56492 .28969 m
.56448 .29025 L
s
.56448 .29025 m
.56385 .28944 L
s
.56385 .28944 m
.56476 .28899 L
s
.56476 .28899 m
.56492 .28969 L
s
.55092 .28103 m
.54994 .27976 L
s
.54994 .27976 m
.5519 .27976 L
s
.5519 .27976 m
.55092 .28103 L
s
.8144 .54154 m
.81341 .54027 L
s
.81341 .54027 m
.81484 .53957 L
s
.81484 .53957 m
.8144 .54154 L
s
.76284 .29 m
.76171 .28944 L
s
.76171 .28944 m
.76249 .28843 L
s
.76249 .28843 m
.76284 .29 L
s
.49326 .04809 m
.49204 .04966 L
s
.49204 .04966 m
.49007 .04966 L
s
.49007 .04966 m
.48884 .04809 L
s
.48884 .04809 m
.48928 .04612 L
s
.48928 .04612 m
.49105 .04524 L
s
.49105 .04524 m
.49283 .04612 L
s
.49283 .04612 m
.49326 .04809 L
s
.64666 .38318 m
.6409 .38034 L
s
.6409 .38034 m
.64488 .37522 L
s
.64488 .37522 m
.64666 .38318 L
s
.73983 .23829 m
.73522 .24057 L
s
.73522 .24057 m
.7392 .23545 L
s
.7392 .23545 m
.73983 .23829 L
s
.26876 .32863 m
.2608 .32863 L
s
.2608 .32863 m
.25584 .32224 L
s
.25584 .32224 m
.25903 .32067 L
s
.25903 .32067 m
.26797 .32508 L
s
.26797 .32508 m
.26876 .32863 L
s
.74672 .84565 m
.74097 .84281 L
s
.74097 .84281 m
.74815 .83927 L
s
.74815 .83927 m
.74672 .84565 L
s
.87818 .43103 m
.87151 .43433 L
s
.87151 .43433 m
.86895 .43103 L
s
.86895 .43103 m
.87356 .4251 L
s
.87356 .4251 m
.87726 .42693 L
s
.87726 .42693 m
.87818 .43103 L
s
.88188 .4292 m
.87818 .43103 L
s
.87818 .43103 m
.87726 .42693 L
s
.87726 .42693 m
.88188 .4292 L
s
.2662 .31712 m
.25185 .31712 L
s
.25185 .31712 m
.25087 .31586 L
s
.25087 .31586 m
.25726 .3127 L
s
.25726 .3127 m
.2662 .31712 L
s
.88188 .44766 m
.88045 .44583 L
s
.88045 .44583 m
.88159 .44639 L
s
.88159 .44639 m
.88188 .44766 L
s
.88188 .44766 m
.88159 .44639 L
s
.88159 .44639 m
.8821 .44664 L
s
.8821 .44664 m
.88188 .44766 L
s
.76171 .96468 m
.76313 .9583 L
s
.76313 .9583 m
.7647 .9583 L
s
.7647 .9583 m
.76569 .95956 L
s
.76569 .95956 m
.76171 .96468 L
s
.30995 .3816 m
.30818 .38073 L
s
.30818 .38073 m
.31039 .37964 L
s
.31039 .37964 m
.30995 .3816 L
s
.84707 .17508 m
.82122 .17508 L
s
.82122 .17508 m
.8399 .16585 L
s
.8399 .16585 m
.84707 .17508 L
s
.87151 .19171 m
.85283 .20093 L
s
.85283 .20093 m
.85858 .17508 L
s
.85858 .17508 m
.87151 .19171 L
s
.74815 .86228 m
.74239 .86512 L
s
.74239 .86512 m
.74416 .85716 L
s
.74416 .85716 m
.74815 .86228 L
s
.57741 .08475 m
.57102 .08475 L
s
.57102 .08475 m
.57421 .0704 L
s
.57421 .0704 m
.58139 .07962 L
s
.58139 .07962 m
.57741 .08475 L
s
.31854 .0819 m
.3042 .0819 L
s
.3042 .0819 m
.3243 .05605 L
s
.3243 .05605 m
.31854 .0819 L
s
.88188 .18659 m
.87151 .19171 L
s
.87151 .19171 m
.86895 .1802 L
s
.86895 .1802 m
.88188 .18659 L
s
.33722 .11414 m
.32607 .12849 L
s
.32607 .12849 m
.30818 .12849 L
s
.30818 .12849 m
.29702 .11414 L
s
.29702 .11414 m
.301 .09625 L
s
.301 .09625 m
.31712 .08829 L
s
.31712 .08829 m
.33324 .09625 L
s
.33324 .09625 m
.33722 .11414 L
s
.301 .09625 m
.3042 .0819 L
s
.3042 .0819 m
.33005 .0819 L
s
.33005 .0819 m
.301 .09625 L
s
.30818 .12849 m
.28232 .12849 L
s
.28232 .12849 m
.28488 .11699 L
s
.28488 .11699 m
.30818 .12849 L
s
.30818 .06401 m
.28808 .07394 L
s
.28808 .07394 m
.26797 .06401 L
s
.26797 .06401 m
.26301 .0417 L
s
.26301 .0417 m
.27692 .02381 L
s
.27692 .02381 m
.29923 .02381 L
s
.29923 .02381 m
.31314 .0417 L
s
.31314 .0417 m
.30818 .06401 L
s
.49105 .4799 m
.48486 .45208 L
s
.48486 .45208 m
.50496 .46201 L
s
.50496 .46201 m
.49105 .4799 L
s
.58139 .4799 m
.53622 .45759 L
s
.53622 .45759 m
.57642 .45759 L
s
.57642 .45759 m
.58139 .4799 L
s
.58635 .50221 m
.57244 .5201 L
s
.57244 .5201 m
.56129 .46997 L
s
.56129 .46997 m
.58635 .50221 L
s
.3444 .1106 m
.33821 .11856 L
s
.33821 .11856 m
.33324 .09625 L
s
.33324 .09625 m
.3444 .1106 L
s
.56129 .52561 m
.53622 .53799 L
s
.53622 .53799 m
.56748 .49779 L
s
.56748 .49779 m
.56129 .52561 L
s
.82776 .20448 m
.82059 .20093 L
s
.82059 .20093 m
.82378 .18659 L
s
.82378 .18659 m
.82776 .20448 L
s
.52507 .53248 m
.5 .5201 L
s
.5 .5201 m
.55013 .5201 L
s
.55013 .5201 m
.52507 .53248 L
s
.84565 .23317 m
.83848 .22395 L
s
.83848 .22395 m
.86177 .21244 L
s
.86177 .21244 m
.84565 .23317 L
s
.52231 .5201 m
.5 .5201 L
s
.5 .5201 m
.49105 .4799 L
s
.49105 .4799 m
.52231 .5201 L
s
.78358 .30277 m
.77463 .29127 L
s
.77463 .29127 m
.78756 .28488 L
s
.78756 .28488 m
.78358 .30277 L
s
.66774 .46201 m
.64985 .46201 L
s
.64985 .46201 m
.6789 .44766 L
s
.6789 .44766 m
.66774 .46201 L
s
.0672 .03816 m
.06003 .0417 L
s
.06003 .0417 m
.0471 .03532 L
s
.0471 .03532 m
.05605 .02381 L
s
.05605 .02381 m
.06401 .02381 L
s
.06401 .02381 m
.06898 .0302 L
s
.06898 .0302 m
.0672 .03816 L
s
.58139 .02792 m
.5782 .02381 L
s
.5782 .02381 m
.58458 .02381 L
s
.58458 .02381 m
.58139 .02792 L
s
.59318 .04966 m
.59175 .04328 L
s
.59175 .04328 m
.59637 .04556 L
s
.59637 .04556 m
.59318 .04966 L
s
.09944 .03816 m
.09227 .0417 L
s
.09227 .0417 m
.0851 .03816 L
s
.0851 .03816 m
.0819 .02381 L
s
.0819 .02381 m
.09625 .02381 L
s
.09625 .02381 m
.10122 .0302 L
s
.10122 .0302 m
.09944 .03816 L
s
.58076 .03532 m
.57564 .03532 L
s
.57564 .03532 m
.57962 .0302 L
s
.57962 .0302 m
.58076 .03532 L
s
.58025 .0597 m
.5782 .05706 L
s
.5782 .05706 m
.58025 .05605 L
s
.58025 .05605 m
.5823 .05706 L
s
.5823 .05706 m
.58025 .0597 L
s
.58076 .73813 m
.57918 .73813 L
s
.57918 .73813 m
.57023 .72662 L
s
.57023 .72662 m
.57918 .73104 L
s
.57918 .73104 m
.58076 .73813 L
s
.82903 .41953 m
.82811 .41998 L
s
.82811 .41998 m
.82555 .41668 L
s
.82555 .41668 m
.82776 .41384 L
s
.82776 .41384 m
.82903 .41953 L
s
.70219 .66853 m
.69324 .65702 L
s
.69324 .65702 m
.70617 .65064 L
s
.70617 .65064 m
.70219 .66853 L
s
.46122 .31712 m
.45483 .31712 L
s
.45483 .31712 m
.45085 .29923 L
s
.45085 .29923 m
.46378 .30562 L
s
.46378 .30562 m
.46122 .31712 L
s
.85283 .4103 m
.84565 .41953 L
s
.84565 .41953 m
.83848 .4103 L
s
.83848 .4103 m
.84344 .40391 L
s
.84344 .40391 m
.84786 .40391 L
s
.84786 .40391 m
.85283 .4103 L
s
.80943 .39595 m
.80447 .38956 L
s
.80447 .38956 m
.80801 .38956 L
s
.80801 .38956 m
.80943 .39595 L
s
.56846 .04454 m
.56527 .04044 L
s
.56527 .04044 m
.56988 .03816 L
s
.56988 .03816 m
.56846 .04454 L
s
.81341 .40107 m
.80943 .39595 L
s
.80943 .39595 m
.81164 .39311 L
s
.81164 .39311 m
.81341 .40107 L
s
.45164 .56385 m
.44368 .56385 L
s
.44368 .56385 m
.43871 .55746 L
s
.43871 .55746 m
.44191 .55588 L
s
.44191 .55588 m
.45085 .5603 L
s
.45085 .5603 m
.45164 .56385 L
s
.51931 .31712 m
.51293 .31712 L
s
.51293 .31712 m
.51214 .31358 L
s
.51214 .31358 m
.51931 .31712 L
s
.55952 .31712 m
.54162 .31712 L
s
.54162 .31712 m
.55057 .3127 L
s
.55057 .3127 m
.55952 .31712 L
s
.70936 .72947 m
.71079 .72308 L
s
.71079 .72308 m
.71236 .72308 L
s
.71236 .72308 m
.71335 .72434 L
s
.71335 .72434 m
.70936 .72947 L
s
.49283 .61682 m
.49105 .61595 L
s
.49105 .61595 m
.49326 .61485 L
s
.49326 .61485 m
.49283 .61682 L
s
.69005 .6299 m
.69324 .61556 L
s
.69324 .61556 m
.70617 .62194 L
s
.70617 .62194 m
.69005 .6299 L
s
.11955 .06401 m
.11237 .06756 L
s
.11237 .06756 m
.1052 .06401 L
s
.1052 .06401 m
.10343 .05605 L
s
.10343 .05605 m
.11237 .04454 L
s
.11237 .04454 m
.12132 .05605 L
s
.12132 .05605 m
.11955 .06401 L
s
.56925 .68642 m
.56129 .68642 L
s
.56129 .68642 m
.56748 .67846 L
s
.56748 .67846 m
.56925 .68642 L
s
.54197 .68004 m
.53401 .68004 L
s
.53401 .68004 m
.52905 .67365 L
s
.52905 .67365 m
.53224 .67207 L
s
.53224 .67207 m
.54119 .67649 L
s
.54119 .67649 m
.54197 .68004 L
s
.71768 .71512 m
.71192 .71228 L
s
.71192 .71228 m
.7191 .70873 L
s
.7191 .70873 m
.71768 .71512 L
s
.52649 .61044 m
.5201 .61044 L
s
.5201 .61044 m
.51754 .59893 L
s
.51754 .59893 m
.52329 .59609 L
s
.52329 .59609 m
.52905 .59893 L
s
.52905 .59893 m
.52649 .61044 L
s
.699 .60816 m
.6958 .60405 L
s
.6958 .60405 m
.70219 .60405 L
s
.70219 .60405 m
.699 .60816 L
s
.5782 .72662 m
.57023 .72662 L
s
.57023 .72662 m
.56527 .72024 L
s
.56527 .72024 m
.56846 .71866 L
s
.56846 .71866 m
.57741 .72308 L
s
.57741 .72308 m
.5782 .72662 L
s
.82697 .4103 m
.82236 .41258 L
s
.82236 .41258 m
.82634 .40746 L
s
.82634 .40746 m
.82697 .4103 L
s
.48707 .31712 m
.46918 .31712 L
s
.46918 .31712 m
.47813 .3127 L
s
.47813 .3127 m
.48707 .31712 L
s
.67314 .56669 m
.67456 .5603 L
s
.67456 .5603 m
.67614 .5603 L
s
.67614 .5603 m
.67712 .56157 L
s
.67712 .56157 m
.67314 .56669 L
s
.78295 .0778 m
.78181 .07836 L
s
.78181 .07836 m
.78216 .07678 L
s
.78216 .07678 m
.78295 .0778 L
s
.70298 .688 m
.70617 .67365 L
s
.70617 .67365 m
.7191 .68004 L
s
.7191 .68004 m
.70298 .688 L
s
.53941 .66853 m
.52507 .66853 L
s
.52507 .66853 m
.52408 .66726 L
s
.52408 .66726 m
.53047 .66411 L
s
.53047 .66411 m
.53941 .66853 L
s
.55234 .61044 m
.5488 .61044 L
s
.5488 .61044 m
.55057 .60956 L
s
.55057 .60956 m
.55234 .61044 L
s
.68607 .62478 m
.68635 .62352 L
s
.68635 .62352 m
.68705 .62352 L
s
.68705 .62352 m
.68607 .62478 L
s
.68351 .61328 m
.68493 .60689 L
s
.68493 .60689 m
.68651 .60689 L
s
.68651 .60689 m
.68749 .60816 L
s
.68749 .60816 m
.68351 .61328 L
s
.82555 .41668 m
.82457 .41542 L
s
.82457 .41542 m
.82654 .41542 L
s
.82654 .41542 m
.82555 .41668 L
s
.82953 .4218 m
.82492 .41953 L
s
.82492 .41953 m
.82555 .41668 L
s
.82555 .41668 m
.82953 .4218 L
s
.60354 .04454 m
.59893 .04682 L
s
.59893 .04682 m
.59432 .04454 L
s
.59432 .04454 m
.60149 .03532 L
s
.60149 .03532 m
.60354 .04454 L
s
.69005 .5782 m
.68493 .5782 L
s
.68493 .5782 m
.68607 .57307 L
s
.68607 .57307 m
.69005 .5782 L
s
.78933 .09625 m
.78579 .09625 L
s
.78579 .09625 m
.78358 .09341 L
s
.78358 .09341 m
.785 .08702 L
s
.785 .08702 m
.79012 .08702 L
s
.79012 .08702 m
.79331 .09113 L
s
.79331 .09113 m
.78933 .09625 L
s
.54517 .61398 m
.54241 .61044 L
s
.54241 .61044 m
.55234 .61044 L
s
.55234 .61044 m
.54517 .61398 L
s
.8399 .40391 m
.84167 .39595 L
s
.84167 .39595 m
.84388 .39879 L
s
.84388 .39879 m
.8399 .40391 L
s
.83159 .42282 m
.83067 .42237 L
s
.83067 .42237 m
.83194 .41668 L
s
.83194 .41668 m
.83415 .41953 L
s
.83415 .41953 m
.83159 .42282 L
s
.67058 .55518 m
.67093 .55361 L
s
.67093 .55361 m
.67137 .55417 L
s
.67137 .55417 m
.67058 .55518 L
s
.77833 .07186 m
.7776 .07223 L
s
.7776 .07223 m
.77742 .07141 L
s
.77742 .07141 m
.77798 .07141 L
s
.77798 .07141 m
.77833 .07186 L
s
.77656 .08601 m
.77628 .08475 L
s
.77628 .08475 m
.77754 .08475 L
s
.77754 .08475 m
.77656 .08601 L
s
.45262 .56827 m
.45085 .56739 L
s
.45085 .56739 m
.45208 .56581 L
s
.45208 .56581 m
.45262 .56827 L
s
.77321 .39083 m
.77223 .38956 L
s
.77223 .38956 m
.77419 .38956 L
s
.77419 .38956 m
.77321 .39083 L
s
.08731 .04809 m
.08608 .04966 L
s
.08608 .04966 m
.08411 .04966 L
s
.08411 .04966 m
.08289 .04809 L
s
.08289 .04809 m
.08332 .04612 L
s
.08332 .04612 m
.0851 .04524 L
s
.0851 .04524 m
.08687 .04612 L
s
.08687 .04612 m
.08731 .04809 L
s
.55013 .70077 m
.54517 .69438 L
s
.54517 .69438 m
.55234 .69084 L
s
.55234 .69084 m
.55013 .70077 L
s
.83848 .4103 m
.8399 .40391 L
s
.8399 .40391 m
.84344 .40391 L
s
.84344 .40391 m
.83848 .4103 L
s
.1052 .03532 m
.11414 .02381 L
s
.11414 .02381 m
.12849 .02381 L
s
.12849 .02381 m
.1052 .03532 L
s
.63373 .03532 m
.62478 .02381 L
s
.62478 .02381 m
.63629 .02381 L
s
.63629 .02381 m
.63373 .03532 L
s
.63629 .06528 m
.61761 .05605 L
s
.61761 .05605 m
.6409 .04454 L
s
.6409 .04454 m
.63629 .06528 L
s
.7191 .73174 m
.71335 .73459 L
s
.71335 .73459 m
.71512 .72662 L
s
.71512 .72662 m
.7191 .73174 L
s
.10122 .05889 m
.09483 .05889 L
s
.09483 .05889 m
.09802 .04454 L
s
.09802 .04454 m
.1052 .05377 L
s
.1052 .05377 m
.10122 .05889 L
s
.62798 .06117 m
.61761 .06629 L
s
.61761 .06629 m
.60468 .04966 L
s
.60468 .04966 m
.62798 .06117 L
s
.64666 .0704 m
.63629 .06528 L
s
.63629 .06528 m
.6409 .04454 L
s
.6409 .04454 m
.64666 .0704 L
s
.6409 .09625 m
.62798 .10264 L
s
.62798 .10264 m
.61505 .09625 L
s
.61505 .09625 m
.6093 .0704 L
s
.6093 .0704 m
.63515 .0704 L
s
.63515 .0704 m
.6441 .0819 L
s
.6441 .0819 m
.6409 .09625 L
s
.6441 .0819 m
.62798 .06117 L
s
.62798 .06117 m
.64666 .0704 L
s
.64666 .0704 m
.6441 .0819 L
s
.17047 .04454 m
.16329 .03532 L
s
.16329 .03532 m
.18659 .02381 L
s
.18659 .02381 m
.17047 .04454 L
s
.66995 .22679 m
.63373 .24468 L
s
.63373 .24468 m
.59751 .22679 L
s
.59751 .22679 m
.58856 .18659 L
s
.58856 .18659 m
.61363 .15435 L
s
.61363 .15435 m
.65383 .15435 L
s
.65383 .15435 m
.6789 .18659 L
s
.6789 .18659 m
.66995 .22679 L
s
.74815 .83927 m
.73522 .84565 L
s
.73522 .84565 m
.73301 .83572 L
s
.73301 .83572 m
.7392 .82776 L
s
.7392 .82776 m
.74815 .83927 L
s
.66995 .0819 m
.66278 .07836 L
s
.66278 .07836 m
.6789 .0704 L
s
.6789 .0704 m
.66995 .0819 L
s
.30818 .16428 m
.28311 .17666 L
s
.28311 .17666 m
.28808 .15435 L
s
.28808 .15435 m
.30818 .16428 L
s
.87072 .46201 m
.85283 .46201 L
s
.85283 .46201 m
.88188 .44766 L
s
.88188 .44766 m
.87072 .46201 L
s
.72804 .74893 m
.71512 .75532 L
s
.71512 .75532 m
.71192 .74097 L
s
.71192 .74097 m
.72185 .74097 L
s
.72185 .74097 m
.72804 .74893 L
s
.54615 .21244 m
.53622 .21244 L
s
.53622 .21244 m
.53224 .19455 L
s
.53224 .19455 m
.54615 .21244 L
s
.91092 .22395 m
.90198 .21244 L
s
.90198 .21244 m
.91987 .21244 L
s
.91987 .21244 m
.91092 .22395 L
s
.83273 .66853 m
.80049 .66853 L
s
.80049 .66853 m
.81661 .66057 L
s
.81661 .66057 m
.83273 .66853 L
s
.8144 .7509 m
.80545 .75532 L
s
.80545 .75532 m
.80226 .74097 L
s
.80226 .74097 m
.81661 .74097 L
s
.81661 .74097 m
.8144 .7509 L
s
.40348 .36725 m
.38956 .34936 L
s
.38956 .34936 m
.39728 .33943 L
s
.39728 .33943 m
.40348 .36725 L
s
.77144 .14796 m
.77463 .13361 L
s
.77463 .13361 m
.78756 .14 L
s
.78756 .14 m
.77144 .14796 L
s
.7593 .62833 m
.74815 .64268 L
s
.74815 .64268 m
.75532 .61044 L
s
.75532 .61044 m
.7593 .62833 L
s
.77144 .35732 m
.73522 .37522 L
s
.73522 .37522 m
.699 .35732 L
s
.699 .35732 m
.69005 .31712 L
s
.69005 .31712 m
.71512 .28488 L
s
.71512 .28488 m
.75532 .28488 L
s
.75532 .28488 m
.78039 .31712 L
s
.78039 .31712 m
.77144 .35732 L
s
.23573 .12849 m
.22679 .12407 L
s
.22679 .12407 m
.22458 .11414 L
s
.22458 .11414 m
.23893 .11414 L
s
.23893 .11414 m
.23573 .12849 L
s
.66278 .70077 m
.65162 .69526 L
s
.65162 .69526 m
.67669 .68288 L
s
.67669 .68288 m
.66278 .70077 L
s
.86576 .31074 m
.86895 .29639 L
s
.86895 .29639 m
.88188 .30277 L
s
.88188 .30277 m
.86576 .31074 L
s
.91092 .31712 m
.90517 .29127 L
s
.90517 .29127 m
.91411 .30277 L
s
.91411 .30277 m
.91092 .31712 L
s
.15435 .08829 m
.14142 .0819 L
s
.14142 .0819 m
.14761 .07394 L
s
.14761 .07394 m
.15754 .07394 L
s
.15754 .07394 m
.15435 .08829 L
s
.66897 .26699 m
.66278 .25903 L
s
.66278 .25903 m
.67393 .24468 L
s
.67393 .24468 m
.66897 .26699 L
s
.699 .09625 m
.68288 .08829 L
s
.68288 .08829 m
.6958 .0819 L
s
.6958 .0819 m
.699 .09625 L
s
.74815 .83927 m
.72804 .81341 L
s
.72804 .81341 m
.74416 .82138 L
s
.74416 .82138 m
.74815 .83927 L
s
.5434 .27338 m
.53622 .27692 L
s
.53622 .27692 m
.52329 .27053 L
s
.52329 .27053 m
.53224 .25903 L
s
.53224 .25903 m
.5402 .25903 L
s
.5402 .25903 m
.54517 .26541 L
s
.54517 .26541 m
.5434 .27338 L
s
.74416 .21883 m
.74097 .21472 L
s
.74097 .21472 m
.74559 .21244 L
s
.74559 .21244 m
.74416 .21883 L
s
.64346 .42054 m
.6409 .4218 L
s
.6409 .4218 m
.63948 .41542 L
s
.63948 .41542 m
.64346 .42054 L
s
.72229 .22395 m
.71768 .22167 L
s
.71768 .22167 m
.72406 .22167 L
s
.72406 .22167 m
.72229 .22395 L
s
.57564 .27338 m
.56846 .27692 L
s
.56846 .27692 m
.56129 .27338 L
s
.56129 .27338 m
.55809 .25903 L
s
.55809 .25903 m
.57244 .25903 L
s
.57244 .25903 m
.57741 .26541 L
s
.57741 .26541 m
.57564 .27338 L
s
.87072 .49779 m
.86576 .49141 L
s
.86576 .49141 m
.87214 .49141 L
s
.87214 .49141 m
.87072 .49779 L
s
.84246 .50291 m
.8399 .50165 L
s
.8399 .50165 m
.84388 .49653 L
s
.84388 .49653 m
.85027 .49653 L
s
.85027 .49653 m
.84964 .49937 L
s
.84964 .49937 m
.84246 .50291 L
s
.74672 .20732 m
.74353 .20321 L
s
.74353 .20321 m
.74815 .20093 L
s
.74815 .20093 m
.74672 .20732 L
s
.11955 .12849 m
.10918 .13361 L
s
.10918 .13361 m
.1052 .12849 L
s
.1052 .12849 m
.11237 .11926 L
s
.11237 .11926 m
.11812 .12211 L
s
.11812 .12211 m
.11955 .12849 L
s
.73522 .91013 m
.7338 .90375 L
s
.7338 .90375 m
.74018 .90375 L
s
.74018 .90375 m
.73522 .91013 L
s
.87407 .46429 m
.87151 .46555 L
s
.87151 .46555 m
.86895 .46429 L
s
.86895 .46429 m
.87151 .46099 L
s
.87151 .46099 m
.87407 .46429 L
s
.74211 .23171 m
.74148 .23089 L
s
.74148 .23089 m
.74353 .22167 L
s
.74353 .22167 m
.74495 .22805 L
s
.74495 .22805 m
.74211 .23171 L
s
.76151 .96381 m
.76028 .96539 L
s
.76028 .96539 m
.75567 .96311 L
s
.75567 .96311 m
.75595 .96184 L
s
.75595 .96184 m
.76107 .96184 L
s
.76107 .96184 m
.76151 .96381 L
s
.6154 .30719 m
.61363 .30632 L
s
.61363 .30632 m
.61505 .30562 L
s
.61505 .30562 m
.6154 .30719 L
s
.47671 .06117 m
.46776 .04966 L
s
.46776 .04966 m
.48565 .04966 L
s
.48565 .04966 m
.47671 .06117 L
s
.84104 .5093 m
.83592 .50677 L
s
.83592 .50677 m
.83671 .50575 L
s
.83671 .50575 m
.84821 .50575 L
s
.84821 .50575 m
.84104 .5093 L
s
.1253 .15435 m
.12309 .1515 L
s
.12309 .1515 m
.12486 .15238 L
s
.12486 .15238 m
.1253 .15435 L
s
.70936 .90445 m
.70794 .90375 L
s
.70794 .90375 m
.70991 .90375 L
s
.70991 .90375 m
.70936 .90445 L
s
.72529 .91722 m
.72406 .9188 L
s
.72406 .9188 m
.71689 .91525 L
s
.71689 .91525 m
.72485 .91525 L
s
.72485 .91525 m
.72529 .91722 L
s
.70475 .21528 m
.70361 .21472 L
s
.70361 .21472 m
.7044 .2137 L
s
.7044 .2137 m
.70475 .21528 L
s
.70361 .21472 m
.70156 .21573 L
s
.70156 .21573 m
.699 .21244 L
s
.699 .21244 m
.70361 .21472 L
s
.51435 .25903 m
.5 .25903 L
s
.5 .25903 m
.50142 .25264 L
s
.50142 .25264 m
.50717 .2498 L
s
.50717 .2498 m
.51435 .25903 L
s
.75709 .94395 m
.75134 .94111 L
s
.75134 .94111 m
.75532 .93599 L
s
.75532 .93599 m
.75709 .94395 L
s
.61186 .29127 m
.60787 .29639 L
s
.60787 .29639 m
.6007 .29285 L
s
.6007 .29285 m
.59972 .28843 L
s
.59972 .28843 m
.60468 .28204 L
s
.60468 .28204 m
.61044 .28488 L
s
.61044 .28488 m
.61186 .29127 L
s
.71079 .20093 m
.71398 .19683 L
s
.71398 .19683 m
.71654 .19809 L
s
.71654 .19809 m
.71079 .20093 L
s
.85858 .48786 m
.85283 .48502 L
s
.85283 .48502 m
.85681 .4799 L
s
.85681 .4799 m
.85858 .48786 L
s
.71079 .20093 m
.70617 .20321 L
s
.70617 .20321 m
.71015 .19809 L
s
.71015 .19809 m
.71079 .20093 L
s
.54659 .25903 m
.53941 .22679 L
s
.53941 .22679 m
.55234 .23317 L
s
.55234 .23317 m
.54659 .25903 L
s
.50717 .22679 m
.51293 .20093 L
s
.51293 .20093 m
.53622 .21244 L
s
.53622 .21244 m
.50717 .22679 L
s
.72947 .21016 m
.73061 .20504 L
s
.73061 .20504 m
.73522 .20732 L
s
.73522 .20732 m
.72947 .21016 L
s
.56208 .27692 m
.55809 .28204 L
s
.55809 .28204 m
.54915 .27053 L
s
.54915 .27053 m
.56065 .27053 L
s
.56065 .27053 m
.56208 .27692 L
s
.72804 .81341 m
.71192 .80545 L
s
.71192 .80545 m
.7191 .77321 L
s
.7191 .77321 m
.72804 .81341 L
s
.53622 .21244 m
.51293 .20093 L
s
.51293 .20093 m
.51612 .18659 L
s
.51612 .18659 m
.53622 .21244 L
s
.7191 .85362 m
.699 .86355 L
s
.699 .86355 m
.6789 .85362 L
s
.6789 .85362 m
.67393 .83131 L
s
.67393 .83131 m
.699 .79907 L
s
.699 .79907 m
.72406 .83131 L
s
.72406 .83131 m
.7191 .85362 L
s
.73522 .84565 m
.7191 .85362 L
s
.7191 .85362 m
.72804 .81341 L
s
.72804 .81341 m
.73522 .84565 L
s
.59432 .21244 m
.58281 .21244 L
s
.58281 .21244 m
.58856 .18659 L
s
.58856 .18659 m
.59432 .21244 L
s
.03993 .03177 m
.04072 .03532 L
s
.04072 .03532 m
.03276 .03532 L
s
.03276 .03532 m
.02779 .02893 L
s
.02779 .02893 m
.03098 .02735 L
s
.03098 .02735 m
.03993 .03177 L
s
.43075 .07678 m
.42579 .0704 L
s
.42579 .0704 m
.43217 .0704 L
s
.43217 .0704 m
.43075 .07678 L
s
.72485 .24569 m
.72229 .2424 L
s
.72229 .2424 m
.72691 .23647 L
s
.72691 .23647 m
.73522 .24057 L
s
.73522 .24057 m
.72485 .24569 L
s
.74097 .26643 m
.7338 .2572 L
s
.7338 .2572 m
.73955 .26004 L
s
.73955 .26004 m
.74097 .26643 L
s
.54197 .02893 m
.53559 .02893 L
s
.53559 .02893 m
.53524 .02735 L
s
.53524 .02735 m
.53622 .02609 L
s
.53622 .02609 m
.54197 .02893 L
s
.0819 .08829 m
.08013 .08741 L
s
.08013 .08741 m
.08234 .08632 L
s
.08234 .08632 m
.0819 .08829 L
s
.72406 .83131 m
.699 .79907 L
s
.699 .79907 m
.72804 .81341 L
s
.72804 .81341 m
.72406 .83131 L
s
.72804 .87789 m
.699 .86355 L
s
.699 .86355 m
.73522 .84565 L
s
.73522 .84565 m
.72804 .87789 L
s
.45164 .0704 m
.44368 .0704 L
s
.44368 .0704 m
.44766 .06528 L
s
.44766 .06528 m
.45164 .0704 L
s
.64268 .37806 m
.63629 .37806 L
s
.63629 .37806 m
.63948 .36371 L
s
.63948 .36371 m
.64666 .37294 L
s
.64666 .37294 m
.64268 .37806 L
s
.58281 .21244 m
.56846 .21244 L
s
.56846 .21244 m
.58856 .18659 L
s
.58856 .18659 m
.58281 .21244 L
s
.74416 .88586 m
.72804 .87789 L
s
.72804 .87789 m
.7392 .86355 L
s
.7392 .86355 m
.74416 .88586 L
s
.60149 .24468 m
.59033 .25903 L
s
.59033 .25903 m
.57244 .25903 L
s
.57244 .25903 m
.56129 .24468 L
s
.56129 .24468 m
.56527 .22679 L
s
.56527 .22679 m
.58139 .21883 L
s
.58139 .21883 m
.59751 .22679 L
s
.59751 .22679 m
.60149 .24468 L
s
.56527 .22679 m
.56846 .21244 L
s
.56846 .21244 m
.59432 .21244 L
s
.59432 .21244 m
.56527 .22679 L
s
.57244 .25903 m
.54659 .25903 L
s
.54659 .25903 m
.54915 .24752 L
s
.54915 .24752 m
.57244 .25903 L
s
.57244 .19455 m
.55234 .20448 L
s
.55234 .20448 m
.53224 .19455 L
s
.53224 .19455 m
.52728 .17224 L
s
.52728 .17224 m
.54119 .15435 L
s
.54119 .15435 m
.5635 .15435 L
s
.5635 .15435 m
.57741 .17224 L
s
.57741 .17224 m
.57244 .19455 L
s
.26301 .18659 m
.25682 .15876 L
s
.25682 .15876 m
.27692 .16869 L
s
.27692 .16869 m
.26301 .18659 L
s
.88188 .44766 m
.86576 .45562 L
s
.86576 .45562 m
.84565 .42977 L
s
.84565 .42977 m
.88188 .44766 L
s
.35831 .2089 m
.3444 .22679 L
s
.3444 .22679 m
.33324 .17666 L
s
.33324 .17666 m
.35831 .2089 L
s
.60866 .24114 m
.60247 .2491 L
s
.60247 .2491 m
.59751 .22679 L
s
.59751 .22679 m
.60866 .24114 L
s
.33324 .2323 m
.30818 .24468 L
s
.30818 .24468 m
.33943 .20448 L
s
.33943 .20448 m
.33324 .2323 L
s
.6705 .83572 m
.66774 .82334 L
s
.66774 .82334 m
.68784 .81341 L
s
.68784 .81341 m
.6705 .83572 L
s
.29702 .23917 m
.27196 .22679 L
s
.27196 .22679 m
.32209 .22679 L
s
.32209 .22679 m
.29702 .23917 L
s
.699 .04454 m
.69182 .03532 L
s
.69182 .03532 m
.71512 .02381 L
s
.71512 .02381 m
.699 .04454 L
s
.29427 .22679 m
.27196 .22679 L
s
.27196 .22679 m
.26301 .18659 L
s
.26301 .18659 m
.29427 .22679 L
s
.63692 .11414 m
.62798 .10264 L
s
.62798 .10264 m
.6409 .09625 L
s
.6409 .09625 m
.63692 .11414 L
s
.73301 .75532 m
.71512 .75532 L
s
.71512 .75532 m
.74416 .74097 L
s
.74416 .74097 m
.73301 .75532 L
s
.33147 .16869 m
.3243 .17224 L
s
.3243 .17224 m
.31137 .16585 L
s
.31137 .16585 m
.3243 .14923 L
s
.3243 .14923 m
.33324 .16073 L
s
.33324 .16073 m
.33147 .16869 L
s
.63452 .39311 m
.62656 .39311 L
s
.62656 .39311 m
.63275 .38515 L
s
.63275 .38515 m
.63452 .39311 L
s
.36371 .16869 m
.35654 .17224 L
s
.35654 .17224 m
.34936 .16869 L
s
.34936 .16869 m
.34617 .15435 L
s
.34617 .15435 m
.36052 .15435 L
s
.36052 .15435 m
.36548 .16073 L
s
.36548 .16073 m
.36371 .16869 L
s
.32209 .14638 m
.31712 .14 L
s
.31712 .14 m
.32351 .14 L
s
.32351 .14 m
.32209 .14638 L
s
.60724 .38672 m
.60212 .38672 L
s
.60212 .38672 m
.60326 .3816 L
s
.60326 .3816 m
.60645 .38318 L
s
.60645 .38318 m
.60724 .38672 L
s
.35271 .44482 m
.35113 .44482 L
s
.35113 .44482 m
.34219 .43331 L
s
.34219 .43331 m
.35113 .43773 L
s
.35113 .43773 m
.35271 .44482 L
s
.88074 .21016 m
.87777 .21163 L
s
.87777 .21163 m
.87726 .21097 L
s
.87726 .21097 m
.8801 .20732 L
s
.8801 .20732 m
.88074 .21016 L
s
.76746 .96184 m
.75851 .95034 L
s
.75851 .95034 m
.77144 .94395 L
s
.77144 .94395 m
.76746 .96184 L
s
.82583 .36371 m
.81917 .367 L
s
.81917 .367 m
.81661 .36371 L
s
.81661 .36371 m
.82378 .35448 L
s
.82378 .35448 m
.82583 .36371 L
s
.87356 .20093 m
.86525 .20504 L
s
.86525 .20504 m
.86319 .19581 L
s
.86319 .19581 m
.86895 .19297 L
s
.86895 .19297 m
.87214 .19455 L
s
.87214 .19455 m
.87356 .20093 L
s
.89942 .20093 m
.90261 .19683 L
s
.90261 .19683 m
.90517 .19809 L
s
.90517 .19809 m
.89942 .20093 L
s
.60866 .35732 m
.61044 .34936 L
s
.61044 .34936 m
.61761 .35291 L
s
.61761 .35291 m
.60866 .35732 L
s
.89942 .20093 m
.8948 .20321 L
s
.8948 .20321 m
.89878 .19809 L
s
.89878 .19809 m
.89942 .20093 L
s
.2236 .27053 m
.21563 .27053 L
s
.21563 .27053 m
.21067 .26415 L
s
.21067 .26415 m
.21386 .26257 L
s
.21386 .26257 m
.22281 .26699 L
s
.22281 .26699 m
.2236 .27053 L
s
.84246 .39696 m
.8399 .39367 L
s
.8399 .39367 m
.84132 .39184 L
s
.84132 .39184 m
.84246 .39696 L
s
.85858 .4177 m
.85141 .40847 L
s
.85141 .40847 m
.85716 .41131 L
s
.85716 .41131 m
.85858 .4177 L
s
.33005 .13361 m
.32366 .13361 L
s
.32366 .13361 m
.32331 .13204 L
s
.32331 .13204 m
.3243 .13077 L
s
.3243 .13077 m
.33005 .13361 L
s
.26478 .32351 m
.26301 .32263 L
s
.26301 .32263 m
.26522 .32154 L
s
.26522 .32154 m
.26478 .32351 L
s
.75532 .92322 m
.75851 .90887 L
s
.75851 .90887 m
.77144 .91525 L
s
.77144 .91525 m
.75532 .92322 L
s
.38381 .19455 m
.37664 .19809 L
s
.37664 .19809 m
.36946 .19455 L
s
.36946 .19455 m
.36769 .18659 L
s
.36769 .18659 m
.37664 .17508 L
s
.37664 .17508 m
.38558 .18659 L
s
.38558 .18659 m
.38381 .19455 L
s
.3412 .39311 m
.33324 .39311 L
s
.33324 .39311 m
.33943 .38515 L
s
.33943 .38515 m
.3412 .39311 L
s
.31393 .38672 m
.30597 .38672 L
s
.30597 .38672 m
.301 .38034 L
s
.301 .38034 m
.3042 .37876 L
s
.3042 .37876 m
.31314 .38318 L
s
.31314 .38318 m
.31393 .38672 L
s
.31314 .13488 m
.30818 .12849 L
s
.30818 .12849 m
.31456 .12849 L
s
.31456 .12849 m
.31314 .13488 L
s
.29844 .31712 m
.29206 .31712 L
s
.29206 .31712 m
.2895 .30562 L
s
.2895 .30562 m
.29525 .30277 L
s
.29525 .30277 m
.301 .30562 L
s
.301 .30562 m
.29844 .31712 L
s
.76427 .90147 m
.76107 .89736 L
s
.76107 .89736 m
.76746 .89736 L
s
.76746 .89736 m
.76427 .90147 L
s
.35015 .43331 m
.34219 .43331 L
s
.34219 .43331 m
.33722 .42693 L
s
.33722 .42693 m
.34042 .42535 L
s
.34042 .42535 m
.34936 .42977 L
s
.34936 .42977 m
.35015 .43331 L
s
.88444 .20833 m
.88188 .20504 L
s
.88188 .20504 m
.8833 .20321 L
s
.8833 .20321 m
.88444 .20833 L
s
.82953 .38034 m
.82236 .37111 L
s
.82236 .37111 m
.82811 .37395 L
s
.82811 .37395 m
.82953 .38034 L
s
.73841 .86 m
.73983 .85362 L
s
.73983 .85362 m
.74141 .85362 L
s
.74141 .85362 m
.74239 .85488 L
s
.74239 .85488 m
.73841 .86 L
s
.57465 .08829 m
.57421 .08632 L
s
.57421 .08632 m
.57564 .08702 L
s
.57564 .08702 m
.57465 .08829 L
s
.29206 .14923 m
.27771 .14923 L
s
.27771 .14923 m
.2809 .13488 L
s
.2809 .13488 m
.29206 .14923 L
s
.31137 .37522 m
.29702 .37522 L
s
.29702 .37522 m
.29604 .37395 L
s
.29604 .37395 m
.30242 .3708 L
s
.30242 .3708 m
.31137 .37522 L
s
.3243 .31712 m
.32075 .31712 L
s
.32075 .31712 m
.32252 .31625 L
s
.32252 .31625 m
.3243 .31712 L
s
.75134 .9181 m
.75162 .91683 L
s
.75162 .91683 m
.75232 .91683 L
s
.75232 .91683 m
.75134 .9181 L
s
.74878 .90659 m
.7502 .9002 L
s
.7502 .9002 m
.75178 .9002 L
s
.75178 .9002 m
.75276 .90147 L
s
.75276 .90147 m
.74878 .90659 L
s
.88188 .2096 m
.88074 .21016 L
s
.88074 .21016 m
.88045 .2089 L
s
.88045 .2089 m
.88188 .2096 L
s
.88023 .21244 m
.87612 .21244 L
s
.87612 .21244 m
.88074 .21016 L
s
.88074 .21016 m
.88023 .21244 L
s
.34936 .14 m
.34042 .12849 L
s
.34042 .12849 m
.34617 .12565 L
s
.34617 .12565 m
.35192 .12849 L
s
.35192 .12849 m
.34936 .14 L
s
.75532 .87151 m
.7502 .87151 L
s
.7502 .87151 m
.75134 .86639 L
s
.75134 .86639 m
.75532 .87151 L
s
.58856 .0704 m
.58458 .07552 L
s
.58458 .07552 m
.5782 .07552 L
s
.5782 .07552 m
.57642 .06756 L
s
.57642 .06756 m
.57918 .06401 L
s
.57918 .06401 m
.5836 .06401 L
s
.5836 .06401 m
.58856 .0704 L
s
.31712 .32067 m
.31437 .31712 L
s
.31437 .31712 m
.3243 .31712 L
s
.3243 .31712 m
.31712 .32067 L
s
.8747 .19581 m
.87356 .19069 L
s
.87356 .19069 m
.87612 .18943 L
s
.87612 .18943 m
.8747 .19581 L
s
.87511 .21244 m
.87429 .21244 L
s
.87429 .21244 m
.87356 .20915 L
s
.87356 .20915 m
.87612 .20788 L
s
.87612 .20788 m
.87511 .21244 L
s
.73585 .8485 m
.7362 .84692 L
s
.7362 .84692 m
.73664 .84748 L
s
.73664 .84748 m
.73585 .8485 L
s
.56944 .09499 m
.56874 .09499 L
s
.56874 .09499 m
.56897 .09397 L
s
.56897 .09397 m
.56988 .09442 L
s
.56988 .09442 m
.56944 .09499 L
s
.5689 .07836 m
.56732 .07836 L
s
.56732 .07836 m
.56767 .07678 L
s
.56767 .07678 m
.5689 .07836 L
s
.22458 .27495 m
.22281 .27408 L
s
.22281 .27408 m
.22403 .2725 L
s
.22403 .2725 m
.22458 .27495 L
s
.92846 .2096 m
.92732 .21016 L
s
.92732 .21016 m
.92704 .2089 L
s
.92704 .2089 m
.92846 .2096 L
s
.35157 .17862 m
.35035 .1802 L
s
.35035 .1802 m
.34838 .1802 L
s
.34838 .1802 m
.34715 .17862 L
s
.34715 .17862 m
.34759 .17666 L
s
.34759 .17666 m
.34936 .17578 L
s
.34936 .17578 m
.35113 .17666 L
s
.35113 .17666 m
.35157 .17862 L
s
.32209 .40746 m
.31712 .40107 L
s
.31712 .40107 m
.3243 .39753 L
s
.3243 .39753 m
.32209 .40746 L
s
.87356 .20093 m
.87214 .19455 L
s
.87214 .19455 m
.8747 .19581 L
s
.8747 .19581 m
.87356 .20093 L
s
.39276 .15435 m
.36946 .16585 L
s
.36946 .16585 m
.38956 .14 L
s
.38956 .14 m
.39276 .15435 L
s
.39851 .12849 m
.36946 .11414 L
s
.36946 .11414 m
.39276 .10264 L
s
.39276 .10264 m
.39851 .12849 L
s
.33403 .12849 m
.32607 .12849 L
s
.32607 .12849 m
.33005 .12337 L
s
.33005 .12337 m
.33403 .12849 L
s
.36548 .18943 m
.3591 .18943 L
s
.3591 .18943 m
.36229 .17508 L
s
.36229 .17508 m
.36946 .18431 L
s
.36946 .18431 m
.36548 .18943 L
s
.64666 .44766 m
.63054 .4397 L
s
.63054 .4397 m
.63771 .40746 L
s
.63771 .40746 m
.64666 .44766 L
s
.39851 .12849 m
.39276 .10264 L
s
.39276 .10264 m
.40568 .09625 L
s
.40568 .09625 m
.39851 .12849 L
s
.63771 .48786 m
.61761 .49779 L
s
.61761 .49779 m
.59751 .48786 L
s
.59751 .48786 m
.59254 .46555 L
s
.59254 .46555 m
.61761 .43331 L
s
.61761 .43331 m
.64268 .46555 L
s
.64268 .46555 m
.63771 .48786 L
s
.65383 .4799 m
.63771 .48786 L
s
.63771 .48786 m
.64666 .44766 L
s
.64666 .44766 m
.65383 .4799 L
s
.43473 .17508 m
.42756 .16585 L
s
.42756 .16585 m
.45085 .15435 L
s
.45085 .15435 m
.43473 .17508 L
s
.73522 .5201 m
.699 .53799 L
s
.699 .53799 m
.66278 .5201 L
s
.66278 .5201 m
.65383 .4799 L
s
.65383 .4799 m
.6789 .44766 L
s
.6789 .44766 m
.7191 .44766 L
s
.7191 .44766 m
.74416 .4799 L
s
.74416 .4799 m
.73522 .5201 L
s
.35334 .12211 m
.34042 .12849 L
s
.34042 .12849 m
.33821 .11856 L
s
.33821 .11856 m
.3444 .1106 L
s
.3444 .1106 m
.35334 .12211 L
s
.57244 .5201 m
.56129 .52561 L
s
.56129 .52561 m
.56748 .49779 L
s
.56748 .49779 m
.57244 .5201 L
s
.76427 .03532 m
.75532 .02381 L
s
.75532 .02381 m
.77321 .02381 L
s
.77321 .02381 m
.76427 .03532 L
s
.25185 .05605 m
.2407 .0417 L
s
.2407 .0417 m
.24468 .02381 L
s
.24468 .02381 m
.25185 .05605 L
s
.33324 .03177 m
.32032 .03816 L
s
.32032 .03816 m
.31712 .02381 L
s
.31712 .02381 m
.32705 .02381 L
s
.32705 .02381 m
.33324 .03177 L
s
.70396 .39949 m
.70617 .38956 L
s
.70617 .38956 m
.72406 .38956 L
s
.72406 .38956 m
.70396 .39949 L
s
.70794 .72308 m
.68288 .7107 L
s
.68288 .7107 m
.70298 .70077 L
s
.70298 .70077 m
.70794 .72308 L
s
.23893 .11414 m
.20669 .11414 L
s
.20669 .11414 m
.22281 .10618 L
s
.22281 .10618 m
.23893 .11414 L
s
.80766 .40391 m
.80049 .40746 L
s
.80049 .40746 m
.78756 .40107 L
s
.78756 .40107 m
.79651 .38956 L
s
.79651 .38956 m
.80447 .38956 L
s
.80447 .38956 m
.80943 .39595 L
s
.80943 .39595 m
.80766 .40391 L
s
.59751 .0302 m
.59432 .02609 L
s
.59432 .02609 m
.59893 .02381 L
s
.59893 .02381 m
.59751 .0302 L
s
.70873 .71385 m
.70617 .71512 L
s
.70617 .71512 m
.70475 .70873 L
s
.70475 .70873 m
.70873 .71385 L
s
.57564 .03532 m
.57102 .03304 L
s
.57102 .03304 m
.57741 .03304 L
s
.57741 .03304 m
.57564 .03532 L
s
.8399 .40391 m
.83273 .40746 L
s
.83273 .40746 m
.82555 .40391 L
s
.82555 .40391 m
.82236 .38956 L
s
.82236 .38956 m
.83671 .38956 L
s
.83671 .38956 m
.84167 .39595 L
s
.84167 .39595 m
.8399 .40391 L
s
.06898 .0302 m
.06756 .02381 L
s
.06756 .02381 m
.07394 .02381 L
s
.07394 .02381 m
.06898 .0302 L
s
.04249 .03304 m
.03879 .03121 L
s
.03879 .03121 m
.04135 .02792 L
s
.04135 .02792 m
.04312 .0302 L
s
.04312 .0302 m
.04249 .03304 L
s
.59545 .04308 m
.59482 .04226 L
s
.59482 .04226 m
.59688 .03304 L
s
.59688 .03304 m
.5983 .03942 L
s
.5983 .03942 m
.59545 .04308 L
s
.53224 .67207 m
.52763 .66979 L
s
.52763 .66979 m
.52791 .66853 L
s
.52791 .66853 m
.53499 .66853 L
s
.53499 .66853 m
.53224 .67207 L
s
.55952 .31712 m
.5434 .30916 L
s
.5434 .30916 m
.5635 .29923 L
s
.5635 .29923 m
.55952 .31712 L
s
.55695 .02609 m
.5549 .0271 L
s
.5549 .0271 m
.55234 .02381 L
s
.55234 .02381 m
.55695 .02609 L
s
.77861 .38956 m
.76427 .38956 L
s
.76427 .38956 m
.76569 .38318 L
s
.76569 .38318 m
.77144 .38034 L
s
.77144 .38034 m
.77861 .38956 L
s
.54241 .64622 m
.53622 .65418 L
s
.53622 .65418 m
.52329 .6478 L
s
.52329 .6478 m
.53224 .63629 L
s
.53224 .63629 m
.54119 .64071 L
s
.54119 .64071 m
.54241 .64622 L
s
.57023 .69084 m
.56129 .68642 L
s
.56129 .68642 m
.56925 .68642 L
s
.56925 .68642 m
.57023 .69084 L
s
.06578 .04454 m
.06003 .0417 L
s
.06003 .0417 m
.0672 .03816 L
s
.0672 .03816 m
.06578 .04454 L
s
.56129 .68642 m
.55411 .68288 L
s
.55411 .68288 m
.56404 .68288 L
s
.56404 .68288 m
.56129 .68642 L
s
.80049 .34298 m
.77719 .33147 L
s
.77719 .33147 m
.79154 .33147 L
s
.79154 .33147 m
.80049 .34298 L
s
.48211 .5201 m
.4598 .5201 L
s
.4598 .5201 m
.47095 .50575 L
s
.47095 .50575 m
.48211 .5201 L
s
.5201 .54596 m
.49105 .5603 L
s
.49105 .5603 m
.5 .5201 L
s
.5 .5201 m
.5201 .54596 L
s
.79012 .03532 m
.7887 .03714 L
s
.7887 .03714 m
.78551 .03304 L
s
.78551 .03304 m
.78665 .02792 L
s
.78665 .02792 m
.7887 .02893 L
s
.7887 .02893 m
.79012 .03532 L
s
.79012 .03532 m
.7887 .02893 L
s
.7887 .02893 m
.79331 .03121 L
s
.79331 .03121 m
.79012 .03532 L
s
.5782 .05706 m
.57564 .05377 L
s
.57564 .05377 m
.58025 .04784 L
s
.58025 .04784 m
.58856 .05194 L
s
.58856 .05194 m
.5782 .05706 L
s
.59432 .0778 m
.58714 .06857 L
s
.58714 .06857 m
.59289 .07141 L
s
.59289 .07141 m
.59432 .0778 L
s
.47636 .31358 m
.46918 .31712 L
s
.46918 .31712 m
.47415 .31074 L
s
.47415 .31074 m
.47592 .31161 L
s
.47592 .31161 m
.47636 .31358 L
s
.78039 .07906 m
.77925 .07962 L
s
.77925 .07962 m
.77896 .07836 L
s
.77896 .07836 m
.78039 .07906 L
s
.50319 .57023 m
.47095 .57023 L
s
.47095 .57023 m
.50717 .55234 L
s
.50717 .55234 m
.50319 .57023 L
s
.60149 .30916 m
.59254 .31358 L
s
.59254 .31358 m
.59432 .30562 L
s
.59432 .30562 m
.60149 .30916 L
s
.70794 .67137 m
.70156 .67137 L
s
.70156 .67137 m
.70475 .65702 L
s
.70475 .65702 m
.71192 .66625 L
s
.71192 .66625 m
.70794 .67137 L
s
.53622 .53799 m
.5201 .54596 L
s
.5201 .54596 m
.5 .5201 L
s
.5 .5201 m
.53622 .53799 L
s
.55632 .59254 m
.53622 .60247 L
s
.53622 .60247 m
.5 .58458 L
s
.5 .58458 m
.52507 .55234 L
s
.52507 .55234 m
.54738 .55234 L
s
.54738 .55234 m
.56129 .57023 L
s
.56129 .57023 m
.55632 .59254 L
s
.54738 .55234 m
.50717 .55234 L
s
.50717 .55234 m
.53622 .53799 L
s
.53622 .53799 m
.54738 .55234 L
s
.83671 .38956 m
.81085 .38956 L
s
.81085 .38956 m
.81341 .37806 L
s
.81341 .37806 m
.83671 .38956 L
s
.59574 .29923 m
.58856 .30277 L
s
.58856 .30277 m
.57564 .29639 L
s
.57564 .29639 m
.58856 .27976 L
s
.58856 .27976 m
.59751 .29127 L
s
.59751 .29127 m
.59574 .29923 L
s
.85539 .52522 m
.84964 .52806 L
s
.84964 .52806 m
.85141 .5201 L
s
.85141 .5201 m
.85539 .52522 L
s
.62798 .29923 m
.6208 .30277 L
s
.6208 .30277 m
.61363 .29923 L
s
.61363 .29923 m
.61044 .28488 L
s
.61044 .28488 m
.62478 .28488 L
s
.62478 .28488 m
.62975 .29127 L
s
.62975 .29127 m
.62798 .29923 L
s
.58635 .27692 m
.58139 .27053 L
s
.58139 .27053 m
.58777 .27053 L
s
.58777 .27053 m
.58635 .27692 L
s
.83785 .51087 m
.83529 .51214 L
s
.83529 .51214 m
.83273 .51087 L
s
.83273 .51087 m
.83529 .50758 L
s
.83529 .50758 m
.83785 .51087 L
s
.12467 .1515 m
.12309 .1515 L
s
.12309 .1515 m
.11414 .14 L
s
.11414 .14 m
.12309 .14442 L
s
.12309 .14442 m
.12467 .1515 L
s
.71512 .90729 m
.7105 .90501 L
s
.7105 .90501 m
.71079 .90375 L
s
.71079 .90375 m
.71787 .90375 L
s
.71787 .90375 m
.71512 .90729 L
s
.52905 .03532 m
.5201 .02381 L
s
.5201 .02381 m
.53799 .02381 L
s
.53799 .02381 m
.52905 .03532 L
s
.67918 .17508 m
.67251 .17837 L
s
.67251 .17837 m
.66995 .17508 L
s
.66995 .17508 m
.67712 .16585 L
s
.67712 .16585 m
.67918 .17508 L
s
.72529 .88144 m
.7191 .8894 L
s
.7191 .8894 m
.70617 .88301 L
s
.70617 .88301 m
.71512 .87151 L
s
.71512 .87151 m
.72406 .87593 L
s
.72406 .87593 m
.72529 .88144 L
s
.75311 .92606 m
.74416 .92164 L
s
.74416 .92164 m
.75213 .92164 L
s
.75213 .92164 m
.75311 .92606 L
s
.82236 .53445 m
.81661 .53161 L
s
.81661 .53161 m
.82059 .52649 L
s
.82059 .52649 m
.82236 .53445 L
s
.74416 .92164 m
.73699 .9181 L
s
.73699 .9181 m
.74692 .9181 L
s
.74692 .9181 m
.74416 .92164 L
s
.74815 .22395 m
.74672 .22577 L
s
.74672 .22577 m
.74353 .22167 L
s
.74353 .22167 m
.74467 .21655 L
s
.74467 .21655 m
.74672 .21756 L
s
.74672 .21756 m
.74815 .22395 L
s
.6958 .20833 m
.69324 .20504 L
s
.69324 .20504 m
.69467 .20321 L
s
.69467 .20321 m
.6958 .20833 L
s
.71192 .22907 m
.70475 .21984 L
s
.70475 .21984 m
.7105 .22268 L
s
.7105 .22268 m
.71192 .22907 L
s
.59432 .26415 m
.58793 .26415 L
s
.58793 .26415 m
.58758 .26257 L
s
.58758 .26257 m
.58856 .26131 L
s
.58856 .26131 m
.59432 .26415 L
s
.62798 .32224 m
.62699 .32351 L
s
.62699 .32351 m
.62656 .32154 L
s
.62656 .32154 m
.62798 .32224 L
s
.50398 .04454 m
.48963 .04454 L
s
.48963 .04454 m
.49283 .0302 L
s
.49283 .0302 m
.50398 .04454 L
s
.64808 .32508 m
.6409 .32863 L
s
.6409 .32863 m
.63373 .32508 L
s
.63373 .32508 m
.63196 .31712 L
s
.63196 .31712 m
.6409 .30562 L
s
.6409 .30562 m
.64985 .31712 L
s
.64985 .31712 m
.64808 .32508 L
s
.11316 .0998 m
.1052 .0998 L
s
.1052 .0998 m
.11139 .09183 L
s
.11139 .09183 m
.11316 .0998 L
s
.08589 .09341 m
.07792 .09341 L
s
.07792 .09341 m
.07296 .08702 L
s
.07296 .08702 m
.07615 .08545 L
s
.07615 .08545 m
.0851 .08987 L
s
.0851 .08987 m
.08589 .09341 L
s
.57741 .26541 m
.57244 .25903 L
s
.57244 .25903 m
.57883 .25903 L
s
.57883 .25903 m
.57741 .26541 L
s
.76057 .27976 m
.7539 .28305 L
s
.7539 .28305 m
.75134 .27976 L
s
.75134 .27976 m
.75595 .27383 L
s
.75595 .27383 m
.75965 .27566 L
s
.75965 .27566 m
.76057 .27976 L
s
.47813 .04454 m
.47671 .03816 L
s
.47671 .03816 m
.48132 .04044 L
s
.48132 .04044 m
.47813 .04454 L
s
.12211 .14 m
.11414 .14 L
s
.11414 .14 m
.10918 .13361 L
s
.10918 .13361 m
.11237 .13204 L
s
.11237 .13204 m
.12132 .13645 L
s
.12132 .13645 m
.12211 .14 L
s
.72087 .91013 m
.72229 .90375 L
s
.72229 .90375 m
.72584 .90375 L
s
.72584 .90375 m
.72087 .91013 L
s
.68288 .19171 m
.6757 .18248 L
s
.6757 .18248 m
.68146 .18532 L
s
.68146 .18532 m
.68288 .19171 L
s
.44766 .07552 m
.44127 .07552 L
s
.44127 .07552 m
.44092 .07394 L
s
.44092 .07394 m
.44191 .07268 L
s
.44191 .07268 m
.44766 .07552 L
s
.63992 .3816 m
.63948 .37964 L
s
.63948 .37964 m
.6409 .38034 L
s
.6409 .38034 m
.63992 .3816 L
s
.55632 .27976 m
.54197 .27976 L
s
.54197 .27976 m
.54517 .26541 L
s
.54517 .26541 m
.55632 .27976 L
s
.08332 .0819 m
.06898 .0819 L
s
.06898 .0819 m
.06799 .08064 L
s
.06799 .08064 m
.07438 .07748 L
s
.07438 .07748 m
.08332 .0819 L
s
.76427 .29639 m
.76284 .29456 L
s
.76284 .29456 m
.76398 .29512 L
s
.76398 .29512 m
.76427 .29639 L
s
.5 .04966 m
.49874 .04966 L
s
.49874 .04966 m
.49858 .04896 L
s
.49858 .04896 m
.5 .04966 L
s
.48963 .05478 m
.48325 .05478 L
s
.48325 .05478 m
.4829 .05321 L
s
.4829 .05321 m
.48388 .05194 L
s
.48388 .05194 m
.48963 .05478 L
s
.71689 .90817 m
.71512 .90729 L
s
.71512 .90729 m
.71634 .90571 L
s
.71634 .90571 m
.71689 .90817 L
s
.71512 .90729 m
.71192 .90887 L
s
.71192 .90887 m
.70794 .90375 L
s
.70794 .90375 m
.71512 .90729 L
s
.61363 .27053 m
.60468 .25903 L
s
.60468 .25903 m
.61044 .25619 L
s
.61044 .25619 m
.61619 .25903 L
s
.61619 .25903 m
.61363 .27053 L
s
.45597 .06117 m
.45085 .06117 L
s
.45085 .06117 m
.45483 .05605 L
s
.45483 .05605 m
.45597 .06117 L
s
.65383 .36371 m
.64985 .36883 L
s
.64985 .36883 m
.64346 .36883 L
s
.64346 .36883 m
.64169 .36087 L
s
.64169 .36087 m
.64445 .35732 L
s
.64445 .35732 m
.65241 .35732 L
s
.65241 .35732 m
.65383 .36371 L
s
.72627 .88586 m
.73124 .87947 L
s
.73124 .87947 m
.73522 .88144 L
s
.73522 .88144 m
.72627 .88586 L
s
.70696 .90248 m
.70617 .90147 L
s
.70617 .90147 m
.70936 .89736 L
s
.70936 .89736 m
.71335 .89933 L
s
.71335 .89933 m
.70696 .90248 L
s
.43729 .08064 m
.43572 .08064 L
s
.43572 .08064 m
.43615 .08008 L
s
.43615 .08008 m
.43729 .08064 L
s
.63471 .3883 m
.63401 .3883 L
s
.63401 .3883 m
.63424 .38729 L
s
.63424 .38729 m
.63515 .38774 L
s
.63515 .38774 m
.63471 .3883 L
s
.63417 .37167 m
.63259 .37167 L
s
.63259 .37167 m
.63294 .3701 L
s
.63294 .3701 m
.63417 .37167 L
s
.74495 .22805 m
.74467 .22679 L
s
.74467 .22679 m
.74594 .22679 L
s
.74594 .22679 m
.74495 .22805 L
s
.76206 .96626 m
.76028 .96539 L
s
.76028 .96539 m
.76151 .96381 L
s
.76151 .96381 m
.76206 .96626 L
s
.61584 .30916 m
.61461 .31074 L
s
.61461 .31074 m
.61264 .31074 L
s
.61264 .31074 m
.61142 .30916 L
s
.61142 .30916 m
.61186 .30719 L
s
.61186 .30719 m
.61363 .30632 L
s
.61363 .30632 m
.6154 .30719 L
s
.6154 .30719 m
.61584 .30916 L
s
.09404 .11414 m
.08908 .10776 L
s
.08908 .10776 m
.09625 .10421 L
s
.09625 .10421 m
.09404 .11414 L
s
.72627 .88586 m
.7191 .8894 L
s
.7191 .8894 m
.72529 .88144 L
s
.72529 .88144 m
.72627 .88586 L
s
.65702 .28488 m
.63373 .29639 L
s
.63373 .29639 m
.65383 .27053 L
s
.65383 .27053 m
.65702 .28488 L
s
.66278 .25903 m
.63373 .24468 L
s
.63373 .24468 m
.65702 .23317 L
s
.65702 .23317 m
.66278 .25903 L
s
.5983 .25903 m
.59033 .25903 L
s
.59033 .25903 m
.59432 .25391 L
s
.59432 .25391 m
.5983 .25903 L
s
.62975 .31996 m
.62336 .31996 L
s
.62336 .31996 m
.62656 .30562 L
s
.62656 .30562 m
.63373 .31484 L
s
.63373 .31484 m
.62975 .31996 L
s
.96326 .0819 m
.94714 .06117 L
s
.94714 .06117 m
.95865 .06117 L
s
.95865 .06117 m
.96326 .0819 L
s
.66278 .25903 m
.65702 .23317 L
s
.65702 .23317 m
.66995 .22679 L
s
.66995 .22679 m
.66278 .25903 L
s
.96788 .06117 m
.94458 .04966 L
s
.94458 .04966 m
.94139 .03532 L
s
.94139 .03532 m
.95034 .02381 L
s
.95034 .02381 m
.96468 .02381 L
s
.96468 .02381 m
.97363 .03532 L
s
.97363 .03532 m
.96788 .06117 L
s
.94714 .06117 m
.93422 .04454 L
s
.93422 .04454 m
.94139 .03532 L
s
.94139 .03532 m
.94714 .06117 L
s
.699 .30562 m
.69182 .29639 L
s
.69182 .29639 m
.71512 .28488 L
s
.71512 .28488 m
.699 .30562 L
s
.86 .42977 m
.85283 .43331 L
s
.85283 .43331 m
.84565 .42977 L
s
.84565 .42977 m
.84388 .4218 L
s
.84388 .4218 m
.85283 .4103 L
s
.85283 .4103 m
.86177 .4218 L
s
.86177 .4218 m
.86 .42977 L
s
.10741 .03816 m
.09944 .03816 L
s
.09944 .03816 m
.10343 .03304 L
s
.10343 .03304 m
.10741 .03816 L
s
.09483 .05889 m
.09113 .05706 L
s
.09113 .05706 m
.09369 .05377 L
s
.09369 .05377 m
.09546 .05605 L
s
.09546 .05605 m
.09483 .05889 L
s
.76541 .12703 m
.76477 .12621 L
s
.76477 .12621 m
.76591 .12109 L
s
.76591 .12109 m
.76797 .12211 L
s
.76797 .12211 m
.76825 .12337 L
s
.76825 .12337 m
.76541 .12703 L
s
.48707 .61398 m
.48246 .6117 L
s
.48246 .6117 m
.48274 .61044 L
s
.48274 .61044 m
.48983 .61044 L
s
.48983 .61044 m
.48707 .61398 L
s
.48884 .30916 m
.48388 .30277 L
s
.48388 .30277 m
.49105 .29923 L
s
.49105 .29923 m
.48884 .30916 L
s
.56527 .61682 m
.56129 .62194 L
s
.56129 .62194 m
.55092 .61682 L
s
.55092 .61682 m
.55234 .61044 L
s
.55234 .61044 m
.56385 .61044 L
s
.56385 .61044 m
.56527 .61682 L
s
.48388 .59254 m
.47813 .5897 L
s
.47813 .5897 m
.48211 .58458 L
s
.48211 .58458 m
.48388 .59254 L
s
.60149 .03532 m
.60007 .03714 L
s
.60007 .03714 m
.59688 .03304 L
s
.59688 .03304 m
.59802 .02792 L
s
.59802 .02792 m
.60007 .02893 L
s
.60007 .02893 m
.60149 .03532 L
s
.53799 .67492 m
.53941 .66853 L
s
.53941 .66853 m
.54296 .66853 L
s
.54296 .66853 m
.53799 .67492 L
s
.56527 .04044 m
.55809 .03121 L
s
.55809 .03121 m
.56385 .03405 L
s
.56385 .03405 m
.56527 .04044 L
s
.54162 .60689 m
.53445 .61044 L
s
.53445 .61044 m
.53941 .60405 L
s
.53941 .60405 m
.54119 .60493 L
s
.54119 .60493 m
.54162 .60689 L
s
.69226 .61682 m
.69182 .61485 L
s
.69182 .61485 m
.69324 .61556 L
s
.69324 .61556 m
.69226 .61682 L
s
.53622 .30562 m
.5201 .31358 L
s
.5201 .31358 m
.52507 .29127 L
s
.52507 .29127 m
.53622 .30562 L
s
.77144 .11926 m
.77002 .12109 L
s
.77002 .12109 m
.76683 .11699 L
s
.76683 .11699 m
.76705 .11597 L
s
.76705 .11597 m
.77116 .118 L
s
.77116 .118 m
.77144 .11926 L
s
.49283 .61682 m
.49425 .61044 L
s
.49425 .61044 m
.49779 .61044 L
s
.49779 .61044 m
.49283 .61682 L
s
.54639 .6411 m
.54517 .64268 L
s
.54517 .64268 m
.54596 .63913 L
s
.54596 .63913 m
.54639 .6411 L
s
.60114 .31642 m
.59972 .31712 L
s
.59972 .31712 m
.60094 .31555 L
s
.60094 .31555 m
.60114 .31642 L
s
.47892 .60917 m
.47813 .60816 L
s
.47813 .60816 m
.48132 .60405 L
s
.48132 .60405 m
.48309 .60493 L
s
.48309 .60493 m
.48353 .60689 L
s
.48353 .60689 m
.47892 .60917 L
s
.61407 .31712 m
.61505 .31586 L
s
.61505 .31586 m
.61584 .31625 L
s
.61584 .31625 m
.61407 .31712 L
s
.69998 .68161 m
.69928 .68161 L
s
.69928 .68161 m
.6995 .6806 L
s
.6995 .6806 m
.70042 .68105 L
s
.70042 .68105 m
.69998 .68161 L
s
.53401 .67295 m
.53224 .67207 L
s
.53224 .67207 m
.53347 .6705 L
s
.53347 .6705 m
.53401 .67295 L
s
.53224 .67207 m
.52905 .67365 L
s
.52905 .67365 m
.52507 .66853 L
s
.52507 .66853 m
.53224 .67207 L
s
.71512 .72662 m
.70617 .71512 L
s
.70617 .71512 m
.71192 .71228 L
s
.71192 .71228 m
.71768 .71512 L
s
.71768 .71512 m
.71512 .72662 L
s
.52329 .59609 m
.51754 .59893 L
s
.51754 .59893 m
.51612 .59254 L
s
.51612 .59254 m
.52329 .59609 L
s
.70617 .59893 m
.70219 .60405 L
s
.70219 .60405 m
.6958 .60405 L
s
.6958 .60405 m
.69403 .59609 L
s
.69403 .59609 m
.69679 .59254 L
s
.69679 .59254 m
.70121 .59254 L
s
.70121 .59254 m
.70617 .59893 L
s
.54517 .64268 m
.5434 .63471 L
s
.5434 .63471 m
.54738 .63275 L
s
.54738 .63275 m
.54517 .64268 L
s
.5434 .65064 m
.54836 .64425 L
s
.54836 .64425 m
.55234 .64622 L
s
.55234 .64622 m
.5434 .65064 L
s
.52408 .66726 m
.52329 .66625 L
s
.52329 .66625 m
.52649 .66214 L
s
.52649 .66214 m
.53047 .66411 L
s
.53047 .66411 m
.52408 .66726 L
s
.5488 .61044 m
.54978 .60917 L
s
.54978 .60917 m
.55057 .60956 L
s
.55057 .60956 m
.5488 .61044 L
s
.68705 .62352 m
.68635 .62352 L
s
.68635 .62352 m
.68658 .6225 L
s
.68658 .6225 m
.68749 .62296 L
s
.68749 .62296 m
.68705 .62352 L
s
.68651 .60689 m
.68493 .60689 L
s
.68493 .60689 m
.68528 .60531 L
s
.68528 .60531 m
.68651 .60689 L
s
.78693 .03942 m
.78665 .03816 L
s
.78665 .03816 m
.78791 .03816 L
s
.78791 .03816 m
.78693 .03942 L
s
.57918 .73104 m
.57741 .73017 L
s
.57741 .73017 m
.57863 .72859 L
s
.57863 .72859 m
.57918 .73104 L
s
.82776 .41384 m
.82654 .41542 L
s
.82654 .41542 m
.82457 .41542 L
s
.82457 .41542 m
.82334 .41384 L
s
.82334 .41384 m
.82378 .41188 L
s
.82378 .41188 m
.82555 .411 L
s
.82555 .411 m
.82732 .41188 L
s
.82732 .41188 m
.82776 .41384 L
s
.09227 .0417 m
.08652 .04454 L
s
.08652 .04454 m
.0851 .03816 L
s
.0851 .03816 m
.09227 .0417 L
s
.5434 .65064 m
.53622 .65418 L
s
.53622 .65418 m
.54241 .64622 L
s
.54241 .64622 m
.5434 .65064 L
s
.70936 .21756 m
.70987 .21984 L
s
.70987 .21984 m
.70475 .21984 L
s
.70475 .21984 m
.70156 .21573 L
s
.70156 .21573 m
.70361 .21472 L
s
.70361 .21472 m
.70936 .21756 L
s
.50717 .2498 m
.50142 .25264 L
s
.50142 .25264 m
.50319 .24468 L
s
.50319 .24468 m
.50717 .2498 L
s
.75851 .95034 m
.74815 .95546 L
s
.74815 .95546 m
.74416 .95034 L
s
.74416 .95034 m
.75134 .94111 L
s
.75134 .94111 m
.75709 .94395 L
s
.75709 .94395 m
.75851 .95034 L
s
.613 .29639 m
.60787 .29639 L
s
.60787 .29639 m
.61186 .29127 L
s
.61186 .29127 m
.613 .29639 L
s
.70822 .21244 m
.699 .21244 L
s
.699 .21244 m
.69837 .21163 L
s
.69837 .21163 m
.70247 .2096 L
s
.70247 .2096 m
.70822 .21244 L
s
.76427 .97619 m
.76206 .97335 L
s
.76206 .97335 m
.76383 .97422 L
s
.76383 .97422 m
.76427 .97619 L
s
.61761 .31712 m
.61682 .31611 L
s
.61682 .31611 m
.61726 .31555 L
s
.61726 .31555 m
.61761 .31712 L
s
.60724 .312 m
.60326 .30688 L
s
.60326 .30688 m
.60424 .30562 L
s
.60424 .30562 m
.60582 .30562 L
s
.60582 .30562 m
.60724 .312 L
s
.73636 .25391 m
.73522 .25334 L
s
.73522 .25334 m
.73664 .25264 L
s
.73664 .25264 m
.73636 .25391 L
s
.96788 .06117 m
.94714 .06117 L
s
.94714 .06117 m
.94458 .04966 L
s
.94458 .04966 m
.96788 .06117 L
s
.93422 .04454 m
.9296 .02381 L
s
.9296 .02381 m
.95034 .02381 L
s
.95034 .02381 m
.93422 .04454 L
s
.51931 .26541 m
.51435 .25903 L
s
.51435 .25903 m
.52073 .25903 L
s
.52073 .25903 m
.51931 .26541 L
s
.85744 .50575 m
.85106 .50575 L
s
.85106 .50575 m
.84707 .50063 L
s
.84707 .50063 m
.86 .49425 L
s
.86 .49425 m
.85744 .50575 L
s
.69182 .29639 m
.68288 .28488 L
s
.68288 .28488 m
.71512 .28488 L
s
.71512 .28488 m
.69182 .29639 L
s
.92704 .03532 m
.9181 .02381 L
s
.9181 .02381 m
.9296 .02381 L
s
.9296 .02381 m
.92704 .03532 L
s
.69005 .31712 m
.6789 .33147 L
s
.6789 .33147 m
.661 .33147 L
s
.661 .33147 m
.64985 .31712 L
s
.64985 .31712 m
.65383 .29923 L
s
.65383 .29923 m
.66995 .29127 L
s
.66995 .29127 m
.68607 .29923 L
s
.68607 .29923 m
.69005 .31712 L
s
.699 .30562 m
.66995 .29127 L
s
.66995 .29127 m
.68288 .28488 L
s
.68288 .28488 m
.699 .30562 L
s
.64985 .31712 m
.63373 .29639 L
s
.63373 .29639 m
.6441 .29127 L
s
.6441 .29127 m
.64985 .31712 L
s
.7191 .26699 m
.699 .27692 L
s
.699 .27692 m
.6789 .26699 L
s
.6789 .26699 m
.67393 .24468 L
s
.67393 .24468 m
.68784 .22679 L
s
.68784 .22679 m
.71015 .22679 L
s
.71015 .22679 m
.72406 .24468 L
s
.72406 .24468 m
.7191 .26699 L
s
.85283 .31712 m
.84885 .29923 L
s
.84885 .29923 m
.86177 .30562 L
s
.86177 .30562 m
.85283 .31712 L
s
.91092 .31712 m
.88188 .30277 L
s
.88188 .30277 m
.90773 .30277 L
s
.90773 .30277 m
.91092 .31712 L
s
.15036 .18659 m
.13302 .16428 L
s
.13302 .16428 m
.1454 .16428 L
s
.1454 .16428 m
.15036 .18659 L
s
.90517 .34298 m
.898 .31074 L
s
.898 .31074 m
.90915 .32508 L
s
.90915 .32508 m
.90517 .34298 L
s
.68607 .33501 m
.67614 .33501 L
s
.67614 .33501 m
.69005 .31712 L
s
.69005 .31712 m
.68607 .33501 L
s
.898 .34652 m
.88188 .35448 L
s
.88188 .35448 m
.90198 .32863 L
s
.90198 .32863 m
.898 .34652 L
s
.68012 .59805 m
.66897 .59254 L
s
.66897 .59254 m
.67393 .57023 L
s
.67393 .57023 m
.68012 .59805 L
s
.8747 .35094 m
.85858 .34298 L
s
.85858 .34298 m
.89082 .34298 L
s
.89082 .34298 m
.8747 .35094 L
s
.83352 .5201 m
.82555 .5201 L
s
.82555 .5201 m
.82953 .51498 L
s
.82953 .51498 m
.83352 .5201 L
s
.76028 .96539 m
.75709 .96696 L
s
.75709 .96696 m
.75311 .96184 L
s
.75311 .96184 m
.76028 .96539 L
s
.64985 .43331 m
.6409 .4218 L
s
.6409 .4218 m
.64666 .41896 L
s
.64666 .41896 m
.65241 .4218 L
s
.65241 .4218 m
.64985 .43331 L
s
.60263 .2498 m
.59751 .2498 L
s
.59751 .2498 m
.60149 .24468 L
s
.60149 .24468 m
.60263 .2498 L
s
.6409 .30562 m
.63692 .31074 L
s
.63692 .31074 m
.63054 .31074 L
s
.63054 .31074 m
.62656 .30562 L
s
.62656 .30562 m
.63152 .29923 L
s
.63152 .29923 m
.63594 .29923 L
s
.63594 .29923 m
.6409 .30562 L
s
.59751 .29127 m
.59254 .28488 L
s
.59254 .28488 m
.59609 .28488 L
s
.59609 .28488 m
.59751 .29127 L
s
.68607 .19581 m
.68493 .19069 L
s
.68493 .19069 m
.68749 .18943 L
s
.68749 .18943 m
.68607 .19581 L
s
.75213 .96058 m
.75134 .95956 L
s
.75134 .95956 m
.75453 .95546 L
s
.75453 .95546 m
.75851 .95742 L
s
.75851 .95742 m
.75213 .96058 L
s
.58395 .26927 m
.58237 .26927 L
s
.58237 .26927 m
.58281 .26871 L
s
.58281 .26871 m
.58395 .26927 L
s
.62179 .33021 m
.62108 .33021 L
s
.62108 .33021 m
.62131 .32919 L
s
.62131 .32919 m
.62222 .32964 L
s
.62222 .32964 m
.62179 .33021 L
s
.62124 .31358 m
.61966 .31358 L
s
.61966 .31358 m
.62001 .312 L
s
.62001 .312 m
.62124 .31358 L
s
.0417 .03973 m
.03993 .03886 L
s
.03993 .03886 m
.04116 .03728 L
s
.04116 .03728 m
.0417 .03973 L
s
.73983 .2096 m
.73869 .21016 L
s
.73869 .21016 m
.73841 .2089 L
s
.73841 .2089 m
.73983 .2096 L
s
.5635 .28331 m
.56227 .28488 L
s
.56227 .28488 m
.5603 .28488 L
s
.5603 .28488 m
.55908 .28331 L
s
.55908 .28331 m
.55952 .28134 L
s
.55952 .28134 m
.56129 .28046 L
s
.56129 .28046 m
.56306 .28134 L
s
.56306 .28134 m
.5635 .28331 L
s
.69324 .20504 m
.69005 .20093 L
s
.69005 .20093 m
.69644 .20093 L
s
.69644 .20093 m
.69324 .20504 L
s
.10244 .09625 m
.09802 .09625 L
s
.09802 .09625 m
.09625 .08829 L
s
.09625 .08829 m
.10244 .09625 L
s
.56846 .27692 m
.56271 .27976 L
s
.56271 .27976 m
.56129 .27338 L
s
.56129 .27338 m
.56846 .27692 L
s
.74141 .9181 m
.73699 .9181 L
s
.73699 .9181 m
.73522 .91013 L
s
.73522 .91013 m
.74141 .9181 L
s
.84964 .51214 m
.84821 .50575 L
s
.84821 .50575 m
.8546 .50575 L
s
.8546 .50575 m
.84964 .51214 L
s
.60787 .29639 m
.60149 .29639 L
s
.60149 .29639 m
.6007 .29285 L
s
.6007 .29285 m
.60787 .29639 L
s
.66499 .34936 m
.6588 .35732 L
s
.6588 .35732 m
.64887 .35732 L
s
.64887 .35732 m
.64268 .34936 L
s
.64268 .34936 m
.64488 .33943 L
s
.64488 .33943 m
.65383 .33501 L
s
.65383 .33501 m
.66278 .33943 L
s
.66278 .33943 m
.66499 .34936 L
s
.54517 .05605 m
.51612 .0417 L
s
.51612 .0417 m
.54836 .0417 L
s
.54836 .0417 m
.54517 .05605 L
s
.87293 .34298 m
.85858 .34298 L
s
.85858 .34298 m
.85283 .31712 L
s
.85283 .31712 m
.87293 .34298 L
s
.61142 .7509 m
.59751 .73301 L
s
.59751 .73301 m
.61761 .72308 L
s
.61761 .72308 m
.61142 .7509 L
s
.15435 .08829 m
.16152 .05605 L
s
.16152 .05605 m
.1655 .07394 L
s
.1655 .07394 m
.15435 .08829 L
s
.57564 .06401 m
.56846 .06756 L
s
.56846 .06756 m
.56129 .06401 L
s
.56129 .06401 m
.55809 .04966 L
s
.55809 .04966 m
.57244 .04966 L
s
.57244 .04966 m
.57741 .05605 L
s
.57741 .05605 m
.57564 .06401 L
s
.29702 .32351 m
.29206 .31712 L
s
.29206 .31712 m
.30199 .31712 L
s
.30199 .31712 m
.29702 .32351 L
s
.31535 .35732 m
.31314 .3474 L
s
.31314 .3474 m
.32032 .35094 L
s
.32032 .35094 m
.31535 .35732 L
s
.59574 .08987 m
.58856 .09341 L
s
.58856 .09341 m
.58139 .08987 L
s
.58139 .08987 m
.57962 .0819 L
s
.57962 .0819 m
.58856 .0704 L
s
.58856 .0704 m
.59751 .0819 L
s
.59751 .0819 m
.59574 .08987 L
s
.29604 .33501 m
.28808 .33501 L
s
.28808 .33501 m
.29427 .32705 L
s
.29427 .32705 m
.29604 .33501 L
s
.29525 .37294 m
.29206 .36883 L
s
.29206 .36883 m
.29525 .36725 L
s
.29525 .36725 m
.29844 .36883 L
s
.29844 .36883 m
.29525 .37294 L
s
.32174 .31586 m
.32075 .31712 L
s
.32075 .31712 m
.3064 .31712 L
s
.3064 .31712 m
.31535 .3127 L
s
.31535 .3127 m
.32174 .31586 L
s
.75276 .91627 m
.75185 .91582 L
s
.75185 .91582 m
.75276 .91171 L
s
.75276 .91171 m
.7563 .91171 L
s
.7563 .91171 m
.75276 .91627 L
s
.3444 .17508 m
.33005 .17508 L
s
.33005 .17508 m
.33324 .16073 L
s
.33324 .16073 m
.3444 .17508 L
s
.83364 .21244 m
.82953 .21244 L
s
.82953 .21244 m
.82697 .20093 L
s
.82697 .20093 m
.83529 .20504 L
s
.83529 .20504 m
.83364 .21244 L
s
.77463 .9296 m
.76313 .9296 L
s
.76313 .9296 m
.76569 .9181 L
s
.76569 .9181 m
.77365 .9181 L
s
.77365 .9181 m
.7764 .92164 L
s
.7764 .92164 m
.77463 .9296 L
s
.75851 .88586 m
.76028 .87789 L
s
.76028 .87789 m
.76249 .88074 L
s
.76249 .88074 m
.75851 .88586 L
s
.27692 .34936 m
.27196 .34298 L
s
.27196 .34298 m
.27913 .33943 L
s
.27913 .33943 m
.27692 .34936 L
s
.75709 .89224 m
.75851 .88586 L
s
.75851 .88586 m
.76206 .88586 L
s
.76206 .88586 m
.75709 .89224 L
s
.82697 .36883 m
.82748 .37111 L
s
.82748 .37111 m
.82236 .37111 L
s
.82236 .37111 m
.81917 .367 L
s
.81917 .367 m
.82122 .36599 L
s
.82122 .36599 m
.82697 .36883 L
s
.871 .21244 m
.86689 .21244 L
s
.86689 .21244 m
.86639 .21016 L
s
.86639 .21016 m
.871 .21244 L
s
.89686 .21244 m
.88535 .21244 L
s
.88535 .21244 m
.8911 .2096 L
s
.8911 .2096 m
.89686 .21244 L
s
.39532 .20732 m
.39134 .2022 L
s
.39134 .2022 m
.39232 .20093 L
s
.39232 .20093 m
.3939 .20093 L
s
.3939 .20093 m
.39532 .20732 L
s
.85397 .40518 m
.85283 .40461 L
s
.85283 .40461 m
.85425 .40391 L
s
.85425 .40391 m
.85397 .40518 L
s
.30739 .16073 m
.29844 .14923 L
s
.29844 .14923 m
.31137 .14284 L
s
.31137 .14284 m
.30739 .16073 L
s
.58856 .12211 m
.58139 .12565 L
s
.58139 .12565 m
.57421 .12211 L
s
.57421 .12211 m
.57244 .11414 L
s
.57244 .11414 m
.57741 .10776 L
s
.57741 .10776 m
.59175 .10776 L
s
.59175 .10776 m
.58856 .12211 L
s
.27018 .29923 m
.26797 .2893 L
s
.26797 .2893 m
.27515 .29285 L
s
.27515 .29285 m
.27018 .29923 L
s
.25008 .31484 m
.24689 .31074 L
s
.24689 .31074 m
.25008 .30916 L
s
.25008 .30916 m
.25328 .31074 L
s
.25328 .31074 m
.25008 .31484 L
s
.88147 .44583 m
.88045 .44583 L
s
.88045 .44583 m
.87726 .44172 L
s
.87726 .44172 m
.87931 .44071 L
s
.87931 .44071 m
.88045 .44127 L
s
.88045 .44127 m
.88147 .44583 L
s
.88228 .44583 m
.88147 .44583 L
s
.88147 .44583 m
.88045 .44127 L
s
.88045 .44127 m
.88301 .44254 L
s
.88301 .44254 m
.88228 .44583 L
s
.38956 .19171 m
.38381 .19455 L
s
.38381 .19455 m
.38558 .18659 L
s
.38558 .18659 m
.38956 .19171 L
s
.87561 .40107 m
.87151 .40107 L
s
.87151 .40107 m
.86986 .39367 L
s
.86986 .39367 m
.87356 .39184 L
s
.87356 .39184 m
.87726 .39367 L
s
.87726 .39367 m
.87561 .40107 L
s
.29639 .14 m
.29127 .14 L
s
.29127 .14 m
.29525 .13488 L
s
.29525 .13488 m
.29639 .14 L
s
.3064 .31712 m
.29844 .31712 L
s
.29844 .31712 m
.29923 .31358 L
s
.29923 .31358 m
.30818 .30916 L
s
.30818 .30916 m
.31137 .31074 L
s
.31137 .31074 m
.3064 .31712 L
s
.75851 .90887 m
.7539 .90659 L
s
.7539 .90659 m
.76028 .90659 L
s
.76028 .90659 m
.75851 .90887 L
s
.85027 .21244 m
.83876 .21244 L
s
.83876 .21244 m
.84451 .2096 L
s
.84451 .2096 m
.85027 .21244 L
s
.24866 .13488 m
.24468 .12976 L
s
.24468 .12976 m
.24566 .12849 L
s
.24566 .12849 m
.24724 .12849 L
s
.24724 .12849 m
.24866 .13488 L
s
.61044 .40107 m
.60866 .40195 L
s
.60866 .40195 m
.60921 .39949 L
s
.60921 .39949 m
.61044 .40107 L
s
.35973 .18659 m
.35078 .17508 L
s
.35078 .17508 m
.36371 .16869 L
s
.36371 .16869 m
.35973 .18659 L
s
.87982 .43843 m
.8747 .43843 L
s
.8747 .43843 m
.87407 .43762 L
s
.87407 .43762 m
.87818 .43559 L
s
.87818 .43559 m
.87931 .43615 L
s
.87931 .43615 m
.87982 .43843 L
s
.88393 .43843 m
.87982 .43843 L
s
.87982 .43843 m
.87931 .43615 L
s
.87931 .43615 m
.88393 .43843 L
s
.89224 .40107 m
.88996 .40107 L
s
.88996 .40107 m
.8911 .40051 L
s
.8911 .40051 m
.89224 .40107 L
s
.301 .16073 m
.30021 .15972 L
s
.30021 .15972 m
.30065 .15915 L
s
.30065 .15915 m
.301 .16073 L
s
.29064 .15561 m
.28665 .15049 L
s
.28665 .15049 m
.28764 .14923 L
s
.28764 .14923 m
.28921 .14923 L
s
.28921 .14923 m
.29064 .15561 L
s
.75434 .91171 m
.75276 .91171 L
s
.75276 .91171 m
.75311 .91013 L
s
.75311 .91013 m
.75434 .91171 L
s
.75134 .9181 m
.7502 .91298 L
s
.7502 .91298 m
.75276 .91171 L
s
.75276 .91171 m
.75134 .9181 L
s
.33147 .34936 m
.3243 .35291 L
s
.3243 .35291 m
.31712 .34936 L
s
.31712 .34936 m
.32828 .33501 L
s
.32828 .33501 m
.33147 .34936 L
s
.26478 .1326 m
.26159 .12849 L
s
.26159 .12849 m
.26797 .12849 L
s
.26797 .12849 m
.26478 .1326 L
s
.62036 .42977 m
.61485 .42977 L
s
.61485 .42977 m
.61142 .42535 L
s
.61142 .42535 m
.61363 .41542 L
s
.61363 .41542 m
.62159 .41542 L
s
.62159 .41542 m
.62656 .4218 L
s
.62656 .4218 m
.62036 .42977 L
s
.88763 .40335 m
.88586 .40107 L
s
.88586 .40107 m
.89224 .40107 L
s
.89224 .40107 m
.88763 .40335 L
s
.77783 .91525 m
.77144 .91525 L
s
.77144 .91525 m
.77861 .91171 L
s
.77861 .91171 m
.77783 .91525 L
s
.75595 .92038 m
.75185 .92038 L
s
.75185 .92038 m
.75162 .91936 L
s
.75162 .91936 m
.75674 .91683 L
s
.75674 .91683 m
.75595 .92038 L
s
.23829 .12976 m
.23731 .12849 L
s
.23731 .12849 m
.23801 .12849 L
s
.23801 .12849 m
.23829 .12976 L
s
.60326 .39184 m
.60212 .39241 L
s
.60212 .39241 m
.60184 .39114 L
s
.60184 .39114 m
.60272 .39114 L
s
.60272 .39114 m
.60326 .39184 L
s
.60051 .41384 m
.60007 .41188 L
s
.60007 .41188 m
.60204 .41188 L
s
.60204 .41188 m
.60051 .41384 L
s
.82811 .37395 m
.82697 .37339 L
s
.82697 .37339 m
.82776 .37237 L
s
.82776 .37237 m
.82811 .37395 L
s
.74141 .85362 m
.73983 .85362 L
s
.73983 .85362 m
.74018 .85204 L
s
.74018 .85204 m
.74141 .85362 L
s
.57465 .08829 m
.57343 .08987 L
s
.57343 .08987 m
.57146 .08987 L
s
.57146 .08987 m
.57023 .08829 L
s
.57023 .08829 m
.57067 .08632 L
s
.57067 .08632 m
.57244 .08545 L
s
.57244 .08545 m
.57421 .08632 L
s
.57421 .08632 m
.57465 .08829 L
s
.27416 .31712 m
.2662 .31712 L
s
.2662 .31712 m
.26797 .30916 L
s
.26797 .30916 m
.27416 .31712 L
s
.77365 .9181 m
.76569 .9181 L
s
.76569 .9181 m
.77144 .91525 L
s
.77144 .91525 m
.77365 .9181 L
s
.77463 .13361 m
.76746 .14284 L
s
.76746 .14284 m
.75134 .12211 L
s
.75134 .12211 m
.77463 .13361 L
s
.80049 .55234 m
.78437 .5603 L
s
.78437 .5603 m
.79331 .5201 L
s
.79331 .5201 m
.80049 .55234 L
s
.85602 .40619 m
.85653 .40847 L
s
.85653 .40847 m
.85141 .40847 L
s
.85141 .40847 m
.84821 .40436 L
s
.84821 .40436 m
.85027 .40335 L
s
.85027 .40335 m
.85602 .40619 L
s
.24291 .11926 m
.23716 .12211 L
s
.23716 .12211 m
.23893 .11414 L
s
.23893 .11414 m
.24291 .11926 L
s
.91759 .21244 m
.91348 .21244 L
s
.91348 .21244 m
.91184 .20504 L
s
.91184 .20504 m
.91554 .20321 L
s
.91554 .20321 m
.91924 .20504 L
s
.91924 .20504 m
.91759 .21244 L
s
.34873 .16585 m
.34361 .16585 L
s
.34361 .16585 m
.34759 .16073 L
s
.34759 .16073 m
.34873 .16585 L
s
.85488 .40107 m
.84565 .40107 L
s
.84565 .40107 m
.84502 .40026 L
s
.84502 .40026 m
.84913 .39823 L
s
.84913 .39823 m
.85488 .40107 L
s
.93422 .21244 m
.93194 .21244 L
s
.93194 .21244 m
.93308 .21188 L
s
.93308 .21188 m
.93422 .21244 L
s
.35334 .18659 m
.35256 .18557 L
s
.35256 .18557 m
.35299 .18501 L
s
.35299 .18501 m
.35334 .18659 L
s
.34298 .18147 m
.339 .17634 L
s
.339 .17634 m
.33998 .17508 L
s
.33998 .17508 m
.34156 .17508 L
s
.34156 .17508 m
.34298 .18147 L
s
.88301 .44254 m
.88188 .44198 L
s
.88188 .44198 m
.8833 .44127 L
s
.8833 .44127 m
.88301 .44254 L
s
.64268 .46555 m
.61761 .43331 L
s
.61761 .43331 m
.64666 .44766 L
s
.64666 .44766 m
.64268 .46555 L
s
.64666 .51214 m
.61761 .49779 L
s
.61761 .49779 m
.65383 .4799 L
s
.65383 .4799 m
.64666 .51214 L
s
.25505 .13488 m
.25008 .12849 L
s
.25008 .12849 m
.25647 .12849 L
s
.25647 .12849 m
.25505 .13488 L
s
.61761 .4103 m
.60866 .4218 L
s
.60866 .4218 m
.60468 .40391 L
s
.60468 .40391 m
.61264 .40391 L
s
.61264 .40391 m
.61761 .4103 L
s
.42756 .16585 m
.41861 .15435 L
s
.41861 .15435 m
.45085 .15435 L
s
.45085 .15435 m
.42756 .16585 L
s
.66278 .5201 m
.64666 .51214 L
s
.64666 .51214 m
.65781 .49779 L
s
.65781 .49779 m
.66278 .5201 L
s
.42579 .18659 m
.41463 .20093 L
s
.41463 .20093 m
.39674 .20093 L
s
.39674 .20093 m
.38558 .18659 L
s
.38558 .18659 m
.38956 .16869 L
s
.38956 .16869 m
.40568 .16073 L
s
.40568 .16073 m
.4218 .16869 L
s
.4218 .16869 m
.42579 .18659 L
s
.43473 .17508 m
.40568 .16073 L
s
.40568 .16073 m
.41861 .15435 L
s
.41861 .15435 m
.43473 .17508 L
s
.38558 .18659 m
.36946 .16585 L
s
.36946 .16585 m
.37983 .16073 L
s
.37983 .16073 m
.38558 .18659 L
s
.45483 .13645 m
.43473 .14638 L
s
.43473 .14638 m
.41463 .13645 L
s
.41463 .13645 m
.40967 .11414 L
s
.40967 .11414 m
.42358 .09625 L
s
.42358 .09625 m
.44589 .09625 L
s
.44589 .09625 m
.4598 .11414 L
s
.4598 .11414 m
.45483 .13645 L
s
.8027 .5782 m
.78039 .5782 L
s
.78039 .5782 m
.79154 .56385 L
s
.79154 .56385 m
.8027 .5782 L
s
.80049 .55234 m
.79651 .53445 L
s
.79651 .53445 m
.82555 .5201 L
s
.82555 .5201 m
.80049 .55234 L
s
.77542 .5201 m
.73522 .5201 L
s
.73522 .5201 m
.74637 .50575 L
s
.74637 .50575 m
.77542 .5201 L
s
.37841 .4799 m
.36106 .45759 L
s
.36106 .45759 m
.37344 .45759 L
s
.37344 .45759 m
.37841 .4799 L
s
.72804 .55234 m
.73301 .53003 L
s
.73301 .53003 m
.75311 .5201 L
s
.75311 .5201 m
.72804 .55234 L
s
.4218 .20448 m
.41188 .20448 L
s
.41188 .20448 m
.42579 .18659 L
s
.42579 .18659 m
.4218 .20448 L
s
.74815 .5782 m
.73424 .5603 L
s
.73424 .5603 m
.7392 .53799 L
s
.7392 .53799 m
.74815 .5782 L
s
.71512 .10421 m
.70794 .10776 L
s
.70794 .10776 m
.699 .09625 L
s
.699 .09625 m
.71512 .10421 L
s
.78039 .5782 m
.75808 .5782 L
s
.75808 .5782 m
.74416 .5603 L
s
.74416 .5603 m
.78039 .5782 L
s
.61264 .37522 m
.60468 .37522 L
s
.60468 .37522 m
.60645 .36725 L
s
.60645 .36725 m
.61264 .37522 L
s
.92682 .21244 m
.92271 .21244 L
s
.92271 .21244 m
.92732 .21016 L
s
.92732 .21016 m
.92682 .21244 L
s
.58458 .14 m
.57564 .12849 L
s
.57564 .12849 m
.58139 .12565 L
s
.58139 .12565 m
.58714 .12849 L
s
.58714 .12849 m
.58458 .14 L
s
.33836 .11926 m
.33324 .11926 L
s
.33324 .11926 m
.33722 .11414 L
s
.33722 .11414 m
.33836 .11926 L
s
.37664 .17508 m
.37266 .1802 L
s
.37266 .1802 m
.36627 .1802 L
s
.36627 .1802 m
.36229 .17508 L
s
.36229 .17508 m
.36725 .16869 L
s
.36725 .16869 m
.37167 .16869 L
s
.37167 .16869 m
.37664 .17508 L
s
.33324 .16073 m
.32828 .15435 L
s
.32828 .15435 m
.33182 .15435 L
s
.33182 .15435 m
.33324 .16073 L
s
.83273 .38444 m
.83159 .37932 L
s
.83159 .37932 m
.83415 .37806 L
s
.83415 .37806 m
.83273 .38444 L
s
.9217 .21244 m
.92088 .21244 L
s
.92088 .21244 m
.92015 .20915 L
s
.92015 .20915 m
.92271 .20788 L
s
.92271 .20788 m
.9217 .21244 L
s
.31968 .13873 m
.31811 .13873 L
s
.31811 .13873 m
.31854 .13817 L
s
.31854 .13817 m
.31968 .13873 L
s
.55652 .03689 m
.55582 .03689 L
s
.55582 .03689 m
.55604 .03588 L
s
.55604 .03588 m
.55695 .03633 L
s
.55695 .03633 m
.55652 .03689 L
s
.35697 .18304 m
.3554 .18304 L
s
.3554 .18304 m
.35575 .18147 L
s
.35575 .18147 m
.35697 .18304 L
s
.26975 .33305 m
.26797 .33217 L
s
.26797 .33217 m
.2692 .3306 L
s
.2692 .3306 m
.26975 .33305 L
s
.88649 .39823 m
.88535 .39879 L
s
.88535 .39879 m
.88507 .39753 L
s
.88507 .39753 m
.88649 .39823 L
s
.29923 .15277 m
.298 .15435 L
s
.298 .15435 m
.29604 .15435 L
s
.29604 .15435 m
.29481 .15277 L
s
.29481 .15277 m
.29525 .1508 L
s
.29525 .1508 m
.29702 .14993 L
s
.29702 .14993 m
.29879 .1508 L
s
.29879 .1508 m
.29923 .15277 L
s
.8399 .39367 m
.83671 .38956 L
s
.83671 .38956 m
.84309 .38956 L
s
.84309 .38956 m
.8399 .39367 L
s
.33049 .38956 m
.32607 .38956 L
s
.32607 .38956 m
.3243 .3816 L
s
.3243 .3816 m
.33049 .38956 L
s
.3042 .14638 m
.29844 .14923 L
s
.29844 .14923 m
.29702 .14284 L
s
.29702 .14284 m
.3042 .14638 L
s
.8948 .20321 m
.89019 .20093 L
s
.89019 .20093 m
.89657 .20093 L
s
.89657 .20093 m
.8948 .20321 L
s
.6154 .40746 m
.61044 .40107 L
s
.61044 .40107 m
.61761 .39753 L
s
.61761 .39753 m
.6154 .40746 L
s
.34361 .16585 m
.33722 .16585 L
s
.33722 .16585 m
.33644 .16231 L
s
.33644 .16231 m
.34361 .16585 L
s
.31933 .33943 m
.30818 .34494 L
s
.30818 .34494 m
.29702 .33943 L
s
.29702 .33943 m
.29427 .32705 L
s
.29427 .32705 m
.30199 .31712 L
s
.30199 .31712 m
.31437 .31712 L
s
.31437 .31712 m
.32209 .32705 L
s
.32209 .32705 m
.31933 .33943 L
s
.24787 .03816 m
.24468 .02381 L
s
.24468 .02381 m
.27692 .02381 L
s
.27692 .02381 m
.24787 .03816 L
s
.75134 .44766 m
.7191 .44766 L
s
.7191 .44766 m
.71512 .42977 L
s
.71512 .42977 m
.75134 .44766 L
s
.80943 .35448 m
.80049 .34298 L
s
.80049 .34298 m
.81838 .34298 L
s
.81838 .34298 m
.80943 .35448 L
s
.74416 .4799 m
.73301 .46555 L
s
.73301 .46555 m
.73699 .44766 L
s
.73699 .44766 m
.74416 .4799 L
s
.6958 .0819 m
.6843 .0819 L
s
.6843 .0819 m
.69005 .05605 L
s
.69005 .05605 m
.6958 .0819 L
s
.27692 .20448 m
.26301 .18659 L
s
.26301 .18659 m
.28808 .15435 L
s
.28808 .15435 m
.27692 .20448 L
s
.7191 .77321 m
.71512 .75532 L
s
.71512 .75532 m
.73301 .75532 L
s
.73301 .75532 m
.7191 .77321 L
s
.27692 .16869 m
.25682 .15876 L
s
.25682 .15876 m
.25185 .13645 L
s
.25185 .13645 m
.27692 .16869 L
s
.76107 .11414 m
.73522 .11414 L
s
.73522 .11414 m
.75851 .10264 L
s
.75851 .10264 m
.76107 .11414 L
s
.78039 .5782 m
.76427 .57023 L
s
.76427 .57023 m
.80049 .55234 L
s
.80049 .55234 m
.78039 .5782 L
s
.76249 .20093 m
.74815 .20093 L
s
.74815 .20093 m
.75134 .18659 L
s
.75134 .18659 m
.76249 .20093 L
s
.82059 .5782 m
.8027 .5782 L
s
.8027 .5782 m
.79154 .56385 L
s
.79154 .56385 m
.82059 .5782 L
s
.57244 .11414 m
.54119 .15435 L
s
.54119 .15435 m
.49105 .15435 L
s
.49105 .15435 m
.4598 .11414 L
s
.4598 .11414 m
.47095 .06401 L
s
.47095 .06401 m
.51612 .0417 L
s
.51612 .0417 m
.56129 .06401 L
s
.56129 .06401 m
.57244 .11414 L
s
.61761 .10776 m
.59432 .09625 L
s
.59432 .09625 m
.60866 .09625 L
s
.60866 .09625 m
.61761 .10776 L
s
.37841 .33501 m
.3645 .31712 L
s
.3645 .31712 m
.38239 .31712 L
s
.38239 .31712 m
.37841 .33501 L
s
.38239 .3816 m
.35334 .36725 L
s
.35334 .36725 m
.38956 .34936 L
s
.38956 .34936 m
.38239 .3816 L
s
.4017 .20732 m
.39674 .20093 L
s
.39674 .20093 m
.40312 .20093 L
s
.40312 .20093 m
.4017 .20732 L
s
.58025 .10776 m
.57386 .10776 L
s
.57386 .10776 m
.56988 .10264 L
s
.56988 .10264 m
.58281 .09625 L
s
.58281 .09625 m
.58025 .10776 L
s
.36946 .37522 m
.35334 .38318 L
s
.35334 .38318 m
.33324 .35732 L
s
.33324 .35732 m
.36946 .37522 L
s
.39851 .38956 m
.38239 .3816 L
s
.38239 .3816 m
.38956 .34936 L
s
.38956 .34936 m
.39851 .38956 L
s
.38956 .42977 m
.36946 .4397 L
s
.36946 .4397 m
.34936 .42977 L
s
.34936 .42977 m
.34042 .38956 L
s
.34042 .38956 m
.38062 .38956 L
s
.38062 .38956 m
.39453 .40746 L
s
.39453 .40746 m
.38956 .42977 L
s
.39453 .40746 m
.36946 .37522 L
s
.36946 .37522 m
.39851 .38956 L
s
.39851 .38956 m
.39453 .40746 L
s
.65383 .15435 m
.62798 .15435 L
s
.62798 .15435 m
.63054 .14284 L
s
.63054 .14284 m
.65383 .15435 L
s
.91348 .21244 m
.90198 .21244 L
s
.90198 .21244 m
.898 .20732 L
s
.898 .20732 m
.89942 .20093 L
s
.89942 .20093 m
.90517 .19809 L
s
.90517 .19809 m
.91092 .20093 L
s
.91092 .20093 m
.91348 .21244 L
s
.34617 .15435 m
.34042 .1515 L
s
.34042 .1515 m
.3444 .14638 L
s
.3444 .14638 m
.34617 .15435 L
s
.31933 .14284 m
.31137 .14284 L
s
.31137 .14284 m
.31535 .13772 L
s
.31535 .13772 m
.31933 .14284 L
s
.88507 .20093 m
.87868 .20093 L
s
.87868 .20093 m
.8747 .19581 L
s
.8747 .19581 m
.87612 .18943 L
s
.87612 .18943 m
.88188 .18659 L
s
.88188 .18659 m
.89224 .19171 L
s
.89224 .19171 m
.88507 .20093 L
s
.33324 .16073 m
.33182 .15435 L
s
.33182 .15435 m
.33821 .15435 L
s
.33821 .15435 m
.33324 .16073 L
s
.30676 .16357 m
.30306 .16175 L
s
.30306 .16175 m
.30562 .15845 L
s
.30562 .15845 m
.30739 .16073 L
s
.30739 .16073 m
.30676 .16357 L
s
.34538 .13488 m
.34361 .14284 L
s
.34361 .14284 m
.34105 .13133 L
s
.34105 .13133 m
.34184 .13032 L
s
.34184 .13032 m
.34538 .13488 L
s
.3042 .37876 m
.29958 .37648 L
s
.29958 .37648 m
.29986 .37522 L
s
.29986 .37522 m
.30695 .37522 L
s
.30695 .37522 m
.3042 .37876 L
s
.86895 .41258 m
.85858 .4177 L
s
.85858 .4177 m
.85602 .40619 L
s
.85602 .40619 m
.86895 .41258 L
s
.61938 .32508 m
.61619 .32351 L
s
.61619 .32351 m
.61761 .31712 L
s
.61761 .31712 m
.61938 .32508 L
s
.93422 .21244 m
.92385 .20732 L
s
.92385 .20732 m
.93216 .20321 L
s
.93216 .20321 m
.93536 .20732 L
s
.93536 .20732 m
.93422 .21244 L
s
.31437 .35291 m
.30818 .36087 L
s
.30818 .36087 m
.29525 .35448 L
s
.29525 .35448 m
.3042 .34298 L
s
.3042 .34298 m
.31314 .3474 L
s
.31314 .3474 m
.31437 .35291 L
s
.34219 .39753 m
.33324 .39311 L
s
.33324 .39311 m
.3412 .39311 L
s
.3412 .39311 m
.34219 .39753 L
s
.33005 .17508 m
.3243 .17224 L
s
.3243 .17224 m
.33147 .16869 L
s
.33147 .16869 m
.33005 .17508 L
s
.33324 .39311 m
.32607 .38956 L
s
.32607 .38956 m
.336 .38956 L
s
.336 .38956 m
.33324 .39311 L
s
.94458 .16585 m
.92385 .16585 L
s
.92385 .16585 m
.93422 .16073 L
s
.93422 .16073 m
.94458 .16585 L
s
.25406 .22679 m
.23175 .22679 L
s
.23175 .22679 m
.24291 .21244 L
s
.24291 .21244 m
.25406 .22679 L
s
.29206 .25264 m
.26301 .26699 L
s
.26301 .26699 m
.27196 .22679 L
s
.27196 .22679 m
.29206 .25264 L
s
.58856 .14512 m
.58025 .14923 L
s
.58025 .14923 m
.57883 .14284 L
s
.57883 .14284 m
.58281 .13772 L
s
.58281 .13772 m
.58856 .14512 L
s
.61938 .38956 m
.60326 .3816 L
s
.60326 .3816 m
.60468 .37522 L
s
.60468 .37522 m
.61619 .37522 L
s
.61619 .37522 m
.61938 .38956 L
s
.60051 .41384 m
.59432 .4218 L
s
.59432 .4218 m
.5983 .40391 L
s
.5983 .40391 m
.60051 .41384 L
s
.82776 .37237 m
.82697 .37339 L
s
.82697 .37339 m
.82236 .37111 L
s
.82236 .37111 m
.82748 .37111 L
s
.82748 .37111 m
.82776 .37237 L
s
.57067 .08632 m
.57102 .08475 L
s
.57102 .08475 m
.57244 .08545 L
s
.57244 .08545 m
.57067 .08632 L
s
.27515 .27692 m
.24291 .27692 L
s
.24291 .27692 m
.27913 .25903 L
s
.27913 .25903 m
.27515 .27692 L
s
.87931 .43615 m
.87356 .43331 L
s
.87356 .43331 m
.87818 .43103 L
s
.87818 .43103 m
.87931 .43615 L
s
.88393 .43843 m
.87931 .43615 L
s
.87931 .43615 m
.87818 .43103 L
s
.87818 .43103 m
.88649 .42693 L
s
.88649 .42693 m
.88393 .43843 L
s
.30818 .24468 m
.29206 .25264 L
s
.29206 .25264 m
.27196 .22679 L
s
.27196 .22679 m
.30818 .24468 L
s
.32828 .29923 m
.30818 .30916 L
s
.30818 .30916 m
.27196 .29127 L
s
.27196 .29127 m
.29702 .25903 L
s
.29702 .25903 m
.31933 .25903 L
s
.31933 .25903 m
.33324 .27692 L
s
.33324 .27692 m
.32828 .29923 L
s
.31933 .25903 m
.27913 .25903 L
s
.27913 .25903 m
.30818 .24468 L
s
.30818 .24468 m
.31933 .25903 L
s
.90056 .19581 m
.88188 .18659 L
s
.88188 .18659 m
.90261 .18659 L
s
.90261 .18659 m
.90056 .19581 L
s
.86576 .20732 m
.86177 .21244 L
s
.86177 .21244 m
.85539 .21244 L
s
.85539 .21244 m
.85141 .20732 L
s
.85141 .20732 m
.85283 .20093 L
s
.85283 .20093 m
.86319 .19581 L
s
.86319 .19581 m
.86576 .20732 L
s
.37167 .16869 m
.36371 .16869 L
s
.36371 .16869 m
.36769 .16357 L
s
.36769 .16357 m
.37167 .16869 L
s
.3591 .18943 m
.3554 .1876 L
s
.3554 .1876 m
.35796 .18431 L
s
.35796 .18431 m
.35973 .18659 L
s
.35973 .18659 m
.3591 .18943 L
s
.55731 .0302 m
.55695 .03177 L
s
.55695 .03177 m
.55439 .03304 L
s
.55439 .03304 m
.55297 .02665 L
s
.55297 .02665 m
.55376 .02564 L
s
.55376 .02564 m
.55731 .0302 L
s
.25903 .32067 m
.25441 .31839 L
s
.25441 .31839 m
.2547 .31712 L
s
.2547 .31712 m
.26178 .31712 L
s
.26178 .31712 m
.25903 .32067 L
s
.83415 .37806 m
.83529 .37294 L
s
.83529 .37294 m
.8399 .37522 L
s
.8399 .37522 m
.83415 .37806 L
s
.33722 .32351 m
.33324 .32863 L
s
.33324 .32863 m
.32288 .32351 L
s
.32288 .32351 m
.3243 .31712 L
s
.3243 .31712 m
.3358 .31712 L
s
.3358 .31712 m
.33722 .32351 L
s
.25584 .29923 m
.25008 .29639 L
s
.25008 .29639 m
.25406 .29127 L
s
.25406 .29127 m
.25584 .29923 L
s
.34759 .14796 m
.34503 .14923 L
s
.34503 .14923 m
.34361 .14284 L
s
.34361 .14284 m
.34759 .13772 L
s
.34759 .13772 m
.34936 .14 L
s
.34936 .14 m
.34759 .14796 L
s
.30995 .3816 m
.31137 .37522 L
s
.31137 .37522 m
.31491 .37522 L
s
.31491 .37522 m
.30995 .3816 L
s
.61663 .3414 m
.61044 .34936 L
s
.61044 .34936 m
.61442 .33147 L
s
.61442 .33147 m
.61663 .3414 L
s
.31358 .31358 m
.3064 .31712 L
s
.3064 .31712 m
.31137 .31074 L
s
.31137 .31074 m
.31314 .31161 L
s
.31314 .31161 m
.31358 .31358 L
s
.75753 .91013 m
.75709 .90817 L
s
.75709 .90817 m
.75851 .90887 L
s
.75851 .90887 m
.75753 .91013 L
s
.85488 .40107 m
.84451 .39595 L
s
.84451 .39595 m
.85744 .38956 L
s
.85744 .38956 m
.85488 .40107 L
s
.56094 .03689 m
.55582 .03942 L
s
.55582 .03942 m
.55553 .03816 L
s
.55553 .03816 m
.55952 .03304 L
s
.55952 .03304 m
.56129 .03532 L
s
.56129 .03532 m
.56094 .03689 L
s
.26478 .32351 m
.2662 .31712 L
s
.2662 .31712 m
.26975 .31712 L
s
.26975 .31712 m
.26478 .32351 L
s
.31835 .34779 m
.31712 .34936 L
s
.31712 .34936 m
.31791 .34582 L
s
.31791 .34582 m
.31835 .34779 L
s
.87561 .43888 m
.8747 .43843 L
s
.8747 .43843 m
.87597 .43843 L
s
.87597 .43843 m
.87561 .43888 L
s
.25087 .31586 m
.25008 .31484 L
s
.25008 .31484 m
.25328 .31074 L
s
.25328 .31074 m
.25505 .31161 L
s
.25505 .31161 m
.25548 .31358 L
s
.25548 .31358 m
.25087 .31586 L
s
.88159 .44639 m
.88045 .44583 L
s
.88045 .44583 m
.88147 .44583 L
s
.88147 .44583 m
.88159 .44639 L
s
.8821 .44664 m
.88159 .44639 L
s
.88159 .44639 m
.88147 .44583 L
s
.88147 .44583 m
.88228 .44583 L
s
.88228 .44583 m
.8821 .44664 L
s
.30597 .37964 m
.3042 .37876 L
s
.3042 .37876 m
.30542 .37718 L
s
.30542 .37718 m
.30597 .37964 L
s
.3042 .37876 m
.301 .38034 L
s
.301 .38034 m
.29702 .37522 L
s
.29702 .37522 m
.3042 .37876 L
s
.31712 .14 m
.31314 .13488 L
s
.31314 .13488 m
.31456 .12849 L
s
.31456 .12849 m
.32607 .12849 L
s
.32607 .12849 m
.31712 .14 L
s
.29525 .30277 m
.2895 .30562 L
s
.2895 .30562 m
.28808 .29923 L
s
.28808 .29923 m
.29525 .30277 L
s
.77144 .89224 m
.76746 .89736 L
s
.76746 .89736 m
.76107 .89736 L
s
.76107 .89736 m
.7593 .8894 L
s
.7593 .8894 m
.76206 .88586 L
s
.76206 .88586 m
.76648 .88586 L
s
.76648 .88586 m
.77144 .89224 L
s
.31712 .34936 m
.31535 .3414 L
s
.31535 .3414 m
.31933 .33943 L
s
.31933 .33943 m
.31712 .34936 L
s
.31535 .35732 m
.32032 .35094 L
s
.32032 .35094 m
.3243 .35291 L
s
.3243 .35291 m
.31535 .35732 L
s
.29604 .37395 m
.29525 .37294 L
s
.29525 .37294 m
.29844 .36883 L
s
.29844 .36883 m
.30242 .3708 L
s
.30242 .3708 m
.29604 .37395 L
s
.32075 .31712 m
.32174 .31586 L
s
.32174 .31586 m
.32252 .31625 L
s
.32252 .31625 m
.32075 .31712 L
s
.75232 .91683 m
.75162 .91683 L
s
.75162 .91683 m
.75185 .91582 L
s
.75185 .91582 m
.75276 .91627 L
s
.75276 .91627 m
.75232 .91683 L
s
.75178 .9002 m
.7502 .9002 L
s
.7502 .9002 m
.75055 .89863 L
s
.75055 .89863 m
.75178 .9002 L
s
.58183 .13645 m
.58025 .13645 L
s
.58025 .13645 m
.5806 .13488 L
s
.5806 .13488 m
.58183 .13645 L
s
.35113 .43773 m
.34936 .43685 L
s
.34936 .43685 m
.35059 .43528 L
s
.35059 .43528 m
.35113 .43773 L
s
.8833 .2089 m
.88188 .2096 L
s
.88188 .2096 m
.88045 .2089 L
s
.88045 .2089 m
.8801 .20732 L
s
.8801 .20732 m
.88109 .20605 L
s
.88109 .20605 m
.88266 .20605 L
s
.88266 .20605 m
.88365 .20732 L
s
.88365 .20732 m
.8833 .2089 L
s
.35654 .17224 m
.35078 .17508 L
s
.35078 .17508 m
.34936 .16869 L
s
.34936 .16869 m
.35654 .17224 L
s
.31535 .35732 m
.30818 .36087 L
s
.30818 .36087 m
.31437 .35291 L
s
.31437 .35291 m
.31535 .35732 L
s
.76427 .38956 m
.75532 .38515 L
s
.75532 .38515 m
.75311 .37522 L
s
.75311 .37522 m
.76746 .37522 L
s
.76746 .37522 m
.76427 .38956 L
s
.76028 .40746 m
.75532 .38515 L
s
.75532 .38515 m
.76427 .38956 L
s
.76427 .38956 m
.76028 .40746 L
s
.68784 .63275 m
.66278 .62036 L
s
.66278 .62036 m
.68288 .61044 L
s
.68288 .61044 m
.68784 .63275 L
s
.55632 .0417 m
.54517 .05605 L
s
.54517 .05605 m
.55234 .02381 L
s
.55234 .02381 m
.55632 .0417 L
s
.56988 .08987 m
.56732 .09113 L
s
.56732 .09113 m
.5659 .08475 L
s
.5659 .08475 m
.56988 .07962 L
s
.56988 .07962 m
.57165 .0819 L
s
.57165 .0819 m
.56988 .08987 L
s
.32607 .30916 m
.3211 .30277 L
s
.3211 .30277 m
.32828 .29923 L
s
.32828 .29923 m
.32607 .30916 L
s
.60149 .45404 m
.59751 .45917 L
s
.59751 .45917 m
.58714 .45404 L
s
.58714 .45404 m
.58856 .44766 L
s
.58856 .44766 m
.60007 .44766 L
s
.60007 .44766 m
.60149 .45404 L
s
.86319 .40518 m
.86228 .40107 L
s
.86228 .40107 m
.86639 .40107 L
s
.86639 .40107 m
.86319 .40518 L
s
.57386 .09499 m
.56874 .09752 L
s
.56874 .09752 m
.56846 .09625 L
s
.56846 .09625 m
.57564 .08702 L
s
.57564 .08702 m
.57386 .09499 L
s
.58261 .47832 m
.58139 .4799 L
s
.58139 .4799 m
.58218 .47636 L
s
.58218 .47636 m
.58261 .47832 L
s
.84657 .40152 m
.84565 .40107 L
s
.84565 .40107 m
.84692 .40107 L
s
.84692 .40107 m
.84657 .40152 L
s
.85681 .40974 m
.85602 .41075 L
s
.85602 .41075 m
.85141 .40847 L
s
.85141 .40847 m
.85653 .40847 L
s
.85653 .40847 m
.85681 .40974 L
s
.2608 .32154 m
.25903 .32067 L
s
.25903 .32067 m
.26025 .31909 L
s
.26025 .31909 m
.2608 .32154 L
s
.78756 .87151 m
.76427 .88301 L
s
.76427 .88301 m
.78437 .85716 L
s
.78437 .85716 m
.78756 .87151 L
s
.79331 .84565 m
.76427 .83131 L
s
.76427 .83131 m
.78756 .8198 L
s
.78756 .8198 m
.79331 .84565 L
s
.29923 .31358 m
.301 .30562 L
s
.301 .30562 m
.30818 .30916 L
s
.30818 .30916 m
.29923 .31358 L
s
.76028 .90659 m
.7539 .90659 L
s
.7539 .90659 m
.75709 .89224 L
s
.75709 .89224 m
.76427 .90147 L
s
.76427 .90147 m
.76028 .90659 L
s
.85858 .34298 m
.84821 .33786 L
s
.84821 .33786 m
.85283 .31712 L
s
.85283 .31712 m
.85858 .34298 L
s
.79651 .83131 m
.78756 .8198 L
s
.78756 .8198 m
.80049 .81341 L
s
.80049 .81341 m
.79651 .83131 L
s
.85283 .36883 m
.8399 .37522 L
s
.8399 .37522 m
.82697 .36883 L
s
.82697 .36883 m
.82378 .35448 L
s
.82378 .35448 m
.83273 .34298 L
s
.83273 .34298 m
.84707 .34298 L
s
.84707 .34298 m
.85602 .35448 L
s
.85602 .35448 m
.85283 .36883 L
s
.85602 .35448 m
.8399 .33375 L
s
.8399 .33375 m
.85858 .34298 L
s
.85858 .34298 m
.85602 .35448 L
s
.85858 .38444 m
.8399 .37522 L
s
.8399 .37522 m
.86063 .37522 L
s
.86063 .37522 m
.85858 .38444 L
s
.90198 .32863 m
.89082 .34298 L
s
.89082 .34298 m
.87293 .34298 L
s
.87293 .34298 m
.86177 .32863 L
s
.86177 .32863 m
.86576 .31074 L
s
.86576 .31074 m
.88188 .30277 L
s
.88188 .30277 m
.898 .31074 L
s
.898 .31074 m
.90198 .32863 L
s
.66499 .61044 m
.64268 .61044 L
s
.64268 .61044 m
.66002 .58812 L
s
.66002 .58812 m
.66499 .61044 L
s
.54836 .0417 m
.51612 .0417 L
s
.51612 .0417 m
.55234 .02381 L
s
.55234 .02381 m
.54836 .0417 L
s
.68509 .70077 m
.66278 .70077 L
s
.66278 .70077 m
.69403 .66057 L
s
.69403 .66057 m
.68509 .70077 L
s
.22679 .12407 m
.20669 .11414 L
s
.20669 .11414 m
.22458 .11414 L
s
.22458 .11414 m
.22679 .12407 L
s
.65162 .69526 m
.62656 .68288 L
s
.62656 .68288 m
.67669 .68288 L
s
.67669 .68288 m
.65162 .69526 L
s
.82157 .35732 m
.8198 .34936 L
s
.8198 .34936 m
.83273 .34298 L
s
.83273 .34298 m
.82157 .35732 L
s
.64887 .68288 m
.6238 .6705 L
s
.6238 .6705 m
.61761 .64268 L
s
.61761 .64268 m
.64887 .68288 L
s
.74416 .4799 m
.74018 .46201 L
s
.74018 .46201 m
.74913 .45759 L
s
.74913 .45759 m
.74416 .4799 L
s
.63152 .66057 m
.62533 .63275 L
s
.62533 .63275 m
.64268 .61044 L
s
.64268 .61044 m
.63152 .66057 L
s
.75532 .93599 m
.7539 .9296 L
s
.7539 .9296 m
.76028 .9296 L
s
.76028 .9296 m
.75532 .93599 L
s
.58714 .46997 m
.58395 .46839 L
s
.58395 .46839 m
.58537 .46201 L
s
.58537 .46201 m
.58714 .46997 L
s
.85027 .21244 m
.8399 .20732 L
s
.8399 .20732 m
.84821 .20321 L
s
.84821 .20321 m
.85141 .20732 L
s
.85141 .20732 m
.85027 .21244 L
s
.21961 .25264 m
.21386 .2498 L
s
.21386 .2498 m
.21784 .24468 L
s
.21784 .24468 m
.21961 .25264 L
s
.85681 .38672 m
.85283 .39184 L
s
.85283 .39184 m
.84821 .38956 L
s
.84821 .38956 m
.84707 .38444 L
s
.84707 .38444 m
.85027 .38034 L
s
.85027 .38034 m
.85602 .38318 L
s
.85602 .38318 m
.85681 .38672 L
s
.8747 .41542 m
.86895 .41258 L
s
.86895 .41258 m
.87407 .41258 L
s
.87407 .41258 m
.8747 .41542 L
s
.58139 .12565 m
.5782 .12723 L
s
.5782 .12723 m
.57421 .12211 L
s
.57421 .12211 m
.58139 .12565 L
s
.59211 .46358 m
.58572 .46043 L
s
.58572 .46043 m
.586 .45917 L
s
.586 .45917 m
.59112 .45917 L
s
.59112 .45917 m
.59211 .46358 L
s
.22635 .28292 m
.22458 .28204 L
s
.22458 .28204 m
.22616 .28204 L
s
.22616 .28204 m
.22635 .28292 L
s
.92436 .21163 m
.92362 .21199 L
s
.92362 .21199 m
.9235 .21143 L
s
.9235 .21143 m
.92385 .21097 L
s
.92385 .21097 m
.92436 .21163 L
s
.84913 .39823 m
.84799 .39879 L
s
.84799 .39879 m
.84771 .39753 L
s
.84771 .39753 m
.84913 .39823 L
s
.339 .17634 m
.33801 .17508 L
s
.33801 .17508 m
.33998 .17508 L
s
.33998 .17508 m
.339 .17634 L
s
.32331 .3414 m
.32288 .33943 L
s
.32288 .33943 m
.32484 .33943 L
s
.32484 .33943 m
.32331 .3414 L
s
.8833 .44127 m
.88188 .44198 L
s
.88188 .44198 m
.88045 .44127 L
s
.88045 .44127 m
.8801 .4397 L
s
.8801 .4397 m
.88109 .43843 L
s
.88109 .43843 m
.88266 .43843 L
s
.88266 .43843 m
.88365 .4397 L
s
.88365 .4397 m
.8833 .44127 L
s
.57244 .11414 m
.57102 .10776 L
s
.57102 .10776 m
.57741 .10776 L
s
.57741 .10776 m
.57244 .11414 L
s
.29127 .14 m
.28488 .14 L
s
.28488 .14 m
.28409 .13645 L
s
.28409 .13645 m
.29127 .14 L
s
.24291 .30562 m
.23794 .29923 L
s
.23794 .29923 m
.24787 .29923 L
s
.24787 .29923 m
.24291 .30562 L
s
.61142 .42535 m
.60866 .4218 L
s
.60866 .4218 m
.61363 .41542 L
s
.61363 .41542 m
.61142 .42535 L
s
.76427 .91171 m
.75851 .90887 L
s
.75851 .90887 m
.76249 .90375 L
s
.76249 .90375 m
.76427 .91171 L
s
.86718 .4103 m
.86433 .4103 L
s
.86433 .4103 m
.86319 .40518 L
s
.86319 .40518 m
.86718 .4103 L
s
.3444 .14638 m
.33821 .15435 L
s
.33821 .15435 m
.32828 .15435 L
s
.32828 .15435 m
.32209 .14638 L
s
.32209 .14638 m
.3243 .13645 L
s
.3243 .13645 m
.33324 .13204 L
s
.33324 .13204 m
.34219 .13645 L
s
.34219 .13645 m
.3444 .14638 L
s
.36946 .19455 m
.35831 .2089 L
s
.35831 .2089 m
.33324 .17666 L
s
.33324 .17666 m
.36946 .19455 L
s
.57741 .17224 m
.55234 .14 L
s
.55234 .14 m
.58139 .15435 L
s
.58139 .15435 m
.57741 .17224 L
s
.58856 .18659 m
.58458 .16869 L
s
.58458 .16869 m
.60247 .16869 L
s
.60247 .16869 m
.58856 .18659 L
s
.57642 .13204 m
.56527 .14638 L
s
.56527 .14638 m
.57244 .11414 L
s
.57244 .11414 m
.57642 .13204 L
s
.77542 .5201 m
.74637 .50575 L
s
.74637 .50575 m
.75532 .49425 L
s
.75532 .49425 m
.77542 .5201 L
s
.45085 .15435 m
.43473 .14638 L
s
.43473 .14638 m
.47095 .12849 L
s
.47095 .12849 m
.45085 .15435 L
s
.42358 .53799 m
.40967 .5201 L
s
.40967 .5201 m
.43749 .5201 L
s
.43749 .5201 m
.42358 .53799 L
s
.49105 .15435 m
.47316 .15435 L
s
.47316 .15435 m
.46201 .14 L
s
.46201 .14 m
.49105 .15435 L
s
.75532 .42977 m
.77542 .40391 L
s
.77542 .40391 m
.78437 .41542 L
s
.78437 .41542 m
.75532 .42977 L
s
.63771 .63275 m
.64268 .61044 L
s
.64268 .61044 m
.68288 .61044 L
s
.68288 .61044 m
.63771 .63275 L
s
.699 .35732 m
.68288 .34936 L
s
.68288 .34936 m
.69403 .33501 L
s
.69403 .33501 m
.699 .35732 L
s
.66499 .61044 m
.66002 .58812 L
s
.66002 .58812 m
.67393 .57023 L
s
.67393 .57023 m
.66499 .61044 L
s
.9181 .28488 m
.88188 .30277 L
s
.88188 .30277 m
.84565 .28488 L
s
.84565 .28488 m
.83671 .24468 L
s
.83671 .24468 m
.86177 .21244 L
s
.86177 .21244 m
.90198 .21244 L
s
.90198 .21244 m
.92704 .24468 L
s
.92704 .24468 m
.9181 .28488 L
s
.93422 .04454 m
.92704 .03532 L
s
.92704 .03532 m
.9296 .02381 L
s
.9296 .02381 m
.93422 .04454 L
s
.69005 .31712 m
.68607 .29923 L
s
.68607 .29923 m
.699 .30562 L
s
.699 .30562 m
.69005 .31712 L
s
.65383 .29923 m
.65958 .27338 L
s
.65958 .27338 m
.68288 .28488 L
s
.68288 .28488 m
.65383 .29923 L
s
.6789 .85362 m
.66995 .8492 L
s
.66995 .8492 m
.67712 .84565 L
s
.67712 .84565 m
.6789 .85362 L
s
.50973 .0417 m
.50575 .04682 L
s
.50575 .04682 m
.49681 .03532 L
s
.49681 .03532 m
.50831 .03532 L
s
.50831 .03532 m
.50973 .0417 L
s
.64985 .31712 m
.6441 .29127 L
s
.6441 .29127 m
.65702 .28488 L
s
.65702 .28488 m
.64985 .31712 L
s
.68288 .28488 m
.65958 .27338 L
s
.65958 .27338 m
.66278 .25903 L
s
.66278 .25903 m
.68288 .28488 L
s
.65383 .27053 m
.63373 .29639 L
s
.63373 .29639 m
.61363 .27053 L
s
.61363 .27053 m
.61761 .25264 L
s
.61761 .25264 m
.63373 .24468 L
s
.63373 .24468 m
.64985 .25264 L
s
.64985 .25264 m
.65383 .27053 L
s
.65702 .28488 m
.64985 .25264 L
s
.64985 .25264 m
.66278 .25903 L
s
.66278 .25903 m
.65702 .28488 L
s
.96326 .0819 m
.95865 .06117 L
s
.95865 .06117 m
.96788 .06117 L
s
.96788 .06117 m
.96326 .0819 L
s
.80943 .0704 m
.79793 .0704 L
s
.79793 .0704 m
.81661 .06117 L
s
.81661 .06117 m
.80943 .0704 L
s
.60645 .62833 m
.59254 .61044 L
s
.59254 .61044 m
.61044 .61044 L
s
.61044 .61044 m
.60645 .62833 L
s
.61044 .67492 m
.58139 .66057 L
s
.58139 .66057 m
.61761 .64268 L
s
.61761 .64268 m
.61044 .67492 L
s
.13744 .07678 m
.13247 .0704 L
s
.13247 .0704 m
.13886 .0704 L
s
.13886 .0704 m
.13744 .07678 L
s
.7887 .0704 m
.77833 .06528 L
s
.77833 .06528 m
.78153 .06117 L
s
.78153 .06117 m
.78665 .06117 L
s
.78665 .06117 m
.7887 .0704 L
s
.59751 .66853 m
.58139 .67649 L
s
.58139 .67649 m
.56129 .65064 L
s
.56129 .65064 m
.59751 .66853 L
s
.62656 .68288 m
.61044 .67492 L
s
.61044 .67492 m
.61761 .64268 L
s
.61761 .64268 m
.62656 .68288 L
s
.61761 .72308 m
.59751 .73301 L
s
.59751 .73301 m
.57741 .72308 L
s
.57741 .72308 m
.56846 .68288 L
s
.56846 .68288 m
.60866 .68288 L
s
.60866 .68288 m
.62257 .70077 L
s
.62257 .70077 m
.61761 .72308 L
s
.62257 .70077 m
.59751 .66853 L
s
.59751 .66853 m
.62656 .68288 L
s
.62656 .68288 m
.62257 .70077 L
s
.82697 .03304 m
.82492 .02381 L
s
.82492 .02381 m
.84565 .02381 L
s
.84565 .02381 m
.82697 .03304 L
s
.87151 .19171 m
.85858 .17508 L
s
.85858 .17508 m
.86895 .1802 L
s
.86895 .1802 m
.87151 .19171 L
s
.33324 .09625 m
.31712 .08829 L
s
.31712 .08829 m
.33005 .0819 L
s
.33005 .0819 m
.33324 .09625 L
s
.29702 .11414 m
.2809 .09341 L
s
.2809 .09341 m
.3042 .0819 L
s
.3042 .0819 m
.29702 .11414 L
s
.82697 .36883 m
.82122 .36599 L
s
.82122 .36599 m
.82583 .36371 L
s
.82583 .36371 m
.82697 .36883 L
s
.871 .21244 m
.86639 .21016 L
s
.86639 .21016 m
.86525 .20504 L
s
.86525 .20504 m
.87356 .20093 L
s
.87356 .20093 m
.871 .21244 L
s
.30818 .12849 m
.28488 .11699 L
s
.28488 .11699 m
.28808 .10264 L
s
.28808 .10264 m
.30818 .12849 L
s
.2809 .09341 m
.27196 .0819 L
s
.27196 .0819 m
.3042 .0819 L
s
.3042 .0819 m
.2809 .09341 L
s
.28232 .12849 m
.25008 .12849 L
s
.25008 .12849 m
.23893 .11414 L
s
.23893 .11414 m
.24291 .09625 L
s
.24291 .09625 m
.25903 .08829 L
s
.25903 .08829 m
.27515 .09625 L
s
.27515 .09625 m
.28232 .12849 L
s
.28808 .10264 m
.25903 .08829 L
s
.25903 .08829 m
.27196 .0819 L
s
.27196 .0819 m
.28808 .10264 L
s
.82953 .17097 m
.82122 .17508 L
s
.82122 .17508 m
.81661 .15435 L
s
.81661 .15435 m
.82953 .17097 L
s
.94714 .15435 m
.88188 .18659 L
s
.88188 .18659 m
.81661 .15435 L
s
.81661 .15435 m
.80049 .0819 L
s
.80049 .0819 m
.84565 .02381 L
s
.84565 .02381 m
.9181 .02381 L
s
.9181 .02381 m
.96326 .0819 L
s
.96326 .0819 m
.94714 .15435 L
s
.83671 .65064 m
.80049 .66853 L
s
.80049 .66853 m
.76427 .65064 L
s
.76427 .65064 m
.75532 .61044 L
s
.75532 .61044 m
.78039 .5782 L
s
.78039 .5782 m
.82059 .5782 L
s
.82059 .5782 m
.84565 .61044 L
s
.84565 .61044 m
.83671 .65064 L
s
.5 .25903 m
.49105 .25461 L
s
.49105 .25461 m
.48884 .24468 L
s
.48884 .24468 m
.50319 .24468 L
s
.50319 .24468 m
.5 .25903 L
s
.43473 .40746 m
.42358 .40195 L
s
.42358 .40195 m
.44864 .38956 L
s
.44864 .38956 m
.43473 .40746 L
s
.7191 .12211 m
.72229 .10776 L
s
.72229 .10776 m
.73522 .11414 L
s
.73522 .11414 m
.7191 .12211 L
s
.76427 .12849 m
.75851 .10264 L
s
.75851 .10264 m
.76746 .11414 L
s
.76746 .11414 m
.76427 .12849 L
s
.41861 .21883 m
.40568 .21244 L
s
.40568 .21244 m
.41188 .20448 L
s
.41188 .20448 m
.4218 .20448 L
s
.4218 .20448 m
.41861 .21883 L
s
.73424 .5603 m
.72804 .55234 L
s
.72804 .55234 m
.7392 .53799 L
s
.7392 .53799 m
.73424 .5603 L
s
.46697 .0819 m
.45085 .07394 L
s
.45085 .07394 m
.47095 .06401 L
s
.47095 .06401 m
.46697 .0819 L
s
.40568 .09625 m
.40967 .07836 L
s
.40967 .07836 m
.42579 .0704 L
s
.42579 .0704 m
.40568 .09625 L
s
.47493 .14638 m
.46201 .14 L
s
.46201 .14 m
.47095 .12849 L
s
.47095 .12849 m
.47714 .13645 L
s
.47714 .13645 m
.47493 .14638 L
s
.79651 .24468 m
.78756 .23317 L
s
.78756 .23317 m
.79252 .22679 L
s
.79252 .22679 m
.79651 .24468 L
s
.59254 .51017 m
.59751 .48786 L
s
.59751 .48786 m
.61761 .49779 L
s
.61761 .49779 m
.59254 .51017 L
s
.35334 .12211 m
.33324 .09625 L
s
.33324 .09625 m
.34936 .10421 L
s
.34936 .10421 m
.35334 .12211 L
s
.80049 .81341 m
.76427 .83131 L
s
.76427 .83131 m
.72804 .81341 L
s
.72804 .81341 m
.7191 .77321 L
s
.7191 .77321 m
.74416 .74097 L
s
.74416 .74097 m
.78437 .74097 L
s
.78437 .74097 m
.80943 .77321 L
s
.80943 .77321 m
.80049 .81341 L
s
.61761 .25264 m
.60468 .25903 L
s
.60468 .25903 m
.60247 .2491 L
s
.60247 .2491 m
.60866 .24114 L
s
.60866 .24114 m
.61761 .25264 L
s
.3444 .22679 m
.33324 .2323 L
s
.33324 .2323 m
.33943 .20448 L
s
.33943 .20448 m
.3444 .22679 L
s
.5635 .15435 m
.54119 .15435 L
s
.54119 .15435 m
.55234 .14 L
s
.55234 .14 m
.5635 .15435 L
s
.51612 .18659 m
.50496 .17224 L
s
.50496 .17224 m
.50895 .15435 L
s
.50895 .15435 m
.51612 .18659 L
s
.59751 .16231 m
.58458 .16869 L
s
.58458 .16869 m
.58139 .15435 L
s
.58139 .15435 m
.59132 .15435 L
s
.59132 .15435 m
.59751 .16231 L
s
.76923 .69281 m
.77144 .68288 L
s
.77144 .68288 m
.78933 .68288 L
s
.78933 .68288 m
.76923 .69281 L
s
.4799 .42977 m
.45483 .41739 L
s
.45483 .41739 m
.47493 .40746 L
s
.47493 .40746 m
.4799 .42977 L
s
.50319 .24468 m
.47095 .24468 L
s
.47095 .24468 m
.48707 .23672 L
s
.48707 .23672 m
.50319 .24468 L
s
.69324 .59254 m
.68607 .59609 L
s
.68607 .59609 m
.6789 .59254 L
s
.6789 .59254 m
.6757 .5782 L
s
.6757 .5782 m
.69005 .5782 L
s
.69005 .5782 m
.69502 .58458 L
s
.69502 .58458 m
.69324 .59254 L
s
.55013 .62036 m
.54517 .61398 L
s
.54517 .61398 m
.55234 .61044 L
s
.55234 .61044 m
.55013 .62036 L
s
.11812 .0704 m
.11237 .06756 L
s
.11237 .06756 m
.11876 .06756 L
s
.11876 .06756 m
.11812 .0704 L
s
.51612 .62833 m
.50895 .62478 L
s
.50895 .62478 m
.51888 .62478 L
s
.51888 .62478 m
.51612 .62833 L
s
.71335 .6184 m
.70617 .62194 L
s
.70617 .62194 m
.699 .6184 L
s
.699 .6184 m
.69723 .61044 L
s
.69723 .61044 m
.70617 .59893 L
s
.70617 .59893 m
.71512 .61044 L
s
.71512 .61044 m
.71335 .6184 L
s
.78614 .10036 m
.78295 .09625 L
s
.78295 .09625 m
.78933 .09625 L
s
.78933 .09625 m
.78614 .10036 L
s
.77975 .0819 m
.77833 .08373 L
s
.77833 .08373 m
.77514 .07962 L
s
.77514 .07962 m
.77628 .0745 L
s
.77628 .0745 m
.77833 .07552 L
s
.77833 .07552 m
.77975 .0819 L
s
.55411 .60247 m
.54915 .59609 L
s
.54915 .59609 m
.55632 .59254 L
s
.55632 .59254 m
.55411 .60247 L
s
.61391 .09113 m
.60724 .09442 L
s
.60724 .09442 m
.60468 .09113 L
s
.60468 .09113 m
.6093 .0852 L
s
.6093 .0852 m
.613 .08702 L
s
.613 .08702 m
.61391 .09113 L
s
.54915 .29923 m
.5434 .29639 L
s
.5434 .29639 m
.54738 .29127 L
s
.54738 .29127 m
.54915 .29923 L
s
.77053 .11516 m
.76723 .11516 L
s
.76723 .11516 m
.76797 .11186 L
s
.76797 .11186 m
.77002 .11288 L
s
.77002 .11288 m
.77053 .11516 L
s
.54694 .6404 m
.54596 .63913 L
s
.54596 .63913 m
.54915 .62478 L
s
.54915 .62478 m
.55136 .63471 L
s
.55136 .63471 m
.54694 .6404 L
s
.60689 .31358 m
.60228 .31586 L
s
.60228 .31586 m
.60149 .31484 L
s
.60149 .31484 m
.60468 .31074 L
s
.60468 .31074 m
.60645 .31161 L
s
.60645 .31161 m
.60689 .31358 L
s
.70519 .67492 m
.70475 .67295 L
s
.70475 .67295 m
.70617 .67365 L
s
.70617 .67365 m
.70519 .67492 L
s
.82059 .4103 m
.80624 .4103 L
s
.80624 .4103 m
.80943 .39595 L
s
.80943 .39595 m
.82059 .4103 L
s
.78295 .0778 m
.77719 .0704 L
s
.77719 .0704 m
.77742 .06938 L
s
.77742 .06938 m
.78153 .07141 L
s
.78153 .07141 m
.78295 .0778 L
s
.61761 .10776 m
.61619 .10593 L
s
.61619 .10593 m
.61733 .10649 L
s
.61733 .10649 m
.61761 .10776 L
s
.5287 .31642 m
.52728 .31712 L
s
.52728 .31712 m
.5285 .31555 L
s
.5285 .31555 m
.5287 .31642 L
s
.5488 .31358 m
.54162 .31712 L
s
.54162 .31712 m
.54659 .31074 L
s
.54659 .31074 m
.54836 .31161 L
s
.54836 .31161 m
.5488 .31358 L
s
.48884 .61485 m
.48707 .61398 L
s
.48707 .61398 m
.4883 .6124 L
s
.4883 .6124 m
.48884 .61485 L
s
.48707 .61398 m
.48388 .61556 L
s
.48388 .61556 m
.4799 .61044 L
s
.4799 .61044 m
.48707 .61398 L
s
.6789 .56385 m
.66995 .55234 L
s
.66995 .55234 m
.6757 .5495 L
s
.6757 .5495 m
.68146 .55234 L
s
.68146 .55234 m
.6789 .56385 L
s
.58856 .30277 m
.58281 .30562 L
s
.58281 .30562 m
.58139 .29923 L
s
.58139 .29923 m
.58856 .30277 L
s
.7191 .65702 m
.71512 .66214 L
s
.71512 .66214 m
.70873 .66214 L
s
.70873 .66214 m
.70696 .65418 L
s
.70696 .65418 m
.70972 .65064 L
s
.70972 .65064 m
.71768 .65064 L
s
.71768 .65064 m
.7191 .65702 L
s
.49823 .59254 m
.50319 .58616 L
s
.50319 .58616 m
.50717 .58812 L
s
.50717 .58812 m
.49823 .59254 L
s
.77144 .09625 m
.77258 .09113 L
s
.77258 .09113 m
.77719 .09341 L
s
.77719 .09341 m
.77144 .09625 L
s
.49823 .59254 m
.49105 .59609 L
s
.49105 .59609 m
.49724 .58812 L
s
.49724 .58812 m
.49823 .59254 L
s
.72229 .5782 m
.699 .5897 L
s
.699 .5897 m
.7191 .56385 L
s
.7191 .56385 m
.72229 .5782 L
s
.72804 .55234 m
.699 .53799 L
s
.699 .53799 m
.72229 .52649 L
s
.72229 .52649 m
.72804 .55234 L
s
.52728 .60689 m
.52905 .59893 L
s
.52905 .59893 m
.53622 .60247 L
s
.53622 .60247 m
.52728 .60689 L
s
.69502 .61328 m
.68863 .61328 L
s
.68863 .61328 m
.69182 .59893 L
s
.69182 .59893 m
.699 .60816 L
s
.699 .60816 m
.69502 .61328 L
s
.47095 .24468 m
.45483 .25264 L
s
.45483 .25264 m
.43473 .22679 L
s
.43473 .22679 m
.47095 .24468 L
s
.72804 .55234 m
.72229 .52649 L
s
.72229 .52649 m
.73522 .5201 L
s
.73522 .5201 m
.72804 .55234 L
s
.49105 .29923 m
.47095 .30916 L
s
.47095 .30916 m
.45085 .29923 L
s
.45085 .29923 m
.44191 .25903 L
s
.44191 .25903 m
.48211 .25903 L
s
.48211 .25903 m
.49602 .27692 L
s
.49602 .27692 m
.49105 .29923 L
s
.5 .25903 m
.49602 .27692 L
s
.49602 .27692 m
.47095 .24468 L
s
.47095 .24468 m
.5 .25903 L
s
.76427 .59893 m
.75709 .5897 L
s
.75709 .5897 m
.78039 .5782 L
s
.78039 .5782 m
.76427 .59893 L
s
.56271 .02893 m
.56321 .03121 L
s
.56321 .03121 m
.55809 .03121 L
s
.55809 .03121 m
.5549 .0271 L
s
.5549 .0271 m
.55695 .02609 L
s
.55695 .02609 m
.56271 .02893 L
s
.77144 .38034 m
.76569 .38318 L
s
.76569 .38318 m
.76746 .37522 L
s
.76746 .37522 m
.77144 .38034 L
s
.5201 .66214 m
.51612 .65702 L
s
.51612 .65702 m
.52329 .6478 L
s
.52329 .6478 m
.53622 .65418 L
s
.53622 .65418 m
.5201 .66214 L
s
.54517 .69438 m
.53401 .68004 L
s
.53401 .68004 m
.54296 .68445 L
s
.54296 .68445 m
.54517 .69438 L
s
.87151 .44254 m
.86753 .43742 L
s
.86753 .43742 m
.86851 .43615 L
s
.86851 .43615 m
.87009 .43615 L
s
.87009 .43615 m
.87151 .44254 L
s
.5897 .06528 m
.58856 .06471 L
s
.58856 .06471 m
.58998 .06401 L
s
.58998 .06401 m
.5897 .06528 L
s
.48211 .25903 m
.44191 .25903 L
s
.44191 .25903 m
.47095 .24468 L
s
.47095 .24468 m
.48211 .25903 L
s
.5201 .28488 m
.49105 .29923 L
s
.49105 .29923 m
.5 .25903 L
s
.5 .25903 m
.5201 .28488 L
s
.78358 .39595 m
.77861 .38956 L
s
.77861 .38956 m
.785 .38956 L
s
.785 .38956 m
.78358 .39595 L
s
.08589 .0417 m
.0819 .04682 L
s
.0819 .04682 m
.07296 .03532 L
s
.07296 .03532 m
.08446 .03532 L
s
.08446 .03532 m
.08589 .0417 L
s
.75709 .5897 m
.74815 .5782 L
s
.74815 .5782 m
.78039 .5782 L
s
.78039 .5782 m
.75709 .5897 L
s
.53622 .27692 m
.5201 .28488 L
s
.5201 .28488 m
.51612 .26699 L
s
.51612 .26699 m
.53622 .27692 L
s
.75532 .61044 m
.74416 .62478 L
s
.74416 .62478 m
.72627 .62478 L
s
.72627 .62478 m
.71512 .61044 L
s
.71512 .61044 m
.7191 .59254 L
s
.7191 .59254 m
.73522 .58458 L
s
.73522 .58458 m
.75134 .59254 L
s
.75134 .59254 m
.75532 .61044 L
s
.76427 .59893 m
.73522 .58458 L
s
.73522 .58458 m
.74815 .5782 L
s
.74815 .5782 m
.76427 .59893 L
s
.71512 .61044 m
.699 .5897 L
s
.699 .5897 m
.70936 .58458 L
s
.70936 .58458 m
.71512 .61044 L
s
.78437 .5603 m
.76427 .57023 L
s
.76427 .57023 m
.74416 .5603 L
s
.74416 .5603 m
.7392 .53799 L
s
.7392 .53799 m
.75311 .5201 L
s
.75311 .5201 m
.77542 .5201 L
s
.77542 .5201 m
.78933 .53799 L
s
.78933 .53799 m
.78437 .5603 L
s
.70617 .12849 m
.70219 .1106 L
s
.70219 .1106 m
.71512 .11699 L
s
.71512 .11699 m
.70617 .12849 L
s
.76427 .12849 m
.73522 .11414 L
s
.73522 .11414 m
.76107 .11414 L
s
.76107 .11414 m
.76427 .12849 L
s
.76746 .14284 m
.75851 .15435 L
s
.75851 .15435 m
.75134 .12211 L
s
.75134 .12211 m
.76746 .14284 L
s
.75134 .62833 m
.74141 .62833 L
s
.74141 .62833 m
.75532 .61044 L
s
.75532 .61044 m
.75134 .62833 L
s
.75134 .15789 m
.73522 .16585 L
s
.73522 .16585 m
.75532 .14 L
s
.75532 .14 m
.75134 .15789 L
s
.45208 .30474 m
.44092 .29923 L
s
.44092 .29923 m
.44589 .27692 L
s
.44589 .27692 m
.45208 .30474 L
s
.72804 .16231 m
.71192 .15435 L
s
.71192 .15435 m
.74416 .15435 L
s
.74416 .15435 m
.72804 .16231 L
s
.4799 .34936 m
.46874 .33501 L
s
.46874 .33501 m
.50496 .31712 L
s
.50496 .31712 m
.4799 .34936 L
s
.72627 .15435 m
.71192 .15435 L
s
.71192 .15435 m
.70617 .12849 L
s
.70617 .12849 m
.72627 .15435 L
s
.38337 .45759 m
.36946 .4397 L
s
.36946 .4397 m
.38956 .42977 L
s
.38956 .42977 m
.38337 .45759 L
s
.41861 .21883 m
.42579 .18659 L
s
.42579 .18659 m
.42977 .20448 L
s
.42977 .20448 m
.41861 .21883 L
s
.6409 .35732 m
.63373 .36087 L
s
.63373 .36087 m
.62656 .35732 L
s
.62656 .35732 m
.62336 .34298 L
s
.62336 .34298 m
.6441 .34298 L
s
.6441 .34298 m
.6409 .35732 L
s
.09227 .05763 m
.08731 .06401 L
s
.08731 .06401 m
.0851 .05408 L
s
.0851 .05408 m
.09227 .05763 L
s
.661 .38318 m
.65383 .38672 L
s
.65383 .38672 m
.64666 .38318 L
s
.64666 .38318 m
.64488 .37522 L
s
.64488 .37522 m
.65383 .36371 L
s
.65383 .36371 m
.66278 .37522 L
s
.66278 .37522 m
.661 .38318 L
s
.65064 .33659 m
.64488 .33943 L
s
.64488 .33943 m
.64666 .33147 L
s
.64666 .33147 m
.65064 .33659 L
s
.0672 .07962 m
.06401 .07552 L
s
.06401 .07552 m
.0672 .07394 L
s
.0672 .07394 m
.0704 .07552 L
s
.0704 .07552 m
.0672 .07962 L
s
.76386 .29456 m
.76284 .29456 L
s
.76284 .29456 m
.75709 .28716 L
s
.75709 .28716 m
.76284 .29 L
s
.76284 .29 m
.76386 .29456 L
s
.49795 .04865 m
.49772 .04966 L
s
.49772 .04966 m
.49361 .04966 L
s
.49361 .04966 m
.49283 .04612 L
s
.49283 .04612 m
.49795 .04865 L
s
.60866 .30562 m
.59432 .30562 L
s
.59432 .30562 m
.59751 .29127 L
s
.59751 .29127 m
.60866 .30562 L
s
.67712 .84565 m
.66676 .85077 L
s
.66676 .85077 m
.66278 .84565 L
s
.66278 .84565 m
.67393 .83131 L
s
.67393 .83131 m
.67712 .84565 L
s
.50831 .03532 m
.49681 .03532 L
s
.49681 .03532 m
.49504 .02735 L
s
.49504 .02735 m
.49779 .02381 L
s
.49779 .02381 m
.50575 .02381 L
s
.50575 .02381 m
.50831 .03532 L
s
.46776 .04966 m
.4598 .04966 L
s
.4598 .04966 m
.46201 .04682 L
s
.46201 .04682 m
.46776 .04966 L
s
.04888 .05605 m
.04391 .04966 L
s
.04391 .04966 m
.05108 .04612 L
s
.05108 .04612 m
.04888 .05605 L
s
.47415 .04966 m
.46776 .04966 L
s
.46776 .04966 m
.46697 .04612 L
s
.46697 .04612 m
.47415 .04966 L
s
.68032 .1802 m
.68082 .18248 L
s
.68082 .18248 m
.6757 .18248 L
s
.6757 .18248 m
.67251 .17837 L
s
.67251 .17837 m
.67456 .17736 L
s
.67456 .17736 m
.68032 .1802 L
s
.70298 .89736 m
.699 .89224 L
s
.699 .89224 m
.70121 .8894 L
s
.70121 .8894 m
.70298 .89736 L
s
.72804 .9296 m
.71689 .91525 L
s
.71689 .91525 m
.72584 .91967 L
s
.72584 .91967 m
.72804 .9296 L
s
.65958 .33786 m
.6556 .33274 L
s
.6556 .33274 m
.65659 .33147 L
s
.65659 .33147 m
.65816 .33147 L
s
.65816 .33147 m
.65958 .33786 L
s
.70731 .21655 m
.70617 .21598 L
s
.70617 .21598 m
.70759 .21528 L
s
.70759 .21528 m
.70731 .21655 L
s
.57165 .29127 m
.56271 .27976 L
s
.56271 .27976 m
.57564 .27338 L
s
.57564 .27338 m
.57165 .29127 L
s
.65383 .41542 m
.64666 .41896 L
s
.64666 .41896 m
.63948 .41542 L
s
.63948 .41542 m
.63771 .40746 L
s
.63771 .40746 m
.64268 .40107 L
s
.64268 .40107 m
.65702 .40107 L
s
.65702 .40107 m
.65383 .41542 L
s
.75646 .26131 m
.75134 .26131 L
s
.75134 .26131 m
.75532 .25619 L
s
.75532 .25619 m
.75646 .26131 L
s
.73841 .25492 m
.73892 .2572 L
s
.73892 .2572 m
.7338 .2572 L
s
.7338 .2572 m
.73061 .25309 L
s
.73061 .25309 m
.73266 .25208 L
s
.73266 .25208 m
.73841 .25492 L
s
.65383 .32224 m
.64808 .32508 L
s
.64808 .32508 m
.64985 .31712 L
s
.64985 .31712 m
.65383 .32224 L
s
.72896 .21244 m
.72485 .21244 L
s
.72485 .21244 m
.72321 .20504 L
s
.72321 .20504 m
.72691 .20321 L
s
.72691 .20321 m
.73061 .20504 L
s
.73061 .20504 m
.72896 .21244 L
s
.56065 .27053 m
.55553 .27053 L
s
.55553 .27053 m
.55952 .26541 L
s
.55952 .26541 m
.56065 .27053 L
s
.76171 .28488 m
.76221 .28716 L
s
.76221 .28716 m
.75709 .28716 L
s
.75709 .28716 m
.7539 .28305 L
s
.7539 .28305 m
.75595 .28204 L
s
.75595 .28204 m
.76171 .28488 L
s
.48849 .04966 m
.48707 .04328 L
s
.48707 .04328 m
.48963 .04454 L
s
.48963 .04454 m
.48849 .04966 L
s
.68288 .87151 m
.67172 .85716 L
s
.67172 .85716 m
.68067 .86158 L
s
.68067 .86158 m
.68288 .87151 L
s
.51293 .26541 m
.50895 .26029 L
s
.50895 .26029 m
.50993 .25903 L
s
.50993 .25903 m
.51151 .25903 L
s
.51151 .25903 m
.51293 .26541 L
s
.84821 .50575 m
.84664 .50575 L
s
.84664 .50575 m
.84786 .50418 L
s
.84786 .50418 m
.84821 .50575 L
s
.62399 .31712 m
.61505 .30562 L
s
.61505 .30562 m
.62798 .29923 L
s
.62798 .29923 m
.62399 .31712 L
s
.73727 .2498 m
.72804 .2498 L
s
.72804 .2498 m
.72741 .24899 L
s
.72741 .24899 m
.73152 .24696 L
s
.73152 .24696 m
.73727 .2498 L
s
.74559 .21244 m
.74331 .21244 L
s
.74331 .21244 m
.74445 .21188 L
s
.74445 .21188 m
.74559 .21244 L
s
.56527 .29127 m
.56448 .29025 L
s
.56448 .29025 m
.56492 .28969 L
s
.56492 .28969 m
.56527 .29127 L
s
.5549 .28615 m
.55092 .28103 L
s
.55092 .28103 m
.5519 .27976 L
s
.5519 .27976 m
.55348 .27976 L
s
.55348 .27976 m
.5549 .28615 L
s
.49361 .04966 m
.49204 .04966 L
s
.49204 .04966 m
.49326 .04809 L
s
.49326 .04809 m
.49361 .04966 L
s
.49539 .05194 m
.49361 .04966 L
s
.49361 .04966 m
.5 .04966 L
s
.5 .04966 m
.49539 .05194 L
s
.67712 .3522 m
.66676 .35732 L
s
.66676 .35732 m
.66995 .34298 L
s
.66995 .34298 m
.6757 .34582 L
s
.6757 .34582 m
.67712 .3522 L
s
.52905 .26313 m
.52585 .25903 L
s
.52585 .25903 m
.53224 .25903 L
s
.53224 .25903 m
.52905 .26313 L
s
.86895 .50575 m
.86256 .50575 L
s
.86256 .50575 m
.85858 .50063 L
s
.85858 .50063 m
.86355 .49425 L
s
.86355 .49425 m
.86796 .49425 L
s
.86796 .49425 m
.87072 .49779 L
s
.87072 .49779 m
.86895 .50575 L
s
.74097 .21472 m
.7392 .21244 L
s
.7392 .21244 m
.74559 .21244 L
s
.74559 .21244 m
.74097 .21472 L
s
.49283 .0302 m
.48786 .02381 L
s
.48786 .02381 m
.49141 .02381 L
s
.49141 .02381 m
.49283 .0302 L
s
.50205 .04865 m
.50114 .0491 L
s
.50114 .0491 m
.4976 .04454 L
s
.4976 .04454 m
.50114 .04454 L
s
.50114 .04454 m
.50205 .04865 L
s
.50256 .26029 m
.50158 .25903 L
s
.50158 .25903 m
.50228 .25903 L
s
.50228 .25903 m
.50256 .26029 L
s
.83899 .50575 m
.83829 .50575 L
s
.83829 .50575 m
.83785 .50519 L
s
.83785 .50519 m
.83876 .50474 L
s
.83876 .50474 m
.83899 .50575 L
s
.85062 .49495 m
.84964 .49368 L
s
.84964 .49368 m
.85106 .49298 L
s
.85106 .49298 m
.85062 .49495 L
s
.68146 .18532 m
.68032 .18476 L
s
.68032 .18476 m
.68111 .18374 L
s
.68111 .18374 m
.68146 .18532 L
s
.44127 .07552 m
.4397 .07552 L
s
.4397 .07552 m
.44092 .07394 L
s
.44092 .07394 m
.44127 .07552 L
s
.63992 .3816 m
.63869 .38318 L
s
.63869 .38318 m
.63673 .38318 L
s
.63673 .38318 m
.6355 .3816 L
s
.6355 .3816 m
.63594 .37964 L
s
.63594 .37964 m
.63771 .37876 L
s
.63771 .37876 m
.63948 .37964 L
s
.63948 .37964 m
.63992 .3816 L
s
.74416 .27053 m
.74097 .26643 L
s
.74097 .26643 m
.74559 .26415 L
s
.74559 .26415 m
.74416 .27053 L
s
.49681 .03532 m
.49283 .0302 L
s
.49283 .0302 m
.49504 .02735 L
s
.49504 .02735 m
.49681 .03532 L
s
.68288 .40107 m
.65958 .38956 L
s
.65958 .38956 m
.69182 .38956 L
s
.69182 .38956 m
.68288 .40107 L
s
.72229 .36883 m
.70617 .38956 L
s
.70617 .38956 m
.699 .35732 L
s
.699 .35732 m
.72229 .36883 L
s
.66597 .33786 m
.661 .33147 L
s
.661 .33147 m
.66739 .33147 L
s
.66739 .33147 m
.66597 .33786 L
s
.64552 .40107 m
.63913 .40107 L
s
.63913 .40107 m
.63515 .39595 L
s
.63515 .39595 m
.64808 .38956 L
s
.64808 .38956 m
.64552 .40107 L
s
.14142 .0819 m
.1253 .08987 L
s
.1253 .08987 m
.1052 .06401 L
s
.1052 .06401 m
.14142 .0819 L
s
.70617 .38956 m
.72229 .36883 L
s
.72229 .36883 m
.73522 .37522 L
s
.73522 .37522 m
.70617 .38956 L
s
.16152 .13645 m
.14142 .14638 L
s
.14142 .14638 m
.12132 .13645 L
s
.12132 .13645 m
.11237 .09625 L
s
.11237 .09625 m
.15257 .09625 L
s
.15257 .09625 m
.16648 .11414 L
s
.16648 .11414 m
.16152 .13645 L
s
.17047 .09625 m
.16648 .11414 L
s
.16648 .11414 m
.14142 .0819 L
s
.14142 .0819 m
.17047 .09625 L
s
.7191 .44766 m
.69324 .44766 L
s
.69324 .44766 m
.6958 .43615 L
s
.6958 .43615 m
.7191 .44766 L
s
.24291 .09625 m
.20669 .11414 L
s
.20669 .11414 m
.17047 .09625 L
s
.17047 .09625 m
.16152 .05605 L
s
.16152 .05605 m
.18659 .02381 L
s
.18659 .02381 m
.22679 .02381 L
s
.22679 .02381 m
.25185 .05605 L
s
.25185 .05605 m
.24291 .09625 L
s
.68288 .34936 m
.66995 .34298 L
s
.66995 .34298 m
.67614 .33501 L
s
.67614 .33501 m
.68607 .33501 L
s
.68607 .33501 m
.68288 .34936 L
s
.90517 .34298 m
.898 .34652 L
s
.898 .34652 m
.90198 .32863 L
s
.90198 .32863 m
.90517 .34298 L
s
.58139 .33501 m
.56748 .31712 L
s
.56748 .31712 m
.5953 .31712 L
s
.5953 .31712 m
.58139 .33501 L
s
.66995 .22679 m
.67393 .2089 L
s
.67393 .2089 m
.69005 .20093 L
s
.69005 .20093 m
.66995 .22679 L
s
.7392 .27692 m
.72627 .27053 L
s
.72627 .27053 m
.73522 .25903 L
s
.73522 .25903 m
.74141 .26699 L
s
.74141 .26699 m
.7392 .27692 L
s
.64985 .05605 m
.6409 .04454 L
s
.6409 .04454 m
.64587 .03816 L
s
.64587 .03816 m
.64985 .05605 L
s
.38956 .20448 m
.3645 .21686 L
s
.3645 .21686 m
.36946 .19455 L
s
.36946 .19455 m
.38956 .20448 L
s
.61761 .25264 m
.59751 .22679 L
s
.59751 .22679 m
.61363 .23475 L
s
.61363 .23475 m
.61761 .25264 L
s
.75851 .88586 m
.75134 .8894 L
s
.75134 .8894 m
.74416 .88586 L
s
.74416 .88586 m
.74097 .87151 L
s
.74097 .87151 m
.75532 .87151 L
s
.75532 .87151 m
.76028 .87789 L
s
.76028 .87789 m
.75851 .88586 L
s
.32209 .32705 m
.31712 .32067 L
s
.31712 .32067 m
.3243 .31712 L
s
.3243 .31712 m
.32209 .32705 L
s
.38239 .20093 m
.37664 .19809 L
s
.37664 .19809 m
.38302 .19809 L
s
.38302 .19809 m
.38239 .20093 L
s
.28808 .33501 m
.2809 .33147 L
s
.2809 .33147 m
.29083 .33147 L
s
.29083 .33147 m
.28808 .33501 L
s
.77861 .91171 m
.77144 .91525 L
s
.77144 .91525 m
.76427 .91171 L
s
.76427 .91171 m
.76249 .90375 L
s
.76249 .90375 m
.77144 .89224 L
s
.77144 .89224 m
.78039 .90375 L
s
.78039 .90375 m
.77861 .91171 L
s
.5836 .06401 m
.57564 .06401 L
s
.57564 .06401 m
.57962 .05889 L
s
.57962 .05889 m
.5836 .06401 L
s
.55952 .04328 m
.55695 .04454 L
s
.55695 .04454 m
.55604 .04044 L
s
.55604 .04044 m
.56015 .04044 L
s
.56015 .04044 m
.55952 .04328 L
s
.31889 .34708 m
.31791 .34582 L
s
.31791 .34582 m
.3211 .33147 L
s
.3211 .33147 m
.32331 .3414 L
s
.32331 .3414 m
.31889 .34708 L
s
.8801 .4397 m
.87931 .44071 L
s
.87931 .44071 m
.87635 .43924 L
s
.87635 .43924 m
.87653 .43843 L
s
.87653 .43843 m
.87982 .43843 L
s
.87982 .43843 m
.8801 .4397 L
s
.8801 .4397 m
.87982 .43843 L
s
.87982 .43843 m
.88109 .43843 L
s
.88109 .43843 m
.8801 .4397 L
s
.89686 .21244 m
.88649 .20732 L
s
.88649 .20732 m
.89942 .20093 L
s
.89942 .20093 m
.89686 .21244 L
s
.25903 .32067 m
.25584 .32224 L
s
.25584 .32224 m
.25185 .31712 L
s
.25185 .31712 m
.25903 .32067 L
s
.74416 .85716 m
.73522 .84565 L
s
.73522 .84565 m
.74097 .84281 L
s
.74097 .84281 m
.74672 .84565 L
s
.74672 .84565 m
.74416 .85716 L
s
.87726 .42693 m
.87356 .4251 L
s
.87356 .4251 m
.87612 .4218 L
s
.87612 .4218 m
.87726 .42693 L
s
.88586 .42408 m
.88188 .4292 L
s
.88188 .4292 m
.87726 .42693 L
s
.87726 .42693 m
.87612 .4218 L
s
.87612 .4218 m
.87931 .4177 L
s
.87931 .4177 m
.88507 .42054 L
s
.88507 .42054 m
.88586 .42408 L
s
.27018 .29923 m
.27515 .29285 L
s
.27515 .29285 m
.27913 .29481 L
s
.27913 .29481 m
.27018 .29923 L
s
.56846 .06756 m
.56271 .0704 L
s
.56271 .0704 m
.56129 .06401 L
s
.56129 .06401 m
.56846 .06756 L
s
.27018 .29923 m
.26301 .30277 L
s
.26301 .30277 m
.2692 .29481 L
s
.2692 .29481 m
.27018 .29923 L
s
.79331 .84565 m
.78756 .8198 L
s
.78756 .8198 m
.79651 .83131 L
s
.79651 .83131 m
.79331 .84565 L
s
.84707 .34298 m
.83273 .34298 L
s
.83273 .34298 m
.8399 .33375 L
s
.8399 .33375 m
.84707 .34298 L
s
.86319 .36371 m
.85283 .36883 L
s
.85283 .36883 m
.85858 .34298 L
s
.85858 .34298 m
.86319 .36371 L
s
.87151 .3596 m
.86319 .36371 L
s
.86319 .36371 m
.85858 .34298 L
s
.85858 .34298 m
.87151 .3596 L
s
.62159 .33501 m
.61938 .33786 L
s
.61938 .33786 m
.61442 .33147 L
s
.61442 .33147 m
.61619 .32351 L
s
.61619 .32351 m
.61938 .32508 L
s
.61938 .32508 m
.62159 .33501 L
s
.93536 .20732 m
.93216 .20321 L
s
.93216 .20321 m
.93678 .20093 L
s
.93678 .20093 m
.93536 .20732 L
s
.29206 .36883 m
.28808 .36371 L
s
.28808 .36371 m
.29525 .35448 L
s
.29525 .35448 m
.30818 .36087 L
s
.30818 .36087 m
.29206 .36883 L
s
.31712 .40107 m
.30597 .38672 L
s
.30597 .38672 m
.31491 .39114 L
s
.31491 .39114 m
.31712 .40107 L
s
.84338 .21016 m
.83876 .21244 L
s
.83876 .21244 m
.84195 .20833 L
s
.84195 .20833 m
.84309 .2089 L
s
.84309 .2089 m
.84338 .21016 L
s
.60645 .40304 m
.60468 .40391 L
s
.60468 .40391 m
.60424 .40195 L
s
.60424 .40195 m
.60645 .40304 L
s
.86063 .37522 m
.8399 .37522 L
s
.8399 .37522 m
.86319 .36371 L
s
.86319 .36371 m
.86063 .37522 L
s
.9181 .21016 m
.91924 .20504 L
s
.91924 .20504 m
.92385 .20732 L
s
.92385 .20732 m
.9181 .21016 L
s
.35015 .17224 m
.34617 .17736 L
s
.34617 .17736 m
.33722 .16585 L
s
.33722 .16585 m
.34873 .16585 L
s
.34873 .16585 m
.35015 .17224 L
s
.88188 .35448 m
.87151 .3596 L
s
.87151 .3596 m
.85858 .34298 L
s
.85858 .34298 m
.88188 .35448 L
s
.86895 .38956 m
.85858 .38444 L
s
.85858 .38444 m
.86576 .37522 L
s
.86576 .37522 m
.86895 .38956 L
s
.8948 .38956 m
.88188 .39595 L
s
.88188 .39595 m
.86895 .38956 L
s
.86895 .38956 m
.86576 .37522 L
s
.86576 .37522 m
.8747 .36371 L
s
.8747 .36371 m
.88905 .36371 L
s
.88905 .36371 m
.898 .37522 L
s
.898 .37522 m
.8948 .38956 L
s
.88905 .36371 m
.86319 .36371 L
s
.86319 .36371 m
.88188 .35448 L
s
.88188 .35448 m
.88905 .36371 L
s
.78039 .90375 m
.76427 .88301 L
s
.76427 .88301 m
.77463 .87789 L
s
.77463 .87789 m
.78039 .90375 L
s
.70617 .65064 m
.699 .65418 L
s
.699 .65418 m
.69182 .65064 L
s
.69182 .65064 m
.68863 .63629 L
s
.68863 .63629 m
.70936 .63629 L
s
.70936 .63629 m
.70617 .65064 L
s
.79843 .07268 m
.79331 .07268 L
s
.79331 .07268 m
.79729 .06756 L
s
.79729 .06756 m
.79843 .07268 L
s
.72627 .67649 m
.7191 .68004 L
s
.7191 .68004 m
.71192 .67649 L
s
.71192 .67649 m
.71015 .66853 L
s
.71015 .66853 m
.7191 .65702 L
s
.7191 .65702 m
.72804 .66853 L
s
.72804 .66853 m
.72627 .67649 L
s
.71591 .6299 m
.71015 .63275 L
s
.71015 .63275 m
.71192 .62478 L
s
.71192 .62478 m
.71591 .6299 L
s
.78089 .06857 m
.7776 .06857 L
s
.7776 .06857 m
.77833 .06528 L
s
.77833 .06528 m
.78039 .06629 L
s
.78039 .06629 m
.78089 .06857 L
s
.6172 .10593 m
.61619 .10593 L
s
.61619 .10593 m
.61044 .09853 L
s
.61044 .09853 m
.61619 .10137 L
s
.61619 .10137 m
.6172 .10593 L
s
.53445 .31358 m
.52984 .31586 L
s
.52984 .31586 m
.52905 .31484 L
s
.52905 .31484 m
.53347 .30916 L
s
.53347 .30916 m
.53445 .31358 L
s
.87293 .43615 m
.85858 .43615 L
s
.85858 .43615 m
.86177 .4218 L
s
.86177 .4218 m
.87293 .43615 L
s
.44908 .55234 m
.43871 .55746 L
s
.43871 .55746 m
.43473 .55234 L
s
.43473 .55234 m
.44589 .53799 L
s
.44589 .53799 m
.44908 .55234 L
s
.52329 .29923 m
.51037 .30562 L
s
.51037 .30562 m
.50717 .29127 L
s
.50717 .29127 m
.51612 .28685 L
s
.51612 .28685 m
.52108 .2893 L
s
.52108 .2893 m
.52329 .29923 L
s
.5635 .29923 m
.56846 .29285 L
s
.56846 .29285 m
.57244 .29481 L
s
.57244 .29481 m
.5635 .29923 L
s
.78181 .04966 m
.78295 .04454 L
s
.78295 .04454 m
.78756 .04682 L
s
.78756 .04682 m
.78181 .04966 L
s
.5635 .29923 m
.55632 .30277 L
s
.55632 .30277 m
.56251 .29481 L
s
.56251 .29481 m
.5635 .29923 L
s
.55632 .62833 m
.55411 .63117 L
s
.55411 .63117 m
.54915 .62478 L
s
.54915 .62478 m
.55092 .61682 L
s
.55092 .61682 m
.55411 .6184 L
s
.55411 .6184 m
.55632 .62833 L
s
.47493 .60405 m
.47095 .59893 L
s
.47095 .59893 m
.47316 .59609 L
s
.47316 .59609 m
.47493 .60405 L
s
.5 .63629 m
.48884 .62194 L
s
.48884 .62194 m
.49779 .62636 L
s
.49779 .62636 m
.5 .63629 L
s
.72485 .63117 m
.72087 .62605 L
s
.72087 .62605 m
.72185 .62478 L
s
.72185 .62478 m
.72343 .62478 L
s
.72343 .62478 m
.72485 .63117 L
s
.56065 .02792 m
.55952 .02735 L
s
.55952 .02735 m
.56094 .02665 L
s
.56094 .02665 m
.56065 .02792 L
s
.83592 .4218 m
.82697 .4103 L
s
.82697 .4103 m
.8399 .40391 L
s
.8399 .40391 m
.83592 .4218 L
s
.7191 .70873 m
.71192 .71228 L
s
.71192 .71228 m
.70475 .70873 L
s
.70475 .70873 m
.70298 .70077 L
s
.70298 .70077 m
.70794 .69438 L
s
.70794 .69438 m
.72229 .69438 L
s
.72229 .69438 m
.7191 .70873 L
s
.6098 .07268 m
.60468 .07268 L
s
.60468 .07268 m
.60866 .06756 L
s
.60866 .06756 m
.6098 .07268 L
s
.59175 .06629 m
.59226 .06857 L
s
.59226 .06857 m
.58714 .06857 L
s
.58714 .06857 m
.58395 .06446 L
s
.58395 .06446 m
.586 .06345 L
s
.586 .06345 m
.59175 .06629 L
s
.7191 .61556 m
.71335 .6184 L
s
.71335 .6184 m
.71512 .61044 L
s
.71512 .61044 m
.7191 .61556 L
s
.57564 .71512 m
.56527 .72024 L
s
.56527 .72024 m
.56129 .71512 L
s
.56129 .71512 m
.56846 .70589 L
s
.56846 .70589 m
.57421 .70873 L
s
.57421 .70873 m
.57564 .71512 L
s
.82492 .40107 m
.8198 .40107 L
s
.8198 .40107 m
.82378 .39595 L
s
.82378 .39595 m
.82492 .40107 L
s
.61505 .09625 m
.61556 .09853 L
s
.61556 .09853 m
.61044 .09853 L
s
.61044 .09853 m
.60724 .09442 L
s
.60724 .09442 m
.6093 .09341 L
s
.6093 .09341 m
.61505 .09625 L
s
.5402 .31074 m
.53622 .30562 L
s
.53622 .30562 m
.53843 .30277 L
s
.53843 .30277 m
.5402 .31074 L
s
.45483 .5782 m
.44368 .56385 L
s
.44368 .56385 m
.45262 .56827 L
s
.45262 .56827 m
.45483 .5782 L
s
.77719 .39595 m
.77321 .39083 L
s
.77321 .39083 m
.77419 .38956 L
s
.77419 .38956 m
.77577 .38956 L
s
.77577 .38956 m
.77719 .39595 L
s
.08687 .04612 m
.0851 .04524 L
s
.0851 .04524 m
.08652 .04454 L
s
.08652 .04454 m
.08687 .04612 L
s
.68926 .61044 m
.68032 .59893 L
s
.68032 .59893 m
.69324 .59254 L
s
.69324 .59254 m
.68926 .61044 L
s
.59062 .06117 m
.58139 .06117 L
s
.58139 .06117 m
.58076 .06036 L
s
.58076 .06036 m
.58486 .05833 L
s
.58486 .05833 m
.59062 .06117 L
s
.58139 .74097 m
.57918 .73813 L
s
.57918 .73813 m
.58095 .73901 L
s
.58095 .73901 m
.58139 .74097 L
s
.82953 .4218 m
.82875 .42079 L
s
.82875 .42079 m
.82918 .42023 L
s
.82918 .42023 m
.82953 .4218 L
s
.81917 .41668 m
.81519 .41156 L
s
.81519 .41156 m
.81617 .4103 L
s
.81617 .4103 m
.81775 .4103 L
s
.81775 .4103 m
.81917 .41668 L
s
.53622 .3127 m
.53445 .31358 L
s
.53445 .31358 m
.53401 .31161 L
s
.53401 .31161 m
.53622 .3127 L
s
.53366 .31712 m
.52728 .31712 L
s
.52728 .31712 m
.53445 .31358 L
s
.53445 .31358 m
.53366 .31712 L
s
.74239 .64552 m
.73203 .65064 L
s
.73203 .65064 m
.73522 .63629 L
s
.73522 .63629 m
.74097 .63913 L
s
.74097 .63913 m
.74239 .64552 L
s
.79331 .39367 m
.79012 .38956 L
s
.79012 .38956 m
.79651 .38956 L
s
.79651 .38956 m
.79331 .39367 L
s
.08332 .0302 m
.07934 .03532 L
s
.07934 .03532 m
.07217 .03177 L
s
.07217 .03177 m
.07119 .02735 L
s
.07119 .02735 m
.07394 .02381 L
s
.07394 .02381 m
.0819 .02381 L
s
.0819 .02381 m
.08332 .0302 L
s
.59432 .02609 m
.59254 .02381 L
s
.59254 .02381 m
.59893 .02381 L
s
.59893 .02381 m
.59432 .02609 L
s
.52507 .29127 m
.52329 .28331 L
s
.52329 .28331 m
.52728 .28134 L
s
.52728 .28134 m
.52507 .29127 L
s
.5257 .31712 m
.52443 .31712 L
s
.52443 .31712 m
.52329 .312 L
s
.52329 .312 m
.52728 .31004 L
s
.52728 .31004 m
.5257 .31712 L
s
.76683 .39083 m
.76584 .38956 L
s
.76584 .38956 m
.76654 .38956 L
s
.76654 .38956 m
.76683 .39083 L
s
.08873 .05447 m
.08829 .05504 L
s
.08829 .05504 m
.08766 .05422 L
s
.08766 .05422 m
.08857 .05377 L
s
.08857 .05377 m
.08873 .05447 L
s
.07473 .04581 m
.07375 .04454 L
s
.07375 .04454 m
.07571 .04454 L
s
.07571 .04454 m
.07473 .04581 L
s
.55136 .63471 m
.55092 .63275 L
s
.55092 .63275 m
.55289 .63275 L
s
.55289 .63275 m
.55136 .63471 L
s
.60866 .3127 m
.60689 .31358 L
s
.60689 .31358 m
.60645 .31161 L
s
.60645 .31161 m
.60866 .3127 L
s
.70519 .67492 m
.70396 .67649 L
s
.70396 .67649 m
.702 .67649 L
s
.702 .67649 m
.70077 .67492 L
s
.70077 .67492 m
.70121 .67295 L
s
.70121 .67295 m
.70298 .67207 L
s
.70298 .67207 m
.70475 .67295 L
s
.70475 .67295 m
.70519 .67492 L
s
.59751 .0819 m
.59432 .0778 L
s
.59432 .0778 m
.59893 .07552 L
s
.59893 .07552 m
.59751 .0819 L
s
.52329 .29923 m
.52108 .2893 L
s
.52108 .2893 m
.52507 .29127 L
s
.52507 .29127 m
.52329 .29923 L
s
.74815 .69438 m
.72485 .68288 L
s
.72485 .68288 m
.75709 .68288 L
s
.75709 .68288 m
.74815 .69438 L
s
.77144 .68288 m
.76427 .65064 L
s
.76427 .65064 m
.78756 .66214 L
s
.78756 .66214 m
.77144 .68288 L
s
.73124 .63117 m
.72627 .62478 L
s
.72627 .62478 m
.73266 .62478 L
s
.73266 .62478 m
.73124 .63117 L
s
.71079 .69438 m
.7044 .69438 L
s
.7044 .69438 m
.70042 .68926 L
s
.70042 .68926 m
.71335 .68288 L
s
.71335 .68288 m
.71079 .69438 L
s
.80624 .10776 m
.79587 .10264 L
s
.79587 .10264 m
.80049 .0819 L
s
.80049 .0819 m
.80624 .10776 L
s
.77144 .68288 m
.78756 .66214 L
s
.78756 .66214 m
.80049 .66853 L
s
.80049 .66853 m
.77144 .68288 L
s
.80049 .13361 m
.78756 .14 L
s
.78756 .14 m
.77463 .13361 L
s
.77463 .13361 m
.77144 .11926 L
s
.77144 .11926 m
.78756 .09853 L
s
.78756 .09853 m
.80368 .11926 L
s
.80368 .11926 m
.80049 .13361 L
s
.81085 .12849 m
.80049 .13361 L
s
.80049 .13361 m
.80624 .10776 L
s
.80624 .10776 m
.81085 .12849 L
s
.78437 .74097 m
.75851 .74097 L
s
.75851 .74097 m
.76107 .72947 L
s
.76107 .72947 m
.78437 .74097 L
s
.77144 .94395 m
.76427 .94749 L
s
.76427 .94749 m
.75709 .94395 L
s
.75709 .94395 m
.75532 .93599 L
s
.75532 .93599 m
.76028 .9296 L
s
.76028 .9296 m
.77463 .9296 L
s
.77463 .9296 m
.77144 .94395 L
s
.59353 .0998 m
.58856 .09341 L
s
.58856 .09341 m
.59495 .09341 L
s
.59495 .09341 m
.59353 .0998 L
s
.57244 .10137 m
.56988 .10264 L
s
.56988 .10264 m
.56897 .09853 L
s
.56897 .09853 m
.57307 .09853 L
s
.57307 .09853 m
.57244 .10137 L
s
.58316 .47762 m
.58218 .47636 L
s
.58218 .47636 m
.58395 .46839 L
s
.58395 .46839 m
.58714 .46997 L
s
.58714 .46997 m
.58758 .47194 L
s
.58758 .47194 m
.58316 .47762 L
s
.85027 .40335 m
.8473 .40188 L
s
.8473 .40188 m
.84748 .40107 L
s
.84748 .40107 m
.85204 .40107 L
s
.85204 .40107 m
.85027 .40335 L
s
.85141 .20732 m
.84821 .20321 L
s
.84821 .20321 m
.85283 .20093 L
s
.85283 .20093 m
.85141 .20732 L
s
.22104 .25903 m
.21067 .26415 L
s
.21067 .26415 m
.20669 .25903 L
s
.20669 .25903 m
.21386 .2498 L
s
.21386 .2498 m
.21961 .25264 L
s
.21961 .25264 m
.22104 .25903 L
s
.84821 .38956 m
.84451 .38774 L
s
.84451 .38774 m
.84707 .38444 L
s
.84707 .38444 m
.84821 .38956 L
s
.32828 .33501 m
.32607 .33786 L
s
.32607 .33786 m
.3211 .33147 L
s
.3211 .33147 m
.32288 .32351 L
s
.32288 .32351 m
.32607 .32508 L
s
.32607 .32508 m
.32828 .33501 L
s
.24689 .31074 m
.24291 .30562 L
s
.24291 .30562 m
.24512 .30277 L
s
.24512 .30277 m
.24689 .31074 L
s
.27196 .34298 m
.2608 .32863 L
s
.2608 .32863 m
.26975 .33305 L
s
.26975 .33305 m
.27196 .34298 L
s
.88535 .39879 m
.88074 .40107 L
s
.88074 .40107 m
.88393 .39696 L
s
.88393 .39696 m
.88507 .39753 L
s
.88507 .39753 m
.88535 .39879 L
s
.29879 .1508 m
.29702 .14993 L
s
.29702 .14993 m
.29844 .14923 L
s
.29844 .14923 m
.29879 .1508 L
s
.88188 .20504 m
.87151 .21016 L
s
.87151 .21016 m
.8747 .19581 L
s
.8747 .19581 m
.88188 .20504 L
s
.59254 .46555 m
.59033 .46839 L
s
.59033 .46839 m
.58537 .46201 L
s
.58537 .46201 m
.58572 .46043 L
s
.58572 .46043 m
.59211 .46358 L
s
.59211 .46358 m
.59254 .46555 L
s
.85397 .40518 m
.85488 .40107 L
s
.85488 .40107 m
.85716 .40107 L
s
.85716 .40107 m
.85397 .40518 L
s
.22679 .28488 m
.22458 .28204 L
s
.22458 .28204 m
.22635 .28292 L
s
.22635 .28292 m
.22679 .28488 L
s
.92362 .21199 m
.92271 .21244 L
s
.92271 .21244 m
.9235 .21143 L
s
.9235 .21143 m
.92362 .21199 L
s
.84799 .39879 m
.84502 .40026 L
s
.84502 .40026 m
.84451 .39961 L
s
.84451 .39961 m
.84657 .39696 L
s
.84657 .39696 m
.84771 .39753 L
s
.84771 .39753 m
.84799 .39879 L
s
.93194 .21244 m
.93257 .21163 L
s
.93257 .21163 m
.93308 .21188 L
s
.93308 .21188 m
.93194 .21244 L
s
.35299 .18501 m
.35256 .18557 L
s
.35256 .18557 m
.35192 .18476 L
s
.35192 .18476 m
.35284 .18431 L
s
.35284 .18431 m
.35299 .18501 L
s
.88045 .44127 m
.87931 .44071 L
s
.87931 .44071 m
.8801 .4397 L
s
.8801 .4397 m
.88045 .44127 L
s
.87931 .44071 m
.87726 .44172 L
s
.87726 .44172 m
.8747 .43843 L
s
.8747 .43843 m
.87931 .44071 L
s
.39674 .20093 m
.38239 .20093 L
s
.38239 .20093 m
.38381 .19455 L
s
.38381 .19455 m
.38956 .19171 L
s
.38956 .19171 m
.39674 .20093 L
s
.87356 .39184 m
.86986 .39367 L
s
.86986 .39367 m
.86895 .38956 L
s
.86895 .38956 m
.87356 .39184 L
s
.29525 .13488 m
.29127 .14 L
s
.29127 .14 m
.28409 .13645 L
s
.28409 .13645 m
.28311 .13204 L
s
.28311 .13204 m
.28587 .12849 L
s
.28587 .12849 m
.29383 .12849 L
s
.29383 .12849 m
.29525 .13488 L
s
.88763 .4218 m
.88649 .41668 L
s
.88649 .41668 m
.88905 .41542 L
s
.88905 .41542 m
.88763 .4218 L
s
.23175 .29127 m
.22998 .28331 L
s
.22998 .28331 m
.23396 .28134 L
s
.23396 .28134 m
.23175 .29127 L
s
.87407 .43762 m
.87356 .43697 L
s
.87356 .43697 m
.87561 .43433 L
s
.87561 .43433 m
.87818 .43559 L
s
.87818 .43559 m
.87407 .43762 L
s
.88996 .40107 m
.8906 .40026 L
s
.8906 .40026 m
.8911 .40051 L
s
.8911 .40051 m
.88996 .40107 L
s
.30065 .15915 m
.30021 .15972 L
s
.30021 .15972 m
.29958 .1589 L
s
.29958 .1589 m
.3005 .15845 L
s
.3005 .15845 m
.30065 .15915 L
s
.28665 .15049 m
.28567 .14923 L
s
.28567 .14923 m
.28764 .14923 L
s
.28764 .14923 m
.28665 .15049 L
s
.61663 .3414 m
.61619 .33943 L
s
.61619 .33943 m
.61816 .33943 L
s
.61816 .33943 m
.61663 .3414 L
s
.31535 .3127 m
.31358 .31358 L
s
.31358 .31358 m
.31314 .31161 L
s
.31314 .31161 m
.31535 .3127 L
s
.75753 .91013 m
.7563 .91171 L
s
.7563 .91171 m
.75434 .91171 L
s
.75434 .91171 m
.75311 .91013 L
s
.75311 .91013 m
.75355 .90817 L
s
.75355 .90817 m
.75532 .90729 L
s
.75532 .90729 m
.75709 .90817 L
s
.75709 .90817 m
.75753 .91013 L
s
.58139 .08987 m
.57564 .08702 L
s
.57564 .08702 m
.57962 .0819 L
s
.57962 .0819 m
.58139 .08987 L
s
.88649 .42693 m
.88188 .4292 L
s
.88188 .4292 m
.88586 .42408 L
s
.88586 .42408 m
.88649 .42693 L
s
.49681 .62194 m
.48884 .62194 L
s
.48884 .62194 m
.48388 .61556 L
s
.48388 .61556 m
.48707 .61398 L
s
.48707 .61398 m
.49602 .6184 L
s
.49602 .6184 m
.49681 .62194 L
s
.68146 .55234 m
.6757 .5495 L
s
.6757 .5495 m
.68288 .54596 L
s
.68288 .54596 m
.68146 .55234 L
s
.59175 .31712 m
.58537 .31712 L
s
.58537 .31712 m
.58281 .30562 L
s
.58281 .30562 m
.58856 .30277 L
s
.58856 .30277 m
.59432 .30562 L
s
.59432 .30562 m
.59175 .31712 L
s
.71192 .66625 m
.70873 .66214 L
s
.70873 .66214 m
.71512 .66214 L
s
.71512 .66214 m
.71192 .66625 L
s
.49425 .61044 m
.4799 .61044 L
s
.4799 .61044 m
.47892 .60917 L
s
.47892 .60917 m
.4853 .60602 L
s
.4853 .60602 m
.49425 .61044 L
s
.61761 .31712 m
.61407 .31712 L
s
.61407 .31712 m
.61584 .31625 L
s
.61584 .31625 m
.61761 .31712 L
s
.699 .68288 m
.69928 .68161 L
s
.69928 .68161 m
.69998 .68161 L
s
.69998 .68161 m
.699 .68288 L
s
.69644 .67137 m
.69786 .66499 L
s
.69786 .66499 m
.69944 .66499 L
s
.69944 .66499 m
.70042 .66625 L
s
.70042 .66625 m
.69644 .67137 L
s
.53799 .67492 m
.53622 .67404 L
s
.53622 .67404 m
.53843 .67295 L
s
.53843 .67295 m
.53799 .67492 L
s
.80368 .11926 m
.78756 .09853 L
s
.78756 .09853 m
.80624 .10776 L
s
.80624 .10776 m
.80368 .11926 L
s
.80624 .14923 m
.78756 .14 L
s
.78756 .14 m
.81085 .12849 L
s
.81085 .12849 m
.80624 .14923 L
s
.68288 .56897 m
.67712 .57181 L
s
.67712 .57181 m
.6789 .56385 L
s
.6789 .56385 m
.68288 .56897 L
s
.78756 .08373 m
.78181 .09113 L
s
.78181 .09113 m
.77925 .07962 L
s
.77925 .07962 m
.78437 .07962 L
s
.78437 .07962 m
.78756 .08373 L
s
.78437 .74097 m
.76107 .72947 L
s
.76107 .72947 m
.76427 .71512 L
s
.76427 .71512 m
.78437 .74097 L
s
.81661 .15435 m
.80624 .14923 L
s
.80624 .14923 m
.81341 .14 L
s
.81341 .14 m
.81661 .15435 L
s
.75532 .72662 m
.74416 .74097 L
s
.74416 .74097 m
.72627 .74097 L
s
.72627 .74097 m
.71512 .72662 L
s
.71512 .72662 m
.7191 .70873 L
s
.7191 .70873 m
.73522 .70077 L
s
.73522 .70077 m
.75134 .70873 L
s
.75134 .70873 m
.75532 .72662 L
s
.75851 .74097 m
.75134 .70873 L
s
.75134 .70873 m
.76427 .71512 L
s
.76427 .71512 m
.75851 .74097 L
s
.7191 .70873 m
.72485 .68288 L
s
.72485 .68288 m
.73522 .688 L
s
.73522 .688 m
.7191 .70873 L
s
.82059 .72308 m
.80049 .73301 L
s
.80049 .73301 m
.78039 .72308 L
s
.78039 .72308 m
.77542 .70077 L
s
.77542 .70077 m
.78933 .68288 L
s
.78933 .68288 m
.81164 .68288 L
s
.81164 .68288 m
.82555 .70077 L
s
.82555 .70077 m
.82059 .72308 L
s
.58139 .15435 m
.56527 .14638 L
s
.56527 .14638 m
.57642 .13204 L
s
.57642 .13204 m
.58139 .15435 L
s
.51612 .18659 m
.51214 .16869 L
s
.51214 .16869 m
.54119 .15435 L
s
.54119 .15435 m
.51612 .18659 L
s
.63373 .12849 m
.62257 .11414 L
s
.62257 .11414 m
.63054 .11414 L
s
.63054 .11414 m
.63373 .12849 L
s
.53622 .21244 m
.52231 .19455 L
s
.52231 .19455 m
.52728 .17224 L
s
.52728 .17224 m
.53622 .21244 L
s
.72804 .74893 m
.72185 .74097 L
s
.72185 .74097 m
.74416 .74097 L
s
.74416 .74097 m
.72804 .74893 L
s
.56846 .21244 m
.54615 .21244 L
s
.54615 .21244 m
.53224 .19455 L
s
.53224 .19455 m
.56846 .21244 L
s
.27692 .14884 m
.26576 .15435 L
s
.26576 .15435 m
.25185 .13645 L
s
.25185 .13645 m
.27692 .14884 L
s
.57465 .20448 m
.55234 .20448 L
s
.55234 .20448 m
.58856 .18659 L
s
.58856 .18659 m
.57465 .20448 L
s
.78437 .06117 m
.77925 .06117 L
s
.77925 .06117 m
.78039 .05605 L
s
.78039 .05605 m
.78437 .06117 L
s
.6061 .31712 m
.59972 .31712 L
s
.59972 .31712 m
.60689 .31358 L
s
.60689 .31358 m
.6061 .31712 L
s
.13247 .0704 m
.11812 .0704 L
s
.11812 .0704 m
.11955 .06401 L
s
.11955 .06401 m
.1253 .06117 L
s
.1253 .06117 m
.13247 .0704 L
s
.74097 .62889 m
.73778 .62478 L
s
.73778 .62478 m
.74416 .62478 L
s
.74416 .62478 m
.74097 .62889 L
s
.72229 .69438 m
.71591 .69438 L
s
.71591 .69438 m
.71192 .68926 L
s
.71192 .68926 m
.71335 .68288 L
s
.71335 .68288 m
.72131 .68288 L
s
.72131 .68288 m
.72406 .68642 L
s
.72406 .68642 m
.72229 .69438 L
s
.70617 .65064 m
.70794 .64268 L
s
.70794 .64268 m
.71015 .64552 L
s
.71015 .64552 m
.70617 .65064 L
s
.4598 .58458 m
.45803 .57662 L
s
.45803 .57662 m
.46201 .57465 L
s
.46201 .57465 m
.4598 .58458 L
s
.59814 .31712 m
.59688 .31712 L
s
.59688 .31712 m
.59574 .312 L
s
.59574 .312 m
.59972 .31004 L
s
.59972 .31004 m
.59814 .31712 L
s
.71449 .62605 m
.7135 .62478 L
s
.7135 .62478 m
.7142 .62478 L
s
.7142 .62478 m
.71449 .62605 L
s
.03639 .02862 m
.03595 .02918 L
s
.03595 .02918 m
.03532 .02837 L
s
.03532 .02837 m
.03623 .02792 L
s
.03623 .02792 m
.03639 .02862 L
s
.70396 .68358 m
.70298 .68231 L
s
.70298 .68231 m
.7044 .68161 L
s
.7044 .68161 m
.70396 .68358 L
s
.56385 .03405 m
.56271 .03349 L
s
.56271 .03349 m
.5635 .03247 L
s
.5635 .03247 m
.56385 .03405 L
s
.5434 .60602 m
.54162 .60689 L
s
.54162 .60689 m
.54119 .60493 L
s
.54119 .60493 m
.5434 .60602 L
s
.69226 .61682 m
.69103 .6184 L
s
.69103 .6184 m
.68907 .6184 L
s
.68907 .6184 m
.68784 .61682 L
s
.68784 .61682 m
.68828 .61485 L
s
.68828 .61485 m
.69005 .61398 L
s
.69005 .61398 m
.69182 .61485 L
s
.69182 .61485 m
.69226 .61682 L
s
.47095 .59893 m
.46599 .59254 L
s
.46599 .59254 m
.47592 .59254 L
s
.47592 .59254 m
.47095 .59893 L
s
.60291 .0704 m
.60007 .0704 L
s
.60007 .0704 m
.59893 .06528 L
s
.59893 .06528 m
.60291 .0704 L
s
.699 .6184 m
.69324 .61556 L
s
.69324 .61556 m
.69723 .61044 L
s
.69723 .61044 m
.699 .6184 L
s
.55632 .30277 m
.54915 .29923 L
s
.54915 .29923 m
.55908 .29923 L
s
.55908 .29923 m
.55632 .30277 L
s
.78614 .0819 m
.78295 .0778 L
s
.78295 .0778 m
.78756 .07552 L
s
.78756 .07552 m
.78614 .0819 L
s
.70873 .66214 m
.70475 .65702 L
s
.70475 .65702 m
.70696 .65418 L
s
.70696 .65418 m
.70873 .66214 L
s
.59574 .03816 m
.58856 .0417 L
s
.58856 .0417 m
.58139 .03816 L
s
.58139 .03816 m
.57962 .0302 L
s
.57962 .0302 m
.58458 .02381 L
s
.58458 .02381 m
.59254 .02381 L
s
.59254 .02381 m
.59751 .0302 L
s
.59751 .0302 m
.59574 .03816 L
s
.86576 .45562 m
.85283 .46201 L
s
.85283 .46201 m
.84565 .42977 L
s
.84565 .42977 m
.86576 .45562 L
s
.58856 .18659 m
.57244 .19455 L
s
.57244 .19455 m
.58139 .15435 L
s
.58139 .15435 m
.58856 .18659 L
s
.35059 .29923 m
.32828 .29923 L
s
.32828 .29923 m
.33324 .27692 L
s
.33324 .27692 m
.35059 .29923 L
s
.60247 .16869 m
.58458 .16869 L
s
.58458 .16869 m
.61363 .15435 L
s
.61363 .15435 m
.60247 .16869 L
s
.67393 .57023 m
.64268 .61044 L
s
.64268 .61044 m
.59254 .61044 L
s
.59254 .61044 m
.56129 .57023 L
s
.56129 .57023 m
.57244 .5201 L
s
.57244 .5201 m
.61761 .49779 L
s
.61761 .49779 m
.66278 .5201 L
s
.66278 .5201 m
.67393 .57023 L
s
.77719 .30277 m
.76923 .30277 L
s
.76923 .30277 m
.76427 .29639 L
s
.76427 .29639 m
.77463 .29127 L
s
.77463 .29127 m
.77719 .30277 L
s
.25804 .06401 m
.25185 .05605 L
s
.25185 .05605 m
.26301 .0417 L
s
.26301 .0417 m
.25804 .06401 L
s
.75134 .44766 m
.73522 .4397 L
s
.73522 .4397 m
.75532 .42977 L
s
.75532 .42977 m
.75134 .44766 L
s
.78437 .41542 m
.76427 .38956 L
s
.76427 .38956 m
.78039 .39753 L
s
.78039 .39753 m
.78437 .41542 L
s
.82157 .35732 m
.81661 .36371 L
s
.81661 .36371 m
.80943 .35448 L
s
.80943 .35448 m
.8198 .34936 L
s
.8198 .34936 m
.82157 .35732 L
s
.64887 .68288 m
.62656 .68288 L
s
.62656 .68288 m
.6238 .6705 L
s
.6238 .6705 m
.64887 .68288 L
s
.91411 .30277 m
.90517 .29127 L
s
.90517 .29127 m
.9181 .28488 L
s
.9181 .28488 m
.91411 .30277 L
s
.15036 .18659 m
.14142 .14638 L
s
.14142 .14638 m
.15533 .16428 L
s
.15533 .16428 m
.15036 .18659 L
s
.86177 .30562 m
.8546 .29639 L
s
.8546 .29639 m
.86177 .29285 L
s
.86177 .29285 m
.86895 .29639 L
s
.86895 .29639 m
.86177 .30562 L
s
.69281 .28488 m
.68288 .28488 L
s
.68288 .28488 m
.6789 .26699 L
s
.6789 .26699 m
.69281 .28488 L
s
.76427 .83131 m
.74815 .83927 L
s
.74815 .83927 m
.74416 .82138 L
s
.74416 .82138 m
.76427 .83131 L
s
.19553 .24468 m
.20944 .22679 L
s
.20944 .22679 m
.23175 .22679 L
s
.23175 .22679 m
.19553 .24468 L
s
.49105 .4799 m
.4598 .5201 L
s
.4598 .5201 m
.40967 .5201 L
s
.40967 .5201 m
.37841 .4799 L
s
.37841 .4799 m
.38956 .42977 L
s
.38956 .42977 m
.43473 .40746 L
s
.43473 .40746 m
.4799 .42977 L
s
.4799 .42977 m
.49105 .4799 L
s
.75355 .21244 m
.74559 .21244 L
s
.74559 .21244 m
.74815 .20093 L
s
.74815 .20093 m
.75851 .20605 L
s
.75851 .20605 m
.75355 .21244 L
s
.40348 .10618 m
.40568 .09625 L
s
.40568 .09625 m
.42358 .09625 L
s
.42358 .09625 m
.40348 .10618 L
s
.83671 .24468 m
.83273 .22679 L
s
.83273 .22679 m
.84565 .23317 L
s
.84565 .23317 m
.83671 .24468 L
s
.82953 .27692 m
.81661 .27053 L
s
.81661 .27053 m
.84246 .27053 L
s
.84246 .27053 m
.82953 .27692 L
s
.82953 .21244 m
.81803 .21244 L
s
.81803 .21244 m
.82059 .20093 L
s
.82059 .20093 m
.82776 .20448 L
s
.82776 .20448 m
.82953 .21244 L
s
.53622 .53799 m
.52507 .53248 L
s
.52507 .53248 m
.55013 .5201 L
s
.55013 .5201 m
.53622 .53799 L
s
.2407 .0417 m
.22679 .02381 L
s
.22679 .02381 m
.24468 .02381 L
s
.24468 .02381 m
.2407 .0417 L
s
.78039 .31712 m
.77463 .29127 L
s
.77463 .29127 m
.78358 .30277 L
s
.78358 .30277 m
.78039 .31712 L
s
.61264 .4397 m
.60645 .44766 L
s
.60645 .44766 m
.58856 .44766 L
s
.58856 .44766 m
.59254 .42977 L
s
.59254 .42977 m
.60149 .42535 L
s
.60149 .42535 m
.61044 .42977 L
s
.61044 .42977 m
.61264 .4397 L
s
.8747 .40518 m
.87151 .40107 L
s
.87151 .40107 m
.87789 .40107 L
s
.87789 .40107 m
.8747 .40518 L
s
.23175 .29127 m
.22679 .28488 L
s
.22679 .28488 m
.22998 .28331 L
s
.22998 .28331 m
.23175 .29127 L
s
.88649 .42693 m
.88507 .42054 L
s
.88507 .42054 m
.88763 .4218 L
s
.88763 .4218 m
.88649 .42693 L
s
.63771 .40746 m
.62656 .4218 L
s
.62656 .4218 m
.6154 .40746 L
s
.6154 .40746 m
.61761 .39753 L
s
.61761 .39753 m
.62656 .39311 L
s
.62656 .39311 m
.6355 .39753 L
s
.6355 .39753 m
.63771 .40746 L
s
.87407 .41258 m
.86895 .41258 L
s
.86895 .41258 m
.87293 .40746 L
s
.87293 .40746 m
.87407 .41258 L
s
.87356 .43697 m
.87151 .43433 L
s
.87151 .43433 m
.87356 .43331 L
s
.87356 .43331 m
.87561 .43433 L
s
.87561 .43433 m
.87356 .43697 L
s
.8906 .40026 m
.88996 .40107 L
s
.88996 .40107 m
.88074 .40107 L
s
.88074 .40107 m
.88649 .39823 L
s
.88649 .39823 m
.8906 .40026 L
s
.3005 .15845 m
.29958 .1589 L
s
.29958 .1589 m
.29702 .15561 L
s
.29702 .15561 m
.29923 .15277 L
s
.29923 .15277 m
.3005 .15845 L
s
.57165 .0819 m
.56271 .0704 L
s
.56271 .0704 m
.57564 .06401 L
s
.57564 .06401 m
.57165 .0819 L
s
.76427 .97619 m
.76313 .97107 L
s
.76313 .97107 m
.76569 .9698 L
s
.76569 .9698 m
.76427 .97619 L
s
.59574 .4799 m
.58856 .48344 L
s
.58856 .48344 m
.58139 .4799 L
s
.58139 .4799 m
.59254 .46555 L
s
.59254 .46555 m
.59574 .4799 L
s
.3243 .14923 m
.31712 .15845 L
s
.31712 .15845 m
.30995 .14923 L
s
.30995 .14923 m
.31491 .14284 L
s
.31491 .14284 m
.31933 .14284 L
s
.31933 .14284 m
.3243 .14923 L
s
.2809 .13488 m
.27594 .12849 L
s
.27594 .12849 m
.27948 .12849 L
s
.27948 .12849 m
.2809 .13488 L
s
.86177 .4218 m
.85858 .4177 L
s
.85858 .4177 m
.86319 .41542 L
s
.86319 .41542 m
.86177 .4218 L
s
.28488 .14 m
.2809 .13488 L
s
.2809 .13488 m
.28311 .13204 L
s
.28311 .13204 m
.28488 .14 L
s
.65781 .49779 m
.64666 .51214 L
s
.64666 .51214 m
.65383 .4799 L
s
.65383 .4799 m
.65781 .49779 L
s
.42579 .18659 m
.4218 .16869 L
s
.4218 .16869 m
.43473 .17508 L
s
.43473 .17508 m
.42579 .18659 L
s
.38956 .16869 m
.39532 .14284 L
s
.39532 .14284 m
.41861 .15435 L
s
.41861 .15435 m
.38956 .16869 L
s
.83876 .21244 m
.83364 .21244 L
s
.83364 .21244 m
.83529 .20504 L
s
.83529 .20504 m
.84195 .20833 L
s
.84195 .20833 m
.83876 .21244 L
s
.76313 .9296 m
.7539 .9296 L
s
.7539 .9296 m
.75276 .92448 L
s
.75276 .92448 m
.76569 .9181 L
s
.76569 .9181 m
.76313 .9296 L
s
.74878 .90659 m
.74559 .89224 L
s
.74559 .89224 m
.75055 .89863 L
s
.75055 .89863 m
.74878 .90659 L
s
.57883 .14284 m
.58025 .13645 L
s
.58025 .13645 m
.58183 .13645 L
s
.58183 .13645 m
.58281 .13772 L
s
.58281 .13772 m
.57883 .14284 L
s
.88444 .20833 m
.8833 .2089 L
s
.8833 .2089 m
.88365 .20732 L
s
.88365 .20732 m
.88444 .20833 L
s
.38558 .18659 m
.37983 .16073 L
s
.37983 .16073 m
.39276 .15435 L
s
.39276 .15435 m
.38558 .18659 L
s
.56527 .04044 m
.55952 .04328 L
s
.55952 .04328 m
.56129 .03532 L
s
.56129 .03532 m
.56527 .04044 L
s
.2809 .33147 m
.26478 .32351 L
s
.26478 .32351 m
.26975 .31712 L
s
.26975 .31712 m
.27771 .31712 L
s
.27771 .31712 m
.2809 .33147 L
s
.41861 .15435 m
.39532 .14284 L
s
.39532 .14284 m
.39851 .12849 L
s
.39851 .12849 m
.41861 .15435 L
s
.38956 .14 m
.36946 .16585 L
s
.36946 .16585 m
.34936 .14 L
s
.34936 .14 m
.35334 .12211 L
s
.35334 .12211 m
.36946 .11414 L
s
.36946 .11414 m
.38558 .12211 L
s
.38558 .12211 m
.38956 .14 L
s
.39276 .15435 m
.38558 .12211 L
s
.38558 .12211 m
.39851 .12849 L
s
.39851 .12849 m
.39276 .15435 L
s
.63054 .4397 m
.61761 .43331 L
s
.61761 .43331 m
.63771 .40746 L
s
.63771 .40746 m
.63054 .4397 L
s
.57244 .70077 m
.56129 .71512 L
s
.56129 .71512 m
.55013 .70077 L
s
.55013 .70077 m
.55234 .69084 L
s
.55234 .69084 m
.56129 .68642 L
s
.56129 .68642 m
.57023 .69084 L
s
.57023 .69084 m
.57244 .70077 L
s
.59432 .04454 m
.58856 .0417 L
s
.58856 .0417 m
.59318 .03942 L
s
.59318 .03942 m
.59432 .04454 L
s
.49504 .31712 m
.48707 .31712 L
s
.48707 .31712 m
.48786 .31358 L
s
.48786 .31358 m
.49504 .31712 L
s
.07296 .03532 m
.06898 .0302 L
s
.06898 .0302 m
.07119 .02735 L
s
.07119 .02735 m
.07296 .03532 L
s
.56527 .66853 m
.54738 .66853 L
s
.54738 .66853 m
.54119 .66057 L
s
.54119 .66057 m
.5434 .65064 L
s
.5434 .65064 m
.55234 .64622 L
s
.55234 .64622 m
.56129 .65064 L
s
.56129 .65064 m
.56527 .66853 L
s
.80943 .39595 m
.80801 .38956 L
s
.80801 .38956 m
.8144 .38956 L
s
.8144 .38956 m
.80943 .39595 L
s
.82555 .41668 m
.82492 .41953 L
s
.82492 .41953 m
.81917 .41668 L
s
.81917 .41668 m
.81775 .4103 L
s
.81775 .4103 m
.82059 .4103 L
s
.82059 .4103 m
.82555 .41668 L
s
.60468 .04966 m
.59893 .04682 L
s
.59893 .04682 m
.60354 .04454 L
s
.60354 .04454 m
.60468 .04966 L
s
.68493 .5782 m
.6757 .5782 L
s
.6757 .5782 m
.67456 .57307 L
s
.67456 .57307 m
.68288 .56897 L
s
.68288 .56897 m
.68607 .57307 L
s
.68607 .57307 m
.68493 .5782 L
s
.79012 .08702 m
.785 .08702 L
s
.785 .08702 m
.78756 .08373 L
s
.78756 .08373 m
.79012 .08702 L
s
.78295 .39879 m
.77925 .39696 L
s
.77925 .39696 m
.78181 .39367 L
s
.78181 .39367 m
.78358 .39595 L
s
.78358 .39595 m
.78295 .39879 L
s
.71114 .7215 m
.70936 .72947 L
s
.70936 .72947 m
.7068 .71796 L
s
.7068 .71796 m
.70759 .71695 L
s
.70759 .71695 m
.71114 .7215 L
s
.77002 .12109 m
.76923 .12211 L
s
.76923 .12211 m
.76797 .12211 L
s
.76797 .12211 m
.76723 .11881 L
s
.76723 .11881 m
.76797 .11845 L
s
.76797 .11845 m
.77002 .12109 L
s
.49381 .6124 m
.49228 .61044 L
s
.49228 .61044 m
.49425 .61044 L
s
.49425 .61044 m
.49381 .6124 L
s
.60468 .07268 m
.59432 .0778 L
s
.59432 .0778 m
.59175 .06629 L
s
.59175 .06629 m
.60468 .07268 L
s
.83067 .42237 m
.82953 .4218 L
s
.82953 .4218 m
.82697 .4103 L
s
.82697 .4103 m
.83194 .41668 L
s
.83194 .41668 m
.83067 .42237 L
s
.67058 .55518 m
.66995 .55234 L
s
.66995 .55234 m
.67093 .55361 L
s
.67093 .55361 m
.67058 .55518 L
s
.77798 .07141 m
.77742 .07141 L
s
.77742 .07141 m
.77719 .0704 L
s
.77719 .0704 m
.77798 .07141 L
s
.77833 .08373 m
.77754 .08475 L
s
.77754 .08475 m
.77628 .08475 L
s
.77628 .08475 m
.77514 .07962 L
s
.77514 .07962 m
.77833 .08373 L
s
.0851 .05093 m
.08411 .04966 L
s
.08411 .04966 m
.08608 .04966 L
s
.08608 .04966 m
.0851 .05093 L
s
.08908 .05605 m
.08446 .05377 L
s
.08446 .05377 m
.0851 .05093 L
s
.0851 .05093 m
.08908 .05605 L
s
.58856 .73743 m
.58139 .74097 L
s
.58139 .74097 m
.57741 .72308 L
s
.57741 .72308 m
.59033 .72947 L
s
.59033 .72947 m
.58856 .73743 L
s
.77719 .11186 m
.77628 .10776 L
s
.77628 .10776 m
.78039 .10776 L
s
.78039 .10776 m
.77719 .11186 L
s
.51888 .62478 m
.51336 .62478 L
s
.51336 .62478 m
.50717 .61682 L
s
.50717 .61682 m
.51214 .61044 L
s
.51214 .61044 m
.5201 .61044 L
s
.5201 .61044 m
.52507 .61682 L
s
.52507 .61682 m
.51888 .62478 L
s
.09944 .03816 m
.10122 .0302 L
s
.10122 .0302 m
.10343 .03304 L
s
.10343 .03304 m
.09944 .03816 L
s
.80624 .4103 m
.80049 .40746 L
s
.80049 .40746 m
.80766 .40391 L
s
.80766 .40391 m
.80624 .4103 L
s
.09802 .04454 m
.09944 .03816 L
s
.09944 .03816 m
.10299 .03816 L
s
.10299 .03816 m
.09802 .04454 L
s
.60866 .68288 m
.56846 .68288 L
s
.56846 .68288 m
.59751 .66853 L
s
.59751 .66853 m
.60866 .68288 L
s
.64666 .70873 m
.61761 .72308 L
s
.61761 .72308 m
.62656 .68288 L
s
.62656 .68288 m
.64666 .70873 L
s
.60149 .03532 m
.60007 .02893 L
s
.60007 .02893 m
.60468 .03121 L
s
.60468 .03121 m
.60149 .03532 L
s
.55411 .68288 m
.53799 .67492 L
s
.53799 .67492 m
.54296 .66853 L
s
.54296 .66853 m
.55092 .66853 L
s
.55092 .66853 m
.55411 .68288 L
s
.82953 .04454 m
.82697 .03304 L
s
.82697 .03304 m
.84565 .02381 L
s
.84565 .02381 m
.82953 .04454 L
s
.66278 .70077 m
.64666 .70873 L
s
.64666 .70873 m
.62656 .68288 L
s
.62656 .68288 m
.66278 .70077 L
s
.81917 .04966 m
.80624 .05605 L
s
.80624 .05605 m
.79331 .04966 L
s
.79331 .04966 m
.79012 .03532 L
s
.79012 .03532 m
.79907 .02381 L
s
.79907 .02381 m
.82492 .02381 L
s
.82492 .02381 m
.81917 .04966 L
s
.81661 .06117 m
.80624 .05605 L
s
.80624 .05605 m
.82953 .04454 L
s
.82953 .04454 m
.81661 .06117 L
s
.61363 .62478 m
.61044 .61044 L
s
.61044 .61044 m
.64268 .61044 L
s
.64268 .61044 m
.61363 .62478 L
s
.63054 .37522 m
.61264 .37522 L
s
.61264 .37522 m
.60645 .36725 L
s
.60645 .36725 m
.60866 .35732 L
s
.60866 .35732 m
.61761 .35291 L
s
.61761 .35291 m
.62656 .35732 L
s
.62656 .35732 m
.63054 .37522 L
s
.85744 .38956 m
.85602 .38318 L
s
.85602 .38318 m
.86063 .38546 L
s
.86063 .38546 m
.85744 .38956 L
s
.84451 .39961 m
.84246 .39696 L
s
.84246 .39696 m
.84451 .39595 L
s
.84451 .39595 m
.84657 .39696 L
s
.84657 .39696 m
.84451 .39961 L
s
.93257 .21163 m
.93194 .21244 L
s
.93194 .21244 m
.92682 .21244 L
s
.92682 .21244 m
.92732 .21016 L
s
.92732 .21016 m
.92846 .2096 L
s
.92846 .2096 m
.93257 .21163 L
s
.35284 .18431 m
.35192 .18476 L
s
.35192 .18476 m
.34936 .18147 L
s
.34936 .18147 m
.35157 .17862 L
s
.35157 .17862 m
.35284 .18431 L
s
.58714 .12849 m
.58139 .12565 L
s
.58139 .12565 m
.58856 .12211 L
s
.58856 .12211 m
.58714 .12849 L
s
.34042 .12849 m
.3358 .13077 L
s
.3358 .13077 m
.33005 .12337 L
s
.33005 .12337 m
.33324 .11926 L
s
.33324 .11926 m
.33836 .11926 L
s
.33836 .11926 m
.34042 .12849 L
s
.36946 .18431 m
.36627 .1802 L
s
.36627 .1802 m
.37266 .1802 L
s
.37266 .1802 m
.36946 .18431 L
s
.88074 .40107 m
.87561 .40107 L
s
.87561 .40107 m
.87612 .39879 L
s
.87612 .39879 m
.88188 .39595 L
s
.88188 .39595 m
.88393 .39696 L
s
.88393 .39696 m
.88074 .40107 L
s
.29844 .14923 m
.29383 .1515 L
s
.29383 .1515 m
.29781 .14638 L
s
.29781 .14638 m
.29844 .14923 L
s
.76171 .96468 m
.75851 .95034 L
s
.75851 .95034 m
.76348 .95672 L
s
.76348 .95672 m
.76171 .96468 L
s
.34361 .14284 m
.34503 .13645 L
s
.34503 .13645 m
.34661 .13645 L
s
.34661 .13645 m
.34759 .13772 L
s
.34759 .13772 m
.34361 .14284 L
s
.31093 .37718 m
.3094 .37522 L
s
.3094 .37522 m
.31137 .37522 L
s
.31137 .37522 m
.31093 .37718 L
s
.57244 .10137 m
.57564 .08702 L
s
.57564 .08702 m
.58856 .09341 L
s
.58856 .09341 m
.57244 .10137 L
s
.92271 .21244 m
.9217 .21244 L
s
.9217 .21244 m
.92271 .20788 L
s
.92271 .20788 m
.92385 .20732 L
s
.92385 .20732 m
.9259 .20833 L
s
.9259 .20833 m
.92271 .21244 L
s
.35078 .17508 m
.34617 .17736 L
s
.34617 .17736 m
.35015 .17224 L
s
.35015 .17224 m
.35078 .17508 L
s
.31712 .14 m
.31811 .13873 L
s
.31811 .13873 m
.31968 .13873 L
s
.31968 .13873 m
.31712 .14 L
s
.55553 .03816 m
.55582 .03689 L
s
.55582 .03689 m
.55652 .03689 L
s
.55652 .03689 m
.55553 .03816 L
s
.3554 .1876 m
.35448 .18715 L
s
.35448 .18715 m
.3554 .18304 L
s
.3554 .18304 m
.35697 .18304 L
s
.35697 .18304 m
.35796 .18431 L
s
.35796 .18431 m
.3554 .1876 L
s
.55297 .02665 m
.55332 .02507 L
s
.55332 .02507 m
.55376 .02564 L
s
.55376 .02564 m
.55297 .02665 L
s
.25441 .31839 m
.25328 .31782 L
s
.25328 .31782 m
.25382 .31712 L
s
.25382 .31712 m
.2547 .31712 L
s
.2547 .31712 m
.25441 .31839 L
s
.29702 .15561 m
.29604 .15435 L
s
.29604 .15435 m
.298 .15435 L
s
.298 .15435 m
.29702 .15561 L
s
.301 .16073 m
.29639 .15845 L
s
.29639 .15845 m
.29702 .15561 L
s
.29702 .15561 m
.301 .16073 L
s
.23396 .28134 m
.22679 .28488 L
s
.22679 .28488 m
.22281 .26699 L
s
.22281 .26699 m
.23573 .27338 L
s
.23573 .27338 m
.23396 .28134 L
s
.36052 .15435 m
.3554 .15435 L
s
.3554 .15435 m
.35654 .14923 L
s
.35654 .14923 m
.36052 .15435 L
s
.33943 .38515 m
.336 .38956 L
s
.336 .38956 m
.33049 .38956 L
s
.33049 .38956 m
.3243 .3816 L
s
.3243 .3816 m
.32926 .37522 L
s
.32926 .37522 m
.33722 .37522 L
s
.33722 .37522 m
.33943 .38515 L
s
.32351 .14 m
.31712 .14 L
s
.31712 .14 m
.3243 .13645 L
s
.3243 .13645 m
.32351 .14 L
s
.31137 .14284 m
.31314 .13488 L
s
.31314 .13488 m
.31535 .13772 L
s
.31535 .13772 m
.31137 .14284 L
s
.30306 .16175 m
.30214 .16129 L
s
.30214 .16129 m
.30341 .15561 L
s
.30341 .15561 m
.30562 .15845 L
s
.30562 .15845 m
.30306 .16175 L
s
.34105 .13133 m
.3414 .12976 L
s
.3414 .12976 m
.34184 .13032 L
s
.34184 .13032 m
.34105 .13133 L
s
.29958 .37648 m
.29844 .37592 L
s
.29844 .37592 m
.29899 .37522 L
s
.29899 .37522 m
.29986 .37522 L
s
.29986 .37522 m
.29958 .37648 L
s
.31491 .39114 m
.31314 .39027 L
s
.31314 .39027 m
.31437 .38869 L
s
.31437 .38869 m
.31491 .39114 L
s
.84451 .2096 m
.84338 .21016 L
s
.84338 .21016 m
.84309 .2089 L
s
.84309 .2089 m
.84451 .2096 L
s
.24468 .12976 m
.2437 .12849 L
s
.2437 .12849 m
.24566 .12849 L
s
.24566 .12849 m
.24468 .12976 L
s
.60866 .40195 m
.60645 .40304 L
s
.60645 .40304 m
.60424 .40195 L
s
.60424 .40195 m
.6037 .39949 L
s
.6037 .39949 m
.60523 .39753 L
s
.60523 .39753 m
.60768 .39753 L
s
.60768 .39753 m
.60921 .39949 L
s
.60921 .39949 m
.60866 .40195 L
s
.86 .40107 m
.85488 .40107 L
s
.85488 .40107 m
.85602 .39595 L
s
.85602 .39595 m
.86 .40107 L
s
.30995 .14923 m
.31137 .14284 L
s
.31137 .14284 m
.31491 .14284 L
s
.31491 .14284 m
.30995 .14923 L
s
.70042 .67649 m
.69786 .67776 L
s
.69786 .67776 m
.69644 .67137 L
s
.69644 .67137 m
.70042 .66625 L
s
.70042 .66625 m
.70219 .66853 L
s
.70219 .66853 m
.70042 .67649 L
s
.62222 .10548 m
.62336 .10036 L
s
.62336 .10036 m
.62798 .10264 L
s
.62798 .10264 m
.62222 .10548 L
s
.0471 .03532 m
.04249 .03304 L
s
.04249 .03304 m
.04454 .02381 L
s
.04454 .02381 m
.04966 .02381 L
s
.04966 .02381 m
.05286 .02792 L
s
.05286 .02792 m
.0471 .03532 L
s
.56988 .02792 m
.56897 .02381 L
s
.56897 .02381 m
.57307 .02381 L
s
.57307 .02381 m
.56988 .02792 L
s
.7044 .68161 m
.69928 .68414 L
s
.69928 .68414 m
.699 .68288 L
s
.699 .68288 m
.70617 .67365 L
s
.70617 .67365 m
.7044 .68161 L
s
.02637 .02507 m
.02381 .02381 L
s
.02381 .02381 m
.02539 .02381 L
s
.02539 .02381 m
.02637 .02507 L
s
.55325 .02426 m
.55234 .02381 L
s
.55234 .02381 m
.55361 .02381 L
s
.55361 .02381 m
.55325 .02426 L
s
.5635 .03247 m
.56271 .03349 L
s
.56271 .03349 m
.55809 .03121 L
s
.55809 .03121 m
.56321 .03121 L
s
.56321 .03121 m
.5635 .03247 L
s
.68828 .61485 m
.68863 .61328 L
s
.68863 .61328 m
.69005 .61398 L
s
.69005 .61398 m
.68828 .61485 L
s
.82953 .04454 m
.81917 .04966 L
s
.81917 .04966 m
.82492 .02381 L
s
.82492 .02381 m
.82953 .04454 L
s
.81661 .06117 m
.79793 .0704 L
s
.79793 .0704 m
.79331 .04966 L
s
.79331 .04966 m
.81661 .06117 L
s
.61505 .09625 m
.6093 .09341 L
s
.6093 .09341 m
.61391 .09113 L
s
.61391 .09113 m
.61505 .09625 L
s
.5402 .31074 m
.53843 .30277 L
s
.53843 .30277 m
.5434 .29639 L
s
.5434 .29639 m
.55632 .30277 L
s
.55632 .30277 m
.5402 .31074 L
s
.61761 .64268 m
.61363 .62478 L
s
.61363 .62478 m
.64268 .61044 L
s
.64268 .61044 m
.61761 .64268 L
s
.80049 .0819 m
.79793 .0704 L
s
.79793 .0704 m
.80943 .0704 L
s
.80943 .0704 m
.80049 .0819 L
s
.60149 .65064 m
.58139 .66057 L
s
.58139 .66057 m
.56129 .65064 L
s
.56129 .65064 m
.55632 .62833 L
s
.55632 .62833 m
.57023 .61044 L
s
.57023 .61044 m
.59254 .61044 L
s
.59254 .61044 m
.60645 .62833 L
s
.60645 .62833 m
.60149 .65064 L
s
.61761 .64268 m
.60149 .65064 L
s
.60149 .65064 m
.61044 .61044 L
s
.61044 .61044 m
.61761 .64268 L
s
.58139 .67649 m
.56846 .68288 L
s
.56846 .68288 m
.56129 .65064 L
s
.56129 .65064 m
.58139 .67649 L
s
.69403 .66057 m
.67669 .68288 L
s
.67669 .68288 m
.64887 .68288 L
s
.64887 .68288 m
.63152 .66057 L
s
.63152 .66057 m
.63771 .63275 L
s
.63771 .63275 m
.66278 .62036 L
s
.66278 .62036 m
.68784 .63275 L
s
.68784 .63275 m
.69403 .66057 L
s
.73301 .46555 m
.7191 .44766 L
s
.7191 .44766 m
.73699 .44766 L
s
.73699 .44766 m
.73301 .46555 L
s
.77542 .40391 m
.75532 .42977 L
s
.75532 .42977 m
.76427 .38956 L
s
.76427 .38956 m
.77542 .40391 L
s
.75532 .38515 m
.73522 .37522 L
s
.73522 .37522 m
.75311 .37522 L
s
.75311 .37522 m
.75532 .38515 L
s
.76028 .40746 m
.73522 .37522 L
s
.73522 .37522 m
.75532 .38515 L
s
.75532 .38515 m
.76028 .40746 L
s
.59254 .61044 m
.56472 .61044 L
s
.56472 .61044 m
.57244 .60051 L
s
.57244 .60051 m
.59254 .61044 L
s
.74637 .38956 m
.70617 .38956 L
s
.70617 .38956 m
.72627 .37964 L
s
.72627 .37964 m
.74637 .38956 L
s
.33324 .03177 m
.32705 .02381 L
s
.32705 .02381 m
.34936 .02381 L
s
.34936 .02381 m
.33324 .03177 L
s
.699 .4218 m
.70396 .39949 L
s
.70396 .39949 m
.72406 .38956 L
s
.72406 .38956 m
.699 .4218 L
s
.78039 .05605 m
.76427 .03532 L
s
.76427 .03532 m
.77463 .0302 L
s
.77463 .0302 m
.78039 .05605 L
s
.7191 .44766 m
.699 .4218 L
s
.699 .4218 m
.71015 .40746 L
s
.71015 .40746 m
.7191 .44766 L
s
.23893 .11414 m
.22281 .10618 L
s
.22281 .10618 m
.24291 .09625 L
s
.24291 .09625 m
.23893 .11414 L
s
.80943 .35448 m
.81838 .34298 L
s
.81838 .34298 m
.83273 .34298 L
s
.83273 .34298 m
.80943 .35448 L
s
.75532 .93599 m
.74416 .95034 L
s
.74416 .95034 m
.73301 .93599 L
s
.73301 .93599 m
.73522 .92606 L
s
.73522 .92606 m
.74416 .92164 L
s
.74416 .92164 m
.75311 .92606 L
s
.75311 .92606 m
.75532 .93599 L
s
.61044 .28488 m
.60468 .28204 L
s
.60468 .28204 m
.60866 .27692 L
s
.60866 .27692 m
.61044 .28488 L
s
.5836 .27338 m
.57564 .27338 L
s
.57564 .27338 m
.57962 .26826 L
s
.57962 .26826 m
.5836 .27338 L
s
.74815 .90375 m
.73025 .90375 L
s
.73025 .90375 m
.72406 .89579 L
s
.72406 .89579 m
.72627 .88586 L
s
.72627 .88586 m
.73522 .88144 L
s
.73522 .88144 m
.74416 .88586 L
s
.74416 .88586 m
.74815 .90375 L
s
.59751 .29127 m
.59609 .28488 L
s
.59609 .28488 m
.60247 .28488 L
s
.60247 .28488 m
.59751 .29127 L
s
.57102 .29411 m
.56732 .29228 L
s
.56732 .29228 m
.56988 .28899 L
s
.56988 .28899 m
.57165 .29127 L
s
.57165 .29127 m
.57102 .29411 L
s
.60965 .26541 m
.60787 .27338 L
s
.60787 .27338 m
.60531 .26187 L
s
.60531 .26187 m
.6061 .26086 L
s
.6061 .26086 m
.60965 .26541 L
s
.07615 .08545 m
.07154 .08317 L
s
.07154 .08317 m
.07182 .0819 L
s
.07182 .0819 m
.07891 .0819 L
s
.07891 .0819 m
.07615 .08545 L
s
.72229 .22395 m
.71192 .22907 L
s
.71192 .22907 m
.70936 .21756 L
s
.70936 .21756 m
.72229 .22395 L
s
.80943 .56385 m
.80049 .55234 L
s
.80049 .55234 m
.80368 .54823 L
s
.80368 .54823 m
.81199 .55234 L
s
.81199 .55234 m
.80943 .56385 L
s
.08632 .05959 m
.08013 .06756 L
s
.08013 .06756 m
.0672 .06117 L
s
.0672 .06117 m
.07615 .04966 L
s
.07615 .04966 m
.0851 .05408 L
s
.0851 .05408 m
.08632 .05959 L
s
.11414 .10421 m
.1052 .0998 L
s
.1052 .0998 m
.11316 .0998 L
s
.11316 .0998 m
.11414 .10421 L
s
.59432 .30562 m
.58856 .30277 L
s
.58856 .30277 m
.59574 .29923 L
s
.59574 .29923 m
.59432 .30562 L
s
.1052 .0998 m
.09802 .09625 L
s
.09802 .09625 m
.10795 .09625 L
s
.10795 .09625 m
.1052 .0998 L
s
.64808 .44127 m
.64552 .44254 L
s
.64552 .44254 m
.6441 .43615 L
s
.6441 .43615 m
.64808 .43103 L
s
.64808 .43103 m
.64985 .43331 L
s
.64985 .43331 m
.64808 .44127 L
s
.83131 .51726 m
.82953 .51498 L
s
.82953 .51498 m
.83273 .51087 L
s
.83273 .51087 m
.83131 .51726 L
s
.85106 .49298 m
.84388 .49653 L
s
.84388 .49653 m
.85283 .48502 L
s
.85283 .48502 m
.85106 .49298 L
s
.68111 .18374 m
.68032 .18476 L
s
.68032 .18476 m
.6757 .18248 L
s
.6757 .18248 m
.68082 .18248 L
s
.68082 .18248 m
.68111 .18374 L
s
.63594 .37964 m
.63629 .37806 L
s
.63629 .37806 m
.63771 .37876 L
s
.63771 .37876 m
.63594 .37964 L
s
.73727 .2498 m
.72691 .24468 L
s
.72691 .24468 m
.73983 .23829 L
s
.73983 .23829 m
.73727 .2498 L
s
.70396 .88586 m
.69403 .88586 L
s
.69403 .88586 m
.68784 .87789 L
s
.68784 .87789 m
.69005 .86796 L
s
.69005 .86796 m
.699 .86355 L
s
.699 .86355 m
.71512 .87151 L
s
.71512 .87151 m
.70396 .88586 L
s
.63594 .29923 m
.62798 .29923 L
s
.62798 .29923 m
.63196 .29411 L
s
.63196 .29411 m
.63594 .29923 L
s
.62336 .31996 m
.61966 .31814 L
s
.61966 .31814 m
.62222 .31484 L
s
.62222 .31484 m
.62399 .31712 L
s
.62399 .31712 m
.62336 .31996 L
s
.62222 .32508 m
.61966 .32635 L
s
.61966 .32635 m
.61824 .31996 L
s
.61824 .31996 m
.61966 .31814 L
s
.61966 .31814 m
.62336 .31996 L
s
.62336 .31996 m
.62222 .32508 L
s
.68749 .18943 m
.68863 .18431 L
s
.68863 .18431 m
.69324 .18659 L
s
.69324 .18659 m
.68749 .18943 L
s
.6642 .36883 m
.65958 .37111 L
s
.65958 .37111 m
.65383 .36371 L
s
.65383 .36371 m
.65702 .3596 L
s
.65702 .3596 m
.66534 .36371 L
s
.66534 .36371 m
.6642 .36883 L
s
.74559 .25391 m
.74467 .2498 L
s
.74467 .2498 m
.74878 .2498 L
s
.74878 .2498 m
.74559 .25391 L
s
.61186 .2785 m
.6093 .27976 L
s
.6093 .27976 m
.60787 .27338 L
s
.60787 .27338 m
.61186 .26826 L
s
.61186 .26826 m
.61363 .27053 L
s
.61363 .27053 m
.61186 .2785 L
s
.0819 .08829 m
.08332 .0819 L
s
.08332 .0819 m
.08687 .0819 L
s
.08687 .0819 m
.0819 .08829 L
s
.81484 .53957 m
.80766 .54311 L
s
.80766 .54311 m
.81661 .53161 L
s
.81661 .53161 m
.81484 .53957 L
s
.76249 .28843 m
.76171 .28944 L
s
.76171 .28944 m
.75709 .28716 L
s
.75709 .28716 m
.76221 .28716 L
s
.76221 .28716 m
.76249 .28843 L
s
.48928 .04612 m
.48963 .04454 L
s
.48963 .04454 m
.49105 .04524 L
s
.49105 .04524 m
.48928 .04612 L
s
.70822 .21244 m
.69786 .20732 L
s
.69786 .20732 m
.71079 .20093 L
s
.71079 .20093 m
.70822 .21244 L
s
.6262 .33021 m
.62108 .33274 L
s
.62108 .33274 m
.6208 .33147 L
s
.6208 .33147 m
.62798 .32224 L
s
.62798 .32224 m
.6262 .33021 L
s
.6696 .34455 m
.66818 .34526 L
s
.66818 .34526 m
.66995 .34298 L
s
.66995 .34298 m
.6696 .34455 L
s
.72896 .25025 m
.72804 .2498 L
s
.72804 .2498 m
.72931 .2498 L
s
.72931 .2498 m
.72896 .25025 L
s
.7392 .25847 m
.73841 .25948 L
s
.73841 .25948 m
.7338 .2572 L
s
.7338 .2572 m
.73892 .2572 L
s
.73892 .2572 m
.7392 .25847 L
s
.07792 .08632 m
.07615 .08545 L
s
.07615 .08545 m
.07738 .08387 L
s
.07738 .08387 m
.07792 .08632 L
s
.07615 .08545 m
.07296 .08702 L
s
.07296 .08702 m
.06898 .0819 L
s
.06898 .0819 m
.07615 .08545 L
s
.58139 .27053 m
.57741 .26541 L
s
.57741 .26541 m
.57883 .25903 L
s
.57883 .25903 m
.59033 .25903 L
s
.59033 .25903 m
.58139 .27053 L
s
.75965 .27566 m
.75595 .27383 L
s
.75595 .27383 m
.75851 .27053 L
s
.75851 .27053 m
.75965 .27566 L
s
.47813 .04454 m
.47095 .04809 L
s
.47095 .04809 m
.46697 .04612 L
s
.46697 .04612 m
.46599 .0417 L
s
.46599 .0417 m
.47095 .03532 L
s
.47095 .03532 m
.47671 .03816 L
s
.47671 .03816 m
.47813 .04454 L
s
.66499 .34936 m
.6642 .34582 L
s
.6642 .34582 m
.66995 .34298 L
s
.66995 .34298 m
.66499 .34936 L
s
.08731 .06401 m
.09227 .05763 L
s
.09227 .05763 m
.09625 .05959 L
s
.09625 .05959 m
.08731 .06401 L
s
.06799 .08064 m
.0672 .07962 L
s
.0672 .07962 m
.0704 .07552 L
s
.0704 .07552 m
.07438 .07748 L
s
.07438 .07748 m
.06799 .08064 L
s
.76398 .29512 m
.76284 .29456 L
s
.76284 .29456 m
.76386 .29456 L
s
.76386 .29456 m
.76398 .29512 L
s
.49874 .04966 m
.49772 .04966 L
s
.49772 .04966 m
.49795 .04865 L
s
.49795 .04865 m
.49858 .04896 L
s
.49858 .04896 m
.49874 .04966 L
s
.48325 .05478 m
.48167 .05478 L
s
.48167 .05478 m
.4829 .05321 L
s
.4829 .05321 m
.48325 .05478 L
s
.64709 .42977 m
.64552 .42977 L
s
.64552 .42977 m
.64587 .42819 L
s
.64587 .42819 m
.64709 .42977 L
s
.12309 .14442 m
.12132 .14354 L
s
.12132 .14354 m
.12254 .14196 L
s
.12254 .14196 m
.12309 .14442 L
s
.72131 .90817 m
.7191 .90926 L
s
.7191 .90926 m
.71689 .90817 L
s
.71689 .90817 m
.71634 .90571 L
s
.71634 .90571 m
.71787 .90375 L
s
.71787 .90375 m
.72032 .90375 L
s
.72032 .90375 m
.72185 .90571 L
s
.72185 .90571 m
.72131 .90817 L
s
.6208 .30277 m
.61505 .30562 L
s
.61505 .30562 m
.61363 .29923 L
s
.61363 .29923 m
.6208 .30277 L
s
.08731 .06401 m
.08013 .06756 L
s
.08013 .06756 m
.08632 .05959 L
s
.08632 .05959 m
.08731 .06401 L
s
.7392 .86355 m
.72804 .87789 L
s
.72804 .87789 m
.73522 .84565 L
s
.73522 .84565 m
.7392 .86355 L
s
.59751 .22679 m
.58139 .21883 L
s
.58139 .21883 m
.59432 .21244 L
s
.59432 .21244 m
.59751 .22679 L
s
.56129 .24468 m
.54517 .22395 L
s
.54517 .22395 m
.56846 .21244 L
s
.56846 .21244 m
.56129 .24468 L
s
.68032 .1802 m
.67456 .17736 L
s
.67456 .17736 m
.67918 .17508 L
s
.67918 .17508 m
.68032 .1802 L
s
.70298 .89736 m
.70121 .8894 L
s
.70121 .8894 m
.70617 .88301 L
s
.70617 .88301 m
.7191 .8894 L
s
.7191 .8894 m
.70298 .89736 L
s
.57244 .25903 m
.54915 .24752 L
s
.54915 .24752 m
.55234 .23317 L
s
.55234 .23317 m
.57244 .25903 L
s
.54517 .22395 m
.53622 .21244 L
s
.53622 .21244 m
.56846 .21244 L
s
.56846 .21244 m
.54517 .22395 L
s
.54659 .25903 m
.51435 .25903 L
s
.51435 .25903 m
.50319 .24468 L
s
.50319 .24468 m
.50717 .22679 L
s
.50717 .22679 m
.52329 .21883 L
s
.52329 .21883 m
.53941 .22679 L
s
.53941 .22679 m
.54659 .25903 L
s
.55234 .23317 m
.52329 .21883 L
s
.52329 .21883 m
.53622 .21244 L
s
.53622 .21244 m
.55234 .23317 L
s
.71192 .80545 m
.699 .79907 L
s
.699 .79907 m
.7191 .77321 L
s
.7191 .77321 m
.71192 .80545 L
s
.87293 .48786 m
.86576 .49141 L
s
.86576 .49141 m
.85858 .48786 L
s
.85858 .48786 m
.85681 .4799 L
s
.85681 .4799 m
.86576 .46839 L
s
.86576 .46839 m
.8747 .4799 L
s
.8747 .4799 m
.87293 .48786 L
s
.72804 .21655 m
.72485 .21244 L
s
.72485 .21244 m
.73124 .21244 L
s
.73124 .21244 m
.72804 .21655 L
s
.73983 .23829 m
.73841 .23191 L
s
.73841 .23191 m
.74303 .23419 L
s
.74303 .23419 m
.73983 .23829 L
s
.86576 .5201 m
.85858 .52364 L
s
.85858 .52364 m
.85141 .5201 L
s
.85141 .5201 m
.84964 .51214 L
s
.84964 .51214 m
.8546 .50575 L
s
.8546 .50575 m
.86895 .50575 L
s
.86895 .50575 m
.86576 .5201 L
s
.72741 .22395 m
.72229 .22395 L
s
.72229 .22395 m
.72627 .21883 L
s
.72627 .21883 m
.72741 .22395 L
s
.72691 .24834 m
.72485 .24569 L
s
.72485 .24569 m
.72691 .24468 L
s
.72691 .24468 m
.72896 .24569 L
s
.72896 .24569 m
.72691 .24834 L
s
.74394 .21163 m
.74331 .21244 L
s
.74331 .21244 m
.73408 .21244 L
s
.73408 .21244 m
.73983 .2096 L
s
.73983 .2096 m
.74394 .21163 L
s
.56476 .28899 m
.56385 .28944 L
s
.56385 .28944 m
.56129 .28615 L
s
.56129 .28615 m
.5635 .28331 L
s
.5635 .28331 m
.56476 .28899 L
s
.63692 .37522 m
.62798 .36371 L
s
.62798 .36371 m
.6409 .35732 L
s
.6409 .35732 m
.63692 .37522 L
s
.54773 .02609 m
.54596 .02381 L
s
.54596 .02381 m
.55234 .02381 L
s
.55234 .02381 m
.54773 .02609 L
s
.97363 .03532 m
.96788 .02792 L
s
.96788 .02792 m
.97107 .02381 L
s
.97107 .02381 m
.97619 .02381 L
s
.97619 .02381 m
.97363 .03532 L
s
.58856 .27976 m
.58139 .28899 L
s
.58139 .28899 m
.57421 .27976 L
s
.57421 .27976 m
.57918 .27338 L
s
.57918 .27338 m
.5836 .27338 L
s
.5836 .27338 m
.58856 .27976 L
s
.54517 .26541 m
.5402 .25903 L
s
.5402 .25903 m
.54375 .25903 L
s
.54375 .25903 m
.54517 .26541 L
s
.71512 .23317 m
.71192 .22907 L
s
.71192 .22907 m
.71654 .22679 L
s
.71654 .22679 m
.71512 .23317 L
s
.54915 .27053 m
.54517 .26541 L
s
.54517 .26541 m
.54738 .26257 L
s
.54738 .26257 m
.54915 .27053 L
s
.67968 .85716 m
.67172 .85716 L
s
.67172 .85716 m
.66676 .85077 L
s
.66676 .85077 m
.66995 .8492 L
s
.66995 .8492 m
.6789 .85362 L
s
.6789 .85362 m
.67968 .85716 L
s
.51037 .04454 m
.50575 .04682 L
s
.50575 .04682 m
.50973 .0417 L
s
.50973 .0417 m
.51037 .04454 L
s
.47671 .06117 m
.48167 .05478 L
s
.48167 .05478 m
.48963 .05478 L
s
.48963 .05478 m
.47671 .06117 L
s
.6441 .43615 m
.64552 .42977 L
s
.64552 .42977 m
.64709 .42977 L
s
.64709 .42977 m
.64808 .43103 L
s
.64808 .43103 m
.6441 .43615 L
s
.72087 .91013 m
.7191 .90926 L
s
.7191 .90926 m
.72131 .90817 L
s
.72131 .90817 m
.72087 .91013 L
s
.6409 .32863 m
.62478 .33659 L
s
.62478 .33659 m
.62798 .32224 L
s
.62798 .32224 m
.6409 .32863 L
s
.84246 .53161 m
.82953 .53799 L
s
.82953 .53799 m
.82236 .53445 L
s
.82236 .53445 m
.82059 .52649 L
s
.82059 .52649 m
.82555 .5201 L
s
.82555 .5201 m
.83352 .5201 L
s
.83352 .5201 m
.84246 .53161 L
s
.71079 .20093 m
.70936 .19455 L
s
.70936 .19455 m
.71398 .19683 L
s
.71398 .19683 m
.71079 .20093 L
s
.69786 .21097 m
.6958 .20833 L
s
.6958 .20833 m
.69786 .20732 L
s
.69786 .20732 m
.69991 .20833 L
s
.69991 .20833 m
.69786 .21097 L
s
.76363 .97335 m
.76206 .97335 L
s
.76206 .97335 m
.75709 .96696 L
s
.75709 .96696 m
.76028 .96539 L
s
.76028 .96539 m
.76206 .96626 L
s
.76206 .96626 m
.76363 .97335 L
s
.6171 .31484 m
.61619 .31529 L
s
.61619 .31529 m
.61363 .312 L
s
.61363 .312 m
.61584 .30916 L
s
.61584 .30916 m
.6171 .31484 L
s
.65241 .4218 m
.64666 .41896 L
s
.64666 .41896 m
.65383 .41542 L
s
.65383 .41542 m
.65241 .4218 L
s
.60468 .25903 m
.60007 .26131 L
s
.60007 .26131 m
.59432 .25391 L
s
.59432 .25391 m
.59751 .2498 L
s
.59751 .2498 m
.60263 .2498 L
s
.60263 .2498 m
.60468 .25903 L
s
.63373 .31484 m
.63054 .31074 L
s
.63054 .31074 m
.63692 .31074 L
s
.63692 .31074 m
.63373 .31484 L
s
.73408 .21244 m
.72896 .21244 L
s
.72896 .21244 m
.72947 .21016 L
s
.72947 .21016 m
.73522 .20732 L
s
.73522 .20732 m
.73727 .20833 L
s
.73727 .20833 m
.73408 .21244 L
s
.56271 .27976 m
.55809 .28204 L
s
.55809 .28204 m
.56208 .27692 L
s
.56208 .27692 m
.56271 .27976 L
s
.52905 .03532 m
.53401 .02893 L
s
.53401 .02893 m
.54197 .02893 L
s
.54197 .02893 m
.52905 .03532 L
s
.60787 .27338 m
.6093 .26699 L
s
.6093 .26699 m
.61087 .26699 L
s
.61087 .26699 m
.61186 .26826 L
s
.61186 .26826 m
.60787 .27338 L
s
.08289 .08387 m
.08136 .0819 L
s
.08136 .0819 m
.08332 .0819 L
s
.08332 .0819 m
.08289 .08387 L
s
.63771 .39469 m
.6409 .38034 L
s
.6409 .38034 m
.65383 .38672 L
s
.65383 .38672 m
.63771 .39469 L
s
.76107 .96184 m
.75311 .96184 L
s
.75311 .96184 m
.75213 .96058 L
s
.75213 .96058 m
.75851 .95742 L
s
.75851 .95742 m
.76028 .9583 L
s
.76028 .9583 m
.76107 .96184 L
s
.61505 .30562 m
.61044 .3079 L
s
.61044 .3079 m
.61442 .30277 L
s
.61442 .30277 m
.61505 .30562 L
s
.58139 .27053 m
.58237 .26927 L
s
.58237 .26927 m
.58395 .26927 L
s
.58395 .26927 m
.58139 .27053 L
s
.6208 .33147 m
.62108 .33021 L
s
.62108 .33021 m
.62179 .33021 L
s
.62179 .33021 m
.6208 .33147 L
s
.61966 .31814 m
.61875 .31769 L
s
.61875 .31769 m
.61966 .31358 L
s
.61966 .31358 m
.62124 .31358 L
s
.62124 .31358 m
.62222 .31484 L
s
.62222 .31484 m
.61966 .31814 L
s
.61824 .31996 m
.61875 .31769 L
s
.61875 .31769 m
.61966 .31814 L
s
.61966 .31814 m
.61824 .31996 L
s
.56129 .28615 m
.5603 .28488 L
s
.5603 .28488 m
.56227 .28488 L
s
.56227 .28488 m
.56129 .28615 L
s
.56527 .29127 m
.56065 .28899 L
s
.56065 .28899 m
.56129 .28615 L
s
.56129 .28615 m
.56527 .29127 L
s
.7502 .23317 m
.74559 .23545 L
s
.74559 .23545 m
.74097 .23317 L
s
.74097 .23317 m
.74815 .22395 L
s
.74815 .22395 m
.7502 .23317 L
s
.62478 .28488 m
.61966 .28488 L
s
.61966 .28488 m
.6208 .27976 L
s
.6208 .27976 m
.62478 .28488 L
s
.11139 .09183 m
.10795 .09625 L
s
.10795 .09625 m
.10244 .09625 L
s
.10244 .09625 m
.09625 .08829 L
s
.09625 .08829 m
.10122 .0819 L
s
.10122 .0819 m
.10918 .0819 L
s
.10918 .0819 m
.11139 .09183 L
s
.58777 .27053 m
.58139 .27053 L
s
.58139 .27053 m
.58856 .26699 L
s
.58856 .26699 m
.58777 .27053 L
s
.57564 .27338 m
.57741 .26541 L
s
.57741 .26541 m
.57962 .26826 L
s
.57962 .26826 m
.57564 .27338 L
s
.56732 .29228 m
.56641 .29183 L
s
.56641 .29183 m
.56767 .28615 L
s
.56767 .28615 m
.56988 .28899 L
s
.56988 .28899 m
.56732 .29228 L
s
.60531 .26187 m
.60567 .26029 L
s
.60567 .26029 m
.6061 .26086 L
s
.6061 .26086 m
.60531 .26187 L
s
.07154 .08317 m
.0704 .08261 L
s
.0704 .08261 m
.07094 .0819 L
s
.07094 .0819 m
.07182 .0819 L
s
.07182 .0819 m
.07154 .08317 L
s
.08687 .09783 m
.0851 .09695 L
s
.0851 .09695 m
.08632 .09538 L
s
.08632 .09538 m
.08687 .09783 L
s
.68067 .86158 m
.6789 .8607 L
s
.6789 .8607 m
.68012 .85913 L
s
.68012 .85913 m
.68067 .86158 L
s
.50895 .26029 m
.50796 .25903 L
s
.50796 .25903 m
.50993 .25903 L
s
.50993 .25903 m
.50895 .26029 L
s
.84786 .50418 m
.84664 .50575 L
s
.84664 .50575 m
.84467 .50575 L
s
.84467 .50575 m
.84344 .50418 L
s
.84344 .50418 m
.84388 .50221 L
s
.84388 .50221 m
.84565 .50133 L
s
.84565 .50133 m
.84743 .50221 L
s
.84743 .50221 m
.84786 .50418 L
s
.71335 .21244 m
.70822 .21244 L
s
.70822 .21244 m
.70936 .20732 L
s
.70936 .20732 m
.71335 .21244 L
s
.57421 .27976 m
.57564 .27338 L
s
.57564 .27338 m
.57918 .27338 L
s
.57918 .27338 m
.57421 .27976 L
s
.59751 .48786 m
.58635 .50221 L
s
.58635 .50221 m
.56129 .46997 L
s
.56129 .46997 m
.59751 .48786 L
s
.31314 .0417 m
.29923 .02381 L
s
.29923 .02381 m
.31712 .02381 L
s
.31712 .02381 m
.31314 .0417 L
s
.76427 .03532 m
.77321 .02381 L
s
.77321 .02381 m
.78756 .02381 L
s
.78756 .02381 m
.76427 .03532 L
s
.72485 .91525 m
.71689 .91525 L
s
.71689 .91525 m
.71192 .90887 L
s
.71192 .90887 m
.71512 .90729 L
s
.71512 .90729 m
.72406 .91171 L
s
.72406 .91171 m
.72485 .91525 L
s
.61619 .25903 m
.61044 .25619 L
s
.61044 .25619 m
.61761 .25264 L
s
.61761 .25264 m
.61619 .25903 L
s
.45803 .0704 m
.45341 .07268 L
s
.45341 .07268 m
.44766 .06528 L
s
.44766 .06528 m
.45085 .06117 L
s
.45085 .06117 m
.45597 .06117 L
s
.45597 .06117 m
.45803 .0704 L
s
.64666 .37294 m
.64346 .36883 L
s
.64346 .36883 m
.64985 .36883 L
s
.64985 .36883 m
.64666 .37294 L
s
.72229 .90375 m
.70794 .90375 L
s
.70794 .90375 m
.70696 .90248 L
s
.70696 .90248 m
.71335 .89933 L
s
.71335 .89933 m
.72229 .90375 L
s
.43473 .0819 m
.43572 .08064 L
s
.43572 .08064 m
.43729 .08064 L
s
.43729 .08064 m
.43473 .0819 L
s
.63373 .38956 m
.63401 .3883 L
s
.63401 .3883 m
.63471 .3883 L
s
.63471 .3883 m
.63373 .38956 L
s
.63117 .37806 m
.63259 .37167 L
s
.63259 .37167 m
.63417 .37167 L
s
.63417 .37167 m
.63515 .37294 L
s
.63515 .37294 m
.63117 .37806 L
s
.61363 .312 m
.61264 .31074 L
s
.61264 .31074 m
.61461 .31074 L
s
.61461 .31074 m
.61363 .312 L
s
.15257 .09625 m
.11237 .09625 L
s
.11237 .09625 m
.14142 .0819 L
s
.14142 .0819 m
.15257 .09625 L
s
.19057 .12211 m
.16152 .13645 L
s
.16152 .13645 m
.17047 .09625 L
s
.17047 .09625 m
.19057 .12211 L
s
.61761 .27566 m
.61186 .2785 L
s
.61186 .2785 m
.61363 .27053 L
s
.61363 .27053 m
.61761 .27566 L
s
.09802 .09625 m
.0819 .08829 L
s
.0819 .08829 m
.08687 .0819 L
s
.08687 .0819 m
.09483 .0819 L
s
.09483 .0819 m
.09802 .09625 L
s
.7191 .44766 m
.6958 .43615 L
s
.6958 .43615 m
.699 .4218 L
s
.699 .4218 m
.7191 .44766 L
s
.20669 .11414 m
.19057 .12211 L
s
.19057 .12211 m
.18659 .10421 L
s
.18659 .10421 m
.20669 .11414 L
s
.69005 .43331 m
.6789 .44766 L
s
.6789 .44766 m
.661 .44766 L
s
.661 .44766 m
.64985 .43331 L
s
.64985 .43331 m
.65383 .41542 L
s
.65383 .41542 m
.66995 .40746 L
s
.66995 .40746 m
.68607 .41542 L
s
.68607 .41542 m
.69005 .43331 L
s
.69324 .44766 m
.68607 .41542 L
s
.68607 .41542 m
.699 .4218 L
s
.699 .4218 m
.69324 .44766 L
s
.65383 .41542 m
.65958 .38956 L
s
.65958 .38956 m
.66995 .39469 L
s
.66995 .39469 m
.65383 .41542 L
s
.75532 .42977 m
.73522 .4397 L
s
.73522 .4397 m
.71512 .42977 L
s
.71512 .42977 m
.71015 .40746 L
s
.71015 .40746 m
.72406 .38956 L
s
.72406 .38956 m
.74637 .38956 L
s
.74637 .38956 m
.76028 .40746 L
s
.76028 .40746 m
.75532 .42977 L
s
.3243 .05605 m
.32032 .03816 L
s
.32032 .03816 m
.33821 .03816 L
s
.33821 .03816 m
.3243 .05605 L
s
.78039 .05605 m
.77463 .0302 L
s
.77463 .0302 m
.78756 .02381 L
s
.78756 .02381 m
.78039 .05605 L
s
.25185 .05605 m
.24787 .03816 L
s
.24787 .03816 m
.27692 .02381 L
s
.27692 .02381 m
.25185 .05605 L
s
.78039 .31712 m
.76923 .30277 L
s
.76923 .30277 m
.77719 .30277 L
s
.77719 .30277 m
.78039 .31712 L
s
.27196 .0819 m
.25804 .06401 L
s
.25804 .06401 m
.26301 .0417 L
s
.26301 .0417 m
.27196 .0819 L
s
.66278 .45562 m
.65659 .44766 L
s
.65659 .44766 m
.6789 .44766 L
s
.6789 .44766 m
.66278 .45562 L
s
.3042 .0819 m
.28188 .0819 L
s
.28188 .0819 m
.26797 .06401 L
s
.26797 .06401 m
.3042 .0819 L
s
.50496 .44215 m
.49381 .44766 L
s
.49381 .44766 m
.4799 .42977 L
s
.4799 .42977 m
.50496 .44215 L
s
.31039 .07394 m
.28808 .07394 L
s
.28808 .07394 m
.3243 .05605 L
s
.3243 .05605 m
.31039 .07394 L
s
.06003 .0704 m
.05507 .06401 L
s
.05507 .06401 m
.065 .06401 L
s
.065 .06401 m
.06003 .0704 L
s
.44305 .0778 m
.44127 .07552 L
s
.44127 .07552 m
.44766 .07552 L
s
.44766 .07552 m
.44305 .0778 L
s
.82378 .54083 m
.81341 .54596 L
s
.81341 .54596 m
.81661 .53161 L
s
.81661 .53161 m
.82236 .53445 L
s
.82236 .53445 m
.82378 .54083 L
s
.6757 .33558 m
.67251 .33147 L
s
.67251 .33147 m
.6789 .33147 L
s
.6789 .33147 m
.6757 .33558 L
s
.65702 .40107 m
.65064 .40107 L
s
.65064 .40107 m
.64666 .39595 L
s
.64666 .39595 m
.64808 .38956 L
s
.64808 .38956 m
.65604 .38956 L
s
.65604 .38956 m
.6588 .39311 L
s
.6588 .39311 m
.65702 .40107 L
s
.6409 .35732 m
.64268 .34936 L
s
.64268 .34936 m
.64488 .3522 L
s
.64488 .3522 m
.6409 .35732 L
s
.68784 .87789 m
.68607 .86993 L
s
.68607 .86993 m
.69005 .86796 L
s
.69005 .86796 m
.68784 .87789 L
s
.44971 .0745 m
.4488 .07496 L
s
.4488 .07496 m
.44525 .0704 L
s
.44525 .0704 m
.4488 .0704 L
s
.4488 .0704 m
.44971 .0745 L
s
.64922 .33274 m
.64823 .33147 L
s
.64823 .33147 m
.64894 .33147 L
s
.64894 .33147 m
.64922 .33274 L
s
.87521 .45917 m
.87451 .45917 L
s
.87451 .45917 m
.87407 .4586 L
s
.87407 .4586 m
.87498 .45815 L
s
.87498 .45815 m
.87521 .45917 L
s
.63869 .39027 m
.63771 .389 L
s
.63771 .389 m
.63913 .3883 L
s
.63913 .3883 m
.63869 .39027 L
s
.7105 .22268 m
.70936 .22212 L
s
.70936 .22212 m
.71015 .2211 L
s
.71015 .2211 m
.7105 .22268 L
s
.58793 .26415 m
.58635 .26415 L
s
.58635 .26415 m
.58758 .26257 L
s
.58758 .26257 m
.58793 .26415 L
s
.62699 .32351 m
.62577 .32508 L
s
.62577 .32508 m
.6238 .32508 L
s
.6238 .32508 m
.62257 .32351 L
s
.62257 .32351 m
.62301 .32154 L
s
.62301 .32154 m
.62478 .32067 L
s
.62478 .32067 m
.62656 .32154 L
s
.62656 .32154 m
.62699 .32351 L
s
.699 .89224 m
.69403 .88586 L
s
.69403 .88586 m
.70396 .88586 L
s
.70396 .88586 m
.699 .89224 L
s
.74957 .25903 m
.74672 .25903 L
s
.74672 .25903 m
.74559 .25391 L
s
.74559 .25391 m
.74957 .25903 L
s
.63373 .32508 m
.62798 .32224 L
s
.62798 .32224 m
.63196 .31712 L
s
.63196 .31712 m
.63373 .32508 L
s
.47415 .04966 m
.47095 .04809 L
s
.47095 .04809 m
.47813 .04454 L
s
.47813 .04454 m
.47415 .04966 L
s
.09129 .0819 m
.08332 .0819 L
s
.08332 .0819 m
.0851 .07394 L
s
.0851 .07394 m
.09129 .0819 L
s
.64346 .36883 m
.63948 .36371 L
s
.63948 .36371 m
.64169 .36087 L
s
.64169 .36087 m
.64346 .36883 L
s
.74239 .22679 m
.73522 .23033 L
s
.73522 .23033 m
.72804 .22679 L
s
.72804 .22679 m
.72627 .21883 L
s
.72627 .21883 m
.73124 .21244 L
s
.73124 .21244 m
.7392 .21244 L
s
.7392 .21244 m
.74416 .21883 L
s
.74416 .21883 m
.74239 .22679 L
s
.71015 .22679 m
.68111 .21244 L
s
.68111 .21244 m
.69005 .20093 L
s
.69005 .20093 m
.71015 .22679 L
s
.699 .04454 m
.66995 .0302 L
s
.66995 .0302 m
.68288 .02381 L
s
.68288 .02381 m
.699 .04454 L
s
.65162 .83131 m
.63771 .81341 L
s
.63771 .81341 m
.66553 .81341 L
s
.66553 .81341 m
.65162 .83131 L
s
.69182 .03532 m
.70077 .02381 L
s
.70077 .02381 m
.71512 .02381 L
s
.71512 .02381 m
.69182 .03532 L
s
.47493 .40746 m
.45704 .40746 L
s
.45704 .40746 m
.46599 .36725 L
s
.46599 .36725 m
.47493 .40746 L
s
.71512 .14 m
.70617 .12849 L
s
.70617 .12849 m
.72229 .10776 L
s
.72229 .10776 m
.71512 .14 L
s
.43473 .22679 m
.41861 .21883 L
s
.41861 .21883 m
.42977 .20448 L
s
.42977 .20448 m
.43473 .22679 L
s
.71512 .11699 m
.70219 .1106 L
s
.70219 .1106 m
.699 .09625 L
s
.699 .09625 m
.71512 .11699 L
s
.57642 .45759 m
.53622 .45759 L
s
.53622 .45759 m
.57244 .4397 L
s
.57244 .4397 m
.57642 .45759 L
s
.3243 .05605 m
.30818 .06401 L
s
.30818 .06401 m
.31712 .02381 L
s
.31712 .02381 m
.3243 .05605 L
s
.57863 .59254 m
.55632 .59254 L
s
.55632 .59254 m
.56129 .57023 L
s
.56129 .57023 m
.57863 .59254 L
s
.33821 .03816 m
.32032 .03816 L
s
.32032 .03816 m
.34936 .02381 L
s
.34936 .02381 m
.33821 .03816 L
s
.85681 .4799 m
.82555 .5201 L
s
.82555 .5201 m
.77542 .5201 L
s
.77542 .5201 m
.74416 .4799 L
s
.74416 .4799 m
.75532 .42977 L
s
.75532 .42977 m
.80049 .40746 L
s
.80049 .40746 m
.84565 .42977 L
s
.84565 .42977 m
.85681 .4799 L
s
.85858 .55234 m
.85283 .52649 L
s
.85283 .52649 m
.86177 .53799 L
s
.86177 .53799 m
.85858 .55234 L
s
.78039 .22395 m
.77144 .21244 L
s
.77144 .21244 m
.78295 .21244 L
s
.78295 .21244 m
.78039 .22395 L
s
.78295 .25391 m
.76427 .24468 L
s
.76427 .24468 m
.78756 .23317 L
s
.78756 .23317 m
.78295 .25391 L
s
.65383 .43843 m
.64808 .44127 L
s
.64808 .44127 m
.64985 .43331 L
s
.64985 .43331 m
.65383 .43843 L
s
.84565 .51726 m
.83529 .52238 L
s
.83529 .52238 m
.83131 .51726 L
s
.83131 .51726 m
.83273 .51087 L
s
.83273 .51087 m
.84565 .51726 L
s
.77463 .2498 m
.76427 .25492 L
s
.76427 .25492 m
.75134 .23829 L
s
.75134 .23829 m
.77463 .2498 L
s
.79331 .25903 m
.78295 .25391 L
s
.78295 .25391 m
.78756 .23317 L
s
.78756 .23317 m
.79331 .25903 L
s
.78756 .28488 m
.77463 .29127 L
s
.77463 .29127 m
.76171 .28488 L
s
.76171 .28488 m
.75595 .25903 L
s
.75595 .25903 m
.78181 .25903 L
s
.78181 .25903 m
.79075 .27053 L
s
.79075 .27053 m
.78756 .28488 L
s
.79075 .27053 m
.77463 .2498 L
s
.77463 .2498 m
.79331 .25903 L
s
.79331 .25903 m
.79075 .27053 L
s
.84565 .61044 m
.82953 .5897 L
s
.82953 .5897 m
.8399 .58458 L
s
.8399 .58458 m
.84565 .61044 L
s
.44589 .27692 m
.41463 .31712 L
s
.41463 .31712 m
.3645 .31712 L
s
.3645 .31712 m
.33324 .27692 L
s
.33324 .27692 m
.3444 .22679 L
s
.3444 .22679 m
.38956 .20448 L
s
.38956 .20448 m
.43473 .22679 L
s
.43473 .22679 m
.44589 .27692 L
s
.63054 .11414 m
.62257 .11414 L
s
.62257 .11414 m
.61761 .10776 L
s
.61761 .10776 m
.62798 .10264 L
s
.62798 .10264 m
.63054 .11414 L
s
.52231 .19455 m
.51612 .18659 L
s
.51612 .18659 m
.52728 .17224 L
s
.52728 .17224 m
.52231 .19455 L
s
.81661 .74097 m
.80049 .73301 L
s
.80049 .73301 m
.82059 .72308 L
s
.82059 .72308 m
.81661 .74097 L
s
.91092 .22395 m
.91987 .21244 L
s
.91987 .21244 m
.93422 .21244 L
s
.93422 .21244 m
.91092 .22395 L
s
.67492 .16869 m
.66995 .17508 L
s
.66995 .17508 m
.66278 .16585 L
s
.66278 .16585 m
.67314 .16073 L
s
.67314 .16073 m
.67492 .16869 L
s
.42082 .38956 m
.39851 .38956 L
s
.39851 .38956 m
.39576 .37718 L
s
.39576 .37718 m
.42082 .38956 L
s
.76746 .11414 m
.75851 .10264 L
s
.75851 .10264 m
.77144 .09625 L
s
.77144 .09625 m
.76746 .11414 L
s
.77144 .14796 m
.75851 .15435 L
s
.75851 .15435 m
.77463 .13361 L
s
.77463 .13361 m
.77144 .14796 L
s
.71512 .11699 m
.70794 .10776 L
s
.70794 .10776 m
.71512 .10421 L
s
.71512 .10421 m
.72229 .10776 L
s
.72229 .10776 m
.71512 .11699 L
s
.75808 .5782 m
.74815 .5782 L
s
.74815 .5782 m
.74416 .5603 L
s
.74416 .5603 m
.75808 .5782 L
s
.42579 .0704 m
.40967 .07836 L
s
.40967 .07836 m
.41463 .05605 L
s
.41463 .05605 m
.42579 .0704 L
s
.77144 .21244 m
.74815 .20093 L
s
.74815 .20093 m
.76249 .20093 L
s
.76249 .20093 m
.77144 .21244 L
s
.26301 .18659 m
.23175 .22679 L
s
.23175 .22679 m
.18162 .22679 L
s
.18162 .22679 m
.15036 .18659 L
s
.15036 .18659 m
.16152 .13645 L
s
.16152 .13645 m
.20669 .11414 L
s
.20669 .11414 m
.25185 .13645 L
s
.25185 .13645 m
.26301 .18659 L
s
.60149 .7509 m
.58911 .7509 L
s
.58911 .7509 m
.58139 .74097 L
s
.58139 .74097 m
.59751 .73301 L
s
.59751 .73301 m
.60149 .7509 L
s
.66774 .23672 m
.66995 .22679 L
s
.66995 .22679 m
.68784 .22679 L
s
.68784 .22679 m
.66774 .23672 L
s
.69005 .05605 m
.68607 .03816 L
s
.68607 .03816 m
.699 .04454 L
s
.699 .04454 m
.69005 .05605 L
s
.68288 .08829 m
.66995 .0819 L
s
.66995 .0819 m
.6958 .0819 L
s
.6958 .0819 m
.68288 .08829 L
s
.6705 .83572 m
.66278 .84565 L
s
.66278 .84565 m
.65162 .83131 L
s
.65162 .83131 m
.66774 .82334 L
s
.66774 .82334 m
.6705 .83572 L
s
.30818 .24468 m
.29702 .23917 L
s
.29702 .23917 m
.32209 .22679 L
s
.32209 .22679 m
.30818 .24468 L
s
.50496 .17224 m
.49105 .15435 L
s
.49105 .15435 m
.50895 .15435 L
s
.50895 .15435 m
.50496 .17224 L
s
.63373 .12849 m
.62798 .10264 L
s
.62798 .10264 m
.63692 .11414 L
s
.63692 .11414 m
.63373 .12849 L
s
.3444 .40746 m
.33324 .4218 L
s
.33324 .4218 m
.32209 .40746 L
s
.32209 .40746 m
.3243 .39753 L
s
.3243 .39753 m
.33324 .39311 L
s
.33324 .39311 m
.34219 .39753 L
s
.34219 .39753 m
.3444 .40746 L
s
.339 .13488 m
.33324 .13204 L
s
.33324 .13204 m
.34042 .12849 L
s
.34042 .12849 m
.339 .13488 L
s
.83273 .38444 m
.82953 .38034 L
s
.82953 .38034 m
.83159 .37932 L
s
.83159 .37932 m
.83273 .38444 L
s
.33722 .16585 m
.33324 .16073 L
s
.33324 .16073 m
.33545 .15789 L
s
.33545 .15789 m
.33722 .16585 L
s
.33722 .37522 m
.31933 .37522 L
s
.31933 .37522 m
.31314 .36725 L
s
.31314 .36725 m
.31535 .35732 L
s
.31535 .35732 m
.3243 .35291 L
s
.3243 .35291 m
.33324 .35732 L
s
.33324 .35732 m
.33722 .37522 L
s
.89942 .20093 m
.898 .19455 L
s
.898 .19455 m
.90261 .19683 L
s
.90261 .19683 m
.89942 .20093 L
s
.88535 .21244 m
.88023 .21244 L
s
.88023 .21244 m
.88074 .21016 L
s
.88074 .21016 m
.88649 .20732 L
s
.88649 .20732 m
.88854 .20833 L
s
.88854 .20833 m
.88535 .21244 L
s
.35192 .12849 m
.34617 .12565 L
s
.34617 .12565 m
.35334 .12211 L
s
.35334 .12211 m
.35192 .12849 L
s
.7502 .87151 m
.74097 .87151 L
s
.74097 .87151 m
.73983 .86639 L
s
.73983 .86639 m
.74815 .86228 L
s
.74815 .86228 m
.75134 .86639 L
s
.75134 .86639 m
.7502 .87151 L
s
.58139 .07962 m
.5782 .07552 L
s
.5782 .07552 m
.58458 .07552 L
s
.58458 .07552 m
.58139 .07962 L
s
.92088 .21244 m
.91759 .21244 L
s
.91759 .21244 m
.9181 .21016 L
s
.9181 .21016 m
.92015 .20915 L
s
.92015 .20915 m
.92088 .21244 L
s
.31968 .13873 m
.31854 .13817 L
s
.31854 .13817 m
.32209 .13361 L
s
.32209 .13361 m
.33005 .13361 L
s
.33005 .13361 m
.31968 .13873 L
s
.55695 .03633 m
.55604 .03588 L
s
.55604 .03588 m
.55695 .03177 L
s
.55695 .03177 m
.55853 .03177 L
s
.55853 .03177 m
.55952 .03304 L
s
.55952 .03304 m
.55695 .03633 L
s
.26576 .31909 m
.26424 .31712 L
s
.26424 .31712 m
.2662 .31712 L
s
.2662 .31712 m
.26576 .31909 L
s
.61044 .42977 m
.59432 .4218 L
s
.59432 .4218 m
.60547 .40746 L
s
.60547 .40746 m
.61044 .42977 L
s
.87612 .21244 m
.87511 .21244 L
s
.87511 .21244 m
.87612 .20788 L
s
.87612 .20788 m
.88188 .20504 L
s
.88188 .20504 m
.87612 .21244 L
s
.73585 .8485 m
.73522 .84565 L
s
.73522 .84565 m
.7362 .84692 L
s
.7362 .84692 m
.73585 .8485 L
s
.56846 .09625 m
.56874 .09499 L
s
.56874 .09499 m
.56944 .09499 L
s
.56944 .09499 m
.56846 .09625 L
s
.5659 .08475 m
.56732 .07836 L
s
.56732 .07836 m
.5689 .07836 L
s
.5689 .07836 m
.56988 .07962 L
s
.56988 .07962 m
.5659 .08475 L
s
.34936 .18147 m
.34838 .1802 L
s
.34838 .1802 m
.35035 .1802 L
s
.35035 .1802 m
.34936 .18147 L
s
.35334 .18659 m
.34873 .18431 L
s
.34873 .18431 m
.34936 .18147 L
s
.34936 .18147 m
.35334 .18659 L
s
.36052 .44412 m
.35334 .44766 L
s
.35334 .44766 m
.34936 .42977 L
s
.34936 .42977 m
.36229 .43615 L
s
.36229 .43615 m
.36052 .44412 L
s
.57244 .04966 m
.56732 .04966 L
s
.56732 .04966 m
.56846 .04454 L
s
.56846 .04454 m
.57244 .04966 L
s
.29083 .33147 m
.28532 .33147 L
s
.28532 .33147 m
.27913 .32351 L
s
.27913 .32351 m
.28409 .31712 L
s
.28409 .31712 m
.29206 .31712 L
s
.29206 .31712 m
.29702 .32351 L
s
.29702 .32351 m
.29083 .33147 L
s
.36371 .16869 m
.36548 .16073 L
s
.36548 .16073 m
.36769 .16357 L
s
.36769 .16357 m
.36371 .16869 L
s
.90198 .21244 m
.89686 .21244 L
s
.89686 .21244 m
.898 .20732 L
s
.898 .20732 m
.90198 .21244 L
s
.36229 .17508 m
.36371 .16869 L
s
.36371 .16869 m
.36725 .16869 L
s
.36725 .16869 m
.36229 .17508 L
s
.38062 .38956 m
.34042 .38956 L
s
.34042 .38956 m
.36946 .37522 L
s
.36946 .37522 m
.38062 .38956 L
s
.41861 .41542 m
.38956 .42977 L
s
.38956 .42977 m
.39851 .38956 L
s
.39851 .38956 m
.41861 .41542 L
s
.35334 .14512 m
.34759 .14796 L
s
.34759 .14796 m
.34936 .14 L
s
.34936 .14 m
.35334 .14512 L
s
.32607 .38956 m
.30995 .3816 L
s
.30995 .3816 m
.31491 .37522 L
s
.31491 .37522 m
.32288 .37522 L
s
.32288 .37522 m
.32607 .38956 L
s
.65383 .15435 m
.63054 .14284 L
s
.63054 .14284 m
.63373 .12849 L
s
.63373 .12849 m
.65383 .15435 L
s
.43473 .40746 m
.41861 .41542 L
s
.41861 .41542 m
.39851 .38956 L
s
.39851 .38956 m
.43473 .40746 L
s
.62798 .15435 m
.59574 .15435 L
s
.59574 .15435 m
.58458 .14 L
s
.58458 .14 m
.58856 .12211 L
s
.58856 .12211 m
.60468 .11414 L
s
.60468 .11414 m
.6208 .12211 L
s
.6208 .12211 m
.62798 .15435 L
s
.63373 .12849 m
.60468 .11414 L
s
.60468 .11414 m
.61761 .10776 L
s
.61761 .10776 m
.63373 .12849 L
s
.38558 .33147 m
.38239 .31712 L
s
.38239 .31712 m
.41463 .31712 L
s
.41463 .31712 m
.38558 .33147 L
s
.76569 .9698 m
.76313 .97107 L
s
.76313 .97107 m
.76171 .96468 L
s
.76171 .96468 m
.76569 .95956 L
s
.76569 .95956 m
.76746 .96184 L
s
.76746 .96184 m
.76569 .9698 L
s
.59751 .48786 m
.58856 .48344 L
s
.58856 .48344 m
.59574 .4799 L
s
.59574 .4799 m
.59751 .48786 L
s
.31137 .16585 m
.30676 .16357 L
s
.30676 .16357 m
.30995 .14923 L
s
.30995 .14923 m
.31712 .15845 L
s
.31712 .15845 m
.31137 .16585 L
s
.29064 .15561 m
.27771 .14923 L
s
.27771 .14923 m
.28567 .14923 L
s
.28567 .14923 m
.29064 .15561 L
s
.61938 .33786 m
.61816 .33943 L
s
.61816 .33943 m
.61619 .33943 L
s
.61619 .33943 m
.61442 .33147 L
s
.61442 .33147 m
.61938 .33786 L
s
.75355 .90817 m
.7539 .90659 L
s
.7539 .90659 m
.75532 .90729 L
s
.75532 .90729 m
.75355 .90817 L
s
.62798 .15435 m
.6208 .12211 L
s
.6208 .12211 m
.63373 .12849 L
s
.63373 .12849 m
.62798 .15435 L
s
.58856 .12211 m
.59432 .09625 L
s
.59432 .09625 m
.61761 .10776 L
s
.61761 .10776 m
.58856 .12211 L
s
.59254 .46555 m
.59033 .45562 L
s
.59033 .45562 m
.59751 .45917 L
s
.59751 .45917 m
.59254 .46555 L
s
.86433 .4103 m
.85397 .40518 L
s
.85397 .40518 m
.85716 .40107 L
s
.85716 .40107 m
.86228 .40107 L
s
.86228 .40107 m
.86433 .4103 L
s
.38956 .34936 m
.38558 .33147 L
s
.38558 .33147 m
.41463 .31712 L
s
.41463 .31712 m
.38956 .34936 L
s
.60866 .09625 m
.59432 .09625 L
s
.59432 .09625 m
.59751 .0819 L
s
.59751 .0819 m
.60866 .09625 L
s
.37344 .35732 m
.35334 .36725 L
s
.35334 .36725 m
.33324 .35732 L
s
.33324 .35732 m
.32828 .33501 L
s
.32828 .33501 m
.34219 .31712 L
s
.34219 .31712 m
.3645 .31712 L
s
.3645 .31712 m
.37841 .33501 L
s
.37841 .33501 m
.37344 .35732 L
s
.38956 .34936 m
.37344 .35732 L
s
.37344 .35732 m
.38239 .31712 L
s
.38239 .31712 m
.38956 .34936 L
s
.35334 .38318 m
.34042 .38956 L
s
.34042 .38956 m
.33324 .35732 L
s
.33324 .35732 m
.35334 .38318 L
s
.46599 .36725 m
.44864 .38956 L
s
.44864 .38956 m
.42082 .38956 L
s
.42082 .38956 m
.40348 .36725 L
s
.40348 .36725 m
.40967 .33943 L
s
.40967 .33943 m
.43473 .32705 L
s
.43473 .32705 m
.4598 .33943 L
s
.4598 .33943 m
.46599 .36725 L
s
.79828 .75886 m
.78437 .74097 L
s
.78437 .74097 m
.80226 .74097 L
s
.80226 .74097 m
.79828 .75886 L
s
.92704 .24468 m
.92129 .21883 L
s
.92129 .21883 m
.93422 .21244 L
s
.93422 .21244 m
.92704 .24468 L
s
.82555 .70077 m
.80049 .66853 L
s
.80049 .66853 m
.81838 .66853 L
s
.81838 .66853 m
.82555 .70077 L
s
.3645 .31712 m
.33668 .31712 L
s
.33668 .31712 m
.3444 .30719 L
s
.3444 .30719 m
.3645 .31712 L
s
.81164 .68288 m
.77144 .68288 L
s
.77144 .68288 m
.79154 .67295 L
s
.79154 .67295 m
.81164 .68288 L
s
.59751 .16231 m
.59132 .15435 L
s
.59132 .15435 m
.61363 .15435 L
s
.61363 .15435 m
.59751 .16231 L
s
.76427 .71512 m
.76923 .69281 L
s
.76923 .69281 m
.78933 .68288 L
s
.78933 .68288 m
.76427 .71512 L
s
.56527 .14638 m
.55234 .14 L
s
.55234 .14 m
.57244 .11414 L
s
.57244 .11414 m
.56527 .14638 L
s
.78437 .74097 m
.76427 .71512 L
s
.76427 .71512 m
.77542 .70077 L
s
.77542 .70077 m
.78437 .74097 L
s
.50319 .24468 m
.48707 .23672 L
s
.48707 .23672 m
.50717 .22679 L
s
.50717 .22679 m
.50319 .24468 L
s
.66278 .16585 m
.67172 .15435 L
s
.67172 .15435 m
.68607 .15435 L
s
.68607 .15435 m
.66278 .16585 L
s
.51612 .65702 m
.50496 .64268 L
s
.50496 .64268 m
.50717 .63275 L
s
.50717 .63275 m
.51612 .62833 L
s
.51612 .62833 m
.53224 .63629 L
s
.53224 .63629 m
.51612 .65702 L
s
.84786 .40391 m
.8399 .40391 L
s
.8399 .40391 m
.84388 .39879 L
s
.84388 .39879 m
.84786 .40391 L
s
.5201 .61044 m
.50221 .61044 L
s
.50221 .61044 m
.49602 .60247 L
s
.49602 .60247 m
.49823 .59254 L
s
.49823 .59254 m
.50717 .58812 L
s
.50717 .58812 m
.51612 .59254 L
s
.51612 .59254 m
.5201 .61044 L
s
.54517 .64268 m
.53622 .63826 L
s
.53622 .63826 m
.5434 .63471 L
s
.5434 .63471 m
.54517 .64268 L
s
.83529 .42465 m
.83159 .42282 L
s
.83159 .42282 m
.83415 .41953 L
s
.83415 .41953 m
.83592 .4218 L
s
.83592 .4218 m
.83529 .42465 L
s
.67492 .55873 m
.67314 .56669 L
s
.67314 .56669 m
.67058 .55518 L
s
.67058 .55518 m
.67137 .55417 L
s
.67137 .55417 m
.67492 .55873 L
s
.78117 .07552 m
.77833 .07552 L
s
.77833 .07552 m
.7776 .07223 L
s
.7776 .07223 m
.77833 .07186 L
s
.77833 .07186 m
.78117 .07552 L
s
.57564 .03532 m
.56527 .04044 L
s
.56527 .04044 m
.56271 .02893 L
s
.56271 .02893 m
.57564 .03532 L
s
.14142 .0819 m
.13681 .07962 L
s
.13681 .07962 m
.13886 .0704 L
s
.13886 .0704 m
.15036 .0704 L
s
.15036 .0704 m
.14142 .0819 L
s
.79729 .06756 m
.79508 .0704 L
s
.79508 .0704 m
.7887 .0704 L
s
.7887 .0704 m
.78665 .06117 L
s
.78665 .06117 m
.79587 .06117 L
s
.79587 .06117 m
.79729 .06756 L
s
.78614 .10036 m
.78437 .10264 L
s
.78437 .10264 m
.78295 .09625 L
s
.78295 .09625 m
.78614 .10036 L
s
.85858 .43615 m
.85283 .43331 L
s
.85283 .43331 m
.86 .42977 L
s
.86 .42977 m
.85858 .43615 L
s
.78579 .09625 m
.78295 .09625 L
s
.78295 .09625 m
.78181 .09113 L
s
.78181 .09113 m
.78579 .09625 L
s
.71335 .73459 m
.71079 .73585 L
s
.71079 .73585 m
.70936 .72947 L
s
.70936 .72947 m
.71335 .72434 L
s
.71335 .72434 m
.71512 .72662 L
s
.71512 .72662 m
.71335 .73459 L
s
.09944 .06117 m
.09483 .05889 L
s
.09483 .05889 m
.10122 .05889 L
s
.10122 .05889 m
.09944 .06117 L
s
.07871 .05093 m
.06578 .04454 L
s
.06578 .04454 m
.07375 .04454 L
s
.07375 .04454 m
.07871 .05093 L
s
.55411 .63117 m
.55289 .63275 L
s
.55289 .63275 m
.55092 .63275 L
s
.55092 .63275 m
.54915 .62478 L
s
.54915 .62478 m
.55411 .63117 L
s
.70121 .67295 m
.70156 .67137 L
s
.70156 .67137 m
.70298 .67207 L
s
.70298 .67207 m
.70121 .67295 L
s
.59062 .06117 m
.58025 .05605 L
s
.58025 .05605 m
.59318 .04966 L
s
.59318 .04966 m
.59062 .06117 L
s
.47592 .59254 m
.46599 .59254 L
s
.46599 .59254 m
.4598 .58458 L
s
.4598 .58458 m
.46201 .57465 L
s
.46201 .57465 m
.47095 .57023 L
s
.47095 .57023 m
.48707 .5782 L
s
.48707 .5782 m
.47592 .59254 L
s
.70121 .59254 m
.69324 .59254 L
s
.69324 .59254 m
.69723 .58742 L
s
.69723 .58742 m
.70121 .59254 L
s
.68749 .6184 m
.68493 .61966 L
s
.68493 .61966 m
.68351 .61328 L
s
.68351 .61328 m
.68749 .60816 L
s
.68749 .60816 m
.68926 .61044 L
s
.68926 .61044 m
.68749 .6184 L
s
.56129 .65064 m
.55234 .64622 L
s
.55234 .64622 m
.55952 .64268 L
s
.55952 .64268 m
.56129 .65064 L
s
.72947 .66214 m
.72485 .66442 L
s
.72485 .66442 m
.7191 .65702 L
s
.7191 .65702 m
.72229 .65292 L
s
.72229 .65292 m
.73061 .65702 L
s
.73061 .65702 m
.72947 .66214 L
s
.59893 .06528 m
.59802 .06117 L
s
.59802 .06117 m
.60212 .06117 L
s
.60212 .06117 m
.59893 .06528 L
s
.67712 .57181 m
.67456 .57307 L
s
.67456 .57307 m
.67314 .56669 L
s
.67314 .56669 m
.67712 .56157 L
s
.67712 .56157 m
.6789 .56385 L
s
.6789 .56385 m
.67712 .57181 L
s
.78437 .07962 m
.77925 .07962 L
s
.77925 .07962 m
.78295 .0778 L
s
.78295 .0778 m
.78437 .07962 L
s
.13105 .07678 m
.11812 .0704 L
s
.11812 .0704 m
.12609 .0704 L
s
.12609 .0704 m
.13105 .07678 L
s
.61584 .0998 m
.61505 .10081 L
s
.61505 .10081 m
.61044 .09853 L
s
.61044 .09853 m
.61556 .09853 L
s
.61556 .09853 m
.61584 .0998 L
s
.53745 .30719 m
.53499 .30719 L
s
.53499 .30719 m
.53622 .30562 L
s
.53622 .30562 m
.53745 .30719 L
s
.54517 .69438 m
.54119 .67649 L
s
.54119 .67649 m
.56129 .68642 L
s
.56129 .68642 m
.54517 .69438 L
s
.69147 .62352 m
.68635 .62605 L
s
.68635 .62605 m
.68607 .62478 L
s
.68607 .62478 m
.69324 .61556 L
s
.69324 .61556 m
.69147 .62352 L
s
.73487 .63787 m
.73345 .63857 L
s
.73345 .63857 m
.73522 .63629 L
s
.73522 .63629 m
.73487 .63787 L
s
.5823 .06162 m
.58139 .06117 L
s
.58139 .06117 m
.58265 .06117 L
s
.58265 .06117 m
.5823 .06162 L
s
.59254 .06983 m
.59175 .07085 L
s
.59175 .07085 m
.58714 .06857 L
s
.58714 .06857 m
.59226 .06857 L
s
.59226 .06857 m
.59254 .06983 L
s
.77861 .07678 m
.77833 .07552 L
s
.77833 .07552 m
.7796 .07552 L
s
.7796 .07552 m
.77861 .07678 L
s
.77833 .07552 m
.77628 .0745 L
s
.77628 .0745 m
.77719 .0704 L
s
.77719 .0704 m
.77833 .07552 L
s
.55234 .61044 m
.53622 .60247 L
s
.53622 .60247 m
.54915 .59609 L
s
.54915 .59609 m
.55411 .60247 L
s
.55411 .60247 m
.55234 .61044 L
s
.613 .08702 m
.6093 .0852 L
s
.6093 .0852 m
.61186 .0819 L
s
.61186 .0819 m
.613 .08702 L
s
.56251 .29481 m
.55908 .29923 L
s
.55908 .29923 m
.54915 .29923 L
s
.54915 .29923 m
.54738 .29127 L
s
.54738 .29127 m
.55234 .28488 L
s
.55234 .28488 m
.56129 .2893 L
s
.56129 .2893 m
.56251 .29481 L
s
.73025 .64268 m
.72947 .63913 L
s
.72947 .63913 m
.73522 .63629 L
s
.73522 .63629 m
.73025 .64268 L
s
.79907 .07552 m
.79331 .07268 L
s
.79331 .07268 m
.79843 .07268 L
s
.79843 .07268 m
.79907 .07552 L
s
.78153 .07141 m
.77742 .06938 L
s
.77742 .06938 m
.7776 .06857 L
s
.7776 .06857 m
.78089 .06857 L
s
.78089 .06857 m
.78153 .07141 L
s
.61733 .10649 m
.61619 .10593 L
s
.61619 .10593 m
.6172 .10593 L
s
.6172 .10593 m
.61733 .10649 L
s
.52984 .31586 m
.5287 .31642 L
s
.5287 .31642 m
.5285 .31555 L
s
.5285 .31555 m
.52905 .31484 L
s
.52905 .31484 m
.52984 .31586 L
s
.55057 .3127 m
.5488 .31358 L
s
.5488 .31358 m
.54836 .31161 L
s
.54836 .31161 m
.55057 .3127 L
s
.71236 .72308 m
.71079 .72308 L
s
.71079 .72308 m
.71114 .7215 L
s
.71114 .7215 m
.71236 .72308 L
s
.76825 .12337 m
.76797 .12211 L
s
.76797 .12211 m
.76923 .12211 L
s
.76923 .12211 m
.76825 .12337 L
s
.49326 .61485 m
.49105 .61595 L
s
.49105 .61595 m
.48884 .61485 L
s
.48884 .61485 m
.4883 .6124 L
s
.4883 .6124 m
.48983 .61044 L
s
.48983 .61044 m
.49228 .61044 L
s
.49228 .61044 m
.49381 .6124 L
s
.49381 .6124 m
.49326 .61485 L
s
.68607 .59609 m
.68032 .59893 L
s
.68032 .59893 m
.6789 .59254 L
s
.6789 .59254 m
.68607 .59609 L
s
.79331 .07268 m
.7887 .0704 L
s
.7887 .0704 m
.79508 .0704 L
s
.79508 .0704 m
.79331 .07268 L
s
.5 .58458 m
.50717 .55234 L
s
.50717 .55234 m
.52507 .55234 L
s
.52507 .55234 m
.5 .58458 L
s
.56129 .57023 m
.53622 .53799 L
s
.53622 .53799 m
.56846 .53799 L
s
.56846 .53799 m
.56129 .57023 L
s
.55632 .62833 m
.55411 .6184 L
s
.55411 .6184 m
.56129 .62194 L
s
.56129 .62194 m
.55632 .62833 L
s
.47493 .60405 m
.47316 .59609 L
s
.47316 .59609 m
.47813 .5897 L
s
.47813 .5897 m
.49105 .59609 L
s
.49105 .59609 m
.47493 .60405 L
s
.83671 .38956 m
.81341 .37806 L
s
.81341 .37806 m
.81661 .36371 L
s
.81661 .36371 m
.83671 .38956 L
s
.56846 .53799 m
.53622 .53799 L
s
.53622 .53799 m
.57244 .5201 L
s
.57244 .5201 m
.56846 .53799 L
s
.81085 .38956 m
.77861 .38956 L
s
.77861 .38956 m
.76746 .37522 L
s
.76746 .37522 m
.77144 .35732 L
s
.77144 .35732 m
.78756 .34936 L
s
.78756 .34936 m
.80368 .35732 L
s
.80368 .35732 m
.81085 .38956 L
s
.81661 .36371 m
.78756 .34936 L
s
.78756 .34936 m
.80049 .34298 L
s
.80049 .34298 m
.81661 .36371 L
s
.48388 .51214 m
.47095 .50575 L
s
.47095 .50575 m
.49105 .4799 L
s
.49105 .4799 m
.48388 .51214 L
s
.85283 .31712 m
.83273 .34298 L
s
.83273 .34298 m
.80049 .34298 L
s
.80049 .34298 m
.78039 .31712 L
s
.78039 .31712 m
.78756 .28488 L
s
.78756 .28488 m
.81661 .27053 L
s
.81661 .27053 m
.84565 .28488 L
s
.84565 .28488 m
.85283 .31712 L
s
.56472 .61044 m
.55234 .61044 L
s
.55234 .61044 m
.55632 .59254 L
s
.55632 .59254 m
.57244 .60051 L
s
.57244 .60051 m
.56472 .61044 L
s
.74637 .38956 m
.72627 .37964 L
s
.72627 .37964 m
.73522 .37522 L
s
.73522 .37522 m
.74637 .38956 L
s
.56129 .06401 m
.54517 .05605 L
s
.54517 .05605 m
.55632 .0417 L
s
.55632 .0417 m
.56129 .06401 L
s
.68288 .7107 m
.66278 .70077 L
s
.66278 .70077 m
.70298 .70077 L
s
.70298 .70077 m
.68288 .7107 L
s
.68288 .61044 m
.66499 .61044 L
s
.66499 .61044 m
.66897 .59254 L
s
.66897 .59254 m
.68012 .59805 L
s
.68012 .59805 m
.68288 .61044 L
s
.88188 .35448 m
.8747 .35094 L
s
.8747 .35094 m
.89082 .34298 L
s
.89082 .34298 m
.88188 .35448 L
s
.69005 .20093 m
.67393 .2089 L
s
.67393 .2089 m
.6789 .18659 L
s
.6789 .18659 m
.69005 .20093 L
s
.60645 .77321 m
.59751 .73301 L
s
.59751 .73301 m
.61142 .7509 L
s
.61142 .7509 m
.60645 .77321 L
s
.11635 .11414 m
.1052 .12849 L
s
.1052 .12849 m
.09404 .11414 L
s
.09404 .11414 m
.09625 .10421 L
s
.09625 .10421 m
.1052 .0998 L
s
.1052 .0998 m
.11414 .10421 L
s
.11414 .10421 m
.11635 .11414 L
s
.60326 .26541 m
.59751 .26257 L
s
.59751 .26257 m
.60468 .25903 L
s
.60468 .25903 m
.60326 .26541 L
s
.68607 .19581 m
.68288 .19171 L
s
.68288 .19171 m
.68493 .19069 L
s
.68493 .19069 m
.68607 .19581 L
s
.60149 .29639 m
.59751 .29127 L
s
.59751 .29127 m
.59972 .28843 L
s
.59972 .28843 m
.60149 .29639 L
s
.10918 .0819 m
.09129 .0819 L
s
.09129 .0819 m
.0851 .07394 L
s
.0851 .07394 m
.08731 .06401 L
s
.08731 .06401 m
.09625 .05959 L
s
.09625 .05959 m
.1052 .06401 L
s
.1052 .06401 m
.10918 .0819 L
s
.75213 .92164 m
.74416 .92164 L
s
.74416 .92164 m
.75036 .91368 L
s
.75036 .91368 m
.75213 .92164 L
s
.75134 .95956 m
.74815 .95546 L
s
.74815 .95546 m
.75134 .95388 L
s
.75134 .95388 m
.75453 .95546 L
s
.75453 .95546 m
.75134 .95956 L
s
.58395 .26927 m
.58281 .26871 L
s
.58281 .26871 m
.58635 .26415 L
s
.58635 .26415 m
.59432 .26415 L
s
.59432 .26415 m
.58395 .26927 L
s
.62222 .32964 m
.62131 .32919 L
s
.62131 .32919 m
.62222 .32508 L
s
.62222 .32508 m
.62577 .32508 L
s
.62577 .32508 m
.62222 .32964 L
s
.84964 .49937 m
.85283 .48502 L
s
.85283 .48502 m
.86576 .49141 L
s
.86576 .49141 m
.84964 .49937 L
s
.61761 .31712 m
.613 .31484 L
s
.613 .31484 m
.61363 .312 L
s
.61363 .312 m
.61761 .31712 L
s
.13247 .1508 m
.1253 .15435 L
s
.1253 .15435 m
.12132 .13645 L
s
.12132 .13645 m
.13424 .14284 L
s
.13424 .14284 m
.13247 .1508 L
s
.6441 .34298 m
.63259 .34298 L
s
.63259 .34298 m
.63515 .33147 L
s
.63515 .33147 m
.64311 .33147 L
s
.64311 .33147 m
.64587 .33501 L
s
.64587 .33501 m
.6441 .34298 L
s
.62798 .29923 m
.62975 .29127 L
s
.62975 .29127 m
.63196 .29411 L
s
.63196 .29411 m
.62798 .29923 L
s
.73301 .93599 m
.72804 .9296 L
s
.72804 .9296 m
.73522 .92606 L
s
.73522 .92606 m
.73301 .93599 L
s
.62656 .30562 m
.62798 .29923 L
s
.62798 .29923 m
.63152 .29923 L
s
.63152 .29923 m
.62656 .30562 L
s
.19057 .12211 m
.17047 .09625 L
s
.17047 .09625 m
.18659 .10421 L
s
.18659 .10421 m
.19057 .12211 L
s
.69324 .44766 m
.6789 .44766 L
s
.6789 .44766 m
.69005 .43331 L
s
.69005 .43331 m
.69324 .44766 L
s
.699 .4218 m
.66995 .40746 L
s
.66995 .40746 m
.69324 .39595 L
s
.69324 .39595 m
.699 .4218 L
s
.54773 .02609 m
.54197 .02893 L
s
.54197 .02893 m
.53622 .02609 L
s
.53622 .02609 m
.53799 .02381 L
s
.53799 .02381 m
.54596 .02381 L
s
.54596 .02381 m
.54773 .02609 L
s
.96788 .02792 m
.96468 .02381 L
s
.96468 .02381 m
.97107 .02381 L
s
.97107 .02381 m
.96788 .02792 L
s
.57564 .29639 m
.57102 .29411 L
s
.57102 .29411 m
.57421 .27976 L
s
.57421 .27976 m
.58139 .28899 L
s
.58139 .28899 m
.57564 .29639 L
s
.5549 .28615 m
.54197 .27976 L
s
.54197 .27976 m
.54994 .27976 L
s
.54994 .27976 m
.5549 .28615 L
s
.81405 .54311 m
.80766 .54311 L
s
.80766 .54311 m
.81341 .54027 L
s
.81341 .54027 m
.8144 .54154 L
s
.8144 .54154 m
.81405 .54311 L
s
.49007 .04966 m
.48849 .04966 L
s
.48849 .04966 m
.48884 .04809 L
s
.48884 .04809 m
.49007 .04966 L
s
.65383 .41542 m
.66995 .39469 L
s
.66995 .39469 m
.68288 .40107 L
s
.68288 .40107 m
.65383 .41542 L
s
.87726 .46839 m
.87151 .46555 L
s
.87151 .46555 m
.87868 .46201 L
s
.87868 .46201 m
.87726 .46839 L
s
.71768 .22167 m
.70731 .21655 L
s
.70731 .21655 m
.7105 .21244 L
s
.7105 .21244 m
.71562 .21244 L
s
.71562 .21244 m
.71768 .22167 L
s
.699 .4218 m
.69324 .39595 L
s
.69324 .39595 m
.70617 .38956 L
s
.70617 .38956 m
.699 .4218 L
s
.70298 .37522 m
.69182 .38956 L
s
.69182 .38956 m
.65958 .38956 L
s
.65958 .38956 m
.66676 .35732 L
s
.66676 .35732 m
.68288 .34936 L
s
.68288 .34936 m
.699 .35732 L
s
.699 .35732 m
.70298 .37522 L
s
.70617 .38956 m
.68288 .40107 L
s
.68288 .40107 m
.70298 .37522 L
s
.70298 .37522 m
.70617 .38956 L
s
.1253 .08987 m
.11237 .09625 L
s
.11237 .09625 m
.1052 .06401 L
s
.1052 .06401 m
.1253 .08987 L
s
.28808 .36371 m
.27692 .34936 L
s
.27692 .34936 m
.27913 .33943 L
s
.27913 .33943 m
.28808 .33501 L
s
.28808 .33501 m
.3042 .34298 L
s
.3042 .34298 m
.28808 .36371 L
s
.8747 .19581 m
.86895 .19297 L
s
.86895 .19297 m
.87356 .19069 L
s
.87356 .19069 m
.8747 .19581 L
s
.29206 .31712 m
.27416 .31712 L
s
.27416 .31712 m
.26797 .30916 L
s
.26797 .30916 m
.27018 .29923 L
s
.27018 .29923 m
.27913 .29481 L
s
.27913 .29481 m
.28808 .29923 L
s
.28808 .29923 m
.29206 .31712 L
s
.31712 .34936 m
.30818 .34494 L
s
.30818 .34494 m
.31535 .3414 L
s
.31535 .3414 m
.31712 .34936 L
s
.87429 .21244 m
.871 .21244 L
s
.871 .21244 m
.87151 .21016 L
s
.87151 .21016 m
.87356 .20915 L
s
.87356 .20915 m
.87429 .21244 L
s
.74018 .85204 m
.73841 .86 L
s
.73841 .86 m
.73585 .8485 L
s
.73585 .8485 m
.73664 .84748 L
s
.73664 .84748 m
.74018 .85204 L
s
.56988 .09442 m
.56897 .09397 L
s
.56897 .09397 m
.56988 .08987 L
s
.56988 .08987 m
.57343 .08987 L
s
.57343 .08987 m
.56988 .09442 L
s
.62656 .35732 m
.61044 .34936 L
s
.61044 .34936 m
.62159 .33501 L
s
.62159 .33501 m
.62656 .35732 L
s
.40568 .21244 m
.40107 .21016 L
s
.40107 .21016 m
.40312 .20093 L
s
.40312 .20093 m
.41463 .20093 L
s
.41463 .20093 m
.40568 .21244 L
s
.59175 .10776 m
.58025 .10776 L
s
.58025 .10776 m
.58281 .09625 L
s
.58281 .09625 m
.59077 .09625 L
s
.59077 .09625 m
.59353 .0998 L
s
.59353 .0998 m
.59175 .10776 L
s
.57564 .06401 m
.57741 .05605 L
s
.57741 .05605 m
.57962 .05889 L
s
.57962 .05889 m
.57564 .06401 L
s
.85539 .21244 m
.85027 .21244 L
s
.85027 .21244 m
.85141 .20732 L
s
.85141 .20732 m
.85539 .21244 L
s
.57421 .0704 m
.57564 .06401 L
s
.57564 .06401 m
.57918 .06401 L
s
.57918 .06401 m
.57421 .0704 L
s
.3358 .13077 m
.33005 .13361 L
s
.33005 .13361 m
.3243 .13077 L
s
.3243 .13077 m
.32607 .12849 L
s
.32607 .12849 m
.33403 .12849 L
s
.33403 .12849 m
.3358 .13077 L
s
.36371 .19171 m
.3591 .18943 L
s
.3591 .18943 m
.36548 .18943 L
s
.36548 .18943 m
.36371 .19171 L
s
.34298 .18147 m
.33005 .17508 L
s
.33005 .17508 m
.33801 .17508 L
s
.33801 .17508 m
.34298 .18147 L
s
.32607 .33786 m
.32484 .33943 L
s
.32484 .33943 m
.32288 .33943 L
s
.32288 .33943 m
.3211 .33147 L
s
.3211 .33147 m
.32607 .33786 L
s
.88365 .4397 m
.88266 .43843 L
s
.88266 .43843 m
.88393 .43843 L
s
.88393 .43843 m
.88365 .4397 L
s
.62656 .39311 m
.61044 .40107 L
s
.61044 .40107 m
.60645 .38318 L
s
.60645 .38318 m
.62656 .39311 L
s
.24787 .29923 m
.23794 .29923 L
s
.23794 .29923 m
.23175 .29127 L
s
.23175 .29127 m
.23396 .28134 L
s
.23396 .28134 m
.24291 .27692 L
s
.24291 .27692 m
.25903 .28488 L
s
.25903 .28488 m
.24787 .29923 L
s
.76648 .88586 m
.75851 .88586 L
s
.75851 .88586 m
.76249 .88074 L
s
.76249 .88074 m
.76648 .88586 L
s
.75276 .91171 m
.7502 .91298 L
s
.7502 .91298 m
.74878 .90659 L
s
.74878 .90659 m
.75276 .90147 L
s
.75276 .90147 m
.75453 .90375 L
s
.75453 .90375 m
.75276 .91171 L
s
.33324 .35732 m
.3243 .35291 L
s
.3243 .35291 m
.33147 .34936 L
s
.33147 .34936 m
.33324 .35732 L
s
.25903 .14 m
.25441 .13772 L
s
.25441 .13772 m
.25647 .12849 L
s
.25647 .12849 m
.26159 .12849 L
s
.26159 .12849 m
.26478 .1326 L
s
.26478 .1326 m
.25903 .14 L
s
.62159 .41542 m
.61363 .41542 L
s
.61363 .41542 m
.61761 .4103 L
s
.61761 .4103 m
.62159 .41542 L
s
.74239 .86512 m
.73983 .86639 L
s
.73983 .86639 m
.73841 .86 L
s
.73841 .86 m
.74239 .85488 L
s
.74239 .85488 m
.74416 .85716 L
s
.74416 .85716 m
.74239 .86512 L
s
.57564 .08702 m
.57102 .08475 L
s
.57102 .08475 m
.57741 .08475 L
s
.57741 .08475 m
.57564 .08702 L
s
.39532 .20732 m
.38239 .20093 L
s
.38239 .20093 m
.39035 .20093 L
s
.39035 .20093 m
.39532 .20732 L
s
.59033 .46839 m
.58911 .46997 L
s
.58911 .46997 m
.58714 .46997 L
s
.58714 .46997 m
.58537 .46201 L
s
.58537 .46201 m
.59033 .46839 L
s
.8546 .40234 m
.85362 .40107 L
s
.85362 .40107 m
.85488 .40107 L
s
.85488 .40107 m
.8546 .40234 L
s
.31712 .40107 m
.31314 .38318 L
s
.31314 .38318 m
.33324 .39311 L
s
.33324 .39311 m
.31712 .40107 L
s
.75674 .91683 m
.75162 .91936 L
s
.75162 .91936 m
.75134 .9181 L
s
.75134 .9181 m
.75851 .90887 L
s
.75851 .90887 m
.75674 .91683 L
s
.23829 .12976 m
.23573 .12849 L
s
.23573 .12849 m
.23731 .12849 L
s
.23731 .12849 m
.23829 .12976 L
s
.60272 .39114 m
.60184 .39114 L
s
.60184 .39114 m
.60149 .38956 L
s
.60149 .38956 m
.60272 .39114 L
s
.60326 .4103 m
.60204 .41188 L
s
.60204 .41188 m
.60007 .41188 L
s
.60007 .41188 m
.5983 .40391 L
s
.5983 .40391 m
.60326 .4103 L
s
.57146 .08987 m
.56988 .08987 L
s
.56988 .08987 m
.57023 .08829 L
s
.57023 .08829 m
.57146 .08987 L
s
.56846 .09625 m
.56732 .09113 L
s
.56732 .09113 m
.56988 .08987 L
s
.56988 .08987 m
.56846 .09625 L
s
.3243 .31712 m
.30818 .30916 L
s
.30818 .30916 m
.3211 .30277 L
s
.3211 .30277 m
.32607 .30916 L
s
.32607 .30916 m
.3243 .31712 L
s
.60149 .45404 m
.60007 .44766 L
s
.60007 .44766 m
.60645 .44766 L
s
.60645 .44766 m
.60149 .45404 L
s
.87293 .40746 m
.87072 .4103 L
s
.87072 .4103 m
.86718 .4103 L
s
.86718 .4103 m
.86319 .40518 L
s
.86319 .40518 m
.86639 .40107 L
s
.86639 .40107 m
.87151 .40107 L
s
.87151 .40107 m
.87293 .40746 L
s
.8747 .40518 m
.87293 .40746 L
s
.87293 .40746 m
.87151 .40107 L
s
.87151 .40107 m
.8747 .40518 L
s
.59495 .09341 m
.58856 .09341 L
s
.58856 .09341 m
.59574 .08987 L
s
.59574 .08987 m
.59495 .09341 L
s
.57307 .09853 m
.56897 .09853 L
s
.56897 .09853 m
.56874 .09752 L
s
.56874 .09752 m
.57386 .09499 L
s
.57386 .09499 m
.57307 .09853 L
s
.58316 .47762 m
.58261 .47832 L
s
.58261 .47832 m
.58218 .47636 L
s
.58218 .47636 m
.58316 .47762 L
s
.8473 .40188 m
.84657 .40152 L
s
.84657 .40152 m
.84692 .40107 L
s
.84692 .40107 m
.84748 .40107 L
s
.84748 .40107 m
.8473 .40188 L
s
.85716 .41131 m
.85602 .41075 L
s
.85602 .41075 m
.85681 .40974 L
s
.85681 .40974 m
.85716 .41131 L
s
.32366 .13361 m
.32209 .13361 L
s
.32209 .13361 m
.32331 .13204 L
s
.32331 .13204 m
.32366 .13361 L
s
.55853 .03177 m
.55695 .03177 L
s
.55695 .03177 m
.55731 .0302 L
s
.55731 .0302 m
.55853 .03177 L
s
.26522 .32154 m
.26301 .32263 L
s
.26301 .32263 m
.2608 .32154 L
s
.2608 .32154 m
.26025 .31909 L
s
.26025 .31909 m
.26178 .31712 L
s
.26178 .31712 m
.26424 .31712 L
s
.26424 .31712 m
.26576 .31909 L
s
.26576 .31909 m
.26522 .32154 L
s
.75134 .8894 m
.74559 .89224 L
s
.74559 .89224 m
.74416 .88586 L
s
.74416 .88586 m
.75134 .8894 L
s
.59077 .09625 m
.58281 .09625 L
s
.58281 .09625 m
.58856 .09341 L
s
.58856 .09341 m
.59077 .09625 L
s
.27196 .29127 m
.27913 .25903 L
s
.27913 .25903 m
.29702 .25903 L
s
.29702 .25903 m
.27196 .29127 L
s
.33324 .27692 m
.30818 .24468 L
s
.30818 .24468 m
.34042 .24468 L
s
.34042 .24468 m
.33324 .27692 L
s
.32828 .33501 m
.32607 .32508 L
s
.32607 .32508 m
.33324 .32863 L
s
.33324 .32863 m
.32828 .33501 L
s
.24689 .31074 m
.24512 .30277 L
s
.24512 .30277 m
.25008 .29639 L
s
.25008 .29639 m
.26301 .30277 L
s
.26301 .30277 m
.24689 .31074 L
s
.90261 .18659 m
.88188 .18659 L
s
.88188 .18659 m
.90517 .17508 L
s
.90517 .17508 m
.90261 .18659 L
s
.34042 .24468 m
.30818 .24468 L
s
.30818 .24468 m
.3444 .22679 L
s
.3444 .22679 m
.34042 .24468 L
s
.93678 .20093 m
.92385 .20732 L
s
.92385 .20732 m
.90056 .19581 L
s
.90056 .19581 m
.91668 .17508 L
s
.91668 .17508 m
.93102 .17508 L
s
.93102 .17508 m
.93997 .18659 L
s
.93997 .18659 m
.93678 .20093 L
s
.93102 .17508 m
.90517 .17508 L
s
.90517 .17508 m
.92385 .16585 L
s
.92385 .16585 m
.93102 .17508 L
s
.25584 .21883 m
.24291 .21244 L
s
.24291 .21244 m
.26301 .18659 L
s
.26301 .18659 m
.25584 .21883 L
s
.065 .06401 m
.05507 .06401 L
s
.05507 .06401 m
.04888 .05605 L
s
.04888 .05605 m
.05108 .04612 L
s
.05108 .04612 m
.06003 .0417 L
s
.06003 .0417 m
.07615 .04966 L
s
.07615 .04966 m
.065 .06401 L
s
.72627 .88586 m
.72406 .87593 L
s
.72406 .87593 m
.73124 .87947 L
s
.73124 .87947 m
.72627 .88586 L
s
.70617 .90147 m
.70298 .89736 L
s
.70298 .89736 m
.70617 .89579 L
s
.70617 .89579 m
.70936 .89736 L
s
.70936 .89736 m
.70617 .90147 L
s
.43729 .08064 m
.43615 .08008 L
s
.43615 .08008 m
.4397 .07552 L
s
.4397 .07552 m
.44127 .07552 L
s
.44127 .07552 m
.44305 .0778 L
s
.44305 .0778 m
.43729 .08064 L
s
.63515 .38774 m
.63424 .38729 L
s
.63424 .38729 m
.63515 .38318 L
s
.63515 .38318 m
.63869 .38318 L
s
.63869 .38318 m
.63515 .38774 L
s
.82953 .53799 m
.82378 .54083 L
s
.82378 .54083 m
.82236 .53445 L
s
.82236 .53445 m
.82953 .53799 L
s
.66995 .34298 m
.66534 .3407 L
s
.66534 .3407 m
.66739 .33147 L
s
.66739 .33147 m
.67251 .33147 L
s
.67251 .33147 m
.6757 .33558 L
s
.6757 .33558 m
.66995 .34298 L
s
.65064 .40107 m
.64552 .40107 L
s
.64552 .40107 m
.64666 .39595 L
s
.64666 .39595 m
.65064 .40107 L
s
.60007 .26131 m
.59432 .26415 L
s
.59432 .26415 m
.58856 .26131 L
s
.58856 .26131 m
.59033 .25903 L
s
.59033 .25903 m
.5983 .25903 L
s
.5983 .25903 m
.60007 .26131 L
s
.62798 .32224 m
.62336 .31996 L
s
.62336 .31996 m
.62975 .31996 L
s
.62975 .31996 m
.62798 .32224 L
s
.60724 .312 m
.59432 .30562 L
s
.59432 .30562 m
.60228 .30562 L
s
.60228 .30562 m
.60724 .312 L
s
.66739 .35448 m
.661 .35448 L
s
.661 .35448 m
.66676 .35164 L
s
.66676 .35164 m
.66774 .35291 L
s
.66774 .35291 m
.66739 .35448 L
s
.73699 .25107 m
.73601 .2498 L
s
.73601 .2498 m
.73727 .2498 L
s
.73727 .2498 m
.73699 .25107 L
s
.85141 .5201 m
.83529 .51214 L
s
.83529 .51214 m
.84821 .50575 L
s
.84821 .50575 m
.85141 .5201 L
s
.4488 .07496 m
.44766 .07552 L
s
.44766 .07552 m
.44191 .07268 L
s
.44191 .07268 m
.44368 .0704 L
s
.44368 .0704 m
.44525 .0704 L
s
.44525 .0704 m
.4488 .07496 L
s
.6409 .38034 m
.63629 .37806 L
s
.63629 .37806 m
.64268 .37806 L
s
.64268 .37806 m
.6409 .38034 L
s
.64922 .33274 m
.64666 .33147 L
s
.64666 .33147 m
.64823 .33147 L
s
.64823 .33147 m
.64922 .33274 L
s
.87451 .45917 m
.87293 .45917 L
s
.87293 .45917 m
.87407 .4586 L
s
.87407 .4586 m
.87451 .45917 L
s
.63834 .39184 m
.63424 .39184 L
s
.63424 .39184 m
.63401 .39083 L
s
.63401 .39083 m
.63771 .389 L
s
.63771 .389 m
.63869 .39027 L
s
.63869 .39027 m
.63834 .39184 L
s
.88137 .44994 m
.8801 .44994 L
s
.8801 .44994 m
.88152 .44924 L
s
.88152 .44924 m
.88137 .44994 L
s
.70064 .21325 m
.69991 .21289 L
s
.69991 .21289 m
.70026 .21244 L
s
.70026 .21244 m
.70083 .21244 L
s
.70083 .21244 m
.70064 .21325 L
s
.6238 .32508 m
.62222 .32508 L
s
.62222 .32508 m
.62257 .32351 L
s
.62257 .32351 m
.6238 .32508 L
s
.6208 .33147 m
.61966 .32635 L
s
.61966 .32635 m
.62222 .32508 L
s
.62222 .32508 m
.6208 .33147 L
s
.68749 .18943 m
.68288 .19171 L
s
.68288 .19171 m
.68032 .1802 L
s
.68032 .1802 m
.68863 .18431 L
s
.68863 .18431 m
.68749 .18943 L
s
.66278 .37522 m
.65958 .37111 L
s
.65958 .37111 m
.6642 .36883 L
s
.6642 .36883 m
.66278 .37522 L
s
.75532 .25619 m
.75311 .25903 L
s
.75311 .25903 m
.74957 .25903 L
s
.74957 .25903 m
.74559 .25391 L
s
.74559 .25391 m
.74878 .2498 L
s
.74878 .2498 m
.7539 .2498 L
s
.7539 .2498 m
.75532 .25619 L
s
.65383 .33501 m
.65064 .33659 L
s
.65064 .33659 m
.64666 .33147 L
s
.64666 .33147 m
.65383 .33501 L
s
.64729 .32863 m
.6409 .32863 L
s
.6409 .32863 m
.64808 .32508 L
s
.64808 .32508 m
.64729 .32863 L
s
.62542 .33375 m
.62131 .33375 L
s
.62131 .33375 m
.62108 .33274 L
s
.62108 .33274 m
.6262 .33021 L
s
.6262 .33021 m
.62542 .33375 L
s
.66944 .34526 m
.66818 .34526 L
s
.66818 .34526 m
.6696 .34455 L
s
.6696 .34455 m
.66944 .34526 L
s
.72969 .25061 m
.72896 .25025 L
s
.72896 .25025 m
.72931 .2498 L
s
.72931 .2498 m
.72987 .2498 L
s
.72987 .2498 m
.72969 .25061 L
s
.73955 .26004 m
.73841 .25948 L
s
.73841 .25948 m
.7392 .25847 L
s
.7392 .25847 m
.73955 .26004 L
s
.53559 .02893 m
.53401 .02893 L
s
.53401 .02893 m
.53524 .02735 L
s
.53524 .02735 m
.53559 .02893 L
s
.61087 .26699 m
.6093 .26699 L
s
.6093 .26699 m
.60965 .26541 L
s
.60965 .26541 m
.61087 .26699 L
s
.08234 .08632 m
.08013 .08741 L
s
.08013 .08741 m
.07792 .08632 L
s
.07792 .08632 m
.07738 .08387 L
s
.07738 .08387 m
.07891 .0819 L
s
.07891 .0819 m
.08136 .0819 L
s
.08136 .0819 m
.08289 .08387 L
s
.08289 .08387 m
.08234 .08632 L
s
.73025 .90375 m
.72229 .90375 L
s
.72229 .90375 m
.72406 .89579 L
s
.72406 .89579 m
.73025 .90375 L
s
.64311 .33147 m
.63515 .33147 L
s
.63515 .33147 m
.6409 .32863 L
s
.6409 .32863 m
.64311 .33147 L
s
.34936 .18147 m
.34873 .18431 L
s
.34873 .18431 m
.34298 .18147 L
s
.34298 .18147 m
.34156 .17508 L
s
.34156 .17508 m
.3444 .17508 L
s
.3444 .17508 m
.34936 .18147 L
s
.36052 .44412 m
.36229 .43615 L
s
.36229 .43615 m
.36946 .4397 L
s
.36946 .4397 m
.36052 .44412 L
s
.56732 .04966 m
.55809 .04966 L
s
.55809 .04966 m
.55695 .04454 L
s
.55695 .04454 m
.56527 .04044 L
s
.56527 .04044 m
.56846 .04454 L
s
.56846 .04454 m
.56732 .04966 L
s
.27913 .32351 m
.27771 .31712 L
s
.27771 .31712 m
.28409 .31712 L
s
.28409 .31712 m
.27913 .32351 L
s
.35448 .18715 m
.35334 .18659 L
s
.35334 .18659 m
.35078 .17508 L
s
.35078 .17508 m
.35575 .18147 L
s
.35575 .18147 m
.35448 .18715 L
s
.55332 .02507 m
.55297 .02665 L
s
.55297 .02665 m
.55234 .02381 L
s
.55234 .02381 m
.55332 .02507 L
s
.25328 .31782 m
.25185 .31712 L
s
.25185 .31712 m
.25382 .31712 L
s
.25382 .31712 m
.25328 .31782 L
s
.2692 .3306 m
.26797 .33217 L
s
.26797 .33217 m
.2608 .32863 L
s
.2608 .32863 m
.26876 .32863 L
s
.26876 .32863 m
.2692 .3306 L
s
.29481 .15277 m
.29383 .1515 L
s
.29383 .1515 m
.29525 .1508 L
s
.29525 .1508 m
.29481 .15277 L
s
.90056 .19581 m
.90517 .17508 L
s
.90517 .17508 m
.91668 .17508 L
s
.91668 .17508 m
.90056 .19581 L
s
.93997 .18659 m
.92385 .16585 L
s
.92385 .16585 m
.94458 .16585 L
s
.94458 .16585 m
.93997 .18659 L
s
.34936 .42977 m
.34042 .42535 L
s
.34042 .42535 m
.34759 .4218 L
s
.34759 .4218 m
.34936 .42977 L
s
.88444 .20833 m
.8833 .20321 L
s
.8833 .20321 m
.88649 .19911 L
s
.88649 .19911 m
.8948 .20321 L
s
.8948 .20321 m
.88444 .20833 L
s
.27196 .22679 m
.25584 .21883 L
s
.25584 .21883 m
.26301 .18659 L
s
.26301 .18659 m
.27196 .22679 L
s
.94458 .16585 m
.93422 .16073 L
s
.93422 .16073 m
.94714 .15435 L
s
.94714 .15435 m
.94458 .16585 L
s
.26301 .26699 m
.24291 .27692 L
s
.24291 .27692 m
.22281 .26699 L
s
.22281 .26699 m
.21784 .24468 L
s
.21784 .24468 m
.23175 .22679 L
s
.23175 .22679 m
.25406 .22679 L
s
.25406 .22679 m
.26797 .24468 L
s
.26797 .24468 m
.26301 .26699 L
s
.26797 .24468 m
.24291 .21244 L
s
.24291 .21244 m
.27196 .22679 L
s
.27196 .22679 m
.26797 .24468 L
s
.27196 .29127 m
.24291 .27692 L
s
.24291 .27692 m
.27515 .27692 L
s
.27515 .27692 m
.27196 .29127 L
s
.33943 .20448 m
.32209 .22679 L
s
.32209 .22679 m
.29427 .22679 L
s
.29427 .22679 m
.27692 .20448 L
s
.27692 .20448 m
.28311 .17666 L
s
.28311 .17666 m
.30818 .16428 L
s
.30818 .16428 m
.33324 .17666 L
s
.33324 .17666 m
.33943 .20448 L
s
.69182 .03532 m
.68288 .02381 L
s
.68288 .02381 m
.70077 .02381 L
s
.70077 .02381 m
.69182 .03532 L
s
.6843 .0819 m
.66995 .0819 L
s
.66995 .0819 m
.69005 .05605 L
s
.69005 .05605 m
.6843 .0819 L
s
.7392 .82776 m
.73301 .83572 L
s
.73301 .83572 m
.72804 .81341 L
s
.72804 .81341 m
.7392 .82776 L
s
.66278 .07836 m
.64666 .0704 L
s
.64666 .0704 m
.6789 .0704 L
s
.6789 .0704 m
.66278 .07836 L
s
.21441 .2491 m
.21165 .23672 L
s
.21165 .23672 m
.23175 .22679 L
s
.23175 .22679 m
.21441 .2491 L
s
.661 .0704 m
.64488 .06243 L
s
.64488 .06243 m
.6409 .04454 L
s
.6409 .04454 m
.661 .0704 L
s
.75532 .28488 m
.7392 .27692 L
s
.7392 .27692 m
.74141 .26699 L
s
.74141 .26699 m
.75532 .28488 L
s
.64985 .05605 m
.64587 .03816 L
s
.64587 .03816 m
.65702 .02381 L
s
.65702 .02381 m
.64985 .05605 L
s
.86689 .21244 m
.86177 .21244 L
s
.86177 .21244 m
.86576 .20732 L
s
.86576 .20732 m
.86689 .21244 L
s
.55553 .03816 m
.55439 .03304 L
s
.55439 .03304 m
.55695 .03177 L
s
.55695 .03177 m
.55553 .03816 L
s
.83415 .37806 m
.82953 .38034 L
s
.82953 .38034 m
.82697 .36883 L
s
.82697 .36883 m
.83529 .37294 L
s
.83529 .37294 m
.83415 .37806 L
s
.33722 .32351 m
.3358 .31712 L
s
.3358 .31712 m
.34219 .31712 L
s
.34219 .31712 m
.33722 .32351 L
s
.2692 .29481 m
.26301 .30277 L
s
.26301 .30277 m
.25584 .29923 L
s
.25584 .29923 m
.25406 .29127 L
s
.25406 .29127 m
.25903 .28488 L
s
.25903 .28488 m
.26797 .2893 L
s
.26797 .2893 m
.2692 .29481 L
s
.29702 .33943 m
.28808 .33501 L
s
.28808 .33501 m
.29604 .33501 L
s
.29604 .33501 m
.29702 .33943 L
s
.38302 .19809 m
.37664 .19809 L
s
.37664 .19809 m
.38381 .19455 L
s
.38381 .19455 m
.38302 .19809 L
s
.56015 .04044 m
.55604 .04044 L
s
.55604 .04044 m
.55582 .03942 L
s
.55582 .03942 m
.56094 .03689 L
s
.56094 .03689 m
.56015 .04044 L
s
.31889 .34708 m
.31835 .34779 L
s
.31835 .34779 m
.31791 .34582 L
s
.31791 .34582 m
.31889 .34708 L
s
.87635 .43924 m
.87561 .43888 L
s
.87561 .43888 m
.87597 .43843 L
s
.87597 .43843 m
.87653 .43843 L
s
.87653 .43843 m
.87635 .43924 L
s
.25726 .3127 m
.25548 .31358 L
s
.25548 .31358 m
.25505 .31161 L
s
.25505 .31161 m
.25726 .3127 L
s
.7647 .9583 m
.76313 .9583 L
s
.76313 .9583 m
.76348 .95672 L
s
.76348 .95672 m
.7647 .9583 L
s
.34661 .13645 m
.34503 .13645 L
s
.34503 .13645 m
.34538 .13488 L
s
.34538 .13488 m
.34661 .13645 L
s
.31039 .37964 m
.30818 .38073 L
s
.30818 .38073 m
.30597 .37964 L
s
.30597 .37964 m
.30542 .37718 L
s
.30542 .37718 m
.30695 .37522 L
s
.30695 .37522 m
.3094 .37522 L
s
.3094 .37522 m
.31093 .37718 L
s
.31093 .37718 m
.31039 .37964 L
s
.36946 .19455 m
.36371 .19171 L
s
.36371 .19171 m
.36769 .18659 L
s
.36769 .18659 m
.36946 .19455 L
s
.76107 .89736 m
.75709 .89224 L
s
.75709 .89224 m
.7593 .8894 L
s
.7593 .8894 m
.76107 .89736 L
s
.31933 .37522 m
.31137 .37522 L
s
.31137 .37522 m
.31314 .36725 L
s
.31314 .36725 m
.31933 .37522 L
s
.5782 .07552 m
.57421 .0704 L
s
.57421 .0704 m
.57642 .06756 L
s
.57642 .06756 m
.5782 .07552 L
s
.88188 .20504 m
.87868 .20093 L
s
.87868 .20093 m
.88507 .20093 L
s
.88507 .20093 m
.88188 .20504 L
s
.28532 .33147 m
.2809 .33147 L
s
.2809 .33147 m
.27913 .32351 L
s
.27913 .32351 m
.28532 .33147 L
s
.88905 .41542 m
.88188 .41896 L
s
.88188 .41896 m
.8747 .41542 L
s
.8747 .41542 m
.87293 .40746 L
s
.87293 .40746 m
.87789 .40107 L
s
.87789 .40107 m
.88586 .40107 L
s
.88586 .40107 m
.89082 .40746 L
s
.89082 .40746 m
.88905 .41542 L
s
.60645 .36725 m
.58139 .33501 L
s
.58139 .33501 m
.59751 .32705 L
s
.59751 .32705 m
.60645 .36725 L
s
.65383 .03816 m
.65702 .02381 L
s
.65702 .02381 m
.68288 .02381 L
s
.68288 .02381 m
.65383 .03816 L
s
.63373 .24468 m
.61761 .25264 L
s
.61761 .25264 m
.61363 .23475 L
s
.61363 .23475 m
.63373 .24468 L
s
.65162 .83131 m
.66553 .81341 L
s
.66553 .81341 m
.68784 .81341 L
s
.68784 .81341 m
.65162 .83131 L
s
.58537 .31712 m
.56748 .31712 L
s
.56748 .31712 m
.56129 .30916 L
s
.56129 .30916 m
.5635 .29923 L
s
.5635 .29923 m
.57244 .29481 L
s
.57244 .29481 m
.58139 .29923 L
s
.58139 .29923 m
.58537 .31712 L
s
.7191 .65702 m
.71768 .65064 L
s
.71768 .65064 m
.72406 .65064 L
s
.72406 .65064 m
.7191 .65702 L
s
.71114 .62833 m
.70617 .62194 L
s
.70617 .62194 m
.71256 .62194 L
s
.71256 .62194 m
.71114 .62833 L
s
.54119 .29923 m
.53126 .29923 L
s
.53126 .29923 m
.52507 .29127 L
s
.52507 .29127 m
.52728 .28134 L
s
.52728 .28134 m
.53622 .27692 L
s
.53622 .27692 m
.55234 .28488 L
s
.55234 .28488 m
.54119 .29923 L
s
.71413 .65064 m
.70617 .65064 L
s
.70617 .65064 m
.71015 .64552 L
s
.71015 .64552 m
.71413 .65064 L
s
.69005 .6299 m
.68749 .63117 L
s
.68749 .63117 m
.68658 .62706 L
s
.68658 .62706 m
.69068 .62706 L
s
.69068 .62706 m
.69005 .6299 L
s
.73345 .64425 m
.72627 .6478 L
s
.72627 .6478 m
.73345 .63857 L
s
.73345 .63857 m
.73471 .63857 L
s
.73471 .63857 m
.73345 .64425 L
s
.586 .06345 m
.58303 .06198 L
s
.58303 .06198 m
.58322 .06117 L
s
.58322 .06117 m
.58777 .06117 L
s
.58777 .06117 m
.586 .06345 L
s
.5 .63629 m
.49602 .6184 L
s
.49602 .6184 m
.51612 .62833 L
s
.51612 .62833 m
.5 .63629 L
s
.7887 .02893 m
.78665 .02792 L
s
.78665 .02792 m
.78756 .02381 L
s
.78756 .02381 m
.7887 .02893 L
s
.79331 .03121 m
.7887 .02893 L
s
.7887 .02893 m
.78756 .02381 L
s
.78756 .02381 m
.79907 .02381 L
s
.79907 .02381 m
.79331 .03121 L
s
.59254 .04682 m
.58856 .05194 L
s
.58856 .05194 m
.58025 .04784 L
s
.58025 .04784 m
.586 .04044 L
s
.586 .04044 m
.59175 .04328 L
s
.59175 .04328 m
.59254 .04682 L
s
.61044 .07552 m
.60468 .07268 L
s
.60468 .07268 m
.6098 .07268 L
s
.6098 .07268 m
.61044 .07552 L
s
.699 .65418 m
.69324 .65702 L
s
.69324 .65702 m
.69182 .65064 L
s
.69182 .65064 m
.699 .65418 L
s
.60468 .07268 m
.60007 .0704 L
s
.60007 .0704 m
.60645 .0704 L
s
.60645 .0704 m
.60468 .07268 L
s
.13744 .07678 m
.13681 .07962 L
s
.13681 .07962 m
.13105 .07678 L
s
.13105 .07678 m
.12963 .0704 L
s
.12963 .0704 m
.13247 .0704 L
s
.13247 .0704 m
.13744 .07678 L
s
.77833 .06528 m
.77925 .06117 L
s
.77925 .06117 m
.78153 .06117 L
s
.78153 .06117 m
.77833 .06528 L
s
.77656 .08601 m
.77258 .09113 L
s
.77258 .09113 m
.77514 .07962 L
s
.77514 .07962 m
.77656 .08601 L
s
.45208 .56581 m
.45085 .56739 L
s
.45085 .56739 m
.44368 .56385 L
s
.44368 .56385 m
.45164 .56385 L
s
.45164 .56385 m
.45208 .56581 L
s
.08289 .04809 m
.0819 .04682 L
s
.0819 .04682 m
.08332 .04612 L
s
.08332 .04612 m
.08289 .04809 L
s
.53941 .66853 m
.52329 .66057 L
s
.52329 .66057 m
.5434 .65064 L
s
.5434 .65064 m
.53941 .66853 L
s
.51116 .30916 m
.50496 .31712 L
s
.50496 .31712 m
.49504 .31712 L
s
.49504 .31712 m
.48884 .30916 L
s
.48884 .30916 m
.49105 .29923 L
s
.49105 .29923 m
.50717 .29127 L
s
.50717 .29127 m
.51116 .30916 L
s
.72406 .68642 m
.7191 .68004 L
s
.7191 .68004 m
.72548 .68004 L
s
.72548 .68004 m
.72406 .68642 L
s
.70298 .688 m
.70042 .68926 L
s
.70042 .68926 m
.6995 .68516 L
s
.6995 .68516 m
.70361 .68516 L
s
.70361 .68516 m
.70298 .688 L
s
.03212 .02792 m
.02637 .02507 L
s
.02637 .02507 m
.02609 .02381 L
s
.02609 .02381 m
.03177 .02381 L
s
.03177 .02381 m
.03276 .02507 L
s
.03276 .02507 m
.03212 .02792 L
s
.55695 .02609 m
.55399 .02462 L
s
.55399 .02462 m
.55417 .02381 L
s
.55417 .02381 m
.55873 .02381 L
s
.55873 .02381 m
.55695 .02609 L
s
.46201 .57465 m
.46378 .56669 L
s
.46378 .56669 m
.47095 .57023 L
s
.47095 .57023 m
.46201 .57465 L
s
.60724 .02792 m
.60468 .03121 L
s
.60468 .03121 m
.59802 .02792 L
s
.59802 .02792 m
.59893 .02381 L
s
.59893 .02381 m
.60633 .02381 L
s
.60633 .02381 m
.60724 .02792 L
s
.55234 .67492 m
.55092 .66853 L
s
.55092 .66853 m
.55731 .66853 L
s
.55731 .66853 m
.55234 .67492 L
s
.72485 .65418 m
.72229 .65292 L
s
.72229 .65292 m
.72627 .6478 L
s
.72627 .6478 m
.73266 .6478 L
s
.73266 .6478 m
.73203 .65064 L
s
.73203 .65064 m
.72485 .65418 L
s
.5897 .06528 m
.59062 .06117 L
s
.59062 .06117 m
.59289 .06117 L
s
.59289 .06117 m
.5897 .06528 L
s
.78693 .03942 m
.78295 .04454 L
s
.78295 .04454 m
.78551 .03304 L
s
.78551 .03304 m
.78693 .03942 L
s
.57863 .72859 m
.57741 .73017 L
s
.57741 .73017 m
.57023 .72662 L
s
.57023 .72662 m
.5782 .72662 L
s
.5782 .72662 m
.57863 .72859 L
s
.82732 .41188 m
.82555 .411 L
s
.82555 .411 m
.82697 .4103 L
s
.82697 .4103 m
.82732 .41188 L
s
.49425 .61044 m
.47813 .60247 L
s
.47813 .60247 m
.49823 .59254 L
s
.49823 .59254 m
.49425 .61044 L
s
.03788 .03076 m
.03674 .0302 L
s
.03674 .0302 m
.03532 .02381 L
s
.03532 .02381 m
.03816 .02381 L
s
.03816 .02381 m
.03914 .02507 L
s
.03914 .02507 m
.03788 .03076 L
s
.56065 .02792 m
.56157 .02381 L
s
.56157 .02381 m
.56385 .02381 L
s
.56385 .02381 m
.56065 .02792 L
s
.5951 .04353 m
.59432 .04454 L
s
.59432 .04454 m
.59482 .04226 L
s
.59482 .04226 m
.5951 .04353 L
s
.52649 .66923 m
.52507 .66853 L
s
.52507 .66853 m
.52703 .66853 L
s
.52703 .66853 m
.52649 .66923 L
s
.54241 .682 m
.54119 .68358 L
s
.54119 .68358 m
.53401 .68004 L
s
.53401 .68004 m
.54197 .68004 L
s
.54197 .68004 m
.54241 .682 L
s
.58714 .06401 m
.586 .06345 L
s
.586 .06345 m
.58679 .06243 L
s
.58679 .06243 m
.58714 .06401 L
s
.586 .06345 m
.58395 .06446 L
s
.58395 .06446 m
.58139 .06117 L
s
.58139 .06117 m
.586 .06345 L
s
.72627 .62478 m
.71192 .62478 L
s
.71192 .62478 m
.71335 .6184 L
s
.71335 .6184 m
.7191 .61556 L
s
.7191 .61556 m
.72627 .62478 L
s
.57421 .70873 m
.56846 .70589 L
s
.56846 .70589 m
.57244 .70077 L
s
.57244 .70077 m
.57421 .70873 L
s
.82378 .39595 m
.8198 .40107 L
s
.8198 .40107 m
.81263 .39753 L
s
.81263 .39753 m
.81164 .39311 L
s
.81164 .39311 m
.8144 .38956 L
s
.8144 .38956 m
.82236 .38956 L
s
.82236 .38956 m
.82378 .39595 L
s
.59432 .04454 m
.59318 .03942 L
s
.59318 .03942 m
.59574 .03816 L
s
.59574 .03816 m
.59432 .04454 L
s
.59318 .04966 m
.59637 .04556 L
s
.59637 .04556 m
.59893 .04682 L
s
.59893 .04682 m
.59318 .04966 L
s
.58076 .06036 m
.58025 .0597 L
s
.58025 .0597 m
.5823 .05706 L
s
.5823 .05706 m
.58486 .05833 L
s
.58486 .05833 m
.58076 .06036 L
s
.58095 .73901 m
.57918 .73813 L
s
.57918 .73813 m
.58076 .73813 L
s
.58076 .73813 m
.58095 .73901 L
s
.82918 .42023 m
.82875 .42079 L
s
.82875 .42079 m
.82811 .41998 L
s
.82811 .41998 m
.82903 .41953 L
s
.82903 .41953 m
.82918 .42023 L
s
.81519 .41156 m
.8142 .4103 L
s
.8142 .4103 m
.81617 .4103 L
s
.81617 .4103 m
.81519 .41156 L
s
.12707 .07166 m
.12609 .0704 L
s
.12609 .0704 m
.12805 .0704 L
s
.12805 .0704 m
.12707 .07166 L
s
.61619 .10137 m
.61505 .10081 L
s
.61505 .10081 m
.61584 .0998 L
s
.61584 .0998 m
.61619 .10137 L
s
.53843 .31161 m
.53622 .3127 L
s
.53622 .3127 m
.53401 .31161 L
s
.53401 .31161 m
.53347 .30916 L
s
.53347 .30916 m
.53499 .30719 L
s
.53499 .30719 m
.53745 .30719 L
s
.53745 .30719 m
.53898 .30916 L
s
.53898 .30916 m
.53843 .31161 L
s
.71192 .67649 m
.70617 .67365 L
s
.70617 .67365 m
.71015 .66853 L
s
.71015 .66853 m
.71192 .67649 L
s
.59318 .04966 m
.58856 .05194 L
s
.58856 .05194 m
.59254 .04682 L
s
.59254 .04682 m
.59318 .04966 L
s
.44589 .09625 m
.41684 .0819 L
s
.41684 .0819 m
.42579 .0704 L
s
.42579 .0704 m
.44589 .09625 L
s
.83273 .22679 m
.81661 .21883 L
s
.81661 .21883 m
.82953 .21244 L
s
.82953 .21244 m
.83273 .22679 L
s
.84565 .23317 m
.83273 .22679 L
s
.83273 .22679 m
.82953 .21244 L
s
.82953 .21244 m
.84565 .23317 L
s
.0851 .05093 m
.08446 .05377 L
s
.08446 .05377 m
.07871 .05093 L
s
.07871 .05093 m
.07729 .04454 L
s
.07729 .04454 m
.08013 .04454 L
s
.08013 .04454 m
.0851 .05093 L
s
.58856 .73743 m
.59033 .72947 L
s
.59033 .72947 m
.59751 .73301 L
s
.59751 .73301 m
.58856 .73743 L
s
.77719 .11186 m
.77463 .11516 L
s
.77463 .11516 m
.76797 .11186 L
s
.76797 .11186 m
.76888 .10776 L
s
.76888 .10776 m
.77628 .10776 L
s
.77628 .10776 m
.77719 .11186 L
s
.50717 .61682 m
.50575 .61044 L
s
.50575 .61044 m
.51214 .61044 L
s
.51214 .61044 m
.50717 .61682 L
s
.09022 .05661 m
.08908 .05605 L
s
.08908 .05605 m
.08652 .04454 L
s
.08652 .04454 m
.09148 .05093 L
s
.09148 .05093 m
.09022 .05661 L
s
.76505 .12748 m
.76427 .12849 L
s
.76427 .12849 m
.76477 .12621 L
s
.76477 .12621 m
.76505 .12748 L
s
.48132 .61114 m
.4799 .61044 L
s
.4799 .61044 m
.48187 .61044 L
s
.48187 .61044 m
.48132 .61114 L
s
.49724 .62391 m
.49602 .62549 L
s
.49602 .62549 m
.48884 .62194 L
s
.48884 .62194 m
.49681 .62194 L
s
.49681 .62194 m
.49724 .62391 L
s
.55809 .02665 m
.55695 .02609 L
s
.55695 .02609 m
.55774 .02507 L
s
.55774 .02507 m
.55809 .02665 L
s
.81085 .38956 m
.80368 .35732 L
s
.80368 .35732 m
.81661 .36371 L
s
.81661 .36371 m
.81085 .38956 L
s
.77144 .35732 m
.77719 .33147 L
s
.77719 .33147 m
.80049 .34298 L
s
.80049 .34298 m
.77144 .35732 L
s
.57741 .72308 m
.56846 .71866 L
s
.56846 .71866 m
.57564 .71512 L
s
.57564 .71512 m
.57741 .72308 L
s
.82634 .40746 m
.82236 .41258 L
s
.82236 .41258 m
.81341 .40107 L
s
.81341 .40107 m
.82492 .40107 L
s
.82492 .40107 m
.82634 .40746 L
s
.5 .5201 m
.48388 .51214 L
s
.48388 .51214 m
.49105 .4799 L
s
.49105 .4799 m
.5 .5201 L
s
.79154 .33147 m
.77719 .33147 L
s
.77719 .33147 m
.78039 .31712 L
s
.78039 .31712 m
.79154 .33147 L
s
.49105 .5603 m
.47095 .57023 L
s
.47095 .57023 m
.45085 .5603 L
s
.45085 .5603 m
.44589 .53799 L
s
.44589 .53799 m
.4598 .5201 L
s
.4598 .5201 m
.48211 .5201 L
s
.48211 .5201 m
.49602 .53799 L
s
.49602 .53799 m
.49105 .5603 L
s
.49602 .53799 m
.47095 .50575 L
s
.47095 .50575 m
.5 .5201 L
s
.5 .5201 m
.49602 .53799 L
s
.5 .58458 m
.47095 .57023 L
s
.47095 .57023 m
.50319 .57023 L
s
.50319 .57023 m
.5 .58458 L
s
.56748 .49779 m
.55013 .5201 L
s
.55013 .5201 m
.52231 .5201 L
s
.52231 .5201 m
.50496 .49779 L
s
.50496 .49779 m
.51116 .46997 L
s
.51116 .46997 m
.53622 .45759 L
s
.53622 .45759 m
.56129 .46997 L
s
.56129 .46997 m
.56748 .49779 L
s
.81803 .21244 m
.80368 .21244 L
s
.80368 .21244 m
.81484 .19809 L
s
.81484 .19809 m
.81803 .21244 L
s
.83848 .22395 m
.82953 .21244 L
s
.82953 .21244 m
.86177 .21244 L
s
.86177 .21244 m
.83848 .22395 L
s
.83095 .27053 m
.81661 .27053 L
s
.81661 .27053 m
.83671 .24468 L
s
.83671 .24468 m
.83095 .27053 L
s
.67393 .53445 m
.66774 .54241 L
s
.66774 .54241 m
.66278 .5201 L
s
.66278 .5201 m
.67393 .53445 L
s
.80943 .26699 m
.79331 .25903 L
s
.79331 .25903 m
.82555 .25903 L
s
.82555 .25903 m
.80943 .26699 L
s
.44245 .54241 m
.4397 .53003 L
s
.4397 .53003 m
.4598 .5201 L
s
.4598 .5201 m
.44245 .54241 L
s
.80766 .25903 m
.79154 .25107 L
s
.79154 .25107 m
.78756 .23317 L
s
.78756 .23317 m
.80766 .25903 L
s
.49105 .15435 m
.47493 .14638 L
s
.47493 .14638 m
.47714 .13645 L
s
.47714 .13645 m
.49105 .15435 L
s
.79651 .24468 m
.79252 .22679 L
s
.79252 .22679 m
.80368 .21244 L
s
.80368 .21244 m
.79651 .24468 L
s
.84565 .42977 m
.8399 .42693 L
s
.8399 .42693 m
.84388 .4218 L
s
.84388 .4218 m
.84565 .42977 L
s
.76797 .12211 m
.76591 .12109 L
s
.76591 .12109 m
.76683 .11699 L
s
.76683 .11699 m
.76797 .12211 L
s
.48707 .31712 m
.47095 .30916 L
s
.47095 .30916 m
.48388 .30277 L
s
.48388 .30277 m
.48884 .30916 L
s
.48884 .30916 m
.48707 .31712 L
s
.56527 .61682 m
.56385 .61044 L
s
.56385 .61044 m
.57023 .61044 L
s
.57023 .61044 m
.56527 .61682 L
s
.49724 .58812 m
.49105 .59609 L
s
.49105 .59609 m
.48388 .59254 L
s
.48388 .59254 m
.48211 .58458 L
s
.48211 .58458 m
.48707 .5782 L
s
.48707 .5782 m
.49602 .58261 L
s
.49602 .58261 m
.49724 .58812 L
s
.52507 .63275 m
.51612 .62833 L
s
.51612 .62833 m
.52408 .62833 L
s
.52408 .62833 m
.52507 .63275 L
s
.11876 .06756 m
.11237 .06756 L
s
.11237 .06756 m
.11955 .06401 L
s
.11955 .06401 m
.11876 .06756 L
s
.77116 .118 m
.76705 .11597 L
s
.76705 .11597 m
.76723 .11516 L
s
.76723 .11516 m
.77053 .11516 L
s
.77053 .11516 m
.77116 .118 L
s
.54694 .6404 m
.54639 .6411 L
s
.54639 .6411 m
.54596 .63913 L
s
.54596 .63913 m
.54694 .6404 L
s
.60228 .31586 m
.60114 .31642 L
s
.60114 .31642 m
.60094 .31555 L
s
.60094 .31555 m
.60149 .31484 L
s
.60149 .31484 m
.60228 .31586 L
s
.4853 .60602 m
.48353 .60689 L
s
.48353 .60689 m
.48309 .60493 L
s
.48309 .60493 m
.4853 .60602 L
s
.69944 .66499 m
.69786 .66499 L
s
.69786 .66499 m
.69821 .66341 L
s
.69821 .66341 m
.69944 .66499 L
s
.5983 .03942 m
.59802 .03816 L
s
.59802 .03816 m
.59928 .03816 L
s
.59928 .03816 m
.5983 .03942 L
s
.53843 .67295 m
.53622 .67404 L
s
.53622 .67404 m
.53401 .67295 L
s
.53401 .67295 m
.53347 .6705 L
s
.53347 .6705 m
.53499 .66853 L
s
.53499 .66853 m
.53745 .66853 L
s
.53745 .66853 m
.53898 .6705 L
s
.53898 .6705 m
.53843 .67295 L
s
.1052 .06401 m
.09944 .06117 L
s
.09944 .06117 m
.10343 .05605 L
s
.10343 .05605 m
.1052 .06401 L
s
.6958 .60405 m
.69182 .59893 L
s
.69182 .59893 m
.69403 .59609 L
s
.69403 .59609 m
.6958 .60405 L
s
.54738 .66853 m
.53941 .66853 L
s
.53941 .66853 m
.54119 .66057 L
s
.54119 .66057 m
.54738 .66853 L
s
.78358 .09341 m
.78181 .09113 L
s
.78181 .09113 m
.785 .08702 L
s
.785 .08702 m
.78358 .09341 L
s
.83273 .40746 m
.82697 .4103 L
s
.82697 .4103 m
.82555 .40391 L
s
.82555 .40391 m
.83273 .40746 L
s
.51336 .62478 m
.50895 .62478 L
s
.50895 .62478 m
.50717 .61682 L
s
.50717 .61682 m
.51336 .62478 L
s
.73025 .64268 m
.72406 .65064 L
s
.72406 .65064 m
.71413 .65064 L
s
.71413 .65064 m
.70794 .64268 L
s
.70794 .64268 m
.71015 .63275 L
s
.71015 .63275 m
.7191 .62833 L
s
.7191 .62833 m
.72804 .63275 L
s
.72804 .63275 m
.73025 .64268 L
s
.70298 .70077 m
.68509 .70077 L
s
.68509 .70077 m
.69403 .66057 L
s
.69403 .66057 m
.70298 .70077 L
s
.86177 .32863 m
.85283 .31712 L
s
.85283 .31712 m
.86895 .29639 L
s
.86895 .29639 m
.86177 .32863 L
s
.17047 .09625 m
.15435 .08829 L
s
.15435 .08829 m
.1655 .07394 L
s
.1655 .07394 m
.17047 .09625 L
s
.86177 .30562 m
.84885 .29923 L
s
.84885 .29923 m
.84565 .28488 L
s
.84565 .28488 m
.86177 .30562 L
s
.51214 .16869 m
.50895 .15435 L
s
.50895 .15435 m
.54119 .15435 L
s
.54119 .15435 m
.51214 .16869 L
s
.81661 .74097 m
.78437 .74097 L
s
.78437 .74097 m
.78039 .72308 L
s
.78039 .72308 m
.81661 .74097 L
s
.66278 .16585 m
.65383 .15435 L
s
.65383 .15435 m
.67172 .15435 L
s
.67172 .15435 m
.66278 .16585 L
s
.80943 .77321 m
.79828 .75886 L
s
.79828 .75886 m
.80226 .74097 L
s
.80226 .74097 m
.80943 .77321 L
s
.4598 .11414 m
.45262 .0819 L
s
.45262 .0819 m
.46697 .0819 L
s
.46697 .0819 m
.4598 .11414 L
s
.80049 .22679 m
.80368 .21244 L
s
.80368 .21244 m
.82953 .21244 L
s
.82953 .21244 m
.80049 .22679 L
s
.36946 .11414 m
.35334 .12211 L
s
.35334 .12211 m
.34936 .10421 L
s
.34936 .10421 m
.36946 .11414 L
s
.81803 .21244 m
.81484 .19809 L
s
.81484 .19809 m
.82378 .18659 L
s
.82378 .18659 m
.81803 .21244 L
s
.59254 .42977 m
.53622 .45759 L
s
.53622 .45759 m
.4799 .42977 L
s
.4799 .42977 m
.46599 .36725 L
s
.46599 .36725 m
.50496 .31712 L
s
.50496 .31712 m
.56748 .31712 L
s
.56748 .31712 m
.60645 .36725 L
s
.60645 .36725 m
.59254 .42977 L
s
.5201 .28488 m
.5 .25903 L
s
.5 .25903 m
.51612 .26699 L
s
.51612 .26699 m
.5201 .28488 L
s
.75532 .61044 m
.75134 .59254 L
s
.75134 .59254 m
.76427 .59893 L
s
.76427 .59893 m
.75532 .61044 L
s
.7191 .59254 m
.72485 .56669 L
s
.72485 .56669 m
.74815 .5782 L
s
.74815 .5782 m
.7191 .59254 L
s
.45085 .5603 m
.44191 .55588 L
s
.44191 .55588 m
.44908 .55234 L
s
.44908 .55234 m
.45085 .5603 L
s
.51931 .31712 m
.51214 .31358 L
s
.51214 .31358 m
.51037 .30562 L
s
.51037 .30562 m
.52329 .29923 L
s
.52329 .29923 m
.51931 .31712 L
s
.71512 .61044 m
.70936 .58458 L
s
.70936 .58458 m
.72229 .5782 L
s
.72229 .5782 m
.71512 .61044 L
s
.74815 .5782 m
.72485 .56669 L
s
.72485 .56669 m
.72804 .55234 L
s
.72804 .55234 m
.74815 .5782 L
s
.7191 .56385 m
.699 .5897 L
s
.699 .5897 m
.6789 .56385 L
s
.6789 .56385 m
.68288 .54596 L
s
.68288 .54596 m
.699 .53799 L
s
.699 .53799 m
.71512 .54596 L
s
.71512 .54596 m
.7191 .56385 L
s
.72229 .5782 m
.71512 .54596 L
s
.71512 .54596 m
.72804 .55234 L
s
.72804 .55234 m
.72229 .5782 L
s
.45483 .25264 m
.44191 .25903 L
s
.44191 .25903 m
.43473 .22679 L
s
.43473 .22679 m
.45483 .25264 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
      GeneratedCell->False,
      CellAutoOverwrite->False,
      ImageSize->{441, 441},
      ImageMargins->{{0, 0}, {0, 0}},
      ImageRegion->{{0, 1}, {0, 1}},
      ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006i0001^B000`400?l00000o`00003oo`3ooonj
0?ooo`00o`3ooonj0?ooo`00o`3ooonj0?ooo`00o`3ooonj0?ooo`00o`3ooonj0?ooo`00o`3ooonj
0?ooo`00o`3ooonj0?ooo`00o`3ooonj0?ooo`00o`3ooonj0?ooo`00o`3ooonj0?ooo`00o`3ooonj
0?ooo`002P3ooooo00000:D000002`3oool000/0oooo0P0000001`3<ol`000000000003<ol`00000
0<coc00000000P3<ol`2000000D0c?o<00<000000<coc0000000103<ol`00`000000c?o<0<coc004
0<coc0030000003<ol`0c?o<00<0c?o<00<000000<coc03<ol`00P3<ol`3000000P0c?o<0P000000
0`3<ol`000000<coc0090<coc0<000004P3<ol`00`000000c?o<0<coc0040<coc0030000003<ol`0
c?o<00T0c?o<0P00000;0<coc0030000003<ol`0c?o<00@0c?o<00<000000<coc03<ol`00P3<ol`0
0`000000c?o<0<coc0030<coc0<000004`3<ol`00`000000c?o<0<coc0030<coc0030000003<ol`0
c?o<0080c?o<0`0000080<coc080000000<0c?o<0000003<ol`02@3<ol`3000000@0c?o<0P000000
0`3<ol`000000<coc0020<coc0030000003<ol`0c?o<00@0c?o<00<000000<coc03<ol`00`3<ol`2
000000<0c?o<200000020<coc08000000P3<ol`00`000000c?o<000000040<coc0<000000P3<ol`2
000000L0c?o<00D000000<coc03<ol`0c?o<000000060<coc0@000001`3<ol`3000000030<coc000
0000c?o<00@0c?o<00<000000<coc03<ol`00P3<ol`2000001<0c?o<00<000000<coc03<ol`00`3<
ol`00`000000c?o<0<coc0020<coc0<000000`3<c?l00`000000c<co0<c<o`090<c<o`030000003<
c?l0c<co00@0c<co0`00000P0<c<o`030000003<c?l0c<co0080c<co00<000000<c<o`3<c?l01@3<
c?l00`000000c<co0<c<o`040<c<o`<000000P3<c?l00`000000oooo0?ooo`090?ooo`00303oool7
000000<0c?o<0P0000050<coc0<00000103<ol`00`000000c?o<0<coc0040<coc08000000`3<ol`0
10000000c?o<0<coc03<ol`200000080c?o<00<000000<coc03<ol`0103<ol`2000000@0c?o<00<0
00000<coc03<ol`01@3<ol`2000000030<coc0000000c?o<0180c?o<0P0000040<coc0<00000203<
ol`3000000`0c?o<00<000000<coc03<ol`00`3<ol`2000000D0c?o<00<000000<coc03<ol`00P00
00000`3<ol`000000<coc00D0<coc0050000003<ol`0c?o<0<coc00000000`3<ol`200000080c?o<
00<000000<coc03<ol`0103<ol`2000000@0c?o<00<000000<coc03<ol`01@3<ol`2000000030<co
c0000000c?o<00@0c?o<0`0000040<coc0030000003<ol`0c?o<00D0c?o<00@000000<coc03<ol`0
c?o<1`0000001@3<ol`00000000000000000c?o<008000000P3<ol`00`000000c?o<0<coc0020<co
c0800000103<ol`4000000030<coc0000000000000P0c?o<00@000000<coc03<ol`00000103<ol`2
000000030<coc0000000000000H0c?o<0`0000040<coc0050000003<ol`0c?o<0<coc00000000`3<
ol`3000001D0c?o<00D000000<coc03<ol`0c?o<000000030<coc08000000P3<ol`2000000030<c<
o`000000000000/0c<co00<000000<c<o`3<c?l00P3<c?l2000000030<c<o`000000c<co0240c<co
00<000000<c<o`3<c?l00P0000060<c<o`030000003<c?l0c<co00H0c<co0P0000020<c<o`030000
003oool0oooo00T0oooo000=0?ooo`030000003oc<`0000000<000000`3<ol`00`000000c?o<0<co
c0050<coc0800000103<ol`00`000000c?o<0<coc0050<coc0060000003<ol`0c?o<0<coc0000000
c?o<0P0000030<coc0030000003<ol`0c?o<00<0c?o<0`0000050<coc0800000103<ol`2000000<0
c?o<00<000000<coc03<ol`04P3<ol`00`000000c?o<0<coc0020<coc0030000003<ol`0000000H0
c?o<0P0000020<coc0030000003<ol`0c?o<00/0c?o<00<000000<coc03<ol`00P3<ol`3000000D0
c?o<0P0000020<coc08000005@3<ol`01P000000c?o<0<coc03<ol`000000<coc08000000`3<ol`0
0`000000c?o<0<coc0030<coc0<000001@3<ol`2000000@0c?o<0P0000030<coc0030000003<ol`0
c?o<00@0c?o<0P0000040<coc08000001P3<ol`2000000040<coc000000000000<coc0<000000`3<
ol`2000000030<coc0000000000000D000000P3<ol`2000000H0c?o<00<000000<coc00000000P00
00090<coc0060000003<ol`000000<coc0000000c?o<0P0000020<coc0030000003<ol`0000000@0
c?o<0`0000060<coc0060000003<ol`0c?o<0<coc0000000c?o<0P0000020<coc0030000003<ol`0
c?o<01<0c?o<00H000000<coc03<ol`0c?o<0000003<ol`2000000<0c?o<00<000000<coc0000000
0P00000;0<c<o`040000003<c?l000000<c<o`8000000P3<c?l200000280c<co00H000000<c<o`3<
c?l000000<c<o`0000050<c<o`030000003<c?l0c<co00L0c<co00<000000<c<o`000000303oool0
00d0oooo00@000000?o<c03oc<`0olc<0`0000000`3<ol`000000<coc0070<coc0@0000000@0c?o<
00000000000000001P3<ol`2000000040<coc00000000000000000D0c?o<00@000000<coc03<ol`0
c?o<0P0000030<coc0800000103<ol`2000000030<coc0000000000000@0c?o<00<000000<coc03<
ol`0503<ol`01`000000c?o<0<coc03<ol`000000<coc0000000103<ol`2000000<0c?o<00<00000
0<coc03<ol`03@3<ol`01`000000c?o<0<coc03<ol`000000<coc00000000`3<ol`2000000@0c?o<
00<000000<coc03<ol`05@3<ol`00`000000c?o<00000002000000D0c?o<00@000000<coc03<ol`0
c?o<0P0000030<coc0800000103<ol`2000000030<coc0000000000000@0c?o<00<000000<coc03<
ol`01@3<ol`3000000@0c?o<00<000000<coc03<ol`01@3<ol`00`000000c?o<00000003000000D0
c?o<1`0000000`3<ol`0000000000004000000H0c?o<00@000000<coc000000000002`3<ol`20000
00030<coc0000000000000<0c?o<0P000000103<ol`000000<coc03<ol`2000000<0c?o<0P000005
0<coc0030000003<ol`00000008000000`3<ol`00`000000c?o<0<coc00E0<coc0030000003<ol`0
000000<00000103<ol`010000000c?o<00000000000<0<c<o`040000003<c?l00000000000<0c<co
0P00000T0<c<o`8000000P3<c?l00`000000c<co0<c<o`020<c<o`030000003<c?l0c<co00T0c<co
0P00000<0?ooo`003P3oool4000000040?o<c00000000000000000L0c?o<00<000000<coc03<ol`0
1P0000050<coc080000000<0c?o<0000000000001`3<ol`010000000c?o<0000000000070<coc080
00000`3<ol`2000000D0c?o<00<000000<coc03<ol`05P3<ol`01@000000c?o<0<coc0000000c?o<
0080000000<0c?o<000000000000103<ol`00`000000c?o<0<coc00?0<coc0070000003<ol`0c?o<
0000003<ol`000000<coc002000000D0c?o<00<000000<coc03<ol`05`3<ol`2000000L0c?o<00@0
00000<coc000000000001`3<ol`2000000<0c?o<0P0000050<coc0030000003<ol`0c?o<00H0c?o<
00<000000<coc00000001@0000060<coc0030000003<ol`00000008000001`3<ol`5000000030<co
c0000000c?o<0080c?o<100000060<coc0<000003@3<ol`00`000000c?o<000000040<coc0030000
003<ol`0000000<000001`3<ol`2000000@0c?o<0P0000040<coc0030000003<ol`0c?o<01L0c?o<
0P0000030<coc0040000003<ol`0c?o<0<coc0<000003@3<c?l00`000000c<co000000040<c<o`03
0000003<c?l0c<co02@0c<co00@000000<c<o`3<c?l000000`3<c?l00`000000c<co0<c<o`0;0<c<
o`030000003oool0oooo00X0oooo000?0?ooo`80000000@0olc<0000003oc<`0olc<0`0000050<co
c0030000003<ol`0c?o<008000000`3<ol`00`000000c?o<0<coc0030<coc0D000001`3<ol`20000
00/0c?o<0P0000020<coc0030000003<ol`0c?o<0080c?o<00<000000<coc03<ol`05`3<ol`30000
0080c?o<0`0000050<coc0030000003<ol`0c?o<0100c?o<00D000000<coc000000000000<coc009
000001/0c?o<00<000000<coc03<ol`01@3<ol`2000000/0c?o<0P0000020<coc0030000003<ol`0
c?o<0080c?o<00@000000<coc000000000001@3<ol`2000000030<coc0000000000000<0c?o<00<0
00000<coc03<ol`0103<ol`3000000P0c?o<00D000000<coc03<ol`000000<coc003000000030<co
c000000000000080c?o<0P0000050<coc0@000003@3<ol`00`000000c?o<000000030<coc0030000
003<ol`0c?o<008000002`3<ol`2000000<0c?o<00D000000<coc03<ol`0c?o<0000000K0<coc005
0000003<ol`0c?o<0<coc00000000`3<ol`3000000d0c<co00<000000<c<o`0000000`3<c?l00`00
0000c<co0<c<o`0V0<c<o`030000003<c?l000000080c<co0P00000=0<c<o`030000003oool0oooo
00X0oooo000@0?ooo`<00000103oc<`3000000040<coc00000000000000000<0c?o<0P0000020<co
c0<0000000<0c?o<0000000000000P0000030<coc0030000003<ol`0c?o<00<0c?o<0P00000>0<co
c080000000@0c?o<0000003<ol`0c?o<0P00000J0<coc08000000P3<ol`2000000D0c?o<0P00000C
0<coc08000000P3<ol`00`000000c?o<0<coc0040<coc0030000003<ol`0c?o<01X0c?o<0P000005
0<coc08000003P3<ol`2000000030<coc0000000c?o<0080c?o<00<000000<coc03<ol`00`000002
0<coc0<000000P3<ol`200000080c?o<0`0000020<coc0<000002P3<ol`00`000000c?o<0<coc003
000000040<coc00000000000000000D0c?o<0P0000020<coc0H00000303<ol`01@000000c?o<0<co
c0000000c?o<008000000P3<ol`00`000000c?o<0<coc00;0<coc0<0000000@0c?o<0000003<ol`0
c?o<0P00000K0<coc08000000P3<ol`00`000000c?o<0<coc003000000030<coc0000000c<co00/0
c<co00D000000<c<o`3<c?l000000<c<o`02000002P0c<co0P0000000`3<c?l00000000000020000
00`0c<co00<000000?ooo`3oool02`3oool00100oooo00<000000?o<c00000001P3oc<`4000000D0
c?o<00<000000<coc03<ol`0100000020<coc08000000`3<ol`00`000000c?o<0<coc0030<coc003
0000003<ol`0c?o<00l0c?o<0`0000000`3<ol`000000<coc00K0<coc0050000003<ol`0c?o<0<co
c00000001@3<ol`00`000000c?o<0<coc00C0<coc0030000003<ol`0c?o<00800000103<ol`20000
01d0c?o<00<000000<coc03<ol`00`3<ol`00`000000c?o<0<coc00?0<coc0<0000000<0c?o<0000
003<ol`00`3<ol`01P000000c?o<000000000000c?o<000000@0c?o<00H000000<coc03<ol`0c?o<
0000003<ol`@00000080c?o<00D000000<coc000000000000<coc002000000D0c?o<00D000000<co
c000000000000<coc00200000080c?o<00<000000<coc03<ol`02@3<ol`200000080c?o<0P000000
0`3<ol`000000<coc002000000d0c?o<00<000000<coc03<ol`00`0000000`3<ol`000000<coc00L
0<coc0040000003<ol`0c?o<00000080c?o<0P0000020<coc0030000003<c?l0c<co00X0c<co00<0
00000<c<o`3<c?l00`00000Z0<c<o`@0000000<0c<co0000000000002`3<c?l00`000000oooo0?oo
o`0;0?ooo`004@3oool2000000@0olc<0`0000000`3oc<`000000000000;000000<0c?o<00<00000
0<coc03<ol`00`3<ol`00`000000c?o<0<coc0020<coc0030000003<ol`0c?o<0140c?o<0P00000N
0<coc0040000003<ol`0c?o<000000@0c?o<0P00000E0<coc0050000003<ol`0c?o<0<coc0000000
103<ol`00`000000c?o<0<coc00M0<coc0030000003<ol`0c?o<0080c?o<00<000000<coc03<ol`0
4@3<ol`3000000<0c?o<0P0000030<coc0P0000000<0c?o<0000000000000P0000000`3<ol`00000
0000000:0<coc080000000<0c?o<0000000000000P0000030<coc0030000003<ol`0c?o<00<0c?o<
00@000000<coc03<ol`0c?o<0P0000030<coc0030000003<ol`0c?o<00T0c?o<00D000000<coc03<
ol`0c?o<000000020<coc0030000003<ol`0000000l0c?o<00@000000<coc03<ol`0c?o<0P00000O
0<coc0050000003<ol`0c?o<0000003<ol`00P0000020<coc0030000003<c?l0c<co00T0c<co00@0
00000<c<o`3<c?l0c<co0P00000/0<c<o`8000000`3<c?l00`000000c<co0<c<o`090<c<o`030000
003oool0oooo00/0oooo000B0?ooo`80000000@0olc<00000000000000001@3oc<`6000000030<co
c00000000000008000000P3<ol`3000000<0c?o<00<000000<coc00000000`3<ol`00`000000c?o<
0<coc00A0<coc0030000003<ol`0c?o<01h0c?o<00<000000<coc00000000`3<ol`00`000000c?o<
0000000E0<coc0050000003<ol`0c?o<0<coc00000000`3<ol`00`000000c?o<0<coc00O0<coc005
0000003<ol`0c?o<0<coc00000004`3<ol`01@000000c?o<000000000000c?o<00800000103<ol`7
000000040<coc00000000000000000D0c?o<0P0000080<coc0040000003<ol`000000<coc0800000
0`3<ol`3000000<0c?o<00<000000<coc03<ol`00P3<ol`7000000X0c?o<00<000000<coc0000000
0`000000103<ol`000000<coc000000?0<coc0050000003<ol`0c?o<0<coc00000008@3<ol`00`00
0000c?o<00000005000000030<coc0000000c<co00T0c<co00<000000<c<o`0000000P00000^0<c<
o`8000000P3<c?l00`000000c<co0<c<o`090<c<o`030000003oool0oooo00/0oooo000C0?ooo`80
000000<0olc<0000003oc<`01`3oc<`4000000030<coc0000000000000<0000000@0c?o<0000003<
ol`000000P3<ol`01@000000c?o<0<coc03<ol`000000080c?o<00<000000<coc03<ol`0403<ol`0
0`000000c?o<0<coc00O0<coc0@0000000H0c?o<0000003<ol`000000<coc000000C0<coc0800000
0`3<ol`010000000c?o<0<coc000000S0<coc0040000003<ol`0c?o<00000180c?o<5@0000090<co
c08000001P3<ol`2000000<0c?o<1`0000020<coc0<000000P3<ol`400000080c?o<0P00000:0<co
c08000000P3<ol`3000000030<coc0000000000000l0c?o<00@000000<coc03<ol`000008`3<ol`4
000000<0c?o<0P00000:0<c<o`80000000<0c<co000000000000;P3<c?l200000080c<co00<00000
0<c<o`3<c?l0203<c?l00`000000oooo0?ooo`0<0?ooo`00503oool2000000X0olc<100000000`3<
ol`0000000000002000000070<coc0000000c?o<0<coc0000000c?o<000000030<coc0030000003<
ol`0000001<0c?o<00<000000<coc03<ol`0803<ol`02@000000c?o<0000003<ol`000000<coc000
0000c?o<0000000C0<coc0030000003<ol`0c?o<0080c?o<1000000S0<coc0030000003<ol`00000
0180c?o<0P0000030<coc0030000003<ol`0c?o<00<0c?o<00<000000<coc03<ol`00P3<ol`40000
00d0c?o<0P0000040<coc08000000`3<ol`00`000000c?o<0<coc0040<coc0030000003<ol`00000
0080c?o<1@0000040<coc0<000001P3<ol`2000000<0c?o<00D000000<coc000000000000<coc002
000000l0c?o<00@000000<coc03<ol`000008`3<ol`3000000D0c?o<0`0000060<c<o`8000000P3<
c?l200000300c<co0P000000103<c?l000000000000000080<c<o`030000003oool0oooo00`0oooo
000D0?ooo`8000002@3oc<`2000000<0olc<100000000`3<ol`00000000000030<coc0030000003<
ol`0c?o<00<0c?o<0P00000B0<coc0030000003<ol`0c?o<0280c?o<0`0000020<coc0030000003<
ol`0000001<0c?o<00<000000<coc03<ol`00`3<ol`2000002D0c?o<0P00000B0<coc0030000003<
ol`0c?o<0080c?o<0P0000030<coc0@0000000@0c?o<00000000000000004@3<ol`2000000030<co
c0000000000000@0c?o<00<000000<coc03<ol`01@3<ol`010000000c?o<0<coc03<ol`200000003
0<coc0000000c?o<00@0c?o<0P0000000`3<ol`00000000000020<coc08000001@3<ol`010000000
c?o<0000003<ol`200000140c?o<0P00000U0<coc08000001@3<ol`00`000000c<co0<c<o`020000
0080c<co0P0000030<c<o`800000<P3<c?l300000080c<co0P0000060<c<o`030000003oool0oooo
00`0oooo000E0?ooo`030000003oc<`0olc<00L0olc<00<000000?o<c03oc<`00`3oc<`600000080
c?o<00<000000<coc03<ol`01@3<ol`00`000000c?o<0<coc00?0<coc0030000003<ol`0c?o<02@0
c?o<00L000000<coc03<ol`0c?o<0000003<ol`0000001<0c?o<00<000000<coc03<ol`00`3<ol`0
0`000000c?o<0<coc00U0<coc0030000003<ol`0c?o<00l0c?o<00<000000<coc03<ol`0103<ol`0
10000000c?o<0<coc03<ol`6000001D0c?o<0P0000050<coc0030000003<ol`0c?o<00D0c?o<1000
00030<coc0030000003<ol`0c?o<00@0c?o<0P0000020<coc08000001`3<ol`00`000000c?o<0000
00020<coc0030000003<ol`0c?o<00l0c?o<00<000000<coc03<ol`09@3<ol`00`000000c?o<0<co
c0040<coc0040000003<c?l0c<co0<c<o`800000103<c?l2000003@0c<co0`0000030<c<o`800000
103<c?l00`000000oooo0?ooo`0<0?ooo`005P3oool00`000000olc<0?o<c0050?o<c0030000003o
c<`0olc<00@0olc<00<000000?o<c03oc<`01P0000070<coc08000003`3<ol`2000002H0c?o<0P00
00020<coc0040000003<ol`0000000000180c?o<00@000000<coc03<ol`0c?o<0`00000W0<coc080
00003`3<ol`2000000H0c?o<0P0000000`3<ol`0000000000003000001T0c?o<0P0000030<coc080
00001`3<ol`4000000040<coc0000000c?o<000000D0c?o<0P0000030<coc0<000001@3<ol`01000
0000c?o<0000000000020<coc0030000003<ol`0c?o<00d0c?o<0P00000V0<coc0<000001@3<ol`0
0`000000c<co0<c<o`030<c<o`8000000P3<c?l00`000000c<co0<c<o`0d0<c<o`8000001@3<c?l2
000000030<c<o`000000oooo00h0oooo000F0?ooo`030000003oc<`0olc<00@0olc<00<000000?o<
c03oc<`01@3oc<`3000000060?o<c000000000000000003<ol`000001P3<ol`010000000c?o<0<co
c000000=0<coc0<000009P3<ol`2000000030<coc0000000c?o<0080c?o<00<000000<coc03<ol`0
3`3<ol`00`000000c?o<0<coc003000000030<coc0000000c?o<02H0c?o<00<000000<coc0000000
3@3<ol`3000000H0c?o<00<000000<coc00000000`00000M0<coc08000000P3<ol`00`000000c?o<
0<coc0040<coc0l0000000<0c?o<0000003<ol`00`3<ol`300000080c?o<00D000000<coc03<ol`0
c?o<000000030<coc0030000003<ol`0c?o<00/0c?o<00<000000<coc00000009P3<ol`9000000L0
c<co0`00000f0<c<o`/000003`3oool001L0oooo00<000000?o<c03oc<`00P3oc<`4000000@0olc<
1P0000000`3oc<`0000000000002000000D0c?o<1@00000;0<coc0030000003<ol`0000000800000
903<ol`00`000000c?o<0<coc002000000<0c?o<00<000000<coc03<ol`03`3<ol`300000080c?o<
0P0000000`3<ol`000000<coc00T0<coc0040000003<ol`0c?o<000000`0c?o<00@000000<coc03<
ol`000001P3<ol`400000240c?o<0`0000060<coc0L000000`3<ol`01@000000c?o<0<coc03<ol`0
00000080c?o<00@000000<coc03<ol`0c?o<1P0000030<coc08000000P3<ol`2000000/0c?o<0`00
00000`3<ol`000000<coc00T0<coc0050000003<ol`0c?o<0<coc00000000`3<ol`00`000000c<co
0<c<o`040<c<o`<00000>03<c?l2000000<0c<co00D000000<c<o`3<c?l0c<co0000000?0?ooo`00
603oool5000000<0olc<0P0000020?o<c0@000001@3oc<`3000000<0c?o<0P0000030<coc0030000
003<ol`0c?o<00P0c?o<0P000000103<ol`0000000000000000T0<coc0050000003<ol`0c?o<0<co
c00000000`3<ol`2000000l0c?o<0P0000030<coc0050000003<ol`000000<coc00000009@3<ol`0
1@000000c?o<0<coc03<ol`0000000X0c?o<0P0000020<coc0800000103<ol`3000002D0c?o<0P00
00040<coc0D0000000@0c?o<00000000000000000P3<ol`010000000c?o<0<coc03<ol`200000003
0<coc0000000c?o<008000000`3<ol`400000080c?o<00H000000<coc000000000000<coc000000;
0<coc0050000003<ol`000000<coc00000009@3<ol`200000080c?o<00@000000<coc03<ol`0c?o<
0P0000030<c<o`@00000>P3<c?l01@000000c<co0<c<o`3<c?l0000000<0c<co00<000000?ooo`3o
ool03@3oool001T0oooo00<000000?o<c00000001P3oc<`3000000030?o<c0000000olc<00H0olc<
1`0000040<coc0030000003<ol`0c?o<00L0c?o<00H000000<coc03<ol`000000<coc000000T0<co
c0030000003<ol`0c?o<0080c?o<00<000000<coc03<ol`01000000;0<coc0800000103<ol`01P00
0000c?o<0<coc0000000c?o<000002D0c?o<00<000000<coc03<ol`00P3<ol`00`000000c?o<0<co
c0060<coc0<000000`3<ol`00`000000c?o<00000002000000030<coc0000000c?o<02D0c?o<00<0
00000<coc00000001@0000030<coc0030000003<ol`0c?o<00D000000P3<ol`2000000030<coc000
0000000000H0c?o<00<000000<coc03<ol`00P000000103<ol`000000<coc03<ol`3000000T0c?o<
00H000000<coc03<ol`000000<coc000000U0<coc0@0000000@0c?o<0000003<ol`0c?o<0P000000
0`3<c?l00000000000020<c<o`030000003<c?l0c<co03X0c<co00L000000<c<o`3<c?l0c<co0000
003<c?l000000100oooo000J0?ooo`030000003oc<`0olc<00@0olc<0P0000020?o<c0030000003o
c<`0olc<00H0olc<00<000000?o<c00000004P0000020<coc0040000003<ol`0c?o<000002@0c?o<
00<000000<coc03<ol`00P3<ol`00`000000c?o<0<coc006000000L0c?o<0P0000050<coc0070000
003<ol`0c?o<0<coc0000000c?o<0000000U0<coc0030000003<ol`0c?o<00<0c?o<300000020<co
c0<000000P3<ol`2000002H0c?o<0`0000030<coc0800000103<ol`3000000030<coc00000000000
010000000`3<ol`@000000<0c?o<00<000000<coc0000000903<ol`3000000030<coc00000000000
00/00000?03<c?l200000080c<co00<000000<c<o`000000403oool001/0oooo00@000000?o<c03o
c<`0olc<0P0000040?o<c0030000003oc<`0olc<00L0olc<0P0000020?o<c0<0000000P0c?o<0000
0000000000000<coc0000000c?o<000000<0c?o<00D000000<coc03<ol`0c?o<000000020<coc080
00008P3<ol`4000000<0c?o<00L000000<coc03<ol`000000<coc0000000c?o<00<000000`3<ol`2
000000L0c?o<00D000000<coc03<ol`0c?o<000000020<coc0030000003<ol`0c?o<0240c?o<0P00
00030<coc080000000@0c?o<0000003<ol`000000`3<ol`01@000000c?o<000000000000c?o<00<0
0000103<ol`00`000000c?o<0<coc00V0<coc08000000`3<ol`2000000<0c?o<100000040<coc0@0
00002P3<ol`2000000<0c?o<0`0000090<coc0<000000`3<ol`010000000c?o<0<coc000000S0<co
c0<00000103<ol`4000000<0c<co0P00000n0<c<o`060000003<c?l0c<co0000003<c?l00000403o
ool001/0oooo00@000000?o<c000000000001P3oc<`00`000000olc<0?o<c0070?o<c0030000003o
c<`0000000<0olc<1@000000103<ol`000000000000000020<coc0H000000P3<ol`200000280c?o<
00@000000<coc03<ol`0c?o<0P0000020<coc0050000003<ol`000000<coc00000000`3<ol`=0000
00@0c?o<00@000000<coc03<ol`000008`3<ol`00`000000c?o<0<coc004000000030<coc0000000
000000@0c?o<0P000000103<ol`000000000000000060<coc0030000003<ol`0c?o<02H0c?o<0P00
00030<coc0<000000P3<ol`00`000000c?o<0000000200000080c?o<0P0000000`3<ol`000000000
000;0<coc0030000003<ol`0c?o<00<0000000<0c?o<0000000000001@3<ol`2000000030<coc000
0000c?o<00<0c?o<00@000000<coc03<ol`000008`3<ol`400000080c?o<0P0000000`3<ol`00000
000000030<c<o`030000003<c?l0c<co03h0c<co00D000000<c<o`000000c<co0000000@0?ooo`00
703oool010000000olc<0000000000050?o<c0800000203oc<`010000000olc<0?o<c00000040?o<
c0<000000P3<ol`00`000000c?o<0<coc002000000<0c?o<0P000000103<ol`0000000000000000R
0<coc0030000003<ol`0c?o<00<0c?o<00<000000<coc03<ol`00P0000020<coc0030000003<ol`0
c?o<0080c?o<0`0000060<coc0030000003<ol`0c?o<0080c?o<00D000000<coc03<ol`0c?o<0000
000S0<coc0<000000P3<ol`01@000000c?o<0<coc03<ol`0000000<0c?o<1@0000000`3<ol`00000
000000050<coc0030000003<ol`0c?o<02H0c?o<00<000000<coc00000000P3<ol`00`000000c?o<
0000000300000080c?o<100000040<coc0030000003<ol`0c?o<00X0c?o<00<000000<coc0000000
0P3<ol`00`000000c?o<0<coc002000000030<coc000000000000080c?o<00<000000<coc03<ol`0
0P3<ol`01@000000c?o<0<coc03<ol`0000002<0c?o<1P0000040<coc0040000003<c?l0c<co0000
0480c<co0P0000000`3<c?l000000?ooo`0?0?ooo`00703oool2000000040?o<c000000000000000
0080olc<00<000000?o<c0000000203oc<`01@000000olc<0?o<c03oc<`0000000D0olc<10000002
0<coc0030000003<ol`0c?o<0080c?o<00<000000<coc00000000P3<ol`00`000000c?o<0<coc00P
0<coc0030000003<ol`0c?o<00@0c?o<1@0000020<coc0030000003<ol`0c?o<00<0c?o<0`000003
0<coc0030000003<ol`0c?o<00<0c?o<00D000000<coc03<ol`0c?o<0000000S0<coc0050000003<
ol`0c?o<0<coc00000001@3<ol`010000000c?o<0000003<ol`2000000D0c?o<0P0000020<coc080
0000:03<ol`500000080c?o<00<000000<coc0000000103<ol`3000000@0c?o<0P00000<0<coc080
00000`3<ol`00`000000c?o<0<coc002000000<0c?o<00<000000<coc03<ol`00`3<ol`01@000000
c?o<0<coc03<ol`0000002<0c?o<1P0000040<coc0@00000@P3<c?l300000140oooo000M0?ooo`80
00000P3oc<`400000080olc<00<000000?o<c03oc<`01@3oc<`2000000<0olc<00<000000?o<c03o
c<`0103oc<`2000000030<coc0000000000000@0c?o<0P0000030<coc0030000003<ol`0c?o<0200
c?o<00<000000<coc03<ol`01P3<ol`3000000<0c?o<00<000000<coc03<ol`0103<ol`300000003
0<coc0000000c?o<00@0c?o<00@000000<coc03<ol`0c?o<0P00000R0<coc0030000003<ol`0c?o<
008000001@3<ol`4000000T0c?o<0`00000Z0<coc0@000000`3<ol`00`000000c?o<0<coc0030<co
c08000001P3<ol`00`000000c?o<0<coc00:0<coc0800000103<ol`010000000c?o<0<coc03<ol`2
000000030<coc0000000c?o<00@0c?o<00@000000<coc03<ol`0c?o<0P00000R0<coc0D000001P3<
ol`2000004@0c<co0P00000A0?ooo`007P3ooolC000000@0olc<00<000000?o<c03oc<`01@3oc<`3
000000@0c?o<0P0000030<coc0800000803<ol`00`000000c?o<0<coc0080<coc1`000008@3<ol`0
0`000000c?o<0<coc003000000H0c?o<3`00000Z0<coc080000000@0c?o<0000003<ol`0c?o<0P00
00060<coc0030000003<ol`0c?o<00@0c?o<00<000000<coc03<ol`02P3<ol`2000000@0c?o<00<0
00000<coc03<ol`00P3<ol`>00000240c?o<100000000`3<ol`00000000000050<coc0030000003<
c?l0c<co04@0c<co00<000000?ooo`3oool03`3oool001l0oooo100000000`3oc<`0000000000003
0?o<c0030000003oc<`0000000@0olc<00<000000?o<c03oc<`00P3oc<`00`000000olc<0?o<c003
0?o<c08000000P3oc<`3000000030<coc0000000000000@0c?o<0P00000P0<coc0030000003<ol`0
c?o<00D0c?o<0`0000020<coc0030000003<ol`0c?o<00P0c?o<0`0000070<coc0<0000000<0c?o<
0000003<ol`0803<ol`010000000c?o<0<coc00000020<coc08000001@3<ol`00`000000c?o<0<co
c0040<coc0030000003<ol`0c?o<00<0c?o<00<000000<coc03<ol`0:03<ol`00`000000c?o<0<co
c005000000H0c?o<0P0000040<coc0800000303<ol`2000000D0c?o<00<000000<coc00000000P00
00020<coc0<000000`3<ol`3000000030<coc0000000c?o<0200c?o<100000000`3<ol`000000000
00040<coc0800000AP3<c?l00`000000oooo0?ooo`0?0?ooo`00803oool00`000000olc<00000002
000000D0olc<00<000000?o<c03oc<`00`3oc<`00`000000olc<0?o<c0030?o<c0030000003oc<`0
olc<008000001@3oc<`010000000olc<0000000000060<coc0030000003<ol`0c?o<01h0c?o<00<0
00000<coc03<ol`00`3<ol`3000000D0c?o<00<000000<coc03<ol`01@3<ol`200000080c?o<00<0
00000<coc03<ol`00`3<ol`3000000<0c?o<00<000000<coc03<ol`07`3<ol`00`000000c?o<0000
00050<coc0800000103<ol`00`000000c?o<0<coc0030<coc0030000003<ol`0c?o<00<0c?o<00<0
00000<coc03<ol`0:03<ol`010000000c?o<0000003<ol`2000000030<coc0000000c?o<00D0c?o<
00<000000<coc00000000P3<ol`00`000000c?o<0000000<0<coc0030000003<ol`0c?o<00@0c?o<
0`0000060<coc0@00000103<ol`00`000000c?o<0<coc00O0<coc080000000<0c?o<000000000000
0`0000020<coc0030000003<ol`0000004H0c<co00<000000?ooo`3oool03`3oool00240oooo00<0
00000?o<c03oc<`00`0000030?o<c0800000103oc<`2000000D0olc<0P0000070?o<c0040000003o
c<`0olc<0?o<c0800000103<ol`00`000000c?o<0<coc00N0<coc0040000003<ol`0c?o<0<coc0D0
00001@3<ol`00`000000c?o<0<coc0030<coc08000000`3<ol`00`000000c?o<0<coc0020<coc0D0
00000`3<ol`00`000000c?o<0<coc00O0<coc0800000203<ol`200000080c?o<0P0000050<coc005
0000003<ol`0c?o<0<coc0000000:`3<ol`8000000D0c?o<0P0000001`3<ol`000000000003<ol`0
00000<coc0000000303<ol`00`000000c?o<0<coc0020<coc08000002`3<ol`3000000<0c?o<00<0
00000<coc03<ol`07P3<ol`200000080c?o<0`0000020<coc0@0000000<0c?o<0000003<c?l0@`3<
c?l00`000000oooo0?ooo`0@0?ooo`008@3oool01P000000olc<0?o<c03oc<`000000?o<c0800000
00<0olc<0000000000001@3oc<`010000000olc<0?o<c03oc<`2000000X0olc<00<000000?o<c03o
c<`00P3oc<`200000080c?o<0P00000N0<coc0030000003<ol`0c?o<00<00000103<ol`2000000@0
c?o<00<000000<coc03<ol`00P0000050<coc0030000003<ol`0c?o<00<00000103<ol`200000080
c?o<00<000000<coc03<ol`07@3<ol`3000000X0c?o<0P0000000`3<ol`000000<coc0040<coc005
0000003<ol`0c?o<0<coc0000000;03<ol`4000000<0c?o<0P0000020<coc08000000`3<ol`20000
0080c?o<0P00000:0<coc08000000P3<ol`2000000l0c?o<0`0000020<coc0030000003<ol`0c?o<
01d0c?o<0P0000020<coc0800000103<ol`01@000000c?o<0000003<ol`0000004@0c<co00<00000
0?ooo`3oool0403oool00280oooo100000030?o<c0@000000`3oc<`2000000030?o<c00000000000
00d0olc<00<000000?o<c03oc<`00`3oc<`2000000030<coc0000000c?o<01d0c?o<100000080<co
c08000000`3<ol`2000000L0c?o<100000080<coc0<000007`3<ol`2000000d0c?o<0`0000040<co
c0050000003<ol`0c?o<0<coc0000000;03<ol`4000000@0c?o<1@0000040<coc0D000002P3<ol`0
10000000c?o<00000000000C0<coc0@000007`3<ol`6000000<0c?o<00H000000<coc03<ol`00000
0<coc00000140<c<o`030000003oool0oooo0100oooo000S0?ooo`@00000103oc<`5000000030?o<
c00000000000014000001P3oc<`3000001d0c?o<0P00000<0<coc08000000P3<ol`00`000000c?o<
0<coc0050<coc0800000303<ol`2000001h0c?o<4`0000030<coc0050000003<ol`0c?o<0<coc000
0000;03<ol`400000080c?o<3@0000000`3<ol`000000000000:0<coc08000005`3<ol`3000001h0
c?o<0P0000020<coc0D000000`3<ol`00`000000c?o<000000140<c<o`030000003oool0oooo0100
oooo000T0?ooo`<000001P3oc<`500000140olc<0P0000060?o<c0@000006@3<ol`3000000h0c?o<
1@0000050<coc08000003@3<ol`4000001X0c?o<0`0000040<coc0<000002P3<ol`200000080c?o<
00<000000<coc03<ol`00P00000/0<coc0P000000`3<ol`4000000@0c?o<1@0000060<coc0<00000
6@3<ol`4000001X0c?o<0`0000040<coc0030000003<ol`0000000<0c?o<00<000000<coc03<ol`0
0P0000120<c<o`030000003oool0oooo0140oooo000T0?ooo`030000003oc<`0000000D0olc<0P00
0000103oc<`0000000000000000B0?o<c0030000003oc<`0olc<00<0olc<0`000000103oc<`00000
00000000000E0<coc08000000P3<ol`00`000000c?o<0<coc00<0<coc0030000003<ol`0c?o<0080
00001@3<ol`00`000000c?o<0<coc00<0<coc0030000003<ol`0000000<000005P3<ol`200000003
0<coc000000000000080c?o<0P0000000`3<ol`000000<coc00;0<coc0070000003<ol`0c?o<0<co
c0000000c?o<0000000^0<coc0@000000P3<ol`010000000c?o<0<coc03<ol`200000080c?o<0P00
00030<coc0<0000000<0c?o<0000000000000P3<ol`200000080c?o<00<000000<coc03<ol`05`3<
ol`00`000000c?o<00000003000001H0c?o<0P0000000`3<ol`00000000000050<coc0060000003<
ol`000000000003<ol`000000P3<ol`200000480c<co00<000000?ooo`3oool04@3oool002D0oooo
0P0000030?o<c08000001@3oc<`200000180olc<00<000000?o<c03oc<`00P3oc<`010000000olc<
0?o<c00000020?o<c0<000004@3<ol`2000000@0c?o<00<000000<coc03<ol`03@3<ol`01@000000
c?o<0<coc03<ol`0000000@0c?o<00<000000<coc03<ol`03@3<ol`200000080c?o<0`00000B0<co
c08000000`3<ol`010000000c?o<0000000000030<coc0030000003<ol`0c?o<00/0c?o<00H00000
0<coc03<ol`000000<coc000000^0<coc08000000`3<ol`00`000000c?o<0<coc0020<coc0030000
003<ol`0c?o<00<0c?o<0P0000001`3<ol`00000000000000000c?o<0000003<ol`00P0000030<co
c08000006@3<ol`300000080c?o<0`00000B0<coc08000000`3<ol`00`000000c?o<0<coc0030<co
c08000000P3<ol`3000000<0c?o<00<000000<c<o`3<c?l0@03<c?l00`000000oooo0?ooo`0A0?oo
o`009P3oool5000000L0olc<00<000000?o<c03oc<`04@3oc<`01@000000olc<0?o<c03oc<`00000
00<0olc<00@000000?o<c03oc<`0olc<0`00000=0<coc08000001@3<ol`00`000000c?o<0<coc00>
0<coc0040000003<ol`0c?o<0<coc08000000`3<ol`00`000000c?o<0<coc00=0<coc0030000003<
ol`0000000<0c?o<0`00000>0<coc0<00000103<ol`2000000@0c?o<00<000000<coc03<ol`03@3<
ol`01@000000c?o<0000003<ol`0000002h0c?o<0P0000030<coc0030000003<ol`0c?o<0080c?o<
00<000000<coc03<ol`01@3<ol`4000000040<coc000000000000<coc08000000P3<ol`00`000000
c?o<0<coc00I0<coc0040000003<ol`000000<coc0D000003P3<ol`4000000<0c?o<00<000000<co
c03<ol`00`3<ol`01@000000c?o<0<coc03<ol`000000080c?o<0P0000000`3<ol`000000<c<o`11
0<c<o`030000003oool0oooo0140oooo000W0?ooo`040000003oc<`0olc<000000L0olc<00<00000
0?o<c03oc<`04P3oc<`010000000olc<0?o<c00000040?o<c0050000003oc<`0olc<0000003oc<`0
0P00000:0<coc080000000<0c?o<000000000000103<ol`00`000000c?o<0<coc00>0<coc0070000
003<ol`0c?o<0<coc0000000c?o<000000020<coc0030000003<ol`0c?o<00d0c?o<00@000000<co
c03<ol`000000P3<ol`00`000000c?o<00000002000000X0c?o<0P0000030<coc0050000003<ol`0
c?o<0<coc0000000103<ol`00`000000c?o<0<coc00?0<coc080000000<0c?o<0000003<ol`0;@3<
ol`;000000T0c?o<0`0000030<coc0050000003<ol`000000<coc00000006`3<ol`010000000c?o<
0<coc00000040<coc08000002`3<ol`200000080c?o<0`0000020<coc0H000001@3<ol`010000000
c?o<0<coc03<ol`200000480c<co00<000000?ooo`3oool04@3oool002P0oooo0P0000080?o<c080
00004`3oc<`010000000olc<0000000000040?o<c0040000003oc<`0olc<000000<0olc<0P000006
0<coc08000001@3<ol`200000080c?o<00<000000<coc03<ol`03P3<ol`010000000c?o<0<coc000
00020<coc0030000003<ol`000000100c?o<00D000000<coc03<ol`0c?o<000000020<coc0030000
003<ol`0c?o<00<000001P3<ol`2000000D0c?o<00D000000<coc03<ol`0c?o<000000030<coc003
0000003<ol`0c?o<0100c?o<00<000000<coc0000000<03<ol`00`000000c?o<000000050<coc080
00001`3<ol`3000000030<coc0000000c?o<00<0c?o<0P0000000`3<ol`000000<coc00J0<coc005
0000003<ol`0c?o<0<coc00000000`3<ol`4000000L0c?o<0P0000050<coc080000000<0c?o<0000
003<ol`00P3<ol`2000000L0c?o<00@000000<coc03<ol`0c?o<0P0000100<c<o`030000003oool0
oooo0180oooo000X0?ooo`8000002@3oc<`00`000000olc<0?o<c00B0?o<c08000001P3oc<`00`00
0000olc<000000050?o<c08000000P3<ol`2000000T0c?o<0`00000@0<coc0040000003<ol`0c?o<
000000<0c?o<0P00000@0<coc080000000H0c?o<0000003<ol`000000<coc00000040<coc0<00000
0P3<ol`2000000L0c?o<00@000000<coc03<ol`000000`3<ol`2000001<0c?o<0P00000`0<coc080
00001P3<ol`00`000000c?o<0<coc0040<coc0<000000`3<ol`2000000<0c?o<00@000000<coc000
000000006`3<ol`3000000070<coc0000000c?o<0<coc0000000c?o<000000020<coc08000000`3<
ol`2000000L0c?o<00<000000<coc00000000P0000020<coc0030000003<ol`0c?o<00L0c?o<00<0
00000<coc03<ol`00P0000100<c<o`030000003oool0oooo0180oooo000Y0?ooo`030000003oc<`0
olc<00L0olc<00<000000?o<c03oc<`04`3oc<`00`000000olc<0?o<c0050?o<c0030000003oc<`0
000000D0olc<4@00000A0<coc0030000003<ol`0000000@0c?o<00<000000<coc03<ol`03`3<ol`2
000000<0c?o<0P0000060<coc0<000002@3<ol`010000000c?o<0<coc00000030<coc0030000003<
ol`0c?o<01<0c?o<00<000000<coc03<ol`0;P3<ol`00`000000c?o<0<coc0050<coc0030000003<
ol`0c?o<0080c?o<100000050<coc0D0000000<0c?o<0000000000006`3<ol`2000000050<coc000
000000000000003<ol`00P0000050<coc0d000000P3<ol`5000000T0c?o<00D000000<coc0000000
c?o<000000100<c<o`030000003oool0oooo0180oooo000Z0?ooo`030000003oc<`0olc<00D0olc<
0P00000E0?o<c0030000003oc<`0olc<00H0olc<0P0000030?o<c0<0000000@0olc<000000000000
0000103<ol`00`000000c?o<0<coc0040<coc0800000403<ol`00`000000c?o<000000050<coc003
0000003<ol`0c?o<00d0c?o<0`0000030<coc0800000103<ol`2000000<0c?o<0P0000080<coc003
0000003<ol`000000080c?o<0P00000E0<coc0800000;P3<ol`2000000L0c?o<00<000000<coc03<
ol`00`0000020<coc0<00000103<ol`01@000000c?o<0<coc0000000c?o<00800000703<ol`01000
0000c?o<0<coc03<ol`2000000030<coc0000000c?o<0080c?o<0P0000030<coc08000001`3<ol`2
000000030<coc00000000000008000002`3<ol`2000000030<coc0000000c<co03l0c<co00<00000
0?ooo`3oool04P3oool002/0oooo00<000000?o<c03oc<`00`3oc<`00`000000olc<0000000E0?o<
c0030000003oc<`0olc<00H0olc<0P000000103oc<`000000000000000050?o<c0<000000P3<ol`0
0`000000c?o<0<coc0030<coc0040000003<ol`00000000000l0c?o<00<000000<coc00000000P00
00040<coc0030000003<ol`0c?o<00/0c?o<0`0000050<coc080000000<0c?o<0000000000001`3<
ol`2000000H0c?o<00L000000<coc0000000c?o<0000003<ol`0000001D0c?o<00<000000<coc000
0000;03<ol`4000000D0c?o<00<000000<coc00000000P0000060<coc0<000000`3<ol`01@000000
c?o<0000003<ol`0000001d0c?o<00D000000<coc03<ol`0c?o<000000020<coc0040000003<ol`0
0000000000L0c?o<0P0000060<coc0050000003<ol`000000<coc00000003@3<ol`010000000c?o<
00000000000n0<c<o`030000003oool0oooo01<0oooo000[0?ooo`030000003oc<`0olc<0080olc<
00@000000?o<c00000000000503oc<`2000000T0olc<0`0000090?o<c0<0000000<0c?o<0000003<
ol`00`3<ol`2000000030<coc0000000c?o<00h0c?o<00<000000<coc00000000P3<ol`200000080
c?o<0P00000;0<coc0040000003<ol`0c?o<000000H0c?o<0P00000;0<coc0800000103<ol`02000
0000c?o<000000000000c?o<0000003<ol`000004`3<ol`010000000c?o<0<coc000000/0<coc080
000000<0c?o<0000003<ol`0103<ol`2000000/0c?o<0`0000001P3<ol`00000000000000000c?o<
000001d0c?o<00@000000<coc03<ol`000000`3<ol`2000000/0c?o<0P0000040<coc0D000003@3<
ol`010000000c?o<00000000000n0<c<o`030000003oool0oooo01<0oooo000/0?ooo`030000003o
c<`0olc<008000000P3oc<`2000001<0olc<00<000000?o<c03oc<`01P3oc<`3000000d0olc<0`00
00040<coc0050000003<ol`0c?o<0<coc00000003`3<ol`00`000000c?o<0<coc0030<coc0800000
00<0c?o<0000003<ol`02P3<ol`010000000c?o<0<coc00000040<coc0<000003@3<ol`300000080
c?o<0P0000001P3<ol`000000<coc0000000c?o<000001<0c?o<00D000000<coc03<ol`0c?o<0000
000Z0<coc0040000003<ol`000000<coc0<0000000@0c?o<00000000000000003P3<ol`400000003
0<coc0000000000001d0c?o<0P000000103<ol`000000<coc03<ol`2000000d0c?o<0`0000020<co
c0D000003@3<ol`010000000c?o<0<coc000000n0<c<o`030000003oool0oooo01<0oooo000]0?oo
o`030000003oc<`0000000@0olc<00<000000?o<c03oc<`04@3oc<`00`000000olc<0?o<c0040?o<
c0<000004@3oc<`3000000030<coc0000000c?o<00@0c?o<00<000000<coc03<ol`0303<ol`00`00
0000c?o<0<coc0050<coc0<000002@3<ol`300000080c?o<00H000000<coc000000000000<coc000
000>0<coc0030000003<ol`0c?o<0080000000<0c?o<0000000000000P3<ol`00`000000c?o<0000
000C0<coc0030000003<ol`0c?o<0080c?o<00<000000<coc03<ol`09P3<ol`01@000000c?o<0<co
c0000000c?o<00D0000000<0c?o<0000003<ol`03@3<ol`00`000000c?o<00000003000001l0c?o<
0P0000030<coc0030000003<ol`0c?o<00`0c?o<00<000000<coc00000000P000000103<ol`00000
0000003<ol`2000000/0c?o<0P0000020<coc0030000003<c?l0c<co03`0c<co00<000000?ooo`3o
ool04`3oool002h0oooo00<000000?o<c03oc<`00`3oc<`00`000000olc<0?o<c00A0?o<c0030000
003oc<`0olc<00<0olc<0P00000E0?o<c2h000000P3<ol`200000080c?o<0P00000?0<coc0040000
003<ol`0c?o<0<coc08000000`3<ol`00`000000c?o<0000000C0<coc0030000003<ol`0c?o<00<0
c?o<00<000000<coc03<ol`0903<ol`200000080c?o<00<000000<coc00000000P0000020<coc080
00003`3<ol`00`000000c?o<0<coc002000001l0c?o<00<000000<coc03<ol`00P3<ol`00`000000
c?o<0<coc00=0<coc08000000P3<ol`2000000<0c?o<00<000000<coc03<ol`02@3<ol`010000000
c?o<0<coc03<ol`2000003`0c<co00<000000?ooo`3oool0503oool002l0oooo00<000000?o<c03o
c<`00`00000C0?o<c0040000003oc<`0olc<0?o<c08000006@3oc<`3000000030<coc00000000000
0080c?o<0P0000020<coc08000001@3<ol`00`000000c?o<000000040<coc0030000003<ol`0c?o<
00@0c?o<00<000000<coc00000000`3<ol`2000000<0c?o<100000030<coc0030000003<ol`0c?o<
00d0c?o<00<000000<coc03<ol`00P3<ol`200000080c?o<00@000000<coc000000000004P3<ol`0
10000000c?o<0<coc03<ol`4000002D0c?o<00@000000<coc03<ol`000000`3<ol`200000080c?o<
0P00000?0<coc0040000003<ol`0c?o<0<coc08000007@3<ol`3000000<0c?o<00<000000<coc03<
ol`03@3<ol`00`000000c?o<000000030<coc0@000002`3<ol`00`000000c?o<00000003000003`0
c<co00<000000?ooo`3oool0503oool00300oooo0P0000020?o<c08000004@3oc<`00`000000olc<
0?o<c002000001d0olc<1@0000000`3<ol`00000000000020<coc08000001@3<ol`3000000@0c?o<
00<000000<coc03<ol`0103<ol`2000000<0c?o<1`000000103<ol`000000000000000020<coc003
0000003<ol`0c?o<00d0c?o<00H000000<coc03<ol`0c?o<0000003<ol`3000000<0c?o<00<00000
0<coc03<ol`03`3<ol`00`000000c?o<0<coc00300000080c?o<0P00000S0<coc0050000003<ol`0
c?o<0<coc00000000`3<ol`3000000030<coc0000000000000l0c?o<00L000000<coc03<ol`0c?o<
0000003<ol`0000001/0c?o<1@0000020<coc0030000003<ol`0c?o<00d0c?o<00@000000<coc03<
ol`00000103<ol`2000000/0c?o<0P0000020<coc0800000?03<c?l00`000000oooo0?ooo`0D0?oo
o`00<@3oool3000000030?o<c0000000olc<0100olc<0`00000Q0?o<c0<0000000<0c?o<00000000
00000P3<ol`00`000000c?o<0<coc0050<coc0800000103<ol`00`000000c?o<0<coc0050<coc003
0000003<ol`0c?o<0080000000D0c?o<00000000000000000<coc005000000030<coc0000000c?o<
00l0c?o<00D000000<coc03<ol`0c?o<000000020<coc08000000`3<ol`00`000000c?o<0<coc00?
0<coc0<000000P3<ol`00`000000c?o<0<coc00200000280c?o<00<000000<coc03<ol`00P3<ol`0
0`000000c?o<0<coc002000000040<coc0000000c?o<00000100c?o<00@000000<coc03<ol`00000
0P3<ol`00`000000c?o<0<coc00I0<coc080000000D0c?o<000000000000c?o<0000000@0<coc005
0000003<ol`0c?o<0<coc00000000`3<ol`4000000L0c?o<0P0000030<coc0030000003<ol`00000
03`0c<co00<000000?ooo`3oool0503oool00340oooo00<000000?o<c03oc<`00`00000?0?o<c080
00009@3oc<`300000080c?o<00<000000<coc03<ol`01P3<ol`4000000040<coc000000000000000
00H0c?o<0P0000000`3<ol`0000000000002000000D0c?o<1@00000@0<coc08000000P3<ol`01@00
0000c?o<0<coc03<ol`0000000<0c?o<0P00000?0<coc08000000`3<ol`00`000000c?o<0<coc002
0<coc0800000803<ol`2000000@0c?o<00@000000<coc0000000c?o<1@00000@0<coc0040000003<
ol`0c?o<000000<0c?o<00<000000<coc03<ol`05`3<ol`01P000000c?o<0000003<ol`000000<co
c0800000403<ol`200000080c?o<00H000000<coc03<ol`000000<coc00000020<coc08000000`3<
ol`2000000D0c?o<00<000000<coc0000000?03<c?l00`000000oooo0?ooo`0D0?ooo`00<P3oool4
000000040?o<c00000000000000000X0olc<0P0000000`3oc<`000000?o<c00U0?o<c0@00000203<
ol`2000000030<coc0000000000000@000001P3<ol`00`000000c?o<00000003000000L0c?o<0P00
00000`3<ol`000000<coc00@0<coc0040000003<ol`00000000000@0c?o<00<000000<coc03<ol`0
1000000;0<coc0800000103<ol`2000000@0c?o<0`00000O0<coc0030000003<ol`0c?o<00<0c?o<
0P0000030<coc080000000<0c?o<0000003<ol`0403<ol`00`000000c?o<000000040<coc0030000
003<ol`0c?o<01D0c?o<00H000000<coc03<ol`000000<coc00000020<coc0030000003<ol`0c?o<
00l0c?o<00T000000<coc03<ol`0c?o<0000003<ol`000000<coc0000000103<ol`3000000L0c?o<
00@000000<coc00000000000>P3<c?l00`000000oooo0?ooo`0E0?ooo`00<`3oool400000080olc<
0`0000060?o<c08000000P3oc<`2000002H0olc<0`0000000`3oc<`00000000000060<coc0030000
003<ol`0c?o<008000000`3<ol`00`000000c?o<0<coc0040<coc0H000001`3<ol`2000000030<co
c0000000000000l0c?o<0P0000000`3<ol`00000000000050<coc0040000003<ol`0c?o<00000080
c?o<0P0000070<coc08000001@3<ol`00`000000c?o<00000002000000040<coc0000000c?o<0<co
c08000007@3<ol`010000000c?o<0000000000020<coc0030000003<ol`0000000<0c?o<00<00000
0<coc03<ol`00P00000@0<coc0030000003<ol`0000000D0c?o<00<000000<coc03<ol`04`3<ol`2
00000080c?o<00@000000<coc03<ol`000000P3<ol`00`000000c?o<0<coc00=0<coc0800000103<
ol`00`000000c?o<000000030<coc0<0000000@0c?o<00000000000000001@3<ol`4000003X0c<co
00<000000?ooo`3oool05@3oool003@0oooo0`0000040?o<c0<000000P3oc<`2000000@0olc<00<0
00000?o<c03oc<`09P3oc<`300000080olc<0P0000020<coc0<000000`3<ol`200000080c?o<0`00
00020<coc0<000000P3<ol`2000000T0c?o<0P0000020<coc0030000003<ol`0c?o<00/0c?o<00H0
00000<coc0000000c?o<0000003<ol`2000000@0c?o<00<000000<coc0000000103<ol`2000000<0
c?o<0P0000060<coc0040000003<ol`0c?o<0<coc0@000000`3<ol`2000001/0c?o<00<000000<co
c03<ol`01P0000040<coc0040000003<ol`0c?o<0<coc08000003`3<ol`00`000000c?o<00000002
000000@0c?o<00<000000<coc03<ol`04@3<ol`200000080c?o<00D000000<coc03<ol`0c?o<0000
00030<coc0030000003<ol`0c?o<00/0c?o<0`0000030<coc0050000003<ol`0c?o<0000003<ol`0
0`0000050<coc0<000000P3<ol`200000080c?o<00<000000<c<o`3<c?l0>03<c?l00`000000oooo
0?ooo`0E0?ooo`00=03oool00`000000olc<000000030?o<c0030000003oc<`0olc<00<000001P3o
c<`00`000000olc<0?o<c00V0?o<c0030000003oc<`0000000@0olc<0`0000000`3<ol`000000<co
c0030<coc0060000003<ol`0c?o<0<coc0000000c?o<0P0000000`3<ol`00000000000030<coc003
0000003<ol`0c?o<00L0c?o<1@00000=0<coc0050000003<ol`000000<coc00000000`3<ol`20000
0080c?o<0`0000060<coc0<000001`3<ol`00`000000c?o<0<coc0020<coc0030000003<ol`0c?o<
00<000000P3<ol`2000001T0c?o<00<000000<coc03<ol`00P3<ol`00`000000c?o<0<coc0020000
00@0c?o<100000000`3<ol`000000<coc00>0<coc0030000003<ol`000000080c?o<0P0000030<co
c0030000003<ol`0c?o<00l0c?o<0P000000103<ol`000000000000000030<coc0040000003<ol`0
c?o<0<coc08000002`3<ol`400000080c?o<00@000000<coc03<ol`0c?o<0`0000090<coc0D00000
0P3<ol`00`000000c<co0<c<o`0h0<c<o`030000003oool0oooo01D0oooo000e0?ooo`8000000`3o
c<`6000000H0olc<00<000000?o<c03oc<`09P3oc<`2000000030?o<c0000000olc<00@0olc<2@00
0000103<ol`000000000000000030<coc0030000003<ol`0c?o<00<0c?o<00<000000<coc03<ol`0
1@3<ol`3000000<0c?o<00<000000<coc03<ol`02@3<ol`010000000c?o<0<coc03<ol`2000000D0
c?o<0P000000103<ol`000000000000000080<coc08000001@3<ol`00`000000c?o<0<coc0030<co
c0040000003<ol`0c?o<0<coc0<0000000<0c?o<0000003<ol`0603<ol`00`000000c?o<0<coc003
0<coc0040000003<ol`0c?o<0<coc08000000`3<ol`00`000000c?o<0<coc0020<coc0030000003<
ol`0c?o<00d0c?o<00<000000<coc03<ol`00`3<ol`2000000030<coc0000000c?o<0100c?o<00<0
00000<coc03<ol`0100000020<coc0030000003<ol`0c?o<0080c?o<00<000000<coc03<ol`02@3<
ol`020000000c?o<0000003<ol`000000<coc0000000c?o<0`00000=0<coc0<000000P3<ol`20000
03P0c<co00<000000?ooo`3oool05P3oool003H0oooo0P000000103oc<`000000000000000020?o<
c08000001@3oc<`2000002P0olc<0P0000020?o<c0030000003oc<`0olc<008000000`3oc<`20000
00040<coc000000000000<coc0@000000`3<ol`2000000<0c?o<00<000000<coc00000001@3<ol`4
000000<0c?o<0P0000090<coc0030000003<ol`0c?o<0080c?o<00<000000<coc03<ol`01P3<ol`4
000000X0c?o<0P0000020<coc0030000003<ol`0c?o<00D0c?o<00<000000<coc03<ol`00P3<ol`4
000001L0c?o<00<000000<coc03<ol`0103<ol`2000000@0c?o<0P0000000`3<ol`000000<coc004
0<coc0030000003<ol`0c?o<00`0c?o<00<000000<coc03<ol`01@3<ol`3000000l0c?o<00<00000
0<coc03<ol`00P3<ol`00`000000c?o<0<coc002000000030<coc0000000c?o<00<0c?o<00<00000
0<coc03<ol`01`3<ol`01@000000c?o<0<coc0000000c?o<00D000004P3<ol`2000000030<coc000
0000c<co03L0c<co00<000000?ooo`3oool05P3oool003H0oooo0`0000050?o<c0<00000103oc<`0
0`000000olc<0?o<c00X0?o<c0030000003oc<`0olc<00<000001`3oc<`3000000030<coc0000000
000000<0000000@0c?o<00000000000000000P3<ol`200000080c?o<1@0000020<coc0P000001`3<
ol`00`000000c?o<0<coc0030<coc0030000003<ol`0c?o<00P0c?o<@P0000050<coc3L000000`3<
ol`@00000080c?o<00<000000<coc03<ol`00P00000G0<coc0800000>03<c?l00`000000oooo0?oo
o`0F0?ooo`00>03oool00`000000olc<0?o<c0030?o<c080000000<0olc<0000003oc<`00P3oc<`0
0`000000olc<0?o<c00X0?o<c08000000P3oc<`2000000L0olc<100000000`3<ol`0000000000002
000000070<coc0000000c?o<0<coc0000000c?o<000000030<coc0D000000`3<ol`00`000000c?o<
0<coc0040<coc0030000003<ol`0c?o<00<0c?o<00<000000<coc03<ol`00P3<ol`3000000T0c?o<
0P0000000`3<ol`000000<coc0090<coc08000004`3<ol`00`000000c?o<0<coc0030<coc0030000
003<ol`0c?o<00X0c?o<0P00000:0<coc0030000003<ol`0c?o<00@0c?o<00<000000<coc03<ol`0
0P3<ol`00`000000c?o<0<coc0040<coc08000004`3<ol`00`000000c?o<0<coc0030<coc0030000
003<ol`0c?o<0080c?o<0P0000080<coc0040000003<ol`0c?o<0<coc0<000002@3<ol`2000000<0
c?o<1000000I0<coc0<00000=03<c?l3000001P0oooo000h0?ooo`030000003oc<`0olc<00@0olc<
00@000000?o<c03oc<`000000P3oc<`00`000000olc<0?o<c00X0?o<c08000000`3oc<`00`000000
olc<0?o<c0050?o<c08000000P3oc<`4000000030<coc0000000000000<0c?o<00<000000<coc03<
ol`00`3<ol`3000000@0c?o<00<000000<coc03<ol`0103<ol`2000000<0c?o<00@000000<coc03<
ol`0c?o<0P0000020<coc0030000003<ol`0c?o<00D0c?o<0P0000030<coc08000001`3<ol`20000
00030<coc0000000c?o<0180c?o<00<000000<coc03<ol`00`3<ol`2000000T0c?o<1000000;0<co
c0030000003<ol`0c?o<00<0c?o<0P0000040<coc0040000003<ol`0c?o<0<coc080000000<0c?o<
0000003<ol`04P3<ol`2000000<0c?o<00@000000<coc03<ol`0c?o<100000090<coc0030000003<
ol`000000080000000<0c?o<0000000000001@3<ol`3000000<0c?o<0P0000020<coc0030000003<
ol`0c?o<01L0c?o<0P0000000`3<c?l000000000000`0<c<o`8000000P3<c?l00`000000oooo0?oo
o`0F0?ooo`00>@3oool00`000000olc<0?o<c0030?o<c0050000003oc<`0olc<0000003oc<`00P00
000Z0?o<c0@000000P3oc<`00`000000olc<0?o<c0030?o<c08000001@3oc<`500000080c?o<00<0
00000<coc03<ol`01@3<ol`2000000@0c?o<00<000000<coc03<ol`01@3<ol`01P000000c?o<0<co
c03<ol`000000<coc08000000`3<ol`2000000D0c?o<0P0000060<coc0030000003<ol`0c?o<00<0
c?o<0P0000020<coc0030000003<ol`0c?o<01<0c?o<00<000000<coc03<ol`00P3<ol`2000000L0
c?o<0P0000020<coc0030000003<ol`0c?o<00/0c?o<00@000000<coc03<ol`0c?o<0`0000040<co
c0040000003<ol`0000000000080c?o<00<000000<coc03<ol`04`3<ol`01P000000c?o<0<coc03<
ol`000000<coc08000000P3<ol`00`000000c?o<0<coc0080<coc0030000003<ol`000000080c?o<
00<000000<coc03<ol`00P0000000`3<ol`00000000000020<coc0040000003<ol`00000000000<0
c?o<00<000000<coc03<ol`06@3<ol`200000080c<co0P00000/0<c<o`8000000`3<c?l00`000000
oooo0?ooo`0G0?ooo`00>@3oool00`000000olc<0?o<c0030?o<c08000000P3oc<`2000002/0olc<
0P0000020?o<c0040000003oc<`0olc<000000<0olc<00<000000?o<c00000001`3oc<`300000080
c?o<00<000000<coc03<ol`01@3<ol`4000000040<coc00000000000000000H0c?o<0P0000001P3<
ol`00000000000000000c?o<000000<0c?o<00<000000<coc03<ol`00P3<ol`2000000030<coc000
0000000000H0c?o<00<000000<coc03<ol`00P0000030<coc0030000003<ol`0c?o<01D0c?o<00H0
00000<coc03<ol`000000<coc00000050<coc08000000`3<ol`00`000000c?o<0<coc00<0<coc080
00000P3<ol`00`000000c?o<000000050<coc08000000P3<ol`2000001H0c?o<00<000000<coc000
00000P000000103<ol`000000<coc000000<0<coc08000000P3<ol`00`000000c?o<0<coc0020<co
c08000000P3<ol`3000000D0c?o<00<000000<coc03<ol`06@3<ol`2000000@0c<co0P00000X0<c<
o`8000000P3<c?l2000000030<c<o`000000oooo01P0oooo000j0?ooo`L000000`3oc<`00`000000
olc<0?o<c00Z0?o<c0040000003oc<`0olc<0?o<c0@0000000D0olc<0000003oc<`0olc<00000008
0?o<c0@000001`3<ol`9000000H0c?o<100000030<coc0050000003<ol`0c?o<0<coc00000000P3<
ol`2000000D0c?o<0P0000040<coc0<00000103<ol`00`000000c?o<0<coc00G0<coc0050000003<
ol`000000<coc00000000`3<ol`2000000@0c?o<00<000000<coc03<ol`03P3<ol`2000000040<co
c0000000c?o<000000<0c?o<0P0000030<coc0800000603<ol`2000000<0c?o<0P00000>0<coc005
0000003<ol`0c?o<0<coc00000001@3<ol`;000001/0c?o<00<000000<c<o`0000001@3<c?l20000
02@0c<co2P00000I0?ooo`00>`3oool010000000olc<0?o<c03oc<`2000000<0olc<00<000000?o<
c03oc<`0:P3oc<`2000000@0olc<0P0000001@3oc<`000000?o<c03oc<`0000000H0olc<0P000003
0?o<c0<000001@3<ol`2000000030<coc0000000000000<0c?o<00<000000<coc03<ol`0103<ol`0
10000000c?o<0000000000030<coc0040000003<ol`0c?o<0<coc0<000002@3<ol`2000000<0c?o<
0P0000040<coc0030000003<ol`0c?o<01L0c?o<00<000000<coc00000000P3<ol`3000000D0c?o<
0P00000A0<coc0040000003<ol`000000<coc0@000001@3<ol`2000001P0c?o<0P0000030<coc080
00003@3<ol`2000000@0c?o<00@000000<coc03<ol`0c?o<0P0000000`3<ol`000000<coc0060<co
c0030000003<ol`0c?o<01T0c?o<00@000000<c<o`3<c?l000000`3<c?l2000000030<c<o`000000
00000200c<co0P0000000`3<c?l000000<c<o`060<c<o`030000003oool0oooo01L0oooo000l0?oo
o`050000003oc<`0olc<0?o<c00000000`3oc<`00`000000olc<0?o<c00Z0?o<c08000001P3oc<`0
0`000000olc<0?o<c002000000@0olc<0P0000070?o<c0<000000P3<ol`2000000<0c?o<00@00000
0<coc03<ol`0c?o<0P0000040<coc0D00000103<ol`010000000c?o<0<coc000000=0<coc0800000
0P3<ol`01@000000c?o<0<coc03<ol`0000001/0c?o<0P0000020<coc0030000003<ol`0c?o<00D0
c?o<00<000000<coc03<ol`04@3<ol`2000000030<coc0000000000000P000006P3<ol`010000000
c?o<0<coc03<ol`3000000`0c?o<00<000000<coc03<ol`00`3<ol`010000000c?o<000000000003
0<coc0030000003<ol`0c?o<00D0c?o<00<000000<coc03<ol`06@3<ol`01@000000c<co0<c<o`00
0000c<co008000000`3<c?l010000000c<co00000000000M0<c<o`050000003<c?l0c<co0<c<o`00
00001`3<c?l00`000000oooo0?ooo`0G0?ooo`00?03oool01@000000olc<0?o<c03oc<`000000080
olc<0P00000/0?o<c08000001@3oc<`01@000000olc<0?o<c03oc<`0000000<0olc<0P00000;0?o<
c0<0000000<0c?o<0000003<ol`00`3<ol`00`000000c?o<0<coc008000000<0c?o<00H000000<co
c03<ol`0c?o<0000003<ol`2000000d0c?o<10000000103<ol`000000<coc000000M0<coc0040000
003<ol`0c?o<000000H0c?o<00<000000<coc03<ol`04P3<ol`200000080c?o<00<000000<coc03<
ol`00`3<ol`2000001`0c?o<00<000000<coc00000000P3<ol`00`000000c?o<0<coc00:0<coc003
0000003<ol`0c?o<00@0c?o<0P0000050<coc0030000003<ol`0c?o<00<0c?o<00<000000<coc03<
ol`06`3<ol`00`000000c<co0<c<o`02000000D0c<co00<000000<c<o`0000000P00000I0<c<o`80
00001@3<c?l00`000000c<co0<c<o`030<c<o`030000003oool0oooo01P0oooo000m0?ooo`030000
003oc<`0olc<0080000000<0olc<0000003oc<`0;@3oc<`00`000000olc<0?o<c0020?o<c0030000
003oc<`0olc<0080olc<00@000000?o<c000000000003`3oc<`3000000@0c?o<0P0000000`3<ol`0
000000000003000000030<coc0000000000000<0c?o<0P0000020<coc0030000003<ol`0000000h0
c?o<00<000000<coc03<ol`01@00000N0<coc0030000003<ol`0000000D0c?o<0P00000D0<coc080
00000P3<ol`00`000000c?o<0<coc0020<coc08000007@3<ol`300000080c?o<00<000000<coc03<
ol`02P3<ol`00`000000c?o<0<coc0020<coc08000001`3<ol`2000000@0c?o<00<000000<coc03<
ol`06`3<ol`3000000L0c<co0P0000020<c<o`<000005@3<c?l2000000L0c<co0P0000040<c<o`03
0000003oool0oooo01P0oooo000n0?ooo`060000003oc<`000000000003oc<`00000;P3oc<`00`00
0000olc<0?o<c0020?o<c0030000003oc<`0olc<0080olc<0P00000C0?o<c0/000000`3<ol`00`00
0000c?o<0<coc0030<coc0060000003<ol`0c?o<0000003<ol`000003`3<ol`010000000c?o<0<co
c03<ol`2000001l0c?o<00@000000<coc03<ol`00000103<ol`2000001@0c?o<00D000000<coc03<
ol`0c?o<000000040<coc0030000003<ol`0c?o<01d0c?o<00<000000<coc03<ol`00P00000;0<co
c08000000P3<ol`=000000@0c?o<00<000000<coc03<ol`06`3<ol`<000000@0c<co0`00000A0<c<
o`d00000103<c?l00`000000oooo0?ooo`0H0?ooo`00?`3oool01@000000olc<0000003oc<`00000
02h0olc<00D000000?o<c03oc<`0olc<000000040?o<c08000005@3oc<`5000000030<coc0000000
0000008000000`3<ol`2000000<0c?o<00L000000<coc0000000c?o<0000003<ol`0000000l0c?o<
00D000000<coc03<ol`0c?o<0000000Q0<coc0030000003<ol`0000000<0c?o<1000000C0<coc005
0000003<ol`0c?o<0<coc00000000`3<ol`00`000000c?o<0<coc00O0<coc0D000002P3<ol`00`00
0000c?o<00000003000000<0c?o<00<000000<coc03<ol`01@3<ol`01@000000c?o<0<coc03<ol`0
000001d0c?o<00<000000<c<o`3<c?l02@3<c?l010000000c<co0<c<o`3<c?l5000000d0c<co1000
00030<c<o`030000003<c?l0c<co00D0c<co00D000000<c<o`3<c?l0c<co0000000J0?ooo`00@03o
ool2000000030?o<c0000000olc<02d0olc<0P0000000`3oc<`000000?o<c0040?o<c0030000003o
c<`0olc<01@0olc<00<000000?o<c00000000P0000020<coc080000000@0c?o<0000003<ol`0c?o<
1@0000030<coc080000000<0c?o<0000003<ol`03P3<ol`010000000c?o<0<coc000000S0<coc080
00000P3<ol`01@000000c?o<0000003<ol`000000180c?o<0P0000030<coc080000000<0c?o<0000
000000008P3<ol`010000000c?o<00000000000:0<coc0<000000P3<ol`010000000c?o<0<coc000
00090<coc0040000003<ol`0c?o<000001d0c?o<00<000000<c<o`3<c?l02P3<c?l01`000000c<co
0<c<o`000000c<co0000003<c?l00`0000090<c<o`<000000P3<c?l010000000c<co0<c<o`000009
0<c<o`040000003<c?l0c<co000001X0oooo00100?ooo`<00000<03oc<`2000000H0olc<00<00000
0?o<c03oc<`05@3oc<`200000080olc<200000020<coc0<000000`3<ol`300000100c?o<00@00000
0<coc00000000000903<ol`01@000000c?o<0000003<ol`000000080c?o<00<000000<coc03<ol`0
403<ol`00`000000c?o<0<coc0030<coc0<00000903<ol`5000000H0c?o<0`0000030<coc0050000
003<ol`0c?o<0<coc00000002@3<ol`3000001l0c?o<00<000000<c<o`3<c?l02@3<c?l3000000<0
c<co00<000000<c<o`0000000`0000050<c<o`<000000`3<c?l01@000000c<co0<c<o`3<c?l00000
00T0c<co0`00000K0?ooo`00@@3oool200000300olc<0P0000060?o<c0030000003oc<`0olc<01D0
olc<00<000000?o<c00000000`3oc<`3000000030<coc0000000000000<0c?o<00<000000<coc03<
ol`00`3<ol`200000140c?o<0P00000U0<coc0<0000000D0c?o<0000003<ol`0c?o<0000000B0<co
c0030000003<ol`0c?o<00<0c?o<0P00000U0<coc0<000000P3<ol`200000080c?o<0`0000050<co
c0040000003<ol`0c?o<000000/0c?o<0P00000O0<coc0030000003<c?l0c<co00X0c<co0P000003
0<c<o`030000003<c?l000000080c<co0`000000103<c?l000000000000000050<c<o`040000003<
c?l0c<co000000/0c<co0P00000K0?ooo`00@P3oool00`000000olc<0?o<c00^0?o<c0030000003o
c<`0olc<00D0olc<00<000000?o<c03oc<`05@3oc<`010000000olc<0?o<c00000030?o<c0<00000
00D0c?o<0000003<ol`0c?o<000000070<coc0030000003<ol`0c?o<00l0c?o<00<000000<coc03<
ol`09@3<ol`010000000c?o<0<coc00000020<coc0030000003<ol`0c?o<0100c?o<00<000000<co
c03<ol`00P3<ol`2000002L0c?o<0`0000000`3<ol`000000<coc00;000000030<coc0000000c?o<
00`0c?o<00<000000<coc03<ol`07@3<ol`00`000000c<co0<c<o`0;0<c<o`030000003<c?l0c<co
0080c<co00<000000<c<o`0000000`3<c?l;000000030<c<o`000000c<co00`0c<co00<000000?oo
o`3oool06@3oool004<0oooo00<000000?o<c03oc<`0;03oc<`3000000D0olc<00<000000?o<c03o
c<`05P3oc<`01@000000olc<0?o<c03oc<`0000000D0olc<1@0000070<coc08000003`3<ol`20000
02L0c?o<0P000000103<ol`000000<coc03<ol`200000100c?o<0P0000020<coc0@000009`3<ol`6
00000080c?o<0P0000060<coc08000003P3<ol`2000001d0c?o<0P00000=0<c<o`030000003<c?l0
c<co00<0c<co1@0000020<c<o`8000001P3<c?l2000000h0c<co00<000000?ooo`3oool06@3oool0
04@0oooo00<000000?o<c03oc<`0:P3oc<`01@000000olc<0000003oc<`0000000@0olc<00<00000
0?o<c03oc<`05`3oc<`010000000olc<0?o<c00000070?o<c080000000<0c?o<0000003<ol`0103<
ol`010000000c?o<00000000000=0<coc0@000009@3<ol`4000000<0c?o<0P00000@0<coc0050000
003<ol`000000000003<ol`01000000V0<coc0030000003<ol`00000008000001@3<ol`300000080
c?o<00<000000<coc00000003P3<ol`00`000000c?o<0000000K0<coc0@00000303<c?l00`000000
c<co0<c<o`030<c<o`@000001@3<c?l300000080c<co00<000000<c<o`0000003P3<c?l00`000000
oooo0?ooo`0I0?ooo`00A03oool00`000000olc<0?o<c00Z0?o<c080000000@0olc<000000000000
00000`3oc<`00`000000olc<0?o<c00G0?o<c0050000003oc<`0olc<0?o<c0000000203oc<`30000
00@0c?o<0P0000000`3<ol`000000000000;0<coc0050000003<ol`000000<coc00000009@3<ol`0
10000000c?o<0<coc00000040<coc08000003`3<ol`200000080c?o<0`0000000`3<ol`000000<co
c00T0<coc0030000003<ol`0c?o<008000001P3<ol`00`000000c?o<00000004000000h0c?o<00@0
00000<coc03<ol`000006`3<ol`4000000/0c<co0P0000030<c<o`D000001P3<c?l00`000000c<co
00000004000000h0c<co00<000000?ooo`3oool06P3oool004D0oooo00<000000?o<c03oc<`0:03o
c<`01`000000olc<0000003oc<`000000?o<c00000000`3oc<`00`000000olc<0?o<c00G0?o<c003
0000003oc<`0olc<0080olc<00<000000?o<c03oc<`01@3oc<`8000000<0c?o<00<000000<coc03<
ol`02@3<ol`01@000000c?o<0000003<ol`0000002D0c?o<00D000000<coc03<ol`0c?o<00000003
0<coc0@000002`3<ol`2000000@0c?o<00D000000<coc0000000c?o<0000000U0<coc0050000003<
ol`0c?o<0<coc00000001@3<ol`2000000<0c?o<0`00000>0<coc0050000003<ol`0c?o<0<coc000
00006@3<ol`01@000000c?o<0000003<ol`0000000/0c<co00@000000<c<o`3<c?l0c<co0P000002
0<c<o`8000001@3<c?l2000000<0c<co0`00000>0<c<o`030000003oool0oooo01X0oooo00160?oo
o`030000003oc<`0olc<02H0olc<00H000000?o<c03oc<`000000?o<c00000020?o<c0030000003o
c<`0000001X0olc<00<000000?o<c03oc<`00`3oc<`00`000000olc<0?o<c0030?o<c0030000003o
c<`000000080olc<100000040<coc0030000003<ol`0c?o<00L0c?o<00H000000<coc03<ol`00000
0<coc000000T0<coc08000000`3<ol`200000080c?o<0P000000103<ol`000000000000000070<co
c08000001@3<ol`01P000000c?o<0<coc0000000c?o<000002D0c?o<00<000000<coc03<ol`00P3<
ol`00`000000c?o<0<coc0020<coc08000000`3<ol`4000000d0c?o<00<000000<coc03<ol`00P3<
ol`00`000000c?o<0<coc00E0<coc0060000003<ol`0c?o<0000003<ol`000002`3<c?l00`000000
c<co00000002000000@0c<co0P0000040<c<o`8000000`3<c?l4000000d0c<co00<000000?ooo`3o
ool06P3oool004L0oooo00<000000?o<c03oc<`0903oc<`01`000000olc<0?o<c03oc<`000000?o<
c00000000`3oc<`2000001X0olc<0P0000050?o<c0040000003oc<`0olc<0?o<c0<000001@3oc<`@
00000080c?o<0P0000000`3<ol`000000000000S0<coc0800000103<ol`01P000000c?o<0<coc000
0000c?o<00000080c?o<0`0000030<coc08000001P3<ol`200000080c?o<00@000000<coc0000000
0000903<ol`00`000000c?o<0<coc0020<coc0D0000000@0c?o<000000000000c?o<0`0000020<co
c08000002`3<ol`7000001D0c?o<0P0000000`3<ol`0000000000003000000X0c<co0P0000020<c<
o`030000003<c?l0c<co0080c<co00<000000<c<o`0000000`0000000`3<c?l00000000000040000
0080c<co0P00000;0<c<o`030000003oool0oooo01X0oooo00170?ooo`030000003oc<`0olc<02<0
olc<00D000000?o<c03oc<`0olc<000000030?o<c0050000003oc<`0olc<0?o<c00000006`3oc<`0
0`000000olc<0?o<c0030?o<c0070000003oc<`0olc<0?o<c0000000olc<000000070?o<c0D00000
00@0c?o<0000003<ol`000000`3<ol`5000000<0c?o<00<000000<coc03<ol`08@3<ol`3000000@0
c?o<00<000000<coc00000000P3<ol`010000000c?o<0<coc03<ol`=000000<0c?o<00@000000<co
c03<ol`000008`3<ol`010000000c?o<0<coc03<ol`3000000030<coc0000000000000<0c?o<1000
00040<coc0<000001`3<ol`5000000@0c?o<00<000000<coc03<ol`04@3<ol`010000000c?o<0000
003<ol`2000000040<coc00000000000000000L0c<co0`0000040<c<o`030000003<c?l000000080
00000P3<c?l2000000<0c<co100000040<c<o`<000001`3<c?l3000001`0oooo00180?ooo`030000
003oc<`0olc<0240olc<00<000000?o<c03oc<`00P3oc<`01@000000olc<0?o<c03oc<`0000000@0
olc<00<000000?o<c03oc<`05`3oc<`2000000H0olc<00<000000?o<c00000000P3oc<`00`000000
olc<0?o<c0050?o<c0D0000000<0c?o<0000000000000`3<ol`00`000000c?o<0<coc0020<coc003
0000003<ol`0c?o<008000008`3<ol`00`000000c?o<0<coc002000000<0c?o<0`0000020<coc003
0000003<ol`0c?o<0080c?o<0`0000050<coc0800000103<ol`010000000c?o<0<coc000000S0<co
c0060000003<ol`000000000003<ol`000000`3<ol`00`000000c?o<0<coc00200000080c?o<00<0
00000<coc03<ol`00P3<ol`2000000030<coc0000000000000<0c?o<1@0000020<coc08000000`3<
ol`00`000000c?o<0<coc00?0<coc0060000003<ol`0c?o<0000003<ol`000000P3<ol`200000004
0<c<o`000000000000000080c<co100000050<c<o`80000000<0c<co0000000000000P3<c?l20000
0080c<co0P0000020<c<o`030000003<c?l0c<co0080c<co0P0000000`3<c?l00000000000030<c<
o`@000007@3oool004T0oooo00<000000?o<c03oc<`0803oc<`00`000000olc<0?o<c0020?o<c005
0000003oc<`0olc<0?o<c0000000103oc<`2000001L0olc<00<000000?o<c00000001`3oc<`01@00
0000olc<0?o<c03oc<`0000000D0olc<0P0000040?o<c0@000000P3<ol`2000000@0c?o<00<00000
0<coc03<ol`00P00000R0<coc0800000103<ol`2000000040<coc0000000000000000080c?o<00<0
00000<coc03<ol`0103<ol`3000000<0c?o<00<000000<coc03<ol`00P3<ol`01@000000c?o<0<co
c03<ol`0000002<0c?o<0P0000030<coc0040000003<ol`0c?o<0<coc0@000000P3<ol`2000000D0
c?o<00<000000<coc0000000100000030<coc0060000003<ol`0c?o<0<coc0000000c?o<0P000000
0`3<ol`000000<coc00@0<coc0040000003<ol`0c?o<0<coc08000000`3<ol`00`000000c<co0<c<
o`04000000<0c<co00<000000<c<o`3<c?l00`3<c?l01@000000c<co0<c<o`000000c<co00L00000
0P3<c?l2000000D0c<co00<000000<c<o`000000100000030<c<o`030000003oool0oooo01/0oooo
001:0?ooo`030000003oc<`0olc<01h0olc<00<000000?o<c03oc<`00`3oc<`01@000000olc<0?o<
c03oc<`0000000D0olc<00<000000?o<c03oc<`05@3oc<`4000000D0olc<00<000000?o<c03oc<`0
0P3oc<`010000000olc<0?o<c03oc<`2000000P0olc<0`0000000`3<ol`000000<coc0040<coc004
0000003<ol`000000<coc08000008@3<ol`2000000H0c?o<100000030<coc0030000003<ol`0c?o<
00D0c?o<1@0000040<coc0040000003<ol`0c?o<0<coc08000008P3<ol`01@000000c?o<0<coc03<
ol`0000000D0c?o<100000000`3<ol`00000000000050<coc0050000003<ol`000000000003<ol`0
100000000`3<ol`000000<coc0020<coc0040000003<ol`0c?o<0<coc0<000003`3<ol`00`000000
c?o<0<coc0020<coc0030000003<ol`0c?o<0080c?o<00<000000<c<o`0000000P3<c?l01@000000
c<co000000000000c<co008000000`3<c?l3000000030<c<o`000000000000D0000000@0c<co0000
00000000c<co0P0000050<c<o`030000003<c?l0000000H0000000<0c<co0000003oool0703oool0
04X0oooo00<000000?o<c03oc<`07@3oc<`2000000D0olc<00<000000?o<c03oc<`00P3oc<`00`00
0000olc<0?o<c0030?o<c0030000003oc<`0olc<01<0olc<00D000000?o<c0000000olc<00000004
0?o<c08000000`3oc<`00`000000olc<0?o<c002000000`0olc<0`0000040<coc0<000000`3<ol`0
0`000000c?o<0<coc00O0<coc0030000003<ol`0c?o<00L0c?o<7000000Q0<coc0040000003<ol`0
c?o<0<coc08000001P3<olaY000001d0oooo001;0?ooo`030000003oc<`0olc<01/0olc<00<00000
0?o<c00000000P0000020?o<c0030000003oc<`0olc<00<0olc<00<000000?o<c03oc<`0103oc<`0
0`000000olc<0?o<c00A0?o<c0060000003oc<`0olc<0000003oc<`00000103oc<`00`000000olc<
0?o<c0020?o<c0<00000403oc<`300000080c?o<0P0000040<coc0030000003<ol`0c?o<01l0c?o<
00<000000<coc03<ol`01P3<ol`2000000030<coc0000000c?o<00T0c?o<0P0000000`3<ol`00000
0<coc0060<coc0@000008@3<ol`010000000c?o<0<coc00000020<coc08000001@3<ol`400000080
c?o<0P0000030<coc08000001@3<ol`300000080c?o<0P0000070<coc0050000003<ol`0c?o<0<co
c00000001P3<ol`3000000P0c?o<1000000:0<c<o`<000004P3<c?l00`000000c<co0<c<o`030<c<
o`030000003<c?l0c<co0080c<co1000000M0?ooo`00C03oool00`000000olc<0?o<c00I0?o<c004
0000003oc<`0olc<0?o<c0D000001@3oc<`00`000000olc<0?o<c0050?o<c0030000003oc<`0olc<
00l0olc<00L000000?o<c03oc<`0olc<0000003oc<`0000000<0olc<00<000000?o<c03oc<`00P3o
c<`2000001@0olc<1@0000040<coc0030000003<ol`0c?o<01l0c?o<00<000000<coc03<ol`0103<
ol`2000000@0c?o<00<000000<coc03<ol`01@3<ol`200000080c?o<00<000000<coc03<ol`0103<
ol`300000080c?o<00<000000<coc03<ol`07`3<ol`00`000000c?o<000000050<coc0800000103<
ol`4000000030<coc0000000000000@0c?o<00<000000<coc03<ol`00`3<ol`300000080c?o<00<0
00000<coc03<ol`01`3<ol`010000000c?o<0000000000040<coc0<0000000<0c?o<0000003<ol`0
1@3<ol`2000000<0c?o<0P0000070<c<o`80000000<0c<co0000003<c?l04`3<c?l01@000000c<co
0<c<o`3<c?l0000000<0c<co0`0000000`3<c?l000000?ooo`0M0?ooo`00C@3oool00`000000olc<
0?o<c00G0?o<c0030000003oc<`0olc<0080olc<00<000000?o<c03oc<`00`0000040?o<c0030000
003oc<`0olc<00H0olc<00<000000?o<c03oc<`03@3oc<`200000080olc<00@000000?o<c03oc<`0
00000P3oc<`010000000olc<0?o<c03oc<`2000001P0olc<0`0000040<coc0030000003<ol`0c?o<
01l0c?o<00<000000<coc03<ol`00P3<ol`3000000D0c?o<0P0000040<coc0800000103<ol`00`00
0000c?o<0<coc0020<coc0<00000103<ol`00`000000c?o<0<coc00O0<coc0800000203<ol`20000
00<0c?o<1`0000020<coc0030000003<ol`0c?o<00D0c?o<1@0000090<coc0060000003<ol`00000
0<coc0000000c?o<0P000000103<ol`000000000000000050<coc0<00000103<ol`3000000@0c<co
0P0000030<c<o`030000003<c?l0c<co0180c<co00H000000<c<o`3<c?l0c<co0000003<c?l30000
00<0c<co00<000000?ooo`3oool0703oool004d0oooo00<000000?o<c03oc<`05`3oc<`00`000000
olc<0?o<c0030?o<c0030000003oc<`0olc<0080olc<0P0000030?o<c0030000003oc<`0olc<00D0
olc<00<000000?o<c03oc<`03@3oc<`01@000000olc<0?o<c03oc<`0000000<0olc<0`0000000`3o
c<`000000000000M0?o<c08000000`3<ol`00`000000c?o<0<coc00M0<coc0040000003<ol`0c?o<
0<coc08000000`3<ol`2000000@0c?o<0P0000000`3<ol`00000000000060<coc0030000003<ol`0
c?o<008000000`3<ol`2000000<0c?o<00<000000<coc03<ol`07@3<ol`00`000000c?o<0000000:
0<coc080000000D0c?o<00000000000000000<coc006000000L0c?o<00@000000<coc00000000000
2`3<ol`2000000030<coc0000000000000<0c?o<00<000000<coc00000000`3<ol`2000000<0c?o<
0P0000020<coc0050000003<c?l000000000003<c?l00P0000040<c<o`030000003<c?l0c<co01@0
c<co00<000000<c<o`0000000P0000000`3<c?l000000<c<o`030<c<o`030000003oool0oooo01`0
oooo001>0?ooo`030000003oc<`0olc<01D0olc<00<000000?o<c03oc<`01@3oc<`00`000000olc<
0?o<c0030?o<c080000000<0olc<0000003oc<`01`3oc<`00`000000olc<0?o<c00;0?o<c0030000
003oc<`0olc<0080olc<00@000000?o<c03oc<`0olc<1000000Q0?o<c080000000<0c?o<0000003<
ol`07P3<ol`010000000c?o<0000000000070<coc08000000`3<ol`2000000L0c?o<100000070<co
c080000000<0c?o<0000003<ol`07P3<ol`2000000d0c?o<1@0000020<coc0D000001@3<ol`20000
00030<coc0000000c?o<00`0c?o<00<000000<coc00000000`3<ol`01@000000c?o<0<coc0000000
c?o<008000001`3<ol`2000000030<coc0000000c<co008000001@3<c?l00`000000c<co0<c<o`0F
0<c<o`8000000`3<c?l00`000000c<co0<c<o`020<c<o`030000003oool0oooo01`0oooo001?0?oo
ob4000001P3oc<`H000000D0olc<00@000000?o<c03oc<`0olc<0P00000U0?o<c08000007`3<ol`2
000000/0c?o<0P0000020<coc0030000003<ol`0c?o<00D0c?o<0P00000;0<coc08000007`3<ol`D
000000030<coc000000000000080c?o<0P0000050<coc0@00000303<ol`2000000050<coc0000000
c?o<0<coc00000000`3<ol`2000000/0c?o<0P0000020<c<o`030000003<c?l0c<co0080c<co00<0
00000<c<o`3<c?l0603<c?l00`000000c<co0<c<o`020<c<o`040000003<c?l0c<co000001l0oooo
001@0?ooo`030000003oc<`0olc<00P0olc<00<000000?o<c03oc<`01@3oc<`2000000X0olc<0P00
00060?o<c0<000004@3oc<`2000000D0olc<00<000000?o<c03oc<`00`00000W0?o<c0<000006`3<
ol`3000000d0c?o<0`0000000`3<ol`000000<coc0050<coc0030000003<ol`0c?o<00/0c?o<0`00
000K0<coc0<000001@3<ol`2000000/0c?o<0`0000050<coc080000000<0c?o<0000000000000P00
00000`3<ol`000000<coc00;0<coc0040000003<ol`0c?o<0<coc0<000000P3<ol`2000000d0c?o<
0`000000103<c?l000000<c<o`3<c?l2000001X0c<co0P0000030<c<o`040000003<c?l0c<co0000
01l0oooo001A0?ooo`030000003oc<`0olc<00H0olc<00<000000?o<c03oc<`0103oc<`4000000/0
olc<00<000000?o<c03oc<`00`3oc<`3000000030?o<c0000000000000d0olc<100000050?o<c0<0
000000<0olc<0000000000009`3oc<`2000000030?o<c0000000000001L0c?o<0P0000000`3<ol`0
00000<coc00=0<coc0030000003<ol`0c?o<00<00000103<ol`2000000d0c?o<0P0000000`3<ol`0
00000000000G0<coc08000000P3<ol`010000000c?o<0<coc03<ol`3000000`0c?o<0P0000060<co
c0030000003<ol`0000000@0000000<0c?o<0000000000002`3<ol`010000000c?o<0<coc03<ol`3
00000080c?o<00<000000<coc03<ol`0303<ol`00`000000c<co0<c<o`03000000030<c<o`000000
c<co01/0c<co00D000000<c<o`3<c?l0c<co000000020<c<o`030000003oool0oooo01d0oooo001B
0?ooo`030000003oc<`0olc<00D0olc<00<000000?o<c03oc<`00P3oc<`3000000030?o<c0000000
olc<00`0olc<00<000000?o<c03oc<`00P3oc<`010000000olc<0?o<c00000020?o<c08000002@3o
c<`200000080olc<00<000000?o<c03oc<`00`3oc<`2000000<0olc<00<000000?o<c03oc<`09`3o
c<`200000080olc<0P00000C0<coc08000000`3<ol`00`000000c?o<0<coc00=0<coc0040000003<
ol`0c?o<0<coc08000000`3<ol`00`000000c?o<0<coc00=0<coc08000000P3<ol`2000001<0c?o<
0P0000030<coc0030000003<ol`0c?o<008000000P3<ol`00`000000c?o<0<coc00;0<coc0030000
003<ol`0c?o<00<0c?o<00@000000<coc03<ol`0c?o<0`0000030<coc0030000003<ol`0c?o<00T0
c?o<00<000000<coc03<ol`00P0000020<coc0030000003<ol`0000000l0c?o<00@000000<c<o`3<
c?l0c<co0P00000N0<c<o`060000003<c?l0c<co0000003<c?l00000803oool00580oooo00<00000
0?o<c03oc<`0103oc<`010000000olc<0?o<c03oc<`300000080olc<00<000000?o<c03oc<`03@3o
c<`01@000000olc<0?o<c03oc<`0000000<0olc<00@000000?o<c03oc<`0olc<0P0000050?o<c080
00000`3oc<`00`000000olc<0?o<c0020?o<c08000001@3oc<`00`000000olc<0?o<c00W0?o<c003
0000003oc<`0000000<0olc<0P00000?0<coc08000001@3<ol`00`000000c?o<0<coc00=0<coc003
0000003<ol`0c?o<0080c?o<0P0000020<coc0030000003<ol`0c?o<00d0c?o<00<000000<coc000
00000`3<ol`2000000l0c?o<0P0000000`3<ol`000000<coc0020<coc0<000000`3<ol`00`000000
c?o<0<coc00=0<coc0040000003<ol`0c?o<0<coc08000000`3<ol`7000000X0c?o<00<000000<co
c000000010000000103<ol`000000<coc000000?0<coc0050000003<c?l0c<co0<c<o`000000803<
c?l01@000000c<co0000003<c?l000000200oooo001C0?ooo`030000003oc<`0olc<0080olc<00<0
00000?o<c03oc<`00`0000030?o<c0030000003oc<`0olc<00l0olc<00@000000?o<c03oc<`00000
103oc<`00`000000olc<0?o<c0020?o<c080000000<0olc<000000000000103oc<`010000000olc<
0?o<c03oc<`2000000L0olc<00<000000?o<c03oc<`09`3oc<`010000000olc<0?o<c00000040?o<
c08000002`3<ol`3000000H0c?o<00<000000<coc03<ol`03@3<ol`01`000000c?o<0<coc03<ol`0
00000<coc00000000P3<ol`00`000000c?o<0<coc00=0<coc0040000003<ol`0c?o<00000080c?o<
00@000000<coc000000000002`3<ol`2000000<0c?o<00D000000<coc03<ol`0c?o<000000040<co
c0030000003<ol`0c?o<00h0c?o<0P0000020<coc08000000`3<ol`300000080c?o<0P00000:0<co
c0<000000P3<ol`4000000030<coc0000000c?o<00h0c?o<00@000000<c<o`3<c?l000008P3<c?l2
000000030<c<o`000000oooo01l0oooo001D0?ooo`050000003oc<`0olc<0000003oc<`00`000000
103oc<`000000?o<c03oc<`200000140olc<00@000000?o<c00000000000103oc<`00`000000olc<
0?o<c0040?o<c0800000103oc<`2000000030?o<c0000000000000P0olc<0P00000Y0?o<c0040000
003oc<`0olc<000000H0olc<0P0000070<coc08000000`3<ol`2000000<0c?o<00<000000<coc03<
ol`03P3<ol`01P000000c?o<0<coc03<ol`000000<coc0@000003`3<ol`2000000050<coc0000000
c?o<0<coc00000000`3<ol`2000000L0c?o<0P0000060<coc0040000003<ol`0c?o<000000<0c?o<
00<000000<coc03<ol`0403<ol`00`000000c?o<000000020<coc0D00000103<ol`3000000H0c?o<
0`0000030<coc0030000003<ol`0000000<00000403<ol`010000000c<co0<c<o`00000R0<c<o`04
0000003<c?l0000000000200oooo001E0?ooo`030000003oc<`00000008000000`3oc<`010000000
olc<0?o<c000000C0?o<c08000001P3oc<`00`000000olc<0?o<c0050?o<c08000000P3oc<`30000
00X0olc<00<000000?o<c03oc<`0:03oc<`200000080olc<00<000000?o<c03oc<`01@3oc<`20000
00<0c?o<0P0000070<coc080000000<0c?o<0000003<ol`03`3<ol`01@000000c?o<0<coc03<ol`0
00000080c?o<0P00000A0<coc0040000003<ol`0c?o<00000080c?o<00<000000<coc03<ol`00P3<
ol`2000000<0c?o<0P0000080<coc0040000003<ol`0000000000080c?o<0P00000C0<coc0040000
003<ol`0c?o<0<coc080000000<0c?o<000000000000103<ol`2000000030<coc000000000000080
c?o<0`0000050<coc0040000003<ol`000000<coc08000004@3<ol`2000002@0c<co0P00000Q0?oo
o`00EP3oool2000000H0olc<0P00000E0?o<c0030000003oc<`0olc<00D0olc<00<000000?o<c03o
c<`01P3oc<`@000002/0olc<00D000000?o<c03oc<`0olc<000000080?o<c10000004@3<ol`01000
0000c?o<0000000000030<coc0800000403<ol`01`000000c?o<0000003<ol`000000<coc0000000
1P3<ol`3000000X0c?o<00<000000<coc00000000`3<ol`00`000000c?o<0<coc00B0<coc0@00000
0`3<ol`00`000000c?o<0<coc0040<coc08000000P3<ol`3000000L0c?o<00<000000<coc0000000
0P3<ol`00`000000c?o<0<coc00?0<coc0030000003<c?l0c<co02@0c<co00<000000?ooo`3oool0
7`3oool005L0oooo00<000000?o<c03oc<`0103oc<`2000001D0olc<00<000000?o<c03oc<`01P3o
c<`00`000000olc<0?o<c0030?o<c0<0000000<0olc<0000003oc<`02`3oc<`00`000000olc<0?o<
c00Y0?o<c0030000003oc<`0olc<0080olc<00<000000?o<c03oc<`00`3oc<`3000000040?o<c000
00000000000000@0c?o<00<000000<coc03<ol`00`3<ol`200000100c?o<00<000000<coc0000000
1@3<ol`00`000000c?o<0<coc00=0<coc0@000000P3<ol`2000000D0c?o<0P000000103<ol`00000
0000000000080<coc0030000003<ol`000000080c?o<0P00000E0<coc0D0000000<0c?o<00000000
00001@3<ol`00`000000c?o<000000030<coc08000001P3<ol`010000000c?o<0000000000020<co
c0030000003<ol`0c?o<00d0c?o<0P00000V0<c<o`030000003oool0oooo01l0oooo001G0?ooo`03
0000003oc<`0olc<00@0olc<0`00000D0?o<c0030000003oc<`0olc<00H0olc<00@000000?o<c03o
c<`0olc<0`0000040?o<c0030000003oc<`0olc<00T0olc<00<000000?o<c03oc<`0:@3oc<`00`00
0000olc<0?o<c0020?o<c0040000003oc<`0olc<0?o<c0<00000103oc<`400000080c?o<00<00000
0<coc03<ol`00P3<ol`2000000030<coc0000000c?o<00h0c?o<00<000000<coc00000000P000004
0<coc0030000003<ol`0c?o<00/0c?o<100000030<coc08000000`3<ol`2000000D0c?o<0`000006
0<coc0070000003<ol`000000<coc0000000c?o<0000000E0<coc0h000000P3<ol`00`000000c?o<
0<coc0020<coc0<000000P3<ol`01@000000c?o<0<coc03<ol`0000000<0c?o<00<000000<coc03<
ol`02`3<ol`3000002H0c<co00<000000?ooo`3oool07`3oool005P0oooo00<000000?o<c03oc<`0
0P3oc<`010000000olc<00000000000C0?o<c08000002@3oc<`4000000H0olc<00<000000?o<c03o
c<`0203oc<`00`000000olc<0?o<c00Z0?o<c0030000003oc<`0olc<00<0olc<100000060?o<c003
0000003oc<`0olc<00<0000000<0c?o<0000003<ol`00P3<ol`5000000h0c?o<00<000000<coc000
00000P3<ol`200000080c?o<0P00000;0<coc0050000003<ol`0c?o<0<coc0000000103<ol`40000
00T0c?o<0`0000040<coc0080000003<ol`000000000003<ol`000000<coc000000C0<coc0030000
003<ol`0c?o<00D000000P3<ol`200000080c?o<00@000000<coc03<ol`000000`3<ol`200000003
0<coc00000000000008000000`3<ol`200000080c?o<0P00000;0<coc0D00000903<c?l00`000000
oooo0?ooo`0P0?ooo`00F@3oool010000000olc<0?o<c00000030?o<c0030000003oc<`0olc<0140
olc<00<000000?o<c03oc<`01`3oc<`3000000T0olc<00<000000?o<c03oc<`01`3oc<`00`000000
olc<0?o<c00[0?o<c0040000003oc<`0olc<0?o<c0<000002@3oc<`010000000olc<0?o<c03oc<`3
000000<0c?o<00D000000<coc03<ol`0c?o<0000000?0<coc0800000103<ol`2000000030<coc000
0000000000X0c?o<00D000000<coc03<ol`0c?o<000000040<coc08000003@3<ol`3000000<0c?o<
00L000000<coc0000000c?o<0000003<ol`0000001<0c?o<00@000000<coc03<ol`0c?o<10000002
0<coc08000000`3<ol`00`000000c?o<0<coc00400000080c?o<00<000000<coc00000000P000002
0<coc0060000003<ol`000000000003<ol`000002`3<ol`01@000000c?o<0000003<ol`0000002@0
c<co00<000000?ooo`3oool0803oool005T0oooo00<000000?o<c0000000103oc<`00`000000olc<
0?o<c00A0?o<c0030000003oc<`0olc<00D0olc<0`00000<0?o<c0030000003oc<`0olc<00H0olc<
00<000000?o<c03oc<`0:`3oc<`00`000000olc<00000002000000`0olc<00<000000?o<c03oc<`0
0P3oc<`3000000030<coc0000000c?o<00<0c?o<00<000000<coc03<ol`0303<ol`00`000000c?o<
0<coc0050<coc0<000002@3<ol`00`000000c?o<000000030<coc0060000003<ol`000000000003<
ol`000003@3<ol`00`000000c?o<00000002000000030<coc000000000000080c?o<00<000000<co
c00000004`3<ol`010000000c?o<0<coc03<ol`2000000060<coc000000000000000003<ol`00000
0`3<ol`00`000000c?o<00000002000000D0c?o<00@000000<coc03<ol`0c?o<0P000000103<ol`0
00000<coc03<ol`3000000T0c?o<00H000000<coc03<ol`000000<coc000000T0<c<o`030000003o
ool0oooo0200oooo001J0?ooo`030000003oc<`0olc<00@0olc<00<000000?o<c03oc<`0403oc<`0
0`000000olc<0?o<c0030?o<c1<000001`3oc<`00`000000olc<0?o<c00[0?o<c1<000001@3oc<`^
00000080c?o<0P0000020<coc08000003@3<ol`2000000<0c?o<0P0000030<coc0030000003<ol`0
000001<0c?o<00<000000<coc03<ol`00P3<ol`F000000@0c?o<400000020<coc0040000003<ol`0
c?o<000002@0c<co00<000000?ooo`3oool0803oool005/0oooo00@000000?o<c03oc<`0olc<0`00
000B0?o<c0040000003oc<`0olc<0?o<c0<000001P3oc<`00`000000olc<0?o<c0080?o<c0800000
1@3oc<`2000002d0olc<00<000000?o<c03oc<`03`3oc<`2000000H0olc<1P000000203<ol`00000
0<coc0000000c?o<0000003<ol`00000103<ol`2000000030<coc0000000c?o<0080c?o<00<00000
0<coc03<ol`0103<ol`00`000000c?o<000000030<coc0030000003<ol`0c?o<00<0c?o<0`000003
0<coc08000003P3<ol`00`000000c?o<0<coc0020<coc08000000P3<ol`010000000c?o<00000000
000B0<coc0040000003<ol`0c?o<0<coc0D000000`3<ol`4000000X0c?o<0P0000040<coc0<00000
2@3<ol`300000080c?o<00<000000<coc03<ol`00P00000R0<c<o`030000003<c?l0oooo0240oooo
001K0?ooo`040000003oc<`0000000000080olc<00<000000?o<c03oc<`03`3oc<`00`000000olc<
0?o<c003000000030?o<c0000000olc<00D0olc<00<000000?o<c03oc<`02@3oc<`00`000000olc<
0?o<c0030?o<c0030000003oc<`0olc<02`0olc<0P00000A0?o<c0030000003oc<`0olc<00<0olc<
1`000000103<ol`000000000000000020<coc0800000103<ol`3000000@0c?o<0P0000060<coc080
00000`3<ol`3000000040<coc000000000000<coc0<000000P3<ol`00`000000c?o<0<coc00=0<co
c0030000003<ol`0c?o<0080c?o<0P0000000`3<ol`000000<coc0020<coc0030000003<ol`0c?o<
00l0c?o<00<000000<coc03<ol`0100000000`3<ol`00000000000030<coc0040000003<ol`00000
000000/0c?o<00P000000<coc03<ol`0c?o<0000003<ol`000000<coc08000001@3<ol`200000003
0<coc0000000c?o<0080c?o<00<000000<coc03<ol`00P00000R0<c<o`030000003oool0oooo0240
oooo001L0?ooo`80000000D0olc<000000000000olc<0000000@0?o<c0@000000P3oc<`2000000D0
olc<00<000000?o<c03oc<`02`3oc<`00`000000olc<0?o<c0020?o<c0030000003oc<`0olc<02d0
olc<00<000000?o<c03oc<`0403oc<`00`000000olc<0?o<c0020?o<c0050000003oc<`0olc<0000
003oc<`00`000000103<ol`000000<coc03<ol`2000000H0c?o<0P0000040<coc08000001`3<ol`0
0`000000c?o<0<coc005000000030<coc0000000000000@0000000<0c?o<0000003<ol`03P3<ol`0
10000000c?o<0<coc03<ol`2000000030<coc0000000000000<0c?o<00<000000<coc03<ol`03`3<
ol`300000080c?o<00@000000<coc03<ol`0c?o<100000040<coc0030000003<ol`0c?o<00T0c?o<
00@000000<coc03<ol`000000P3<ol`00`000000c?o<0<coc002000000030<coc000000000000080
c?o<00<000000<coc03<ol`00P3<ol`00`000000c?o<0<coc00200000280c<co00<000000?ooo`3o
ool08@3oool005d0oooo00@000000?o<c03oc<`0olc<0P00000?0?o<c0<00000103oc<`00`000000
olc<0?o<c0030?o<c0030000003oc<`0olc<00d0olc<00D000000?o<c03oc<`0olc<0000000_0?o<
c0030000003oc<`0olc<0140olc<00D000000?o<c03oc<`0olc<000000030?o<c0030000003oc<`0
olc<00<000000P3<ol`00`000000c?o<0<coc0050<coc0<000000`3<ol`2000000L0c?o<00@00000
0<coc0000000c?o<0P0000050<coc080000000@0c?o<00000000000000003`3<ol`200000080c?o<
00D000000<coc03<ol`0c?o<000000030<coc08000003`3<ol`2000000<0c?o<00<000000<coc03<
ol`00`3<ol`3000000@0c?o<00<000000<coc03<ol`02P3<ol`00`000000c?o<000000020<coc004
0000003<ol`0c?o<0<coc08000000`3<ol`00`000000c?o<0<coc0020<coc0030000003<ol`0c?o<
0080c?o<00<000000<c<o`3<c?l0803<c?l00`000000oooo0?ooo`0Q0?ooo`00G@3oool00`000000
oooo0?o<c0020?o<c0<000002`3oc<`2000000L0olc<00<000000?o<c03oc<`00P3oc<`00`000000
olc<0?o<c00?0?o<c0040000003oc<`0olc<000002l0olc<00<000000?o<c03oc<`04P3oc<`01000
0000olc<0?o<c00000030?o<c0040000003oc<`0olc<0?o<c0D000001`3<ol`5000000030<coc000
0000000000H0c?o<00<000000<coc00000000`0000070<coc0@000004@3<ol`010000000c?o<0<co
c00000040<coc0030000003<ol`0c?o<00@000002`3<ol`2000000@0c?o<0P0000050<coc0800000
1@3<ol`00`000000c?o<0<coc00:0<coc0<000000`3<ol`00`000000c?o<0<coc0020<coc0800000
00<0c?o<0000003<ol`00`3<ol`00`000000c?o<0<coc0020<coc0030000003<c?l0c<co0200c<co
00<000000?ooo`3oool08@3oool005h0oooo1@0000020?o<c08000001`3oc<`2000000T0olc<00<0
00000?o<c03oc<`00P3oc<`00`000000olc<0?o<c00?0?o<c0030000003oc<`000000300olc<0P00
000C0?o<c0040000003oc<`00000000000@0olc<00D000000?o<c03oc<`000000?o<c003000000L0
c?o<00<000000<coc00000001@0000060<coc0H000001`3<ol`400000140c?o<00@000000<coc03<
ol`00000103<ol`00`000000c?o<0<coc002000000040<coc00000000000000000L0c?o<0P000005
0<coc0<00000103<ol`00`000000c?o<000000050<coc0030000003<ol`0c?o<00/0c?o<00<00000
0<coc03<ol`00`3<ol`00`000000c?o<0<coc0020<coc0h00000803<c?l00`000000oooo0?ooo`0R
0?ooo`00G`3oool4000000@0olc<0P0000030?o<c08000002`3oc<`01@000000olc<0?o<c03oc<`0
000001<0olc<0P00000a0?o<c0030000003oc<`0olc<0180olc<0P0000060?o<c0030000003oc<`0
000000@0olc<0P0000040<coc08000000P3<ol`010000000c?o<0<coc03<ol`2000000@0c?o<1P00
00090<coc0040000003<ol`00000000000l0c?o<0`0000000`3<ol`000000<coc0040<coc0030000
003<ol`0c?o<008000000P3<ol`3000000<0c?o<0P0000070<coc0030000003<ol`0000000<00000
00D0c?o<0000003<ol`0c?o<000000030<coc0<00000303<ol`00`000000c?o<0<coc0030<coc003
0000003<ol`0c?o<008000000`3<ol`2000000<0c?o<0`0000000`3<ol`000000000000P0<c<o`03
0000003oool0oooo0280oooo001P0?ooo`030000003oc<`0000000@0olc<00<000000?o<c0000000
400000020?o<c0030000003oc<`0olc<01<0olc<00<000000?o<c03oc<`0;`3oc<`00`000000olc<
0?o<c00C0?o<c0030000003oc<`0olc<00@0olc<00<000000?o<c00000001P3oc<`6000000<0c?o<
00<000000<coc03<ol`0200000030<coc0030000003<ol`0c?o<00L0c?o<00D000000<coc0000000
c?o<0000000=0<coc0050000003<ol`0c?o<0000003<ol`00`0000040<coc0050000003<ol`00000
0<coc00000000`3<ol`4000000P0c?o<00H000000<coc03<ol`0c?o<0000003<ol`300000080c?o<
0P0000000`3<ol`000000<coc002000000`0c?o<00<000000<coc03<ol`0103<ol`2000000L0c?o<
0`0000050<coc0030000003<c?l0c<co01h0c<co00<000000?ooo`3oool08P3oool00600oooo00@0
00000?ooo`00000000000P3oc<`01@000000olc<000000000000olc<008000002`3oc<`200000003
0?o<c0000000olc<01D0olc<0P00000_0?o<c08000005@3oc<`00`000000olc<0?o<c0050?o<c003
0000003oc<`0000000@0olc<0P000000103oc<`000000000000000040<coc0030000003<ol`0c?o<
00D0000000<0c?o<0000000000000`3<ol`2000000L0c?o<1`00000<0<coc0030000003<ol`0c?o<
008000000`3<ol`2000000<0c?o<0P0000020<coc0030000003<ol`0c?o<0080c?o<0`0000060<co
c0030000003<ol`0c?o<0080c?o<00@000000<coc03<ol`0c?o<0`000000103<ol`0000000000000
00020<coc0030000003<ol`0c?o<00T0c?o<0P0000040<coc08000002`3<ol`2000000@0c?o<00<0
00000<c<o`3<c?l07P3<c?l00`000000oooo0?ooo`0R0?ooo`00H@3oool00`000000olc<00000002
0?o<c08000001@3oc<`2000000T0olc<00@000000?o<c03oc<`000005P3oc<`00`000000olc<0000
000]0?o<c0030000003oc<`0000001D0olc<00<000000?o<c03oc<`01P3oc<`200000080olc<0P00
00050?o<c0L0000000@0c?o<00000000000000000`3<ol`00`000000c?o<0<coc0030<coc0030000
003<ol`0c?o<00D0c?o<0`0000030<coc08000002P3<ol`010000000c?o<0<coc03<ol`2000000D0
c?o<0P0000001P3<ol`00000000000000000c?o<000000H0c?o<0`0000030<coc08000001@3<ol`0
0`000000c?o<0<coc0020<coc0@000000P3<ol`2000000/0c?o<00@000000<coc03<ol`0c?o<0P00
000?0<coc08000000P3<ol`2000001h0c<co00<000000<c<o`3oool08`3oool00680oooo1@000008
0?o<c08000001`3oc<`00`000000olc<0000000F0?o<c0040000003oc<`0olc<000002d0olc<0`00
000D0?o<c0800000203oc<`6000000L0olc<100000000`3<ol`0000000000002000000<0c?o<0P00
00030<coc0030000003<ol`0000000D0c?o<0P0000000`3<ol`000000<coc0020<coc08000002@3<
ol`00`000000c?o<0<coc0030<coc0030000003<ol`0c?o<00D0c?o<100000020<coc0030000003<
ol`0c?o<00D0c?o<0`0000000`3<ol`000000<coc0060<coc0030000003<ol`0c?o<00<0c?o<1`00
000:0<coc0040000003<ol`00000000001<0c?o<0P0000000`3<ol`000000<c<o`0M0<c<o`030000
003oool0oooo02<0oooo001S0?ooo`@000002P3oc<`2000000D0olc<0P00000G0?o<c0050000003o
c<`0olc<0?o<c0000000:`3oc<`01@000000olc<0000003oc<`0000001<0olc<00<000000?o<c03o
c<`0203oc<`3000000030?o<c0000000olc<00P0olc<0`0000001@3<ol`000000000003<ol`00000
0080c?o<0P0000020<coc08000000P3<ol`6000000030<coc0000000000000H000001`3<ol`00`00
0000c?o<0<coc0030<coc08000002@3<ol`R000000030<coc0000000000000X0c?o<0P00000G0<co
c0<000007@3<c?l00`000000oooo0?ooo`0S0?ooo`00I03oool2000000X0olc<00<000000?o<c000
00000P0000020?o<c0800000603oc<`00`000000olc<0?o<c0020?o<c0030000003oc<`0olc<02L0
olc<00H000000?o<c03oc<`000000?o<c000000C0?o<c0030000003oc<`0olc<00H0olc<0P000002
0?o<c08000002P3oc<`00`000000olc<00000005000000070<coc0000000c?o<0<coc0000000c?o<
000000030<coc0D000000`3<ol`00`000000c?o<0<coc0040<coc0030000003<ol`0c?o<00<0c?o<
00<000000<coc03<ol`00P3<ol`4000000L0c?o<0`0000000`3<ol`000000<coc0090<coc0800000
4`3<ol`5000000H0c?o<0`00000I0<coc0@000006@3<c?l3000002D0oooo001T0?ooo`8000002P3o
c<`010000000olc<0?o<c03oc<`5000001P0olc<00<000000?o<c03oc<`00`3oc<`00`000000olc<
0?o<c00U0?o<c0070000003oc<`0olc<0?o<c0000000olc<0000000C0?o<c0030000003oc<`0olc<
00@0olc<0`0000001@3oc<`000000000003oc<`0000000T0olc<00<000000?o<c03oc<`00P3oc<`6
000000<0c?o<00<000000<coc03<ol`00`3<ol`3000000@0c?o<0P0000060<coc0050000003<ol`0
c?o<0<coc00000000`3<ol`3000000030<coc0000000c?o<00D0c?o<0`0000040<coc0030000003<
ol`0c?o<00D0c?o<0`00000E0<coc08000000P3<ol`200000080c?o<0P0000000`3<ol`000000000
000I0<coc0030000003<c?l0000000<000005@3<c?l200000080c<co00<000000?ooo`3oool08`3o
ool006D0oooo00<000000?o<c03oc<`01`3oc<`00`000000olc<0?o<c0030?o<c0030000003oc<`0
0000008000005`3oc<`00`000000olc<0?o<c0030?o<c08000009P3oc<`00`000000olc<0?o<c002
000000030?o<c0000000olc<0180olc<00<000000?o<c03oc<`00P3oc<`3000000@0olc<0`000008
0?o<c0030000003oc<`0olc<00<0olc<1P0000020<coc0030000003<ol`0c?o<00D0c?o<0`000003
0<coc08000001P3<ol`200000080c?o<00<000000<coc00000000P0000030<coc0030000003<ol`0
c?o<0080c?o<0`0000060<coc0030000003<ol`0c?o<00<0c?o<0P0000020<coc0030000003<ol`0
c?o<01<0c?o<0`0000000`3<ol`0000000000002000000<0c?o<00<000000<coc03<ol`0603<ol`3
00000080c<co0`00000A0<c<o`800000103<c?l00`000000oooo0?ooo`0S0?ooo`00IP3oool00`00
0000olc<0?o<c0050?o<c08000001@3oc<`2000000040?o<c00000000000000001D0olc<00<00000
0?o<c03oc<`01@3oc<`00`000000olc<0?o<c00S0?o<c0050000003oc<`0olc<0?o<c00000000P3o
c<`200000140olc<00@000000?o<c03oc<`0olc<0P0000000`3oc<`000000?o<c0040?o<c0040000
003oc<`00000000000H0olc<0P0000050?o<c080000000@0olc<00000000000000000P3<ol`00`00
0000c?o<0<coc0050<coc0D0000000<0c?o<0000000000001`3<ol`5000000030<coc0000000c?o<
00<0c?o<00<000000<coc03<ol`00P0000030<coc08000001@3<ol`00`000000c?o<0<coc0020000
00<0c?o<00<000000<coc03<ol`05@3<ol`2000000030<coc00000000000008000000`3<ol`00`00
0000c?o<0<coc00I0<coc0040000003<c?l000000<c<o`D000003@3<c?l500000080c<co00<00000
0?ooo`3oool0903oool006L0oooo00<000000?o<c03oc<`0103oc<`00`000000olc<000000040?o<
c0P000004`3oc<`00`000000olc<0?o<c0060?o<c0030000003oc<`0olc<0240olc<0P0000030?o<
c0030000003oc<`0olc<008000004@3oc<`010000000olc<0000000000030?o<c0030000003oc<`0
olc<00@0olc<00<000000?o<c00000001P3oc<`00`000000olc<000000040?o<c0D0000000<0olc<
000000000000203<ol`00`000000c?o<00000005000000H0c?o<100000030<coc0040000003<ol`0
c?o<0<coc0@000001`3<ol`2000000@0c?o<0P0000040<coc0030000003<ol`0c?o<01L0c?o<0P00
00020<coc0<000000P3<ol`00`000000c?o<0<coc00I0<coc0040000003<c?l0c<co000000@0c<co
0P00000:0<c<o`<000000P3<c?l01@000000c<co0000003<c?l0000002H0oooo001X0?ooo`H00000
00<0olc<0000000000000`3oc<`010000000olc<0000000000040?o<c0<000004@3oc<`;00000240
olc<00<000000?o<c00000000`3oc<`01@000000olc<0?o<c03oc<`000000140olc<0P0000050?o<
c0030000003oc<`0olc<00@0olc<00<000000?o<c03oc<`01P0000000`3oc<`00000000000040000
00030?o<c0000000000000D0olc<0P0000050<coc080000000<0c?o<0000000000000`3<ol`00`00
0000c?o<0<coc0040<coc0@00000103<ol`00`000000c?o<0<coc002000000/0c?o<0P0000030<co
c0050000003<ol`0c?o<0<coc00000006`3<ol`010000000c?o<0<coc03<ol`2000000030<coc000
0000000001/0c?o<00D000000<c<o`3<c?l0c<co000000030<c<o`@000001P3<c?l3000000D0c<co
0P0000000`3<c?l000000?ooo`0U0?ooo`00J@3oool010000000olc<0?o<c00000040?o<c0800000
00@0olc<00000000000000001`3oc<`3000000d0olc<1@0000080?o<c0030000003oc<`0olc<01d0
olc<0P0000020?o<c0030000003oc<`0olc<008000000P3oc<`3000000d0olc<0`0000060?o<c080
00000`3oc<`3000000<0olc<00@000000?o<c03oc<`00000103oc<`6000000L0olc<0`0000020<co
c0<000000P3<ol`200000080c?o<0`0000020<coc0<000000`3<ol`01@000000c?o<0<coc03<ol`0
00000080c?o<00<000000<coc03<ol`02`3<ol`3000000040<coc0000000c?o<0<coc08000006`3<
ol`01P000000c?o<0<coc03<ol`000000<coc0800000703<ol`3000000040<c<o`000000c<co0<c<
o`<000000P3<c?l200000080c<co0`0000070<c<o`040000003<c?l00000000002H0oooo001Y0?oo
o`030000003oc<`0000000H0olc<0P0000020?o<c0030000003oc<`0olc<00D0olc<1@0000090?o<
c080000000<0olc<0000000000000P3oc<`2000000H0olc<00<000000?o<c03oc<`07@3oc<`01`00
0000olc<0?o<c03oc<`000000?o<c00000000P3oc<`300000080olc<0P0000090?o<c08000000P3o
c<`00`000000olc<0?o<c0050?o<c0060000003oc<`000000000003oc<`00000103oc<`00`000000
olc<000000060?o<c08000000P3oc<`00`000000olc<0?o<c0050?o<c080000000D0olc<00000000
0000c?o<000000040<coc0060000003<ol`0c?o<0<coc0000000c?o<0P0000000`3<ol`000000000
00030<coc0060000003<ol`0c?o<0<coc0000000c?o<0P00000=0<coc0030000003<ol`0c?o<00<0
000000<0c?o<0000003<ol`0703<ol`400000080c?o<00<000000<coc03<ol`06P3<ol`200000005
0<c<o`00000000000000003<c?l00P0000050<c<o`d000000P3<c?l00`000000oooo0?ooo`0T0?oo
o`00JP3oool2000000@0olc<0`0000020?o<c0800000203oc<`2000000040?o<c000000000000000
00D0olc<0`0000000`3oc<`00000000000050?o<c08000001@3oc<`00`000000olc<0?o<c00K0?o<
c0030000003oc<`0olc<0080olc<00<000000?o<c0000000103oc<`2000000<0olc<0P0000050?o<
c080000000@0olc<0000003oc<`00000203oc<`2000000<0olc<00<000000?o<c03oc<`00P3oc<`3
000000@0olc<0`0000020?o<c0800000203oc<`200000080olc<20000000103<ol`0000000000000
00030<coc0030000003<ol`0c?o<00<0c?o<00H000000<coc03<ol`000000<coc000000?0<coc004
0000003<ol`0c?o<0<coc08000007`3<ol`01P000000c?o<000000000000c?o<000001d0c?o<00@0
00000<c<o`3<c?l0c<co0P0000000`3<c?l000000<c<o`020<c<o`8000000P3<c?l3000000L0c<co
00@000000<c<o`3<c?l000009P3oool006/0oooo0P000000103oc<`000000000000000040?o<c003
0000003oc<`0olc<00L0olc<00<000000?o<c03oc<`00P3oc<`3000000040?o<c000000000000000
00<0olc<0P0000070?o<c0800000103oc<`00`000000olc<0?o<c00I0?o<c0030000003oc<`0olc<
00<0olc<00<000000?o<c0000000103oc<`2000000@0olc<0`0000000`3oc<`00000000000040?o<
c0800000203oc<`00`000000olc<0?o<c0020?o<c0030000003oc<`0olc<00H0000000@0olc<0000
000000000000103oc<`00`000000olc<0?o<c0070?o<c0030000003oc<`0olc<0080olc<0`000000
103oc<`000000000003<ol`4000000<0c?o<0P0000030<coc0070000003<ol`000000<coc0000000
c?o<0000000?0<coc0050000003<ol`0c?o<0<coc00000008@3<ol`01@000000c?o<0000003<ol`0
000001d0c?o<00H000000<c<o`3<c?l0c<co0000003<c?l5000000H0c<co0`0000050<c<o`030000
003<c?l0000002L0oooo001/0?ooo`@000001@3oc<`00`000000olc<0?o<c0070?o<c0040000003o
c<`0olc<0?o<c080000000<0olc<0000000000000P0000050?o<c0030000003oc<`0olc<00@0olc<
00<000000?o<c03oc<`00P0000030?o<c0030000003oc<`0olc<01L0olc<00<000000?o<c03oc<`0
103oc<`00`000000olc<000000050?o<c0050000003oc<`0olc<0?o<c00000000`3oc<`2000000H0
olc<00<000000?o<c03oc<`01P3oc<`200000080olc<1@000000103oc<`000000?o<c03oc<`40000
00D0olc<00<000000?o<c03oc<`01`3oc<`010000000olc<0?o<c03oc<`2000000030?o<c0000000
000000P000000P3<ol`600000080c?o<0P0000000`3<ol`000000<coc00>0<coc0040000003<ol`0
c?o<00000280c?o<1@00000M0<coc0040000003<c?l0c<co00000080c<co0P00000;0<c<o`<00000
0`3<c?l00`000000c<co0000000W0?ooo`00K@3oool2000000030?o<c0000000000000<0olc<0P00
00080?o<c08000000P3oc<`300000080olc<100000020?o<c08000001@3oc<`00`000000olc<0?o<
c0030?o<c080000000<0olc<0000003oc<`0603oc<`00`000000olc<0?o<c0050?o<c0030000003o
c<`0olc<00@0olc<00D000000?o<c03oc<`0olc<000000030?o<c0040000003oc<`00000000000<0
olc<0`0000060?o<c0<000000P3oc<`:000000030?o<c0000000olc<008000000`3oc<`2000000P0
olc<0P0000020?o<c0@0000000<0olc<000000000000200000020<coc0030000003<ol`0000000<0
c?o<00@000000<coc000000000003`3<ol`010000000c?o<0<coc000000S0<coc0<000007P3<ol`2
000000050<c<o`000000c<co0<c<o`0000003P3<c?l300000080c<co0P00000W0?ooo`00KP3oool2
00000080olc<0P000000103oc<`000000?o<c00000080?o<c0040000003oc<`0olc<000000<0olc<
0`0000000`3oc<`0000000000002000000H0olc<00<000000?o<c03oc<`01@3oc<`3000001L0olc<
00<000000?o<c03oc<`01P3oc<`00`000000olc<0?o<c0050?o<c0030000003oc<`0000000@0olc<
0`000000103oc<`000000000003oc<`3000000H0olc<00<000000?o<c00000000`0000000`3oc<`0
000000000003000000@0olc<0`0000001`3oc<`000000000003oc<`000000?o<c0000000203oc<`0
1@000000olc<0?o<c0000000olc<00D0000000<0olc<0000000000001@0000030<coc0800000103<
ol`200000140c?o<0P00000U0<coc08000007`3<ol`2000000<0c<co00<000000<c<o`3<c?l0303<
c?l6000002P0oooo001^0?oooj<0000000@0c?o<0000003<ol`0c?o<0P0000060<coc0030000003<
ol`0c?o<00l0c?o<00<000000<coc03<ol`09@3<ol`00`000000c?o<0<coc00M0<coc0030000003<
c?l0c<co0080c<co00<000000<c<o`3<c?l0303<c?l3000000030<c<o`000000000002P0oooo001_
0?ooo`80000000<0olc<0000003oc<`00P0000040?o<c0030000003oc<`0000000@0olc<00<00000
0?o<c00000001P3oc<`5000000@0olc<00<000000?o<c00000002`3oc<`00`000000olc<0?o<c004
0?o<c0030000003oc<`0olc<00P0olc<1000000>0?o<c0<0000000<0olc<0000003oc<`04@3oc<`2
000001`0olc<00<000000?o<c03oc<`01`3oc<`00`000000olc<0?o<c0050?o<c0/000001P3<ol`2
000000l0c?o<0P00000W0<coc08000007@3<ol`300000080c<co0P00000>0<c<o`80000000@0c<co
0000003<c?l00000:03oool00700oooo1P0000040?o<c08000001@3oc<`3000000L0olc<00@00000
0?o<c000000000001@3oc<`2000000/0olc<00<000000?o<c03oc<`00`3oc<`2000000P0olc<0P00
0000103oc<`000000?o<c000000<0?o<c0<000000`3oc<`2000000l0olc<0`00000M0?o<c0800000
1`3oc<`00`000000olc<0?o<c0040?o<c0<000000P3oc<`2000000060?o<c000000000000000003<
ol`000001P3<ol`00`000000c?o<0000000=0<coc0<000009P3<ol`2000000030<coc0000000c?o<
01X0c?o<00H000000<coc0000000c<co0000003<c?l2000000l0c<co00<000000<c<o`3<c?l00P00
000X0?ooo`00L@3oool5000000@0olc<00<000000?o<c03oc<`01@3oc<`00`000000olc<0?o<c007
0?o<c0<000001@3oc<`00`000000olc<0?o<c00;0?o<c0030000003oc<`0olc<0080olc<0`000005
0?o<c08000000`3oc<`2000000/0olc<0`0000060?o<c0030000003oc<`0olc<00/0olc<0P000002
0?o<c0030000003oc<`0olc<01`0olc<00<000000?o<c03oc<`01@3oc<`00`000000olc<0?o<c002
0?o<c0<000000`3oc<`4000000030?o<c00000000000008000001P3<ol`4000000/0c?o<0`000000
0`3<ol`000000<coc00T0<coc0040000003<ol`0c?o<000001X0c?o<0`0000001@3<ol`000000000
003<c?l000000100c<co00<000000<c<o`3<c?l00P00000X0?ooo`00L@3oool00`000000olc<0?o<
c00400000080olc<0P0000050?o<c0030000003oc<`0olc<00T0olc<100000020?o<c0030000003o
c<`0olc<00d0olc<00L000000?o<c03oc<`0olc<0000003oc<`0000000<0olc<0P0000040?o<c003
0000003oc<`0000000T0olc<0`0000090?o<c0030000003oc<`0olc<00P0olc<0P0000030?o<c003
0000003oc<`0olc<01h0olc<00<000000?o<c03oc<`00`3oc<`010000000olc<0?o<c03oc<`30000
00D0olc<1P0000020?o<c0<000000`3<ol`200000080c?o<00<000000<coc03<ol`02@3<ol`01@00
0000c?o<0000003<ol`0000002D0c?o<00D000000<coc03<ol`0c?o<0000000I0<coc0060000003<
ol`000000<coc0000000c<co0P00000@0<c<o`050000003<c?l0c<co0<c<o`000000:03oool00780
oooo200000000`3oc<`00000000000030?o<c08000002`3oc<`010000000olc<0000003oc<`20000
0140olc<00L000000?o<c03oc<`000000?o<c0000000olc<008000001@3oc<`010000000olc<0?o<
c00000070?o<c0D000002P3oc<`00`000000olc<0?o<c0050?o<c0800000103oc<`00`000000olc<
0?o<c00P0?o<c0050000003oc<`0olc<0?o<c00000000P3oc<`3000000L0olc<00<000000?o<c000
00000`0000040?o<c0D00000103<ol`00`000000c?o<0<coc0070<coc0060000003<ol`0c?o<0000
003<ol`00000903<ol`2000000@0c?o<00<000000<coc03<ol`05@3<ol`01P000000c?o<0<coc000
0000c?o<00000080c<co00<000000<c<o`3<c?l03P3<c?l200000080c<co00<000000?ooo`3oool0
9P3oool007<0oooo0P000000103oc<`000000?o<c03oc<`7000000030?o<c0000000olc<00X0olc<
00D000000?o<c0000000olc<0000000B0?o<c0050000003oc<`000000000003oc<`00P0000060?o<
c0050000003oc<`0olc<0?o<c00000001@3oc<`3000000@0olc<0P0000080?o<c0800000103oc<`2
000000D0olc<00<000000?o<c03oc<`08@3oc<`2000000030?o<c0000000olc<00<0000000<0olc<
0000003oc<`01P3oc<`01P000000olc<000000000000olc<000000<0olc<500000020<coc0800000
00<0c?o<0000003<ol`08`3<ol`8000001D0c?o<00L000000<coc03<ol`0c?o<0000003<ol`00000
00<0c<co00<000000<c<o`3<c?l0303<c?l3000000030<c<o`000000oooo02P0oooo001d0?ooo`<0
0000103oc<`5000000030?o<c0000000000000T0olc<0`0000000`3oc<`000000000000C0?o<c080
00000P3oc<`00`000000olc<0?o<c0040?o<c0040000003oc<`0olc<0?o<c08000000`3oc<`30000
00P0olc<0P0000070?o<c0030000003oc<`0olc<008000001P3oc<`2000002@0olc<00<000000?o<
c00000000P0000040?o<c0030000003oc<`0olc<00<0olc<0`0000001@3oc<`00000000000000000
olc<00<000000`3oc<`4000000070<coc000000000000<coc0000000c?o<000000020<coc0<00000
0P3<ol`01@000000c?o<0<coc03<ol`0000002<0c?o<00@000000<coc00000000000103<ol`00`00
0000c?o<0<coc00A0<coc0050000003<ol`0c?o<0<coc00000000P3<ol`00`000000c<co0<c<o`02
0<c<o`030000003<c?l0c<co00X0c<co100000000`3<c?l000000?ooo`0X0?ooo`00M03oool00`00
0000olc<000000060?o<c0H000002@3oc<`3000000030?o<c0000000olc<01@0olc<00<000000?o<
c03oc<`00P0000050?o<c0050000003oc<`0olc<0?o<c00000000P3oc<`3000000`0olc<0P000006
0?o<c0800000203oc<`00`000000olc<0?o<c00T0?o<c08000001P3oc<`00`000000olc<0?o<c003
0?o<c0<0000000<0olc<0000000000000P0000020?o<c0040000003oc<`0olc<0?o<c0<0000000<0
olc<0000000000000P0000000`3<ol`00000000000030<coc0D000000`3<ol`00`000000c?o<0<co
c00Q0<coc0040000003<ol`0c?o<0<coc08000000`3<ol`00`000000c?o<0<coc00?0<coc0060000
003<ol`000000000003<ol`000000P3<ol`00`000000c<co0<c<o`020<c<o`8000002P3<c?l20000
00050<c<o`00000000000<c<o`000000:@3oool007D0oooo0P0000040?o<c0<0000000<0olc<0000
000000000P0000090?o<c0030000003oc<`00000008000005@3oc<`01@000000olc<0?o<c03oc<`0
000000@0olc<00<000000?o<c03oc<`00P3oc<`400000100olc<0P0000050?o<c0030000003oc<`0
olc<00D0olc<00<000000?o<c03oc<`09P3oc<`00`000000olc<0?o<c0040?o<c0030000003oc<`0
olc<00<0olc<00<000000?o<c00000000`0000030?o<c0030000003oc<`0olc<0080olc<10000000
1@3oc<`00000000000000000c?o<008000000P3<ol`00`000000c?o<0<coc0020<coc0030000003<
ol`0c?o<008000008P3<ol`2000000D0c?o<0P0000000`3<ol`000000<coc00?0<coc080000000<0
c?o<0000000000000P0000030<coc0030000003<c?l0c<co0080c<co00<000000<c<o`3<c?l0203<
c?l010000000c<co0000003<c?l3000002T0oooo001f0?ooo`80000000@0olc<0000000000000000
1@3oc<`3000000L0olc<0P000000103oc<`000000?o<c000000E0?o<c0050000003oc<`0olc<0?o<
c00000000`3oc<`00`000000olc<0?o<c0030?o<c0800000503oc<`2000000@0olc<00<000000?o<
c03oc<`00`3oc<`00`000000olc<0?o<c00X0?o<c0030000003oc<`0olc<00<0olc<00<000000?o<
c03oc<`00`3oc<`01@000000olc<0000003oc<`0000000@0olc<00<000000?o<c03oc<`00P3oc<`2
000000D0olc<0`0000020<coc0030000003<ol`0c?o<00<0c?o<00D000000<coc0000000c?o<0000
000R0<coc08000001`3<ol`3000000l0c?o<00D000000<coc03<ol`0c?o<000000020<coc0800000
00<0c?o<0000003<c?l0103<c?l00`000000c<co0<c<o`060<c<o`040000003<c?l0c<co00000080
c<co00<000000?ooo`3oool0:03oool007L0oooo0P0000000`3oc<`000000?o<c0080?o<c0800000
0`3oc<`6000000030?o<c0000000000001<0olc<0P0000030?o<c0030000003oc<`0olc<00800000
103oc<`2000001D0olc<00@000000?o<c000000000000P3oc<`2000000<0olc<00<000000?o<c03o
c<`0:@3oc<`00`000000olc<0?o<c0040?o<c0040000003oc<`0olc<0?o<c0@000000P3oc<`:0000
00L0olc<00@000000?o<c000000000001@3<ol`300000080c?o<0P00000Q0<coc08000002@3<ol`F
000000<0c?o<4@0000020<c<o`040000003<c?l0c<co000002X0oooo001h0?ooo`8000002P3oc<`0
0`000000olc<00000002000000050?o<c000000000000?o<c00000000`3oc<`00`000000olc<0?o<
c00A0?o<c0030000003oc<`0olc<0080olc<1@0000040?o<c0030000003oc<`0olc<01@0olc<00@0
00000?o<c03oc<`0olc<0P0000000`3oc<`000000?o<c0020?o<c0030000003oc<`0olc<02X0olc<
00<000000?o<c03oc<`00`3oc<`01`000000olc<0?o<c03oc<`000000?o<c00000000`3oc<`00`00
0000olc<0?o<c0050?o<c08000001`3oc<`6000000<0c?o<00<000000<coc00000000`3<ol`00`00
0000c?o<0<coc00O0<coc0030000003<ol`0c?o<00L0c?o<0P0000000`3<ol`000000<coc0040<co
c0030000003<ol`0c?o<0080c?o<0P0000070<coc0040000003<ol`0c?o<0<coc0@00000203<c?l3
000000<0c<co1000000Z0?ooo`00N03oool2000000T0olc<0P0000030?o<c080000000<0olc<0000
00000000103oc<`00`000000olc<0?o<c00A0?o<c0030000003oc<`0olc<00<0olc<0P0000020?o<
c0050000003oc<`0olc<0?o<c00000005`3oc<`00`000000olc<0?o<c0020?o<c0<0000000<0olc<
0000003oc<`0;@3oc<`00`000000olc<0?o<c0020?o<c0040000003oc<`0olc<0?o<c0800000103o
c<`00`000000olc<0?o<c0050?o<c0030000003oc<`0olc<00L0olc<0`0000020?o<c080000000<0
c?o<000000000000103<ol`00`000000c?o<0<coc00O0<coc0030000003<ol`0c?o<00D0c?o<0P00
00030<coc08000000`3<ol`010000000c?o<0<coc03<ol`4000000P0c?o<00<000000<coc03<ol`0
0P000000103<c?l000000000000000040<c<o`80000000<0c<co0000003<c?l00P3<c?l200000080
c<co00<000000?ooo`3oool0:03oool007T0oooo00<000000?o<c03oc<`01`3oc<`00`000000olc<
0?o<c0030?o<c0@00000103oc<`00`000000olc<0?o<c00A0?o<c0030000003oc<`0olc<00<0olc<
00D000000?o<c03oc<`0olc<000000030?o<c0030000003oc<`0olc<01D0olc<00<000000?o<c03o
c<`0103oc<`200000300olc<00D000000?o<c03oc<`0olc<000000030?o<c0030000003oc<`0olc<
00<0olc<00<000000?o<c03oc<`01@3oc<`00`000000olc<0?o<c0070?o<c0030000003oc<`00000
0080olc<00@000000?o<c000000000001@3<ol`00`000000c?o<0<coc00O0<coc0030000003<ol`0
c?o<00<0c?o<0P0000060<coc0060000003<ol`0c?o<0<coc0000000c?o<0P0000020<coc0030000
003<ol`0c?o<00L0c?o<00@000000<coc0000000c?o<0P0000020<c<o`D000000P3<c?l00`000000
c<co0<c<o`02000000<0c<co00<000000?ooo`3oool0:@3oool007X0oooo00<000000?o<c03oc<`0
1@3oc<`00`000000olc<0?o<c0040?o<c080000000@0olc<000000000000olc<0`00000C0?o<c004
0000003oc<`0olc<0?o<c0@000000P3oc<`01@000000olc<0?o<c03oc<`0000001L0olc<00<00000
0?o<c03oc<`0103oc<`00`000000olc<0?o<c00_0?o<c08000000P3oc<`010000000olc<0?o<c03o
c<`3000000<0olc<0P0000060?o<c08000001`3oc<`400000080olc<0`0000000`3oc<`000000000
00030<coc0030000003<ol`0c?o<01h0c?o<0P0000030<coc080000000<0c?o<0000000000001P3<
ol`00`000000c?o<0000000300000080c?o<00<000000<coc03<ol`02@3<ol`2000000040<coc000
0000c<co000000<0c<co0`0000020<c<o`<000001@3<c?l00`000000oooo0?ooo`0Y0?ooo`00NP3o
ool00`000000olc<0?o<c0040?o<c0030000003oc<`0olc<00H0olc<0P0000000`3oc<`000000000
00020?o<c08000004@3oc<`00`000000olc<0?o<c00200000080olc<0`0000001@3oc<`000000?o<
c03oc<`0000001P0olc<00<000000?o<c03oc<`00`3oc<`200000380olc<00L000000?o<c03oc<`0
olc<0000003oc<`0000000<0olc<0P0000020?o<c0030000003oc<`0olc<00<0olc<100000050?o<
c0@000000P3oc<`2000000D0olc<0P0000020<coc0030000003<ol`0c?o<01d0c?o<00<000000<co
c03<ol`00P0000050<coc0800000103<ol`300000080c?o<00<000000<coc00000003@3<ol`00`00
0000c?o<000000020<c<o`030000003<c?l0c<co0080c<co3000000[0?ooo`00N`3oool00`000000
olc<0?o<c0020?o<c0@000001@3oc<`5000000050?o<c000000000000?o<c00000004@3oc<`30000
00<0olc<00@000000?o<c000000000000P3oc<`00`000000olc<0000000I0?o<c0030000003oc<`0
olc<0080olc<00<000000?o<c03oc<`0<P3oc<`01`000000olc<0?o<c0000000olc<0000003oc<`0
0P0000000`3oc<`0000000000002000000D0olc<0P0000000`3oc<`000000?o<c0040?o<c0030000
003oc<`0olc<00<000002@3oc<`3000001l0c?o<0`0000090<coc08000000`3<ol`2000000<0c?o<
0P00000=0<coc0030000003<ol`000000080c<co00<000000<c<o`3<c?l00P3<c?l2000000030<c<
o`000000c<co00H0c<co00<000000?ooo`3oool0:@3oool007`0oooo00D000000?o<c03oc<`0olc<
000000030?o<c08000000P3oc<`4000000D0olc<0`00000?0?o<c08000001@3oc<`02@000000olc<
0000003oc<`000000?o<c0000000olc<0000000I0?o<c0050000003oc<`0olc<0?o<c0000000=P3o
c<`010000000olc<0000003oc<`2000000D0olc<0`0000030?o<c0X000000P3oc<`2000000d0olc<
00<000000?o<c03<ol`0703<ol`2000000d0c?o<0P0000020<coc0040000003<ol`0c?o<0<coc080
00003@3<ol`010000000c?o<0000003<ol`20<c<o`040000003<c?l00000000000<0c<co00<00000
0<c<o`3<c?l01@3<c?l00`000000oooo0?ooo`0Y0?ooo`00O@3oool00`000000olc<000000060?o<
c0<0000000<0olc<0000003oc<`01P3oc<`4000000/0olc<0P0000070?o<c0030000003oc<`00000
0080olc<0P0000000`3oc<`000000?o<c00H0?o<c0040000003oc<`0olc<000003P0olc<0P000000
0`3oc<`000000?o<c0060?o<c0030000003oc<`0000000D00000103oc<`5000000030?o<c0000000
olc<00`0olc<0`0000000`3oc<`0c?o<0<coc00G0<coc0@000003@3<ol`4000000050<coc0000000
c?o<0000003<ol`00P00000<0<coc0040000003<ol`0c?o<00000080c<co0P0000060<c<o`030000
003<c?l0c<co00<0c<co00<000000?ooo`3oool0:P3oool007d0oooo00<000000?o<c00000001@3o
c<`200000080olc<0P0000070?o<c0030000003oc<`0000000<000001`3oc<`2000000T0olc<00<0
00000?o<c00000000P3oc<`3000001X0olc<00@000000?o<c00000000000>03oc<`00`000000olc<
000000080?o<c0@000000P3oc<`2000000@0olc<0P0000000`3oc<`0000000000002000000d0olc<
00<000000?o<c03oc<`00P0000000`3oc<`0c?o<0<coc00C0<coc0<0000000<0c?o<0000003<ol`0
3@3<ol`00`000000c?o<0<coc003000000050<coc0000000c?o<0<coc00000002`3<ol`010000000
c?o<0<coc03<ol`4000000L0c<co0P0000040<c<o`030000003oool0oooo02X0oooo001n0?ooo`03
0000003oc<`0olc<0080olc<0P0000040?o<c0800000203oc<`200000080olc<0`0000030?o<c080
00002P3oc<`01@000000olc<0?o<c03oc<`000000080olc<0P00000K0?o<c0800000>P3oc<`20000
00T0olc<00<000000?o<c03oc<`00P3oc<`2000000@0olc<00<000000?o<c03oc<`00P3oc<`00`00
0000olc<0?o<c00=0?o<c0040000003oc<`0olc<0?o<c080000000<0olc<0<coc03<ol`03`3<ol`3
000000<0c?o<00<000000<coc03<ol`03@3<ol`010000000c?o<0<coc03<ol`200000080c?o<0P00
000;0<coc0040000003<ol`0c?o<0<coc0d00000103<c?l00`000000oooo0?ooo`0Z0?ooo`00O`3o
ool010000000olc<0000000000060?o<c0030000003oc<`0olc<00L0olc<00<000000?o<c0000000
0`3oc<`4000000`0olc<00D000000?o<c03oc<`0olc<000000030?o<c0030000003oc<`0olc<01T0
olc<00<000000?o<c03oc<`0>P3oc<`00`000000olc<0?o<c0070?o<c08000000P3oc<`400000080
olc<00<000000?o<c00000000`3oc<`00`000000olc<0?o<c00=0?o<c0030000003oc<`0olc<00<0
olc<0P0000000`3oc<`0c?o<0<coc00;0<coc0<000001@3<ol`00`000000c?o<0<coc00=0<coc003
0000003<ol`0c?o<0080c?o<1@00000;0<coc0030000003<ol`000000080000000@0c?o<0<c<o`3<
c?l00000203<c?l01@000000c<co0<c<o`3<c?l0000002`0oooo00200?ooo`040000003oc<`00000
000000D0olc<0P0000080?o<c0040000003oc<`0olc<000000@0olc<1000000:0?o<c0050000003o
c<`0olc<0?o<c0000000103oc<`00`000000olc<0?o<c00G0?o<c0800000?03oc<`2000000P0olc<
00H000000?o<c0000000olc<0000003oc<`4000000<0olc<00@000000?o<c03oc<`000003`3oc<`0
0`000000olc<0?o<c0050?o<c080000000<0olc<0<coc03<ol`01`3<ol`5000000D0c?o<00<00000
0<coc03<ol`03@3<ol`01P000000c?o<0<coc03<ol`000000<coc0@000002`3<ol`200000080c?o<
00@000000<coc03<c?l000002P3<c?l010000000c<co0<c<o`00000/0?ooo`00P03oool010000000
oooo0000003oc<`2000000<0olc<0P0000080?o<c0050000003oc<`0olc<0?o<c00000001@3oc<`4
000000P0olc<00D000000?o<c03oc<`0olc<000000050?o<c0030000003oc<`0olc<01D0olc<00<0
00000?o<c0000000?03oc<`2000000P0olc<00<000000?o<c00000000P0000020?o<c0<000000`3o
c<`4000000l0olc<00<000000?o<c03oc<`01@3oc<`01@000000olc<000000000000olc<00D0c?o<
0`0000040<coc08000000P3<ol`00`000000c?o<0<coc00>0<coc0050000003<ol`0c?o<0<coc000
00000P3<ol`5000000L0c?o<0P0000030<coc0050000003<ol`000000<c<o`0000002P3<c?l30000
02d0oooo00210?ooo`<000000P3oc<`2000000040?o<c0000000olc<000000L0olc<0P0000030?o<
c0030000003oc<`0olc<00@0olc<100000060?o<c0040000003oc<`0olc<0?o<c0800000103oc<`2
000001H0olc<1000000j0?o<c080000000<0olc<0000003oc<`01`3oc<`4000000<0olc<00<00000
0?o<c03oc<`00`3oc<`200000100olc<0P0000050?o<c0030000003oc<`0olc<0080olc<0P000000
0`3oc<`0c?o<00000002000000P0c?o<0`00000@0<coc0050000003<ol`0c?o<0<coc00000000`3<
ol`3000000030<coc0000000000000<0c?o<0P0000050<coc0040000003<ol`00000000000`0c<co
0P00000]0?ooo`00PP3ooolC000000@0olc<00<000000?o<c03oc<`01@3oc<`4000000<0olc<00<0
00000?o<c03oc<`00`3oc<`00`000000olc<0?o<c0030?o<c0030000003oc<`0olc<01<0olc<00D0
00000?o<c0000000olc<0000000j0?o<c10000000P3oc<`00`000000olc<0?o<c0050?o<c0030000
003oc<`0olc<00l0olc<00<000000?o<c03oc<`00`3oc<`00`000000olc<0?o<c0040?o<c1000000
4@3<ol`010000000c?o<0000000000030<coc0<000000P3<ol`<000000030<coc0000000c<co00d0
c<co00<000000?ooo`3oool0:`3oool008<0oooo100000000`3oc<`00000000000040?o<c0800000
103oc<`00`000000olc<0?o<c0020?o<c0030000003oc<`0olc<00<0olc<0P0000020?o<c0@00000
00<0olc<0000003oc<`0103oc<`3000000@0olc<00<000000?o<c03oc<`04@3oc<`01P000000olc<
0?o<c0000000olc<000003X0olc<00<000000?o<c03oc<`00`3oc<`00`000000olc<0?o<c0030?o<
c0030000003oc<`0000000@000001`3oc<`00`000000olc<0?o<c00>0?o<c0800000103oc<`00`00
0000olc<0?o<c0030?o<c0<0000000D0olc<00000000000000000?o<c0030<coc0030000003<ol`0
c?o<00<0c?o<0P00000@0<coc0040000003<ol`00000000000@0c?o<1P000000103<ol`000000000
000000050<coc0<0000000<0c?o<0<c<o`3<c?l02`3<c?l00`000000oooo0?ooo`0[0?ooo`00Q03o
ool00`000000olc<00000002000000D0olc<00<000000?o<c03oc<`00`3oc<`00`000000olc<0?o<
c0030?o<c0030000003oc<`0olc<008000001@3oc<`00`000000olc<00000002000000D0olc<00<0
00000?o<c03oc<`00P0000030?o<c0030000003oc<`0olc<00l0olc<00L000000?o<c03oc<`0olc<
0000003oc<`0000003X0olc<00<000000?o<c03oc<`00`3oc<`00`000000olc<0?o<c0030?o<c003
0000003oc<`0000000<0000000<0olc<0000003oc<`0103oc<`2000000l0olc<00<000000?o<c000
00000`3oc<`00`000000olc<0?o<c0020?o<c0<00000103oc<`01`000000olc<000000000000olc<
0<coc0000000103<ol`4000000l0c?o<00@000000<coc0000000c?o<0P0000030<coc080000000<0
c?o<0000003<ol`00`3<ol`300000080c?o<0P0000020<coc0030000003<c?l0c<co00X0c<co00<0
00000?ooo`3oool0;03oool008D0oooo00<000000?o<c03oc<`00`0000030?o<c0800000103oc<`2
000000D0olc<0P0000070?o<c0040000003oc<`0olc<0?o<c0<000000`3oc<`00`000000olc<0?o<
c0020?o<c08000000P3oc<`00`000000olc<0?o<c00=0?o<c08000000P3oc<`010000000olc<0?o<
c000000i0?o<c0@000000`3oc<`00`000000olc<0?o<c0040?o<c0L000001@3oc<`2000000h0olc<
0P0000001@3oc<`000000?o<c03oc<`0000000<0olc<0P0000030?o<c08000000P3oc<`010000000
olc<0?o<c03oc<`2000000030?o<c0000000c?o<0080c?o<0P0000000`3<ol`000000000000>0<co
c0030000003<ol`0000000<0c?o<0P0000020<coc08000001P3<ol`600000080c?o<00<000000<c<
o`3<c?l02P3<c?l00`000000oooo0?ooo`0/0?ooo`00Q@3oool01P000000olc<0?o<c03oc<`00000
0?o<c080000000<0olc<0000000000001@3oc<`010000000olc<0?o<c03oc<`2000000X0olc<00<0
00000?o<c03oc<`00P3oc<`300000080olc<00<000000?o<c03oc<`00`3oc<`3000000l0olc<00D0
00000?o<c03oc<`0olc<000000020?o<c0800000>03oc<`010000000olc<0000003oc<`200000080
olc<00<000000?o<c03oc<`00`3oc<`400000080olc<0`000000103oc<`0000000000000000?0?o<
c0080000003oc<`0olc<0?o<c0000000olc<0000003oc<`2000000L0olc<0P0000000`3oc<`00000
0?o<c0030?o<c080000000@0olc<0<coc03<ol`000000`3<ol`00`000000c?o<0<coc00=0<coc080
00001@3<ol`2000000030<coc0000000c?o<00@0c?o<00@000000<coc03<ol`0c?o<0`0000020<co
c0030000003<c?l0c<co00X0c<co00<000000?ooo`3oool0;03oool008H0oooo1@0000020?o<c0@0
00000`3oc<`2000000030?o<c0000000000000d0olc<00<000000?o<c03oc<`00`3oc<`4000000L0
olc<0P00000=0?o<c0030000003oc<`0olc<0080olc<00<000000?o<c03oc<`00P00000h0?o<c0@0
00000P3oc<`3000000@0olc<1@0000040?o<c0D000003P3oc<`00`000000olc<0?o<c0020?o<c0@0
00002`3oc<`3000000@0olc<0`0000000`3oc<`000000<coc0030<coc0030000003<ol`0c?o<00`0
c?o<00<000000<coc03<ol`01P3<ol`3000000<0c?o<0P0000030<coc080000000D0c?o<00000000
0000c?o<0000000:0<c<o`030000003oool0oooo02d0oooo00270?ooo`@00000103oc<`500000003
0?o<c00000000000014000001P3oc<`H000000D0olc<00D000000?o<c03oc<`0olc<0000000h0?o<
c0@00000103oc<`5000000030?o<c00000000000008000000P3oc<`E000000D0olc<4`0000030?o<
c0030000003oc<`0olc<02@0000000H0c?o<000000000000c?o<0000003<ol`200000080c?o<0P00
000:0<c<o`030000003oool0oooo02d0oooo00280?ooo`<000001P3oc<`600000100olc<0P000006
0?o<c0@000003`3oc<`3000000H0olc<00D000000?o<c03oc<`0olc<0000000h0?o<c080000000<0
olc<0000003oc<`01@3oc<`7000000030?o<c00000000000008000000`3oc<`4000000X0olc<00<0
00000?o<c03oc<`00P3oc<`3000000@0olc<0`00000:0?o<c08000000`3oc<`00`000000olc<0?o<
c008000000040<coc0000000c?o<0<coc0800000103<ol`2000000030<coc0000000c?o<0080c?o<
00<000000<coc03<ol`0103<ol`3000000<0c?o<100000040<coc0<000001P3<c?l3000002l0oooo
00280?ooo`030000003oc<`0000000D0olc<0P0000000`3oc<`000000000000200000140olc<00<0
00000?o<c03oc<`00`3oc<`2000000030?o<c00000000000008000002`3oc<`2000000030?o<c000
0000000000D0olc<00<000000?o<c03oc<`00P3oc<`2000003H0olc<1@0000050?o<c080000000@0
olc<000000000000olc<100000000`3oc<`00000000000030?o<c0040000003oc<`0olc<0?o<c080
00001`3oc<`010000000olc<0?o<c03oc<`2000000030?o<c000000000000080olc<0P0000000`3o
c<`000000?o<c00;0?o<c0060000003oc<`0olc<0?o<c0000000olc<0P0000000`3oc<`000000000
0002000000030<coc0000000000000<0c?o<0P0000050<coc0<00000103<ol`00`000000c?o<0<co
c0040<coc080000000D0c?o<00000000000000000<coc002000000@0c?o<0P0000000`3<c?l00000
000000020<c<o`80000000<0c<co000000000000;`3oool008T0oooo0P0000030?o<c08000001@3o
c<`200000180olc<00<000000?o<c03oc<`00P3oc<`010000000olc<0?o<c00000020?o<c0<00000
1`3oc<`2000000<0olc<00<000000?o<c03oc<`0103oc<`00`000000olc<0?o<c0020?o<c0800000
=P3oc<`5000000<0olc<0P0000050?o<c0<000000`3oc<`00`000000olc<0?o<c0020?o<c0060000
003oc<`0olc<0?o<c0000000olc<0P0000050?o<c0040000003oc<`00000000000<0olc<00@00000
0?o<c000000000000`3oc<`00`000000olc<0?o<c00;0?o<c0060000003oc<`0olc<0000003oc<`0
00000P3oc<`00`000000olc<0?o<c004000000<0c?o<00<000000<coc03<ol`01@3<ol`2000000@0
c?o<00<000000<coc03<ol`01@3<ol`3000000<0c?o<00<000000<coc03<ol`00`3<ol`200000003
0<c<o`000000c<co00<000000`3<c?l00`000000oooo0?ooo`0]0?ooo`00RP3oool5000000L0olc<
00<000000?o<c03oc<`04@3oc<`01@000000olc<0?o<c03oc<`0000000<0olc<00@000000?o<c03o
c<`0olc<0`0000030?o<c0800000103oc<`00`000000olc<0?o<c0050?o<c0030000003oc<`0olc<
0080olc<0P00000f0?o<c0<0000000<0olc<0000000000000`0000070?o<c08000000`3oc<`20000
00<0olc<00@000000?o<c03oc<`00000103oc<`200000080olc<0`0000000`3oc<`000000?o<c002
0?o<c0800000103oc<`00`000000olc<0?o<c00=0?o<c0050000003oc<`000000?o<c00000000`3o
c<`010000000olc<0?o<c03oc<`3000000030<coc0000000c?o<00L0c?o<100000000`3<ol`00000
000000070<coc080000000@0c?o<000000000000c?o<0P0000050<coc0030000003<c?l000000080
000000D0c<co000000000000c<co0000000`0?ooo`00R`3oool010000000olc<0?o<c00000070?o<
c0030000003oc<`0olc<0180olc<00@000000?o<c03oc<`00000103oc<`00`000000olc<0?o<c002
0?o<c0@000001@3oc<`00`000000olc<0?o<c0060?o<c0030000003oc<`0olc<0080olc<0P00000f
0?o<c0040000003oc<`000000?o<c08000000P3oc<`00`000000olc<0?o<c0050?o<c0/000000P3o
c<`00`000000olc<0?o<c0040?o<c0<000000`3oc<`01@000000olc<0?o<c03oc<`0000000@0olc<
00<000000?o<c03oc<`03`3oc<`2000000030?o<c0000000olc<00<0olc<00D000000?o<c03oc<`0
00000?o<c003000000L0c?o<00<000000<coc00000001P0000050<coc1P00000<03oool008`0oooo
0P0000080?o<c08000004`3oc<`010000000olc<0000000000050?o<c0030000003oc<`0olc<00<0
olc<0`0000030?o<c08000001`3oc<`00`000000olc<0?o<c0040?o<c0030000003oc<`0olc<03@0
olc<00<000000?o<c03oc<`01@0000080?o<c0<000001P3oc<`2000000030?o<c0000000olc<00@0
olc<0`0000060?o<c0040000003oc<`0olc<000000<0olc<00<000000?o<c03oc<`0403oc<`01000
0000olc<0000000000050?o<c0040000003oc<`0olc<00000080olc<0`0000050<coc0040000003<
ol`0c?o<000000<0c?o<0P0000050<coc0P000000P3<ol`200000080c?o<00<000000<c<o`000000
103<c?l300000300oooo002<0?ooo`8000002@3oc<`00`000000olc<0?o<c00B0?o<c08000001`3o
c<`00`000000olc<0?o<c0040?o<c0<0000000<0olc<0000003oc<`01`3oc<`00`000000olc<0?o<
c0040?o<c0800000=03oc<`3000000040?o<c0000000olc<0?o<c08000002@3oc<`2000000H0olc<
00<000000?o<c0000000103oc<`3000000P0olc<00<000000?o<c00000000`3oc<`2000001<0olc<
0P0000050?o<c0050000003oc<`000000?o<c0000000103oc<`3000000040<coc000000000000000
00<0c?o<00@000000<coc03<ol`0c?o<0`0000000`3<ol`000000000000200000080c?o<10000002
0<coc0030000003<ol`0c?o<0080c?o<0P0000040<c<o`800000<@3oool008d0oooo00<000000?o<
c03oc<`01`3oc<`00`000000olc<0?o<c00C0?o<c0030000003oc<`0olc<00H0olc<00<000000?o<
c03oc<`01@3oc<`D000003@0olc<0`0000000`3oc<`000000?o<c0020?o<c0030000003oc<`0olc<
00L0olc<00<000000?o<c03oc<`01@3oc<`2000000<0olc<0`00000:0?o<c0030000003oc<`00000
00<0olc<00<000000?o<c03oc<`04`3oc<`00`000000olc<0?o<c0020?o<c0040000003oc<`0olc<
0?o<c08000001P3oc<`2000000030?o<c0000000c?o<00<0c?o<0P0000020<coc0050000003<ol`0
00000000003<ol`00P0000040<coc0L000000`3<ol`00`000000c<co0<c<o`040<c<o`030000003o
ool0oooo02l0oooo002>0?ooo`030000003oc<`0olc<00D0olc<0P00000E0?o<c0030000003oc<`0
olc<00H0olc<00<000000?o<c03oc<`00`3oc<`3000000040?o<c00000000000000000/0olc<1000
000d0?o<c0030000003oc<`0000000800000103oc<`00`000000olc<0?o<c0050?o<c08000001`3o
c<`2000000030?o<c0000000000000<0olc<0P0000080?o<c0030000003oc<`000000080olc<0P00
000E0?o<c0030000003oc<`0olc<0080olc<00@000000?o<c03oc<`0olc<0P0000040?o<c0<00000
00<0olc<0000000000002P0000030<coc0030000003<ol`0c?o<00@0c?o<0`0000000`3<ol`00000
00000004000000H0c<co00<000000?ooo`3oool0;`3oool008l0oooo00<000000?o<c03oc<`00`3o
c<`4000001@0olc<00<000000?o<c03oc<`01`3oc<`00`000000olc<0?o<c003000000D0olc<0`00
00070?o<c08000000`3oc<`00`000000olc<0?o<c00b0?o<c0050000003oc<`000000?o<c0000000
0`3oc<`00`000000olc<000000050?o<c0040000003oc<`00000000000D0olc<100000070?o<c080
00001P3oc<`01`000000olc<0000003oc<`000000?o<c00000005@3oc<`01@000000olc<0?o<c03o
c<`0000000D0olc<0P000000103oc<`000000000000000050?o<c080000000@0olc<000000000000
c?o<100000030<coc0800000103<ol`4000000<0c?o<100000060<c<o`030000003oool0oooo02l0
oooo002?0?ooo`030000003oc<`0olc<0080olc<00<000000?o<c03oc<`00P00000C0?o<c0800000
2P3oc<`3000000T0olc<0`0000030?o<c08000001@3oc<`00`000000olc<0?o<c00a0?o<c0@00000
0P3oc<`00`000000olc<00000004000000<0olc<0`0000000`3oc<`000000?o<c0040?o<c0800000
2`3oc<`2000000@0olc<00@000000?o<c000000000000`3oc<`00`000000olc<0?o<c00A0?o<c080
00000P3oc<`00`000000olc<0?o<c0050?o<c0<000002@3oc<`4000000030<coc000000000000080
00000P3<ol`00`000000c?o<000000020<coc0030000003<ol`0c?o<0080000000<0c?o<00000000
00000P3<ol`2000000H0c<co00<000000?ooo`3oool0;`3oool00900oooo00<000000?o<c03oc<`0
0P0000030?o<c0030000003oc<`0olc<0140olc<00<000000?o<c03oc<`01`3oc<`3000000d0olc<
100000070?o<c0800000<P3oc<`00`000000olc<000000030?o<c0<000000`3oc<`200000080olc<
00@000000?o<c0000000olc<0`000000103oc<`0000000000000000=0?o<c0<000000`3oc<`00`00
0000olc<000000030?o<c0030000003oc<`0olc<0140olc<00@000000?o<c03oc<`000001P3oc<`3
000000d0olc<0P0000000`3oc<`0c?o<00000004000000<0c?o<00<000000<coc00000000`3<ol`3
000000@0c?o<0`0000020<c<o`<00000<@3oool00940oooo00<000000?o<c0000000103oc<`00`00
0000olc<0?o<c00A0?o<c0030000003oc<`0olc<00D0olc<0`00000A0?o<c0<000001P3oc<`20000
0380olc<0P0000040?o<c0<00000103oc<`00`000000olc<000000020?o<c0030000003oc<`00000
00H000003@3oc<`2000000040?o<c000000000000?o<c0800000103oc<`00`000000olc<0?o<c00A
0?o<c0040000003oc<`0olc<000000@0olc<0`00000A0?o<c0L00000103<ol`00`000000c?o<0<co
c0030<coc08000001@3<ol`00`000000c<co0000000300000380oooo002B0?ooo`030000003oc<`0
olc<00<0olc<00<000000?o<c03oc<`04@3oc<`00`000000olc<0?o<c0030?o<c0<000005@3oc<`3
000000D0olc<00<000000?o<c03oc<`0<03oc<`00`000000olc<0?o<c0030?o<c0030000003oc<`0
000000D0olc<00H000000?o<c03oc<`0olc<0000003oc<`300000080olc<0P00000>0?o<c0040000
003oc<`0olc<0?o<c08000001@3oc<`00`000000olc<0?o<c00A0?o<c0030000003oc<`0000000<0
olc<0`00000E0?o<c0D000000`3<ol`00`000000c?o<0<coc0050<coc0030000003<ol`0c?o<00<0
c?o<00@000000<c<o`3<c?l0c<co0P00000b0?ooo`00T`3oool00`000000olc<0?o<c003000001<0
olc<00@000000?o<c03oc<`0olc<0`00000I0?o<c0<000000`3oc<`00`000000olc<0?o<c00`0?o<
c0<000000`3oc<`3000000@0olc<00D000000?o<c03oc<`0olc<000000020?o<c08000000`3oc<`2
000000h0olc<00<000000?o<c03oc<`00P3oc<`2000000@0olc<0P00000B0?o<c08000000P3oc<`3
000001T0olc<0`0000020<coc08000001`3<ol`2000000<0c?o<0P0000030<c<o`800000<P3oool0
09@0oooo0P0000020?o<c08000004@3oc<`00`000000olc<0?o<c003000001d0olc<0`0000000`3o
c<`000000000000`0?o<c0040000003oc<`0olc<0?o<c080000000@0olc<00000000000000000`3o
c<`00`000000olc<0?o<c0020?o<c0040000003oc<`0olc<0?o<c08000000P3oc<`00`000000olc<
0?o<c00=0?o<c0030000003oc<`0olc<0080olc<00<000000?o<c0000000103oc<`00`000000olc<
0?o<c00?0?o<c080000000@0olc<00000000000000007@3oc<`3000000030<coc0000000c?o<00D0
c?o<00D000000<coc000000000000<coc004000000040<c<o`000000c<co00000380oooo002E0?oo
o`<0000000<0olc<0000003oc<`0403oc<`400000240olc<1000000`0?o<c0050000003oc<`00000
0000003oc<`01@0000030?o<c0030000003oc<`0olc<0080olc<00@000000?o<c03oc<`0olc<1@00
000?0?o<c08000000P3oc<`010000000olc<0?o<c00000040?o<c0030000003oc<`0olc<00l0olc<
1000000Q0?o<c0@000001@3<ol`02@000000c?o<0<coc0000000c?o<0000003<ol`000000<coc004
00000380oooo002E0?ooo`030000003oc<`0olc<00<000003`3oc<`3000002D0olc<0`00000^0?o<
c0<000001@3oc<`6000000D0olc<00H000000?o<c03oc<`0olc<0000003oc<`200000140olc<00@0
00000?o<c03oc<`000000`3oc<`010000000olc<0?o<c03oc<`2000000l0olc<0`00000U0?o<c0<0
00000`3<ol`2000000<0c?o<00@000000<coc03<ol`0c?o<0P0000000`3<c?l000000?ooo`0b0?oo
o`00UP3oool8000000X0olc<0P0000000`3oc<`000000?o<c00V0?o<c0@00000:P3oc<`200000003
0?o<c0000000olc<00H0olc<0P0000000`3oc<`00000000000050?o<c0030000003oc<`0olc<0080
olc<0`00000A0?o<c0040000003oc<`0olc<000000@0olc<00<000000?o<c03oc<`01000000;0?o<
c080000000<0olc<0000003oc<`09P3oc<`6000000@0c?o<1@0000020<c<o`030000003oool0oooo
0340oooo002G0?ooo`80000000@0olc<0000003oc<`0olc<0`0000060?o<c08000000P3oc<`20000
02L0olc<00<000000?o<c00000000`00000V0?o<c08000000P3oc<`00`000000olc<0?o<c0060?o<
c0040000003oc<`000000?o<c0<000000P3oc<`00`000000olc<0?o<c0030?o<c0040000003oc<`0
0000000000l0olc<0`0000000`3oc<`000000?o<c0040?o<c0040000003oc<`0olc<00000080olc<
0P0000070?o<c08000000P3oc<`2000002L0olc<0P0000020?o<c0/0000000<0c<co0000003<c?l0
<`3oool009P0oooo0`0000040?o<c0<000000P3oc<`2000000@0olc<00<000000?o<c03oc<`09`3o
c<`3000000040?o<c0000000000000000280olc<0P0000040?o<c0030000003oc<`0olc<00L0olc<
00@000000?o<c03oc<`0olc<1@0000050?o<c0050000003oc<`000000?o<c00000003@3oc<`01@00
0000olc<0?o<c0000000olc<00<00000103oc<`00`000000olc<000000040?o<c08000000`3oc<`2
000000@0olc<00<000000?o<c03oc<`09`3oc<`2000000<0olc<0P000000103<ol`000000000003<
ol`5000003@0oooo002H0?ooo`030000003oc<`0000000<0olc<00<000000?o<c03oc<`00`000006
0?o<c0030000003oc<`0olc<02L0olc<00<000000?o<c00000000`3oc<`3000001h0olc<0P000006
0?o<c0030000003oc<`0olc<00L0olc<00D000000?o<c03oc<`0olc<000000020?o<c0<00000103o
c<`6000000/0olc<00L000000?o<c03oc<`0olc<0000003oc<`000000080olc<0P0000030?o<c080
00001P3oc<`3000000H0olc<00<000000?o<c03oc<`09`3oc<`00`000000olc<000000040?o<c0T0
0000=03oool009T0oooo0`0000020?o<c0H000001P3oc<`00`000000olc<0?o<c00W0?o<c0040000
003oc<`0olc<000000@0olc<1000000I0?o<c0@000001P3oc<`00`000000olc<0?o<c0060?o<c003
0000003oc<`0olc<00<0olc<00<000000?o<c03oc<`00P3oc<`2000000<0olc<0P0000020?o<c003
0000003oc<`0olc<00T0olc<00@000000?o<c03oc<`0olc<0P0000050?o<c080000000@0olc<0000
000000000000203oc<`2000000@0olc<00<000000?o<c03oc<`09`3oc<`010000000olc<0?o<c000
00050?o<c0L00000=03oool009X0oooo0P000000103oc<`000000000000000020?o<c08000001@3o
c<`2000002T0olc<00D000000?o<c03oc<`0olc<000000020?o<c080000000<0olc<000000000000
0P00000E0?o<c08000000P3oc<`2000000D0olc<00<000000?o<c03oc<`01P3oc<`00`000000olc<
0?o<c0050?o<c0030000003oc<`0olc<00<0olc<0P0000000`3oc<`000000?o<c0030?o<c0030000
003oc<`0olc<00L0olc<00<000000?o<c03oc<`00`3oc<`00`000000olc<0?o<c0050?o<c0@00000
2P3oc<`2000000030?o<c0000000000002T0olc<00@000000?o<c03oc<`000001`3oc<`5000003@0
oooo002K0?ooo`8000001P3oc<`2000000@0olc<00<000000?o<c03oc<`0:@3oc<`00`000000olc<
0?o<c003000000D0olc<1000000A0?o<c08000001@3oc<`2000000@0olc<2@0000090?o<c0030000
003oc<`0olc<00@0olc<<000000Z0?o<c0050000003oc<`0olc<0?o<c00000002@3oc<`2000003@0
oooo002L0?ooo`030000003oc<`0olc<00@0olc<00<000000?o<c00000000`3oc<`00`000000olc<
0?o<c00Y0?o<c0040000003oc<`0olc<0?o<c08000001`3oc<`4000000d0olc<0P0000070?o<c003
0000003oc<`0000000<0olc<00<000000?o<c03oc<`00`3oc<`2000000X0olc<00<000000?o<c03o
c<`01@3oc<`00`000000olc<0?o<c0020?o<c0030000003oc<`0olc<00@0olc<0P00000C0?o<c003
0000003oc<`0olc<00@0olc<00<000000?o<c03oc<`00`3oc<`00`000000olc<0?o<c00X0?o<c080
00000`3oc<`00`000000olc<0?o<c0050?o<c0800000=@3oool009`0oooo00<000000?o<c03oc<`0
103oc<`010000000olc<0?o<c00000020?o<c0030000003oc<`0olc<02T0olc<00<000000?o<c03o
c<`00P3oc<`00`000000olc<0?o<c0050?o<c0D000002P3oc<`2000000T0olc<00@000000?o<c03o
c<`000000P3oc<`00`000000olc<0?o<c0030?o<c08000002`3oc<`00`000000olc<0?o<c0030?o<
c0800000103oc<`00`000000olc<0?o<c0020?o<c080000000<0olc<0000003oc<`04P3oc<`00`00
0000olc<0?o<c0030?o<c08000001@3oc<`00`000000olc<0?o<c00Y0?o<c0030000003oc<`0olc<
0080olc<00<000000?o<c03oc<`00P3oc<`4000003D0oooo002M0?ooo`030000003oc<`0olc<00<0
olc<00D000000?o<c03oc<`000000?o<c002000002/0olc<0`0000030?o<c0030000003oc<`0olc<
00<0olc<0P0000030?o<c0<000001P3oc<`2000000/0olc<00D000000?o<c03oc<`000000?o<c002
000000D0olc<00<000000?o<c03oc<`02`3oc<`00`000000olc<0?o<c0020?o<c0<00000103oc<`0
10000000olc<0000000000020?o<c0030000003oc<`0olc<01<0olc<00<000000?o<c03oc<`00P3o
c<`3000000<0olc<0P00000[0?o<c0030000003oc<`0olc<0080olc<00<000000?o<c03oc<`00P00
00020?o<c0800000=@3oool009d0oooo00<000000?o<c03oc<`0103oc<`00`000000olc<0?o<c002
000002`0olc<00<000000?o<c03oc<`00P0000020?o<c0070000003oc<`0olc<0?o<c0000000olc<
000000050?o<c0<000000P3oc<`2000000h0olc<00<000000?o<c03oc<`0100000030?o<c0030000
003oc<`0olc<00d0olc<00L000000?o<c03oc<`0olc<0000003oc<`0000000@0olc<0P0000030?o<
c0030000003oc<`0olc<01D0olc<00L000000?o<c03oc<`0olc<0000003oc<`0000000<0olc<00<0
00000?o<c03oc<`0:P3oc<`00`000000olc<0?o<c0030?o<c08000000`3oc<`3000003D0oooo002N
0?ooo`L000000`3oc<`00`000000olc<0?o<c00[0?o<c0040000003oc<`0olc<0?o<c0@0000000<0
olc<0000003oc<`00P0000070?o<c1@000000`3oc<`00`000000olc<0000000400000100olc<00H0
00000?o<c03oc<`000000?o<c00000020?o<c0<000000`3oc<`00`000000olc<0?o<c00G0?o<c006
0000003oc<`0olc<0000003oc<`000000`3oc<`00`000000olc<0?o<c00Z0?o<c08000000P3oc<`2
000000@0olc<0P0000000`3oc<`000000?ooo`0d0?ooo`00W`3oool00`000000olc<0?o<c0020?o<
c0050000003oc<`0olc<0?o<c0000000;@3oc<`00`000000olc<0?o<c0030?o<c080000000<0olc<
0000003oc<`00P0000050?o<c08000000P3oc<`3000000h0olc<00@000000?o<c03oc<`0olc<1000
00000`3oc<`000000?o<c00@0?o<c0050000003oc<`000000000003oc<`0100000050?o<c0030000
003oc<`0olc<01L0olc<00<000000?o<c00000000P3oc<`00`000000olc<00000002000002`0olc<
100000050?o<c0@00000=P3oool00:00oooo00D000000?o<c03oc<`0olc<000000030?o<c0030000
003oc<`0olc<02/0olc<00<000000?o<c03oc<`01@3oc<`010000000olc<0?o<c00000040?o<c080
00001P3oc<`3000000`0olc<00H000000?o<c03oc<`0olc<0000003oc<`3000001<0olc<0P000002
0?o<c0T000006`3oc<`200000080olc<0P0000020?o<c0030000003oc<`0olc<02/0olc<3000000f
0?ooo`00X03oool010000000olc<0?o<c03oc<`2000000030?o<c0000000000002d0olc<00<00000
0?o<c03oc<`0103oc<`01@000000olc<0?o<c03oc<`000000080olc<0P00000:0?o<c0<000002P3o
c<`2000000060?o<c000000000000000003oc<`000005@3oc<`00`000000olc<0?o<c002000000D0
olc<00<000000?o<c03oc<`06`3oc<`00`000000olc<0?o<c002000000030?o<c0000000000002d0
olc<00<000000?o<c03oc<`0103oc<`3000000030?o<c0000000oooo03D0oooo002Q0?ooo`070000
003oc<`0olc<0?o<c0000000olc<0000000_0?o<c0030000003oc<`0olc<0080olc<00@000000?o<
c03oc<`0olc<1000000>0?o<c0<000002@3oc<`010000000olc<0000003oc<`3000001D0olc<00<0
00000?o<c03oc<`00P0000040?o<c0030000003oc<`0olc<01d0olc<00H000000?o<c00000000000
0?o<c000000^0?o<c0030000003oc<`0olc<00<0olc<00<000000?o<c00000000P00000g0?ooo`00
XP3oool01P000000olc<0?o<c0000000olc<000002l0olc<00<000000?o<c03oc<`00P3oc<`01000
0000olc<0?o<c03oc<`200000180olc<0`0000070?o<c0030000003oc<`0000000D00000503oc<`0
1@000000olc<0?o<c03oc<`0000000@0olc<00<000000?o<c03oc<`07@3oc<`01P000000olc<0?o<
c0000000olc<000002h0olc<00<000000?o<c03oc<`00P3oc<`00`000000olc<0?o<c0020?o<c003
0000003oool0oooo03D0oooo002S0?ooo`050000003oc<`000000?o<c0000000;`3oc<`01@000000
olc<0?o<c03oc<`0000000@0olc<0P00000D0?o<c0<000001@3oc<`01@000000olc<0000003oc<`0
00000080olc<00<000000?o<c03oc<`04@3oc<`2000000<0olc<00D000000?o<c03oc<`0olc<0000
000Q0?o<c0050000003oc<`000000?o<c0000000;P3oc<`01`000000olc<0?o<c03oc<`000000?o<
c00000000`3oc<`00`000000oooo0?ooo`0e0?ooo`00Y03oool2000000030?o<c0000000olc<02h0
olc<00@000000?o<c03oc<`000001@3oc<`00`000000olc<0?o<c00C0?o<c0030000003oc<`00000
008000000`3oc<`010000000olc<0000000000030?o<c0030000003oc<`0olc<0140olc<00<00000
0?o<c03oc<`00P3oc<`010000000olc<0?o<c000000S0?o<c080000000<0olc<0000003oc<`0;@3o
c<`2000000030?o<c000000000000080olc<00@000000?o<c03oc<`00000=`3oool00:@0oooo00<0
00000?o<c0000000<@3oc<`2000000H0olc<00<000000?o<c03oc<`0503oc<`2000000040?o<c000
0000000000000080olc<0`0000030?o<c0030000003oc<`0olc<0140olc<00<000000?o<c03oc<`0
0P3oc<`3000002D0olc<0P00000`0?o<c0030000003oc<`0000000<0olc<1000000g0?ooo`00Y@3o
ool200000340olc<0P0000050?o<c08000005P3oc<`00`000000olc<000000020?o<c0D00000103o
c<`200000180olc<00<000000?o<c03oc<`00`3oc<`2000002D0olc<0P00000`0?o<c08000001@3o
c<`2000003P0oooo002V0?ooo`030000003oc<`0olc<02l0olc<00<000000?o<c03oc<`0103oc<`2
000001H0olc<00@000000?o<c03oc<`000000`3oc<`3000000@0olc<0P00000B0?o<c0030000003o
c<`0olc<0080olc<0P00000W0?o<c0030000003oc<`0olc<02h0olc<00<000000?o<c03oc<`01@3o
c<`00`000000oooo0?ooo`0f0?ooo`00Y`3oool00`000000olc<0?o<c00]0?o<c0<000001@3oc<`2
000001H0olc<00D000000?o<c03oc<`0olc<000000050?o<c0@0000000<0olc<0000003oc<`0403o
c<`010000000olc<0?o<c03oc<`4000002L0olc<0P00000^0?o<c08000001`3oc<`00`000000oooo
0?ooo`0f0?ooo`00Z03oool00`000000olc<0?o<c00[0?o<c0D00000103oc<`00`000000olc<0?o<
c00F0?o<c0040000003oc<`0olc<000000L0olc<0P0000000`3oc<`000000?o<c00@0?o<c0030000
003oc<`00000008000000P3oc<`00`000000olc<0?o<c00U0?o<c0030000003oc<`0000002`0olc<
0P0000000`3oc<`000000?o<c0050?o<c0030000003oool0oooo03H0oooo002X0?ooo`030000003o
c<`0olc<02/0olc<0P0000000`3oc<`00000000000040?o<c0030000003oc<`0olc<01H0olc<00D0
00000?o<c03oc<`0olc<000000080?o<c08000004@3oc<`3000000<0olc<00<000000?o<c0000000
9@3oc<`010000000olc<0?o<c000000/0?o<c0@000001P3oc<`00`000000oooo0?ooo`0f0?ooo`00
Z@3oool00`000000olc<0?o<c00Y0?o<c0070000003oc<`000000?o<c0000000olc<000000030?o<
c0030000003oc<`0olc<01H0olc<00<000000?o<c03oc<`00P3oc<`00`000000olc<0?o<c0050?o<
c0@000003@3oc<`3000000D0olc<00<000000?o<c00000009@3oc<`01@000000olc<0?o<c03oc<`0
000002X0olc<0P0000030?o<c08000000P3oc<`2000003T0oooo002Z0?ooo`030000003oc<`0olc<
02L0olc<00H000000?o<c03oc<`000000?o<c00000020?o<c0040000003oc<`00000000001P0olc<
00<000000?o<c03oc<`00`3oc<`00`000000olc<0?o<c0030?o<c0030000003oc<`000000080olc<
0P0000090?o<c0<000001`3oc<`00`000000olc<0000000U0?o<c0030000003oc<`0olc<0080olc<
00<000000?o<c03oc<`09P3oc<`3000000@0olc<1@00000i0?ooo`00Z`3oool00`000000olc<0?o<
c00U0?o<c0040000003oc<`0olc<00000080olc<00<000000?o<c03oc<`00`00000I0?o<c0800000
1@3oc<`010000000olc<0?o<c03oc<`3000000D0olc<0P0000050?o<c0<000002@3oc<`00`000000
olc<0000000U0?o<c0030000003oc<`0olc<0080olc<0P00000V0?o<c0@000000P3oc<`500000003
0?o<c0000000oooo03P0oooo002/0?ooo`030000003oc<`0olc<02<0olc<00D000000?o<c03oc<`0
olc<000000030?o<c0030000003oc<`0olc<008000006P3oc<`00`000000olc<0?o<c0030?o<c007
0000003oc<`0olc<0?o<c0000000olc<000000070?o<c080000000@0olc<00000000000000002P3o
c<`01@000000olc<0?o<c03oc<`0000002<0olc<00@000000?o<c03oc<`0olc<0`0000000`3oc<`0
00000?o<c00T0?o<c0P000000`3oc<`2000003T0oooo002]0?ooo`030000003oc<`0olc<0240olc<
00<000000?o<c03oc<`00P3oc<`01@000000olc<0?o<c03oc<`0000000<0olc<00<000000?o<c03o
c<`0603oc<`00`000000olc<0?o<c0040?o<c0030000003oc<`000000080olc<00<000000?o<c03o
c<`01P3oc<`3000000`0olc<00D000000?o<c03oc<`0olc<0000000S0?o<c0060000003oc<`00000
0000003oc<`000000`3oc<`00`000000olc<0?o<c00Q0?o<c0030000003oc<`0olc<00<0000000<0
olc<000000000000103oc<`00`000000oooo0?ooo`0g0?ooo`00[@3oool00`000000olc<0?o<c00Q
0?o<c0050000003oc<`0olc<0?o<c0000000103oc<`00`000000olc<0?o<c0020?o<c0030000003o
c<`0olc<01H0olc<0P0000070?o<c0050000003oc<`0olc<0?o<c00000001P3oc<`2000000<0olc<
0P00000:0?o<c0030000003oc<`0olc<008000008`3oc<`2000000<0olc<00D000000?o<c03oc<`0
olc<0000000R0?o<c0030000003oc<`00000008000000`3oc<`00`000000olc<0?o<c0030?o<c003
0000003oool0oooo03L0oooo002^0?ooo`030000003oc<`0olc<01l0olc<00<000000?o<c03oc<`0
0P3oc<`00`000000olc<0?o<c0020?o<c0030000003oc<`0olc<00<0olc<00<000000?o<c03oc<`0
503oc<`3000000H0olc<00<000000?o<c03oc<`00P3oc<`00`000000olc<0?o<c0020?o<c0800000
1`3oc<`2000000P0olc<00D000000?o<c0000000olc<0000000S0?o<c0050000003oc<`0olc<0?o<
c00000001@3oc<`00`000000olc<0?o<c00N0?o<c0030000003oc<`0000000<000000`3oc<`20000
00<0olc<00<000000?ooo`3oool0>03oool00:l0oooo00<000000?o<c03oc<`07@3oc<`2000000@0
olc<00<000000?o<c03oc<`00`3oc<`00`000000olc<0?o<c0020?o<c0030000003oc<`0olc<01@0
olc<0P0000000`3oc<`000000?o<c0030?o<c08000000`3oc<`010000000olc<0?o<c03oc<`20000
00/0olc<0P0000060?o<c08000000`3oc<`00`000000olc<0?o<c00O0?o<c0040000003oc<`0olc<
0?o<c08000001P3oc<`00`000000olc<0?o<c00L0?o<c1000000>P3oool00;00oooo00<000000?o<
c03oc<`06`3oc<`00`000000olc<0000000200000080olc<00<000000?o<c03oc<`00`3oc<`00`00
0000olc<0?o<c0030?o<c0030000003oc<`0olc<0180olc<00D000000?o<c0000000olc<00000004
0?o<c0030000003oc<`0olc<0080olc<00@000000?o<c000000000003`3oc<`2000000<0olc<00<0
00000?o<c00000000`3oc<`00`000000olc<0?o<c00O0?o<c0040000003oc<`0olc<00000080olc<
0P0000050?o<c0030000003oc<`0olc<01/0olc<0`0000001P3oc<`00000000000000000olc<0000
00H0olc<00<000000?ooo`3oool0>03oool00;40oooo00<000000?o<c03oc<`06@3oc<`010000000
olc<0?o<c03oc<`4000000H0olc<00<000000?o<c03oc<`0103oc<`00`000000olc<0?o<c00@0?o<
c0060000003oc<`0olc<0000003oc<`000000`3oc<`00`000000olc<0?o<c0020?o<c0<000004`3o
c<`5000000@0olc<00<000000?o<c03oc<`07`3oc<`00`000000olc<000000050?o<c0800000103o
c<`00`000000olc<0?o<c00I0?o<c0030000003oc<`00000008000000P3oc<`2000000H0olc<00<0
00000?ooo`3oool0>@3oool00;80oooo00<000000?o<c03oc<`05`3oc<`00`000000olc<0?o<c002
0?o<c0030000003oc<`0olc<00<00000103oc<`00`000000olc<0?o<c0050?o<c0030000003oc<`0
olc<00h0olc<00@000000?o<c03oc<`000000P3oc<`010000000olc<0?o<c00000030?o<c0800000
603oc<`3000000@0olc<00<000000?o<c03oc<`07`3oc<`2000000P0olc<0P0000030?o<c0030000
003oc<`0olc<01L0olc<100000040?o<c0030000003oc<`0olc<00D0olc<00<000000?ooo`3oool0
>@3oool00;80oooo00<000000?o<c03oc<`05`3oc<`00`000000olc<0?o<c0030?o<c0040000003o
c<`0olc<0?o<c0<000000`3oc<`00`000000olc<0?o<c0040?o<c0030000003oc<`0olc<00d0olc<
0P0000020?o<c0040000003oc<`0olc<0?o<c0<0000000<0olc<0000000000007@3oc<`2000000<0
olc<00<000000?o<c03oc<`07@3oc<`00`000000olc<0000000:0?o<c080000000<0olc<0000003o
c<`05`3oc<`2000000<0olc<0P0000020?o<c08000001P3oc<`00`000000oooo0?ooo`0i0?ooo`00
/`3oool00`000000olc<0?o<c00E0?o<c0030000003oc<`0olc<00D0olc<00<000000?o<c03oc<`0
0P3oc<`3000000030?o<c0000000olc<00H0olc<00<000000?o<c03oc<`02`3oc<`2000000<0olc<
00@000000?o<c03oc<`0olc<1000000Q0?o<c080000000<0olc<0000003oc<`07P3oc<`2000000d0
olc<0`00000F0?o<c0<000001@3oc<`2000000030?o<c0000000olc<00@0olc<00<000000?o<c03o
ool0>P3oool00;@0oooo8@0000060?o<c1P00000103oc<`010000000olc<0?o<c03oc<`2000002D0
olc<0P00000O0?o<c2`000000P3oc<`200000080olc<0P0000050?o<c0030000003oool0oooo03X0
oooo002e0?ooo`030000003oc<`0olc<00L0olc<00<000000?o<c03oc<`01P3oc<`2000000X0olc<
0P0000060?o<c0<000004@3oc<`2000000@0olc<00<000000?o<c03oc<`00`00000W0?o<c0<00000
6`3oc<`3000000D0olc<0P00000;0?o<c0030000003oc<`0olc<00@0olc<00<000000?o<c03oc<`0
2@3oc<`2000000@0olc<0P0000040?o<c0@0000000@0olc<0000000000000000?03oool00;D0oooo
00<000000?o<c03oc<`01P3oc<`00`000000olc<0?o<c0050?o<c0<00000303oc<`00`000000olc<
0?o<c0030?o<c0<0000000<0olc<0000000000003@3oc<`3000000D0olc<0`0000020?o<c0030000
003oc<`0olc<02D0olc<0P0000000`3oc<`000000000000G0?o<c08000000P3oc<`010000000olc<
0?o<c03oc<`4000000/0olc<00<000000?o<c03oc<`00`3oc<`2000000T0olc<0P0000000`3oc<`0
00000?o<c0040?o<c0030000003oc<`0olc<0080olc<1@0000020?o<c0030000003oool0oooo03X0
oooo002f0?ooo`030000003oc<`0olc<00D0olc<00<000000?o<c03oc<`00`3oc<`200000080olc<
00<000000?o<c03oc<`02`3oc<`00`000000olc<0?o<c0020?o<c0040000003oc<`0olc<00000080
olc<0P0000090?o<c080000000<0olc<0000003oc<`0103oc<`2000000<0olc<0P00000X0?o<c080
00000P3oc<`2000001<0olc<0P0000030?o<c0030000003oc<`0olc<008000000P3oc<`00`000000
olc<0?o<c00;0?o<c0030000003oc<`0olc<0080olc<0`0000060?o<c08000000P3oc<`00`000000
olc<0?o<c0040?o<c0030000003oc<`0olc<0080olc<100000030?o<c0030000003oool0oooo03X0
oooo002g0?ooo`030000003oc<`0olc<00<0olc<00<000000?o<c03oc<`00P3oc<`2000000<0olc<
00<000000?o<c03oc<`03@3oc<`01@000000olc<0?o<c03oc<`0000000<0olc<00@000000?o<c03o
c<`0olc<0P0000050?o<c08000000P3oc<`00`000000olc<0?o<c0020?o<c08000001@3oc<`00`00
0000olc<0?o<c00W0?o<c0030000003oc<`0000000<0olc<0P00000?0?o<c0<00000103oc<`30000
00<0olc<00<000000?o<c03oc<`03@3oc<`01`000000olc<0?o<c03oc<`000000?o<c0000000103o
c<`2000000<0olc<0P0000070?o<c0030000003oc<`0olc<00D000000P3oc<`00`000000oooo0?oo
o`0k0?ooo`00^03oool01@000000olc<0?o<c03oc<`0000000<0olc<0P0000040?o<c0030000003o
c<`0olc<00l0olc<00@000000?o<c03oc<`000000`3oc<`00`000000olc<0?o<c0030?o<c0800000
00<0olc<0000000000000`3oc<`200000080olc<0P0000070?o<c0030000003oc<`0olc<02L0olc<
00@000000?o<c03oc<`000000P3oc<`010000000olc<00000000000;0?o<c08000000P3oc<`00`00
0000olc<0?o<c0020?o<c0030000003oc<`0olc<0080olc<00<000000?o<c03oc<`03`3oc<`01P00
0000olc<0?o<c0000000olc<00000080olc<0P0000040?o<c0030000003oc<`0000000P0olc<0P00
00030?o<c0050000003oc<`000000?o<c0000000?@3oool00;P0oooo00@000000?o<c03oc<`00000
0P3oc<`2000000030?o<c0000000olc<0080olc<00<000000?o<c03oc<`0403oc<`010000000olc<
0000000000040?o<c0030000003oc<`0olc<00@0olc<0P0000040?o<c0040000003oc<`000000000
00T0olc<00<000000?o<c03oc<`09`3oc<`010000000olc<0?o<c00000020?o<c0040000003oc<`0
olc<0?o<c08000001`3oc<`2000000D0olc<00D000000?o<c03oc<`0olc<000000030?o<c0800000
4@3oc<`01@000000olc<000000000000olc<00<000001@3oc<`4000000H0olc<0P0000050?o<c005
0000003oc<`000000?o<c0000000?@3oool00;T0oooo00<000000?o<c00000000P0000030?o<c003
0000003oc<`0olc<008000004`3oc<`2000000H0olc<00<000000?o<c03oc<`0103oc<`300000004
0?o<c00000000000000000X0olc<0P00000Y0?o<c08000000P3oc<`010000000olc<0?o<c0000004
0?o<c08000000`3oc<`2000000L0olc<00D000000?o<c03oc<`0olc<000000030?o<c0030000003o
c<`0olc<0140olc<0P0000020?o<c0030000003oc<`0olc<00@0olc<0P0000020?o<c08000000`3o
c<`2000000P0olc<00@000000?o<c00000000000?@3oool00;X0oooo0P0000060?o<c0030000003o
c<`0000001D0olc<00<000000?o<c03oc<`0103oc<`00`000000olc<0?o<c0060?o<c1400000:P3o
c<`01`000000olc<0000003oc<`000000?o<c00000001P3oc<`3000000T0olc<00@000000?o<c03o
c<`000000`3oc<`00`000000olc<0?o<c00C0?o<c0030000003oc<`0olc<008000001@3oc<`20000
0080olc<00<000000?o<c00000000P00000:0?o<c0040000003oc<`0olc<000003d0oooo002k0?oo
o`030000003oc<`0olc<00@0olc<0`00000E0?o<c0030000003oc<`0olc<00D0olc<00<000000?o<
c03oc<`0103oc<`2000000030?o<c0000000olc<00/0olc<0P00000Z0?o<c08000000`3oc<`20000
00D0olc<0P0000000`3oc<`00000000000080?o<c0040000003oc<`0olc<00000080olc<0P00000E
0?o<c0030000003oc<`0olc<00800000103oc<`3000000<0olc<0P0000000`3oc<`0000000000009
0?o<c0040000003oc<`0olc<000003d0oooo002k0?ooo`030000003oc<`0olc<00@0olc<0`00000E
0?o<c0030000003oc<`0olc<00H0olc<00@000000?o<c03oc<`0olc<0P0000030?o<c08000002`3o
c<`00`000000olc<0?o<c00Y0?o<c0030000003oc<`0olc<0080olc<0P0000030?o<c08000001@3o
c<`2000000L0olc<00<000000?o<c00000000P3oc<`2000001D0olc<00D000000?o<c03oc<`0olc<
000000030?o<c0@0000000<0olc<0000000000001@3oc<`2000000L0olc<00<000000?o<c0000000
?P3oool00;`0oooo00<000000?o<c03oc<`00P3oc<`2000000030?o<c0000000000001<0olc<0P00
00080?o<c0040000003oc<`00000000000H0olc<00<000000?o<c03oc<`0203oc<`2000002/0olc<
00<000000?o<c03oc<`00`3oc<`4000000T0olc<0P0000050?o<c0040000003oc<`000000?o<c080
000000<0olc<0000003oc<`04P3oc<`2000000<0olc<00<000000?o<c03oc<`00P000000103oc<`0
00000000000000090?o<c08000001@3oc<`00`000000olc<0000000n0?ooo`00_@3oool01@000000
olc<0?o<c03oc<`0000000<0olc<00<000000?o<c03oc<`04@3oc<`00`000000olc<0?o<c0080?o<
c0800000203oc<`00`000000olc<0?o<c0070?o<c0800000:`3oc<`2000000@0olc<0P00000=0?o<
c08000000`3oc<`020000000olc<000000000000olc<0000003oc<`000004`3oc<`00`000000olc<
0?o<c0020?o<c0040000003oc<`0olc<00000080olc<0P00000<0?o<c08000000`3oc<`00`000000
olc<0000000n0?ooo`00_P3oool00`000000olc<000000040?o<c0030000003oc<`0olc<0140olc<
00<000000?o<c03oc<`01P3oc<`2000000/0olc<00<000000?o<c03oc<`01P3oc<`2000002`0olc<
00<000000?o<c03oc<`01000000=0?o<c0@0000000@0olc<00000000000000000P3oc<`00`000000
olc<0000000C0?o<c0030000003oc<`0olc<0080olc<0`0000030?o<c0030000003oc<`0olc<00`0
olc<0`0000020?o<c0800000?P3oool00;h0oooo00<000000?o<c0000000103oc<`00`000000olc<
0?o<c00A0?o<c0030000003oc<`0olc<00@0olc<0P00000=0?o<c08000001`3oc<`00`000000olc<
0?o<c00[0?o<c0H000003P3oc<`00`000000olc<0?o<c00500000080olc<00<000000?o<c0000000
4`3oc<`00`000000olc<0?o<c0030?o<c0@0000000<0olc<0000003oc<`03@3oc<`00`000000olc<
0?o<c003000003l0oooo002o0?ooo`030000003oc<`0olc<0080olc<0P00000C0?o<c0030000003o
c<`0olc<0080olc<4`0000070?o<c0030000003oc<`0olc<02/0olc<0P0000030?o<c0030000003o
c<`0olc<00d0olc<00@000000?o<c03oc<`0olc<0P0000030?o<c0040000003oc<`0000000000180
olc<00<000000?o<c03oc<`00P3oc<`2000000<0olc<0P00000>0?o<c08000000`3oc<`00`000000
oooo0?ooo`0m0?ooo`00`03oool00`000000olc<0000000400000140olc<00@000000?o<c03oc<`0
olc<0P0000000`3oc<`000000?o<c0050?o<c0030000003oc<`0olc<00P0olc<00<000000?o<c03o
c<`00`3oc<`2000002h0olc<00D000000?o<c03oc<`0olc<0000000?0?o<c0030000003oc<`0olc<
0080olc<0P0000000`3oc<`000000?o<c0020?o<c0030000003oc<`0olc<00l0olc<00@000000?o<
c03oc<`0olc<0`000000103oc<`000000?o<c03oc<`2000000h0olc<0P0000030?o<c0030000003o
ool0oooo03d0oooo00310?ooo`@0000000<0olc<0000003oc<`0403oc<`010000000olc<00000000
00020?o<c08000001@3oc<`00`000000olc<0?o<c00:0?o<c0030000003oc<`0olc<0080olc<00<0
00000?o<c03oc<`0;@3oc<`200000080olc<00<000000?o<c03oc<`03@3oc<`01@000000olc<0?o<
c03oc<`000000080olc<0P0000030?o<c0030000003oc<`0olc<00l0olc<00H000000?o<c0000000
00000?o<c00000020?o<c080000000<0olc<0000000000003`3oc<`01@000000olc<0?o<c03oc<`0
000003l0oooo00320?ooo`030000003oc<`0olc<00<000003`3oc<`3000000@0olc<00<000000?o<
c03oc<`0103oc<`00`000000olc<0?o<c00;0?o<c0050000003oc<`0olc<0?o<c0000000;`3oc<`4
00000100olc<00D000000?o<c03oc<`0olc<000000020?o<c08000000`3oc<`2000000l0olc<0`00
00030?o<c0070000003oc<`0olc<0?o<c0000000olc<0000000@0?o<c0040000003oc<`0olc<0000
0400oooo00320?ooo`040000003oc<`0olc<0?o<c0@000002`3oc<`3000000H0olc<00<000000?o<
c03oc<`00`3oc<`00`000000olc<0?o<c00<0?o<c08000000P3oc<`00`000000olc<0?o<c00]0?o<
c0@00000403oc<`200000080olc<00@000000?o<c03oc<`0olc<0P0000020?o<c0@000002`3oc<`3
000000@0olc<00<000000?o<c03oc<`00P3oc<`300000100olc<00@000000?o<c03oc<`00000@03o
ool00<<0oooo100000020?o<c0<000001`3oc<`2000000T0olc<00<000000?o<c03oc<`00P3oc<`0
0`000000olc<0?o<c00>0?o<c0040000003oc<`0000000000300olc<00<000000?o<c00000004@3o
c<`010000000olc<0000000000040?o<c0030000003oc<`0olc<0080000000@0olc<000000000000
00001`3oc<`2000000H0olc<0P0000030?o<c0040000003oc<`0olc<00000100olc<0P0000000`3o
c<`000000?ooo`0o0?ooo`00a03oool4000000<0olc<0`0000030?o<c08000002P3oc<`2000000<0
olc<00<000000?o<c03oc<`0403oc<`200000340olc<00@000000?o<c000000000003`3oc<`20000
00030?o<c0000000000000D0olc<00<000000?o<c03oc<`00P0000020?o<c0<000000`3oc<`20000
00L0olc<00<000000?o<c00000000P0000000`3oc<`000000?o<c0020?o<c0030000003oc<`0olc<
00`0olc<0`0000000`3oc<`000000?ooo`0o0?ooo`00a@3oool3000000@0olc<00<000000?o<c000
00003`0000030?o<c0030000003oc<`0olc<0180olc<00<000000?o<c03oc<`0;`3oc<`200000003
0?o<c0000000000000d0olc<00H000000?o<c0000000olc<0000003oc<`2000000@0olc<00D00000
0?o<c0000000olc<000000030?o<c0@00000203oc<`01P000000olc<0?o<c03oc<`000000?o<c080
00000`3oc<`00`000000olc<0?o<c00;0?o<c0060000003oc<`0olc<0000003oc<`00000@03oool0
0<D0oooo00<000000?o<c00000000`3oc<`01@000000olc<000000000000olc<008000002`3oc<`0
1@000000olc<0?o<c03oc<`0000001@0olc<0P00000_0?o<c0H000003@3oc<`01@000000olc<0000
003oc<`0000000<0olc<0P0000030?o<c08000000P3oc<`00`000000olc<0?o<c0020?o<c0<00000
1P3oc<`00`000000olc<0?o<c0020?o<c0040000003oc<`0olc<0?o<c08000000P3oc<`00`000000
olc<0?o<c00:0?o<c0060000003oc<`0olc<0000003oc<`00000@03oool00<H0oooo0P0000030?o<
c08000001@3oc<`2000000T0olc<00@000000?o<c03oc<`000005@3oc<`00`000000olc<0000000]
0?o<c0040000003oc<`00000000000<0olc<00<000000?o<c03oc<`02@3oc<`010000000olc<0?o<
c03oc<`2000000D0olc<0P0000001P3oc<`00000000000000000olc<000000H0olc<0`0000040?o<
c0030000003oc<`0olc<00<0olc<00<000000?o<c03oc<`00P3oc<`2000000030?o<c0000000olc<
00T0olc<00@000000?o<c03oc<`0olc<0P0000110?ooo`00a`3oool5000000P0olc<0P0000070?o<
c0030000003oc<`0000001D0olc<00@000000?o<c03oc<`00000;@3oc<`4000000<0olc<0P000009
0?o<c0030000003oc<`0olc<0080olc<00<000000?o<c03oc<`01P3oc<`400000080olc<00<00000
0?o<c03oc<`01@3oc<`3000000030?o<c0000000olc<00H0olc<00<000000?o<c03oc<`00`3oc<`3
000000P0olc<00<000000?o<c03oc<`00`3oc<`00`000000oooo0?ooo`0o0?ooo`00b03oool20000
00030?o<c0000000olc<00T0olc<0P0000040?o<c0<000005P3oc<`01@000000olc<0?o<c03oc<`0
000002/0olc<00@000000?o<c0000000olc<1`0000070?o<c0030000003oc<`0olc<00<0olc<00<0
00000?o<c03oc<`0203oc<`R000000H0olc<00<000000?o<c03oc<`00`3oc<`200000440oooo0039
0?ooo`8000002P3oc<`00`000000olc<0000000200000080olc<00<000000?o<c00000005P3oc<`0
0`000000olc<0?o<c0020?o<c0030000003oc<`0olc<02L0olc<00H000000?o<c03oc<`000000?o<
c00000060?o<c0030000003oc<`0olc<00<0olc<00<000000?o<c03oc<`00P3oc<`3000000P0olc<
0`0000000`3oc<`000000?o<c0090?o<c08000004P3oc<`2000000@0olc<00<000000?o<c03oc<`0
0P3oc<`400000440oooo00390?ooo`8000002@3oc<`2000000<0olc<1@00000G0?o<c0030000003o
c<`0olc<00<0olc<00<000000?o<c03oc<`09@3oc<`01`000000olc<0?o<c03oc<`000000?o<c000
00001P3oc<`2000000<0olc<00@000000?o<c03oc<`0olc<0P0000020?o<c0030000003oc<`0olc<
00@0olc<0`0000040?o<c0030000003oc<`0olc<00D0olc<0`00000D0?o<c08000000P3oc<`01000
0000olc<0?o<c03oc<`300000080olc<00<000000?ooo`3oool0?`3oool00<X0oooo00<000000?o<
c03oc<`01P3oc<`2000000D0olc<00@000000?o<c000000000005`3oc<`00`000000olc<0?o<c003
0?o<c08000009P3oc<`00`000000olc<0?o<c002000000030?o<c0000000000000H0olc<00H00000
0?o<c03oc<`0olc<0000003oc<`2000000<0olc<0P0000040?o<c0<000001P3oc<`00`000000olc<
0?o<c0030?o<c08000000P3oc<`00`000000olc<0?o<c00C0?o<c0050000003oc<`0olc<0000003o
c<`00`0000030?o<c0030000003oool0oooo0400oooo003;0?ooo`030000003oc<`0olc<00D0olc<
0P0000050?o<c0030000003oc<`0000000<00000503oc<`00`000000olc<0?o<c0050?o<c0030000
003oc<`0olc<02<0olc<00D000000?o<c03oc<`0olc<000000030?o<c0030000003oc<`0olc<00@0
olc<0P0000001P3oc<`00000000000000000olc<000000<0olc<00@000000?o<c03oc<`0olc<0P00
00030?o<c08000001@3oc<`00`000000olc<0?o<c002000000<0olc<00<000000?o<c03oc<`0503o
c<`5000000030?o<c0000000olc<00<0olc<00<000000?ooo`3oool0@03oool00<`0oooo00<00000
0?o<c03oc<`00`3oc<`00`000000olc<000000040?o<c0T000004P3oc<`00`000000olc<0?o<c006
0?o<c0030000003oc<`0olc<0240olc<0P0000030?o<c0050000003oc<`0olc<0?o<c00000001P3o
c<`010000000olc<0000000000030?o<c0060000003oc<`0olc<0?o<c0000000olc<0P0000070?o<
c0800000103oc<`2000000@0olc<00<000000?o<c03oc<`05P3oc<`2000000@0olc<00D000000?o<
c03oc<`0olc<000000120?ooo`00c@3oool5000000030?o<c0000000000000@0olc<00@000000?o<
c00000000000103oc<`300000100olc<2`00000Q0?o<c0030000003oc<`0000000<0olc<00D00000
0?o<c03oc<`0olc<000000060?o<c0@00000103oc<`00`000000olc<0?o<c002000000/0olc<0P00
00030?o<c0050000003oc<`0olc<0?o<c00000006P3oc<`2000000<0olc<00D000000?o<c03oc<`0
olc<000000120?ooo`00cP3oool010000000olc<0000000000030?o<c080000000<0olc<00000000
00000P0000070?o<c0<00000303oc<`5000000P0olc<00<000000?o<c03oc<`07@3oc<`200000080
olc<00<000000?o<c03oc<`00`000000103oc<`000000000000000020?o<c0<000000`3oc<`01P00
0000olc<0?o<c03oc<`000000?o<c08000003@3oc<`3000000040?o<c0000000olc<0?o<c0800000
6`3oc<`01@000000olc<0?o<c03oc<`000000080olc<00<000000?ooo`3oool0@@3oool00<h0oooo
00<000000?o<c00000001P3oc<`2000000030?o<c0000000000000L0olc<00@000000?o<c0000000
00002@3oc<`200000080olc<00<000000?o<c03oc<`00P0000060?o<c0030000003oc<`0olc<01d0
olc<00L000000?o<c03oc<`0olc<0000003oc<`0000000<0olc<0`000000103oc<`000000000003o
c<`2000000<0olc<00L000000?o<c03oc<`0olc<0000003oc<`0000000h0olc<00<000000?o<c03o
c<`00`0000000`3oc<`000000?o<c00L0?o<c0040000003oc<`0olc<00000080olc<00<000000?oo
o`3oool0@@3oool00<l0oooo0P0000040?o<c08000000`3oc<`00`000000olc<0?o<c0060?o<c080
00000P3oc<`2000000D0olc<0`000000103oc<`000000000000000040?o<c08000001@3oc<`00`00
0000olc<0?o<c00K0?o<c0030000003oc<`0olc<0080olc<00<000000?o<c00000001@3oc<`20000
00<0olc<0P0000040?o<c0060000003oc<`0olc<0000003oc<`000003`3oc<`010000000olc<0?o<
c03oc<`2000001l0olc<00H000000?o<c03oc<`000000?o<c00000130?ooo`00c`3oool200000004
0?o<c00000000000000000D0olc<00<000000?o<c03oc<`01P3oc<`00`000000olc<0?o<c0020?o<
c0<0000000@0olc<00000000000000000`3oc<`2000000L0olc<0P0000040?o<c0030000003oc<`0
olc<01T0olc<00<000000?o<c03oc<`00`3oc<`00`000000olc<000000050?o<c08000000`3oc<`3
00000080olc<00L000000?o<c0000000olc<0000003oc<`0000000l0olc<00D000000?o<c03oc<`0
olc<0000000P0?o<c080000000@0olc<0000003oc<`00000@`3oool00=00oooo100000060?o<c003
0000003oc<`0olc<00H0olc<0P0000030?o<c0030000003oc<`0olc<00<000001@3oc<`00`000000
olc<0?o<c0040?o<c0030000003oc<`0olc<008000000`3oc<`00`000000olc<0?o<c00G0?o<c003
0000003oc<`0olc<00@0olc<00<000000?o<c00000001@3oc<`3000000030?o<c0000000000000@0
00000`3oc<`2000000030?o<c0000000olc<00h0olc<00@000000?o<c03oc<`000008P3oc<`30000
00030?o<c0000000oooo0480oooo003A0?ooo`80000000<0olc<0000000000000`3oc<`3000000P0
olc<00<000000?o<c03oc<`0100000000`3oc<`0000000000002000000<0olc<00<000000?o<c03o
c<`00`3oc<`00`000000olc<0?o<c0030?o<c080000000<0olc<0000003oc<`0603oc<`00`000000
olc<0?o<c0050?o<c0030000003oc<`0olc<00@0olc<0`000000103oc<`000000?o<c03oc<`30000
00<0olc<00<000000?o<c0000000403oc<`010000000olc<0?o<c000000S0?o<c0<00000A03oool0
0=80oooo0`0000001`3oc<`000000000003oc<`000000?o<c0000000203oc<`00`000000olc<0?o<
c002000000<0olc<1P0000000`3oc<`000000?o<c0040?o<c0030000003oc<`0olc<00D0olc<0`00
000G0?o<c0030000003oc<`0olc<00H0olc<00<000000?o<c03oc<`01@3oc<`4000000<0olc<00<0
00000?o<c03oc<`00`3oc<`200000140olc<0P00000U0?o<c0800000A03oool00=80ooooGP000002
0?o<c0030000003oc<`0olc<00D0olc<00<000000?o<c03oc<`03`3oc<`00`000000olc<0?o<c00U
0?o<c0030000003oool0oooo0480oooo003C0?ooo`@000000P3oc<`2000000<0olc<00<000000?o<
c0000000103oc<`010000000olc<0?o<c00000050?o<c080000000@0olc<0000000000000000103o
c<`2000000/0olc<00<000000?o<c03oc<`0103oc<`00`000000olc<0?o<c0080?o<c0@000003P3o
c<`4000000030?o<c0000000000000<000001`3oc<`2000000l0olc<0P00000W0?o<c0030000003o
ool0oooo0480oooo003D0?ooo`H00000103oc<`3000000D0olc<0`0000060?o<c080000000<0olc<
0000003oc<`0103oc<`2000000/0olc<00<000000?o<c03oc<`00`3oc<`2000000P0olc<0P000000
103oc<`0000000000000000<0?o<c0<000000P3oc<`00`000000olc<00000004000000H0olc<00@0
00000?o<c03oc<`000003@3oc<`3000002L0olc<00<000000?ooo`3oool0@P3oool00=D0oooo00<0
00000?o<c00000000P0000040?o<c08000001P3oc<`2000000P0olc<0`0000050?o<c0030000003o
c<`0olc<00/0olc<00<000000?o<c03oc<`00P3oc<`3000000D0olc<0P0000030?o<c08000002`3o
c<`3000000D0olc<0P0000000`3oc<`0000000000002000000D0olc<1@00000;0?o<c0<0000000<0
olc<0000003oc<`0903oc<`00`000000oooo0?ooo`130?ooo`00eP3oool00`000000olc<0?o<c003
000000<0olc<0P0000040?o<c08000002`3oc<`300000080olc<00<000000?o<c03oc<`03@3oc<`0
1`000000olc<0?o<c03oc<`000000?o<c00000000`3oc<`2000000@0olc<00<000000?o<c0000000
2@3oc<`3000000L0olc<100000020?o<c0<000000P3oc<`2000000<0olc<00<000000?o<c03oc<`0
2@3oc<`01@000000olc<0000003oc<`0000002D0olc<00<000000?ooo`3oool0@`3oool00=L0oooo
10000000103oc<`000000000003oc<`2000000<0olc<0P00000;0?o<c0<0000000<0olc<00000000
00004@3oc<`01`000000olc<0?o<c0000000olc<0000003oc<`00P0000050?o<c0040000003oc<`0
olc<000000L0olc<1@0000070?o<c0@00000103oc<`5000000@0olc<00<000000?o<c03oc<`01`3o
c<`01P000000olc<0?o<c0000000olc<000002D0olc<00<000000?ooo`3oool0@`3oool00=P0oooo
100000020?o<c0T000002P3oc<`01@000000olc<0000003oc<`000000180olc<00D000000?o<c000
000000000?o<c002000000H0olc<0P0000020?o<c0030000003oc<`0olc<00<0olc<0`0000040?o<
c08000001@3oc<`4000000<0olc<100000000`3oc<`000000000000=00000080olc<0P0000000`3o
c<`000000?o<c00T0?o<c0030000003oool0oooo04<0oooo003I0?ooo`<00000103oc<`200000005
0?o<c0000000olc<0?o<c00000002P3oc<`2000000030?o<c0000000000001<0olc<0P0000020?o<
c0030000003oc<`0olc<00@0olc<0P0000020?o<c08000000`3oc<`3000000P0olc<0P0000030?o<
c0@0000000@0olc<00000000000000000P3oc<`5000000070?o<c000000000000?o<c0000000olc<
000000020?o<c0<000000P3oc<`01@000000olc<0?o<c03oc<`0000002<0olc<00<000000?ooo`3o
ool0A03oool00=T0oooo00<000000?o<c00000001P3oc<`5000000X0olc<0P0000000`3oc<`00000
0?o<c00D0?o<c0030000003oc<`0olc<008000001@3oc<`01@000000olc<0?o<c03oc<`000000080
olc<0`00000<0?o<c08000000P3oc<`400000080olc<00H000000?o<c03oc<`0olc<0000003oc<`5
000000030?o<c0000000000000@0olc<1@0000030?o<c0030000003oc<`0olc<0240olc<00<00000
0?ooo`3oool0A03oool00=X0oooo0P0000040?o<c0<0000000<0olc<0000000000000P0000080?o<
c0D000005@3oc<`01@000000olc<0?o<c03oc<`0000000@0olc<0P0000030?o<c0@00000403oc<`4
000000<0olc<00<000000?o<c03oc<`00P3oc<`01@000000olc<000000000000olc<00<0000000<0
olc<0000003oc<`00P3oc<`00`000000olc<0?o<c0020?o<c0030000003oc<`0olc<008000008`3o
c<`00`000000oooo0?ooo`140?ooo`00f`3oool2000000040?o<c00000000000000000D0olc<0`00
00060?o<c080000000<0olc<0000000000000P00000D0?o<c0050000003oc<`0olc<0?o<c0000000
0`3oc<`2000000@0olc<0P00000D0?o<c0030000003oc<`0olc<0080olc<00<000000?o<c03oc<`0
0P3oc<`2000000D0olc<0`0000020?o<c0030000003oc<`0olc<00<0olc<00D000000?o<c0000000
olc<0000000S0?o<c0030000003oool0oooo04@0oooo003L0?ooo`80000000<0olc<0000003oc<`0
1`3oc<`300000080olc<1P0000020?o<c0030000003oc<`0olc<0140olc<0P0000030?o<c0030000
003oc<`0olc<00<000000`3oc<`2000001D0olc<2`0000070?o<c0040000003oc<`00000000000D0
olc<0`0000020?o<c08000008P3oc<`00`000000oooo0?ooo`140?ooo`00g@3oool2000000X0olc<
1@000000103oc<`000000000000000030?o<c0030000003oc<`0olc<0140olc<00<000000?o<c03o
c<`00P3oc<`2000000040?o<c0000000olc<000000<0olc<00<000000?o<c03oc<`0503oc<`00`00
0000olc<0?o<c0060?o<c08000001`3oc<`6000000<0olc<00<000000?o<c00000000`3oc<`00`00
0000olc<0?o<c00O0?o<c0030000003oool0oooo04D0oooo003M0?ooo`8000002P3oc<`00`000000
olc<0?o<c005000000@0olc<0P00000B0?o<c0030000003oc<`0olc<00<0olc<0P0000020?o<c005
0000003oc<`0olc<0?o<c00000005`3oc<`00`000000olc<0?o<c0050?o<c0030000003oc<`0olc<
00H0olc<100000020?o<c080000000<0olc<000000000000103oc<`00`000000olc<0?o<c00O0?o<
c0030000003oool0oooo04D0oooo003N0?ooo`030000003oc<`0olc<00L0olc<00<000000?o<c03o
c<`00`3oc<`3000000@0olc<0P00000B0?o<c0030000003oc<`0olc<00<0olc<00<000000?o<c03o
c<`00P3oc<`010000000olc<0?o<c000000G0?o<c0030000003oc<`0olc<00D0olc<00<000000?o<
c03oc<`01`3oc<`300000080olc<00@000000?o<c000000000001@3oc<`00`000000olc<0?o<c00O
0?o<c0030000003oool0oooo04D0oooo003O0?ooo`030000003oc<`0olc<00D0olc<00<000000?o<
c03oc<`0103oc<`010000000olc<0000000000020?o<c0<000004P3oc<`010000000olc<0?o<c03o
c<`4000000<0olc<00@000000?o<c03oc<`000005`3oc<`00`000000olc<0?o<c0050?o<c0800000
1`3oc<`00`000000olc<000000030?o<c0<0000000<0olc<0000000000000`3oc<`00`000000olc<
0?o<c00O0?o<c0030000003oool0oooo04D0oooo003O0?ooo`030000003oc<`0olc<00@0olc<0P00
00060?o<c0<0000000<0olc<0000000000000P3oc<`00`000000olc<0?o<c00?0?o<c0030000003o
c<`0olc<008000000P3oc<`300000080olc<00<000000?o<c0000000603oc<`00`000000olc<0?o<
c0040?o<c0<000001P3oc<`400000080olc<0P0000050?o<c08000000P3oc<`00`000000olc<0?o<
c00M0?o<c0030000003oool0oooo04H0oooo003P0?ooo`030000003oc<`0olc<00<0olc<0P000005
0?o<c0H0000000@0olc<00000000000000004@3oc<`3000000<0olc<00@000000?o<c00000000000
0P3oc<`00`000000olc<0000000I0?o<c0030000003oc<`0olc<00<0olc<0P0000000`3oc<`00000
0?o<c0040?o<c0L00000203oc<`3000001l0olc<00<000000?ooo`3oool0AP3oool00>40oooo00D0
00000?o<c03oc<`0olc<000000020?o<c08000000P3oc<`00`000000olc<00000002000000D0olc<
0P00000?0?o<c08000001@3oc<`02@000000olc<0000003oc<`000000?o<c0000000olc<0000000I
0?o<c08000000`3oc<`:00000080olc<0`00000<0?o<c0030000003oc<`0olc<01`0olc<0P000018
0?ooo`00hP3oool00`000000olc<000000050?o<c0@0000000<0olc<0000003oc<`01@3oc<`40000
00/0olc<0P0000070?o<c0030000003oc<`000000080olc<0P0000000`3oc<`000000?o<c00H0?o<
c0030000003oc<`0000000D000000`3oc<`00`000000olc<00000003000000030?o<c0000000olc<
00`0olc<0`00000J0?o<c0@00000B03oool00>80oooo00<000000?o<c0000000103oc<`300000080
olc<00<000000?o<c03oc<`01@3oc<`6000000L0olc<0P0000090?o<c0030000003oc<`000000080
olc<0`00000J0?o<c0@0000000@0olc<0000000000000000103oc<`6000000h0olc<00<000000?o<
c03oc<`00P00000F0?o<c0<0000000<0olc<0000003oool0B03oool00><0oooo00@000000?o<c03o
c<`0olc<0`0000040?o<c0030000003oc<`0olc<00H0olc<0P0000020?o<c0<000000`3oc<`20000
00X0olc<00D000000?o<c03oc<`0olc<000000020?o<c08000006`3oc<`010000000olc<0?o<c03o
c<`3000000@0olc<00@000000?o<c03oc<`0olc<0P00000?0?o<c0040000003oc<`0olc<0?o<c080
00004P3oc<`3000000<0olc<00<000000?ooo`3oool0A`3oool00><0oooo00<000000?o<c0000000
0P0000060?o<c0030000003oc<`0olc<00H0olc<00<000000?o<c00000000`3oc<`4000000`0olc<
00D000000?o<c03oc<`0olc<000000030?o<c0030000003oc<`0olc<01T0olc<0P0000020?o<c0<0
00000`3oc<`00`000000olc<000000020?o<c08000003`3oc<`00`000000olc<0?o<c0030?o<c080
00003P3oc<`3000000D0olc<00<000000?ooo`3oool0A`3oool00>@0oooo0P0000000`3oc<`00000
000000050?o<c0030000003oc<`0olc<00H0olc<00@000000?o<c03oc<`00000103oc<`4000000X0
olc<00D000000?o<c03oc<`0olc<000000040?o<c0030000003oc<`0olc<01L0olc<100000000`3o
c<`000000?o<c00400000080olc<0P0000000`3oc<`000000000000?0?o<c0030000003oc<`0olc<
00D0olc<0P00000:0?o<c0D000001@3oc<`00`000000oooo0?ooo`170?ooo`00i@3oool200000004
0?o<c0000000000000000080olc<00<000000?o<c00000001`3oc<`200000080olc<00<000000?o<
c03oc<`00`3oc<`4000000P0olc<00D000000?o<c03oc<`0olc<000000050?o<c0030000003oc<`0
olc<01D0olc<00@000000?o<c0000000olc<0`0000020?o<c0<000000`3oc<`300000100olc<00<0
00000?o<c03oc<`01@3oc<`010000000olc<0000000000060?o<c0<00000103oc<`200000080olc<
00<000000?ooo`3oool0B03oool00>H0oooo0P0000020?o<c0@0000000<0olc<0000003oc<`01`3o
c<`01@000000olc<0?o<c03oc<`0000000H0olc<100000060?o<c0040000003oc<`0olc<0?o<c080
0000103oc<`2000001H0olc<0P0000000`3oc<`0000000000002000000<0olc<00<000000?o<c03o
c<`00`3oc<`200000100olc<0P0000050?o<c0030000003oc<`0olc<0080olc<0P0000020?o<c0<0
0000203oc<`3000004X0oooo003W0?oooa800000103oc<`00`000000olc<0?o<c0050?o<c0@00000
0`3oc<`00`000000olc<0?o<c0030?o<c0030000003oc<`0olc<00<0olc<00<000000?o<c03oc<`0
4`3oc<`010000000olc<0000003oc<`3000000<0olc<00<000000?o<c03oc<`01@3oc<`00`000000
olc<0?o<c00?0?o<c0030000003oc<`0olc<00<0olc<00<000000?o<c03oc<`0103oc<`@000004X0
oooo003W0?ooo`050000003oc<`000000000003oc<`00P0000040?o<c0030000003oc<`0000000<0
olc<0P0000030?o<c0030000003oc<`0olc<00<0olc<0`0000000`3oc<`000000000000200000003
0?o<c0000000olc<00@0olc<0P0000050?o<c0030000003oc<`0olc<0140olc<00L000000?o<c03o
c<`000000?o<c0000000olc<00D000001P3oc<`200000100olc<0P0000040?o<c0030000003oc<`0
olc<00<0olc<0`0000000`3oc<`000000?o<c0050?o<c0030000003oc<`0olc<00<0olc<00<00000
0?ooo`3oool0B03oool00>P0oooo1@0000050?o<c0800000103oc<`2000000@0olc<00<000000?o<
c03oc<`00`0000040?o<c0030000003oc<`00000008000001@3oc<`010000000olc<000000000004
0?o<c0030000003oc<`0olc<00l0olc<00P000000?o<c03oc<`0olc<0000003oc<`000000?o<c0@0
000000<0olc<0000003oc<`0103oc<`00`000000olc<0?o<c00>0?o<c0030000003oc<`0000000<0
olc<00<000000?o<c03oc<`00P3oc<`3000000@0olc<00<000000?o<c03oc<`00`3oc<`00`000000
olc<0?o<c0030?o<c0030000003oool0oooo04P0oooo003Y0?ooo`040000003oc<`0olc<0?o<c080
00000`3oc<`2000000D0olc<00<000000?o<c03oc<`00`3oc<`3000000H0olc<00@000000?o<c03o
c<`0olc<0`0000030?o<c0040000003oc<`0olc<0?o<c08000000`3oc<`00`000000olc<0?o<c00=
0?o<c08000000P3oc<`010000000olc<0?o<c03oc<`7000000D0olc<00<000000?o<c03oc<`03@3o
c<`2000000050?o<c0000000olc<0?o<c00000000`3oc<`2000000<0olc<0P0000020?o<c0030000
003oc<`0olc<00@0olc<00D000000?o<c03oc<`0olc<0000001;0?ooo`00j@3oool00`000000oooo
0?o<c0020?o<c0<000000P3oc<`00`000000olc<0?o<c0030?o<c0040000003oc<`0olc<0?o<c0<0
00002@3oc<`00`000000olc<0?o<c0020?o<c0<000000P3oc<`00`000000olc<0?o<c0020?o<c080
000000<0olc<0000003oc<`03P3oc<`01@000000olc<0?o<c03oc<`0000000<0olc<100000020?o<
c0<0000000@0olc<00000000000000003`3oc<`020000000olc<0?o<c03oc<`000000?o<c0000000
olc<0P0000070?o<c080000000<0olc<0000003oc<`0103oc<`01@000000olc<0?o<c03oc<`00000
04/0oooo003Z0?ooo`D000000P3oc<`3000000@0olc<1P00000<0?o<c0030000003oc<`0olc<00<0
olc<100000060?o<c0<000003@3oc<`00`000000olc<0?o<c0020?o<c0040000003oc<`0olc<0?o<
c0<000001@3oc<`5000000h0olc<00<000000?o<c03oc<`00P3oc<`4000000/0olc<0`0000040?o<
c0050000003oc<`0olc<0?o<c0000000B`3oool00>/0oooo100000030?o<c1X000001P3oc<`H0000
00D0olc<00@000000?o<c03oc<`0olc<0`0000030?o<c1D000001@3oc<`C000000<0olc<00D00000
0?o<c03oc<`0olc<0000001;0?ooo`00k03oool3000000D0olc<0P0000001@3oc<`000000?o<c03o
c<`000000100olc<0P0000060?o<c0@000003`3oc<`3000000H0olc<00@000000?o<c03oc<`0olc<
0`000000103oc<`000000000000000030?o<c080000000<0olc<0000000000002P3oc<`00`000000
olc<0?o<c0020?o<c0<00000103oc<`3000000X0olc<0P0000020?o<c0040000003oc<`0olc<0000
04`0oooo003/0?ooo`040000003oool00000000000D0olc<1P00000A0?o<c0030000003oc<`0olc<
00<0olc<0P0000000`3oc<`0000000000002000000/0olc<0P0000000`3oc<`00000000000050?o<
c0030000003oc<`0olc<0080olc<100000020?o<c0030000003oc<`0olc<0080olc<00@000000?o<
c03oc<`0olc<0P0000070?o<c0040000003oc<`0olc<0?o<c080000000<0olc<0000000000000P3o
c<`2000000030?o<c0000000olc<00/0olc<00L000000?o<c03oc<`0olc<0000003oc<`0000004`0
oooo003]0?ooo`<000000`3oc<`2000000<0olc<1000000A0?o<c0030000003oc<`0olc<0080olc<
00@000000?o<c03oc<`000000P3oc<`3000000L0olc<0P0000030?o<c0030000003oc<`0olc<00@0
olc<00<000000?o<c03oc<`00`3oc<`010000000olc<0?o<c03oc<`2000000<0olc<0P0000030?o<
c0040000003oc<`00000000000D0olc<00@000000?o<c000000000000`3oc<`010000000olc<0000
000000030?o<c0030000003oc<`0olc<00/0olc<00H000000?o<c03oc<`000000?o<c000001<0?oo
o`00kP3oool2000000040?o<c00000000000000000H0olc<0P00000B0?o<c0050000003oc<`0olc<
0?o<c00000000`3oc<`010000000olc<0?o<c03oc<`3000000<0olc<0P0000040?o<c0030000003o
c<`0olc<00D0olc<00<000000?o<c03oc<`00`3oc<`01`000000olc<0?o<c03oc<`000000?o<c000
00000P3oc<`01@000000olc<0?o<c03oc<`0000000@0olc<0P0000020?o<c0@00000103oc<`20000
00@0olc<00<000000?o<c03oc<`03@3oc<`01@000000olc<0000003oc<`0000004`0oooo003_0?oo
o`8000000P3oc<`00`000000olc<0?o<c0040?o<c08000004`3oc<`010000000olc<0?o<c0000004
0?o<c0030000003oc<`0olc<0080olc<100000050?o<c0030000003oc<`0olc<00H0olc<00<00000
0?o<c03oc<`00`3oc<`:000000<0olc<00<000000?o<c03oc<`0103oc<`3000000<0olc<00D00000
0?o<c03oc<`0olc<000000040?o<c0030000003oc<`0olc<00l0olc<0P0000000`3oc<`000000?oo
o`1;0?ooo`00l03oool00`000000olc<000000080?o<c0030000003oc<`0olc<0140olc<00@00000
0?o<c000000000001@3oc<`00`000000olc<0?o<c0030?o<c0<000000`3oc<`2000000L0olc<00<0
00000?o<c03oc<`0103oc<`3000000H0olc<00@000000?o<c03oc<`000001@3oc<`3000000D0olc<
00D000000?o<c03oc<`0olc<000000030?o<c0030000003oc<`0olc<0100olc<00<000000?o<c000
0000C@3oool00?40oooo0P0000080?o<c08000004`3oc<`2000000L0olc<00<000000?o<c03oc<`0
103oc<`3000000030?o<c0000000olc<00L0olc<00<000000?o<c03oc<`01@3oc<`2000000H0olc<
00<000000?o<c0000000103oc<`3000000L0olc<00@000000?o<c03oc<`000000`3oc<`2000001<0
olc<0P00001=0?ooo`00lP3oool00`000000olc<0?o<c0060?o<c0800000503oc<`00`000000olc<
0?o<c0060?o<c0030000003oc<`0olc<00D0olc<500000060?o<c0<000000`3oc<`3000000T0olc<
00@000000?o<c03oc<`000000`3oc<`00`000000olc<0?o<c00C0?o<c0030000003oool0oooo04/0
oooo003c0?ooo`030000003oc<`0olc<00@0olc<0`00000D0?o<c0030000003oc<`0olc<00H0olc<
00<000000?o<c03oc<`00`3oc<`3000000040?o<c00000000000000000/0olc<0P0000000`3oc<`0
00000?o<c0050?o<c0040000003oc<`000000?o<c08000000`3oc<`2000000P0olc<00<000000?o<
c00000000P3oc<`2000001D0olc<00<000000?ooo`3oool0B`3oool00?<0oooo00<000000?o<c03o
c<`00`3oc<`2000000030?o<c0000000olc<01<0olc<00<000000?o<c03oc<`01`3oc<`00`000000
olc<0?o<c003000000D0olc<0`0000070?o<c08000000`3oc<`2000000D0olc<100000070?o<c080
00001P3oc<`01`000000olc<0000003oc<`000000?o<c00000005@3oc<`00`000000oooo0?ooo`1;
0?ooo`00m03oool010000000olc<0?o<c03oc<`2000000030?o<c0000000000001<0olc<0P00000:
0?o<c0<000002@3oc<`3000000<0olc<0P0000060?o<c0030000003oc<`0olc<00<0olc<0P00000;
0?o<c0800000103oc<`010000000olc<0000000000030?o<c0030000003oc<`0olc<0140olc<00<0
00000?ooo`3oool0C03oool00?D0oooo00@000000?o<c03oc<`000000`3oc<`200000180olc<00<0
00000?o<c03oc<`01`3oc<`3000000d0olc<100000080?o<c0<0000000@0olc<0000000000000000
3@3oc<`300000080olc<0P0000000`3oc<`000000?o<c0020?o<c0030000003oc<`0olc<0140olc<
00<000000?ooo`3oool0C03oool00?D0oooo00<000000?o<c00000001@3oc<`00`000000olc<0?o<
c00@0?o<c0030000003oc<`0olc<00D0olc<0`00000A0?o<c0<000001`3oc<`4000000030?o<c000
0000olc<00d0olc<00<000000?o<c03oc<`00P0000000`3oc<`00000000000040?o<c0030000003o
c<`0olc<0140olc<00<000000?ooo`3oool0C03oool00?H0oooo00<000000?o<c03oc<`00`3oc<`2
00000180olc<00<000000?o<c03oc<`00`3oc<`3000001D0olc<0`0000050?o<c0<0000000<0olc<
0000000000003`3oc<`010000000olc<0?o<c03oc<`2000000D0olc<00<000000?o<c03oc<`04@3o
c<`00`000000oooo0?ooo`1<0?ooo`00m`3oool00`000000olc<0?o<c00400000180olc<00@00000
0?o<c03oc<`0olc<0`00000I0?o<c0<000000`3oc<`2000000<0olc<00<000000?o<c03oc<`03@3o
c<`00`000000olc<0?o<c0020?o<c0800000103oc<`200000180olc<00<000000?ooo`3oool0C03o
ool00?P0oooo0`0000020?o<c0800000403oc<`00`000000olc<0?o<c003000001d0olc<0`000000
103oc<`000000000000000020?o<c0030000003oc<`0olc<00d0olc<00L000000?o<c03oc<`0olc<
0000003oc<`0000000D0olc<00<000000?o<c03oc<`03`3oc<`00`000000oooo0?ooo`1=0?ooo`00
n@3oool01P000000olc<000000000000olc<00000100olc<1000000Q0?o<c0D0000000<0olc<0000
003oc<`03`3oc<`01@000000olc<0?o<c03oc<`000000080olc<00<000000?o<c03oc<`00P3oc<`0
0`000000olc<0?o<c00?0?o<c0030000003oool0oooo04d0oooo003i0?ooo`040000003oc<`0olc<
0?o<c0<000003P3oc<`3000002D0olc<1@00000@0?o<c08000000P3oc<`01@000000olc<0?o<c03o
c<`0000000<0olc<0P00000?0?o<c0800000C`3oool00?X0oooo2000000:0?o<c080000000<0olc<
0000003oc<`09P3oc<`2000000030?o<c0000000olc<0100olc<00@000000?o<c00000000000103o
c<`00`000000olc<0?o<c004000000/0olc<0P0000000`3oc<`000000?ooo`1>0?ooo`00n`3oool2
000000040?o<c0000000olc<0?o<c0<000001P3oc<`2000000<0olc<00<000000?o<c03oc<`09@3o
c<`2000000030?o<c0000000000000l0olc<0P0000000`3oc<`000000?o<c0040?o<c0030000003o
c<`0olc<0080000000@0olc<00000000000000001`3oc<`200000080olc<00<000000?ooo`3oool0
CP3oool00?`0oooo0`0000040?o<c0<000000P3oc<`2000000@0olc<00<000000?o<c03oc<`09`3o
c<`2000000030?o<c0000000000000h0olc<0P000000103oc<`000000000000000040?o<c0040000
003oc<`0olc<000000<0olc<0`0000030?o<c0800000103oc<`00`000000oooo0?ooo`1>0?ooo`00
o03oool00`000000olc<000000030?o<c0030000003oc<`0olc<00<000001P3oc<`00`000000olc<
0?o<c00W0?o<c0H00000303oc<`01@000000olc<0000003oc<`000000080olc<0P0000030?o<c003
0000003oc<`0000000D0olc<100000060?o<c0030000003oool0oooo04h0oooo003m0?ooo`030000
003oc<`000000080olc<00<000000?o<c00000000`0000060?o<c0030000003oc<`0olc<02L0olc<
0P0000030?o<c0030000003oc<`0olc<00T0olc<00<000000?o<c03oc<`00`0000040?o<c0800000
0P3oc<`2000000L0olc<0`0000050?o<c0030000003oool0oooo04h0oooo003n0?ooo`8000000P3o
c<`200000080olc<00<000000?o<c00000001@3oc<`00`000000olc<0?o<c00W0?o<c0030000003o
c<`0olc<00<0olc<00<000000?o<c03oc<`01`3oc<`00`000000olc<0?o<c0020?o<c0030000003o
c<`0olc<00D0olc<1@0000080?o<c0<000000P3oc<`00`000000oooo0?ooo`1?0?ooo`00oP3oool4
000000D0olc<00<000000?o<c00000000`3oc<`2000002X0olc<00<000000?o<c03oc<`00P3oc<`0
0`000000olc<0?o<c0070?o<c0030000003oc<`0olc<0080olc<00<000000?o<c03oc<`01`3oc<`3
000000X0olc<1000001A0?ooo`00o`3oool00`000000olc<0?o<c0050?o<c0030000003oc<`00000
00<0olc<0P00000Z0?o<c2l00000D@3oool00?l0oooo0@3oool00`000000olc<0?o<c0040?o<c004
0000003oc<`0olc<00000080olc<00<000000?o<c03oc<`0:@3oc<`00`000000olc<0?o<c0020?o<
c0030000003oc<`0olc<00<0olc<0`00000C0?o<c0030000003oc<`0olc<00<0olc<00<000000?o<
c03oc<`0103oc<`00`000000oooo0?ooo`1?0?ooo`00o`3oool20?ooo`030000003oc<`0olc<00<0
olc<00L000000?o<c03oc<`0olc<0000003oc<`0000002/0olc<00<000000?o<c03oc<`00`3oc<`0
0`000000olc<0?o<c002000000030?o<c0000000olc<01@0olc<00<000000?o<c03oc<`00P3oc<`2
000000@0olc<00<000000?ooo`3oool0D03oool00?l0oooo0`3oool00`000000olc<0?o<c0030?o<
c0040000003oc<`0olc<0?o<c0800000:`3oc<`00`000000olc<0?o<c0040?o<c08000000P3oc<`2
000001D0olc<0P0000030?o<c0800000103oc<`00`000000oooo0?ooo`1@0?ooo`00o`3oool40?oo
o`H000000`3oc<`2000002`0olc<00@000000?o<c03oc<`0olc<0P0000040?o<c0030000003oc<`0
olc<01D0olc<00H000000?o<c03oc<`000000?o<c00000040?o<c0030000003oool0oooo0500oooo
003o0?ooo`D0oooo00D000000?o<c03oc<`0olc<000000030?o<c0800000;03oc<`010000000olc<
0000000000050?o<c0030000003oc<`0olc<01L0olc<00@000000?o<c0000000olc<0P000000103o
c<`0000000000000001B0?ooo`00o`3oool50?ooo`050000003oc<`0olc<0?o<c00000000`3oc<`0
0`000000olc<0?o<c00[0?o<c0T000006`3oc<`200000080olc<0P0000020?o<c0030000003oool0
oooo0500oooo003o0?ooo`H0oooo00<000000?o<c03oc<`00P0000020?o<c0030000003oc<`0olc<
02/0olc<00<000000?o<c03oc<`0103oc<`00`000000olc<0?o<c00J0?o<c08000000P3oc<`01000
0000olc<0?o<c000001C0?ooo`00o`3oool70?ooo`050000003oc<`0olc<0000003oc<`00P00000]
0?o<c0800000103oc<`2000001d0olc<0P0000001@3oc<`000000?o<c03oc<`0000005<0oooo003o
0?ooo`L0oooo00H000000?o<c03oc<`000000?o<c000000_0?o<c0030000003oc<`0olc<0080olc<
00<000000?o<c03oc<`07@3oc<`01P000000olc<0?o<c0000000olc<000005<0oooo003o0?ooo`P0
oooo00D000000?o<c0000000olc<0000000_0?o<c0050000003oc<`0olc<0?o<c00000008@3oc<`0
1@000000olc<0000003oc<`0000005<0oooo003o0?ooo`T0oooo0P0000000`3oc<`000000?o<c00^
0?o<c0040000003oc<`0olc<000002<0olc<0P0000000`3oc<`000000?ooo`1B0?ooo`00o`3oool:
0?ooo`<00000;`3oc<`4000002<0olc<0`00001D0?ooo`00o`3oool:0?ooo`800000<@3oc<`20000
02D0olc<0P00001D0?ooo`00o`3oool;0?ooo`030000003oc<`0olc<02l0olc<00<000000?o<c03o
c<`09@3oc<`00`000000oooo0?ooo`1B0?ooo`00o`3oool<0?ooo`030000003oc<`0olc<02d0olc<
0P00000W0?o<c0030000003oool0oooo0580oooo003o0?ooo`d0oooo00<000000?o<c03oc<`0:`3o
c<`00`000000olc<0000000W0?o<c0030000003oool0oooo0580oooo003o0?ooo`d0oooo00<00000
0?ooo`3oc<`0:`3oc<`2000000030?o<c0000000olc<02@0olc<00<000000?ooo`3oool0D`3oool0
0?l0oooo3P3oool00`000000olc<0?o<c00Y0?o<c0050000003oc<`000000?o<c00000009@3oc<`0
0`000000oooo0?ooo`1C0?ooo`00o`3oool?0?ooo`030000003oc<`0olc<02L0olc<00H000000?o<
c03oc<`000000?o<c000000U0?o<c0030000003oool0oooo05<0oooo003o0?oooa00oooo00<00000
0?o<c03oc<`09@3oc<`01`000000olc<0?o<c03oc<`000000?o<c00000009@3oc<`00`000000oooo
0?ooo`1C0?ooo`00o`3ooolA0?ooo`030000003oc<`0olc<02<0olc<00D000000?o<c03oc<`0olc<
000000030?o<c0030000003oc<`0olc<0240olc<00<000000?ooo`3oool0E03oool00?l0oooo4P3o
ool00`000000olc<0?o<c00Q0?o<c0030000003oc<`0olc<0080olc<00D000000?o<c03oc<`0olc<
0000000S0?o<c0030000003oool0oooo05@0oooo003o0?oooa80oooo00<000000?o<c03oc<`08@3o
c<`00`000000olc<0?o<c0020?o<c0050000003oc<`0olc<0?o<c00000008`3oc<`00`000000oooo
0?ooo`1D0?ooo`00o`3ooolC0?ooo`030000003oc<`0olc<01l0olc<00<000000?o<c03oc<`00`3o
c<`01@000000olc<0?o<c03oc<`0000002<0olc<00<000000?ooo`3oool0E03oool00?l0oooo503o
ool00`000000olc<0?o<c00M0?o<c08000001@3oc<`00`000000olc<0?o<c0020?o<c0030000003o
c<`0olc<01l0olc<00<000000?ooo`3oool0E@3oool00?l0oooo5@3oool00`000000olc<0?o<c00K
0?o<c0030000003oc<`00000008000000P3oc<`00`000000olc<0?o<c0030?o<c0030000003oc<`0
olc<01l0olc<00<000000?ooo`3oool0E@3oool00?l0oooo5P3oool00`000000olc<0?o<c00I0?o<
c0040000003oc<`0olc<0?o<c0D000001@3oc<`00`000000olc<0?o<c00O0?o<c0030000003oool0
oooo05D0oooo003o0?oooaL0oooo00<000000?o<c03oc<`05`3oc<`2000000<0olc<00<000000?o<
c03oc<`00`0000040?o<c0030000003oc<`0olc<01l0olc<00<000000?ooo`3oool0E@3oool00?l0
oooo5`3oool00`000000olc<0?o<c00G0?o<c0030000003oc<`0olc<00<0olc<00<000000?o<c03o
c<`00P3oc<`2000000<0olc<00<000000?o<c03oc<`07@3oc<`00`000000oooo0?ooo`1F0?ooo`00
o`3ooolH0?ooo`030000003oc<`0olc<01D0olc<00<000000?o<c03oc<`01@3oc<`00`000000olc<
0?o<c0030?o<c080000000<0olc<0000003oc<`07P3oc<`00`000000oooo0?ooo`1F0?ooo`00o`3o
oolI0?oooaL000002@3oc<`00`000000olc<0?o<c0040?o<c08000007`3oc<`00`000000oooo0?oo
o`1F0?ooo`00o`3ooolJ0?ooo`030000003oc<`0olc<00L0olc<00<000000?o<c03oc<`01P3oc<`2
000000X0olc<00<000000?o<c03oc<`01@3oc<`3000001/0olc<0`00001H0?ooo`00o`3ooolJ0?oo
o`030000003oc<`0olc<00H0olc<00<000000?o<c03oc<`01@3oc<`2000000030?o<c0000000olc<
00X0olc<00<000000?o<c03oc<`00`3oc<`3000000030?o<c0000000000001L0olc<0P0000000`3o
c<`000000?ooo`1H0?ooo`00o`3ooolK0?ooo`030000003oc<`0olc<00D0olc<00<000000?o<c03o
c<`00`3oc<`200000080olc<00<000000?o<c03oc<`02`3oc<`00`000000olc<0?o<c0020?o<c004
0000003oc<`0000000000080olc<0P00000C0?o<c08000000`3oc<`00`000000oooo0?ooo`1G0?oo
o`00o`3ooolL0?ooo`030000003oc<`0olc<00<0olc<00<000000?o<c03oc<`00P3oc<`2000000<0
olc<00<000000?o<c03oc<`03@3oc<`02@000000olc<0?o<c03oc<`000000?o<c0000000olc<0000
00030?o<c08000003`3oc<`4000000<0olc<00<000000?ooo`3oool0E`3oool00?l0oooo7@3oool0
1@000000olc<0?o<c03oc<`0000000<0olc<0P0000040?o<c0030000003oc<`0olc<00l0olc<00H0
00000?o<c03oc<`000000?o<c00000020?o<c0050000003oc<`0olc<0000003oc<`00P00000;0?o<
c08000000P3oc<`00`000000olc<000000020?o<c0030000003oool0oooo05L0oooo003o0?oooad0
oooo00@000000?o<c03oc<`000000P3oc<`2000000030?o<c0000000olc<00<0olc<00<000000?o<
c03oc<`03`3oc<`01P000000olc<000000000000olc<00000080olc<00@000000?o<c03oc<`00000
0`3oc<`2000000L0olc<0P0000050?o<c080000000<0olc<0000003oool0F@3oool00?l0oooo7P3o
ool00`000000olc<00000002000000@0olc<00@000000?o<c03oc<`000004`3oc<`200000080olc<
00D000000?o<c03oc<`0olc<000000020?o<c0030000003oc<`0olc<0080olc<0P0000030?o<c080
00001`3oc<`010000000olc<00000000001J0?ooo`00o`3ooolO0?ooo`8000001P3oc<`00`000000
olc<0000000E0?o<c00;0000003oc<`0olc<0?o<c0000000olc<0000003oc<`000000?o<c0000000
1P3oc<`3000000T0olc<00@000000?o<c03oc<`00000FP3oool00?l0oooo803oool00`000000olc<
0?o<c0050?o<c08000005@3oc<`010000000olc<0?o<c03oc<`2000000<0olc<0P0000050?o<c080
000000<0olc<000000000000203oc<`010000000olc<0?o<c000001J0?ooo`00o`3ooolP0?ooo`03
0000003oc<`0olc<00D0olc<0P00000E0?o<c0050000003oc<`0olc<0?o<c0000000103oc<`20000
00<0olc<0P0000050?o<c08000001`3oc<`00`000000olc<0000001J0?ooo`00o`3ooolQ0?ooo`03
0000003oc<`0olc<00<0olc<00@000000?o<c000000000004`3oc<`2000000<0olc<00<000000?o<
c03oc<`00`3oc<`4000000T0olc<0P0000050?o<c0030000003oc<`0000005X0oooo003o0?ooob80
oooo00D000000?o<c03oc<`0olc<000000030?o<c0030000003oc<`0olc<0140olc<00<000000?o<
c03oc<`00P3oc<`00`000000olc<0?o<c0030?o<c08000003@3oc<`2000000<0olc<0P00001K0?oo
o`00o`3ooolS0?ooo`040000003oc<`00000000000<0olc<00<000000?o<c03oc<`04@3oc<`00`00
0000olc<0?o<c0030?o<c0030000003oc<`0olc<00@000003@3oc<`4000000030?o<c00000000000
05/0oooo003o0?ooob<0oooo00<000000?o<c0000000103oc<`00`000000olc<0?o<c00A0?o<c003
0000003oc<`0olc<00<0olc<1P00000>0?o<c0030000003oc<`0olc<00@00000F`3oool00?l0oooo
903oool00`000000olc<0?o<c0020?o<c08000004`3oc<`00`000000olc<0?o<c0020?o<c0<00000
0`3oc<`00`000000olc<0?o<c00=0?o<c0040000003oc<`0olc<0?o<c0800000F`3oool00?l0oooo
9@3oool00`000000olc<0000000400000140olc<00@000000?o<c03oc<`0olc<0P0000000`3oc<`0
0000000000030?o<c0030000003oc<`0olc<00d0olc<00<000000?o<c03oc<`00P3oc<`00`000000
oooo0?ooo`1I0?ooo`00o`3ooolV0?ooo`@0000000<0olc<0000003oc<`0403oc<`010000000olc<
0000000000030?o<c0<000000P3oc<`00`000000olc<0?o<c00=0?o<c0050000003oc<`0olc<0?o<
c0000000G03oool00?l0oooo9`3oool00`000000olc<0?o<c003000000l0olc<0`0000040?o<c0H0
0000403oc<`01@000000olc<0?o<c03oc<`0000005`0oooo003o0?ooobL0oooo00@000000?o<c03o
c<`0olc<1000000;0?o<c0<000001P3oc<`00`000000olc<0000000300000100olc<0P0000020?o<
c0030000003oool0oooo05X0oooo003o0?ooobP0oooo1@000000103oc<`000000000000000070?o<
c08000002@3oc<`01P000000olc<000000000000olc<00000140olc<00@000000?o<c03oc<`00000
G03oool00?l0oooo:@3oool4000000<0olc<0`0000030?o<c08000002`3oc<`01@000000olc<0000
00000000olc<008000003`3oc<`2000000030?o<c0000000oooo05`0oooo003o0?ooobX0oooo0`00
00040?o<c0030000003oc<`0000000800000303oc<`00`000000olc<0?o<c003000000030?o<c000
0000000000d0olc<00D000000?o<c0000000olc<0000001M0?ooo`00o`3ooolZ0?ooo`030000003o
c<`0000000<0olc<00D000000?o<c000000000000?o<c002000000/0olc<00<000000?o<c03oc<`0
1P00000=0?o<c0050000003oc<`000000?o<c0000000G@3oool00?l0oooo:`3oool2000000<0olc<
0P0000050?o<c08000002@3oc<`00`000000olc<0?o<c003000000<0olc<00<000000?o<c03oc<`0
2@3oc<`010000000olc<0?o<c03oc<`2000005d0oooo003o0?ooob`0oooo1@0000080?o<c0800000
1`3oc<`010000000olc<0000003oc<`2000000<0olc<0P0000090?o<c0030000003oc<`0olc<0080
olc<00<000000?ooo`3oool0G03oool00?l0oooo;@3oool2000000030?o<c0000000olc<00T0olc<
0P0000050?o<c08000000`3oc<`7000000L0olc<00<000000?o<c03oc<`00`3oc<`00`000000oooo
0?ooo`1L0?ooo`00o`3oool^0?ooo`8000002P3oc<`00`000000olc<0000000200000080olc<0P00
00040?o<c0030000003oc<`0olc<00@0olc<00<000000?o<c03oc<`00`3oc<`00`000000olc<0?o<
c0020?o<c0<00000GP3oool00?l0oooo;P3oool2000000T0olc<00<000000?o<c03oc<`00P3oc<`5
000000@0olc<00<000000?o<c03oc<`0103oc<`2000000<0olc<00@000000?o<c03oc<`0olc<0P00
00020?o<c0030000003oool0oooo05`0oooo003o0?ooobl0oooo00<000000?o<c03oc<`01P3oc<`2
000000D0olc<00@000000?o<c00000000000103oc<`00`000000olc<0?o<c0050?o<c0060000003o
c<`0olc<0?o<c0000000olc<0P0000030?o<c0030000003oool0oooo05d0oooo003o0?oooc00oooo
00<000000?o<c03oc<`01@3oc<`00`000000olc<0?o<c0040?o<c0<0000000<0olc<000000000000
0`3oc<`00`000000olc<0?o<c0040?o<c080000000<0olc<0000000000000P0000040?o<c0030000
003oool0oooo05d0oooo003o0?oooc40oooo00<000000?o<c03oc<`00`3oc<`00`000000olc<0?o<
c0050?o<c0D0000000D0olc<000000000000olc<000000050?o<c080000000<0olc<000000000000
0`3oc<`01@000000olc<0?o<c03oc<`0000005l0oooo003o0?oooc80oooo1@0000000`3oc<`00000
000000040?o<c0040000003oc<`00000000000D0olc<0P0000050?o<c0D000000`3oc<`01@000000
olc<0?o<c03oc<`0000005l0oooo003o0?oooc<0oooo00@000000?o<c000000000000`3oc<`20000
0080olc<0`0000070?o<c0<0000000<0olc<0000000000000P0000030?o<c0040000003oc<`0olc<
00000080olc<00<000000?ooo`3oool0GP3oool00?l0oooo<`3oool00`000000olc<000000060?o<
c080000000<0olc<0000000000001`3oc<`4000000040?o<c00000000000000000<0olc<00@00000
0?o<c03oc<`000000P3oc<`00`000000oooo0?ooo`1N0?ooo`00o`3ooold0?ooo`800000103oc<`2
000000<0olc<00<000000?o<c03oc<`01`3oc<`200000080olc<0`0000040?o<c0060000003oc<`0
olc<0000003oc<`00000H03oool00?l0oooo=@3oool2000000030?o<c0000000000000D0olc<00<0
00000?o<c03oc<`01`3oc<`200000080olc<0`0000030?o<c0070000003oc<`000000?o<c0000000
olc<0000001P0?ooo`00o`3ooolf0?ooo`@000001@3oc<`00`000000olc<0?o<c0070?o<c0800000
0P3oc<`00`000000olc<00000003000000<0olc<0P0000000`3oc<`000000?ooo`1O0?ooo`00o`3o
oolf0?ooo`030000003oc<`00000008000000`3oc<`3000000P0olc<00<000000?o<c00000000P00
00020?o<c0<000000`3oc<`300000640oooo003o0?ooocL0oooo00@000000?o<c0000000olc<0P00
00001@3oc<`000000?o<c03oc<`0000000P0olc<100000030?o<c0030000003oc<`0olc<00<0olc<
0P00001Q0?ooo`00o`3ooolh0?oooaD000000`3oc<`00`000000olc<0?o<c0050?o<c0030000003o
ool0oooo05l0oooo003o0?ooocT0oooo100000000`3oc<`00000000000030?o<c0030000003oc<`0
000000@0olc<00<000000?o<c0000000100000070?o<c0030000003oool0oooo05l0oooo003o0?oo
ocX0oooo0`0000000`3oc<`00000000000040?o<c0800000103oc<`00`000000olc<000000020000
00030?o<c0000000olc<00D0olc<00<000000?ooo`3oool0H03oool00?l0oooo>`3oool5000000@0
olc<00<000000?o<c03oc<`0103oc<`7000000D0olc<00<000000?ooo`3oool0H03oool00?l0oooo
>`3oool00`000000olc<0?o<c00400000080olc<0P0000050?o<c0@000000P3oc<`2000000<0olc<
0P00001R0?ooo`00o`3oooll0?ooo`@0000000D0olc<00000000000000000?o<c002000000@0olc<
100000040?o<c0D00000HP3oool00?l0oooo?@3oool400000080olc<2`0000030?o<c0D0000000<0
olc<0000003oool0H@3oool00?l0oooo?@3oool010000000olc<0000000000040?o<c0D0000000D0
olc<00000000000000000?o<c003000000<0olc<0P00001S0?ooo`00o`3oooln0?ooo`030000003o
c<`0000000H0olc<1@0000001P3oc<`00000000000000000olc<000000@0olc<00<000000?ooo`3o
ool0H@3oool00?l0oooo?`3oool2000000D0olc<0P0000000`3oc<`000000000000300000080olc<
00<000000?o<c03oc<`00`3oc<`00`000000oooo0?ooo`1Q0?ooo`00o`3ooom00?ooo`8000000P3o
c<`2000000D0olc<0P0000030?o<c0030000003oc<`0olc<0080olc<00<000000?ooo`3oool0HP3o
ool00?l0oooo@03oool5000000L0olc<00D000000?o<c03oc<`0olc<000000040?o<c0030000003o
ool0oooo0680oooo003o0?oood40oooo00<000000?o<c0000000203oc<`:000006@0oooo003o0?oo
od80oooo0P0000080?o<c0<000001P3oc<`00`000000oooo0?ooo`1R0?ooo`00o`3ooom30?ooo`03
0000003oc<`0olc<00L0olc<00<000000?o<c03oc<`01@3oc<`00`000000oooo0?ooo`1R0?ooo`00
o`3ooom40?ooo`030000003oc<`0olc<00D0olc<0P0000060?o<c0030000003oool0oooo06<0oooo
003o0?oood@0oooo00<000000?o<c03oc<`01@3oc<`2000000H0olc<00<000000?ooo`3oool0H`3o
ool00?l0ooooA@3oool00`000000olc<0?o<c0030?o<c080000000<0olc<0000003oc<`0103oc<`0
0`000000oooo0?ooo`1S0?ooo`00o`3ooom60?ooo`050000003oc<`0olc<0?o<c00000000P3oc<`3
000000<0olc<0P00001U0?ooo`00o`3ooom70?ooo`030000003oc<`0000000@0olc<00<000000?o<
c00000001000001U0?ooo`00o`3ooom70?ooo`030000003oc<`0000000@0olc<100000000`3oc<`0
00000?ooo`1U0?ooo`00o`3ooom80?ooo`030000003oc<`0olc<0080olc<0`0000030?o<c0030000
003oool0oooo06@0oooo003o0?ooodT0oooo00<000000?o<c0000000100000030?o<c0030000003o
ool0oooo06@0oooo003o0?ooodX0oooo100000000`3oc<`00000000000020?o<c0030000003oool0
oooo06@0oooo003o0?ooodX0oooo0P0000000`3oc<`0000000000004000006L0oooo003o0?oood/0
oooo0P0000020?o<c0@00000I`3oool00?l0ooooC03oool5000000030?o<c0000000oooo06H0oooo
003o0?ooodd0oooo100000000`3oc<`000000?ooo`1V0?ooo`00o`3ooom>0?ooo`040000003oc<`0
0000000006P0oooo003o0?ooodl0oooo0`00001X0?ooo`00o`3ooom?0?ooo`<00000J03oool00?l0
ooooD03oool2000006P0oooo003o0?oooe40oooo00<000000?ooo`3oool0IP3oool00?l0oooo^P3o
ool00?l0oooo^P3oool00?l0oooo^P3oool00?l0oooo^P3oool00?l0oooo^P3oool00?l0oooo^P3o
ool00?l0oooo^P3oool00?l0oooo^P3oool00?l0oooo^P3oool00?l0oooo^P3oool00001\
\>"],
      ImageRangeCache->{{{0, 440}, {440, 0}} -> {-1.30317, -0.0547776, 
      0.00536217, 0.00522773}}]], "Input"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1280}, {0, 976}},
WindowSize->{1272, 946},
WindowMargins->{{0, Automatic}, {Automatic, 0}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 109, 4, 80, "Subtitle"],

Cell[CellGroupData[{
Cell[1910, 61, 41, 0, 38, "Subsection"],
Cell[1954, 63, 114, 2, 50, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2105, 70, 68, 0, 38, "Subsection"],

Cell[CellGroupData[{
Cell[2198, 74, 4263, 78, 1190, "Input"],
Cell[6464, 154, 36, 1, 29, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[6549, 161, 254, 5, 74, "Subsection"],

Cell[CellGroupData[{
Cell[6828, 170, 710, 13, 210, "Input"],
Cell[7541, 185, 298, 4, 22, "Message"],
Cell[7842, 191, 298, 4, 22, "Message"],
Cell[8143, 197, 298, 4, 22, "Message"],
Cell[8444, 203, 330, 5, 22, "Message"],
Cell[8777, 210, 167, 3, 25, "Print"],
Cell[8947, 215, 165, 3, 25, "Print"],
Cell[9115, 220, 165, 3, 25, "Print"],
Cell[9283, 225, 165, 3, 25, "Print"],
Cell[9451, 230, 163, 3, 25, "Print"],
Cell[9617, 235, 165, 3, 25, "Print"],
Cell[9785, 240, 165, 3, 25, "Print"],
Cell[9953, 245, 165, 3, 25, "Print"],
Cell[10121, 250, 165, 3, 25, "Print"],
Cell[10289, 255, 163, 3, 25, "Print"],
Cell[10455, 260, 165, 3, 25, "Print"],
Cell[10623, 265, 167, 3, 25, "Print"],
Cell[10793, 270, 165, 3, 25, "Print"],
Cell[10961, 275, 165, 3, 25, "Print"],
Cell[11129, 280, 165, 3, 25, "Print"],
Cell[11297, 285, 165, 3, 25, "Print"],
Cell[11465, 290, 165, 3, 25, "Print"],
Cell[11633, 295, 163, 3, 25, "Print"],
Cell[11799, 300, 165, 3, 25, "Print"],
Cell[11967, 305, 165, 3, 25, "Print"],
Cell[12135, 310, 165, 3, 25, "Print"],
Cell[12303, 315, 165, 3, 25, "Print"],
Cell[12471, 320, 167, 3, 25, "Print"],
Cell[12641, 325, 165, 3, 25, "Print"],
Cell[12809, 330, 165, 3, 25, "Print"],
Cell[12977, 335, 165, 3, 25, "Print"],
Cell[13145, 340, 165, 3, 25, "Print"],
Cell[13313, 345, 165, 3, 25, "Print"],
Cell[13481, 350, 165, 3, 25, "Print"],
Cell[13649, 355, 165, 3, 25, "Print"],
Cell[13817, 360, 165, 3, 25, "Print"],
Cell[13985, 365, 165, 3, 25, "Print"],
Cell[14153, 370, 167, 3, 25, "Print"],
Cell[14323, 375, 167, 3, 25, "Print"],
Cell[14493, 380, 165, 3, 25, "Print"],
Cell[14661, 385, 165, 3, 25, "Print"],
Cell[14829, 390, 165, 3, 25, "Print"],
Cell[14997, 395, 165, 3, 25, "Print"],
Cell[15165, 400, 167, 3, 25, "Print"],
Cell[15335, 405, 165, 3, 25, "Print"],
Cell[15503, 410, 165, 3, 25, "Print"],
Cell[15671, 415, 165, 3, 25, "Print"],
Cell[15839, 420, 165, 3, 25, "Print"],
Cell[16007, 425, 165, 3, 25, "Print"],
Cell[16175, 430, 167, 3, 25, "Print"],
Cell[16345, 435, 163, 3, 25, "Print"],
Cell[16511, 440, 165, 3, 25, "Print"],
Cell[16679, 445, 165, 3, 25, "Print"],
Cell[16847, 450, 165, 3, 25, "Print"],
Cell[17015, 455, 165, 3, 25, "Print"],
Cell[17183, 460, 165, 3, 25, "Print"],
Cell[17351, 465, 165, 3, 25, "Print"],
Cell[17519, 470, 165, 3, 25, "Print"],
Cell[17687, 475, 165, 3, 25, "Print"],
Cell[17855, 480, 165, 3, 25, "Print"],
Cell[18023, 485, 298, 4, 22, "Message"],
Cell[18324, 491, 298, 4, 22, "Message"],
Cell[18625, 497, 298, 4, 22, "Message"],
Cell[18926, 503, 330, 5, 22, "Message"],
Cell[19259, 510, 165, 3, 25, "Print"],
Cell[19427, 515, 163, 3, 25, "Print"],
Cell[19593, 520, 163, 3, 25, "Print"],
Cell[19759, 525, 163, 3, 25, "Print"],
Cell[19925, 530, 163, 3, 25, "Print"],
Cell[20091, 535, 163, 3, 25, "Print"],
Cell[20257, 540, 163, 3, 25, "Print"],
Cell[20423, 545, 163, 3, 25, "Print"],
Cell[20589, 550, 163, 3, 25, "Print"],
Cell[20755, 555, 163, 3, 25, "Print"],
Cell[20921, 560, 163, 3, 25, "Print"],
Cell[21087, 565, 165, 3, 25, "Print"],
Cell[21255, 570, 163, 3, 25, "Print"],
Cell[21421, 575, 163, 3, 25, "Print"],
Cell[21587, 580, 165, 3, 25, "Print"],
Cell[21755, 585, 163, 3, 25, "Print"],
Cell[21921, 590, 163, 3, 25, "Print"],
Cell[22087, 595, 163, 3, 25, "Print"],
Cell[22253, 600, 163, 3, 25, "Print"],
Cell[22419, 605, 163, 3, 25, "Print"],
Cell[22585, 610, 163, 3, 25, "Print"],
Cell[22751, 615, 163, 3, 25, "Print"],
Cell[22917, 620, 165, 3, 25, "Print"],
Cell[23085, 625, 163, 3, 25, "Print"],
Cell[23251, 630, 163, 3, 25, "Print"],
Cell[23417, 635, 163, 3, 25, "Print"],
Cell[23583, 640, 163, 3, 25, "Print"],
Cell[23749, 645, 165, 3, 25, "Print"],
Cell[23917, 650, 163, 3, 25, "Print"],
Cell[24083, 655, 163, 3, 25, "Print"],
Cell[24249, 660, 165, 3, 25, "Print"],
Cell[24417, 665, 163, 3, 25, "Print"],
Cell[24583, 670, 165, 3, 25, "Print"],
Cell[24751, 675, 165, 3, 25, "Print"],
Cell[24919, 680, 163, 3, 25, "Print"],
Cell[25085, 685, 165, 3, 25, "Print"],
Cell[25253, 690, 163, 3, 25, "Print"],
Cell[25419, 695, 163, 3, 25, "Print"],
Cell[25585, 700, 165, 3, 25, "Print"],
Cell[25753, 705, 163, 3, 25, "Print"],
Cell[25919, 710, 163, 3, 25, "Print"],
Cell[26085, 715, 163, 3, 25, "Print"],
Cell[26251, 720, 163, 3, 25, "Print"],
Cell[26417, 725, 165, 3, 25, "Print"],
Cell[26585, 730, 165, 3, 25, "Print"],
Cell[26753, 735, 163, 3, 25, "Print"],
Cell[26919, 740, 163, 3, 25, "Print"],
Cell[27085, 745, 163, 3, 25, "Print"],
Cell[27251, 750, 163, 3, 25, "Print"],
Cell[27417, 755, 163, 3, 25, "Print"],
Cell[27583, 760, 163, 3, 25, "Print"],
Cell[27749, 765, 165, 3, 25, "Print"],
Cell[27917, 770, 163, 3, 25, "Print"],
Cell[28083, 775, 163, 3, 25, "Print"],
Cell[28249, 780, 163, 3, 25, "Print"]
}, Open  ]],
Cell[28427, 786, 52, 1, 50, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[28516, 792, 129, 3, 38, "Subsection"],
Cell[28648, 797, 444, 8, 190, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[29129, 810, 36, 0, 38, "Subsection"],

Cell[CellGroupData[{
Cell[29190, 814, 224, 5, 110, "Input"],
Cell[29417, 821, 38, 1, 29, "Output"],
Cell[29458, 824, 37, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[29532, 830, 106, 2, 50, "Input"],
Cell[29641, 834, 368, 6, 22, "Message"],
Cell[30012, 842, 368, 6, 22, "Message"],
Cell[30383, 850, 67, 1, 25, "Print"],
Cell[30453, 853, 1536, 48, 225, "Print"],
Cell[31992, 903, 89, 1, 25, "Print"],
Cell[32084, 906, 368, 6, 22, "Message"],
Cell[32455, 914, 329, 5, 22, "Message"],
Cell[32787, 921, 67, 1, 25, "Print"],
Cell[32857, 924, 1536, 48, 225, "Print"],
Cell[34396, 974, 89, 1, 25, "Print"],
Cell[34488, 977, 67, 1, 25, "Print"],
Cell[34558, 980, 1536, 48, 225, "Print"],
Cell[36097, 1030, 89, 1, 25, "Print"],
Cell[36189, 1033, 67, 1, 25, "Print"],
Cell[36259, 1036, 1550, 48, 227, "Print"],
Cell[37812, 1086, 89, 1, 25, "Print"],
Cell[37904, 1089, 45, 1, 25, "Print"],
Cell[37952, 1092, 1537, 48, 225, "Print"],
Cell[39492, 1142, 89, 1, 25, "Print"],
Cell[39584, 1145, 45, 1, 25, "Print"],
Cell[39632, 1148, 1543, 48, 227, "Print"],
Cell[41178, 1198, 89, 1, 25, "Print"],
Cell[41270, 1201, 67, 1, 25, "Print"],
Cell[41340, 1204, 1536, 48, 225, "Print"],
Cell[42879, 1254, 89, 1, 25, "Print"],
Cell[42971, 1257, 67, 1, 25, "Print"],
Cell[43041, 1260, 1550, 48, 227, "Print"],
Cell[44594, 1310, 89, 1, 25, "Print"],
Cell[44686, 1313, 67, 1, 25, "Print"],
Cell[44756, 1316, 1536, 48, 225, "Print"],
Cell[46295, 1366, 89, 1, 25, "Print"],
Cell[46387, 1369, 67, 1, 25, "Print"],
Cell[46457, 1372, 1537, 48, 225, "Print"],
Cell[47997, 1422, 89, 1, 25, "Print"],
Cell[48089, 1425, 45, 1, 25, "Print"],
Cell[48137, 1428, 1530, 48, 225, "Print"],
Cell[49670, 1478, 89, 1, 25, "Print"],
Cell[49762, 1481, 45, 1, 25, "Print"],
Cell[49810, 1484, 1551, 48, 227, "Print"],
Cell[51364, 1534, 89, 1, 25, "Print"],
Cell[51456, 1537, 45, 1, 25, "Print"],
Cell[51504, 1540, 1544, 48, 227, "Print"],
Cell[53051, 1590, 89, 1, 25, "Print"],
Cell[53143, 1593, 45, 1, 25, "Print"],
Cell[53191, 1596, 1544, 48, 227, "Print"],
Cell[54738, 1646, 89, 1, 25, "Print"],
Cell[54830, 1649, 67, 1, 25, "Print"],
Cell[54900, 1652, 1537, 48, 225, "Print"],
Cell[56440, 1702, 89, 1, 25, "Print"],
Cell[56532, 1705, 67, 1, 25, "Print"],
Cell[56602, 1708, 1537, 48, 225, "Print"],
Cell[58142, 1758, 89, 1, 25, "Print"],
Cell[58234, 1761, 45, 1, 25, "Print"],
Cell[58282, 1764, 1551, 48, 227, "Print"],
Cell[59836, 1814, 89, 1, 25, "Print"],
Cell[59928, 1817, 67, 1, 25, "Print"],
Cell[59998, 1820, 1537, 48, 225, "Print"],
Cell[61538, 1870, 89, 1, 25, "Print"],
Cell[61630, 1873, 88, 1, 25, "Print"],
Cell[61721, 1876, 1509, 48, 221, "Print"],
Cell[63233, 1926, 89, 1, 25, "Print"],
Cell[63325, 1929, 45, 1, 25, "Print"],
Cell[63373, 1932, 1544, 48, 227, "Print"],
Cell[64920, 1982, 89, 1, 25, "Print"],
Cell[65012, 1985, 67, 1, 25, "Print"],
Cell[65082, 1988, 1520, 48, 223, "Print"],
Cell[66605, 2038, 89, 1, 25, "Print"],
Cell[66697, 2041, 50, 1, 25, "Print"],
Cell[66750, 2044, 1544, 48, 227, "Print"],
Cell[68297, 2094, 89, 1, 25, "Print"],
Cell[68389, 2097, 50, 1, 25, "Print"],
Cell[68442, 2100, 1569, 48, 227, "Print"],
Cell[70014, 2150, 89, 1, 25, "Print"],
Cell[70106, 2153, 50, 1, 25, "Print"],
Cell[70159, 2156, 1537, 48, 225, "Print"],
Cell[71699, 2206, 89, 1, 25, "Print"],
Cell[71791, 2209, 50, 1, 25, "Print"],
Cell[71844, 2212, 1576, 48, 229, "Print"],
Cell[73423, 2262, 89, 1, 25, "Print"],
Cell[73515, 2265, 96, 2, 25, "Print"],
Cell[73614, 2269, 1520, 48, 223, "Print"],
Cell[75137, 2319, 89, 1, 25, "Print"],
Cell[75229, 2322, 67, 1, 25, "Print"],
Cell[75299, 2325, 1537, 48, 225, "Print"],
Cell[76839, 2375, 89, 1, 25, "Print"],
Cell[76931, 2378, 67, 1, 25, "Print"],
Cell[77001, 2381, 1537, 48, 225, "Print"],
Cell[78541, 2431, 89, 1, 25, "Print"],
Cell[78633, 2434, 45, 1, 25, "Print"],
Cell[78681, 2437, 1543, 48, 225, "Print"],
Cell[80227, 2487, 89, 1, 25, "Print"],
Cell[80319, 2490, 67, 1, 25, "Print"],
Cell[80389, 2493, 1537, 48, 225, "Print"],
Cell[81929, 2543, 89, 1, 25, "Print"],
Cell[82021, 2546, 45, 1, 25, "Print"],
Cell[82069, 2549, 1543, 48, 225, "Print"],
Cell[83615, 2599, 89, 1, 25, "Print"],
Cell[83707, 2602, 88, 1, 25, "Print"],
Cell[83798, 2605, 1509, 48, 221, "Print"],
Cell[85310, 2655, 89, 1, 25, "Print"],
Cell[85402, 2658, 67, 1, 25, "Print"],
Cell[85472, 2661, 1537, 48, 225, "Print"],
Cell[87012, 2711, 89, 1, 25, "Print"],
Cell[87104, 2714, 45, 1, 25, "Print"],
Cell[87152, 2717, 1544, 48, 227, "Print"],
Cell[88699, 2767, 89, 1, 25, "Print"],
Cell[88791, 2770, 67, 1, 25, "Print"],
Cell[88861, 2773, 1537, 48, 225, "Print"],
Cell[90401, 2823, 89, 1, 25, "Print"],
Cell[90493, 2826, 45, 1, 25, "Print"],
Cell[90541, 2829, 1551, 48, 227, "Print"],
Cell[92095, 2879, 89, 1, 25, "Print"],
Cell[92187, 2882, 67, 1, 25, "Print"],
Cell[92257, 2885, 1537, 48, 225, "Print"],
Cell[93797, 2935, 89, 1, 25, "Print"],
Cell[93889, 2938, 45, 1, 25, "Print"],
Cell[93937, 2941, 1544, 48, 227, "Print"],
Cell[95484, 2991, 89, 1, 25, "Print"],
Cell[95576, 2994, 45, 1, 25, "Print"],
Cell[95624, 2997, 1538, 48, 225, "Print"],
Cell[97165, 3047, 89, 1, 25, "Print"],
Cell[97257, 3050, 50, 1, 25, "Print"],
Cell[97310, 3053, 1537, 48, 225, "Print"],
Cell[98850, 3103, 89, 1, 25, "Print"],
Cell[98942, 3106, 45, 1, 25, "Print"],
Cell[98990, 3109, 1544, 48, 227, "Print"],
Cell[100537, 3159, 89, 1, 25, "Print"],
Cell[100629, 3162, 45, 1, 25, "Print"],
Cell[100677, 3165, 1530, 48, 225, "Print"],
Cell[102210, 3215, 89, 1, 25, "Print"],
Cell[102302, 3218, 67, 1, 25, "Print"],
Cell[102372, 3221, 1537, 48, 225, "Print"],
Cell[103912, 3271, 89, 1, 25, "Print"],
Cell[104004, 3274, 45, 1, 25, "Print"],
Cell[104052, 3277, 1537, 48, 225, "Print"],
Cell[105592, 3327, 89, 1, 25, "Print"],
Cell[105684, 3330, 45, 1, 25, "Print"],
Cell[105732, 3333, 1551, 48, 227, "Print"],
Cell[107286, 3383, 89, 1, 25, "Print"],
Cell[107378, 3386, 130, 2, 25, "Print"],
Cell[107511, 3390, 1857, 61, 149, "Print"],
Cell[109371, 3453, 89, 1, 25, "Print"],
Cell[109463, 3456, 74, 1, 25, "Print"],
Cell[109540, 3459, 1711, 57, 209, "Print"],
Cell[111254, 3518, 89, 1, 25, "Print"],
Cell[111346, 3521, 74, 1, 25, "Print"],
Cell[111423, 3524, 2327, 74, 209, "Print"],
Cell[113753, 3600, 89, 1, 25, "Print"],
Cell[113845, 3603, 130, 2, 25, "Print"],
Cell[113978, 3607, 2273, 74, 209, "Print"],
Cell[116254, 3683, 89, 1, 25, "Print"],
Cell[116346, 3686, 168, 2, 25, "Print"],
Cell[116517, 3690, 1702, 54, 207, "Print"],
Cell[118222, 3746, 89, 1, 25, "Print"],
Cell[118314, 3749, 168, 2, 25, "Print"],
Cell[118485, 3753, 1709, 54, 209, "Print"],
Cell[120197, 3809, 89, 1, 25, "Print"],
Cell[120289, 3812, 130, 2, 25, "Print"],
Cell[120422, 3816, 2359, 76, 169, "Print"],
Cell[122784, 3894, 89, 1, 25, "Print"],
Cell[122876, 3897, 130, 2, 25, "Print"],
Cell[123009, 3901, 1654, 54, 149, "Print"],
Cell[124666, 3957, 89, 1, 25, "Print"],
Cell[124758, 3960, 74, 1, 25, "Print"],
Cell[124835, 3963, 1654, 54, 149, "Print"],
Cell[126492, 4019, 89, 1, 25, "Print"],
Cell[126584, 4022, 74, 1, 25, "Print"],
Cell[126661, 4025, 1654, 54, 149, "Print"],
Cell[128318, 4081, 89, 1, 25, "Print"],
Cell[128410, 4084, 74, 1, 25, "Print"],
Cell[128487, 4087, 1687, 55, 209, "Print"],
Cell[130177, 4144, 89, 1, 25, "Print"],
Cell[130269, 4147, 91, 1, 25, "Print"],
Cell[130363, 4150, 1845, 60, 209, "Print"],
Cell[132211, 4212, 89, 1, 25, "Print"],
Cell[132303, 4215, 74, 1, 25, "Print"],
Cell[132380, 4218, 2223, 72, 209, "Print"],
Cell[134606, 4292, 89, 1, 25, "Print"],
Cell[134698, 4295, 74, 1, 25, "Print"],
Cell[134775, 4298, 2232, 72, 209, "Print"],
Cell[137010, 4372, 89, 1, 25, "Print"],
Cell[137102, 4375, 130, 2, 25, "Print"],
Cell[137235, 4379, 1839, 61, 209, "Print"],
Cell[139077, 4442, 89, 1, 25, "Print"],
Cell[139169, 4445, 74, 1, 25, "Print"],
Cell[139246, 4448, 1720, 56, 197, "Print"],
Cell[140969, 4506, 89, 1, 25, "Print"],
Cell[141061, 4509, 74, 1, 25, "Print"],
Cell[141138, 4512, 1694, 56, 209, "Print"],
Cell[142835, 4570, 89, 1, 25, "Print"],
Cell[142927, 4573, 74, 1, 25, "Print"],
Cell[143004, 4576, 2223, 72, 209, "Print"],
Cell[145230, 4650, 89, 1, 25, "Print"],
Cell[145322, 4653, 74, 1, 25, "Print"],
Cell[145399, 4656, 1654, 54, 149, "Print"],
Cell[147056, 4712, 89, 1, 25, "Print"],
Cell[147148, 4715, 74, 1, 25, "Print"],
Cell[147225, 4718, 1654, 54, 149, "Print"],
Cell[148882, 4774, 89, 1, 25, "Print"],
Cell[148974, 4777, 104, 2, 63, "Print"],
Cell[149081, 4781, 1774, 56, 217, "Print"],
Cell[150858, 4839, 89, 1, 25, "Print"],
Cell[150950, 4842, 168, 3, 25, "Print"],
Cell[151121, 4847, 1570, 52, 189, "Print"],
Cell[152694, 4901, 89, 1, 25, "Print"],
Cell[152786, 4904, 168, 3, 25, "Print"],
Cell[152957, 4909, 1528, 50, 149, "Print"],
Cell[154488, 4961, 89, 1, 25, "Print"],
Cell[154580, 4964, 168, 3, 25, "Print"],
Cell[154751, 4969, 1943, 63, 189, "Print"],
Cell[156697, 5034, 89, 1, 25, "Print"],
Cell[156789, 5037, 168, 3, 25, "Print"],
Cell[156960, 5042, 1540, 52, 149, "Print"],
Cell[158503, 5096, 89, 1, 25, "Print"],
Cell[158595, 5099, 74, 1, 25, "Print"],
Cell[158672, 5102, 1866, 59, 209, "Print"],
Cell[160541, 5163, 89, 1, 25, "Print"],
Cell[160633, 5166, 74, 1, 25, "Print"],
Cell[160710, 5169, 1868, 59, 209, "Print"],
Cell[162581, 5230, 89, 1, 25, "Print"],
Cell[162673, 5233, 74, 1, 25, "Print"],
Cell[162750, 5236, 2515, 80, 209, "Print"],
Cell[165268, 5318, 89, 1, 25, "Print"],
Cell[165360, 5321, 74, 1, 25, "Print"],
Cell[165437, 5324, 2524, 80, 209, "Print"],
Cell[167964, 5406, 89, 1, 25, "Print"],
Cell[168056, 5409, 130, 2, 25, "Print"],
Cell[168189, 5413, 1891, 64, 199, "Print"],
Cell[170083, 5479, 89, 1, 25, "Print"],
Cell[170175, 5482, 130, 2, 25, "Print"],
Cell[170308, 5486, 2470, 79, 242, "Print"],
Cell[172781, 5567, 89, 1, 25, "Print"],
Cell[172873, 5570, 130, 2, 25, "Print"],
Cell[173006, 5574, 2780, 88, 253, "Print"],
Cell[175789, 5664, 89, 1, 25, "Print"],
Cell[175881, 5667, 362, 5, 22, "Message"],
Cell[176246, 5674, 362, 5, 22, "Message"],
Cell[176611, 5681, 262, 4, 22, "Message"],
Cell[176876, 5687, 262, 4, 22, "Message"],
Cell[177141, 5693, 262, 4, 22, "Message"],
Cell[177406, 5699, 327, 5, 22, "Message"],
Cell[177736, 5706, 362, 5, 22, "Message"],
Cell[178101, 5713, 334, 5, 22, "Message"],
Cell[178438, 5720, 921, 13, 37, "Message"],
Cell[179362, 5735, 921, 13, 37, "Message"],
Cell[180286, 5750, 921, 13, 37, "Message"],
Cell[181210, 5765, 329, 5, 22, "Message"],
Cell[181542, 5772, 1890, 26, 52, "Message"],
Cell[183435, 5800, 410, 6, 22, "Message"],
Cell[183848, 5808, 1038, 15, 37, "Message"],
Cell[184889, 5825, 1896, 26, 52, "Message"],
Cell[186788, 5853, 410, 6, 22, "Message"],
Cell[187201, 5861, 1046, 16, 37, "Message"],
Cell[188250, 5879, 1896, 26, 52, "Message"],
Cell[190149, 5907, 333, 5, 22, "Message"],
Cell[190485, 5914, 410, 6, 22, "Message"],
Cell[190898, 5922, 334, 5, 22, "Message"],
Cell[191235, 5929, 1046, 16, 37, "Message"],
Cell[192284, 5947, 328, 5, 22, "Message"],
Cell[192615, 5954, 480, 7, 22, "Message"],
Cell[193098, 5963, 480, 7, 22, "Message"],
Cell[193581, 5972, 480, 7, 22, "Message"],
Cell[194064, 5981, 328, 5, 22, "Message"],
Cell[194395, 5988, 148, 2, 25, "Print"],
Cell[194546, 5992, 2850, 86, 276, "Print"],
Cell[197399, 6080, 89, 1, 25, "Print"],
Cell[197491, 6083, 74, 1, 25, "Print"],
Cell[197568, 6086, 2233, 72, 199, "Print"],
Cell[199804, 6160, 89, 1, 25, "Print"],
Cell[199896, 6163, 130, 2, 25, "Print"],
Cell[200029, 6167, 1801, 58, 219, "Print"],
Cell[201833, 6227, 89, 1, 25, "Print"],
Cell[201925, 6230, 130, 2, 25, "Print"],
Cell[202058, 6234, 2252, 72, 199, "Print"],
Cell[204313, 6308, 89, 1, 25, "Print"],
Cell[204405, 6311, 130, 2, 25, "Print"],
Cell[204538, 6315, 1904, 62, 199, "Print"],
Cell[206445, 6379, 89, 1, 25, "Print"],
Cell[206537, 6382, 130, 2, 25, "Print"],
Cell[206670, 6386, 2141, 71, 169, "Print"],
Cell[208814, 6459, 89, 1, 25, "Print"],
Cell[208906, 6462, 130, 2, 25, "Print"],
Cell[209039, 6466, 1803, 59, 199, "Print"],
Cell[210845, 6527, 89, 1, 25, "Print"],
Cell[210937, 6530, 130, 2, 25, "Print"],
Cell[211070, 6534, 2273, 72, 199, "Print"],
Cell[213346, 6608, 89, 1, 25, "Print"],
Cell[213438, 6611, 130, 2, 25, "Print"],
Cell[213571, 6615, 2132, 69, 169, "Print"],
Cell[215706, 6686, 89, 1, 25, "Print"],
Cell[215798, 6689, 74, 1, 25, "Print"],
Cell[215875, 6692, 2233, 72, 199, "Print"],
Cell[218111, 6766, 89, 1, 25, "Print"],
Cell[218203, 6769, 130, 2, 25, "Print"],
Cell[218336, 6773, 1801, 58, 219, "Print"],
Cell[220140, 6833, 89, 1, 25, "Print"],
Cell[220232, 6836, 74, 1, 25, "Print"],
Cell[220309, 6839, 1857, 61, 149, "Print"],
Cell[222169, 6902, 89, 1, 25, "Print"],
Cell[222261, 6905, 74, 1, 25, "Print"],
Cell[222338, 6908, 2316, 74, 209, "Print"],
Cell[224657, 6984, 89, 1, 25, "Print"],
Cell[224749, 6987, 74, 1, 25, "Print"],
Cell[224826, 6990, 1773, 57, 197, "Print"],
Cell[226602, 7049, 89, 1, 25, "Print"],
Cell[226694, 7052, 91, 1, 25, "Print"],
Cell[226788, 7055, 1711, 57, 209, "Print"],
Cell[228502, 7114, 89, 1, 25, "Print"],
Cell[228594, 7117, 74, 1, 25, "Print"],
Cell[228671, 7120, 1771, 57, 197, "Print"],
Cell[230445, 7179, 89, 1, 25, "Print"],
Cell[230537, 7182, 74, 1, 25, "Print"],
Cell[230614, 7185, 1971, 64, 149, "Print"],
Cell[232588, 7251, 89, 1, 25, "Print"],
Cell[232680, 7254, 74, 1, 25, "Print"],
Cell[232757, 7257, 1857, 61, 189, "Print"],
Cell[234617, 7320, 89, 1, 25, "Print"],
Cell[234709, 7323, 74, 1, 25, "Print"],
Cell[234786, 7326, 1857, 61, 149, "Print"],
Cell[236646, 7389, 89, 1, 25, "Print"],
Cell[236738, 7392, 74, 1, 25, "Print"],
Cell[236815, 7395, 1857, 61, 189, "Print"],
Cell[238675, 7458, 89, 1, 25, "Print"],
Cell[238767, 7461, 74, 1, 25, "Print"],
Cell[238844, 7464, 2316, 74, 209, "Print"],
Cell[241163, 7540, 89, 1, 25, "Print"],
Cell[241255, 7543, 208, 3, 44, "Print"],
Cell[241466, 7548, 1635, 53, 207, "Print"],
Cell[243104, 7603, 89, 1, 25, "Print"],
Cell[243196, 7606, 74, 1, 25, "Print"],
Cell[243273, 7609, 1740, 55, 215, "Print"],
Cell[245016, 7666, 89, 1, 25, "Print"],
Cell[245108, 7669, 74, 1, 25, "Print"],
Cell[245185, 7672, 1777, 56, 217, "Print"],
Cell[246965, 7730, 89, 1, 25, "Print"],
Cell[247057, 7733, 130, 2, 25, "Print"],
Cell[247190, 7737, 1754, 58, 197, "Print"],
Cell[248947, 7797, 89, 1, 25, "Print"],
Cell[249039, 7800, 130, 2, 25, "Print"],
Cell[249172, 7804, 1958, 64, 189, "Print"],
Cell[251133, 7870, 89, 1, 25, "Print"],
Cell[251225, 7873, 130, 2, 25, "Print"],
Cell[251358, 7877, 2113, 69, 199, "Print"],
Cell[253474, 7948, 89, 1, 25, "Print"],
Cell[253566, 7951, 130, 2, 25, "Print"],
Cell[253699, 7955, 2284, 73, 189, "Print"],
Cell[255986, 8030, 89, 1, 25, "Print"],
Cell[256078, 8033, 130, 2, 25, "Print"],
Cell[256211, 8037, 2008, 66, 217, "Print"],
Cell[258222, 8105, 89, 1, 25, "Print"],
Cell[258314, 8108, 130, 2, 25, "Print"],
Cell[258447, 8112, 2350, 77, 219, "Print"],
Cell[260800, 8191, 89, 1, 25, "Print"],
Cell[260892, 8194, 130, 2, 25, "Print"],
Cell[261025, 8198, 2372, 77, 219, "Print"],
Cell[263400, 8277, 89, 1, 25, "Print"],
Cell[263492, 8280, 130, 2, 25, "Print"],
Cell[263625, 8284, 2505, 80, 209, "Print"],
Cell[266133, 8366, 89, 1, 25, "Print"],
Cell[266225, 8369, 130, 2, 25, "Print"],
Cell[266358, 8373, 2226, 72, 199, "Print"],
Cell[268587, 8447, 89, 1, 25, "Print"],
Cell[268679, 8450, 130, 2, 25, "Print"],
Cell[268812, 8454, 2222, 72, 199, "Print"],
Cell[271037, 8528, 89, 1, 25, "Print"],
Cell[271129, 8531, 74, 1, 25, "Print"],
Cell[271206, 8534, 1758, 56, 217, "Print"],
Cell[272967, 8592, 89, 1, 25, "Print"],
Cell[273059, 8595, 208, 3, 44, "Print"],
Cell[273270, 8600, 1636, 53, 207, "Print"],
Cell[274909, 8655, 89, 1, 25, "Print"],
Cell[275001, 8658, 74, 1, 25, "Print"],
Cell[275078, 8661, 2217, 71, 209, "Print"],
Cell[277298, 8734, 89, 1, 25, "Print"],
Cell[277390, 8737, 91, 1, 25, "Print"],
Cell[277484, 8740, 1529, 50, 149, "Print"],
Cell[279016, 8792, 89, 1, 25, "Print"],
Cell[279108, 8795, 91, 1, 25, "Print"],
Cell[279202, 8798, 1529, 50, 149, "Print"],
Cell[280734, 8850, 89, 1, 25, "Print"],
Cell[280826, 8853, 74, 1, 25, "Print"],
Cell[280903, 8856, 1712, 57, 209, "Print"],
Cell[282618, 8915, 89, 1, 25, "Print"],
Cell[282710, 8918, 74, 1, 25, "Print"],
Cell[282787, 8921, 1858, 61, 149, "Print"],
Cell[284648, 8984, 89, 1, 25, "Print"],
Cell[284740, 8987, 74, 1, 25, "Print"],
Cell[284817, 8990, 2224, 72, 209, "Print"],
Cell[287044, 9064, 89, 1, 25, "Print"],
Cell[287136, 9067, 91, 1, 25, "Print"],
Cell[287230, 9070, 1529, 50, 149, "Print"],
Cell[288762, 9122, 89, 1, 25, "Print"],
Cell[288854, 9125, 91, 1, 25, "Print"],
Cell[288948, 9128, 1529, 50, 149, "Print"],
Cell[290480, 9180, 89, 1, 25, "Print"],
Cell[290572, 9183, 74, 1, 25, "Print"],
Cell[290649, 9186, 1858, 61, 149, "Print"],
Cell[292510, 9249, 89, 1, 25, "Print"],
Cell[292602, 9252, 74, 1, 25, "Print"],
Cell[292679, 9255, 1858, 61, 149, "Print"],
Cell[294540, 9318, 89, 1, 25, "Print"],
Cell[294632, 9321, 74, 1, 25, "Print"],
Cell[294709, 9324, 1858, 61, 149, "Print"],
Cell[296570, 9387, 89, 1, 25, "Print"],
Cell[296662, 9390, 74, 1, 25, "Print"],
Cell[296739, 9393, 2317, 74, 209, "Print"],
Cell[299059, 9469, 89, 1, 25, "Print"],
Cell[299151, 9472, 91, 1, 25, "Print"],
Cell[299245, 9475, 1841, 60, 199, "Print"],
Cell[301089, 9537, 89, 1, 25, "Print"],
Cell[301181, 9540, 74, 1, 25, "Print"],
Cell[301258, 9543, 1774, 57, 197, "Print"],
Cell[303035, 9602, 89, 1, 25, "Print"],
Cell[303127, 9605, 91, 1, 25, "Print"],
Cell[303221, 9608, 1737, 56, 199, "Print"],
Cell[304961, 9666, 89, 1, 25, "Print"],
Cell[305053, 9669, 74, 1, 25, "Print"],
Cell[305130, 9672, 2317, 74, 209, "Print"],
Cell[307450, 9748, 89, 1, 25, "Print"],
Cell[307542, 9751, 373, 7, 25, "Print"]
}, Open  ]],
Cell[307930, 9761, 35, 1, 30, "Input"],

Cell[CellGroupData[{
Cell[307990, 9766, 92, 1, 50, "Input"],
Cell[308085, 9769, 368, 6, 22, "Message"],
Cell[308456, 9777, 24856, 582, 180, 7935, 369, "GraphicsData", "PostScript", \
"Graphics"],
Cell[333315, 10361, 368, 6, 22, "Message"],
Cell[333686, 10369, 24856, 582, 180, 7935, 369, "GraphicsData", "PostScript", \
"Graphics"],
Cell[358545, 10953, 368, 6, 22, "Message"],
Cell[358916, 10961, 329, 5, 22, "Message"],

Cell[CellGroupData[{
Cell[359270, 10970, 24856, 582, 180, 7935, 369, "GraphicsData", "PostScript", \
"Graphics"],
Cell[384129, 11554, 21804, 551, 135, 8068, 377, "GraphicsData", "PostScript", \
"Graphics"],
Cell[405936, 12107, 19194, 509, 103, 7890, 365, "GraphicsData", "PostScript", \
"Graphics"],
Cell[425133, 12618, 19761, 522, 110, 8012, 373, "GraphicsData", "PostScript", \
"Graphics"],
Cell[444897, 13142, 24629, 579, 180, 7943, 369, "GraphicsData", "PostScript", \
"Graphics"],
Cell[469529, 13723, 21757, 550, 135, 8074, 377, "GraphicsData", "PostScript", \
"Graphics"],
Cell[491289, 14275, 24629, 579, 180, 7943, 369, "GraphicsData", "PostScript", \
"Graphics"],
Cell[515921, 14856, 24629, 579, 180, 7943, 369, "GraphicsData", "PostScript", \
"Graphics"],
Cell[540553, 15437, 18615, 502, 129, 7868, 365, "GraphicsData", "PostScript", \
"Graphics"],
Cell[559171, 15941, 21904, 552, 135, 8075, 377, "GraphicsData", "PostScript", \
"Graphics"],
Cell[581078, 16495, 23112, 563, 149, 8024, 373, "GraphicsData", "PostScript", \
"Graphics"],
Cell[604193, 17060, 23112, 563, 149, 8024, 373, "GraphicsData", "PostScript", \
"Graphics"],
Cell[627308, 17625, 24629, 579, 180, 7943, 369, "GraphicsData", "PostScript", \
"Graphics"],
Cell[651940, 18206, 24629, 579, 180, 7943, 369, "GraphicsData", "PostScript", \
"Graphics"],
Cell[676572, 18787, 8199, 381, 191, 8072, 377, "GraphicsData", "PostScript", \
"Graphics",
  ImageCacheValid->False],
Cell[684774, 19170, 8070, 373, 180, 7943, 369, "GraphicsData", "PostScript", \
"Graphics",
  ImageCacheValid->False],
Cell[692847, 19545, 30036, 634, 261, 7621, 353, "GraphicsData", "PostScript", \
"Graphics"],
Cell[722886, 20181, 33353, 690, 293, 8018, 373, "GraphicsData", "PostScript", \
"Graphics"],
Cell[756242, 20873, 22575, 545, 154, 7708, 357, "GraphicsData", "PostScript", \
"Graphics"],
Cell[778820, 21420, 21814, 547, 135, 8022, 373, "GraphicsData", "PostScript", \
"Graphics"],
Cell[800637, 21969, 19517, 522, 91, 8090, 377, "GraphicsData", "PostScript", \
"Graphics"],
Cell[820157, 22493, 24637, 579, 180, 7943, 369, "GraphicsData", "PostScript", \
"Graphics"],
Cell[844797, 23074, 27743, 627, 202, 8148, 381, "GraphicsData", "PostScript", \
"Graphics"],
Cell[872543, 23703, 22575, 545, 154, 7708, 357, "GraphicsData", "PostScript", \
"Graphics"],
Cell[895121, 24250, 24637, 579, 180, 7943, 369, "GraphicsData", "PostScript", \
"Graphics"],
Cell[919761, 24831, 24637, 579, 180, 7943, 369, "GraphicsData", "PostScript", \
"Graphics"],
Cell[944401, 25412, 25387, 588, 180, 7948, 369, "GraphicsData", "PostScript", \
"Graphics"],
Cell[969791, 26002, 24637, 579, 180, 7943, 369, "GraphicsData", "PostScript", \
"Graphics"],
Cell[994431, 26583, 24955, 583, 180, 7956, 369, "GraphicsData", "PostScript", \
"Graphics"],
Cell[1019389, 27168, 30036, 634, 261, 7621, 353, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1049428, 27804, 24852, 582, 180, 7935, 369, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1074283, 28388, 19760, 522, 110, 8011, 373, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1094046, 28912, 24856, 582, 180, 7935, 369, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1118905, 29496, 22061, 554, 135, 8078, 377, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1140969, 30052, 24856, 582, 180, 7935, 369, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1165828, 30636, 19761, 522, 110, 8012, 373, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1185592, 31160, 17902, 493, 85, 7901, 365, "GraphicsData", "PostScript", \
"Graphics"],
Cell[1203497, 31655, 24852, 582, 180, 7935, 369, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1228352, 32239, 23044, 563, 149, 8024, 373, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1251399, 32804, 19196, 510, 111, 7824, 365, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1270598, 33316, 24856, 582, 180, 7935, 369, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1295457, 33900, 30706, 654, 261, 7946, 369, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1326166, 34556, 33470, 695, 293, 8086, 377, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1359685, 35257, 316, 5, 90, "Input"],
Cell[1360004, 35264, 368, 6, 22, "Message"],
Cell[1360375, 35272, 368, 6, 22, "Message"]
}, Open  ]],
Cell[1360758, 35281, 469467, 28923, 459, "Input"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

